/* Generated by Edge Impulse
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*/
// Generated on: 28.09.2021 16:39:06

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include "edge-impulse-sdk/tensorflow/lite/c/builtin_op_data.h"
#include "edge-impulse-sdk/tensorflow/lite/c/common.h"
#include "edge-impulse-sdk/tensorflow/lite/micro/micro_mutable_op_resolver.h"
#include "edge-impulse-sdk/porting/ei_classifier_porting.h"

#if EI_CLASSIFIER_PRINT_STATE
#if defined(__cplusplus) && EI_C_LINKAGE == 1
extern "C" {
    extern void ei_printf(const char *format, ...);
}
#else
extern void ei_printf(const char *format, ...);
#endif
#endif

#if defined __GNUC__
#define ALIGN(X) __attribute__((aligned(X)))
#elif defined _MSC_VER
#define ALIGN(X) __declspec(align(X))
#elif defined __TASKING__
#define ALIGN(X) __align(X)
#endif

using namespace tflite;
using namespace tflite::ops;
using namespace tflite::ops::micro;

namespace {

constexpr int kTensorArenaSize = 286432;

#if defined(EI_CLASSIFIER_ALLOCATION_STATIC)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX)
#pragma Bss(".tensor_arena")
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#pragma Bss()
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX_GNU)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16) __attribute__((section(".tensor_arena")));
#else
#define EI_CLASSIFIER_ALLOCATION_HEAP 1
uint8_t* tensor_arena = NULL;
#endif

static uint8_t* tensor_boundary;
static uint8_t* current_location;

template <int SZ, class T> struct TfArray {
  int sz; T elem[SZ];
};
enum used_operators_e {
  OP_CONV_2D, OP_DEPTHWISE_CONV_2D, OP_PAD, OP_ADD, OP_RESHAPE, OP_FULLY_CONNECTED, OP_SOFTMAX,  OP_LAST
};
struct TensorInfo_t { // subset of TfLiteTensor used for initialization from constant memory
  TfLiteAllocationType allocation_type;
  TfLiteType type;
  void* data;
  TfLiteIntArray* dims;
  size_t bytes;
  TfLiteQuantization quantization;
};
struct NodeInfo_t { // subset of TfLiteNode used for initialization from constant memory
  struct TfLiteIntArray* inputs;
  struct TfLiteIntArray* outputs;
  void* builtin_data;
  used_operators_e used_op_index;
};

TfLiteContext ctx{};
TfLiteTensor tflTensors[183];
TfLiteEvalTensor tflEvalTensors[183];
TfLiteRegistration registrations[OP_LAST];
TfLiteNode tflNodes[71];

const TfArray<4, int> tensor_dimension0 = { 4, { 1,96,96,1 } };
const TfArray<1, float> quant0_scale = { 1, { 0.0039215688593685627, } };
const TfArray<1, int> quant0_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant0 = { (TfLiteFloatArray*)&quant0_scale, (TfLiteIntArray*)&quant0_zero, 0 };
const ALIGN(8) int32_t tensor_data1[2] = { -1, 144, };
const TfArray<1, int> tensor_dimension1 = { 1, { 2 } };
const ALIGN(8) int32_t tensor_data2[4*2] = { 
  0, 0, 
  0, 1, 
  0, 1, 
  0, 0, 
};
const TfArray<2, int> tensor_dimension2 = { 2, { 4,2 } };
const ALIGN(8) int32_t tensor_data3[16] = { -220, 38, -20, 228, -219, -245, 322, 548, 580, 34, -61, -296, -54, 678, 347, 292, };
const TfArray<1, int> tensor_dimension3 = { 1, { 16 } };
const TfArray<1, float> quant3_scale = { 1, { 2.463653072481975e-05, } };
const TfArray<1, int> quant3_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant3 = { (TfLiteFloatArray*)&quant3_scale, (TfLiteIntArray*)&quant3_zero, 0 };
const ALIGN(8) int32_t tensor_data4[2] = { -33, 33, };
const TfArray<1, int> tensor_dimension4 = { 1, { 2 } };
const TfArray<1, float> quant4_scale = { 1, { 0.00010079735511681065, } };
const TfArray<1, int> quant4_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant4 = { (TfLiteFloatArray*)&quant4_scale, (TfLiteIntArray*)&quant4_zero, 0 };
const ALIGN(8) int32_t tensor_data5[2] = { 9, 1280, };
const TfArray<1, int> tensor_dimension5 = { 1, { 2 } };
const ALIGN(8) int32_t tensor_data6[16] = { 2279, 1021, 1152, 3176, 73736, 57789, 12153, 77429, 9977, 61614, 3515, -62, 17466, 112244, 694, -28619, };
const TfArray<1, int> tensor_dimension6 = { 1, { 16 } };
const TfArray<16, float> quant6_scale = { 16, { 8.5352898167911917e-05, 0.00015821770648472011, 9.1762791271321476e-05, 6.969111564103514e-05, 1.1993707630608696e-05, 1.5377920135506429e-05, 5.8282221289118752e-05, 1.3155263332009781e-05, 7.1656002546660602e-05, 1.6910207705223002e-05, 0.00012849303311668336, 0.00012071874516550452, 9.3814895080868155e-05, 8.5714209490106441e-06, 0.00012012928345939144, 1.7608681446290575e-05, } };
const TfArray<16, int> quant6_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant6 = { (TfLiteFloatArray*)&quant6_scale, (TfLiteIntArray*)&quant6_zero, 0 };
const ALIGN(8) int32_t tensor_data7[144] = { 4083, 4736, 8972, 3355, 10600, 4047, 1423, 5052, 13879, 7415, 815, 8204, 5386, 2788, 2709, 2979, 6911, 2145, 2222, -2576, -651, 4123, 1547, 2734, 8984, 1440, 5201, 11622, 7166, -623, 2569, 588, 4897, 434, 5452, 812, 6804, 4884, 4095, -4034, 2782, 4563, 1651, 2840, 5311, 879, 334, 10430, 7114, 2970, 1066, 2573, 2978, 6044, 7084, 2132, 6798, 2359, 360, 4020, -1793, 16217, 2958, 6316, 4995, 1757, -1204, 9531, 7193, 1165, 7514, 256, 3681, 3805, -1350, 4501, 5612, 1133, 2092, 1343, 4736, 1433, 1631, 1534, 1223, 3826, -640, 2241, 139, 37946, 899, 1091, 2310, 4778, 261, -2569, 15501, 1101, 1696, 3801, 17964, 7848, 3004, 1989, 15108, 2070, 13030, 1594, 2798, 1643, 816, 3451, 4193, 6228, 4746, 3831, 3103, 3230, 10303, 2110, 4615, 2923, 1281, 891, 3494, 10585, -410, 4318, 1509, -2325, 5022, 11403, 2901, 977, 3472, 937, 1561, 6577, 6052, 1312, 1479, 3453, 2285, 2100, };
const TfArray<1, int> tensor_dimension7 = { 1, { 144 } };
const TfArray<144, float> quant7_scale = { 144, { 0.00010122358798980713, 8.1057383795268834e-05, 8.1535537901800126e-05, 0.00010473951988387853, 7.0535679697059095e-05, 9.5840092399157584e-05, 0.0001237919059349224, 8.6412735981866717e-05, 5.5603541113669053e-05, 6.3435814809054136e-05, 0.00015696646005380899, 7.5016730988863856e-05, 9.4763163360767066e-05, 0.00011584562889765948, 0.00012083582987543195, 0.00011479382374091074, 8.7132153566926718e-05, 0.00012949042138643563, 8.7952750618569553e-05, 0.00010172140173381194, 9.9078039056621492e-05, 0.00013484565715771168, 0.00010248217586195096, 8.8452929048798978e-05, 8.459037053398788e-05, 0.00011351535795256495, 0.00013211631448939443, 5.8057477872353047e-05, 7.9302866652142256e-05, 0.00011825323599623516, 9.4098293629940599e-05, 0.00010880367335630581, 0.00010585269774310291, 0.00017847251729108393, 0.00010939178901026025, 0.0001746946363709867, 9.3922833912074566e-05, 0.00011370224092388526, 0.00011308456305414438, 0.00010488763655303046, 0.00010073876910610124, 8.5500476416200399e-05, 0.00012722880637738854, 7.9376142821274698e-05, 0.00010803747863974422, 9.786326700123027e-05, 9.6707735792733729e-05, 7.6086238550487906e-05, 8.5553125245496631e-05, 0.00010129427391802892, 0.00011908509623026475, 0.00010204729187535122, 0.00011606089537963271, 8.7703243480063975e-05, 8.4226390754338354e-05, 0.00011119369446532801, 6.0030000895494595e-05, 8.4356302977539599e-05, 0.00013070806744508445, 0.00012797972885891795, 9.5556635642424226e-05, 5.0565427955007181e-05, 0.0001170857940451242, 0.00010511417349334806, 8.5578190919477493e-05, 0.00012386932212393731, 0.00012590594997163862, 8.2205588114447892e-05, 8.5727362602483481e-05, 9.4858973170630634e-05, 8.6835760157555342e-05, 0.00014503179409075528, 0.00010728976485552266, 0.00010681457933969796, 9.5644827524665743e-05, 9.1807989520020783e-05, 0.00010268767073284835, 0.00012588762911036611, 7.2241120506078005e-05, 0.00012558397429529577, 8.3266175352036953e-05, 0.00016046274686232209, 0.00017541281704325229, 0.00012811450869776309, 0.00010696594836190343, 9.2378104454837739e-05, 0.00011069405445596203, 0.00013325097097549587, 9.6222582214977592e-05, 2.5962004656321369e-05, 0.0001330888771917671, 8.965973393060267e-05, 9.529231465421617e-05, 0.00011895658099092543, 0.00010377394210081547, 0.00016955399769358337, 5.2759260142920539e-05, 0.00010738315177150071, 0.00015530362725257874, 9.6097362984437495e-05, 5.116732427268289e-05, 8.2180973549839109e-05, 0.00012459862045943737, 0.00010663933062460274, 5.4092321079224348e-05, 9.6162715635728091e-05, 6.4873835071921349e-05, 0.00013728468911722302, 0.00016818945005070418, 0.00012708843860309571, 0.00018463790183886886, 9.4550312496721745e-05, 8.9606794063001871e-05, 6.9617148255929351e-05, 9.5980554760899395e-05, 0.00013784170732833445, 9.7659278253559023e-05, 8.4251929365564138e-05, 6.0924619901925325e-05, 8.0868281656876206e-05, 0.00010595624917186797, 0.00010622764239087701, 0.00012118757149437442, 0.00013899467012379318, 0.0001137111903517507, 7.174904749263078e-05, 8.0151789006777108e-05, 8.5130523075349629e-05, 0.00014807944535277784, 0.00010098703933181241, 9.2566784587688744e-05, 6.5128180722240359e-05, 0.00013374398986343294, 0.00011459492088761181, 9.7771706350613385e-05, 8.4312654507812113e-05, 0.00013360450975596905, 6.8521658249665052e-05, 7.5901989475823939e-05, 9.5256124041043222e-05, 0.00012292571773286909, 0.00011543536675162613, 0.00016982693341560662, 0.00010898162145167589, } };
const TfArray<144, int> quant7_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant7 = { (TfLiteFloatArray*)&quant7_scale, (TfLiteIntArray*)&quant7_zero, 0 };
const ALIGN(8) int32_t tensor_data8[144] = { 4963, 10301, -342, 458, -118, 3, -6099, 8342, -138, 6276, -4230, -111, 2057, 10638, -2134, 11075, 8729, -4431, -5651, -1815, -1169, 13797, -667, 928, -300, -2915, 1773, -128, -897, -2497, -125, 7047, -1028, -3040, -33, -3527, 15678, -162, 173, -11, 165, -436, -3459, -1289, -40, 7190, -1275, 3630, 2320, 631, 7337, -76, -4201, -1767, 92, -397, -16, -56, -2552, 14045, -2937, -400, 11095, -1324, -521, 9480, -1996, -201, -93, 538, -178, -987, 13110, 5139, -2381, 1111, 9089, 3337, -3975, -1798, -742, -1117, 15668, 24, 4769, 7918, -3043, 8943, -2102, 12025, -25, -2908, -270, 7548, -1880, 8110, -354, 8509, 10367, -630, 11218, 275, -999, 305, -103, 2699, -241, 73, 9385, -4450, -7497, 1612, -2543, 237, -24, 7968, 34, -16, 12026, -315, 297, 4259, -3310, -3816, -298, -65, -3100, 462, 243, -2117, -400, 127, -6729, -2791, 12068, -5082, -194, -285, 7603, -1411, -213, 7106, 10562, -3322, };
const TfArray<1, int> tensor_dimension8 = { 1, { 144 } };
const TfArray<144, float> quant8_scale = { 144, { 0.0001787340734153986, 0.00013508221309166402, 0.00023528850579168648, 0.00020856644550804049, 0.00034484249772503972, 0.00020945776486769319, 0.00017834718164522201, 0.00014783433289267123, 0.00034055943251587451, 0.00017292187840212137, 0.00020720341126434505, 0.00025828505749814212, 0.00017311899864580482, 0.0001006189631880261, 0.00025466177612543106, 0.00010508189006941393, 0.00013706604659091681, 0.00017190379730891436, 0.00015966597129590809, 0.00037584116216748953, 0.00036660980549640954, 0.00010343127360101789, 0.00030408686143346131, 0.00037864470505155623, 0.00024951386149041355, 0.0002294795704074204, 0.00029132509371265769, 0.00023111898917704821, 0.00023848230193834752, 0.00023027001589071006, 0.00019087981490883976, 0.00012974707351531833, 0.00026460827211849391, 0.00022483296925202012, 0.00014938319509383291, 0.00020395647152327001, 0.00010286134056514129, 0.00015455592074431479, 0.00017632698290981352, 0.00066104787401854992, 0.00022678988170810044, 0.00033842533593997359, 0.00022453306883107871, 0.00024585227947682142, 0.00025005964562296867, 0.00012618314940482378, 0.00037642513052560389, 0.0003009373031090945, 0.00019987278210464865, 0.00040013523539528251, 0.00013278603728394955, 0.00028832105454057455, 0.00017598964041098952, 0.00022615122725255787, 0.00020419659267645329, 0.00035069408477284014, 0.00021325469424482435, 0.00021515943808481097, 0.00029652687953785062, 0.0001016084715956822, 0.00028207470313645899, 0.00033348242868669331, 9.4309740234166384e-05, 0.00028139250935055315, 0.00024278255295939744, 0.00011005264241248369, 0.00033240541233681142, 0.00024051321088336408, 0.00032536941580474377, 0.0004135722410865128, 0.00024770139134489, 0.0003205653338227421, 8.8185224740300328e-05, 0.00018940100562758744, 0.0001659038825891912, 0.00020190110080875456, 0.00014254402776714414, 0.00023206599871627986, 0.00025302096037194133, 0.00026516287471167743, 0.00033532688394188881, 0.00028706583543680608, 9.0864974481519312e-05, 0.0002314312441740185, 0.00019630369206424803, 0.00013392289110925049, 0.0002819143992383033, 0.00011136948160128668, 0.0002331861323909834, 0.00028009215020574629, 0.00021134353301022202, 0.00013514878810383379, 0.0002879743988160044, 0.00010809005470946431, 0.00010302991722710431, 0.00011951373016927391, 0.00034676090581342578, 0.00011350664135534316, 0.00011166720651090145, 0.00031691719777882099, 0.00023986499581951648, 0.00026123013230971992, 0.00038020647480152547, 0.00026680846349336207, 0.00027283138479106128, 0.00015048040950205177, 0.00026093344786204398, 0.00039055297384038568, 0.00013269933697301894, 0.0001659645204199478, 9.0479661594145e-05, 0.00017436749476473778, 0.00014289317186921835, 0.00023284403141587973, 0.00029583938885480165, 0.00015010085189715028, 0.00024532852694392204, 0.00028472574194893241, 9.7263902716804296e-05, 0.00025734989321790636, 0.00025864370400086045, 0.00012050200166413561, 0.00021877346443943679, 0.00023621988657396287, 0.00023589140619151294, 0.00026984993019141257, 0.00030655800946988165, 0.00023526145378127694, 0.00025913782883435488, 0.00037628659629262984, 0.0001725772162899375, 0.00028189149452373385, 0.0001185901346616447, 0.00025717468815855682, 9.3135276983957738e-05, 0.0001964261318789795, 0.00032259558793157339, 0.00028815536643378437, 0.00015302938118111342, 0.00030750432051718235, 0.00022276242088992149, 0.00014775994350202382, 0.00011289755639154464, 0.00028560424107126892, } };
const TfArray<144, int> quant8_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant8 = { (TfLiteFloatArray*)&quant8_scale, (TfLiteIntArray*)&quant8_zero, 0 };
const ALIGN(8) int32_t tensor_data9[144] = { 5703, 7225, -61, 2175, 1378, 1372, 1120, 1864, -1684, 2615, 3442, 1542, 4637, 1398, -268, 570, 2484, 6287, 2033, 744, 4665, -860, 1754, -98, 5097, 1898, 3376, 3819, 387, 2774, 2777, 1320, 5535, 2597, 1185, -381, 1211, 3587, 3151, 527, 1529, 5992, 3452, 58, 2510, 1401, 2035, 3094, 336, -1036, 13392, -55, 3080, 686, -777, 3850, 5242, 1270, 1601, 2108, 2439, 1493, 2142, 607, 1685, 1526, 2446, 1515, 3236, 1178, 3508, 4870, 1858, 2381, -96, 6492, 6303, 2130, 3802, 965, -468, 80, 1232, 1888, 2337, 5513, 880, 27, 1747, 1154, 2432, 1986, 1650, 2802, 3122, 11554, -3938, 7180, 570, 1441, -863, 2270, 1430, 870, 1429, 4759, 2363, 2296, 3679, 6752, -1743, 921, 4181, 6361, 720, 9470, 529, -758, -136, 396, 2302, 1957, 2611, -1197, 3138, 6463, 1577, 1118, 1051, 814, 2458, 3964, 987, 930, 5966, 4388, 1600, 3009, 3636, 4181, 10271, 7309, 761, 166, };
const TfArray<1, int> tensor_dimension9 = { 1, { 144 } };
const TfArray<144, float> quant9_scale = { 144, { 8.2472230133134872e-05, 8.0244084529113024e-05, 0.00011310676927678287, 0.00012419553240761161, 0.00010919793567154557, 9.0457317128311843e-05, 0.00015982839977368712, 0.00010309112985851243, 0.00011070096661569551, 9.9332159152254462e-05, 9.4883936981204897e-05, 0.00012985224020667374, 9.2745387519244105e-05, 9.4289382104761899e-05, 0.00010838648449862376, 8.6665531853213906e-05, 9.1581343440338969e-05, 7.798115984769538e-05, 0.00014538895629812032, 9.8024749604519457e-05, 9.9781704193446785e-05, 0.00011768990952987224, 7.204362191259861e-05, 0.00011035522038582712, 8.3020837337244302e-05, 0.00011320266639813781, 8.9455803390592337e-05, 0.00011324833758408204, 7.1593989559914917e-05, 0.00010846264194697142, 0.00011152483784826472, 0.00010721081343945116, 7.8968572779558599e-05, 0.0001298588904319331, 0.00014158492558635771, 0.00011567283218028024, 0.00012456683907657862, 0.0001107896096073091, 9.2774891527369618e-05, 0.0001349160447716713, 0.00020145198504906148, 8.5167659563012421e-05, 0.00010439322795718908, 8.7297383288387209e-05, 8.2992388342972845e-05, 0.00014489803288597614, 9.7887794254347682e-05, 0.00011807208647951484, 7.8540084359701723e-05, 8.9693196059670299e-05, 6.5042171627283096e-05, 0.00010171238682232797, 0.00011371143045835197, 0.00013904202205594629, 7.5263815233483911e-05, 0.00011187563359271735, 7.9240409831982106e-05, 7.9223762440960854e-05, 0.00010412076517241076, 0.00013542671513278037, 0.0001167138252640143, 0.00012177428288850933, 8.643147157272324e-05, 0.0001806777436286211, 0.00016523829253856093, 0.00010267495235893875, 0.00011012847971869633, 0.00011747572716558352, 0.00011132379586342722, 0.00012158618483226746, 9.3135633505880833e-05, 9.4087670731823891e-05, 8.4877654444426298e-05, 0.0001142357214121148, 0.00013226596638560295, 0.00011544455628609285, 7.3585215432103723e-05, 8.5942752775736153e-05, 8.8511813373770565e-05, 9.108903759624809e-05, 0.00012462401355151087, 0.000111567453132011, 0.00010912615834968165, 9.2233043687883765e-05, 9.7699383331928402e-05, 8.7527609139215201e-05, 0.00014365672541316599, 0.00014589981583412737, 7.9214121797122061e-05, 8.5278057667892426e-05, 8.0288729805033654e-05, 8.9179557107854635e-05, 0.00012460506695788354, 9.639693598728627e-05, 9.0637753601185977e-05, 7.2400689532514662e-05, 8.2635327999014407e-05, 7.7333490480668843e-05, 0.00013816502178087831, 0.00011555388482520357, 8.1890510045923293e-05, 0.00011766486568376422, 0.00016666651936247945, 7.5929623562842607e-05, 9.8658158094622195e-05, 8.2670710980892181e-05, 0.00011232548422412947, 0.00010752949310699478, 9.9414864962454885e-05, 7.0684342063032091e-05, 8.6007195932324976e-05, 7.6873402576893568e-05, 8.2492333604022861e-05, 6.7267297708895057e-05, 0.00010628985910443589, 7.4119881901424378e-05, 9.1529356723185629e-05, 0.0001234907831531018, 9.7301861387677491e-05, 7.9055105743464082e-05, 9.9975004559382796e-05, 0.00011382369848433882, 0.00010060079512186348, 9.0781388280447572e-05, 0.00011602310405578464, 8.8908251200336963e-05, 9.3675465905107558e-05, 0.00012038213753839955, 0.00010485647362656891, 0.0001240028504980728, 0.00013265969755593687, 0.0001093193786800839, 0.00010827543883351609, 0.00012458107084967196, 7.215825462481007e-05, 8.506605081493035e-05, 0.00011750717385439202, 9.6670359198469669e-05, 9.5404328021686524e-05, 0.00010116910561919212, 6.2762257584836334e-05, 9.9641853012144566e-05, 9.0625173470471054e-05, 8.9340093836653978e-05, } };
const TfArray<144, int> quant9_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant9 = { (TfLiteFloatArray*)&quant9_scale, (TfLiteIntArray*)&quant9_zero, 0 };
const ALIGN(8) int32_t tensor_data10[144] = { 12096, -441, 6, -43, -522, -890, -46, -288, -5304, -18, 722, -703, 15707, 37, -4143, -4014, -9912, 16601, -8919, -5287, 13846, -12557, -590, -7371, -30, -215, 15878, 12400, -3681, -698, 19275, -6296, -11209, 11836, 71, 96, -3760, -166, 8932, -5798, -6680, -2098, 19368, -2951, -417, -929, -1330, 15247, -244, -5373, 23344, 20, 11813, 8759, -2609, -175, -153, -4882, 10803, -6525, 13608, -198, -459, -4692, -729, -3581, 2456, 1855, 11994, -5598, -310, -74, -4550, 630, -6118, 16575, -320, -1826, 342, -962, -6091, -6013, 12211, -105, 10738, 15152, 11659, 13789, -78, 13099, -76, 2594, -1276, -4582, 82, 18200, -2559, -340, -3547, -386, 64, -521, 15217, -387, -3881, 6662, -865, -664, 541, -1149, -6553, 3917, 14821, -135, -5866, -142, -5164, -352, -296, -1379, -7871, 13709, -2551, -41, -3212, 10030, -3644, -5272, -1240, -1004, -51, 18604, -4421, -63, -2167, 13110, -8376, 19817, -391, -822, -39, -440, -1579, 9330, };
const TfArray<1, int> tensor_dimension10 = { 1, { 144 } };
const TfArray<144, float> quant10_scale = { 144, { 0.00010227735037915409, 0.00017600813589524478, 0.00017717859009280801, 0.00023488698934670538, 0.00024716748157516122, 0.00018962673493660986, 0.00015072672977112234, 0.00021408198517747223, 0.00017103068239521235, 0.00022944620286580175, 0.00029817706672474742, 0.00017771212151274085, 8.8150540250353515e-05, 0.00017880040104500949, 0.00020097369269933552, 0.00013249310723040253, 9.5857416454236954e-05, 9.0588218881748617e-05, 0.00010204167483607307, 0.00021497347916010767, 8.119957783492282e-05, 7.5366879173088819e-05, 0.0002838331856764853, 8.406541746808216e-05, 0.00017278935411013663, 0.00018373140483163297, 7.2071874456014484e-05, 0.00010385286441305652, 0.00024414091603830457, 0.00021975747949909419, 6.1778657254762948e-05, 9.2605885583907366e-05, 0.00012990797404199839, 9.9716729891952127e-05, 0.00018652745347935706, 0.00027332644094713032, 0.00022381894814316183, 0.00015472741506528109, 0.00012519325537141412, 0.00017004876281134784, 0.00016813777619972825, 0.00020512494666036218, 7.2231574449688196e-05, 0.00023803279327694327, 0.00022370598162524402, 0.00013858149759471416, 0.00016000572941266, 8.5778483480680734e-05, 0.0001376216096105054, 0.00021780378301627934, 8.5357809439301491e-05, 0.00037390651414170861, 9.8357450042385608e-05, 0.00011642056779237464, 0.00020725622016470879, 0.00015324540436267853, 0.0001970736775547266, 9.2438436695374548e-05, 0.0001056721230270341, 0.00014017694047652185, 9.7825119155459106e-05, 0.00023257908469531685, 0.00015627936227247119, 0.00014025947893969715, 0.00017457552894484252, 0.0001612464984646067, 0.00019790387887042016, 0.00015041499864310026, 0.00011131638893857598, 0.00018185401859227568, 0.00021952635142952204, 0.00024315697373822331, 0.00019928120309486985, 0.00016940895875450224, 0.00011833409371320158, 0.00010611311881802976, 0.00020100854453630745, 0.00014582014409825206, 0.0001892363652586937, 0.00017798933549784124, 0.00015845580492168665, 0.00018858327530324459, 0.00010235795343760401, 0.00018727770657278597, 0.0001043635857058689, 0.00011092747445218265, 9.9790202511940151e-05, 7.8031400335021317e-05, 0.00023197109112516046, 9.3170907348394394e-05, 0.00030991964740678668, 0.00021203645155765116, 0.00017087646119762212, 0.00011580032150959596, 0.00017873360775411129, 0.00010670683695934713, 0.00030260835774242878, 0.00024094518448691815, 0.00019617044017650187, 0.00015645359235350043, 0.00035784384817816317, 0.00016311899526044726, 8.3363469457253814e-05, 0.00023231370141729712, 0.00020721141481772065, 0.00012442863953765482, 0.00014219069271348417, 0.00019240191613789648, 0.00022623538097832352, 0.00020460360974539071, 9.0028806880582124e-05, 0.000142151620821096, 7.5188232585787773e-05, 0.00021385442232713103, 0.00015627166430931538, 0.0001950241276063025, 0.00010633553756633773, 0.0001867018872871995, 0.0002182265161536634, 0.00022554986935574561, 0.00011116109817521647, 9.2554560978896916e-05, 0.00024581881007179618, 0.0003909822553396225, 0.00015216796600725502, 0.00015678013733122498, 0.00013317744014784694, 0.00020244761253707111, 0.00017583934823051095, 0.00028508194372989237, 0.00010719463898567483, 6.6246837377548218e-05, 0.00014943921996746212, 0.00020137682440690696, 0.00022390893718693405, 9.9407370726112276e-05, 0.00014669781376142055, 0.00010661408305168152, 0.00016540796787012368, 0.00017404701793566346, 0.00021374537027440965, 0.00010866886441363022, 0.00017538511019665748, 0.00013699699775315821, } };
const TfArray<144, int> quant10_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant10 = { (TfLiteFloatArray*)&quant10_scale, (TfLiteIntArray*)&quant10_zero, 0 };
const ALIGN(8) int32_t tensor_data11[144] = { 1182, 2104, 3687, 1894, 2161, 3127, 9943, 70, 271, 5817, 12218, 2240, 1453, 5050, 1746, 437, 3479, 321, 1233, 143, 1566, 1880, 9140, 4840, 3324, 199, -4594, 887, -1898, 2756, 974, -1332, 575, 713, 3256, 1560, 2355, 1892, 3321, 4809, 2666, 3037, 1524, 2850, 618, 859, 1022, 2959, 3534, 713, 1076, 398, 3774, 2135, 3589, 817, 1834, 1354, 3345, 558, 484, 2837, 1867, 525, -440, 7514, 843, 7596, -1117, 968, 3621, 2271, 2609, 1668, 1227, 2277, 2416, 1022, 3062, 197, 4, -393, 1044, 523, 56, 2036, 3118, 4379, 1091, 2959, 3963, 3713, -26, 588, 5233, 1188, 497, 2309, 102, 9461, 2813, -1131, 321, 2950, 1180, 2215, 491, 933, -1266, 322, -923, -134, 1616, 2626, 2785, 3601, 3069, 2843, 164, -2936, -98, -1171, 1249, 3304, 3733, -222, 3239, -298, 577, 3525, 5780, 314, 938, 2124, -587, 6111, 7698, 445, 847, -8988, 2530, 645, -354, 4982, };
const TfArray<1, int> tensor_dimension11 = { 1, { 144 } };
const TfArray<144, float> quant11_scale = { 144, { 9.8142234492115676e-05, 9.3623348220717162e-05, 6.9870911829639226e-05, 8.4779021563008428e-05, 7.9062716395128518e-05, 7.735343388048932e-05, 6.0940939874853939e-05, 8.4261824667919427e-05, 0.00011990383791271597, 7.8782060882076621e-05, 4.9656897317618132e-05, 9.57088777795434e-05, 8.8632150436751544e-05, 8.5132014646660537e-05, 8.1553698692005128e-05, 0.00010958650818793103, 8.3155820902902633e-05, 0.00012009802594548091, 0.00012644538946915418, 8.5116138507146388e-05, 8.7264954345300794e-05, 9.5446055638603866e-05, 6.2010913097765297e-05, 8.3157385233789682e-05, 9.723731636768207e-05, 8.3236343925818801e-05, 7.467003888450563e-05, 0.00014613302482757717, 9.8326636361889541e-05, 0.00010259863483952358, 8.8107088231481612e-05, 0.00010565945558482781, 0.000109405918919947, 0.00013070252316538244, 0.00011713458661688492, 9.3454211310017854e-05, 0.00012808706378564239, 7.7422155300155282e-05, 9.5313742349389941e-05, 9.4731825811322778e-05, 9.9530298030003905e-05, 8.5104722529649734e-05, 0.00013515223690774292, 9.2895206762477756e-05, 0.00010158109216718003, 0.00011669651576085016, 0.00010658465907908976, 9.3290989752858877e-05, 9.661987132858485e-05, 9.0244073362555355e-05, 9.4483548309653997e-05, 0.00010152303002541885, 7.8102413681335747e-05, 7.8568082244601101e-05, 8.0344121670350432e-05, 9.6444913651794195e-05, 9.47801090660505e-05, 0.00011924946738872677, 8.5883169958833605e-05, 9.6143172413576394e-05, 0.00013008386304136366, 0.00011301261110929772, 0.00011280921899015084, 0.00010984236723743379, 0.00013690332707483321, 7.1663751441519707e-05, 8.6995052697602659e-05, 8.359752973774448e-05, 8.5995336121413857e-05, 9.3386268417816609e-05, 0.00010431661212351173, 0.0001572409673826769, 0.0001046020770445466, 0.0001153847697423771, 9.4631184765603393e-05, 8.5777246567886323e-05, 0.00013597134966403246, 0.00015874281234573573, 8.5406565631274134e-05, 7.9847741289995611e-05, 0.00010799269512062892, 0.00010170671885134652, 0.00012027139746351168, 0.00010072994336951524, 0.00011420343798818067, 7.9181263572536409e-05, 9.0156827354803681e-05, 7.5201860454399139e-05, 8.7300977611448616e-05, 9.1435991635080427e-05, 8.5044222942087799e-05, 9.5979288744274527e-05, 0.00014485478459391743, 7.9726909461896867e-05, 9.0697976702358574e-05, 0.00010710174683481455, 0.0001068997589754872, 8.332754805451259e-05, 0.00011634785914793611, 6.7558285081759095e-05, 0.00011028361041098833, 8.8894070358946919e-05, 8.0837031418923289e-05, 8.8012006017379463e-05, 0.00015787259326316416, 0.00011878897930728272, 0.00011718643509084359, 8.7935688497964293e-05, 8.302121568704024e-05, 0.0001050901337293908, 0.00011974602966802195, 0.00016022277122829109, 7.6842727139592171e-05, 9.8644886747933924e-05, 0.00011111386265838519, 9.5313203928526491e-05, 8.8095759565476328e-05, 8.1206359027419239e-05, 0.00014459554222412407, 9.3996546638663858e-05, 0.00011627219646470621, 0.00013486045645549893, 0.00011086497397627681, 9.4732691650278866e-05, 8.0931757111102343e-05, 0.00012042518937960267, 8.277266169898212e-05, 0.00013927124382462353, 0.00013916206080466509, 0.00010018012835644186, 8.8507847976870835e-05, 0.0001093734463211149, 7.4280847911722958e-05, 0.00010569211735855788, 0.000132191096781753, 7.8023476817179471e-05, 7.3689152486622334e-05, 0.00014993794320616871, 0.00010721717262640595, 6.2045575759839267e-05, 9.2749985924456269e-05, 0.00015337181685026735, 0.00011548212205525488, 8.5695784946437925e-05, } };
const TfArray<144, int> quant11_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant11 = { (TfLiteFloatArray*)&quant11_scale, (TfLiteIntArray*)&quant11_zero, 0 };
const ALIGN(8) int32_t tensor_data12[144] = { 12004, -242, -7138, 207, 611, 14897, 17253, -2422, -1499, 21432, 6495, 11364, -1793, 2073, 10421, -2303, 14461, -1034, -1776, -4350, -104, -208, 24148, 17068, -272, -328, -3456, 12130, -3740, 19625, -572, -1970, -7493, 11493, 3787, -510, -568, -1164, 16224, 10701, 11220, 10114, -375, 20856, -4142, -1598, 242, -9327, -5791, -1735, -6033, -89, 829, 9438, -138, -4633, 9746, -2716, 18174, -5149, -2065, 5741, 14398, 17334, -2141, 15111, -7642, 9074, 180, -3698, 15476, 1576, 4849, -3648, 8498, 19437, 762, -7016, -6116, -7553, -632, -5107, -5875, -7091, -5092, 288, -772, -5173, 438, -13583, -618, -7361, -444, -2612, 3405, -6895, -3457, 411, 771, 19129, 12473, -1999, -3124, -12497, -10013, -4178, -235, -3438, 8808, -2530, -8502, -8723, 1332, -3578, 7020, -5564, -176, 232, -8128, -2600, -3582, -5162, -5926, 5845, 4948, -7228, 8169, -4925, -2358, 7548, 152, -1898, 9339, 7924, -6263, 12635, 6137, -3373, -1388, -1332, 7696, -14, -3120, 11583, };
const TfArray<1, int> tensor_dimension12 = { 1, { 144 } };
const TfArray<144, float> quant12_scale = { 144, { 9.8039046861231327e-05, 0.00023799465270712972, 0.00012978870654478669, 0.00023599436099175364, 0.00024761757231317461, 9.2713824415113777e-05, 0.00010717016266426072, 0.00010794886475196108, 0.00014493100752588362, 6.8282577558420599e-05, 0.00015077927673701197, 0.00011074251233367249, 0.00013530762225855142, 0.00024171006225515157, 0.00010788990766741335, 0.00017831288278102875, 8.3091734268236905e-05, 0.000189137106644921, 0.00014207480126060545, 0.00018072743841912597, 0.00013782235328108072, 0.00021291464508976787, 6.6248154325876385e-05, 7.0574933488387614e-05, 0.00016758892161305994, 0.0002677318116184324, 0.00031943619251251221, 9.227135160472244e-05, 0.00024266455147881061, 6.191964348545298e-05, 0.00016838770534377545, 0.00024654174922034144, 0.00013891662820242345, 9.3571674369741231e-05, 0.00015670896391384304, 0.00020101162954233587, 0.00016889414109755307, 0.00018204825755674392, 7.425944204442203e-05, 0.00010477481555426493, 0.0001073785315384157, 0.00010995216143783182, 0.00013927975669503212, 6.3626423070672899e-05, 0.00020076350483577698, 0.00019208983576390892, 0.00016267159662675112, 0.00010471477435203269, 0.00013842956104781479, 0.00017974800721276551, 8.7245287431869656e-05, 0.00020105474686715752, 0.00020769989350810647, 9.7656564321368933e-05, 0.00012981118925381452, 0.00012684613466262817, 0.00010237550304736942, 0.00025996557087637484, 6.4934509282466024e-05, 0.00017296508303843439, 0.00026865708059631288, 0.00016187074652407318, 7.6383024861570448e-05, 6.4390020270366222e-05, 0.00027407234301790595, 0.00010628963354974985, 9.4719216576777399e-05, 0.00012467660417314619, 0.00022161993547342718, 0.00013801961904391646, 9.7317177278455347e-05, 0.00016493804287165403, 0.00017760637274477631, 0.00021359969105105847, 0.00011342907964717597, 6.2455597799271345e-05, 0.00019110176071990281, 0.00016634643543511629, 0.00011972992069786415, 0.00013832065451424569, 0.00020855583716183901, 0.00019821031310129911, 0.0001482436346122995, 0.00019624159904196858, 0.00018143869237974286, 0.00010184925486100838, 0.00023990687623154372, 0.00012065168266417459, 0.00028831366216763854, 7.4087380198761821e-05, 0.00020773493451997638, 0.00013782772293779999, 0.00018126885697711259, 0.00016015012806747109, 0.00017574369849171489, 0.00012587438686750829, 0.00017503462731838226, 0.00024733867030590773, 0.00018355410429649055, 9.1578091087285429e-05, 0.00010301741713192314, 8.2946389738935977e-05, 0.00020133901853114367, 8.2597754953894764e-05, 0.00015142012853175402, 0.00019673274073284119, 0.00023789689294062555, 0.00019265581795480102, 0.0001321330782957375, 0.00027885354938916862, 0.00012796177179552615, 9.9005279480479658e-05, 0.00020912862964905798, 0.00011063156125601381, 0.00013031512207817286, 0.00012885493924841285, 0.00015387800522148609, 0.0001781046885298565, 0.00014357719919644296, 0.00028760044369846582, 0.00017853952886071056, 0.00013018226309213787, 0.00025335923419333994, 0.00016240171680692583, 0.00017268765077460557, 0.00016540635260753334, 0.00014208376524038613, 0.00017297417798545212, 0.00018922693561762571, 0.00015761236136313528, 0.00019933484145440161, 0.00028979690978303552, 0.00010954158642562106, 0.00011435043415986001, 0.00016743050946388394, 8.234108827309683e-05, 0.0001748621289152652, 0.00019744812743738294, 0.00026007756241597235, 0.00058901624288409948, 0.00014031962200533599, 0.00021635457233060151, 0.00014952992205508053, 0.00011140277638332918, } };
const TfArray<144, int> quant12_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant12 = { (TfLiteFloatArray*)&quant12_scale, (TfLiteIntArray*)&quant12_zero, 0 };
const ALIGN(8) int32_t tensor_data13[48] = { 2873, -1171, -1043, 3468, 35240, 4339, -1256, 10871, 3608, 3729, 609, 7572, 2965, 1318, -2366, 1120, 8053, 28040, 7955, -1973, 3041, -3345, -263, 7856, -921, -1948, 4476, -140, 8520, 39081, 7494, -73, 1088, -301, 6622, -12, 1894, -543, 2958, 2908, 4346, 4947, 513, -841, 2173, 5755, 3472, -521, };
const TfArray<1, int> tensor_dimension13 = { 1, { 48 } };
const TfArray<48, float> quant13_scale = { 48, { 0.00017716450383886695, 0.00016307408805005252, 0.00012243061792105436, 0.00011302821076242253, 2.8086451493436471e-05, 0.00014317444583866745, 0.00020311435218900442, 8.2302445662207901e-05, 0.00012095218698959798, 0.000179967304575257, 0.00012539591989479959, 0.00011794541933340952, 8.3760816778521985e-05, 0.00015039094432722777, 0.00011988602636847645, 0.00012717998470179737, 9.1260306362528354e-05, 3.3452110073994845e-05, 9.6099160145968199e-05, 0.00012952335237059742, 0.00014592883235309273, 7.6462267315946519e-05, 0.00016740839055273682, 9.4953167717903852e-05, 0.00013921903155278414, 0.0002746674872469157, 0.00011677356087602675, 0.00021450527128763497, 9.407667675986886e-05, 2.5153092792606913e-05, 9.7473784990143031e-05, 0.00027323869289830327, 0.00016197643708437681, 0.00014970968186389655, 0.00011092950444435701, 0.00014045517309568822, 0.00010544600809225813, 0.00022076827008277178, 0.00014689225645270199, 0.00020637840498238802, 0.00012813979992642999, 0.00013258271792437881, 0.00013064542145002633, 0.00016685570881236345, 0.00013046461390331388, 8.8530527136754245e-05, 0.00010333313548471779, 0.00011364875535946339, } };
const TfArray<48, int> quant13_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant13 = { (TfLiteFloatArray*)&quant13_scale, (TfLiteIntArray*)&quant13_zero, 0 };
const ALIGN(8) int32_t tensor_data14[144] = { 5362, 4492, 709, 2828, 1330, 1273, 10044, 4365, 8495, 4850, 3922, 1921, 1726, 1478, 5678, 707, 5775, 17630, 4930, 2344, 4749, 5239, 3539, 4016, 196, 6022, 4744, 4083, 3201, 3595, 2434, 5190, 5775, 215, 10851, 2351, 4723, 3180, 5761, 4612, 4660, 4749, 2359, 4852, 10704, 11293, 5672, 4018, 2415, 2927, 4100, 2238, 1797, 1240, 1084, 439, 5746, 2463, 3888, 11825, 4798, 5294, 1852, 328, 5956, 2414, 462, 5633, 5127, 1968, 7356, 3447, 2252, 3644, 3741, 5747, 3025, 2578, 5519, 7569, 9512, 2987, 4569, 2748, 3411, 2820, 2757, 4292, 994, -586, 10568, 3385, 3830, 621, 2405, 15575, 2537, 3331, 2984, 121, 253, 1739, 2415, 2361, -977, 1922, 4829, 4339, 3915, 5295, 19146, 8209, 3553, 2678, 2992, 8955, 916, 741, 8086, 8578, 1504, 3500, 7164, 7113, 1471, 1496, 3786, 2353, 3683, 6075, -108, 559, 3017, 4748, 7174, 6115, 7303, 1503, 1111, 4301, 1930, 10540, 4215, 1197, };
const TfArray<1, int> tensor_dimension14 = { 1, { 144 } };
const TfArray<144, float> quant14_scale = { 144, { 9.2034533736295998e-05, 7.2495175118092448e-05, 0.00011666832870105281, 8.7487176642753184e-05, 0.00011885426647495478, 9.888661588774994e-05, 6.9378424086607993e-05, 9.8541378974914551e-05, 6.1868864577263594e-05, 9.1912501375190914e-05, 0.00010457829193910584, 0.0001035057648550719, 9.5046998467296362e-05, 0.00011593029921641573, 9.3118767836131155e-05, 0.00010043416841654107, 0.00010222064156550914, 4.8994039389071986e-05, 0.0001081519658328034, 0.00012406922178342938, 5.1969225751236081e-05, 8.6559564806520939e-05, 0.00010268370533594862, 0.00011381890362827107, 9.287253487855196e-05, 7.8722245234530419e-05, 0.00010672223288565874, 0.00012702842650469393, 9.9811688414774835e-05, 0.00010921419743681327, 0.00013810522796120495, 8.4769038949161768e-05, 7.7890515967737883e-05, 9.2984570073895156e-05, 5.8854668168351054e-05, 9.982527990359813e-05, 7.425427611451596e-05, 0.00010316326370229945, 7.8256613051053137e-05, 9.5160612545441836e-05, 0.00010528365965001285, 6.832230428699404e-05, 8.9501401816960424e-05, 0.0001190300754387863, 6.9052533945068717e-05, 5.3776864660903811e-05, 8.5414874774869531e-05, 8.389509457629174e-05, 0.0001473089650971815, 0.0001072232989827171, 9.8812684882432222e-05, 0.00013398932060226798, 0.0001008260587695986, 9.001872967928648e-05, 0.00015467197226826102, 7.7052456617821008e-05, 8.4330553363543004e-05, 0.00010759507858892903, 9.4377035566139966e-05, 6.8015411670785397e-05, 7.5307623774278909e-05, 0.00010997433855663985, 0.00013190937170293182, 0.00011380811338312924, 9.3567789008375257e-05, 0.00012495920236688107, 9.9845747172366828e-05, 8.9107270468957722e-05, 9.0513000031933188e-05, 9.5068928203545511e-05, 8.0734935181681067e-05, 8.5635758296120912e-05, 9.556822624290362e-05, 0.00010455855954205617, 9.7766889666672796e-05, 9.122483606915921e-05, 0.00011776080646086484, 8.7029919086489826e-05, 9.5208299171645194e-05, 8.4320861788000911e-05, 6.6563916334416717e-05, 0.00010484168888069689, 9.823005530051887e-05, 8.2596896390896291e-05, 0.00011399068898754194, 0.00010470848064869642, 0.0001306175981881097, 0.00010528001439524814, 0.0001668738987063989, 0.00011901406105607748, 6.4382824348285794e-05, 9.3303329776972532e-05, 9.9868484539911151e-05, 0.00012327361037023365, 0.0001049989732564427, 5.3317726269597188e-05, 9.1691712441388518e-05, 0.0001068849815055728, 9.3214199296198785e-05, 9.773157216841355e-05, 0.00012021655129501596, 0.00011968673788942397, 7.5430201832205057e-05, 0.00012184918159618974, 9.3114264018367976e-05, 0.00012925270129926503, 8.2322098023723811e-05, 9.4782531959936023e-05, 9.1203197371214628e-05, 8.5538449638988823e-05, 4.1845501982606947e-05, 7.366646605078131e-05, 9.357243834529072e-05, 0.00010504126112209633, 9.3977600045036525e-05, 8.006547432160005e-05, 8.8245586084667593e-05, 0.00011545011511771008, 7.1463437052443624e-05, 6.2032602727413177e-05, 0.00016203011909965426, 0.00014259055024012923, 8.5891937487758696e-05, 7.6438591349869967e-05, 0.00010002253111451864, 0.00010505162208573893, 0.00011430093582021073, 0.00010936264152405784, 8.4981969848740846e-05, 0.00010027027019532397, 0.00011933475616388023, 0.00010952864977298304, 0.00013523144298233092, 8.6789703345857561e-05, 9.5923918706830591e-05, 9.025284816743806e-05, 8.0653873737901449e-05, 0.00010540673974901438, 0.00011457532673375681, 8.434373012278229e-05, 0.00011329029075568542, 6.7892120569013059e-05, 8.7992018961813301e-05, 0.0001117981446441263, } };
const TfArray<144, int> quant14_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant14 = { (TfLiteFloatArray*)&quant14_scale, (TfLiteIntArray*)&quant14_zero, 0 };
const ALIGN(8) int32_t tensor_data15[144] = { -6436, 895, 18358, 11949, -8048, -1513, 6, -2676, 24368, -600, -1506, -3392, -2111, -5136, 17273, -441, -1810, 37399, -1635, -2204, 358, -129, 22602, 14206, -5019, -5043, 84, -811, -218, -3641, -2561, 930, -2465, -3656, -4870, -4247, 1796, -138, 1144, 15856, 20863, 17597, 15734, -128, 19501, 1470, -408, 14897, 5334, -3769, -4597, 25852, 137, -2006, -8347, 904, 9, 3312, 24712, 19621, -423, 16314, -1982, -5455, -1529, -829, -81, 21247, -336, -1836, -1867, -3749, -185, -3868, 21031, -14, -2836, 70, 29163, 20311, 13058, -5071, -3890, -866, 20938, 20700, -8830, -755, -4670, -931, 9696, 6, -5837, -5210, -7332, 14933, -2270, -46, -1723, -3538, -5089, -2506, -3650, 17140, -2791, 21758, -4209, -3019, -3997, 18780, 16896, -4273, 119, -6265, -3300, 29016, -74, -6666, -798, -1165, -1603, -4503, 16445, -4634, -3000, -1308, 19688, -2176, -2873, 27459, -182, -2522, -3061, -1164, 5146, 14041, 25529, -3127, -1165, 20108, -2194, -232, -1215, -3481, };
const TfArray<1, int> tensor_dimension15 = { 1, { 144 } };
const TfArray<144, float> quant15_scale = { 144, { 0.00016672041965648532, 0.00012103222979931161, 7.088318670867011e-05, 0.00011803909728769213, 9.497306018602103e-05, 0.0002000836975639686, 0.00021582275803666562, 0.0001860308984760195, 6.8061606725677848e-05, 0.00018967759388033301, 0.00018744925910141319, 0.00018281419761478901, 0.00019656015501823276, 0.00017042862600646913, 0.00010342799942009151, 0.00012334338680375367, 0.00018442298460286111, 7.631257176399231e-05, 0.00017029978334903717, 0.00021516502602025867, 0.00012297966168262064, 0.00020053678599651903, 6.2618273659609258e-05, 0.00011027388973161578, 0.00018263842503074557, 0.00023474532645195723, 0.00018491674563847482, 0.00016965110262390226, 0.00020876240159850568, 0.00015982554759830236, 0.00021462432050611824, 0.00018192882998846471, 0.00018118960724677891, 0.00021019928681198508, 0.00025137004558928311, 0.00015782960690557957, 0.00018271707813255489, 0.00018038052076008171, 0.00020952596969436854, 0.00010245764860883355, 7.9851626651361585e-05, 7.761271990602836e-05, 7.9682424257043749e-05, 0.00017887826834339648, 9.9961536761838943e-05, 0.00017970167391467839, 0.00014458579244092107, 8.9937602751888335e-05, 0.00014448241563513875, 0.00015466210606973618, 0.00016633090854156762, 6.0093429055996239e-05, 0.00016635509382467717, 0.00011930927576031536, 9.8655400506686419e-05, 0.00030076241819187999, 0.00013232917990535498, 0.0002470805193297565, 5.8178549807053059e-05, 0.00011093883222201839, 0.00017953140195459127, 8.458711818093434e-05, 0.00016128817514982074, 0.00012006841279799119, 0.00012275487824808806, 0.00018469690985511988, 0.00010900995403062552, 7.5643532909452915e-05, 0.0002130222856067121, 0.00019396950665395707, 0.00011077261297032237, 0.00017763636424206197, 9.8328790045343339e-05, 0.0001801892212824896, 7.044724770821631e-05, 0.00014819562784396112, 0.00022044997604098171, 0.00015838007675483823, 6.159445911180228e-05, 9.0319015725981444e-05, 0.00011608179920585826, 0.00011173981329193339, 0.00018331431783735752, 0.0001639007095945999, 6.8158704380039126e-05, 7.089106657076627e-05, 0.0001431102427886799, 0.00019629822054412216, 0.00016714620869606733, 0.00016152572061400861, 0.00015243806410580873, 0.00018632855790201575, 0.00014792717411182821, 9.5348965260200202e-05, 0.00017675722483545542, 0.0001538150681881234, 0.00021236485918052495, 0.00016312599473167211, 0.00016248025349341333, 0.00025019532768055797, 9.9310425866860896e-05, 0.00019718045950867236, 0.00018649872799869627, 6.9622074079234153e-05, 0.00016883139323908836, 5.9103364037582651e-05, 0.00014702441694680601, 0.00017151270003523678, 0.00021013297373428941, 8.5044179286342114e-05, 0.0001168942908407189, 0.00020515015057753772, 0.00016400631284341216, 7.0342975959647447e-05, 0.00018231308786198497, 6.8653564085252583e-05, 0.00021564644703175873, 0.00016605568816885352, 0.00018368383462075144, 0.00020434411999303848, 0.00020532683993224055, 0.00023032794706523418, 0.00011084974539699033, 0.0001700018037809059, 0.00016204704297706485, 0.00019830846576951444, 6.0957721871091053e-05, 0.00016707912436686456, 0.00013438459427561611, 6.3974264776334167e-05, 0.00017734599532559514, 0.00020583128207363188, 0.0001814359420677647, 0.00019119909848086536, 0.00012194383452879265, 9.9853990832343698e-05, 6.5701497078407556e-05, 0.00017650244990363717, 0.00010907997784670442, 7.3619521572254598e-05, 0.00019505346426740289, 0.00022256055672187358, 0.0001569114247104153, 0.00018492470553610474, } };
const TfArray<144, int> quant15_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant15 = { (TfLiteFloatArray*)&quant15_scale, (TfLiteIntArray*)&quant15_zero, 0 };
const ALIGN(8) int32_t tensor_data16[192] = { 4452, 870, 3581, 2075, 1811, 1726, -225, 3353, -1861, 4867, 3808, 4236, 3414, 5922, 649, 3297, 251, 2067, 2779, 736, 4137, 2030, 2948, 3720, 1725, 2598, 5027, 1719, 3149, 1418, 776, 6946, 2010, -1820, 805, 964, 2093, 2201, -1310, 18434, 3679, 888, 4127, 5538, 3509, 707, -2211, 2787, 246, 228, -267, 2523, 1609, 480, 1068, 4689, -658, -914, 269, 2562, 5422, 1917, 410, 290, 2372, -33, 2000, 1785, 1822, 4143, 2918, 5329, 1339, 1606, 3755, 2981, 1177, 2735, 616, 489, -937, 847, -780, -2801, 1858, 1849, 6667, 3349, -163, 313, 3001, 604, 1807, 6456, 3690, 3836, 1261, 1584, 1309, 731, 1361, -114, 9697, -1404, 883, 1234, 4219, 1660, 5184, 1730, 2899, 3100, -1198, -605, 7236, 4118, 887, 2427, 6124, 1016, 551, 1385, 2364, 2240, 581, 1428, 6014, 1449, 1462, 1105, 954, 2519, 2563, 3258, 1395, -120, 513, -522, 2400, 855, 1738, 3086, -36, 126, 1528, 2741, -690, 1641, 1548, -745, -1748, -702, -602, 6486, 34, -62, 1363, -142, 6513, 2648, 102, 2711, 931, 862, 952, 749, 1171, 950, 231, 1322, -24, -9, 3545, 992, 4474, -277, 989, 575, 3197, -473, 2642, -1237, 705, 6365, 3605, -40, 2311, 4069, 2645, 1430, -269, 897, };
const TfArray<1, int> tensor_dimension16 = { 1, { 192 } };
const TfArray<192, float> quant16_scale = { 192, { 7.7914955909363925e-05, 0.00010549365833867341, 9.1148169303778559e-05, 9.0215944510418922e-05, 0.00010686217865440995, 0.00012169498950242996, 0.00015050385263748467, 9.9146192951593548e-05, 0.00011729727702913806, 8.8137894636020064e-05, 7.7222684922162443e-05, 8.0467732914257795e-05, 7.954688771860674e-05, 6.9527268351521343e-05, 0.00011825520778074861, 0.00010153311450267211, 9.976388537324965e-05, 9.744741691974923e-05, 0.00010185784776695073, 0.00015335540228988975, 9.9604127171915025e-05, 0.00013992634194437414, 8.6476837168447673e-05, 7.1520938945468515e-05, 0.00010084434325108305, 8.809637074591592e-05, 0.00010805136116687208, 0.0001047223704517819, 9.6117299108300358e-05, 0.0001126015413319692, 0.00010891855345107615, 7.7570832218043506e-05, 9.5993702416308224e-05, 8.8521941506769508e-05, 9.2956113803666085e-05, 0.00015234629972837865, 0.00011207851639483124, 9.3698319687973708e-05, 0.00013724954624194652, 4.7655772505095229e-05, 8.6719337559770793e-05, 9.3368027592077851e-05, 0.00010553659376455471, 7.0833586505614221e-05, 6.8567482230719179e-05, 0.00012323768169153482, 9.9565600976347923e-05, 8.285962394438684e-05, 0.00013660780678037554, 0.00010760704026324674, 0.00013343122554942966, 0.00013846108049619943, 9.8196149338036776e-05, 0.00011482573609100655, 8.9095257862936705e-05, 7.4626637797337025e-05, 0.00017759365437086672, 9.968708036467433e-05, 0.00014178633864503354, 0.00011010887828888372, 7.140506204450503e-05, 0.00010548978025326505, 8.7103784608189017e-05, 0.00010499673953745514, 9.4325267127715051e-05, 0.0001255221723113209, 0.00012324175622779876, 9.1360634542070329e-05, 0.00013810185191687196, 9.7201445896644145e-05, 9.6432202553842217e-05, 5.7740318879950792e-05, 0.00012332003097981215, 8.8147804490290582e-05, 0.00012205800885567442, 0.00012826333113480359, 8.5758103523403406e-05, 0.00012128093658247963, 0.0001196627999888733, 0.00014441338134929538, 9.5952906121965498e-05, 0.00013333043898455799, 0.00014319393085315824, 8.5061168647371233e-05, 8.4709608927369118e-05, 9.7941716376226395e-05, 9.0169982286170125e-05, 7.809998351149261e-05, 0.0001090593432309106, 0.00010465599916642532, 7.4474235589150339e-05, 0.00012422697909642011, 0.00010443180508445948, 8.4198785771150142e-05, 8.342186629306525e-05, 9.1606249043252319e-05, 0.00010331963130738586, 0.00011439593799877912, 8.7528169387951493e-05, 8.6521671619266272e-05, 0.00012217943731229752, 0.00010839222522918135, 6.3781299104448408e-05, 8.0484671343583614e-05, 0.00017871121235657483, 0.0001134336635004729, 6.4944186306092888e-05, 8.9888562797568738e-05, 7.7794393291696906e-05, 9.9323988251853734e-05, 0.00011618059943430126, 0.00010290242062183097, 0.00012061502638971433, 7.7678698289673775e-05, 7.1979848144110292e-05, 7.7327429607976228e-05, 0.00012332214100752026, 9.271776070818305e-05, 0.00010035050217993557, 0.00013022909115534276, 9.6175943326670676e-05, 6.4318723161704838e-05, 8.8679713371675462e-05, 8.7565291323699057e-05, 9.4732269644737244e-05, 9.758615487953648e-05, 0.00010188875603489578, 7.999187073437497e-05, 0.00015541266475338489, 0.00016311192302964628, 0.0001213865980389528, 8.6266300058923662e-05, 7.7316617534961551e-05, 9.0334229753352702e-05, 8.244961645686999e-05, 9.8757540399674326e-05, 0.00011577377154026181, 9.4464536232408136e-05, 6.6704211349133402e-05, 0.00010388211376266554, 0.00011861534585477784, 8.1267127825412899e-05, 0.000130457803606987, 0.00010601802205201238, 0.00010646362352417782, 7.786127389408648e-05, 9.5621646323706955e-05, 0.00012707905261777341, 0.00012241024523973465, 0.00019119329226668924, 8.3927647210657597e-05, 8.8740453065838665e-05, 0.00011372029257472605, 6.4747677242849022e-05, 9.9943099485244602e-05, 9.7235606517642736e-05, 9.7583651950117201e-05, 8.1871752627193928e-05, 8.1533551565371454e-05, 8.2145983469672501e-05, 0.00013575748016592115, 0.00010645678412402049, 9.6155847131740302e-05, 0.00011838404316222295, 0.00010285188909620047, 0.00012883258750662208, 0.00011773430742323399, 7.8833298175595701e-05, 7.8939126979093999e-05, 9.2640577349811792e-05, 0.00014038628432899714, 9.9422250059433281e-05, 9.0854489826597273e-05, 9.0114939666818827e-05, 7.5731331889983267e-05, 0.00012243675882928073, 9.821544517762959e-05, 9.1051864728797227e-05, 6.7800734541378915e-05, 0.00012933170364703983, 9.0724664914887398e-05, 0.00010427043889649212, 0.00012040082219755277, 6.1833379731979221e-05, 7.9810641182120889e-05, 0.00010825401841429994, 0.00010932570876320824, 0.00010038223263109103, 8.7425440142396837e-05, 8.6542182543780655e-05, 0.00010473101428942755, 0.00013863509229850024, } };
const TfArray<192, int> quant16_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant16 = { (TfLiteFloatArray*)&quant16_scale, (TfLiteIntArray*)&quant16_zero, 0 };
const ALIGN(8) int32_t tensor_data17[192] = { 10578, -3711, 87, -454, 9865, -9305, -475, 17869, -2809, -1132, -428, 12894, -1919, -23, -5339, 4401, -373, 12, 6051, -1886, 8208, -2922, -5521, 11246, -1087, 454, 6598, 9204, -11, -139, -5465, -6158, 820, -473, -1538, -3705, -810, -451, -4081, 1370, -1257, -5967, 1732, -6670, 3218, -2188, -3358, 301, -6072, -6474, -2933, 231, 6646, -851, -2821, -294, -2559, -2380, -2058, -764, -69, 63, -3016, -3836, 609, -4694, 79, 9055, 269, 486, -1318, -489, 1834, 6246, 13245, 341, 146, -203, -2706, -3401, 6640, -1282, -3509, -1131, -5868, 10690, 925, 7, -1663, -3341, -90, -5639, 331, 6165, 620, 10398, -49, -2844, 9957, -3101, -867, 6801, 369, -3431, -4625, 5027, 9340, -3490, 4877, -1358, -641, 6973, -2426, -3431, -502, 719, 711, 11869, 1578, -413, -1981, -2891, 9483, 10911, 9565, 15316, 14706, -1803, 11819, -3019, 9657, -2944, 8925, 258, 3627, -71, -938, -2076, -3829, 8363, -1769, 12429, -2478, 10207, -233, 14213, -4704, -90, -2396, -3871, -3496, -3043, -2203, -258, -2244, -3965, -666, -3471, -374, -1112, -3834, 265, -3301, -418, -5859, -2515, -253, -615, -3274, 10855, -2398, -5174, 7950, -2981, -979, -4753, 8437, -213, 10122, 758, -191, -3383, 59, -96, -430, -1573, -2994, 10740, 279, 10860, -263, -1621, };
const TfArray<1, int> tensor_dimension17 = { 1, { 192 } };
const TfArray<192, float> quant17_scale = { 192, { 0.00011416290362831205, 0.00019234600767958909, 0.00015256954065989703, 0.00019798016001004726, 0.00012447425979189575, 8.6668893345631659e-05, 0.00028852597461082041, 6.9593072112184018e-05, 0.00028443409246392548, 0.00022763294691685587, 0.00021248793927952647, 8.5440558905247599e-05, 0.00022626567806582898, 0.00022905811783857644, 0.00018630614795256406, 0.00020012418099213392, 0.00032833471777848899, 0.00023837204207666218, 0.00018119202286470681, 0.00030678886105306447, 0.00014874120824970305, 0.0001821837795432657, 0.00015039194840937853, 0.00011481151159387082, 0.00021564042253885418, 0.00011897554213646799, 0.00025250602629967034, 0.00013233875506557524, 0.00018986997019965202, 0.00020040934032294899, 0.00016387489449698478, 0.00014655043196398765, 0.00019821077876258641, 0.00027058707200922072, 0.00030923605663701892, 0.00016710290219634771, 0.0001646963064558804, 0.00020168011542409658, 0.00027441460406407714, 0.00067080126609653234, 0.00028982802177779377, 0.00014910756726749241, 0.00024158121959771961, 0.00021705088147427887, 0.00016861128096934408, 0.00018323537369724363, 0.00025967994588427246, 0.00026155798695981503, 0.00013677477545570582, 0.00011565061868168414, 0.00024146026407834142, 0.00022451400582212955, 0.00012741604587063193, 0.0002825937990564853, 0.00015322482795454562, 0.00012666003021877259, 0.00030608993256464601, 0.00028991443105041981, 0.00023006483388599008, 0.00020754158322233707, 0.00015729064762126654, 0.00020061418763361871, 0.00028386656777001917, 0.00020741604384966195, 0.00022169282601680607, 0.00018666186952032149, 0.00023562980641145259, 0.00011165978503413498, 0.00025988693232648075, 0.00016288431652355939, 0.00016393196710851043, 0.00015278013597708195, 0.00026409453130327165, 0.00016235763905569911, 9.7976218967232853e-05, 0.00019484666700009257, 0.00019929854897782207, 0.00024904447491280735, 0.00028765405295416713, 0.00020179238345008343, 0.00014085878501646221, 0.00021132799156475812, 0.00019123347010463476, 0.00019916822202503681, 0.00016888896061573178, 9.6342409960925579e-05, 0.00037158714258112013, 0.00020015034533571452, 0.00026177082327194512, 0.00023359179613180459, 0.00025952589930966496, 0.00013250496704131365, 0.00019739632261916995, 0.00021135987481102347, 0.0002256383013445884, 0.00012011851504212245, 0.00016812256944831461, 0.00018146065121982247, 0.00013919000048190355, 0.00026411682483740151, 0.0002839371154550463, 0.00013352352834772319, 0.00023565081937704235, 0.00018217031902167946, 0.00017008793656714261, 0.00016655173385515809, 0.00012901710579171777, 0.00020661049347836524, 0.00017615394608583301, 0.00027563003823161125, 0.00022803180036135018, 0.00015940472076181322, 0.00021072437812108546, 0.0002657166332937777, 0.00021399564866442233, 0.00018534428090788424, 0.00016151055751834065, 0.00010528510756557807, 0.00022682451526634395, 0.00023233724641613662, 0.00017279540770687163, 0.00025116465985774994, 0.0001236563257407397, 0.00010523691889829934, 0.00011776292376453057, 8.3513077697716653e-05, 0.00010223415301879868, 0.0002529449702706188, 0.0001249268971150741, 0.00017677294090390205, 0.00012476732081267983, 0.00013588728324975818, 0.00012488315405789763, 0.00019823799084406346, 0.00024207771639339626, 0.00031471988768316805, 0.00022622308460995555, 0.00026676291599869728, 0.00017395224131178111, 0.00013680265692528337, 0.00024419563123956323, 0.00010080488573294133, 0.00027076975675299764, 9.5858100394252688e-05, 0.00029583380091935396, 7.8388911788351834e-05, 0.00018134915444534272, 0.00016284693265333772, 0.00017639754514675587, 0.0001894614688353613, 0.0002590650983620435, 0.00019973919552285224, 0.00030294156749732792, 0.00021218421170488, 0.00022369457292370498, 0.00016012422565836459, 0.00015794414503034204, 0.00030228999094106257, 0.00031644670525565743, 0.00027206572121940553, 0.00020726014918182045, 0.00020686320203822106, 0.0001656538515817374, 0.00032975387875922024, 0.000226973308599554, 0.0002368702698731795, 0.00016550502914469689, 0.00027078919811174273, 0.00027545471675693989, 0.00012766625150106847, 0.00023470606538467109, 0.00016863568453118205, 0.00016231945483013988, 0.00020795769523829222, 0.00023779622279107571, 0.00017038156511262059, 0.00012818090908695012, 0.00026110431645065546, 0.00011219608131796122, 0.00024182426568586379, 0.00018635114247445017, 0.00023286580108106136, 0.00016930472338572145, 0.00027018296532332897, 0.00024246760585810989, 0.0001865708181867376, 0.00013464056246448308, 0.00011823896056739613, 0.00026510469615459442, 0.00010365068010287359, 0.0001985452399821952, 0.00024358867085538805, } };
const TfArray<192, int> quant17_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant17 = { (TfLiteFloatArray*)&quant17_scale, (TfLiteIntArray*)&quant17_zero, 0 };
const ALIGN(8) int32_t tensor_data18[192] = { 2449, 3585, 2823, -302, 1581, 1164, 371, 752, 374, 5355, 405, 3438, -500, 3497, 4010, 3357, 1445, 2661, 91, -189, -194, -505, 1467, 937, 2274, 1039, 949, -677, -479, 1177, 3546, -69, -197, 2052, 1322, 2016, 2717, 1085, 640, 2197, 85, 2466, -765, 1435, -377, 249, 1139, 1082, 2888, 554, 5967, -435, 255, 1705, 886, 2794, 401, -774, 2214, 2900, 898, -560, 1473, 2580, 761, -315, 4655, 181, 463, -633, 1479, 1469, -767, 3511, 2600, 1982, 1204, 2978, 3812, 2455, 1199, -729, 462, 184, 231, 115, -982, 1015, 2759, 2215, 1428, 1578, 2981, 1310, -713, 1604, -160, 1867, -324, 2150, 836, 4611, 1014, 1561, -1530, 2712, 2822, 367, -1115, -660, 818, 1251, -394, 2362, 2539, 3656, -338, 1030, 1274, 2327, -591, -644, 408, 3267, 184, 3813, 17, 2378, 920, -633, -980, -444, 2407, 1095, 2414, 1044, -168, 2132, 5109, 3021, -1163, 333, 3511, 1236, 528, 3134, 1589, 2104, 695, -317, 1418, 662, -497, 3102, -967, -553, 897, -1091, 1695, 1797, -3834, 689, -981, 891, 2090, 1856, -1135, 4398, 4314, 1025, -201, 1682, 873, 2032, -1337, 1565, 3914, 1368, 1129, 1363, 930, -481, 761, 1799, 1636, -1158, 425, 553, 1005, 1005, 3354, 1186, };
const TfArray<1, int> tensor_dimension18 = { 1, { 192 } };
const TfArray<192, float> quant18_scale = { 192, { 8.567311306251213e-05, 8.177568088285625e-05, 7.464949885616079e-05, 0.00011546229507075623, 9.738673543324694e-05, 0.00010482322977622971, 8.478514791931957e-05, 0.00016062958457041532, 9.9935910839121789e-05, 8.9660490630194545e-05, 0.00013477506581693888, 0.00010869766992982477, 8.4138227975927293e-05, 0.00010637914238031954, 9.3868868134450167e-05, 0.00010962558735627681, 8.9781060523819178e-05, 0.00011757073662010953, 0.00013316150580067188, 0.00017449203005526215, 0.00012327627337072045, 0.00014218493015505373, 0.00010560364898992702, 8.8552951638121158e-05, 9.9140190286561847e-05, 0.00013592763571068645, 0.00012678309576585889, 9.8289201559964567e-05, 0.00010881050548050553, 9.856410906650126e-05, 9.6510899311397225e-05, 0.00010720124555518851, 0.0001448277325835079, 0.00010052382276626304, 0.00012461682490538806, 0.00011202830501133576, 9.6583593403920531e-05, 0.00012437338591553271, 0.00012203487858641893, 0.00011035542411264032, 9.0578105300664902e-05, 0.00010033954458776861, 0.00012449990026652813, 0.00011274694406893104, 0.00012134239659644663, 0.00012336525833234191, 0.00011494281352497637, 0.00014063462731428444, 8.5959058196749538e-05, 0.00013782813039142638, 8.5009887698106468e-05, 0.00014141979045234621, 0.00015768292360007763, 0.00010107975685968995, 0.00013357568241190165, 9.0304718469269574e-05, 0.00015768806042615324, 0.00012749423331115395, 9.1548135969787836e-05, 9.0684101451188326e-05, 0.00010878876491915435, 7.8312696132343262e-05, 9.5150870038196445e-05, 9.3623573775403202e-05, 0.00014929755707271397, 0.00011693490523612127, 9.5391405920963734e-05, 0.00010715336975408718, 0.00012429885100573301, 0.00015273111057467759, 0.00013045012019574642, 8.3744991570711136e-05, 0.00010580019443295896, 9.5199087809305638e-05, 9.2814683739561588e-05, 9.1546018666122109e-05, 9.1758556663990021e-05, 0.00010967721755150706, 0.00012215271999593824, 0.00012491310189943761, 0.00010571743769105524, 8.6981868662405759e-05, 9.7503514552954584e-05, 0.00013128039427101612, 0.00016098623746074736, 9.4624971097800881e-05, 9.3253867817111313e-05, 0.00011460957466624677, 9.8184544185642153e-05, 0.00012842549767810851, 9.7072348580695689e-05, 0.00011541596904862672, 0.00010079093772219494, 8.8953456724993885e-05, 0.0001272392546525225, 9.1345704277046025e-05, 0.00016355792467948049, 9.5217008492909372e-05, 9.4535986136179417e-05, 0.00010206738807028159, 0.00010144215048057958, 9.6576695796102285e-05, 0.00012417268590070307, 0.00013105898688081652, 0.0001053505766321905, 9.4349998107645661e-05, 0.00011632921086857095, 0.00010635849321261048, 8.4445484390016645e-05, 0.0001406441442668438, 0.00012792051711585373, 9.5598661573603749e-05, 9.4323368102777749e-05, 0.00010647568706190214, 0.00010434309660922736, 9.3319191364571452e-05, 0.00014355119492392987, 0.00011921144323423505, 0.00013303123705554754, 9.6626412414480001e-05, 0.0001193254574900493, 0.00012083366164006293, 0.00016268587205559015, 9.3851558631286025e-05, 0.00010949096758849919, 8.7203559814952314e-05, 8.7642038124613464e-05, 0.0001208049216074869, 0.00011416200868552551, 0.00016204906569328159, 0.00011575970711419359, 0.00013136511552147567, 8.6171668954193592e-05, 0.00012324551062192768, 8.7246968178078532e-05, 9.4403083494398743e-05, 9.7698473837226629e-05, 0.00010440423648105934, 6.215304892975837e-05, 8.3790873759426177e-05, 0.00012031871301587671, 8.6902226030360907e-05, 7.4990712164435536e-05, 0.00011344684025971219, 0.00010110225412063301, 9.5103117928374559e-05, 0.00010187002044403926, 0.00012073322432115674, 9.3517490313388407e-05, 8.8941633293870836e-05, 0.00013642785779666156, 0.00010842156189028174, 0.00017600851424504071, 0.00010776500130305067, 0.00010724702588049695, 0.00013811311509925872, 0.000105336781416554, 0.00010822279000421986, 9.4016781076788902e-05, 0.00010785405174829066, 0.00010513157030800357, 0.0001086565971490927, 0.00018061751325149089, 8.830878505250439e-05, 9.484889596933499e-05, 0.00010057263716589659, 0.00013303926971275359, 8.7329790403600782e-05, 9.6399038739036769e-05, 9.7916534286923707e-05, 9.9296164989937097e-05, 0.00010164692503167316, 8.5688734543509781e-05, 9.7955802630167454e-05, 9.379194671055302e-05, 0.00011917131632799283, 7.5523996201809496e-05, 0.00014110725896898657, 0.00011581243597902358, 9.2217305791564286e-05, 0.00013480806956067681, 8.4277184214442968e-05, 0.00012276480265427381, 0.00010702128201955929, 0.00010588218719931319, 0.00012133026029914618, 0.00014254236884880811, 0.00015520125452894717, 0.00015848893963266164, 0.00011586755135795102, 8.1257887359242886e-05, 0.00012444415187928826, } };
const TfArray<192, int> quant18_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant18 = { (TfLiteFloatArray*)&quant18_scale, (TfLiteIntArray*)&quant18_zero, 0 };
const ALIGN(8) int32_t tensor_data19[192] = { 2926, 2095, -3615, -654, 12766, -1131, -2581, -1429, -1338, 1358, -807, 1014, -2689, 9747, 626, -3772, -386, 10732, -2439, -1081, -3845, -3699, 14065, -400, 11872, -5249, -2042, -1539, -2324, -1341, 14985, 4436, -2707, -1519, 948, -1694, 13125, -1214, -2958, -536, -709, 1597, -50, 5410, -2744, -3405, -2973, -356, 1334, -2821, 5026, 11154, -1665, 9385, 66, 108, -5582, -666, -85, 11422, -4227, -2791, 10598, -23, -4304, -1654, 38, -1311, -2722, -1744, -1996, -2297, -2530, -2207, 1733, -5502, -4968, -3762, -572, 13856, -292, -1705, -1774, -371, 11842, -613, -3403, -7212, -448, -1653, -332, 3773, -8185, 9480, -907, 10844, -1787, -151, 12891, -1022, -3930, 17289, 3999, -4202, -4511, -1459, -259, -367, -4660, -1873, -1534, 6351, 9061, 8871, 8054, -558, -8697, -4869, -1940, 2027, -8222, -478, -3313, -220, 60, -537, -999, 14180, -8, -4978, -3827, -3704, -2873, -3034, 17193, -237, -1209, 11855, -1278, 2493, -1560, -307, -879, -86, 9885, -2601, -2227, -218, 9, -6785, -4982, -226, -2040, -3846, -2185, -2191, -5005, -6026, 201, 8213, -135, -2132, -5177, -1925, -578, -266, -4531, 12012, 8271, -277, -949, -2568, -65, -392, -1723, 536, -61, -3052, -5232, 9834, -798, -960, -1885, 11813, -187, -3432, -3895, -2774, -6146, -2717, 7235, -3068, };
const TfArray<1, int> tensor_dimension19 = { 1, { 192 } };
const TfArray<192, float> quant19_scale = { 192, { 0.00017908590962179005, 0.0001957615022547543, 0.00011675458517856896, 0.00017156612011604011, 9.7848969744518399e-05, 0.00019943174265790731, 0.00025162193924188614, 0.00019065199012402445, 0.00029360505868680775, 0.00019541342044249177, 0.00026198654086329043, 0.00033196181175298989, 0.00024462235160171986, 0.00011931733752135187, 0.00017266877694055438, 0.00019572547171264887, 0.00015490029181819409, 0.00011293635179754347, 0.00026814854936674237, 0.00027843739371746778, 0.00023174274247139692, 0.00022569333668798208, 9.6556817879900336e-05, 0.00014741295308340341, 8.994646486826241e-05, 0.00013949495041742921, 0.00019091321155428886, 0.0002356913173571229, 0.00019187707221135497, 0.00015124972560442984, 8.1180893175769597e-05, 0.00022177283244673163, 0.00023612819495610893, 0.00015910870570223778, 0.00019782246090471745, 0.00018179940525442362, 0.00010467616812093183, 0.00023564274306409061, 0.00022064078075345606, 0.00011655630078166723, 0.00027359492378309369, 0.00021004253358114511, 0.00021320852101780474, 0.00021411983470898122, 0.00019090950081590563, 0.00029725200147368014, 0.00021664140513166785, 0.00015540808090008795, 0.00021496752742677927, 0.00021317973732948303, 0.00037252696347422898, 0.0001034411252476275, 0.00018840737175196409, 0.00013415091962087899, 0.00019176400383003056, 0.00014239815936889499, 0.00017135954112745821, 0.00022155656188260764, 0.00018895049288403243, 0.0001107447751564905, 0.0001165557187050581, 0.00016962563677225262, 0.00011704201460815966, 0.00024517418933100998, 0.00015849636110942811, 0.00029815733432769775, 0.0003624005476012826, 0.00018228139379061759, 0.00017452587781008333, 0.00024842191487550735, 0.00024243559164460748, 0.00021637686586473137, 0.00028936719172634184, 0.00029827069374732673, 0.00019846096984110773, 0.00014445664419326931, 0.00012108677037758753, 0.0002191846288042143, 0.00024246472457889467, 0.00010522687080083415, 0.0002659610181581229, 0.00024318306532222778, 0.00020968657918274403, 0.0002522905997466296, 8.8517284893896431e-05, 0.00026742971385829151, 0.00017272307013627142, 9.2509602836798877e-05, 0.0001859454350778833, 0.00019612706091720611, 0.00023264830815605819, 0.00016029119433369488, 0.00015379702381324023, 0.0001074754327419214, 0.00019011170661542565, 0.00011222086322959512, 0.00015183608047664165, 0.00022328115301206708, 7.6846037700306624e-05, 0.00018516146519687027, 0.00022773006639908999, 8.644162880955264e-05, 0.00017931603360921144, 0.00020731787662953138, 0.00014373500016517937, 0.00021809092140756547, 0.00022897646704223007, 0.00027490122010931373, 0.00020300896721892059, 0.000275965197943151, 0.00025085062952712178, 0.00013668138126377016, 0.00013735711399931461, 0.00013248094182927161, 0.00014346871466841549, 0.00032664078753441572, 0.00014963991998229176, 0.00015059906581882387, 0.00024470852804370224, 0.00019426080689299852, 0.00012072914250893518, 0.00032119470415636897, 0.0002357308694627136, 0.00022626586724072695, 0.00020013056928291917, 0.00027727923588827252, 0.00021338631631806493, 8.8419641542714089e-05, 0.0002360104990657419, 0.00020500818209256977, 0.00019320436695124954, 0.00023636437254026532, 0.00017788393597584218, 0.00018358162196818739, 7.4677533120848238e-05, 0.00021823737188242376, 0.00029891659505665302, 0.00011038804223062471, 0.00023482319375034422, 0.000154219611431472, 0.0001736518315738067, 0.00035819833283312619, 0.00028723443392664194, 0.00024316350754816085, 0.0001195708682644181, 0.00022897856251802295, 0.00014965511218179017, 0.00018432716024108231, 0.00020590427448041737, 0.00014377736079040915, 0.0001105269548133947, 0.00025432469556108117, 0.00023125488951336592, 0.00017400585056748241, 0.00017618160927668214, 0.00021623361681122333, 0.00017781562928576022, 0.00016028844402171671, 0.00017698541341815144, 0.00012899858120363206, 0.00037295857327990234, 0.00024081282026600093, 0.0002681344049051404, 0.00030954691465012729, 0.00025034844293259084, 0.00022802075545769185, 0.00016987933486234397, 0.00010319893772248179, 0.00017227494390681386, 0.00021599710453301668, 0.00017649577057454735, 0.00020201937877573073, 0.00016865677025634795, 0.00030036061070859432, 0.00018993268895428628, 0.00021074256801512092, 0.0002165707410313189, 0.00019733424414880574, 0.00016050877457018942, 0.00012327809236012399, 0.00022485741646960378, 0.00025248492602258921, 0.00021051980729680508, 9.5494426204822958e-05, 0.00029539986280724406, 0.00025254764477722347, 0.00018609629478305578, 0.00015592873387504369, 9.0747620561160147e-05, 0.0002601086744107306, 0.00015275167243089527, 0.00020312913693487644, } };
const TfArray<192, int> quant19_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant19 = { (TfLiteFloatArray*)&quant19_scale, (TfLiteIntArray*)&quant19_zero, 0 };
const ALIGN(8) int32_t tensor_data20[192] = { 1287, -438, -4602, 2106, 1573, -1827, -1024, 6135, 3648, 1070, -353, 1249, -302, 1662, 940, 605, -1270, 3275, 719, -1380, -1888, 3263, -998, 211, -4247, 709, -3507, 3812, -1110, -2692, -433, 7081, 3578, 4206, -2476, -2707, 1981, 2136, -3135, 4565, -1024, -433, 1559, -1686, 1439, 3122, -1068, -1012, 786, -1923, 6048, 1276, 2203, 5746, -926, 372, 7692, -392, 431, -1285, -1694, 110, -3122, -760, -1696, 407, -702, 1317, -850, 1754, -2893, -4531, -3902, 3940, 1777, 5025, -1479, 3576, -429, -14, -3376, 2068, -1275, 579, 16, 7612, 3909, 63, 3052, -1631, 3322, 1848, 1080, 2608, 2578, -1713, -2599, -4252, -733, 1890, -50, 3514, 6033, -136, -3219, -1385, 5412, -1296, -1389, 751, 1600, -1682, -2962, 74, 2819, -390, 213, 3183, 2565, -2839, 6699, 3169, 277, 2726, 3123, 403, 3347, 2580, 2332, -5412, -1403, -4257, 1167, 333, 2702, -2860, 6660, 3800, -950, -1893, -3042, 357, 6048, 2704, -237, -1508, 4737, 705, 1454, 3951, -2323, 3333, 2251, 6067, 160, -2428, 3797, 5535, -1113, 1686, 5884, -957, -1471, 556, -1969, 1934, 4657, 734, -703, -1493, 4013, 5700, 4673, 4753, 3944, -2035, 4454, -3102, -1965, 7883, -541, 1880, 6287, 3069, 6913, 4167, -1227, 1986, 4030, -785, -1127, 2018, };
const TfArray<1, int> tensor_dimension20 = { 1, { 192 } };
const TfArray<192, float> quant20_scale = { 192, { 0.00010257966641802341, 0.00010952837328659371, 8.7057742348406464e-05, 0.0001303605386056006, 9.9073011369910091e-05, 9.3093403847888112e-05, 0.00010358192230341956, 8.9027475041802973e-05, 8.932336641009897e-05, 0.00010027624375652522, 9.2230904556345195e-05, 8.7704858742654324e-05, 0.00011258204176556319, 0.00010573559120530263, 0.00010312171070836484, 8.5593848780263215e-05, 0.00011364118836354464, 0.0001024722951115109, 0.00010088604904012755, 7.3789546149782836e-05, 0.00010727639892138541, 0.00011270646791672334, 0.00011111424828413874, 7.8312827099580318e-05, 7.6528311183210462e-05, 9.6824187494348735e-05, 0.00012660682841669768, 9.4317234470508993e-05, 9.0483677922748029e-05, 0.00010670981282601133, 0.00012072523531969637, 8.4960644016973674e-05, 7.652783824596554e-05, 0.00010774203110486269, 8.7765489297453314e-05, 0.00010603581904433668, 9.8768316092900932e-05, 0.00011298329627607018, 8.2904829469043761e-05, 7.6599491876550019e-05, 0.00013803059118799865, 0.00011995810928056017, 8.6908490629866719e-05, 0.00010361048771301284, 0.00011250829265918583, 9.6661264251451939e-05, 0.0001004383884719573, 8.6167347035370767e-05, 0.00012360632536001503, 0.00010300130088580772, 8.7878179328981787e-05, 0.00011135590466437861, 0.00012282091483939439, 8.0328849435318261e-05, 0.00010958717757603154, 8.777906623436138e-05, 6.5986976551357657e-05, 0.00012225480168126523, 0.00010934237070614472, 0.00010651034972397611, 7.0954498369246721e-05, 0.00011393966997275129, 9.0324923803564161e-05, 8.9709770691115409e-05, 0.00011043125414289534, 0.00010212522465735674, 0.00011637235729722306, 9.2904178018216044e-05, 8.2565144111867994e-05, 9.5292998594231904e-05, 9.3245434982236475e-05, 9.3426395324058831e-05, 7.8346609370782971e-05, 0.00010497739276615903, 0.00011205783084733412, 8.9209694124292582e-05, 7.0992638939060271e-05, 0.00010123229003511369, 0.00014065027062315494, 0.00012625090312212706, 0.00011066043225582689, 0.00012233435700181872, 9.7391821327619255e-05, 0.00012315352796576917, 0.00013836834114044905, 6.2706516473554075e-05, 0.0001094363396987319, 9.5720781246200204e-05, 0.00010243646829621866, 8.2110564108006656e-05, 9.050180233316496e-05, 8.9049950474873185e-05, 8.6825290054548532e-05, 0.00011587071639951319, 0.00016410868556704372, 0.00011781971988966689, 8.6948297393973917e-05, 8.3080682088620961e-05, 0.00010807829676195979, 0.00013907032553106546, 0.0001091489102691412, 9.8332689958624542e-05, 9.4774521130602807e-05, 0.00013396210852079093, 0.000100581361039076, 0.00010451677371747792, 9.0912355517502874e-05, 9.9970638984814286e-05, 0.00011070684558944777, 0.00010455655137775466, 7.4259689426980913e-05, 9.9580116511788219e-05, 8.9724089775700122e-05, 9.8099997558165342e-05, 0.00010968738934025168, 7.2797047323547304e-05, 8.3085607911925763e-05, 9.3173977802507579e-05, 0.00010999615915352479, 7.0334521296899766e-05, 7.91006168583408e-05, 0.00010550866136327386, 9.6700168796814978e-05, 0.00012255548790562898, 9.7145457402803004e-05, 0.0001083662937162444, 7.0187124947551638e-05, 0.00011638436990324408, 0.00011346535757184029, 9.0182285930495709e-05, 7.2526236181147397e-05, 8.9010936790145934e-05, 0.00010084543464472517, 8.0892146797850728e-05, 9.2696864157915115e-05, 8.9741486590355635e-05, 7.9217155871447176e-05, 9.3787835794501007e-05, 0.00011716449807863683, 9.1166701167821884e-05, 9.9537581263575703e-05, 8.9125976955983788e-05, 8.2309546996839345e-05, 7.0348505687434226e-05, 9.4171424279920757e-05, 9.9672630312852561e-05, 0.00010238280083285645, 0.00011523202556418255, 9.3954702606424689e-05, 9.1435133072081953e-05, 0.0001054458916769363, 0.00011391478619771078, 0.00014432606985792518, 8.313000580528751e-05, 0.00011217605788260698, 8.9079512690659612e-05, 0.00012963757035322487, 7.7802833402529359e-05, 9.136526205111295e-05, 9.5646471891086549e-05, 9.1796704509761184e-05, 8.3295213698875159e-05, 8.1798229075502604e-05, 7.7706201409455389e-05, 0.00012755404168274254, 8.6623680545017123e-05, 9.8060372692998499e-05, 0.00014937465311959386, 9.1351685114204884e-05, 8.289223478641361e-05, 7.6712240115739405e-05, 9.9233380751684308e-05, 7.8932367614470422e-05, 9.7734569862950593e-05, 0.0001105457340599969, 0.0001232622453244403, 8.6936379375401884e-05, 6.5431158873252571e-05, 0.00010864168871194124, 7.068867125781253e-05, 9.4106391770765185e-05, 9.4153874670155346e-05, 8.8188317022286355e-05, 9.1730558779090643e-05, 6.6454136685933918e-05, 0.00010199831740465015, 8.1737642176449299e-05, 9.9811215477529913e-05, 0.00011449430894572288, 8.393688767682761e-05, 9.3031354481354356e-05, 8.7751635874155909e-05, } };
const TfArray<192, int> quant20_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant20 = { (TfLiteFloatArray*)&quant20_scale, (TfLiteIntArray*)&quant20_zero, 0 };
const ALIGN(8) int32_t tensor_data21[48] = { 12985, 5760, 4779, -159, 755, -1064, -561, 30654, -260, 1367, 6771, 55982, 913, 1729, -76, 12520, -1169, 12867, 8, 7486, 12299, -6, 4221, -9179, 12782, 588, 824, 13163, 140, -1431, -9537, 11082, 5600, 2268, -39, 3064, -8900, 8954, -1110, 18447, -33, -933, 2740, 448, 395, -871, 888, -482, };
const TfArray<1, int> tensor_dimension21 = { 1, { 48 } };
const TfArray<48, float> quant21_scale = { 48, { 8.1396101450081915e-05, 9.8627941042650491e-05, 0.00018173028365708888, 0.00015191211423370987, 0.00059810403035953641, 0.00014206863124854863, 0.00015298683138098568, 0.0001096930936910212, 0.00011929452739423141, 7.7761054853908718e-05, 7.1046713856048882e-05, 5.5144129873951897e-05, 9.4442642875947058e-05, 7.4985677201766521e-05, 0.00020880787633359432, 0.00014078500680625439, 0.00013456573651637882, 0.00035566440783441067, 0.00016768404748290777, 0.00016765011241659522, 0.00013339763972908258, 0.00036780862137675285, 0.00015237278421409428, 0.00025146134430542588, 0.00010636803926900029, 0.00011451727914391086, 6.3296443840954453e-05, 9.5954230346251279e-05, 0.0001536128984298557, 0.00090971571626141667, 0.00023741699988022447, 8.4448263805825263e-05, 0.00011313898721709847, 0.00015566885122098029, 0.00017475831555202603, 6.770063191652298e-05, 0.00010490733257029206, 4.8266883823089302e-05, 0.0001282598968828097, 7.1395559643860906e-05, 0.00016662110283505172, 0.00014444600674323738, 8.4821782365906984e-05, 9.9039396445732564e-05, 8.3847866335418075e-05, 0.00031843187753111124, 7.2228249337058514e-05, 0.00017831746663432568, } };
const TfArray<48, int> quant21_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant21 = { (TfLiteFloatArray*)&quant21_scale, (TfLiteIntArray*)&quant21_zero, 0 };
const ALIGN(8) int32_t tensor_data22[192] = { 27576, -13, -133, 24480, -680, -243, -1437, 27400, 24711, 65, 674, 428, 589, 24418, 19838, -18, 463, 27824, 22684, 499, -379, 20975, -229, 370, 138, 24, -747, 28106, 23, 95, -9, 33495, 21146, 1528, -11, 21, -443, 26101, 693, -4170, 49, 15, -1434, -285, 22200, 30225, 155, -361, -198, 23, 19468, -161, 27260, 25021, 770, -48, 469, 551, -540, -362, 562, -81, 226, -116, -132, -311, -91, 18244, -5056, 20479, 343, -553, -103, 28023, 24203, 25426, 931, 27647, 615, -233, -90, 248, 57, 18519, 521, 25638, 22524, -719, 23178, -178, 22632, -573, -277, 24081, 28010, 253, 259, 926, 433, -87, 335, 16803, -2833, 0, 81, -427, 21767, -117, 225, 18948, 20926, -220, 778, 283, 25266, -454, 204, 623, 24952, 1846, 26229, 24968, 23017, 30427, -1106, -193, 20585, 28054, 36766, -227, -86, -416, 905, 71, -589, -184, 27745, 25737, 61, 307, -128, -240, 29383, 22780, 394, 35, 25337, -397, 361, 22513, 1207, 24195, 32889, 25378, -376, 7, 31426, 26876, -3455, -111, 33456, 157, 132, 31393, 363, 22813, 3569, -538, 606, 379, 24102, 24748, 25666, 22763, 22166, 284, 26088, 102, -161, 25479, -266, 101, 28925, -1377, 31966, 26768, 350, -4625, 26642, -390, 76, 23007, };
const TfArray<1, int> tensor_dimension22 = { 1, { 192 } };
const TfArray<192, float> quant22_scale = { 192, { 5.7466677390038967e-05, 7.4420306191314012e-05, 0.00011134766828035936, 6.9032212195452303e-05, 7.0940215664450079e-05, 8.5762781964149326e-05, 0.00013046928506810218, 6.1564765928778797e-05, 6.2353828980121762e-05, 6.4810381445568055e-05, 7.604547863593325e-05, 8.078426617430523e-05, 7.8173288784455508e-05, 5.9733210946433246e-05, 7.5771000410895795e-05, 6.6362321376800537e-05, 8.0462537880521268e-05, 5.9327045164536685e-05, 6.5242609707638621e-05, 8.8347202108707279e-05, 9.6661453426349908e-05, 7.2736678703222424e-05, 8.4520026575773954e-05, 7.7316341048572212e-05, 0.00010004259092966095, 7.4559422500897199e-05, 0.00011375179019523785, 5.5543700000271201e-05, 7.3693794547580183e-05, 9.4435796199832112e-05, 7.383856427622959e-05, 5.8406149037182331e-05, 6.3975312514230609e-05, 8.4764738858211786e-05, 8.6907966760918498e-05, 0.00010628058953443542, 7.2191462095361203e-05, 5.3932737500872463e-05, 9.1649926616810262e-05, 7.61425617383793e-05, 9.797553502721712e-05, 7.5780277256853878e-05, 7.1609494625590742e-05, 9.058979048859328e-05, 5.9598289226414636e-05, 5.0825539801735431e-05, 7.7222917752806097e-05, 8.76526755746454e-05, 7.2216003900393844e-05, 8.608565985923633e-05, 7.7687000157311559e-05, 7.2927854489535093e-05, 5.478915772982873e-05, 7.3507995693944395e-05, 6.5659980464261025e-05, 8.0496727605350316e-05, 8.0655343481339514e-05, 7.7941876952536404e-05, 6.1381084378808737e-05, 7.8839562775101513e-05, 9.3077549536246806e-05, 8.0381818406749517e-05, 9.9041142675559968e-05, 8.551677456125617e-05, 9.172514546662569e-05, 6.759998359484598e-05, 7.7517412137240171e-05, 6.8009845563210547e-05, 9.6698597189970315e-05, 7.2978546086233109e-05, 9.9937380582559854e-05, 0.00012363545829430223, 9.9637349194381386e-05, 5.8603523939382285e-05, 5.5603264627279714e-05, 6.4701125666033477e-05, 8.1310136010870337e-05, 5.5062366300262511e-05, 8.1806021626107395e-05, 6.8085937527939677e-05, 8.650787640362978e-05, 6.7256209149491042e-05, 7.2279544838238508e-05, 6.889056385261938e-05, 6.7306216806173325e-05, 6.5408072259742767e-05, 6.3380539359059185e-05, 8.3685939898714423e-05, 5.9332913224352524e-05, 8.8885521108750254e-05, 6.2676081142853945e-05, 5.7920948165701702e-05, 6.9858724600635469e-05, 7.165632996475324e-05, 5.1965726015623659e-05, 7.9255012678913772e-05, 9.1018991952296346e-05, 0.00010089067654917017, 8.288590470328927e-05, 7.3079943831544369e-05, 7.5699426815845072e-05, 7.6130570960231125e-05, 0.00014200301666278392, 6.7881162976846099e-05, 0.00010512592416489497, 8.361330401385203e-05, 7.2808186814654619e-05, 7.0490474172402173e-05, 7.7898381277918816e-05, 6.7113265686202794e-05, 7.6409742177929729e-05, 8.8791144662536681e-05, 9.1889931354671717e-05, 7.8284756455104798e-05, 5.2158247854094952e-05, 7.2914343036245555e-05, 0.00011657923460006714, 7.1391747042071074e-05, 6.200130155775696e-05, 8.8886685261968523e-05, 6.3446816056966782e-05, 6.1855105741415173e-05, 5.6535009207436815e-05, 5.1772683946182951e-05, 0.00010001218470279127, 7.2952119808178395e-05, 5.8976282161893323e-05, 5.8388704928802326e-05, 4.3375155655667186e-05, 0.00010062484216177836, 9.2995833256281912e-05, 0.00011319939221721143, 6.3905739807523787e-05, 7.4597104685381055e-05, 0.00011230199015699327, 8.8031520135700703e-05, 6.487150676548481e-05, 5.1849619921995327e-05, 8.4527018771041185e-05, 9.0842644567601383e-05, 8.6572137661278248e-05, 7.6785079727414995e-05, 5.6780598242767155e-05, 7.3119554144795984e-05, 8.3218335930723697e-05, 8.7647262262180448e-05, 6.1021299188723788e-05, 6.4268591813743114e-05, 9.2626229161396623e-05, 6.275503255892545e-05, 8.1801088526844978e-05, 6.968866364331916e-05, 4.9613223382038996e-05, 7.3834089562296867e-05, 7.3687479016371071e-05, 9.6335221314802766e-05, 5.4579988500336185e-05, 5.085822704131715e-05, 0.00010012646816903725, 6.3784114900045097e-05, 5.5091277317842469e-05, 9.2161790234968066e-05, 9.3081354862079024e-05, 4.7966546844691038e-05, 8.4975035861134529e-05, 6.5530846768524498e-05, 8.3776154497172683e-05, 7.2484792326577008e-05, 8.2548329373821616e-05, 9.1707093815784901e-05, 6.3839295762591064e-05, 5.9231479099253193e-05, 6.4806314185261726e-05, 7.1008689701557159e-05, 7.0190930273383856e-05, 7.8297664003912359e-05, 4.9913975090021268e-05, 9.7686162916943431e-05, 9.0115354396402836e-05, 7.2995571827050298e-05, 9.2360205599106848e-05, 7.1439826569985598e-05, 5.1236405852250755e-05, 7.1076407039072365e-05, 5.9425932704471052e-05, 6.9445071858353913e-05, 8.394633186981082e-05, 9.371331543661654e-05, 5.9634439821820706e-05, 7.017570169409737e-05, 9.5491239335387945e-05, 5.9396334108896554e-05, } };
const TfArray<192, int> quant22_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant22 = { (TfLiteFloatArray*)&quant22_scale, (TfLiteIntArray*)&quant22_zero, 0 };
const ALIGN(8) int32_t tensor_data23[336] = { 342, 2013, 2982, 3829, 2583, 6101, 11071, 552, 6477, -172, 6074, 821, -108, 358, 3233, 2113, 1981, 6942, 323, -1338, 2023, 4296, 484, 2795, 6813, 2208, 8765, 953, 361, 1777, -206, 3634, 3971, 3815, 4746, 675, 1068, 1343, 2176, 2648, 4566, 1444, 1551, 6411, 9977, 2134, 2049, 4032, 3641, -588, 5671, 1684, 156, -758, 1989, 1942, 315, 2108, 1653, 683, 2789, 1484, 10011, 2047, 3953, 1412, 4496, 3134, 2626, 866, 4464, 738, -479, 4168, 1972, 6383, 1303, 3359, 833, 1907, 1672, 3713, 6482, 5156, 5916, 673, 3375, 4574, 4156, 2835, 1059, 1635, 7963, 3161, 834, 2534, 2579, -539, 1388, 5879, 2450, 6464, 5410, 627, 3480, 1279, 2600, 5785, 547, 2463, 450, 1543, 2929, 3521, 3394, 2954, 3745, 1831, 1871, 3495, 767, 2279, 3118, 2064, 3613, 2744, 2475, 3821, -313, 2345, 692, 2135, 1092, 1999, 3331, 2690, 1600, 2699, 3264, 4794, 1469, 6838, -37, -77, 3142, 645, 2460, 3389, 3371, 2978, 3535, 940, 5101, 4305, 5750, 2603, 3840, -1259, 2168, 3940, 1089, 340, 1265, 1757, 1416, -326, -57, 848, 5806, 1200, 1529, 900, 760, -167, 1274, 2833, 1040, 4356, 1708, 2719, 1546, 2310, 1713, 2858, 2411, 2251, 1539, 2234, 5749, 8252, 3096, 4333, 2779, 1208, 4754, 444, 4814, 1738, 3359, 471, 1276, 1395, -712, 2290, 660, 2706, 4362, 1483, 5132, 713, 2182, 5231, 4171, 2799, 1646, 1635, 8690, 1172, 2089, 1864, 573, 1764, 3304, 2536, 2845, 3356, 730, 3930, 1502, 1233, 2514, 2574, 2262, 2054, 3088, 810, -159, 5530, 2031, 2574, 3175, 3293, -214, 1955, 1407, 785, 3262, 1224, 1831, 5587, 2671, 52, 682, 2166, 2792, 1901, 5087, -337, 2861, 2123, 1162, 2561, 1416, 7086, 470, 1076, 383, 3940, 1198, 1546, 4557, 834, 1705, 3431, 1110, 5765, 3081, 1021, 96, 5418, -114, 3523, 2391, 1364, 3443, 576, 613, 1730, 4096, 2227, 2865, 1268, 8190, 2979, 1565, 471, 1804, 4840, 2392, 2612, 82, 1749, 2955, 1721, 674, 1358, 5818, 2441, 2204, 4725, 499, 4559, 840, 518, 3373, 4029, 2830, 5084, 1156, 453, 2894, 3173, 3123, 1495, 2044, 2612, 409, 3996, 900, 1914, 3900, 3951, 1315, 3127, -933, 2076, };
const TfArray<1, int> tensor_dimension23 = { 1, { 336 } };
const TfArray<336, float> quant23_scale = { 336, { 0.00010842684423550963, 8.9488625235389918e-05, 6.6419081122148782e-05, 7.9353856563102454e-05, 0.0001083550596376881, 6.7808105086442083e-05, 5.6370412494288757e-05, 0.00012940798478666693, 6.6281136241741478e-05, 9.2809073976241052e-05, 5.8582118072081357e-05, 9.7597876447252929e-05, 0.0001105095652746968, 8.803871605778113e-05, 7.7341996075119823e-05, 6.6435786720830947e-05, 7.940873911138624e-05, 6.7888511694036424e-05, 8.1855796452146024e-05, 0.00010530621511861682, 8.4996972873341292e-05, 7.0164547651074827e-05, 7.8599870903417468e-05, 9.0484994871076196e-05, 7.3673152655828744e-05, 8.6042084149084985e-05, 6.4369400206487626e-05, 0.00010450190893607214, 8.5642226622439921e-05, 9.3545968411490321e-05, 0.0001008879771688953, 8.7257285485975444e-05, 6.8902598286513239e-05, 8.9154971647076309e-05, 8.3563107182271779e-05, 9.0598055976442993e-05, 0.0001003607758320868, 9.5905328635126352e-05, 9.8125106887891889e-05, 0.00010002683848142624, 7.4049719842150807e-05, 9.5793628133833408e-05, 7.6172706030774862e-05, 6.9471010647248477e-05, 5.5153494031401351e-05, 0.00010776479757623747, 9.5343384600710124e-05, 8.3681501564569771e-05, 9.2699963715858757e-05, 8.384884858969599e-05, 6.5934560552705079e-05, 7.9182005720213056e-05, 0.00010127226414624602, 7.3379080276936293e-05, 8.6525280494242907e-05, 0.00015017791884019971, 0.00013092285371385515, 8.905917638912797e-05, 8.4528881416190416e-05, 0.00011979705595877022, 0.00011504346184665337, 8.9161876530852169e-05, 6.4067200582940131e-05, 0.00010400851897429675, 6.5025851654354483e-05, 9.4247043307404965e-05, 7.449766417266801e-05, 6.3688239606563002e-05, 7.2121612902265042e-05, 9.2006324848625809e-05, 6.9733818236272782e-05, 0.00010328442294849083, 8.1086269346997142e-05, 8.7943226390052587e-05, 8.0570309364702553e-05, 5.933421925874427e-05, 7.2327005909755826e-05, 9.353078348794952e-05, 0.00014309807738754898, 8.2175349234603345e-05, 0.00011306023952784017, 7.7610246080439538e-05, 6.2610401073470712e-05, 7.3872208304237574e-05, 8.2183054473716766e-05, 0.00010952482261927798, 6.6245091147720814e-05, 8.8340748334303498e-05, 7.0314279582817107e-05, 0.00011025532148778439, 8.4552273619920015e-05, 9.132966079050675e-05, 5.9370267990743741e-05, 9.6152791229542345e-05, 0.0001025548335746862, 7.5990006735082716e-05, 0.00011208626528969035, 7.8987366578076035e-05, 0.00012070983211742714, 7.3816365329548717e-05, 8.5762367234565318e-05, 9.2132606368977576e-05, 8.1498823419678956e-05, 0.00011725938384188339, 9.1457732196431607e-05, 6.5163840190507472e-05, 8.901253022486344e-05, 6.692230817861855e-05, 0.00013579580991063267, 8.8427441369276494e-05, 9.4599468866363168e-05, 7.1944268711376935e-05, 8.6416919657494873e-05, 8.5898827819619328e-05, 9.4109316705726087e-05, 0.0001009418410831131, 8.761569915805012e-05, 9.5039184088818729e-05, 9.4891409389674664e-05, 8.323091606143862e-05, 9.3230461061466485e-05, 6.9210916990414262e-05, 9.7351003205403686e-05, 8.6594860476907343e-05, 6.3935876823961735e-05, 0.00010294318053638563, 8.9321583800483495e-05, 7.5637013651430607e-05, 0.00010520144860493019, 0.00010229637700831518, 9.7201445896644145e-05, 8.7102154793683439e-05, 9.3232003564480692e-05, 8.8811808382160962e-05, 8.5206505900714546e-05, 5.2774728828808293e-05, 8.9074113930109888e-05, 8.8288914412260056e-05, 7.6711759902536869e-05, 7.1948154072742909e-05, 0.00010692351497709751, 6.244633550522849e-05, 9.0688881755340844e-05, 0.00014213427493814379, 9.0021370851900429e-05, 0.0001084255418390967, 8.3297192759346217e-05, 7.4236064392607659e-05, 9.0519904915709049e-05, 9.5844392490107566e-05, 8.6294901848305017e-05, 9.8030468507204205e-05, 9.0548521257005632e-05, 6.9287772930692881e-05, 6.8452303821686655e-05, 7.7606768172699958e-05, 7.0774724008515477e-05, 6.7463930463418365e-05, 8.5829313320573419e-05, 0.00010187036969000474, 8.5735387983731925e-05, 6.9733876443933696e-05, 8.8151020463556051e-05, 9.171592682832852e-05, 8.9526838564779609e-05, 0.0001026867757900618, 8.2604958151932806e-05, 0.00011856537457788363, 7.7775766840204597e-05, 0.00011511790216900408, 8.9982284407597035e-05, 0.00012086178321624175, 0.00012047900236211717, 0.0001204985092044808, 0.00011038379307137802, 7.8421362559311092e-05, 0.00012063720350852236, 7.1649345045443624e-05, 0.00012359562970232219, 0.00010490681597730145, 8.2951330114156008e-05, 8.0418154539074749e-05, 0.00010173966438742355, 8.8549466454423964e-05, 0.00010608642332954332, 9.7119882411789149e-05, 8.7022548541426659e-05, 0.00010403150372439995, 8.5145838966127485e-05, 6.5512009314261377e-05, 8.9033710537478328e-05, 7.2743452619761229e-05, 7.9925281170289963e-05, 9.9578363006003201e-05, 8.7132517364807427e-05, 0.00011792284931289032, 7.9367222497239709e-05, 9.5108312962111086e-05, 0.00011589313362492248, 8.6456857388839126e-05, 0.00010487764666322619, 0.00012560408504214138, 6.4801228290889412e-05, 7.8553486673627049e-05, 0.00010275763634126633, 7.9582030593883246e-05, 7.1664893766865134e-05, 9.5802039140835404e-05, 8.8410553871653974e-05, 8.4657694969791919e-05, 7.1398892032448202e-05, 6.9252615503501147e-05, 9.144857176579535e-05, 8.7324959167744964e-05, 0.00011780094064306468, 8.8205662905238569e-05, 5.7047433074330911e-05, 0.00011816281039500609, 0.00010342207679059356, 0.00010203884448856115, 9.7805503173731267e-05, 9.2711983597837389e-05, 6.6942695411853492e-05, 0.00010640970140229911, 9.2335380031727254e-05, 7.4974799645133317e-05, 9.147062519332394e-05, 7.3230490670539439e-05, 9.5638184575363994e-05, 0.00010028976248577237, 0.00011628997162915766, 9.6523661341052502e-05, 0.00011783466470660642, 9.0416484454181045e-05, 8.3210848970338702e-05, 8.7939726654440165e-05, 7.7213975600898266e-05, 9.0137458755634725e-05, 0.00011144502786919475, 8.2030084740836173e-05, 0.00010546710836933926, 7.4093375587835908e-05, 0.00011233988334424794, 8.1284699263051152e-05, 0.00015934526163619012, 0.00013782533642370254, 9.1500580310821533e-05, 9.3953472969587892e-05, 8.3503560745157301e-05, 5.7782192016020417e-05, 0.0001000587799353525, 0.0001322432653978467, 8.723014616407454e-05, 9.6620955446269363e-05, 8.1705999036785215e-05, 0.00010315033432561904, 7.1890135586727411e-05, 0.00010649272007867694, 7.6945660111960024e-05, 7.5907875725533813e-05, 7.8953766205813736e-05, 8.591765072196722e-05, 0.00010997565550496802, 6.0602516896324232e-05, 0.00015977346629370004, 7.4785661126952618e-05, 0.00010052182915387675, 8.0543752119410783e-05, 9.5385839813388884e-05, 0.00011172889935551211, 6.9313100539147854e-05, 0.00011782934598159045, 6.9524961872957647e-05, 6.8857858423143625e-05, 8.3608028944581747e-05, 7.0072615926619619e-05, 7.036334864096716e-05, 8.2179831224493682e-05, 0.00013475790910888463, 7.5723633926827461e-05, 0.0001199000544147566, 0.00010351377568440512, 0.00015164932119660079, 8.7357431766577065e-05, 9.0594337962102145e-05, 0.0001064733078237623, 8.3308550529181957e-05, 8.5788960859645158e-05, 8.1237158156000078e-05, 9.9258963018655777e-05, 8.342788351001218e-05, 9.4653922133147717e-05, 6.5358966821804643e-05, 8.604226604802534e-05, 0.00011099590483354405, 0.00010133816249435768, 8.1307698565069586e-05, 7.1986200055107474e-05, 9.6113253675866872e-05, 8.1604972365312278e-05, 8.3362545410636812e-05, 9.0444205852691084e-05, 7.6203286880627275e-05, 0.00010377777653047815, 8.8459135440643877e-05, 8.2297527114860713e-05, 7.9384990385733545e-05, 0.00011011829337803647, 5.9049725678050891e-05, 7.7596218034159392e-05, 8.996326505439356e-05, 6.4378698880318552e-05, 0.00010979293438140303, 0.00013438622409012169, 9.1334513854235411e-05, 7.8958648373372853e-05, 0.00010863036732189357, 5.0582981202751398e-05, 0.0001338591828243807, 0.0001403432252118364, 8.5341634985525161e-05, 8.6863481556065381e-05, 8.6000618466641754e-05, 0.00010051442222902551, 6.8941044446546584e-05, 9.9393189884722233e-05, 8.8947002950590104e-05, 8.207444625440985e-05, 7.6356693170964718e-05, 0.00010878402827074751, 8.2626298535615206e-05, 0.00010280169954057783, 9.6540054073557258e-05, 9.1095636889804155e-05, 9.2312599008437246e-05, 8.8347340351901948e-05, } };
const TfArray<336, int> quant23_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant23 = { (TfLiteFloatArray*)&quant23_scale, (TfLiteIntArray*)&quant23_zero, 0 };
const ALIGN(8) int32_t tensor_data24[336] = { -975, -5444, -863, 10673, -253, 25, 12757, -2473, -127, -700, 13886, 11542, -406, -3974, 250, -123, 1081, 6, 7038, -1741, -1626, -2855, 721, -462, 13507, 4164, 5461, -1515, -5481, -857, -65, 13800, -220, 11074, -157, 1141, -1014, 8326, -2661, 9688, -74, -3575, -242, 8500, -184, -6443, -390, -278, -68, -2267, 30, 228, -287, -2542, -503, -10737, -1521, -3425, 11031, -1547, 26, -2275, 3268, -300, -108, -5141, 13885, -956, -1764, -3184, -2, -1184, -1427, -5106, -21, -180, -22, -1281, -4764, -597, 20, 12822, 874, -99, 10400, 7214, -125, 7804, -764, -334, -270, 340, 10888, 71, -2216, -5770, -436, -1041, 11328, 10466, -87, 175, 55, -1967, -1067, -809, -58, 292, -344, -357, -447, -128, -6340, -30, 9984, 7404, 9097, 1598, -60, 123, 151, 100, 10918, -16, -3993, -1902, 21, 778, -3583, -3388, -2634, 9074, -3676, -2366, -298, -300, 22, 265, -98, -173, 45, 17, -2978, -3003, 8000, 8334, -939, 5279, 653, -2, -5026, 2291, -105, 61, 242, -79, -393, -2890, -3414, -904, -1647, 8844, -2341, -213, -7639, -2534, -2748, -5059, -49, 127, -148, -549, -2966, -3573, 10737, -583, -520, 11548, -911, 8069, -227, -4799, -2314, 10345, -3555, -7184, -1832, -5123, 13274, -233, -54, -1094, 8365, -2073, -5821, -4975, -45, -645, -5989, -6443, 239, -3013, -177, 10210, -73, -6366, 783, 11350, 20, -3899, 7928, 9451, 84, -2696, -315, 128, -495, -5949, 8980, -389, -103, -192, 834, 11593, 6763, -118, -1394, 11519, -182, -3326, 9798, -3940, 8083, -489, 73, -17, -2112, 11885, 650, -154, 330, -776, -1487, -124, -6164, -3898, -7520, -590, -652, -520, 11499, -715, -5095, -132, 9856, 8661, 11770, -3140, 128, -2297, 54, 4592, -5316, 3140, -4917, -1398, -24, 8128, -2430, -324, -244, -710, 28, -42, -211, 150, -101, -272, -3350, -8306, -4179, -1100, 10529, -2622, 843, -694, -5792, -4647, -3101, -1635, 276, -2396, 15055, 11805, -82, -3303, -483, -116, 16, 266, -2240, -3705, 6925, -1955, -940, -2014, 191, 15037, -35, -207, 97, -172, -3431, -6204, -7755, 8935, -636, -49, -802, -3838, 3167, 14378, -187, -3415, -4279, -2397, -1344, 46, -609, -7292, 21, -8348, -797, 510, 332, -384, };
const TfArray<1, int> tensor_dimension24 = { 1, { 336 } };
const TfArray<336, float> quant24_scale = { 336, { 0.00020870951993856579, 0.00019493217405397445, 0.00014934198406990618, 0.00011117719259345904, 0.00017764813674148172, 0.00024960492737591267, 0.00012400535342749208, 0.00020397125626914203, 0.00024057959672063589, 0.0003095657448284328, 9.3690876383334398e-05, 9.0366433141753078e-05, 0.00025729363551363349, 0.00019681479898281395, 0.00014226521307136863, 0.00026541616534814239, 0.00013769953511655331, 0.0002564130409155041, 0.00014877172361593693, 0.00023693694674875587, 0.00021180401381570846, 0.00018140061001759022, 0.00016405622591264546, 0.00022399854788091034, 0.00010143725376110524, 0.00019540754146873951, 0.00019732347573153675, 0.00029029455618001521, 0.00012843550939578563, 0.0001848847750807181, 0.00017726585792843252, 9.167315874947235e-05, 0.00021831411868333817, 8.5573039541486651e-05, 0.00016063959628809243, 0.00022791251831222326, 0.00019106909167021513, 0.00012224321835674345, 0.00018448838090989739, 0.00010415277210995555, 0.00023260264424607158, 0.00015546454233117402, 0.00018002283468376845, 0.00016872398555278778, 0.00017000979278236628, 0.00014972625649534166, 0.00021189148537814617, 0.00017084187129512429, 0.00017396124894730747, 0.00027547168429009616, 0.00026488408911973238, 0.00019807451462838799, 0.00022347010963130742, 0.00019016288570128381, 0.00025853430270217359, 9.6991898317355663e-05, 0.00030986714409664273, 0.00022717745741829276, 0.00010046879469882697, 0.00012986366346012801, 0.00018022971926257014, 0.00024494272656738758, 0.00019447739759925753, 0.00017959422257263213, 0.00022283806174527854, 0.00013042484351899475, 0.00011468760931165889, 0.00030751666054129601, 0.0002212786057498306, 0.0002725719241425395, 0.00024940745788626373, 0.00016956712352111936, 0.00020753649005200714, 0.00019469960534479469, 0.00024671672144904733, 0.00019069020345341414, 0.00020878556824754924, 0.00015987560618668795, 0.00015869156050030142, 0.00017924064013641328, 0.00020032755855936557, 9.1906935267616063e-05, 0.00023251796665135771, 0.00016992892778944224, 0.00016014424909371883, 0.00014773130533285439, 0.00029597594402730465, 0.0001476565666962415, 0.00014711527910549194, 0.00024087440397124738, 0.00026936104404740036, 0.00023914552002679557, 0.00014495258801616728, 0.0001824611535994336, 0.00021484441822394729, 0.00010659913823474199, 0.0001819470344344154, 0.00016560660151299089, 9.6981697424780577e-05, 0.00012394394434522837, 0.00020084533025510609, 0.00014509086031466722, 0.00023560436966363341, 0.00026374505250714719, 0.00014552166976500303, 0.00022071009152568877, 0.00023703654005657881, 0.00018539404845796525, 0.00021657512115780264, 0.00020630445214919746, 0.00027045424212701619, 0.00025841023307293653, 0.00012037601845804602, 0.00027272631996311247, 0.00011695236025843769, 0.00015340490790549666, 0.0001236972602782771, 0.00022414932027459145, 0.00017741868214216083, 0.00015935626288410276, 0.00019769881328102201, 0.00019940103811677545, 9.5797011454124004e-05, 0.00015407784667331725, 0.00014890079910401255, 0.00015441757568623871, 0.00018274386820849031, 0.00018164643552154303, 0.0002556100080255419, 0.00024751899763941765, 0.00024149760429281741, 0.00010122535604750738, 0.00016038914327509701, 0.00021141221805009991, 0.00022953345614951104, 0.00027651147684082389, 0.00018225284293293953, 0.00022881815675646067, 0.00024482072331011295, 0.00025600954541005194, 0.00021437967370729893, 0.00027475715614855289, 0.00030453677754849195, 0.00023591404897160828, 0.00012112628610339016, 0.0001345205819234252, 0.00029777653981000185, 0.00019539112690836191, 0.00017706069047562778, 0.00018289327272213995, 0.00012694996257778257, 0.00022439843451138586, 0.00016118123312480748, 0.00017866527196019888, 0.00028016380383633077, 0.00026475946651771665, 0.00018549292872194201, 0.00028648029547184706, 0.00021467867190949619, 0.00014710644609294832, 0.00036843057023361325, 0.00011126141907880083, 0.00020972407946828753, 0.00021069127251394093, 0.00010881683556362987, 0.00019068899564445019, 0.00023730019165668637, 0.00021318050858099014, 0.00024615018628537655, 0.00019310395873617381, 0.0002258535532746464, 0.00024961656890809536, 0.00012646778486669064, 0.00024672778090462089, 0.0001028729384415783, 0.00015393782814498991, 0.00025110901333391666, 0.00010271552309859544, 0.00021773917251266539, 0.00012229816638864577, 0.00021529747755266726, 0.00014985803863964975, 0.00027840936672873795, 0.00012019493442494422, 0.00013598527584690601, 0.00014057372754905373, 0.00023844154202379286, 0.00016638598754070699, 0.00011079208343289793, 0.0002273118298035115, 0.00022910587722435594, 0.00017233451944775879, 0.00014417280908674002, 0.00022373166575562209, 0.0001308330538449809, 0.00017211488739121705, 0.00023372864234261215, 0.00033213364076800644, 0.00016212537593673915, 9.8368342150934041e-05, 0.00019999151118099689, 0.00014458088844548911, 0.00031647243304178119, 0.00010892101272474974, 0.00027581356698647141, 0.00010552231105975807, 0.00025512161664664745, 8.6609856225550175e-05, 0.00023578865511808544, 0.0002281696506543085, 0.00015453629021067172, 0.00014358926273416728, 0.00025816605193540454, 0.00022480866755358875, 0.00025116279721260071, 0.00020066155411768705, 0.00026423938106745481, 0.00015259078645613045, 0.00012334111670497805, 0.00022093349252827466, 0.0001491574221290648, 0.00036562790046446025, 0.00019971662550233305, 9.5805044111330062e-05, 0.00016053784929681569, 0.00024529258371330798, 0.0002076188538921997, 0.00010221295815426856, 0.00031322447466664016, 0.00019298476399853826, 0.0001215427037095651, 0.00015563696797471493, 0.00013304135063663125, 0.00015140452887862921, 0.00024045945610851049, 0.00018606458615977317, 0.00022967951372265816, 0.00012942153261974454, 0.00025052440469153225, 0.00018754183838609606, 0.00016092440637294203, 0.00017894295160658658, 0.0003154987352900207, 0.0002718486066441983, 0.00013548626156989485, 0.00023412438167724758, 0.00011711255501722917, 0.00024287449195981026, 0.00028737311367876828, 0.00028621146338991821, 0.00010270786879118532, 0.00021150885731913149, 0.00016665608563926071, 0.00016751069051679224, 0.0001136350110755302, 0.00012303692346904427, 0.0001052300285664387, 0.00015542468463536352, 0.00023039367806632072, 0.0003083075862377882, 0.00020929555466864258, 0.00022009525855537504, 0.00015791632176842541, 0.00024394816136918962, 0.00014259300951380283, 0.00018840975826606154, 0.00019479937327560037, 0.00014655871200375259, 0.00025106707471422851, 0.00016090982535388321, 0.00023979450634215027, 0.00023407374101225287, 0.00028892356203868985, 0.00024986121570691466, 0.00020371796563267708, 0.00014722284686286002, 0.00021255781757645309, 0.00025342748267576098, 0.00020876240159850568, 0.00012393716315273196, 0.00019105926912743598, 0.00016401063476223499, 0.0001081468362826854, 0.00013329261855687946, 0.00017502628907095641, 0.00025337495026178658, 0.00011596619879128411, 0.00020182439766358584, 0.00025603760150261223, 0.0001274487585760653, 0.0001718897110549733, 0.00021286997071001679, 9.9324992334004492e-05, 9.8805285233538598e-05, 0.00020828477863688022, 0.00020334942382760346, 0.00018480951257515699, 0.00025778813869692385, 0.00019238804816268384, 0.00018044494208879769, 0.00030226318631321192, 0.00014881840615998954, 0.00014793295122217387, 0.00024827761808410287, 0.00022521385108120739, 0.00015401508426293731, 0.00013391223910730332, 8.904046262614429e-05, 0.00018140154134016484, 0.00027113751275464892, 0.00017921265680342913, 0.00019415553833823651, 0.00021359403035603464, 0.00012325108400546014, 0.00010255185043206438, 0.00014356616884469986, 0.00022825312044005841, 0.00018982931214850396, 0.00016905498341657221, 0.0002059275284409523, 0.00021319597726687789, 8.3957413153257221e-05, 0.00017653615213930607, 0.00021719113283324987, 0.00015402096323668957, 0.00018790726608131081, 0.00034051539842039347, 0.00020230231166351587, 0.00016867497470229864, 0.00012467120541259646, 0.00012393217184580863, 0.00010198531526839361, 0.00019319441344123334, 0.00022262702987063676, 0.00036462501157075167, 0.0001951998274307698, } };
const TfArray<336, int> quant24_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant24 = { (TfLiteFloatArray*)&quant24_scale, (TfLiteIntArray*)&quant24_zero, 0 };
const ALIGN(8) int32_t tensor_data25[336] = { -1801, 2421, 5131, 266, 1574, 909, 1644, 2920, 2559, 1668, 817, 538, 664, -406, 740, -1411, -193, -1062, 1777, -63, 2338, 2221, 708, -557, 1065, 2664, 2659, 2418, 1544, 1991, 1468, -1206, 2057, 2709, -1505, 4112, 2682, 528, 665, 3889, 422, 1690, 2489, -293, 715, 289, 937, 570, 343, -280, 1778, 2179, 315, 431, 262, 950, 5080, 336, 6290, 7577, 5404, 1532, 487, 4825, 880, 1742, 2050, 1808, 1427, 3900, 2045, 2430, -878, -788, -387, 3618, 6079, 466, 1495, 2000, 1184, 5132, 4171, 1317, 1308, 1269, 1641, 1326, 1277, 184, 3463, 5287, 2599, 4167, 3191, 2198, 499, 358, -751, -1, 4254, -392, 1541, 5880, 4517, 2399, 9260, 1162, 1946, 3671, -700, 3510, 744, 3754, 1861, 3476, 1863, 3176, 2587, -814, 1857, 1780, -426, 786, 1968, 91, 1585, 2573, 2398, 1636, 1510, -408, -772, 1194, -453, 2365, 1487, 493, 2193, 24, -351, 7322, 5231, 272, 1117, 163, 186, 4883, 848, 1580, -918, 2777, 684, 415, 3497, 1592, 962, -224, 1911, 914, 1060, 523, 470, 760, 751, 4281, 602, 2397, 489, 567, 2940, 870, 1210, -1075, 4355, 1551, 456, 474, 1848, 930, 2529, 2702, 2995, -233, 2289, 1502, 2169, 539, 370, 4163, 76, -157, 1446, 1004, 4220, 1907, 1985, 145, 22, 1968, 1347, 1039, 812, -534, 1803, 883, 833, 2475, 854, 889, 1549, 1010, 1644, 3277, -349, 6283, 1669, 2754, 1210, 1024, 1103, 3956, -188, 1606, 303, -222, 2256, 1148, 961, 1347, 1789, 302, 2297, 2654, 2716, -126, 954, 988, 91, 4461, 3258, 1587, 3101, -9, 52, -128, 1472, -38, 3140, 356, 1469, 1239, 3458, 965, 925, 2814, 2906, 1890, 390, -99, 1353, 681, 2487, 1218, 154, 334, 3096, -353, 492, 900, 604, 1072, -776, 3762, 903, 801, 3113, 440, 4078, 116, 1850, 3433, 6825, -369, 2854, 863, 565, 1359, 2496, 1869, 627, 5493, 187, 1669, 872, 927, 2499, 2158, 1195, 703, 630, 1448, 2785, -587, 1997, 1951, 1690, 1267, 1302, 1540, 749, -178, 1935, 569, 2555, 1207, 468, 651, 3881, -1064, 402, 92, -338, 310, 879, 662, 1236, 2772, 2044, 2149, 684, 354, 542, 2132, 1246, 1541, };
const TfArray<1, int> tensor_dimension25 = { 1, { 336 } };
const TfArray<336, float> quant25_scale = { 336, { 0.00010560134251136333, 0.00010352359822718427, 6.7144414060749114e-05, 0.00010825502977240831, 0.0001215960510307923, 0.000105366634670645, 0.00010390012903371826, 0.00010473086877027526, 9.9303433671593666e-05, 9.1459070972632617e-05, 0.0001022327778628096, 0.00012996021541766822, 7.5147305324207991e-05, 9.7389354777988046e-05, 0.00010992887837346643, 9.9515993497334421e-05, 0.0001001081764115952, 0.00010289373312843964, 8.6645297415088862e-05, 0.00015026282926555723, 0.00010218488023383543, 8.1932266766671091e-05, 9.4202448963187635e-05, 0.00011638177238637581, 8.870708552422002e-05, 0.00011564549640752375, 8.4049563156440854e-05, 9.3707087216898799e-05, 8.8158856669906527e-05, 0.0001062698574969545, 0.00011982364958385006, 7.7091761340852827e-05, 0.00010899427434196696, 9.2977359599899501e-05, 0.00014858004578854889, 8.1443948147352785e-05, 8.9638269855640829e-05, 0.00011085104051744565, 9.0740591986104846e-05, 9.1942616563756019e-05, 0.00011649639054667205, 0.00011104928853455931, 8.4198793047107756e-05, 7.5814808951690793e-05, 0.00010265343735227361, 8.4572471678256989e-05, 8.4874751337338239e-05, 8.1283244071528316e-05, 0.00014668975200038403, 9.1254289145581424e-05, 0.000109006607090123, 0.00011138407717226073, 0.000106409439467825, 9.4242481281980872e-05, 0.00011449749581515789, 8.1801692431326956e-05, 7.5983480201102793e-05, 0.0001399439643137157, 6.6521271946839988e-05, 5.9636018704622984e-05, 8.1019294157158583e-05, 9.9344550108071417e-05, 9.4495524535886943e-05, 8.3537379396148026e-05, 8.1297839642502367e-05, 0.00010771819506771863, 8.6806787294335663e-05, 0.00010694447701098397, 0.00010043379006674513, 8.3390550571493804e-05, 0.00010784799815155566, 6.2956707552075386e-05, 9.7409545560367405e-05, 9.3409835244528949e-05, 0.0001130610762629658, 8.4968072769697756e-05, 7.5188618211541325e-05, 0.0001215233642142266, 0.00013858107558917254, 8.2527440099511296e-05, 0.00010224472498521209, 8.4246690676081926e-05, 8.1784375652205199e-05, 7.3642899224068969e-05, 8.8313165178988129e-05, 0.00011057759547838941, 7.2808637924026698e-05, 9.1392015747260302e-05, 0.00010371422831667587, 0.00013860917533747852, 0.00011045079736504704, 8.5123494500294328e-05, 9.7807649581227452e-05, 7.3487201007083058e-05, 0.00010727907647378743, 0.00013247046445030719, 9.5123512437567115e-05, 0.00010361555177951232, 0.00012576361768878996, 9.5752322522457689e-05, 7.7426258940249681e-05, 7.987158460309729e-05, 7.8485347330570221e-05, 5.672158658853732e-05, 8.61324806464836e-05, 0.00010873151040868834, 7.0773086918052286e-05, 0.0001048759586410597, 0.00011912022455362603, 9.2291818873491138e-05, 7.5186231697443873e-05, 8.356180478585884e-05, 9.5629337010905147e-05, 7.3169525421690196e-05, 8.9912682597059757e-05, 7.230081973830238e-05, 0.00010298220149707049, 0.00012269699072930962, 7.6989250374026597e-05, 8.5516483522951603e-05, 0.00011247876682318747, 0.0001168764938483946, 7.9808254668023437e-05, 9.5007111667655408e-05, 8.8909364421851933e-05, 0.00011819645442301407, 9.4920651463326067e-05, 9.8804346635006368e-05, 7.8708828368689865e-05, 0.00010820743045769632, 7.7323173172771931e-05, 0.00011336838360875845, 9.9655087979044765e-05, 0.0001308401842834428, 7.3194540163967758e-05, 9.3955153715796769e-05, 9.4180606538429856e-05, 0.00011737432214431465, 0.00010525805555516854, 0.00011291791452094913, 0.00010391156683908775, 6.4750012825243175e-05, 7.8251257946249098e-05, 9.9107564892619848e-05, 9.9362616310827434e-05, 0.00012657740444410592, 0.00011823449312942103, 8.5265070083551109e-05, 0.00012214104935992509, 8.9521425252314657e-05, 0.00010988519352395087, 9.6075833425857127e-05, 9.3299422587733716e-05, 8.0524885561317205e-05, 7.3046176112256944e-05, 0.00010730414214776829, 0.00011771181743824854, 7.2794347943272442e-05, 8.8147768110502511e-05, 9.6351119282189757e-05, 0.00014049799938220531, 9.3426286184694618e-05, 0.00013954324822407216, 8.5751336882822216e-05, 8.8770582806318998e-05, 8.7521140812896192e-05, 8.5195497376844287e-05, 0.00013275978562887758, 0.00014423654647544026, 0.00011260947212576866, 7.1409274823963642e-05, 8.5193023551255465e-05, 0.00011182892194483429, 7.6456271926872432e-05, 9.2527909146156162e-05, 8.5161649622023106e-05, 0.00014915208157617599, 0.00011636773706413805, 9.9551652965601534e-05, 8.7493011960759759e-05, 0.00010796736751217395, 9.6059018687810749e-05, 0.00010008762910729274, 0.0001484102540416643, 9.0678171545732766e-05, 0.00010446913074702024, 0.00010008971730712801, 9.638067422201857e-05, 0.00012907394557259977, 8.2141697930637747e-05, 9.7578544227872044e-05, 0.00011805289977928624, 0.00011505620204843581, 9.4148803327698261e-05, 8.2524515164550394e-05, 7.566211570519954e-05, 9.4105278549250215e-05, 0.00011012550385203212, 8.5394305642694235e-05, 8.1299440353177488e-05, 0.00010446969827171415, 8.8922250142786652e-05, 0.00010511674918234348, 0.00013229237811174244, 9.3209469923749566e-05, 9.9696218967437744e-05, 8.9426510385237634e-05, 8.581054862588644e-05, 9.217097976943478e-05, 9.0501656814012676e-05, 9.2989903350826353e-05, 9.8384880402591079e-05, 9.0301567979622632e-05, 7.1265632868744433e-05, 8.7348198576364666e-05, 7.4447008955758065e-05, 8.1812780990730971e-05, 8.3633094618562609e-05, 7.2644375904928893e-05, 0.00010196228686254472, 0.00010767445928649977, 9.0493536845315248e-05, 0.00014537293463945389, 8.9989967818837613e-05, 0.00011035308125428855, 0.00011578960402403027, 0.00010871376434806734, 9.912666428135708e-05, 0.00011290752445347607, 8.8720487838145345e-05, 8.0530197010375559e-05, 0.00012484878243412822, 9.8532043921295553e-05, 0.00010177022340940312, 0.00012404518201947212, 0.00011702437768690288, 8.1932623288594186e-05, 0.00012828721082769334, 0.00012128044909331948, 7.9142766480799764e-05, 9.1488211182877421e-05, 9.6780349849723279e-05, 7.0381334808189422e-05, 0.0001184272623504512, 9.8568321845959872e-05, 9.6903597295749933e-05, 0.00010014361760113388, 0.00010724440653575584, 0.00010417803423479199, 8.0563215306028724e-05, 0.00012751031317748129, 0.00016906500968616456, 0.00011922025441890582, 0.00011506536975502968, 9.7282769274897873e-05, 7.8803226642776281e-05, 9.0900612121913582e-05, 6.8920329795219004e-05, 0.00011937110684812069, 0.00011281547631369904, 0.00012696289923042059, 9.2614391178358346e-05, 8.9025394117925316e-05, 9.9817414593417197e-05, 6.8880035541951656e-05, 0.0001151916294475086, 8.9564047812018543e-05, 0.00011402976087993011, 8.5744431999046355e-05, 0.00010914025915553793, 9.5726158178877085e-05, 9.1163732577115297e-05, 9.7530661150813103e-05, 8.5367908468469977e-05, 0.00012458179844543338, 8.135007374221459e-05, 8.9418725110590458e-05, 0.00015021019498817623, 6.4183914219029248e-05, 9.9910001154057682e-05, 9.5342402346432209e-05, 8.8934597442857921e-05, 6.3414881878998131e-05, 0.00011810066644102335, 7.70255719544366e-05, 0.00012211380817461759, 9.4706694653723389e-05, 0.0001156846628873609, 0.00010764959006337449, 0.00011803115194197744, 0.0001025601159199141, 7.2421171353198588e-05, 9.7845346317626536e-05, 9.8909287771675736e-05, 7.701261347392574e-05, 8.8230386609211564e-05, 0.00012489450455177575, 7.5016832852270454e-05, 7.7608114224858582e-05, 8.9009256043937057e-05, 9.5091309049166739e-05, 9.9391996627673507e-05, 0.00010292082879459485, 7.7178803621791303e-05, 9.6903197118081152e-05, 8.1811151176225394e-05, 0.0001235484960488975, 0.00011170774814672768, 0.00011532757343957201, 0.00010109315917361528, 0.00011806645488832146, 8.0851976235862821e-05, 8.7458305642940104e-05, 0.00010548825230216607, 0.00010921791545115411, 9.334821515949443e-05, 0.00012869456259068102, 0.00011606474436121061, 6.4345877035520971e-05, 8.4944855188950896e-05, 9.53959024627693e-05, 8.9824134192895144e-05, 9.2065420176368207e-05, 0.00011786576942540705, 0.00010585693235043436, 0.00011170901416335255, 7.9400284448638558e-05, 0.00011517706298036501, 0.00013048227992840111, 9.8241223895456642e-05, 6.8985311372671276e-05, 8.7361877376679331e-05, 9.0593617642298341e-05, 8.9713073975872248e-05, 0.00011189976066816598, 0.00012313481420278549, } };
const TfArray<336, int> quant25_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant25 = { (TfLiteFloatArray*)&quant25_scale, (TfLiteIntArray*)&quant25_zero, 0 };
const ALIGN(8) int32_t tensor_data26[336] = { -2516, -5184, 11125, -1490, 6072, -5350, -354, -122, 6606, -516, -636, -3410, -1926, 557, -10177, -2373, -2193, -697, -709, -1635, -6045, -786, 8363, -7292, -2956, -4099, 11097, 12340, -116, -1419, -5645, -3326, -77, 10567, 356, -10233, 4488, -2454, -4396, 14646, -3148, -5015, -482, -3257, -5048, -1802, -1122, -978, -185, -5377, -4973, -2568, -2759, -3682, -3377, -224, 14851, -3881, -1504, 10351, 11439, -1753, -4405, 11484, -2331, 450, -2617, -4728, -4673, -5731, 10628, 2891, -2474, 1468, -3304, -6816, 16096, -4303, 1822, -5866, -3603, -5913, -1384, -3023, -6089, 8759, 2215, -4622, -3748, -2546, 12881, 11567, -351, -479, 542, 1344, 5909, -7059, -1995, -2604, 13006, -799, -3629, 13311, -747, -3361, 16884, -1816, 7728, 13837, -3559, 228, -100, -159, -8441, -6040, -204, 17006, -2, -4849, -662, -5281, -2869, -3640, -5138, -4642, -3232, -25, 15745, -3292, -7509, 252, -5652, -4230, -1302, 2906, -2676, -1337, 10938, -324, -3927, 14290, -363, -876, -2043, -217, -2600, 12383, -3356, 9360, -1336, 10076, -254, -3216, -2398, -4265, -836, -1481, 1441, -21, -3941, -1064, -2975, -3139, 21, 9713, -1006, -192, -3178, -2799, 1204, -2017, -5115, -2904, -2815, -2936, -3153, -3600, -4442, -2849, -3262, 254, -2946, -2327, 12052, -4130, 196, -4844, 6469, 5927, 2195, -2126, 10933, -2709, 12144, 4300, -4327, -814, -108, -1736, -3265, -1108, -3643, -1535, 7175, -867, -937, 10423, -3518, -4128, -1363, -3391, 1486, 15056, -300, 12768, -664, -3674, -4910, -1034, -1036, -830, -4306, -3090, -4713, -2424, 11534, -1292, -4611, 5540, -39, -683, 9677, -6220, -5928, -1996, 8877, -1993, -3853, 11834, 8535, -4926, -35, -194, -2521, -3385, -781, -2677, 9514, -2563, -5318, -414, 8858, -983, -3452, 10911, -4518, -258, -2523, -2891, -1730, -3257, -5565, 8571, -4866, -5514, 12509, -1034, -2902, -1170, -3782, -2053, -3182, 14184, -436, -70, -5806, -1107, -8769, -3658, 11696, 12434, 19423, -57, 10497, -2784, -1119, -6559, -5074, -9212, -1277, 14201, -983, 11510, -4278, -4081, 507, -940, -3551, 111, 9308, -271, 11987, -3446, -5230, -5470, -4510, -4150, -4516, -4824, -4881, -3227, 9209, -5638, 8010, -68, -2217, 4039, 7302, -2913, -2111, -2464, -3186, -6791, -1703, -1142, -1790, 11908, 61, -4511, -5036, -3463, -3632, -2117, -7465, -998, };
const TfArray<1, int> tensor_dimension26 = { 1, { 336 } };
const TfArray<336, float> quant26_scale = { 336, { 0.00027406835579313338, 0.00015729886945337057, 0.000169726787135005, 0.00027622169000096619, 0.00017844187095761299, 0.00015919630823191255, 0.00018643634393811226, 0.00021075227414257824, 0.000162924436153844, 0.00015752180479466915, 0.00017956200463231653, 0.00022067136887926608, 0.00031896206201054156, 0.00014665142225567251, 0.00010845742508536205, 0.00030306272674351931, 0.00020026029960718006, 0.00026598549447953701, 0.00027167401276528835, 0.000189306287211366, 0.0001326422207057476, 0.00014929693134035915, 0.00012156573211541399, 0.00013295297685544938, 0.00015027716290205717, 0.00020119560940656811, 0.00013120578660164028, 0.00010879294131882489, 0.00022868183441460133, 0.00021143023332115263, 0.00018155496218241751, 0.00016953310114331543, 0.0001592359330970794, 0.0001251668727491051, 0.00036760178045369685, 6.1958184232935309e-05, 0.00024708040291443467, 0.00021053780801594257, 0.0001992918987525627, 0.00011342029029037803, 0.00025398671277798712, 0.00021263495727907866, 0.00020509611931629479, 0.00013968316488899291, 0.00014840571384411305, 0.00029017569613642991, 0.00011900941899511963, 0.00031223820406012237, 0.00021686112449970096, 0.00016176443023141474, 0.00018305689445696771, 0.00016797616262920201, 0.00030933611560612917, 0.00018568400992080569, 0.00027705938555300236, 0.00026687304489314556, 0.00014712488336954266, 0.00022491297568194568, 0.00022933249420020729, 0.00016791436064522713, 0.00012377888197079301, 0.00018402031855657697, 0.000167466962011531, 0.00012121309555368498, 0.00030332925962284207, 0.00023605526075698435, 0.00029662516317330301, 0.00021536345593631268, 0.00015843099390622228, 0.00023621961008757353, 0.00010942953667836264, 0.00017781704082153738, 0.0003911994572263211, 0.00015334512863773853, 0.00028215264319442213, 0.00019208708545193076, 8.917500963434577e-05, 0.00023895705817267299, 0.00022609565348830074, 0.00011285828804830089, 0.0002351617586100474, 0.00019227757002227008, 0.00023997695825528353, 0.00018101430032402277, 0.00014096839004196227, 0.00012356135994195938, 0.00014942478446755558, 0.0001504152751294896, 0.00028652907349169254, 0.00026160833658650517, 0.0001125580893130973, 0.00015523245383519679, 0.00025806989287957549, 0.00025456139701418579, 0.00021214236039668322, 0.00015654490562155843, 0.00015651155263185501, 0.00012045679613947868, 0.00027541510644368827, 0.0002685927611310035, 0.00010363715409766883, 0.00027212483109906316, 0.00018897536210715771, 0.00016417683218605816, 0.00025794247630983591, 0.0001447349350200966, 9.8004958999808878e-05, 0.00023203529417514801, 0.00013759192370343953, 0.00010801907046698034, 0.00029915673076175153, 0.00014508854656014591, 0.00018710563017521054, 0.00031652586767449975, 0.00011845400149468333, 0.00020444058463908732, 0.00032046434353105724, 8.01625064923428e-05, 0.00022242889099288732, 0.00014605575415771455, 0.00019854296988341957, 0.00014908099547028542, 0.00027507345657795668, 0.00020451864111237228, 0.00017850827134680003, 0.000199477857677266, 0.00014251797983888537, 0.00016921371570788324, 8.1890648289117962e-05, 0.00020279051386751235, 0.00016572595632169396, 0.00018004667072091252, 0.00014078551612328738, 0.00021658296464011073, 0.0002819634391926229, 0.00017673859838396311, 0.00024506100453436375, 0.00018770068709272891, 0.00011140861170133576, 0.00024877142277546227, 0.00025144618120975792, 0.00010856340668397024, 0.00029691791860386729, 0.00018880225252360106, 0.00018836982781067491, 0.00024201975611504167, 0.00025403167819604278, 0.0001081812079064548, 0.00025606635608710349, 0.0001105208502849564, 0.00025750533677637577, 0.00011852527677547187, 0.00021996247232891619, 0.00025305623421445489, 0.00020366255193948746, 0.00021366335568018258, 0.00015405392332468182, 0.00016091114957816899, 0.00019591828458942473, 0.00018049900245387107, 0.00023291852266993374, 0.00019542875816114247, 0.00022385247575584799, 0.0002337348269065842, 0.00014130787167232484, 0.00016969384159892797, 0.00014581947471015155, 0.00026112297200597823, 0.00023760135809425265, 0.00025963553343899548, 0.00022021001495886594, 0.0001496580516686663, 0.00012157791934441775, 0.00017125805607065558, 0.00015496541163884103, 0.00018282386008650064, 0.00027043910813517869, 0.00030399032402783632, 0.0001535157352918759, 0.00031581829534843564, 0.00014857888163533062, 0.00019702830468304455, 0.00022895754955243319, 0.00023042281100060791, 0.00010281031427439302, 0.00021554369595833123, 0.00022339833958540112, 0.00016371039964724332, 0.00014838430797681212, 0.00020168499031569809, 0.00025526128592900932, 0.00013815038255415857, 8.3084691141266376e-05, 0.00025751351495273411, 0.00011421587987570092, 0.00023800133203621954, 0.00014395422476809472, 0.00020544524886645377, 0.00029139962862245739, 0.00037086501833982766, 0.00020815315656363964, 0.00018936456763185561, 0.00013061542995274067, 0.00021336585632525384, 0.00017138166003860533, 0.0002073572832159698, 0.00017405622929800302, 0.00010276057582814246, 0.00021689895947929472, 0.00018176960293203592, 0.00029719894519075751, 0.00012631762365344912, 0.00028122932417318225, 9.0053174062632024e-05, 0.00020606296311598271, 0.00011832675227196887, 0.00014311638369690627, 0.00026396146859042346, 0.00018355184874963015, 0.00015398887626361102, 0.00019257752865087241, 0.00020443955145310611, 0.00024424539878964424, 0.0002352804149268195, 0.000175213732291013, 0.00026607318432070315, 0.00011475544306449592, 0.00025553136947564781, 0.00019783660536631942, 0.0001802236947696656, 0.00018936542619485408, 0.0002304842637386173, 0.00013651853078044951, 0.00013924286758992821, 0.00012543796037789434, 0.00027990739909000695, 0.00014563534932676703, 0.00023315507860388607, 0.00019717418763320893, 0.00012208557745907456, 0.00014481112884823233, 0.00025962741347029805, 0.00029629596974700689, 0.00021063505846541375, 0.00025806954363361001, 0.00026652839733287692, 0.0002427451399853453, 0.00023852101003285497, 0.00013243459397926927, 0.00028661324176937342, 0.0001797265576897189, 0.00017927896988112479, 0.00015719978546258062, 0.0003021122538484633, 0.00018858566181734204, 0.00010248086618958041, 0.00016182074614334852, 0.00033317890483886003, 0.00018887651094701141, 0.00019520874775480479, 0.00016566873819101602, 0.00018509771325625479, 0.00016082856745924801, 0.00014149295748211443, 0.00015215660096146166, 0.000177571433596313, 9.9409902759362012e-05, 0.00020823873637709767, 0.00031031068647280335, 0.00021881423890590668, 0.00016314083768520504, 0.00022999889915809035, 0.0001949649304151535, 0.00011368151172064245, 0.00027041902649216354, 0.0002945336455013603, 0.00015520671149715781, 0.00014171151269692928, 0.00012012365186819807, 0.00018626984092406929, 9.7435404313728213e-05, 0.00010129297152161598, 9.4807874120306224e-05, 0.0002421519166091457, 0.00012846516619902104, 0.00025965343229472637, 0.00032477750210091472, 0.0001902105868794024, 0.00018905856995843351, 0.00010476018360350281, 0.00024898341507650912, 0.00010379590094089508, 0.00026034840266220272, 0.00010947408736683428, 0.00024545154883526266, 0.00019611856259871274, 0.00013574413605965674, 0.00020799165940843523, 0.00024263624800369143, 0.00032597433892078698, 0.00010720778664108366, 0.00028473694692365825, 0.00011290267138974741, 0.00027133597177453339, 0.00016365564079023898, 0.00018831649504136294, 0.00020348750695120543, 0.00018635591550264508, 0.00013432506239041686, 0.00012387223250698298, 0.00020684576884377748, 0.00019535297178663313, 0.00013225975271780044, 0.00011535199155332521, 0.00015162366617005318, 0.00023787874670233577, 0.00026864217943511903, 0.00019393613911233842, 0.00016840478929225355, 0.00027477738331072032, 0.00017858212231658399, 0.0003231650625821203, 0.00028968960396014154, 0.00016350910300388932, 0.00022609006555285305, 0.00017000845400616527, 0.00021798773377668113, 0.00010778920841403306, 0.00026570196496322751, 0.00019218972011003643, 0.0001375191641272977, 0.00027155771385878325, 0.00023904840054456145, 0.00019106133549939841, 0.00010226922313449904, 0.00016931956633925438, } };
const TfArray<336, int> quant26_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant26 = { (TfLiteFloatArray*)&quant26_scale, (TfLiteIntArray*)&quant26_zero, 0 };
const ALIGN(8) int32_t tensor_data27[336] = { 4586, 763, 2600, 1882, 2210, -1446, 2103, 3408, -2867, 4509, -3829, -2851, 7496, -3879, -5528, -3229, 933, -2128, 2442, -2451, 5434, 1707, -1878, -3940, 534, 5264, -1479, 3615, -1898, -1325, 6508, 8955, 5371, 6717, 9266, 2318, -771, 1011, -222, 1831, 853, -2205, 1500, 4297, 8529, 4449, 2284, 3187, -2644, 5454, -3666, -1328, -1175, -895, 327, 3799, -19, -302, -816, 2410, -640, 8990, -2590, 1808, -512, 2102, 3208, -110, 2145, -5458, 829, -1341, 1993, 2009, 6649, 5950, -2006, -3591, 2083, -1132, 5067, 7642, -905, 2562, -2552, -692, 5329, 311, 4968, 1073, -1469, 3146, 4485, -6133, 1799, -2694, 2949, -1392, -298, -3188, -3369, 2068, 3397, 10503, 4292, -1743, 865, 1905, -1469, 829, -3122, 475, 4906, -310, -2654, -1668, 2607, -1061, 13735, -810, -3163, -345, -2610, -674, -553, 2455, -1968, -2082, -18, -962, -672, 5774, 3215, -725, 4266, -452, 6039, 1027, 2106, 1711, -701, 7136, -1256, 806, 3212, -2153, 2280, -2334, 11644, 4151, 2596, -2548, 3944, -868, 4842, -100, -3584, -3790, 1829, 4139, 4735, 1284, 3056, 5985, -214, 419, 5900, 3959, -1031, -2568, 678, 8268, -7454, -1249, 2919, 6153, 5895, -1648, 2899, -756, 4022, 452, 5298, 63, 3578, 494, -1017, 6923, -2541, -3049, 3076, 8343, 1976, 2827, -1122, 3348, -799, -767, 4336, -698, -20, 5984, 6735, -2703, -1033, 1948, 3282, -2318, -832, -3402, 2857, 4376, 7208, 1219, -1421, 3114, 3269, -3258, 1307, -1414, 1608, 2016, 1518, 8729, 3732, 3098, -624, 556, 3876, 3713, 2881, 4934, 7, -301, -2449, 1250, 8621, -681, -1357, 2011, -694, 1255, 8485, -811, 5399, 645, 6810, -1693, -849, 509, -1987, 2387, 240, 3070, 1914, -909, 1057, 2282, -826, -332, 2303, 937, 3908, 4286, 4888, 3003, -3452, -1437, -1481, 5458, 3673, 8814, 2902, -2188, 947, 1764, -6601, -4234, 4678, 8957, 5014, 3418, -2083, 1444, 2063, 797, 2158, 11464, 14684, -2021, -1215, -1334, -288, -1628, -294, -399, 5589, 3329, 2991, 2295, -1653, -2385, -735, 4699, 2558, -1689, -720, 5681, -1990, -1506, -536, 3186, -3302, 4867, -1748, -1705, 3790, 814, -2024, -747, 3242, 295, 2484, 1595, -756, 1709, -1192, -5743, -1354, -1029, 3334, 3841, -602, -939, 1963, 5574, };
const TfArray<1, int> tensor_dimension27 = { 1, { 336 } };
const TfArray<336, float> quant27_scale = { 336, { 8.3597202319651842e-05, 0.00010327463678549975, 0.00013649924949277192, 8.9237153588328511e-05, 0.00010563593968981877, 9.0616114903241396e-05, 0.00012325751595199108, 7.9817051300778985e-05, 5.9324120229575783e-05, 8.8403379777446389e-05, 6.5647916926536709e-05, 9.3892522272653878e-05, 7.3556802817620337e-05, 7.930697756819427e-05, 7.7653632615692914e-05, 8.3751154306810349e-05, 0.00011662168253678828, 0.00011528807954164222, 0.00010781420860439539, 0.00010954774188576266, 8.1391350249759853e-05, 0.00011336720490362495, 0.00010971221490763128, 7.841233309591189e-05, 8.1027363194152713e-05, 8.2499922427814454e-05, 9.7315052698832005e-05, 0.00010481357458047569, 8.8742504885885864e-05, 8.6679683590773493e-05, 8.2110447692684829e-05, 7.1576789196114987e-05, 8.3204344264231622e-05, 8.2803686382248998e-05, 6.2421495385933667e-05, 0.00011643001198535785, 0.0001189780596178025, 9.8443051683716476e-05, 0.00011434178304625675, 9.6347335784230381e-05, 9.0867411927320063e-05, 0.00012188281107228249, 0.00011165859905304387, 8.2668928371276706e-05, 7.2884904511738569e-05, 7.6701420766767114e-05, 9.9464334198273718e-05, 0.00010687883332138881, 8.6230007582344115e-05, 7.2608730988577008e-05, 5.6666067393962294e-05, 7.6831813203170896e-05, 0.00010730710346251726, 7.0018693804740906e-05, 0.00010790453234221786, 6.7791566834785044e-05, 9.7711214039009064e-05, 9.6827272500377148e-05, 9.0017005277331918e-05, 0.00011194640683243051, 8.2211896369699389e-05, 7.0264883106574416e-05, 0.00010251256026094779, 0.00013637640222441405, 8.6340347479563206e-05, 0.00010637855302775279, 8.772271394263953e-05, 0.00013116122863721102, 9.9467244581319392e-05, 7.9440258559770882e-05, 9.0187262685503811e-05, 9.2917340225540102e-05, 0.00010683466825867072, 9.5190749561879784e-05, 7.4868665251415223e-05, 7.3870134656317532e-05, 9.5771349151618779e-05, 8.3133534644730389e-05, 0.00012620924098882824, 0.000110151908302214, 0.00010433921124786139, 8.6950567492749542e-05, 0.0001061192451743409, 9.477663115831092e-05, 8.0024117778521031e-05, 0.00011556571553228423, 8.9489440142642707e-05, 8.3300146798137575e-05, 9.4158342108130455e-05, 8.0571182479616255e-05, 0.00012420077109709382, 0.00010876746819121763, 0.00011177775741089135, 7.0411115302704275e-05, 9.1491332568693906e-05, 9.9548211437650025e-05, 0.00012544311175588518, 9.6713287348393351e-05, 0.00010509116691537201, 0.00010030827252194285, 7.9911478678695858e-05, 0.00011234623525524512, 8.7516913481522352e-05, 5.7525623560650274e-05, 0.00010858129826374352, 8.9698245574254543e-05, 9.9811040854547173e-05, 0.00011838407226605341, 8.2585313066374511e-05, 0.00016907321696635336, 7.9782781540416181e-05, 0.00012754989438690245, 8.5094485257286578e-05, 8.8555891124997288e-05, 9.8246498964726925e-05, 0.00012727905414067209, 9.0987676230724901e-05, 0.00010609755554469302, 5.410694211605005e-05, 7.7113436418585479e-05, 8.6551946878898889e-05, 7.9955825640354306e-05, 0.00010686336463550106, 0.00011805538815679029, 8.4398918261285871e-05, 0.00014181963342707604, 8.0155477917287499e-05, 9.8025222541764379e-05, 9.4832910690456629e-05, 0.00010775132977869362, 0.00011573556548682973, 8.6064799688756466e-05, 0.00010028665565187111, 7.4096322350669652e-05, 7.8418692282866687e-05, 0.00012747093569487333, 8.840141526889056e-05, 9.9281380244065076e-05, 8.8328059064224362e-05, 8.6586944235023111e-05, 0.00010347707575419918, 8.8836131908465177e-05, 9.3046255642548203e-05, 9.7093019576277584e-05, 7.5716860010288656e-05, 7.7299227996263653e-05, 9.6044372185133398e-05, 0.00013287972251418978, 4.9475220293970779e-05, 0.00011501037079142407, 0.00010183507401961833, 8.7212480138987303e-05, 8.5447936726268381e-05, 9.1189918748568743e-05, 0.00010100263170897961, 9.0934387117158622e-05, 7.369020750047639e-05, 8.1515390775166452e-05, 0.00011365592945367098, 8.9622539235278964e-05, 0.00011214119876967743, 9.4867406005505472e-05, 0.00010661419946700335, 7.7701122791040689e-05, 9.1847214207518846e-05, 9.8883007012773305e-05, 8.0332938523497432e-05, 9.9898061307612807e-05, 9.8255244665779173e-05, 8.759484626352787e-05, 0.00011800747597590089, 7.2036556957755238e-05, 6.4388528699055314e-05, 9.3757313152309507e-05, 0.00013545605179388076, 7.4161631346214563e-05, 0.00010636179649736732, 9.0863512014038861e-05, 0.00010857635788852349, 9.8395015811547637e-05, 9.9801822216250002e-05, 9.7055017249658704e-05, 8.5140949522610754e-05, 8.6178042693063617e-05, 8.8191271061077714e-05, 0.00011473389895400032, 0.00012306909775361419, 8.6281448602676392e-05, 7.8452518209815025e-05, 0.00010272757936036214, 0.00010535626643104479, 6.9721747422590852e-05, 0.00011033483315259218, 9.3542286776937544e-05, 0.00011963754513999447, 0.00011276886652922258, 9.259702346753329e-05, 7.9770550655666739e-05, 8.1272060924675316e-05, 0.00010052547440864146, 0.00010231735359411687, 8.8929213234223425e-05, 7.4392446549609303e-05, 7.3259907367173582e-05, 0.00010913339792750776, 0.00010938699415419251, 7.998795626917854e-05, 7.9896024544723332e-05, 9.1506546596065164e-05, 0.00010690686758607626, 0.00011686445941450074, 8.3087936218362302e-05, 7.4326402682345361e-05, 8.0716745287645608e-05, 0.000111585613922216, 8.8531669462099671e-05, 0.00010423546336824074, 8.8823115220293403e-05, 7.4506664532236755e-05, 0.00011648868530755863, 9.3322261818684638e-05, 0.00012229163257870823, 6.829071935499087e-05, 7.1054339059628546e-05, 8.430906746070832e-05, 9.9882439826615155e-05, 0.00011267321679042652, 8.7875785538926721e-05, 0.0001261938305106014, 9.8660690127871931e-05, 9.6724201284814626e-05, 0.00011998696572845802, 8.854250336298719e-05, 0.00010209914762526751, 5.7131463108817115e-05, 0.00011053035268560052, 7.5828276749234647e-05, 0.00010031787678599358, 7.9362769611179829e-05, 7.7065960795152932e-05, 0.00010287758050253615, 9.8537428129930049e-05, 7.3058814450632781e-05, 7.2690032538957894e-05, 7.3805473221000284e-05, 0.00012230635911691934, 8.2679624028969556e-05, 0.0001024916346068494, 8.3704355347435921e-05, 0.00010474849841557443, 6.4188163378275931e-05, 0.00010899579501710832, 9.096772555494681e-05, 9.8653712484519929e-05, 8.1589962064754218e-05, 8.7694519606884569e-05, 0.00018131260003428906, 0.00013959500938653946, 0.00010365165508119389, 9.865129686659202e-05, 0.0001093866303563118, 0.00011204332986380905, 0.00010159679368371144, 0.00012585509102791548, 0.00010093662422150373, 0.00010642372217262164, 6.3790306739974767e-05, 8.5034756921231747e-05, 9.4257702585309744e-05, 0.0001024714729283005, 9.1265050286892802e-05, 7.7886106737423688e-05, 8.9261804532725364e-05, 0.00011466493742773309, 0.00010124861000804231, 0.0001177523226942867, 5.2015100663993508e-05, 6.5888059907592833e-05, 8.7656379037071019e-05, 8.0149933637585491e-05, 1.5157784218899906e-05, 0.00011046914733015001, 0.00010769088112283498, 0.00015176793385762721, 8.1050529843196273e-05, 6.1333994381129742e-05, 9.1994734248146415e-05, 6.0990183555986732e-05, 5.3778050641994923e-05, 8.3997001638635993e-05, 8.4771883848588914e-05, 0.0001079951980500482, 0.0001511939917691052, 9.5830146165098995e-05, 9.7813972388394177e-05, 0.00011020568490494043, 0.00011849063594127074, 0.00010060677595902234, 9.2137270257808268e-05, 0.00011600453581195325, 9.8728196462616324e-05, 9.1501300630625337e-05, 7.5460513471625745e-05, 8.1657519331201911e-05, 0.00012997712474316359, 0.00010138096695300192, 0.00012504831829573959, 0.00010675074008759111, 9.3097398348618299e-05, 0.00010377725266152993, 9.1669971880037338e-05, 7.4265350122004747e-05, 9.0355373686179519e-05, 9.1471418272703886e-05, 0.00012920473818667233, 5.3843210480408743e-05, 8.5398613009601831e-05, 9.9061311630066484e-05, 9.3206559540703893e-05, 9.5635077741462737e-05, 8.6590524006169289e-05, 8.8043452706187963e-05, 9.1069530753884465e-05, 9.7262265626341105e-05, 0.00012467833585105836, 9.9471391877159476e-05, 9.7990392532665282e-05, 5.8263667597202584e-05, 8.3300321421120316e-05, 9.6589239547029138e-05, 0.00011969916522502899, 0.00010768679931061342, 9.3171467597130686e-05, 0.0001039429334923625, 7.7565688116010278e-05, 9.6445430244784802e-05, } };
const TfArray<336, int> quant27_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant27 = { (TfLiteFloatArray*)&quant27_scale, (TfLiteIntArray*)&quant27_zero, 0 };
const ALIGN(8) int32_t tensor_data28[336] = { 17614, -3677, 16860, 18728, 16539, -3016, 16075, -6865, -4590, 22253, -321, -259, 17823, -131, -680, -573, -4176, -1285, 18365, -219, 16370, 15717, -1242, -268, -2021, 16596, -3341, 20992, -1697, -2261, 21181, 21859, 21738, 23631, 6972, 17639, -2897, -2409, -1645, -2485, -3791, -1528, -1997, 23846, 15533, 21809, 24492, 26602, -1837, 17065, -188, -393, -1687, -6770, -3937, 17744, -1153, -816, -2729, 20756, -784, 23126, -799, 20599, -1483, 6744, 22572, -3400, 19715, -46, -4680, -515, 19315, 17955, 16288, 22519, -3837, -271, 9636, -1778, 3668, 17778, -1248, 20447, -2142, -2473, 21271, -2813, 22857, -5966, -2846, 49, 22136, -102, 17614, -1854, 23081, -1565, -1886, -730, -390, 8953, -1049, 11450, 20773, -641, -3367, 16142, -329, 18265, -1803, -4061, 17950, -1091, -201, -979, 22789, -1796, 15388, -612, -349, -1044, -436, -3262, -2543, 21014, -1844, -1267, -4702, -2543, -1465, 15657, 20798, -5216, 19508, -1961, 17352, 16462, 18166, 17249, -1093, 19703, -1806, -2152, 8235, -441, 18945, -579, 13621, 21720, 18398, -1480, 24791, -1619, 17274, -1148, -1226, -476, 19238, 17889, 22242, -4269, 21412, 18058, -3121, -3556, 17819, 18221, -1640, -1826, -1714, 5924, -1151, -1629, 24621, 1531, 24457, -284, 18100, -2562, 19312, -2856, 21544, -1636, 19378, -3370, -4576, 19662, -1159, -635, 21411, 18857, 19752, 21768, -1394, 21046, -2412, -1388, 21783, -2305, -3260, 19272, 22076, -1550, -1664, 17059, 18841, -302, 15888, -213, 17009, 17826, 11989, -3562, -3223, -1628, 19125, -568, 14433, -1698, 19787, 22639, 13861, 23824, 9926, 12977, -2334, 10905, 23594, 25942, 20789, 21473, -1462, -1614, -765, 5553, 23411, -3475, -1192, 19239, -2335, -1591, 25836, -1832, 16370, -3263, 18250, -134, -2159, -4721, -489, 20384, -6018, 22296, 19036, -1566, 21213, 23214, -1715, 20191, 16075, -2955, 21906, 21910, 19072, 24800, -333, -2396, -1557, 20151, 17256, 24721, 17466, -1719, 15135, -896, -5, -220, 18294, 22921, -2197, 23174, -206, 17525, 1394, -3735, 17487, 19160, 14623, -1833, -651, -969, -1440, -300, -1888, -3476, 25525, 20536, 19919, 1221, -926, -1618, -1508, 21332, 20519, -2115, -2768, 19594, -802, -2651, -3081, -4834, -1172, 15721, -838, -1792, -3574, -5582, -1803, -2879, 18453, -6569, 17149, -2517, -794, -2716, -2567, -69, -1300, -239, 20539, 22962, -3102, -3451, 18927, 13109, };
const TfArray<1, int> tensor_dimension28 = { 1, { 336 } };
const TfArray<336, float> quant28_scale = { 336, { 7.9723882663529366e-05, 0.00011659214942483231, 8.8961729488801211e-05, 9.0472502051852643e-05, 9.2101065092720091e-05, 0.00017602798470761627, 9.1290239652153105e-05, 9.2098300228826702e-05, 0.0001636742235859856, 7.5989832112099975e-05, 0.00015109253581613302, 0.00016504980158060789, 0.00010750520596047863, 0.00013376584684010595, 0.00019716854149010032, 0.00016279786359518766, 0.00018566883227322251, 0.00013696699170395732, 7.8437842603307217e-05, 0.00015473642270080745, 0.00010982666572090238, 9.3633010692428797e-05, 0.00013030566333327442, 0.00018150047981180251, 0.00013764458708465099, 0.00011256627476541325, 0.00015376805095002055, 6.7677254264708608e-05, 0.00016661113477312028, 0.00015510251978412271, 0.00011340090713929385, 0.00010505534010007977, 8.9819615823216736e-05, 7.3338880611117929e-05, 0.00012749363668262959, 6.6705375502351671e-05, 0.00011054803326260298, 0.0001401730696670711, 0.00015434929809998721, 0.00012163638893980533, 0.00011194765102118254, 0.0001466685498598963, 0.00011624656326603144, 7.8556717198807746e-05, 0.00014622713206335902, 8.0797908594831824e-05, 6.8768611527048051e-05, 5.2754145144717768e-05, 0.00016141700325533748, 0.00011881823593284935, 0.00025158014614135027, 0.00014965597074478865, 0.00011544516019057482, 0.00013821707398165017, 0.00011932496272493154, 0.00010900221968768165, 0.00012967240763828158, 0.00012667321425396949, 0.00012997993326280266, 6.9095782237127423e-05, 0.00015992626140359789, 7.6644733780995011e-05, 0.00014526776794809848, 7.0822461566422135e-05, 0.0001409027463523671, 0.00017580389976501465, 7.3412062192801386e-05, 0.00012446976325009018, 7.113106403267011e-05, 0.00023170580971054733, 0.0001337437133770436, 0.00014613341772928834, 8.2216487498953938e-05, 8.2257160102017224e-05, 8.9181994553655386e-05, 8.7237160187214613e-05, 0.00011864909902215004, 0.00014108358300291002, 0.00012268751743249595, 0.00012242095544934273, 0.00011718220775946975, 0.00011220555461477488, 0.00012450684153009206, 7.6671945862472057e-05, 0.00014196516713127494, 0.0001238375116372481, 8.4398641774896532e-05, 0.00012072564277332276, 7.2967792220879346e-05, 0.00014046207070350647, 0.00012490680092014372, 0.0001774270785972476, 7.2108901804313064e-05, 0.0002055265213130042, 8.5441788542084396e-05, 0.00014048950106371194, 6.848946213722229e-05, 0.00016175223572645336, 0.00012017002882203087, 0.00015521371096838266, 0.00014808084233663976, 0.00015439424896612763, 0.00013693995424546301, 0.00016691054042894393, 7.9946279583964497e-05, 0.00014558563998434693, 0.0001270483189728111, 9.4572198577225208e-05, 0.00017617159755900502, 8.3323990111239254e-05, 0.00014026788994669914, 0.00011062155681429431, 9.5493465778417885e-05, 0.00013017513265367597, 0.00014971179189160466, 0.00015250238357111812, 6.5306172473356128e-05, 0.00013952315202914178, 0.00014605073374696076, 0.0001659780100453645, 0.00015045376494526863, 0.00014390247815754265, 0.00016891391715034842, 0.00019594337209127843, 0.00014136602112557739, 7.3593560955487192e-05, 0.00014745767111890018, 0.00015213432197924703, 9.5335817604791373e-05, 0.00013432573177851737, 0.00012834533117711544, 0.00012014730600640178, 7.1741698775440454e-05, 0.00018827102030627429, 8.8340719230473042e-05, 0.00014834814646746963, 0.00010469905100762844, 8.4397142927628011e-05, 8.0159326898865402e-05, 8.7606509623583406e-05, 0.00015044328756630421, 8.5902509454172105e-05, 0.0001422567293047905, 0.00012401734420564026, 0.00018714369798544794, 0.00012435426469892263, 8.4399471234064549e-05, 0.00014574549277313054, 0.00017248526273760945, 8.2733662566170096e-05, 7.9974328400567174e-05, 0.00014732877025380731, 7.3276940383948386e-05, 0.00011837116471724585, 0.0001085936528397724, 0.00015803906717337668, 0.00017710341489873827, 0.00016700349806342274, 7.1134760219138116e-05, 8.1424084783066064e-05, 7.6913776865694672e-05, 0.00014447655121330172, 7.3962808528449386e-05, 9.8058168077841401e-05, 0.00011133366206195205, 0.00017246360948774964, 8.7180444097612053e-05, 9.1727160906884819e-05, 0.00013972341548651457, 0.00016136074555106461, 0.0001486970140831545, 0.00015128245286177844, 0.00030589595553465188, 0.00014862764510326087, 7.1995535108726472e-05, 0.00016138068167492747, 7.809721864759922e-05, 0.00015624983643647283, 8.2947692135348916e-05, 0.00014861425734125078, 8.6888016085140407e-05, 9.2102542112115771e-05, 8.7119100498966873e-05, 0.00012513039109762758, 8.490026812069118e-05, 0.00018507383356336504, 0.00017743860371410847, 7.2509115852881223e-05, 0.00015184939547907561, 0.00015681653167121112, 7.2253831604029983e-05, 0.00011156235996168107, 6.9890855229459703e-05, 7.4518000474199653e-05, 0.00011963759607169777, 7.1627458964940161e-05, 0.00015702156815677881, 0.00015539269952569157, 7.7016935392748564e-05, 0.00010874191502807662, 0.00015278294449672103, 9.9065684480592608e-05, 9.4515271484851837e-05, 0.00015225964307319373, 0.00014227947394829243, 8.370423165615648e-05, 8.0297999375034124e-05, 0.00014601097791455686, 9.356821101391688e-05, 0.00016454987053293735, 7.6186726801097393e-05, 9.6889132692012936e-05, 0.00016105778922792524, 0.00011538832768565044, 0.00012058234278811142, 0.00012168665125500411, 9.6514602773822844e-05, 0.00013971808948554099, 9.6485753601882607e-05, 0.00014723525964654982, 8.3659688243642449e-05, 6.608580588363111e-05, 0.00010487855615792796, 9.1679299657698721e-05, 0.0001422077912138775, 0.00011250416719121858, 0.00013427031808532774, 0.00012666691327467561, 6.550396210514009e-05, 6.5765794715844095e-05, 7.3876020906027406e-05, 8.885878196451813e-05, 0.00014221560559235513, 0.00013320513244252652, 0.00014777571777813137, 0.0002501282433513552, 9.8886921477969736e-05, 0.00011378340423107147, 0.00016503888764418662, 8.7042164523154497e-05, 0.00013566699635703117, 0.00013154528278391808, 8.2963051681872457e-05, 0.00015174996224232018, 9.7109943453688174e-05, 0.00011415671178838238, 9.9845870863646269e-05, 9.6954339824151248e-05, 0.00015613717550877482, 0.00012845055607613176, 0.00016210235480684787, 7.6846750744152814e-05, 0.00010924392699962482, 7.7260549005586654e-05, 8.1348662206437439e-05, 0.00019691232591867447, 7.0009162300266325e-05, 7.4369403591845185e-05, 0.00014254741836339235, 7.1388516516890377e-05, 8.1050500739365816e-05, 0.00017579529958311468, 7.3721370426937938e-05, 8.4099156083539128e-05, 8.7729764345567673e-05, 6.772388587705791e-05, 0.0001775360869942233, 0.00016906275413930416, 0.00014226886560209095, 8.2354803453199565e-05, 9.5818882982712239e-05, 8.3447281213011593e-05, 9.3912036390975118e-05, 0.0001388074888382107, 8.5848514572717249e-05, 0.00012283166870474815, 0.0002715378359425813, 0.000220047018956393, 7.8478034993167967e-05, 8.96941710379906e-05, 0.00059657421661540866, 7.6406293374020606e-05, 0.00018930538499262184, 9.1584166511893272e-05, 0.00015041347069200128, 0.00014370637654792517, 8.6418418504763395e-05, 0.00012789467291440815, 0.00016765440523158759, 0.00014328135875985026, 0.00015861140855122358, 0.00014608286437578499, 0.00012550894462037832, 0.00018037151312455535, 0.00014627404743805528, 0.00012116263678763062, 7.7006574429105967e-05, 8.1878686614800245e-05, 7.5510382885113358e-05, 0.00013906101230531931, 0.00012400206469465047, 0.00013265968300402164, 0.00014486163854598999, 8.1467449490446597e-05, 7.4560542998369783e-05, 0.00011546916357474402, 0.00010899990593316033, 0.00010529386054258794, 0.00019714150403160602, 0.00013511587167158723, 0.00012891230289824307, 0.00013578060315921903, 0.0001495768956374377, 0.00010356030543334782, 0.00016348047938663512, 0.00021283769456204027, 0.00014460830425377935, 8.7978936790022999e-05, 0.0001537444768473506, 0.00013768368808086962, 9.3955837655812502e-05, 0.00016648431483190507, 8.4087492723483592e-05, 0.00010388678492745385, 0.00011444324627518654, 0.00011918731615878642, 0.00011655819980660453, 0.00021282525267452002, 0.00015119154704734683, 0.00012218746996950358, 7.3085866461042315e-05, 7.5049632869195193e-05, 0.00015067562344484031, 0.00013358329306356609, 0.00010161734826397151, 0.00012250051076989621, } };
const TfArray<336, int> quant28_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant28 = { (TfLiteFloatArray*)&quant28_scale, (TfLiteIntArray*)&quant28_zero, 0 };
const ALIGN(8) int32_t tensor_data29[1280] = { -803, 311, -29, -480, -1461, -532, -1052, -672, 4, -311, 84, -955, -678, -987, 131, -499, -739, -827, -1162, -417, -330, -65, -706, -271, -418, -268, -592, -209, -613, -363, -1662, -107, -1036, 133, -855, -554, 323, -1657, 286, -1503, -146, 185, -17, -1139, 395, -29, 432, -747, -601, -534, -991, -1331, -254, -1014, -1082, -300, -1281, -157, -762, -852, -89, -939, -1289, -88, -39, 361, -773, -1176, -850, -215, -423, -775, -316, -269, -936, 220, -309, -152, -1145, 276, -1325, -1180, -671, -765, -283, 27, -362, -93, -20, -132, 19, -790, -209, -623, -294, -871, 53, 8, -58, -474, -128, -103, -1433, -746, -318, -389, -804, -815, -726, -188, -211, -595, -560, -611, 122, -58, -520, -848, -309, -360, -292, 336, -162, -608, -889, -381, 46, -1289, -1121, -357, -1370, -55, -720, -400, -978, -26, -1074, -1105, -794, 1171, 603, -57, 242, -866, -715, -928, -537, -359, -572, -594, -63, 62, -220, -124, -81, -556, -1337, -470, -282, -36, -786, 102, 46, 258, -335, -1539, -1193, -612, -535, 266, -332, -323, -209, -313, 351, -919, -458, -690, 445, -694, 181, -601, -666, -1038, -153, -406, -350, -226, -275, -672, 160, -691, -419, -974, -1263, -743, -875, -355, -583, -209, -258, -462, -854, -677, -913, -1062, -249, -390, -1173, -603, -429, -676, -1683, 28, -1093, -314, -325, -282, -572, -994, -889, -933, 313, -314, -521, -484, -1322, -1032, -1191, -777, 401, -1051, -454, -1094, -1037, 351, -65, -552, -655, -335, -676, -1053, -396, -947, -712, -672, 346, -558, -437, -50, -485, -634, -360, 259, -1296, -248, -972, 259, -1027, -587, -785, 426, -213, -641, 35, -274, -1261, -728, 108, -809, -367, -356, -654, -1410, -985, 626, -53, -437, -203, -661, -885, -446, -126, -665, -954, -855, -399, -728, -1574, -692, -1023, -389, -1141, -921, -595, -185, -729, -461, -757, 25, -130, -800, -997, -21, -159, -10, -767, -146, -1413, 569, -1010, 403, -577, 106, 358, -79, -789, -734, -702, -1626, -262, -314, -333, -571, -537, -808, -660, -678, 3, -532, -564, -40, -968, -728, -1432, -702, 289, -277, -1432, -233, 1634, 201, -787, -343, -717, -606, -524, -957, -633, -257, 639, -240, -134, -320, -336, 79, 142, -648, -957, -1289, 1731, -700, -185, -252, -9, -1002, -722, -671, -676, -602, 269, -600, 444, -442, -760, -363, -273, 245, -1354, -546, 301, -590, -1075, 729, -218, -462, -2298, 393, -666, -1200, -167, -1328, -340, -1386, -575, 289, -501, -781, -745, -637, -724, -778, -555, -379, -770, -302, -257, -588, -683, -747, -565, 381, -742, -267, -183, -553, -703, -717, -830, -427, -180, -125, -412, 664, -348, -1131, -1008, -296, -1555, -1136, -316, -810, -518, -183, -754, -687, 129, 23, -113, -456, -500, -436, 383, -860, -291, -423, -99, 64, -884, 146, -564, -1104, -515, -1099, -158, -328, -563, -821, 116, -332, -1332, -909, 495, -798, -1037, -751, -1016, -837, -650, -707, 105, 27, -1163, -417, 169, -751, -1020, 265, -314, -1136, -377, -242, -1358, -1103, -180, -433, 63, 230, 189, 50, -1203, -593, -625, -66, -289, -323, -17, -599, -267, -420, -772, 332, 25, -1386, -221, 603, -804, -420, -10, -1140, -262, -1362, -818, -534, 219, -1476, -1275, -1206, -238, -1318, -571, -44, -110, -527, 30, -115, -172, -725, -108, -396, -522, -844, -264, -582, -954, -135, -489, -139, -1146, -957, -510, -1165, -822, -1252, -509, -1643, -881, -1170, -1383, -124, 292, -375, 138, -281, -379, -465, -257, -1012, 77, -209, 129, -682, -462, -765, -842, -267, -534, -394, -892, 207, -534, -7, -27, -927, -349, -645, 397, -588, -490, -594, 74, -745, 271, -271, 345, -921, -177, -599, -363, -165, -330, -405, 209, -791, -276, -428, -833, -453, -1245, -885, 443, -218, -538, -508, 113, -161, -332, -1215, -698, -841, -871, -1568, -754, -1592, -1026, -691, -313, -1153, -89, -618, -393, -767, 528, -75, -470, -262, -734, -947, -797, -110, -680, -1616, -168, 318, -1603, -1014, -1084, -688, -312, 196, -293, -972, -651, -413, -88, -184, -1191, -757, -554, -85, -585, 4, -620, -823, -475, 18, -736, -8, 29, -360, -964, -1201, -865, -1036, -835, -322, -1212, -1580, -822, -766, -1022, -531, -865, -445, -575, -528, -764, 1302, -110, -779, -943, -254, -1395, -192, 1207, -399, -612, -502, -143, -1249, -634, 631, -1541, -328, -1624, 205, -134, -236, -936, -436, -861, -687, -74, -493, -1174, -235, -67, -388, 238, 150, -725, -137, -98, -1313, 276, -320, 152, -544, 686, -1393, -349, 163, 422, 109, -106, 6, 392, -766, -743, -679, 439, -243, 0, 301, -1092, -567, -638, 148, -989, -915, -284, -19, -774, -11, -382, -25, 808, 283, -761, -1037, -1151, -290, 227, -935, 255, -635, -46, -547, -1283, -1281, -60, -571, -1512, 418, -846, 218, -884, -227, -575, -525, -834, 407, -1996, -186, -995, -677, -364, -546, -600, -861, -524, -109, -1141, -1134, 56, 26, -552, -686, 296, -698, -1185, -38, -298, -1369, -408, -672, -9, -295, 194, -1472, 874, -195, -391, -389, 484, -807, -1219, -87, -1660, -799, -419, -625, -214, -172, -596, -874, -518, -839, -1071, -129, -151, -989, -500, -1394, -437, 353, -786, -1105, -301, -68, -475, -393, -563, -178, -191, 295, -694, -675, 723, -402, 766, -226, -171, -424, -537, 20, 434, 1180, -452, -186, -1040, -595, -990, 503, -509, -1600, 67, -814, -620, -507, -703, -897, -122, -831, -823, -1194, -739, 23, -99, -82, -1212, -51, -746, -1039, 240, -300, -1205, -1076, -242, -835, -2030, -296, -789, -442, -179, -1715, -655, -489, -1363, -28, 5, -80, -441, -971, 548, -542, 444, -1150, -65, 220, -138, -415, -940, -1017, -853, 182, -248, -1050, 419, -435, -1, -329, -44, -368, -790, -1019, 101, 1316, 505, -782, -327, -641, -1145, -687, -545, -631, -839, -251, -1042, -1040, -1109, -352, -231, -84, 859, -316, -369, 702, 164, -608, -561, -803, -179, -814, -1404, -988, -340, 71, -666, 111, 238, -327, -578, -53, 826, -1419, -48, -646, -415, -965, -730, 482, -229, -1018, -193, -463, -448, -822, -716, -1425, -1169, -405, -531, 65, -413, -1204, -1847, -1130, 613, -533, -332, -446, -775, -758, -856, 41, -210, -776, -465, 223, -160, -1086, -252, -420, -461, -686, -817, -609, -311, -648, -391, -50, -568, -283, 845, 74, -32, -1103, 763, -305, -472, -613, -968, -1591, -431, -1083, 53, 52, 418, -462, 253, -456, -250, -1261, 547, -1167, -901, -969, 254, -38, -1025, -449, -1045, -1821, -269, -347, -1023, -60, 392, -501, -1175, -659, -667, -451, -106, -905, -778, -737, -296, -622, -100, -612, -375, -820, -52, -1269, -364, -690, -881, -565, -188, -728, -825, -249, -528, 57, -376, 550, -668, 49, 506, 416, -93, -867, -159, -411, 369, 149, -814, -849, -662, -1686, -423, -296, -494, 44, -605, -329, -1366, 153, -688, -752, -841, -805, 476, -751, -121, -890, -1368, -78, -100, -1199, -841, -567, 486, -619, -100, -1339, -460, -658, -714, -633, 673, -791, -616, 89, -510, -433, 26, -697, -927, -1073, -1216, -419, -760, -1352, -768, 705, -312, -398, -1262, 276, 343, -650, -262, 40, -209, -347, -791, -857, -684, -766, -781, -441, -78, -557, -759, -1944, -175, -855, -880, -330, -1696, -548, -1185, -211, -671, -322, -4, -772, -295, -1844, -136, -1339, 76, -799, -219, 86, -28, -1038, -587, -370, -271, -924, -1061, -596, 46, 464, -25, -937, -757, -591, -1429, -1384, -469, -442, -472, -1074, 94, -396, -322, -366, -879, -594, -234, -230, -113, 581, -708, -1141, -529, 226, 399, -847, 235, -196, 156, 208, -432, -240, -328, -695, -685, -168, -327, 371, 181, -986, -414, -839, -494, -1177, 184, -416, -1571, -530, -367, -690, 322, -480, -988, 281, -387, -687, 159, -1295, -35, -119, -819, -962, -640, -232, 104, -1900, -905, 116, -719, -427, -1035, -1118, -279, -397, -1527, -786, -811, -367, -6, -261, -96, -628, -310, -434, -398, -776, -670, -696, 73, -1921, -289, -517, -137, -1207, -115, -858, -366, -440, -727, -449, -730, -760, };
const TfArray<1, int> tensor_dimension29 = { 1, { 1280 } };
const TfArray<1280, float> quant29_scale = { 1280, { 0.00010818849841598421, 9.9062228400725871e-05, 0.0001237442484125495, 0.00011370432184776291, 0.0001095022089430131, 0.00011233633267693222, 0.00011546030145836994, 0.00013925923849456012, 0.00010041410860139877, 0.0001128752701333724, 9.4698720204178244e-05, 0.00011062764679081738, 0.00010683552682166919, 0.00011138213449157774, 0.00010969465074595064, 0.00011241048196097836, 0.0001239775592694059, 0.00011209600052097812, 9.2623486125376076e-05, 8.8646658696234226e-05, 0.00011224529589526355, 9.895514085656032e-05, 0.00012436576071195304, 0.00012567760131787509, 0.00011964193254243582, 0.00014407745038624853, 0.00013462630158755928, 0.00014611668302677572, 0.00011149270721944049, 0.00011852969328174368, 0.00010744320752564818, 0.00013149036385584623, 9.6351905085612088e-05, 8.5162486357148737e-05, 0.00012926844647154212, 0.00011890196765307337, 0.00011437037755968049, 0.00011739815818145871, 0.00013152994506526738, 9.8674521723296493e-05, 0.00011198715219506994, 9.7190830274485052e-05, 0.00012657571642193943, 0.00010475644376128912, 0.00014375970931723714, 0.00011739431647583842, 9.6597250376362354e-05, 0.00012642350338865072, 0.0001281828444916755, 0.00012055903061991557, 0.00011114987137261778, 9.703820978756994e-05, 0.00014263273624237627, 9.7375857876613736e-05, 0.00012026444164803252, 0.00012485867773648351, 0.00010736459807958454, 9.2538764874916524e-05, 0.00011402454401832074, 8.6657113570254296e-05, 0.00010605872375890613, 8.5807223513256758e-05, 0.00012764534039888531, 0.00011929059837711975, 0.00010319602733943611, 0.00011215695121791214, 0.00013289124763105065, 0.00012335817154962569, 0.00012380555563140661, 0.00010277968976879492, 0.00011569675552891567, 0.00012708033318631351, 0.00010969397408189252, 0.00012125602370360866, 0.00011919611279154196, 0.00013366961502470076, 8.7487424025312066e-05, 9.5865238108672202e-05, 0.00010710431524785236, 9.639297059038654e-05, 0.00012317684013396502, 0.00010749473585747182, 9.8497781436890364e-05, 0.00012351475015748292, 0.00011583148443605751, 8.268436067737639e-05, 0.00011110296327387914, 0.00011077820818172768, 0.00011734415602404624, 0.00012762540427502245, 0.0001289922947762534, 0.00011275137512711808, 0.00010001780174206942, 0.00011016107600880787, 0.00011064191494369879, 0.00011806705151684582, 0.00010059914347948506, 0.00010249119077343494, 0.00010129131987923756, 0.0001220326084876433, 0.00013563019456341863, 0.00013550514995586127, 0.00011693323904182762, 0.00012361463450361043, 9.4683666247874498e-05, 9.3546652351506054e-05, 9.9703465821221471e-05, 0.00011587983317440376, 0.00010648206080077216, 0.00012855813838541508, 0.00011852215538965538, 0.00010196588846156374, 0.00014525570441037416, 9.3581598775926977e-05, 0.00012154802971053869, 0.00012661305663641542, 0.00012731643801089376, 0.00010728291817940772, 0.00011324066144879907, 0.00012890927609987557, 9.4689108664169908e-05, 0.00011374789755791426, 0.00010905176168307662, 0.00010132850729860365, 0.00011327362881274894, 0.00011381503281882033, 0.00010913363803410903, 0.00011986018944298849, 0.00012133466952946037, 0.00011892776092281565, 0.00010575452324701473, 0.00013873286661691964, 0.00012732768664136529, 0.00010210705659119412, 9.9100660008843988e-05, 0.00012273213360458612, 0.00011690021347021684, 0.00011617151176324114, 0.00012344559945631772, 0.00010724733874667436, 0.00010342885798308998, 0.00013273849617689848, 0.00011867255670949817, 0.00011005422129528597, 0.0001040264469338581, 0.00011427477147663012, 9.2427944764494896e-05, 0.00012936546409036964, 0.00012762572441715747, 0.00012315914500504732, 0.00011231622193008661, 0.00012149826216045767, 0.00013177933578845114, 0.00010339650179957971, 9.6886040410026908e-05, 0.00011920878023374826, 0.00011131938663311303, 0.00010557455971138552, 0.00011916366202058271, 8.8695545855443925e-05, 0.00011115165398223326, 0.00012284170952625573, 0.00011276112491032109, 0.00012431465438567102, 0.00014311636914499104, 9.535709978081286e-05, 9.2174777819309384e-05, 0.00012809765757992864, 0.00011526418529683724, 0.00011741566413547844, 0.00012083929323125631, 0.00011478696978883818, 0.00012151757982792333, 0.00011496032675495371, 0.00010648000898072496, 8.8124717876780778e-05, 0.00010589732846710831, 0.00012562115443870425, 0.00011610984074650332, 0.00011408912541810423, 9.7555894171819091e-05, 0.00010258865222567692, 0.00010529436985962093, 0.00012929974764119834, 0.00010614762868499383, 0.00011984310549451038, 0.00010478281183168292, 0.00011366631224518642, 0.00011605171312112361, 0.00010528867278480902, 0.00013983790995553136, 0.00011467029980849475, 9.090927051147446e-05, 8.8027365563903004e-05, 0.00010364520130679011, 0.00011316550808260217, 0.00013231432239990681, 0.00015515887935180217, 9.4678158347960562e-05, 0.00013020796177443117, 0.00010468810069141909, 0.00010753286187537014, 0.00010822078911587596, 0.00011286417429801077, 9.1254471044521779e-05, 0.00010071625001728535, 0.00012601005437318236, 0.00011080846888944507, 0.00010316751286154613, 0.00012723373947665095, 0.00011378578346921131, 0.00011244493362028152, 0.00011848895519506186, 0.00010697276593418792, 0.00013093644520267844, 0.00010279898560838774, 0.00011474253551568836, 0.00010131887393072248, 9.973198757506907e-05, 0.00010241318523185328, 0.0001242015277966857, 0.00010123600804945454, 0.00010404422209830955, 0.00010851501428987831, 0.00012549117673188448, 0.00010089005081681535, 9.1615191195160151e-05, 0.00010547314013820142, 8.5305524407885969e-05, 0.00012823072029277682, 0.00010876204760279506, 0.00012306943244766444, 0.00011822572560049593, 0.00012556863657664508, 0.00011367704428266734, 9.9101809610147029e-05, 0.00010771815868793055, 0.00011756427556974813, 9.4445276772603393e-05, 0.00011181055015185848, 0.00013222159759607166, 0.00010470954293850809, 0.00010054781887447461, 0.00012089966185158119, 0.00010591339378152043, 0.00010405455395812169, 0.00010087789269164205, 0.00010638977255439386, 0.00012755862553603947, 0.00012308808800298721, 0.00011142986477352679, 0.00011474473285488784, 0.00010660415864549577, 9.4702081696595997e-05, 0.00011087777966167778, 0.00011828501737909392, 0.00010866350203286856, 0.00010667330934666097, 0.0001373156119370833, 9.4049653853289783e-05, 9.6144220151472837e-05, 0.00014104798901826143, 0.00010992971510859206, 0.00010648696479620412, 0.00012127460649935529, 0.00010942583321593702, 0.00012298674846533686, 9.807065362110734e-05, 0.00011334134615026414, 0.0001063970776158385, 0.00010034757724497467, 9.4258444732986391e-05, 0.00012732132745441049, 0.00010821980686159804, 0.00010408962407382205, 0.00011242160690017045, 0.00010311331425327808, 8.9977736934088171e-05, 9.3037306214682758e-05, 0.00012070628872606903, 0.00017590034985914826, 0.00012381348642520607, 0.00011074357462348416, 0.0001360097958240658, 0.00010717301483964548, 0.00011146981705678627, 0.0001253190275747329, 0.00010327249765396118, 9.0369452664162964e-05, 0.00012444671301636845, 9.5442061137873679e-05, 0.00010865707736229524, 8.9959088654723018e-05, 0.00010577838111203164, 0.00012405391316860914, 9.0644985903054476e-05, 0.0001067345729097724, 0.00011138492845930159, 0.00011949885083595291, 9.0494693722575903e-05, 0.00013095485337544233, 0.0001311944070039317, 0.00011451679893070832, 0.00011022549006156623, 0.00013755330292042345, 0.00010007471428252757, 0.00011500446271384135, 0.00013750165817327797, 0.00010453884897287935, 0.00011779010674217716, 0.00011576140968827531, 0.0001070270300260745, 9.9069300631526858e-05, 0.00011969220940954983, 0.00012787288869731128, 0.00010160823876503855, 9.2947098892182112e-05, 0.0001119647640734911, 9.3509530415758491e-05, 9.9584976851474494e-05, 0.00012103997869417071, 0.00011579773126868531, 9.7662727057468146e-05, 0.00011342526704538614, 0.00011830090079456568, 0.00011190935038030148, 0.00010698405094444752, 0.00010966478293994442, 0.00013854529242962599, 0.0001262678561033681, 9.2581663921009749e-05, 0.00011016767530236393, 0.00010938930790871382, 0.0001324182958342135, 0.00011428936704760417, 0.0001095081606763415, 0.00011005879787262529, 0.00010956733603961766, 0.00011032713518943638, 0.00011923715646844357, 9.3740483862347901e-05, 0.00010967311391141266, 0.00010566253331489861, 9.5654133474454284e-05, 9.6728639618959278e-05, 9.7552139777690172e-05, 0.00010445902444189414, 0.00010517189366510138, 0.00010916406608885154, 0.0001245976600330323, 0.00011795245518442243, 0.00010933822341030464, 0.00011039155651815236, 0.00011213221296202391, 8.8424400018993765e-05, 8.9558649051468819e-05, 9.7168405773118138e-05, 9.1134104877710342e-05, 9.7742864454630762e-05, 8.65968904690817e-05, 0.00011136622197227553, 0.00011831375741166994, 8.2456543168518692e-05, 0.00011056291259592399, 0.00011208928481210023, 0.00010441998892929405, 0.00011473105405457318, 9.8981479823123664e-05, 0.00013114511966705322, 0.00010638724052114412, 9.5345727459061891e-05, 0.00010422783816466108, 0.00012730967137031257, 0.00011561840074136853, 0.00012288262951187789, 0.0001148248920799233, 0.00010521250806050375, 0.00011821235239040107, 0.00011187155905645341, 9.9237826361786574e-05, 0.00011412439926061779, 0.000122407654998824, 0.00013486627722159028, 0.00010040676716016605, 0.0001164938512374647, 0.00010755783296190202, 0.00011314047151245177, 0.00011665820784401149, 0.0001155188656412065, 0.00010833143460331485, 0.00013745884643867612, 0.0001217065000673756, 0.00012629912816919386, 9.9592580227181315e-05, 0.00013018320896662772, 0.00013191903417464346, 9.9191856861580163e-05, 0.00011411649757064879, 0.00011890778841916472, 0.00012892810627818108, 0.00016256353410426527, 0.00011474222264951095, 0.00013842889165971428, 0.00011260238534305245, 0.00012233518646098673, 9.7612319223117083e-05, 0.00011970713239861652, 9.8241282103117555e-05, 0.00011369930871296674, 9.6098454378079623e-05, 0.00010920531349256635, 9.975207649404183e-05, 0.00011564286978682503, 0.00012701393279712647, 0.00011404969700379297, 0.00013102749653626233, 0.0001220753911184147, 0.00011378875933587551, 0.00012275757035240531, 0.00010155227209907025, 0.00010206305887550116, 0.00010964889952447265, 0.00011930177424801514, 0.00011216034909011796, 0.00011641067249001935, 0.00010916706378338858, 0.00011052263289457187, 0.00011537480168044567, 8.9410452346783131e-05, 0.000103446000139229, 0.00010098751226905733, 0.00010770402877824381, 0.00011187365453224629, 0.00011483080743346363, 0.00010652260243659839, 0.00010640310938470066, 0.00010441528138471767, 0.00010640585969667882, 0.00011983631702605635, 9.6161158580798656e-05, 0.00013351929374039173, 0.00014224406913854182, 0.00010379317245678976, 0.00015331456961575896, 0.00010106291301781312, 0.00011792199802584946, 0.00010476147144800052, 9.0835346782114357e-05, 0.00011179612192790955, 9.7278149041812867e-05, 8.8900946138892323e-05, 0.00012051812518620864, 9.1407993750181049e-05, 0.00010796637798193842, 0.00011549058399396017, 0.00012690592848230153, 9.1289686679374427e-05, 0.00012446042092051357, 0.00013030532863922417, 0.00010917396139120683, 0.00010390969691798091, 0.00010777053103083745, 0.00014518275565933436, 0.00012629851698875427, 0.00010909470438491553, 0.00010832461703103036, 9.8478951258584857e-05, 0.00011916871153516695, 0.00011390527652110904, 9.715395572129637e-05, 0.00011510480544529855, 0.00010941996151814237, 0.00010355869017075747, 0.00012036982661811635, 0.00011171751975780353, 0.00011472772166598588, 0.00013242012937553227, 9.8027820058632642e-05, 9.4477283710148185e-05, 0.00013084954116493464, 0.00010446534724906087, 0.00010339808068238199, 9.5542134658899158e-05, 9.1680412879213691e-05, 9.0668043412733823e-05, 0.00010203073907177895, 0.0001197413876070641, 0.00016158382641151547, 0.00016871925618033856, 0.00011494935461087152, 0.00013589480658993125, 0.00010325625771656632, 0.00010001012560678646, 0.00011107351747341454, 0.00012354558566585183, 0.00014919006207492203, 0.00011444068513810635, 9.4781637017149478e-05, 0.00013427170051727444, 9.7591910162009299e-05, 9.3793903943151236e-05, 0.00010007179662352428, 0.00014051006291992962, 0.00010129982547368854, 9.2516842414624989e-05, 9.4002214609645307e-05, 0.00011513190838741139, 0.00010993157775374129, 0.00013146406854502857, 0.00013540254440158606, 0.00010663154534995556, 9.3629118055105209e-05, 0.00010478353942744434, 0.00010394228593213484, 0.00011343551886966452, 8.8432869233656675e-05, 8.0549820268061012e-05, 0.00013726096949540079, 0.00010439629113534465, 0.00011257144069531932, 0.00010123963875230402, 0.00010363755427533761, 0.0001116524072131142, 0.00010672005009837449, 0.00010852888226509094, 8.8313456217292696e-05, 8.7785832874942571e-05, 0.00011145827738801017, 9.4950846687424928e-05, 0.00012943304318469018, 0.00013017999299336225, 0.0001019555566017516, 0.00011113345681224018, 0.00012756130308844149, 0.00012235919712111354, 0.00010468959953868762, 0.00013310914800968021, 0.00011728338722605258, 0.00012270326260477304, 0.00010516809561522678, 0.00011002254177583382, 0.00010168589506065473, 0.00010892840509768575, 0.00013746840704698116, 0.00010061020293505862, 0.00010892788850469515, 0.00010242033749818802, 0.00010288659541402012, 0.00010386195208411664, 9.8154625447932631e-05, 0.0001180328254122287, 9.9461489298846573e-05, 0.00013696255336981267, 0.00012718039215542376, 0.00013313764065969735, 9.7263633506372571e-05, 0.00011393005115678534, 9.6185365691781044e-05, 0.00012412625073920935, 8.8253516878467053e-05, 0.00010414618736831471, 0.00010546993144089356, 0.00010299689893145114, 0.00010130207374459133, 0.00010781244782265276, 0.00012005140160908923, 0.00013737790868617594, 0.00011841324885608628, 9.2244627012405545e-05, 0.00012214775779284537, 0.00011003895633621141, 0.00010252049105474725, 0.00011666427599266171, 0.00010500403732294217, 9.7929761977866292e-05, 0.00012476775737013668, 0.00011353669106028974, 0.00010234866931568831, 0.00015690042346250266, 0.00011398540664231405, 0.00010140848462469876, 9.8178184998687357e-05, 0.00011545165762072429, 0.000122096884297207, 9.2477603175211698e-05, 0.00010983445827150717, 9.8204669484402984e-05, 0.00011253441334702075, 9.5721501566004008e-05, 0.00010023031063610688, 0.00013069681881461293, 0.00012702606909442693, 0.00015740838716737926, 0.00013252273492980748, 0.00012788866297341883, 0.0001184020220534876, 0.00012734101619571447, 0.00011555280798347667, 9.1412141046021134e-05, 0.00010273396037518978, 8.2775521150324494e-05, 0.00011326646927045658, 0.00010041638597613201, 0.0001133008991018869, 0.00012018308916594833, 0.00011001262464560568, 0.00012021025759167969, 0.00013209592725615948, 0.00010003766510635614, 0.00011732292477972806, 0.00012325074931140989, 9.9891331046819687e-05, 0.00011284500942565501, 8.8205219071824104e-05, 0.00011586313485167921, 0.00010354150435887277, 0.00011337311298120767, 0.00010583886614767835, 0.00011530095798661932, 0.00015012107905931771, 0.00011076172813773155, 0.00014080612163525075, 0.00010170199675485492, 0.00012132927076891065, 0.00012932754179928452, 0.00010186724830418825, 0.00011402064410503954, 0.00011945004371227697, 0.00010953126911772415, 0.00012828495528083295, 0.00012371840421110392, 0.00010904917871812358, 9.4145842012949288e-05, 8.823617099551484e-05, 0.00012019729183521122, 0.00013736818800680339, 0.00010402925545349717, 0.00010527843551244587, 0.00013583437248598784, 0.00010910200217040256, 0.00010868914250750095, 9.4737719336990267e-05, 0.0001193405405501835, 9.5923373010009527e-05, 0.00011063813144573942, 0.00012142130435677245, 0.000103568090707995, 9.7630872915033251e-05, 9.9342723842710257e-05, 0.00012590090045705438, 0.00011700118193402886, 9.9425393273122609e-05, 0.0001111994351958856, 0.00011274899588897824, 0.0001117112988140434, 0.00010004987416323274, 0.00011804028326878324, 0.00010419863247079775, 0.00011817624181276187, 9.6186173323076218e-05, 9.8458134743850678e-05, 0.0001268460473511368, 9.5934810815379024e-05, 9.9845725344493985e-05, 0.00010296798427589238, 9.8132921266369522e-05, 9.6717056294437498e-05, 9.3170470790937543e-05, 0.00011430186714278534, 8.6141742940526456e-05, 9.5832605438772589e-05, 0.00010981086961692199, 9.9987926660105586e-05, 0.00010724573076004162, 0.00012169638648629189, 9.4847542641218752e-05, 0.00011512359924381599, 8.8488282926846296e-05, 0.00010314808605471626, 0.00010564229887677357, 0.00010222628770861775, 0.00012558876187540591, 9.0475288743618876e-05, 9.6018011390697211e-05, 9.6312309324275702e-05, 9.0944835392292589e-05, 0.00012187427637400106, 0.00012199384946143255, 9.9995893833693117e-05, 0.00010039531480288133, 0.00013878777099307626, 0.00011658539006020874, 0.00011142142466269433, 0.00010084372479468584, 9.0882400400005281e-05, 0.00011522560089360923, 0.00010977379861287773, 0.00013360075536184013, 0.00011171972437296063, 0.0001060119247995317, 0.00010301855218131095, 0.00011273502605035901, 0.0001122418834711425, 9.9812918051611632e-05, 0.00015083405014593154, 9.596767631592229e-05, 0.00010583029506960884, 9.7467651357874274e-05, 0.00010345247574150562, 0.00013762469461653382, 0.00013269399642013013, 0.00015223934315145016, 0.00010082304652314633, 0.0001037053152685985, 0.00010157414362765849, 0.00012313252955209464, 9.7478157840669155e-05, 0.00011602746963035315, 0.00013269908959046006, 9.3729140644427389e-05, 0.00015255177277140319, 9.8304495622869581e-05, 0.00010174467752221972, 0.0001004007863230072, 0.00013284778106026351, 0.00011823004751931876, 9.0487585111986846e-05, 0.00011918319069081917, 0.00011314508446957916, 0.0001066771219484508, 0.00011147191253257915, 9.5609029813203961e-05, 0.00012965344649273902, 0.00011238996376050636, 0.00011844391701743007, 0.00011417767382226884, 0.0001030945495585911, 0.00010526712867431343, 0.00010982280946336687, 8.8930450147017837e-05, 0.00011507781164254993, 0.000128429543110542, 0.00010201097029494122, 0.00011010131856892258, 0.00010408827802166343, 0.00011641270248219371, 9.7219133749604225e-05, 0.00010367624054197222, 0.00012287957360967994, 9.1253386926837265e-05, 0.00013177230721339583, 9.8964148492086679e-05, 0.00011139542039018124, 9.2326634330675006e-05, 8.98984435480088e-05, 0.00010341107554268092, 0.00013405797653831542, 0.0001026380923576653, 9.0884197561535984e-05, 0.00010645078145898879, 0.00013619444507639855, 0.00013413488341029733, 0.00010536203626543283, 9.8686017736326903e-05, 0.00012297519424464554, 0.00012444048479665071, 0.0001066762488335371, 0.00012862916628364474, 0.00010958686470985413, 0.00012083885667379946, 0.00012215363676659763, 9.3013703008182347e-05, 0.00010679497790988535, 0.00010626018774928525, 0.00010524550452828407, 8.9005668996833265e-05, 0.00011358661140548065, 9.3780094175599515e-05, 9.765208960743621e-05, 0.00011238202569074929, 0.00010456328891450539, 0.00013962812954559922, 0.00012857510591857135, 0.00010000494512496516, 0.0001322830212302506, 0.00010421044135000557, 9.5843795861583203e-05, 0.00012307272118050605, 0.00012103866902180016, 0.00010807078069774434, 0.00011525565787451342, 0.00010541770461713895, 0.00012764622806571424, 0.00010176492651225999, 0.00014591719082091004, 0.00010118346835952252, 9.03343825484626e-05, 0.00010549174476182088, 0.00013666109589394182, 9.9291428341530263e-05, 0.00014262624608818442, 0.00010740193101810291, 0.00011045941209886223, 0.000104494858533144, 0.00010615080827847123, 0.00011673681001411751, 8.1112193583976477e-05, 0.00011134160740766674, 0.00012256970512680709, 0.00010453989671077579, 0.00012474143295548856, 9.4864568382035941e-05, 0.00010796485730679706, 0.00010783634206745774, 0.0001072443337761797, 9.9701137514784932e-05, 0.00011187100608367473, 0.0001154386336565949, 9.6388102974742651e-05, 9.6903590019792318e-05, 0.00010259450937155634, 0.0001031899155350402, 9.6701871370896697e-05, 0.00010060211934614927, 0.00012088116636732593, 0.00012113986304029822, 0.00012634768791031092, 8.3549268310889602e-05, 0.00011143759184051305, 0.00012748442532029003, 0.00013235720689408481, 0.0001241849095094949, 0.00011245700443396345, 0.00012735955533571541, 0.00011222904868191108, 0.00011223115143366158, 0.00010808566730702296, 0.00011114210792584345, 9.7737887699622661e-05, 0.00010245484736515209, 0.00010279367415932938, 0.00012031225924147293, 0.00010313094389857724, 0.00012902646267320961, 9.4086281023919582e-05, 9.2706795840058476e-05, 0.0001033800799632445, 9.2858048446942121e-05, 0.00010003102215705439, 0.00010730983922258019, 0.00012717314530164003, 0.00010909270349657163, 0.00010112787276739255, 0.00010748437489382923, 9.6167314040940255e-05, 9.6085779659915715e-05, 0.00010405684588477015, 0.00010659326653694734, 0.00011994133092230186, 0.00011639305739663541, 0.0001228231267305091, 0.00010397252481197938, 0.00011420193914091215, 9.9855475127696991e-05, 0.00010708975605666637, 9.6154988568741828e-05, 0.00015138117305468768, 8.5070510976947844e-05, 0.0001093795508495532, 0.00011412960157031193, 0.00010507680417504162, 0.0001176338191726245, 0.00012361077824607491, 9.1772380983456969e-05, 0.00015165971126407385, 0.00011639615695457906, 9.6258379926439375e-05, 0.00010592832404654473, 0.00013471237616613507, 9.9753058748319745e-05, 9.731149475555867e-05, 0.0001167178779724054, 0.00010157363431062549, 9.911619417835027e-05, 0.0001233498624060303, 9.7726064268499613e-05, 0.0001113556427299045, 0.00010604894487187266, 0.000111246838059742, 0.00010422382911201566, 0.00010016460146289319, 8.543292642571032e-05, 0.00011383564560674131, 0.00014727463712915778, 9.6894524176605046e-05, 0.00010889751865761355, 0.00010060826025437564, 0.00011075870861532167, 0.00011226955393794924, 0.00015174069267231971, 0.00012479872384574264, 9.1142130258958787e-05, 0.00010346334602218121, 0.00010327233758289367, 8.542388241039589e-05, 0.0001203390711452812, 0.0001325560879195109, 0.00011356188042555004, 0.0001131696262746118, 0.00012455346586648375, 0.00017400362412445247, 0.00010320176079403609, 0.0001078487912309356, 0.00010688819020288065, 0.00010876608575927094, 0.00010697022662498057, 0.00013678680988959968, 0.00011012107279384509, 0.00010579937952570617, 0.00010496842151042074, 0.00013643513375427574, 9.5497816801071167e-05, 0.00011185340554220602, 0.00010408719390397891, 0.00011520255065988749, 0.00011238893785048276, 0.00012054815306328237, 0.00010901143832597882, 0.00010134108742931858, 0.00010120442311745137, 0.00010839227616088465, 0.00010357171413488686, 0.00011552243086043745, 9.2891008534934372e-05, 9.2420152213890105e-05, 0.0001010237101581879, 0.00011625893966993317, 9.1063979198224843e-05, 0.00010320429282728583, 9.4037546659819782e-05, 0.00011018219083780423, 0.00012817734386771917, 0.00010424773063277826, 0.00012465121108107269, 0.00010069713607663289, 0.00010306334297638386, 9.4176910351961851e-05, 0.00012288861034903675, 0.00010599925008136779, 0.00010328823555028066, 0.00013466009113471955, 0.00011511349293868989, 9.4442744739353657e-05, 0.00011873697803821415, 0.00010698160622268915, 0.0001027518228511326, 9.226030670106411e-05, 0.00011133713269373402, 0.00013849415699951351, 9.6851588750723749e-05, 0.00013050864799879491, 0.0001069638310582377, 0.00010780960292322561, 0.00011326318781357259, 0.00010210824257228523, 0.00011103134602308273, 9.6381147159263492e-05, 9.128190140472725e-05, 0.00013182258408050984, 0.00011787917901528999, 0.0001178976526716724, 0.00010527246922720224, 8.1140125985257328e-05, 0.00010379496234236285, 0.00011723966599674895, 9.0275265392847359e-05, 0.00011436235945438966, 8.3583137893583626e-05, 9.860211139312014e-05, 0.00010182717232964933, 0.00013109363499097526, 9.8556680313777179e-05, 0.00010644362919265404, 0.00011307736713206396, 0.00011675284622469917, 0.00010890656994888559, 0.00010987692803610116, 0.0001208416506415233, 0.00010500463395146653, 9.9487449915613979e-05, 9.2451628006529063e-05, 0.00011490293400129303, 0.0001096698033506982, 0.00010541310621192679, 0.00012363368296064436, 0.00010374710836913437, 0.00013705775199923664, 0.00010475629824213684, 0.00010296021355316043, 0.0001133614860009402, 0.00012451469956431538, 0.00014138365804683417, 0.00012821743439417332, 0.00013067296822555363, 0.00011515292135300115, 0.00011143655865453184, 0.0001313397369813174, 0.00012938314466737211, 9.049133223015815e-05, 0.00011386834376025945, 0.00011354689922882244, 9.5106195658445358e-05, 9.0174959041178226e-05, 9.4458140665665269e-05, 0.00010569015285000205, 0.0001002798235276714, 0.00011202549649169669, 0.00010981565719703212, 0.00012191321729915217, 0.00014641587040387094, 0.00015860804705880582, 0.00010818744340213016, 0.00013360295270103961, 0.00010839197057066485, 0.00011808014096459374, 0.00010866659431485459, 0.0001041585928760469, 0.00010876043961616233, 0.00014679916785098612, 0.00012997940939385444, 0.00010259919508825988, 0.00011627443745965138, 0.00010640855180099607, 9.9238568509463221e-05, 0.00010317684063920751, 0.00011419539077905938, 9.5356212113983929e-05, 9.3549366283696145e-05, 0.00013346693594940007, 0.00013292882067617029, 0.00010244503209833056, 0.00013571137969847769, 0.0001112077952711843, 0.00012198490730952471, 9.950468665920198e-05, 0.00011725674266926944, 8.3194128819741309e-05, 0.00012749458255711943, 0.00010573402687441558, 0.00010296812251908705, 0.00010566305718384683, 0.00011832376912934706, 0.00012799348041880876, 0.00013051462883595377, 0.00013808677613269538, 9.633300214773044e-05, 0.00013202891568653286, 0.00010332140664104372, 9.9072232842445374e-05, 0.00012404826702550054, 0.00016424311615992337, 0.00012243364471942186, 0.00012743806291837245, 9.4697308668401092e-05, 9.3322792963590473e-05, 0.00011700168397510424, 0.00010688771726563573, 0.00010239227412967011, 0.00010647924500517547, 0.00010173842019867152, 0.00011945430014748126, 0.00010266210301779211, 0.00010204232967225835, 0.00012683925160672516, 0.00015623762737959623, 0.00010221064439974725, 0.00013154894986655563, 9.460439468966797e-05, 0.00011877380893565714, 9.3514965556096286e-05, 0.00012483056343626231, 8.6363310401793569e-05, 0.00014383211964741349, 9.806708840187639e-05, 9.7346288384869695e-05, 0.00012361750123091042, 0.000117780378786847, 0.00010082591325044632, 0.00010157076030736789, 0.00012948090443387628, 0.00013341943849809468, 0.00012544615310616791, 0.0001226769236382097, 0.00011628885840764269, 0.00012364768190309405, 9.9742021120619029e-05, 0.00011395243200240657, 0.00011926911247428507, 0.00011124845332233235, 0.00013525135000236332, 8.2607439253479242e-05, 0.00013923749793320894, 0.00010841975745279342, 0.00011490680481074378, 0.00013162998948246241, 0.00011388200800865889, 0.00011424884723965079, 0.00010632883640937507, 0.00012558534217532724, 0.00011914639617316425, 9.248306741937995e-05, 0.00011696583533193916, 0.00010300744906999171, 0.00011000672384398058, 0.00011655895650619641, 0.00010199461394222453, 0.00010368337825639173, 9.701392991701141e-05, 9.8537668236531317e-05, 0.00010662005661288276, 0.00010335915430914611, 0.00011537943646544591, 0.00010105764522450045, 0.00013076483446639031, 0.00012357864761725068, 0.00011191025987500325, 0.00012007078476017341, 0.0001066953336703591, 0.00014696113066747785, 9.729161683935672e-05, 0.00015896699915174395, 0.00010376271529821679, 0.00015028647612780333, 0.00010839359310921282, 0.00010461603960720822, 0.00010885243682423607, 0.0001120933739002794, 0.00010876905434997752, 0.00012281774252187461, 0.00013357801071833819, 0.00012488075299188495, 0.00011550071940291673, 0.00015333443298004568, 9.8943855846300721e-05, 0.00011644351616268978, 0.00010878897592192516, 0.00011519325198605657, 0.00010295459651388228, 0.00010640903929015622, 8.9511369878891855e-05, 0.00010255520464852452, 8.8687578681856394e-05, 9.524963388685137e-05, 9.5242401584982872e-05, 0.00011001182429026812, 9.7838033980224282e-05, 0.00013324586325325072, 0.00012086366768926382, 0.00013312118244357407, 0.00012770673492923379, 0.00013400104944594204, 9.4786351837683469e-05, 0.00010842154733836651, 0.00010679044498829171, 9.9043376394547522e-05, 0.0001359026791760698, 9.3629882030654699e-05, 9.9122546089347452e-05, 0.000109695247374475, 0.00010678541730158031, 0.00013229105388745666, 0.00012464469182305038, 0.00010959358041873202, 0.00011847120913444087, 0.00011149361671414226, 0.00012215923925396055, 9.7590673249214888e-05, 0.00011533060023793951, 9.3753995315637439e-05, 0.0001055867105606012, 0.00013197284715715796, 9.2495844000950456e-05, 9.7084805020131171e-05, 0.0001005234444164671, 0.00012150116526754573, 0.00012335144856479019, 0.00011098515096819028, 9.9564131232909858e-05, 0.00012025460455333814, 8.3614941104315221e-05, 0.00014416121121030301, 0.00011984287993982434, 9.4083196017891169e-05, 9.6732175734359771e-05, 0.00014263781486079097, 0.00010648457100614905, 0.00010768264473881572, 9.2094189312774688e-05, 0.00011695044668158516, 0.00012739669182337821, 0.00013002513151150197, 0.00010134030890185386, 7.6640091720037162e-05, 9.2799142294097692e-05, 9.52871487243101e-05, 0.00015054515097290277, 9.8794400400947779e-05, 0.00012470025103539228, 0.00010350324009777978, 0.00010008922981796786, 0.00010019908950198442, 9.0912639279849827e-05, 0.00010795980779221281, 0.00011313321010675281, 9.7488693427294493e-05, 0.0001018721450236626, 0.00010498223127797246, 0.00011182866001036018, 0.00011284520587651059, 9.2166410468053073e-05, 0.00010843128256965429, 0.00010951651347568259, 0.00013879069592803717, 0.00010191376350121573, 0.00012519332813099027, 0.00011474341590655968, 0.00013063631195109338, 0.00014137370453681797, 0.00017041384126059711, 0.0001195980585180223, 0.00010922810906777158, 0.00010399430902907625, 0.00014294568973127753, 8.4282211901154369e-05, 0.00012233566667418927, 0.00010056386236101389, 0.00010311548976460472, 0.0001391883852193132, 0.00011145621101604775, 0.00012321204121690243, 0.00010170744644710794, 9.347246668767184e-05, 0.00012195213639643043, 0.000111674155050423, 0.00013367450446821749, 0.00011548666225280613, 0.00012692691234406084, 0.00010888920951401815, 0.00010783582547446713, 9.0177876700181514e-05, 0.00011004888074239716, 0.00011172322410857305, 9.5676710770931095e-05, 0.00010268439655192196, 0.00012442505976650864, 0.00011370612628525123, 0.00010518304043216631, 0.00012615363812074065, 0.00010905692033702508, 0.00010487958206795156, 0.00011032571637770161, 0.00010729393397923559, 0.00011311090929666534, 0.00011009555601049215, 0.00010862825729418546, 0.00011354170419508591, 0.00012038287968607619, 9.8137898021377623e-05, 0.00010975652548950166, 0.00010319676221115515, 9.6558229415677488e-05, 0.00012132224219385535, 9.6887109975796193e-05, 0.00010384898632764816, 0.00011386929691070691, 0.00010439600009704009, 0.00010479820048203692, 9.3443093646783382e-05, 0.00010030889825429767, 0.00013117972412146628, } };
const TfArray<1280, int> quant29_zero = { 1280, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant29 = { (TfLiteFloatArray*)&quant29_scale, (TfLiteIntArray*)&quant29_zero, 0 };
const ALIGN(8) int8_t tensor_data30[16*1280] = { 
  8, -7, 28, 11, 15, -56, -47, 61, -45, 48, 4, -30, 0, 56, 34, 55, -11, -25, -23, 21, -67, 43, -53, -38, -58, -25, 59, 46, -35, -66, 32, -20, 18, 16, 46, 41, 10, -35, -1, -18, -23, -66, -56, -16, -25, -59, 11, 5, 49, 61, -59, -40, -4, -46, 55, 10, 29, -22, -50, 50, 37, 59, 0, 15, -46, -44, 47, -29, 14, 14, -35, 3, -11, -12, 4, 46, -48, -66, -14, 32, -56, 22, -29, 15, 57, 47, -41, -25, 34, -55, -13, -4, -47, -58, 54, -34, -62, -16, 58, 23, -51, 59, 8, 38, -17, -25, 41, -58, -2, 33, 25, 5, -41, 21, -52, 49, -4, -26, 16, -33, -12, 23, 45, -16, 20, -4, -66, 32, 35, -10, -68, 18, -59, 34, 34, -25, 26, -2, -48, -34, -6, 38, 60, 6, -33, 39, 17, -6, -24, 23, 65, -47, -30, 41, -35, -33, -21, -55, -8, -30, -63, -19, 33, 10, 35, -6, 16, -58, -25, 47, -40, -38, -33, 0, -32, -63, 11, 58, 21, -50, 15, 48, 33, -60, -54, 28, -49, 10, -30, 41, 25, -56, 45, -20, 1, 35, -52, -7, -5, 15, -58, -64, 19, 51, -41, 51, -28, -58, -27, -60, -6, -59, -14, -19, -31, -6, -29, -57, 26, -62, 18, -28, 38, -54, -24, 15, 29, 41, 46, -42, 24, -9, 6, 27, 16, 48, 43, -8, -16, -37, -62, -34, -57, -11, -29, 36, 27, 20, -32, -20, -61, 46, -6, -67, -18, 29, 57, -21, 54, -44, 40, 37, -48, -17, 23, 55, -12, -2, 46, -6, -12, 29, -16, -32, -54, -17, 26, -24, 13, -51, 7, 11, 27, 11, 0, -13, 39, 43, 24, -42, 5, -68, 39, 12, -10, -14, -9, 22, 53, 20, 34, -63, -9, -56, 54, -6, 46, 33, -38, 36, 24, -20, 39, 33, -38, 7, -51, 17, -54, -48, 39, 20, 7, -23, -16, -61, -64, 57, 15, -54, 28, -69, 56, 38, -13, -17, -55, 58, -5, 2, 43, 24, 14, 45, 18, -61, 21, -38, 63, -39, 42, -15, -25, 2, -5, 48, 2, 25, 7, -38, 42, -61, 67, 10, -11, 16, -42, -51, 22, -34, -5, -62, 4, -11, -8, -35, 20, 24, 3, 34, -34, 9, 29, 50, -38, -22, 9, -21, -56, -51, 41, -66, 55, -64, -18, 63, 38, -35, 5, -55, 54, 25, 47, -20, 28, 14, -55, 2, -58, -59, -39, 3, 4, 36, 44, -4, 25, -12, -46, 12, 54, 56, 18, -22, -38, 56, -41, 49, 39, 13, -31, 20, -3, 17, -33, 18, -35, -54, 33, 22, -41, 4, 33, 56, -58, -54, -17, -52, 54, -61, 31, 9, 43, 53, 36, 54, 1, 46, -31, 46, 29, 39, -10, 0, -50, -13, -21, 38, 23, 4, -31, -41, -57, -57, -54, -57, -33, -48, 9, -9, -41, -60, -15, -49, -3, -54, -56, 65, -38, 10, -62, -60, -49, -37, 59, -40, 5, -4, -13, -11, -60, 57, -15, 22, -19, 21, -14, -13, -26, -53, -54, 20, 3, -64, -17, -55, -4, 17, -3, -59, 7, -57, -61, 13, -52, 8, -27, 31, 50, -33, -10, -42, 29, -16, 20, 34, 20, 34, -64, 38, 37, -36, -34, 17, -56, -64, 33, 9, -36, 32, 34, -62, 16, -2, 35, 26, 41, -5, -60, 21, -3, 55, 39, 17, 32, 60, -2, -34, -38, 56, -46, -37, -35, -38, 11, -45, -32, 28, 4, 60, 40, -65, 41, 3, 7, -53, 43, 45, -4, 48, -14, -5, 28, 19, -45, -49, 29, -4, 22, -37, 64, 24, -39, -19, -18, -50, -36, 40, 45, -4, 27, 7, -11, 60, 48, 21, -10, -21, -6, 6, -16, -53, 35, -31, -41, -40, 8, -61, -31, 60, -64, -41, 23, 16, -28, -47, 42, -7, 35, -37, -46, -34, 11, -44, -27, 30, 8, -45, -2, -60, 14, 50, 52, -52, -35, -61, -39, 17, 47, -32, -4, 12, -39, 43, 53, 4, 1, -18, -12, 24, -28, 7, 36, -59, -65, -13, -33, -68, -62, 37, 48, 3, -13, -52, 52, -30, -57, -27, -6, -30, -34, -5, -47, 49, 44, -36, -36, 16, -51, -43, -25, -21, 57, -32, 18, -53, -37, -52, -58, -27, 37, -11, -21, -43, -2, 24, 18, 37, 58, 20, 26, -28, -36, -6, -20, -14, 41, -11, 4, -4, -34, 19, -61, -51, -37, -45, 30, -30, 8, -62, 8, -45, -2, -38, 27, -27, 55, 9, -15, 28, 18, -1, 30, 11, -47, -56, 8, 43, -34, -32, 58, 66, -41, 35, -66, 8, -5, 37, -23, -10, -31, 37, 40, -31, -62, 43, -5, -60, -4, -52, 25, 26, -17, -19, -9, 19, 48, 11, 33, 9, -51, 26, -25, 36, -5, 45, 46, 55, -30, -61, 33, -33, -28, 12, 39, 8, -30, -54, 18, 62, 53, 5, 35, 22, -35, -12, -11, 31, 10, 35, 41, 57, -35, 12, 9, -5, -7, -4, 51, 15, -35, 61, -49, 11, -48, 59, -22, 40, -20, 57, -49, -38, 34, -38, 7, -34, 50, 51, 6, 9, 55, 58, -60, 33, 59, -34, -55, -3, -49, -34, -46, -44, -57, 25, 47, 17, -32, 60, 57, -22, -67, -13, -29, -32, 7, -51, -12, 32, -47, 51, 14, -20, 20, -11, -1, -47, -59, -11, -19, -31, 38, 24, -38, 27, -38, 9, 17, 56, 9, -12, 47, -57, 37, 26, 51, 37, 30, -53, -51, 14, 34, 49, -2, -7, 14, -34, -28, 60, -43, 1, -53, 35, -22, -37, 12, -4, 56, 23, -62, 16, 64, 38, -2, -56, 22, 53, 38, 23, 3, -12, -64, -3, -60, 13, -30, 0, 13, 25, -30, -58, 42, 31, 48, 3, -55, 55, 41, -9, -36, 59, -11, 25, 19, 31, 36, -32, 5, -39, -53, -4, 19, 42, -5, 57, 5, 43, -9, 22, -62, 0, -5, -13, -64, -49, -19, 5, 36, 10, 20, 36, -41, 60, 15, 7, -37, 51, -46, 26, -25, 46, -22, -34, 53, 34, -32, -23, 50, 46, 24, 30, 48, -15, 37, 61, 10, 39, -53, -43, -32, -34, 17, -1, 33, 8, 30, -42, 51, 50, 60, -4, 46, 37, 38, -51, 50, -20, 29, -31, -54, 21, -57, -31, 50, -8, -19, -47, 40, 47, -14, -19, 54, -12, 1, -53, -4, -29, 16, 38, 60, -65, -7, -23, -36, 52, -57, -37, 3, 6, 24, -8, -66, -61, 5, 15, -54, -39, -15, 18, -46, 21, -42, -16, 18, 27, 18, 36, 38, -17, 36, 47, 20, -51, -44, 7, -8, 48, 35, 6, 54, 21, -50, -60, -38, 52, 50, -16, -12, -15, -14, -64, 5, 9, 6, -11, -13, -65, -11, -49, 30, 29, -53, 12, -3, -54, -1, -35, -24, -49, -27, -3, -10, 25, -63, -24, -18, 30, -31, -20, -54, -29, -64, 33, -30, 27, 21, 34, 50, -36, 56, 35, -21, 46, -40, 56, -23, -61, 8, -4, -70, 5, 14, -56, -46, -15, -34, 48, 8, -62, -54, 20, -15, 47, -29, 49, 33, -48, -25, -20, 38, -26, 19, 57, 18, -13, -22, -40, 9, 11, -27, -2, -42, -39, -52, -40, -39, 16, -25, 49, -16, 33, -34, 13, -51, -40, 10, 26, 57, 58, -1, -53, -28, 57, 2, -8, -6, -5, 54, -66, 14, 35, 21, 35, -37, -50, -66, 55, -3, 21, 49, 15, 55, -66, 55, 10, 46, -4, -37, 44, -45, 21, 49, -7, 58, -33, 49, -28, -29, -54, -18, -18, -39, -55, 15, 46, 35, -64, -58, -64, 7, -55, -8, 24, -20, -10, -61, -25, 21, -65, -38, -39, -53, -10, -29, 40, 45, -45, -9, 0, -45, 34, 
  46, -21, -8, 40, 31, -63, 23, -33, 30, -2, -28, 7, 20, -10, 63, 65, 26, 18, 21, -12, -42, 54, 45, -4, -66, -4, -42, 59, 15, 32, -25, -10, -12, 8, -3, 41, 15, -3, -18, 35, 30, -18, 28, 0, -45, -26, -49, 0, -1, -56, 12, 31, -13, -18, -50, -34, 60, -7, 11, 22, -12, 22, -25, -47, -27, 38, -42, -16, -21, -27, -48, 33, 18, 42, -33, -30, -3, -4, -3, 19, 6, -26, 75, 67, -9, -16, 21, -34, 23, 73, 7, 21, -30, -44, 29, -41, 45, 20, -82, -49, 7, -13, -26, -51, -23, -42, -70, 17, -46, 38, -74, 10, 27, -45, 16, 59, 76, -26, 11, -57, 29, 20, -40, 61, -12, 40, 1, 31, 61, -16, -2, 11, -7, -56, 36, 32, 54, -39, 62, -35, 8, 25, 66, -24, 10, -22, 19, -16, 31, 13, 41, 21, 61, -73, -63, -55, 65, 77, -18, -56, -42, -39, 70, -1, -44, 59, 53, -20, 4, 32, 17, 30, -82, -6, -1, 53, -40, 25, -31, 60, 51, -32, -4, 53, -40, -51, 28, -63, 30, 44, 0, -11, 12, -15, 28, 89, 12, -62, -16, -18, -4, -28, -3, 17, -49, -35, -28, 50, -48, -27, -44, 5, -33, -11, -37, 58, 11, -55, 13, 18, 12, 59, -27, -35, -65, -48, 59, 67, -7, 76, 54, -6, 63, 5, 46, 12, 34, 14, -8, -47, -41, 52, 1, -41, -40, 28, 12, -30, -27, 33, -18, -26, -53, -26, -51, -11, -49, -47, 6, 65, 47, -61, 74, -49, -22, -26, 55, 55, 14, -16, -39, 60, -56, -51, -13, 27, -24, -2, 6, -47, 27, -47, 34, -4, 6, -10, -38, 30, -11, 73, 57, 48, 26, 8, -19, -51, 10, -8, 16, 45, -35, -14, -50, 35, 46, -14, -30, 0, -17, -11, -34, 51, -48, 16, -11, 70, -71, 25, 38, -20, 12, 35, 14, -41, 65, 39, -77, -66, -20, -38, -56, 11, 58, 42, -58, 41, -36, 39, 14, 16, -26, -48, 0, -48, -16, -53, -8, 43, 41, -36, -14, 68, -46, 5, 57, 55, 1, 17, 24, -41, 13, -3, -35, 87, 39, -26, -4, -50, -31, 5, -45, -66, -14, -34, 13, 66, -70, 52, 28, -56, -57, 32, 47, -45, 43, 60, 52, 74, -34, 10, 15, 73, -15, -34, -26, 84, 68, 50, -68, -59, 40, -9, 46, 16, 52, -4, 9, 29, 61, -52, -4, 52, -40, -54, -32, -29, -36, -13, -11, -47, 32, 81, 32, 27, 0, 38, 14, -24, -42, -37, 35, -15, -25, 43, 17, 56, 30, -32, 72, 65, 62, -76, 18, 18, 26, 55, -38, 53, 3, -3, -51, -1, 58, 13, 47, 32, 35, 40, -19, -5, -65, 70, -18, 52, 41, -2, 20, -61, -46, 14, 38, -38, 36, -11, -26, -65, -12, -44, -10, -14, 66, -2, 0, 74, 18, -37, 33, 1, -76, 58, 43, -2, -4, 18, 36, 79, 1, -70, 33, 61, 27, -21, 12, 16, 19, -39, -13, 30, 40, -21, 35, 12, 72, 47, 47, -18, -37, -35, -29, -11, -34, 79, -38, 20, 45, -45, 24, -52, 51, -8, 7, -50, 36, 5, 28, 4, -56, 40, 14, -31, -13, 12, 15, 44, 44, 20, -42, 12, -22, -27, 16, -2, 78, 24, -24, -50, -22, -76, -12, 27, -40, 22, -65, -43, -64, 55, -32, -34, 77, 73, 40, -44, 56, -15, -11, 48, -68, -64, -67, 19, 6, 29, -11, -14, 2, 22, 31, -53, 20, 46, 23, 21, 16, -49, 36, -37, 48, -5, 2, -59, 28, 14, 45, -49, 40, -23, 12, -61, -25, -22, -21, 1, -43, -39, -40, 23, -41, 21, -30, 1, -59, 11, 7, -47, 20, 50, 3, 67, -21, 63, 8, 51, 83, 75, -46, -39, 51, 35, 56, -27, -24, -67, 40, -19, -14, -60, -32, -15, 44, -48, 35, -5, -9, 35, 24, 32, -14, 36, -2, -24, -33, -7, 8, 34, -9, 79, -46, 17, -63, 43, 62, -3, -32, -19, 52, -89, 49, -29, 13, 22, 32, 0, -13, -7, -36, 55, 25, 3, -51, 37, 53, -6, -28, -36, 57, -13, 58, -7, 63, 2, -53, -24, -7, 17, 48, -9, 45, 63, 8, -31, -19, -27, 65, 3, -9, 14, 64, 41, 61, -56, -2, -3, -31, 13, 16, -25, -51, 42, 18, 28, 42, -57, -33, 69, -24, -29, -31, 22, 57, -22, -65, -7, -24, 17, 66, 48, 22, -30, -10, -51, -1, -24, 65, 32, 62, -63, 35, -47, -11, -46, 9, -46, 18, -4, 42, -23, 25, -52, -48, 59, 28, -61, 48, 29, -11, -16, 3, -25, 35, 47, -23, -50, 23, 50, 54, 39, -6, 18, -26, 65, 58, 30, 74, -3, 5, 34, 82, -55, -84, 67, 54, -57, 27, -37, -25, 1, -68, 7, -78, -42, 26, -50, -23, -26, -10, 58, 53, 52, 31, -29, -19, 51, -13, -25, -46, -19, 19, 47, -67, 10, 67, -64, 66, -47, 28, 42, 5, -57, -5, -21, 36, -11, 73, -17, -25, 79, 63, 28, 37, -12, 62, 0, 66, 28, 69, -25, -26, 55, -10, -48, -39, 19, -44, 20, -41, 53, 60, -75, -7, 13, 25, 20, -61, 2, -4, 4, -48, 15, -33, 40, 16, -39, -35, 26, -7, -31, 14, -62, -27, -41, 2, -19, -33, -37, -57, 14, -26, 51, 52, -17, -20, 55, -41, 22, 8, 41, 57, 59, 32, 48, -10, -41, 56, 2, -50, -19, -87, -38, 21, 50, -60, 29, 73, -34, -13, 53, 53, -24, 60, -3, 50, -59, -15, -16, 34, 36, 50, 4, 63, -22, 18, -23, -65, -23, 13, 74, 8, 65, -26, 57, -4, 66, -49, 55, 36, 0, 52, 10, 13, 30, 33, 70, -54, 37, 24, 27, -25, -63, -47, 18, -7, -34, -10, -13, 46, -41, 27, 1, 66, 22, 66, -70, -34, -7, -10, -1, -42, -21, -23, -7, 43, -32, 48, 8, 7, -51, -39, 5, 10, -35, 24, 71, 24, 42, 49, 61, 50, -10, 30, 6, 68, -25, -35, 62, -69, 31, 2, -38, 29, -29, -15, 68, 53, 4, 10, -23, 11, -2, 63, -34, -60, 64, 48, 34, 28, -55, -39, -4, 32, 35, 60, -8, -74, 61, 29, 60, 32, 2, 63, 0, -27, 17, -4, 28, -8, 0, 4, 50, -19, 37, -17, 58, 5, 65, 7, 5, 34, -54, 61, -29, 36, -40, -25, 2, -36, -71, -24, 71, -4, 26, -21, 4, 27, -15, -52, 11, -31, -52, 30, -8, -55, 67, -23, 54, -32, -27, 13, 54, 9, -14, -6, 26, -18, 41, -12, -21, -45, 15, -47, -58, 62, 29, 68, 30, -10, -14, -47, -77, -16, -29, -34, 25, -64, 31, 16, 43, 69, 79, -45, -3, 7, -9, 44, 64, 35, -27, 45, 31, 22, -52, 12, -45, -44, -35, 29, 59, -42, 74, 61, -14, 75, -42, 7, -11, -53, 16, -13, 18, 59, -57, 49, 15, 65, 56, -18, -34, -2, 35, 31, 10, 34, 25, -21, 42, -29, 4, 7, 85, -11, -7, -5, -55, 48, 61, 1, -10, 60, -28, 11, 53, 63, 39, 70, -29, 43, 28, 1, 23, -10, 19, -25, -43, -52, -61, -5, 3, 14, -34, -67, 85, 27, 60, 45, 17, 0, 26, 22, -54, -8, -24, 24, -42, 38, 24, 2, 30, 44, 69, 18, -17, 9, 48, 25, 37, 32, -50, -52, -25, 62, 64, 35, 29, -41, 42, -54, 25, -61, -22, -11, 37, 7, 43, 64, -3, -1, 44, 48, 15, -50, 50, 16, 34, -32, -40, 72, 46, -24, -58, -57, 55, 69, -65, -10, -3, 57, -7, 24, -34, 46, 23, 
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
  -32, 23, 53, 51, 32, -42, -55, 29, 73, 70, 54, 38, 60, -33, 43, 38, 70, 46, 7, -21, 38, 12, -21, -30, 48, 45, 55, 37, 48, 51, 64, -32, -43, 0, 39, -60, -42, -25, 52, 44, -38, -64, 36, -42, -30, 15, -6, 73, 46, 17, 21, 11, -55, 12, 18, -3, 44, 48, 12, 2, -27, 47, 79, -42, -38, 69, 27, 1, 25, -34, -68, 64, -79, -29, -18, -1, -54, -26, -40, 2, -37, 19, 1, 10, -42, 40, 24, 33, -32, -6, -63, 38, -25, -44, -39, 65, 3, 75, 64, 19, 11, 28, -47, -15, -1, 38, 11, -39, 40, 26, -45, 48, -48, 14, -48, 37, 53, -57, -41, 1, -21, -38, 58, 40, -22, 55, -12, -38, 2, 49, 53, -7, -31, -51, -14, 67, -42, 54, -8, 17, 53, -40, -3, -9, 61, -8, 39, 33, -2, 36, -15, 66, -69, 24, -44, 37, 68, -23, -29, 61, 56, -58, 46, -40, -46, 46, -37, -48, 36, 11, -51, 19, 73, 50, -62, -33, -21, -17, -59, -7, 48, -26, 35, 24, -71, -7, -39, -35, 22, 41, -35, -49, -20, -16, 30, 36, 40, 39, -50, 5, -28, -41, -13, -50, -40, -29, -34, -42, 68, 28, -36, 65, 19, 47, 28, -40, -66, 33, 17, 2, 45, 6, -24, 11, -55, -49, -18, -43, -65, -61, 44, -12, 30, -56, -19, -23, 52, 63, -6, -77, 47, 15, 64, 70, -34, 52, 89, 63, -55, 78, -36, -5, 22, 5, 7, -33, -62, 90, -53, 37, 35, 49, 17, -45, -11, 53, -32, 29, -27, 43, 43, 58, -27, -55, -18, -37, -39, 28, 65, 3, 22, -34, 66, -78, -5, 27, -59, 25, 12, -9, 22, 26, 5, 53, -9, -10, 58, 1, -53, 48, 35, 42, -42, 10, -51, 32, -4, 40, 14, 61, -55, -28, 67, -41, 34, -50, 14, -24, 41, -4, -6, -29, 17, -45, -30, -19, -16, -22, 74, -21, -25, 7, 53, 67, -26, 51, 30, 45, 45, -5, 35, 67, -51, 47, -31, -2, -20, -48, 13, 53, 37, 15, -43, 79, 58, 3, -50, -6, -65, 43, 3, 1, 14, -37, -38, 10, 47, -43, -56, 57, 7, 2, 52, -48, 48, -16, -60, -5, 55, 67, 64, -66, 18, 59, 28, -36, 8, -34, -30, -9, 28, 32, -19, -31, 37, -42, -54, 43, 41, 76, 7, 46, 59, -22, -10, -8, 22, 52, 10, -27, -53, 63, 25, -31, 60, -55, -3, 18, 71, 3, 31, -24, 49, -31, -26, -18, 87, 7, 47, 3, 44, -8, -26, -68, -42, 32, -31, -38, -20, 5, 70, -62, 55, -1, -21, -6, 6, -33, 22, 67, 52, -32, 55, 36, 22, -55, 25, -63, 73, 9, 56, 16, -8, -31, -66, -5, -38, -76, 24, 49, 62, -2, 41, -52, 21, -13, 12, -31, 31, 17, 89, 44, -36, -31, 2, -23, 47, -7, 25, -39, 21, 13, 15, 9, -19, -18, 31, 42, -71, -38, -28, -8, 17, -15, 5, 31, 5, 18, 33, -13, -14, 79, -72, -30, 22, 47, 32, 14, -70, 63, -69, -21, 31, -11, 19, -41, 39, 56, 59, 10, 6, 3, 49, 27, -65, 29, 14, -35, -31, 77, -11, -7, -18, -41, -24, 49, 9, 50, -25, -34, 3, -65, -63, 58, 72, 44, 28, 45, 27, 37, -1, -27, -1, 70, -57, 3, -9, -2, 35, 7, -17, 18, 66, 8, -4, -9, -73, -13, 11, 75, -31, -19, 57, -7, -17, -45, 58, -5, 28, 71, -71, -28, 40, -15, 0, 52, 59, -7, -14, -3, -12, -73, 7, 37, 14, 5, 65, -32, -9, 16, 11, 67, -16, 6, 12, 49, -37, 57, 44, -2, 64, -26, -53, -6, 14, 19, 61, 11, 40, -51, -6, 43, 33, 45, -39, -11, -4, 14, 19, -14, -36, 38, 2, -22, 7, 31, 33, 77, 38, 67, 34, -73, -8, -41, 84, -49, -25, -44, -31, 68, 87, 10, -16, 22, -15, 23, -74, 45, -35, -55, -28, -43, -37, -43, 63, 28, -5, 61, -2, 74, 6, 46, 35, -15, -13, -8, 55, 13, -33, -60, 40, -40, -30, 47, -11, 19, 6, -2, 19, -66, -52, -45, -13, -21, -36, -9, -61, -27, 35, 40, 41, 43, -60, 26, 27, 39, 43, -32, -8, -31, -85, 56, -31, 22, -6, 58, 56, 40, 7, -47, -11, -16, 39, 23, 41, -1, -13, 22, 0, 14, 27, -30, -11, 15, -52, -48, 42, -43, -24, 11, -38, 4, 83, 48, -20, -59, 15, -12, 67, 7, 68, -21, 51, 44, 57, 20, -44, -42, 20, -60, -40, -37, -60, -7, 2, 46, 27, 22, 24, -62, -45, -32, 25, -21, 11, 55, -47, 31, 69, -63, 17, -6, -60, 56, 3, 35, -40, -43, 0, -14, 35, -6, 35, 57, -55, 82, 60, -34, -68, 15, 26, -41, -47, -35, -66, 54, -47, -61, -7, -32, 39, -13, -52, -26, 18, -62, 16, 57, -64, -3, -21, -53, 24, -35, -5, -27, 48, 63, -27, -25, -14, 20, -5, -1, 35, 16, 15, 23, 53, -23, -5, 24, 4, 50, -3, -29, -36, 3, -22, 24, 65, 49, 6, -8, 12, 76, 14, -27, -30, -46, -38, -7, -28, -48, -44, -39, -66, 8, 55, 58, 5, 20, -51, 5, 0, 68, 12, 16, -49, 19, -5, -12, -31, -52, -35, -38, -4, -46, -45, -6, -15, 6, -15, 25, 44, -11, -41, 52, -16, 17, -52, -27, 68, 28, 22, -43, -33, 44, 44, 46, -17, -34, 5, -12, 72, 47, -25, 67, -65, 72, 56, 41, -52, -25, 50, 33, -58, -57, 11, 11, -40, -11, 22, -31, 32, -60, -10, 4, 25, 93, 17, 22, -47, 20, 0, 19, -47, 18, 59, -7, 8, -24, 68, -54, 53, -62, 21, 38, -6, -3, -49, -42, -77, 12, -53, -11, -5, -44, -31, 47, -11, 34, 42, 70, -61, -45, -24, 44, 13, 35, -2, -41, -59, 69, 42, -11, 0, 32, -11, -58, -56, -19, -7, 52, -58, 68, 6, -53, -38, 31, 75, -15, -20, -67, -64, -5, -13, -6, 31, 37, -10, -41, 25, 48, 20, 27, -46, -21, -22, -1, -6, -30, 18, -26, -28, -38, -65, 47, 37, 47, -47, 61, 49, 66, 12, 48, -20, -12, -15, 56, 75, 2, 46, 77, 19, 12, -56, 24, 35, -34, 65, 64, 26, 29, -41, 9, -10, 18, 25, 13, 38, -16, 50, -3, 47, 39, 44, -11, -24, 54, -48, 62, -2, 8, 48, 56, 66, 53, 6, 51, -22, 4, -27, 75, 25, 17, -14, -50, 48, -4, 57, -46, 57, 45, 77, 39, -13, -57, -51, -43, 70, 31, 62, -11, -30, -49, -12, -32, 8, 61, 12, 35, -24, 12, 2, -47, 40, -27, 29, -13, -12, 62, -5, 82, 1, -62, 49, 37, -46, -49, 13, -19, 6, 52, 68, -3, 73, 7, 12, -30, 20, -4, -5, -51, 4, 48, 54, -78, 70, -31, -60, -20, 74, 43, -29, -10, -11, 47, 25, 52, -32, -48, 30, -21, 18, 52, 48, 46, 57, 53, -41, -55, -45, -55, 6, 7, 41, -41, -3, -31, 38, -42, -21, 51, 41, 0, -18, -16, 70, 29, -4, -27, 0, 9, 43, -59, 26, -14, -1, 8, 48, -20, 55, -19, -76, -70, 0, -30, -9, 66, -47, 70, -40, -35, -62, 8, 38, 32, -29, 20, 41, -3, 67, 3, 9, 75, -44, -22, -43, -29, -68, -71, 35, 20, -38, 4, -16, -16, -23, 28, -45, 7, -29, 1, 20, -42, -72, 46, -41, 21, 10, 45, -74, -40, 60, 22, 6, 8, -7, -63, -35, 27, -41, -54, 49, 28, 40, 19, 27, -36, 
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
  -47, 51, 58, 44, -21, 57, -10, -40, 15, -17, -10, -26, -26, -33, 53, -39, -21, -16, -57, 79, 33, 18, 12, -69, -38, -16, 19, -16, 66, -34, 77, -24, -82, 7, 92, 3, 80, -17, 2, -57, 51, 8, 9, 27, -26, 62, 75, -23, -82, 67, 59, 17, -9, 29, -51, -8, -13, -16, 10, -54, 43, 67, -14, 4, -41, -80, 34, 6, 42, 47, 36, 51, 82, -65, -26, -56, -18, -42, -21, 31, 31, 18, -3, 35, -7, -41, -51, 25, 75, -36, 96, 56, 25, -81, 23, 43, 38, 29, 59, -84, 28, 21, 21, -22, -46, 42, -36, -11, 26, -46, -1, -23, 65, -19, -38, -23, -28, 55, 32, 17, 14, 20, 13, -28, -24, 12, 22, 51, 60, -5, -36, 56, 29, -34, 27, -1, 81, -14, -20, -42, 4, -13, 7, 1, -65, 0, 36, -28, 14, -40, -39, -19, -26, -65, 22, 60, -3, 82, -3, 36, 41, -32, 84, 54, -57, 16, -21, 4, 29, -54, -8, -24, -73, 16, -9, 33, 53, -57, 81, 29, 4, -25, 92, 30, 2, -11, 69, -42, 20, 74, 70, -19, 15, 22, -7, -18, -40, -12, -35, 23, 3, 32, -30, 37, 9, 13, 21, 36, -33, -30, 28, 28, -40, 8, -1, 7, 61, 18, 14, 61, 31, -16, 8, 58, 23, -37, 9, -8, -23, 12, 18, -49, 1, 6, 36, -4, 15, -78, -38, 18, 21, 48, 45, 43, 25, -79, 46, 3, 81, 49, -53, -21, 33, 16, 36, -41, 3, -28, -69, 11, 67, -62, 46, -68, 16, 52, -52, 70, -71, -42, -6, 25, 1, 16, -68, -6, -54, 18, -69, 8, 16, 11, -44, -52, 56, -14, 86, -51, 3, 43, -34, -42, 25, -2, -44, 4, 20, -43, -31, 6, -8, -26, 71, -41, -1, -33, 11, 57, 8, -48, -33, -87, 44, -3, 13, -48, 12, 11, 7, 63, 26, 28, 23, -1, -1, -73, 29, -33, 16, 56, 72, 23, -1, 21, -40, -28, -15, 8, 2, 21, -43, -39, 17, 24, 38, 56, -38, -53, 62, 17, 44, 90, -12, -56, -36, -55, 6, -34, -18, 32, -59, -19, -9, 62, 55, 37, 13, -19, 7, 51, -8, 35, -49, -20, 33, 39, -5, 34, 14, -14, -9, -21, 62, 16, -36, 0, -6, 85, -15, 40, 3, -45, 49, 33, 10, 3, -6, 37, -28, 48, -59, -52, -13, -7, -62, 19, 5, -55, -33, 0, -20, 37, -30, 7, -78, 64, 26, -3, -8, 39, -46, 9, -67, 3, -32, -1, -31, 41, -41, -25, 80, 65, 13, 47, -27, -23, -34, -37, 42, -39, -50, -54, 46, 3, -13, -37, 37, -9, 14, -54, 51, -27, 76, -13, 26, 72, 11, 44, -39, -55, 28, 13, 47, 28, -23, -47, 86, 31, -5, 8, -52, -43, -54, -66, 40, 48, -33, 16, -72, -48, 1, -74, 45, 1, 22, -13, -25, 0, 43, 34, -25, 23, -3, 15, -72, -11, 77, 37, -60, 23, -18, 18, 32, -42, -51, -26, 55, -26, 10, 52, 0, -31, 54, 35, -39, 31, -35, 9, 65, -34, 37, -17, 2, -45, 67, 82, 22, 15, 21, -42, 60, -3, 56, 18, 16, -28, 72, -7, -40, -48, 4, 52, -13, -37, -41, -16, -54, 9, 12, -24, 15, -62, -32, -9, -63, 55, 15, -19, 52, 32, -13, -38, -15, 64, 3, -10, -28, 43, 43, 15, 53, 31, -22, -6, 52, 38, 45, -60, 49, -28, 9, -34, 38, -2, -17, -20, -38, 23, 23, -41, 76, -51, -48, -22, 9, 29, -64, -21, 42, 52, -4, -18, -68, -74, 6, -38, 46, 16, -21, -22, 54, -38, -51, -2, -26, 14, -43, 9, -8, -13, 14, -85, 35, 18, 18, 21, 18, 28, -49, 19, -22, 9, -8, -18, 86, -18, -7, -55, -76, -34, -39, 54, -23, 38, -59, -3, 34, 38, 25, 60, -26, 11, 35, -24, -12, 7, 28, 69, 58, -1, 9, -57, 4, 39, 20, 4, 66, 32, 33, 48, 1, 11, 24, 25, -62, -1, 45, 16, -39, -55, 21, 54, -43, -36, -20, -48, -41, 55, -66, -18, 45, -2, 34, -32, 43, -51, 36, 39, 54, 28, 23, 4, -34, -31, -11, -22, -51, -19, 79, 8, 21, -27, -55, 65, -103, 29, 37, -14, 34, 43, -10, -8, -20, -11, 61, 33, 8, 0, -19, 33, 44, 15, -6, 31, -38, 41, 27, 66, -21, -67, 1, -66, 19, -20, 41, 9, -11, 42, 56, -19, -7, -13, -84, 10, 16, -18, -7, -27, 36, 29, -37, 36, 42, -2, 7, 13, -64, 36, -26, 5, 89, 5, 45, -27, 40, 36, -60, 5, -34, 35, 1, 35, 34, -40, 5, 78, -55, 3, 6, 38, 26, -58, 66, 55, 45, -46, -13, 12, -47, 40, -4, -44, 28, -14, 54, 8, -54, -33, -16, -32, -53, 2, 44, -17, -48, 85, 55, 33, 39, -47, 34, 61, -42, -41, -60, 29, -50, -24, 23, 10, 31, 47, -24, 50, -35, 46, 49, 4, -43, 29, 16, -8, 1, 18, 27, 88, -47, -11, 19, 58, 53, 47, 3, -43, 45, 25, 26, 27, -85, 45, 43, -37, -45, -43, 35, -52, -43, -19, 2, 13, 68, -32, -77, 31, -58, 18, -45, -5, 12, 43, 32, -60, -38, -27, 61, 28, 47, -70, -7, 53, 42, 59, 14, -13, -38, -40, 17, -55, -36, 39, -32, 60, 18, 32, 6, -48, -40, -26, 25, 53, 12, 49, 26, -24, 67, -12, 40, 59, -14, -79, 13, 29, 2, 8, 49, 39, 57, -34, 10, 3, 35, 41, 14, 29, -62, -58, -31, -50, -67, 1, -31, -15, 17, -43, -51, 50, -23, 31, 60, -11, -41, 31, -17, -38, 42, -46, 70, 63, 7, 43, -51, -52, -55, 46, -70, 12, -6, -1, 32, 18, -57, -30, -45, 37, 9, 4, -46, -61, 36, 17, -11, -7, 61, -36, -40, -46, -65, -8, -68, 74, -46, 61, -23, -64, 35, 0, 33, -27, -33, 65, -65, -40, -29, 41, -6, 3, -25, 5, -42, 34, -22, -61, 30, 18, -42, 66, -57, 16, 41, 6, -22, 34, 28, 14, 27, 4, -51, -50, 30, 4, -34, 24, -63, 47, 67, 3, -44, 52, -81, 43, -38, 1, 6, 3, 57, -62, 55, 44, 13, 29, -37, -33, 12, -56, 70, -83, -32, 69, 55, 26, -24, 43, 14, 74, -25, -44, -15, -19, 45, -52, 22, -10, -26, -32, 10, 13, -24, 27, -47, 6, -9, -51, -17, -52, -48, -79, 39, -22, -38, -59, -70, 48, -35, -49, 45, 38, -11, -63, 23, 82, 31, 16, -42, 60, 40, -34, -43, 28, 5, -7, -45, -11, -21, -43, 57, -30, -9, 48, 37, -12, 13, -39, -37, 40, -8, 46, 16, -30, -7, 41, -18, 72, -20, 35, 44, 61, -65, 5, 39, 3, -2, -37, 10, 23, -20, -43, 56, -12, -21, 40, 25, 47, 17, 43, 46, -23, 30, -61, -44, -51, 30, -60, 15, -13, 37, -50, -17, 37, -38, 30, 55, 25, 46, -35, 61, 38, -46, -13, 32, -33, -49, -56, 57, -16, 34, -32, 8, -78, -27, -59, 44, -70, 50, 6, -43, -18, 49, 35, -43, 70, -1, -17, 75, 3, -50, -7, 8, -16, 54, -39, 40, -38, -17, -25, 61, -2, 2, -28, 10, 67, 8, -56, 24, -61, 18, -58, -23, -13, 11, -6, -26, -30, 58, -37, 18, 35, 56, 22, -40, 29, 57, 39, -1, 65, 61, 6, 29, 15, -43, -4, 38, -21, -58, -26, 6, 4, -3, 11, 29, 45, -39, 30, -12, -26, 5, 42, -87, -29, -36, 56, -10, 62, 51, 23, 0, -26, 46, 57, -20, 47, 
  63, -5, -16, -51, -14, 48, -49, 3, -83, -52, -17, -48, 28, 45, -46, 30, 17, 38, 60, -3, 5, -39, 67, 14, 45, -56, -51, 26, 2, -19, 50, -74, -62, -65, 50, -11, 32, -65, 39, 67, -61, 54, 70, 50, 33, -27, 38, 47, -12, -59, 2, 3, -61, -30, -52, 30, -26, -26, -40, -42, -14, -34, 14, -62, -71, -25, 12, 48, 33, 23, 47, 18, -72, -14, -31, -58, -15, -66, 46, -42, -38, -15, 10, -15, 48, -63, -19, -11, -52, 33, 40, -40, -36, 60, -2, -59, 6, -39, 55, -30, 3, -29, -27, 49, -38, -59, -52, 56, -20, 9, -29, 21, -42, 81, -15, 40, -22, -72, 32, 45, 1, -49, -39, -37, 42, 4, 0, 16, 77, 51, 26, -56, 3, -33, 29, -26, -3, 28, -61, 62, -30, -74, -8, -2, 21, -2, -8, 54, 31, -74, 30, -10, -51, -58, 51, -31, -31, 13, -54, -26, 14, 70, -3, -52, -4, -56, -48, -27, 36, 12, -20, 41, 4, -22, 99, 54, -6, 9, -45, 70, -48, 81, -12, 3, -19, -77, 2, 44, 43, 50, -65, 37, -35, -19, 3, 38, 73, 0, 6, -36, -21, -51, -28, -24, -43, -21, -48, -28, -55, -73, 45, -22, -51, 41, -36, -48, 44, -77, -35, 2, 39, -51, 33, -19, 11, 31, -32, -7, 44, -17, 24, 8, 9, 5, -79, -51, 9, 59, -29, -26, -47, -9, -51, 67, -36, 20, -33, -5, 53, 53, -41, -40, -64, -50, 29, -23, 23, 27, 47, -12, -58, -51, 32, -28, 29, 15, -59, 12, -44, 1, -7, -38, 57, -44, 9, 65, 17, -48, 37, -31, -77, -47, -52, -23, 37, -37, 33, 16, -7, -19, -16, -62, -47, -54, -11, 12, 35, -11, -53, 18, -37, 32, 48, 46, -51, 70, 53, -6, -40, -36, -15, -45, 14, 23, -35, -2, 4, -4, -5, 40, 2, 21, -14, 56, 22, 31, -19, 56, 4, 21, 24, 61, 44, 67, 63, 20, 8, -42, -27, 67, -19, -83, 23, 32, -47, 31, 83, 7, -34, -51, -26, 40, -10, -57, 29, 54, -18, -66, 29, -20, 42, -40, -60, -9, -23, -4, 50, 20, -48, 17, -46, 55, -65, -74, -8, 34, -2, 69, 0, -55, 28, -47, 11, -14, 68, 3, -73, -56, -13, -5, -23, -8, -6, 24, -52, 32, -44, -13, -51, 53, 42, -57, 28, -25, -33, 64, -57, -36, 5, 43, 66, 60, 31, 61, 39, 46, 59, 61, 53, 6, 62, 41, -19, 72, -3, 3, -8, -26, 56, 62, 14, -14, 13, 45, -76, 3, 15, -18, 12, -14, 8, -25, 43, 48, 27, 32, -58, -33, -50, 34, 26, 58, -22, -18, -63, 1, -45, 5, 25, -51, -29, 8, 50, 8, -5, -91, 24, 73, 13, 54, 5, -62, -53, -25, 38, 68, -58, -45, 77, -40, 45, -25, 25, 49, 80, -2, -50, 6, 47, 69, -63, 31, -29, -4, 45, 11, -24, 81, 2, -58, -17, -32, -61, 49, 5, -6, -26, -13, 71, 53, 42, -57, 32, 37, -25, 58, 15, 39, 25, 32, 59, -63, 12, 66, 32, -10, 36, -19, 48, -6, -62, -1, 35, -7, 75, 34, -69, 1, 56, -48, -71, 51, -30, 9, -5, -17, -35, -29, 54, 29, 25, -58, -22, 31, -12, -85, -36, 60, 73, -36, -40, -21, -44, -19, 75, -8, -2, 8, -75, -52, 4, 43, -29, 4, 6, 31, 48, 11, 32, -27, 30, -2, -51, 42, 63, -61, 59, -46, -50, 42, 13, 54, 10, 74, -13, 67, -13, -20, 20, -32, -38, 4, 31, -18, 43, -20, 42, 32, 17, 76, -6, 53, -15, -53, 53, 5, 4, 53, -13, 21, 47, -26, 35, -15, -3, -43, -5, 4, 2, 32, -61, -18, -54, -24, 16, -17, 25, -33, 45, 12, -83, 83, -60, 19, -56, 27, 50, -1, 27, 7, 59, -28, 29, 35, 14, 6, -47, -7, -56, 51, -3, 10, 9, -29, 45, -27, 64, -70, -63, -5, 8, -46, 4, -21, -28, -28, -8, 3, -26, -2, 8, -40, -54, 22, 9, -65, 70, -44, 73, -52, 24, -13, -33, 50, 33, 52, -67, -6, 44, 25, 59, -30, -23, -45, -29, -22, -12, 45, -14, 13, 5, 4, -46, -21, -48, 28, 53, -27, -32, 23, 51, -34, 0, 0, -55, 16, 77, -56, 42, 29, -45, -24, -63, -58, 10, 7, 45, -38, 3, 41, 19, 9, 1, 25, -7, 23, -62, -11, -39, -29, -16, -65, -30, -9, -54, -15, -33, -30, 7, 42, -28, -6, -1, 51, 5, 67, -51, 29, -27, -23, -72, 20, 17, -39, 44, -37, -54, -17, -66, -38, -4, 4, -36, 29, -32, -22, -58, 67, -27, 6, 44, 14, -11, -17, 15, -9, 68, 9, -56, 40, 44, -10, -31, -5, -2, -67, 58, -60, 54, 44, -8, -49, -68, 29, -33, 0, -54, -46, 20, -88, -68, -9, 36, 48, 44, -31, -6, -44, 35, 28, -19, -6, 19, -4, 66, -37, 3, 18, -8, -73, 24, -44, -24, -22, -19, -66, -60, -55, -47, -76, 69, -69, -13, -22, -3, 8, -20, -25, -45, -43, -10, 20, 24, 54, 54, 52, 0, 24, -61, 18, -40, 37, -63, 1, 21, 63, -25, 15, -50, 67, -10, -19, -38, 22, 44, 10, -18, 29, 28, -13, -48, -35, 57, -41, -1, 6, 6, -4, 65, -66, -16, 20, 21, 2, 47, 62, 38, -3, 30, 42, 48, 17, -17, 22, 36, -67, -54, -21, 5, -61, 56, -39, -7, -4, -36, 47, 27, 36, 63, -65, 32, 17, -38, -27, 79, 33, 61, 68, -63, 47, -26, -69, -35, -15, -30, -37, 4, -57, 48, -74, 33, -28, 0, 7, 3, 63, 25, -48, 42, -45, 45, 51, 38, 82, 25, 26, -2, -28, 0, 73, -45, 1, -6, -16, 56, 4, 21, -20, 29, 42, 20, 20, -3, -42, 84, 12, 61, 26, 46, 18, 3, 8, -39, 13, 12, 58, -75, -18, 72, 6, 73, 16, 60, -22, 3, 26, 64, 38, 19, -2, 17, -10, -33, -31, 8, 31, 15, 41, 44, 69, -29, -20, -19, 42, 57, 12, -29, -72, -41, -13, -29, -43, -43, -15, -38, -22, -2, -5, 52, -75, 30, 66, -40, -72, 54, 36, 16, 24, -34, -37, 38, 8, -57, 41, -31, -22, 59, -38, 17, 26, 17, 56, 20, -28, 48, -14, 17, -31, 16, -45, 14, -42, -26, 12, -11, -44, -57, -33, -75, 11, -1, -18, 19, 23, 35, -39, -32, -28, 42, -7, 32, 54, 30, -61, -16, 1, 63, 12, 19, 4, -57, -56, 1, 13, -18, 12, 48, -6, -16, 1, -11, -45, 37, -48, -52, -14, 14, 68, 68, -52, 10, 40, 28, -61, 22, 41, 21, 42, 33, 31, -2, -36, -12, 26, -34, -4, -60, 35, -51, 14, 35, 26, 16, 44, -20, 25, -57, -61, -71, 61, 11, -50, 15, 77, -24, -46, -13, 49, 36, 62, 8, 22, 6, 22, -23, -27, 74, 23, 16, 47, -60, 17, 8, -7, 19, -26, 26, -81, 32, 47, -25, 62, 14, -62, 32, -1, -26, -48, 37, -21, -1, 31, 2, 21, 32, -48, -24, -18, 48, -27, 44, -17, 51, -49, 20, -9, 37, 34, -32, 46, -81, -31, 44, -30, 24, 55, 39, -3, 21, 57, 32, 65, 59, 58, 47, 27, -4, 39, 34, 22, -51, 34, 3, 1, 65, 7, 67, -32, 8, -37, -48, 17, -6, 53, 22, -58, 75, 57, -44, -41, -45, 11, -52, -54, -65, 64, -32, -3, 12, 7, 9, 57, 51, 3, -61, 51, -44, -49, -36, -18, 40, 0, 6, -3, -9, 50, -24, 33, 20, 56, 
  46, -40, 31, 19, -27, 15, -65, -34, 77, -39, -12, -3, 5, 30, -24, 35, 28, 1, -40, -47, 6, 42, -9, -50, -33, -55, 85, 33, 35, 30, 37, -38, 64, -2, -7, 25, -34, 17, 30, 2, 37, 13, -61, 60, 17, 42, -32, -1, 37, 15, -40, -8, 28, -28, 66, -22, -34, -54, -25, 32, -16, -12, 29, 73, -39, 67, -8, -21, 50, 68, -33, 3, 33, 22, -1, 71, -11, 48, -78, -49, -55, 43, 43, 23, -49, 76, 65, -37, 9, -51, -49, 14, -87, -24, -53, 67, 56, 14, -31, 53, 4, -40, 63, -19, -38, -40, 11, 77, 18, 31, 29, 7, 32, 4, -61, 21, 19, 23, -49, 10, 30, -43, -12, 52, 8, 28, -35, -66, -9, 59, -19, -71, -49, -2, -57, -2, 2, 52, -54, 77, -46, -42, 7, 46, -41, 40, 15, 13, -7, 44, 69, -5, -36, -44, -27, -3, -13, -36, 8, -4, -45, -63, 16, -4, -1, -54, 45, -40, -34, -37, -46, -53, 10, 71, -57, -65, 22, 10, 64, -39, 63, -39, -68, -21, -11, 3, -59, -39, 62, -37, -62, 81, -58, 7, -46, -56, 14, -32, -22, -14, -9, -61, 48, -6, 41, 70, -31, -6, 52, -35, 53, -5, -17, -52, 43, 12, -25, 81, -25, -38, 59, 68, 2, 29, -23, 52, 73, 43, -11, 35, -37, -31, 30, 4, 74, -57, -31, 0, -66, -51, -9, 65, 45, 4, -15, -60, -46, 55, -18, 70, -46, 52, 38, -63, 4, 56, 6, 32, -78, -6, -7, 47, -34, 8, 26, 61, 5, 32, -46, -6, 19, 84, -34, 15, 43, -8, -39, -9, 26, 35, 17, -36, 15, 47, 12, -44, -51, -39, -4, 26, -42, -48, 38, -6, 71, -59, 24, 79, 11, -14, 16, -37, -30, -18, -57, -30, 37, -19, 11, 21, -79, 67, 59, 50, 2, -29, 64, -24, -13, 36, 32, 43, 25, 7, -4, -18, 9, 28, -32, 1, 59, -33, 64, -41, 33, -40, 15, -16, -15, 21, -45, -3, 49, 15, -47, -35, -73, 59, -52, 26, -34, 39, 29, 1, 28, 25, -32, -39, -29, -10, 3, 53, -19, -19, 36, 34, 43, -17, -23, 2, 10, 14, 41, 75, -27, -39, 47, 35, -31, -50, 56, 29, 15, 11, -49, -32, -3, 75, -3, -30, -37, 49, 28, -64, -3, -19, -54, -3, 50, -59, 13, 22, 48, 55, -29, 36, 74, -26, 18, -40, -24, -42, 28, 46, 63, 3, 4, -16, 55, -32, -67, 3, 80, -19, -44, 36, 21, 26, 13, -53, 5, 11, -53, -33, -8, 9, -37, 42, 14, -4, 39, -52, 59, 69, -33, -4, 20, -48, 3, 31, 39, 40, 3, 41, -28, 51, 4, -49, 0, -28, 19, -14, 26, 39, -54, -19, 20, 48, -49, 34, 41, -35, 27, -11, 4, 42, -63, 64, 25, -28, -27, -12, -8, 27, -16, -7, 49, 28, -62, 0, -39, 65, -29, -53, -20, 19, 53, 13, 47, 21, 39, -32, -64, 37, -13, -32, 64, 34, -22, -2, -3, 60, 24, -70, 2, 31, 10, 28, 32, 29, 22, -27, 39, 24, 47, 76, -54, -28, 82, 62, 65, 0, 61, -18, 68, 45, -16, -47, 43, -29, -29, -4, -16, -15, -3, -35, 41, 45, 73, 83, 18, -54, 11, 22, 3, 25, -19, -7, 47, -17, -74, -25, 29, 12, 41, -4, -56, 70, 27, -13, 42, 6, -49, 59, -37, 60, 45, -8, 10, -20, 29, 31, -34, 25, 4, 50, 26, -12, -13, -41, 37, 28, -37, -46, 35, -37, 34, 27, -30, -45, 48, -17, -37, -11, 55, -51, 22, -57, -21, 8, -4, 66, -44, 32, 62, 34, -52, -23, -20, 59, -32, -31, 45, -42, -38, 3, -22, -27, -12, 47, 56, -27, -16, -43, -26, -34, 61, 71, 63, -6, -24, 18, 38, 63, 43, -65, -1, -33, -18, -62, -56, -68, 61, 14, 70, 23, -32, 0, 73, 36, 40, -52, 59, 11, 9, -46, 24, 44, -39, 16, 41, 37, 56, 55, 49, 26, -38, -13, 52, -30, -55, 8, -24, -17, -59, 9, -20, -44, 37, 1, 7, 12, 21, -29, -37, -25, 21, -56, 54, 36, -48, -24, -40, -33, -8, 26, -63, 48, -69, -44, -77, -13, -36, 8, -10, -2, 56, -35, -16, -22, -25, -61, -12, -57, -27, 0, -62, 28, 25, -1, 36, -32, 44, -43, -8, 47, 4, -19, -7, 43, -12, -7, 12, 42, -33, 33, -5, -59, -26, 13, 21, 39, 65, -24, -8, -43, -32, -8, 5, 25, -63, -38, 64, -21, -2, 44, 21, -49, 35, 0, -16, -50, 21, 47, 38, 25, -31, -58, 33, 12, 60, -46, -39, -25, -50, -10, 42, 4, 17, 0, 67, -61, -22, 30, -73, -40, 30, 38, 19, -74, 43, -83, -7, 70, 38, 23, -12, 25, -51, 22, 70, 25, 10, -42, -63, -59, 18, 11, -11, -13, 62, -49, -64, 32, 9, -30, 49, -26, -55, -7, 32, 50, 37, 15, 9, 25, -27, 37, -35, 79, -45, -33, 6, -10, -32, 23, -6, 59, -74, 34, 22, 19, -26, 42, 41, -44, -47, 15, -5, -27, 36, 25, 49, 21, 54, 46, 38, -44, -44, 26, 11, 8, -52, 47, 38, -21, 40, -38, -27, 64, 27, -48, -24, -24, 42, -3, -16, -22, 40, -55, 20, -74, -2, -41, -55, -16, 25, -44, -25, 9, 27, 47, -18, 27, -11, 3, 38, 36, -38, 18, -46, 24, -49, 7, 28, -52, 48, 20, 69, 56, -72, -32, 7, -17, 51, 6, 2, -30, -39, -35, -8, 5, -38, 25, -63, -1, -10, -6, 34, -47, -17, -55, 62, 17, -26, -63, -78, -1, -67, 3, 35, 6, 59, -32, 48, -39, 21, 21, -67, -25, -3, 13, 9, 2, 37, -8, 52, -4, -12, -38, 28, 69, 31, -32, -44, -30, -37, 16, 34, -45, -63, -33, -5, 64, -71, -60, 8, 36, 25, -18, 15, 6, -17, -7, 57, 58, 18, 62, -49, 60, -46, -15, -21, 18, 20, 5, -50, 6, 27, 0, 28, 14, 24, 32, 47, 62, 4, -48, 15, -33, 65, 20, 1, -37, 34, 46, -27, 21, 60, -59, -2, 39, 65, 54, 60, -33, -16, 3, -7, 51, -12, 18, -42, -26, 45, 80, 11, -50, 4, -30, 4, 94, 47, -24, -9, 6, 19, -77, 27, -64, 7, -45, 29, -1, 48, 61, -22, -28, 29, 59, 44, -57, -9, 70, 77, -23, 33, 41, 85, 48, -25, 25, -49, 77, 6, 52, 64, -28, 16, -32, -62, -36, 13, 58, 37, 21, 31, 29, 27, 59, -21, 19, 30, -21, 60, -37, -50, -57, 37, 57, 66, 22, 9, 34, -70, 30, -3, 32, 55, 2, -14, 7, -26, -23, -49, -51, 19, 39, -3, 65, -33, 37, 84, 10, 17, 35, 4, -73, 31, -13, 6, 55, -2, 45, -50, 17, -35, -62, 71, -17, -26, -28, 47, 22, 41, -25, -15, 38, 34, -4, -88, 60, -32, 58, 19, 4, 8, -47, 54, 11, 52, -4, -36, 16, 41, 45, 19, -30, 40, 0, 95, -49, -12, -49, 49, 11, -53, 37, 58, -16, -53, -30, -46, 4, -25, 35, 14, -45, 27, 63, -17, -31, 0, -34, -50, 53, 45, 69, 12, -63, -19, 23, 22, 22, -12, -51, 40, -27, -14, -49, 10, -11, 62, 18, -32, 28, -21, 20, -68, -51, -49, -37, 1, -14, 21, 44, -27, -20, 25, 75, -65, -86, 60, 52, 35, 31, -9, 30, 7, 49, 32, -20, -41, 25, 39, 28, -26, -4, -17, -29, 17, -28, -35, -36, -44, 26, 61, 5, 52, -61, -39, 26, -56, -58, 61, 21, 10, 19, 5, 71, 
  -28, -5, -11, 51, -64, 49, -18, 36, 51, 54, -26, -20, -5, -38, -35, 84, 54, -5, -74, -58, 77, -59, -42, 55, -37, 35, -16, 4, -78, -1, 2, -37, 30, -25, 43, 29, 35, -26, -52, 10, 62, 45, 15, 2, 80, 11, -61, 28, -61, -17, -73, 67, 7, -49, -59, -38, -46, 62, -62, 50, -62, 52, 13, 10, 0, 95, -7, -4, -39, -4, 45, -6, -77, 10, -54, -47, -37, -33, -53, -44, -10, -3, 28, 70, 10, -30, 22, 20, 13, -14, -19, 59, -25, 39, 20, -22, 72, -39, 44, -28, -30, 1, -3, -22, 52, -32, 11, 63, -30, 49, -35, -22, 8, 19, -1, 14, 0, -11, 25, -22, -46, 41, 17, 34, -42, 24, 65, -37, -18, -68, 7, -26, -12, -47, -54, 60, -67, 20, 23, -34, -60, -4, 19, 12, 35, -13, 43, -62, 55, 18, 53, 3, 42, 16, -32, -38, 23, 7, -21, 44, 41, 25, 52, -32, -19, 32, 50, -23, 35, -44, 0, -20, 6, -6, 21, -7, 26, -28, 24, 56, -51, -48, 26, 0, -83, -37, 74, -24, 70, 31, -29, 63, 0, 14, -13, -61, -33, 46, 53, -43, 32, -1, 12, 49, -41, -7, -42, 59, 87, 54, -20, 34, -1, 43, 76, 13, 48, 11, -52, -70, 64, 51, -39, 65, -34, -36, 15, 7, 1, 50, -8, -5, 44, -22, -30, -11, 56, 56, -55, -18, 61, -23, 78, -63, -38, 38, -40, -30, 35, 4, -24, 26, 11, -38, -75, -46, -16, 35, -58, -4, 23, -47, -10, -51, 37, 48, 35, 3, -51, 0, -16, -34, -43, -8, 54, 19, -48, -61, -27, -34, 31, 56, 49, -9, 19, 2, -37, 59, 55, 9, 18, 16, 16, 30, -5, 48, -37, -19, 12, -26, -16, -26, -25, 37, -48, -45, 64, 90, -19, 40, 22, -18, -30, 15, 73, -35, -32, -21, -6, 6, 9, -5, 28, 44, 18, 24, -28, 41, 41, 59, -34, 36, 53, -43, -55, 30, -27, 68, -18, -64, 15, 18, 65, -42, -54, -36, 18, -20, 32, 66, 28, -71, 65, -5, 4, 24, 29, -70, 50, 45, -17, 3, -23, -41, -57, 89, -40, -44, -26, -22, 69, 63, 78, -3, 53, -12, -5, -65, -16, -73, 44, -51, -79, 14, -36, 60, 0, 14, -15, 42, 29, -17, 21, -34, -15, 69, -47, -8, 6, 59, -34, -18, -8, -48, -48, -21, 26, -29, -52, -63, -70, -28, 28, 34, 0, -40, -24, -68, -4, -55, -51, -27, 76, -2, 50, 11, 73, 62, -72, -33, 22, 15, -3, -63, -14, -22, 21, 16, 7, -14, -45, 25, 62, 21, -47, -8, 59, 2, 22, 56, -56, -65, 28, 21, 63, -15, -32, -27, 53, -37, -28, 30, -36, -54, 48, 11, -43, 25, 35, -28, -37, 15, 44, -79, 51, -34, 30, -39, 27, -48, 24, -73, 26, -35, -52, -17, -40, 23, -64, -68, 64, 70, 1, 37, -83, 12, 22, -41, 7, 32, -60, 16, -36, 2, -44, -14, 38, 14, -15, 36, 18, 1, -33, -54, -68, 5, -24, -25, -9, -14, -38, -26, 38, -42, 4, 55, 52, 39, 53, -12, -23, 60, 26, -26, -36, 58, 66, 66, -72, -9, 14, 55, -38, 18, 52, 63, 47, 56, 31, -26, -12, 45, -12, -44, -35, -20, -25, 10, -51, -30, 4, -20, 20, -8, 66, 32, 36, 32, 60, 40, -29, 40, 13, 70, -83, 9, 37, 7, 32, 55, -37, -16, 64, -22, 45, -13, 0, -38, -32, 3, -32, 61, -34, 24, -23, 47, 52, -43, 41, -64, -11, 30, -52, -28, 43, 49, 3, -13, -47, 45, -29, 69, -22, -46, 23, 51, 13, 37, -20, -25, -29, -59, -53, -24, 29, 66, 37, 22, -26, -15, 45, -74, 34, -46, -37, -3, 3, -39, -38, -51, 15, 41, -5, 18, -46, -31, 59, 46, -17, -15, -49, -67, 16, 30, 77, 24, 30, -16, 25, 11, -12, 65, 64, -37, 15, -6, -11, 80, 39, 11, -36, 82, 19, -44, 12, 24, -4, -13, 18, 42, 31, 46, -32, 22, -27, -26, 28, -13, -45, 46, 73, 34, -24, -41, -37, -6, 42, -32, -8, -44, 18, 17, 58, 80, -32, -50, 30, -8, -21, -11, -40, -49, -37, 74, -11, -27, -73, 10, 22, 24, 25, -24, 25, -65, -31, -46, -59, 9, -1, -11, 63, 31, 4, 85, 21, 22, 55, -78, -58, -40, 34, 15, -21, -56, -28, 20, 2, 28, 55, 33, -54, 12, 12, -29, -8, 47, -44, 38, -25, -18, -60, -65, -26, -21, 47, -49, 50, -48, 24, -53, -27, -24, -39, -48, -32, -3, -40, 9, -37, 74, 52, -13, 34, -68, -78, -67, -1, 17, 77, 11, 21, -25, -26, -4, -43, -65, 40, 33, 11, 14, 2, 4, -54, 62, 37, 48, 34, 30, 33, 54, -32, 49, -11, 89, 17, -47, 52, 9, 65, -6, 31, -32, -23, 30, 35, -16, 2, -56, -79, -45, 27, -33, 82, -44, 36, 44, 16, 43, -35, 36, -60, -73, 24, -59, -31, -16, -32, 88, 1, 29, 21, 72, 44, -19, -22, 61, -4, 68, 25, -18, -45, -25, -50, -38, -66, -48, 66, 18, -19, 10, -33, 17, -21, 27, -49, 40, -56, -14, 29, -7, -49, -19, 41, 39, -21, 59, 26, -29, -7, 9, 80, -29, -25, -5, 7, 34, -20, 72, 48, -8, -10, -57, 35, -72, -20, 20, 30, 35, 40, 16, 5, -18, -25, -42, 55, -66, 35, 33, 16, 68, 34, 19, 10, 12, -43, 48, 13, 18, 33, 58, -49, -22, -76, -8, -37, 14, 34, -76, -22, -41, -35, 50, 11, 35, -30, -23, 10, 13, -95, -49, 52, -65, 4, 12, -39, 40, 35, 25, -67, -17, 55, -39, 28, 13, 53, -37, 22, 59, -3, 46, -12, -1, 42, -33, 8, 7, 21, -43, -40, 28, -51, 44, 64, 45, 39, 4, 8, 7, -21, -66, -65, -65, -29, -6, -39, 47, -24, 60, -16, 46, -33, -4, 59, 58, 45, 43, 13, -12, -20, -37, 72, -17, -21, 35, -2, 72, -22, 51, 13, 48, 2, 48, 22, 64, 13, 28, 53, 3, 14, -24, -26, 49, -49, 21, -40, 42, 14, -63, 1, 8, -6, 37, -63, 80, -48, 52, -15, 39, -51, -29, 34, 74, -15, -33, 38, 68, 48, 4, 16, -55, 28, 74, 54, 23, 10, 43, -48, 0, 44, -2, -9, -22, -3, 33, 33, 54, 40, -43, -47, 38, -7, -20, -5, 78, -35, 18, 33, 1, 3, 53, 7, 56, -14, 1, 31, 14, 69, -3, -35, -10, 18, -8, -30, 10, 7, 72, -49, 24, -34, 9, 31, 19, 27, -49, -53, -55, -9, -44, -77, -44, 31, 45, -15, 36, -16, 37, 62, -22, 33, 8, -1, 48, 21, 65, 4, 37, 37, 16, -52, -43, -16, 39, 37, 21, 76, 68, -10, 30, 21, 1, -40, -11, 23, -8, -54, 21, 35, 28, -15, 31, -78, -7, -25, -40, -19, 32, -65, 48, -18, -1, 22, 52, 51, -6, 22, -1, 41, -6, 3, -28, -10, 38, 65, 50, 4, 81, -25, 32, -25, -43, -10, 33, 78, 9, -16, -3, -3, -56, -24, 5, 36, -8, 83, 54, -39, -8, 47, 11, -47, 4, 53, 46, 52, 9, 11, -59, 39, 18, -42, 14, -4, 66, -11, 66, -55, -7, -27, -31, 53, -83, 4, 108, -38, -12, -53, 19, 19, -35, -52, 48, 38, -12, 61, 15, -6, 7, -2, 35, 56, -44, 11, -37, 44, -41, -11, 66, 34, -30, 51, -56, -21, -47, -53, 63, -30, 13, 16, -60, -60, -8, 61, -14, 27, 43, -6, -21, -12, -24, -6, 22, 
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
  -53, 58, 23, -56, -38, 4, -39, 23, -44, 31, 50, -43, -80, 53, -49, -37, 29, 38, -35, -12, 33, -51, 34, 5, 15, -33, -5, -26, 56, 22, -11, -21, 36, 65, 19, 16, -30, -47, 20, -28, 2, 49, -13, -29, -30, 43, 60, 42, 40, 11, 57, -38, -16, 34, -8, 8, -64, 1, -25, 5, -11, -14, -73, -37, 16, -31, 7, 9, 63, 19, -43, 43, 94, -26, -36, 47, 28, -73, 85, 68, 48, 64, -3, 8, 26, -27, 21, -55, 5, -8, 31, 15, 31, 52, 19, -6, -76, 5, 65, 29, 42, 77, 58, -11, 70, 54, -33, 44, 74, 22, 35, 29, 17, 65, -5, -25, 26, -27, -14, -25, 24, 32, 7, 52, 28, -41, 36, -47, -4, 30, 50, 0, 8, -37, 32, -26, 16, 2, -15, -31, 39, 13, 34, 45, -64, -45, -33, -20, -2, -66, 3, -50, 30, -17, 74, 33, 22, -24, -5, 40, -8, 71, 35, 11, 15, -23, 25, -12, 22, 2, 29, -37, -64, -10, 42, -58, -2, -4, 25, 14, -28, 67, 78, 45, 59, -30, 39, 39, 8, 26, 0, -42, 78, 41, 53, 8, 45, -44, 18, -7, 47, -45, 50, 14, -2, -59, 30, 25, 39, -1, -22, 43, 9, -56, -70, -52, -5, -94, 45, 6, -54, -44, 32, -42, 59, -7, 23, -67, 43, -70, 23, 7, 1, -35, -36, -50, -28, -40, 46, -38, 13, 14, 9, 53, 25, -27, 19, -28, -27, -55, 30, 27, 12, -16, 2, 33, -25, -94, 77, 36, 1, 17, 4, 46, 22, -16, 14, 46, -56, -18, 1, -34, 41, -7, -54, 47, -45, 21, -50, -21, -44, 37, 51, 35, -4, -2, -49, 9, 24, -4, 18, -39, 20, -24, 7, 49, -10, -40, 53, -19, 22, 12, 14, 61, -20, -66, -20, -65, 32, 43, -21, 31, -41, 5, -21, -18, 30, 33, 57, 34, 60, -26, -61, -29, -38, 38, 31, -40, -30, 44, -31, 2, -10, -19, 61, 61, -9, -51, -32, 46, 19, -30, 61, -54, -58, -5, 0, -12, -40, -71, -63, 45, 4, -69, 39, -62, -8, 70, 50, 38, -18, 2, 27, 20, -30, -87, -2, 15, -33, 27, 24, 47, -3, -8, 3, 53, 60, 4, 25, 8, -22, 35, 32, 52, 80, 2, 28, 27, -21, -14, -14, -15, -64, 21, 34, -55, 61, 35, -39, -29, -31, 56, 33, 2, -23, 5, 46, 27, -41, 37, 19, -33, -14, 22, 41, 44, -26, 5, 19, -54, 46, -3, -56, -24, -54, -25, 15, 90, 14, -32, 8, -11, -21, 42, -45, 56, 3, -12, -29, 37, 16, -47, 17, -62, -69, -22, 45, 39, -14, -19, -58, -54, -27, -58, 41, 33, 2, 75, -27, 31, 27, 19, -33, 9, 9, 31, 13, 63, 58, -43, -58, -37, 6, 43, -12, -24, -15, -59, 42, -42, -29, -3, 38, -27, -25, 79, 33, -16, 8, -44, 1, -55, -12, -35, -16, 67, -11, -12, 14, -4, -46, -42, 15, -13, -15, 47, 52, 6, -23, 27, 39, 5, -17, -55, -11, 68, -32, -28, 5, -47, -26, -34, -26, -17, 12, -71, -18, -31, -65, -6, 22, -60, -51, -23, -32, 51, 7, 3, 30, 43, 47, -60, 41, -33, -22, -33, -9, -28, -5, -43, 27, -14, 9, -20, -37, 36, -42, 55, 65, -2, 72, -1, 29, 18, 43, 41, 15, 29, -8, 53, -4, 37, 13, 63, 35, 35, -23, 49, -20, 21, 0, 39, 18, 7, 32, -34, 49, 61, 24, 39, -58, 15, -50, -23, 9, 31, 36, 56, -15, 23, -49, 74, -35, -23, 34, -7, 71, 34, -14, 58, -54, -20, 18, -23, 8, -38, 62, 55, 37, 7, 40, -30, -18, 32, -22, -26, 62, -41, -10, 38, -25, 17, -48, 16, -17, 22, -51, 38, -25, 70, -57, 59, -45, 37, -35, 45, -24, -38, 14, 23, -51, 1, -66, -38, 30, 37, -62, 62, 4, -10, -35, -33, -23, -53, -25, 1, -38, -17, -36, 56, 49, -11, -41, 56, -87, 53, 9, -2, 0, -64, 44, -4, 19, -36, 58, -39, 7, 43, -10, -45, -11, 60, -17, -56, -20, -56, 18, -31, -19, 19, -30, 8, 1, -37, 47, 3, 58, 20, 74, -34, -48, -34, -31, -40, -24, -33, 1, -50, 62, -20, -48, 42, -16, -22, -55, -12, -31, -75, -65, 50, 48, 54, -15, -36, 16, -1, 26, 41, 40, 67, 6, -16, 49, 48, 29, 17, -63, 45, -68, 59, 34, 46, -67, 24, 8, -16, -5, 44, 3, 69, -47, -33, -56, 2, 50, -37, 17, 0, 12, 46, 53, 12, 30, -28, -29, -13, -62, -58, -54, 33, -51, -25, 48, -26, 70, -52, 8, 68, 26, 56, 12, -6, 19, -11, 55, 27, 36, 69, 87, -11, 27, 60, -33, 32, -29, 4, 37, -61, 60, 45, -33, -21, -30, -2, 25, -67, -36, 48, 45, 49, -67, -28, 14, -21, -16, -19, -43, -16, 11, 34, -66, -64, -28, 30, 46, 58, -46, -7, -9, -27, 7, 72, -74, 62, -64, -37, -20, 33, 42, -17, 44, -65, 43, 0, 9, 37, 26, -90, -5, 51, 28, -4, 46, 58, 65, -17, -61, -14, -50, 20, 25, 35, 14, 54, 46, 34, 45, -19, 54, 43, 42, -2, -54, -43, -20, -34, 28, 44, 50, 65, -44, -28, 49, 71, 0, -8, -24, 18, -46, 32, -26, 49, 64, 67, 13, 62, -16, -27, -69, 1, 5, -55, 66, 78, -39, -31, 10, 55, -68, -28, -20, -7, 56, -50, 40, 13, -5, 33, 57, -7, 4, 35, 49, 37, -39, -49, -12, 47, 33, 30, -11, -69, 10, 28, -52, -24, 15, 61, 21, -75, 28, 8, -39, -24, -48, 14, -40, 18, -55, 48, -33, 49, -14, 27, 31, 37, 48, 58, -54, -42, -8, 57, 69, -51, 23, 8, 42, -22, 82, -24, -48, 3, -23, 4, -43, -7, -8, 14, -62, 36, -4, -51, -15, -3, -34, -68, 59, -13, 47, -25, 9, -16, -57, -22, -44, 5, 65, 53, 50, 48, 55, -5, 3, 57, -56, -15, -23, -25, -38, 47, 27, 29, 42, 28, -34, -15, 27, -26, 13, -18, -40, -72, 28, 44, 27, 43, 11, 41, 57, 15, -43, -71, -36, -40, 60, -34, 17, -68, 50, 12, 30, -23, 73, 1, 54, 26, 13, 37, 15, 47, 38, 41, 1, -17, -75, -11, -12, 40, 36, 4, 51, 39, -32, -25, -40, 8, 33, -62, -65, -22, -5, 19, -56, -51, -28, -75, 9, -41, -25, -38, -12, 36, -69, -31, -18, 35, -60, 7, -11, -26, -61, -13, -50, 0, 19, 13, -18, 18, 3, -21, 11, -1, 45, -52, -7, -40, 46, -40, 54, 4, -53, -26, -37, 25, 1, -17, 31, 10, -19, 16, 36, 30, -7, -80, -48, 25, 9, 43, 51, 43, 42, 13, 22, -54, 39, 39, 42, 47, -57, 22, 25, 28, 9, -47, -25, 16, 32, -30, -12, 56, 64, -67, 37, -56, -23, -47, 64, 22, -53, 16, -14, -28, 62, 48, 21, -56, -47, 36, -69, -39, -51, -39, 25, -49, -87, 56, -43, -38, -22, 80, -72, -32, 28, 43, -64, -71, 3, 12, 26, -18, -10, -9, 16, 42, 36, -67, -38, 31, 37, -40, 28, -34, 26, 63, 6, -9, 32, 44, -12, -33, 24, -27, 12, -8, 59, 75, -10, 46, 62, 1, -28, 8, -20, -16, 5, -16, 49, -28, -53, 49, 52, 7, 27, 35, -16, -60, 63, -11, 76, -22, 18, 25, 50, 33, -9, -24, 39, -5, 21, -37, -12, -56, 68, 23, -9, 11, -67, -12, 59, 26, 16, -28, 45, -44, 7, -52, -25, 1, -53, 29, 
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
  -28, -51, -26, -46, 65, -41, 31, -25, 34, 33, -37, 58, 11, 38, 0, -2, -16, -43, 23, 41, -18, 23, -38, 30, -12, 49, 88, 39, -22, -63, 29, -41, -49, 50, 8, 54, -9, 76, -67, -9, 5, -3, 25, -27, -4, 68, -29, -44, -31, 10, -17, 37, 47, -19, 10, 10, 62, 54, -48, -41, 45, -3, -10, 33, -19, -18, 53, -33, 73, 9, -4, 5, 23, -32, 50, -22, -40, 53, -50, -2, 42, -17, 53, -67, 41, -51, 25, -30, 68, 52, -22, 58, 6, -20, -26, -13, -33, -42, 14, 47, -9, -53, -39, -22, -10, -43, -87, -2, 22, 30, -44, -56, 15, 53, -48, 46, -22, 0, -68, -1, -43, -15, -48, -65, 12, 20, 4, 38, 7, 76, 57, 75, -2, -4, 17, 43, -43, 48, 2, 46, 12, 61, -43, -61, -54, 15, -47, -64, 51, -20, 13, 1, -34, 36, -30, -18, 38, 8, 27, -21, 60, 23, 5, 37, 63, 54, 26, 25, -34, 49, -29, -23, -29, 33, 21, 25, 42, 43, 2, 24, -36, 36, -15, -72, -27, 13, -50, 67, -26, -34, -27, -57, 6, 38, -28, 58, 57, 13, 47, 12, -46, -45, 17, -3, 36, 23, 22, -36, -50, 48, -31, 64, 15, 2, -49, 19, -3, 27, 58, 41, -23, -23, -56, 76, -5, -9, -17, -19, -47, 60, -3, -59, 56, 28, -27, 2, -59, -59, -21, -29, -58, -27, 50, -26, 35, -6, 38, 66, 69, -50, -5, -57, 36, -18, 27, -27, -59, 98, -31, 11, 9, 55, -20, 62, 71, -14, -27, -44, -65, 13, -13, -5, -59, 17, 7, 50, -32, 42, 38, 39, -55, 51, -29, -39, 51, -52, 1, -48, 22, 50, -16, -4, 22, -8, 54, -66, 19, -45, 29, -23, -68, -26, 52, 11, -42, -31, 44, 79, -64, 33, -10, -18, 38, 36, 44, 24, 12, -16, -65, 56, 25, -5, 32, 51, -10, 56, 40, -39, -35, 53, 10, 29, -49, -48, 17, 52, 50, 38, 5, -46, 45, -34, 23, 25, -19, 2, -68, 14, 69, 53, -40, -7, -15, 35, 66, -1, 3, 5, -65, 55, 2, -23, -32, 58, 48, -35, -3, 69, -47, 34, 1, -77, 44, -44, -64, -15, 39, 40, 19, 4, -24, 32, 36, -44, -80, -16, -30, -13, 63, -31, 27, -26, 45, 14, 37, -34, -16, -74, -28, 78, -30, -39, -58, 39, 62, 10, 43, 67, -5, 25, -57, 36, 33, -27, -41, 23, -12, 41, 50, 0, 36, 48, 50, 49, -25, 1, 45, -42, -32, 12, 66, -43, -14, 16, -44, 65, 55, -55, -44, 54, -27, 42, 59, 34, -61, -60, 51, -57, -45, 56, -51, 74, 25, 49, -16, 18, 43, -69, -40, -2, -45, -30, -40, 10, -29, 51, -20, -52, -35, -37, 2, -42, -32, 63, -6, 31, -54, 17, 24, 10, -49, -33, 72, -24, 3, -53, 20, 53, 3, -27, -2, -46, -5, -1, 48, 32, 65, -32, -10, 42, -23, 18, -20, -23, -5, 56, -35, -48, -35, 37, 54, 41, -46, 29, -42, -23, -55, -33, 25, 1, -11, -11, -56, -49, 75, 77, 52, 14, 65, -1, 10, -30, 68, 19, 46, 7, 30, 32, -23, -6, 16, 16, 13, -10, -39, -12, -39, 2, -55, 44, 33, 44, -13, -24, -54, -23, -57, -63, 80, 19, -66, -16, -59, -43, -57, -5, -24, 23, 44, 17, 43, 34, 65, -39, -59, 26, -57, -60, 73, 7, -37, 9, 29, 70, -21, 26, -22, -31, -8, 30, -39, 21, -15, -47, 53, -2, 8, -43, 59, -45, 75, -2, 45, -4, 50, 27, -23, 54, -76, -22, 51, 1, -27, 38, 29, -37, 13, 3, -52, 22, -13, -56, -3, -2, -41, -45, 61, -43, -46, -7, 29, -47, 48, -15, 38, -41, 38, 2, 7, -5, 3, 46, -17, -49, 17, 22, -49, -56, 68, 11, 61, -20, 12, -16, 1, 0, 38, -44, 15, -33, 8, -33, 36, -17, -14, -7, -6, 14, 16, -48, 29, -43, 45, -25, -33, -35, 39, -54, -9, 38, 25, 51, 40, -53, -53, 13, 50, -25, -21, 29, -28, 25, 37, 18, 42, -32, 15, -43, -40, -34, -55, 52, -2, 33, 59, -3, -54, 11, -34, -32, -20, 69, 11, -25, -21, -53, -65, -5, 32, -49, -53, -18, 25, -35, 9, 75, 8, 64, -14, -50, -49, 64, 14, 57, 3, 20, 16, -3, 53, 32, -8, -39, -15, -25, 67, -25, 32, 49, 52, -3, 37, 1, 22, -17, 64, -44, 21, -39, -8, 2, 12, -55, -33, -41, 18, -56, -14, -33, 74, -1, 36, -4, -51, -42, 61, 62, 29, -6, -21, -30, 7, 16, -48, -37, 5, 48, -13, 43, -34, -11, 61, 43, 18, -30, 41, 57, 20, -16, 43, 1, 6, -14, 2, 68, 16, 64, 17, -26, 40, 8, 42, 64, 23, -41, 33, -37, -33, 14, 16, -38, 49, -15, 47, -64, -17, 51, 20, -62, -30, -12, 44, -27, 81, 46, 53, -47, -17, 43, 55, 20, -11, -8, -7, -45, 22, 38, -18, -23, -51, -68, 21, 46, -39, -41, 41, 33, 31, 27, 55, 45, -26, 63, 23, -54, -19, -45, 17, 9, 42, 31, -2, 55, 10, -30, 55, 72, 0, 9, -38, 52, -31, -56, 39, -61, -1, -14, 22, 31, 12, 27, -32, 46, -44, -9, -64, 24, 65, -53, -10, -31, 64, -55, 10, 49, 22, -11, 18, -9, -32, 26, 54, 19, -22, 42, -36, 22, -19, -51, 33, 12, 42, 6, -64, 59, -45, -33, 19, 6, 46, 63, 66, -39, -40, 18, -2, -22, -22, 20, -19, -56, 63, -17, -16, 7, 4, -56, 0, -19, 58, 37, -39, 34, -54, -65, -33, 49, 33, -52, -16, -57, -35, 5, -30, 28, 34, -16, 29, -21, 28, -16, -28, 20, 7, -26, -13, -50, -12, 65, 35, 52, 37, -3, -57, 25, -31, -38, -61, 17, -10, -60, -23, 36, 4, -13, -37, -51, 65, -42, 19, -9, -14, -2, 4, 37, 53, -14, 23, -60, 51, 2, -30, 40, 52, -27, -57, 29, 11, 2, 43, -30, -45, 54, 0, 50, 66, 42, 27, 25, -6, 3, -48, 62, 47, 54, 31, 36, -3, -26, 27, 66, -41, -14, 40, -20, -9, -75, 23, -38, 66, -5, 6, -8, 66, 13, -48, 63, -57, -49, -35, -24, 69, 63, -26, -44, -49, -16, 52, -66, -56, 26, 15, 26, -40, -37, 6, 55, 58, 64, 30, 30, -7, -4, -28, 1, -42, -25, -62, 22, -40, -32, 37, 49, 3, 33, 77, 14, 51, 53, -44, -9, -51, -85, -3, 44, 26, -21, -44, 1, 50, -58, 13, 23, 3, 11, 39, 47, 34, 25, -44, -22, -44, 2, 15, 7, -21, -43, -6, -13, 6, -42, 22, -16, 42, 59, 26, 40, -26, 18, 40, -26, 24, 65, 23, 13, 31, -1, 1, -8, 26, -34, 18, 67, -11, 49, -11, 0, 68, -80, -39, 5, 52, 2, 51, -18, 25, -46, 4, -51, -22, -20, -44, 53, -4, -10, 57, 24, 77, 64, -27, 67, -24, -31, 62, -11, 66, 30, -39, -13, 16, 39, -33, 28, 20, 39, -72, 69, 30, 4, -21, 59, 3, 51, 31, 47, 48, -43, 45, 37, -18, 0, 68, 2, 52, -4, -57, 29, -45, -13, -18, -61, -41, -4, 30, 43, -29, 5, 26, 36, -33, -56, -38, 42, 39, -36, 21, -28, -80, -20, -72, 33, -55, -26, -29, -39, -48, 24, -53, -27, -34, -8, -4, 41, -25, 11, -43, -30, -36, -68, 51, -28, -18, 38, -57, -21, 14, -66, 46, 25, -46, 53, -57, -13, 5, -21, -36, 25, -3, -13, 6, 5, 
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
};
const TfArray<2, int> tensor_dimension30 = { 2, { 16,1280 } };
const TfArray<1, float> quant30_scale = { 1, { 0.0010470525594428182, } };
const TfArray<1, int> quant30_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant30 = { (TfLiteFloatArray*)&quant30_scale, (TfLiteIntArray*)&quant30_zero, 0 };
const ALIGN(8) int8_t tensor_data31[2*144] = { 
  -38, -23, -54, -54, 83, 3, 111, -7, 20, -58, -76, -54, 81, -39, 84, -24, -81, -11, 67, 5, 65, -35, 95, -58, -63, 102, 14, -98, -49, -121, 14, 4, 1, 66, 19, 24, -6, -93, 72, 59, -25, -8, 36, 19, 17, -70, -60, -35, 81, 17, -22, -89, -29, 100, 54, -48, -94, -96, 31, 102, 84, 46, -51, 74, -98, -25, -70, -23, 43, -56, -56, -61, -117, -15, -6, -3, 65, -25, -78, -98, 80, -4, -76, 0, -26, 92, -27, 66, -6, -86, 80, -10, 50, 32, 33, -87, -4, 18, -89, -11, 8, 15, -39, 30, -15, 79, -59, -12, -29, 35, 94, -81, -14, 3, -107, -64, 22, 14, 84, -61, -53, 26, 65, 53, 43, -119, -74, -81, -4, 91, -3, -103, 54, 100, -17, -61, -92, 46, -7, 113, -72, -28, -97, -68, 
  73, 113, -64, -56, 15, 80, -10, -35, 73, -102, -81, 52, -75, 16, 37, 75, -75, 97, 88, 65, -56, 1, -31, 51, 111, -37, -75, -67, 35, 121, 101, -84, 21, 19, -51, 55, -62, 42, -58, -8, -8, -30, 47, 55, 58, -26, 113, 51, -85, -30, 72, -58, 96, 9, -73, 38, 10, -50, -66, 67, -53, 12, -31, -84, -66, 100, 71, 59, -13, -42, 8, -56, 17, 9, -51, -83, -89, 69, -74, -62, 5, 58, -18, 68, 37, 46, 21, 106, 4, -30, -21, -26, 79, 127, -35, -43, -52, 19, 7, -39, -60, -122, -8, -27, -19, 57, -69, -62, 4, 53, 10, 94, 30, -34, -25, 73, -93, -67, -43, 106, -50, 20, 32, -100, -5, -6, -76, -37, 41, 70, 62, 26, -90, -47, -54, 6, -25, 85, -32, -106, -7, 50, 42, -8, 
};
const TfArray<2, int> tensor_dimension31 = { 2, { 2,144 } };
const TfArray<1, float> quant31_scale = { 1, { 0.0020510295871645212, } };
const TfArray<1, int> quant31_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant31 = { (TfLiteFloatArray*)&quant31_scale, (TfLiteIntArray*)&quant31_zero, 0 };
const ALIGN(8) int32_t tensor_data32[48] = { 4471, 8101, 26414, 2667, 4228, -2754, 10164, 24036, 7368, -1376, 6667, -3957, 36197, -3064, 3312, 33078, -607, 3734, 227, 4828, 5693, 5609, 835, 48819, 11294, 6878, 22278, 2669, 11262, 9929, 957, 1770, 1641, 2820, -461, 418, -5142, -856, 4541, 3996, 7064, 3600, 6424, 7865, 8820, 6004, 3138, 10526, };
const TfArray<1, int> tensor_dimension32 = { 1, { 48 } };
const TfArray<48, float> quant32_scale = { 48, { 0.00013550164294429123, 0.00010153102630283684, 3.6760997318197042e-05, 0.00010917161125689745, 0.00011991173232672736, 0.00014609057689085603, 7.7865544881206006e-05, 4.0289083699462935e-05, 7.8143850259948522e-05, 0.00014340544294100255, 0.00012209583655931056, 0.00012240406067576259, 2.7030029741581529e-05, 0.00014323121285997331, 0.00014016171917319298, 3.1776624382473528e-05, 0.00017982689314521849, 0.00011646416533039883, 0.00017188813944812864, 0.0001255932729691267, 0.00012449581117834896, 0.00013236142694950104, 0.00021427999308798462, 2.2531054128194228e-05, 7.5040719821117818e-05, 8.3679798990488052e-05, 4.583673580782488e-05, 0.00015151973639149219, 6.9601133873220533e-05, 7.6427102612797171e-05, 0.00029453352908603847, 0.00023974051873665303, 0.00012167636305093765, 0.00013424686039797962, 0.00017014071636367589, 0.00017701875185593963, 0.00011181259469594806, 0.00017417587514501065, 0.00012831219646614045, 0.00013252410280983895, 0.00011059932876378298, 0.00014001976524014026, 0.0001257774856640026, 0.00010321753507014364, 8.4317543951328844e-05, 0.00011808879935415462, 0.00020620755094569176, 7.8488948929589242e-05, } };
const TfArray<48, int> quant32_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant32 = { (TfLiteFloatArray*)&quant32_scale, (TfLiteIntArray*)&quant32_zero, 0 };
const ALIGN(8) int32_t tensor_data33[48] = { 3, 11754, -364, -472, 1303, -1510, 2550, -1784, -4633, 116, -8082, -141, 88, -1133, -2674, 4818, 7128, 2393, -4, -4569, -8108, 336, 20258, -5919, -2176, -872, 4870, -7964, -210, -146, -9350, 10231, 6002, -226, 4348, -103, -5, -500, 11379, 209, 7056, -3029, 3360, 7136, -976, 10114, -360, 338, };
const TfArray<1, int> tensor_dimension33 = { 1, { 48 } };
const TfArray<48, float> quant33_scale = { 48, { 0.00023024564143270254, 0.00013752499944530427, 0.00078236585250124335, 0.00019281628192402422, 0.00020316329027991742, 0.00024145736824721098, 0.00022185483248904347, 0.00027089181821793318, 8.1704019976314157e-05, 0.00023989600595086813, 0.00017818933702073991, 0.0011697270674631, 0.00043005653424188495, 0.00048758229240775108, 0.00033379803062416613, 0.00055286177666857839, 0.00016120111104100943, 5.420566230895929e-05, 0.00019551864534150809, 0.00025795746478252113, 0.00024637265596538782, 0.00019517629698384553, 7.4899064202327281e-05, 0.00040031291428022087, 0.00015787848678883165, 0.00035049914731644094, 0.00042435302748344839, 0.00017647455388214439, 0.00026434625033289194, 0.00029602454742416739, 0.00012217728362884372, 0.00010621968249324709, 0.00012025079922750592, 0.00018075716798193753, 0.00012464605970308185, 0.00025282526621595025, 0.0018225101521238685, 0.00030099850846454501, 0.00012735099880956113, 0.00015006904141046107, 0.00014583728625439107, 0.00012476365373004228, 0.00026032919413410127, 0.00016849784879013896, 0.00028547117835842073, 7.9245102824643254e-05, 5.5597356549696997e-05, 0.00015519262524321675, } };
const TfArray<48, int> quant33_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant33 = { (TfLiteFloatArray*)&quant33_scale, (TfLiteIntArray*)&quant33_zero, 0 };
const ALIGN(8) int32_t tensor_data34[48] = { 3171, -1813, 1174, -3218, 5782, -1108, 6193, -5596, 1816, 980, 3263, 6861, 604, -688, 1001, 6707, -3009, 5362, 8364, 1185, -1258, 3794, -1380, 7435, 3211, 2788, 1811, -1307, 12721, -570, 3918, -3333, -1240, 6162, -1729, 3223, 2943, 1405, 604, 6459, 2746, 12425, -6725, 2381, 10727, 135, 3676, 4115, };
const TfArray<1, int> tensor_dimension34 = { 1, { 48 } };
const TfArray<48, float> quant34_scale = { 48, { 0.00013797650171909481, 0.00018914449901785702, 0.0001901149662444368, 0.00014322360220830888, 0.00013426190707832575, 0.0001394378487020731, 0.00012046883057337254, 9.7595737315714359e-05, 0.0001680343848420307, 0.00018776750948745757, 0.00012562925985548645, 0.00011269180686213076, 0.00019356698612682521, 0.00019036378944292665, 0.00016529222193639725, 0.00011585221363930032, 0.00014873230247758329, 0.00014176765398588032, 0.00010574380576144904, 0.00019802639144472778, 0.00018395933147985488, 0.00014409729919862002, 0.00012543688353616744, 0.00010758387361420318, 0.00014128704788163304, 0.00014213101530913264, 0.00017770081467460841, 0.00018124787311535329, 7.1869901148602366e-05, 0.00019089436682406813, 0.00011733341671060771, 0.0001063564486685209, 0.00012590996630024165, 0.00012606660311575979, 0.00013782645692117512, 0.00016338845307473093, 0.00014783555525355041, 0.00017068527813535184, 0.00014579056005459279, 0.00011894724593730643, 0.00018688759882934391, 7.1373433456756175e-05, 8.323576912516728e-05, 0.00017697831208352, 7.9569697845727205e-05, 0.00016665025032125413, 0.0001517345808679238, 0.00014510381151922047, } };
const TfArray<48, int> quant34_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant34 = { (TfLiteFloatArray*)&quant34_scale, (TfLiteIntArray*)&quant34_zero, 0 };
const ALIGN(8) int32_t tensor_data35[16] = { 31814, -655, -619, 3785, -1084, 320, 11515, 1856, 966, 346, -2543, 3509, 662, -533, -404, -1290, };
const TfArray<1, int> tensor_dimension35 = { 1, { 16 } };
const TfArray<16, float> quant35_scale = { 16, { 7.1170601586345583e-05, 0.00016493663133587688, 0.00016153792967088521, 0.00016674023936502635, 0.00082636094884946942, 0.00060049805324524641, 0.00014297901361715049, 0.00059892528224736452, 0.00020516106451395899, 0.00078744243364781141, 0.00017562953871674836, 0.0001593414053786546, 9.0096509666182101e-05, 0.00019653268100228161, 0.00017112545901909471, 0.00047782872570678592, } };
const TfArray<16, int> quant35_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant35 = { (TfLiteFloatArray*)&quant35_scale, (TfLiteIntArray*)&quant35_zero, 0 };
const ALIGN(8) int32_t tensor_data36[48] = { 14921, -1188, 20250, -111, 15825, -1861, 34450, 258, 11374, 33781, 1952, 24099, 285, 13052, 37374, 23460, -73, 792, 2340, 48182, -161, 20494, 723, 17299, 18252, 34433, -254, -1025, -1926, 14486, 22404, -84, -294, 88, 25, 17062, 11120, 31775, 3019, 17254, 28363, 1534, 1358, 17066, 496, 446, 41448, 25050, };
const TfArray<1, int> tensor_dimension36 = { 1, { 48 } };
const TfArray<48, float> quant36_scale = { 48, { 8.0268597230315208e-05, 0.00012193722068332136, 5.9266687458148226e-05, 0.00010875584121095017, 0.00010317203850718215, 8.1448386481497437e-05, 5.9515019529499114e-05, 0.00024605021462775767, 9.8660886578727514e-05, 6.4266801928170025e-05, 6.405166641343385e-05, 0.00010303130693500862, 7.5551026384346187e-05, 9.335471986560151e-05, 4.5637330913450569e-05, 8.3730745245702565e-05, 0.00010270823986502364, 6.4453197410330176e-05, 0.00014446968270931393, 4.5522261643782258e-05, 7.065980025799945e-05, 5.7261633628513664e-05, 9.4849201559554785e-05, 0.00010449614637764171, 6.159120675874874e-05, 7.2472190367989242e-05, 6.4355175709351897e-05, 4.279146742192097e-05, 0.0002337110199732706, 9.8796852398663759e-05, 5.6509612477384508e-05, 0.00029276512213982642, 0.00012378135579638183, 0.00017326734086964279, 0.00010150346497539431, 6.7666202085092664e-05, 0.00010010922414949164, 5.6431726989103481e-05, 8.1115686043631285e-05, 0.00010187480802414939, 5.0768881919793785e-05, 0.00015931323287077248, 0.00016446346126031131, 5.8651610743254423e-05, 0.00015786394942551851, 6.7353197664488107e-05, 4.7340890887426212e-05, 5.6608067097840831e-05, } };
const TfArray<48, int> quant36_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant36 = { (TfLiteFloatArray*)&quant36_scale, (TfLiteIntArray*)&quant36_zero, 0 };
const ALIGN(8) int32_t tensor_data37[96] = { 1904, 9750, 440, 2474, 7316, 22281, 227, 3490, 18973, -1601, 26898, 6595, 2840, 633, 8930, 587, 4876, 7142, -455, 20142, 1536, 13074, -2440, 2646, -14557, 2022, 3536, 2617, 9690, 1710, 5504, 6581, 2673, 18278, 5207, 5697, 6068, 3057, 6509, 3623, 26699, 2129, 3382, 2325, 4544, 16410, 10926, 11012, 1722, -1697, 2635, 9036, 3653, -4891, 11493, 212, 3471, 24722, 2230, 2491, 4024, 15127, 4977, -420, 27915, 21367, 2496, 5792, 9948, 7996, 3075, 2659, -5915, 5915, 2519, 4068, 692, 13925, 5251, 8474, 4457, 1854, 7499, 24327, -79, 17316, 8371, 2443, -853, 3443, 1831, 16041, 4649, 4922, 9029, 7645, };
const TfArray<1, int> tensor_dimension37 = { 1, { 96 } };
const TfArray<96, float> quant37_scale = { 96, { 0.00016508020053151995, 7.7930752013344318e-05, 0.00019184300617780536, 0.00015352659102063626, 8.8900182163342834e-05, 4.1904990212060511e-05, 0.00015862392319831997, 9.2186230176594108e-05, 4.6675930207129568e-05, 0.00010890636622207239, 3.1519215553998947e-05, 7.4029056122526526e-05, 0.00011154084495501593, 0.00026711120153777301, 6.3159503042697906e-05, 9.7324184025637805e-05, 0.00012127300578868017, 8.75114492373541e-05, 9.6918563940562308e-05, 4.4477896153694019e-05, 0.00015996514412108809, 5.8456713304622099e-05, 0.00010224736615782604, 9.737480286275968e-05, 5.1030543545493856e-05, 9.3817783636040986e-05, 0.00014004051627125591, 0.00013604275591205806, 8.9013963588513434e-05, 0.00015046489716041833, 0.00010509851563256234, 8.2642436609603465e-05, 0.00015481094305869192, 4.7355097194667906e-05, 9.9366770882625133e-05, 0.00010784886399051175, 9.7276890301145613e-05, 0.00013826486247126013, 7.7102973591536283e-05, 0.00011550819908734411, 3.5536853829398751e-05, 0.00012963858898729086, 0.00011147112672915682, 8.4477229393087327e-05, 8.4084051195532084e-05, 5.1503742724889889e-05, 6.4847772591747344e-05, 6.9438334321603179e-05, 0.00016173985204659402, 0.0001285379403270781, 0.00014964227739255875, 7.8503137046936899e-05, 0.00013182437396608293, 8.3377024566289037e-05, 6.5038235334213823e-05, 0.00024608263629488647, 9.7035328508354723e-05, 3.55729935108684e-05, 8.7571599578950554e-05, 0.00011438631918281317, 0.00010849204409169033, 5.637014692183584e-05, 0.00012498331489041448, 0.00015903468010947108, 3.4477594454074278e-05, 4.2330928408773616e-05, 0.0001681456487858668, 0.0001032806612784043, 7.7999655331950635e-05, 6.4044368627946824e-05, 0.00015854573575779796, 8.6684929556213319e-05, 9.6913579909596592e-05, 0.00010830534301931038, 0.00014961848501116037, 0.00015323268598876894, 0.00011448225268395618, 5.8528112276690081e-05, 0.00011080298281740397, 9.8790529591497034e-05, 9.8638622148428112e-05, 8.7240172433666885e-05, 6.721265526721254e-05, 3.9170925447251648e-05, 9.9709803180303425e-05, 4.3043350160587579e-05, 8.3672566688619554e-05, 0.00016771728405728936, 0.00016015590517781675, 0.00016424946079496294, 0.0001139989253715612, 5.4194100812310353e-05, 0.00010989361180691049, 8.478951349388808e-05, 6.141794438008219e-05, 8.3616119809448719e-05, } };
const TfArray<96, int> quant37_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant37 = { (TfLiteFloatArray*)&quant37_scale, (TfLiteIntArray*)&quant37_zero, 0 };
const ALIGN(8) int32_t tensor_data38[96] = { 11609, -1095, -6536, 7944, 515, 1784, 162, -1142, 2196, -4565, -79, -2148, 12152, -3699, -2015, -7894, -6, 77, -13123, 61, -3362, 151, -8983, 20, 50, 10520, -11672, -5915, -26, -3693, -172, -865, 22926, 191, -2823, -181, -39, 15858, 4032, 12172, -337, 7031, -25, 7267, 489, -86, 10470, 1783, -6456, 14, -4096, 52, -227, -4129, 446, 2443, 642, 2527, 520, 1789, -165, -251, -84, 9513, 9733, 210, 16727, 12798, -849, 84, 11543, -1258, -1, 957, -4961, -65, 22391, 11703, 13075, 14257, 17775, -1842, 9688, 9734, -1459, -879, 11499, -8587, 12672, 187, -9802, -1135, -242, 904, 26801, -1946, };
const TfArray<1, int> tensor_dimension38 = { 1, { 96 } };
const TfArray<96, float> quant38_scale = { 96, { 8.6538675532210618e-05, 0.00025349089992232621, 0.00014307485253084451, 0.00012462554150260985, 0.00019613807671703398, 0.00043808339978568256, 8.6648542492184788e-05, 0.00017972866771742702, 0.00036849791649729013, 0.00022239732788875699, 0.00026558793615549803, 0.00018539623124524951, 8.1124489952344447e-05, 0.00013778737047687173, 0.00021151435794308782, 0.0001521228114143014, 0.00026937326765619218, 0.00029109697788953781, 9.1738198534585536e-05, 0.00035212576040066779, 0.00018540829478297383, 0.00021831516642123461, 6.5691514464560896e-05, 0.00015491699741687626, 0.0017455557826906443, 0.00010996385390171781, 0.00020355838933028281, 0.00013137332280166447, 0.00027154257986694574, 0.00014790626300964504, 0.00016040333139244467, 0.00029890332370996475, 5.1899198297178373e-05, 0.00044204414007253945, 0.00012904132017865777, 0.00017348024994134903, 0.00028926710365340114, 6.8892019044142216e-05, 0.00018574060231912881, 8.8504624727647752e-05, 0.00052346504526212811, 0.00016251859779004008, 0.00019644231360871345, 0.00011583366722334176, 0.00013340955774765462, 0.000263238325715065, 0.00011555233504623175, 0.00022991430887486786, 0.00016655700164847076, 0.00042505914461798966, 0.00024747225688770413, 0.00017542915884405375, 0.00012055615661665797, 0.00022872386034578085, 0.00024530838709324598, 0.00021879329869989306, 0.00015191789134405553, 0.00037335103843361139, 0.00038919498911127448, 0.0002638855658005923, 0.0002393617614870891, 0.00023208558559417725, 0.00012689224968198687, 9.7913885838352144e-05, 0.00023729595704935491, 0.000397167430492118, 9.8348158644512296e-05, 0.00011032846668967977, 0.00020907761063426733, 0.00031892050174064934, 9.7907657618634403e-05, 0.00025845435447990894, 0.00044376033474691212, 0.00014831895532552153, 0.00013383623445406556, 0.00017895923519972712, 5.9571608289843425e-05, 0.00013322338054422289, 0.00010336138802813366, 0.00013486595707945526, 5.8943423937307671e-05, 0.00025487368111498654, 8.7496780906803906e-05, 0.00026728457305580378, 8.6926862422842532e-05, 0.00029910699231550097, 0.0001169708848465234, 0.00019279414846096188, 8.6543790530413389e-05, 0.00018991100660059601, 8.1929298175964504e-05, 0.00020274132839404047, 0.00026932172477245331, 0.00014384168025571853, 5.6023967772489414e-05, 0.000254486920312047, } };
const TfArray<96, int> quant38_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant38 = { (TfLiteFloatArray*)&quant38_scale, (TfLiteIntArray*)&quant38_zero, 0 };
const ALIGN(8) int32_t tensor_data39[96] = { 9134, 4519, 1287, -1550, 6512, 13805, 11511, 2230, -360, 13593, 1230, -5742, 5032, 4084, 628, -827, 4370, 11330, -636, 42, 5403, 16752, 11794, -2150, -4540, -1244, 17153, 20, 2075, 1578, 12809, -2222, 12480, 3155, 5295, -5236, 1159, -7330, 191, 2469, 3565, 1783, 2107, -479, 1169, 2598, 5365, 4987, 5573, 3525, 6853, 4009, -3044, 2063, 1557, 3006, 2729, 3530, 9367, 1575, -1312, 8009, 5722, 4701, 5426, 9413, -5942, 3782, 7324, -821, 8116, 2168, 4414, 4640, 4861, 2952, -476, 2453, 3578, 4412, 3829, 4667, 11661, 1127, 3366, 5304, 913, -1091, 20203, -500, 851, -1619, 14831, 3743, -13, -1431, };
const TfArray<1, int> tensor_dimension39 = { 1, { 96 } };
const TfArray<96, float> quant39_scale = { 96, { 8.1114711065310985e-05, 8.0128127592615783e-05, 0.00012367749877739698, 0.0001330527156824246, 0.00010659350664354861, 5.8230325521435589e-05, 7.2025068220682442e-05, 0.00012386679009068757, 0.00011557253310456872, 5.7553777878638357e-05, 0.00015287419955711812, 8.4432795119937509e-05, 0.0001048790363711305, 0.00011511507182149217, 0.00011578930570976809, 0.00010661193664418533, 0.00013753499661106616, 6.5818407165352255e-05, 0.00010023961658589542, 0.00013182239490561187, 0.00011145860480610281, 5.3517745982389897e-05, 7.3788643931038678e-05, 0.00012536787835415453, 0.00011993543012067676, 0.00011362347868271172, 5.2249361033318564e-05, 9.6589079475961626e-05, 0.00011972295033046976, 0.00011813359014922753, 6.4888226916082203e-05, 0.00012326463183853775, 6.2928018451202661e-05, 0.00014961257693357766, 0.00013238715473562479, 0.00011681060277624056, 0.00012026922195218503, 8.2032645877916366e-05, 0.0001235779927810654, 0.0001264083111891523, 0.00012585405784193426, 0.00013772789679933339, 0.00016283131844829768, 0.00016825820785015821, 0.00020082823175471276, 0.00014521802950184792, 0.00010442108759889379, 0.00012542201147880405, 0.0001042761723510921, 0.00014547823229804635, 0.00010384229244664311, 0.00010635681246640161, 0.00012073665857315063, 0.00017187725461553782, 0.00015234271995723248, 0.00013502129877451807, 0.00012325322313699871, 0.00010787973587866873, 8.8407527073286474e-05, 0.00013766853953711689, 0.00016049308760557324, 9.0525049017742276e-05, 9.9449156550690532e-05, 0.00012761299149133265, 0.00010380599269410595, 7.9001561971381307e-05, 9.80379045358859e-05, 0.00011241532047279179, 8.4268482169136405e-05, 0.00015262540546245873, 8.4767540101893246e-05, 9.5102237537503242e-05, 9.8081320174969733e-05, 8.9846194896381348e-05, 0.00011149876081617549, 9.183612564811483e-05, 0.00016016147856134921, 0.00014347428805194795, 0.00010598652443150058, 0.00011830068251583725, 0.00011393651220714673, 9.4175353297032416e-05, 6.5632113546598703e-05, 0.00010069454583572224, 0.0001043838492478244, 0.00012690619041677564, 0.00014464075502473861, 0.0002043312560999766, 4.6433771785814315e-05, 0.00014396166079677641, 0.00019584708206821233, 0.00013577987556345761, 5.7979552366305143e-05, 0.00010967838170472533, 0.00016042255447246134, 0.00010376798309152946, } };
const TfArray<96, int> quant39_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant39 = { (TfLiteFloatArray*)&quant39_scale, (TfLiteIntArray*)&quant39_zero, 0 };
const ALIGN(8) int32_t tensor_data40[96] = { -59, -323, -2796, -4673, -563, 2352, -86, -538, -365, -1280, 9588, -2013, -304, 10682, 8664, -4696, 14253, 1923, -4708, 340, -1054, -1823, 1300, -1985, 536, -3987, -374, -4743, -9, -8539, 124, -52, 12151, 25, -1075, -81, -21, -1520, -964, 7830, 11, -231, 1017, -5991, 13231, 14232, -22, 16412, -658, 14430, 14366, -4059, -823, -34, 17, 11557, -302, -59, 16173, 6679, 8652, 12357, 7647, -7989, 527, 1271, -2125, 3475, -3418, -2083, 1086, 1506, 13603, -22, -553, 10714, -730, -51, 9763, -107, -235, 18395, -646, 1807, 20639, 1444, -4156, -2670, -26, -5905, 12420, 56, 33, -198, -5211, -2979, };
const TfArray<1, int> tensor_dimension40 = { 1, { 96 } };
const TfArray<96, float> quant40_scale = { 96, { 0.00025213247863575816, 0.0001726416521705687, 0.00012581449118442833, 0.00016547211271245033, 0.00025812123203650117, 0.00030478616827167571, 0.00030304785468615592, 0.00019785953918471932, 0.00023512874031439424, 0.00016012159176170826, 9.685345139587298e-05, 0.00034140248317271471, 0.00026801475905813277, 0.00011428618017816916, 0.00011981862189713866, 0.00013998552458360791, 0.00010606589785311371, 0.00023111373593565077, 0.00018098505097441375, 0.00011948903556913137, 0.00017365782696288079, 0.00028548584668897092, 0.00020968166063539684, 0.00019392352260183543, 0.00072195252869278193, 0.00019864835485350341, 0.00026609166525304317, 0.00012268920545466244, 0.00020057304936926812, 7.3073344537988305e-05, 0.00032048887806013227, 0.00021422322606667876, 0.00013886949454899877, 0.00018890135106630623, 0.00028842754545621574, 0.00034217818756587803, 0.00018662124057300389, 0.00031075318111106753, 0.00030317433993332088, 0.00011581637227209285, 0.0001967812713701278, 0.00024090390070341527, 0.00022878522577229887, 0.00010660683619789779, 9.3453854788094759e-05, 9.4140814326237887e-05, 0.0002225888310931623, 0.00010613146150717512, 0.00021023971203248948, 8.4923718532081693e-05, 9.6876399766188115e-05, 0.00012538688315544277, 0.0001932181476149708, 0.00015354545030277222, 0.00022072666615713388, 0.00012652300938498229, 0.00019810038793366402, 0.00021535893029067665, 0.00014697425649501383, 0.00013343369937501848, 0.00013809418305754662, 0.00017173209926113486, 0.00014658000145573169, 0.00010688939801184461, 0.00019286155293229967, 0.00023890084412414581, 0.0002921867708209902, 0.00020753977878484875, 0.00022482831263914704, 0.00017636998381931335, 0.00025697692763060331, 0.00016098117339424789, 0.00010880416084546596, 0.00023085271823219955, 0.00028879017918370664, 0.00010427130473544821, 0.00015568944218102843, 0.00021505674521904439, 0.00012339424574747682, 0.00022089392587076873, 0.00026068612351082265, 8.8554967078380287e-05, 0.00026281987084075809, 0.00018531447858549654, 5.907271770411171e-05, 0.0002055290387943387, 0.00013943873636890203, 0.00025382806779816747, 0.00025085915694944561, 0.00020659633446484804, 9.9868972029071301e-05, 0.00039317546179518104, 0.00021569484670180827, 0.0002732364519033581, 0.00013722848962061107, 0.00035285894409753382, } };
const TfArray<96, int> quant40_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant40 = { (TfLiteFloatArray*)&quant40_scale, (TfLiteIntArray*)&quant40_zero, 0 };
const ALIGN(8) int32_t tensor_data41[96] = { 1830, -68, 4155, 6807, 6468, -2522, 5141, -1573, -2978, -844, 6021, -3547, 5428, 8545, 2495, 2657, -648, -598, -2057, 7632, 2849, -827, 3381, -635, -1236, 4292, 1691, 2699, 5110, 2936, 5983, 1554, 1586, 7128, 6268, 4637, -526, 4840, 3110, -4832, -443, 1683, -21, 2293, -1506, 527, -1869, 955, -9681, 2147, 1585, -4055, 8531, -1312, 2348, 1716, 1394, 3092, -876, -2782, 323, 2035, 434, 5499, 7434, 4912, 3652, 6192, 4776, -1052, 4226, 6258, 4583, -2327, 6563, 8461, 1100, -4602, 763, 1602, 12779, 2239, -580, -3538, 1549, 967, 1801, -2867, 3773, -588, 4358, 1614, 25, -3911, -230, 2130, };
const TfArray<1, int> tensor_dimension41 = { 1, { 96 } };
const TfArray<96, float> quant41_scale = { 96, { 0.00010391053365310654, 0.0001797827280825004, 0.00013766389747615904, 0.00011109782644780353, 9.651214350014925e-05, 0.00015727771096862853, 0.00011444030678831041, 0.00015487549535464495, 0.00013542993110604584, 0.00016352906823158264, 0.00010697893594624475, 0.00012627065007109195, 0.000101972691481933, 6.9671354140155017e-05, 0.00012168284592917189, 0.00015400692063849419, 0.00022657889348920435, 0.00014870559971313924, 0.00013946356193628162, 8.0650024756323546e-05, 0.00014927954180166125, 0.00012712915486190468, 0.00010500117787159979, 0.00016514294838998467, 0.0001860044285422191, 0.00014277933223638684, 0.00016673495701979846, 0.00012887216871604323, 0.0001393277634633705, 0.00014257116708904505, 8.6840271251276135e-05, 0.00015691477165091783, 0.00018626864766702056, 8.798890485195443e-05, 0.00010265991295455024, 0.0001050658684107475, 0.00015693028399255127, 9.5156414317898452e-05, 0.00012655662430915982, 0.0001067212360794656, 0.00013692832726519555, 0.00012986775254830718, 0.00014878994261380285, 0.00011885719140991569, 0.00015158858150243759, 0.00014063040725886822, 0.00013562708045355976, 0.00014870267477817833, 7.2562550485599786e-05, 0.00011924657155759633, 0.00015595540753565729, 0.00012106370559195057, 8.6828404164407402e-05, 0.00012988009257242084, 0.00014652710524387658, 0.00014034949708729982, 0.00013227944145910442, 0.00012844784941989928, 0.00017936213407665491, 0.00010817378642968833, 0.00016522310033906251, 0.00012737423821818084, 0.00018760144303087145, 0.0001190226394101046, 9.1002082626800984e-05, 9.4953073130454868e-05, 0.00011277065641479567, 0.00011633732356131077, 0.00013903572107665241, 0.00013901325291953981, 0.00011234611883992329, 0.00011107834870927036, 0.00010306063632015139, 0.00010505087266210467, 0.0001089862416847609, 9.4202783657237887e-05, 0.00010653769277269021, 0.00013195190695114434, 0.0001385132345603779, 0.00012491022062022239, 6.6989356128033251e-05, 0.00012701493687927723, 0.00014866754645481706, 0.00012084451009286568, 0.00013566439156420529, 0.00011727579840226099, 0.00015110644744709134, 0.00013704491721000522, 0.00016840716125443578, 0.0001443242363166064, 0.0001367145887343213, 0.00014074576029088348, 0.00012453657109290361, 0.00010907978139584884, 0.00019705758313648403, 0.00011822536180261523, } };
const TfArray<96, int> quant41_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant41 = { (TfLiteFloatArray*)&quant41_scale, (TfLiteIntArray*)&quant41_zero, 0 };
const ALIGN(8) int32_t tensor_data42[96] = { 535, 17054, 556, 22874, 25909, -49, 17514, -126, -1575, 119, 27941, 2779, -1, -1271, 15507, -676, -208, 23592, -4, 26758, 36135, 74, 29418, 3567, 17, 18783, 140, 1079, -1130, 1279, 1961, 21349, 17435, -676, 19853, 22014, 1065, 22439, 21652, -125, 8, -103, 717, 1897, 17826, -210, 2173, 10, 1772, 22907, 472, -334, -916, 739, -359, 20157, 942, 20700, -567, -335, -215, 15237, 539, 22769, 390, 1586, 20699, 227, 30679, 526, 27734, -94, 1372, -7875, 20886, 30588, 29833, 1042, 24896, -103, -1, 34669, 9, -931, 19948, 17801, -1238, -70, 32422, 28521, 33958, -92, 454, -304, 16595, 804, };
const TfArray<1, int> tensor_dimension42 = { 1, { 96 } };
const TfArray<96, float> quant42_scale = { 96, { 7.8892444435041398e-05, 6.9886598794255406e-05, 6.1788203311152756e-05, 8.0993944720830768e-05, 6.4834006479941308e-05, 9.1562949819490314e-05, 6.3581683207303286e-05, 7.2714909038040787e-05, 0.00014386780094355345, 8.6439387814607471e-05, 6.4215775637421757e-05, 9.3455913884099573e-05, 0.00011158407869515941, 7.7613141911569983e-05, 7.6799951784778386e-05, 6.9308625825215131e-05, 7.1237387601286173e-05, 6.6355940361972898e-05, 8.9617948106024414e-05, 6.5572508901823312e-05, 5.4182874009711668e-05, 7.7405165939126164e-05, 6.4041763835120946e-05, 6.4449857745785266e-05, 9.0191577328369021e-05, 7.7523203799501061e-05, 7.6332464232109487e-05, 6.5648629970382899e-05, 6.1406732129398733e-05, 5.187492206459865e-05, 5.3989617299521342e-05, 6.1250291764736176e-05, 6.2026287196204066e-05, 0.00011101112613687292, 6.8844958150293678e-05, 6.3809871789999306e-05, 8.4592174971476197e-05, 7.48987149563618e-05, 6.8015135184396058e-05, 0.0001269812200916931, 7.2759845352265984e-05, 5.4886160796741024e-05, 6.363738066283986e-05, 6.6429915023036301e-05, 6.9323708885349333e-05, 6.3688348745927215e-05, 6.7778055381495506e-05, 7.6637887104880065e-05, 0.00029603371513076127, 6.224192475201562e-05, 8.447599975625053e-05, 0.0001791289250832051, 0.00012460097786970437, 7.4753050284925848e-05, 6.2081518990453333e-05, 6.2631537730339915e-05, 7.2809853008948267e-05, 6.7095090344082564e-05, 8.4592466009780765e-05, 9.2474940174724907e-05, 7.1430979005526751e-05, 6.3291321566794068e-05, 6.1451952205970883e-05, 7.002511847531423e-05, 0.00013480891357176006, 5.7841429224936292e-05, 6.6056643845513463e-05, 6.0031397879356518e-05, 5.6783086620271206e-05, 6.8578177888412029e-05, 4.7174642531899735e-05, 5.9476737078512087e-05, 6.0635433328570798e-05, 0.00011301723134238273, 7.4298128311056644e-05, 9.0916517365258187e-05, 4.566681309370324e-05, 0.00016053693252615631, 6.1384540458675474e-05, 9.1586560301948339e-05, 0.00021572073455899954, 4.8623314796714112e-05, 7.9089135397225618e-05, 0.00012067770876456052, 6.1712729802820832e-05, 6.4772488258313388e-05, 5.5425589380320162e-05, 0.00011676840222207829, 6.370206392602995e-05, 6.5985870605800301e-05, 5.9728423366323113e-05, 0.00012920412700623274, 8.2494829257484525e-05, 0.00013930271961726248, 7.9055389505811036e-05, 0.00010334446415072307, } };
const TfArray<96, int> quant42_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant42 = { (TfLiteFloatArray*)&quant42_scale, (TfLiteIntArray*)&quant42_zero, 0 };
const ALIGN(8) int8_t tensor_data43[16*3*3*1] = { 
  /* [0][0][][] */ -85, -110, -30, 
  /* [0][1][][] */ 67, -37, 17, 
  /* [0][2][][] */ 32, 127, 19, 
  /* [1][0][][] */ 105, -95, -10, 
  /* [1][1][][] */ -127, 104, 23, 
  /* [1][2][][] */ 14, -2, -13, 
  /* [2][0][][] */ -24, -2, -48, 
  /* [2][1][][] */ 36, 95, 127, 
  /* [2][2][][] */ -12, -94, -79, 
  /* [3][0][][] */ 120, 126, 58, 
  /* [3][1][][] */ 2, -22, -15, 
  /* [3][2][][] */ -101, -127, -44, 
  /* [4][0][][] */ 26, -57, 1, 
  /* [4][1][][] */ 26, -127, 2, 
  /* [4][2][][] */ 15, -84, -12, 
  /* [5][0][][] */ -61, 28, -1, 
  /* [5][1][][] */ -127, 33, 3, 
  /* [5][2][][] */ -85, 26, 0, 
  /* [6][0][][] */ -17, 79, 127, 
  /* [6][1][][] */ -51, 55, -16, 
  /* [6][2][][] */ -36, -52, -88, 
  /* [7][0][][] */ 38, 28, -16, 
  /* [7][1][][] */ 127, 70, -7, 
  /* [7][2][][] */ 31, 3, -24, 
  /* [8][0][][] */ -21, -30, 53, 
  /* [8][1][][] */ -54, -87, 127, 
  /* [8][2][][] */ -26, -61, 96, 
  /* [9][0][][] */ -22, 51, -10, 
  /* [9][1][][] */ -15, 127, -12, 
  /* [9][2][][] */ -7, 88, -7, 
  /* [10][0][][] */ 24, 87, 12, 
  /* [10][1][][] */ -37, -127, -29, 
  /* [10][2][][] */ 12, 40, 18, 
  /* [11][0][][] */ 7, -19, 10, 
  /* [11][1][][] */ 65, -93, 35, 
  /* [11][2][][] */ -85, 127, -46, 
  /* [12][0][][] */ -41, 49, -10, 
  /* [12][1][][] */ -127, 114, 6, 
  /* [12][2][][] */ -78, 79, 5, 
  /* [13][0][][] */ 79, 22, -15, 
  /* [13][1][][] */ 127, 105, -10, 
  /* [13][2][][] */ 72, 104, 36, 
  /* [14][0][][] */ -30, -28, 48, 
  /* [14][1][][] */ 44, 98, -127, 
  /* [14][2][][] */ -16, -70, 81, 
  /* [15][0][][] */ -85, -27, 19, 
  /* [15][1][][] */ -127, -123, 17, 
  /* [15][2][][] */ -22, -73, -7, 
};
const TfArray<4, int> tensor_dimension43 = { 4, { 16,3,3,1 } };
const TfArray<16, float> quant43_scale = { 16, { 0.021764988079667091, 0.040345512330532074, 0.023399509489536285, 0.01777123287320137, 0.0030583953484892845, 0.003921369556337595, 0.014861965551972389, 0.003354592015966773, 0.01827227883040905, 0.0043121026828885078, 0.032765720039606094, 0.030783278867602348, 0.023922797292470932, 0.0021857121028006077, 0.030632965266704559, 0.004490213468670845, } };
const TfArray<16, int> quant43_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant43 = { (TfLiteFloatArray*)&quant43_scale, (TfLiteIntArray*)&quant43_zero, 0 };
const ALIGN(8) int8_t tensor_data44[8*1*1*16] = { 
  /* [0][0][][] */ -13,-14,-19,-66,-26,-35,19,-18,38,8,-32,-6,111,127,-20,-106, 
  /* [1][0][][] */ 127,-60,-42,15,-46,72,-69,-44,-40,84,-34,-52,-9,4,-64,-18, 
  /* [2][0][][] */ -36,-96,41,41,47,-55,-77,-21,30,-88,26,-127,44,-22,-76,22, 
  /* [3][0][][] */ 37,13,15,16,-12,69,-52,-20,127,45,11,23,4,-13,11,23, 
  /* [4][0][][] */ -94,-37,-26,-127,-9,39,53,-117,31,-18,-47,-38,-120,31,-40,-24, 
  /* [5][0][][] */ 88,51,70,-27,46,-48,-127,-123,-18,-77,66,49,-58,50,65,-45, 
  /* [6][0][][] */ 107,40,-126,-77,29,-74,5,-91,-41,20,-127,96,92,-89,7,73, 
  /* [7][0][][] */ -127,-3,97,-28,-64,4,-2,-61,-51,62,85,-32,62,-26,30,29, 
};
const TfArray<4, int> tensor_dimension44 = { 4, { 8,1,1,16 } };
const TfArray<8, float> quant44_scale = { 8, { 0.0081800585612654686, 0.0095678027719259262, 0.0079526863992214203, 0.0092860786244273186, 0.0070665106177330017, 0.0071527557447552681, 0.0069983173161745071, 0.010597777552902699, } };
const TfArray<8, int> quant44_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant44 = { (TfLiteFloatArray*)&quant44_scale, (TfLiteIntArray*)&quant44_zero, 0 };
const ALIGN(8) int8_t tensor_data45[48*1*1*8] = { 
  /* [0][0][][] */ -40,29,2,-16,-80,-36,-127,32, 
  /* [1][0][][] */ 84,-77,-56,-53,127,-88,96,25, 
  /* [2][0][][] */ -106,124,-50,-127,52,-21,-27,43, 
  /* [3][0][][] */ 52,23,96,8,98,122,127,-13, 
  /* [4][0][][] */ -72,-127,66,8,-57,-111,4,-35, 
  /* [5][0][][] */ 127,-24,68,65,-70,-9,1,-23, 
  /* [6][0][][] */ 25,35,127,-27,44,-36,-43,29, 
  /* [7][0][][] */ 28,7,-127,-35,-41,98,98,-75, 
  /* [8][0][][] */ -2,127,-35,12,64,104,47,55, 
  /* [9][0][][] */ -7,127,-65,90,15,-114,43,121, 
  /* [10][0][][] */ 4,-127,-4,-28,-78,-122,-57,-83, 
  /* [11][0][][] */ -127,-80,105,50,-8,-64,100,64, 
  /* [12][0][][] */ -27,44,-127,81,34,-55,-72,98, 
  /* [13][0][][] */ 90,-127,92,79,8,33,37,-59, 
  /* [14][0][][] */ -28,95,-38,-127,-28,-111,-27,-62, 
  /* [15][0][][] */ 41,113,32,-16,36,-65,97,-127, 
  /* [16][0][][] */ -114,-127,-60,92,-54,23,-19,78, 
  /* [17][0][][] */ -26,-113,-127,86,-63,75,-51,75, 
  /* [18][0][][] */ -97,-75,-50,92,-9,72,-4,127, 
  /* [19][0][][] */ 62,-124,102,-127,12,-67,32,-33, 
  /* [20][0][][] */ -3,73,32,13,42,127,75,-11, 
  /* [21][0][][] */ 27,113,46,-33,39,-67,93,-127, 
  /* [22][0][][] */ 22,12,103,20,-10,127,31,-36, 
  /* [23][0][][] */ -101,-67,36,-73,92,100,-62,-127, 
  /* [24][0][][] */ -97,-91,36,-86,108,106,-45,-127, 
  /* [25][0][][] */ 127,9,-59,-14,14,33,-62,-8, 
  /* [26][0][][] */ -127,-36,-125,-24,-52,-29,20,-2, 
  /* [27][0][][] */ 79,33,-2,-59,-127,-25,87,90, 
  /* [28][0][][] */ -127,-84,6,50,-77,-103,6,1, 
  /* [29][0][][] */ 123,102,43,-127,28,11,-65,-95, 
  /* [30][0][][] */ -88,-68,40,-70,75,89,-52,-127, 
  /* [31][0][][] */ 48,44,-5,127,5,-72,8,9, 
  /* [32][0][][] */ -28,127,-7,37,23,69,-17,49, 
  /* [33][0][][] */ -36,127,-75,26,22,-32,-25,1, 
  /* [34][0][][] */ -127,-114,-50,105,-14,14,23,104, 
  /* [35][0][][] */ -52,127,-30,-5,70,106,54,69, 
  /* [36][0][][] */ 71,28,1,-45,-127,-30,102,108, 
  /* [37][0][][] */ -66,110,27,22,-127,107,-24,-98, 
  /* [38][0][][] */ 35,37,30,22,127,73,105,55, 
  /* [39][0][][] */ -24,-68,37,-18,11,38,-96,127, 
  /* [40][0][][] */ -70,-57,-72,127,-30,1,11,68, 
  /* [41][0][][] */ 127,13,57,106,-48,-11,-5,-21, 
  /* [42][0][][] */ -42,9,-71,-127,54,-106,4,84, 
  /* [43][0][][] */ 25,-6,86,-5,36,127,90,7, 
  /* [44][0][][] */ -29,-28,-69,127,46,11,-40,-39, 
  /* [45][0][][] */ 67,127,112,-118,50,-60,21,-119, 
  /* [46][0][][] */ -35,-127,-42,33,-8,40,-66,123, 
  /* [47][0][][] */ 41,45,126,3,95,124,127,-24, 
};
const TfArray<4, int> tensor_dimension45 = { 4, { 48,1,1,8 } };
const TfArray<48, float> quant45_scale = { 48, { 0.0047908122651278973, 0.0044097849167883396, 0.0033107202034443617, 0.0030564640183001757, 0.00075950269820168614, 0.0038716667331755161, 0.0054925377480685711, 0.0022255901712924242, 0.0032707410864531994, 0.0048666046932339668, 0.0033909068442881107, 0.003189433366060257, 0.002265026792883873, 0.004066812340170145, 0.0032419103663414717, 0.0034391507506370544, 0.0024678250774741173, 0.00090459873899817467, 0.0025986754335463047, 0.0035025191027671099, 0.0039461497217416763, 0.0020676623098552227, 0.0045269913971424103, 0.0025676859077066183, 0.003764705965295434, 0.0074274493381381035, 0.0031577444169670343, 0.0058005666360259056, 0.0025439842138439417, 0.00068017997546121478, 0.002635847544297576, 0.0073888124898076057, 0.0043801027350127697, 0.0040483898483216763, 0.0029997117817401886, 0.0037981329951435328, 0.0028514291625469923, 0.0059699281118810177, 0.0039722020737826824, 0.0055808029137551785, 0.0034651057794690132, 0.0035852491855621338, 0.0035328618250787258, 0.0045120459981262684, 0.0035279723815619946, 0.0023940075188875198, 0.002794293686747551, 0.0030732445884495974, } };
const TfArray<48, int> quant45_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant45 = { (TfLiteFloatArray*)&quant45_scale, (TfLiteIntArray*)&quant45_zero, 0 };
const ALIGN(8) int8_t tensor_data46[8*1*1*48] = { 
  /* [0][0][][] */ -45,-3,32,12,-33,-14,10,9,-42,-6,-64,-56,-25,-64,-11,-31,46,-40,39,42,-16,32,-38,14,1,-39,55,-14,-4,-18,17,11,82,35,37,-127,18,-1,-17,-34,4,-17,44,47,36,5,28,2, 
  /* [1][0][][] */ 1,39,65,-27,-13,44,-50,-30,2,24,-16,-92,11,89,-17,58,-19,20,-25,-55,11,-79,-27,23,-72,-12,-2,-114,-26,-17,32,-53,50,79,-41,4,127,-31,2,49,-30,39,-82,-30,115,-20,-33,-26, 
  /* [2][0][][] */ -4,-21,-62,14,-3,44,26,3,-8,42,-3,27,64,-91,17,-61,35,-88,23,34,-24,52,-5,25,-17,60,-23,-69,17,4,19,-70,-46,-87,35,-30,106,21,-11,-58,-1,29,78,28,127,16,19,25, 
  /* [3][0][][] */ -5,25,-66,41,13,-37,-71,-102,11,-23,-36,0,4,26,33,77,-6,14,-37,25,5,-98,29,-58,-73,-9,127,-13,-44,2,-66,18,0,-80,11,-13,-21,-40,-23,102,-45,-37,-1,18,39,3,-39,42, 
  /* [4][0][][] */ -27,-46,-6,8,30,-29,-12,-8,27,-30,57,-78,6,29,8,10,-16,-24,11,-14,-4,-52,4,-20,17,-10,40,48,32,21,-15,27,-10,-2,2,-1,-68,83,35,-25,30,-20,-20,-24,-76,11,127,10, 
  /* [5][0][][] */ 46,-21,3,14,25,-43,34,-127,25,-30,-11,119,-81,66,22,-67,-1,-90,14,3,-37,66,-36,-47,-60,76,-26,3,-22,49,-43,-34,28,54,34,-6,-41,-9,-47,-41,16,-40,-47,-9,-35,56,88,19, 
  /* [6][0][][] */ 52,-21,21,-10,-36,-19,-36,19,-40,6,-40,127,-42,-36,-4,57,11,46,15,34,37,-82,-20,18,23,39,-64,6,9,-42,13,37,6,16,-15,-2,12,0,-3,-5,-8,-15,41,57,-2,-36,73,-15, 
  /* [7][0][][] */ -27,4,-7,66,34,32,5,30,23,6,70,-3,124,108,62,50,45,47,-14,3,22,-21,-88,-26,15,-3,-29,64,34,-27,-33,-18,37,6,42,-96,-75,38,40,56,-33,35,86,127,-60,-27,-109,62, 
};
const TfArray<4, int> tensor_dimension46 = { 4, { 8,1,1,48 } };
const TfArray<8, float> quant46_scale = { 8, { 0.0096787204965949059, 0.0052117141894996166, 0.0058633238077163696, 0.0061403708532452583, 0.008045257069170475, 0.0067136101424694061, 0.0095207691192626953, 0.0057099484838545322, } };
const TfArray<8, int> quant46_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant46 = { (TfLiteFloatArray*)&quant46_scale, (TfLiteIntArray*)&quant46_zero, 0 };
const ALIGN(8) int8_t tensor_data47[48*1*1*8] = { 
  /* [0][0][][] */ 63,127,-79,-90,13,86,16,68, 
  /* [1][0][][] */ 59,-75,46,-127,-57,72,-85,-43, 
  /* [2][0][][] */ -29,127,117,49,109,4,51,9, 
  /* [3][0][][] */ 106,43,-94,63,-6,-103,-127,-35, 
  /* [4][0][][] */ -43,32,14,-68,-37,114,127,50, 
  /* [5][0][][] */ 23,76,-127,-77,45,88,33,-30, 
  /* [6][0][][] */ -9,127,64,58,76,11,17,-92, 
  /* [7][0][][] */ 127,-19,-34,28,22,4,107,17, 
  /* [8][0][][] */ 51,127,64,92,113,80,95,-82, 
  /* [9][0][][] */ 50,112,-127,-90,12,97,6,69, 
  /* [10][0][][] */ -68,-43,22,-49,-4,-30,-47,127, 
  /* [11][0][][] */ 16,-110,-127,-16,21,-13,38,-9, 
  /* [12][0][][] */ -27,-111,-123,-30,-127,30,-66,46, 
  /* [13][0][][] */ -9,9,-101,101,-127,-25,1,-17, 
  /* [14][0][][] */ -64,-43,-127,-8,37,-2,-12,-59, 
  /* [15][0][][] */ 22,-100,-127,15,-101,-27,-30,-13, 
  /* [16][0][][] */ 127,-67,-19,67,-84,25,32,100, 
  /* [17][0][][] */ -26,115,127,-26,-49,-10,-28,-21, 
  /* [18][0][][] */ 9,-127,46,70,-3,-64,50,-84, 
  /* [19][0][][] */ 127,-46,-57,38,-99,7,41,103, 
  /* [20][0][][] */ -29,-127,80,73,-15,-87,0,-74, 
  /* [21][0][][] */ -6,-50,-11,-33,127,-6,44,21, 
  /* [22][0][][] */ -127,26,-79,49,48,54,-93,-108, 
  /* [23][0][][] */ -93,-50,65,-4,-107,127,124,-50, 
  /* [24][0][][] */ -30,58,-5,-45,-41,124,127,1, 
  /* [25][0][][] */ -52,-110,-127,-61,-53,-16,-26,-43, 
  /* [26][0][][] */ -12,65,-16,127,-93,36,-54,-1, 
  /* [27][0][][] */ 16,-127,33,76,15,-54,6,-122, 
  /* [28][0][][] */ 19,127,59,45,115,-21,24,-64, 
  /* [29][0][][] */ 107,29,-38,-10,81,-127,-108,37, 
  /* [30][0][][] */ 24,-7,32,-127,18,-23,17,-23, 
  /* [31][0][][] */ 48,-40,3,64,-13,30,12,127, 
  /* [32][0][][] */ -86,-70,13,-62,-63,127,65,90, 
  /* [33][0][][] */ -34,45,48,-39,38,127,-111,73, 
  /* [34][0][][] */ 30,127,-74,-50,19,47,-68,64, 
  /* [35][0][][] */ 12,-127,33,54,-21,-60,40,-75, 
  /* [36][0][][] */ -17,-32,-79,-8,-127,-57,-17,11, 
  /* [37][0][][] */ -52,-127,72,83,-46,-89,-13,-50, 
  /* [38][0][][] */ -75,25,65,-71,-127,-88,-61,87, 
  /* [39][0][][] */ 68,-127,88,49,-10,-76,-16,-80, 
  /* [40][0][][] */ 0,60,23,47,-127,-12,-59,20, 
  /* [41][0][][] */ 108,127,-82,-113,55,22,-4,15, 
  /* [42][0][][] */ -11,-39,-16,14,127,12,46,20, 
  /* [43][0][][] */ 127,24,83,21,-71,-24,64,107, 
  /* [44][0][][] */ 68,44,-22,14,69,-113,-127,21, 
  /* [45][0][][] */ 47,13,20,19,80,-127,-3,-50, 
  /* [46][0][][] */ 59,-37,-9,127,39,57,20,72, 
  /* [47][0][][] */ -79,-81,44,67,-48,17,127,-75, 
};
const TfArray<4, int> tensor_dimension47 = { 4, { 48,1,1,8 } };
const TfArray<48, float> quant47_scale = { 48, { 0.0033599536400288343, 0.0025176045019179583, 0.00091154058463871479, 0.0027070636861026287, 0.0029733800329267979, 0.0036225211806595325, 0.001930785714648664, 0.00099902448710054159, 0.001937686582095921, 0.0035559397656470537, 0.0030275378376245499, 0.0030351807363331318, 0.00067024759482592344, 0.0035516193602234125, 0.0034755067899823189, 0.00078794610453769565, 0.0044590607285499573, 0.0028878927696496248, 0.0042622080072760582, 0.0031142616644501686, 0.0030870488844811916, 0.0032820876222103834, 0.0053133736364543438, 0.00055868917843326926, 0.0018607401289045811, 0.0020749582909047604, 0.0011365863028913736, 0.0037571450229734182, 0.0017258579609915614, 0.0018951175734400749, 0.0073033729568123817, 0.0059447032399475574, 0.0030171365942806005, 0.0033288395497947931, 0.0042188782244920731, 0.0043894289992749691, 0.0027725505642592907, 0.0043189357966184616, 0.003181681502610445, 0.0032861214131116867, 0.0027424658183008432, 0.0034719870891422033, 0.0031188298016786575, 0.0025594239123165607, 0.0020907721482217312, 0.0029281778261065483, 0.0051132063381373882, 0.0019462438067421317, } };
const TfArray<48, int> quant47_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant47 = { (TfLiteFloatArray*)&quant47_scale, (TfLiteIntArray*)&quant47_zero, 0 };
const ALIGN(8) int8_t tensor_data48[8*1*1*48] = { 
  /* [0][0][][] */ -42,-48,-19,-65,1,-13,87,83,-97,-85,-36,7,-54,-5,-61,34,-81,11,13,127,57,-26,13,93,69,73,26,3,-89,-55,-78,-56,-50,97,32,-47,28,-31,91,-6,25,6,1,-104,39,-33,-32,-83, 
  /* [1][0][][] */ -14,53,-19,-26,-71,60,-20,-48,-34,71,-19,18,56,45,-49,-5,-20,-120,77,-50,127,9,-62,23,58,-2,-82,63,39,-14,68,34,-32,-18,2,-12,2,107,-15,-26,65,42,-7,14,105,15,-31,57, 
  /* [2][0][][] */ -24,-34,112,4,83,-42,-12,22,-32,-1,-12,45,8,-42,-46,-127,-51,-97,-23,16,-95,21,-39,-34,-48,17,-2,-45,-40,6,-32,-12,-1,-5,26,-5,26,-29,-49,8,35,-31,30,-46,-43,-43,-61,-49, 
  /* [3][0][][] */ 50,16,64,13,18,-33,34,72,-54,-26,44,-24,-67,59,-17,51,67,30,-35,32,-108,-68,127,-2,7,3,-58,-33,-51,65,117,-64,7,-113,-23,44,-11,-79,-13,73,-76,-57,62,-2,-96,-72,58,-8, 
  /* [4][0][][] */ 18,-18,72,-28,5,-9,-4,-3,-59,-6,-24,7,45,-72,40,-98,44,45,-9,-34,11,33,18,9,0,3,58,-16,26,23,-127,-13,-27,-21,5,16,49,-3,36,1,-39,-11,-70,28,-16,-98,2,20, 
  /* [5][0][][] */ 25,-48,60,30,31,18,24,1,-76,-8,-47,29,31,8,13,-44,93,72,-4,-15,86,-60,127,-88,-16,45,3,46,10,11,-31,-47,-18,-46,-37,11,42,26,68,4,-77,28,33,28,48,-17,77,-3, 
  /* [6][0][][] */ -46,54,-127,87,51,21,39,20,-22,-8,62,-78,-97,-18,-29,29,-117,30,-8,94,23,47,-88,-90,-7,-20,26,77,-32,-38,-45,10,39,74,-47,-26,-15,-7,82,4,71,65,-121,-56,-36,119,-55,-37, 
  /* [7][0][][] */ 35,74,-82,17,16,62,123,75,44,78,-99,-3,-44,2,-71,-46,32,39,119,105,84,4,127,25,106,100,-51,99,-71,33,0,-76,18,-67,-23,24,1,101,-64,83,-63,49,-5,-83,81,-22,53,-36, 
};
const TfArray<4, int> tensor_dimension48 = { 4, { 8,1,1,48 } };
const TfArray<8, float> quant48_scale = { 8, { 0.0040236036293208599, 0.0042944713495671749, 0.0063317948952317238, 0.004599645733833313, 0.0057872929610311985, 0.0058249961584806442, 0.0037646577693521976, 0.0036769222933799028, } };
const TfArray<8, int> quant48_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant48 = { (TfLiteFloatArray*)&quant48_scale, (TfLiteIntArray*)&quant48_zero, 0 };
const ALIGN(8) int8_t tensor_data49[48*1*1*8] = { 
  /* [0][0][][] */ 71,31,127,-37,65,105,-77,-56, 
  /* [1][0][][] */ 10,-84,-127,5,51,25,30,2, 
  /* [2][0][][] */ -127,-6,-48,-27,55,26,-72,-41, 
  /* [3][0][][] */ 42,71,127,-78,-10,-109,-7,-15, 
  /* [4][0][][] */ -127,22,-51,-25,45,11,-41,-59, 
  /* [5][0][][] */ -99,23,-56,-10,9,38,-81,-127, 
  /* [6][0][][] */ -37,-127,-119,42,99,13,7,46, 
  /* [7][0][][] */ -62,-127,-95,-78,-70,-67,19,86, 
  /* [8][0][][] */ 85,31,-8,-4,94,-78,-127,12, 
  /* [9][0][][] */ -37,53,-53,89,-60,-40,127,-31, 
  /* [10][0][][] */ -24,127,37,64,124,-22,-11,56, 
  /* [11][0][][] */ -80,-34,-24,-10,-85,103,127,-5, 
  /* [12][0][][] */ 67,34,-127,36,-9,-34,-66,-14, 
  /* [13][0][][] */ 62,-31,-69,9,13,-127,-29,-23, 
  /* [14][0][][] */ 8,-77,77,11,127,-117,-65,20, 
  /* [15][0][][] */ -40,-42,-4,127,63,82,-74,27, 
  /* [16][0][][] */ 113,28,-34,18,77,-107,-127,-25, 
  /* [17][0][][] */ 61,127,54,73,46,64,26,-87, 
  /* [18][0][][] */ 34,-11,3,-2,127,3,26,-12, 
  /* [19][0][][] */ 11,127,33,14,-118,19,25,-32, 
  /* [20][0][][] */ -44,19,66,-127,20,35,-17,106, 
  /* [21][0][][] */ -37,74,41,-127,30,47,-12,115, 
  /* [22][0][][] */ -71,-68,-97,18,-127,121,112,-25, 
  /* [23][0][][] */ 99,37,-127,19,15,-48,-72,-18, 
  /* [24][0][][] */ -53,43,7,5,-21,78,-127,101, 
  /* [25][0][][] */ -99,-55,-127,10,-56,-67,66,96, 
  /* [26][0][][] */ 47,-10,-38,-33,108,-14,127,-42, 
  /* [27][0][][] */ 127,-70,25,92,1,31,-20,95, 
  /* [28][0][][] */ 44,57,53,-11,127,-56,52,-30, 
  /* [29][0][][] */ -16,-12,-25,-44,-68,15,127,-32, 
  /* [30][0][][] */ 42,-127,-53,-70,-106,-2,10,-54, 
  /* [31][0][][] */ 10,26,-7,-12,-127,6,-26,-12, 
  /* [32][0][][] */ 44,-60,-60,79,-7,-91,117,-127, 
  /* [33][0][][] */ 53,127,47,36,56,-19,-25,-24, 
  /* [34][0][][] */ -121,-34,127,-5,-22,104,97,12, 
  /* [35][0][][] */ -32,76,127,-13,-64,-70,-39,28, 
  /* [36][0][][] */ -95,6,98,-19,-17,127,77,26, 
  /* [37][0][][] */ -19,-81,-8,-127,-43,-80,70,44, 
  /* [38][0][][] */ 47,-15,87,-57,54,59,-127,8, 
  /* [39][0][][] */ -15,92,-127,-41,-22,3,5,82, 
  /* [40][0][][] */ 65,-52,19,31,11,1,7,127, 
  /* [41][0][][] */ -29,88,127,-4,8,80,-70,26, 
  /* [42][0][][] */ 66,-127,-115,-22,-118,5,15,-95, 
  /* [43][0][][] */ -11,-83,29,-66,127,-43,18,38, 
  /* [44][0][][] */ 4,127,122,20,6,56,-74,8, 
  /* [45][0][][] */ -35,45,12,83,-117,61,-127,20, 
  /* [46][0][][] */ -47,-40,65,48,-127,-123,-31,-1, 
  /* [47][0][][] */ -21,58,46,-105,-127,39,-19,61, 
};
const TfArray<4, int> tensor_dimension49 = { 4, { 48,1,1,8 } };
const TfArray<48, float> quant49_scale = { 48, { 0.0025292246136814356, 0.0034671768080443144, 0.0034849662333726883, 0.0026254083495587111, 0.0024611330591142178, 0.0025560122448951006, 0.0022082943469285965, 0.0017890114104375243, 0.0030802106484770775, 0.0034419354051351547, 0.002302889246493578, 0.002065734937787056, 0.0035482447128742933, 0.0034895273856818676, 0.0030299446079879999, 0.0021236678585410118, 0.0027263874653726816, 0.0025987196713685989, 0.0019383722683414817, 0.0036299892235547304, 0.0033721283543854952, 0.0026414238382130861, 0.0022993627935647964, 0.001972102327272296, 0.0025899095926433802, 0.0026053802575916052, 0.0032574043143540621, 0.003322425065562129, 0.0013174352934584022, 0.003499253187328577, 0.0021508196368813515, 0.0019496026216074824, 0.0023080348037183285, 0.0023109063040465117, 0.0025264741852879524, 0.0029950467869639397, 0.0027099493891000748, 0.003128803800791502, 0.0026724627241492271, 0.0021804023999720812, 0.0034258058294653893, 0.0013083346420899034, 0.0015257812337949872, 0.0032441604416817427, 0.0014585790922865272, 0.0030548383947461843, 0.0027814216446131468, 0.0026598740369081497, } };
const TfArray<48, int> quant49_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant49 = { (TfLiteFloatArray*)&quant49_scale, (TfLiteIntArray*)&quant49_zero, 0 };
const ALIGN(8) int8_t tensor_data50[16*1*1*48] = { 
  /* [0][0][][] */ 25,39,19,-33,68,66,-41,57,-15,113,4,45,-36,36,-15,44,33,80,42,-62,-69,74,-8,50,57,45,38,52,-47,-48,-8,84,-27,11,-69,51,49,-127,-33,15,13,-32,61,-7,-8,-55,-60,-17, 
  /* [1][0][][] */ -51,2,-80,-44,10,90,-57,19,-11,-34,-44,33,59,-17,-28,-25,-28,-33,-5,20,-66,45,-104,-46,-52,-39,48,68,-25,-29,42,-42,12,-59,-34,53,13,-59,127,-36,-23,29,-46,-15,33,52,31,19, 
  /* [2][0][][] */ 3,4,59,-34,-18,-80,18,24,101,76,-66,13,110,-49,127,82,-70,-22,-31,31,83,-80,-33,-97,12,-37,36,-70,40,44,-43,14,33,-27,60,42,-66,11,1,-29,32,29,66,-16,21,-86,95,-56, 
  /* [3][0][][] */ 40,3,-23,-29,33,112,17,-18,43,-49,23,-25,-52,8,11,42,-44,-68,37,-124,-10,-1,-27,-17,-41,92,127,64,-12,-42,27,41,61,-30,96,35,-44,-57,1,40,27,15,-16,0,24,20,-10,-23, 
  /* [4][0][][] */ 101,-9,6,-50,90,86,51,12,70,-18,-108,31,43,-21,16,-16,-101,-125,-27,-99,-22,24,-40,-34,-86,127,-105,122,-59,-56,29,83,40,-52,16,-33,-8,13,-28,29,-52,-10,-5,53,-51,107,-32,-56, 
  /* [5][0][][] */ 0,-4,-55,6,-13,54,18,-26,63,53,39,89,52,-22,32,-3,-38,127,-17,36,10,-1,-65,-14,35,0,-63,-34,-14,29,18,-17,-38,3,41,16,-45,7,-83,4,87,-19,26,47,-16,8,-38,32, 
  /* [6][0][][] */ 61,13,17,71,6,-28,105,-56,2,68,127,105,42,47,-51,60,39,-43,-78,90,49,-63,-44,59,-87,93,88,-8,115,52,-32,-2,98,-65,-122,-7,102,34,0,2,14,61,58,-32,67,122,34,-4, 
  /* [7][0][][] */ -96,-5,-23,27,-60,-58,25,51,80,114,-56,-73,-99,11,-16,-14,-79,100,1,119,-49,42,24,39,-19,-94,-33,-82,30,40,-7,9,-17,12,14,-18,5,-59,127,12,6,44,24,-14,56,70,-30,-1, 
  /* [8][0][][] */ -10,-90,51,-63,60,-59,71,-40,-27,-115,28,10,-33,3,29,29,-2,7,-44,101,4,36,-21,27,66,-10,-61,-35,-127,-23,-55,-113,9,-64,2,83,-7,33,108,17,16,-2,69,116,-10,-68,-43,79, 
  /* [9][0][][] */ 20,-36,23,-64,41,82,-38,49,18,-36,-36,-17,20,-47,112,-16,7,-115,39,42,-70,40,56,-38,-24,-79,-25,79,56,74,-41,-26,-51,32,-8,127,-26,-44,-54,-24,-28,0,36,106,59,82,-67,16, 
  /* [10][0][][] */ -12,19,-23,-8,20,28,-64,-43,49,38,62,-7,-34,-9,49,-49,-60,127,0,49,1,-10,18,28,-42,44,4,92,36,7,-34,-10,71,9,-8,27,-8,-46,-38,21,-79,-2,26,-15,17,44,30,33, 
  /* [11][0][][] */ -29,46,-19,35,30,56,1,8,18,17,-127,-70,71,19,-7,-45,-2,26,-44,-46,-11,-7,105,5,47,11,-17,32,-7,26,-9,49,29,-4,-49,1,42,79,100,19,34,-30,63,-1,-55,-19,84,4, 
  /* [12][0][][] */ -66,-2,34,21,-63,-58,3,2,-38,-34,-127,16,71,-98,19,33,49,105,85,-121,-32,43,-44,-82,-1,-16,36,-32,8,16,-18,74,67,80,38,-34,-56,-28,32,1,-33,17,60,-4,36,-15,-39,-36, 
  /* [13][0][][] */ -56,-117,-46,-104,11,25,60,13,-123,27,121,-64,56,44,127,6,119,25,-6,-98,77,-80,121,1,-79,7,-27,13,-43,-100,-113,17,48,-28,-75,64,31,-57,81,-77,-7,57,71,44,60,-29,107,-66, 
  /* [14][0][][] */ 67,20,-55,5,-42,16,-88,-25,-31,60,56,47,-12,-64,14,-46,52,-117,23,11,89,-61,24,-5,-11,127,-89,3,-59,-28,-93,2,127,44,89,-22,-82,12,-23,58,-16,-48,108,-26,-57,-45,-58,54, 
  /* [15][0][][] */ -64,14,41,20,95,4,2,34,21,78,-17,55,55,-15,-35,-18,13,38,1,-38,28,-37,-49,-54,52,-64,-38,65,-32,7,15,8,-60,0,127,-5,-88,16,59,-15,-46,-19,20,-3,-33,-33,-10,9, 
};
const TfArray<4, int> tensor_dimension50 = { 4, { 16,1,1,48 } };
const TfArray<16, float> quant50_scale = { 16, { 0.006117683369666338, 0.0063198278658092022, 0.0057736113667488098, 0.0065434379503130913, 0.0040667885914444923, 0.006243397481739521, 0.0043571465648710728, 0.006647252943366766, 0.0043322262354195118, 0.0036325417459011078, 0.008143705315887928, 0.0065707270987331867, 0.0055289301089942455, 0.0040980037301778793, 0.0057219606824219227, 0.0054624998010694981, } };
const TfArray<16, int> quant50_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant50 = { (TfLiteFloatArray*)&quant50_scale, (TfLiteIntArray*)&quant50_zero, 0 };
const ALIGN(8) int8_t tensor_data51[96*1*1*16] = { 
  /* [0][0][][] */ 42,6,2,56,-127,-22,95,49,59,85,-24,40,15,1,34,81, 
  /* [1][0][][] */ -21,29,-90,3,127,100,-3,0,-28,17,-58,33,-52,85,-53,-38, 
  /* [2][0][][] */ -40,62,78,-3,63,86,7,36,38,-7,40,-18,54,-127,-8,11, 
  /* [3][0][][] */ 127,-33,23,3,34,32,-13,14,38,36,-60,-23,-41,51,-30,55, 
  /* [4][0][][] */ -80,-19,7,38,-116,-9,-88,-30,-9,32,-10,-56,-21,34,-42,127, 
  /* [5][0][][] */ -94,15,33,13,127,31,6,8,-48,34,-26,13,-67,54,-96,-37, 
  /* [6][0][][] */ -127,25,-38,29,-10,-71,72,16,7,-31,-52,36,11,-1,-42,12, 
  /* [7][0][][] */ -1,105,55,-95,68,52,127,8,47,1,-3,45,89,26,-30,2, 
  /* [8][0][][] */ -35,-26,-72,55,-56,87,-47,-73,27,-41,88,42,127,48,-102,9, 
  /* [9][0][][] */ -25,-127,-18,81,-41,-63,-13,58,51,46,8,66,-76,14,-8,-35, 
  /* [10][0][][] */ -39,-51,-109,55,-126,127,61,-89,12,-74,66,-43,38,111,-84,87, 
  /* [11][0][][] */ -43,-111,-38,30,-10,93,35,-7,19,13,44,-96,16,116,-119,127, 
  /* [12][0][][] */ -30,-95,-81,102,-101,-127,18,65,78,67,-35,101,-5,-64,-24,-8, 
  /* [13][0][][] */ -64,-23,-33,-4,-14,1,30,16,-17,127,-10,-20,38,32,15,-12, 
  /* [14][0][][] */ -120,-27,-52,-51,-23,94,-23,-106,127,-67,74,-2,95,-59,-93,-91, 
  /* [15][0][][] */ 4,-127,96,-56,-56,-38,6,58,17,-50,-92,-38,85,-42,-27,-49, 
  /* [16][0][][] */ -23,-34,25,-38,31,25,-19,-25,64,-127,38,-18,-6,1,-76,-92, 
  /* [17][0][][] */ -21,6,29,-63,22,1,-36,3,95,-63,27,71,115,-80,-29,-127, 
  /* [18][0][][] */ 74,1,-38,-124,6,-27,125,-50,28,62,-9,64,-8,77,-9,-127, 
  /* [19][0][][] */ -34,-31,-31,-64,-122,38,-16,-2,31,-52,29,-127,-13,-20,-17,-3, 
  /* [20][0][][] */ 19,74,70,-94,64,-5,-51,91,-109,-127,36,-86,-39,110,-18,-16, 
  /* [21][0][][] */ 12,-109,-127,-5,98,39,88,99,-82,-91,-23,18,111,-107,-32,26, 
  /* [22][0][][] */ 59,-9,81,-11,3,7,66,27,25,127,32,28,-3,1,116,-6, 
  /* [23][0][][] */ -119,-72,-24,64,67,46,18,9,-5,10,-1,-92,-2,68,60,127, 
  /* [24][0][][] */ 17,-13,38,32,17,-93,14,-60,22,127,-115,77,-20,-64,80,-71, 
  /* [25][0][][] */ 127,-63,110,121,44,11,-15,35,-116,80,54,-58,-10,25,74,-16, 
  /* [26][0][][] */ -22,25,11,41,-57,115,-17,38,-60,-36,-81,33,2,20,46,-127, 
  /* [27][0][][] */ 35,-5,-8,-48,-47,3,-81,12,-105,-24,-67,-42,-74,46,-21,127, 
  /* [28][0][][] */ -68,15,23,-1,26,-13,-127,2,-3,-32,-3,-11,11,-50,-73,-33, 
  /* [29][0][][] */ -24,-115,-25,94,-27,10,127,6,78,58,-112,65,33,-27,-51,75, 
  /* [30][0][][] */ 42,-52,-63,7,-127,28,55,-34,12,-3,2,-25,-16,49,-10,73, 
  /* [31][0][][] */ -127,-11,8,95,-35,8,-50,-1,-27,-53,13,-29,-24,-53,-19,97, 
  /* [32][0][][] */ -127,-81,-92,-5,-94,-51,3,-14,118,55,-56,-66,39,43,33,-16, 
  /* [33][0][][] */ -8,8,-91,41,-127,-97,52,-8,-113,19,-56,-58,-22,100,74,66, 
  /* [34][0][][] */ 37,62,6,39,-69,-48,33,11,22,-127,-20,38,-27,-1,45,92, 
  /* [35][0][][] */ 40,-5,-66,-15,-127,15,89,-33,26,49,-14,-11,21,71,32,64, 
  /* [36][0][][] */ -5,-5,-56,58,127,-22,44,69,-86,16,-84,-81,29,-19,10,29, 
  /* [37][0][][] */ -123,53,-2,-75,46,-94,-41,-35,-9,-24,-26,51,60,-80,16,-127, 
  /* [38][0][][] */ 39,107,31,-75,-107,-63,-127,-57,-44,-73,50,67,-74,-102,84,-6, 
  /* [39][0][][] */ 0,-52,7,72,13,80,85,-50,-25,50,17,-25,-12,127,53,116, 
  /* [40][0][][] */ 104,48,79,96,-59,-57,-2,26,-80,63,-8,-16,-44,-25,127,2, 
  /* [41][0][][] */ -22,-11,10,54,-94,116,2,52,-56,29,-112,11,19,33,50,-127, 
  /* [42][0][][] */ 9,-102,26,-18,127,32,64,12,-26,-100,-95,-26,-15,-12,-10,36, 
  /* [43][0][][] */ -39,-96,-43,7,122,16,-6,95,-71,-66,-127,-85,117,-11,-62,58, 
  /* [44][0][][] */ -39,-56,-80,-96,35,80,70,15,-36,-127,-68,74,-45,56,28,109, 
  /* [45][0][][] */ -4,-57,-70,-9,-127,69,-25,-59,60,-49,29,-49,1,14,-38,48, 
  /* [46][0][][] */ 29,-83,-14,4,85,-84,-17,94,-5,-27,36,64,-49,-56,56,-127, 
  /* [47][0][][] */ -79,-29,-12,87,-7,8,37,42,-2,127,82,88,-42,83,-8,102, 
  /* [48][0][][] */ 43,-13,-80,-88,33,-65,8,53,45,-77,-3,24,-58,6,-42,-127, 
  /* [49][0][][] */ 55,36,10,32,-11,-25,48,44,-31,127,-40,36,-37,-28,73,84, 
  /* [50][0][][] */ 6,2,13,11,-127,-18,-11,-47,54,20,22,52,-22,-62,17,-2, 
  /* [51][0][][] */ 16,-6,-11,-127,-25,99,49,-52,10,6,35,-51,71,77,-28,15, 
  /* [52][0][][] */ 23,-22,-1,-83,81,-111,-10,-34,39,-1,127,-56,37,6,-33,95, 
  /* [53][0][][] */ -46,-63,50,-24,-40,-127,19,-101,-4,91,-95,80,-33,-18,30,-84, 
  /* [54][0][][] */ 62,66,44,-16,-127,-41,-90,-102,-7,12,49,69,-72,-49,61,10, 
  /* [55][0][][] */ 15,12,-35,72,-35,25,38,-19,5,127,20,58,-2,1,-1,45, 
  /* [56][0][][] */ 43,-112,-75,83,-79,43,-7,62,127,11,59,53,-31,-32,53,90, 
  /* [57][0][][] */ 48,20,104,-92,96,-6,-14,-2,95,-36,7,127,63,-58,103,-71, 
  /* [58][0][][] */ 79,-59,13,-70,35,17,-3,127,52,92,-6,63,51,16,85,-3, 
  /* [59][0][][] */ -45,39,32,-45,2,-96,-3,9,4,23,-120,-103,-127,-59,79,-16, 
  /* [60][0][][] */ 39,-24,23,17,10,-19,12,-52,24,127,-11,63,-10,-26,-18,-32, 
  /* [61][0][][] */ 65,63,15,-24,-86,-127,-19,-61,-63,-16,-23,19,-68,-45,86,86, 
  /* [62][0][][] */ -25,87,-39,40,-55,127,-46,26,-59,8,-40,32,-31,41,60,-88, 
  /* [63][0][][] */ 31,-7,-67,-127,-17,-47,80,-13,-2,-95,-30,33,-39,72,34,-32, 
  /* [64][0][][] */ -39,18,13,-25,56,-66,29,85,-127,-15,-78,-36,-29,86,63,62, 
  /* [65][0][][] */ -71,-13,-42,-20,73,41,-46,-79,-127,-54,9,-27,-119,111,-60,49, 
  /* [66][0][][] */ -17,58,-10,31,-45,127,-22,21,-61,20,-30,45,-30,51,49,-84, 
  /* [67][0][][] */ 18,-26,-42,-30,14,-88,66,-98,-4,30,8,121,-63,-30,-24,-127, 
  /* [68][0][][] */ 9,-127,-26,73,-9,3,23,86,40,39,54,11,-69,32,-15,-11, 
  /* [69][0][][] */ 10,88,88,-120,55,6,-33,103,36,106,61,92,100,-99,30,-127, 
  /* [70][0][][] */ 46,28,46,-37,97,7,-99,-51,-127,-90,-3,47,-33,64,-105,-7, 
  /* [71][0][][] */ -22,-73,30,-45,72,-13,39,32,-86,83,-127,-47,16,92,-21,49, 
  /* [72][0][][] */ 14,17,67,13,-61,-28,-117,-71,-8,71,-27,65,29,117,-127,-6, 
  /* [73][0][][] */ -1,-37,-18,-41,41,-115,32,-49,75,90,109,-14,21,-22,-73,127, 
  /* [74][0][][] */ 6,2,-28,80,-81,-3,92,23,78,62,28,113,127,22,-58,7, 
  /* [75][0][][] */ -30,42,-26,35,-51,127,-18,20,-35,29,-38,43,-20,49,29,-67, 
  /* [76][0][][] */ -74,90,-58,47,-113,-7,-9,26,52,46,-45,-46,51,-50,-127,42, 
  /* [77][0][][] */ 114,114,-122,127,79,77,77,52,46,11,106,-39,83,36,66,24, 
  /* [78][0][][] */ 14,-37,0,-62,70,-124,32,-55,50,48,127,-26,6,-17,-42,124, 
  /* [79][0][][] */ -40,58,3,22,-2,-46,-36,-4,-127,-6,52,8,105,42,-78,-43, 
  /* [80][0][][] */ -79,22,80,-1,67,48,-5,-127,-77,61,-69,-47,-8,-94,30,59, 
  /* [81][0][][] */ 87,73,-19,-2,34,-30,76,112,-105,127,-65,-40,-45,24,115,115, 
  /* [82][0][][] */ 55,118,-34,-76,-13,-53,117,-106,28,22,-70,74,127,-21,72,-52, 
  /* [83][0][][] */ 6,-35,19,27,2,27,-31,-101,68,-35,97,15,36,-67,-54,-127, 
  /* [84][0][][] */ -127,-86,-40,-21,-4,98,92,2,88,72,101,103,59,88,-81,8, 
  /* [85][0][][] */ 119,4,100,-82,75,-7,-26,90,17,126,-61,10,-41,66,127,20, 
  /* [86][0][][] */ -79,71,-34,-1,33,87,20,18,94,42,127,-22,-26,64,-10,-23, 
  /* [87][0][][] */ 10,-58,25,-45,44,-127,27,-31,45,-10,65,-37,34,-42,-40,71, 
  /* [88][0][][] */ -82,58,42,-6,113,-28,37,22,-59,-72,103,-71,74,116,105,-127, 
  /* [89][0][][] */ -24,37,-13,28,-33,127,-17,33,-45,11,-40,22,-7,58,29,-86, 
  /* [90][0][][] */ 52,-80,25,23,127,-3,49,31,-9,-95,-118,-24,-13,-9,-59,30, 
  /* [91][0][][] */ -10,69,-24,-42,1,-82,-102,36,-83,23,-115,-127,-122,-88,-6,17, 
  /* [92][0][][] */ 68,46,63,35,-127,-90,17,9,-21,31,-28,-33,-23,-81,26,-3, 
  /* [93][0][][] */ -4,-127,-112,67,-44,-58,-18,116,100,70,7,68,-64,62,-16,-31, 
  /* [94][0][][] */ 104,11,127,-25,25,-36,15,37,29,88,-2,58,14,7,123,-13, 
  /* [95][0][][] */ -58,-45,-22,-23,127,-7,42,76,-33,-9,-102,-55,18,10,-64,28, 
};
const TfArray<4, int> tensor_dimension51 = { 4, { 96,1,1,16 } };
const TfArray<96, float> quant51_scale = { 96, { 0.0044465991668403149, 0.0020991421770304441, 0.0051674819551408291, 0.0041353912092745304, 0.0023946147412061691, 0.0011287524830549955, 0.0042726928368210793, 0.0024831276386976242, 0.0012572625419124961, 0.0029335010331124067, 0.00084900140063837171, 0.0019940461497753859, 0.0030044633895158768, 0.0071949055418372154, 0.0017012638272717595, 0.0026215235702693462, 0.0032666088081896305, 0.0023572077043354511, 0.0026105977594852448, 0.0011980562703683972, 0.0043088197708129883, 0.0015745896380394697, 0.0027541343588382006, 0.0026228870265185833, 0.001374558312818408, 0.0025270751211792231, 0.0037721302360296249, 0.0036644467618316412, 0.002397679490968585, 0.0040529211983084679, 0.0028309328481554985, 0.0022260560654103756, 0.0041699865832924843, 0.0012755565112456679, 0.0026765426155179739, 0.0029050162993371487, 0.0026202495209872723, 0.0037243012338876724, 0.0020768451504409313, 0.0031113279983401299, 0.00095722038531675935, 0.0034919441677629948, 0.0030025853775441647, 0.0022754780948162079, 0.0022648873273283243, 0.0013873043935745955, 0.0017467391444370151, 0.0018703904934227467, 0.0043566236272454262, 0.0034622969105839729, 0.0040307631716132164, 0.0021145599894225597, 0.0035508205182850361, 0.0022458429448306561, 0.0017518693348392844, 0.0066284802742302418, 0.0026137428358197212, 0.00095819390844553709, 0.0023588279727846384, 0.0030811091419309378, 0.0029223409947007895, 0.0015183858340606093, 0.0033665494993329048, 0.0042837569490075111, 0.00092868821229785681, 0.0011402255622670054, 0.0045291697606444359, 0.0027819671668112278, 0.0021009980700910091, 0.0017250985838472843, 0.0042705866508185863, 0.0023349446710199118, 0.0026104634162038565, 0.0029173118527978659, 0.004030122421681881, 0.0041274745017290115, 0.0030836930964142084, 0.0015765128191560507, 0.0029845882672816515, 0.0026610209606587887, 0.0026569291949272156, 0.0023499005474150181, 0.0018104395130649209, 0.0010551078012213111, 0.0026857824996113777, 0.0011594153475016356, 0.0022538036573678255, 0.0045176316052675247, 0.0043139583431184292, 0.0044242222793400288, 0.0030706741381436586, 0.0014597718836739659, 0.0029600935522466898, 0.0022838898003101349, 0.0016543533420190215, 0.0022522832732647657, } };
const TfArray<96, int> quant51_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant51 = { (TfLiteFloatArray*)&quant51_scale, (TfLiteIntArray*)&quant51_zero, 0 };
const ALIGN(8) int8_t tensor_data52[16*1*1*96] = { 
  /* [0][0][][] */ 20,25,11,18,-16,-71,-12,-5,-24,-73,11,-5,55,-67,53,31,-87,-30,36,6,79,21,-68,11,-8,64,127,70,14,73,57,-39,5,2,9,-23,30,25,-9,-8,116,17,25,-20,-8,-8,4,-42,26,-37,95,-4,-70,-4,38,33,-8,-41,7,20,-11,35,-64,-13,12,-6,65,31,3,-22,22,27,5,37,8,32,57,-33,47,21,-13,47,35,32,-56,10,-8,68,17,6,-88,-21,20,12,106,70, 
  /* [1][0][][] */ 21,40,-49,-16,-2,-48,94,-76,-63,-39,-64,-47,-3,-43,-10,-54,-31,-25,-32,-16,-15,-91,113,-34,-3,17,2,61,-52,8,-37,16,-32,23,14,6,-22,54,-58,84,29,12,0,-46,56,-59,-8,35,-84,-2,50,-106,-41,42,63,60,33,24,-66,14,-45,0,-14,-16,33,28,103,8,-43,-127,8,4,22,66,-22,34,-54,-30,104,-30,41,-12,54,-60,-28,-62,-19,14,-20,-45,32,0,68,-58,-34,55, 
  /* [2][0][][] */ 8,-18,18,-9,64,44,-53,24,-56,44,15,-26,34,-8,20,30,29,-27,-127,-10,-17,-42,-12,22,1,-17,-44,16,-37,-19,-18,69,-16,-37,-3,15,-44,25,-23,-19,71,13,4,41,6,55,5,-7,-84,5,-18,17,-24,48,13,-60,35,23,42,33,-25,-11,-21,55,39,-4,-34,-2,-4,-5,-13,-37,21,51,27,70,-54,-10,-26,-34,35,33,53,-16,-11,-42,-13,-49,-16,-35,-13,68,-1,-8,83,-40, 
  /* [3][0][][] */ 38,-39,-23,-115,-7,-31,112,-30,25,122,-78,-19,8,-23,-21,63,59,43,-26,17,-50,22,20,7,-45,78,51,-6,-44,-14,-69,65,-1,-21,30,-27,2,-55,-27,61,6,11,-19,24,57,-53,-5,33,48,-27,28,-39,104,41,30,-4,0,-23,-8,-45,-36,37,67,-5,-32,-27,123,-36,-38,-16,-51,27,14,-73,3,-77,17,-48,127,-4,-9,-56,-37,-49,-34,-45,75,79,-42,46,-59,0,8,-81,-21,33, 
  /* [4][0][][] */ -29,77,33,14,-12,9,-37,-21,13,-32,3,-14,22,44,-23,23,-10,-42,-17,-73,28,-34,-62,16,-28,-35,-23,17,-38,127,-52,-18,5,-43,-3,-30,71,43,-34,2,14,8,15,-40,-49,-6,52,-22,23,-17,-63,-10,-66,28,45,21,5,57,-23,20,-33,-72,-27,5,53,24,-65,-8,0,0,8,-70,-13,61,53,64,-33,18,-61,40,17,65,28,-63,43,-65,-30,-67,-39,-49,-49,-14,0,8,33,-30, 
  /* [5][0][][] */ -5,-10,38,-18,-11,-21,-15,2,37,7,-17,-4,-18,-28,22,-19,-11,4,-49,-33,-21,15,-21,11,21,-42,65,-18,-3,39,11,75,-8,-81,20,9,-36,-28,-30,1,-49,-3,-22,12,4,19,-70,24,-19,16,48,-10,23,-72,4,18,-23,-54,7,-36,39,22,23,44,-38,9,107,-23,-6,-23,12,16,-2,28,35,10,-6,-14,127,37,-23,-12,-29,27,41,60,4,91,2,-34,-8,10,11,-13,-29,19, 
  /* [6][0][][] */ 25,-60,75,14,-44,121,-51,-107,-25,-84,-91,63,9,12,-35,96,10,42,17,-42,-92,-25,-93,-67,6,-55,-10,77,-125,57,-21,-33,46,96,-20,-4,-1,-41,19,-20,-68,43,33,-37,24,53,-105,-8,56,10,-90,-127,88,8,-40,-22,27,-31,26,-23,-16,-47,41,0,60,-81,-73,-67,-104,17,-16,-85,-31,-107,26,-113,92,11,-82,47,-34,90,23,-107,72,-47,-17,-1,-77,84,-88,94,49,-53,74,-108, 
  /* [7][0][][] */ -11,-11,-60,60,-29,-2,40,-3,-99,2,83,55,-3,-56,-1,-34,-11,-3,0,-2,-50,-24,-39,-41,70,45,-6,70,-1,32,20,29,-52,-127,29,106,-2,16,-41,6,-8,-11,4,-78,29,56,68,84,-15,46,-49,3,27,-44,45,-57,-16,34,-79,-20,58,8,7,-35,72,-50,106,-16,-61,-26,69,2,-16,-28,-78,-24,30,-39,96,-33,-2,-11,-74,-34,45,20,-74,44,-10,15,5,31,65,-7,85,-7, 
  /* [8][0][][] */ -10,-57,9,6,-10,-5,18,-5,-12,-4,45,42,14,28,-40,-5,69,-2,15,-1,-13,-73,-33,-20,-24,-34,69,4,-20,46,5,-30,-14,-3,0,0,-45,-17,16,-25,-5,40,27,-39,12,-17,24,-14,35,-2,47,3,-5,11,-42,1,-16,105,-58,-4,-14,-60,-59,-6,-84,-35,-20,18,-8,11,37,-21,-27,-127,42,-103,11,14,-58,19,-27,-10,1,57,62,-60,-40,49,-35,85,12,-20,-50,1,-3,-61, 
  /* [9][0][][] */ -27,-26,-27,22,4,18,4,38,-43,2,61,55,-26,54,25,-47,-17,33,-20,-43,1,39,-4,9,-22,23,8,15,33,-7,15,-8,-15,-21,6,54,-20,-5,23,-1,-11,-25,12,2,8,44,2,40,-43,8,-15,30,127,20,-11,2,16,-13,32,17,-31,3,80,10,13,23,63,7,32,-7,-20,23,6,-122,-37,-120,-31,-12,40,-2,-4,33,3,-40,41,14,-54,-1,-3,110,37,31,52,34,-12,29, 
  /* [10][0][][] */ 22,43,14,-3,-16,14,-41,-21,66,8,-36,21,18,9,-4,-54,-31,0,20,0,23,-13,-18,-30,13,-19,-93,42,-20,52,-2,11,19,23,-18,3,13,4,3,-1,41,-10,56,-42,-30,-2,18,27,18,4,11,-24,-21,-13,-2,35,-12,8,-12,-7,-12,-36,-6,11,-3,-14,-89,-28,-50,-17,45,-15,-19,31,35,19,50,-19,-90,12,-11,32,0,-4,8,8,-70,-127,-24,26,12,21,50,-30,18,31, 
  /* [11][0][][] */ 21,-41,1,6,-57,32,13,8,70,-16,-20,-41,21,10,12,-10,-30,49,22,-63,6,30,17,-25,38,12,61,0,30,-58,-29,17,18,102,-98,5,13,-13,57,10,-49,48,-16,15,-44,1,-12,-6,49,-19,-24,-15,-21,17,-79,92,-29,2,-4,-31,23,4,-9,-65,-7,-45,-127,-77,-1,-35,-90,30,51,19,-8,1,34,56,-112,-35,-11,-4,-14,-3,-21,-4,57,78,21,-48,8,7,-35,28,81,31, 
  /* [12][0][][] */ 20,26,-35,-26,15,-24,5,36,54,-37,19,-3,0,-16,-5,12,9,-42,-25,12,11,56,4,51,-39,-37,-127,-10,74,-24,29,-1,-18,-73,70,-7,32,-13,-4,18,-3,-56,14,34,44,-2,24,-16,-71,-2,-49,95,74,-23,31,-74,9,22,-38,-33,15,51,76,4,-14,-17,32,24,109,26,24,28,4,-18,-11,-6,-35,-56,44,-67,22,-47,31,-39,5,6,6,-104,-8,35,-40,20,15,68,12,42, 
  /* [13][0][][] */ -14,22,-69,24,26,15,-9,6,28,66,-34,40,-46,-21,61,-47,11,50,59,12,-29,-40,-4,15,42,45,-19,23,8,39,53,-18,-14,63,-3,46,19,-36,-50,-48,3,-13,15,15,46,49,-30,48,-45,35,-1,3,-16,-39,62,39,13,-43,-12,-14,24,20,3,-25,16,87,127,36,22,0,-47,-16,38,53,-76,52,19,-70,125,-39,-12,-32,23,1,29,56,-31,-20,-15,-23,10,48,41,14,59,54, 
  /* [14][0][][] */ -9,48,19,22,-57,-42,19,40,-76,-23,70,10,-77,-8,67,-21,-48,36,-57,22,-25,23,-93,12,-48,-2,-51,-110,13,-4,28,75,-57,27,15,-15,-25,-69,-10,-40,28,-34,48,-22,-12,47,-73,25,-13,-44,82,29,-15,26,-31,30,-55,30,1,41,37,61,-9,41,13,-51,3,-66,41,59,73,35,-52,34,8,13,28,-13,38,17,-68,117,-1,-127,80,-3,-1,11,-105,-17,-19,-5,-28,12,37,32, 
  /* [15][0][][] */ 74,-33,25,30,38,8,-12,-7,23,32,-59,-17,68,68,-5,-20,-8,8,-81,55,3,-30,16,29,68,-34,89,28,46,-31,-43,70,67,59,0,-81,64,72,69,53,94,40,-20,6,-39,-123,38,-35,-33,-21,-16,-5,-5,-55,-30,55,-13,7,-12,19,5,-51,-31,31,42,49,-80,39,-8,-32,-6,-4,0,-126,-45,-104,-22,20,-127,34,82,-35,51,31,-54,-3,-6,-21,38,93,13,-63,-31,-31,36,-38, 
};
const TfArray<4, int> tensor_dimension52 = { 4, { 16,1,1,96 } };
const TfArray<16, float> quant52_scale = { 16, { 0.0034393013920634985, 0.002522207098081708, 0.0026237764395773411, 0.0026172443758696318, 0.0039404565468430519, 0.0059090047143399715, 0.0022590628359466791, 0.0024868366308510303, 0.0046300445683300495, 0.0042140302248299122, 0.0043794405646622181, 0.0033136862330138683, 0.0036011722404509783, 0.0037313015200197697, 0.003195042721927166, 0.0030467144679278135, } };
const TfArray<16, int> quant52_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant52 = { (TfLiteFloatArray*)&quant52_scale, (TfLiteIntArray*)&quant52_zero, 0 };
const ALIGN(8) int8_t tensor_data53[96*1*1*16] = { 
  /* [0][0][][] */ -52,49,-12,-28,-30,-61,-66,-37,69,-53,40,-56,86,-120,14,-127, 
  /* [1][0][][] */ -104,66,-106,-112,-80,25,-12,60,-42,4,94,-52,48,127,23,46, 
  /* [2][0][][] */ -44,-10,-78,7,-10,-50,27,-41,-92,127,75,9,50,59,-46,114, 
  /* [3][0][][] */ -53,-73,8,-42,-86,10,-57,-127,-4,16,42,-76,-70,-41,-125,-47, 
  /* [4][0][][] */ 74,2,-17,41,-64,-8,-127,39,20,70,17,52,4,3,-49,-85, 
  /* [5][0][][] */ -98,57,-89,-31,58,-59,-20,-84,98,-29,15,-42,21,-121,-127,-101, 
  /* [6][0][][] */ -9,-36,-35,24,-87,73,38,-42,-22,-55,127,-25,-5,-1,-118,10, 
  /* [7][0][][] */ -29,109,127,-84,60,83,-3,-60,40,64,-87,-16,52,3,25,75, 
  /* [8][0][][] */ -49,4,38,-7,56,10,96,127,-78,-23,-67,-84,43,91,-69,-62, 
  /* [9][0][][] */ 38,48,103,28,-118,-44,-102,-119,71,13,127,30,-45,-104,57,-23, 
  /* [10][0][][] */ -12,-117,9,-78,-127,73,33,31,-31,-58,-3,39,-18,58,-126,26, 
  /* [11][0][][] */ 119,-59,-12,95,-117,-35,58,-7,127,118,-51,45,26,-84,-16,114, 
  /* [12][0][][] */ -64,-64,127,-12,55,-19,23,56,65,-24,97,69,-29,16,-94,30, 
  /* [13][0][][] */ -4,-31,20,24,13,10,127,34,-103,12,9,12,-24,115,96,-71, 
  /* [14][0][][] */ 126,-88,127,4,75,62,108,60,83,70,60,43,67,-49,38,-57, 
  /* [15][0][][] */ -4,123,10,-41,36,127,-76,67,-42,-23,-39,-12,-48,119,-24,-48, 
  /* [16][0][][] */ -40,64,110,-45,23,80,2,-8,-8,12,-14,45,88,2,89,127, 
  /* [17][0][][] */ 13,109,80,-127,32,-41,6,-79,-55,83,-26,58,-65,-29,102,-61, 
  /* [18][0][][] */ -85,3,-76,-91,116,86,-48,-69,45,86,127,78,-9,112,-43,-7, 
  /* [19][0][][] */ 48,127,90,70,52,-31,-10,-2,-30,119,41,115,60,66,-54,37, 
  /* [20][0][][] */ 102,-2,2,70,-75,-7,-31,52,-32,-54,-127,-43,95,-47,34,-7, 
  /* [21][0][][] */ -90,-77,-24,115,-29,4,-127,65,7,-4,32,21,-39,34,-64,9, 
  /* [22][0][][] */ -5,2,-65,-49,127,1,-33,52,56,71,41,63,-17,26,-14,31, 
  /* [23][0][][] */ -69,20,-17,13,15,56,100,85,-17,127,-23,-30,-3,28,-59,-31, 
  /* [24][0][][] */ 30,-77,39,2,127,33,71,-37,54,26,44,30,-63,32,-7,-18, 
  /* [25][0][][] */ 127,-61,79,22,9,-9,-34,90,121,-24,-56,10,122,-56,98,42, 
  /* [26][0][][] */ 59,39,108,91,75,-11,-67,-17,5,68,15,127,29,-69,26,-58, 
  /* [27][0][][] */ -59,38,-78,21,-31,112,19,-94,31,-86,124,21,43,-44,127,106, 
  /* [28][0][][] */ -40,32,-78,-127,31,-81,1,-54,-98,89,-56,29,-22,27,-30,70, 
  /* [29][0][][] */ 88,96,-75,42,32,83,-46,-22,49,47,7,61,-127,15,-24,79, 
  /* [30][0][][] */ -27,80,-120,-61,80,-40,13,13,-58,52,-69,-9,9,65,-14,127, 
  /* [31][0][][] */ 25,-116,87,43,63,-70,-80,35,-20,1,21,-37,-73,55,38,127, 
  /* [32][0][][] */ -58,63,-1,42,-104,55,14,62,22,-127,28,-87,30,43,40,52, 
  /* [33][0][][] */ -73,-7,62,89,-4,19,-51,16,-44,-51,13,-16,-9,-3,9,127, 
  /* [34][0][][] */ -14,9,-86,-92,54,-11,-5,61,19,-10,3,-14,-51,-21,-35,127, 
  /* [35][0][][] */ 71,-9,23,-10,-1,18,-76,-22,-17,-127,-54,11,-5,-30,47,-27, 
  /* [36][0][][] */ -7,23,-124,-16,37,127,-8,43,-27,14,59,30,15,29,-79,50, 
  /* [37][0][][] */ 56,39,62,-54,58,-127,40,-20,-109,61,-88,-26,9,20,99,33, 
  /* [38][0][][] */ -35,127,30,-43,34,24,71,-91,9,0,-107,35,-51,-92,-82,15, 
  /* [39][0][][] */ 88,47,-127,-121,-21,-28,12,-65,7,-6,3,-42,64,7,-122,-70, 
  /* [40][0][][] */ -36,22,-75,-84,-47,-14,20,-127,-8,-10,5,-35,39,72,37,63, 
  /* [41][0][][] */ -37,-93,-13,127,-1,-18,-67,-11,-5,-52,69,-65,-68,-9,5,25, 
  /* [42][0][][] */ -19,62,-19,-127,20,17,6,-29,54,-2,-42,16,70,-19,-18,12, 
  /* [43][0][][] */ 5,44,4,18,127,28,24,20,10,39,-3,-83,-117,-46,-16,-14, 
  /* [44][0][][] */ 81,-15,28,41,-27,-12,4,34,28,-37,27,9,127,5,-50,-31, 
  /* [45][0][][] */ 18,-85,-61,38,-39,-88,7,45,30,-22,11,34,-83,127,41,-37, 
  /* [46][0][][] */ -16,-87,46,77,0,-4,-107,53,32,-56,52,-22,34,76,81,127, 
  /* [47][0][][] */ -38,-54,19,76,1,-3,54,19,5,-65,-127,-35,44,-32,-61,16, 
  /* [48][0][][] */ -78,90,-16,-28,4,61,-5,-127,28,-27,39,-53,52,-127,-57,2, 
  /* [49][0][][] */ -59,6,43,-38,2,6,125,127,-31,-37,-11,20,-48,30,-51,30, 
  /* [50][0][][] */ 53,20,-75,33,36,-127,-43,0,-77,50,-42,-1,18,-81,-113,-48, 
  /* [51][0][][] */ -50,57,-34,113,-38,45,-46,-78,-43,-85,2,-54,1,34,-13,127, 
  /* [52][0][][] */ -127,6,20,-2,24,44,61,10,12,-83,-42,-41,-104,-57,-117,-9, 
  /* [53][0][][] */ -49,-74,-56,-127,-39,-7,11,81,39,-66,-48,28,-29,28,65,105, 
  /* [54][0][][] */ 10,-54,1,-6,-62,62,55,-22,-21,-90,55,30,-20,-12,-127,42, 
  /* [55][0][][] */ -18,-30,-41,30,63,-27,63,89,-59,-59,-127,-36,62,-29,-24,40, 
  /* [56][0][][] */ 73,-37,-55,-28,-127,23,-119,-7,-10,-18,-40,13,102,-42,51,9, 
  /* [57][0][][] */ -51,12,21,-30,127,40,50,41,-37,46,-1,-10,-57,74,-104,-24, 
  /* [58][0][][] */ 24,-1,2,-22,37,-13,-46,-57,48,-127,-63,1,-73,-49,-30,55, 
  /* [59][0][][] */ -70,-27,-3,9,15,55,-98,-44,80,127,-83,11,-23,4,-18,1, 
  /* [60][0][][] */ 20,-50,-2,17,-127,-47,30,6,-4,46,-18,47,1,-39,38,42, 
  /* [61][0][][] */ 20,31,-86,-12,-50,-22,-127,-81,-19,6,39,107,69,-61,106,60, 
  /* [62][0][][] */ 58,-19,50,-24,-16,38,47,127,-66,127,23,93,32,42,82,115, 
  /* [63][0][][] */ 20,-123,-14,-17,-71,14,47,-26,-10,-21,0,-15,-37,127,104,35, 
  /* [64][0][][] */ -9,-6,-127,-36,19,52,33,-20,-7,-102,46,-1,67,-39,-69,106, 
  /* [65][0][][] */ -10,-5,65,60,85,-19,80,83,-39,-3,-127,-76,30,106,-75,-17, 
  /* [66][0][][] */ -43,-127,-9,-104,-70,-125,49,-32,-7,-44,23,89,-65,-39,-70,86, 
  /* [67][0][][] */ -28,-83,-83,-26,-81,113,-2,-127,-81,-28,-40,-96,19,-15,-64,43, 
  /* [68][0][][] */ 127,46,22,-10,-78,15,-68,-53,-75,-111,-22,-11,36,-28,70,-64, 
  /* [69][0][][] */ 37,4,46,-22,-2,-47,-48,29,-12,127,-29,6,-4,33,67,-29, 
  /* [70][0][][] */ 42,-6,-26,76,-119,33,-16,-100,99,127,29,64,50,-56,-5,21, 
  /* [71][0][][] */ 127,-83,76,111,-93,-41,44,-27,124,7,-52,44,74,-72,28,18, 
  /* [72][0][][] */ -8,-45,43,106,57,1,-127,88,86,-8,43,5,-47,-72,-75,87, 
  /* [73][0][][] */ 71,17,67,-127,70,-89,-77,53,-15,116,-36,15,15,-84,30,-42, 
  /* [74][0][][] */ 92,10,35,44,-127,-29,39,-4,-76,-43,10,-44,30,-71,7,17, 
  /* [75][0][][] */ 82,127,-105,20,64,59,-22,-32,-18,-25,51,80,-114,56,58,80, 
  /* [76][0][][] */ -71,-38,0,-45,-55,-6,93,-5,-64,25,100,48,-54,-127,-21,92, 
  /* [77][0][][] */ -57,127,-27,17,-60,-78,45,83,46,-65,-15,72,-23,58,-8,87, 
  /* [78][0][][] */ 123,49,-65,34,-86,36,-127,-22,-11,-15,-74,10,33,-107,30,69, 
  /* [79][0][][] */ -72,-37,127,56,-24,-96,-53,-52,-23,19,16,16,-69,123,-58,71, 
  /* [80][0][][] */ 60,102,27,-127,-13,31,95,-33,14,19,-38,23,85,-52,3,-2, 
  /* [81][0][][] */ 39,-65,18,-121,100,44,-11,127,112,30,-21,-53,-20,20,-96,-73, 
  /* [82][0][][] */ 79,46,74,-1,127,-99,27,45,-2,105,-33,27,-11,-43,36,-104, 
  /* [83][0][][] */ -39,85,15,12,91,67,127,110,-10,51,-30,-70,-92,104,-58,-102, 
  /* [84][0][][] */ 3,-95,-8,101,2,-86,-84,38,-91,64,-64,-13,-127,71,-9,-59, 
  /* [85][0][][] */ -102,53,-38,-8,-19,-43,-47,-37,-15,41,16,-72,-127,-84,-71,45, 
  /* [86][0][][] */ -13,60,98,117,38,-38,56,19,8,24,-53,-74,28,76,-127,-69, 
  /* [87][0][][] */ -18,47,127,-27,-99,-30,21,12,35,-24,12,43,-51,19,-9,-6, 
  /* [88][0][][] */ -27,-74,-118,28,41,38,-5,23,-20,-83,-118,-105,127,-17,10,41, 
  /* [89][0][][] */ 35,22,19,-122,8,-65,-54,54,127,-16,25,-104,6,-38,61,-82, 
  /* [90][0][][] */ 2,68,23,11,-38,38,38,115,6,-59,-12,127,52,13,-42,80, 
  /* [91][0][][] */ -53,3,-19,67,81,52,-40,-113,-40,34,-10,15,-104,-127,-61,-16, 
  /* [92][0][][] */ -30,69,1,-21,-127,2,-87,53,-42,57,93,76,-16,-20,65,9, 
  /* [93][0][][] */ 111,44,101,47,-127,-81,15,26,-20,-64,-25,-70,24,-57,-9,-2, 
  /* [94][0][][] */ -34,-127,25,-102,14,35,-22,4,81,-21,2,55,13,58,-48,42, 
  /* [95][0][][] */ -42,-60,-28,-57,121,113,-32,44,88,46,-74,57,-34,127,-79,40, 
};
const TfArray<4, int> tensor_dimension53 = { 4, { 96,1,1,16 } };
const TfArray<96, float> quant53_scale = { 96, { 0.0014675323618575931, 0.0014496829826384783, 0.0022375809494405985, 0.0024071978405117989, 0.0019284961745142937, 0.0010535066248849034, 0.0013030819827690721, 0.0022410056553781033, 0.0020909453742206097, 0.0010412664851173759, 0.0027658094186335802, 0.0015275633195415139, 0.001897477894090116, 0.0020826689433306456, 0.0020948671735823154, 0.0019288297044113278, 0.0024882915895432234, 0.0011907906737178564, 0.0018135412828996778, 0.0023849387653172016, 0.0020165159367024899, 0.000968246313277632, 0.001334988628514111, 0.0022681632544845343, 0.0021698791533708572, 0.0020556829404085875, 0.00094529864145442843, 0.0017474954947829247, 0.0021660348866134882, 0.0021372800692915916, 0.0011739617912098765, 0.002230111276730895, 0.0011384974932298064, 0.0027067998889833689, 0.0023951565381139517, 0.0021133446134626865, 0.0021759180817753077, 0.0014841395895928144, 0.0022357804700732231, 0.0022869869135320187, 0.0022769593633711338, 0.0024917814880609512, 0.0029459542129188776, 0.0030441377311944962, 0.0036333967000246048, 0.0026272935792803764, 0.0018891927320510149, 0.0022691427730023861, 0.0018865708261728287, 0.0026320009492337704, 0.0018787210574373603, 0.0019242139533162117, 0.0021843749564141035, 0.0031096136663109064, 0.002756193745881319, 0.0024428137112408876, 0.0022299047559499741, 0.0019517667824402452, 0.0015994743444025517, 0.0024907076731324196, 0.0029036507476121187, 0.0016377847641706467, 0.0017992402426898479, 0.0023087819572538137, 0.0018780643586069345, 0.0014293011045083404, 0.0017737078014761209, 0.0020338247995823622, 0.0015245905378833413, 0.0027613081037998199, 0.0015336194774135947, 0.0017205955227836967, 0.0017744932556524873, 0.0016255028313025832, 0.0020172423683106899, 0.0016615048516541719, 0.0028976511675864458, 0.0025957454927265644, 0.0019175147172063589, 0.0021403031423687935, 0.0020613463129848242, 0.0017038262449204922, 0.001187420217320323, 0.001821771846152842, 0.0018885189201682806, 0.0022959944326430559, 0.0026168492622673512, 0.0036967734340578318, 0.00084008264821022749, 0.0026045632548630238, 0.003543277271091938, 0.0024565376807004213, 0.0010489695705473423, 0.0019843080081045628, 0.0029023746028542519, 0.0018773766933009028, } };
const TfArray<96, int> quant53_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant53 = { (TfLiteFloatArray*)&quant53_scale, (TfLiteIntArray*)&quant53_zero, 0 };
const ALIGN(8) int8_t tensor_data54[16*1*1*96] = { 
  /* [0][0][][] */ -108,38,62,-27,-72,-8,-69,-2,-56,6,-13,-29,34,41,39,-39,15,0,93,13,9,-52,127,66,47,28,4,31,-65,-119,-93,4,-46,-48,28,19,8,24,-4,30,-8,-4,-83,5,-69,-26,-1,90,-21,14,-47,-17,-8,3,26,-55,-106,3,-11,82,54,27,-3,6,-32,-54,-45,25,-57,-65,11,-20,8,-3,-77,-48,-46,12,-37,7,-60,71,86,-73,10,52,9,50,31,-18,-7,-25,-35,-39,-59,11, 
  /* [1][0][][] */ 35,17,26,-49,-63,-24,-11,11,-18,24,52,-55,4,-10,-64,-35,-9,-1,-66,27,-13,-77,8,49,-11,-68,-4,-48,66,-108,108,-77,54,23,-18,49,36,70,-11,-43,30,18,-3,-13,8,60,-127,-48,-54,-53,-16,-26,39,-49,-36,47,9,-1,-31,16,26,53,-9,-100,-15,-16,-59,-5,4,-17,-81,-10,-43,-23,16,-73,8,20,32,-70,-23,-27,-88,-30,34,-38,-23,19,-75,-12,-55,42,21,61,-53,53, 
  /* [2][0][][] */ 84,-37,21,23,19,-78,66,3,-9,-10,-11,-12,-78,-29,10,-34,-95,-52,-39,46,6,-54,-47,30,-1,-69,9,-28,-32,47,-57,127,-53,125,-29,24,-12,-15,-16,-10,-102,80,75,18,-65,8,-20,-13,38,5,-33,-53,52,-20,-24,66,41,0,47,-4,10,45,-31,10,75,13,-5,-9,30,53,-48,-2,48,51,67,40,31,-73,71,53,87,-15,-43,26,-57,33,23,71,17,11,-22,32,-50,50,-17,36, 
  /* [3][0][][] */ 1,-7,-21,8,11,-10,7,-59,-23,57,38,57,29,-11,-53,41,5,-35,29,11,13,127,33,-45,10,23,-20,4,65,-36,61,-18,-20,32,-30,-26,22,49,35,8,-74,-33,-38,26,-31,33,25,-3,-18,-48,-6,-26,47,-83,-33,-47,13,86,-29,-1,-7,-11,-42,3,25,46,-42,-1,-25,-1,11,-69,-31,-46,33,-11,12,-6,-35,-30,-28,-7,-54,11,-11,-38,32,-26,-1,21,29,-18,47,26,-37,59, 
  /* [4][0][][] */ 32,11,-40,14,26,20,-45,5,-29,78,95,-18,-13,0,6,-49,12,-14,-29,48,18,-47,51,87,-73,0,-127,13,-44,-63,9,16,-60,-50,17,55,14,37,21,28,-35,-42,46,-24,-4,9,-34,52,-40,55,12,17,43,-14,-82,16,47,-17,10,-9,48,-4,28,8,-47,14,-36,6,-49,28,-45,53,41,-63,-38,-47,26,-59,-6,8,-44,87,-79,1,-28,23,33,-59,55,5,31,8,-59,-26,36,33, 
  /* [5][0][][] */ -78,38,47,-8,48,-19,60,-40,-10,34,-8,-32,35,-22,-21,-41,-9,-34,54,26,-123,-22,-75,49,-45,-10,48,13,44,-80,-16,44,56,119,-14,39,-6,20,45,-21,-29,98,78,-30,-1,67,44,-4,0,14,-24,30,16,-39,30,-96,41,-56,-64,-65,62,100,-52,-19,78,-40,-78,-65,-60,-22,-62,-7,-20,11,-24,-46,22,-42,-35,-18,127,-25,24,-90,-84,37,33,-13,-50,38,23,-6,-18,37,11,95, 
  /* [6][0][][] */ 49,-11,-89,31,-36,-117,106,95,-62,74,-16,77,-126,-84,60,62,-1,-59,-4,4,-6,-16,-69,-62,-60,46,83,30,36,35,99,-57,26,17,18,-78,15,6,33,77,6,19,-61,-25,0,-65,-82,21,40,-127,-24,78,39,12,-20,-73,76,50,13,-2,-114,55,-97,4,30,7,0,59,43,29,-5,-52,-39,23,102,35,67,-22,46,-77,-7,-58,-78,70,6,-66,52,15,-41,65,37,43,-26,14,-34,122, 
  /* [7][0][][] */ 34,85,-42,-57,-25,-13,37,11,-59,35,-50,-57,-40,16,10,-11,-47,-47,-35,60,-5,127,10,32,-8,7,23,27,52,45,81,-28,70,32,-20,9,3,-7,2,33,-66,-5,11,-54,18,-47,74,-28,42,-77,-86,-29,-48,8,-1,-15,27,16,-104,7,-5,116,19,-25,-22,-1,-45,15,-39,-16,-103,34,14,70,-36,46,-55,55,10,-77,-20,-53,61,-77,43,-23,-6,0,-8,76,-85,49,54,-34,-44,12, 
  /* [8][0][][] */ -9,78,-44,41,-35,-29,-83,24,-96,-33,6,1,-41,38,31,82,5,-46,5,7,31,-3,3,-13,-38,73,-3,24,-14,-20,-43,-32,-20,-53,-29,-68,-43,23,48,4,-2,-39,28,9,-36,-33,6,-13,-24,-15,47,67,-2,-20,-70,97,-37,28,-3,-38,-37,8,19,50,-34,-61,-37,-10,-40,5,3,2,-19,-48,-116,-16,-45,23,-61,-40,-33,2,-42,-33,0,-3,19,29,10,61,-55,-10,-85,-127,22,-49, 
  /* [9][0][][] */ -14,20,-70,46,-32,-32,69,53,-9,46,-23,93,-26,-21,23,127,12,11,72,18,18,14,33,-89,-33,-3,25,-9,12,-15,40,50,-28,0,0,-112,26,-17,-23,-18,-14,20,40,-24,-9,3,17,17,35,83,25,-9,-54,-76,-2,0,1,-8,67,-18,-62,55,-59,-26,82,-11,-24,6,-67,27,36,36,-9,86,-21,-24,-29,19,-41,-9,51,-29,61,-2,26,-15,-12,-34,-53,20,2,0,63,34,-44,1, 
  /* [10][0][][] */ 73,0,-45,-2,-35,-32,73,1,12,-24,-20,-6,-93,-17,3,-5,-73,-32,25,23,39,35,22,7,-46,83,42,-6,-51,-74,-30,-11,77,-35,48,13,75,-88,85,127,17,-59,6,6,-21,-91,-8,64,34,86,-68,-44,-21,28,16,56,19,-61,78,51,-11,49,-65,-20,-7,-59,21,57,21,-24,-11,43,121,37,26,-86,29,-47,56,-9,-46,32,35,24,-38,-9,7,42,-41,-13,28,55,52,69,-33,10, 
  /* [11][0][][] */ -58,-39,44,-68,15,-15,-30,-46,43,-48,2,-5,-17,0,7,5,-64,-4,63,12,-56,22,-81,-89,12,16,-50,41,36,-59,40,-34,22,-6,17,-28,-80,10,-122,18,-75,68,-50,58,20,9,-4,-40,21,-41,-67,-59,20,28,80,-59,-31,-73,13,-54,-26,-56,-26,-127,8,-70,65,71,122,20,80,-21,-41,-14,65,-37,99,39,26,50,29,-10,-26,94,81,5,-11,-20,-85,-67,-13,26,59,40,59,76, 
  /* [12][0][][] */ 40,-23,-4,-39,36,113,-10,34,49,60,1,59,20,49,14,1,-64,49,15,50,127,-2,71,-71,35,24,-70,-68,-20,80,2,9,31,-7,8,-34,46,-3,-33,-35,22,-20,44,54,-23,38,2,-10,-64,27,1,23,-26,-25,13,16,-36,61,10,51,27,-93,12,-97,-8,95,-14,-34,-4,-42,62,12,-9,15,-9,48,-11,52,-78,-12,-20,30,123,15,-8,77,-28,-69,75,10,-82,56,71,8,-19,-96, 
  /* [13][0][][] */ -7,35,-17,-46,-33,-7,6,-35,18,-32,-33,-73,61,-110,-44,-72,-17,-36,-82,-14,-96,-33,19,105,-29,6,114,8,22,-37,57,49,12,2,-125,127,-29,-54,28,-57,118,14,-2,26,-5,-94,60,-31,80,-10,-42,28,26,-4,-4,72,71,-53,-44,-8,52,47,-2,-86,-3,36,-39,35,-69,-38,-83,2,-67,21,-43,-89,-108,23,37,83,-14,61,39,-94,55,45,36,-15,-17,-15,-11,21,-61,19,-23,-4, 
  /* [14][0][][] */ -8,22,-77,-28,82,92,-87,-8,29,-46,78,-7,18,-26,-37,-69,-69,16,30,127,8,-22,-2,5,3,40,-31,67,10,-6,-27,7,61,-4,-43,6,-19,59,71,9,59,-1,28,2,-9,-43,57,-38,22,-8,-14,-25,43,14,-40,27,12,56,-93,-11,-18,-68,-43,-100,8,-41,-50,-7,-76,53,-18,30,0,-30,-24,-35,36,-15,-53,-29,27,5,-2,-15,-13,46,-15,-19,-36,67,66,19,1,-40,-46,-68, 
  /* [15][0][][] */ -71,-41,40,-63,20,-25,-37,-87,-4,18,-3,73,-3,-22,32,94,-113,-20,21,-67,31,-30,-10,-84,53,-9,54,-51,-62,-104,-67,39,-36,62,90,-95,-7,-35,23,-25,-22,-1,33,-19,0,-1,68,108,-45,-8,26,-40,-48,58,18,-53,-96,-13,110,16,-29,15,-97,31,-66,-10,9,29,54,-70,88,-23,62,-37,-33,-48,15,29,50,6,-15,79,58,33,1,-14,-127,10,-4,-54,-86,29,48,-32,-23,66, 
};
const TfArray<4, int> tensor_dimension54 = { 4, { 16,1,1,96 } };
const TfArray<16, float> quant54_scale = { 16, { 0.0023164576850831509, 0.0028642693068832159, 0.0024025880265980959, 0.0028110495768487453, 0.0031959658954292536, 0.0029252548702061176, 0.0022178466897457838, 0.0023197054397314787, 0.0040708407759666443, 0.0031559444032609463, 0.0023514255881309509, 0.0022801239974796772, 0.0029261545278131962, 0.0026940761599689722, 0.0034528106916695833, 0.0028707808814942837, } };
const TfArray<16, int> quant54_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant54 = { (TfLiteFloatArray*)&quant54_scale, (TfLiteIntArray*)&quant54_zero, 0 };
const ALIGN(8) int8_t tensor_data55[96*1*1*16] = { 
  /* [0][0][][] */ -10,97,-81,36,49,-30,98,69,-59,2,33,-91,82,127,-62,20, 
  /* [1][0][][] */ -20,0,-59,-25,-10,44,24,-127,30,-47,-22,-53,-10,-42,-54,5, 
  /* [2][0][][] */ -24,-27,33,76,23,44,-107,127,-23,3,77,-59,-19,-67,-44,69, 
  /* [3][0][][] */ 90,-92,76,-6,-3,-32,-32,127,-29,58,68,50,-6,59,12,9, 
  /* [4][0][][] */ -40,-21,-10,50,-91,16,-31,-127,0,-10,34,-16,39,54,117,115, 
  /* [5][0][][] */ 127,24,-25,-25,-83,21,28,72,14,-12,65,94,124,28,-89,5, 
  /* [6][0][][] */ 18,-34,-59,-53,-72,7,-2,-47,-51,-52,-29,27,88,53,127,-9, 
  /* [7][0][][] */ -56,31,-29,-75,3,-58,-74,14,-96,53,-69,-64,-127,-37,15,87, 
  /* [8][0][][] */ 53,43,73,8,55,23,71,9,67,-28,40,5,-127,-27,-78,12, 
  /* [9][0][][] */ -37,62,29,-45,-28,-14,29,-14,-31,49,-40,13,44,127,24,28, 
  /* [10][0][][] */ 77,54,-46,54,-30,-17,53,-51,-76,-36,-59,-106,-127,-76,11,98, 
  /* [11][0][][] */ 51,7,65,11,-12,-30,10,112,-91,25,-32,2,-13,-3,69,127, 
  /* [12][0][][] */ -50,-21,6,1,24,2,127,45,-63,26,5,-15,-7,86,-45,107, 
  /* [13][0][][] */ 23,41,33,58,127,43,115,113,-46,108,-94,-71,37,100,-125,-30, 
  /* [14][0][][] */ -123,127,5,-14,-3,6,67,2,-43,33,122,-9,-98,26,-46,49, 
  /* [15][0][][] */ -13,-18,-127,-45,79,-44,-87,-36,-24,-21,-16,-66,-7,-82,-56,49, 
  /* [16][0][][] */ 110,-17,9,-12,29,-31,44,-21,-39,10,127,52,47,3,-38,20, 
  /* [17][0][][] */ 12,16,-26,-99,-11,-62,117,-127,1,-21,-46,33,39,75,5,51, 
  /* [18][0][][] */ 26,119,-12,-48,58,-74,-21,-54,-40,127,-23,-3,-30,54,-15,-27, 
  /* [19][0][][] */ -70,-123,127,-96,47,-126,30,-39,51,44,91,107,28,-11,75,-35, 
  /* [20][0][][] */ -16,92,57,4,11,3,21,-27,63,-7,96,-27,-127,-25,-75,-9, 
  /* [21][0][][] */ -67,38,23,18,66,35,68,51,-127,57,-41,19,-25,19,-61,-26, 
  /* [22][0][][] */ 18,-90,46,13,21,-127,115,6,19,-55,-45,-77,44,-85,-55,-55, 
  /* [23][0][][] */ -57,-98,44,65,29,-18,23,-45,19,-37,81,3,9,71,77,127, 
  /* [24][0][][] */ -2,-3,25,79,46,17,-51,-127,64,15,-42,16,1,1,-24,-26, 
  /* [25][0][][] */ -12,31,20,-50,-27,-5,11,-33,-28,54,-42,-9,40,127,22,9, 
  /* [26][0][][] */ -67,80,5,19,32,-89,-2,-33,17,23,13,75,9,0,-83,127, 
  /* [27][0][][] */ -20,-127,-49,6,-62,93,1,-61,17,-39,59,-30,30,-47,-104,-19, 
  /* [28][0][][] */ -33,3,39,82,28,12,-40,-127,-118,49,103,-13,73,12,-43,-27, 
  /* [29][0][][] */ -127,112,-23,-33,-27,26,-127,-76,-44,-36,-3,-3,9,-61,-112,61, 
  /* [30][0][][] */ 57,78,-52,80,-108,-94,-75,-16,-39,-5,4,-117,127,35,-5,92, 
  /* [31][0][][] */ 127,29,-66,-34,-67,21,102,38,-60,-18,68,51,41,22,-26,9, 
  /* [32][0][][] */ -32,-20,127,0,-22,73,74,17,-19,-12,-8,22,7,68,63,41, 
  /* [33][0][][] */ -1,25,-68,-54,-25,30,126,27,-3,-15,30,-67,103,127,-54,56, 
  /* [34][0][][] */ -97,-24,97,19,27,-54,106,-9,-127,37,37,-44,50,60,-53,-33, 
  /* [35][0][][] */ -2,20,-53,16,-77,127,-36,-17,-19,126,2,92,-69,74,24,34, 
  /* [36][0][][] */ -11,-76,127,-50,-54,17,-42,-9,15,21,-50,82,2,-84,-39,47, 
  /* [37][0][][] */ 86,-9,73,-31,116,-76,-50,34,-62,127,-68,0,-93,-44,112,-21, 
  /* [38][0][][] */ 51,48,17,-108,-9,-56,-108,61,-89,60,-107,-57,-74,-127,-111,65, 
  /* [39][0][][] */ -79,21,-59,-33,-82,-81,73,13,-127,-36,21,84,35,-2,-4,53, 
  /* [40][0][][] */ 127,36,7,-93,-74,23,15,-39,-40,-24,-45,-81,15,53,40,36, 
  /* [41][0][][] */ 91,-78,-60,-47,-5,-4,-58,-20,58,-23,3,-55,127,-71,55,-31, 
  /* [42][0][][] */ -13,-87,-42,127,4,-96,-108,17,7,10,7,52,-78,73,-59,-2, 
  /* [43][0][][] */ -94,-49,-48,-124,-59,1,-1,77,42,-127,-38,37,-19,-53,-32,99, 
  /* [44][0][][] */ -42,43,40,-47,-26,-26,35,124,120,-84,82,112,127,51,-27,5, 
  /* [45][0][][] */ 31,77,-80,95,127,-90,-38,-66,110,-70,70,-66,-29,9,-76,64, 
  /* [46][0][][] */ -22,-40,10,-9,100,-24,32,20,-9,127,-29,-122,34,66,-50,75, 
  /* [47][0][][] */ 77,-42,-31,-11,77,-16,-40,-58,-3,127,-27,35,-6,-103,-80,13, 
  /* [48][0][][] */ 10,26,-14,-127,-6,-51,118,-122,7,2,-38,50,51,64,4,40, 
  /* [49][0][][] */ -24,127,-69,39,48,-55,70,58,-28,23,41,-88,-28,75,120,-95, 
  /* [50][0][][] */ 12,41,-21,3,-127,0,-67,-57,54,69,30,30,-36,-39,1,35, 
  /* [51][0][][] */ 127,-39,-48,-13,-44,85,-92,-41,46,-17,-40,64,-31,-65,2,38, 
  /* [52][0][][] */ -20,-52,44,67,-46,-105,-127,-10,-47,-58,-35,-70,16,-65,11,81, 
  /* [53][0][][] */ 28,102,58,-127,7,112,93,-20,-12,-26,-7,-41,86,-116,5,57, 
  /* [54][0][][] */ 32,122,8,-20,-4,-92,-105,52,4,-23,-41,127,81,90,19,62, 
  /* [55][0][][] */ -42,-14,53,29,51,-33,108,91,-84,-7,19,10,127,51,-5,-2, 
  /* [56][0][][] */ 127,23,14,23,-48,110,-54,-75,-25,48,-82,6,-60,103,-9,38, 
  /* [57][0][][] */ -46,-37,-48,-32,-71,-97,64,-22,-127,-28,57,55,19,38,-3,51, 
  /* [58][0][][] */ 47,-53,60,22,6,-62,-17,7,27,-14,-127,-27,23,-35,-35,44, 
  /* [59][0][][] */ 75,14,-127,92,8,36,87,-28,-73,-49,31,-101,-115,-59,29,112, 
  /* [60][0][][] */ -2,30,-11,21,-16,-26,-23,4,-35,-77,61,123,-46,-127,-35,-5, 
  /* [61][0][][] */ -33,15,84,-97,-76,56,3,127,-17,-106,58,71,97,-4,16,124, 
  /* [62][0][][] */ 78,44,-8,-127,-15,3,7,-41,-6,33,-37,45,24,-20,-86,-75, 
  /* [63][0][][] */ 2,-26,2,-4,-64,-69,-58,9,-70,-12,-35,-21,127,3,54,-14, 
  /* [64][0][][] */ 30,2,-16,58,-110,-44,-24,-87,63,127,37,-1,41,-56,-41,112, 
  /* [65][0][][] */ -29,9,-20,-15,-81,80,25,-27,56,-120,100,-69,76,69,-127,62, 
  /* [66][0][][] */ -127,96,-97,-88,38,-37,-112,-69,-105,115,95,3,-120,-59,42,59, 
  /* [67][0][][] */ 2,-33,-127,-110,66,76,10,-27,-28,-6,49,-19,28,39,18,49, 
  /* [68][0][][] */ 55,23,-14,-46,-66,40,17,38,-63,69,127,-15,-11,-43,-119,-3, 
  /* [69][0][][] */ 75,-103,56,-44,20,-109,-31,127,1,65,82,79,-21,74,-26,-5, 
  /* [70][0][][] */ 50,7,120,41,102,-20,127,14,33,22,-67,39,-73,65,-77,36, 
  /* [71][0][][] */ 8,30,95,-73,-127,-79,14,8,-24,-11,21,-101,-76,2,11,32, 
  /* [72][0][][] */ -64,-101,24,-125,76,-14,10,46,-70,14,-127,-18,60,122,-61,123, 
  /* [73][0][][] */ 23,19,50,-4,127,-91,-50,8,-34,97,-89,33,-85,-54,122,-19, 
  /* [74][0][][] */ -107,2,-127,-70,65,-45,-39,25,-86,5,-124,-37,-36,-60,-42,83, 
  /* [75][0][][] */ 93,-25,49,-44,21,6,-127,-25,-5,-97,69,3,3,-13,-6,-9, 
  /* [76][0][][] */ 1,-56,-39,112,39,91,104,-62,84,-127,70,117,39,-89,-71,43, 
  /* [77][0][][] */ -41,-37,127,-23,33,-30,-27,-116,15,19,38,91,46,50,17,4, 
  /* [78][0][][] */ -49,3,13,-37,-2,-54,34,-10,22,-16,18,-90,-99,-68,-127,-49, 
  /* [79][0][][] */ -98,-73,-19,24,127,35,-18,22,23,29,-16,49,-43,-70,-64,-18, 
  /* [80][0][][] */ 1,-121,49,127,-37,-30,-108,83,-12,25,77,3,-82,-8,-23,75, 
  /* [81][0][][] */ 116,65,-18,85,-1,38,23,127,21,12,114,57,115,31,62,-22, 
  /* [82][0][][] */ -54,2,15,-31,32,-127,-118,-85,4,79,-45,-34,-28,102,-72,-26, 
  /* [83][0][][] */ 107,-20,83,-31,-39,-12,-127,-8,24,-120,12,-52,-18,-11,13,-24, 
  /* [84][0][][] */ 14,-71,-96,29,127,39,39,33,-115,22,-107,-24,49,-34,-73,15, 
  /* [85][0][][] */ 12,88,42,-49,98,1,46,-117,127,-37,39,-13,95,-83,8,2, 
  /* [86][0][][] */ 119,-37,127,50,2,-57,77,41,-64,-55,-97,-47,37,19,-66,10, 
  /* [87][0][][] */ -5,7,17,-76,70,-27,-43,13,34,-38,72,-35,-82,-127,-3,22, 
  /* [88][0][][] */ -59,-32,39,-3,23,28,-64,-47,-4,11,-71,-127,-47,-39,-18,-16, 
  /* [89][0][][] */ -75,12,21,-67,26,5,-127,22,86,25,-69,-10,-14,-82,-43,-21, 
  /* [90][0][][] */ -10,-15,-31,-79,127,20,-59,40,43,55,29,-13,33,18,-67,-20, 
  /* [91][0][][] */ -43,-62,19,48,-43,-11,-8,70,-40,-55,28,-44,-3,59,20,127, 
  /* [92][0][][] */ -24,78,1,-12,-20,61,-96,50,-39,-10,65,2,-32,127,51,24, 
  /* [93][0][][] */ -9,76,-52,-70,70,88,-81,8,64,65,75,57,-127,26,-41,77, 
  /* [94][0][][] */ 26,65,98,12,-127,-38,11,-11,21,-20,27,-19,-56,-23,16,-24, 
  /* [95][0][][] */ -4,28,46,1,127,-20,-94,73,22,17,-84,94,-6,9,102,-39, 
};
const TfArray<4, int> tensor_dimension55 = { 4, { 96,1,1,16 } };
const TfArray<96, float> quant55_scale = { 96, { 0.0015087287174537778, 0.0026103549171239138, 0.001998810563236475, 0.0016130845760926604, 0.0014013078762218356, 0.0022835934069007635, 0.001661615795455873, 0.0022487144451588392, 0.0019663744606077671, 0.0023743598721921444, 0.0015532803954556584, 0.0018333863699808717, 0.0014805922983214259, 0.001011593034490943, 0.0017667737556621432, 0.0022361031733453274, 0.0032898117788136005, 0.0021591305267065763, 0.0020249409135431051, 0.0011709978571161628, 0.0021674640011042356, 0.0018458515405654907, 0.0015245643444359303, 0.0023977926466614008, 0.0027006908785551786, 0.0020730842370539904, 0.0024209078401327133, 0.0018711590673774481, 0.0020229690708220005, 0.0020700616296380758, 0.0012608771212399006, 0.0022783237509429455, 0.0027045272290706635, 0.0012775546638295054, 0.0014905703719705343, 0.00152550358325243, 0.0022785488981753588, 0.001381623325869441, 0.001837538555264473, 0.0015495386905968189, 0.001988130621612072, 0.0018856144743040204, 0.0021603552158921957, 0.0017257466679438949, 0.0022009899839758873, 0.0020418828353285789, 0.0019692371133714914, 0.0021590881515294313, 0.0010535718174651265, 0.0017314002616330981, 0.0022643941920250654, 0.0017577841645106673, 0.0012607048265635967, 0.0018857937538996339, 0.0021275000181049109, 0.0020378041081130505, 0.0019206310389563441, 0.0018649982521310449, 0.0026042480021715164, 0.0015706290723755956, 0.0023989563342183828, 0.0018494098912924528, 0.0027238787151873112, 0.0017281488981097937, 0.0013213044730946422, 0.0013786709168925881, 0.0016373732360079885, 0.001689159544184804, 0.0020187287591397762, 0.0020184025634080172, 0.0016312091611325741, 0.0016128018032759428, 0.0014963886933401227, 0.0015252858866006136, 0.0015824254369363189, 0.0013677771203219891, 0.0015468738274648786, 0.001915875356644392, 0.0020111426711082458, 0.0018136337166652083, 0.00097265176009386778, 0.0018441929714754224, 0.0021585780195891857, 0.0017546016024425626, 0.001969778910279274, 0.001702785724774003, 0.0021939896978437901, 0.0019898233003914356, 0.0024451874196529388, 0.0020955153740942478, 0.0019850272219628096, 0.0020435578189790249, 0.0018082085298374295, 0.0015837836544960737, 0.0028611770831048489, 0.0017165729077532887, } };
const TfArray<96, int> quant55_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant55 = { (TfLiteFloatArray*)&quant55_scale, (TfLiteIntArray*)&quant55_zero, 0 };
const ALIGN(8) int8_t tensor_data56[24*1*1*96] = { 
  /* [0][0][][] */ -25,7,-127,17,-21,22,23,-59,-5,-25,12,-60,-17,11,-13,22,16,-15,-9,-34,0,-48,-15,4,-16,0,53,6,89,45,-8,-24,11,-3,-32,3,19,16,24,-19,-21,7,-51,-91,3,13,30,26,52,13,9,-30,14,49,-19,25,7,22,31,-28,26,7,46,8,26,32,-29,4,-32,-39,-16,24,-14,-22,17,-31,13,25,-7,-13,-46,22,42,15,12,-11,1,-7,-51,5,-35,-4,-1,-36,2,-16, 
  /* [1][0][][] */ -54,-5,32,-31,35,26,45,18,54,66,44,61,-37,-43,4,-23,30,-70,15,10,-93,-23,15,-5,-10,-43,-7,-28,-5,-52,-57,7,-66,-7,27,-89,-55,-26,-22,-19,-32,6,-1,-47,5,-35,20,50,65,5,11,-34,-12,-38,27,17,9,14,9,-32,-11,-19,5,-24,-10,-61,-17,31,-11,-8,-40,14,-61,55,24,-8,-12,2,1,-12,-45,-15,-22,11,32,-51,-18,51,17,26,-29,3,127,58,5,11, 
  /* [2][0][][] */ 82,27,-2,68,-35,-44,31,27,59,90,-39,70,-61,2,-27,52,-79,92,63,47,-99,92,9,-9,43,-63,-5,59,-14,94,29,43,-66,12,-127,-1,-105,-13,0,-104,-31,32,-38,-85,15,12,90,7,-103,-35,12,63,-2,64,23,-71,-18,91,-48,-45,-29,46,3,11,-38,39,35,-67,68,-106,-106,45,22,16,-10,127,-1,-16,-54,-10,-56,34,-21,-70,-19,-44,108,-9,-60,44,65,13,-20,-7,23,18, 
  /* [3][0][][] */ -75,-95,-127,-77,-44,-11,-10,-16,37,65,0,87,73,-32,26,-65,44,26,77,3,18,67,-29,-15,40,-83,-7,98,-9,-30,-6,36,-5,-57,-19,-18,-2,-60,-20,9,-21,37,-116,51,-6,-17,-56,57,-50,-15,58,47,-20,62,41,8,38,-20,-29,-14,-45,-17,30,-4,-1,72,12,18,-31,59,4,-71,-23,22,12,109,-70,10,-6,-1,9,27,-20,-65,-19,10,3,-45,117,118,71,-12,-62,5,44,30, 
  /* [4][0][][] */ 39,-25,-27,-6,7,39,40,57,-1,-82,-87,23,-39,60,16,-19,-29,-18,27,-26,63,15,-89,-42,4,44,84,-24,-55,-27,-12,-11,29,4,-23,-27,48,17,-1,-31,-11,-88,-35,84,-20,20,59,-88,18,12,1,44,34,17,65,-3,100,26,51,65,8,-10,13,42,44,25,-17,-127,20,-8,-20,-82,-50,-11,-20,41,4,28,-13,-33,-15,-35,-19,-49,30,-12,12,-6,-61,6,0,-9,0,-20,98,-4, 
  /* [5][0][][] */ 4,50,57,40,-2,10,42,-56,-16,-19,29,1,22,-50,26,-28,-33,17,45,-28,19,-54,-27,11,-37,14,5,-63,-22,52,127,-10,8,-9,34,7,78,-9,-10,-55,29,51,-62,10,-26,15,24,7,-23,6,-50,-41,-1,92,32,-4,78,80,76,-10,-23,-33,14,-67,12,-93,11,-59,32,-53,-11,-77,-50,26,-3,-37,32,-13,13,24,25,-55,-33,47,39,-11,-2,1,-53,-109,30,-23,31,41,43,-24, 
  /* [6][0][][] */ -93,0,-66,18,-44,-24,-7,73,-8,65,-16,-5,56,-34,-45,116,-26,25,45,17,29,-2,6,91,17,-111,108,25,65,-26,34,-1,-30,-52,-19,-12,-13,63,-12,127,-12,-27,2,67,15,-11,-81,59,-27,-21,-118,-55,29,-75,-5,68,17,-76,25,-63,12,-25,-53,-30,18,-37,-84,-8,75,-103,28,-10,-7,-50,-77,99,-15,-33,-83,12,-45,5,55,-22,36,-12,-92,8,-25,-29,92,25,32,-90,55,-7, 
  /* [7][0][][] */ 62,-5,6,-42,-23,-29,-41,-36,-33,-109,3,-30,10,7,-25,-9,61,-59,-12,-15,-41,25,-12,42,-98,48,55,-112,-8,61,56,-10,20,-29,-78,-20,-37,-33,-29,18,-22,-127,-20,-66,-6,-22,82,-12,72,17,61,-69,-36,-27,-64,-37,-1,-47,8,-19,-71,-11,-62,-34,-29,24,32,35,-27,12,-11,12,111,1,-42,-50,63,-35,-13,-9,-30,41,-14,20,-63,9,72,-53,42,56,-44,-31,42,84,-31,-13, 
  /* [8][0][][] */ 12,-11,-4,-49,-40,23,-17,0,-9,-56,-26,21,-42,-9,-26,32,35,127,26,-46,-22,-51,49,-1,4,12,70,-73,17,-13,38,-15,-2,1,-10,-28,-12,-32,-22,-71,10,-43,-43,-58,36,16,-28,9,-121,36,1,48,-2,10,66,-1,20,17,-2,6,18,-17,-45,0,27,35,-21,39,-16,43,-13,-11,-24,21,-27,-49,7,51,29,-1,-27,6,-21,-33,17,5,-17,57,30,53,6,-4,45,-2,27,-18, 
  /* [9][0][][] */ -127,-16,-9,23,0,0,-26,31,43,-57,-44,1,-5,-3,43,79,11,-15,-12,50,-55,32,70,-54,4,25,6,-20,20,16,-26,42,19,-64,38,14,-28,-32,-38,-15,-18,-23,-52,66,25,20,-54,-14,25,35,1,52,-16,52,-16,10,36,4,18,35,16,-11,-9,-56,-21,-30,6,27,29,-65,6,96,49,42,-14,-21,-48,-16,43,-14,-22,65,-31,10,3,-12,68,-37,31,77,29,-23,-6,37,-24,2, 
  /* [10][0][][] */ 1,-56,-5,-39,-6,9,12,-21,-8,-5,-28,17,-3,5,2,9,14,17,11,-32,-13,-23,-62,108,-36,-32,-87,125,46,-27,14,8,-25,-10,-21,-75,-51,-38,65,2,-20,59,-11,-14,29,57,31,-60,-3,0,-10,-17,-8,-25,-109,35,60,4,38,62,-17,45,-127,-18,-1,34,-42,-18,8,48,1,83,-111,52,32,-8,-23,4,-47,-39,-24,13,-18,15,8,-22,-8,65,-46,9,103,-13,70,-18,46,10, 
  /* [11][0][][] */ 61,4,-2,29,30,89,27,67,-48,6,-51,-35,6,-5,-5,-26,29,4,13,-3,80,-19,-10,17,3,-18,-53,-76,32,-61,49,-85,-7,49,-38,-12,-13,-79,-22,65,14,14,-58,-45,15,-35,71,22,-3,-3,-87,-3,21,95,-56,7,30,-7,40,102,57,-17,41,24,26,-5,-21,127,-37,-10,30,-5,-5,93,-41,7,-26,-21,30,8,-45,-33,-3,-9,-42,30,-26,19,-35,-33,-38,19,-29,-63,-40,-15, 
  /* [12][0][][] */ 31,-79,-68,-72,-16,8,-34,76,-61,-16,34,60,-33,-5,-28,71,23,9,8,-70,49,7,-17,-74,49,35,-38,-7,-93,16,51,-6,-27,30,-74,72,-27,-127,-13,-24,-2,70,-83,11,-63,-16,-15,-112,4,-24,-77,37,-13,22,108,-80,-103,-66,-58,-93,-25,-27,4,-104,-32,88,-31,-35,29,64,15,80,36,80,-14,-53,9,72,-20,-12,-11,-59,74,73,82,-46,70,45,-20,27,35,3,9,-59,43,33, 
  /* [13][0][][] */ -19,26,12,47,18,47,7,78,71,-36,-13,67,36,32,-22,-16,4,13,72,-33,11,71,11,4,127,15,-12,-35,89,3,-56,-10,53,-45,-64,84,-8,-73,42,70,-24,-7,31,-33,-29,57,43,-73,6,-20,11,78,-36,-29,63,-8,-51,-27,-12,48,27,28,-40,-33,-17,-19,-26,40,57,-36,4,-105,-56,106,-5,-5,-87,58,33,0,-25,72,48,23,20,19,-21,-32,-24,-21,8,-29,-67,15,22,-32, 
  /* [14][0][][] */ -22,-79,-2,-58,-76,-63,-34,37,-23,3,10,44,-18,58,0,-63,13,-52,-65,33,110,49,43,41,5,-40,-30,49,93,120,-60,48,-52,-31,-32,-23,70,-22,-18,-29,24,-29,34,13,53,-95,4,-87,42,-34,-102,38,39,23,-11,32,127,15,-7,-41,-33,3,9,38,6,-81,-6,-8,11,-1,-15,-5,81,7,-12,-84,-24,55,53,-2,63,24,-8,76,-27,-52,5,-12,-73,38,43,-8,84,-19,48,5, 
  /* [15][0][][] */ 62,3,58,29,-1,-91,-36,-67,-3,46,50,5,-19,57,-45,-55,32,-21,23,86,79,73,31,-42,-25,-33,25,56,47,57,72,7,-20,-24,-30,26,-18,65,-38,55,10,7,32,22,9,-41,-37,-26,7,-75,-127,49,30,-23,51,0,9,-19,-17,-61,108,-35,26,-26,6,90,41,-12,-9,-83,38,-107,-95,-92,-2,-70,-69,-50,11,-5,-15,47,-86,75,-12,17,41,4,59,32,54,-5,82,-21,-7,-8, 
  /* [16][0][][] */ 6,-13,-56,-25,28,17,-24,-3,-1,40,-57,-45,-13,-5,30,-78,10,34,62,24,1,-4,-9,-71,-37,-65,-63,-42,56,-73,17,-58,15,23,-24,-10,6,6,-48,48,27,-37,105,-33,46,-13,-19,6,-35,-18,-60,12,21,-111,-22,49,94,-12,26,4,75,63,42,4,-4,-59,47,-127,-35,51,1,58,-80,-15,37,-55,30,-59,-6,4,-35,62,56,34,0,66,94,-52,13,2,-7,11,-76,-15,-2,-23, 
  /* [17][0][][] */ 15,-36,-34,-30,-27,-58,2,-21,-35,-18,34,-33,5,13,16,99,24,-17,-39,-5,11,35,-65,-45,-43,3,-35,58,-31,-25,-4,3,12,-14,5,-25,-57,8,-3,-30,-15,15,-13,-29,51,0,-3,36,16,-18,25,16,-11,-42,13,-19,-22,10,-15,-65,-23,52,-9,-6,-6,-127,-16,38,-8,7,-21,-100,10,21,-51,-2,15,-6,-43,-3,9,-51,-31,5,-78,-10,-8,28,7,33,6,-26,17,-29,-25,22, 
  /* [18][0][][] */ -2,-3,18,18,-22,-32,9,20,-67,29,3,11,6,13,19,-29,-40,-42,-14,18,54,53,7,-9,-16,-6,-5,0,-31,52,63,5,4,-15,8,-2,-3,2,-10,23,-37,23,27,-14,-12,-22,38,8,38,-3,127,44,-19,-19,3,-13,-9,-24,-34,-4,-39,4,-6,45,19,-20,-12,-20,-16,-25,28,2,-20,-12,25,24,16,-32,6,-12,-5,3,5,-12,-31,3,-77,-35,-13,-33,34,-11,-46,-2,-28,3, 
  /* [19][0][][] */ 90,30,-68,71,32,-13,-39,50,-6,-26,-25,17,5,29,-26,-37,-21,-34,42,-4,-16,21,-22,-53,26,-3,-10,-35,-8,57,19,-30,10,8,26,-8,-20,32,11,27,64,-4,-1,-6,16,16,10,-74,16,-59,10,8,10,0,-3,0,28,10,-43,12,-3,24,77,-5,2,-7,-2,0,13,-57,38,7,-127,-5,-12,2,14,1,-9,32,28,-47,6,21,24,8,-49,36,-21,-27,26,4,67,56,36,7, 
  /* [20][0][][] */ -44,21,-80,15,-85,-3,-65,-78,37,-60,-17,60,34,17,42,-9,29,-78,-95,-26,-21,11,-36,113,4,54,-25,-113,14,-88,-94,10,-52,-30,-25,-42,-90,96,45,84,-6,-19,-58,-31,-57,59,-17,11,45,31,73,68,-18,3,-24,-63,-70,-81,20,7,-80,-27,-88,-84,-31,-127,72,-71,67,-58,-58,-78,-18,-17,54,-62,-4,29,33,0,-27,-1,-42,16,-23,-38,82,27,23,-25,-61,38,26,57,-48,-34, 
  /* [21][0][][] */ 62,34,-40,21,-2,-53,-3,-20,46,94,-18,29,-38,-20,-22,9,-10,-26,3,13,-42,-56,58,21,3,-61,43,5,-67,-42,106,40,10,26,46,49,-38,38,17,-89,35,33,69,-51,44,38,-38,15,21,-3,-20,21,-12,-24,76,38,-7,12,33,9,8,52,-12,6,13,17,31,127,69,23,-33,0,30,-23,2,3,3,27,22,28,36,61,-23,-18,13,36,11,8,57,1,36,-24,-36,-8,-6,-8, 
  /* [22][0][][] */ 9,-30,-38,25,2,95,-14,11,4,-98,-20,26,8,-34,54,24,-36,34,-12,-1,-24,-23,-12,-3,48,61,-41,42,36,24,87,-73,21,24,3,-32,-71,7,5,0,41,-11,49,-66,-31,-21,25,-5,-8,27,57,41,-5,-76,-4,17,34,-18,36,24,-73,-32,30,-74,-10,127,43,56,-1,-35,-2,-73,47,-59,-65,-31,13,6,17,54,-14,-41,116,27,-4,-38,52,-50,-104,-38,-84,27,-1,74,-24,28, 
  /* [23][0][][] */ -4,-23,80,-5,-2,-14,16,20,33,-3,-24,26,12,10,-39,-8,33,-27,-13,14,3,-7,-15,-8,23,24,65,60,57,-4,61,36,-2,-1,-19,-5,14,-8,-43,-30,1,56,3,-90,47,-44,1,69,18,-21,55,-29,33,-4,-17,-14,-89,27,37,-17,12,12,20,-25,46,-23,-10,-70,-42,0,17,61,-25,14,-16,61,-20,17,23,30,43,-39,-27,-11,-39,-32,25,-1,27,127,26,20,-5,-25,-33,30, 
};
const TfArray<4, int> tensor_dimension56 = { 4, { 24,1,1,96 } };
const TfArray<24, float> quant56_scale = { 24, { 0.0067636976018548012, 0.0051330365240573883, 0.0033137574791908264, 0.0049863806925714016, 0.0060372757725417614, 0.0050520985387265682, 0.0043897372670471668, 0.0040792180225253105, 0.0059967106208205223, 0.0055920965969562531, 0.004946618340909481, 0.0049817874096333981, 0.0040542799979448318, 0.0054637421853840351, 0.0043037156574428082, 0.0043927831575274467, 0.0042015383951365948, 0.0068101827055215836, 0.0072078057564795017, 0.0062808739021420479, 0.0047984085977077484, 0.0068629644811153412, 0.0047012688592076302, 0.0063952822238206863, } };
const TfArray<24, int> quant56_zero = { 24, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant56 = { (TfLiteFloatArray*)&quant56_scale, (TfLiteIntArray*)&quant56_zero, 0 };
const ALIGN(8) int8_t tensor_data57[144*1*1*24] = { 
  /* [0][0][][] */ 89,-41,-27,37,-78,57,-63,-85,-9,39,-32,34,-27,-29,127,1,-57,10,6,63,90,-30,-16,3, 
  /* [1][0][][] */ -37,-97,-84,77,-31,127,49,10,100,-7,85,35,-37,-42,43,-16,3,-94,61,89,27,62,40,53, 
  /* [2][0][][] */ 70,34,-21,36,17,-70,-27,14,-127,-3,7,67,22,-51,-11,3,-27,-23,22,72,-7,86,39,-31, 
  /* [3][0][][] */ -65,36,-36,-13,14,-6,-17,-54,-13,-110,1,2,38,-54,-69,81,-101,-115,-13,13,41,-32,127,-13, 
  /* [4][0][][] */ 120,-15,38,78,0,-15,-17,-4,-58,52,-60,-3,9,-67,-61,-7,-37,37,-12,127,25,1,-37,-1, 
  /* [5][0][][] */ -54,-4,70,-107,32,-7,40,-16,-27,127,51,96,-10,-8,32,-111,89,43,0,-2,-45,63,-126,31, 
  /* [6][0][][] */ 28,31,57,-54,-105,5,41,-47,117,-31,-38,31,-114,24,16,17,-15,-64,-13,13,-127,35,-54,16, 
  /* [7][0][][] */ 26,5,35,87,-59,-85,-63,-105,-51,-18,-24,96,-18,30,-78,-56,11,-16,-80,127,74,62,2,-55, 
  /* [8][0][][] */ 127,-80,67,71,-14,-65,-7,-46,-1,15,19,-14,-19,-123,-6,53,-98,12,-17,58,31,13,17,-72, 
  /* [9][0][][] */ -122,-82,-6,118,12,-4,-44,-43,-7,-107,106,14,-55,-117,32,127,-53,-90,-26,-47,-34,19,80,-50, 
  /* [10][0][][] */ -33,-60,-42,34,-114,127,58,-14,-37,-3,26,-9,28,-13,-89,-9,19,-2,-42,-22,-11,3,-53,15, 
  /* [11][0][][] */ -94,0,-22,-98,-13,20,21,23,86,-82,52,-61,-52,52,6,46,67,-24,11,-127,7,16,-37,-10, 
  /* [12][0][][] */ -9,-105,-25,44,-7,41,-34,97,127,10,27,80,13,-41,-71,33,16,-61,12,35,17,-6,38,45, 
  /* [13][0][][] */ -6,-24,55,-48,54,34,0,46,-127,5,26,7,17,-83,7,2,96,-10,-92,-6,90,-73,3,67, 
  /* [14][0][][] */ 50,-109,-106,69,47,47,127,-21,-32,-88,49,11,-53,101,9,-50,-24,-29,-9,64,103,-72,9,94, 
  /* [15][0][][] */ -52,67,31,-19,70,37,55,16,57,16,55,127,-43,-9,17,-125,-45,48,-37,39,39,-26,1,50, 
  /* [16][0][][] */ 64,-15,25,-2,-43,-49,-31,-91,-27,-127,-25,-113,24,-42,26,95,-50,71,10,29,68,-45,76,-8, 
  /* [17][0][][] */ 60,54,-57,-66,-9,-45,-45,-40,36,27,-127,53,12,-93,-100,67,-15,83,-4,-17,24,-51,63,5, 
  /* [18][0][][] */ 113,-1,127,-2,46,-58,-93,-1,-6,0,-20,-53,-13,82,-2,-1,9,37,-63,-91,41,20,-99,-88, 
  /* [19][0][][] */ -62,-45,-90,-33,22,6,-34,61,13,-58,70,55,24,55,-125,-2,90,94,56,52,31,127,-57,-77, 
  /* [20][0][][] */ -64,20,8,-54,16,61,30,-5,47,-17,21,-74,-16,49,-31,-33,127,30,8,-38,8,-22,-80,17, 
  /* [21][0][][] */ -72,-71,24,12,-127,-88,106,-122,32,-19,-67,108,-33,-111,39,-28,41,-96,-15,-23,92,-47,-51,-47, 
  /* [22][0][][] */ 30,-49,-8,5,-49,76,-24,-5,-91,32,-19,-5,51,32,22,51,96,-27,-15,-75,127,73,37,42, 
  /* [23][0][][] */ 70,-43,46,102,-72,38,-17,13,-96,9,-70,127,-11,-61,-11,-21,-60,-47,7,110,21,13,-30,-38, 
  /* [24][0][][] */ 28,71,15,-71,-3,-46,17,-12,-21,-70,-51,22,65,-127,57,51,27,26,97,-54,20,-15,126,26, 
  /* [25][0][][] */ -127,27,-52,54,44,-4,-92,-32,-58,10,-2,20,57,-76,13,65,-24,35,-59,-11,42,74,-87,-2, 
  /* [26][0][][] */ 33,63,-52,17,41,-30,-20,26,-127,9,-2,37,21,-10,-14,9,-22,-16,15,53,-8,61,45,7, 
  /* [27][0][][] */ 1,-29,-96,-22,2,127,32,-106,46,73,3,-44,78,-11,47,0,54,44,119,2,67,-5,49,58, 
  /* [28][0][][] */ -59,-111,59,-9,82,-93,-87,127,73,-72,12,-80,-53,-25,-62,17,-39,-42,-73,38,0,2,-36,-28, 
  /* [29][0][][] */ -80,28,71,35,6,-127,12,-38,121,-75,-83,19,1,-49,29,-58,-87,-18,54,33,-25,-42,5,-9, 
  /* [30][0][][] */ -127,93,25,-47,37,-94,-27,55,-60,-3,-72,-54,11,97,-16,-23,6,10,-62,42,26,-66,-73,-31, 
  /* [31][0][][] */ -49,78,-46,12,97,31,-89,37,-61,42,98,0,74,89,-37,71,-58,-89,-45,-127,28,102,9,-35, 
  /* [32][0][][] */ 23,24,-93,65,-38,35,4,64,8,-47,101,-29,12,-36,102,-44,-19,127,70,-40,-83,-37,65,21, 
  /* [33][0][][] */ 127,-110,-46,-9,13,60,-92,71,36,-88,44,7,-4,8,-40,38,13,5,53,61,-15,55,-46,-44, 
  /* [34][0][][] */ 58,57,-46,27,29,-42,-24,10,-127,9,1,65,25,-29,-13,26,-27,-16,35,63,-22,88,46,-5, 
  /* [35][0][][] */ -35,127,-12,-65,61,-26,-81,-71,-119,113,-28,36,7,101,-8,26,-33,-14,88,-53,-52,57,105,-13, 
  /* [36][0][][] */ 25,127,21,-59,-50,8,27,11,4,1,-31,-71,17,103,-18,-46,-74,-35,35,71,-52,-8,-16,-29, 
  /* [37][0][][] */ 51,-28,-29,-2,-32,6,-38,-17,55,-12,51,-67,34,-1,-14,-47,55,-77,62,94,-19,-28,-127,-39, 
  /* [38][0][][] */ 4,-25,100,6,-64,-16,-14,-8,-2,-100,0,127,-112,-43,61,-9,22,-45,-19,-48,-25,-50,-68,-47, 
  /* [39][0][][] */ 12,-26,64,-81,-60,29,-28,-28,-31,97,25,6,14,121,-5,-127,-18,-23,-13,15,-20,45,-80,13, 
  /* [40][0][][] */ -17,0,-9,24,75,66,3,37,-17,-53,-70,18,-101,97,20,-127,-61,-59,16,-59,-103,34,-62,-42, 
  /* [41][0][][] */ -60,-54,-16,-105,-8,-12,41,47,36,-32,84,-127,-72,32,-49,88,31,30,18,-67,-16,-39,24,-43, 
  /* [42][0][][] */ 27,41,-14,30,6,56,-28,-29,-119,-127,-54,45,-71,60,-39,39,-13,-69,-76,-78,-32,5,84,2, 
  /* [43][0][][] */ 13,41,-40,29,36,20,40,127,62,-18,-6,120,71,-113,-6,49,-11,-30,97,-84,-38,49,13,21, 
  /* [44][0][][] */ -123,-10,-17,13,-3,-52,-12,-62,-26,-14,5,48,20,-36,2,24,-46,-127,-33,-61,12,15,39,29, 
  /* [45][0][][] */ 103,-28,-69,17,2,-80,-47,49,13,-12,-51,-127,28,-89,-52,88,-45,-68,67,-8,-36,29,59,-7, 
  /* [46][0][][] */ -28,21,-21,-33,-25,58,8,71,-52,36,-113,29,-23,105,51,-13,64,55,-10,-5,57,1,-127,66, 
  /* [47][0][][] */ -89,66,105,-10,50,15,110,-55,74,64,-76,14,72,-57,-20,-88,31,84,-31,49,21,-127,42,62, 
  /* [48][0][][] */ 18,-49,58,-29,23,-127,-71,-5,-15,-37,-59,-95,-73,-39,35,-51,22,56,-59,92,6,-108,-53,-20, 
  /* [49][0][][] */ -25,6,32,-84,-16,110,47,-74,-37,-72,-41,-63,-59,64,127,-58,-18,29,-13,59,43,19,-44,52, 
  /* [50][0][][] */ -23,127,64,-4,35,0,60,68,-63,11,4,63,-70,-31,17,-72,-56,-48,-7,-80,9,-48,108,-47, 
  /* [51][0][][] */ 32,1,127,46,1,10,-51,104,-108,12,-3,-44,30,29,18,-32,54,-27,-123,-93,39,20,36,1, 
  /* [52][0][][] */ -3,10,19,27,-11,6,68,-72,23,62,9,-127,-3,-97,-20,-84,16,-62,30,8,-30,33,-101,-59, 
  /* [53][0][][] */ -127,55,-1,51,-25,-87,11,18,90,-126,-28,27,104,-53,-46,5,-42,-8,17,38,-38,21,-75,18, 
  /* [54][0][][] */ 36,48,-28,88,46,-55,-42,-38,4,-126,20,-4,19,-69,-62,127,-38,-80,-22,-39,29,-22,100,-49, 
  /* [55][0][][] */ -23,42,10,42,-49,6,-56,-57,-39,39,57,97,16,-83,-110,66,-40,-127,27,-80,55,44,-34,-81, 
  /* [56][0][][] */ -89,11,70,120,-56,-112,-50,53,-84,-104,-119,115,-78,1,42,-23,-127,-39,-86,-22,-78,-54,-15,-109, 
  /* [57][0][][] */ -26,-4,-21,-40,-21,103,-34,-22,-69,105,25,-40,53,49,-85,41,-4,37,-62,-127,75,48,61,105, 
  /* [58][0][][] */ -41,15,11,80,42,-42,127,44,-14,-6,-26,-59,35,-33,-43,36,-69,19,-53,-12,-63,22,-6,30, 
  /* [59][0][][] */ -25,-18,63,-39,-60,-68,127,-2,111,46,-56,27,-52,-27,-7,7,-29,28,-31,21,-7,20,-59,29, 
  /* [60][0][][] */ 74,-54,-53,-9,-17,-63,66,-14,-66,-20,-26,-6,-25,94,24,-127,104,85,-27,115,97,49,-41,-7, 
  /* [61][0][][] */ 114,20,43,127,-11,7,-40,-46,-36,11,-78,82,48,-68,39,-74,-41,15,-34,111,45,25,-41,-1, 
  /* [62][0][][] */ -23,98,-22,63,-37,-37,0,33,85,-96,-127,-35,32,-67,-58,51,-58,-12,20,-20,-25,-39,92,39, 
  /* [63][0][][] */ 14,127,58,26,30,-115,11,16,-32,-39,37,-61,40,-119,55,-12,35,-8,-54,10,18,-39,11,44, 
  /* [64][0][][] */ -6,82,-78,31,6,-31,87,27,29,-104,-86,-84,-36,-127,23,27,0,26,28,65,-112,-48,102,17, 
  /* [65][0][][] */ -11,27,-127,-71,17,-55,17,70,40,-18,26,-39,-84,-14,-49,3,-57,52,-107,35,-70,-9,44,39, 
  /* [66][0][][] */ 1,-63,6,-18,-109,-93,-67,-109,20,55,54,43,-29,65,1,2,-72,69,-23,27,19,79,-127,70, 
  /* [67][0][][] */ 59,127,-31,-58,66,-82,28,-67,-96,-16,9,57,46,-76,23,50,5,-46,69,33,-43,96,68,35, 
  /* [68][0][][] */ 127,16,48,70,-2,-8,0,-9,17,36,-94,18,31,-26,-60,-13,53,79,-14,86,21,-44,-25,-51, 
  /* [69][0][][] */ -127,-11,-85,-102,-5,1,-18,31,20,-44,14,-97,-55,65,8,38,78,23,10,-44,-18,-41,-6,9, 
  /* [70][0][][] */ -43,0,34,-115,10,7,99,25,26,59,-42,47,42,-64,1,-127,-23,-4,31,51,-30,-14,-70,-34, 
  /* [71][0][][] */ -66,-1,0,-31,-18,-10,31,-61,-26,8,-58,127,-83,27,27,27,-74,93,8,-104,-6,27,53,-45, 
  /* [72][0][][] */ -15,7,79,69,-42,49,26,-35,-10,29,-95,-50,-13,-30,83,74,-127,-60,1,-11,-30,-46,30,54, 
  /* [73][0][][] */ -5,86,10,18,-3,63,75,82,-25,35,51,15,37,20,-62,127,17,16,118,-20,-45,17,55,66, 
  /* [74][0][][] */ -33,-63,77,-86,41,14,7,-14,3,127,107,-5,-7,-50,-99,29,-71,30,-42,53,-59,-11,-25,29, 
  /* [75][0][][] */ -9,-89,-57,-50,-33,127,-28,-49,-58,80,-7,35,85,116,-57,56,15,-7,55,-36,-3,25,-38,32, 
  /* [76][0][][] */ -71,-78,127,-74,-14,35,-30,42,-18,-60,51,38,-85,3,34,-26,-30,-13,0,-68,22,99,-64,-79, 
  /* [77][0][][] */ -62,-62,-18,72,-24,-66,-127,-25,43,-33,51,-24,22,48,83,-37,-28,45,-82,-31,-2,76,-60,31, 
  /* [78][0][][] */ 59,101,-114,-20,-28,5,30,-124,23,108,66,-81,125,-34,-83,6,99,-103,127,20,53,-5,-48,-46, 
  /* [79][0][][] */ 48,22,24,0,-86,0,-8,-30,10,-14,8,-23,77,-44,25,-57,65,30,-22,1,44,46,-127,-22, 
  /* [80][0][][] */ -127,-68,8,-116,2,13,-18,28,84,-58,1,-84,-79,72,10,45,75,-19,-35,-51,20,-75,-6,36, 
  /* [81][0][][] */ 2,16,6,-37,11,24,-3,-49,-3,-78,-77,111,37,-7,12,-36,-79,-127,13,10,49,-74,-9,-28, 
  /* [82][0][][] */ 62,5,-20,-6,-60,-67,-10,-9,58,-58,-3,20,11,127,6,35,-78,-15,11,20,-33,-1,-29,-14, 
  /* [83][0][][] */ -127,-110,11,35,-89,1,114,-58,69,-41,-54,9,-23,-120,46,-75,17,-115,-81,108,72,8,100,97, 
  /* [84][0][][] */ -90,124,-5,-72,-61,26,-51,-127,-90,-20,-32,-5,-67,50,46,50,10,-41,19,-123,59,-55,0,57, 
  /* [85][0][][] */ -64,-74,-97,66,83,-30,-38,23,51,46,26,127,59,-51,-120,4,23,12,-40,73,69,72,-59,-45, 
  /* [86][0][][] */ 34,-62,40,-53,-45,-85,-127,-2,-26,114,-33,-29,-50,25,-67,-21,-41,-9,-38,-23,-34,35,-103,-49, 
  /* [87][0][][] */ -97,49,-26,38,63,-52,27,13,101,-18,-127,-95,21,-29,-39,59,0,-38,31,40,69,30,28,-66, 
  /* [88][0][][] */ -88,61,8,95,42,46,-25,17,66,26,96,34,127,48,-38,-29,3,61,-80,-41,85,-97,-91,-42, 
  /* [89][0][][] */ -121,0,-7,-105,0,52,90,34,77,-21,41,-127,-17,23,71,32,25,34,82,-63,-24,-82,26,25, 
  /* [90][0][][] */ -75,54,-12,-84,4,13,-4,-25,-13,-14,55,-9,-29,59,48,-12,-4,-127,35,-124,-34,41,-12,-4, 
  /* [91][0][][] */ -13,117,-45,-51,75,100,1,-63,36,90,-65,30,39,4,-123,-41,-104,-3,-16,-16,-27,-127,-56,-72, 
  /* [92][0][][] */ -12,-86,-19,52,-6,69,-98,-47,52,18,92,51,13,-4,62,-18,72,88,95,92,8,127,-62,56, 
  /* [93][0][][] */ 51,90,-30,58,32,-27,8,59,-127,-39,50,18,93,-34,-14,-31,11,61,71,54,36,8,10,-38, 
  /* [94][0][][] */ -82,15,18,-61,16,-34,127,19,-85,114,52,24,-67,27,-40,-113,-44,5,50,67,5,-20,63,-43, 
  /* [95][0][][] */ 44,69,-36,6,41,-22,-12,25,-127,30,5,39,24,-16,-28,12,11,17,25,49,-19,67,42,-8, 
  /* [96][0][][] */ -2,-44,-8,-67,-20,-62,4,10,-6,-39,80,-127,-53,18,-4,121,-51,-26,35,-36,-67,13,73,-1, 
  /* [97][0][][] */ 98,7,41,14,-3,-19,-18,-10,-101,47,40,82,10,-49,7,-23,-55,-32,2,63,-36,127,25,11, 
  /* [98][0][][] */ -39,127,64,16,-14,-42,-29,-27,1,50,28,-30,-73,2,-35,17,-22,-21,-27,55,-47,-15,-12,65, 
  /* [99][0][][] */ -99,86,16,40,-69,-82,23,66,33,2,-83,-28,-107,0,-31,-26,-127,-23,-20,52,-57,34,29,4, 
  /* [100][0][][] */ 77,12,-61,87,32,-28,2,31,-127,30,-14,58,50,-16,-4,-32,-18,21,21,103,-30,94,16,4, 
  /* [101][0][][] */ -82,16,31,-59,-10,47,50,-11,90,-39,6,-68,-24,43,-10,65,82,-10,30,-116,26,-127,-12,-10, 
  /* [102][0][][] */ 8,17,14,65,-70,30,-21,-18,-25,-7,-7,127,10,-4,30,-100,-8,-72,-3,-13,72,40,-33,-46, 
  /* [103][0][][] */ -42,-108,-46,38,32,-47,-4,24,19,72,40,17,68,-127,-50,-110,-65,-8,-82,75,-106,0,-18,10, 
  /* [104][0][][] */ 80,13,-10,25,-75,31,-16,-127,-28,-105,5,-24,-70,119,15,15,27,-18,-68,-33,21,-79,63,-18, 
  /* [105][0][][] */ 90,-19,-37,49,6,-33,15,-25,-98,28,-6,99,55,-23,-9,-10,-52,11,61,127,-30,97,3,0, 
  /* [106][0][][] */ -55,45,4,18,-5,-4,40,-48,-30,-53,-53,27,-47,10,26,10,-53,76,-82,-127,-56,-41,14,-81, 
  /* [107][0][][] */ -1,46,11,-39,3,-127,-7,-78,0,-49,-77,9,-32,19,15,-3,-91,17,2,-24,-21,21,-1,-84, 
  /* [108][0][][] */ 16,127,29,-23,48,59,27,-16,-35,-19,-56,48,96,18,-89,29,36,-76,17,-92,-48,-60,84,-23, 
  /* [109][0][][] */ -13,-47,69,42,-127,-105,51,-86,-29,1,-25,104,-14,48,93,55,127,-51,-24,-71,67,-63,-77,-53, 
  /* [110][0][][] */ 54,37,-66,-25,-2,-17,-29,58,-94,88,19,12,-24,84,22,54,-15,-15,38,-56,-127,-11,-13,-4, 
  /* [111][0][][] */ -14,11,123,17,63,19,-32,70,-75,-127,-21,40,31,-3,33,62,50,29,-21,38,1,-48,-16,31, 
  /* [112][0][][] */ 56,33,12,-6,115,-116,-11,-91,-15,-24,26,-127,-98,55,-11,73,-14,48,48,-36,-62,-23,-84,-88, 
  /* [113][0][][] */ 35,-92,-58,18,8,-90,-18,50,3,-42,78,6,-27,20,-6,120,-127,-76,9,-11,-42,95,88,-36, 
  /* [114][0][][] */ -41,25,-4,50,58,1,60,85,-28,-11,-65,66,-46,24,44,-17,-33,127,-90,-109,-24,24,67,-51, 
  /* [115][0][][] */ -20,-76,47,8,-64,127,83,44,119,-15,-48,7,10,-49,-38,23,-58,-20,3,24,37,-81,-6,-50, 
  /* [116][0][][] */ -33,-43,68,-68,2,-127,75,29,17,13,37,-78,6,-51,-11,-10,-30,-2,55,35,-32,-42,-7,-46, 
  /* [117][0][][] */ -96,92,127,57,-11,16,37,62,-39,3,-51,-60,-35,105,-16,-76,-64,33,-114,-4,-84,59,-78,-54, 
  /* [118][0][][] */ 46,127,-65,27,15,-5,77,65,117,25,-33,-41,-105,11,93,-45,-48,-5,64,123,-97,-12,56,10, 
  /* [119][0][][] */ -85,-35,67,-38,96,-56,70,5,48,95,-78,127,-36,-85,-2,-10,-102,62,-1,8,-45,-24,74,-84, 
  /* [120][0][][] */ 26,27,77,-65,-21,83,21,66,37,55,55,-56,18,-17,-67,48,84,-86,16,67,72,-30,-56,127, 
  /* [121][0][][] */ -2,-69,86,15,19,-35,-24,71,-66,-71,-26,5,0,49,29,43,42,-23,-18,13,54,-45,23,127, 
  /* [122][0][][] */ -127,8,-68,23,56,10,-6,94,27,28,-1,38,22,-108,41,-65,-25,25,-18,59,27,14,-34,32, 
  /* [123][0][][] */ 94,-28,46,-36,-101,30,-41,-54,2,48,10,27,-20,-5,75,-81,5,-87,-35,-127,-1,-60,11,-32, 
  /* [124][0][][] */ 57,12,36,-24,53,-30,30,38,-127,61,-61,-14,-28,16,28,-48,51,24,44,49,-37,17,-54,-38, 
  /* [125][0][][] */ -42,0,68,-127,34,-1,69,10,4,107,5,40,20,-18,37,-117,13,62,35,41,-52,7,-69,42, 
  /* [126][0][][] */ -60,71,-119,47,-99,65,117,-23,56,67,24,78,55,-1,11,91,-58,84,121,-30,-72,-62,127,-40, 
  /* [127][0][][] */ 76,114,99,-47,-124,40,-43,6,3,-16,-86,41,-62,125,22,-60,27,-127,61,-110,112,86,20,21, 
  /* [128][0][][] */ 107,-38,69,-23,55,70,-27,17,53,-3,54,-18,-22,-18,-4,2,-127,-39,57,-67,18,-23,-113,-38, 
  /* [129][0][][] */ 27,-5,38,-35,55,118,-127,2,57,4,-42,-54,-72,-15,-2,15,20,34,-16,-19,58,92,10,-51, 
  /* [130][0][][] */ -88,7,127,-63,56,-31,30,35,-42,9,-61,72,10,-49,81,-70,30,15,-3,35,-23,9,-39,11, 
  /* [131][0][][] */ 69,-22,-35,-17,-10,-3,12,36,-13,71,2,85,107,-39,47,5,33,-28,103,57,26,127,1,15, 
  /* [132][0][][] */ -49,-64,0,-2,-39,17,27,30,127,52,-12,47,-9,-35,41,-28,50,-29,66,-31,-40,3,17,-89, 
  /* [133][0][][] */ -39,-14,-67,-64,-7,-52,-31,69,-56,-71,-36,-80,-13,50,119,127,-26,-11,45,14,-64,43,20,113, 
  /* [134][0][][] */ -78,-46,21,-51,126,-32,50,52,-40,-35,-49,127,22,33,44,-22,42,69,-62,-19,5,-28,56,13, 
  /* [135][0][][] */ 24,-5,75,-16,-71,127,3,-81,8,59,-35,-97,38,74,73,-78,2,55,6,-72,0,1,-94,-16, 
  /* [136][0][][] */ -83,-22,67,-29,-37,-1,76,-71,-42,127,85,61,-67,-72,30,-49,72,-9,-45,59,44,47,-87,57, 
  /* [137][0][][] */ 77,55,32,-98,-51,46,-97,-127,47,-4,-53,-30,-29,72,-4,-76,71,19,51,37,-71,-7,23,-44, 
  /* [138][0][][] */ 1,-67,-23,8,21,71,-42,-22,-8,28,-7,32,94,-4,29,59,110,-13,14,-62,127,69,111,108, 
  /* [139][0][][] */ -56,-17,127,-49,43,-40,-19,48,-85,-42,-32,71,23,-18,20,67,-8,49,-38,-90,43,18,42,78, 
  /* [140][0][][] */ 47,-50,58,-85,6,36,82,-15,18,66,-10,1,-10,-127,19,-39,18,100,41,-54,2,-28,-7,-64, 
  /* [141][0][][] */ -21,34,73,-57,52,-127,-71,-4,26,-49,-87,19,-15,-59,108,39,37,-19,-38,73,48,-31,54,-27, 
  /* [142][0][][] */ -51,-15,-2,32,22,-7,55,-106,-23,3,-127,10,-90,-2,38,-2,16,-77,-20,3,-49,39,82,89, 
  /* [143][0][][] */ -64,-44,40,-56,0,45,-13,-36,127,-50,19,-68,-33,26,-29,10,25,27,-35,-56,-36,-118,22,1, 
};
const TfArray<4, int> tensor_dimension57 = { 4, { 144,1,1,24 } };
const TfArray<144, float> quant57_scale = { 144, { 0.0018331544706597924, 0.001467945403419435, 0.0014766048407182097, 0.0018968278309330344, 0.0012773978523910046, 0.001735659665428102, 0.0022418657317757607, 0.0015649306587874889, 0.0010069775162264705, 0.0011488196905702353, 0.0028426554054021835, 0.0013585494598373771, 0.0017161564901471138, 0.0020979589316993952, 0.0021883312147110701, 0.0020789108239114285, 0.0015779592795297503, 0.0023450655862689018, 0.0015928201610222459, 0.0018421699060127139, 0.0017942986451089382, 0.002442048629745841, 0.001855947426520288, 0.0016018784372135997, 0.0015319276135414839, 0.002055757911875844, 0.0023926203139126301, 0.00105141825042665, 0.0014361712383106351, 0.002141560660675168, 0.0017041157698258758, 0.0019704294390976429, 0.0019169874722138047, 0.003232128918170929, 0.0019810802768915892, 0.0031637116335332394, 0.0017009382136166096, 0.0020591423381119967, 0.0020479562226682901, 0.0018995102727785707, 0.001824374427087605, 0.0015484096948057413, 0.0023041078820824623, 0.0014374982565641403, 0.0019565536640584469, 0.001772299176082015, 0.0017513725906610489, 0.001377918291836977, 0.0015493631362915039, 0.0018344345735386014, 0.0021566255018115044, 0.0018480716971680522, 0.0021018574479967356, 0.0015883016167208552, 0.001525336061604321, 0.0020137126557528973, 0.0010871405247598886, 0.0015276886988431215, 0.0023671169765293598, 0.0023177068214863539, 0.0017305262153968215, 0.00091573753161355853, 0.0021204182412475348, 0.0019036127487197518, 0.0015498170396313071, 0.0022432676050812006, 0.002280151005834341, 0.0014887393917888403, 0.001552518573589623, 0.0017178915441036224, 0.001572591601870954, 0.00262651895172894, 0.0019430126994848251, 0.0019344070460647345, 0.001732123433612287, 0.0016626383876428008, 0.0018596689915284514, 0.0022798192221671343, 0.0013082833029329777, 0.0022743199951946735, 0.0015079465229064226, 0.0029059727676212788, 0.0031767180189490318, 0.002320147817954421, 0.0019371483940631151, 0.0016729631461203098, 0.0020046641584485769, 0.002413169015198946, 0.0017425864934921265, 0.00047017069300636649, 0.0024102332536131144, 0.0016237335512414575, 0.0017257394501939416, 0.0021542981266975403, 0.0018793413182720542, 0.0030706149991601706, 0.00095546775264665484, 0.001944703864865005, 0.0028125415556132793, 0.0017403187230229378, 0.00092663784744217992, 0.001488293637521565, 0.00225647515617311, 0.0019312333315610886, 0.00097960943821817636, 0.0017415023175999522, 0.0011748621473088861, 0.0024862193968147039, 0.0030459030531346798, 0.0023015656042844057, 0.0033437837846577168, 0.0017123017460107803, 0.0016227748710662127, 0.0012607633834704757, 0.0017382033402100205, 0.0024963067844510078, 0.0017686049686744809, 0.0015257985796779394, 0.0011033420450985432, 0.0014645208138972521, 0.0019188628066331148, 0.0019237776286900043, 0.0021947012282907963, 0.0025171870365738869, 0.0020593043882399797, 0.0012993719428777695, 0.0014515451621264219, 0.0015417097602039576, 0.0026817119214683771, 0.0018288706196472049, 0.001676380168646574, 0.0011794683523476124, 0.0024220973718911409, 0.0020753087010234594, 0.001770641072653234, 0.0015268982388079166, 0.0024195713922381401, 0.0012409240007400513, 0.0013745814794674516, 0.0017250839155167341, 0.0022261789999902248, 0.0020905290730297565, 0.0030755577608942986, 0.0019736520480364561, } };
const TfArray<144, int> quant57_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant57 = { (TfLiteFloatArray*)&quant57_scale, (TfLiteIntArray*)&quant57_zero, 0 };
const ALIGN(8) int8_t tensor_data58[24*1*1*144] = { 
  /* [0][0][][] */ 58,-3,-88,42,-127,2,13,59,-45,-50,-4,29,-10,16,-7,-41,46,14,-44,-13,-62,16,-11,46,44,30,-50,-8,-9,15,62,9,11,-10,-25,10,36,-45,51,5,-24,-49,4,5,-25,38,-33,4,-24,9,-44,1,37,14,1,23,-8,-6,-64,4,24,-55,-10,-8,-13,7,26,-17,-109,-52,-12,-16,-19,4,-9,21,-64,-33,-26,19,-22,6,-24,-3,-20,20,22,-1,-43,-83,-32,-13,14,12,33,50,-4,30,-1,-14,95,30,-12,-27,-14,-65,7,23,39,4,37,-3,-23,-14,-29,27,-2,14,49,-39,0,12,7,27,-27,-4,-56,-50,-10,3,-26,-24,2,-25,-11,-22,14,-57,6,-36,-38,-7,15,-53, 
  /* [1][0][][] */ 17,-13,127,62,-4,98,-20,37,-14,-41,-51,-19,-18,0,8,-61,-18,-78,-4,-30,5,-13,-32,31,75,-14,120,10,42,17,-24,-20,3,-27,62,-55,39,-11,-48,36,37,91,-33,30,-22,-33,54,55,-39,-29,-26,28,-39,-2,97,5,-1,53,5,-19,8,-59,-59,44,53,16,45,77,-16,25,11,-11,7,0,27,45,5,28,3,31,25,-22,-54,52,64,-30,-84,-36,-38,-4,13,-13,19,-29,15,-3,5,-4,12,73,-21,-34,86,53,26,5,-37,42,24,5,-11,-52,12,63,23,-59,117,-58,109,44,-24,8,-7,3,-6,3,48,39,40,44,13,-18,-7,-30,-2,-15,54,76,-48,-14,42,-30,-45,-65, 
  /* [2][0][][] */ -85,-51,22,80,-105,-5,73,-45,63,-74,12,22,95,-101,-45,-22,-127,-52,18,-41,79,-15,61,10,15,-43,-8,120,27,36,-43,-66,-4,12,42,7,-40,33,10,-48,93,-56,3,-5,38,-119,14,40,70,-63,-17,93,-9,17,29,-37,39,37,59,-14,-36,1,-47,120,69,5,4,63,-84,7,102,10,1,-3,-22,38,27,75,-118,-32,-53,16,28,39,-49,-49,83,-18,-88,5,-58,-14,-2,40,-7,-37,76,3,-6,-6,46,7,-30,-30,51,-1,4,30,-85,33,-42,32,74,-84,42,55,-35,15,-41,-1,-35,77,44,-11,-19,82,25,-21,-63,43,21,68,-27,-26,10,98,26,-40,-11,53,1,-53,-17,70, 
  /* [3][0][][] */ 5,-15,-109,-43,1,11,22,40,-42,44,-52,-18,5,6,-1,46,18,8,-53,-34,-66,23,34,70,-41,8,-127,-9,41,37,0,-24,24,-12,-120,44,-10,12,-106,10,48,14,79,-17,-7,-5,-12,-26,22,11,54,-25,5,-5,17,11,-18,57,61,-5,-15,-70,-1,27,-29,3,10,-47,-23,-24,-5,-9,40,29,43,3,13,6,9,0,24,-20,17,2,-28,-31,-26,-3,-42,-21,20,18,-31,51,29,30,-47,-18,20,-3,118,67,36,-34,-25,-100,-55,-58,-15,21,-52,-28,7,23,33,-14,6,33,-17,17,-19,10,10,-7,7,3,24,45,-10,24,39,-23,35,-3,31,-11,-22,-5,2,14,19,71,23,61, 
  /* [4][0][][] */ 66,-24,-8,-34,7,5,-81,87,-49,56,44,-54,-29,60,37,-39,13,0,-96,30,-9,127,7,26,-1,-10,98,22,0,-47,-2,61,-61,13,20,-55,-7,-25,21,31,-58,22,-34,47,10,11,7,95,-33,24,-10,95,18,45,10,98,-80,-9,-26,59,30,-19,81,-76,-25,-9,-90,-55,-42,21,-38,39,-70,98,-22,-15,17,-88,-92,-62,-61,67,6,27,75,123,-23,-56,31,22,-69,-46,56,-6,-64,27,-17,74,46,-2,-48,-2,11,8,6,53,-37,21,114,4,57,56,-26,-55,-76,75,5,32,87,-58,-4,-25,-11,-28,-10,3,-25,11,33,-58,-42,-34,-68,-11,3,-32,104,11,-12,-61,-46,59,43,-52, 
  /* [5][0][][] */ -3,-19,51,42,6,27,27,-6,-93,-83,-8,-73,-88,3,7,20,28,50,-13,30,29,-2,37,13,-53,-28,59,-89,62,-48,33,58,-7,67,42,86,110,-24,-17,-17,19,27,31,21,-95,43,23,51,26,-91,-1,-41,35,-50,7,0,29,-9,-35,-4,-71,-89,47,-114,-67,-51,0,17,33,23,-89,-51,29,-19,-26,15,13,38,-6,-51,17,22,82,49,0,-5,-17,25,-25,-5,-35,-43,-11,32,40,-60,-97,26,98,-60,11,-39,1,-13,-127,14,-103,-17,51,91,-50,-39,48,7,-51,-67,8,35,-3,-11,-51,27,35,17,-1,-111,89,-5,-36,50,64,-37,40,-12,-50,4,-27,-67,5,66,22,18,33,18, 
  /* [6][0][][] */ 7,26,-29,82,-58,30,-8,-15,-4,-14,-55,8,2,28,18,4,-7,-8,-31,-68,76,-1,57,-64,-4,-24,-21,-69,-18,54,-6,-39,31,-11,1,4,67,-46,-8,-12,16,-23,-1,24,33,-46,-4,57,-9,-42,38,22,-19,33,73,-12,-27,42,-4,41,10,9,18,-26,-56,43,12,-28,-14,76,-8,2,67,-46,28,5,42,-19,46,54,-54,-41,-6,21,-18,-66,42,13,16,127,-24,33,12,50,-97,33,-16,68,4,-64,83,-9,-29,2,5,2,-66,-41,-27,-25,-64,-53,-24,-46,-54,3,-35,-3,65,-14,-22,3,-16,-29,-42,-7,-66,24,-9,-18,-53,-19,14,-11,65,27,-1,2,-27,-49,6,85,64,-15, 
  /* [7][0][][] */ -15,13,-26,-35,-70,-62,-36,20,-122,-21,-10,-86,-55,-8,-14,36,43,40,-10,-18,-24,42,-61,4,20,-6,-25,24,-8,-28,-3,39,-34,10,-32,23,20,-14,-15,-14,-49,-46,-25,9,-92,57,-12,7,-17,-17,16,13,0,-19,-55,-3,-8,-19,-20,56,22,-121,23,-32,-52,8,-61,-37,-70,-34,-85,-13,32,34,2,44,41,5,-43,43,-54,-18,40,-23,-17,10,11,-2,-52,1,-16,9,-1,20,-27,11,-127,4,47,12,34,-14,-21,13,-65,-14,-53,-27,51,4,-8,-2,13,-16,2,5,-45,-18,14,-32,-33,17,33,-7,-14,-112,-43,-22,-2,-13,-29,-77,4,-5,13,-12,-10,-20,11,-28,-20,-22,27,-9, 
  /* [8][0][][] */ -17,18,9,-28,-38,-3,31,-53,69,7,-10,-2,23,8,-35,33,-13,19,0,27,-8,43,0,-42,-42,-24,24,-15,-45,48,19,13,17,13,50,29,8,-19,32,31,15,-47,14,-7,33,-1,-1,-21,-5,-22,11,-35,11,15,-17,8,12,26,27,-6,-2,31,8,17,34,27,-19,10,-43,11,33,-10,4,7,-2,-25,-24,7,4,-17,-83,-9,0,-26,-22,-25,-41,-8,-27,82,-41,-6,-18,0,-4,-55,33,-16,0,-1,-43,-55,-68,-26,35,36,26,20,-11,-9,-26,5,8,-26,-32,6,-43,9,54,-29,7,41,6,-25,28,66,8,-32,-16,33,-24,18,12,-5,-9,-9,-11,-53,-37,4,-18,21,34,127, 
  /* [9][0][][] */ 18,-65,-51,61,-64,0,98,19,-9,-30,55,75,4,38,-1,42,-51,25,-55,-31,-9,38,-29,-2,-44,25,6,-62,56,-63,-5,-34,-43,-57,-22,75,9,4,-47,-98,-22,-20,-81,-50,-7,49,59,60,-41,-15,-18,-9,86,-59,-17,29,-32,-65,-42,-67,94,32,-7,9,10,1,33,-39,-57,-74,-9,35,-39,85,-71,-20,-49,-26,34,61,11,14,-61,-3,-9,13,16,1,25,-83,-8,-35,-8,-49,-79,7,36,-7,-12,-31,19,67,14,32,-8,-22,50,19,18,31,77,-40,14,3,43,33,13,10,-36,-76,27,-24,20,127,-12,-15,0,19,-11,22,2,-31,4,-32,-39,96,76,-14,-59,-41,11,40,28,-93, 
  /* [10][0][][] */ 1,41,9,-28,3,-6,-42,-10,-72,17,-2,-113,-11,-54,12,-61,36,72,-3,20,12,-25,5,-10,-68,49,-32,-1,-5,47,34,99,-24,65,-2,18,78,-23,14,-24,-37,-40,-53,-39,-52,36,-93,-107,9,-20,-22,-25,7,-61,-52,9,41,-14,-41,-36,63,-54,41,-11,6,70,16,-9,-16,83,-32,-24,5,78,-121,52,29,5,72,0,-81,28,30,57,-2,-1,-15,13,-14,127,-39,28,7,8,1,-18,-97,-36,62,-47,75,-102,28,-26,-61,-23,-38,-15,43,-8,-30,13,-6,65,-65,22,-32,12,13,8,-57,49,-34,8,55,-53,18,29,-13,6,59,0,-105,-70,-87,69,14,-1,-7,-10,31,-85,-4,44, 
  /* [11][0][][] */ 14,37,-83,30,1,2,3,15,32,-42,49,61,-20,-4,44,-11,-61,-3,47,43,-38,-64,20,16,-6,61,-76,41,2,23,10,3,-2,5,-45,-9,7,8,103,-18,-6,-2,6,41,30,-27,15,-2,-14,36,-32,-47,-35,22,9,-18,-15,52,24,-60,-12,17,-8,-20,4,-3,25,2,14,-47,38,52,-49,-21,26,-19,-64,17,-26,-18,50,-2,-40,92,-36,-10,-26,34,8,-55,-36,-5,23,-1,-10,4,62,-32,-51,25,127,53,33,25,76,-93,60,7,-14,4,7,43,72,46,25,-26,17,-28,5,1,23,-13,51,-37,4,45,2,16,18,-5,-19,24,36,29,55,-43,10,27,-4,-38,31,-7,-32,1, 
  /* [12][0][][] */ 12,68,10,20,-48,62,-31,-3,-27,6,86,-6,-1,77,-18,30,-54,-28,-1,17,-20,-17,76,70,70,-40,3,-54,34,42,51,-12,27,-42,-19,-47,-84,-45,-93,41,-11,-17,-62,33,-6,-62,15,37,74,28,66,37,-89,49,35,67,24,-45,19,-9,43,-96,-127,-7,20,-11,-18,-15,-24,-72,-1,-42,-19,37,-3,93,-8,-44,66,26,34,-10,35,-24,7,38,6,-34,-82,10,15,21,19,29,26,50,-28,17,19,-31,61,42,77,57,7,-61,-91,81,32,26,-17,-41,88,-17,-65,7,30,1,-62,-6,-44,48,-17,-2,38,24,-35,12,34,-32,-11,-72,-15,-47,-3,-6,56,49,-43,-30,1,-32,29,-20, 
  /* [13][0][][] */ 3,12,21,-3,12,3,5,9,-100,-24,5,-71,-37,20,39,13,21,60,-87,10,43,-8,4,-4,-74,-17,50,-26,8,-18,-28,33,-42,2,25,-11,-15,-19,12,-32,-18,-38,13,-16,-34,-26,20,23,-2,-14,1,-3,-9,-21,-22,-16,-8,-35,25,-43,33,-89,26,-82,-40,-8,42,-16,-26,-7,-45,20,-13,-36,-33,31,1,-53,14,-75,-34,25,-15,-27,71,-3,4,24,4,-16,-38,17,15,6,-6,-9,-127,43,-10,9,-62,-29,-7,-20,-61,58,-41,-29,28,58,26,13,-33,-37,-32,-6,-16,-2,-72,-33,-26,-46,-8,7,19,-72,14,-42,0,26,-14,7,10,53,31,-86,10,-14,-10,-47,-25,4,44,45, 
  /* [14][0][][] */ 32,66,-6,-104,78,-67,-8,-17,69,13,-41,38,-13,-21,-10,1,66,-70,53,-30,12,-9,-24,1,7,103,-56,39,51,-31,8,-44,-24,-44,-18,-36,19,-6,30,-56,-15,20,53,-70,-28,30,40,3,26,-56,-45,35,-33,-57,-107,-12,-62,-50,-10,30,-30,62,64,6,-39,10,-51,-86,80,19,0,7,123,48,31,-63,-2,-46,-12,-23,38,25,-55,-41,28,2,-90,39,-44,-33,20,-10,15,31,52,-5,50,-6,21,-28,-38,9,18,50,17,26,13,-19,-63,-25,17,56,-6,2,-21,-26,-39,-53,52,-5,30,-43,16,78,14,13,-34,-16,34,-8,-72,8,11,11,-25,127,-65,-17,48,29,17,-17,-43,-41, 
  /* [15][0][][] */ -5,14,-22,-69,-6,3,9,28,-56,-13,36,37,-23,26,-2,61,33,1,-21,-75,-40,-5,-19,-5,8,28,80,-9,24,-18,74,-23,-33,19,15,-1,-31,-32,31,31,38,-33,-1,8,-20,-42,-4,-28,-15,16,27,-25,-21,6,-47,44,-25,-6,89,-37,-94,6,6,-42,-38,-27,-10,31,-44,4,-10,37,-1,9,-16,-20,8,-19,-12,-60,-80,-127,-12,-16,21,-47,26,-12,13,26,-52,-10,17,-47,70,-56,-19,6,8,-8,-88,-4,-58,37,8,58,-13,25,-33,27,4,53,-44,-53,3,-48,14,40,-26,-49,-8,-39,-28,-59,71,-33,-35,70,30,-23,7,53,15,80,68,-10,-18,40,4,-51,10,72,43,-52, 
  /* [16][0][][] */ -50,-87,49,16,-37,-119,1,-17,87,-59,14,34,38,-72,-31,15,-48,-31,-20,-57,81,13,-2,-81,40,1,12,-31,112,2,6,-6,-27,-85,37,-39,50,-17,50,-11,18,-76,33,-13,19,39,26,62,15,45,-4,24,39,-10,-13,-85,47,4,-5,103,103,100,58,74,0,-51,-9,45,-72,48,39,-10,53,3,61,-40,-13,75,-4,30,-35,-93,34,15,-41,-42,-38,-10,60,116,-9,-4,25,-6,-19,80,105,30,23,-49,-5,-103,9,-13,33,44,69,11,-14,-26,12,23,15,-78,37,66,22,53,3,53,33,21,127,0,-18,2,-70,39,90,51,22,88,30,-32,57,31,58,-76,-44,-15,17,21,18,24, 
  /* [17][0][][] */ 25,94,54,26,-23,-42,-38,45,14,12,-3,3,40,22,-33,52,70,4,0,-28,-37,71,24,11,20,-21,-3,46,86,29,7,14,99,6,13,-20,21,125,-27,24,-29,35,-37,-48,-27,-62,-57,34,40,-8,3,34,-59,-21,6,-49,36,-20,-51,53,125,-1,33,-6,4,-20,-90,29,-7,-4,14,115,43,17,-18,71,48,10,-127,-14,5,-108,42,-79,-1,34,45,81,30,109,32,61,7,-57,2,37,40,50,-18,31,47,-9,51,2,-68,-20,-29,52,66,-17,25,19,-15,-13,63,14,72,-23,-2,38,12,27,-40,0,30,-23,-59,49,61,8,10,31,-26,-103,15,41,26,16,72,-13,-3,24,-10,-23, 
  /* [18][0][][] */ -44,6,-47,-12,41,-1,-66,0,5,-52,64,-29,45,101,-21,-56,-33,-25,25,-84,81,-17,-31,8,65,-91,45,-77,-3,58,-21,-52,-23,8,-8,-38,9,8,16,-30,-60,-1,-56,57,-21,-6,-6,60,-37,-18,-16,-11,34,-2,-24,-18,40,4,-38,-32,-33,22,-78,-18,23,17,-103,20,-106,13,27,-1,-34,71,13,-13,6,-7,-41,46,44,-57,-32,11,-10,20,-127,2,-5,109,-73,35,27,14,-13,41,3,51,-49,85,36,-43,25,-38,38,-54,62,30,11,-34,55,1,32,-4,13,37,-3,54,-15,-45,12,-3,6,-66,19,0,18,-30,-4,-78,21,65,-5,40,-24,49,-12,-33,54,77,-61,-26,-72,-127, 
  /* [19][0][][] */ 15,43,-59,7,-42,-19,-22,19,-11,21,-5,22,9,-17,0,36,3,26,25,-29,29,42,-18,49,-34,-34,-127,-1,22,-8,-6,4,-21,19,-78,-21,0,-3,-30,0,6,10,-33,-32,42,5,16,2,8,34,12,1,-22,-16,-7,-16,25,35,25,4,2,3,19,6,19,12,-13,-33,5,-53,9,-39,2,-28,5,-32,15,10,47,-2,17,-10,-7,-14,-10,16,-25,10,-28,-34,41,11,8,57,-4,63,19,-9,-2,8,87,65,21,33,37,-64,11,11,-10,-29,-15,15,-9,-26,-2,8,-2,9,38,37,-7,-11,-8,-23,-7,10,47,20,12,-2,-4,22,-39,24,23,19,8,-3,5,42,12,29,27,14, 
  /* [20][0][][] */ 57,-24,14,64,-39,23,-28,14,76,4,16,46,62,-102,10,-27,3,-7,-79,-30,29,-14,-15,2,-41,-8,-2,9,-45,10,-11,15,-13,8,36,0,5,41,24,36,-51,-31,-34,-48,65,-48,63,-12,-51,-40,-60,-14,8,-56,8,-75,81,-16,-84,4,41,67,-6,-4,59,-13,25,-114,12,-33,57,-1,-23,-25,-13,-22,-31,36,4,56,-38,28,14,51,22,-77,-45,-15,5,29,63,-2,73,55,40,15,124,-55,-1,-92,96,53,-40,-45,27,4,99,-29,0,-42,-90,29,-21,-16,-4,-20,16,6,-21,11,29,20,-23,-45,16,69,25,-50,-34,26,15,39,18,-29,-42,33,-41,14,-127,32,-9,-75,6,-5, 
  /* [21][0][][] */ 37,29,-103,-36,-44,-10,127,32,-47,44,2,30,-16,38,-5,-11,2,23,-44,-13,-104,-23,-8,24,-20,36,-119,-23,17,-6,50,40,35,-8,-112,-7,-50,-4,64,-55,-8,47,33,-8,-78,-2,-46,-96,62,-29,-17,81,19,-21,-70,127,-87,-20,1,-113,24,-76,50,-59,-28,-46,-48,8,59,-25,-49,56,25,-29,-39,-13,-22,41,1,1,66,-118,-19,29,-73,90,-46,11,110,-125,-45,55,31,58,-4,102,-19,-68,-55,44,-14,126,9,33,-12,-92,18,21,-27,126,7,-83,6,8,36,-25,-21,-1,-20,-56,12,-8,-81,8,31,-79,55,-49,36,98,-43,-15,58,-24,-22,-6,1,5,-59,-70,8,-28,-26,-79, 
  /* [22][0][][] */ 24,28,59,85,60,91,-49,-23,26,20,54,-7,-96,6,-37,-42,-48,-47,8,43,57,50,78,-14,112,36,55,-11,-2,-5,94,-42,47,4,41,-16,-111,52,-45,121,43,19,-49,53,64,-80,-115,17,84,48,-49,12,-119,40,108,-11,8,-20,-95,103,-54,17,-91,-42,17,11,59,55,36,15,32,37,35,-20,10,-19,27,10,-127,-49,61,-10,-33,74,28,-35,-45,-23,-121,40,32,120,38,-51,17,51,-21,38,44,-35,39,3,-11,10,26,3,-8,29,-41,-13,-23,-46,31,45,19,23,78,46,38,79,16,-34,-98,41,-51,30,67,18,62,-27,11,-1,76,29,-50,-87,49,26,-71,-6,29,26,-8,46, 
  /* [23][0][][] */ 16,88,-21,-57,37,26,39,-69,-22,78,14,-25,-25,-41,110,52,13,-33,-26,-16,78,31,53,-56,30,61,-10,-48,7,-46,8,-36,69,-39,2,-33,-66,20,-37,-37,47,76,-38,-11,-15,24,-56,22,64,15,51,69,17,45,-19,3,11,50,66,23,-12,-32,47,3,-30,-9,53,-40,46,18,-3,19,25,-93,30,-9,-14,-77,36,-8,-72,-35,-22,-41,27,-11,10,89,-20,-48,27,86,16,22,7,-19,-33,26,-16,-29,-127,32,-4,20,15,81,36,88,-33,-12,0,-31,19,-35,16,-2,-15,76,-17,32,13,-44,-45,31,-24,-7,12,-35,-19,-39,-44,-99,-16,48,59,40,37,-23,-38,-48,11,75,-25,-15, 
};
const TfArray<4, int> tensor_dimension58 = { 4, { 24,1,1,144 } };
const TfArray<24, float> quant58_scale = { 24, { 0.0027276973705738783, 0.0021537239663302898, 0.001585609745234251, 0.0024004243314266205, 0.0017307284288108349, 0.0020611595828086138, 0.0019147727871313691, 0.0030463023576885462, 0.0033345764968544245, 0.0015883778687566519, 0.0016405986389145255, 0.0022673264611512423, 0.0017081883270293474, 0.0030279788188636303, 0.0016907588578760624, 0.0017030409071594477, 0.0013555354671552777, 0.00168753566686064, 0.0014721963088959455, 0.002879489678889513, 0.0017966075101867318, 0.0013922216603532434, 0.001324579818174243, 0.0017463995609432459, } };
const TfArray<24, int> quant58_zero = { 24, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant58 = { (TfLiteFloatArray*)&quant58_scale, (TfLiteIntArray*)&quant58_zero, 0 };
const ALIGN(8) int8_t tensor_data59[144*1*1*24] = { 
  /* [0][0][][] */ -34,127,-102,64,20,-70,-36,-63,57,-72,3,15,5,67,32,-44,65,-53,32,-14,-10,62,-12,-3, 
  /* [1][0][][] */ -20,-51,7,19,-11,88,40,30,-18,0,-127,8,41,-5,80,-12,112,-6,53,-41,64,127,13,65, 
  /* [2][0][][] */ 1,55,-35,58,13,-3,-24,51,-85,-15,5,17,52,12,-7,16,-25,-5,48,52,72,127,11,-15, 
  /* [3][0][][] */ -50,41,-127,-45,111,-89,52,59,-15,-65,-53,-59,20,13,-74,34,48,-16,13,2,54,70,66,-31, 
  /* [4][0][][] */ -13,-99,47,70,42,6,-32,83,-47,-31,55,-75,-19,4,-69,23,-48,-23,-127,-37,-36,-30,-45,-10, 
  /* [5][0][][] */ 84,63,11,-124,6,6,18,-13,60,-22,-127,-1,-26,28,63,-52,25,125,-52,-33,-28,-33,66,-5, 
  /* [6][0][][] */ 81,37,-127,-41,58,-46,55,20,-9,-40,-28,5,-33,-12,67,28,23,2,94,6,50,-40,41,-65, 
  /* [7][0][][] */ 0,-87,127,41,46,-10,-94,40,-77,-5,-14,-2,44,-16,-8,26,88,68,-31,-22,26,-6,12,59, 
  /* [8][0][][] */ -39,-47,41,-16,27,-55,124,62,36,127,57,20,-1,48,58,-75,-25,45,-14,45,-9,23,-63,65, 
  /* [9][0][][] */ -4,-64,-4,17,12,-41,-21,54,-37,127,54,60,3,-62,-59,11,-43,-49,-1,32,13,-17,33,14, 
  /* [10][0][][] */ -25,-88,13,33,-53,49,-70,-45,39,11,-45,10,-70,34,-115,-47,-16,22,-47,-19,6,-21,-127,-58, 
  /* [11][0][][] */ 43,-94,-4,-127,-25,-65,-11,-53,-22,12,-33,10,-24,9,-3,-32,-8,29,11,-15,42,-23,-58,-5, 
  /* [12][0][][] */ -113,-46,42,-17,126,70,-66,42,-5,127,48,51,-47,3,73,-42,55,67,-46,-6,-109,57,-33,33, 
  /* [13][0][][] */ -127,-103,-95,-22,64,-39,60,70,45,-27,16,-74,-48,64,-70,10,-57,39,-125,66,38,12,-33,22, 
  /* [14][0][][] */ 30,27,-29,-40,126,-89,35,-15,-37,-34,34,-127,37,-83,-102,-55,-127,21,64,-38,22,11,-59,46, 
  /* [15][0][][] */ -36,-87,126,54,50,70,-82,115,-20,14,-3,-38,51,-33,-25,12,127,33,-57,-7,94,27,47,79, 
  /* [16][0][][] */ 41,69,26,-85,-58,70,-34,-45,86,-84,-52,-60,-43,26,15,24,15,-29,63,-127,12,-50,-13,18, 
  /* [17][0][][] */ 2,-115,3,-38,46,56,27,10,52,127,60,60,47,70,33,-28,105,-47,112,-9,33,83,-60,60, 
  /* [18][0][][] */ -81,61,51,-68,-14,3,25,-45,48,77,-9,-14,-21,-46,59,45,-127,60,22,19,105,-55,16,76, 
  /* [19][0][][] */ -32,93,85,-127,37,77,78,-28,-2,23,0,44,45,72,-114,-106,51,-10,-42,50,80,-20,57,-48, 
  /* [20][0][][] */ 6,-47,-36,40,-28,-7,-15,-42,0,-41,20,57,55,-10,-127,42,-36,-118,-44,-2,89,-80,-34,-13, 
  /* [21][0][][] */ -7,-108,-10,-8,127,34,23,72,-20,31,25,32,-30,-53,40,19,20,28,-56,-69,60,54,41,15, 
  /* [22][0][][] */ -1,-87,-39,-7,64,6,-92,59,-67,75,37,-38,102,33,-40,32,109,-17,-127,-49,96,-76,-106,3, 
  /* [23][0][][] */ -32,25,-127,25,-28,-27,-84,-119,14,-17,-6,-35,26,37,85,6,-34,24,43,22,-4,19,52,109, 
  /* [24][0][][] */ 67,-79,9,49,-35,6,-127,-34,-14,41,62,-16,-49,37,-52,122,-20,84,-68,16,4,-35,21,-48, 
  /* [25][0][][] */ -27,-127,12,3,-37,71,31,-12,-48,58,-7,-19,59,38,-3,-12,16,38,-43,-25,20,8,-46,40, 
  /* [26][0][][] */ -22,63,80,43,-5,-48,9,127,4,-104,19,35,-21,97,2,-30,-80,-55,-3,84,15,-58,-36,77, 
  /* [27][0][][] */ 127,-24,5,-100,6,24,86,-21,-17,-38,-86,48,-6,32,8,86,7,57,-32,-40,-10,-15,61,68, 
  /* [28][0][][] */ -77,-16,-16,-58,55,-25,111,-97,-77,-107,-127,-67,10,57,20,-109,-45,119,-102,-83,-70,99,-28,-117, 
  /* [29][0][][] */ 37,-43,28,-18,-58,29,20,-38,-44,-7,-127,19,19,19,112,1,84,24,87,36,-62,32,-104,-7, 
  /* [30][0][][] */ -14,-29,-27,-41,64,38,121,23,3,8,7,37,-85,-33,127,-87,61,28,69,60,-47,-17,-13,-27, 
  /* [31][0][][] */ -127,-18,-28,-30,18,27,94,67,-46,104,-57,-29,17,-111,-95,38,-99,-7,-20,52,95,-46,13,-15, 
  /* [32][0][][] */ 102,-127,30,113,-124,-8,47,22,-35,-29,11,58,9,-24,9,-40,-84,-21,71,83,-1,28,-42,-79, 
  /* [33][0][][] */ 19,24,-10,1,54,3,-41,32,48,10,32,25,-34,34,-111,21,-65,-37,33,-65,-41,-21,-21,-127, 
  /* [34][0][][] */ 26,-47,-50,-14,-4,48,13,91,42,37,-41,-97,-44,-29,20,-9,-13,-17,-2,1,6,-127,49,33, 
  /* [35][0][][] */ 59,-37,26,-20,-19,127,16,-3,-12,-6,51,-36,72,-40,-14,-2,58,-26,-72,-3,46,37,53,43, 
  /* [36][0][][] */ 52,78,-42,-54,-55,-38,-33,34,-62,-3,74,25,13,-97,-127,-19,8,109,-92,42,-70,6,24,26, 
  /* [37][0][][] */ -31,127,13,97,67,7,38,32,19,-44,13,-41,-88,-31,55,20,-12,7,12,39,22,20,34,-16, 
  /* [38][0][][] */ -1,-1,38,-10,41,-8,15,42,-12,-55,-66,-24,-72,56,78,-20,-96,127,-84,-2,-8,94,25,-75, 
  /* [39][0][][] */ 24,20,7,-99,21,28,13,-127,-44,-34,2,34,34,-2,22,-67,14,60,81,1,23,22,-38,-14, 
  /* [40][0][][] */ 58,22,33,-63,45,17,15,2,-9,-27,-23,-21,34,-17,1,-29,28,16,3,14,35,-20,127,8, 
  /* [41][0][][] */ -109,120,-33,38,-49,50,-9,6,27,18,46,-23,47,-74,60,-94,2,72,-127,37,24,-22,-26,42, 
  /* [42][0][][] */ 13,89,-120,-16,-39,-4,-39,7,5,34,22,-53,-39,-55,32,-34,-40,-59,-19,127,-37,-52,102,-38, 
  /* [43][0][][] */ 27,20,68,-58,67,-34,-88,-123,-39,68,127,-116,55,50,-98,-36,-50,26,-52,63,-79,-33,60,22, 
  /* [44][0][][] */ -27,90,-82,39,51,30,52,-72,5,2,70,8,2,-82,56,30,-67,-127,37,-81,-32,36,64,24, 
  /* [45][0][][] */ -9,127,-45,-9,-19,-49,-3,-71,4,-14,18,-35,-37,-38,-18,-12,-27,-19,50,25,0,-36,33,-16, 
  /* [46][0][][] */ -11,107,5,67,43,-31,44,-23,66,-127,-2,-10,23,-72,121,-28,2,77,13,18,20,5,-78,0, 
  /* [47][0][][] */ -39,-63,-127,19,43,25,-50,38,-44,-20,1,47,-26,-37,0,9,-121,-17,-82,60,21,-69,-32,40, 
  /* [48][0][][] */ -34,-14,9,-63,-38,-65,11,-87,104,-127,25,-53,-68,36,99,-35,113,-20,34,-92,-84,13,11,1, 
  /* [49][0][][] */ 58,-26,-50,-66,-8,7,91,-57,-57,66,17,-127,-40,-31,42,-77,45,-59,-6,26,27,-82,-60,-18, 
  /* [50][0][][] */ 4,111,53,-55,-30,16,25,-72,-56,-21,-55,-35,69,35,-127,41,-24,-85,11,-8,45,-61,122,-40, 
  /* [51][0][][] */ 57,-10,106,5,-66,-1,-127,-105,12,42,66,-55,-42,3,43,-43,14,92,-7,-23,-112,24,-22,2, 
  /* [52][0][][] */ -16,-4,32,60,-43,23,7,-19,66,-30,58,5,127,-53,21,58,-35,121,61,-19,42,13,9,78, 
  /* [53][0][][] */ 7,-17,26,42,-62,-59,1,36,60,-22,45,52,39,35,-107,14,127,36,-32,25,43,19,48,-40, 
  /* [54][0][][] */ 127,-113,-29,-64,17,-45,-38,-53,21,3,97,-87,-126,23,40,-57,-47,25,29,28,-114,-68,-74,-93, 
  /* [55][0][][] */ -47,91,9,-75,-2,6,-21,-46,-108,16,-82,19,52,5,-43,105,-19,9,44,-23,3,-4,127,31, 
  /* [56][0][][] */ 57,42,66,43,107,39,-32,38,102,-40,77,127,16,-88,-55,48,-40,-80,-36,-64,-13,-5,100,27, 
  /* [57][0][][] */ -109,69,-55,9,-69,-56,-67,-31,-13,-87,0,-18,115,9,-38,15,71,57,5,-127,27,-111,-90,50, 
  /* [58][0][][] */ -57,-42,-28,4,3,-30,53,18,-81,-30,52,64,-23,11,37,68,-127,19,21,40,27,40,16,-13, 
  /* [59][0][][] */ -40,8,-38,16,-25,83,75,37,-65,16,3,-70,127,5,14,6,-37,53,-93,0,-41,-3,8,7, 
  /* [60][0][][] */ -28,-18,-10,31,2,-57,53,-60,19,-33,40,65,-33,-75,127,4,10,16,69,77,38,-10,44,32, 
  /* [61][0][][] */ 26,-3,-18,-79,127,-8,55,1,13,-27,56,-52,-13,-23,-120,77,-33,95,41,31,72,6,9,10, 
  /* [62][0][][] */ 37,-65,31,-25,-60,9,0,-32,-69,60,-41,-89,-127,26,-9,-58,-40,50,-44,107,-61,-63,-29,9, 
  /* [63][0][][] */ 36,52,-22,-70,-18,-28,10,-33,-49,-37,-37,12,-127,-48,9,-33,-2,-47,-51,15,-14,14,-8,92, 
  /* [64][0][][] */ 32,6,1,-5,46,-19,7,-86,91,-16,17,8,-12,-127,26,-13,18,62,72,-1,-9,-26,38,14, 
  /* [65][0][][] */ -1,-21,16,-73,0,60,-7,-8,-8,59,-44,35,32,83,33,-127,45,22,50,54,-105,40,-75,-8, 
  /* [66][0][][] */ 27,-25,7,16,10,-36,-30,-85,-19,-22,50,-127,36,-31,-13,25,-65,21,-53,53,-2,1,-18,-100, 
  /* [67][0][][] */ 18,-42,-9,84,29,-12,-83,-26,55,-19,-13,62,-127,64,-28,11,4,44,-17,-58,-31,107,42,-53, 
  /* [68][0][][] */ -70,51,-25,63,71,-50,-52,-33,47,29,-51,-34,-83,-13,47,-26,21,13,74,127,1,1,94,26, 
  /* [69][0][][] */ 21,86,41,-3,41,-65,-71,-121,58,45,-95,12,72,-3,11,-88,57,42,-35,-26,-55,-4,127,109, 
  /* [70][0][][] */ -24,-10,-57,64,-94,127,-8,-94,59,39,-51,-38,-6,-27,-55,-7,59,20,50,4,-27,30,14,22, 
  /* [71][0][][] */ 13,-53,-48,69,127,41,-13,102,10,52,-54,-41,35,72,-54,36,98,94,-55,-39,-70,-22,-46,-53, 
  /* [72][0][][] */ 49,-11,62,-76,29,-46,18,42,-75,-86,-13,81,-35,34,41,9,11,17,-85,-95,-17,7,-127,-103, 
  /* [73][0][][] */ -93,4,38,-126,53,1,42,-7,33,76,-8,101,75,28,-12,-127,-38,64,28,52,-43,-35,-25,-14, 
  /* [74][0][][] */ 37,66,-24,-57,6,8,51,-36,-13,-49,-16,50,-10,-100,-127,20,-71,41,64,8,-33,1,-22,-27, 
  /* [75][0][][] */ -4,-28,-83,7,-22,-55,-74,-20,-61,-28,-127,-26,-25,-26,43,-39,63,-8,-38,78,-48,34,41,83, 
  /* [76][0][][] */ -18,-72,-44,50,-14,127,-29,-34,82,36,47,-28,24,34,-40,-60,96,2,8,81,39,-91,-37,2, 
  /* [77][0][][] */ -88,-42,127,76,66,-83,-86,49,44,-10,6,-37,-57,89,3,35,-74,39,-115,0,69,69,-36,-33, 
  /* [78][0][][] */ -13,-30,71,-127,34,-31,-84,15,-56,92,-1,-85,35,34,59,34,-7,20,-94,36,23,-39,-39,-108, 
  /* [79][0][][] */ -118,126,4,-77,-57,7,6,-127,-44,-102,35,54,57,-111,17,-13,-48,-11,32,3,118,19,26,51, 
  /* [80][0][][] */ 36,94,-46,-38,90,1,17,50,-66,41,-59,14,15,-41,38,-9,21,-8,17,52,5,127,-23,47, 
  /* [81][0][][] */ -75,28,-47,-68,-11,-127,18,1,41,-41,96,-14,46,7,-63,-6,52,29,5,0,-66,-20,54,29, 
  /* [82][0][][] */ 28,-102,-6,-55,18,-18,49,8,-18,65,-23,-32,87,-1,-28,127,95,-27,-46,-15,15,13,-32,-91, 
  /* [83][0][][] */ -99,-38,-20,76,36,-19,13,9,-25,19,111,2,11,15,36,44,-57,-127,-32,-65,-57,-8,62,18, 
  /* [84][0][][] */ -32,-6,-10,-4,7,-76,-92,55,-4,-30,-127,-32,-73,-101,6,-79,21,-57,19,63,-67,1,-66,-73, 
  /* [85][0][][] */ -99,50,63,60,-18,-127,8,66,115,17,56,-52,96,-115,90,41,-36,70,-32,81,42,-60,23,0, 
  /* [86][0][][] */ -47,-40,-8,-34,1,-9,46,127,35,41,-112,13,-14,19,17,3,-60,5,54,-21,69,33,-43,13, 
  /* [87][0][][] */ 72,127,-7,-31,74,-15,8,36,-38,81,41,-52,26,42,-84,36,-82,-17,11,-26,-73,68,1,-14, 
  /* [88][0][][] */ -122,29,87,-39,69,-44,-88,4,-70,-127,21,60,109,53,-27,-45,83,-18,-49,36,73,-38,-89,8, 
  /* [89][0][][] */ 63,46,95,62,8,127,51,-30,13,41,-104,111,17,-26,92,-68,-35,-78,-3,14,64,-16,-54,-12, 
  /* [90][0][][] */ -31,-88,-26,-23,-26,125,-31,-43,-127,-32,122,9,4,-103,-30,30,-62,83,-90,-65,8,-116,-110,-104, 
  /* [91][0][][] */ 25,-21,63,104,44,41,-24,41,5,40,19,-41,-44,42,-32,-58,7,77,-75,-12,-12,-32,-127,-116, 
  /* [92][0][][] */ -7,-60,-12,56,-25,63,6,11,0,0,-9,26,-4,-52,-16,-33,52,-23,127,-7,46,-22,-1,91, 
  /* [93][0][][] */ 55,51,36,14,-18,26,-85,-23,39,-19,-29,43,-19,-66,80,-88,63,127,52,39,49,-73,58,-114, 
  /* [94][0][][] */ 67,23,6,10,40,24,-83,9,73,0,-127,-56,-22,67,115,-88,99,-43,69,18,7,21,54,-39, 
  /* [95][0][][] */ 76,23,41,17,-7,69,-50,20,47,12,-73,21,36,-32,-30,45,14,79,19,-2,24,-23,-127,-27, 
  /* [96][0][][] */ 20,-109,9,-45,-77,38,-61,-53,-71,-70,122,43,81,-48,53,-37,-15,127,-19,-117,56,-90,-62,-95, 
  /* [97][0][][] */ -127,0,-46,23,-71,-8,-44,17,52,-40,105,54,33,22,24,-104,41,3,-27,-57,30,52,-79,25, 
  /* [98][0][][] */ -32,127,-51,32,10,-75,37,-29,-87,-2,-87,-27,-49,46,-83,50,41,-46,-24,-42,114,34,6,-14, 
  /* [99][0][][] */ 37,-20,16,-98,-12,-54,-25,-43,-30,15,42,-1,28,3,-12,37,-127,5,48,-15,-89,20,-2,6, 
  /* [100][0][][] */ 4,80,-121,14,-43,0,-26,-122,-11,16,26,-103,-22,49,-8,-27,-33,28,23,127,-27,-84,-81,-49, 
  /* [101][0][][] */ 12,8,-127,-49,-21,-22,49,44,-94,32,-42,1,-45,-20,45,-6,-43,-100,44,-3,-3,-80,38,-41, 
  /* [102][0][][] */ -22,-17,68,81,-36,4,127,65,81,-22,6,-85,44,-25,23,69,-25,11,-4,-33,85,19,-30,-35, 
  /* [103][0][][] */ -25,-44,-61,77,-51,-21,-116,-112,55,91,115,-73,-17,104,-71,-31,-127,-58,-88,30,-1,-23,-73,-3, 
  /* [104][0][][] */ -29,74,-37,-46,2,58,-50,17,-25,-18,-78,23,2,55,-14,-16,98,15,47,-41,26,27,-127,16, 
  /* [105][0][][] */ 127,-10,17,-20,-82,70,10,50,43,-37,-49,-113,-65,-43,83,90,-8,80,-83,50,-92,-52,116,-10, 
  /* [106][0][][] */ -26,-2,-53,76,30,-23,-33,38,4,-40,-5,53,-40,127,9,-61,62,-14,9,13,-29,-5,-84,48, 
  /* [107][0][][] */ 121,-127,-25,-94,56,-50,29,62,56,-2,-22,-14,59,-74,37,16,50,-7,51,30,-66,21,-51,-78, 
  /* [108][0][][] */ -90,-96,-97,19,10,12,9,-13,52,7,127,-20,-17,-13,-42,-9,-27,14,-4,24,-50,48,47,2, 
  /* [109][0][][] */ -51,-41,85,8,44,26,6,95,-116,-24,38,127,-29,-36,-55,72,92,-36,-8,-91,102,12,2,69, 
  /* [110][0][][] */ -95,-55,-127,87,78,-68,-33,47,2,21,72,11,-41,28,-44,28,-42,-101,-125,-73,38,3,71,-58, 
  /* [111][0][][] */ 53,12,-107,25,-9,13,59,-11,-44,-25,111,-15,10,-103,-73,125,-78,14,7,-56,-83,-12,68,-127, 
  /* [112][0][][] */ -41,-127,-35,19,69,-74,10,-35,27,-32,48,21,48,-71,-10,48,-92,-60,24,-105,-82,86,-41,12, 
  /* [113][0][][] */ -127,42,-15,37,-4,17,-82,-70,90,-18,78,101,117,13,-13,-94,11,124,-35,37,66,-7,-122,47, 
  /* [114][0][][] */ -84,47,-118,30,-28,15,-61,-30,-127,5,-68,7,-123,-14,49,-39,1,37,-91,-16,-57,-27,-116,-53, 
  /* [115][0][][] */ -27,32,-61,-35,8,-50,31,64,0,8,-122,127,-93,62,8,17,-31,102,-18,-93,5,6,4,-16, 
  /* [116][0][][] */ 7,-82,-10,34,3,-69,15,32,-52,52,127,18,22,7,-48,68,-61,29,-59,-74,-80,-83,56,5, 
  /* [117][0][][] */ 14,28,-103,-48,127,-15,80,75,-25,1,-15,-44,58,-35,28,9,-55,8,121,39,22,-49,0,27, 
  /* [118][0][][] */ 22,92,98,-19,8,10,-9,69,-11,-7,24,56,-19,-86,127,4,-31,-26,-9,10,95,46,-18,40, 
  /* [119][0][][] */ -60,-97,-34,35,-118,110,-6,-52,4,49,92,8,-62,-97,-113,4,-28,127,-115,-12,28,-35,-10,14, 
  /* [120][0][][] */ 86,-22,-39,77,10,-118,-76,62,-16,-39,20,-127,27,5,67,117,-37,-31,65,-23,25,-31,63,-22, 
  /* [121][0][][] */ 76,21,-63,-2,-22,-28,-13,-51,40,-8,25,-110,-11,-30,-75,-37,42,-127,2,0,4,37,0,-41, 
  /* [122][0][][] */ -67,-80,-33,29,-68,127,-15,-25,-36,53,-44,-75,70,28,-17,19,-14,8,44,-25,-8,53,72,1, 
  /* [123][0][][] */ 35,-44,-107,-2,-83,64,82,24,-6,35,25,-127,55,-36,-58,-10,-44,58,26,58,-82,15,3,-28, 
  /* [124][0][][] */ -19,35,-50,73,69,-65,-59,-44,-63,-127,21,-59,16,-80,-49,73,13,29,-40,39,21,35,13,55, 
  /* [125][0][][] */ -48,88,-29,-83,5,-48,19,-41,14,-19,-53,-43,-34,6,-3,82,127,24,43,-105,-38,-12,17,-18, 
  /* [126][0][][] */ -31,-25,62,116,62,6,-43,-70,36,3,77,68,19,121,75,6,127,-21,7,57,79,32,76,25, 
  /* [127][0][][] */ 64,8,108,-127,6,35,52,-33,48,68,-16,-38,-105,-17,-16,14,-50,-12,-10,-60,75,5,-2,27, 
  /* [128][0][][] */ -24,-20,-82,-127,60,-58,-46,6,-27,83,-52,-22,-46,111,101,7,104,-3,14,108,-92,-9,45,-5, 
  /* [129][0][][] */ 71,39,-45,66,29,28,21,-10,-5,-71,66,88,16,73,11,127,34,45,-44,-96,56,-14,50,36, 
  /* [130][0][][] */ 48,127,12,-76,69,-76,0,-74,-40,-62,-4,23,28,-43,14,55,-41,19,43,-30,-5,-18,66,0, 
  /* [131][0][][] */ 69,-124,-50,-63,-54,85,55,37,-75,-127,2,109,-59,-18,60,-78,26,-103,2,10,46,88,48,67, 
  /* [132][0][][] */ -2,-61,-38,-111,81,-20,31,71,-116,24,-36,-35,19,-113,100,-27,39,127,52,-19,-3,2,-43,40, 
  /* [133][0][][] */ 27,8,49,-6,36,8,-42,-16,42,3,54,-19,-15,-2,-83,12,-17,22,-127,-47,-48,-45,-72,30, 
  /* [134][0][][] */ 46,-23,11,-85,-27,-31,70,-13,-39,5,22,1,-12,-76,-19,104,-59,-64,61,3,-24,-10,127,-47, 
  /* [135][0][][] */ -39,-22,-63,-72,-30,-32,31,54,14,-75,14,-66,-5,80,-127,-29,104,100,90,51,-83,69,-9,-63, 
  /* [136][0][][] */ 30,16,-58,-67,-20,52,79,26,-6,39,100,-65,-58,-127,46,-20,-14,21,-18,-40,16,-15,-75,-106, 
  /* [137][0][][] */ -54,88,4,-109,56,24,-20,-43,19,16,-3,-83,-18,54,-8,87,2,15,21,-127,-4,-56,-35,24, 
  /* [138][0][][] */ -19,-15,-41,-27,-13,-2,-4,7,40,-35,-51,-29,-32,127,38,-81,64,46,-9,58,-27,10,-29,22, 
  /* [139][0][][] */ 55,127,-6,-80,-11,46,79,-68,-16,2,-53,-50,-72,20,31,43,77,-27,47,72,-43,28,86,-21, 
  /* [140][0][][] */ -5,-45,87,-11,-95,34,-60,94,15,95,103,-94,38,-58,-127,28,120,-102,44,108,93,-93,-61,87, 
  /* [141][0][][] */ 46,127,26,-107,61,-79,-46,-84,-27,-16,-45,41,15,-27,-16,74,-4,-12,62,-76,15,-10,47,-13, 
  /* [142][0][][] */ 44,-89,112,-15,1,-72,-100,99,25,6,53,-33,-91,3,127,-15,-19,47,27,56,-98,0,-63,-57, 
  /* [143][0][][] */ 39,-81,9,-31,-2,40,-5,2,23,62,-58,-22,-25,66,-96,-61,51,13,-25,-36,-1,-64,-73,-127, 
};
const TfArray<4, int> tensor_dimension59 = { 4, { 144,1,1,24 } };
const TfArray<144, float> quant59_scale = { 144, { 0.0014233553083613515, 0.0013849005335941911, 0.0019520645728334785, 0.0021434410009533167, 0.0018846035236492753, 0.0015611667186021805, 0.0027584144845604897, 0.0017792086582630873, 0.0019105437677353621, 0.0017143340082839131, 0.001637563924305141, 0.0022410678211599588, 0.0016006556106731296, 0.0016273027285933495, 0.0018705989932641387, 0.0014957258244976401, 0.0015805658185854554, 0.0013458456378430128, 0.0025092100258916616, 0.0016917700413614511, 0.0017220925074070692, 0.0020311630796641111, 0.0012433720985427499, 0.0019045766675844789, 0.0014328234829008579, 0.001953719649463892, 0.0015438819536939263, 0.0019545077811926603, 0.0012356120860204101, 0.0018719134386628866, 0.001924762618727982, 0.0018503086175769567, 0.0013628870947286487, 0.0022411826066672802, 0.0024435576051473618, 0.0019963511731475592, 0.0021498491987586021, 0.0019120735814794898, 0.0016011648112908006, 0.0023284622002393007, 0.0034767792094498873, 0.001469874638132751, 0.0018016810063272715, 0.0015066306805238128, 0.0014323324430733919, 0.0025007373187690973, 0.0016894063446670771, 0.0020377589389681816, 0.0013554919278249145, 0.0015479790745303035, 0.0011225368361920118, 0.0017554134828969836, 0.0019625001586973667, 0.0023996706586331129, 0.0012989480746909976, 0.0019308169139549136, 0.0013675786321982741, 0.0013672912027686834, 0.0017969786422327161, 0.0023372755385935307, 0.0020143173169344664, 0.0021016537211835384, 0.0014916862128302455, 0.003118244931101799, 0.0028517816681414843, 0.0017720259493216872, 0.0019006634829565883, 0.0020274666603654623, 0.0019212928600609303, 0.0020984073635190725, 0.001607390702702105, 0.0016238215612247586, 0.0014648694777861238, 0.001971548656001687, 0.0022827254142612219, 0.001992411445826292, 0.0012699777726083994, 0.0014832516899332404, 0.0015275899786502123, 0.0015720693627372384, 0.0021508361678570509, 0.0019254981307312846, 0.0018833647482097149, 0.0015918132849037647, 0.0016861546318978071, 0.0015106040518730879, 0.0024793141055852175, 0.0025180266238749027, 0.0013671248452737927, 0.0014717798912897706, 0.0013856710866093636, 0.0015391143970191479, 0.0021505090408027172, 0.0016636762302368879, 0.0015642807120457292, 0.0012495345436036587, 0.0014261701144278049, 0.001334667787887156, 0.0023845348041504622, 0.001994298305362463, 0.0014133155345916748, 0.0020307309459894896, 0.0028764309827238321, 0.0013104390818625689, 0.0017027017893269658, 0.0014267807127907872, 0.0019385806517675519, 0.0018558085430413485, 0.001715761492960155, 0.0012199127813801169, 0.0014843638055026531, 0.0013267273316159844, 0.0014237022260203958, 0.0011609394568949938, 0.0018344142008572817, 0.0012792054330930114, 0.0015796686057001352, 0.0021312781609594822, 0.0016792939277365804, 0.0013643804704770446, 0.0017254286212846637, 0.0019644377753138542, 0.0017362289363518357, 0.0015667596599087119, 0.0020023963879793882, 0.0015344319399446249, 0.0016167074209079146, 0.0020776272285729647, 0.001809675944969058, 0.0021401157137006521, 0.0022895208094269037, 0.0018866994651034474, 0.0018686825642362237, 0.002150094835087657, 0.0012453504605218768, 0.00146812095772475, 0.0020280093885958195, 0.0016683951253071427, 0.0016465451335534453, 0.0017460371600463986, 0.0010831886902451515, 0.0017196788685396314, 0.0015640635974705219, 0.0015418849652633071, } };
const TfArray<144, int> quant59_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant59 = { (TfLiteFloatArray*)&quant59_scale, (TfLiteIntArray*)&quant59_zero, 0 };
const ALIGN(8) int8_t tensor_data60[24*1*1*144] = { 
  /* [0][0][][] */ -41,-18,14,-24,-46,-25,49,-50,53,-42,-2,-13,71,113,13,-47,7,-42,-2,-53,-29,-3,6,68,-94,1,-18,74,-127,-119,-31,-69,43,-32,-37,44,10,31,24,-33,-28,2,24,-34,-31,-27,18,35,0,-77,79,-42,42,42,-43,-7,20,-97,-39,-54,-98,-2,-32,-28,86,-1,18,-10,48,-31,-37,47,-43,-11,-29,-11,-39,22,-75,26,14,85,14,7,-17,26,2,70,-44,-51,72,-40,-3,24,-9,30,-59,25,21,9,-10,9,78,-27,-33,-12,-4,-22,7,-34,21,-24,14,31,-12,11,-30,-51,-35,-14,60,28,39,-50,30,1,12,-1,-12,-50,31,-36,-27,-65,84,-31,3,114,44,-30,-19,-7,8,-12, 
  /* [1][0][][] */ 90,-24,51,39,21,39,3,-11,-113,-30,17,42,9,-18,-36,-26,-36,1,-5,-50,-29,100,50,21,94,122,-17,12,-36,101,70,69,-59,9,50,15,-16,97,76,-40,-47,1,52,-79,97,-42,-42,42,0,-78,8,-29,-51,-58,3,8,-16,33,45,-23,27,15,11,-13,7,5,17,2,-25,28,-39,78,51,-16,-27,19,17,-5,-39,49,-58,-96,-39,3,7,-127,-14,58,116,-6,92,7,6,-46,0,63,-47,-37,-57,-23,0,-9,-16,-22,1,38,26,9,22,37,-23,28,-51,23,-15,14,-41,18,121,48,-72,32,-38,103,8,30,-23,-105,-41,-13,-31,-17,17,53,13,35,-85,-37,-11,-20,41,-24,-15,25, 
  /* [2][0][][] */ -77,91,49,-63,14,27,-4,21,-61,-9,-84,-33,-25,44,-49,-54,-82,-19,25,67,-88,-30,12,25,2,-24,-21,-31,3,26,3,68,-10,-41,-4,-13,-75,18,77,82,4,18,-61,-49,-2,73,3,2,-41,40,-37,-99,-23,-46,9,51,60,47,-12,43,38,-79,-32,-38,-68,-12,-18,10,20,27,114,49,-4,-81,35,-20,42,13,-94,-19,-13,63,-61,17,-14,-105,-5,31,-27,68,-9,-8,30,-18,31,76,27,48,19,44,78,23,-28,3,11,-75,-10,-93,127,67,78,-24,-85,31,43,22,-9,-43,-38,50,-24,9,-57,81,-13,14,-23,20,59,23,55,-1,-24,-10,-26,-51,-33,-13,17,19,-21,62,-5,-77, 
  /* [3][0][][] */ -8,8,-61,-41,47,27,-57,113,5,23,-53,40,-89,101,-40,-24,-82,8,-24,16,29,-45,56,-4,-29,-13,33,-4,83,-4,34,-20,127,64,13,-66,80,-42,-20,49,76,-14,-68,-25,18,47,-43,24,-41,36,5,0,-32,3,39,-8,3,-51,14,46,32,-31,12,41,-46,-43,-17,-10,-10,-16,38,-41,-53,8,33,51,-9,-64,48,-17,-45,-40,-7,-14,33,22,-13,-52,12,30,7,37,37,6,-17,40,-18,-8,74,30,-43,-20,14,-32,-37,-24,-31,-18,54,10,-36,0,-70,-26,37,-47,-42,-6,-57,-27,28,-13,-71,-14,52,34,-4,-3,54,29,-11,-68,20,-3,-117,-64,23,69,-1,41,-50,-35,30,-22, 
  /* [4][0][][] */ 47,-4,16,92,24,-24,19,-51,-34,-19,71,16,23,-25,-5,-74,-47,54,-25,-48,37,-40,-28,-30,-9,-13,-38,56,50,6,-27,-15,5,20,14,68,8,49,59,-15,-11,14,-50,-23,-42,-34,0,4,-57,-24,-24,15,39,9,-42,-28,-33,-1,52,-98,-73,-1,-34,4,37,-29,47,-70,-127,-36,-50,-1,-63,48,-36,-1,-16,8,37,37,-36,-17,63,55,65,22,88,14,-11,-18,23,-27,6,-58,5,41,-80,27,2,-10,64,-3,-17,5,23,43,12,13,27,81,-69,3,-3,43,-56,-50,-82,-13,11,58,-7,44,32,56,12,-15,-30,-14,-57,80,-4,70,3,43,76,38,-72,30,5,-21,-23,-17,-13,64, 
  /* [5][0][][] */ -47,-95,-35,-65,77,13,-79,-13,-93,-39,-21,-35,-81,35,-50,-32,-9,-60,-14,-14,-32,-69,-37,-8,-13,-22,-30,32,-20,24,-39,24,-95,-31,-5,-19,-51,-32,50,15,83,-69,-49,-85,42,8,-49,1,-22,36,-106,-2,-50,-16,1,92,-74,98,9,82,-25,-42,-37,-13,-17,-31,-10,-19,45,79,68,-49,-19,-59,52,11,-126,-46,50,44,10,20,39,-46,57,31,12,-17,3,0,23,75,-45,90,-71,90,-65,-78,10,-8,13,-44,32,0,-22,56,-10,-41,-3,-16,58,-10,9,-70,39,-121,27,-23,33,-70,15,35,-96,-28,15,10,28,52,16,6,14,-41,6,-9,3,-29,-9,-50,-30,89,-127,88,34,-9, 
  /* [6][0][][] */ 71,-45,-13,40,-9,25,-43,-4,-14,25,-22,-29,4,2,83,66,-45,61,5,-73,-29,-51,28,-12,31,-37,-2,-29,-20,-26,4,22,40,-42,-67,39,-55,5,59,5,-13,71,3,-39,-19,-18,8,-17,-31,16,-89,73,-127,-48,66,34,21,-47,0,106,-24,1,13,-48,-27,-78,55,-26,94,-39,19,85,115,118,76,38,-52,3,32,-2,28,-24,-47,28,50,-108,47,-27,-18,24,21,-66,-33,-19,44,-29,-64,9,-20,-38,-52,-39,-59,70,9,10,14,-9,26,12,52,10,-31,-9,-125,-95,53,16,-58,10,-81,-12,75,-16,55,47,-102,-6,-24,47,6,-3,-49,40,83,73,12,25,42,28,-88,-5,6,-24, 
  /* [7][0][][] */ -46,-89,-56,24,-51,-60,-68,-26,64,-96,15,35,39,-36,-22,-43,30,20,7,-1,-23,5,24,50,-17,-14,39,44,47,-50,15,32,-12,-27,-31,-44,-12,-73,24,-7,33,-51,-41,-3,29,12,-91,40,12,32,-49,32,36,58,3,35,-36,15,-38,34,3,-27,16,-7,-15,12,-31,10,29,35,16,-10,-16,-46,16,44,-12,56,-10,47,43,33,2,-61,-18,1,60,-30,-27,28,3,47,-34,18,-100,18,-24,-127,0,55,5,-41,22,13,48,33,-48,-14,-65,2,63,3,23,-38,-59,-83,91,-23,-11,-47,41,2,-53,9,-28,71,-13,-24,7,-55,-3,18,13,-71,-1,-8,32,65,-78,-35,-85,31,-30,-47, 
  /* [8][0][][] */ -23,43,34,-38,-17,-64,10,51,-15,56,-53,19,-26,-29,-5,-23,19,-1,65,72,15,25,-5,-8,-93,107,31,-29,-24,-41,25,47,-97,29,-27,52,-28,84,10,44,56,-56,2,-29,6,64,84,47,-35,-46,-11,-61,-9,51,-32,64,86,45,57,-28,-29,-11,-12,-44,23,9,-27,-52,-50,36,-48,84,-93,10,71,12,-51,-18,104,-1,67,6,-13,40,75,-82,16,-43,-43,85,54,-44,-16,9,41,39,-62,70,24,15,40,24,8,-75,23,-127,-23,-119,41,-8,-1,-44,-112,31,3,41,76,-52,-97,-6,29,-8,67,-16,15,-54,31,98,19,27,119,5,-19,-45,-32,28,3,-74,54,5,10,112,50,-23, 
  /* [9][0][][] */ -18,-26,-50,-36,-2,-20,3,-50,1,-17,39,3,-31,34,-3,10,-12,80,58,-30,-77,-12,-34,20,-38,-22,21,-37,-86,-10,-20,49,34,-30,-16,-18,47,-36,-19,-50,43,9,41,33,0,9,-23,38,-20,16,-127,-7,45,6,-1,9,-64,-60,-27,43,-17,45,-14,21,24,-51,-15,40,-2,-6,-74,5,11,3,-30,-33,-48,-20,-13,24,69,29,-1,8,59,57,-20,-11,28,11,-28,-33,-20,-2,1,36,27,35,-9,2,-20,-57,27,30,-39,20,10,-13,8,-11,-24,5,-37,14,-51,50,-3,-22,33,-35,6,15,-31,-22,2,-14,19,-74,1,11,-25,9,1,-62,11,-1,-9,55,40,-12,6,23,-96,27, 
  /* [10][0][][] */ -19,16,-50,-40,0,-23,-14,20,19,-14,-64,3,-8,-35,-25,3,-24,-6,51,88,4,-71,-6,11,-22,16,-15,10,-100,27,-48,-33,-5,-28,-38,3,59,2,-11,13,1,-86,-49,-42,52,9,-49,23,-22,14,39,-66,-5,26,30,49,3,-42,25,17,-22,-44,30,-66,24,-111,-29,11,-40,123,41,91,-50,-66,-25,39,-29,24,-3,-23,55,17,-38,-31,52,-63,30,15,-9,-64,-48,44,-19,38,-24,-79,5,-96,48,-40,-30,-57,77,7,-127,-21,-33,-25,-38,-13,-66,-5,-5,-47,-18,-32,-21,-32,8,-48,0,44,-27,14,-35,-10,30,12,19,21,29,-12,32,-49,-81,-29,71,3,17,39,-82,55,25,-53, 
  /* [11][0][][] */ 23,54,21,-32,24,22,38,36,-9,43,-47,3,21,48,-27,10,-32,-11,-52,56,-26,-8,6,17,23,23,-58,-29,-10,16,-16,2,34,-7,9,11,-32,14,7,15,-8,28,18,26,11,4,54,5,16,-76,-15,23,5,13,62,-42,20,-60,-11,-17,-31,-55,51,53,35,-46,-54,-15,24,-15,36,-18,32,43,52,-127,41,1,-8,-6,30,1,-19,0,-45,7,24,-14,-38,-33,10,-28,20,43,24,-32,-9,5,-12,-24,-5,17,19,-13,43,7,6,29,-4,-44,-39,9,-46,-32,52,61,7,36,38,13,-66,-61,49,-23,-17,27,-13,-6,12,0,-5,-3,-6,-9,-17,-58,-44,38,23,24,69,-45,-13,-76, 
  /* [12][0][][] */ -11,-51,53,14,1,-36,-74,-26,-84,-30,57,-33,-23,-27,27,25,-41,92,62,112,37,-12,-71,-57,-15,-45,-55,38,48,-11,-47,-62,-3,3,-20,-19,26,-23,22,68,-19,-69,-29,-127,36,32,-33,43,75,34,62,16,-42,-37,27,48,40,56,66,29,51,23,57,-79,-62,20,-17,39,28,49,36,-27,-39,7,3,17,30,53,-25,7,-66,-79,45,14,33,-26,-27,4,70,40,-15,9,-77,-3,15,99,32,-71,-73,-3,100,-69,-1,-51,35,44,-21,-14,34,16,-28,40,-28,-34,-58,-75,-49,24,-4,37,-33,-37,18,57,-20,5,4,-28,44,-17,85,46,-50,21,11,0,-14,33,46,-30,-34,46,7,13, 
  /* [13][0][][] */ 51,-70,-86,1,76,-61,-37,-32,-24,-69,27,-60,-50,-18,-65,64,97,-50,13,10,21,-71,-24,29,-56,-54,-127,-40,34,1,47,13,-2,-88,-50,-38,28,-103,40,-24,-6,2,33,-46,-38,21,-41,-2,-64,-1,-28,-17,21,20,-35,45,-111,13,6,-44,41,-26,-12,45,-44,-102,-14,-20,12,-1,-74,-38,-68,39,-14,11,-68,10,5,51,30,108,21,-49,39,59,7,-17,2,5,15,13,-23,21,-57,60,30,-126,4,30,-66,-52,44,-73,47,73,-43,17,-54,-29,-58,-9,-58,-110,-7,-92,-13,-12,6,9,103,11,-36,-41,22,9,-62,52,-50,18,-20,50,80,-19,42,58,79,-28,-123,-43,-54,70,-4,65, 
  /* [14][0][][] */ 33,-25,-17,-74,-7,-74,21,26,57,32,6,96,32,43,2,29,6,5,-27,-67,-41,-14,-11,-64,-9,-31,26,-1,8,-92,35,10,-9,-26,46,-19,-22,-49,-3,5,0,-51,36,89,-44,-22,-16,-116,-24,27,35,-63,24,10,-4,-50,-67,-28,-12,-22,62,52,-4,31,-67,-1,-42,11,25,-67,9,36,-13,40,-6,-10,-35,-66,39,-78,40,72,-53,-21,-17,-11,-22,-33,-57,121,-29,29,14,38,-22,-88,-6,40,-49,-30,-23,9,-23,75,-10,-33,-44,38,6,-78,51,-86,35,29,47,52,42,70,-70,-8,52,-127,-11,-26,-77,10,-43,20,-20,6,-75,59,-25,-1,-28,-51,44,64,-7,57,22,-69,-37,19, 
  /* [15][0][][] */ 27,9,-6,35,-47,-26,23,-7,127,-16,21,8,-12,-17,-32,-12,-11,68,14,20,66,21,0,0,-99,-4,-99,62,-15,53,104,-3,29,29,33,28,-19,31,69,0,-80,82,52,-72,-16,-6,40,38,-14,-110,89,52,-76,-56,-22,-22,-93,26,-17,-2,-12,24,22,86,-47,114,-7,-45,56,57,-12,-1,-22,-21,-50,8,-7,-15,11,16,-51,-2,-10,-21,-3,-52,8,3,12,44,5,14,19,-30,35,51,-32,62,-22,22,17,-9,-80,16,-34,28,73,-16,18,-8,36,66,-24,49,-46,33,-112,16,-27,-7,64,30,-3,31,34,73,38,-50,31,78,-43,49,18,43,20,22,-25,-34,-2,-21,-7,-63,-42,22, 
  /* [16][0][][] */ 27,5,43,75,73,-48,53,-7,-59,21,-48,46,26,19,-5,-60,-18,82,-27,22,6,-50,-64,89,68,-8,39,-18,-13,-48,85,-20,-33,-22,-12,-33,27,35,-1,-11,12,-29,15,46,13,45,16,-25,-5,-51,-24,-16,37,19,66,62,32,48,47,46,23,18,32,-19,-32,34,-63,9,-46,-53,9,-72,18,-42,-64,39,-26,-37,-19,127,-33,-46,-17,12,35,84,7,2,-6,-39,50,34,-1,36,31,-24,-71,63,-14,59,-10,39,19,77,96,25,-84,-46,58,-17,9,-88,23,46,-71,-9,-10,33,-4,21,-50,23,-58,59,-11,4,-42,-21,-5,-2,7,20,33,-25,-21,21,-13,-33,-7,78,-34,29,-53,-26, 
  /* [17][0][][] */ 5,21,20,-18,5,9,-3,26,-44,30,52,20,61,-36,-13,-65,-35,-33,0,51,-40,-40,100,-88,-52,-48,33,64,29,4,-13,60,-31,65,-17,48,43,54,67,-52,-51,-64,-89,2,24,42,25,112,-2,-66,-35,-36,13,26,-20,10,9,13,-58,-22,-22,35,-44,-34,30,58,0,-7,-26,-5,-29,-13,-63,-9,17,13,50,-33,-13,31,-41,-32,36,-62,-5,-48,29,0,44,-48,-79,24,1,16,-33,123,15,8,-49,15,73,26,3,4,-74,-4,-43,-26,28,21,20,-19,6,-65,-6,17,-70,36,66,-53,-18,-71,13,34,-32,15,22,14,-7,49,47,31,-53,14,-33,40,-2,7,-11,51,64,65,-23,127, 
  /* [18][0][][] */ -11,28,-3,-1,66,30,9,97,-32,47,-10,-24,62,6,-93,67,-24,102,1,-13,15,122,74,-2,-35,-45,54,76,-30,48,47,14,54,83,13,15,-33,69,-57,118,-105,63,-13,5,-35,37,69,13,-63,27,-7,-45,42,3,-8,-49,-22,48,48,-116,-25,-24,23,-13,71,85,-37,-6,-91,43,44,-31,-64,-39,-26,2,55,-79,-10,24,-7,-10,28,-60,-36,25,21,-7,24,11,25,-39,124,41,-29,30,-41,39,-77,-38,-18,15,-23,-37,82,-3,-24,-28,41,2,90,35,111,25,8,77,-35,10,-15,44,59,-6,32,28,44,64,-7,-106,13,-28,26,78,-3,127,3,23,39,6,-49,-5,85,22,-59,-14, 
  /* [19][0][][] */ 34,25,17,18,55,43,-12,31,-12,23,-11,127,13,-9,7,16,-85,43,-36,37,-3,94,-29,11,25,45,6,-37,30,-34,38,36,113,-6,52,-1,-6,18,-23,-87,24,21,1,76,36,21,23,-72,-14,12,49,26,-2,-14,-7,-28,22,-32,11,-10,21,16,-6,30,-62,19,13,50,-10,-38,11,-24,-3,14,56,-60,12,-15,15,-30,-20,62,-57,27,-4,-6,-3,32,9,48,-36,-35,-16,14,15,-11,-53,50,-33,40,-30,62,-4,15,-7,-13,-13,-25,4,-7,66,-10,-9,-5,3,-18,91,25,18,4,29,-22,16,5,-81,27,-23,73,29,21,-12,-21,-20,8,21,0,94,76,-19,-18,-8,-68,43,-28, 
  /* [20][0][][] */ -3,25,3,30,20,-5,33,-30,43,43,-22,26,-37,-24,-10,-68,22,7,3,-7,12,-86,-23,-10,-30,12,2,-49,-45,-4,-11,54,-37,-16,4,0,7,-21,-29,-31,53,-43,-61,-21,26,20,7,-23,19,-2,-2,36,-12,19,28,-11,42,-21,-38,4,-33,-5,57,-31,-11,3,11,-18,-32,36,-33,48,-72,-51,32,-24,-14,21,15,-38,23,-62,-54,41,8,-56,-19,-7,11,1,-34,-24,3,1,8,-1,34,18,35,17,-34,58,-10,-2,19,-24,-17,-11,28,-7,13,-7,33,-26,-32,53,127,-11,-6,10,28,9,-32,4,-59,-54,-6,25,13,15,37,-5,10,-3,6,-34,4,16,38,-3,17,38,-7,-10, 
  /* [21][0][][] */ -33,-37,-45,12,35,12,15,15,46,-15,45,-60,-10,-74,4,32,-30,-53,4,84,-61,-72,27,48,47,9,18,-42,98,12,20,33,88,20,-6,11,-14,1,31,51,-55,-1,66,32,-14,-30,5,19,-31,-12,1,-100,-32,-48,-53,-38,-50,-7,6,-4,-52,-72,-44,26,18,38,-44,-53,-38,41,-41,-27,-2,26,-26,-57,82,-27,59,-33,-42,25,29,-69,-8,2,6,-8,60,-33,17,16,-10,38,-24,-61,49,8,90,26,61,-26,-23,26,127,-3,37,15,-15,-41,38,-8,-10,-4,-7,-4,-46,-64,-14,9,-15,76,64,20,-9,70,52,-29,-29,-46,-21,-14,20,79,27,55,-14,62,-47,-1,44,-61,54,43, 
  /* [22][0][][] */ 21,-5,40,71,57,69,-7,47,19,13,-101,83,45,10,-65,-17,-39,-15,-31,-71,-34,-18,16,-6,-13,52,-40,-30,-26,-6,7,41,-21,20,-18,25,-33,5,52,-47,-49,29,9,-9,47,-25,-15,-44,39,-127,105,0,-44,-31,14,-36,19,32,-62,0,9,78,-3,-41,10,-31,-4,13,-33,-73,8,61,7,-2,0,-32,65,11,-14,-6,-12,-5,26,57,9,-50,-73,60,90,11,62,-54,-38,14,34,-80,-68,-16,-31,-36,76,16,-4,11,7,41,41,12,-28,49,-17,21,28,66,-32,12,-37,73,83,-6,-43,-40,-23,39,3,112,-79,-61,-40,37,-47,28,-82,36,56,-33,-62,-32,19,43,69,-98,-58,-61, 
  /* [23][0][][] */ 46,-67,2,-29,-39,72,-28,-3,-16,-58,26,-25,59,-4,74,-121,17,70,-29,-52,44,-19,13,6,-8,-1,10,7,-40,-59,77,82,48,-7,-15,45,-42,4,-115,-81,9,-17,48,58,-58,-69,-5,-15,46,-49,1,-23,-127,-36,29,-48,-38,-15,-28,-37,80,25,-17,76,22,10,13,21,82,-92,-34,74,-42,126,44,8,-5,-6,45,-19,-14,30,20,2,-2,-1,-10,-28,-7,29,56,-9,25,-64,-2,-70,55,-40,-46,-59,64,14,-56,-42,-51,-27,35,82,-70,73,65,-23,-77,-12,-60,-8,29,27,9,-24,-58,7,85,0,9,2,-20,39,-44,-31,-44,-2,-1,28,47,37,-58,11,17,-102,-12,-33,76,12, 
};
const TfArray<4, int> tensor_dimension60 = { 4, { 24,1,1,144 } };
const TfArray<24, float> quant60_scale = { 24, { 0.00142294866964221, 0.0015400830889120698, 0.0015049620997160673, 0.0016913932049646974, 0.0020907176658511162, 0.0015638561453670263, 0.0012238885974511504, 0.0019834563136100769, 0.0018821508856490254, 0.0014013737672939897, 0.0017317302990704775, 0.0019644503481686115, 0.0014711944386363029, 0.0016354456311091781, 0.0013741066213697195, 0.0016663079150021076, 0.0012717866338789463, 0.001439830637536943, 0.0013425915967673063, 0.0018405248410999775, 0.0021053978707641363, 0.0014418354257941246, 0.0015478740679100156, 0.0014987792819738388, } };
const TfArray<24, int> quant60_zero = { 24, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant60 = { (TfLiteFloatArray*)&quant60_scale, (TfLiteIntArray*)&quant60_zero, 0 };
const ALIGN(8) int8_t tensor_data61[144*1*1*24] = { 
  /* [0][0][][] */ 107,51,-49,-51,-94,-14,0,10,15,-17,18,-127,29,-18,-87,-20,32,-56,1,115,-7,-31,-66,40, 
  /* [1][0][][] */ -10,55,-71,-70,-35,-29,55,-9,14,-60,52,90,114,25,-35,34,-10,-22,127,-65,-64,7,75,-40, 
  /* [2][0][][] */ -111,-16,-2,-104,-21,51,74,-50,26,-115,127,3,-3,69,-22,-21,45,-47,-16,-119,-90,21,25,60, 
  /* [3][0][][] */ -6,1,-19,43,-30,93,70,52,-8,115,-15,51,43,-51,55,-40,-17,-80,55,33,10,127,36,-32, 
  /* [4][0][][] */ 21,-102,127,-5,-35,9,-16,45,-86,-41,-10,-14,73,75,75,-46,59,39,-107,-85,-42,37,-65,-27, 
  /* [5][0][][] */ -42,82,-72,-49,-71,118,-5,53,27,-17,-67,8,66,-26,127,-117,94,-33,16,-16,-37,-35,-53,10, 
  /* [6][0][][] */ 57,-127,-112,-50,71,-69,-31,-56,-7,104,-8,-48,15,90,-33,-104,-54,-1,72,-10,-34,-59,54,83, 
  /* [7][0][][] */ 72,-69,36,8,49,1,-73,-69,-66,13,61,-120,-56,127,-36,28,-1,1,-113,34,14,52,34,9, 
  /* [8][0][][] */ 34,-42,-7,4,27,25,78,-62,-24,41,28,-23,-43,58,-42,19,-60,5,-101,-74,-127,19,12,27, 
  /* [9][0][][] */ 42,-60,28,-27,-11,-29,-1,-12,1,52,16,-49,-52,-127,9,75,-49,4,22,66,-5,-41,67,68, 
  /* [10][0][][] */ -52,6,-60,66,-46,127,70,-25,-43,52,70,20,70,-65,-17,89,72,-59,97,-90,64,80,122,50, 
  /* [11][0][][] */ -2,6,8,54,24,20,17,-53,28,-76,-36,-63,20,81,1,-35,127,-93,-65,-67,29,0,4,-42, 
  /* [12][0][][] */ -69,-20,-18,-37,-12,-71,127,98,13,26,48,49,51,0,44,39,-50,-80,-19,22,20,-15,38,-15, 
  /* [13][0][][] */ 84,49,-77,-61,9,28,-61,-66,-71,16,-118,20,-69,87,88,-55,83,14,81,109,-55,17,-42,127, 
  /* [14][0][][] */ -21,121,42,-52,-78,45,18,-77,45,23,57,-127,61,-118,-3,-16,-11,-16,112,32,44,-118,-76,51, 
  /* [15][0][][] */ 39,-58,-57,-45,-25,15,2,13,-57,-10,-24,40,37,-63,53,59,74,-33,-61,-20,127,66,3,117, 
  /* [16][0][][] */ -37,82,34,17,-38,-7,-23,59,20,-6,-60,95,-90,-67,7,-127,119,-10,78,45,124,-5,-84,27, 
  /* [17][0][][] */ -25,-3,-54,82,-28,47,-24,-1,86,-27,52,-23,-127,-46,21,-49,33,-9,24,62,24,42,-85,6, 
  /* [18][0][][] */ 53,-42,127,-65,22,-23,-70,22,-24,-19,37,43,23,27,-31,11,16,-54,-30,-73,33,2,-48,-12, 
  /* [19][0][][] */ -40,74,-9,-47,-14,-90,10,34,-46,-50,-102,12,-68,-56,117,-3,-35,-44,-98,127,-36,-47,29,8, 
  /* [20][0][][] */ 3,96,-48,-55,22,-75,119,53,-127,1,-70,28,25,-32,2,26,12,-98,59,34,100,38,63,-6, 
  /* [21][0][][] */ 54,62,-58,24,-33,-7,19,11,-87,113,38,-29,76,-21,11,29,60,-89,59,5,-19,-2,-19,127, 
  /* [22][0][][] */ 52,-50,87,-70,-13,39,-102,3,-57,0,-107,-26,-89,75,-73,54,127,46,-95,-14,34,11,-36,-26, 
  /* [23][0][][] */ -19,-42,-78,-39,18,72,23,0,-39,60,11,-5,93,-48,-33,45,79,-35,1,26,31,-5,39,127, 
  /* [24][0][][] */ 0,94,-46,-51,111,-51,-89,60,-5,-5,-127,43,104,11,99,15,-31,64,85,24,59,-21,23,64, 
  /* [25][0][][] */ 25,-30,-24,-51,-23,-25,119,47,87,127,-45,-58,-49,60,-25,47,-55,122,124,83,60,-117,-84,-40, 
  /* [26][0][][] */ 102,-27,-28,45,46,45,-38,-86,-97,-24,-35,-127,28,-99,-72,102,127,41,-124,-121,48,9,-38,-59, 
  /* [27][0][][] */ -34,44,-16,18,19,-13,64,5,62,-30,4,77,56,-9,-25,35,44,10,-9,31,3,-127,-1,-77, 
  /* [28][0][][] */ -4,-29,48,81,-3,30,-127,-61,-9,-3,7,-75,-25,20,-83,-53,9,52,-1,60,55,36,-34,52, 
  /* [29][0][][] */ 6,-11,79,-125,-16,-14,35,69,-22,127,37,-43,-64,9,56,-26,12,39,47,-23,-110,44,57,6, 
  /* [30][0][][] */ -10,37,36,-14,18,33,13,-3,104,54,15,77,102,-20,-107,-127,35,96,-78,-23,14,-53,-63,-45, 
  /* [31][0][][] */ -50,73,127,-1,27,-54,41,110,-64,-23,-40,-66,-6,26,50,-40,-12,66,22,15,39,-96,7,22, 
  /* [32][0][][] */ 20,-30,-13,-58,-48,19,-27,-28,38,90,-66,-18,-5,-114,-70,-24,3,67,6,33,-127,-83,-7,-38, 
  /* [33][0][][] */ -2,-1,47,-25,-9,30,-41,-4,-54,7,-12,5,-12,58,-121,72,27,-34,-78,31,17,14,-18,127, 
  /* [34][0][][] */ 77,-17,39,-19,26,-67,-10,-127,48,-86,-34,55,-52,-54,0,-44,-17,1,66,-16,-36,7,-56,17, 
  /* [35][0][][] */ 37,3,-44,60,-25,98,-24,-44,-4,127,20,-51,-3,-3,8,-42,-9,14,16,69,1,-8,31,-49, 
  /* [36][0][][] */ 3,36,56,-30,52,-25,-41,8,122,43,-42,57,-2,-25,-27,17,22,127,10,10,29,-89,44,45, 
  /* [37][0][][] */ 10,-76,-75,-27,33,84,-59,4,127,11,49,-43,-74,94,18,-59,3,29,-18,79,55,-29,-77,-38, 
  /* [38][0][][] */ -127,36,7,-42,-34,-26,-15,15,15,-40,39,-85,-21,18,7,86,72,22,84,-17,1,-4,-4,50, 
  /* [39][0][][] */ 93,24,28,24,15,54,-13,61,-32,65,-52,-8,26,-38,127,-13,-51,-31,20,6,34,33,-104,15, 
  /* [40][0][][] */ 127,-64,-72,-67,-11,-60,54,76,-28,83,-20,102,-114,72,51,11,93,-42,29,-84,-13,-24,21,6, 
  /* [41][0][][] */ -12,72,8,6,-26,-106,-62,-48,87,-73,44,-23,59,8,9,24,127,60,49,95,37,-21,-112,-37, 
  /* [42][0][][] */ -14,6,-31,48,18,1,-33,-16,76,20,-76,-32,56,-8,12,-61,-74,-127,-46,-67,17,-47,-30,-45, 
  /* [43][0][][] */ -28,24,-71,31,1,69,-16,114,65,-29,-6,80,-50,-61,127,-13,60,19,59,59,74,25,79,16, 
  /* [44][0][][] */ 34,83,59,-73,24,-74,-121,-30,-127,88,-2,-38,97,-100,21,48,-51,121,93,50,37,17,-18,-10, 
  /* [45][0][][] */ -71,6,-8,39,81,20,24,51,22,-27,-18,-43,6,-31,111,-53,25,72,127,76,-61,-78,27,-59, 
  /* [46][0][][] */ -83,12,-50,45,48,99,35,127,-85,35,20,-5,16,15,-78,42,-10,-37,-53,15,-40,19,86,58, 
  /* [47][0][][] */ -82,70,87,30,-3,-120,25,-80,56,28,-24,36,60,-127,-21,3,-33,41,3,26,64,17,83,13, 
  /* [48][0][][] */ 0,59,22,8,58,7,69,57,-127,-26,24,34,1,-24,112,47,85,9,22,69,14,-29,76,-28, 
  /* [49][0][][] */ -36,-46,21,-12,92,-127,-18,104,-48,-60,-37,3,32,34,40,19,-83,86,-11,3,-49,-8,61,-26, 
  /* [50][0][][] */ 74,-86,-63,-117,58,36,-29,-127,-13,-12,-121,88,-103,21,-122,94,-78,-55,-2,1,61,24,-77,-8, 
  /* [51][0][][] */ 2,42,-127,42,54,2,2,88,103,-71,63,25,-78,54,0,20,29,-27,63,80,60,-25,25,-115, 
  /* [52][0][][] */ 19,-88,-40,-58,-53,13,-126,20,27,88,76,-117,-2,-75,-42,-6,53,-60,73,30,127,-3,6,38, 
  /* [53][0][][] */ -59,-40,-22,-103,30,2,-86,-47,61,-40,-50,105,14,-21,-111,30,100,22,-101,-83,50,-11,19,127, 
  /* [54][0][][] */ 16,-29,61,-4,127,-57,-9,49,-41,-9,-48,93,-27,-77,35,80,-15,51,-32,-52,-15,23,70,-23, 
  /* [55][0][][] */ 25,63,16,35,50,127,1,9,-61,40,60,38,86,-42,-21,-27,-17,-41,-66,-21,108,53,-22,25, 
  /* [56][0][][] */ -127,109,-82,53,-14,-65,96,-29,-73,21,-21,56,62,8,77,63,-18,49,22,-63,-84,-31,10,18, 
  /* [57][0][][] */ 73,96,27,1,-15,-50,72,18,30,-20,-4,-9,9,-33,-15,41,30,1,18,-88,9,29,127,36, 
  /* [58][0][][] */ -37,83,-24,-111,11,-62,42,127,-51,-30,51,76,-37,30,19,65,-70,-23,-37,37,-94,27,-72,3, 
  /* [59][0][][] */ 127,49,-32,-3,-41,69,-42,-28,-27,1,-67,-84,-41,-42,-10,49,40,115,10,93,18,14,2,-51, 
  /* [60][0][][] */ -38,16,37,70,33,107,9,127,-63,7,72,-96,6,78,-34,56,-7,-17,-58,78,-86,40,13,66, 
  /* [61][0][][] */ -49,-33,-14,19,-117,-74,81,-35,-78,10,-30,-7,9,35,127,-30,40,-8,9,113,36,16,-57,28, 
  /* [62][0][][] */ 22,76,0,61,23,86,-25,36,14,38,-48,84,39,-51,-27,22,45,32,-17,-36,1,-66,-127,-28, 
  /* [63][0][][] */ -51,-82,-127,-10,-9,-15,30,43,4,14,-57,113,-23,31,-101,51,19,-71,1,69,-8,40,37,-2, 
  /* [64][0][][] */ 15,-1,-11,-66,51,-25,-32,50,-31,-94,-36,41,-10,39,127,-31,-13,63,-9,44,28,-14,-10,-24, 
  /* [65][0][][] */ 86,-127,-44,-54,-9,42,-24,-48,-57,2,91,-76,21,81,-8,43,95,-15,-8,4,-40,32,-45,30, 
  /* [66][0][][] */ 37,-5,-45,95,54,28,-94,-81,127,36,49,20,-62,-84,4,13,-14,36,-19,-54,86,92,85,68, 
  /* [67][0][][] */ -4,-29,-18,11,64,0,-13,28,16,-114,20,-1,-3,20,80,-96,34,19,10,-45,2,-4,-127,5, 
  /* [68][0][][] */ -27,127,-79,79,-63,55,32,-41,66,-11,83,-23,-83,-53,-40,-70,-20,-51,91,67,-60,-50,29,-73, 
  /* [69][0][][] */ 76,-32,-14,21,15,-68,8,-48,0,-52,2,-127,12,25,-22,38,-100,-41,15,73,-73,-41,111,-43, 
  /* [70][0][][] */ 127,19,65,23,7,58,12,-29,-31,62,-57,29,-27,-44,33,48,-42,-2,-11,16,46,32,-50,35, 
  /* [71][0][][] */ -10,18,-27,47,-2,75,21,127,-11,37,64,-74,26,63,-23,3,-31,6,-5,4,-42,13,28,-2, 
  /* [72][0][][] */ -7,-28,-69,70,-16,127,-42,-32,64,-15,23,59,-79,53,-7,18,-5,25,33,-100,-9,37,-6,-87, 
  /* [73][0][][] */ 12,32,26,-56,-27,-24,26,6,-14,49,-63,65,127,-6,-13,-62,110,-1,71,8,-53,-97,7,-79, 
  /* [74][0][][] */ 14,83,109,7,12,-52,127,79,-34,70,-20,79,-19,71,-52,-63,40,41,66,-56,-41,69,-11,29, 
  /* [75][0][][] */ 31,-11,-58,27,-2,74,-53,-64,-84,-117,-73,67,107,-117,38,31,60,-71,-103,31,127,-34,0,74, 
  /* [76][0][][] */ -33,-17,22,-23,-21,-14,-2,50,-30,48,37,-33,127,0,-49,9,9,27,-16,9,66,-50,75,-45, 
  /* [77][0][][] */ 39,-122,62,-7,127,-4,9,3,51,6,-25,-10,21,-46,-51,-15,19,24,27,-23,-20,13,-8,-66, 
  /* [78][0][][] */ -83,6,-90,-19,26,-58,36,127,19,-20,-34,4,7,97,-35,65,66,10,-90,-93,64,-46,-34,-19, 
  /* [79][0][][] */ 61,-56,-97,-99,44,-30,-40,47,-38,60,-23,11,-59,37,-46,-127,-5,8,14,-63,-11,12,-121,-40, 
  /* [80][0][][] */ 80,-43,-91,-82,44,-92,-52,-33,-39,-28,-50,6,-52,63,98,-46,48,-127,57,-5,37,-90,17,1, 
  /* [81][0][][] */ 32,-7,122,-101,96,-35,-52,-37,-23,45,111,-43,89,-2,-85,-43,-20,23,30,-46,-100,-12,-127,-18, 
  /* [82][0][][] */ -11,-23,-31,61,22,-4,92,-40,-8,29,-51,63,78,71,4,-62,-27,41,16,-114,-12,19,45,-127, 
  /* [83][0][][] */ -4,42,-2,5,100,100,17,127,-13,100,7,-76,19,88,-114,-43,5,37,-69,-40,-65,-76,12,-51, 
  /* [84][0][][] */ -100,26,-56,-127,32,-16,61,43,21,16,-22,-33,-42,-25,48,-5,20,73,80,-9,-20,117,-71,38, 
  /* [85][0][][] */ -3,14,124,60,22,-20,-58,102,-38,-72,-83,-17,20,-105,46,51,127,107,-91,12,-51,-79,34,-17, 
  /* [86][0][][] */ 28,-127,43,-47,40,-83,-36,69,45,15,113,-32,-55,-33,0,4,-8,-54,17,52,-69,-8,-41,83, 
  /* [87][0][][] */ 60,80,-64,-126,-30,-14,96,-6,34,66,44,-96,-11,-84,-32,33,-127,73,65,119,-78,-15,-37,84, 
  /* [88][0][][] */ 54,-127,-18,-7,70,67,-26,25,-17,36,-58,-42,-120,75,-27,8,26,81,38,57,-105,30,-68,34, 
  /* [89][0][][] */ 16,-123,15,-69,-30,-45,89,-4,-53,18,-28,-7,127,-9,70,-3,-7,6,-55,-20,-55,-26,-21,71, 
  /* [90][0][][] */ -43,-11,68,-47,30,-74,-30,46,-81,-76,-27,16,-64,37,56,5,-63,16,-127,28,1,17,-6,29, 
  /* [91][0][][] */ -49,55,-13,55,-25,65,-31,44,-39,48,0,-55,60,48,3,-1,51,32,-68,63,91,-53,-23,-127, 
  /* [92][0][][] */ -31,33,-11,-79,13,14,78,9,-55,13,-15,33,5,46,55,-67,-3,-21,6,11,-2,-127,-25,19, 
  /* [93][0][][] */ -72,-7,-43,42,2,127,13,1,-70,1,62,-15,62,-3,-11,16,38,-62,86,-20,35,70,108,91, 
  /* [94][0][][] */ 16,53,-106,32,43,59,125,-110,-16,-23,-17,9,-88,-28,-68,-60,6,-55,37,13,39,-28,49,127, 
  /* [95][0][][] */ 12,2,11,54,33,79,-6,6,-47,-75,17,-45,-1,77,14,-127,-30,59,-7,35,61,7,16,-81, 
  /* [96][0][][] */ -29,48,-2,-8,-23,-33,-105,-119,32,-81,30,17,-60,-64,50,25,23,18,-9,127,13,-28,-20,-52, 
  /* [97][0][][] */ -107,-76,-58,-32,1,85,66,75,21,127,50,-67,7,-22,-52,20,24,8,-9,56,-38,21,62,42, 
  /* [98][0][][] */ 12,-31,127,-61,38,-93,-18,-63,40,-98,44,30,79,-85,3,31,-18,40,70,4,63,-75,-56,-70, 
  /* [99][0][][] */ 69,-95,-8,12,-16,-50,35,-38,38,-92,-11,-127,7,-1,-24,54,-114,-30,36,59,-35,-68,74,-84, 
  /* [100][0][][] */ -15,-43,-33,83,-40,39,112,-53,-93,-127,17,15,69,-17,52,-15,-39,37,-23,-15,-25,-36,46,33, 
  /* [101][0][][] */ -18,21,-77,-45,-7,14,7,-40,-6,69,61,-44,50,3,-76,-56,37,-124,81,127,-49,-12,-97,75, 
  /* [102][0][][] */ -13,67,96,58,14,-79,120,-51,6,-126,-18,65,-121,-127,-8,4,34,9,-81,-42,-12,-11,-38,27, 
  /* [103][0][][] */ -24,-72,-78,3,51,127,17,-5,38,31,6,-20,57,-42,30,63,73,56,31,20,78,-2,23,53, 
  /* [104][0][][] */ 3,-50,-57,45,1,-127,11,16,26,17,28,3,8,-54,2,50,16,24,9,-33,55,33,-76,-30, 
  /* [105][0][][] */ -19,-13,0,-98,72,66,83,127,-16,-26,-69,59,-38,13,-81,-27,46,15,54,84,72,-77,23,-52, 
  /* [106][0][][] */ 111,30,-16,83,23,-127,-84,-44,4,-30,76,-81,48,59,66,-41,-67,-17,-20,-59,-104,-12,100,-21, 
  /* [107][0][][] */ 16,48,72,6,26,-80,-93,83,-40,1,-40,22,113,127,42,-89,45,20,0,-51,-61,-124,-58,-8, 
  /* [108][0][][] */ 10,-27,-9,-81,-2,31,93,25,62,-101,31,-126,69,-60,44,-61,117,-63,-17,94,15,-127,-27,43, 
  /* [109][0][][] */ 32,-66,64,1,-72,87,10,-40,50,53,127,52,-53,9,88,-52,-80,43,-13,-8,66,14,55,15, 
  /* [110][0][][] */ 18,2,-10,-89,13,25,34,127,107,44,20,28,39,0,37,-17,-37,36,102,-9,-72,-39,-100,-3, 
  /* [111][0][][] */ -49,-34,-45,13,-41,-16,-76,61,6,41,-59,-21,46,-46,11,-127,-49,36,58,28,-24,2,8,-15, 
  /* [112][0][][] */ -88,-3,-127,-2,93,70,-50,-7,51,-15,2,-65,-25,6,-2,0,108,-70,-87,-105,-62,-66,-58,-65, 
  /* [113][0][][] */ -127,1,-44,-32,33,-4,54,50,73,-11,23,-24,9,-27,-37,41,15,7,99,-30,-9,48,34,16, 
  /* [114][0][][] */ -26,-38,54,-19,-37,5,2,41,-4,19,-30,68,-40,43,-29,26,-71,-127,-86,-80,24,8,3,-39, 
  /* [115][0][][] */ 121,-105,-26,44,9,-8,-21,57,-52,-105,50,-85,10,87,127,79,-4,16,46,-116,-20,-31,102,15, 
  /* [116][0][][] */ 113,28,-53,70,13,86,-74,-112,-78,-82,1,-109,41,24,4,-21,-15,82,-20,1,-121,44,127,10, 
  /* [117][0][][] */ 59,115,-47,10,-53,-66,70,13,-44,-127,-67,29,-25,2,15,30,-71,-75,93,83,47,-1,39,33, 
  /* [118][0][][] */ 101,-76,-24,4,51,-27,34,127,74,-15,-1,-64,22,33,32,1,-6,16,-4,-42,44,27,-42,-24, 
  /* [119][0][][] */ -66,15,-11,99,59,47,-29,-127,-9,-57,2,8,27,113,55,-65,-11,1,-111,41,56,35,-30,-14, 
  /* [120][0][][] */ 21,-5,3,19,19,-127,-76,-85,70,-69,9,13,-9,-75,69,-25,-15,43,-18,103,55,-49,2,-48, 
  /* [121][0][][] */ 42,127,-93,-47,-15,19,73,48,-55,-35,-18,-36,-78,21,-24,2,-81,9,-98,-3,-99,23,-11,98, 
  /* [122][0][][] */ -2,-7,-27,-59,-33,31,-14,-19,28,40,-6,18,36,6,104,85,70,5,-66,90,19,-13,-13,-127, 
  /* [123][0][][] */ 27,-9,41,-26,12,111,-40,-8,-23,45,48,-101,87,-19,-127,-9,59,-85,69,14,-3,-68,-4,-26, 
  /* [124][0][][] */ -16,23,-15,104,-123,39,-59,-16,16,-59,-63,-13,74,127,-30,-69,35,4,-14,-26,-22,-24,-72,-52, 
  /* [125][0][][] */ 49,-127,-58,7,48,-2,-43,61,-11,-9,61,-55,-44,-24,-19,17,-23,5,0,-56,-112,33,-67,-74, 
  /* [126][0][][] */ -105,-32,0,94,-62,127,44,-74,-36,70,3,-25,85,-76,3,54,36,52,-75,-69,-23,-12,114,-71, 
  /* [127][0][][] */ -53,12,-1,-12,51,-54,-50,-7,8,1,29,1,11,-27,46,23,13,121,8,-3,-73,-10,31,-127, 
  /* [128][0][][] */ -28,-21,-42,-16,7,25,50,51,22,18,-1,43,-13,47,49,-70,84,5,33,28,-127,8,-16,-6, 
  /* [129][0][][] */ -43,-50,7,45,-12,41,5,12,18,23,68,24,-2,76,5,-37,57,44,-6,63,99,16,-127,-22, 
  /* [130][0][][] */ -55,-25,50,38,69,127,25,75,3,116,-119,-65,-86,54,78,12,-66,-25,-76,-18,85,-45,-54,80, 
  /* [131][0][][] */ -35,25,33,26,25,-2,15,23,10,-35,51,31,23,60,115,0,-42,-127,-40,-48,20,25,88,50, 
  /* [132][0][][] */ 127,59,-82,-27,-48,33,-29,-24,53,118,103,26,68,-69,-60,20,17,-60,74,69,1,-51,15,94, 
  /* [133][0][][] */ -10,24,-27,-22,31,-43,-51,127,17,-28,-49,34,-79,34,-19,20,-67,-55,19,7,-18,-53,7,27, 
  /* [134][0][][] */ 30,64,50,-33,2,-13,127,2,-7,-17,43,8,12,-27,30,-5,-39,19,-18,17,-14,-42,92,48, 
  /* [135][0][][] */ -56,74,77,-52,-98,45,47,-29,14,-89,-20,127,35,37,-60,22,-26,-121,-4,-51,100,-32,59,-18, 
  /* [136][0][][] */ 62,-127,50,-18,24,96,27,109,-16,79,28,32,-43,-50,-14,47,-83,81,18,-1,-17,-46,-48,-113, 
  /* [137][0][][] */ 96,35,-63,-30,23,-39,9,-56,-59,-16,1,49,-46,-24,21,85,127,95,40,-50,-83,-49,48,-29, 
  /* [138][0][][] */ 53,-38,76,-54,-2,23,53,-27,-62,-13,36,-77,-93,48,-16,45,-1,1,-3,127,-36,-22,-20,9, 
  /* [139][0][][] */ 21,97,-127,4,-92,-24,58,-41,101,-17,25,-15,-51,35,-15,-64,-101,-18,57,81,-116,-20,-101,-75, 
  /* [140][0][][] */ -47,-37,-68,10,15,97,6,119,-33,42,-120,-21,47,5,-37,4,93,47,1,-16,-117,-11,-127,-23, 
  /* [141][0][][] */ 42,-29,-14,32,-11,-20,-4,41,76,-32,-12,45,-60,18,39,70,-33,127,-27,-74,-6,1,4,-4, 
  /* [142][0][][] */ -9,19,-29,55,87,-12,-113,127,52,17,9,-44,-71,91,-30,23,-23,19,33,63,-30,-36,30,-63, 
  /* [143][0][][] */ -4,-91,-33,-14,21,100,49,127,-32,92,71,-50,-50,-19,-33,78,5,8,-105,-27,77,9,-34,-107, 
};
const TfArray<4, int> tensor_dimension61 = { 4, { 144,1,1,24 } };
const TfArray<144, float> quant61_scale = { 144, { 0.0017266119830310345, 0.0016471113776788116, 0.0012292357860133052, 0.0014915135689079762, 0.0013909467961639166, 0.0013608755543828011, 0.0010721312137320638, 0.0014824145473539829, 0.0021094628609716892, 0.0013860092731192708, 0.00087361154146492481, 0.0016838019946590066, 0.0015593013959005475, 0.001497723744250834, 0.0014347705291584134, 0.0019279505359008908, 0.0014629566576331854, 0.0021128791850060225, 0.0022245480213314295, 0.0014974444638937712, 0.001535248477011919, 0.0016791782109066844, 0.0010909552220255136, 0.0014629841316491365, 0.0017106917221099138, 0.0014643733156844974, 0.0013136666966602206, 0.0025709117762744427, 0.0017298561288043857, 0.0018050131620839238, 0.0015500640729442239, 0.001858862116932869, 0.0019247734453529119, 0.0022994435857981443, 0.0020607435144484043, 0.0016441356856375933, 0.002253429964184761, 0.0013620845274999738, 0.001676850370131433, 0.0016666128067299724, 0.0017510320758447051, 0.0014972435310482979, 0.0023777273017913103, 0.0016343012684956193, 0.0017871116288006306, 0.0020530365873128176, 0.0018751390744000673, 0.0016412641853094101, 0.0016998291248455644, 0.0015876599354669452, 0.0016622447874397039, 0.0017860900843515992, 0.0013740522554144263, 0.0013822447508573532, 0.0014134905068203807, 0.0016967511037364602, 0.0016674621729180217, 0.0020979505497962236, 0.0015109387459233403, 0.001691442565061152, 0.0022885596845299006, 0.0019882258493453264, 0.0019846474751830101, 0.0019324518507346511, 0.0024085340555757284, 0.0012607771204784513, 0.0015305000124499202, 0.0014707276131957769, 0.0015129121020436287, 0.0016429404495283961, 0.0018352374900132418, 0.0027663332875818014, 0.0018402596469968557, 0.002029959112405777, 0.0016648422461003065, 0.0015090752858668566, 0.0023921378888189793, 0.0027927551418542862, 0.0015025538159534335, 0.001404757727868855, 0.0018999106250703335, 0.0017893217736855149, 0.0021159292664378881, 0.0017721373587846756, 0.0020091759506613016, 0.0013930323766544461, 0.001586124999448657, 0.0013230229960754514, 0.001535882125608623, 0.0016086293617263436, 0.0014961791457608342, 0.0016885593067854643, 0.0025484238285571337, 0.0014026319840922952, 0.0015956454444676638, 0.0018842362333089113, 0.0018806826556101441, 0.001465977868065238, 0.0020469026640057564, 0.0011885499116033316, 0.0019402146572247148, 0.0015639093471691012, 0.0014221622841432691, 0.0015483913011848927, 0.002777445362880826, 0.0020898492075502872, 0.0020616557449102402, 0.0015470485668629408, 0.0014605885371565819, 0.0018488459754735231, 0.0021066865883767605, 0.0028187921270728111, 0.0013518906198441982, 0.0017354551237076521, 0.0019548211712390184, 0.001676840940490365, 0.0015498647699132562, 0.0014286598889157176, 0.002543862909078598, 0.001653676968999207, 0.0020455715712159872, 0.0023725940845906734, 0.0019504425581544638, 0.0016666279407218099, 0.0014238287694752216, 0.0021186349913477898, 0.0014562157448381186, 0.0024501928128302097, 0.0024482719600200653, 0.0017624645261093974, 0.0015571146504953504, 0.0019242020789533854, 0.0013068196130916476, 0.0018594367429614067, 0.0023256319109350443, 0.0013726635370403528, 0.0012964099878445268, 0.0026378515176475048, 0.0018862668657675385, 0.0010915650054812431, 0.0016317463014274836, 0.0026982633862644434, 0.0020316718146204948, 0.0015076420968398452, } };
const TfArray<144, int> quant61_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant61 = { (TfLiteFloatArray*)&quant61_scale, (TfLiteIntArray*)&quant61_zero, 0 };
const ALIGN(8) int8_t tensor_data62[24*1*1*144] = { 
  /* [0][0][][] */ -3,-96,104,78,122,-8,125,-69,-16,-36,4,0,122,17,106,-35,-46,27,92,-64,-13,55,51,-67,-16,29,67,-47,64,-37,127,-27,-8,60,6,-65,-8,81,-7,33,100,5,35,14,16,-113,-20,42,-2,47,108,102,98,-27,81,-37,-13,4,-58,14,33,-10,52,-16,-7,66,42,-44,5,13,78,-9,-33,23,29,-96,-8,31,83,12,-46,-44,30,-48,-10,-20,1,-36,58,-65,-19,75,39,45,45,11,101,26,-19,68,-6,45,-61,9,49,23,35,24,-46,-43,22,-6,4,16,-45,-30,-14,-44,-51,28,24,-56,47,3,21,34,7,0,5,-3,-44,-8,-36,20,-57,51,-24,-8,-45,-86,0,57,-17,30, 
  /* [1][0][][] */ -36,7,21,15,-66,24,6,13,3,-55,16,44,-24,-23,11,2,44,-65,-22,83,30,8,61,-78,-7,9,-67,4,-49,-11,47,58,-29,12,50,-21,-5,-9,4,67,-10,45,20,14,-81,10,-30,0,75,-45,-45,35,8,1,-44,0,-18,24,6,-24,39,-27,45,20,-75,-21,-4,62,-127,63,25,-68,46,-29,31,59,5,-32,-36,-25,84,-64,-14,-43,-39,-71,23,-1,54,-16,-12,-11,-18,52,6,-13,-51,-26,6,-5,0,-6,61,75,-69,-10,42,-57,-45,17,-25,5,28,-35,40,6,4,-7,-26,-9,54,-5,19,30,25,-32,-12,-22,40,7,-18,47,51,27,41,64,17,14,26,39,0,57,-33,19, 
  /* [2][0][][] */ -24,-19,-22,43,-40,-21,-94,-85,8,33,-117,-29,-44,6,13,-5,10,0,-72,-11,-13,-35,-24,-62,-52,2,-6,-29,-11,46,5,-16,-29,-9,-3,78,40,30,-7,31,-44,-15,39,21,46,29,28,-54,-28,-44,-12,-40,-40,-24,-8,-10,28,20,61,68,-89,-64,-33,69,-46,-9,21,14,-8,1,13,127,-48,-43,-17,44,-13,5,-8,-10,-44,76,12,-12,12,43,-11,17,13,22,-4,-75,8,60,-76,-25,-17,38,106,9,21,23,-17,-9,-31,45,-7,11,23,9,-23,9,-14,26,36,37,44,-44,4,56,-42,13,-71,-4,-113,103,103,-50,8,-87,19,-30,-13,10,-60,-46,-27,-47,-14,84,2,-65,61,-4, 
  /* [3][0][][] */ 25,-29,57,-85,43,73,-42,-13,-4,55,-58,46,-7,4,-10,16,46,11,25,27,-54,-35,-20,126,-31,15,64,12,61,-32,-107,-53,-8,-39,-5,-44,-40,-59,41,19,-48,-55,-52,61,36,37,14,-20,11,3,-59,-106,-20,-50,-81,-59,25,25,-2,32,-27,-63,69,29,-18,-50,-69,-20,47,-75,16,49,11,-19,37,-13,8,35,-25,-19,-55,47,-7,19,62,-26,20,29,28,59,45,-47,-9,38,-45,-5,21,56,-11,12,5,-17,26,-12,45,4,6,85,70,-29,49,24,-13,-26,-21,-28,-47,33,26,127,-22,45,-37,-52,20,67,12,-16,-33,-22,27,16,-9,21,-12,-25,-47,-20,28,96,-34,-23,17,-85, 
  /* [4][0][][] */ 18,-32,29,4,70,-29,38,-9,-53,-30,74,-10,68,50,-34,-52,38,18,-20,-31,37,-25,24,-3,102,43,29,-47,-48,49,63,4,-1,62,59,-55,21,6,37,57,32,27,24,45,-21,-3,-46,79,89,15,-25,78,61,-12,20,-43,-17,-43,-51,-49,79,-30,10,-15,-12,17,16,84,50,69,46,-127,68,-26,4,-7,-47,6,10,66,-18,6,-40,-112,-59,21,-74,49,-11,-13,-19,72,12,-32,78,-33,27,8,-90,-51,56,37,-56,18,1,57,22,-32,-17,61,-66,14,98,69,80,14,40,-14,-5,-44,15,-13,-15,44,36,-87,10,44,-39,58,-22,29,-33,63,56,47,79,-40,15,24,103,-65,-106,65, 
  /* [5][0][][] */ 43,-5,22,-26,-42,-25,-82,19,28,31,58,-13,29,-13,23,-3,-16,-108,-8,98,-79,-51,-11,34,-75,-91,9,42,110,6,-29,-43,-16,-9,-13,-5,-60,-75,4,25,-79,-21,-70,105,59,32,70,4,-14,-16,-4,-15,-30,15,-8,35,20,-9,-30,25,64,-23,20,52,31,-42,34,-50,-70,3,-34,84,32,-43,42,20,49,2,38,-10,26,42,24,48,28,-33,30,21,-21,-5,-49,-11,-28,-27,7,-8,-58,-24,74,-61,16,-33,63,-127,50,33,-101,59,52,-65,14,35,-9,-52,-61,22,-113,74,15,5,59,73,64,2,-91,51,21,19,50,27,-37,-4,11,-31,-52,-81,-12,-18,12,18,4,-11,34,-75, 
  /* [6][0][][] */ -10,-32,64,-71,-53,24,69,39,-70,-8,5,-21,8,-52,8,-1,-35,74,89,60,-15,-21,0,47,-35,6,-45,-16,-17,-13,36,16,-92,8,54,-37,36,43,30,74,32,-27,14,-17,54,-12,-28,34,-64,-46,-83,-40,42,-15,-13,72,-1,32,4,73,-41,5,21,23,49,-46,106,76,-26,43,-23,48,-9,-52,-15,44,41,-19,-3,127,4,-27,57,30,5,-12,-88,-5,53,65,-32,27,20,52,79,-48,12,5,42,-34,-36,50,-21,34,-4,92,-84,-32,17,-80,6,11,-23,-54,10,9,24,15,84,38,26,30,52,51,9,-31,-8,32,-28,5,-4,-32,52,72,29,-21,63,47,-70,-65,29,-10,61,23, 
  /* [7][0][][] */ 17,-24,41,-29,-30,7,-20,127,-4,-43,-25,-20,-84,-1,38,24,-43,13,-13,-3,-39,-43,-29,-44,10,-79,-27,125,-60,25,31,70,-68,63,-92,11,-103,-18,-32,-11,11,-78,-72,-22,5,20,19,119,-37,-22,33,-11,53,33,9,32,16,-110,-37,-38,86,3,19,37,-26,-96,108,-33,26,1,31,37,-10,78,-16,-88,65,52,18,-39,-110,-32,-14,71,55,1,-10,-3,41,2,-82,24,-19,56,-56,-1,-7,-105,75,-22,41,-4,88,-38,47,9,-79,103,54,6,120,6,-1,-23,16,-105,-60,42,69,56,-22,88,-18,21,-8,27,38,-13,13,52,-74,-73,-23,4,-16,46,-34,-33,95,-32,-59,-17,47,-22, 
  /* [8][0][][] */ -13,26,-91,-17,83,37,-30,-7,-4,28,-82,-63,-42,28,27,-45,36,50,71,-26,-74,-63,-61,12,-75,38,-21,-52,-57,-16,-27,-105,54,-19,-36,5,81,-31,53,-53,5,-54,83,84,70,11,59,-34,-48,79,-3,75,48,-76,74,40,49,-26,-20,37,-52,-72,42,127,37,13,-7,-24,47,18,-78,120,18,52,14,-33,-12,56,58,-55,-117,10,40,-29,-20,46,-10,97,-11,-23,50,-49,38,-60,-38,64,126,34,-57,-32,54,38,-32,-47,104,-2,1,11,9,10,65,30,2,9,-33,22,-1,-48,60,106,-23,-26,-62,-16,11,12,32,4,-49,-109,97,-49,97,48,-82,-9,-43,25,9,61,16,-68,-40,-25, 
  /* [9][0][][] */ -46,-38,88,-22,-50,35,93,-24,-50,30,7,-95,-37,15,3,-44,-44,-54,46,37,-8,22,-55,56,-14,7,-11,-27,-70,83,40,14,53,-58,-50,-68,11,-61,-33,44,10,-29,19,-24,-3,-13,5,19,14,-39,-7,-63,29,-19,-44,26,-35,84,-5,5,28,-22,55,65,-44,51,-49,-24,-69,26,10,-47,-25,-29,50,2,16,45,15,-29,32,-66,59,20,23,26,-26,-48,-24,-20,18,3,0,5,-47,15,0,-5,-33,-34,-30,-35,76,-26,12,26,31,-18,-45,26,-23,56,25,-15,-20,58,20,-19,77,7,107,29,9,-17,20,15,-27,3,-33,37,-15,-2,62,11,1,-86,83,70,37,127,18,4,17,1, 
  /* [10][0][][] */ 68,-27,-48,24,-31,31,16,-61,-9,107,1,-65,-40,-59,-13,32,6,8,4,93,-50,-14,6,-41,-23,13,109,-33,-14,-3,-31,-11,19,10,-16,51,-36,-84,55,2,-27,-55,-3,-7,7,64,51,-125,-13,44,30,76,-3,-4,8,-20,-39,-60,-8,-32,70,14,-77,16,-84,44,24,-80,-8,-35,24,34,-28,110,28,38,70,-5,-34,-20,-16,92,52,-13,33,-73,-28,10,78,-7,-10,-36,-67,-21,-72,-113,-18,-24,86,-56,60,-78,7,-70,101,43,53,127,45,-93,15,-8,20,10,35,-24,-36,-8,15,-32,-30,76,20,-24,-81,-23,15,29,33,0,-17,-41,55,8,33,50,-26,-25,68,-50,-44,0,38,-38, 
  /* [11][0][][] */ -32,15,24,19,23,-55,39,127,47,-25,-3,-44,-14,-81,17,-52,8,11,-43,-69,0,74,54,-37,-46,-24,-42,-25,24,-17,-88,-42,1,2,36,55,-6,14,-19,-27,12,5,-2,-27,23,-45,-20,-112,-9,30,7,74,-63,54,91,-6,-4,-48,33,-38,-37,2,75,-23,94,-81,-53,-44,29,101,44,66,-12,2,3,34,-53,-84,-13,28,62,3,-54,-10,2,-4,36,5,33,47,36,8,13,-17,42,55,-30,45,92,-110,-43,45,-55,23,-55,-34,-74,24,-26,-63,-101,0,-66,-24,27,15,25,-18,-54,-8,-35,-81,41,-54,-106,-103,36,-34,6,-76,9,14,-34,-27,-30,94,-11,-12,-69,-91,27,90,9,18, 
  /* [12][0][][] */ 37,-29,-2,7,-93,43,-63,22,-17,-5,-31,57,-59,33,40,-39,-11,23,63,-13,14,-23,-13,51,-10,12,77,28,-78,-28,-22,-22,-7,20,-51,51,-25,-3,11,16,-23,-14,-26,2,14,96,22,35,11,69,-4,1,-11,31,47,-74,20,-127,30,-30,-30,-42,57,-11,-15,66,-14,59,-28,-22,22,-4,57,68,26,-11,61,-19,-59,-27,-35,-60,-42,-11,-94,-29,34,13,93,40,31,-4,-36,-26,-77,-37,-38,-3,25,29,-31,-58,41,-61,-24,-38,32,-5,16,52,-8,-22,39,-4,34,-46,44,-67,-52,49,38,35,5,55,48,8,8,-35,-1,-42,5,-38,66,7,-3,29,-9,-47,71,-40,29,-20,110,-26, 
  /* [13][0][][] */ -2,29,7,-15,-90,-116,38,-38,16,-103,-37,-90,2,17,1,-93,-25,-32,36,-14,-68,-32,30,15,4,-61,-24,-17,-44,-7,-31,18,-44,18,-60,23,-114,-20,-10,-60,64,5,-98,46,29,38,31,49,-70,-35,69,4,-35,30,-22,12,-62,-51,-104,-16,127,52,-30,43,10,-39,-21,40,-45,-39,24,-22,20,2,-17,-13,11,-23,-13,-14,33,-29,34,111,-35,-23,-44,61,-3,8,-21,-24,-67,29,-30,-20,-41,3,76,33,-1,3,-5,-6,24,101,-30,-46,17,39,-35,72,-16,-24,-11,44,4,-11,51,47,-58,-16,31,-37,40,97,-45,14,-37,-20,-86,-4,9,-105,-1,-18,-81,17,-84,102,-30,11,15,-59, 
  /* [14][0][][] */ 32,-36,-3,-24,105,21,27,75,59,27,37,43,-13,10,-14,-11,15,67,-33,-73,-1,-38,-39,68,-1,23,-33,-50,69,14,56,-1,38,-17,-17,3,17,-27,-9,18,34,-69,-7,-53,-17,17,-35,5,34,-25,44,-2,11,-49,-42,-13,-17,47,-21,-35,-8,83,-38,4,28,17,-62,-19,107,23,32,-28,-23,32,4,-11,-12,-23,46,-55,-28,46,-33,-127,36,42,16,-11,28,-19,-26,-11,22,9,39,-16,18,49,-43,-77,-12,41,-37,28,7,-22,30,73,-1,-60,22,-42,-18,11,19,-12,20,12,-8,41,18,33,48,-58,-19,22,49,34,-79,-17,1,64,-35,49,94,2,2,48,42,-27,-34,15,17,-28, 
  /* [15][0][][] */ 16,-12,31,0,29,-66,32,12,-17,76,64,-23,-68,33,11,-109,48,-18,-52,-2,-43,-8,53,94,23,-16,-22,23,5,57,-52,-46,-2,61,-64,9,-19,75,-5,-38,-4,8,4,37,45,24,-19,-5,11,-78,-2,-18,48,44,-51,-8,4,-28,96,90,-3,-11,37,86,-54,0,-127,-49,5,-63,53,-27,-4,-18,-24,68,-32,-9,12,65,53,-9,-32,-29,62,52,-45,-38,-7,66,-3,55,-26,-17,-49,74,17,68,-30,74,31,-1,-16,-77,-41,-66,10,-11,-67,36,-15,29,15,-22,6,-12,-20,62,1,-93,58,-3,28,34,-24,-72,43,5,1,-38,-10,2,35,59,-65,96,46,41,-43,88,-94,65,-8,16, 
  /* [16][0][][] */ 49,-15,-28,42,-33,10,-21,-75,99,-15,-6,25,52,-11,10,-9,24,-36,-35,56,4,31,127,70,-55,38,26,-18,36,-18,72,44,-15,5,-40,66,25,-3,85,9,-41,47,54,-13,-8,0,-11,0,64,21,-31,-31,82,75,-22,9,40,-10,30,-2,-51,28,-25,-68,-20,71,-30,-16,61,69,-72,1,-47,32,-79,21,-21,1,-59,-45,-27,-4,-44,-44,12,9,15,-40,-35,41,15,59,-12,61,-66,-46,-33,19,4,-70,-4,-86,1,-105,-22,24,19,-32,-19,-5,12,-6,20,33,-33,6,-19,-45,-43,-7,21,73,13,58,29,-23,68,-95,-104,74,41,25,-12,-11,18,-38,-20,62,33,-13,71,8,-21,-48, 
  /* [17][0][][] */ -24,-1,-82,22,15,12,-15,-17,-70,21,-1,-29,82,79,-50,-3,36,52,89,-24,34,0,70,-26,1,-38,-11,-15,33,23,-15,42,4,62,-3,-12,-8,2,-12,29,-24,-6,-1,-9,-16,74,18,-11,62,34,-109,56,87,30,19,-44,-26,-9,22,-33,-27,10,-8,-26,-83,119,-19,88,19,7,20,-57,51,78,22,30,28,-23,-72,2,-3,-35,45,4,3,-6,64,38,-48,-6,39,-40,-17,12,-65,0,9,10,-95,8,26,112,89,-6,-39,-29,34,31,-56,-60,51,-77,65,37,-11,-71,-5,67,-72,30,16,-17,41,-17,66,74,-55,55,-20,93,-22,-89,16,-5,51,-8,113,-39,127,-58,51,35,5,56, 
  /* [18][0][][] */ 47,-23,-44,31,66,-15,3,98,37,-13,1,-28,-8,50,-48,-1,5,4,12,-22,22,82,-70,15,19,-13,-69,-59,-37,10,-6,10,-45,40,29,16,10,5,18,83,-40,14,-35,-24,-10,14,-62,5,19,40,10,63,29,36,-52,-54,33,-20,-6,-47,0,6,-1,-7,24,0,-78,8,22,6,39,-15,36,-9,-3,40,-60,-75,-15,62,-7,-12,-67,-25,-6,11,-13,17,-64,-41,103,24,-1,-87,-45,28,69,7,22,54,19,-35,15,8,-60,-3,-47,0,-8,28,-80,-75,36,-18,-6,-59,17,4,-69,-9,-41,-62,-127,31,-25,27,0,5,-21,18,17,14,-2,-25,-34,21,33,-82,-66,-39,17,-25,-22,13, 
  /* [19][0][][] */ 80,23,52,-24,48,-121,25,-42,92,64,-18,21,34,61,-35,25,-20,-2,-52,55,83,-63,-18,94,21,-30,-119,27,-15,127,-51,22,-34,55,-30,-52,1,-67,59,22,-6,95,20,19,102,49,-12,70,33,4,-70,-47,-29,68,-59,-10,41,77,-3,-33,-40,-10,-77,-62,-11,48,-42,-16,12,-79,30,-42,-34,-10,-31,-20,14,-61,38,48,-3,21,-67,11,46,-26,-85,-78,-16,44,18,-27,28,78,-18,-104,-115,20,28,40,57,-68,100,27,-120,-28,-9,8,36,47,-4,-34,-63,34,-2,-97,49,39,-27,-95,-29,74,88,89,5,-15,54,-58,-1,2,100,50,1,-90,72,-30,31,-80,58,-37,-36,-10,-6,11, 
  /* [20][0][][] */ -124,-19,44,27,4,31,42,12,18,-25,14,93,89,33,33,47,17,68,80,70,96,-55,22,84,19,49,4,-12,-2,-62,59,21,-33,-2,11,2,91,-13,38,16,-4,-12,96,-4,11,10,-9,-1,-84,38,-43,11,45,-30,54,-81,51,23,-8,-9,-80,5,8,-48,83,57,17,31,72,46,-15,60,4,-31,22,64,32,52,1,-52,-31,20,117,-3,-100,63,-93,29,80,120,22,-81,61,-41,-3,-17,65,38,53,17,21,25,-19,-50,48,82,51,12,21,5,76,-28,-78,-6,-24,-11,71,84,53,-23,17,36,-30,23,44,-39,-15,35,35,82,71,127,-34,-30,-17,-49,7,-36,30,82,-73,30,-52,-29, 
  /* [21][0][][] */ -25,-49,-32,-60,-37,-65,-23,-57,-5,-66,58,15,-38,-23,-25,-31,2,-59,-27,37,-8,55,6,-38,11,-6,33,57,-53,73,10,-31,32,-49,-18,-68,-9,75,73,-14,86,-12,-17,53,-70,-16,-2,52,84,-19,74,-41,-17,-61,-28,-115,-49,-24,-37,-20,64,33,-70,65,-19,10,-25,-13,-39,100,66,-35,27,-31,-5,-14,34,95,36,-103,34,72,42,82,77,-13,31,33,-51,-71,10,26,-66,-65,-61,47,10,-30,-93,-113,-86,13,29,-7,21,-3,-29,-38,12,27,-63,46,17,-65,-9,127,-14,-84,37,-79,34,-51,-2,-30,-33,-13,-74,2,10,38,-17,-31,-5,30,-22,49,-7,55,-1,61,-5,-46,-31,42, 
  /* [22][0][][] */ -27,56,20,-15,-5,19,18,-13,-34,19,46,62,-4,-55,-16,28,-44,-37,-19,48,21,-6,48,20,15,-13,-76,-23,-35,23,30,22,-70,-7,40,-7,-4,6,11,-9,-8,31,-6,15,-58,11,-9,11,49,-6,-69,57,19,-7,29,68,-36,41,-28,-48,2,-50,-46,-2,-19,-42,-26,-52,-54,-49,47,-82,36,-43,-29,69,-16,-43,8,-1,56,-60,8,-36,-41,-25,-24,10,-8,45,-4,-31,-47,-39,35,4,-30,-46,-34,127,15,46,75,-23,-52,-28,84,2,-19,-6,-45,-7,-49,-13,48,0,-15,1,-87,-69,34,31,7,23,1,-23,-25,1,-25,-69,-9,41,1,-41,50,34,66,47,49,78,-7,63,-53,20, 
  /* [23][0][][] */ -94,1,7,-39,44,6,46,-51,-41,6,62,-17,5,62,-38,-27,57,28,-33,5,40,52,-36,22,53,40,-67,5,50,-15,19,-12,15,54,79,-60,-24,74,27,-25,88,-3,8,44,1,-45,21,37,8,-1,-6,-70,42,-39,-32,50,11,92,45,21,-7,-22,-1,2,15,52,2,42,-19,19,80,-110,3,-48,7,-23,6,40,54,79,-10,-87,-8,17,23,-8,-39,-21,-41,35,-54,-28,29,-98,118,26,-74,-37,-56,-38,-31,-61,-13,42,-76,-83,23,5,-36,-12,16,-11,-27,74,-26,16,17,-12,14,19,3,11,127,58,-6,-14,-65,25,-37,30,-24,-9,7,-45,74,58,-6,9,-11,21,-24,49,15,54, 
};
const TfArray<4, int> tensor_dimension62 = { 4, { 24,1,1,144 } };
const TfArray<24, float> quant62_scale = { 24, { 0.0011077873641625047, 0.0023456828203052282, 0.0018021260621026158, 0.0017433534376323223, 0.0022776026744395494, 0.0017986580496653914, 0.0012835236266255379, 0.0014001332456246018, 0.001622493495233357, 0.0015661434736102819, 0.0013498377520591021, 0.0014303842326626182, 0.0017065228894352913, 0.0014809163985773921, 0.0015798673266544938, 0.0013666448649019003, 0.0012194911250844598, 0.0014869297156110406, 0.0017888781148940325, 0.0012721149250864983, 0.0010804180055856705, 0.0015300313243642449, 0.0018456897232681513, 0.0018971143290400505, } };
const TfArray<24, int> quant62_zero = { 24, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant62 = { (TfLiteFloatArray*)&quant62_scale, (TfLiteIntArray*)&quant62_zero, 0 };
const ALIGN(8) int8_t tensor_data63[144*1*1*24] = { 
  /* [0][0][][] */ 0,-22,28,-78,68,95,-59,-8,50,24,-116,2,6,90,16,31,53,127,22,68,-21,-29,2,74, 
  /* [1][0][][] */ 14,76,64,98,-14,-96,-75,58,-2,-23,-120,127,101,1,25,-121,-37,80,-48,3,6,42,-63,-76, 
  /* [2][0][][] */ 35,127,84,52,-6,-53,67,32,-2,-27,-79,18,-30,-43,-18,-48,16,18,-73,-60,40,-84,-24,-23, 
  /* [3][0][][] */ 13,-72,-33,127,-8,14,46,125,55,24,14,-1,-59,-86,31,87,-21,-110,1,-12,4,39,112,-11, 
  /* [4][0][][] */ -127,26,19,17,32,-46,26,-96,20,-16,26,94,36,-81,-79,76,-53,20,-8,4,92,-7,-46,-60, 
  /* [5][0][][] */ 19,57,-59,-30,-59,-50,-27,-5,71,-67,-33,6,-37,31,103,-23,-64,88,12,77,-116,10,-8,-127, 
  /* [6][0][][] */ 71,108,10,-40,88,-2,31,109,1,60,-37,-51,100,-101,127,-11,-61,-36,39,-48,42,-41,-37,79, 
  /* [7][0][][] */ 64,-21,68,-10,21,-104,24,-47,-6,-19,21,-60,0,-22,73,40,-127,27,45,54,-81,-45,26,49, 
  /* [8][0][][] */ 1,51,88,-16,83,-105,-60,-63,-107,-75,-11,37,-80,-20,116,84,104,83,53,127,-15,-43,86,-52, 
  /* [9][0][][] */ -89,12,28,-127,86,-24,14,-3,17,36,54,3,61,-45,-4,117,5,-46,119,27,-25,22,-75,54, 
  /* [10][0][][] */ 81,11,-40,-16,10,-23,-41,47,6,57,-41,10,2,-107,-127,97,121,42,-22,0,48,-28,67,66, 
  /* [11][0][][] */ -10,36,110,10,45,-124,-121,6,24,-31,26,1,127,-21,-8,-59,38,36,7,-55,85,-57,-56,-30, 
  /* [12][0][][] */ -76,127,-21,68,50,29,-6,-91,-31,-58,101,24,-68,-109,59,3,94,86,-51,63,-19,-122,-41,-90, 
  /* [13][0][][] */ -7,16,-2,-92,30,-53,127,-21,-69,51,28,-12,7,45,94,-123,-22,90,58,34,-41,51,-45,9, 
  /* [14][0][][] */ -48,-80,-50,21,1,54,3,-32,55,54,28,13,104,-18,14,42,61,47,127,-16,89,31,53,0, 
  /* [15][0][][] */ 18,89,-8,-50,74,-22,75,-14,-127,-3,-65,54,-3,22,47,-35,-10,-44,28,30,-117,-39,46,27, 
  /* [16][0][][] */ -6,72,127,-39,60,-48,-8,79,-67,41,-42,-49,-40,42,37,-16,13,29,-59,7,-37,-28,33,23, 
  /* [17][0][][] */ 43,-41,-88,5,-9,40,-36,1,-96,-65,38,-50,-51,-89,50,104,-43,38,-45,55,6,24,95,127, 
  /* [18][0][][] */ -56,78,-58,-89,40,9,48,-5,7,-5,-127,-43,7,-72,15,28,-19,96,-22,-47,-43,-44,-40,12, 
  /* [19][0][][] */ 3,42,-52,-2,-12,-30,-95,-4,14,27,62,-16,56,30,-58,-52,73,-21,127,30,13,15,22,60, 
  /* [20][0][][] */ 127,37,-44,-53,2,-102,45,102,-72,-122,-34,114,110,-120,62,111,-101,-34,73,74,-65,-7,118,-50, 
  /* [21][0][][] */ 20,58,-49,-58,-9,-33,25,1,-31,-40,15,55,113,-27,53,127,69,21,-113,111,-76,62,8,-28, 
  /* [22][0][][] */ 10,-127,-95,17,44,-21,4,13,-15,-12,-38,-52,119,8,-13,88,-29,-15,27,-42,-8,-51,101,-44, 
  /* [23][0][][] */ 52,61,5,42,38,31,-31,-22,-6,51,-127,50,86,-36,28,-12,9,4,2,1,-20,-40,-59,-11, 
  /* [24][0][][] */ 108,16,-80,-69,-108,-83,-20,-21,-93,38,-57,-111,-1,-7,87,-88,-1,127,59,-35,-65,-6,-37,-29, 
  /* [25][0][][] */ -34,-127,80,-47,76,30,19,12,-119,56,-30,1,111,-51,8,-20,76,24,-70,-102,26,26,-11,88, 
  /* [26][0][][] */ 46,15,-7,-4,59,-45,61,-47,27,-127,-35,-93,-10,45,-40,17,3,94,30,37,101,40,19,19, 
  /* [27][0][][] */ 42,43,9,14,33,-22,7,11,-102,-127,19,-96,8,32,33,100,54,-10,40,35,-18,25,-17,7, 
  /* [28][0][][] */ -18,-41,-9,-7,-21,106,34,-8,-66,20,49,-5,110,-34,-52,26,84,0,-17,-6,54,-6,15,127, 
  /* [29][0][][] */ 2,-15,-49,7,102,-113,9,-77,-44,-82,-35,68,9,86,-71,-103,127,14,-62,75,-40,-40,105,-29, 
  /* [30][0][][] */ -20,47,17,15,58,-86,31,-43,17,10,72,-42,53,-33,15,-9,-10,127,-9,27,13,-11,-23,-17, 
  /* [31][0][][] */ -67,65,-22,2,31,-52,39,48,-19,45,-97,51,26,-7,48,20,-40,-127,3,-72,-58,-40,57,4, 
  /* [32][0][][] */ -95,84,-22,-20,-13,-36,50,16,-7,-127,-35,-26,63,91,114,-97,80,64,61,8,-84,-74,-51,44, 
  /* [33][0][][] */ 7,-30,73,-66,84,-99,-20,-14,-35,-110,-58,43,-63,-35,127,11,31,41,-73,65,-23,-78,-26,-24, 
  /* [34][0][][] */ 122,65,4,122,73,14,-71,17,-82,56,-127,37,79,-22,-10,-4,-3,123,-25,100,31,2,-63,3, 
  /* [35][0][][] */ 12,-13,-38,-55,94,-63,-6,-127,76,124,-72,21,-92,6,-9,44,-92,-8,-73,-19,46,91,30,67, 
  /* [36][0][][] */ 73,38,77,-60,39,-34,54,-127,-50,-87,-75,88,-104,-66,-20,38,-35,-49,108,-48,-74,21,40,114, 
  /* [37][0][][] */ -33,-3,5,-34,8,-30,17,49,-53,-23,-109,56,-45,68,8,20,-82,127,-26,-55,-5,4,120,-57, 
  /* [38][0][][] */ -46,-127,-81,29,-8,102,-12,-47,19,14,20,-10,15,-5,-44,-31,37,0,-72,-3,68,0,-73,126, 
  /* [39][0][][] */ -127,11,48,-26,50,-34,-27,-39,62,-10,5,-15,-80,-14,13,56,-51,-5,-25,-45,-28,-88,54,28, 
  /* [40][0][][] */ 9,4,-91,23,48,7,127,-40,-14,35,3,-17,-10,-25,-48,-56,-16,-48,84,-5,30,-26,-21,59, 
  /* [41][0][][] */ -91,106,-13,100,-72,110,98,-46,18,-53,88,88,86,-39,68,105,-34,-30,52,-127,96,92,35,-88, 
  /* [42][0][][] */ 25,-57,-9,32,-65,-75,-29,-104,-37,-1,89,-64,-25,-33,-10,120,-92,1,6,-57,-63,-7,127,-9, 
  /* [43][0][][] */ 3,66,7,-21,54,19,21,-26,9,-127,38,60,22,-73,-30,-12,-60,-1,-28,9,28,10,-13,63, 
  /* [44][0][][] */ 48,25,-21,53,93,9,42,21,13,31,0,126,-6,94,78,-36,94,3,31,-7,3,30,127,50, 
  /* [45][0][][] */ -45,-36,-18,46,-89,45,60,-26,69,36,17,-37,-28,106,-93,-69,74,40,-127,-63,72,-93,-98,-54, 
  /* [46][0][][] */ 97,12,-72,-71,43,28,84,-75,-58,-61,-76,6,-36,-42,-3,-1,65,-49,127,-45,-37,8,57,101, 
  /* [47][0][][] */ -89,56,-57,8,-31,-38,-57,36,60,-97,45,-25,87,33,9,-8,127,24,-20,-124,-59,2,-24,-6, 
  /* [48][0][][] */ -29,34,28,87,6,30,1,-127,-2,12,22,69,12,-6,6,-19,39,27,-20,-23,-25,-20,-60,-23, 
  /* [49][0][][] */ 4,1,-23,-75,79,-4,51,-78,-36,70,61,-21,-58,-24,-127,58,-73,28,27,85,-96,5,-66,-38, 
  /* [50][0][][] */ -38,57,-110,15,64,55,-127,-53,-29,-49,-118,-31,88,-19,7,5,70,-73,48,52,97,-15,-31,-8, 
  /* [51][0][][] */ -6,25,-51,64,69,83,24,127,-60,-2,16,-42,-15,55,8,-24,-53,34,-8,-37,-88,11,6,58, 
  /* [52][0][][] */ 15,20,38,12,8,-66,15,77,-7,-54,-71,86,-26,-13,33,127,64,30,66,-15,98,5,22,50, 
  /* [53][0][][] */ 9,79,-48,-36,3,127,1,32,-95,34,-13,81,101,64,14,-94,26,116,-76,-47,-92,16,-35,25, 
  /* [54][0][][] */ 2,-13,100,-62,16,-45,106,-15,-13,127,-28,-39,-17,35,-9,-15,29,58,29,23,40,40,12,5, 
  /* [55][0][][] */ -40,-92,34,43,-81,96,-33,37,47,117,-17,-55,-75,76,-23,-73,-106,-54,-92,20,-127,-24,-37,-29, 
  /* [56][0][][] */ 27,3,-29,-23,124,50,-37,87,78,-127,-60,57,10,-93,-8,83,-77,-11,40,-36,-53,-42,68,-24, 
  /* [57][0][][] */ -11,4,-24,29,-81,64,65,-127,8,87,71,-38,29,24,-21,-37,24,-22,19,-40,-13,-4,-20,-1, 
  /* [58][0][][] */ 42,96,-81,-5,37,-22,-31,17,127,-14,-14,37,-89,6,-11,0,-18,53,9,82,3,-40,70,-86, 
  /* [59][0][][] */ 50,-22,-16,46,33,-95,36,1,36,-15,-28,-22,-62,-127,51,29,-11,42,89,-42,-37,6,38,-20, 
  /* [60][0][][] */ 94,32,127,41,36,1,40,-55,-89,80,-25,82,33,-45,-79,82,-67,8,99,61,38,19,19,-70, 
  /* [61][0][][] */ -13,33,27,63,42,16,-8,127,20,-6,-8,-26,20,76,-34,68,47,-16,-79,-42,76,47,31,57, 
  /* [62][0][][] */ -43,-39,-75,-25,27,-55,42,6,-64,-67,4,13,6,3,-127,62,-14,30,-25,-24,-6,-31,-45,-59, 
  /* [63][0][][] */ -22,-127,12,-106,28,-6,-34,-7,-30,5,38,25,101,-26,-48,94,-61,79,82,5,103,13,49,-7, 
  /* [64][0][][] */ -11,2,-70,7,41,21,34,25,-77,-61,-55,-10,3,-69,-14,-21,-124,62,13,-11,-43,4,51,127, 
  /* [65][0][][] */ -8,16,6,-61,59,-43,62,-25,61,50,-22,127,26,16,-27,-57,-79,26,32,-19,-82,-8,40,53, 
  /* [66][0][][] */ -69,-21,72,-89,43,-101,44,-62,-7,-9,-127,30,26,-71,3,-29,-40,-43,15,17,-23,-25,83,76, 
  /* [67][0][][] */ 50,-14,-84,-53,-68,-59,64,20,46,-32,-2,-20,122,-14,73,-4,-48,-37,127,80,-76,-58,-5,40, 
  /* [68][0][][] */ -32,32,22,-3,21,66,50,103,-38,-27,-32,14,85,-47,46,-60,-67,-43,102,32,-45,127,33,-57, 
  /* [69][0][][] */ 109,-34,39,-101,11,31,28,-127,-113,-74,73,-124,94,62,6,61,-79,17,2,61,-3,-93,68,-39, 
  /* [70][0][][] */ -36,12,127,-28,-11,-7,-24,-89,44,-54,24,57,20,-66,-1,70,61,86,122,-41,115,26,26,-51, 
  /* [71][0][][] */ -22,70,-127,23,67,-44,-44,-98,-17,-64,-93,-58,48,71,33,29,44,71,-29,-50,61,-80,-111,-25, 
  /* [72][0][][] */ 53,25,89,-92,1,-89,54,8,-6,-46,14,-61,36,-114,-29,-94,80,-127,32,76,28,-29,-62,31, 
  /* [73][0][][] */ 14,-14,-127,-3,-43,30,67,-2,4,31,-32,-66,-20,46,-9,59,-83,30,-4,-10,-77,105,40,25, 
  /* [74][0][][] */ -9,102,4,-37,-27,18,127,-4,4,-103,-3,-19,-13,-65,7,63,27,31,91,99,-21,41,-35,-59, 
  /* [75][0][][] */ -22,-20,-61,-44,4,-62,25,13,-44,-51,9,-98,-9,-127,-69,50,-90,-2,57,5,-17,-72,39,-57, 
  /* [76][0][][] */ 13,-31,34,-9,42,14,127,5,-19,-37,-65,10,-42,-34,49,62,-74,26,-126,8,-8,-34,-26,-50, 
  /* [77][0][][] */ -49,-33,-127,-24,39,-1,67,-11,-72,53,33,103,49,-2,-14,22,100,-100,74,57,65,6,66,13, 
  /* [78][0][][] */ 45,122,-44,-19,-20,-53,-5,40,12,-35,-48,3,-127,32,13,-39,-63,2,59,74,-81,-21,-16,33, 
  /* [79][0][][] */ -37,-1,-59,40,17,-85,114,81,-44,8,13,54,42,3,10,95,24,20,85,-23,49,-127,-33,-40, 
  /* [80][0][][] */ -31,-98,-73,5,1,77,41,-75,49,108,53,-26,-61,18,-4,-43,-127,112,99,-27,-1,76,92,-56, 
  /* [81][0][][] */ 127,-36,-31,27,79,-34,-54,38,-11,-35,-4,-29,-102,11,9,-91,-48,26,117,-95,7,5,6,13, 
  /* [82][0][][] */ -45,1,-52,-25,75,44,37,-42,-21,25,-57,-62,-122,47,30,-57,-109,28,127,-5,-14,-67,19,60, 
  /* [83][0][][] */ 101,-9,65,127,15,-22,-32,-7,-64,41,-15,99,30,-41,15,22,7,-37,19,85,24,63,13,11, 
  /* [84][0][][] */ -36,19,20,45,48,56,-37,18,37,-127,-40,68,24,-40,-58,54,45,13,-4,44,54,24,62,2, 
  /* [85][0][][] */ -81,127,-71,105,-66,-65,0,29,22,28,-68,-40,73,-13,-31,-50,39,38,37,-14,68,-60,95,-14, 
  /* [86][0][][] */ -29,15,-38,-24,42,-21,-20,127,47,85,11,72,24,-52,-74,29,5,94,7,-39,32,4,-61,11, 
  /* [87][0][][] */ -10,-35,-14,-11,-10,91,26,-15,-60,31,32,-1,91,-19,-51,28,70,-13,-20,-1,43,6,13,127, 
  /* [88][0][][] */ -24,-44,-71,3,37,27,-35,-127,-9,34,12,20,-9,-25,1,-15,4,51,6,22,-39,-3,2,14, 
  /* [89][0][][] */ 40,73,42,5,-3,-5,-34,-62,-109,-85,12,64,-59,-65,1,-47,-52,127,-25,-64,-21,40,21,13, 
  /* [90][0][][] */ 22,-82,-19,8,-106,127,49,79,-27,32,66,-74,-7,126,-71,-18,-8,3,-14,6,-24,-16,20,-79, 
  /* [91][0][][] */ 108,54,-16,39,58,16,63,-54,-80,74,-12,-5,31,-16,-22,65,-65,-27,5,33,127,56,-11,-41, 
  /* [92][0][][] */ 21,-13,-4,-38,38,-62,-99,-127,-115,17,-24,-88,-46,-39,-112,33,8,31,-45,16,-57,-80,18,-7, 
  /* [93][0][][] */ 34,64,5,17,0,63,-16,5,7,-29,-33,61,9,0,45,-14,127,62,-19,-21,69,9,-62,25, 
  /* [94][0][][] */ 35,27,10,25,95,41,-54,80,26,41,34,-17,127,51,-27,-88,-56,111,-20,29,7,-96,-39,-18, 
  /* [95][0][][] */ -40,122,-90,36,-35,127,71,-53,20,-16,71,8,48,-14,21,-36,-1,0,45,-22,-37,10,53,29, 
  /* [96][0][][] */ -127,50,-55,94,34,-40,-44,108,85,65,-90,105,-102,-66,4,-59,95,25,14,-43,-5,83,-70,79, 
  /* [97][0][][] */ 32,-8,-57,39,33,-36,-80,10,-4,1,-3,13,31,-37,-19,3,-104,-68,-27,-1,-38,-37,127,-31, 
  /* [98][0][][] */ -80,67,-79,-127,118,95,-113,117,-7,-12,70,18,43,-26,48,-40,9,110,-62,-13,-16,-88,12,116, 
  /* [99][0][][] */ 57,-10,-38,-9,6,-112,-90,-80,33,35,31,-18,-42,77,-59,78,87,91,-85,-24,-24,-127,-17,80, 
  /* [100][0][][] */ -7,18,26,-30,70,-46,-19,-33,-48,31,-21,-127,-29,61,35,35,-59,11,-40,3,-84,1,-46,-117, 
  /* [101][0][][] */ 41,14,-5,-127,15,2,37,2,-26,24,-9,-15,-5,-29,-79,-18,40,102,43,60,-63,-89,-73,2, 
  /* [102][0][][] */ 25,1,22,6,-11,62,-60,-124,-33,59,91,-127,-67,40,-31,-11,72,117,-22,60,66,84,-4,-120, 
  /* [103][0][][] */ 113,-25,40,5,9,-9,-32,-28,23,71,-2,127,-41,-9,-38,-33,-53,-20,52,-33,39,55,-32,14, 
  /* [104][0][][] */ 92,95,-69,-59,-23,-7,127,-31,-80,-67,-75,32,28,64,93,34,-26,26,105,80,-95,-29,-31,58, 
  /* [105][0][][] */ 49,8,37,8,15,-24,-50,2,31,0,85,-127,33,-38,-61,46,23,-103,-5,38,-26,-24,10,27, 
  /* [106][0][][] */ 52,61,-127,75,58,-115,118,0,-58,-41,11,-58,-102,-71,-34,-93,-64,-29,55,-39,-76,26,-23,-80, 
  /* [107][0][][] */ -21,-34,-69,45,55,-127,19,-31,-47,91,58,31,55,48,-7,102,-5,0,-4,-52,-97,-121,28,22, 
  /* [108][0][][] */ -78,62,-25,61,36,-77,-33,7,-4,-64,-8,0,127,-76,40,54,-30,11,28,-71,54,-15,61,13, 
  /* [109][0][][] */ 102,-37,56,-26,50,-55,44,82,23,40,59,-69,-49,-41,-98,6,1,5,-7,-45,-81,-54,-105,127, 
  /* [110][0][][] */ 64,-105,-81,-112,-4,79,-120,28,96,25,81,56,51,75,46,78,-71,26,-127,-108,-26,107,-108,-61, 
  /* [111][0][][] */ -24,11,-92,34,52,127,20,-54,-19,45,0,5,52,-26,-5,69,68,10,59,4,19,39,90,110, 
  /* [112][0][][] */ -38,-15,105,7,127,-59,-54,72,-82,-93,4,67,13,15,-9,27,-50,51,47,-34,17,-58,29,8, 
  /* [113][0][][] */ 5,-127,11,-8,107,54,-16,44,-82,-2,16,-49,-7,-114,51,37,89,103,-15,-96,59,-73,35,-57, 
  /* [114][0][][] */ 8,127,-92,55,4,-18,-14,-17,81,-63,9,-11,-117,31,-12,5,-39,-14,40,119,-19,-39,16,-74, 
  /* [115][0][][] */ 92,25,-70,-127,93,-55,-41,41,2,20,16,-24,4,24,-18,-53,28,-82,61,94,-90,18,-52,-30, 
  /* [116][0][][] */ -127,-28,-36,-102,-21,-55,68,-18,57,-71,64,-73,-69,15,-6,-21,30,-33,3,-33,-42,13,49,70, 
  /* [117][0][][] */ 3,-2,-83,6,11,53,84,-7,52,52,47,-50,68,-49,-33,-127,-35,-53,-51,-44,-87,-9,-33,-32, 
  /* [118][0][][] */ -28,-72,42,31,127,-59,-18,66,3,-4,119,4,-39,29,-49,28,-79,-80,-44,0,-65,98,108,70, 
  /* [119][0][][] */ 49,-69,42,-99,25,55,55,91,-53,127,51,30,-70,-68,25,126,-74,50,73,79,-64,-49,101,59, 
  /* [120][0][][] */ -55,30,-8,6,9,-4,-50,-8,-19,-13,63,24,-1,18,48,8,-42,-33,-34,-14,127,54,-17,20, 
  /* [121][0][][] */ 58,-26,3,-22,5,-20,49,1,-3,9,-52,-40,1,-9,-35,7,32,59,32,31,-127,-43,22,-18, 
  /* [122][0][][] */ -41,43,-53,-9,-53,23,-6,-53,-8,61,-48,-16,2,-127,68,46,35,15,54,53,-49,-12,55,49, 
  /* [123][0][][] */ 13,-61,-121,-78,87,6,72,37,127,103,16,-53,44,71,62,78,17,-92,-3,-29,11,-19,-7,-39, 
  /* [124][0][][] */ -60,84,67,-46,-66,-23,-9,-93,22,-127,-21,42,47,-55,-98,58,18,88,14,57,49,12,59,-35, 
  /* [125][0][][] */ 8,7,-126,48,13,-47,54,87,-45,-38,-49,-33,2,-57,9,-44,-79,52,-21,29,-10,-68,64,127, 
  /* [126][0][][] */ 4,-29,-9,10,16,-1,-27,5,14,-41,74,80,65,-11,-64,127,69,-6,-58,2,91,-82,30,6, 
  /* [127][0][][] */ -63,-29,-2,61,127,-44,-40,29,-24,29,-114,-72,-42,-21,57,92,108,84,84,32,48,-18,45,-105, 
  /* [128][0][][] */ -65,73,7,123,-24,103,75,126,-25,-69,70,-12,-2,0,-72,55,17,-44,127,-73,-77,-77,45,59, 
  /* [129][0][][] */ -16,-34,7,-76,81,24,127,70,-12,19,-41,97,-7,-62,14,-39,36,62,-20,-34,-68,48,-1,-19, 
  /* [130][0][][] */ 14,56,42,-15,28,19,9,6,35,31,2,-22,16,-22,124,-52,2,13,66,14,45,-16,127,9, 
  /* [131][0][][] */ 114,54,-10,25,75,-41,33,51,74,-41,-14,83,57,32,85,-33,127,-27,10,-56,-71,57,30,16, 
  /* [132][0][][] */ 13,32,-2,-48,50,-13,37,-46,-35,2,-75,-59,-24,13,53,-127,39,19,19,68,-64,-16,5,-49, 
  /* [133][0][][] */ 13,55,-40,-54,56,-79,99,127,69,17,-66,-4,15,62,-38,5,-60,-53,41,88,6,-25,61,24, 
  /* [134][0][][] */ 55,-33,30,-42,57,-127,-17,-37,53,-40,-52,17,-2,-43,56,34,7,51,48,3,-1,-61,-13,-53, 
  /* [135][0][][] */ -100,45,-1,-62,16,-26,11,48,79,66,83,127,10,32,88,-44,14,47,5,61,-92,-25,-79,-41, 
  /* [136][0][][] */ 52,41,21,-78,58,16,66,-25,95,-78,16,-6,27,5,13,-112,55,-19,-96,-127,6,-82,3,5, 
  /* [137][0][][] */ -60,127,44,9,100,-5,-83,11,-36,6,-85,-11,-24,-34,-101,82,13,-1,-117,3,46,28,48,40, 
  /* [138][0][][] */ 43,-34,6,25,127,67,-61,14,-4,75,66,-16,0,2,38,31,71,19,64,26,-54,74,68,90, 
  /* [139][0][][] */ 33,-8,-89,32,-80,20,127,-75,13,0,100,-19,19,51,-10,-82,18,56,125,-49,-45,-117,-52,4, 
  /* [140][0][][] */ 68,51,51,36,45,6,24,-93,-6,-93,-127,-75,81,58,93,-18,31,-37,40,1,-28,46,49,10, 
  /* [141][0][][] */ -2,11,-48,-70,-21,-120,104,30,-16,-43,64,-16,8,-127,15,-26,41,-21,-37,-59,-2,108,124,-77, 
  /* [142][0][][] */ -94,0,-45,-80,-24,-96,10,47,-59,127,-13,0,17,-110,37,-55,-23,-4,58,100,-73,-63,33,5, 
  /* [143][0][][] */ 74,94,27,4,20,23,-91,-31,-3,44,74,-46,4,-46,11,-19,127,-72,18,64,3,-11,-62,95, 
};
const TfArray<4, int> tensor_dimension63 = { 4, { 144,1,1,24 } };
const TfArray<144, float> quant63_scale = { 144, { 0.0015281946398317814, 0.0012037517735734582, 0.0019372283713892102, 0.0014526876620948315, 0.0019735249225050211, 0.0016419705934822559, 0.0011519994586706161, 0.001636238070204854, 0.0010273064253851771, 0.0015261683147400618, 0.0017364784143865108, 0.0017186695476993918, 0.0015782152768224478, 0.0019249736797064543, 0.0015461979201063514, 0.0016676669474691153, 0.0016973306192085147, 0.00081352534471079707, 0.0017958177486434579, 0.0020601172000169754, 0.00086292705964297056, 0.0014372851001098752, 0.0017050196183845401, 0.0018899148562923074, 0.0015421092975884676, 0.001307149650529027, 0.0017720776377245784, 0.0021092535462230444, 0.0016573310131207108, 0.001813455717638135, 0.0022931790444999933, 0.0014075541403144598, 0.0012933391844853759, 0.001543969614431262, 0.00097725691739469767, 0.0016575566260144114, 0.0012329609598964453, 0.0017129824263975024, 0.0012994180433452129, 0.0015801017871126533, 0.0017481907270848751, 0.0011344630038365722, 0.0014861330855637789, 0.0019764441531151533, 0.0011465882416814566, 0.0008929421310313046, 0.0014182779705151916, 0.0013930426212027669, 0.002446003258228302, 0.0017803976079449058, 0.0016407429939135909, 0.0022248360328376293, 0.0016741742147132754, 0.0014947230229154229, 0.0025682628620415926, 0.0012794235954061151, 0.0014002732932567596, 0.0017865708796307445, 0.0015670908614993095, 0.0011293672723695636, 0.0012504513142630458, 0.0018260774668306112, 0.0021902995649725199, 0.0018897356931120157, 0.0015536536229774356, 0.0020748947281390429, 0.0016578965587541461, 0.0014795886818319559, 0.0015029301866889, 0.0015785794239491224, 0.0013405695790424943, 0.0014219456352293491, 0.0015868700575083494, 0.0017361508216708899, 0.001623378018848598, 0.0015147499507293105, 0.0019553685560822487, 0.0014450950548052788, 0.0015808936441317201, 0.001400112290866673, 0.0011052658082917333, 0.001740852021612227, 0.001631068647839129, 0.0013714865781366825, 0.0018927672645077109, 0.0017386401304975152, 0.0021688500419259071, 0.0017481301911175251, 0.002770870691165328, 0.0019761782605201006, 0.001069049583747983, 0.0015492624370381236, 0.0016582740936428308, 0.0020469063892960548, 0.0017434636829420924, 0.0008853183826431632, 0.0015225021634250879, 0.001774779986590147, 0.0015477824490517378, 0.0016227915184572339, 0.0019961451180279255, 0.0019873478449881077, 0.0012524867197498679, 0.0020232542883604765, 0.0015461230650544167, 0.0021461865399032831, 0.0013669236795976758, 0.001573823974467814, 0.0015143905766308308, 0.0014203299069777131, 0.00069482688559219241, 0.0012232005828991532, 0.0015537309227511287, 0.0017441657837480307, 0.0015604584477841854, 0.0013294534292072058, 0.0014652807731181383, 0.0019170005107298493, 0.0011866202112287283, 0.0010300251888111234, 0.0026904416736215353, 0.0023676559794694185, 0.0014261994510889053, 0.0012692306190729141, 0.0016608319710940123, 0.0017443378455936909, 0.0018979188753291965, 0.0018159205792471766, 0.0014110897900536656, 0.001664945506490767, 0.0019815033301711082, 0.0018186770612373948, 0.0022454611025750637, 0.0014411064330488443, 0.0015927761560305953, 0.0014986104797571898, 0.0013392235850915313, 0.0017502343980595469, 0.0019024750217795372, 0.0014004920376464725, 0.001881137490272522, 0.0011273199925199151, 0.0014610703801736236, 0.0018563610501587391, } };
const TfArray<144, int> quant63_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant63 = { (TfLiteFloatArray*)&quant63_scale, (TfLiteIntArray*)&quant63_zero, 0 };
const ALIGN(8) int8_t tensor_data64[32*1*1*144] = { 
  /* [0][0][][] */ 2,25,35,-8,40,-6,19,59,11,17,-41,-20,-44,59,10,17,-83,-57,86,-8,63,20,-17,2,38,-3,12,127,-51,22,35,-67,-10,-1,-26,78,4,-60,-43,26,11,-46,-25,-17,113,-49,-42,6,9,97,95,33,-94,-5,-52,-71,25,-30,7,-20,-27,65,5,-29,51,-98,-32,-11,-71,99,-24,117,52,126,-10,23,43,-23,-1,2,-1,-13,23,-92,-19,3,21,-54,73,-25,75,46,77,-59,-47,38,-74,25,-8,45,13,37,5,7,-43,-55,24,-1,-5,-8,-42,-64,-64,-16,-108,-56,101,54,-10,-72,45,-69,4,39,24,-5,6,-1,-4,18,-34,-35,-11,3,85,-27,27,-5,-45,63,2,52,20,-14, 
  /* [1][0][][] */ -37,4,-4,4,14,17,47,-59,30,-14,56,4,-62,-34,-50,-19,-33,-98,-47,106,26,-47,-36,9,-21,-30,58,-24,-75,-2,-26,-4,-50,-127,-25,-24,45,76,4,57,-21,4,8,117,-15,25,-116,-5,69,-35,62,-14,0,-26,13,15,10,30,-64,16,-35,-48,35,51,11,-47,56,-33,67,73,44,-2,59,4,29,-13,-71,68,-3,9,-3,27,-69,-19,-24,-46,63,-74,-88,-13,-9,69,-19,0,69,-24,-91,48,38,-40,-15,-19,-22,-17,18,-26,-30,8,46,24,34,-56,72,43,33,-21,-93,10,6,12,121,-118,80,24,-29,42,-55,-45,-15,43,2,1,-91,59,-5,5,15,26,35,-35,-71,28,4,-10, 
  /* [2][0][][] */ 69,25,-39,-1,-15,34,-22,31,2,-29,27,43,-1,-55,34,38,58,37,-3,42,-9,43,71,-47,-29,-35,22,-38,15,-4,58,-55,3,10,50,64,-13,127,17,-24,56,-15,-7,15,6,7,-21,25,31,27,39,28,63,68,1,-42,-18,-10,-57,-10,-47,66,-5,-3,31,30,-36,0,-125,-9,2,44,33,-39,-7,-74,16,-3,-43,34,-20,44,-53,-19,6,-15,-12,13,-33,72,22,-34,0,14,27,30,51,18,12,91,1,46,69,-13,8,44,-53,-74,-51,45,6,-101,51,-58,49,23,4,-17,-55,7,74,-64,14,-44,12,-69,32,-112,41,35,-58,18,-68,-4,16,-17,20,-14,-53,12,-11,-83,-83,65, 
  /* [3][0][][] */ -14,5,64,-43,17,37,45,-52,44,27,26,-52,21,51,-44,-28,-81,22,-10,52,-81,-68,46,2,9,-40,-25,3,25,-7,71,-127,3,-43,-9,10,-14,-39,49,47,-15,21,39,71,-1,-39,20,12,27,44,6,-3,-44,11,-26,-45,69,-7,-54,-55,3,28,-43,-49,-47,56,-38,68,115,2,-35,14,-21,-22,-35,-8,-91,71,51,54,-35,16,-26,1,12,16,65,10,61,-2,17,84,27,-25,14,-14,8,-7,17,-57,-25,47,-31,-3,-70,54,32,-64,-17,8,21,78,86,20,14,-34,-18,44,35,-20,16,41,-47,-12,-48,-109,20,0,-29,-43,65,38,-15,-27,13,-4,-15,-90,34,32,-11,55,-40,21, 
  /* [4][0][][] */ 11,-38,26,20,33,30,-7,15,-15,27,38,-30,30,-46,-22,-44,-56,-53,-7,23,-87,54,-2,-33,9,6,-4,26,41,36,-38,12,-21,21,2,67,-91,-84,-5,-33,2,22,-56,22,-46,35,69,-6,-8,-27,-9,55,-56,46,14,28,50,15,-11,-21,-14,0,-13,-37,13,-13,-18,34,-79,8,13,-1,16,-10,-36,11,-59,16,-55,-3,-18,15,-20,-27,13,61,-25,21,57,-35,2,-24,51,-53,-68,-30,4,-5,22,60,-37,9,-29,-10,60,-41,-46,127,-7,10,-23,58,-16,45,43,-23,-12,-34,119,56,-37,16,-43,40,-58,-27,-33,0,20,-8,20,-14,1,20,54,-8,-33,-26,-5,21,-8,-41,-61,53, 
  /* [5][0][][] */ -10,-9,-16,8,-50,8,30,-57,-13,50,27,53,10,18,-46,22,-82,24,-2,69,76,127,-30,-20,-48,-78,-46,-94,4,1,22,-89,-12,52,-38,-42,31,-97,-32,3,-46,32,40,51,-40,45,82,-49,-10,-11,43,17,69,-2,-60,30,41,-30,-22,-36,51,56,76,-50,-18,68,-8,-24,-71,-70,-50,33,-26,-96,12,54,-49,82,77,-30,13,31,-81,24,-49,13,-10,18,-3,-75,39,-42,-75,-63,24,1,78,0,16,5,9,40,9,-23,15,13,2,-38,49,0,-32,87,-25,-76,30,-40,9,-25,-55,14,8,-8,3,12,24,11,-44,11,-37,-21,-67,59,-43,-24,-5,-7,-25,-9,43,-1,-80,67,109,-9, 
  /* [6][0][][] */ 18,37,42,12,-54,26,-22,-37,31,32,30,22,12,43,-69,-9,65,75,-35,43,-24,92,-48,-11,-27,69,-12,-12,-10,30,39,-46,-101,-43,43,38,26,-15,-12,13,-31,32,28,-88,-2,-1,-90,9,26,62,55,-7,-71,-39,19,-36,-25,70,4,42,37,-23,67,69,-2,-19,-15,11,31,-40,-8,13,17,8,-3,-32,-48,-33,27,61,60,-52,-23,62,51,39,15,-3,-17,-14,19,-13,53,-101,55,28,18,22,-9,-29,33,-13,-1,-17,-51,-38,-8,-79,-127,51,31,-120,-49,12,-1,-32,-102,-9,90,-8,-34,25,35,-23,-50,-86,-17,8,-38,0,-66,41,-13,-47,-33,-46,29,77,20,25,-36,63,57,39, 
  /* [7][0][][] */ 22,33,37,-34,-25,32,99,38,-14,-30,5,-22,-12,-8,51,5,22,-2,-34,-1,32,27,-19,37,27,-64,39,-28,33,-22,-88,42,9,-4,6,37,-59,-47,4,33,-14,30,69,-33,10,-20,55,34,19,13,9,13,6,-2,7,-1,27,-21,-1,11,-11,5,-57,-7,4,-54,20,-28,6,13,1,30,32,4,-14,-43,8,59,-14,9,31,45,17,33,37,17,-68,29,-18,-47,-15,53,-31,27,-27,3,-3,20,-6,-33,-12,-20,52,28,66,-6,33,-72,-72,19,-36,-26,-53,-2,127,-8,-7,-25,-44,9,-21,-4,-18,58,-3,15,9,1,20,38,53,52,29,83,6,17,13,24,-19,16,-15,28,1,51, 
  /* [8][0][][] */ -8,-25,-31,12,27,-72,-44,-32,-79,10,-1,-42,1,-16,16,-6,58,-52,-27,-10,33,93,-16,10,12,-48,35,75,123,28,-71,-55,-33,13,-38,-3,15,-55,-16,-6,36,9,-5,11,-18,8,12,-8,14,-24,23,19,16,1,32,5,-20,44,-49,-51,-2,-13,31,-23,-60,-77,-35,-12,40,-33,7,-31,19,-1,-10,-37,12,-11,-69,15,36,51,-19,42,-29,18,3,127,-5,-12,-18,16,31,20,-19,46,1,-69,-35,-29,82,-14,33,-72,-39,-12,51,-23,-68,10,38,-13,6,-34,67,-100,-16,-57,-3,-73,17,-26,30,18,15,-16,63,33,5,-36,-37,-24,-1,26,36,-14,-13,62,11,16,24,10,29,1, 
  /* [9][0][][] */ -44,1,-23,0,-17,-33,-10,-13,14,34,19,38,-32,28,4,55,-28,28,-105,61,-72,-104,12,18,8,88,4,-7,35,54,1,66,24,-35,-106,-38,-19,-45,10,-8,-11,5,-11,40,-11,20,75,72,-11,16,15,-35,-28,1,38,10,-111,-65,45,13,-63,22,60,-12,-41,0,28,31,-98,84,4,27,112,-1,49,34,-36,95,46,-34,-4,29,14,-12,49,-39,2,28,2,23,-59,31,45,10,4,-29,-53,-17,-58,62,8,59,32,-8,-3,-29,19,14,-2,12,28,-43,-17,-49,-127,12,32,70,-22,-73,-16,22,52,18,15,-78,-18,-59,-22,25,9,11,16,-34,-13,46,-11,-48,2,-44,14,-4,52,13, 
  /* [10][0][][] */ 11,31,43,-18,39,-20,15,-39,15,-23,17,-36,6,94,59,-61,35,17,55,-20,-31,46,8,36,20,-115,-3,-32,127,16,50,-21,-3,59,-35,33,-24,107,25,22,16,22,-25,-55,-22,-21,-36,3,10,18,-62,15,-13,19,-31,11,-75,8,-45,-10,9,14,-9,42,27,37,-18,43,-113,52,-42,-20,-20,-2,9,-26,22,-4,-47,-16,22,41,71,-80,81,-2,-12,118,0,-25,67,18,-2,-79,-59,1,-32,5,15,42,16,-2,-44,-22,24,-16,32,103,-33,26,23,32,15,-35,102,52,-50,-32,-63,53,31,-66,-1,-5,-50,30,12,-13,-38,-23,7,-71,-25,64,-11,-35,22,-32,-3,-7,-40,94,44,-34, 
  /* [11][0][][] */ 8,-13,1,-5,15,-34,-20,-9,-41,-28,51,-9,-12,-47,5,-22,-45,62,-39,29,17,44,6,-19,-40,35,-60,58,-52,43,6,123,-41,-32,103,-21,62,43,9,38,13,-21,-13,-127,-64,-54,3,33,-42,12,15,52,9,-13,-19,-15,-4,-22,50,-3,38,-11,-19,-15,-53,-7,-11,10,5,-6,20,65,-56,16,-3,-47,-48,27,65,-52,31,-62,-47,95,15,-58,6,-46,16,4,52,65,11,-26,-32,23,23,85,-64,44,-4,-48,30,-5,-36,-22,16,104,30,34,69,12,36,-28,22,24,-68,-15,64,-65,-14,0,-22,-16,-2,-16,7,70,-46,-11,12,29,-36,6,13,-18,30,31,-63,54,46,-1,20,-4, 
  /* [12][0][][] */ -46,37,8,-4,-31,38,-32,-92,-43,-38,60,-52,22,22,-4,78,14,-77,61,23,-7,-21,33,-11,-57,48,44,23,-9,19,33,-94,-72,-112,37,59,-24,19,24,9,-12,-60,-23,12,-15,-46,-23,7,3,36,-38,-5,25,42,6,-23,-92,-63,-22,-29,-10,-59,8,-33,47,-43,-5,37,-25,-111,18,-18,-14,10,-59,54,-27,51,-108,-56,-41,-59,-17,36,6,-37,23,-3,12,30,-32,75,7,22,-35,-42,116,-68,-9,23,-21,44,78,7,-9,2,53,-9,-26,-37,29,74,-127,24,41,31,25,-50,29,-23,60,-77,-56,-29,21,-60,-9,4,-18,-85,-33,-9,-6,-43,-24,42,-23,60,11,80,-68,67,-9,-1, 
  /* [13][0][][] */ -127,-24,-4,14,-39,-16,30,51,37,-15,-72,58,79,-43,52,2,13,29,-9,7,-13,53,29,-49,-35,-63,29,62,71,-17,31,61,26,-13,-20,-10,5,-124,21,29,-49,-6,-7,105,40,14,-39,-92,-39,-3,-10,-50,-27,-21,-4,50,-50,-25,2,12,7,-15,-27,-20,19,-36,34,-51,-21,-18,-32,73,0,-9,-24,34,-26,-119,-10,10,8,-46,8,-15,26,-39,16,65,29,-16,-7,-47,-12,2,26,-64,48,80,13,-3,26,-40,10,23,-35,-37,89,41,67,-9,18,-5,-26,-6,35,4,-31,63,64,-84,29,-47,6,-13,-47,36,17,-72,64,65,-64,61,-61,-25,-37,-33,6,-6,12,-47,36,27,-65,25, 
  /* [14][0][][] */ -24,7,-35,14,-14,-15,46,39,22,25,52,-8,-45,-66,-23,-9,-55,-3,33,-17,-7,86,-24,-29,-40,-47,81,27,15,-43,21,-44,-100,-4,40,-10,-23,30,11,-37,0,-25,-34,-52,43,24,63,31,12,4,-7,-6,83,-10,-33,8,44,6,-5,-25,22,20,26,22,18,-23,-11,-16,66,99,9,-12,-2,14,-82,100,8,-11,10,-26,-7,-44,-53,23,11,-2,-6,19,-16,-13,-18,51,-20,-50,-22,30,-108,-10,-80,-47,-14,41,-43,-27,3,-21,1,-37,4,-13,48,-15,-1,-38,-16,-7,-91,-51,-60,32,-127,123,-31,-25,-22,-35,-3,-22,-24,8,-66,-53,-5,17,-29,7,7,-40,-3,15,28,38,-45,-39, 
  /* [15][0][][] */ -14,24,22,-5,-6,-41,-3,-28,-3,-1,32,3,-7,-26,26,12,-5,38,-6,-54,14,-44,-25,-9,-51,30,-22,-14,38,14,-58,85,-12,27,2,32,-53,2,-3,-16,-33,4,9,59,32,-14,27,63,-2,27,53,4,-6,-11,-40,3,127,42,-3,46,-4,-13,52,8,7,-6,28,11,4,-19,-3,3,-32,-50,-1,49,21,4,23,1,48,-41,88,2,-36,23,-23,46,-23,31,1,-26,40,-29,-37,23,47,66,6,-28,-25,11,-51,3,-53,1,16,-64,-39,26,-4,-32,53,-16,-6,-8,-11,-1,23,-9,11,-53,10,-43,30,-2,-14,0,28,-10,-39,-18,-4,-38,11,12,-21,38,-32,35,-8,-80,-44,-17, 
  /* [16][0][][] */ 0,-23,20,0,0,-29,-105,40,22,-57,46,-27,-7,-15,34,-5,-26,6,-30,38,26,14,-4,50,16,-41,100,14,21,63,5,-127,-31,-11,-37,10,11,68,11,12,22,18,-21,11,26,17,29,24,27,11,12,10,-17,-18,-9,15,15,18,-30,-1,15,3,11,15,-3,-16,27,3,-28,24,-41,-24,-23,45,16,28,-12,0,38,75,1,8,-3,22,-44,-27,-24,16,21,46,-4,-6,18,-23,13,12,-24,59,-4,42,0,-39,60,45,-48,-18,7,-68,16,-4,-3,81,-50,-3,79,32,70,30,97,-11,-47,56,22,-57,21,29,-22,3,0,5,13,6,-10,-11,-15,74,23,63,30,34,45,40,-34,-4, 
  /* [17][0][][] */ 12,70,-3,-91,45,-42,-98,-118,108,-8,25,-49,-12,-75,-15,12,-29,45,50,30,4,100,10,-66,-8,-127,-102,-53,13,-27,-87,77,5,-66,-64,-19,16,19,25,31,56,-41,-13,-9,-7,-30,-64,2,-10,-45,52,-68,-81,3,4,-53,57,-19,-116,89,6,-70,20,-3,-22,66,-69,-20,-61,-46,12,18,23,93,3,-26,-53,-67,-77,74,-37,0,-33,-125,-42,-62,65,18,3,-39,-76,-72,2,36,17,-86,3,95,82,95,12,7,2,28,-98,-31,-35,41,-15,-40,-17,59,-118,5,103,-23,11,120,-65,-120,-35,63,0,65,32,-100,-40,-65,52,-12,-20,-15,41,37,-15,-41,-3,28,13,-26,60,-70,19,29, 
  /* [18][0][][] */ 1,17,35,-44,31,29,-6,-38,45,-87,-1,0,-32,22,67,-56,-109,-22,8,8,60,93,36,-13,62,67,-14,28,-20,36,-73,18,1,69,21,65,-62,72,-10,71,-38,-13,19,-7,17,23,78,4,34,-55,3,-18,50,0,6,17,25,18,28,19,23,-20,50,29,65,39,0,43,72,-95,17,27,69,76,21,-111,6,17,3,-7,32,40,18,37,-3,-5,7,-6,9,38,-40,8,31,25,-36,-20,67,25,-26,8,-20,-2,-21,-4,55,10,19,-50,-13,5,-44,-16,-29,11,-127,15,-26,-8,25,-68,-7,6,23,-37,-5,60,2,-41,-3,-27,-105,38,-46,-24,31,4,-32,-87,1,-64,2,69,-50,25, 
  /* [19][0][][] */ 9,31,5,25,-39,-30,15,-55,85,32,33,-63,-44,-49,28,11,-51,-20,-4,29,33,39,-92,15,4,79,68,55,48,-30,14,-118,-92,17,39,-5,53,-21,-15,5,-68,75,37,-82,-13,-72,71,-15,36,76,53,-63,41,-12,-10,11,54,-18,73,97,23,-39,56,65,101,-69,-41,23,-65,15,-52,45,-71,24,36,38,19,21,56,-38,21,7,51,0,20,59,33,37,21,-63,61,6,-24,77,34,-28,26,-12,13,1,25,-20,63,21,4,-1,22,26,-79,-30,-57,127,54,40,-58,9,-22,-19,59,65,16,-8,41,90,-46,53,2,55,85,-8,-83,-47,-40,57,35,68,94,3,27,-47,-20,-112,-104,-40, 
  /* [20][0][][] */ -5,-6,-26,-46,-6,29,62,0,19,-109,90,28,-55,-107,3,4,46,-23,27,-12,18,-58,-13,-11,33,30,-7,-27,-2,26,14,-25,-16,0,-22,6,-23,-8,-18,38,3,43,-3,-76,37,-25,57,-25,38,-26,-15,14,21,-16,-24,-13,72,5,-8,-74,10,10,-62,-48,-27,-26,-20,17,-127,-39,6,46,23,-60,58,35,-16,-46,34,2,-7,51,27,-37,11,-29,39,8,-47,-6,31,-12,18,11,21,79,8,55,18,80,-13,31,-24,-9,-48,-28,52,3,6,-21,-28,-18,-1,38,-35,13,-40,-11,-58,-42,-72,96,4,45,-35,18,-15,45,-4,9,24,12,-3,-47,25,34,-45,-6,3,-6,-37,47,-49,26, 
  /* [21][0][][] */ -6,25,4,83,-17,18,34,-41,17,-2,-27,4,-8,46,58,4,13,-21,107,-5,-17,-62,-40,-41,19,-55,59,-69,-49,33,-20,32,-18,-29,87,8,-48,11,61,-36,-13,21,28,11,-21,10,34,-4,5,-39,21,-19,-107,11,-40,16,26,13,-31,-31,13,38,81,-83,50,37,43,35,14,-23,12,87,-48,-44,-26,71,-10,-57,-56,-36,-65,42,85,-77,45,-30,-21,-55,-37,49,43,1,39,-32,9,-10,12,-49,-27,-34,17,-26,-41,-11,84,11,47,-8,-6,8,-28,-29,-8,-33,84,-20,-58,3,-21,-127,-38,54,11,-28,-70,33,61,33,-30,-9,-34,-8,85,7,41,7,-49,-19,33,-6,24,-44,4,-20, 
  /* [22][0][][] */ -16,16,-28,4,-21,25,22,28,-18,-20,11,31,-29,18,43,20,127,-50,24,-31,17,59,-15,35,55,33,3,31,-19,27,-11,-15,8,41,-11,-46,-44,-3,27,31,32,4,13,47,-51,11,-48,-7,15,-6,-37,-28,-40,21,-32,-1,8,18,30,-13,-29,0,3,-23,69,-2,15,29,-21,-21,54,-24,16,-5,28,-27,-8,-52,-44,10,-19,11,-92,34,23,28,-14,-24,-55,52,23,-15,-36,12,-13,37,-7,16,34,41,-29,-8,-39,4,-2,-5,22,32,-14,-28,-52,-59,62,-17,-87,23,19,11,64,6,-11,72,11,-21,-4,9,-19,-9,36,-34,25,55,-13,-3,27,-16,-26,5,15,29,0,106,44,-6, 
  /* [23][0][][] */ 33,-21,24,9,6,3,-43,-62,-11,26,27,21,2,-5,-43,-15,-19,3,9,127,-24,-15,1,0,62,-31,93,73,0,54,-5,2,102,-35,-66,-65,27,30,-14,-2,14,-29,33,5,26,-13,-13,-35,23,-36,24,3,46,-17,-12,20,-38,17,28,-1,1,6,32,33,23,-84,-14,18,-1,-82,-8,27,18,13,-55,31,-109,52,-1,-41,4,-33,-20,-103,21,-9,-11,-3,-28,-46,-11,-99,-33,-12,-35,32,74,-96,-15,22,-54,42,8,30,23,19,25,41,7,28,45,-46,51,-11,39,18,26,-49,-29,-64,-41,61,33,-32,39,44,24,32,15,9,-14,-49,3,66,-27,-25,41,8,-72,-15,-38,19,-23,2, 
  /* [24][0][][] */ 6,22,11,-2,-25,17,-6,29,16,39,-39,-9,-43,14,-46,19,72,-35,-66,87,0,-35,-25,39,24,35,-47,42,-27,-29,-27,47,16,34,-73,0,-50,79,-5,-36,-1,9,-31,-127,-6,-34,116,-19,10,-51,8,16,39,11,-20,-23,9,6,37,-27,25,24,-67,40,7,0,-30,27,57,-9,12,5,1,-1,27,1,-88,-36,0,43,32,31,58,-2,-11,0,-32,-31,22,18,25,-54,-9,-62,-89,8,26,-17,2,-9,46,-51,-16,-21,-65,-31,-1,-37,-1,39,-20,7,9,-13,-5,-26,121,-37,59,-28,54,-48,-40,-5,-44,-51,-17,37,20,20,51,0,1,31,-6,20,41,12,8,-12,74,43,-28,40, 
  /* [25][0][][] */ 22,-34,-27,15,26,11,90,-59,48,-14,-1,-17,-25,20,-8,15,53,-26,14,-1,-47,-4,-18,-53,-13,55,56,20,-4,75,42,-1,-19,17,65,18,-24,-53,11,22,1,-14,16,36,2,-13,-13,-33,16,24,-8,32,-30,-2,15,-16,-30,-6,-20,7,17,-3,-50,-7,14,40,-20,38,17,44,-11,15,39,-10,-23,-89,6,7,0,33,11,9,2,-12,-58,-1,6,-14,8,-2,87,40,15,-2,18,1,-16,-40,-22,0,-19,3,-31,-32,-27,-14,-13,27,-18,13,-17,16,-23,27,-53,5,-43,5,8,-127,-21,17,43,-3,-31,-29,-59,-13,15,-17,-3,7,104,112,22,15,-15,74,27,35,86,-107,-74,-10, 
  /* [26][0][][] */ 0,-16,14,15,0,-50,45,-10,-26,-53,12,-39,31,8,31,39,-34,-51,-18,49,30,33,4,-22,84,8,-127,-22,16,19,-10,43,-24,-36,103,-37,3,16,9,-13,22,1,15,-31,-1,11,22,24,34,-79,40,2,-96,41,-36,-28,-5,-17,-6,-14,22,58,-4,5,42,-49,7,18,54,37,-24,-24,10,-48,-15,45,-88,18,-62,8,-6,-58,-48,41,-32,17,-51,9,-2,-2,13,-3,-5,-17,14,-9,-29,100,43,-45,-29,27,25,8,37,-12,-34,-15,-28,56,26,-30,-27,23,-10,-33,-55,1,-89,66,-26,27,-61,-71,14,55,-34,-37,-23,-31,-9,-51,56,-54,30,-23,3,-12,-30,-45,-18,21,26,59, 
  /* [27][0][][] */ 50,0,58,21,43,-42,38,85,32,118,82,-30,-59,16,101,-7,46,21,-2,92,71,-82,74,70,-29,17,-42,11,-22,-75,-11,50,28,-83,24,30,21,-20,27,13,-50,-73,25,9,-27,-6,-15,24,14,115,-111,-6,20,-39,-22,-39,-10,-12,13,-55,20,-17,-49,2,78,47,22,-45,27,-30,-42,-127,81,53,-22,54,-45,-88,-63,68,-11,0,89,31,-5,-43,49,-26,-40,48,57,-2,32,-18,41,47,15,9,19,41,-86,121,-14,24,7,-33,-23,3,-59,-28,6,-94,-17,-58,23,-22,58,50,77,125,-116,71,33,-86,4,119,-2,-46,37,-43,-91,-53,-88,80,38,85,60,24,-26,6,12,-91,106,103, 
  /* [28][0][][] */ -59,-51,17,-25,-13,7,-92,11,0,-84,-18,-12,-16,-3,1,32,41,-18,-55,-23,56,49,-3,12,-49,-17,-7,-40,2,86,36,38,7,-23,-16,12,23,-4,6,33,-9,46,-16,-28,-28,-46,-12,1,-7,29,-55,10,-23,4,17,-9,-34,-16,-7,-26,-2,-19,23,-22,-2,94,-9,-26,35,17,-20,8,-1,-11,-8,28,26,60,12,-30,-61,15,-33,9,-25,-5,-34,3,-22,-87,17,-74,-16,-18,-3,-37,35,46,-13,-30,51,0,48,-30,-14,4,67,21,-12,2,21,-63,8,-2,-1,-21,35,6,127,-19,-25,52,3,100,-16,28,64,-25,14,-38,-49,57,94,121,25,-26,-18,-12,6,-15,-26,60,-5,-99, 
  /* [29][0][][] */ -27,-6,-50,10,17,-12,25,-70,36,66,12,25,18,-26,65,0,-26,59,43,-47,-73,19,20,-7,38,13,-36,63,-1,-19,-3,127,28,-11,-93,-11,13,22,76,-78,35,23,27,-1,48,37,-10,-4,21,-3,3,12,18,12,12,-7,38,-5,18,-13,-32,0,49,10,-26,-55,-6,38,48,-25,-8,-1,44,12,-31,108,49,55,-27,-27,17,-16,-46,-44,16,-10,48,9,-45,-23,5,20,8,-6,33,19,15,-16,16,9,-8,-4,-18,12,21,5,3,15,5,28,7,-87,-21,36,-31,75,71,3,10,-11,34,-10,63,29,-48,-40,-32,-6,19,17,-65,15,-26,-2,23,32,31,47,24,39,4,80,14,-6, 
  /* [30][0][][] */ -44,35,12,-23,-22,27,-77,-81,-76,-66,-56,41,114,-15,59,61,1,-19,-63,26,4,-53,38,24,-70,-115,-6,107,-115,27,28,-35,-2,36,-82,-98,-1,-27,120,-18,-95,-15,-7,14,-13,30,24,-18,-27,50,-86,-50,14,-43,-32,51,19,-51,-10,-36,54,-17,54,-15,-52,-29,43,73,-71,111,3,18,-25,-17,-71,37,-25,43,-6,-53,12,-26,0,8,-44,50,-25,-98,-18,6,-30,-51,45,9,12,-54,-52,-7,26,53,41,96,49,-21,52,-15,-9,21,-63,11,6,-121,5,81,127,-37,-46,-12,-5,-39,-20,-15,63,-59,54,6,-63,-22,-15,32,-50,-3,13,27,3,-10,-47,-42,29,-65,-60,-45,-85,10, 
  /* [31][0][][] */ -74,-30,-39,-14,32,72,-4,68,24,-2,-33,-5,34,15,-15,23,-49,-2,-62,22,-45,-54,0,14,77,-127,-39,-14,4,-3,-47,-31,-71,45,97,-16,-31,-40,-2,45,-3,-15,-22,30,52,-27,-58,22,-6,20,18,-14,0,18,24,-21,19,-14,-25,-5,13,30,14,34,35,-6,-66,37,-3,-89,-2,-28,43,44,47,52,39,1,-28,-21,-2,53,46,97,34,51,64,4,15,29,-57,121,28,0,7,64,58,65,-73,-12,-30,-9,-4,-12,3,-13,97,78,15,-42,-49,5,-13,4,77,0,-96,37,55,37,34,-9,30,-2,42,-34,-3,15,28,4,-27,-65,32,-5,-23,17,49,12,-2,1,-13,-8,7,10, 
};
const TfArray<4, int> tensor_dimension64 = { 4, { 32,1,1,144 } };
const TfArray<32, float> quant64_scale = { 32, { 0.0021685988176614046, 0.002088391687721014, 0.0022291804198175669, 0.002450442872941494, 0.0029241661541163921, 0.0025928816758096218, 0.002591713098809123, 0.0032067976426333189, 0.0027948275674134493, 0.002464355668053031, 0.0028591642621904612, 0.0025320779532194138, 0.0024741438683122396, 0.0027082867454737425, 0.0025784666649997234, 0.0032413990702480078, 0.002818642882630229, 0.0018611492123454809, 0.0028951677959412336, 0.0021346260327845812, 0.002922779880464077, 0.002478680107742548, 0.0029385189991444349, 0.002533814636990428, 0.002720358781516552, 0.0032554017379879951, 0.0028499900363385677, 0.0017301908228546381, 0.0026275892741978168, 0.0028262347914278507, 0.0020021465606987476, 0.0026410368736833334, } };
const TfArray<32, int> quant64_zero = { 32, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant64 = { (TfLiteFloatArray*)&quant64_scale, (TfLiteIntArray*)&quant64_zero, 0 };
const ALIGN(8) int8_t tensor_data65[192*1*1*32] = { 
  /* [0][0][][] */ 127,58,-34,22,-6,-39,-7,-122,-96,50,52,-62,37,20,-1,22,-4,7,-30,-36,-46,-91,-14,-72,-108,8,-40,87,92,-47,42,7, 
  /* [1][0][][] */ -86,21,-43,-43,33,96,36,-21,21,61,-11,-2,-94,-48,-35,-109,-127,-88,20,11,-16,33,-79,33,-97,62,-105,-9,30,-16,7,-53, 
  /* [2][0][][] */ -127,-11,13,56,35,14,-42,-37,41,42,-44,9,25,13,66,-88,32,93,-88,-2,-44,-36,-103,-1,38,-51,34,-57,-16,44,-58,-41, 
  /* [3][0][][] */ 11,42,-22,-117,-35,-2,59,-35,-84,-59,-82,-7,32,-19,81,127,10,-48,-29,-64,-38,-90,70,88,25,-50,69,5,34,-4,10,50, 
  /* [4][0][][] */ -10,13,-40,-18,-5,102,-92,6,-10,7,-21,3,16,66,17,2,33,-35,-30,-127,-5,-97,11,-81,-16,94,25,-49,-62,32,24,-39, 
  /* [5][0][][] */ 127,-37,60,119,102,32,-54,-57,35,-45,30,80,-80,-103,-43,-35,7,-4,67,27,49,-7,-4,-77,-55,16,57,-6,9,-27,52,-36, 
  /* [6][0][][] */ 10,15,66,-48,-19,45,-23,6,-127,80,-70,38,10,-16,14,38,33,-8,12,40,-96,14,2,26,-28,-24,16,-13,120,52,-47,-26, 
  /* [7][0][][] */ -27,-65,70,-41,21,-42,-29,26,28,-79,36,1,-20,-71,-83,-40,-24,-12,-11,12,-71,32,21,106,46,127,-19,-73,-50,2,-36,75, 
  /* [8][0][][] */ 53,-27,127,54,-18,-44,-60,-48,-64,-23,-20,78,65,22,-96,-55,20,-27,-47,-14,-31,-73,5,-17,-108,43,35,-17,7,106,55,-19, 
  /* [9][0][][] */ -31,20,9,40,95,52,-28,-2,63,47,2,0,-6,62,8,-58,32,-17,-33,-106,-18,127,-113,-25,41,-14,4,93,-65,-58,25,41, 
  /* [10][0][][] */ -76,-25,-10,41,-58,-48,-32,13,-31,24,3,-3,-5,7,8,-49,-64,127,64,32,78,26,-35,-23,-100,116,21,-86,-76,-29,-5,-15, 
  /* [11][0][][] */ -61,49,-18,-31,125,-15,-29,66,-68,-79,7,-66,-17,54,30,102,-116,-118,80,15,47,-72,-36,127,51,124,38,-61,19,52,-47,-88, 
  /* [12][0][][] */ 127,-64,85,-5,-38,-7,81,-79,-33,-77,-97,41,-115,-122,-11,52,9,-30,14,-2,37,-116,67,1,17,62,-91,-16,-41,84,-3,81, 
  /* [13][0][][] */ 16,28,-20,-75,83,-5,-108,76,11,-116,97,-48,36,36,60,16,-78,62,-54,-127,-48,48,-16,8,76,30,88,58,-36,-40,-8,-83, 
  /* [14][0][][] */ 39,-77,0,48,-45,7,48,-52,-2,-21,-6,-4,-14,56,-34,4,90,-49,-35,-86,-10,12,65,-11,-4,-51,6,56,-88,-127,31,-2, 
  /* [15][0][][] */ -36,127,-52,-54,20,29,82,-88,57,-99,-61,-19,59,23,14,-23,-40,21,-10,33,-39,-35,-42,-102,84,22,-1,-76,95,-46,96,-100, 
  /* [16][0][][] */ -80,-30,-33,-20,-59,-8,-16,-36,8,-2,2,44,-83,-78,-1,-7,-72,-44,31,-20,61,-63,89,10,-12,33,-127,-39,-38,33,30,-2, 
  /* [17][0][][] */ -51,127,95,-40,-89,9,-6,-17,-70,-62,-66,-62,62,55,-23,18,111,-108,-69,109,-26,-22,64,18,49,-11,37,-39,118,72,13,-119, 
  /* [18][0][][] */ 16,8,59,-18,-15,-5,17,8,6,-12,5,-98,-71,-19,52,-57,44,-51,-64,-34,21,127,-70,-19,42,-79,6,-42,16,-37,57,56, 
  /* [19][0][][] */ 40,76,-3,-2,18,27,48,6,-5,-46,-88,-39,4,-35,11,71,60,38,-18,49,14,18,32,34,-127,-47,3,2,44,-7,-41,-35, 
  /* [20][0][][] */ 54,-95,8,-9,93,102,-85,-11,115,-26,18,34,-11,-116,12,-1,57,-59,7,-127,29,-8,27,4,6,42,-1,-39,-26,-9,-76,65, 
  /* [21][0][][] */ -20,27,89,-33,-41,25,-52,-61,33,17,19,42,58,36,20,39,-41,-101,-127,18,-19,18,6,16,25,84,24,11,46,18,22,-44, 
  /* [22][0][][] */ 73,-69,11,-91,-10,-13,-1,65,127,-60,68,-35,7,-6,-39,28,-56,-22,-30,-65,115,18,57,-14,-12,47,6,59,1,39,8,57, 
  /* [23][0][][] */ -22,-99,-62,-38,85,1,31,-45,-20,-28,108,-105,-76,-38,69,61,-30,127,-58,16,31,126,14,96,86,10,-49,-8,-58,41,-48,-120, 
  /* [24][0][][] */ 63,-27,-6,51,36,-116,40,-79,-43,58,-31,83,-22,-9,26,0,66,89,51,-21,42,-44,-21,-18,-23,-8,-41,40,-127,54,-7,33, 
  /* [25][0][][] */ -41,-17,-22,-28,-24,-14,19,62,-6,-51,17,18,85,-1,120,53,-6,-48,-4,31,44,38,26,-45,-97,42,70,2,-13,-127,-4,11, 
  /* [26][0][][] */ 46,127,-57,-105,3,-31,52,-41,20,23,-64,-82,38,-45,-48,-29,-55,42,86,33,53,-11,-37,-70,30,-23,-13,41,18,-18,39,-11, 
  /* [27][0][][] */ 38,0,35,46,66,-108,5,97,-26,-4,66,21,-52,-1,-26,25,82,-40,-32,20,49,-12,3,107,28,51,5,-29,-29,-127,50,51, 
  /* [28][0][][] */ -83,38,-111,0,55,127,77,-23,49,-47,1,32,-20,-6,10,54,53,118,74,-75,113,71,-20,58,32,71,-49,-58,-45,8,-3,24, 
  /* [29][0][][] */ 19,-15,-20,96,-42,4,-14,10,35,17,-52,36,-50,8,-29,0,14,-48,34,16,38,-40,-23,-9,-15,14,20,0,-55,-127,-79,89, 
  /* [30][0][][] */ -96,-19,3,-36,-99,31,-10,-56,108,-39,-47,42,-13,-24,51,-114,-80,-46,-100,33,21,-11,-23,-60,-8,-69,-14,127,9,48,-34,23, 
  /* [31][0][][] */ -93,72,34,-17,-95,59,2,-80,-8,-35,-27,72,29,113,78,26,64,26,-80,53,-34,-5,-127,-28,-30,-6,11,-25,-7,67,9,-114, 
  /* [32][0][][] */ -10,8,-28,70,98,17,54,77,53,3,-19,17,83,76,-38,52,-12,-31,-127,19,25,-17,-91,-35,7,-31,26,3,-34,-44,2,-80, 
  /* [33][0][][] */ 3,-51,-82,62,-53,9,-8,-61,-4,-31,5,60,-76,86,-127,-27,80,15,8,-38,93,-25,12,79,-1,15,-32,-64,-68,5,-47,-74, 
  /* [34][0][][] */ -94,-46,17,-38,12,-7,-38,45,-50,9,-48,-10,49,-51,47,127,-41,-62,-53,-20,-35,4,111,85,48,47,39,47,63,14,32,37, 
  /* [35][0][][] */ 23,-38,-29,-127,-38,13,55,78,1,-47,67,-122,52,40,-48,13,2,18,-7,-24,-41,-48,20,-36,-51,80,36,-67,44,43,-45,52, 
  /* [36][0][][] */ 52,46,3,-4,19,66,98,-9,31,69,-59,-19,-82,61,14,1,-53,-98,26,-21,12,-101,23,15,-28,-21,-18,127,-52,-19,81,-17, 
  /* [37][0][][] */ 21,-48,-17,36,25,-4,-115,29,16,9,49,-20,-12,3,-87,19,32,35,9,-12,27,-46,16,44,127,-53,52,-74,52,79,-55,-52, 
  /* [38][0][][] */ 60,-21,-23,-8,-57,52,42,65,-127,13,-41,43,14,-61,-41,-37,38,5,-24,35,13,5,-79,10,5,8,-13,-2,17,-4,9,32, 
  /* [39][0][][] */ 117,-22,79,54,127,57,-80,27,95,-51,16,52,79,-71,25,45,-87,-71,4,-64,26,77,59,-35,61,-35,13,-30,56,-63,-61,-20, 
  /* [40][0][][] */ 37,-31,64,10,-12,-32,-16,11,11,-121,-32,44,-20,-42,-27,-29,-10,-13,-54,-127,45,102,-2,-16,-30,-47,-36,-11,42,50,95,72, 
  /* [41][0][][] */ 87,-39,-43,100,11,-39,-66,31,84,99,56,-20,-126,-35,-80,-46,21,-58,9,127,12,-50,-84,-26,-59,19,43,-89,27,25,9,-22, 
  /* [42][0][][] */ 10,40,59,28,96,-6,77,1,15,11,-6,-54,-13,82,71,-59,-3,49,-7,-127,39,37,-111,58,65,14,-28,63,-7,4,34,59, 
  /* [43][0][][] */ 70,-78,-1,48,-17,45,-56,105,-93,-88,1,-25,-41,65,16,-40,15,-21,-46,-44,-55,80,-51,99,-65,-107,86,-5,21,-31,127,66, 
  /* [44][0][][] */ -34,50,-26,-10,0,-39,-7,-108,-110,-106,102,46,96,-35,-127,102,-43,120,24,77,6,-38,-124,-121,38,57,-17,43,48,64,-74,77, 
  /* [45][0][][] */ -10,-31,-44,-20,3,61,44,5,-70,-41,34,88,-59,31,-53,45,113,8,-61,-45,-62,-5,-41,-11,28,-3,-2,66,-80,96,127,99, 
  /* [46][0][][] */ 33,41,65,74,-63,103,-11,-127,-43,-31,-48,-45,-60,86,-74,-58,-24,27,8,-67,12,-3,8,10,-11,24,36,32,-5,18,-38,5, 
  /* [47][0][][] */ -25,-26,48,-40,-13,-34,41,15,95,-32,16,1,-65,-55,10,10,-45,-4,12,-35,41,-31,114,-3,48,55,-16,-18,26,127,63,72, 
  /* [48][0][][] */ 13,-16,114,1,64,19,93,48,33,33,18,1,-127,-6,-28,7,-1,16,35,62,-6,48,-7,52,-16,6,-20,82,11,15,-85,54, 
  /* [49][0][][] */ 85,20,4,50,62,-80,-21,68,-24,73,-7,-43,51,-97,-24,127,-22,8,13,34,27,-21,72,-20,2,88,59,64,-1,-32,-75,-36, 
  /* [50][0][][] */ 96,-57,5,-96,52,23,65,28,-33,9,-5,8,43,97,-91,-26,-41,-127,30,-7,23,-36,39,16,-81,22,38,83,57,-89,20,-51, 
  /* [51][0][][] */ 71,-39,7,54,40,-19,-127,-11,-2,12,-12,54,57,59,7,72,41,14,-35,-6,-10,4,29,17,9,20,-16,-3,21,37,-19,36, 
  /* [52][0][][] */ -46,89,53,38,54,29,-4,21,-7,-48,76,61,83,-127,-47,48,10,50,-17,55,68,-35,22,95,62,79,-24,85,-34,31,60,79, 
  /* [53][0][][] */ 127,-38,-26,10,28,21,-86,12,38,-73,-16,31,62,-68,-11,-9,40,32,-24,4,-115,70,64,-21,-38,-1,88,48,33,-24,-81,-71, 
  /* [54][0][][] */ 50,-15,64,-82,-11,101,70,-37,-89,-63,-87,-37,50,44,-67,27,27,98,-9,15,42,-23,-73,-13,-5,127,-21,6,-13,58,17,-7, 
  /* [55][0][][] */ 127,41,-34,8,104,11,1,26,-52,23,51,34,-69,-17,43,-6,7,94,-89,38,-24,-51,-26,-78,84,-52,67,-81,42,24,-11,75, 
  /* [56][0][][] */ -41,-49,53,34,-49,67,17,48,-80,-9,51,7,-93,10,-17,-25,127,-40,-39,10,5,15,-27,-4,-10,50,-4,9,-44,82,-8,31, 
  /* [57][0][][] */ -81,79,-75,36,-63,83,3,-68,-22,-116,-4,-27,-44,127,51,-51,14,-65,38,-11,22,-32,-90,87,-10,20,-25,-46,-60,46,-5,31, 
  /* [58][0][][] */ -7,-120,76,-8,57,36,-35,19,38,46,46,-48,122,11,79,127,-65,1,-78,-33,-45,8,89,32,37,13,52,-76,30,-60,-60,41, 
  /* [59][0][][] */ 75,43,0,12,25,24,-6,-73,22,14,-5,-6,9,33,-44,16,3,-5,29,2,3,5,-46,127,-20,41,38,-100,-14,-20,13,-6, 
  /* [60][0][][] */ -36,52,21,-48,-14,87,127,16,3,41,-15,67,59,-59,44,-57,69,99,9,42,13,4,-117,-125,-26,-72,-50,-112,-67,11,-73,-126, 
  /* [61][0][][] */ 32,3,84,78,127,39,-71,18,34,-42,32,-21,-14,67,89,-32,-38,-110,32,-13,-50,53,83,59,44,-41,-26,-66,2,-109,-86,50, 
  /* [62][0][][] */ 10,-5,2,-54,-33,84,-56,41,12,-82,-38,57,121,87,96,0,-10,-127,-4,-2,-3,62,97,88,94,23,3,31,-74,-83,66,-127, 
  /* [63][0][][] */ 104,-87,-33,-103,-127,107,-27,-62,-81,-77,-13,82,65,-36,56,87,28,97,-55,-5,23,-99,-59,-104,22,1,-62,57,-41,58,37,-78, 
  /* [64][0][][] */ 42,-4,-51,38,85,-20,-48,-44,13,-43,93,26,61,-58,-54,84,34,75,-31,32,-102,127,4,-27,58,-4,69,69,20,-104,-56,-21, 
  /* [65][0][][] */ -37,127,35,-19,66,21,-91,35,-6,52,70,-2,-54,8,-82,-50,-37,17,29,24,-36,57,-4,2,-90,-33,46,-52,-51,69,28,60, 
  /* [66][0][][] */ 53,-6,50,-31,21,44,-63,62,53,127,32,-14,-37,-66,-2,86,-68,-11,56,0,-24,-58,46,64,-53,55,27,-43,50,59,37,53, 
  /* [67][0][][] */ 43,32,16,-48,-16,48,-127,1,63,67,44,-20,-37,-51,18,-119,5,-70,50,-119,-74,75,69,57,-58,23,77,-44,-60,-50,12,11, 
  /* [68][0][][] */ 39,-25,32,-7,-127,-19,33,0,-45,-12,-14,5,35,48,-43,-80,-1,8,-58,19,-21,-19,14,22,-53,-5,21,18,-9,24,-26,2, 
  /* [69][0][][] */ -5,69,-69,2,34,76,17,-48,-30,33,8,-33,43,-64,16,-8,7,58,-11,9,-47,-2,41,0,120,31,-12,127,50,15,-11,48, 
  /* [70][0][][] */ -40,21,77,-41,-4,-28,70,48,-109,-87,-91,38,-90,-41,-59,3,44,-81,-11,-77,-38,65,12,23,-49,-64,-69,-47,27,57,127,49, 
  /* [71][0][][] */ -3,0,-70,-17,23,-54,-7,24,55,-22,-33,65,27,-25,60,65,-12,-127,59,-41,-56,-34,86,-92,-9,-48,89,120,28,-49,56,80, 
  /* [72][0][][] */ 94,-43,85,69,55,-35,20,-2,104,-127,47,58,-59,-44,-13,-20,-106,19,-11,2,-32,10,8,-25,28,-71,45,-81,51,41,29,-18, 
  /* [73][0][][] */ -117,-33,76,70,6,50,55,-20,-112,52,-33,-81,-79,23,-34,-36,-32,127,9,-88,24,3,89,-9,-11,111,70,78,44,6,-38,-31, 
  /* [74][0][][] */ 29,37,11,-9,85,-68,-24,37,-78,-24,43,37,127,-32,24,-27,-39,-82,92,2,50,-72,59,120,27,87,52,-37,-5,-20,53,-1, 
  /* [75][0][][] */ -19,34,-63,-19,13,-3,69,-90,0,-18,43,-54,19,37,121,127,-99,0,-16,62,4,38,-1,59,15,22,45,-78,-3,-13,8,-120, 
  /* [76][0][][] */ 13,-13,56,-8,-11,14,118,-85,-9,-15,-63,90,-2,-28,-39,-127,-107,87,-43,-1,-9,22,8,0,-105,29,72,25,-36,7,77,-66, 
  /* [77][0][][] */ -69,-20,26,24,-21,-8,36,-14,-77,-41,24,32,74,-40,-10,-102,66,-45,72,40,-99,47,51,-16,-26,43,-36,-48,-55,127,-25,-47, 
  /* [78][0][][] */ 45,12,-62,108,-48,-29,-51,-50,-6,59,-8,-50,-29,-127,61,-1,44,20,-14,22,-20,11,38,44,-25,33,-2,-23,-39,-27,25,-63, 
  /* [79][0][][] */ -79,-49,-99,11,4,16,24,52,37,-28,127,-4,-17,-10,29,78,71,17,-22,-15,7,19,-67,47,27,0,-41,-17,-68,-49,-9,76, 
  /* [80][0][][] */ -37,127,-21,-57,60,53,-5,58,8,-16,-42,37,-4,4,-88,58,-3,-76,-12,84,-3,30,67,31,12,-12,-35,40,70,43,12,38, 
  /* [81][0][][] */ -33,7,-61,78,-93,-58,0,-79,77,8,38,99,8,30,34,-18,-39,-1,-13,-19,-25,6,98,46,99,-6,32,127,-49,-44,18,-23, 
  /* [82][0][][] */ -3,-16,103,33,3,14,-47,-36,13,30,-25,66,-5,-8,9,35,-30,-127,-54,20,-54,-27,17,47,-48,1,45,18,-24,53,91,-80, 
  /* [83][0][][] */ 32,-67,-62,-79,127,58,-35,71,-38,9,32,-77,51,-17,66,87,-73,-51,49,-13,-46,122,70,74,85,43,58,1,-20,-86,45,22, 
  /* [84][0][][] */ -26,104,6,-124,11,-39,93,59,-84,-58,7,23,-60,-11,0,10,-105,-57,48,63,-67,-110,54,51,-41,7,43,-127,5,102,28,-48, 
  /* [85][0][][] */ 105,70,-119,-45,-63,-30,9,-1,-14,-57,-15,38,48,6,-63,30,102,40,-55,43,127,-59,12,-16,-32,-59,-15,-27,-54,-63,28,117, 
  /* [86][0][][] */ -43,-54,127,125,-1,-70,30,-28,92,29,-15,-49,-79,-4,25,-112,-65,37,17,21,56,-17,-25,14,67,-104,-21,-90,-36,20,19,78, 
  /* [87][0][][] */ -37,-25,54,-80,-62,-97,-40,-114,83,-23,48,31,-90,70,13,-116,-127,79,8,-60,13,45,-69,103,-70,83,-10,-95,-34,55,-36,65, 
  /* [88][0][][] */ 127,83,-23,26,-59,-11,-72,-25,47,-13,51,-6,13,2,-94,76,-54,-59,21,-52,-75,31,-6,102,-39,50,-11,-61,18,65,-44,51, 
  /* [89][0][][] */ 11,-43,-50,81,-47,61,-47,44,127,33,34,77,101,-9,-118,26,-7,39,-126,13,93,82,-16,-30,5,21,110,68,71,-85,-46,-78, 
  /* [90][0][][] */ -20,39,-87,-49,60,38,58,-35,-30,59,36,89,28,21,14,59,38,-33,-36,9,-87,-14,30,34,32,-127,-45,98,73,58,75,3, 
  /* [91][0][][] */ 62,1,76,18,-39,-74,-8,45,26,59,-52,-6,-127,-98,-23,-44,81,-20,-53,-3,-42,20,-37,58,-4,-19,23,43,101,-40,-52,7, 
  /* [92][0][][] */ -64,42,29,-38,-55,-34,-3,-46,36,-35,-9,54,-19,37,43,68,-14,-44,-28,-60,-27,-65,-9,29,-9,7,21,36,-2,62,127,-58, 
  /* [93][0][][] */ -22,13,-16,71,125,25,-92,37,18,-64,25,34,25,-42,127,-50,-38,5,39,29,-27,52,-8,16,68,0,-16,-20,23,-25,28,-11, 
  /* [94][0][][] */ -55,44,36,-2,7,-48,52,-3,102,-34,126,-7,-51,-4,46,-37,-1,-7,4,-127,61,69,44,-68,28,5,-92,-12,-3,117,23,71, 
  /* [95][0][][] */ -40,-116,87,76,-45,-47,127,72,-41,-49,-15,32,-23,11,-71,-21,-33,53,-69,49,-16,-7,-54,13,-30,12,-108,39,-49,109,-16,85, 
  /* [96][0][][] */ -48,2,-83,-126,-73,127,-49,35,65,13,12,-46,61,115,-106,-2,49,-119,18,-13,-31,40,-44,-82,24,-39,28,3,28,5,-10,-50, 
  /* [97][0][][] */ 26,4,-19,-9,-3,11,-47,-54,33,-26,-28,-126,2,-47,-79,10,-5,-7,-6,-46,127,8,-34,-66,51,17,-47,21,48,-62,79,-20, 
  /* [98][0][][] */ -81,73,67,-25,-103,32,18,-67,-2,-12,-52,23,56,87,8,-10,-5,-51,-124,-57,-73,1,-41,13,-52,-83,37,92,33,111,127,-21, 
  /* [99][0][][] */ 41,-127,89,114,-76,59,20,122,-104,60,119,91,-22,90,67,21,38,-39,-115,82,27,-29,6,115,-17,-12,-32,9,-89,52,-103,-23, 
  /* [100][0][][] */ -71,-12,-32,48,-39,-4,53,43,72,-6,57,48,-48,-11,-29,12,29,95,54,127,85,-57,20,56,-71,0,23,-6,80,-12,-35,-26, 
  /* [101][0][][] */ 39,-15,-61,46,-5,32,56,24,-124,59,5,-21,44,33,127,0,11,-39,-86,92,14,-48,111,106,42,-12,35,-57,16,-19,75,1, 
  /* [102][0][][] */ 103,19,-72,-36,62,-56,-11,-26,15,23,78,-27,-61,18,99,3,127,-71,-46,-27,46,-35,13,-65,65,-29,-14,-19,41,-58,83,-3, 
  /* [103][0][][] */ 42,-84,49,-48,-105,37,-24,28,7,20,-7,-40,-121,-50,72,107,3,-55,-71,-114,13,-127,64,100,-64,53,-80,-16,-78,104,6,29, 
  /* [104][0][][] */ 6,16,2,-39,46,8,-25,36,-23,36,-15,38,47,-43,-2,3,-2,-16,4,42,-8,44,127,-51,-1,53,31,16,-19,35,41,-70, 
  /* [105][0][][] */ 71,51,34,4,6,-98,76,-49,-73,36,3,109,51,-28,-52,30,37,44,44,10,-75,-25,16,20,127,-28,-14,8,-29,-1,-28,-10, 
  /* [106][0][][] */ -22,-18,-29,-20,125,-72,-127,-68,104,-27,49,-77,1,-125,-104,71,7,-66,95,33,67,120,87,-81,26,-51,-71,10,74,-14,3,35, 
  /* [107][0][][] */ 72,-2,73,0,-46,-63,11,90,49,-32,-95,36,-10,-65,33,-51,16,-4,-127,9,-15,-65,-33,65,-61,48,104,-76,-47,120,38,-117, 
  /* [108][0][][] */ -34,-67,127,31,-98,-62,25,-81,91,-18,-8,57,-51,52,4,-33,-50,-14,-83,-88,80,8,-45,-25,-32,3,-29,-7,-1,55,44,-41, 
  /* [109][0][][] */ -13,-1,-56,47,-28,-44,116,-106,-35,-50,-37,-77,29,20,-43,24,-15,9,-31,29,18,-67,-127,20,-88,37,-84,36,56,62,-21,38, 
  /* [110][0][][] */ -6,-67,21,16,13,91,-35,-35,63,-106,-40,32,59,18,-38,-127,6,-70,16,41,-11,36,-71,-24,-4,-27,83,-37,44,-21,-23,-67, 
  /* [111][0][][] */ 19,15,-18,19,-48,-30,5,-55,-36,17,-55,36,61,-25,-127,63,48,-11,40,21,14,-52,-2,15,20,-63,-90,-7,-57,-35,51,45, 
  /* [112][0][][] */ -3,52,17,-50,-68,56,-24,0,63,-127,7,-38,19,75,-10,-81,37,-16,59,22,38,-53,-54,78,54,48,20,-45,106,21,-44,-47, 
  /* [113][0][][] */ 35,47,40,-4,-12,-38,67,60,-85,-40,11,22,-56,-33,-49,32,-15,-103,-34,-41,-127,6,23,-71,-54,96,77,113,-23,-125,2,96, 
  /* [114][0][][] */ 13,-10,9,-97,19,-46,49,9,5,60,-2,-48,-68,-89,-28,55,-26,-8,125,76,76,-70,60,1,-49,14,-93,-127,-44,48,-28,40, 
  /* [115][0][][] */ -68,13,-22,25,29,-21,1,-79,35,-44,56,108,-7,48,-78,10,-15,-84,-24,20,36,-23,31,-127,23,-36,-31,29,62,99,-41,76, 
  /* [116][0][][] */ 8,27,-31,-30,-23,-53,-1,7,32,-51,127,92,-27,-46,11,4,-53,37,9,-22,-76,32,60,17,-23,-49,63,-89,-31,-1,-7,-100, 
  /* [117][0][][] */ 49,10,15,86,-36,2,-31,-55,-28,123,64,-39,-18,-14,58,25,51,10,-13,23,-66,-47,-21,21,-7,2,-127,34,-25,-26,100,-34, 
  /* [118][0][][] */ 27,-46,-2,10,63,11,7,10,65,-99,35,52,-67,-47,-14,4,-2,-94,27,-127,18,0,-46,41,15,40,15,32,-51,34,-6,-22, 
  /* [119][0][][] */ 61,82,-115,-52,49,-22,-17,-46,-93,44,-49,-5,71,-52,-40,30,19,-9,48,-41,-40,37,-31,63,-7,7,-8,40,-33,-127,-23,-15, 
  /* [120][0][][] */ 113,-25,-5,-87,54,65,24,-127,54,-107,-43,102,-5,68,-44,88,11,-66,71,39,-78,-14,55,-74,-57,-5,-59,52,-58,-59,-13,25, 
  /* [121][0][][] */ 113,12,103,-127,-64,-59,21,-102,-33,-78,55,87,-99,15,44,-51,8,-89,78,-107,66,91,53,27,6,53,-24,-30,18,-26,97,38, 
  /* [122][0][][] */ -108,-42,-35,81,89,-2,-79,24,127,-95,29,-22,29,92,-17,30,12,-17,47,-41,0,-4,-52,10,7,-17,-3,97,17,-52,112,17, 
  /* [123][0][][] */ -66,29,17,71,-95,-16,58,-23,-22,69,1,-100,-46,29,66,-63,-117,38,9,-111,-78,-28,-69,-70,-58,88,-41,-4,49,127,-12,-110, 
  /* [124][0][][] */ -23,13,91,-81,-58,69,30,-39,33,53,-26,2,-14,3,35,127,30,-55,-80,-59,21,-78,7,-1,-84,0,-10,-2,1,99,52,-24, 
  /* [125][0][][] */ 8,-32,-58,-13,-105,3,35,57,12,6,41,-29,-21,20,-8,17,83,-113,-82,4,-106,-123,-125,13,-14,-45,-85,2,-42,127,17,56, 
  /* [126][0][][] */ 17,91,-63,-1,49,-28,-85,-7,54,7,6,16,55,43,1,12,-72,-27,27,49,-3,127,78,-13,7,31,30,-44,48,11,-37,-43, 
  /* [127][0][][] */ 97,-24,25,-106,12,19,68,57,-4,-55,97,-49,67,-41,-83,-74,57,-16,-79,-9,-19,80,-72,13,91,-58,-14,69,58,-12,98,127, 
  /* [128][0][][] */ -52,-10,12,21,19,-3,-20,-58,28,-16,10,-17,26,70,127,11,-27,-25,16,-92,3,-29,2,4,-3,-36,18,6,30,-10,-55,-57, 
  /* [129][0][][] */ 59,-99,54,127,-15,-31,-95,23,-64,-16,23,-49,50,18,9,64,-58,-15,-58,65,67,-93,27,36,55,61,67,-20,108,-21,-54,56, 
  /* [130][0][][] */ 50,18,-19,-56,47,-15,-34,35,40,-91,48,62,54,36,0,-2,7,-32,3,69,21,60,53,24,17,15,127,29,-15,-91,-95,-120, 
  /* [131][0][][] */ 66,45,-15,56,-46,-13,43,-76,-59,-5,-46,39,6,81,-46,30,34,15,-55,127,2,-73,-21,-70,-59,-6,-35,-37,41,59,19,-9, 
  /* [132][0][][] */ -79,67,-125,-127,110,65,-22,82,-49,80,78,-33,50,-12,13,39,-62,-21,26,55,-76,-25,-15,12,30,78,-105,21,34,-24,-95,60, 
  /* [133][0][][] */ 42,-31,32,-95,51,76,-39,-44,127,-56,-19,14,-36,-21,71,-22,-28,-17,-15,-79,-30,-64,107,-54,39,92,-17,-57,-82,3,-11,-26, 
  /* [134][0][][] */ 46,38,-23,13,-1,-23,86,-71,-21,127,-45,-105,-46,82,-16,-47,31,4,15,-34,97,50,-65,-34,56,-7,-60,96,-55,-57,19,99, 
  /* [135][0][][] */ -59,-41,-90,14,1,17,20,-33,-104,87,-2,-3,-48,15,-37,44,71,-82,45,127,-34,-79,33,-8,-41,32,-41,-23,-21,-75,-48,-57, 
  /* [136][0][][] */ 92,-94,0,7,60,-42,-49,83,13,-57,-71,-57,63,-36,22,3,21,-63,43,-127,-31,-55,-10,94,-63,82,67,79,-61,108,71,-5, 
  /* [137][0][][] */ 26,9,52,-60,1,-46,122,6,-34,30,-24,-3,-2,-67,54,43,18,99,-27,52,-12,-66,16,38,-37,-47,-21,77,-6,127,54,102, 
  /* [138][0][][] */ 26,-21,-20,-61,-108,3,36,-67,49,-83,-6,-39,-112,88,-33,126,-39,-127,25,-31,28,4,55,39,33,-13,-114,112,58,-33,66,40, 
  /* [139][0][][] */ -38,-80,-49,43,-32,2,39,17,30,53,-72,45,-37,-14,6,-97,-35,-59,127,31,-55,-14,61,-11,-51,31,12,68,11,28,-39,32, 
  /* [140][0][][] */ 51,-94,-19,36,49,87,-37,-127,48,-36,7,-2,47,-37,-31,67,-39,-125,-19,-83,20,3,30,-61,-106,30,-4,50,28,20,-91,-43, 
  /* [141][0][][] */ 11,42,-52,12,76,-54,32,86,-21,-67,26,93,46,44,18,-49,-63,-54,33,-43,-12,-36,84,-97,11,-5,-32,72,-61,-127,10,67, 
  /* [142][0][][] */ 61,79,-31,-20,66,40,6,16,-15,51,-56,0,26,38,-86,24,-26,-45,-77,-37,-5,-22,4,18,-27,18,88,127,15,-1,-71,-40, 
  /* [143][0][][] */ -18,-77,-31,43,32,-27,31,97,-56,69,47,62,1,100,-63,-92,-69,-125,41,-57,-64,-66,13,-12,50,67,-72,35,43,-61,127,-115, 
  /* [144][0][][] */ 2,-86,0,54,30,-127,65,4,97,-59,15,-19,-26,17,-65,-15,-41,-38,-65,-46,82,6,26,53,15,-23,2,4,-8,-29,50,56, 
  /* [145][0][][] */ -73,60,100,92,84,111,20,79,-46,10,-125,65,-1,27,-10,115,-32,33,-49,74,-8,-89,65,74,-27,-35,-127,28,97,-56,-89,-36, 
  /* [146][0][][] */ -4,-61,-127,-73,112,-49,12,-51,-110,2,85,103,29,-89,-89,21,-38,96,31,-57,-77,22,46,84,76,79,-16,-42,78,-57,4,-11, 
  /* [147][0][][] */ 127,-33,24,-5,8,-20,54,23,-11,-30,35,-50,0,27,23,28,30,-32,14,52,35,-30,-3,-28,1,30,-33,45,21,3,-36,30, 
  /* [148][0][][] */ -100,41,-82,-125,-89,101,95,-57,17,7,76,-27,0,127,24,-72,34,16,-38,-43,22,-18,-80,-71,-2,46,8,-24,26,-23,94,-84, 
  /* [149][0][][] */ -25,7,-14,-44,89,61,-86,58,-6,20,-15,-6,-17,-46,-59,-52,-7,-68,53,66,-29,28,43,-37,-127,-17,-38,-15,-7,57,50,-14, 
  /* [150][0][][] */ 127,24,-35,23,-75,-40,-12,-61,-98,73,40,66,-49,-22,41,44,24,-84,-55,110,-22,-52,65,13,9,-50,65,8,-99,47,5,48, 
  /* [151][0][][] */ -4,-31,-46,-60,-52,-87,29,-74,-79,108,-5,120,46,-97,49,-82,-60,75,-16,8,-99,127,23,51,44,41,46,75,99,-35,-88,-14, 
  /* [152][0][][] */ -14,-127,59,93,-80,-18,22,12,-38,-14,-57,-77,34,28,-29,-85,-3,-39,17,5,97,-56,15,26,-30,-35,90,-32,-33,72,-45,14, 
  /* [153][0][][] */ -20,60,-72,-110,64,23,127,-98,-38,63,50,-108,25,-85,37,6,88,54,-55,40,-3,50,57,55,78,-83,-71,-33,114,7,86,-73, 
  /* [154][0][][] */ -13,101,-36,8,14,14,-32,39,124,-92,-31,-12,14,-47,-18,1,-11,-127,12,12,-1,39,11,-53,16,21,23,-24,-3,-40,-61,-18, 
  /* [155][0][][] */ 121,-37,-11,-3,53,-33,-25,-62,74,-28,103,-41,-60,-60,4,-56,-26,-29,47,-44,-17,97,38,-40,50,-8,44,31,0,-127,3,-2, 
  /* [156][0][][] */ -47,-24,-11,80,20,5,-28,-13,-9,12,55,-58,-53,-62,-69,38,-45,-63,62,-49,32,62,12,63,73,127,58,-20,12,-95,-87,-15, 
  /* [157][0][][] */ 127,7,103,-93,-102,11,-6,-118,-120,5,-65,-11,-1,-121,-44,-3,-56,61,-60,22,42,82,26,-29,-35,-49,11,-3,-11,4,-10,-24, 
  /* [158][0][][] */ -42,44,-122,30,6,12,-45,-28,-124,1,-58,66,112,-2,40,-44,-16,17,-16,28,-21,-20,-52,-22,13,-45,-6,-27,-31,-75,30,-127, 
  /* [159][0][][] */ 10,-11,-2,-75,-97,-5,28,-111,-52,-24,-34,66,-46,-114,-4,78,-27,-72,18,-9,37,-108,39,-9,15,17,-127,-83,7,-26,-10,-12, 
  /* [160][0][][] */ 1,-95,55,73,13,0,-49,127,-22,-33,-81,2,-35,-95,45,21,-14,81,-59,40,19,-53,10,-93,-82,-111,-25,4,-20,122,-3,-85, 
  /* [161][0][][] */ -55,-17,-16,127,-8,-26,-35,38,50,-57,1,-47,62,88,-62,14,20,-116,18,-13,43,44,-66,18,2,-30,-72,74,26,-30,110,7, 
  /* [162][0][][] */ -90,-16,-11,-1,-58,14,-45,-6,-75,98,127,53,-41,109,30,81,64,-116,44,56,-23,24,71,103,-115,60,36,68,-13,6,-93,-47, 
  /* [163][0][][] */ 3,-45,-49,-13,56,-36,-25,-7,127,3,36,-61,-86,-66,-11,-26,-55,34,90,-18,48,26,27,-28,37,-66,51,-48,-37,-57,34,67, 
  /* [164][0][][] */ -27,-71,71,-40,-1,-9,33,92,66,-9,106,-69,-9,127,23,-12,33,62,-29,-51,-32,60,-9,0,-67,11,67,78,67,49,-7,12, 
  /* [165][0][][] */ -49,-14,28,-41,-4,20,-68,8,-92,33,48,42,17,-2,-47,-19,-26,-35,55,127,-64,-28,-46,13,-93,23,-24,7,-32,3,42,-45, 
  /* [166][0][][] */ -17,-3,79,39,-24,-68,0,-56,-8,-39,50,-32,-41,-25,45,4,-15,26,5,-50,32,106,37,-46,11,-63,-76,-127,41,7,-35,45, 
  /* [167][0][][] */ -22,45,-12,-105,100,-75,-58,60,76,-54,124,70,124,-102,-95,-7,-8,-43,48,-111,51,-19,29,81,-81,34,-69,-83,70,25,42,127, 
  /* [168][0][][] */ 127,11,-52,15,30,31,-115,-12,-16,72,59,-16,-81,-20,95,-88,-73,71,8,-46,-18,-81,-48,-9,-51,-51,94,-39,-52,-9,-73,-8, 
  /* [169][0][][] */ 43,-10,-8,-124,-48,-1,28,70,-68,68,12,-18,-56,-13,-75,-26,45,17,72,127,36,-78,63,-33,-90,48,42,-6,9,38,-88,-9, 
  /* [170][0][][] */ 127,43,-65,-73,-68,22,-3,-26,-4,-57,27,-100,15,28,15,-44,27,-33,-32,15,2,-67,-5,32,20,102,103,36,56,21,18,-51, 
  /* [171][0][][] */ 65,71,105,41,6,-27,-11,102,15,-4,127,-29,-53,-58,-93,-25,71,-108,13,39,-111,-57,-21,-16,-17,-67,-34,-88,-63,-86,-123,44, 
  /* [172][0][][] */ 29,-52,-38,12,-54,-52,-17,-31,-73,42,-40,-33,-20,16,92,-19,-44,7,29,-62,-1,29,127,75,-10,30,95,93,40,-82,70,5, 
  /* [173][0][][] */ 76,-71,26,-30,12,67,81,26,38,-106,-15,-25,53,-102,9,-56,-78,-60,22,-30,27,74,89,127,33,19,27,93,57,0,-65,67, 
  /* [174][0][][] */ -9,-39,111,9,-28,-49,-34,-13,9,-127,-69,73,-37,-85,-21,-51,0,-33,-62,-127,32,117,-27,-31,-53,-68,-39,-40,54,83,115,54, 
  /* [175][0][][] */ 67,22,23,15,-46,-24,62,116,90,96,-14,-21,46,-40,-31,-102,84,39,12,-76,41,-24,9,86,-18,1,-28,37,21,97,-127,62, 
  /* [176][0][][] */ 77,-127,26,-28,-87,-79,-36,-1,49,58,-52,15,23,-23,19,-56,-60,-49,12,-23,-21,31,-85,17,-4,7,38,-6,-126,8,-54,5, 
  /* [177][0][][] */ -26,-62,69,105,59,113,-58,115,28,50,42,-24,67,-3,-37,-109,29,-26,-61,16,39,-25,-94,-127,-20,20,12,10,-9,75,77,-92, 
  /* [178][0][][] */ 106,18,-41,58,127,42,75,-7,-18,-16,124,73,108,-7,87,68,5,-27,37,-13,-49,-82,118,-93,-2,23,-88,96,-80,58,-12,89, 
  /* [179][0][][] */ 31,-32,-23,40,-69,-3,-10,32,6,-67,-21,64,-61,-14,-79,-41,29,-127,38,-16,73,41,-30,-52,-69,9,42,14,-81,39,3,18, 
  /* [180][0][][] */ 95,-82,-35,10,-127,82,-11,84,-109,-27,49,86,-61,87,8,-66,47,3,13,123,2,-29,-49,4,-23,-18,28,-45,-14,33,-86,-16, 
  /* [181][0][][] */ -10,37,49,22,-113,78,-10,-21,-47,55,-2,20,-21,81,-6,10,125,-86,27,29,-34,-51,-74,59,-41,53,91,-21,56,38,127,-85, 
  /* [182][0][][] */ 40,-21,-6,48,-5,9,-33,39,-18,21,19,-5,-17,56,-127,25,12,-1,6,-18,-42,-15,56,20,85,-30,27,-42,-23,56,-56,-50, 
  /* [183][0][][] */ -101,18,49,-59,-73,-31,-35,27,73,-85,-13,60,13,-6,-59,118,-49,-63,53,-30,-4,9,42,64,65,-39,-5,-34,7,35,127,26, 
  /* [184][0][][] */ -24,-11,44,28,42,-57,85,-8,-19,20,68,-50,-45,-63,110,97,-4,97,-56,49,13,25,-82,123,4,1,-79,-13,-40,-2,127,-75, 
  /* [185][0][][] */ -97,-57,1,7,54,21,-70,-28,-28,23,-50,50,10,9,-127,-45,-67,-51,27,42,11,11,9,-17,-25,86,-12,-8,2,41,-95,5, 
  /* [186][0][][] */ -37,-21,45,8,80,-15,2,48,6,63,-55,-23,-5,43,-48,8,6,-36,-62,-38,127,-5,84,-13,-10,37,-8,43,26,-28,97,64, 
  /* [187][0][][] */ 25,45,9,13,-16,87,-20,-49,-36,35,-69,43,39,79,-23,28,127,54,8,3,-80,52,-41,-48,38,73,17,9,4,-26,28,-49, 
  /* [188][0][][] */ -91,-105,-11,16,55,-29,-89,9,-83,49,30,-17,41,-35,33,92,-17,-46,-22,-17,-23,103,127,20,-9,57,-21,9,22,45,88,123, 
  /* [189][0][][] */ 50,66,14,-82,14,38,103,-50,-13,61,-12,32,53,107,-17,-14,-29,-127,2,25,23,-76,-47,34,-56,95,-14,-13,-90,56,52,-51, 
  /* [190][0][][] */ 119,44,66,-47,71,69,13,30,-127,33,-46,-62,-6,-35,16,-96,31,79,-6,-33,-41,57,87,-26,-101,48,-42,-29,38,81,-30,-14, 
  /* [191][0][][] */ 27,-54,27,55,27,-39,-7,-42,64,1,36,98,-16,47,35,-86,-37,-49,45,-32,-78,-36,57,44,-106,62,-98,127,-58,16,40,-73, 
};
const TfArray<4, int> tensor_dimension65 = { 4, { 192,1,1,32 } };
const TfArray<192, float> quant65_scale = { 192, { 0.0016725283348932862, 0.0022645348217338324, 0.0019565934780985117, 0.0019365822663530707, 0.0022939115297049284, 0.0026123137213289738, 0.003230727044865489, 0.002128279535099864, 0.002517912071198225, 0.0018919747089967132, 0.001657667919062078, 0.0017273264238610864, 0.0017075594514608383, 0.001492477604188025, 0.0025384752079844475, 0.0021795174106955528, 0.0021415390074253082, 0.0020918135996907949, 0.002186488127335906, 0.0032919386867433786, 0.0021381096448749304, 0.0030036692041903734, 0.0018563183257356286, 0.0015352738555520773, 0.0021647321991622448, 0.0018910833168774843, 0.0023194386158138514, 0.0022479782346636057, 0.0020632611121982336, 0.0024171131663024426, 0.0023380538914352655, 0.0016651413170620799, 0.0020606080070137978, 0.0019002186600118876, 0.001995402853935957, 0.0032702770549803972, 0.0024058858398348093, 0.0020113352220505476, 0.0029462091624736786, 0.0010229824110865593, 0.0018615237204357982, 0.00200424506329, 0.0022654563654214144, 0.0015205191448330879, 0.0014718747697770596, 0.0026454294566065073, 0.0021372826304286718, 0.0017786708194762468, 0.0029324335046112537, 0.0023099007084965706, 0.0028642446268349886, 0.0029722158797085285, 0.0021078858990222216, 0.0024648578837513924, 0.001912525505758822, 0.0016019410686567426, 0.0038122388068586588, 0.0021398903336375952, 0.0030435961671173573, 0.0023636054247617722, 0.0015327864093706012, 0.0022644514683634043, 0.0018697762861847878, 0.002253867918625474, 0.0020247932989150286, 0.002694468479603529, 0.0026455167680978775, 0.0019611541647464037, 0.002964504761621356, 0.0020865334663540125, 0.0020700208842754364, 0.0012394579825922847, 0.0026471968740224838, 0.001892187399789691, 0.0026201063301414251, 0.0027533101383596659, 0.0018408898031339049, 0.002603425644338131, 0.0025686905719339848, 0.0030999884475022554, 0.0020597323309630156, 0.0028620811644941568, 0.0030738115310668945, 0.0018259293865412474, 0.0018183827633038163, 0.0021024241577833891, 0.0019355955300852656, 0.0016765000764280558, 0.0023410760331898928, 0.0022465535439550877, 0.0015986695652827621, 0.0026666657067835331, 0.0022417409345507622, 0.0018074173713102937, 0.0017907400615513325, 0.0019664266146719456, 0.0022178669460117817, 0.0024556317366659641, 0.0018788862507790327, 0.00185728061478585, 0.0026227128691971302, 0.0023267555516213179, 0.0013691341737285256, 0.0017276899889111519, 0.0038362282793968916, 0.0024349754676222801, 0.0013940967619419098, 0.0019295546226203442, 0.0016699403058737516, 0.0021320960950106382, 0.0024939414579421282, 0.0022089111153036356, 0.0025891312398016453, 0.0016674568178132176, 0.0015451248036697507, 0.0016599163645878434, 0.0026472422759979963, 0.0019902864005416632, 0.0021541314199566841, 0.0027955074328929186, 0.0020645200274884701, 0.0013806704664602876, 0.0019036054145544767, 0.0018796831136569381, 0.0020335300359874964, 0.0020947917364537716, 0.0021871516946703196, 0.001717111561447382, 0.0033360999077558517, 0.0035013726446777582, 0.0026056938804686069, 0.0018517988501116633, 0.0016596842324361205, 0.0019391212845221162, 0.0017698697047308087, 0.0021199367474764585, 0.0024852084461599588, 0.0020277828443795443, 0.0014318776084110141, 0.0022299413103610277, 0.0025462058838456869, 0.0017444862751290202, 0.0028004168998450041, 0.002275790786370635, 0.002285356167703867, 0.0016713759396225214, 0.0020526214502751827, 0.0027278885245323181, 0.0026276675052940845, 0.0041041695512831211, 0.0018015971872955561, 0.0019049092661589384, 0.0024411282502114773, 0.0013898784527555108, 0.0021453860681504011, 0.0020872668828815222, 0.0020947379525750875, 0.0017574651865288615, 0.0017502052942290902, 0.0017633518436923623, 0.0029141802806407213, 0.0022852092515677214, 0.0020640885923057795, 0.0025412407703697681, 0.0022078263573348522, 0.0027655300218611956, 0.0025272935163229704, 0.0016922415234148502, 0.0016945131355896592, 0.0019886295776814222, 0.0030135423876345158, 0.0021342055406421423, 0.0019502892391756177, 0.0019344140309840441, 0.0016256544040516019, 0.0026282365433871746, 0.0021083001047372818, 0.001954526174813509, 0.001455415622331202, 0.0027762441895902157, 0.0019475024892017245, 0.0022382771130651236, 0.002584533067420125, 0.0013273198856040835, 0.0017132211942225695, 0.0023237888235598803, 0.0023467938881367445, 0.0021548124495893717, 0.0018766809953376651, 0.0018577210139483213, 0.0022481638006865978, 0.0029759511817246675, } };
const TfArray<192, int> quant65_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant65 = { (TfLiteFloatArray*)&quant65_scale, (TfLiteIntArray*)&quant65_zero, 0 };
const ALIGN(8) int8_t tensor_data66[32*1*1*192] = { 
  /* [0][0][][] */ -86,-9,-13,4,-45,-1,34,23,-24,-85,33,-26,65,14,-6,51,-127,-13,2,-30,-59,-4,9,7,-24,10,74,41,30,-7,-56,1,6,-26,-58,7,-42,34,-4,127,-11,-51,7,-5,-18,5,-57,-47,2,-57,33,85,80,76,34,-5,11,-4,19,-34,-30,52,34,-32,-2,81,23,50,-19,29,13,31,16,-66,9,-27,60,-14,36,-26,-40,12,1,14,41,83,-55,7,70,-26,-31,-31,70,1,-43,-16,44,-30,2,-5,8,2,95,45,11,11,-24,-50,-59,55,44,-22,-10,-28,-9,5,9,-20,31,-8,5,-59,53,41,-4,11,5,44,-16,27,-8,-41,32,-22,75,-41,100,-45,-51,36,28,31,-25,-9,-38,-75,-71,48,10,-54,41,-37,25,18,-2,-34,-96,35,-21,-3,-23,-2,-24,27,-14,-83,27,-33,-7,-16,-6,-49,49,-19,13,64,63,3,74,-12,32,-73,64,11,23,-25,51,32,-44,54,23,15, 
  /* [1][0][][] */ -13,19,-6,-8,4,63,20,-73,-18,-92,6,-63,-70,23,-44,-10,-66,59,24,29,22,22,31,27,30,2,22,-65,-8,34,24,38,-67,-88,83,13,29,7,13,1,-73,-24,83,24,18,-1,41,-52,-48,70,-45,-6,-52,-22,43,-8,-18,47,28,-11,-30,84,-69,48,10,-4,-38,-11,3,13,-55,21,29,21,-43,12,-91,-50,-57,-61,-79,31,-18,32,-2,53,-41,1,90,-20,15,66,-94,-54,-12,-31,33,-58,21,14,-66,-1,-45,13,-14,-10,-49,-57,-20,-6,6,29,13,55,30,39,49,79,26,-1,-13,-34,11,-31,-50,60,-125,-6,0,-3,-29,18,14,31,-10,-22,-41,-5,-17,29,-66,-26,61,-1,-8,-12,-64,-17,-39,32,-7,54,-28,-65,51,-16,-4,-69,5,-127,-47,-26,68,4,45,-34,57,-12,-30,-22,-4,17,16,-54,-101,32,-7,14,-34,-15,54,95,-43,101,29,-19,57,45,-40,-39,23,-24, 
  /* [2][0][][] */ 19,-34,-3,3,-11,22,47,35,17,-46,31,-15,-44,26,35,21,-44,20,-11,-33,17,39,-52,8,-16,49,32,-11,28,21,-4,-37,-14,8,-60,-13,32,26,-62,-9,31,24,27,-70,18,14,17,-8,8,-30,-24,35,-14,-49,-32,12,38,19,6,16,11,28,33,-7,-14,-17,6,-18,-10,31,8,-3,51,3,47,8,36,35,-28,49,24,6,24,10,-41,-7,55,20,5,-8,-16,5,-3,-49,0,2,10,9,-5,30,-13,-13,12,9,-18,-15,24,52,-11,12,-27,21,-17,-32,23,38,62,-27,-5,35,-8,14,22,6,2,-18,22,36,-17,-21,19,-10,-13,11,-42,-4,19,60,8,10,-37,25,-9,-45,43,-19,-20,21,-7,-127,-13,3,-36,-26,45,-66,45,35,-10,21,-18,39,-12,12,-79,-6,37,9,10,-11,-30,4,-8,8,23,19,-25,20,-5,19,47,-14,42,-1,14,34,-2,43,7,28,33,-8, 
  /* [3][0][][] */ 3,-45,88,-12,90,56,20,58,20,46,11,51,42,-13,65,27,32,-13,85,61,41,-64,127,29,23,45,-5,73,1,-1,-58,-19,1,-47,22,32,78,16,8,66,9,14,-21,7,33,46,-43,3,-6,12,-27,38,-34,17,-26,57,16,-27,-74,-72,-22,37,50,-58,-51,59,-31,51,-34,9,61,-21,-7,36,-9,40,77,-66,8,22,18,33,-44,-45,17,-22,17,80,-9,67,-31,-78,-13,-44,41,46,5,51,76,-80,-30,-39,36,65,32,10,-8,-22,45,69,12,107,-38,-44,4,5,26,-7,16,-45,-4,8,44,32,38,-2,-47,-60,108,66,45,-24,85,29,21,20,18,56,6,-35,-29,11,-25,43,-75,25,19,-44,32,-120,3,-103,31,-20,105,14,30,-37,-17,68,-12,20,-51,-14,-9,-14,17,0,-24,-38,-17,8,46,5,33,52,26,11,12,12,-8,-20,35,-54,7,14,9,71,-89,78,14,-39, 
  /* [4][0][][] */ -35,-39,-70,29,56,46,35,-22,-49,-22,26,-101,3,46,22,14,-26,-86,-62,-6,-26,-36,89,-37,-42,-108,9,38,-79,-58,-87,107,-22,45,38,-12,89,-19,-39,74,-24,-43,46,61,-5,19,-30,12,-12,-47,11,36,-33,75,98,-48,-56,51,-83,-56,-53,24,-62,9,-67,28,-15,69,17,4,19,-8,-53,-36,-71,2,87,-110,-74,-21,-3,8,3,-94,53,43,60,62,-45,29,62,67,52,-27,-117,46,-121,3,2,-50,-25,-13,-38,24,97,-25,-37,-3,-59,49,20,-47,-30,-34,-52,-20,31,-19,80,-119,-7,-82,-13,-127,73,0,-39,36,34,67,-46,33,-109,58,12,-6,48,-31,-88,-23,-28,76,69,-22,13,-6,60,-53,49,111,-30,42,3,2,-47,-58,-56,-72,-86,75,90,16,-20,-30,-28,-17,99,25,-21,37,22,53,9,61,-25,-2,36,30,-22,-18,-1,64,-60,-14,-109,-57,27,38,29,6,-39,14, 
  /* [5][0][][] */ 16,27,28,25,-8,-79,-13,-31,-23,-34,88,46,-6,-20,-45,28,-11,7,-56,33,-40,41,-71,-13,9,2,33,-46,56,50,-17,-7,29,35,38,-34,-75,8,-59,8,-13,29,-58,-96,-95,54,18,-8,-43,-16,-13,14,-15,-25,19,-3,108,-70,50,-62,-6,108,-48,2,21,-40,81,34,14,37,66,127,-18,6,21,-12,4,-20,22,-36,-10,-37,39,37,-20,-3,-30,24,-29,-4,74,28,78,-3,-24,-1,92,-53,-60,21,88,-8,1,-67,-50,-8,17,-59,-87,-86,-7,-22,-9,-4,60,-19,28,10,-5,43,-15,-27,-31,16,-28,-48,49,29,-31,6,16,-14,-71,7,-3,4,-28,47,-6,-9,36,-64,36,-44,9,-48,-72,93,-16,51,14,-9,-6,101,-5,-25,26,1,80,-13,3,45,12,8,-23,-63,0,-21,-43,-61,-37,-11,2,11,25,-67,-68,-32,-24,-40,16,6,39,-57,8,-10,-60,19,-1,36,60,35, 
  /* [6][0][][] */ -60,54,-118,72,-53,-90,-6,-35,-30,-5,-6,-50,33,-29,-31,-60,-96,69,-52,90,-9,-8,-34,-22,9,-7,56,-10,6,-42,57,10,-94,-95,-21,-16,-31,-23,58,-60,5,-26,5,-28,-13,-43,91,-33,-25,73,-47,-99,-66,-85,-33,-68,33,-21,48,34,17,-12,-63,31,-72,-48,-14,-35,64,18,-8,55,32,21,37,-17,-97,-19,31,-41,14,-35,-9,26,-43,-35,28,-20,-99,-29,-46,-40,-66,50,13,-53,-43,-71,-56,87,0,69,-38,-26,-61,26,84,-19,94,-54,-5,-6,68,60,18,-23,33,-8,-28,9,7,-58,-23,-2,-97,72,30,19,-70,-14,62,-72,-15,-15,-41,17,27,-52,-37,-50,56,-104,59,-30,-4,12,-45,83,-28,-63,41,54,-54,-30,-77,48,-79,25,51,-94,0,-9,91,100,43,-60,-6,68,33,42,11,-8,64,9,0,44,-44,15,126,18,37,57,-121,18,24,61,5,-55,8,-127,-11,-7, 
  /* [7][0][][] */ 72,59,-34,-22,15,-25,-54,58,-30,-38,-52,2,71,17,17,26,127,24,-60,34,28,10,-41,25,2,32,45,-16,-7,-25,25,75,29,-36,-94,-36,18,20,-6,28,30,69,10,-40,-75,14,-38,-38,4,19,40,-12,-14,17,-43,47,85,25,-42,-17,-45,-37,-59,-47,6,32,-39,44,-4,-28,-18,2,-20,-7,21,-26,-18,12,-16,32,47,-58,16,-88,-14,0,-30,-87,37,-3,-48,-3,-26,-11,-49,20,-52,-8,26,62,10,-37,-30,-47,34,13,41,72,-58,-10,5,-21,12,73,-25,32,0,-11,31,5,-38,30,-20,3,17,54,68,88,51,-16,-13,16,-5,50,8,-44,37,-17,-5,-29,-52,37,-7,21,-25,10,-32,11,1,94,-13,46,-52,-1,27,-20,-8,-32,-80,101,6,83,-25,-2,-15,47,5,-26,46,0,49,-60,-19,-3,32,24,9,-10,39,28,17,-19,83,-56,34,-7,29,48,38,-6,-12,19, 
  /* [8][0][][] */ 29,31,23,-46,19,35,-24,-26,24,-70,-6,48,7,-56,46,-29,-29,-15,14,75,-56,-27,64,-7,16,3,-44,-9,-63,-7,-22,40,-51,-46,67,46,-41,-31,-16,127,96,49,-27,104,-22,55,-8,11,29,65,11,6,14,15,22,-49,-87,-2,4,-69,-38,2,67,-20,24,-10,-5,48,-41,-52,82,54,-52,-30,-20,-23,-19,-43,14,77,-8,30,4,-7,103,27,32,-52,22,59,-4,32,-15,-55,63,36,8,19,84,-53,-27,-5,-42,87,30,9,-80,8,31,6,71,25,-28,-4,0,-47,-27,-5,16,-12,-1,8,-10,-1,51,22,-24,6,50,-12,-54,102,-45,23,6,33,-31,-42,62,8,25,-32,-64,21,24,-17,42,-68,10,-2,-44,-13,5,19,3,6,-41,35,-73,-42,43,-34,-8,-101,-31,26,32,-24,31,-38,52,44,7,57,105,11,42,31,-8,-12,22,-43,-41,-8,-46,0,30,-50,-10,-49,-5,21, 
  /* [9][0][][] */ 49,102,59,15,-3,102,16,10,25,40,28,0,-88,-52,89,-24,113,-35,28,-43,60,21,-62,55,25,-52,-43,-70,-1,79,-30,92,47,-28,59,16,30,-21,24,-25,67,108,80,-12,-2,-14,-28,89,35,58,44,-28,9,-111,-46,18,-43,-27,-44,-74,56,11,53,30,43,-2,-3,-3,-48,32,25,-47,-61,-2,-15,16,8,-74,-51,-22,-44,-24,-71,-78,-46,-30,114,92,73,-38,4,26,-87,-46,10,-21,-3,5,42,-24,-1,-28,-48,-73,48,1,-20,76,-26,-24,12,39,0,47,-19,-24,22,6,1,-31,-39,-39,-23,14,-43,-7,-48,14,45,-34,82,4,-23,31,-59,-5,-19,88,-47,-62,-69,-4,32,-50,13,-35,-25,-33,-8,11,29,52,-15,-8,76,-87,41,-63,-39,-20,33,-19,-38,-18,-36,-8,-18,-44,-106,59,-16,112,-80,-28,-18,51,1,127,-43,12,-93,8,-14,42,-15,13,31,-51,50,-48,-17,3, 
  /* [10][0][][] */ -1,-29,42,-15,6,-68,-42,18,1,36,-32,-3,87,36,56,11,122,22,10,26,-77,-47,0,-1,44,-18,104,13,-16,32,-35,26,39,-30,-30,-5,26,41,-87,78,106,-21,-84,-96,36,20,-103,-65,-32,33,16,-67,-40,82,28,53,89,33,-22,45,18,-96,-3,29,50,-74,12,51,25,-90,84,-78,-66,-19,-80,18,-18,-22,-45,11,-65,32,-13,62,17,2,-97,-11,58,59,-20,-28,26,15,58,77,63,-60,-7,41,-10,-27,16,-11,44,-10,-15,-11,6,77,47,-15,47,13,-31,39,14,44,52,-40,8,50,-116,-24,63,29,64,-13,25,44,-14,-46,-50,89,56,40,-9,0,52,-13,26,-11,3,-34,-27,7,-15,-8,50,63,-47,1,50,-65,-23,43,-14,-12,-50,77,51,27,31,-58,-127,31,16,40,-11,7,31,-25,42,7,116,9,21,-30,36,-22,25,-44,-10,34,-44,-46,18,14,53,-21,-48,-10, 
  /* [11][0][][] */ 84,-11,-36,51,64,89,-53,-7,-4,1,-102,-21,80,60,71,-67,82,-14,-75,-15,9,-29,95,-25,38,18,-64,-28,25,-17,-60,-5,-31,25,-48,78,-31,-27,104,70,-125,71,-45,67,-39,-11,-109,-11,30,-3,26,82,16,-63,-52,-40,3,-16,-48,-27,46,2,65,46,12,5,-21,6,-17,-54,-92,3,8,-127,-103,7,-1,9,-69,12,-17,59,-67,71,29,-36,-72,-7,0,9,-33,2,-120,-95,31,82,-9,-40,116,-18,46,-6,91,31,83,23,17,-37,53,88,109,-34,39,29,-86,29,45,-125,-8,-74,35,33,1,-21,62,-20,-11,-36,-5,-74,-90,3,-16,11,32,-46,-23,34,-38,-42,35,10,-6,-75,-103,24,96,-50,46,-50,-55,-32,108,-52,8,-10,-38,70,57,25,42,-64,-3,-5,92,17,-5,74,-73,126,-72,59,-39,41,-119,7,35,54,-35,-1,-45,-7,-14,53,-16,-53,50,-41,-79,-3,-53,26, 
  /* [12][0][][] */ -10,-23,-37,42,-35,-21,-14,3,55,47,7,41,-41,-36,13,-50,112,20,3,-67,-48,-24,-69,19,-63,52,-7,-46,28,31,11,-59,11,0,-81,2,53,-6,-13,-2,-17,-34,20,11,62,-8,0,-12,3,-49,-28,17,3,-14,-6,39,-91,79,3,30,-52,17,50,29,74,-8,-11,14,20,20,-49,31,23,-14,-47,36,38,80,-19,5,10,8,-48,42,20,30,4,5,57,-76,-5,35,-11,27,-29,4,22,13,-28,11,13,15,0,-24,26,-58,23,74,-48,14,-18,69,14,3,30,45,-63,34,-46,17,-13,-99,-59,-4,2,-70,22,0,-15,-15,-12,22,13,34,-5,37,58,-62,-36,-21,32,-8,-30,55,17,54,31,-55,22,6,20,-42,40,33,32,65,-127,-38,-7,16,0,49,-15,31,-10,-27,-27,-7,-10,-14,34,-12,6,-39,-15,-8,-1,4,15,26,10,-25,-29,15,80,54,36,45,-2,-16,-28,8, 
  /* [13][0][][] */ -75,-58,2,10,-2,-26,-14,-45,23,50,-38,47,38,18,-19,-28,59,15,-16,-42,-19,19,-37,8,-21,25,23,-28,64,2,-1,-50,10,15,7,-2,26,11,14,-68,52,-9,5,-12,36,-30,76,32,2,22,50,14,18,-27,-13,47,-14,7,10,74,11,47,1,-10,31,-68,-28,-48,41,6,28,-19,18,-2,-21,42,-24,9,-7,26,52,-37,72,88,13,-22,-15,24,-2,-17,-79,-31,9,60,13,-37,0,-12,-30,34,11,-8,42,-37,-1,-12,-24,37,32,-49,-57,30,20,-48,-9,2,-25,15,-63,43,20,1,-40,41,-31,31,-20,-79,-41,-19,20,-14,21,5,-13,62,-34,25,6,6,-40,24,38,25,41,7,29,11,-12,38,-3,22,23,-56,-43,51,5,-14,-21,108,27,41,-10,30,-127,-2,0,0,48,-24,-15,20,44,-36,26,37,10,16,-35,39,40,79,-1,-48,73,-1,-11,-20,-20,-19,36,9, 
  /* [14][0][][] */ 53,-85,-9,39,-12,25,-11,-71,-64,52,-1,-23,22,35,-36,-41,10,-38,81,-19,17,-30,-42,-29,-18,21,28,-19,-42,7,-33,-29,3,-48,68,13,30,32,-11,-63,2,-7,18,-78,-17,-35,34,34,-48,63,-96,-28,-8,34,-15,10,-36,87,-39,31,38,56,29,-48,0,4,35,-44,-1,-11,20,45,34,-76,-83,64,-65,-54,7,17,-29,36,-52,-61,-4,5,25,-6,-9,-62,22,-85,-4,-48,85,-43,-29,-13,-71,90,28,-14,8,-15,32,-10,76,64,60,-30,38,-1,31,-110,-4,43,32,-16,16,-11,-1,-66,44,-83,-30,-27,45,-45,-90,-34,-7,23,42,126,-56,-21,18,-12,-46,-39,-105,-24,-57,0,-1,-56,-50,-27,19,-60,8,-25,-19,19,26,-28,-49,-31,66,48,-28,-73,86,36,-127,-18,52,45,9,53,-5,-16,-32,25,-15,-39,14,50,-1,40,27,0,-86,103,-32,34,-7,-19,61,-77,-6,27, 
  /* [15][0][][] */ 3,-18,60,61,33,-37,-49,54,-25,45,1,1,52,37,-44,-15,60,45,55,66,59,-16,-3,2,-25,-23,20,2,2,6,21,-37,43,-59,38,52,55,9,-12,-12,-6,8,3,18,29,1,14,-4,-41,4,17,59,5,18,-12,49,22,-13,-40,19,9,-19,-28,26,8,30,-15,37,48,12,50,7,-62,-25,3,26,51,15,4,-50,-35,-12,-5,-26,34,12,7,24,20,60,-14,-15,44,36,-47,20,-19,32,-8,40,9,-22,24,40,28,27,7,-17,-21,-62,10,-3,-10,-63,-82,61,6,-25,5,-6,62,-9,19,-19,47,13,23,87,0,-7,42,-87,-26,33,-21,-14,-16,-25,-62,11,27,2,0,13,-65,-1,-57,19,48,39,11,-22,-25,1,-16,78,22,21,-62,127,16,16,-5,40,4,-15,16,7,-24,-2,27,-38,5,-3,1,-27,38,15,19,19,3,2,9,-37,37,14,13,19,12,-45,-54,-20, 
  /* [16][0][][] */ 28,35,4,-26,13,-25,35,22,23,17,53,79,25,-100,-29,39,20,-13,27,53,-8,-16,-14,31,-2,-22,23,22,16,-18,-6,-33,-17,-4,-13,-60,-11,-22,13,-30,30,-14,-9,-10,-61,112,44,11,-16,3,24,28,-28,4,-63,-7,62,-56,-10,-71,-9,-31,-12,-26,23,-33,-19,20,31,22,21,49,-35,38,25,-5,-42,-3,52,-1,0,-28,-34,-6,-53,34,-31,49,-48,-10,77,-12,-6,3,-34,-34,5,7,1,41,25,-3,28,-16,-13,-22,7,1,11,21,18,36,-87,-12,17,-3,-20,-30,-42,-8,-26,127,-21,28,-4,14,62,5,26,5,-18,-22,10,20,11,21,38,0,28,-13,-53,-7,20,-25,-16,-30,12,42,26,-7,-8,-17,-90,50,-20,29,8,20,10,-51,-38,26,-25,40,4,-32,-21,-18,19,8,-12,0,-5,-6,26,-6,-38,-44,18,-1,-61,31,6,-63,-34,-13,-32,4,-19,7,-49,-1, 
  /* [17][0][][] */ -45,-1,-6,16,-20,12,46,-12,45,-14,-12,23,-23,-37,-41,-39,22,1,26,49,46,-37,-51,47,-72,-18,-73,31,-11,-38,61,-72,73,-40,-67,80,19,-48,67,4,2,34,-13,45,17,50,-127,-52,38,38,-1,-11,-1,64,-42,60,-28,-43,-19,-15,-51,-66,47,23,68,51,-45,5,6,16,18,-43,17,3,39,32,-22,-19,-9,11,29,0,-65,-4,9,26,3,-7,-31,30,-1,-17,-25,25,10,-47,12,29,8,-13,-43,-5,39,-16,-29,13,42,60,8,20,71,-9,-3,-31,18,13,-7,-2,3,56,5,18,64,17,-50,-32,3,-30,55,-1,30,7,53,12,36,-15,-6,-39,55,27,-10,59,37,48,-69,-32,18,-42,-42,-54,-12,14,-6,-19,-29,-13,53,69,-12,-87,0,-60,12,27,-66,-56,4,-48,62,10,5,25,-63,103,-14,1,8,41,-26,-56,3,-18,-70,44,-10,44,21,-36,67,-57,37,-6, 
  /* [18][0][][] */ 25,-8,-71,-3,-28,38,-24,12,38,26,-49,59,-9,-21,23,-61,-23,-19,-12,48,-86,-57,37,6,-37,9,27,72,-35,-29,-9,91,-27,-11,-7,-9,19,33,-39,56,38,60,-15,-19,-17,-58,-31,55,6,-2,18,-28,18,59,29,-32,-70,25,-32,-18,-47,22,-1,-18,-44,93,25,3,32,-75,30,37,-44,5,39,-7,31,-37,34,12,-49,25,-23,-15,-47,71,-1,-61,25,57,-27,15,36,-28,-36,-3,-59,54,10,-82,-51,4,-127,-36,-3,35,-48,32,31,51,10,-13,21,-17,-57,-5,-15,-16,45,-69,-35,-35,1,21,35,72,-19,-36,-52,3,-51,-42,28,34,19,-42,17,28,-42,46,3,-10,82,45,-21,-49,65,-32,29,124,23,-18,-10,-29,14,-45,8,53,-42,8,65,-23,-32,-37,-40,37,-14,18,27,17,-21,46,44,9,12,18,23,3,51,-3,-6,56,-28,-15,2,-49,-18,-57,-26,16,-73,-44, 
  /* [19][0][][] */ -45,-4,55,64,77,24,9,-13,-127,-17,-77,26,51,14,64,26,51,-31,77,-33,21,15,-9,2,-15,44,-1,62,7,-33,-6,-62,56,-34,-106,-7,-27,-86,-20,103,33,-32,-4,76,-9,-72,-36,47,-11,29,-2,68,-30,18,59,45,-32,-46,-13,56,-81,-28,-7,17,-13,16,-43,33,-66,84,29,-9,43,15,6,3,96,11,-8,5,8,-31,32,9,-68,13,-22,43,-71,21,-115,42,79,-68,33,43,-7,35,20,20,-76,11,118,-7,26,-30,-30,32,-86,-21,28,-29,-12,-35,-75,58,-15,13,54,80,67,95,-18,34,31,7,-75,4,91,-20,9,-101,-11,1,44,-32,-115,-14,48,6,0,-64,-34,2,37,37,-20,52,46,120,38,44,-48,-60,34,-67,62,-16,-28,42,-4,89,-9,-4,4,48,22,-37,17,53,-91,1,-20,-6,47,-30,-5,-16,0,-42,-56,-113,-40,-30,-10,39,43,-32,9,60,67,54, 
  /* [20][0][][] */ -6,-36,55,14,5,0,26,-28,-92,-5,-2,-11,-17,-52,11,-17,-6,-72,22,-29,-41,4,53,1,-23,33,7,34,-83,39,-10,35,13,-30,40,-9,-12,67,34,61,-8,5,-63,114,2,11,-40,3,-1,4,0,-73,-38,12,-44,61,-68,46,13,-7,-59,-63,95,-29,-86,-43,60,39,-39,-99,16,23,11,17,3,-41,-58,-25,14,11,67,-32,-13,-34,67,63,-112,4,-19,22,1,-86,45,-71,6,29,12,-26,71,-101,7,-21,-127,67,73,34,-23,32,-7,30,-54,46,99,10,22,9,-24,109,47,57,-27,-23,36,27,17,-18,18,-15,37,33,33,69,-15,-50,36,-20,-36,-41,23,68,-27,-57,-52,44,13,-6,56,-33,-7,6,1,-49,-14,33,-46,-8,-60,-21,-15,40,-12,-50,23,12,62,-19,-42,-5,93,-5,57,25,2,-44,36,-14,5,-34,-4,-6,57,-95,94,-2,-52,-93,-29,61,-28,9,-12,-107, 
  /* [21][0][][] */ 16,-6,-3,75,7,25,-4,-1,2,28,10,66,-40,51,33,57,39,-10,19,12,13,-22,52,-46,2,12,-2,3,18,43,-22,83,-29,-16,39,7,20,-87,-20,42,-39,-36,88,-16,36,15,14,17,15,1,0,7,-7,28,25,10,64,74,-56,12,7,-4,-52,53,12,-36,8,52,10,39,-60,18,21,-16,-19,13,13,7,-18,-24,-12,18,-86,2,-54,36,-35,77,2,5,35,65,-82,1,10,8,-45,-41,41,4,-23,-19,32,22,-20,-42,-34,8,6,-76,5,-27,2,20,24,-70,38,15,34,-18,15,41,-44,-20,60,-8,-52,-49,71,58,-32,76,-13,45,15,2,6,-5,-10,-58,-67,-95,-16,-34,18,107,-20,-22,85,-6,-91,20,-41,10,-36,2,-28,-43,-26,-35,-5,53,-15,-92,-30,-91,-16,22,-35,-18,-64,2,127,31,-63,12,43,-4,25,-59,-75,-20,-79,10,19,1,-7,-1,56,7,23,-31, 
  /* [22][0][][] */ 41,6,-2,46,72,26,5,37,-48,-33,55,6,71,27,15,94,25,4,33,-24,117,-55,-39,109,-44,33,-26,26,28,6,-17,64,72,-6,4,51,37,-1,-33,11,-6,-31,33,14,-18,-16,-48,-92,16,-42,71,70,50,54,25,55,2,29,-81,8,22,71,-93,4,20,22,-39,53,-69,54,-15,54,38,-6,-49,-18,57,47,-39,-56,66,48,-60,-37,47,-5,-60,48,-34,17,-1,41,-11,-65,58,37,-47,-31,13,-36,-20,-28,50,8,92,14,-14,-52,-45,7,37,-35,-9,57,-53,33,7,14,51,50,30,-25,97,-29,2,-31,-1,-16,5,-1,-14,47,104,11,-21,-14,-17,-42,-42,-48,9,33,-47,29,-23,20,51,32,43,21,-35,14,28,-7,59,-39,-2,-29,-42,-4,-21,70,23,-10,-24,-55,-9,-78,-64,14,-50,6,24,0,-48,18,-16,-55,-29,-5,-2,26,-11,-8,45,-10,-14,10,127,-37,51,82, 
  /* [23][0][][] */ -12,-41,-27,-66,-44,15,-8,1,-1,-1,0,-74,-34,41,2,-1,-1,-42,19,-13,75,15,36,74,27,-6,10,-22,9,-85,-23,51,-11,23,40,15,16,26,72,-65,-34,48,29,-92,28,-9,-20,-45,9,-23,37,61,-25,-35,-29,-21,36,8,-3,51,53,-4,-39,-52,-55,8,2,-38,-18,69,1,-83,12,-45,-29,-10,18,50,36,-73,-30,-21,9,-47,85,-4,-14,51,75,-17,13,36,-39,23,-1,-7,-21,-31,44,127,3,-16,-14,17,-23,12,-13,17,11,66,43,-36,-69,-123,-33,91,-23,-20,-1,22,42,-45,34,-12,-26,30,56,60,-28,-34,15,14,9,-40,-16,-15,46,-21,100,14,-45,78,8,43,-51,41,-9,-13,-7,36,-16,32,-26,-4,42,-16,-43,-26,-9,13,-44,-11,24,38,2,74,67,74,-25,49,6,-46,8,110,-19,22,-18,16,22,75,-6,-50,23,52,-9,-19,44,10,-23,-41,-22,37, 
  /* [24][0][][] */ 15,-54,-63,79,1,8,-14,54,-127,-22,13,15,-26,-11,-40,-47,-28,6,-29,12,-39,-25,26,10,33,-101,27,52,3,-68,-7,17,-50,26,17,91,-47,55,35,17,-34,-9,-21,13,4,11,-75,-44,-113,15,-78,-40,-70,49,38,19,-76,-17,-12,50,48,-6,-62,-1,-15,4,18,59,-46,-12,3,26,28,-25,-74,44,-10,-33,48,-3,-10,6,-53,20,6,27,-28,69,49,-19,49,-70,56,-14,120,-22,41,-55,-20,11,-72,-24,-12,33,53,21,-9,9,11,5,51,-13,-1,7,20,67,63,-24,35,42,70,42,-20,-28,-60,3,9,49,-54,20,11,46,5,22,-43,-44,-8,-37,97,-29,-58,44,18,-13,-20,-25,18,-51,71,0,-27,12,108,-1,24,-45,-3,54,70,-80,76,-19,115,-2,-3,-46,18,51,95,64,-47,-25,-4,-28,-54,39,-4,-12,30,-106,-9,-20,30,26,-23,-12,10,40,33,-6,-91,-56, 
  /* [25][0][][] */ -4,24,16,18,-57,-47,49,-43,-22,-28,10,1,6,-19,-25,-5,-22,-61,14,15,-45,33,-61,-33,31,-39,54,6,-42,7,-48,-24,-14,-4,14,-34,18,31,-20,15,36,-18,-28,30,18,49,-127,-61,-48,-37,3,-10,14,27,-10,-5,82,-29,19,-12,-35,-72,-29,22,34,1,53,-5,45,-24,-12,-24,21,14,-43,-42,9,0,64,-23,-12,19,10,15,8,3,-92,45,36,5,40,13,85,41,-49,-26,47,-2,-77,-19,4,-21,-37,43,10,11,-5,1,-22,-14,23,-29,-5,-72,50,27,-19,25,19,32,22,8,-29,33,-48,-37,-15,-2,-33,4,-2,-29,-8,-24,-11,52,63,-10,-36,-26,-38,25,47,-27,16,-51,12,-10,-6,-27,-18,8,-9,34,-47,59,2,-115,-17,-32,-37,-16,37,44,-14,-61,-53,-31,-44,9,-46,-26,-55,-23,37,28,34,-58,5,55,12,-100,45,3,-53,15,-1,21,37,13,-15,21, 
  /* [26][0][][] */ 20,-16,-26,9,-59,-37,18,-57,-34,-58,43,11,-99,27,-34,31,-25,23,7,-29,21,-34,-17,-64,9,89,68,-30,73,7,2,-16,-10,-2,3,-57,32,37,10,39,32,-3,45,-55,21,5,24,-53,-16,-84,20,35,41,-3,25,-2,36,-21,20,92,1,-68,-49,-56,59,-11,-23,-11,-21,14,7,36,10,27,8,51,46,14,59,21,-39,28,25,78,0,-5,0,22,-33,-6,24,7,-25,84,-17,12,-6,10,-16,20,-31,-22,73,-77,-35,-109,-62,8,-21,25,-15,-24,-2,-57,23,127,18,-12,-51,0,47,10,-65,29,-6,-4,23,31,28,-10,-75,42,-45,4,11,115,27,30,17,22,-17,-23,-27,-32,42,-35,-3,-43,-43,1,116,48,38,18,26,40,77,61,-54,-55,-21,85,-18,-44,-35,19,68,-32,-12,-56,17,-54,-32,-12,31,-30,-37,-9,-38,64,3,3,53,-1,111,5,70,0,-40,32,-34,23, 
  /* [27][0][][] */ -2,72,-14,-23,32,19,-19,-15,8,44,-66,37,-1,0,-15,11,-14,-2,17,5,-7,-47,27,2,-55,-37,24,28,-36,-34,11,-12,-29,-32,16,-40,23,16,-30,49,-34,-28,33,-12,-5,-38,-30,57,127,12,72,-33,35,29,-84,-45,-1,28,3,-33,5,35,32,47,26,31,9,21,-25,17,-28,-16,-14,-24,35,-23,15,-20,-68,-32,72,40,-21,108,26,45,-67,-7,-18,-5,-44,-52,-27,-2,-15,-6,14,-18,-25,3,-22,49,-24,16,13,8,-70,9,49,25,-4,-37,-13,-12,2,-60,-66,25,-11,-16,62,-6,-61,45,18,-15,-4,-49,-43,-6,-27,-8,65,-7,61,-18,26,-25,-25,13,50,-13,19,11,-42,54,-9,7,-4,-23,-21,-5,-7,-52,-46,-2,-8,26,-41,4,5,-41,-8,-23,-71,-85,-2,-24,-19,-25,-13,-17,47,38,-24,13,29,1,-4,3,-19,-32,-21,54,-42,-27,-18,-3,-69,51,-52,33, 
  /* [28][0][][] */ 2,-6,-7,46,33,-53,-11,-39,-35,-44,-46,-45,-60,20,-3,-38,-12,75,-42,-48,-29,-7,-48,74,-18,-4,61,-19,11,39,21,5,39,36,-37,-39,12,-21,-48,55,57,58,-47,-65,86,-13,36,55,-13,-46,7,1,0,-49,-19,-13,-65,-20,31,-20,-17,-10,-26,9,-26,65,-12,-48,-24,61,-40,-5,72,1,27,-12,79,39,39,89,-3,-25,-42,46,-7,16,-22,41,-53,-56,5,21,-24,-68,-34,-83,-14,35,44,10,-7,-58,14,31,-85,6,-31,31,-60,-46,-4,-13,82,-20,37,21,-33,-18,9,4,-51,-39,-41,5,-33,-4,-51,-27,36,3,67,-57,-1,8,-31,23,-106,39,-16,47,-23,41,-46,7,35,26,35,6,-45,1,24,22,-11,-37,-65,-39,-5,-21,-36,61,34,-17,-47,-69,-57,41,0,-7,-42,-20,-18,-21,-127,9,29,36,-21,45,-10,-28,59,6,-41,59,-9,-50,48,41,-8,20,29,-94, 
  /* [29][0][][] */ -7,46,-26,-68,58,46,-13,-25,-31,-30,18,-46,-58,-72,67,42,-2,23,17,78,41,37,-29,-33,40,-49,-24,-27,-27,-9,31,-71,-46,-4,-22,-89,-4,9,-75,-61,51,48,63,31,-54,14,2,-61,12,-11,-14,45,-66,-30,-38,-43,-32,-73,-8,-42,-27,-71,-4,-7,-14,-40,-10,-14,-44,-25,-18,-42,59,127,49,-30,-9,-16,-4,65,17,-51,30,-36,-72,21,113,-55,18,-44,42,-1,-54,-13,18,6,-21,8,24,-18,13,27,-24,-19,15,-5,22,13,48,57,-82,60,-78,-46,39,28,18,19,3,-3,-44,38,10,41,-15,-2,-64,-47,66,-6,21,-9,-1,-16,-48,55,2,-42,-34,14,21,-22,-12,25,93,-32,-18,4,-49,-99,47,-6,-64,8,33,-90,47,96,-20,-43,-62,8,-46,-8,15,-25,-51,23,-3,53,-38,62,-25,25,39,-32,-28,-8,-58,39,-19,-54,-2,-36,-56,22,-13,74,-44,63,-10,40, 
  /* [30][0][][] */ -29,5,-45,46,55,37,37,-3,49,76,-29,-21,-6,43,-4,-53,27,11,42,85,58,47,6,-21,91,44,-113,29,30,-1,65,-54,-30,-37,13,-26,-26,-6,-36,-113,-127,-2,11,8,0,-50,13,-71,-5,-12,7,15,-44,-20,46,-27,-74,-84,33,-19,15,32,93,-24,-4,45,31,-83,73,-118,-80,23,44,40,-25,11,-35,-24,53,-44,-55,-15,60,44,6,-37,16,-46,-17,11,-2,31,23,17,-83,-21,73,50,-71,-44,-2,57,32,-34,-75,23,57,-39,8,-5,-53,2,21,-93,40,-33,58,-89,-57,28,-6,15,-34,46,-75,22,14,-73,-57,-25,24,24,35,-38,-82,13,9,67,-24,-26,-28,5,-63,-8,-18,-3,-9,6,-81,92,78,-95,64,19,43,52,12,-45,55,40,-40,27,-4,82,15,10,-111,-4,-54,-9,-14,42,-10,-100,-114,-22,-13,-16,31,-3,9,-42,-49,-46,-17,40,-49,7,35,41,-4,39, 
  /* [31][0][][] */ -67,-30,-33,-12,-91,26,18,73,-10,-4,16,12,-49,-87,-14,-38,-32,-103,34,-36,-9,36,7,41,-32,-64,-1,72,-61,-107,62,87,-17,21,2,59,-43,-9,32,-57,52,15,-17,-27,12,91,-2,-84,-19,-32,0,-13,-17,1,29,-49,9,-48,32,-28,22,-92,16,-44,-17,62,82,-16,-29,-11,14,28,41,96,31,-82,48,-27,59,-4,-13,2,23,-72,2,84,22,-2,51,21,90,34,41,4,74,6,-11,-43,34,-97,13,-11,-122,24,-16,49,15,-9,-37,17,32,-41,-11,94,40,65,-15,32,49,65,-49,43,29,-77,-28,-17,-33,8,55,36,86,-54,9,-50,-26,-37,28,-73,127,-5,18,-14,97,62,24,9,34,5,-17,23,-54,2,7,30,40,-74,-45,17,32,-90,-22,-39,21,-47,-10,58,-19,-11,66,64,-36,16,-26,63,36,30,-48,-40,4,47,-104,-15,3,-62,1,-11,-30,-4,54,-9,-10,-22, 
};
const TfArray<4, int> tensor_dimension66 = { 4, { 32,1,1,192 } };
const TfArray<32, float> quant66_scale = { 32, { 0.0018282083328813314, 0.0014362698420882225, 0.0024784398265182972, 0.0018846237799152732, 0.0015503580216318369, 0.0016853869892656803, 0.0014400560175999999, 0.0017120371339842677, 0.0024560252204537392, 0.0012419644044712186, 0.0019897152669727802, 0.0012770295143127441, 0.0021353415213525295, 0.0022647716104984283, 0.0013277954421937466, 0.0019021235639229417, 0.0016153347678482533, 0.0018865688471123576, 0.001873083645477891, 0.001666176482103765, 0.00137115060351789, 0.001918246503919363, 0.0019378275610506535, 0.0013976073823869228, 0.0014188147615641356, 0.0019618321675807238, 0.0020064916461706161, 0.00170842872466892, 0.0014389040879905224, 0.0018258335767313838, 0.0019255526131018996, 0.0014777450123801827, } };
const TfArray<32, int> quant66_zero = { 32, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant66 = { (TfLiteFloatArray*)&quant66_scale, (TfLiteIntArray*)&quant66_zero, 0 };
const ALIGN(8) int8_t tensor_data67[192*1*1*32] = { 
  /* [0][0][][] */ -43,59,127,-12,-25,109,-34,26,94,-33,30,20,46,80,37,21,11,-72,12,-46,-58,-82,-41,-43,-6,-14,-13,-95,-40,28,-2,-6, 
  /* [1][0][][] */ -53,53,-20,76,31,7,23,62,-17,-23,-2,32,103,16,20,-54,2,127,-77,-44,-40,27,-94,-25,-8,-122,86,15,36,-76,25,-69, 
  /* [2][0][][] */ -119,70,-26,20,74,-81,70,-115,-58,62,-48,16,80,20,8,105,-11,-103,8,86,88,-45,75,-31,86,75,-59,-108,-111,127,29,-95, 
  /* [3][0][][] */ 64,31,-9,30,41,-31,-79,57,93,-1,55,12,3,-13,-66,25,-15,-19,74,127,35,89,28,-41,21,18,92,79,19,-62,-63,-100, 
  /* [4][0][][] */ 13,-74,84,-98,-27,14,67,75,17,-45,-31,-31,-127,-4,29,-89,10,4,17,25,35,69,59,-15,-27,-43,9,114,25,107,-17,32, 
  /* [5][0][][] */ 93,-1,18,6,-35,-112,84,-18,-2,69,35,-20,-39,-44,59,37,-2,97,24,22,37,-28,33,-30,31,-71,51,-127,2,-15,-48,8, 
  /* [6][0][][] */ 98,2,50,-3,-59,-127,86,-27,16,63,-50,38,10,53,-4,-79,39,-76,17,-9,-37,-11,-109,-6,-52,120,-41,-63,-7,-64,15,-12, 
  /* [7][0][][] */ 19,-4,19,-24,87,46,18,33,-37,73,-23,-15,45,-10,9,10,5,15,-43,-29,23,6,79,33,21,-66,2,127,-5,-38,-10,20, 
  /* [8][0][][] */ 58,5,43,-48,-75,102,-33,57,-44,-19,5,-3,15,43,98,-22,13,115,-39,71,-127,-81,49,-36,79,-34,19,-83,-52,-49,-84,-68, 
  /* [9][0][][] */ 18,-3,-3,27,30,43,-127,59,-77,4,90,57,-64,-19,12,88,17,-73,25,67,27,36,121,45,-18,4,26,9,24,-18,-67,-86, 
  /* [10][0][][] */ -33,-8,-37,-88,53,-9,58,-54,21,-71,53,-8,100,127,-5,8,35,-7,-40,-5,-20,-8,-101,-53,-48,15,-4,-50,2,-81,-12,-12, 
  /* [11][0][][] */ -49,16,1,22,22,-54,60,-7,6,118,-81,-74,-1,10,65,3,-31,44,20,44,23,22,-55,-71,51,-30,-43,-25,66,125,127,-20, 
  /* [12][0][][] */ 11,26,19,-15,100,-103,-44,-1,79,2,89,24,58,14,77,45,-64,-79,47,-14,10,21,87,-16,22,-127,-19,98,21,17,-33,35, 
  /* [13][0][][] */ -36,42,-65,-66,-11,102,37,-127,14,-39,-15,-53,14,-1,-13,-46,-21,35,-110,-86,2,-61,-12,-14,55,102,76,6,-32,63,6,-6, 
  /* [14][0][][] */ 32,-13,-108,-48,9,-35,17,-5,127,20,75,66,-42,-127,-105,-54,17,23,63,7,84,-21,-81,25,70,55,67,-17,-40,-21,-54,58, 
  /* [15][0][][] */ -99,-38,-6,-81,28,28,94,8,-127,-83,-88,-24,8,-1,60,49,33,-57,-5,-127,9,-67,-37,13,24,45,-46,-5,-24,17,73,50, 
  /* [16][0][][] */ 41,44,-123,-16,-91,-104,-88,-35,17,13,59,55,4,-42,45,-32,-10,-87,53,-53,-62,127,28,-36,-56,-117,47,20,56,-36,44,37, 
  /* [17][0][][] */ -58,56,-72,76,47,106,-53,-68,21,-87,-46,-29,-30,-7,-33,-127,-12,-87,-33,-40,36,25,-19,8,-4,75,29,-68,-36,-10,-39,-22, 
  /* [18][0][][] */ 28,-23,18,34,-5,54,-27,14,-38,-49,34,44,36,25,-7,19,68,-37,46,-34,0,19,31,127,18,79,19,35,-63,-29,-80,-10, 
  /* [19][0][][] */ 31,5,-2,3,19,-39,-26,59,-5,-43,-1,34,-36,0,-27,-64,5,-14,3,1,16,25,-50,31,57,14,-9,127,-9,-21,-35,65, 
  /* [20][0][][] */ -30,-90,-19,-61,-33,-20,47,12,-45,-43,48,-97,-24,-49,21,23,55,-58,33,31,11,2,-13,46,-42,31,127,57,54,-64,42,50, 
  /* [21][0][][] */ 31,-69,55,-26,2,25,7,46,-38,-4,90,-87,-14,5,59,-15,-47,-30,-15,-66,16,71,41,70,8,23,-17,-1,27,-127,-22,53, 
  /* [22][0][][] */ 13,-33,-31,86,127,-97,-91,-24,101,1,4,78,22,-52,-18,-13,-20,24,87,-32,-15,70,-8,-11,-2,-32,-68,4,0,-42,-47,25, 
  /* [23][0][][] */ -21,-24,-110,-87,73,44,-76,44,-112,14,-34,-70,3,36,123,57,16,-60,-12,-99,-59,-50,90,34,-127,-112,10,-50,-53,-63,-104,53, 
  /* [24][0][][] */ -11,106,50,22,45,-30,7,-18,-12,-21,26,72,96,-42,-15,31,-127,52,8,39,-35,-67,40,25,13,98,-112,-7,75,73,-38,13, 
  /* [25][0][][] */ 21,55,-10,14,-34,0,-25,49,-114,4,-61,80,-5,-127,14,25,-52,-25,-42,116,36,49,-24,81,89,-17,2,45,10,-23,20,27, 
  /* [26][0][][] */ -59,7,-50,51,19,16,-31,-17,30,-23,-69,64,11,48,7,-15,-3,3,-127,0,-86,-44,-78,0,9,-55,-29,-9,-3,-54,-68,-34, 
  /* [27][0][][] */ -109,22,32,20,-75,-75,42,70,127,-87,-24,-22,20,-19,70,66,-27,10,45,-11,-71,-16,95,89,37,-1,-8,16,46,7,-14,-30, 
  /* [28][0][][] */ 13,3,24,17,32,95,-49,-27,-58,-48,-22,56,8,-11,-4,64,-23,-64,-104,127,17,-96,-45,-52,-76,44,-98,-71,9,-125,-59,-120, 
  /* [29][0][][] */ 34,-8,25,40,-26,-8,53,13,-74,109,33,24,-32,6,-54,-127,26,-10,36,91,-72,22,-1,31,-62,-5,-15,11,-107,114,-4,-21, 
  /* [30][0][][] */ -26,127,50,-62,-46,42,-13,-61,94,-47,-25,27,47,59,113,63,37,50,-3,36,58,-61,57,0,-12,-4,-1,12,17,71,45,1, 
  /* [31][0][][] */ -14,-97,50,-78,25,36,-80,-50,72,-8,-4,64,15,44,44,-14,-61,-48,-97,-127,62,14,-11,-24,17,46,36,-3,-61,3,3,18, 
  /* [32][0][][] */ 70,96,59,-32,38,-24,73,-40,-14,-49,-80,10,-13,25,-127,-84,38,-16,-61,7,-47,-6,78,36,88,-24,0,6,24,22,-4,10, 
  /* [33][0][][] */ 5,61,54,-17,11,86,78,23,-26,-8,-53,-33,-57,40,14,3,-127,22,10,-2,15,-46,-43,100,-23,-7,-82,-84,-76,59,3,-51, 
  /* [34][0][][] */ -7,-70,17,20,32,-12,-19,-29,-47,-4,-30,35,-7,-53,-29,38,-95,-10,7,37,127,38,14,42,31,66,-21,-80,-70,33,-5,-25, 
  /* [35][0][][] */ -75,-51,-7,-46,-42,19,92,-14,-127,-15,-58,-22,-1,-2,54,16,45,-8,-44,-113,-15,-66,-43,25,-22,2,-73,-28,-38,57,73,49, 
  /* [36][0][][] */ -127,-20,33,-78,38,92,0,-8,-30,29,-38,-60,21,57,-71,-38,-5,44,91,-15,-109,25,2,-11,-23,48,8,-111,-51,11,-70,-42, 
  /* [37][0][][] */ 12,-36,-89,10,52,21,24,-36,-55,18,80,11,73,50,30,94,-13,-39,14,-22,-75,110,-40,26,90,-16,2,48,-49,-127,18,-16, 
  /* [38][0][][] */ 65,27,13,-67,92,-39,9,-49,-46,50,52,7,98,78,7,20,2,-10,-44,30,45,-45,22,3,53,58,127,-86,16,-85,24,-9, 
  /* [39][0][][] */ 38,98,-23,-6,13,-127,-9,-88,23,-20,27,4,16,18,12,39,-74,48,56,89,-20,1,127,1,24,6,85,69,14,29,67,-64, 
  /* [40][0][][] */ 46,-5,12,-127,-52,-4,33,-69,-8,48,125,-55,-29,2,-99,-82,57,24,-3,-30,-36,111,71,53,63,-47,-23,37,-107,35,23,-86, 
  /* [41][0][][] */ 5,21,-45,34,28,-68,-83,12,31,120,120,-10,-52,-2,10,98,-31,94,10,127,-29,-21,108,-6,3,13,105,10,-47,23,-57,-113, 
  /* [42][0][][] */ -21,-49,62,10,9,20,42,24,-67,59,-57,-41,43,107,76,1,24,-14,-9,49,-50,1,-31,0,1,16,-4,-57,68,25,127,15, 
  /* [43][0][][] */ 62,-26,7,72,21,-16,15,77,-38,-11,58,-34,60,-3,11,-20,31,127,42,4,12,51,-1,-31,-15,-16,41,-18,51,-20,-38,-15, 
  /* [44][0][][] */ 22,80,48,43,-17,-52,27,108,-26,-23,-32,-15,-24,-21,33,17,-83,-80,22,-91,-55,26,127,91,76,-30,45,11,77,-95,27,-12, 
  /* [45][0][][] */ 21,14,47,-89,-102,66,50,-16,-96,-55,-13,-110,-17,30,-15,-65,18,-1,-46,47,1,-127,-55,-34,29,108,98,43,56,27,21,39, 
  /* [46][0][][] */ 5,94,40,-20,-75,32,-12,-32,-121,39,31,-70,-5,-40,31,9,35,-16,5,47,-46,-15,-127,64,-42,-27,15,74,63,-27,68,32, 
  /* [47][0][][] */ 39,-40,-75,-31,24,127,-10,39,-1,116,30,7,-43,19,38,-28,-62,19,13,16,14,27,14,3,-4,-31,-17,36,-88,-42,26,111, 
  /* [48][0][][] */ 25,-35,-5,33,21,20,-3,20,4,3,26,-95,-64,49,-104,-39,8,22,33,-98,26,-60,37,127,86,-59,-17,-71,37,19,-32,-117, 
  /* [49][0][][] */ 8,19,-34,9,6,32,-24,3,-12,-5,-9,-27,-6,11,19,-22,-12,-2,58,127,14,-60,1,-10,48,-15,11,-36,6,-67,-66,-79, 
  /* [50][0][][] */ -26,58,1,2,0,-111,0,-73,110,36,-77,-31,4,-36,-16,-58,-84,127,58,84,17,-5,13,-42,46,-40,-2,-18,46,-20,42,26, 
  /* [51][0][][] */ -19,14,18,2,22,-4,-12,74,99,77,12,-86,11,-14,-58,-3,32,48,101,-9,14,66,-1,-65,22,7,50,-7,8,83,-127,-22, 
  /* [52][0][][] */ 83,15,4,63,19,-32,-14,-15,-39,19,51,33,-22,6,-67,31,-41,-45,-55,-5,-85,3,105,22,127,-9,-35,-1,-35,-34,-14,-3, 
  /* [53][0][][] */ -35,-8,5,-41,-14,73,113,-17,-7,-34,-51,43,2,76,10,80,24,83,-86,-50,-16,-127,-35,-2,-36,-4,-44,-87,5,51,37,-70, 
  /* [54][0][][] */ -2,23,61,-31,-4,18,23,64,28,-18,-56,22,27,-3,48,-64,-10,-38,-11,-127,-64,76,-29,-10,52,6,39,68,-33,57,20,5, 
  /* [55][0][][] */ 45,11,25,-9,12,77,-104,-73,34,-30,-6,-61,95,23,-13,-27,8,32,1,-34,-10,-4,-2,38,116,39,-127,-13,35,86,-29,-39, 
  /* [56][0][][] */ 31,1,50,-57,-5,69,30,33,10,39,-10,-69,87,-97,-29,22,7,-21,127,-49,69,-66,-51,-50,-5,16,-11,11,75,38,-66,22, 
  /* [57][0][][] */ 22,-38,9,-35,-58,-26,12,-43,-41,-61,69,-27,-33,22,-10,48,48,14,21,-18,5,127,-67,-49,36,-5,-36,-8,36,74,44,32, 
  /* [58][0][][] */ 91,-98,-13,29,31,12,-127,86,88,-26,107,-46,-36,-110,-29,-13,42,-17,93,1,-12,-16,-19,95,23,38,39,-24,-43,123,-13,39, 
  /* [59][0][][] */ 17,-12,-75,44,-22,-12,65,62,-25,-16,59,-14,34,-24,-112,85,-62,23,14,127,103,-4,-3,-54,-8,-71,18,87,27,18,-53,109, 
  /* [60][0][][] */ -21,39,-61,-17,-55,-81,127,21,6,-41,-13,62,53,-2,-29,15,50,-12,38,-28,-104,-16,76,-19,-76,-43,-87,76,44,23,-47,21, 
  /* [61][0][][] */ -50,-32,-19,-62,37,-107,-68,-27,127,-9,63,90,-16,-42,-58,4,-85,-38,53,0,63,-99,63,-58,33,113,-55,-40,-48,46,-29,6, 
  /* [62][0][][] */ -52,-10,7,108,64,-39,53,70,43,-73,20,100,-75,-24,83,-49,77,-8,127,-15,-53,68,96,-5,-31,25,34,51,-2,23,21,38, 
  /* [63][0][][] */ -90,-50,13,35,32,61,13,-8,37,25,-53,18,48,-43,25,-59,-22,-127,78,-79,-23,77,66,-35,-12,60,50,-84,-79,-44,7,18, 
  /* [64][0][][] */ 61,53,-15,-14,76,21,59,-53,30,-36,-11,-13,47,-14,14,-54,-58,-27,-54,65,127,64,7,68,-8,-54,-12,32,-14,-123,-90,9, 
  /* [65][0][][] */ 95,32,-13,-95,4,15,4,44,-63,-15,3,-32,-35,80,78,2,-24,-59,35,-127,-26,-5,85,56,5,8,39,-80,15,-81,16,90, 
  /* [66][0][][] */ -60,59,12,-7,-127,-41,78,-15,-33,-2,-81,-85,-18,33,-43,-85,-22,49,0,49,59,-92,-66,-7,-27,-63,38,1,92,49,83,-1, 
  /* [67][0][][] */ 2,-16,-88,-60,127,66,15,35,-24,-22,-9,8,32,-27,22,-8,-27,-52,-123,-15,-81,29,46,72,69,92,-8,-15,-72,41,-102,60, 
  /* [68][0][][] */ 48,15,-70,-62,1,-58,97,68,-39,-16,-27,-36,-28,127,-80,44,-50,-6,3,30,-84,-5,-51,12,-61,47,-35,98,-31,30,-89,44, 
  /* [69][0][][] */ -48,19,12,-26,-127,34,-17,-13,-30,-42,21,-22,43,68,2,-58,22,44,-68,37,29,-83,-52,-51,6,110,15,16,8,46,-19,-6, 
  /* [70][0][][] */ -69,26,-62,-11,55,79,6,63,-14,50,-34,-20,-37,6,44,-17,71,-23,-5,-46,86,-28,-99,-38,9,-38,-127,-20,-3,82,65,37, 
  /* [71][0][][] */ 26,-66,68,-20,6,-8,50,-31,-25,-52,44,-59,-78,17,76,53,-73,-127,95,-23,49,-10,121,2,65,76,-88,-69,-31,92,97,48, 
  /* [72][0][][] */ -59,-54,36,-88,-42,94,-63,15,16,-46,-7,28,-7,-8,26,10,-29,46,2,-17,-15,79,7,71,-73,127,-8,63,-71,-106,-39,-29, 
  /* [73][0][][] */ 97,20,124,74,62,-2,-19,49,57,51,64,37,-48,-99,-63,-32,-63,-50,11,127,66,65,46,17,28,-10,30,-45,53,37,-51,26, 
  /* [74][0][][] */ -39,-47,4,-32,-19,-37,19,18,100,3,59,-16,5,-92,-14,61,27,-54,-25,-68,92,30,127,-16,65,28,-18,11,86,-41,-17,-30, 
  /* [75][0][][] */ -73,-19,116,48,-35,120,-75,-14,-79,18,-18,109,-34,-33,65,116,85,94,-10,28,16,-127,94,20,-88,123,-78,-20,28,28,-100,2, 
  /* [76][0][][] */ -38,-99,-27,-16,-100,-20,-121,20,86,-117,13,-16,-57,56,-1,-9,-17,28,-116,-7,6,96,127,12,9,-2,-38,61,43,-18,1,71, 
  /* [77][0][][] */ 42,32,-37,27,19,-11,77,25,42,-22,35,62,21,-88,63,-52,-28,59,-60,-127,-25,-35,-30,-30,-26,-32,84,-85,29,16,-43,-63, 
  /* [78][0][][] */ 27,90,-78,-13,16,-96,3,-21,-31,-10,33,9,30,46,-15,61,-2,27,31,95,-71,48,127,35,-7,-15,77,40,-27,-14,-5,-89, 
  /* [79][0][][] */ -63,59,-19,15,-44,57,16,-14,18,8,38,-60,-50,-12,73,-75,-36,5,29,-42,15,6,-57,79,27,11,116,1,38,77,-127,-34, 
  /* [80][0][][] */ 11,-31,32,-17,1,-3,93,-30,78,-8,26,-94,-40,63,-72,7,33,74,-56,0,-17,-117,-9,-20,-68,58,-35,44,-99,3,65,127, 
  /* [81][0][][] */ 101,-6,-127,-68,4,-20,-43,35,-3,26,68,-65,-6,-20,-48,102,-20,97,-29,-32,-79,-60,56,60,86,-126,-44,90,-4,-36,66,-8, 
  /* [82][0][][] */ 31,5,37,-103,-58,58,33,-56,45,-54,52,-4,62,61,-9,-41,-11,65,-127,-125,-29,15,-64,-22,-8,34,114,-81,-24,-7,-17,-17, 
  /* [83][0][][] */ -20,-127,35,22,80,-27,18,59,-5,-17,-13,-10,-18,-26,-25,-6,-61,36,-3,23,-49,68,4,100,-18,-16,13,-117,-25,-8,5,39, 
  /* [84][0][][] */ 26,-18,-92,14,21,20,40,-17,-8,-11,-13,-40,55,-31,-11,73,-23,-10,10,-12,10,31,-25,17,-51,-14,-19,-6,48,127,-46,-39, 
  /* [85][0][][] */ 42,-97,71,-5,12,-16,67,127,-51,58,0,-28,-71,-18,11,-69,-19,-62,3,-99,-9,110,40,-2,-33,-89,-21,41,82,-15,86,33, 
  /* [86][0][][] */ -37,55,88,-96,15,52,54,-79,100,-109,32,-85,78,87,29,-3,-27,-101,-91,-94,51,-12,-97,-31,-22,65,127,31,26,87,-27,-7, 
  /* [87][0][][] */ -31,54,26,-3,-26,-29,52,-127,-70,29,63,55,46,12,48,9,1,-21,59,60,-8,-71,15,-42,32,-26,-28,5,-126,74,-28,-72, 
  /* [88][0][][] */ -57,-28,-127,23,-108,26,-16,-96,-78,77,29,-15,123,-55,-46,20,-12,5,5,120,31,-120,19,-71,0,68,66,-25,1,45,13,-81, 
  /* [89][0][][] */ 14,10,7,-71,50,-39,-51,10,17,127,-26,-48,-110,-25,22,-48,15,-57,61,-15,56,8,-30,45,7,-58,-5,-31,-24,21,34,17, 
  /* [90][0][][] */ 32,-38,-4,110,-51,-4,14,49,-35,127,-42,26,-7,-7,27,2,-7,32,60,101,-40,-71,-81,-17,45,-43,-33,-65,-42,-60,1,-73, 
  /* [91][0][][] */ -18,-20,-67,36,37,29,-60,-44,24,77,90,-7,-4,2,51,127,43,-28,11,-41,16,50,48,-10,83,61,-26,49,-99,-84,15,65, 
  /* [92][0][][] */ -76,1,2,-93,15,95,11,45,-57,-74,30,-107,-14,13,53,18,-9,7,-105,-127,-15,29,59,37,-49,47,62,-66,-24,9,79,39, 
  /* [93][0][][] */ 15,13,72,74,-61,-107,-38,76,-8,-6,13,-7,-16,3,-21,-127,90,-44,91,11,-50,80,-93,-45,-52,37,30,-40,-52,14,-54,82, 
  /* [94][0][][] */ 71,-17,-79,33,-4,8,-37,-33,9,36,127,58,1,-85,93,23,-77,-11,15,2,29,73,-4,-60,-55,64,-26,-72,-3,-105,10,41, 
  /* [95][0][][] */ -127,22,-79,-2,106,-53,-14,91,-21,-64,-19,101,-24,-13,-24,-12,-38,-5,-35,-55,28,90,59,-21,95,-1,-15,6,-46,43,-75,-46, 
  /* [96][0][][] */ -3,-64,127,1,28,33,-48,29,54,-28,14,-24,-63,12,38,-39,-24,-64,21,-3,27,14,16,-41,8,-26,-16,-13,-49,58,-17,12, 
  /* [97][0][][] */ -38,-68,50,-66,-39,58,-26,-5,93,-57,30,127,-49,-25,8,16,-61,-18,-59,-63,-20,27,118,-11,2,34,10,-13,-23,41,-16,-55, 
  /* [98][0][][] */ 21,48,-127,-23,23,83,9,23,-84,-14,-69,74,13,32,74,70,-75,26,87,102,39,-55,-13,-1,1,-25,56,-3,50,15,4,29, 
  /* [99][0][][] */ -12,-13,57,-27,-127,-111,17,-26,42,4,25,-24,-22,34,-56,27,16,21,24,-19,-76,19,-44,-13,-56,-5,22,3,-48,-16,83,-69, 
  /* [100][0][][] */ 23,-24,31,-6,-2,22,87,100,-52,68,94,-9,-14,-127,64,0,5,52,-1,40,71,20,53,78,45,-65,0,-43,39,-10,76,-118, 
  /* [101][0][][] */ 7,38,-4,17,-79,-33,-101,-38,-34,63,-49,96,-58,-36,-17,58,-45,-127,1,23,49,-25,115,0,-38,-11,-67,49,22,24,32,-106, 
  /* [102][0][][] */ 29,20,-78,5,-48,42,-66,14,-34,92,-68,67,-40,-71,23,-5,-44,-73,87,10,37,-38,-5,12,-19,61,29,-16,-36,16,-35,-127, 
  /* [103][0][][] */ -33,46,-20,-18,36,12,-3,18,-29,-32,-65,26,22,-35,7,33,7,-106,-21,-17,-86,49,8,-16,35,-27,67,50,-92,12,100,-127, 
  /* [104][0][][] */ -72,-5,-43,14,37,-22,-26,-5,-43,18,-38,-26,-51,0,-53,-77,-81,-42,21,-99,-127,96,39,-21,-61,-42,63,-5,-62,113,-70,-46, 
  /* [105][0][][] */ 43,1,1,121,16,-3,63,17,3,6,44,12,-77,-53,74,10,61,-14,12,127,-14,-57,13,-46,37,-97,-28,23,22,-39,-57,55, 
  /* [106][0][][] */ 52,51,-45,-57,-53,127,-23,-21,-66,32,40,28,41,39,72,6,14,-8,-5,19,-50,31,-45,-78,25,40,52,102,54,-38,27,-88, 
  /* [107][0][][] */ -26,55,-61,127,15,-13,25,-50,-54,-1,-92,77,31,-67,-61,-59,60,-7,-9,44,-5,43,-86,-19,64,-40,-17,-34,-69,-74,21,-55, 
  /* [108][0][][] */ -37,-27,-54,-60,-117,-4,43,-61,-127,19,-99,-71,40,88,42,33,29,-19,-77,-93,-37,-68,6,-21,-74,-1,-26,-26,-51,104,70,-21, 
  /* [109][0][][] */ -46,127,18,-34,29,51,90,24,-59,-55,3,-84,-32,3,-25,114,80,16,34,28,-43,-13,66,-41,-41,14,-21,-52,-2,-16,72,-40, 
  /* [110][0][][] */ 9,-94,43,-49,56,91,-46,127,-8,-9,-7,93,-10,66,35,3,-7,47,-7,20,-109,8,47,-8,51,76,25,-5,35,-71,36,-45, 
  /* [111][0][][] */ -92,6,-32,28,-101,76,-90,-1,-82,-32,21,28,26,32,127,-101,-46,26,44,97,-65,28,61,-47,-19,73,1,62,-91,-44,-26,-97, 
  /* [112][0][][] */ 121,2,35,7,38,-17,2,-24,-59,12,-11,78,94,88,125,68,-76,48,-30,48,-94,-94,-96,81,-32,-7,48,-6,64,-80,-34,-127, 
  /* [113][0][][] */ -33,-111,30,59,52,51,-76,107,-45,51,-30,-26,-67,-48,74,-2,24,73,56,71,-121,1,113,23,74,-127,-53,-77,-90,-4,52,52, 
  /* [114][0][][] */ -26,-32,63,-9,4,3,-15,-57,-16,-127,-83,50,68,69,-87,-39,14,-40,-100,19,-6,-45,28,-2,-43,96,-14,-43,-84,-35,-3,27, 
  /* [115][0][][] */ -44,-72,-127,65,-52,-57,-34,66,-40,60,10,19,16,-2,-68,-63,31,102,-28,41,-6,-2,-23,29,-90,-100,19,-17,-32,-63,-24,-18, 
  /* [116][0][][] */ 63,10,25,36,-35,-28,11,9,15,4,37,6,-10,-7,5,-50,5,45,-18,-6,31,-29,-35,45,-59,-25,54,-2,46,-19,-127,-70, 
  /* [117][0][][] */ 32,-41,-48,39,57,-38,85,-19,-22,-55,24,-5,-5,4,-11,75,-67,-44,-33,-40,60,-19,127,46,40,110,-48,-6,-79,24,47,-18, 
  /* [118][0][][] */ 26,39,18,-83,-79,14,82,-63,-20,-74,-10,-35,-7,34,4,-45,-13,-71,9,-38,74,-107,-119,-26,8,127,15,27,58,64,23,4, 
  /* [119][0][][] */ -20,79,44,-21,-82,-62,21,-89,16,2,-26,-46,-39,30,-22,77,-17,-63,34,101,27,-22,127,11,16,45,-30,21,-13,64,38,-15, 
  /* [120][0][][] */ -19,-55,-24,-33,27,38,-61,16,91,62,57,65,-36,69,-48,36,24,45,65,18,-19,-94,-29,-4,-53,-87,-88,45,-42,-91,127,17, 
  /* [121][0][][] */ -36,36,-56,-11,-20,9,21,67,-75,-18,-13,43,80,6,77,44,-29,127,-1,67,-38,-23,71,38,57,-34,44,-73,12,-55,31,-11, 
  /* [122][0][][] */ 33,-48,13,-20,4,6,17,-12,-19,-9,47,13,-1,-12,34,-36,64,-25,-49,-37,-29,-6,20,28,0,3,19,70,-13,-127,-25,46, 
  /* [123][0][][] */ 55,-64,-120,-1,-13,-12,-123,-68,-13,-6,11,-16,-34,-2,19,52,41,34,23,-112,-104,-62,65,127,-37,10,35,113,89,-111,-38,-61, 
  /* [124][0][][] */ 52,31,-26,43,-48,-20,-46,-43,-85,39,-11,-93,61,54,20,58,-4,-58,-6,-122,-127,86,47,-50,39,38,-20,11,20,64,1,15, 
  /* [125][0][][] */ -28,-32,49,22,-31,6,62,23,45,81,2,-127,24,80,-66,24,-48,-34,24,-44,16,42,-126,65,-8,8,36,13,-40,-77,56,-18, 
  /* [126][0][][] */ 119,41,-127,-20,95,-72,-10,-61,-32,-35,17,117,49,123,48,52,56,26,-14,15,92,37,114,-47,-10,-72,25,-22,-12,13,-10,100, 
  /* [127][0][][] */ -32,-5,18,20,46,36,5,-17,-10,-23,-51,25,-9,6,-16,86,-10,12,27,127,77,-73,-4,-42,35,96,1,-51,-20,7,-49,-38, 
  /* [128][0][][] */ -24,-49,35,-104,-70,52,-18,-6,66,-86,-75,32,14,1,-63,-13,75,-65,-38,-2,12,22,109,13,9,-1,8,-17,-127,-19,-87,60, 
  /* [129][0][][] */ 127,-85,-17,4,-11,17,44,-18,-21,-22,-34,22,-15,12,69,-16,-27,24,-12,-25,-18,35,9,-23,-10,3,11,-7,8,12,10,1, 
  /* [130][0][][] */ -63,45,-89,-23,-52,0,52,-34,-36,-21,63,18,127,55,8,19,2,11,-74,-67,-7,32,-104,-24,-12,29,50,17,10,-67,39,-96, 
  /* [131][0][][] */ -3,-13,30,-9,63,47,-65,-31,29,103,26,-75,-52,52,-7,-78,46,20,1,-22,32,37,5,8,-127,42,69,-28,50,-7,-75,-3, 
  /* [132][0][][] */ 22,-29,5,-65,-83,-23,-89,-87,61,80,-52,-5,-60,-2,-2,99,-46,-126,42,127,45,-98,123,-3,-41,2,3,-32,67,-70,-89,-98, 
  /* [133][0][][] */ 31,-15,-29,34,72,-63,86,127,-42,55,64,9,-9,51,56,79,68,62,57,-1,-36,-18,47,-20,-3,110,31,28,58,-95,97,-39, 
  /* [134][0][][] */ -62,-11,-127,-51,49,70,41,-64,-7,-72,-47,64,11,78,56,16,-57,-38,78,-55,-69,29,40,21,65,-11,82,34,-21,26,-4,2, 
  /* [135][0][][] */ -65,80,-31,55,-10,107,-62,127,46,-8,11,26,-14,100,20,24,-89,72,-31,82,2,-16,57,107,31,111,-87,10,-6,17,-63,27, 
  /* [136][0][][] */ -13,-49,44,-12,-68,-97,-31,-103,-49,-21,-42,-89,66,27,24,20,14,-119,-33,-41,95,24,64,-85,-16,67,-127,-27,17,43,-37,-8, 
  /* [137][0][][] */ 47,76,-127,11,27,-80,-58,-44,-71,-71,63,-23,-19,-59,-30,-25,-19,-14,26,-5,116,108,34,-13,16,-42,-73,30,37,-1,-23,38, 
  /* [138][0][][] */ 57,-126,57,75,-95,19,106,81,24,124,-58,-40,-16,-34,-87,-127,123,31,22,-111,12,66,-77,-21,-3,-99,12,-40,-95,11,9,32, 
  /* [139][0][][] */ -5,88,-11,92,-35,43,-4,120,-69,31,17,52,4,5,95,30,-42,18,98,19,-38,33,71,-101,-9,5,41,-9,-127,-5,-16,78, 
  /* [140][0][][] */ -10,-14,17,-63,-24,2,107,-24,23,-65,25,-39,-18,14,3,6,-39,-34,-52,-127,41,-92,-12,-6,-47,29,33,-78,-1,18,9,-52, 
  /* [141][0][][] */ 13,48,-13,-59,6,-41,30,-75,127,27,-28,12,-2,-78,-17,-26,-121,66,87,48,9,25,-28,-88,102,-8,32,46,43,-65,109,5, 
  /* [142][0][][] */ -53,127,-10,-98,4,2,-9,-42,16,-38,10,-28,-92,9,60,122,-62,-79,6,-30,-11,-32,88,-29,17,-63,-47,6,33,38,14,-92, 
  /* [143][0][][] */ -3,-5,-43,-103,-8,20,30,-43,65,45,127,-9,13,-19,-53,51,-28,-12,-35,36,81,33,65,-69,49,77,-18,-24,-5,26,3,-46, 
  /* [144][0][][] */ -80,1,1,3,-35,-62,-32,-66,-119,-79,-17,41,-29,-9,-35,76,-80,-20,91,127,-58,-86,18,43,33,-50,-5,-39,-104,-39,-52,14, 
  /* [145][0][][] */ -41,-8,89,-11,-15,-88,8,-41,3,127,-45,-86,-53,42,-28,86,-7,-3,110,27,37,-55,66,-4,14,-4,-59,-6,81,38,71,37, 
  /* [146][0][][] */ 69,-18,127,67,35,-60,-32,62,33,12,-31,-24,73,-82,-74,74,7,-14,51,122,30,-17,-5,-35,6,-43,-113,27,7,-34,18,-67, 
  /* [147][0][][] */ 31,24,0,-50,39,-1,90,8,60,-116,10,-2,4,36,-50,-56,46,54,-55,-127,-30,-4,-33,-14,-35,-3,73,-22,-56,71,-10,29, 
  /* [148][0][][] */ 64,94,-63,63,-108,-33,-20,-5,-84,26,111,-34,-45,63,15,-48,91,8,-13,127,-41,-73,-1,-24,-20,-13,101,8,-12,11,42,-72, 
  /* [149][0][][] */ 35,7,-10,-31,127,19,21,50,-76,22,-22,18,8,-86,125,-80,-33,-36,1,71,78,31,11,-71,-97,64,59,-90,119,-24,11,1, 
  /* [150][0][][] */ 14,48,-31,39,-9,-127,47,-13,-13,-59,92,50,9,21,-56,13,6,-5,40,64,-87,77,52,-11,-57,-50,68,-18,28,-1,-30,-127, 
  /* [151][0][][] */ 70,-52,67,-127,-6,120,-2,-59,-14,96,19,-16,43,4,28,29,-110,-15,48,37,-127,15,61,-101,21,45,53,-40,-52,-24,74,-120, 
  /* [152][0][][] */ 72,9,-39,-16,27,-53,39,-73,5,27,41,127,40,-15,-35,-35,-49,1,21,17,-29,23,-23,12,-32,79,-43,-53,-7,13,-45,19, 
  /* [153][0][][] */ -37,52,85,18,45,14,-41,-49,-44,12,-127,19,-21,18,65,-11,48,-28,-59,-119,-74,-4,-2,-41,-42,-38,96,19,44,-3,-109,-107, 
  /* [154][0][][] */ -2,-111,2,49,-30,127,-31,42,-32,-34,74,-41,-14,44,-7,55,31,-44,-1,-36,-120,124,-37,45,-7,-108,-24,-47,-17,-33,-72,50, 
  /* [155][0][][] */ 6,80,-48,0,7,-12,34,-32,11,17,25,74,-44,35,-26,26,67,-71,14,-54,-24,89,54,19,-51,-127,43,20,8,-1,-47,-7, 
  /* [156][0][][] */ 7,33,-9,22,-14,15,-106,26,-69,10,82,83,-6,29,102,-3,-70,42,42,-35,42,-83,26,-14,-86,14,12,53,121,127,71,93, 
  /* [157][0][][] */ 87,27,106,-36,-30,40,50,54,-91,-5,38,-10,-63,-25,13,-5,50,66,48,-40,59,78,-25,75,6,-96,60,127,-53,25,-29,71, 
  /* [158][0][][] */ -73,28,14,45,-11,-29,-121,42,97,1,49,-35,23,-74,-119,-13,-9,101,55,127,-36,64,-24,-29,-68,16,-27,-98,104,37,-33,13, 
  /* [159][0][][] */ -14,-103,44,-19,-13,-55,127,26,60,-36,-6,-8,-37,-11,5,59,3,-121,-3,-25,-33,-62,20,27,58,72,-39,-38,-5,58,10,-33, 
  /* [160][0][][] */ -23,23,-127,-46,25,14,-5,52,-19,-38,-11,-5,-12,-46,36,66,-89,-32,36,-41,-11,86,40,42,-19,-15,71,3,7,-63,21,61, 
  /* [161][0][][] */ -48,-9,-7,63,63,-69,23,7,14,54,32,-127,-22,36,-95,4,15,-10,-51,-82,-36,115,-71,75,27,-69,-28,21,-16,-24,-32,2, 
  /* [162][0][][] */ 53,28,-42,57,-10,-2,-36,35,-127,-78,-76,93,23,-84,-43,-14,17,-7,-16,-36,22,45,-35,-11,-3,-26,-89,0,12,-34,64,-20, 
  /* [163][0][][] */ -22,98,24,84,39,59,-9,38,99,81,-21,9,33,-58,-65,-110,120,-4,0,-25,43,-63,-127,20,46,-53,-126,-55,-47,-22,33,-1, 
  /* [164][0][][] */ -16,-42,-1,-17,-84,-69,-2,-34,41,52,-52,-98,10,30,-73,19,104,-127,83,-40,58,45,-68,-101,-51,-69,-46,111,78,-5,45,-75, 
  /* [165][0][][] */ 71,49,-46,40,85,-85,-21,-59,-101,105,127,-4,-66,9,123,32,65,-35,-84,-38,-43,-23,53,2,31,32,-2,9,-23,-115,38,5, 
  /* [166][0][][] */ -77,7,-46,27,-54,-39,-94,-95,31,18,51,46,7,66,16,54,13,-14,-13,-13,-22,75,-27,17,-72,-127,-8,-25,30,-67,-80,-75, 
  /* [167][0][][] */ 97,26,16,22,27,-5,-114,123,34,-21,108,81,-32,-72,-2,-100,-114,110,-34,1,-41,51,-15,5,-40,-27,32,-40,34,127,102,94, 
  /* [168][0][][] */ 57,25,66,-18,-12,-67,84,7,-87,-59,35,-68,6,127,21,17,0,10,-57,88,59,-54,-55,-46,-3,-31,38,15,-61,-88,1,47, 
  /* [169][0][][] */ -75,12,67,-4,18,-78,33,44,7,-34,68,-77,88,-66,-120,127,39,-99,19,-42,64,-5,28,55,46,34,-31,-38,-53,33,49,35, 
  /* [170][0][][] */ -53,47,-102,91,-2,63,-127,-58,-7,90,-2,-63,-44,33,-7,-113,86,-63,44,106,21,45,-78,21,-18,-32,-28,62,-58,-40,-112,22, 
  /* [171][0][][] */ 42,22,84,-120,71,77,-6,-124,-80,61,103,70,51,-6,74,100,43,-49,-51,-38,9,78,-10,-58,-31,4,65,25,-36,-127,72,68, 
  /* [172][0][][] */ 91,18,-82,-103,36,75,12,94,-17,36,71,-35,88,62,100,56,-52,8,109,74,-127,110,44,81,-32,79,49,-77,-85,114,-61,-24, 
  /* [173][0][][] */ 22,3,-31,-72,-10,40,119,-83,121,-55,-41,-84,-55,5,-105,50,32,-54,-27,-102,2,0,-61,-60,61,127,19,2,-69,42,19,34, 
  /* [174][0][][] */ -76,26,107,3,87,88,-116,56,-42,-36,127,36,-21,-40,-122,18,14,-48,110,83,5,-119,32,-32,-43,9,-26,98,-11,-37,122,48, 
  /* [175][0][][] */ 59,-2,-69,-85,-43,-16,45,-8,-13,-127,72,-13,56,74,-77,-14,-42,0,-95,-78,15,17,-64,-70,-27,31,-54,-43,50,-26,-7,-68, 
  /* [176][0][][] */ -8,-39,31,-42,60,17,-54,127,13,-107,110,40,36,-85,66,32,7,-26,-16,-34,9,23,77,-21,109,-38,70,77,26,6,-14,32, 
  /* [177][0][][] */ 44,9,-127,-28,-20,-29,16,25,62,-11,80,32,-71,-16,-102,-64,16,26,55,-23,60,-21,17,14,-35,4,-87,5,-120,23,-16,8, 
  /* [178][0][][] */ -89,-26,-25,47,9,-50,-127,79,17,-111,-43,16,-57,18,13,-118,-50,-47,28,49,108,-8,-54,21,-34,65,25,-1,-18,51,-87,19, 
  /* [179][0][][] */ 23,-2,-118,36,-23,19,-51,28,8,69,13,-9,-81,-43,97,-86,-34,-27,34,-80,59,55,67,7,-50,-71,21,51,105,127,22,80, 
  /* [180][0][][] */ 24,13,29,40,90,-117,17,56,-27,-7,7,-32,-59,43,-23,44,-24,-68,9,-33,6,-86,-23,50,-20,-47,-85,4,127,33,-70,33, 
  /* [181][0][][] */ 71,-18,-11,-87,-123,48,16,5,-58,-17,-33,-37,-67,96,-127,-89,-42,103,56,-100,37,2,-9,10,1,-49,63,-36,-85,67,-52,65, 
  /* [182][0][][] */ -33,63,74,-9,106,4,25,127,23,2,-30,68,-75,-39,52,3,-6,-31,-81,19,100,-13,-5,54,-16,-12,-28,6,2,-13,-45,58, 
  /* [183][0][][] */ -49,-7,17,-32,-52,38,-8,-16,84,-127,93,52,-46,55,-54,33,7,-18,0,-23,-40,56,10,64,-5,30,-19,37,-37,-5,3,42, 
  /* [184][0][][] */ 35,54,11,-4,44,-16,-37,98,-79,-121,96,21,60,26,13,40,11,47,-76,-127,-30,122,22,-30,41,-37,46,-17,-36,-2,24,-39, 
  /* [185][0][][] */ -17,-91,16,-46,7,-78,1,28,-53,-20,-27,-67,17,127,15,-46,-29,4,69,-70,-53,7,15,8,-4,17,34,-84,-44,-29,-16,10, 
  /* [186][0][][] */ 48,8,27,127,113,-95,-9,-82,22,-80,-27,-18,-67,-80,-6,-23,11,-45,-22,-50,-2,-54,-2,25,46,-31,-22,-31,50,-109,-68,18, 
  /* [187][0][][] */ -56,-2,35,41,36,25,-28,70,-47,50,17,-127,14,27,22,-3,0,-16,-19,18,-83,-1,28,19,70,-20,-35,-15,36,32,43,1, 
  /* [188][0][][] */ 36,53,-55,127,74,-54,-2,-9,-13,-64,73,-4,23,81,-100,17,2,-41,28,-45,95,42,57,-19,-99,30,-6,-6,-17,-18,4,-39, 
  /* [189][0][][] */ 62,-21,-36,127,-50,-30,69,20,84,54,32,-55,-34,24,-78,29,-40,17,-45,70,47,-12,-79,-7,-75,-47,3,-14,32,-1,-81,10, 
  /* [190][0][][] */ 26,-7,5,-27,-94,-7,108,-86,-47,-43,11,-18,65,82,69,44,-14,-9,-79,-107,-28,-127,-76,74,-51,13,2,1,-76,-80,-56,-75, 
  /* [191][0][][] */ -38,-15,7,55,127,-38,-14,-12,66,-9,3,9,-54,-58,0,24,-8,18,54,-22,-35,58,32,-44,48,0,-35,-18,14,23,-13,33, 
};
const TfArray<4, int> tensor_dimension67 = { 4, { 192,1,1,32 } };
const TfArray<192, float> quant67_scale = { 192, { 0.0014268974773585796, 0.0013619852252304554, 0.0012432975927367806, 0.0019230403704568744, 0.0016219894168898463, 0.0017458453075960279, 0.0014121081912890077, 0.0026753076817840338, 0.0016644463175907731, 0.0014933077618479729, 0.0022446971852332354, 0.0018103745533153415, 0.0014013337204232812, 0.0017717592418193817, 0.0015633988659828901, 0.0018258291529491544, 0.0014953158097341657, 0.0019581567030400038, 0.0022178231738507748, 0.0029061886016279459, 0.0020531832706183195, 0.0023681095335632563, 0.001758843194693327, 0.0014748615212738514, 0.001651193480938673, 0.0022638933733105659, 0.0021115897689014673, 0.0016370201483368874, 0.0018122538458555937, 0.0016415987629443407, 0.0016074022278189659, 0.0017854514298960567, 0.002412125701084733, 0.0016742380103096366, 0.0020755103323608637, 0.0018658468034118414, 0.001608612947165966, 0.0020714558195322752, 0.0020325076766312122, 0.0018379846587777138, 0.0015085907652974129, 0.0016711688367649913, 0.0020735629368573427, 0.001877815811894834, 0.0020209741778671741, 0.0020546652376651764, 0.0019143882673233747, 0.0023422890808433294, 0.0014316599117591977, 0.0022955464664846659, 0.0014158512931317091, 0.002355366013944149, 0.0026262307073920965, 0.0016834972193464637, 0.002224721247330308, 0.001504037412814796, 0.0026263161562383175, 0.0021234338637441397, 0.0015247467672452331, 0.0015103560872375965, 0.0018118917942047119, 0.0013043086510151625, 0.0015847507165744901, 0.0015593133866786957, 0.0024865712039172649, 0.0019475668668746948, 0.0015887569170445204, 0.001784654101356864, 0.0020702143665403128, 0.0025437576696276665, 0.0021726645063608885, 0.0013947843108326197, 0.0017621166771277785, 0.0015855538658797741, 0.0015458412235602736, 0.0015247114934027195, 0.0015282513340935111, 0.0018266891129314899, 0.0020344702061265707, 0.0020804447121918201, 0.0017607384361326694, 0.0014486949658021331, 0.0016239343676716089, 0.0021864930167794228, 0.002681247889995575, 0.0015759918605908751, 0.0015531559474766254, 0.0019088381668552756, 0.0016352770617231727, 0.0021389443427324295, 0.0016167532885447145, 0.0019222687697038054, 0.0016786868218332529, 0.0014815320027992129, 0.0021191872656345367, 0.0015213752631098032, 0.0027240796480327845, 0.0015858523547649384, 0.0015745097771286964, 0.0016999463550746441, 0.0016895328881219029, 0.0016084980452433228, 0.0020681130699813366, 0.0021828054450452328, 0.0017546282615512609, 0.0015714121982455254, 0.0019374788971617818, 0.0017714152345433831, 0.0014064511051401496, 0.0023424474056810141, 0.0021305338013917208, 0.0015922087477520108, 0.0015709686558693647, 0.0017733671702444553, 0.0017378486227244139, 0.00155424396507442, 0.0023908647708594799, 0.0019854828715324402, 0.0022156534250825644, 0.0016093261074274778, 0.0019873818382620811, 0.0020125012379139662, 0.0027095554396510124, 0.0015631106216460466, 0.0018235871102660894, 0.0014523871941491961, 0.0014596901601180434, 0.0020120225381106138, 0.0019013838609680533, 0.0026989493053406477, 0.0019279937259852886, 0.0021879039704799652, 0.0014352009166032076, 0.0020526708103716373, 0.0014531102497130632, 0.0015722962561994791, 0.0016271814238280058, 0.0017388669075444341, 0.0010351676028221846, 0.0013955484610050917, 0.0020039246883243322, 0.001447368529625237, 0.0012489805230870843, 0.0018894727109000087, 0.0016838718438521028, 0.0015839554835110903, 0.0016966591356322169, 0.0020108283497393131, 0.0015575466677546501, 0.0014813350280746818, 0.0022722247522324324, 0.0018057759152725339, 0.002931445837020874, 0.0017948409076780081, 0.0017862139502540231, 0.0023002929519861937, 0.0017543985741212964, 0.0018024654127657413, 0.0015658623306080699, 0.0017963240388780832, 0.0017509807366877794, 0.0018096904968842864, 0.0030082094017416239, 0.0014707949012517929, 0.0015797213418409228, 0.0016750510549172759, 0.0022157873027026653, 0.0014544896548613906, 0.0016055392334237695, 0.0016308132326230407, 0.0016537911724299192, 0.0016929435078054667, 0.0014271576656028628, 0.0016314672539010644, 0.0015621177153661847, 0.0019848146475851536, 0.0012578625464811921, 0.0023501606192439795, 0.001928871963173151, 0.0015358919044956565, 0.0022452468983829021, 0.0014036480570212007, 0.0020446646958589554, 0.0017824540846049786, 0.0017634823452681303, 0.0020207720808684826, 0.0023740627802908421, 0.0025848981458693743, 0.0026396550238132477, 0.0019297898979857564, 0.0013533612946048379, 0.0020726344082504511, } };
const TfArray<192, int> quant67_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant67 = { (TfLiteFloatArray*)&quant67_scale, (TfLiteIntArray*)&quant67_zero, 0 };
const ALIGN(8) int8_t tensor_data68[32*1*1*192] = { 
  /* [0][0][][] */ -4,20,53,49,24,-55,-66,13,-6,0,-26,93,-99,29,55,55,-24,43,-6,-92,14,18,-34,-35,0,-11,-64,30,16,20,18,4,-1,30,75,73,-9,74,31,1,2,-8,21,18,4,-66,27,39,77,1,16,-9,55,12,-11,18,-28,6,52,-34,8,39,-46,27,6,69,70,-28,40,5,2,-66,-74,91,-19,47,-25,45,19,55,54,-3,30,-10,9,-84,-14,55,-36,-49,-59,31,16,-2,32,45,19,-44,-3,13,-14,-19,5,41,-22,-17,12,52,39,-42,-13,11,-23,-21,7,54,28,-1,-79,48,-14,-7,67,6,-2,-37,-3,61,-31,26,-49,-112,15,28,-1,9,-40,-27,-34,37,-46,-23,-16,-37,-17,-59,6,-34,18,-19,16,-54,40,34,6,-51,-28,76,-7,-32,-14,-17,43,-13,1,37,48,-21,6,27,-55,16,45,21,-127,3,-26,-43,-39,-14,31,-22,47,1,-58,23,-4,25,-43,15,13,-29, 
  /* [1][0][][] */ 53,-58,-34,-83,-52,-18,4,-2,33,-46,-32,6,19,-9,-9,-23,-12,-80,-11,84,11,56,12,-17,-8,78,3,-25,56,10,27,70,37,-15,-9,-37,-37,-38,-33,32,9,-84,1,33,17,-14,33,61,42,-45,-37,39,-23,30,-85,-9,4,-18,-2,57,-39,51,40,-30,51,4,-43,87,-16,-25,-62,-75,-58,-9,18,48,26,21,67,16,80,-2,-14,69,-3,28,-53,-6,40,-3,-26,5,26,-36,43,-14,41,-64,28,40,-28,65,-5,15,19,-34,-32,86,-7,103,-72,33,-12,22,-10,60,-42,-50,-31,70,-7,-66,21,-18,18,-65,-2,65,-25,-127,-15,0,40,16,-26,19,29,71,12,30,-9,-1,-13,-34,-38,-16,4,-5,-6,38,66,30,18,-10,27,-8,-61,15,-41,3,-6,-34,60,54,-29,36,12,10,-35,22,-13,5,4,72,-17,1,-9,-40,35,11,10,20,-19,34,54,-12,-42,4,20,-126,-6,6, 
  /* [2][0][][] */ -1,-2,67,-17,23,52,-11,85,-101,-48,-40,21,-8,32,-21,8,46,-1,63,-80,-25,-74,34,-42,-14,24,-32,56,-55,13,68,36,-50,29,17,7,30,-43,63,42,-11,43,21,-33,20,55,23,122,43,-22,-10,-12,5,73,43,34,0,81,25,-23,20,36,54,12,38,-1,-60,-31,-1,-78,65,-66,42,16,42,-33,36,78,26,64,-2,-42,-11,-5,8,3,-54,-41,-23,-90,25,-29,-55,-1,-14,0,-57,33,13,-1,1,-28,8,12,-52,-29,9,0,55,21,26,27,-69,30,61,33,-54,1,12,-13,-22,10,83,-15,25,-55,-19,-38,26,-53,57,-21,-25,49,-72,75,21,30,21,76,-18,38,2,-22,49,-29,-28,8,-49,-52,58,10,-24,-17,41,-63,-34,-39,18,-31,-61,-5,-51,55,3,57,-38,35,-3,127,-35,122,14,-12,56,-23,77,-20,-72,112,6,-11,35,-52,-44,3,38,10,-37,51,39,1, 
  /* [3][0][][] */ 30,4,37,-18,34,16,-32,-28,17,-39,41,-16,-30,23,11,28,21,-1,-6,39,46,-58,-26,-73,-43,-25,15,80,-72,-12,10,19,12,26,-25,20,-1,-35,17,18,16,-68,23,-8,88,17,-16,-53,15,41,-16,-52,75,1,4,-13,41,-1,37,11,-11,59,11,-95,19,-50,17,-34,26,-33,3,13,4,-31,28,-39,83,23,-40,-26,24,-61,-30,4,33,-52,-15,-73,8,21,-102,45,27,24,25,-18,-22,-50,17,33,-27,-68,-26,64,-60,-63,-3,-28,-16,59,-41,15,30,20,0,-49,42,40,9,-11,36,14,-1,-37,13,25,-42,8,-44,30,28,-13,15,34,-10,57,14,16,-9,-12,4,-8,127,-7,-15,9,-48,-17,-40,6,-56,-2,-13,-21,31,-5,36,44,-44,-2,-43,-17,-27,-16,-28,27,-23,-34,-65,-67,38,39,-65,-16,23,-43,5,6,53,19,9,49,-39,-28,-17,-55,13,28,43,18,8,-50, 
  /* [4][0][][] */ 9,35,-13,54,55,-28,-41,68,-58,17,26,-17,-4,28,72,58,22,27,-44,37,-6,24,-71,-60,9,-10,-55,34,-96,40,-12,18,-36,-14,-5,65,-18,50,-11,-22,0,-36,2,66,-6,-121,-35,8,-98,11,-8,42,-42,11,75,4,4,38,-84,33,53,18,38,21,6,-13,68,58,24,62,-36,36,-30,116,-31,20,91,61,60,-39,-77,24,-13,33,-47,-68,-62,22,-32,-32,-1,28,102,-63,-40,17,-35,-116,67,31,-15,-69,36,117,5,-4,-45,-14,127,18,86,36,79,-29,-2,-53,67,59,-87,-11,-36,-85,26,2,-17,-32,49,-4,-82,-90,-93,89,-29,-1,3,-40,57,15,0,-19,-34,4,55,3,43,-51,-26,-54,41,36,42,-13,35,69,-12,41,-66,-47,36,-47,-60,-41,-3,22,5,9,-63,31,-20,-59,-47,26,-9,-17,80,24,-17,-102,35,56,39,4,-50,27,-15,-1,-22,47,2,54,-81,-89, 
  /* [5][0][][] */ 9,-4,56,43,-50,27,41,20,21,-37,21,15,41,-18,20,4,22,-42,51,-49,-7,-24,50,40,14,-34,-13,-78,80,30,63,25,-34,-12,72,34,35,14,-3,-93,-22,81,-8,-34,-19,-11,-1,-9,-4,-45,15,-25,19,-21,19,83,-76,9,12,-57,-13,0,-68,-15,-32,72,10,30,-127,-9,-52,58,5,6,20,-4,14,-20,-81,-20,5,6,-20,-15,-21,45,21,44,-86,1,24,6,-47,-13,-13,-45,-6,53,-29,84,-12,0,-51,-35,-5,47,1,20,9,20,48,-17,-11,-35,-57,104,-60,-5,21,-17,-34,37,-62,-2,-58,-32,48,61,-14,-3,-20,38,7,-16,36,-18,-45,72,-18,-9,-57,-18,-85,-59,-44,-20,32,41,-24,-7,-66,-35,-52,-37,-25,0,7,-50,-37,38,13,-15,-33,4,28,-59,-26,-12,30,6,58,-38,23,33,68,31,37,49,-42,-86,-48,-12,21,-24,-2,-36,35,-28,-33,57,55,-30, 
  /* [6][0][][] */ -31,-32,-70,-37,45,-1,-82,27,-31,-76,-46,63,26,-67,-34,-44,124,12,52,28,-76,51,33,-10,-4,57,-60,-46,38,46,-9,-34,-19,-13,28,-48,39,-10,92,14,39,-19,14,40,81,-34,10,43,-64,-20,82,29,-14,-22,-12,-64,46,18,-61,4,-48,-3,16,43,47,-17,-30,-13,26,-7,46,-54,-94,-7,-56,-62,35,-12,26,-9,-32,-56,2,46,-8,38,46,6,22,27,42,0,-17,-28,-71,-34,19,54,24,28,-5,78,-87,15,20,18,16,61,-37,31,-20,-40,34,27,57,53,-17,29,-4,9,24,33,18,12,-34,20,35,-60,23,24,15,-78,20,-11,-112,-23,-57,-26,-50,-20,-37,-37,-19,-23,-70,54,1,15,-40,9,81,38,14,-3,-42,31,-108,29,-28,-23,72,-8,78,127,-49,-70,61,31,19,21,-21,-38,17,30,-97,6,10,-35,68,-17,-11,-27,32,-51,24,8,-40,-1,-8,44,25,-51, 
  /* [7][0][][] */ -57,89,49,30,40,-74,-7,-26,-104,13,-18,63,-110,-9,-27,3,-20,61,-17,79,-1,47,-38,4,-75,82,-48,-67,-17,31,23,-56,39,95,12,53,12,-30,-77,-29,-20,5,13,42,49,-73,-31,-40,53,-47,79,-1,29,-1,2,-12,-38,-36,-93,10,-46,18,23,-21,-21,8,-11,11,-4,-42,5,105,58,5,5,0,40,104,50,72,-19,1,72,4,26,-50,7,71,63,63,-76,-19,20,89,-46,-29,-44,-17,16,26,-79,-25,29,-33,64,14,-21,-72,41,-83,54,-14,63,-10,5,-84,57,34,6,-58,-77,-34,-14,-61,16,18,-100,-14,-16,2,-33,4,-58,87,-10,-2,-26,-2,67,51,-127,-36,-42,-63,-113,-116,44,-40,-9,27,17,-29,-53,60,-26,-76,-35,-20,15,37,-11,53,54,-36,10,-97,31,30,-29,22,-62,12,15,1,-24,-71,22,18,44,7,-52,30,78,4,52,-55,-38,-88,16,-14,20,-55, 
  /* [8][0][][] */ -3,-31,-9,30,-42,82,-31,-7,70,2,-23,-35,35,-51,34,43,-17,25,4,-31,0,5,-3,18,58,-4,75,-46,34,68,-31,50,62,-24,-1,74,11,6,-13,16,-22,47,-49,-36,38,-28,18,57,-37,65,-127,-27,17,12,-16,21,17,15,-12,-46,39,-90,-11,-18,-20,-34,36,21,-23,3,-12,-1,37,91,-19,20,-40,-34,28,13,-36,45,-6,15,3,2,-30,-2,0,36,-49,43,66,-5,23,6,-11,-76,-14,-48,70,-7,32,54,-70,-38,-28,-33,44,26,13,12,8,-33,-35,2,46,21,0,82,-21,-58,-2,12,-70,-65,-6,-54,-69,12,-52,-43,-13,53,-21,-27,34,-29,-12,-23,-11,51,8,69,11,15,-14,-27,65,57,22,13,6,99,71,-32,15,-15,-30,-5,16,9,-68,-17,-2,28,37,-40,-77,-25,93,26,26,2,30,-1,45,51,20,-21,-34,3,20,15,48,-55,-17,2,-22,-29,-27,-40, 
  /* [9][0][][] */ -88,-2,-58,-7,-32,2,35,52,-3,-46,-35,-50,69,-41,4,2,-16,7,-92,-44,-62,7,56,36,-5,-29,60,-39,12,-13,-16,-3,-16,-56,-68,-54,26,-36,18,22,30,57,-42,-33,-50,74,11,-10,-22,44,-70,19,20,38,-62,-61,-23,63,39,45,21,-23,4,-8,44,-66,-6,-6,62,-88,17,127,77,-11,20,19,12,30,7,-93,22,18,-100,2,-17,62,-44,-20,33,-37,-31,3,-16,-31,-43,15,37,9,-45,46,81,-48,62,-11,34,-61,80,-3,-19,-11,-21,8,-49,-1,-33,-88,-60,-34,40,-63,-4,1,15,53,-21,-43,-29,-66,-20,0,89,29,-50,15,37,4,119,65,-56,27,-11,55,32,74,34,-21,100,30,33,-11,-38,41,20,31,89,61,18,-22,36,17,43,-6,-59,-12,-27,53,-80,-8,-43,86,7,-1,72,-62,6,18,-19,78,-6,25,-38,10,-12,-29,17,-20,10,-53,18,8,-8,59, 
  /* [10][0][][] */ 7,16,47,62,63,-2,29,-8,-24,28,49,46,-39,14,22,62,-9,35,12,-9,8,44,-84,-53,10,-39,5,5,20,48,41,28,-39,14,15,69,21,8,18,2,15,44,35,34,32,-127,43,26,12,19,60,-75,31,-51,28,-7,-29,21,4,9,-16,-41,34,-6,-2,25,92,31,-32,16,-26,48,-27,40,5,24,-8,24,23,-24,3,10,-11,5,-26,-24,-65,-7,-27,10,-2,63,71,-41,49,-58,3,-20,-17,-7,-25,-65,-8,-21,-14,-45,-62,-27,29,56,25,10,-1,-31,21,-11,51,37,-91,-25,-39,-31,-18,-20,-24,-2,-1,43,-34,-20,-108,0,-56,-20,27,-24,-18,9,59,-26,-40,-72,63,19,-35,-67,-22,-35,34,-11,18,-18,37,51,-16,-2,-8,-3,12,32,33,-26,-85,-19,-13,-6,-32,-29,-29,-5,21,26,17,11,37,22,-6,-42,-31,-51,-13,0,17,35,-2,-62,-40,-22,-8,17,-30,-61, 
  /* [11][0][][] */ -24,2,27,-16,52,-10,38,-57,-14,48,89,27,-79,2,45,1,-35,20,26,86,-70,-127,-61,-12,-94,-31,-69,63,-38,37,-61,-76,46,5,106,-3,55,12,37,-32,-1,-15,82,62,17,-111,-24,-50,9,-60,-22,21,53,-9,-62,-89,17,-30,-33,6,-13,-67,-22,-17,-2,-20,28,-41,-39,32,-29,-59,59,37,-100,38,-79,-98,-104,-50,48,-28,-118,28,-90,-64,17,-18,-20,-71,-28,15,88,28,56,-1,6,101,49,37,-108,63,33,-62,25,-53,-68,73,96,-41,72,-47,-37,41,-9,-15,-8,-61,-54,-74,-15,57,13,23,-57,19,45,22,4,6,30,14,18,33,-21,22,-16,57,26,-13,-7,-13,46,46,-25,62,55,12,-31,-42,-57,-20,88,56,7,-35,87,-12,-13,-6,-29,3,127,-60,80,-18,-54,65,-98,46,30,20,2,-21,66,2,26,5,33,-24,13,-25,3,-40,0,-117,12,67,21,41,-57,-46, 
  /* [12][0][][] */ -8,2,-60,34,-63,15,-83,39,-20,-38,-4,10,-37,19,-28,-52,56,47,31,-61,53,-65,19,18,-60,-4,29,30,14,-17,3,-29,0,-1,44,-33,-8,5,-48,76,55,15,-87,42,-11,-72,-48,44,41,9,36,52,-38,-53,43,15,-85,53,-14,-87,-2,-20,-55,69,-3,-9,40,6,2,18,-62,34,-31,36,-36,-8,-38,-44,71,16,-1,-29,-92,-87,23,56,16,-121,95,124,101,-34,47,25,10,69,-31,-53,-4,-18,80,4,93,-74,37,-28,65,-77,33,-101,-63,-32,31,88,-27,-90,-13,-59,-42,63,-96,-40,37,-48,47,33,-41,-66,87,-4,14,-39,-4,-22,17,6,16,-36,-15,113,117,-22,-3,52,-26,70,11,87,-29,-40,40,-2,54,-4,-49,46,18,-29,40,48,39,-48,-46,-23,12,20,10,16,37,97,-91,-68,33,-23,55,80,-32,-9,-23,-67,-96,98,-41,53,127,46,34,-3,-42,62,-42,51, 
  /* [13][0][][] */ 7,6,-9,-15,33,62,-19,45,-25,10,9,-17,-26,7,-95,-42,55,29,40,19,-26,-23,20,7,-14,-47,2,10,-22,36,-7,-12,-17,21,-13,-48,22,-36,20,41,-55,13,-31,24,29,25,63,-4,-8,19,51,-21,27,-44,68,8,1,-2,2,-58,49,16,-53,-43,13,41,-50,6,22,-32,18,26,-52,-23,-50,-58,64,-6,57,2,-4,-21,76,33,-17,18,-5,11,25,16,17,25,-15,-1,-4,-28,-8,0,0,-5,22,-54,17,15,-22,46,-29,-74,-108,14,33,-12,25,1,47,-68,25,20,33,-27,-2,12,-32,-40,33,13,45,-17,23,69,-19,8,-27,-18,-19,36,-3,-18,15,1,-32,-27,13,0,-5,33,-35,-5,-3,23,23,37,-6,-47,-16,53,-12,18,13,8,9,21,-127,13,-34,-11,-21,20,9,-32,39,-52,12,-7,16,30,25,-16,10,6,-25,-49,-22,-32,-16,-1,-45,-58,-2,33,29,-5, 
  /* [14][0][][] */ -2,-36,37,-18,16,52,-21,6,-47,30,33,-56,68,19,-8,-7,25,-11,-32,-5,22,-51,4,7,46,16,11,24,-36,18,52,56,-95,-20,-19,-35,39,-104,15,1,-22,56,1,19,26,-4,57,16,-41,60,-41,-2,-96,-13,27,-23,11,-12,-29,12,8,-52,2,70,-4,33,-27,8,15,-31,24,-7,24,-66,19,-26,57,-30,-14,-32,20,-14,-19,53,-5,55,-16,-1,-68,-4,1,-1,29,-31,64,-42,62,30,65,26,60,-85,-3,-78,36,-57,5,20,20,17,22,-22,-61,21,-19,68,29,5,46,-67,58,42,-17,-40,-10,15,-6,-7,8,-11,11,-15,-32,-3,-45,21,85,59,39,-3,-13,12,1,-6,2,127,-49,-23,17,-77,-24,6,-27,-12,14,57,-57,-55,15,16,-62,-56,-92,40,29,26,-5,0,-19,-5,-42,-10,88,-5,-73,23,39,-10,-38,61,-17,-47,-46,-8,-36,-21,-2,34,5,46,-6,26, 
  /* [15][0][][] */ 17,113,-12,48,68,9,-91,-46,2,82,22,40,40,85,7,52,20,-5,-3,38,55,-58,-84,54,43,24,79,10,26,104,-67,29,42,14,25,22,69,57,-70,27,-2,32,62,-7,7,2,-62,-37,-23,53,51,14,47,-18,34,-59,-17,-39,-6,-15,-30,-16,60,-12,5,-68,64,-55,119,-23,-29,97,32,34,38,-87,-9,79,90,-32,11,25,-92,-19,-84,21,28,-11,69,23,-61,39,-30,31,-23,-36,-15,-15,-1,-67,-37,-17,47,-54,84,-20,-38,4,16,65,-69,52,13,45,25,55,-15,-108,-103,-79,-28,-23,-75,34,29,-8,40,-22,-43,-4,6,10,-45,23,8,-69,61,97,55,28,18,-45,-31,105,44,-12,0,-7,-45,-33,-78,-47,24,25,16,67,-57,-127,-23,62,26,70,56,82,-85,-17,-72,4,56,71,-76,-32,61,-84,-43,13,17,8,7,-3,12,13,-13,13,3,-98,-34,20,-13,116,-55,-115, 
  /* [16][0][][] */ -51,-35,57,3,-54,-60,-2,-42,37,-35,9,52,14,35,-20,-44,-9,36,69,43,40,-2,-23,37,-79,-40,76,-105,-38,-39,-11,-85,5,3,4,-12,94,36,67,4,13,-49,-13,24,-25,-103,19,-47,-114,-4,86,-29,8,21,-22,40,-5,6,53,17,-24,15,-24,7,-29,38,42,-45,-80,63,-47,92,-8,-47,-36,84,72,-41,-40,45,13,9,8,7,-15,-8,58,-19,54,-17,16,28,-17,4,-84,21,-94,-24,-75,-12,-22,44,21,-27,24,23,-30,-8,-42,7,37,47,43,-25,-37,2,-32,-84,61,-5,-69,52,86,79,-75,127,54,-2,10,-29,18,55,-15,36,-121,-25,-60,-25,-86,8,-45,-53,40,-79,-87,-33,39,61,2,70,-66,-11,-98,-10,-40,67,-32,9,-16,47,110,58,21,-59,-84,-38,-52,21,-7,38,59,-12,-19,-21,-70,-50,26,111,-53,36,-45,64,54,32,62,-31,13,-61,-5,50,43,-4, 
  /* [17][0][][] */ -37,-1,-8,-36,-26,11,61,13,0,-16,-8,-48,53,-76,-15,14,10,-8,-53,-24,-1,-36,41,49,-22,-21,35,-13,42,-28,-5,-31,-8,-30,41,3,13,-73,13,45,49,4,-22,-22,-32,77,22,5,13,74,-79,10,-25,74,-26,-20,-7,2,-11,-3,24,27,12,16,10,-104,-61,-1,-19,-64,22,30,57,-68,-20,47,46,-32,25,0,47,20,51,0,-8,37,10,-43,-5,54,9,-3,16,7,-11,5,26,-14,19,-2,10,-53,31,29,36,-60,6,-28,-18,-33,-3,-4,-36,38,-12,-24,51,-7,52,55,34,31,-23,21,-34,-23,-5,-68,-29,39,38,-10,18,-2,-37,15,-19,-34,6,-49,-22,48,-13,-15,-27,34,3,-22,-19,-17,-2,-15,15,22,50,10,127,36,-48,43,-35,23,-33,-20,38,7,56,-47,3,39,-59,29,34,-5,-48,-43,22,60,7,26,-7,-74,-35,-44,47,-16,14,-33,21,-39,43,-12, 
  /* [18][0][][] */ 18,108,-31,52,-1,-48,-24,22,-36,18,-26,-6,3,32,113,51,16,37,57,19,21,89,-30,-9,-18,-2,-63,-50,-35,4,-37,15,2,-35,1,87,35,23,-9,-6,-20,20,-37,35,2,-110,20,-22,-75,-121,-32,-29,-40,-60,-35,-43,-1,11,21,-19,35,44,-15,-38,6,93,61,-16,-11,-15,26,19,85,0,-13,77,9,63,23,-31,-31,-11,71,-7,67,-33,-92,5,-11,9,-103,21,41,4,-58,19,-58,-67,35,-45,-4,-104,-36,35,41,-22,-64,16,57,-28,36,-1,-19,-82,13,5,36,7,-6,17,-67,-42,-27,17,-40,1,-25,-8,-48,20,-41,-30,-54,7,-57,-6,22,5,-31,-5,-72,40,-27,-97,30,-127,4,-105,-29,-3,51,3,14,-5,28,-8,-6,71,7,-59,39,30,-76,57,-55,-47,-7,-67,-32,-36,-1,39,-26,-57,16,3,-41,10,19,39,63,-67,19,19,-20,45,-53,53,15,38,-37,-19, 
  /* [19][0][][] */ 22,51,-98,49,-44,25,33,4,13,52,-44,-3,-54,51,-6,38,-5,-49,-48,-9,42,-5,48,0,-47,39,-59,47,3,21,-36,-23,31,46,-37,101,0,35,6,49,-79,-41,-75,34,-4,-6,42,-33,18,-76,-4,11,16,-18,12,-30,-28,-19,6,-8,-5,48,12,36,9,-86,18,-13,-54,-54,13,34,50,63,34,23,22,69,-18,17,40,-72,-8,-3,-4,-1,31,12,-29,-14,0,-19,-37,4,19,27,26,-20,-27,-18,-37,39,-19,50,9,-13,0,-17,49,8,-20,-70,-45,-6,7,-70,7,38,-7,-37,-17,38,10,-30,-40,-41,-13,-7,-12,-13,18,50,-39,28,75,3,-38,5,44,15,-58,30,-56,15,1,-37,-80,-41,33,-13,-31,26,-2,4,26,-112,21,1,-22,11,-28,127,17,-40,22,58,-22,4,6,12,105,-4,42,8,41,-50,7,-5,37,84,45,2,-3,-62,-40,-39,9,54,-3,-21,58,-30, 
  /* [20][0][][] */ 1,20,-121,50,33,14,-61,35,55,-5,40,39,1,57,12,42,39,22,67,-46,66,61,15,4,38,18,-57,-17,68,-62,31,12,6,38,10,33,-72,18,-18,16,42,41,28,-13,-79,4,-94,-18,37,-7,-30,-18,-23,-16,-69,25,-65,-7,-65,-82,38,7,94,-110,-16,16,16,-46,23,-12,-27,7,5,17,79,18,-35,74,1,-19,-36,-5,-7,-76,15,20,-3,-64,-10,18,8,19,-20,-20,6,94,-40,-54,-96,30,52,36,-7,16,-46,49,37,-53,-5,-78,-51,4,-12,-18,45,8,-14,34,17,127,1,-36,23,-76,-25,-70,39,65,20,27,7,9,-28,36,48,8,-8,-47,-27,-51,44,16,29,42,-35,-32,-23,66,-28,19,3,-19,12,-28,-48,-21,91,63,45,-25,30,-37,-27,10,-23,-4,34,17,23,-42,49,12,-106,33,52,40,-52,-84,-51,-54,-6,7,83,23,7,65,33,48,-31,-12,-21,64, 
  /* [21][0][][] */ -6,-66,0,26,33,-30,-40,30,-21,-35,-4,15,-46,-1,73,27,43,-22,-60,1,-35,72,-54,-18,-25,12,8,24,-85,43,-50,28,-16,-42,-4,12,-77,102,-66,51,28,-72,24,92,63,-73,-17,1,16,-5,-3,24,-31,-88,-4,-36,5,25,38,-1,-25,62,-14,25,41,-34,60,-15,-42,44,-61,53,5,104,2,3,9,-6,33,-74,-56,-3,-39,-30,-24,-80,-38,-15,-34,-13,54,63,50,-34,54,53,-73,-52,-52,55,8,2,-16,-2,-41,-49,-53,24,59,56,-11,20,31,11,-46,-86,-43,59,-82,2,-24,8,1,8,8,-47,41,18,-31,27,-42,39,26,-111,-17,8,8,-20,-126,7,14,-5,-3,34,74,-3,39,29,3,-15,8,16,40,87,-5,5,-46,37,16,79,26,-15,-63,46,-27,9,-64,-26,-13,8,45,-80,36,-17,-26,21,2,-56,23,-16,-22,5,-58,28,29,-21,21,34,25,6,-17,-127, 
  /* [22][0][][] */ -3,32,-6,-7,11,-8,70,28,-55,49,-77,-10,4,8,-23,38,-26,-13,-41,-24,23,26,-56,56,-11,-18,-5,-3,0,-10,-5,-2,-50,49,19,20,7,-13,-53,-15,-1,-23,36,45,58,-4,-49,-7,-37,6,40,20,4,-36,-5,-25,20,-24,-31,25,-35,6,2,-13,13,11,-6,-13,-25,-25,19,8,2,35,51,49,-14,57,23,-3,15,39,-20,29,45,-29,-5,-37,-1,23,13,-4,-1,-17,-12,1,-23,48,-4,17,13,-23,29,25,7,-23,-48,-9,28,10,0,-10,-7,-3,-10,-5,51,-7,-13,-18,5,-41,1,0,37,-46,-23,-1,-33,-47,20,62,17,-35,-12,21,10,11,27,12,-5,12,-50,11,53,-4,-12,-27,37,2,3,-5,-23,13,-5,-2,33,6,34,-7,-127,72,17,35,-10,14,-46,-16,-51,27,-62,-22,-7,45,26,-19,-1,-5,43,11,-22,17,-55,33,-38,-19,48,-13,12,46,-3,-53, 
  /* [23][0][][] */ 34,-63,43,-19,77,-6,27,7,6,25,-12,25,-72,25,25,-21,-29,63,101,2,-15,87,-42,31,53,50,6,66,-45,-71,50,38,-22,8,10,-19,99,88,-53,-64,4,-52,39,-23,27,32,-38,-59,-100,-50,95,35,8,-4,8,-4,-1,-87,11,-19,-10,-30,22,51,43,-20,32,-13,52,95,25,-62,27,50,0,-68,47,17,30,63,8,63,-54,-58,-4,-42,54,26,35,-50,-58,56,-70,-21,-22,1,55,-37,12,-44,23,40,-29,-27,-2,-6,-16,36,59,-42,-24,23,-48,-1,64,11,18,2,-58,-85,-8,5,-59,98,22,24,-40,29,-35,-18,9,-33,13,-35,-19,29,30,31,65,-26,35,-37,127,27,-72,72,-51,15,-28,-9,6,-24,26,1,0,-15,-9,-15,-7,-28,-80,73,111,-37,16,-11,-40,23,-14,-19,24,-41,65,89,-47,-18,37,-33,26,-29,17,14,31,6,-48,-61,-90,37,-32,26,28,44, 
  /* [24][0][][] */ 39,-8,-105,13,-11,29,-42,60,13,19,37,-6,43,2,-3,64,70,-19,45,97,-123,40,-63,33,-34,5,-57,39,18,105,-44,32,-75,-79,-32,19,-9,24,-13,48,118,-39,57,28,87,-127,37,7,-64,23,-26,-31,59,9,-62,25,-27,11,-10,39,10,-22,-17,48,-40,-6,79,16,-18,-12,-34,-78,-53,-48,64,36,-22,-40,-59,19,74,47,-66,-12,41,-5,-72,-15,-100,13,37,9,81,-26,-45,-10,38,64,-2,-14,20,0,-36,-39,5,-45,-44,68,23,66,48,-38,-63,-46,11,8,-14,34,-46,-7,-13,4,-14,4,-60,-12,25,99,55,-61,-48,-23,45,-60,-11,18,62,14,-32,-20,-46,2,-117,-17,32,37,-38,-26,37,-68,10,-34,45,73,-19,12,-70,8,-16,4,42,42,16,104,12,54,-55,-68,-12,73,28,-80,16,30,-14,10,46,-113,-19,9,-30,-94,-25,-45,-23,-107,9,-29,17,52,-35,-64, 
  /* [25][0][][] */ 29,-22,-27,15,30,13,-48,9,-2,11,-25,34,-5,74,7,40,-14,25,54,-102,-30,-4,-48,-4,-45,-46,-16,56,28,-24,89,42,-9,-16,0,29,-16,19,-2,23,-51,7,-52,9,7,-81,-16,20,0,37,81,-29,-12,18,6,54,-12,44,-21,-22,27,-55,4,-18,-67,-37,87,22,16,37,33,-44,26,29,3,39,1,-14,24,54,19,-36,-13,-26,-13,-6,-2,18,-34,13,52,5,23,38,-13,-5,23,32,-7,-6,8,45,18,9,-23,15,-1,-39,-5,-25,13,26,27,-22,28,36,27,50,-86,55,17,-47,16,0,30,-13,-21,49,44,-13,-57,21,39,3,48,-12,4,27,32,65,16,-50,-35,31,6,-30,-34,25,38,-18,40,-8,18,3,-63,14,-22,-15,22,-16,33,-23,-3,-37,-22,10,38,11,36,11,-48,6,-30,56,-47,25,-127,-66,-63,-16,-8,-9,-20,42,-24,-10,10,38,-32,-25,-21,-10, 
  /* [26][0][][] */ 56,-37,-5,-19,21,49,-4,64,-77,57,-35,51,-14,5,-44,-11,-20,-10,42,-30,-3,3,-32,63,-45,6,-27,101,8,3,92,86,23,25,77,17,20,-55,-12,51,-56,-44,-56,35,31,-80,34,60,25,74,59,3,14,-25,7,-18,-42,68,21,-3,35,4,-12,-22,25,31,2,127,-93,47,-29,-57,-5,105,-49,15,10,-13,95,42,11,-61,-72,-37,-15,-40,-4,-28,45,-43,10,21,7,-3,41,-32,32,-26,-62,63,-27,43,29,-23,-69,-23,-45,-18,67,65,14,21,105,21,60,-61,16,34,-56,58,15,-7,-39,63,-19,-13,54,31,3,-16,-27,-21,13,-10,22,-57,-55,-48,55,112,31,-65,42,-33,-61,8,5,17,27,61,70,-48,-34,-6,7,15,-11,47,-14,89,-52,19,-17,-21,36,81,-1,-18,18,20,20,-41,26,-14,8,-87,67,15,-41,-2,-25,32,13,-48,53,-32,-65,40,-90,-37,46,36, 
  /* [27][0][][] */ 33,-5,66,39,20,44,36,120,-18,49,-1,18,-52,24,67,-30,8,42,20,0,-16,37,-7,34,-95,24,-27,13,-71,1,4,15,39,-6,-27,-8,18,44,27,95,-30,13,3,22,-57,-46,22,-59,-8,-28,0,-7,1,-3,-39,-3,32,65,14,64,-27,-8,-9,-2,-31,78,64,-6,26,82,-17,-27,49,9,-11,48,-38,-8,4,-48,95,42,-88,4,47,-127,-9,-29,-41,15,14,-15,-38,2,-35,12,-21,37,-66,-5,56,-24,57,-79,18,-20,-48,2,-9,-101,-60,8,14,-42,-13,-9,-27,8,-68,23,-1,-21,90,106,46,-16,-23,-12,-27,43,24,-17,-12,54,-59,-7,35,9,-46,7,65,4,-53,-1,25,33,29,15,26,50,13,8,-28,-19,36,-15,20,66,20,58,44,23,-80,20,-34,41,-40,-27,-9,10,73,100,-44,-55,39,31,-6,-4,20,-14,19,-42,44,18,32,-30,11,12,-55,67,-93,-26, 
  /* [28][0][][] */ -47,15,52,-102,16,-14,-88,-17,36,-4,1,9,7,119,14,21,-58,-30,-39,-80,25,-14,11,29,34,37,-47,87,-78,-63,19,78,11,-8,-79,-1,-70,-45,-107,119,63,-70,-56,-24,-3,-37,47,11,-22,-4,-48,-6,-64,35,-56,33,-7,26,-72,-66,49,37,19,-48,-81,-50,-10,-23,26,-57,8,22,-13,16,61,-27,-25,71,122,28,-43,-92,-6,73,23,11,-24,27,-15,13,80,-55,-1,35,45,46,2,27,38,41,21,50,60,31,-16,7,35,-42,30,13,61,108,8,65,127,-95,-24,-63,-19,-1,11,49,36,78,-10,-79,51,-87,-57,51,6,-89,-10,79,43,36,7,-33,90,16,53,8,-62,-30,8,-59,6,47,37,17,103,-5,-2,-22,4,-23,18,-104,-50,-46,-44,-20,-31,58,72,43,121,58,9,5,-19,52,-20,-64,63,3,28,4,-21,86,110,59,24,-9,27,-21,16,59,-34,-93,29,37, 
  /* [29][0][][] */ 1,-83,-8,-91,18,20,14,-3,-73,-21,-83,-52,54,-18,-82,-70,1,27,-18,26,-26,-84,40,-63,-46,23,-14,-51,-76,-21,20,-59,-8,26,-77,-16,-70,-113,50,-3,-46,-38,-119,-15,-28,93,26,8,-11,9,-16,27,18,47,33,52,81,41,13,55,10,7,-27,-22,-21,-14,-88,78,-69,-39,37,-32,44,-50,-58,-23,-43,4,-54,-5,-11,3,45,63,-4,15,64,-42,40,24,20,-87,-60,-25,-81,24,17,40,42,51,39,5,-61,20,-1,33,55,-47,25,11,-9,8,46,-14,42,-6,-62,23,127,15,-21,14,-81,-12,13,-36,-21,-52,-12,38,82,35,6,-44,13,-25,-18,68,-45,3,-2,29,-38,-12,-5,-24,31,9,-37,35,7,31,-35,-31,53,-10,2,78,17,19,-6,-5,-50,-56,-25,-46,46,35,11,-21,36,44,6,9,-20,-69,-6,84,81,58,-57,-25,-33,-59,87,27,-30,-27,21,-71,65,36, 
  /* [30][0][][] */ 19,40,-41,-65,8,31,-13,-32,-22,-30,55,-36,-15,-88,-22,-56,1,-38,-26,24,2,-6,7,-25,41,-16,3,46,-28,2,-28,-4,33,-13,15,-90,14,-76,64,-35,-18,-9,-15,-19,34,16,81,-46,17,-127,12,13,-30,-11,-26,-3,12,-89,-37,0,14,76,-61,11,-5,-15,-67,-23,-5,-13,29,7,67,-57,36,-16,-9,6,-45,11,7,-32,22,2,44,15,7,69,-16,-33,33,-48,-8,47,-26,-57,41,51,-21,-20,10,27,-16,-80,61,3,-13,-4,-107,23,-44,-6,-40,36,-45,27,-81,79,73,8,31,64,37,28,-45,27,-62,-36,67,-3,34,15,51,26,16,-42,-16,30,2,12,40,38,-36,14,-30,-15,-50,19,-30,-40,-17,25,3,-36,-47,-56,58,45,-22,-3,92,-17,0,-16,-13,19,13,-62,6,-2,-55,-75,-63,-10,27,33,-97,55,-57,-57,4,6,-8,-61,8,-34,-26,11,81,-21,-21,63, 
  /* [31][0][][] */ 4,-35,46,-26,22,-44,-30,-2,38,35,-44,-64,80,27,-18,30,-16,9,-51,42,98,15,-35,21,-14,-46,-30,-29,-43,-37,28,-17,-82,-80,-71,7,-49,75,1,-73,-114,-19,-29,-73,-48,24,-45,-48,-58,3,-50,63,-22,2,41,-33,-88,-97,-78,25,-41,-9,38,80,-7,67,31,17,42,58,4,74,-6,-30,35,-9,-33,90,-73,-10,-84,39,21,-47,-17,-60,-4,45,-64,3,-21,6,-33,61,-57,60,28,-69,1,-36,24,-42,-79,26,42,42,19,-6,26,-74,-57,38,-101,-30,39,-9,-44,77,38,-30,-26,24,-20,-115,-16,30,72,45,52,-76,-35,45,57,-127,73,-50,14,15,51,45,77,55,41,-19,19,42,-82,-41,-21,3,-11,-59,7,41,37,46,7,30,0,-76,-99,60,-3,-52,49,-25,-4,-94,110,-53,-19,84,16,11,7,-26,7,-41,21,19,54,-107,14,9,-9,74,-37,52,-4,-71,12,59, 
};
const TfArray<4, int> tensor_dimension68 = { 4, { 32,1,1,192 } };
const TfArray<32, float> quant68_scale = { 32, { 0.0023807596880942583, 0.0015817309031262994, 0.0016737361438572407, 0.0023799787741154432, 0.0022739237174391747, 0.0017080468824133277, 0.0021108398213982582, 0.0016383499605581164, 0.0025126633699983358, 0.0015589473769068718, 0.0038830267731100321, 0.0016961866058409214, 0.0017139863921329379, 0.0027225364465266466, 0.0016503464430570602, 0.0015996323199942708, 0.0011101396521553397, 0.0023690450470894575, 0.0019860893953591585, 0.0019984808750450611, 0.0017047965666279197, 0.0020171240903437138, 0.002429089043289423, 0.0014751972630620003, 0.0017009829171001911, 0.0024703983217477798, 0.0017717913724482059, 0.0018341727554798126, 0.0011736820451915264, 0.0025650491006672382, 0.002315424382686615, 0.0013921881327405572, } };
const TfArray<32, int> quant68_zero = { 32, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant68 = { (TfLiteFloatArray*)&quant68_scale, (TfLiteIntArray*)&quant68_zero, 0 };
const ALIGN(8) int8_t tensor_data69[192*1*1*32] = { 
  /* [0][0][][] */ 101,9,-13,47,25,10,-47,56,-95,37,25,-60,-4,-13,-72,-1,-21,60,28,-1,24,-25,40,-33,-60,-26,-5,66,62,127,23,-41, 
  /* [1][0][][] */ 48,-34,-121,-4,-26,104,-42,-6,-15,63,78,-24,-52,-11,12,34,46,21,-55,15,25,127,-73,67,-86,42,56,-27,74,-19,-32,45, 
  /* [2][0][][] */ 46,-98,36,53,37,-12,21,-22,-52,-52,18,-78,-48,34,-29,-33,-105,29,-7,-82,49,80,-67,10,-31,62,105,25,-127,-83,20,-42, 
  /* [3][0][][] */ 53,-44,-20,22,64,62,-2,127,-1,40,0,-14,26,38,14,-75,-28,56,-20,-54,-29,42,-53,-1,-1,-11,-2,73,-11,-1,8,23, 
  /* [4][0][][] */ 60,122,-10,19,-44,-45,-63,-5,10,25,49,-22,38,-37,-30,47,59,1,21,115,32,6,16,-9,17,57,-13,27,45,-127,-114,7, 
  /* [5][0][][] */ 30,-127,-65,34,74,-10,-17,45,19,-60,30,-31,30,-71,57,3,97,-12,84,-1,-27,59,41,95,56,45,0,75,14,8,10,-52, 
  /* [6][0][][] */ 36,13,85,10,-35,8,40,21,-80,-25,21,12,-2,0,-22,-21,-37,12,-43,-41,-61,4,26,127,-27,60,11,-57,-31,-52,-23,-57, 
  /* [7][0][][] */ -4,74,-29,57,125,79,64,-21,25,48,-16,9,0,29,13,-29,32,-24,-11,20,27,-58,11,-12,89,73,67,83,-127,1,-25,-69, 
  /* [8][0][][] */ 14,-90,7,86,-117,52,9,-112,-90,-69,12,-77,17,-72,-7,58,-127,-66,13,38,-99,-44,15,-34,-106,10,-53,-9,3,-29,-72,-61, 
  /* [9][0][][] */ 109,62,21,-104,-12,-22,57,-6,8,66,38,12,44,19,127,31,-49,-93,105,-105,-107,62,-27,20,-19,33,58,33,95,44,9,20, 
  /* [10][0][][] */ 97,18,39,-61,11,-30,-35,23,-9,117,54,-67,-86,33,-32,-47,25,26,-7,-83,33,91,4,127,26,38,15,-74,-20,-83,0,-8, 
  /* [11][0][][] */ -22,32,19,-61,-35,45,28,54,15,-73,57,82,64,-81,119,33,18,-106,-19,62,107,23,87,10,-127,13,-11,45,3,-80,2,25, 
  /* [12][0][][] */ -10,91,-60,28,-17,0,-61,30,58,-127,27,-18,19,-23,19,5,14,-11,10,-39,-72,12,-14,67,31,76,-55,-26,-46,-15,-43,-96, 
  /* [13][0][][] */ 35,34,-127,3,-22,51,-10,-20,-1,-39,-11,47,-19,48,86,67,-74,-7,3,-58,-55,-11,8,23,7,-27,-17,54,44,57,-43,1, 
  /* [14][0][][] */ -29,105,13,32,-41,65,35,20,-14,29,-59,13,34,43,-32,-11,-48,-19,45,29,-44,-57,28,-45,-82,19,-10,7,127,94,-34,75, 
  /* [15][0][][] */ -85,-113,-61,-29,-4,-89,32,-19,47,-50,89,54,-74,-101,54,-51,28,-88,-6,99,-70,-37,-94,117,112,-57,91,-15,-52,-127,-55,9, 
  /* [16][0][][] */ -17,82,65,0,-63,127,-56,-7,-76,-29,-21,-18,-2,27,-78,0,-50,51,43,-40,22,32,14,-16,-31,37,-8,-10,7,38,-51,1, 
  /* [17][0][][] */ 66,44,-40,23,-127,-53,84,54,54,33,-74,-9,-82,-30,79,-44,-7,45,-48,12,1,49,43,83,17,78,13,-49,22,29,-29,-39, 
  /* [18][0][][] */ 59,112,8,-2,25,-80,10,60,-25,38,-33,-31,33,95,-93,-42,-5,37,-1,127,34,46,-19,43,-45,62,32,-21,44,-59,26,-32, 
  /* [19][0][][] */ -39,60,-37,14,26,0,63,-52,5,-23,119,108,-37,67,-63,4,46,-72,91,-27,-9,-74,87,-73,44,-16,-18,29,72,-54,-60,127, 
  /* [20][0][][] */ 43,-103,0,-15,9,-68,-16,57,-35,36,51,73,-104,-48,34,95,-116,-7,-49,-18,20,41,-69,-127,22,31,31,58,-93,5,-50,-4, 
  /* [21][0][][] */ -8,-21,-45,-25,-83,43,23,36,-62,4,-26,-39,62,22,-26,-45,6,89,10,-52,38,-36,-127,-87,36,16,-37,28,24,-79,107,0, 
  /* [22][0][][] */ -21,-1,-29,-28,-12,-40,-24,-64,-44,-88,96,14,20,-89,-25,43,7,-11,127,-2,-21,54,4,-15,1,-16,36,-67,32,-13,-89,4, 
  /* [23][0][][] */ -86,86,-33,89,62,127,-41,61,25,6,-47,74,28,-2,13,102,29,-107,19,-12,30,-75,-82,-22,27,90,-20,-33,48,-40,-52,39, 
  /* [24][0][][] */ 16,-21,-63,-12,50,50,-45,75,-19,-44,34,14,12,44,-67,-42,-127,18,74,-1,43,67,72,100,39,110,6,4,-24,57,-75,-94, 
  /* [25][0][][] */ -47,68,-1,-13,40,7,64,64,35,-9,20,19,-80,-69,-8,64,3,58,105,-23,45,76,64,-12,-25,127,-6,101,25,-38,-19,50, 
  /* [26][0][][] */ -51,-127,-10,45,55,34,-50,61,55,-26,110,-56,-3,127,12,39,40,19,32,19,-37,-1,-4,-27,-39,-29,-36,-48,-34,-37,16,31, 
  /* [27][0][][] */ -24,-33,-37,16,73,-49,13,28,59,-58,-33,-36,60,-83,0,-6,26,38,-114,-92,33,107,59,17,127,-16,0,-115,-75,-73,6,70, 
  /* [28][0][][] */ -127,-20,-5,39,25,14,15,21,18,-32,102,65,75,-76,-67,-4,-46,-69,-92,32,-13,11,108,71,-42,87,-117,94,100,-37,-92,-112, 
  /* [29][0][][] */ -16,-12,34,-32,-22,10,-10,5,0,-47,76,-18,-78,-7,39,68,-68,23,-54,-127,-8,79,14,105,22,-17,-1,46,-13,1,-10,-108, 
  /* [30][0][][] */ 24,-54,-59,0,85,57,3,-46,26,-55,30,52,-40,-46,46,29,-55,-40,26,83,33,11,-40,-10,35,127,59,-40,6,-26,-31,-8, 
  /* [31][0][][] */ -48,9,6,-30,-51,64,30,27,67,-110,-14,-123,-10,-30,127,-69,-35,-72,7,-46,90,68,11,45,32,28,10,49,-75,-21,-87,-88, 
  /* [32][0][][] */ 59,90,-92,31,-10,34,37,-74,-91,94,27,-21,-99,34,-96,-3,-40,57,-44,72,-33,-62,85,13,-79,-2,-107,-60,100,127,-28,92, 
  /* [33][0][][] */ 51,-44,10,-11,-1,-53,-58,-55,50,24,47,13,17,-71,-127,-15,111,-53,9,42,34,5,-5,-77,16,4,24,-13,-50,-60,-20,-11, 
  /* [34][0][][] */ 0,-92,48,-5,64,46,-34,9,-49,-127,34,47,-98,-2,6,91,18,-96,102,-13,46,98,-69,72,71,-25,14,91,-18,-119,-24,67, 
  /* [35][0][][] */ -40,5,14,-24,-52,-16,25,44,-25,38,8,68,-32,57,2,-20,49,-12,-19,-2,-64,26,-34,48,-127,74,-25,-18,-30,-18,-58,41, 
  /* [36][0][][] */ 10,11,62,-17,25,-126,-76,-10,-101,-61,67,46,45,127,-23,107,-28,-33,-7,94,-15,46,32,19,45,110,76,65,62,-53,-25,-48, 
  /* [37][0][][] */ -73,20,-26,-11,-2,-90,9,-127,-42,3,72,16,75,23,-31,-17,-1,50,1,54,-1,-67,-28,-68,-32,72,76,-83,-42,47,-1,-108, 
  /* [38][0][][] */ 70,71,-63,-38,115,69,-64,68,-73,-23,43,22,-42,75,64,63,5,47,-22,-72,-76,34,72,3,-45,54,39,78,127,14,-48,25, 
  /* [39][0][][] */ 39,110,-40,39,114,36,-38,66,28,14,34,8,85,-10,24,-4,25,36,17,69,-28,39,16,-23,-13,-15,52,18,74,-69,-127,-45, 
  /* [40][0][][] */ 0,-19,-24,-19,21,57,-24,0,25,-18,28,6,10,-16,0,-47,-28,55,-54,24,-13,18,-5,127,60,-4,23,-25,12,14,-10,-48, 
  /* [41][0][][] */ -41,0,-4,-57,61,-18,-16,8,41,56,61,-27,38,-34,-93,57,80,-127,17,43,66,48,12,-12,8,31,-25,24,-54,-9,-8,-31, 
  /* [42][0][][] */ 56,-28,38,80,-12,-2,29,13,-21,7,31,-6,-34,-63,-11,-7,80,63,26,111,71,-37,-127,0,-1,-43,44,-2,-84,-96,54,17, 
  /* [43][0][][] */ 38,-14,16,71,72,8,22,65,64,-39,127,7,96,-1,-6,-35,15,64,32,-32,17,4,-109,-16,-7,16,18,-42,31,-30,-126,12, 
  /* [44][0][][] */ 84,42,2,57,2,42,-101,-21,-24,-25,21,38,-23,91,38,-7,-38,63,21,-26,127,37,-19,101,4,79,7,-77,-1,-44,30,-61, 
  /* [45][0][][] */ 12,75,-8,98,55,118,-44,57,-69,-80,14,9,37,-24,21,-66,49,32,-74,-32,-70,112,-127,-38,48,23,-42,-3,70,-51,39,1, 
  /* [46][0][][] */ 25,59,-35,-86,15,22,-16,-37,27,-19,30,15,-33,56,15,109,97,37,25,30,75,-33,-15,1,102,-127,-2,12,-38,-5,21,-48, 
  /* [47][0][][] */ 108,88,17,-21,19,-34,108,1,-33,7,-9,84,8,64,-25,76,68,2,-45,127,-30,-90,-81,-49,-36,-3,-94,10,-38,36,-28,-14, 
  /* [48][0][][] */ -31,-17,-40,-2,-15,-34,2,-25,5,-7,0,23,40,4,-27,68,76,-38,-78,22,51,8,-88,-16,-44,39,4,-52,-127,-58,21,-36, 
  /* [49][0][][] */ -29,-127,42,38,-80,54,12,6,-20,-14,61,101,-12,82,38,-55,-2,-38,9,-82,51,-8,-50,80,-30,25,-26,-28,14,31,20,-36, 
  /* [50][0][][] */ -87,14,20,-46,31,82,-74,4,-35,-42,-64,29,-43,74,-16,-22,-60,-1,-10,24,-4,1,-5,35,21,48,10,-127,-61,-18,-52,-62, 
  /* [51][0][][] */ 23,-39,44,102,-54,0,4,76,2,-1,-11,-108,18,-11,8,-7,-10,-31,38,28,-67,28,-84,-26,43,127,-54,7,-47,-63,-29,21, 
  /* [52][0][][] */ 8,24,-33,21,35,-68,58,55,91,-17,20,54,-74,-110,-35,-67,127,5,34,-19,-31,-23,34,-7,14,7,46,35,-53,44,-2,-10, 
  /* [53][0][][] */ -29,-53,101,65,-127,5,52,-29,46,-22,-9,-57,84,-14,-61,-10,-105,31,-41,72,11,99,74,-2,14,23,-89,77,-85,-12,-32,-86, 
  /* [54][0][][] */ 82,-32,-8,29,16,18,-11,67,40,-39,27,-61,0,-10,25,80,80,-41,-34,-6,33,28,32,-56,37,2,127,53,104,-13,6,44, 
  /* [55][0][][] */ 69,-36,-85,92,-38,-69,-1,89,34,-93,127,6,65,-71,85,25,-80,-81,30,1,18,22,12,32,98,-29,-65,114,9,10,-63,38, 
  /* [56][0][][] */ 37,7,-36,-43,-18,68,-54,78,88,-1,33,98,53,-43,19,40,-25,-77,109,11,-69,91,46,-77,17,4,127,78,-34,-83,-45,65, 
  /* [57][0][][] */ -23,46,-10,15,-3,11,-89,37,-22,-94,61,-69,-38,37,20,-38,-41,-20,-34,-48,-87,17,51,-56,-5,27,23,23,-127,-32,7,32, 
  /* [58][0][][] */ 42,27,-9,-4,-21,-6,-96,-10,-127,-26,-62,-52,-94,11,5,84,115,-50,-25,-54,-16,33,-24,23,15,10,-10,-43,-21,95,-62,-16, 
  /* [59][0][][] */ -9,-52,-78,13,34,7,38,100,39,-45,46,69,20,27,-116,-18,-7,-4,-105,-127,-32,84,-20,53,34,19,17,7,-5,-42,60,56, 
  /* [60][0][][] */ 96,-50,-127,-78,120,-44,55,-81,30,-88,104,-1,-24,-45,9,37,44,-104,-70,59,-94,28,97,-45,42,-58,-87,49,11,-27,-52,10, 
  /* [61][0][][] */ -39,-127,-30,-6,43,0,34,89,44,-73,-14,63,7,-11,47,18,-43,8,-6,47,-99,-14,34,-35,26,47,50,66,53,-33,-30,12, 
  /* [62][0][][] */ 29,69,2,-37,127,66,46,-26,-20,-67,65,-37,92,-35,-29,-26,31,-43,20,44,41,4,30,30,116,13,7,2,126,53,-38,76, 
  /* [63][0][][] */ 80,72,-52,-59,-33,-13,71,78,28,-2,127,74,-104,0,34,31,40,61,-91,-31,-65,-18,83,22,20,-72,-24,46,80,63,9,24, 
  /* [64][0][][] */ 35,29,39,-26,60,74,-27,2,-65,1,127,-1,13,12,-63,42,7,11,-64,71,32,3,-62,38,-30,27,-100,-70,-51,-45,8,12, 
  /* [65][0][][] */ -44,-22,2,-44,8,104,-3,-15,-127,59,4,1,46,12,125,103,37,24,-33,13,-45,-120,3,-16,28,18,50,-5,-80,56,-25,-53, 
  /* [66][0][][] */ 75,-25,17,-17,19,8,-75,82,-54,25,34,48,-15,4,-52,-70,49,-48,106,-15,-65,-15,-33,-22,127,-2,47,1,16,-5,-37,-28, 
  /* [67][0][][] */ -4,-59,24,43,-73,-44,-5,81,50,-24,-96,-40,64,-40,11,5,-38,-109,31,4,-127,-41,-3,-69,7,45,127,27,-63,-35,-36,51, 
  /* [68][0][][] */ 14,-50,56,17,-83,-2,104,119,-85,16,68,4,-42,102,127,-17,16,48,11,127,-61,-33,14,98,24,-91,69,-89,-36,49,-1,-28, 
  /* [69][0][][] */ 125,55,-25,-4,28,-53,-33,14,5,2,29,25,-62,12,81,-6,127,-18,-79,22,46,-33,7,-66,49,-68,-22,-1,51,52,64,-39, 
  /* [70][0][][] */ -25,18,-2,44,39,40,-12,98,31,5,30,7,2,51,67,-53,11,-127,48,-11,10,72,-43,-11,16,69,73,38,-38,-74,37,43, 
  /* [71][0][][] */ 127,-24,25,-7,58,-36,-18,73,-11,-56,44,-43,-29,18,-37,52,11,-3,83,32,9,70,-8,-89,-17,56,-49,8,-47,-48,-18,20, 
  /* [72][0][][] */ -6,32,-5,-20,84,-17,3,10,-21,-124,10,127,70,66,64,91,-58,-34,19,34,-37,-52,17,-53,-1,53,-23,-126,33,52,-61,82, 
  /* [73][0][][] */ -36,-92,-50,25,5,-8,14,47,-25,-31,79,-5,1,41,41,-51,-11,-36,-14,-65,-46,51,48,-42,-14,-127,71,63,19,3,18,37, 
  /* [74][0][][] */ -79,51,78,-9,-69,-19,38,-39,29,-87,103,18,-29,5,8,127,45,-17,-3,-8,-29,7,50,-70,4,-12,-24,-2,15,-32,-8,16, 
  /* [75][0][][] */ -12,127,-7,-53,-46,22,73,-25,-78,119,-5,-95,56,34,64,80,9,-73,-15,72,30,-21,42,-53,-35,22,-69,36,31,93,27,-88, 
  /* [76][0][][] */ 27,99,-76,14,55,123,30,74,-97,-84,32,42,-25,-7,61,17,-107,-41,6,62,-30,-18,-14,-127,-14,-33,99,47,61,-91,-83,-7, 
  /* [77][0][][] */ -29,15,-18,30,-5,0,-127,48,38,-39,12,66,1,-2,32,11,-31,-42,55,37,-27,50,-32,-29,108,53,19,-12,-82,39,-21,-63, 
  /* [78][0][][] */ 58,-4,15,-22,-10,-15,-17,42,-10,-30,90,-32,-20,-75,45,-1,-10,24,-29,-8,14,4,-53,28,-35,2,24,127,-5,-8,35,-21, 
  /* [79][0][][] */ -23,9,90,-12,-24,-40,36,71,-85,24,43,-35,22,-6,-26,-36,-37,-46,-26,-79,127,6,-70,-42,25,-16,50,-26,-28,-90,-81,-61, 
  /* [80][0][][] */ 86,-35,17,55,38,-4,5,2,49,-29,127,57,20,-32,-53,-69,-27,-69,30,-9,6,28,68,11,-35,33,-20,48,30,-37,-2,29, 
  /* [81][0][][] */ 60,-16,-28,-34,41,-52,-33,-14,-19,-36,65,-62,-24,-26,-126,127,-26,-71,16,-19,11,-50,13,-1,10,62,27,-58,-5,12,53,-60, 
  /* [82][0][][] */ -88,-32,-14,33,40,110,-8,107,-18,-87,127,-79,-64,-17,-33,-101,16,36,-34,2,69,44,59,-87,1,-36,-41,52,73,-100,13,-27, 
  /* [83][0][][] */ -33,43,127,26,35,92,-44,22,27,-110,22,-15,-30,39,45,34,-12,12,45,-12,-53,67,-32,62,-2,17,1,4,-24,33,28,25, 
  /* [84][0][][] */ 127,9,-36,22,26,-19,-24,-75,-14,-1,-4,3,28,46,-45,21,20,6,-55,-22,4,-88,-47,-44,35,12,3,-20,-7,2,-32,-10, 
  /* [85][0][][] */ 13,87,-70,-15,-8,54,33,15,107,-105,60,54,65,-117,42,113,-10,126,-81,-79,32,-54,71,-54,120,-74,48,13,-26,-64,-28,-127, 
  /* [86][0][][] */ 17,-59,-49,20,42,76,13,9,-85,32,37,-127,-35,-43,-53,-77,-71,-64,36,11,-49,49,71,21,-19,-9,86,-8,-14,-37,45,-15, 
  /* [87][0][][] */ -71,13,-29,-1,-29,19,-71,11,20,-43,5,87,27,15,-43,115,-50,-127,60,10,4,-34,97,-38,-15,-37,42,57,-42,12,-9,-38, 
  /* [88][0][][] */ 64,-34,-36,-61,-37,-46,-1,8,-21,-63,0,-127,-74,4,49,-55,-40,-79,4,25,55,-10,11,-97,91,-60,100,55,35,-9,-8,-19, 
  /* [89][0][][] */ 67,-21,-46,9,0,-43,127,-74,-59,-17,28,-17,-23,-9,3,94,-9,0,18,99,81,-56,68,-74,-79,48,-68,65,71,80,-3,-72, 
  /* [90][0][][] */ 19,-2,46,-105,-11,14,-37,-65,59,-74,-45,55,-19,-74,32,91,-12,-127,-45,-92,63,-20,80,-15,43,32,-44,11,-40,42,27,-36, 
  /* [91][0][][] */ -3,90,-68,21,93,-115,-50,-29,-29,39,-15,4,38,9,90,115,48,-109,113,57,61,-127,97,105,-67,0,86,-61,-57,29,-67,-124, 
  /* [92][0][][] */ 126,-57,-14,-15,41,34,91,-48,58,11,55,127,32,-7,-38,112,51,38,8,31,52,95,-4,112,50,81,-49,48,24,50,-33,13, 
  /* [93][0][][] */ 40,-62,34,3,-6,-7,5,-15,19,-28,36,-32,9,-2,25,4,15,-37,-37,18,-4,25,-49,91,77,-10,9,-16,-55,-4,53,-127, 
  /* [94][0][][] */ 0,62,16,-30,-18,34,-68,14,33,-9,-36,29,-25,46,56,46,127,24,-7,-31,62,-11,-13,4,11,-10,9,6,8,15,-33,4, 
  /* [95][0][][] */ 37,56,-18,-61,127,-43,-79,-3,-5,-42,38,79,-57,-3,23,-60,73,4,29,-3,48,39,-2,-11,23,50,36,-27,-8,-6,32,23, 
  /* [96][0][][] */ -22,-46,-32,-68,-73,-32,-77,25,6,-127,120,21,-83,-4,9,74,29,-96,79,13,-61,32,-15,-20,32,85,-74,-28,99,39,15,42, 
  /* [97][0][][] */ -68,106,-127,-45,70,-113,43,54,31,-48,24,83,-14,25,58,7,57,-30,-21,6,79,66,-4,4,120,22,-8,-4,1,5,-7,16, 
  /* [98][0][][] */ 99,-18,-46,48,127,40,41,59,23,25,0,-41,-9,34,88,-4,3,-35,-77,50,26,1,-45,72,38,29,-11,32,-24,-60,16,48, 
  /* [99][0][][] */ 51,20,-127,-27,14,29,-2,31,17,-55,-23,-41,-32,-1,-23,15,-5,-53,53,-45,53,-28,35,10,-12,14,-36,36,22,-7,-29,-23, 
  /* [100][0][][] */ 52,127,-17,-25,76,66,14,8,-9,-28,59,4,-42,71,-44,-21,-89,-21,14,72,98,15,-17,-12,-35,12,-49,89,-51,66,-21,97, 
  /* [101][0][][] */ 87,-29,-10,-38,-14,-79,-21,27,16,54,0,2,-75,-8,111,-54,127,-87,-70,31,36,50,1,-41,-15,58,-14,-54,4,-27,16,-49, 
  /* [102][0][][] */ -3,-18,-23,34,-107,51,-78,43,-53,1,23,78,-3,56,-43,30,127,-42,-66,55,48,9,55,35,-38,-4,-4,45,-11,73,-63,17, 
  /* [103][0][][] */ 42,14,23,-42,22,-64,56,37,38,-48,20,43,21,0,-22,-34,-23,-72,63,-10,24,-48,28,-33,127,44,-84,4,-62,-28,-13,-47, 
  /* [104][0][][] */ 6,-84,101,-64,17,-20,-33,57,13,-127,12,-10,37,-21,-40,31,32,6,-8,-13,37,70,77,-8,57,30,33,-88,-30,-51,-5,36, 
  /* [105][0][][] */ 3,5,16,-51,-57,91,34,39,-4,-36,-18,85,39,-11,29,-2,43,1,-20,11,-48,-127,-17,47,-12,27,76,-106,-14,-16,-10,-55, 
  /* [106][0][][] */ -55,-66,-3,-25,-7,-44,19,92,18,-87,-21,87,-48,-49,34,6,-84,-18,-16,36,-7,127,33,0,12,6,107,75,26,-5,-6,-51, 
  /* [107][0][][] */ 15,101,64,46,46,-1,-22,-111,-31,-10,-60,-65,-39,30,47,55,-82,-96,-68,-25,76,127,95,45,-52,72,-17,104,93,-52,-7,-6, 
  /* [108][0][][] */ 14,28,84,-33,115,88,-53,18,10,-127,14,68,102,13,19,68,-25,52,8,-72,32,-30,24,-6,17,26,-18,111,-86,-29,-48,-50, 
  /* [109][0][][] */ -20,-98,4,-2,-2,0,-32,38,-29,0,39,-31,-127,-4,-90,-34,-94,66,-12,-50,-19,10,31,-9,99,34,-8,57,33,-13,-38,-84, 
  /* [110][0][][] */ 72,44,118,-7,-27,45,2,-3,-44,-106,-108,-6,22,0,81,29,39,-9,24,119,73,7,0,-79,-127,101,69,-67,-68,-13,15,46, 
  /* [111][0][][] */ 24,16,-80,75,46,-33,-5,-8,-39,85,127,60,-45,-90,-24,-15,-78,-41,-18,15,65,-10,12,14,39,8,62,47,43,-35,-16,-111, 
  /* [112][0][][] */ -127,120,126,17,30,-22,46,2,71,-95,88,61,0,20,-58,95,13,2,-27,57,-66,-52,-5,43,11,2,13,12,-41,-25,-23,6, 
  /* [113][0][][] */ 24,59,-127,45,12,10,85,-44,-89,-46,41,-7,43,43,-3,-51,47,-14,26,109,-72,-81,3,27,-74,17,45,51,54,-7,-19,73, 
  /* [114][0][][] */ 35,-26,-40,-127,15,6,-35,-98,45,39,8,-12,28,53,-18,59,-70,-44,30,-91,60,-37,43,-39,46,18,80,-42,-38,10,-3,3, 
  /* [115][0][][] */ -91,-19,79,-82,116,-77,-127,124,10,-43,105,-11,46,58,50,33,-45,-64,62,67,-58,40,80,-41,33,-86,-51,70,55,27,67,-50, 
  /* [116][0][][] */ 41,-24,-30,10,35,64,-3,127,35,6,87,116,14,-41,39,-6,-47,-95,84,-53,-16,63,68,24,-30,-50,113,6,-63,-94,-62,32, 
  /* [117][0][][] */ 33,20,-51,-110,-12,127,-97,-2,114,22,69,-29,-14,10,-79,67,-62,-61,-26,19,-32,1,-24,-21,67,28,113,32,74,-38,29,-8, 
  /* [118][0][][] */ 13,29,27,-47,-12,127,-26,77,-14,-9,15,-4,-93,-28,98,-40,-85,-62,34,-27,-41,42,-14,7,74,23,71,47,62,29,77,-50, 
  /* [119][0][][] */ 93,-113,-81,-19,-69,-108,6,18,-61,1,54,-101,-65,9,56,-127,-1,-118,-49,-85,7,61,64,-49,-48,-58,108,97,54,-92,39,21, 
  /* [120][0][][] */ 19,-6,-14,-4,44,38,-43,4,-78,-112,45,18,-95,72,-74,56,-88,1,-60,-55,13,39,-84,18,127,9,18,33,-3,76,-73,-125, 
  /* [121][0][][] */ 6,2,22,-33,72,101,-34,127,54,-56,-2,-13,39,43,2,-44,56,-26,-47,-88,0,88,-93,-49,-59,-26,33,-4,39,46,87,3, 
  /* [122][0][][] */ 51,70,61,119,-10,126,64,-19,9,-34,-10,-27,42,-63,127,94,52,-37,-71,5,68,-31,-64,66,32,-78,-47,47,20,-13,-13,-48, 
  /* [123][0][][] */ -27,-22,-10,4,-1,-4,3,46,-2,60,-9,13,24,-24,-63,-47,-50,-127,-22,-35,-75,-1,16,-37,85,-50,-8,-62,105,45,-57,-83, 
  /* [124][0][][] */ -9,-18,37,28,-106,10,110,-60,2,26,-8,-2,-41,27,-35,37,-34,22,-1,-3,58,-39,-40,-30,-27,27,-127,-92,7,27,41,-25, 
  /* [125][0][][] */ 25,10,45,-78,-127,-76,-4,-66,28,7,34,31,-20,30,-84,18,-16,-29,35,-18,43,64,107,-2,-20,60,18,-52,-7,-17,0,37, 
  /* [126][0][][] */ -109,119,32,13,86,95,-75,-62,-40,-87,95,-12,-51,-62,-104,-6,-46,-96,-78,-112,69,-52,54,-88,74,-42,66,127,61,-16,-89,-2, 
  /* [127][0][][] */ 8,-84,2,-36,10,-33,-58,47,-19,-37,20,61,-71,-27,92,15,12,-6,-14,-36,114,19,-13,2,50,39,95,-46,-6,-23,26,-127, 
  /* [128][0][][] */ -28,-127,26,23,69,21,-103,-12,62,-36,35,27,23,30,5,-34,-23,-97,0,-44,14,57,-37,-32,31,38,20,88,-46,-25,-10,3, 
  /* [129][0][][] */ 52,-48,0,-127,42,72,39,122,71,-70,59,-22,-34,-78,-76,62,8,-63,58,49,13,-34,-2,31,21,-76,70,-83,-62,-63,-43,55, 
  /* [130][0][][] */ 21,88,107,29,-25,127,110,-83,-87,-8,-39,22,81,39,12,116,-10,10,43,80,66,-48,32,90,-70,102,44,-85,-96,37,19,-41, 
  /* [131][0][][] */ -76,-88,-29,72,-61,75,101,-21,-79,-2,42,-70,11,-45,-104,0,-110,-24,-13,9,-127,-7,15,52,-96,37,-1,12,3,-12,0,-1, 
  /* [132][0][][] */ -15,-39,35,-18,-29,40,-80,4,79,-76,59,-42,9,-22,13,90,45,-30,-67,-49,63,44,127,24,36,87,13,91,-14,13,56,97, 
  /* [133][0][][] */ -54,-18,32,80,29,38,-79,-9,-105,-35,-73,-23,113,37,8,-34,127,8,-102,-54,8,0,-106,72,-126,-67,35,30,46,-76,35,-91, 
  /* [134][0][][] */ 14,-85,26,-29,-60,73,55,92,43,-67,25,63,-17,41,-7,-8,47,-2,-58,-63,60,-43,-38,-17,-127,-4,24,-33,-28,74,-101,-13, 
  /* [135][0][][] */ 74,3,81,26,65,-69,32,-59,-57,-86,98,-16,109,-24,24,6,127,-76,13,8,93,-9,15,-87,0,-79,11,13,-108,-6,-5,44, 
  /* [136][0][][] */ -63,-18,28,60,-43,92,36,-42,16,15,40,18,16,-69,99,-109,68,-43,-10,68,21,57,87,17,-123,-2,127,33,3,-52,95,13, 
  /* [137][0][][] */ -55,39,65,-30,-34,27,25,-19,58,3,25,-5,-31,-30,-52,43,-49,-47,-83,-91,-73,28,127,74,73,87,-67,-4,-1,-47,29,73, 
  /* [138][0][][] */ -17,36,33,0,30,9,55,-48,42,-127,20,41,-5,49,31,86,53,-71,4,-90,-60,-21,10,-24,-75,19,-13,-26,-8,-56,31,-58, 
  /* [139][0][][] */ -6,62,-26,-26,-32,41,-42,-8,-28,-8,39,4,56,127,-113,10,-3,-11,-2,-35,56,-65,-10,104,46,-27,-34,-37,-27,22,2,-90, 
  /* [140][0][][] */ 25,127,-4,10,-36,-17,4,-48,-56,-66,70,-58,-6,-62,-39,56,0,-44,-84,10,3,-36,3,-80,-88,-12,69,55,-43,64,-53,36, 
  /* [141][0][][] */ 16,61,0,-41,102,79,-2,-50,-32,-29,16,127,90,-19,-55,42,95,-78,-69,40,45,-31,-39,-112,-6,-83,20,20,-50,-12,-6,65, 
  /* [142][0][][] */ -81,96,-31,-2,-32,-42,29,4,-79,-56,-35,0,83,-83,39,37,45,-68,-15,-13,11,90,114,27,-21,-16,79,40,19,127,-116,-57, 
  /* [143][0][][] */ 31,-44,-83,-49,127,35,-1,-24,-55,-28,58,-106,-53,-44,32,-8,15,34,-114,46,9,-17,32,4,68,-102,-62,83,104,81,47,-96, 
  /* [144][0][][] */ 40,43,-3,66,-70,33,27,13,39,-22,-1,127,13,38,45,26,41,-42,47,-6,-87,25,20,-7,37,37,82,-47,-84,-56,-55,122, 
  /* [145][0][][] */ 29,49,63,-22,-52,1,57,-55,-21,-26,33,-80,-60,54,-21,-18,8,-43,-1,-64,-42,-70,-110,33,-127,-31,39,-18,-10,-4,87,-47, 
  /* [146][0][][] */ -23,-56,10,-20,-28,18,20,4,105,-77,23,78,5,27,127,-25,31,-90,32,51,-14,82,-1,60,6,6,-70,-5,68,101,24,-22, 
  /* [147][0][][] */ 7,-98,17,-112,-13,33,-55,-58,-49,-59,50,21,20,9,-51,-56,34,20,46,-25,-21,90,81,-26,-29,-24,-127,75,-4,-23,-50,26, 
  /* [148][0][][] */ 39,59,15,-9,95,39,-5,-46,-3,-1,26,127,75,-6,-49,14,77,-48,-29,40,44,-75,-5,-87,34,-78,32,20,-50,-24,-41,66, 
  /* [149][0][][] */ 44,24,-92,14,-19,76,15,2,-50,35,-36,25,15,74,65,8,16,24,-11,-62,-28,-102,74,-112,29,29,127,-60,119,86,32,-10, 
  /* [150][0][][] */ -5,-21,-59,-6,65,-5,-69,-12,46,-54,27,45,-79,8,-42,40,-54,-1,45,-1,-51,-33,-26,44,127,66,5,23,-20,9,-34,10, 
  /* [151][0][][] */ 29,47,14,47,-44,-12,12,74,47,-13,-14,31,-34,39,127,25,-21,26,-98,1,30,-36,11,91,-67,-10,98,16,-30,-5,-17,-10, 
  /* [152][0][][] */ 9,-29,-90,19,-51,-20,-62,49,-26,-25,-17,-15,-18,4,64,14,-13,-34,-18,-35,-38,127,7,13,-27,-14,-56,-29,17,3,27,-23, 
  /* [153][0][][] */ 18,30,-37,39,-42,2,-77,35,6,31,-14,-60,25,44,-105,50,28,2,-46,-77,-103,-127,21,47,50,-32,-4,-33,11,115,-71,-33, 
  /* [154][0][][] */ -57,-29,40,-18,53,4,127,10,-15,39,-23,-27,-47,-91,-95,-64,47,-30,0,16,-8,-68,2,-23,43,93,73,98,9,32,-73,86, 
  /* [155][0][][] */ 75,-30,-54,37,-33,42,27,47,-80,36,24,-33,-23,23,49,-21,94,-89,-127,-63,-6,-103,21,43,28,-50,77,-17,22,68,9,9, 
  /* [156][0][][] */ 3,64,41,10,-17,6,-79,3,-32,24,18,35,24,-3,70,-8,-56,-35,-33,47,6,-1,44,-13,38,127,-85,90,73,3,-43,-62, 
  /* [157][0][][] */ -90,38,-7,-63,82,123,-40,3,17,-77,70,127,49,-76,-11,23,-75,66,-31,43,51,67,18,3,-70,113,-112,24,38,96,-89,-35, 
  /* [158][0][][] */ -89,37,62,-73,27,99,-54,-12,-26,-61,-54,40,-56,77,-18,-13,-53,-29,22,56,-3,32,-1,56,47,61,9,-127,-82,-56,-65,-57, 
  /* [159][0][][] */ -17,-27,-89,-17,17,28,27,-66,10,127,51,90,124,30,54,-1,-11,-22,20,60,34,-102,123,-11,-29,5,10,-16,-101,-64,-114,-119, 
  /* [160][0][][] */ 80,-2,67,-30,-4,-127,11,14,-55,-100,-36,36,45,5,62,-65,100,21,-6,-87,-3,68,-48,-6,73,-50,-38,51,-85,-31,-78,64, 
  /* [161][0][][] */ -12,-32,6,-45,1,3,109,-15,-127,-17,53,-56,-8,23,-46,-10,59,55,-80,28,-53,17,-74,103,-27,42,-58,-19,56,-32,48,-127, 
  /* [162][0][][] */ 6,61,-103,-98,22,50,-101,33,-11,46,53,55,123,-38,7,51,-77,-127,49,78,-6,18,-37,30,20,-2,58,-83,14,6,17,36, 
  /* [163][0][][] */ 46,-44,31,-1,122,6,-107,35,127,-22,127,-8,-40,12,31,18,-90,51,78,12,-15,36,81,-8,22,-14,-12,-47,67,-90,-9,44, 
  /* [164][0][][] */ -46,2,14,-16,11,-41,23,30,-3,-41,-18,69,-9,-51,-127,28,-2,24,11,6,77,-60,-7,47,20,11,-36,-60,-60,-42,-59,-21, 
  /* [165][0][][] */ -5,-25,57,26,-89,54,33,8,-14,51,75,71,-5,-44,49,-52,-39,-49,39,-41,76,127,-1,-74,-112,125,-35,-28,-40,-52,88,-69, 
  /* [166][0][][] */ 0,25,-127,-38,-11,9,-30,-28,47,-22,-20,-2,21,16,-64,26,4,-75,76,79,-20,-62,-10,-71,0,-49,88,13,66,-18,-25,30, 
  /* [167][0][][] */ 0,43,7,46,41,37,83,-46,-21,-65,-13,4,16,-10,36,24,127,35,-36,-20,-9,16,-16,-55,11,26,-12,-46,-32,23,-36,-51, 
  /* [168][0][][] */ -49,-74,124,-37,-27,-21,-42,29,25,-47,30,-37,19,-76,-16,-82,21,-37,6,-68,-36,-4,15,82,-24,58,-30,0,-35,-86,28,-127, 
  /* [169][0][][] */ -90,121,-41,-13,-29,127,38,37,-75,-73,66,48,-21,-27,49,65,-32,-93,-114,-40,-29,38,15,61,30,34,64,61,19,48,-37,-34, 
  /* [170][0][][] */ 11,-75,58,-13,-77,1,41,-13,3,11,49,-127,-85,-105,-65,-6,-26,-52,-5,45,122,66,43,-70,-3,77,-114,-26,-2,4,30,75, 
  /* [171][0][][] */ 49,87,-17,25,-20,71,-27,-34,24,-50,-8,7,37,26,77,36,3,-11,35,-38,-20,-31,-14,-9,66,71,-117,-47,7,-26,-57,-127, 
  /* [172][0][][] */ -127,-84,10,1,-27,35,9,16,-7,-47,-26,59,-17,16,-111,-1,-106,3,126,-29,36,51,-11,73,13,67,36,-63,-50,-35,-65,6, 
  /* [173][0][][] */ -47,127,20,-27,-33,0,19,14,21,-74,-12,83,-29,-52,10,59,-64,-28,-77,15,-69,-47,-21,119,10,39,-10,2,-24,47,33,-66, 
  /* [174][0][][] */ 55,-21,-46,5,-55,118,3,-76,-44,-34,3,-62,-17,10,127,23,24,6,8,16,22,-6,34,-36,-54,-3,42,46,-4,-6,-67,-31, 
  /* [175][0][][] */ -15,56,0,-127,-8,8,16,0,42,-5,72,16,-20,-17,37,9,-88,-34,-9,-22,66,23,98,11,49,43,28,23,-21,39,-13,7, 
  /* [176][0][][] */ 5,114,21,80,52,89,-28,3,-60,10,53,127,35,6,39,109,39,42,53,-83,-6,4,69,14,71,24,4,-71,-31,36,62,86, 
  /* [177][0][][] */ -67,79,-41,-39,115,127,-27,22,43,-41,75,-34,12,-116,107,63,23,-79,-5,-102,-73,-10,-58,13,96,-23,18,9,53,-65,22,-29, 
  /* [178][0][][] */ -17,10,-31,29,37,127,26,-38,59,-7,53,9,41,33,-26,4,70,-13,103,25,5,58,30,84,53,52,-54,-52,65,9,-4,-49, 
  /* [179][0][][] */ -22,-7,21,31,-110,43,12,-20,10,-45,-97,127,62,-3,112,10,59,-28,-27,-60,-70,-87,3,-51,-42,57,35,1,-32,-67,12,21, 
  /* [180][0][][] */ 112,-54,12,25,-48,-94,36,24,-10,40,58,-28,3,-68,12,43,127,-61,-34,7,-15,-9,-28,2,-83,30,3,-96,-21,-29,36,-65, 
  /* [181][0][][] */ 59,30,-87,30,10,75,26,23,-21,107,-11,3,-47,43,-12,-30,-91,-15,8,-2,-96,-42,-72,127,-4,44,12,54,-80,-39,-63,-86, 
  /* [182][0][][] */ 53,9,-66,9,-16,26,40,-23,29,-11,-12,-9,2,19,29,31,56,-84,-76,66,-44,-37,-18,-127,-18,-15,26,93,99,28,2,11, 
  /* [183][0][][] */ -14,-20,127,82,32,-7,98,-31,13,-3,-59,-7,-89,40,-39,-8,79,56,-55,-90,61,8,49,8,26,103,-49,55,-20,-3,-56,-96, 
  /* [184][0][][] */ 127,-91,-3,36,-71,-29,-29,-105,-42,60,-6,-75,-56,69,65,-77,64,37,-96,8,6,23,19,-27,-99,7,22,43,-2,13,55,30, 
  /* [185][0][][] */ 57,26,-53,0,-127,26,79,-22,-25,-47,-38,68,-51,-95,-39,14,15,-19,-116,41,45,-4,-21,11,-2,-37,-28,-57,-13,36,34,7, 
  /* [186][0][][] */ 56,60,82,87,-9,97,114,68,-75,35,0,-31,-32,77,127,-4,-27,-32,-88,2,-37,15,-42,-77,-120,58,19,-28,-45,-53,38,-41, 
  /* [187][0][][] */ -11,-54,-35,-55,67,-29,19,48,-127,-34,28,-55,-18,39,-6,42,59,-48,-65,-92,53,-30,22,31,-109,61,-55,-22,41,31,-49,18, 
  /* [188][0][][] */ 34,28,-29,-17,-35,-25,-16,26,-52,20,6,-11,-44,-28,20,46,-75,-9,-14,12,32,17,-4,-127,36,23,46,47,-54,-11,-53,88, 
  /* [189][0][][] */ -51,-114,-30,13,48,-10,34,121,-10,87,105,-81,119,38,-27,41,12,-79,95,87,87,-14,113,-111,75,51,77,-94,-57,22,-127,-6, 
  /* [190][0][][] */ 117,10,26,-4,13,127,45,-33,-46,-24,-16,-98,22,81,-15,6,43,-18,21,44,-49,-42,28,28,46,-2,-65,-78,61,82,48,-95, 
  /* [191][0][][] */ -112,91,86,-46,127,20,51,15,17,-102,10,64,-3,-28,-79,53,61,87,47,79,39,-43,-48,19,76,31,-96,71,-47,8,-63,-37, 
};
const TfArray<4, int> tensor_dimension69 = { 4, { 192,1,1,32 } };
const TfArray<192, float> quant69_scale = { 192, { 0.0015568842645734549, 0.001662347000092268, 0.0013213030761107802, 0.0019785233307629824, 0.0015036625554785132, 0.0014129081973806024, 0.0015720957890152931, 0.0013511982979252934, 0.0013556891353800893, 0.0015219243941828609, 0.0013998177601024508, 0.0013311245711520314, 0.0017086934531107545, 0.0016047826502472162, 0.0015651109861209989, 0.0012990850955247879, 0.0017247684299945831, 0.0015552545664831996, 0.0015311796450987458, 0.0011199273867532611, 0.0016281680436804891, 0.001710581942461431, 0.0016864163335412741, 0.0011885786661878228, 0.0011614945251494646, 0.0014695314457640052, 0.001921552000567317, 0.0014314826112240553, 0.0013732995139434934, 0.0016195687931030989, 0.0018322853138670325, 0.001289474661462009, 0.0011614873073995113, 0.0016352350357919931, 0.0013320447178557515, 0.0016093393787741661, 0.0014990381896495819, 0.0017147833714261651, 0.0012582729104906321, 0.0011625748593360186, 0.0020949342288076878, 0.0018206423847004771, 0.0013190377503633499, 0.0015725293196737766, 0.0017075741197913885, 0.0014670587843284011, 0.0015243854140862823, 0.0013077892363071442, 0.001876012422144413, 0.0015632834983989596, 0.0013337550917640328, 0.0016900839982554317, 0.001864092075265944, 0.0012191764544695616, 0.0016632394399493933, 0.0013322507729753852, 0.0010015052976086736, 0.0018554999260231853, 0.0016595239285379648, 0.0016165414126589894, 0.0010768990032374859, 0.0017292986158281565, 0.0013708900660276413, 0.001361553673632443, 0.0016760502476245165, 0.0015499870060011744, 0.001766220317222178, 0.0014100362313911319, 0.0012531174579635262, 0.0014462921535596251, 0.001415215665474534, 0.0014179621357470751, 0.0011890913592651486, 0.0015932752285152674, 0.0017007372807711363, 0.0013539638603106141, 0.0010774778202176094, 0.0015364346327260137, 0.0021346937865018845, 0.0019161500968039036, 0.0016795286210253835, 0.001856707502156496, 0.0014781466452404857, 0.0018691401928663254, 0.0021000602282583714, 0.00095171679276973009, 0.0016609501326456666, 0.0014527847524732351, 0.0015547109069302678, 0.001246218103915453, 0.0013735746033489704, 0.0013515393948182464, 0.0013177749933674932, 0.0017586067551746964, 0.0024907297920435667, 0.0017881873063743114, 0.0013196419458836317, 0.0012609419645741582, 0.001640338683500886, 0.0021107145585119724, 0.0016565877012908459, 0.001492426497861743, 0.0014384230598807335, 0.0020331854466348886, 0.0015265552792698145, 0.0015862842556089163, 0.0013798057334497571, 0.0015172861749306321, 0.0016802330501377583, 0.0015868879854679108, 0.0011270629474893212, 0.0015113591216504574, 0.0013617710210382938, 0.0014888948062434793, 0.0016647604061290622, 0.0011048639426007867, 0.0012610167032107711, 0.0014141311403363943, 0.0016694467049092054, 0.0010674893856048584, 0.00120053521823138, 0.0016013385029509664, 0.0014676492428407073, 0.0018600636394694448, 0.0014744075015187263, 0.0016447097295895219, 0.001065252348780632, 0.001766402623616159, 0.0017220998415723443, 0.0013687252067029476, 0.0011007537832483649, 0.0013509473064914346, 0.0015305632259696722, 0.0012277258792892098, 0.0014068897580727935, 0.0013620350509881973, 0.0012023039162158966, 0.0014234478585422039, 0.001778242876753211, 0.0013836660655215383, 0.0015107134822756052, 0.0013526933034881949, 0.0012492381501942873, 0.0010677016107365489, 0.0014292696723714471, 0.001512763206847012, 0.0015538963489234447, 0.0017489130841568112, 0.001425980357453227, 0.0013877401361241937, 0.0016003858763724566, 0.0017289209645241499, 0.0021904825698584318, 0.0012616905150935054, 0.0017025317065417767, 0.0013519880594685674, 0.0019675507210195065, 0.0011808383278548717, 0.0013866795925423503, 0.0014516569208353758, 0.0013932277215644717, 0.0012641979847103357, 0.001241477788425982, 0.001179371727630496, 0.001935928245075047, 0.001314715133048594, 0.0014882934046909213, 0.002267106669023633, 0.0013864735374227166, 0.0012580817565321922, 0.0011642860481515527, 0.0015060965670272708, 0.0011979816481471062, 0.0014833486638963223, 0.0016777877463027835, 0.0018707902636379004, 0.0013194610364735126, 0.0009930694941431284, 0.0016488895053043962, 0.0010728643974289298, 0.0014282825868576765, 0.0014290033141151071, 0.0013384621124714613, 0.0013922238722443581, 0.001008595572784543, 0.0015480609145015478, 0.001240558223798871, 0.0015148665988817811, 0.0017377164913341403, 0.0012739368248730898, 0.0014119663974270225, 0.0013318344717845321, } };
const TfArray<192, int> quant69_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant69 = { (TfLiteFloatArray*)&quant69_scale, (TfLiteIntArray*)&quant69_zero, 0 };
const ALIGN(8) int8_t tensor_data70[56*1*1*192] = { 
  /* [0][0][][] */ 3,-54,72,52,-127,-36,5,0,-41,-14,-6,-21,13,-28,11,-103,48,19,6,81,56,-3,-44,-2,13,43,-5,16,-44,-39,50,0,14,37,39,3,86,46,-54,-43,-27,-34,-54,-87,-53,14,-56,23,10,3,-48,33,0,-46,14,41,4,2,-23,-37,-25,110,-37,1,-21,-21,-30,-4,14,52,26,43,22,-22,31,43,42,-24,-19,-8,85,55,-41,-23,24,8,10,53,52,14,10,-52,22,21,53,3,-21,-43,-63,4,10,44,-15,-23,-29,-12,-33,11,37,22,31,-12,-45,20,19,-19,-5,-14,-1,24,-31,35,12,26,-30,3,-21,24,5,-74,45,-44,3,55,-6,-35,11,-6,-11,73,-40,34,18,30,53,57,1,1,17,28,57,16,-22,9,-5,-14,34,-11,67,3,25,11,-14,4,-16,18,-9,-47,-8,35,-50,10,-54,-14,4,-44,-35,41,24,-3,-33,-20,-2,-6,-44,59,-21,19,6,-72,-13,20, 
  /* [1][0][][] */ 11,-22,11,42,30,-93,27,27,-38,-29,68,5,-11,26,-37,49,51,-27,28,80,53,-5,25,55,-43,67,-30,-33,-41,13,42,-74,-27,-13,-23,-79,-85,29,-46,-22,60,-76,-22,30,-5,-63,52,-22,-40,-86,-57,26,26,-14,2,47,-12,-14,32,-3,-27,-28,-65,-45,-14,-75,-7,1,0,36,36,-20,-9,-4,1,50,25,4,-4,-37,-10,-127,47,-5,10,-48,-12,-34,-1,-78,-22,-40,-18,-38,-14,78,-41,35,-52,-2,74,32,6,43,-40,-42,-15,40,-19,-17,41,6,-52,-5,12,33,37,-34,-32,103,28,0,-20,18,-7,16,18,9,22,22,-79,38,-7,-54,-44,26,19,10,43,-49,-16,34,36,80,-52,-51,-33,-17,5,-2,-50,7,16,66,-26,-26,51,11,61,-44,-13,32,60,31,-15,4,7,67,-33,-52,-44,-17,72,33,-23,36,-12,-11,-10,-4,-20,36,72,-46,-6,-2,-5,-16,-38,-30,109,-16, 
  /* [2][0][][] */ -9,55,-23,81,47,22,17,63,-38,-35,-54,-96,115,51,-23,66,49,51,50,-108,10,16,-62,63,-55,49,-78,-17,13,-18,87,34,25,2,11,-25,50,37,-86,3,126,-28,42,-32,50,-71,-76,89,3,16,51,-38,20,-19,22,15,24,6,-8,54,-73,-4,-80,-16,-16,-26,55,69,-7,-64,-30,-72,-64,127,-1,22,-20,-122,-69,-82,-110,-26,-34,-41,88,-28,1,8,41,33,33,-47,73,-27,0,-1,25,43,9,-73,-81,22,-22,42,-12,-109,-37,43,-51,-23,27,33,33,-100,56,69,44,14,-28,-20,-2,30,-14,-41,7,50,7,1,-41,-87,-6,72,86,34,12,-34,19,-65,3,-57,-62,-34,10,-16,-79,80,-77,-101,-16,66,32,78,-30,-16,-33,26,-28,7,-44,46,-42,25,121,41,-2,70,20,68,-31,-26,49,-13,-58,-52,-3,18,35,92,8,31,90,-44,70,-71,-95,-59,-55,5,33,-17,91,16, 
  /* [3][0][][] */ -5,-26,50,-8,10,97,26,50,20,-37,44,-48,-41,31,3,25,15,25,-5,19,87,2,19,-8,31,-98,84,12,-28,40,7,-11,-42,-32,38,4,45,14,24,14,-74,50,73,-22,-61,-7,-37,-8,22,46,55,70,56,23,-89,-63,-3,-44,22,-25,-65,-91,-40,-122,127,-8,61,52,49,-1,-83,23,58,-11,42,-41,31,-27,-27,-35,-114,63,2,66,-34,98,-45,4,-12,-67,-19,32,-104,-48,-9,21,-48,4,-37,-17,14,34,-82,19,-31,8,16,49,2,-34,-10,8,-26,28,-31,90,-17,-23,40,4,-31,-17,-26,-6,8,-75,17,-31,-20,-27,47,-19,-29,0,22,6,28,33,-2,-10,27,-11,10,0,15,16,29,54,1,-21,-8,-36,-42,59,-74,24,2,-16,-41,2,34,-61,81,-2,92,26,-10,-78,34,-25,15,23,-7,14,-32,93,34,-112,52,-38,-32,-91,51,-48,64,-42,34,67,-50,14,7,-2, 
  /* [4][0][][] */ 26,4,60,-10,-84,3,-28,17,30,5,-34,-41,13,-17,-20,22,-4,42,14,-65,1,-46,29,-72,-6,-22,-21,-48,-12,82,41,47,12,2,12,39,52,-6,-53,-24,-3,-76,-27,63,-23,-28,68,14,-66,43,0,42,-2,-9,-35,-27,-8,30,-6,127,24,-83,9,96,-16,0,36,-10,-18,-38,44,-36,48,-28,-8,-40,75,-7,26,-41,-60,-1,3,-26,-23,0,16,64,40,-50,-31,10,32,-19,-11,35,-64,36,41,-68,-2,34,40,6,3,-74,0,26,7,9,-30,-3,13,14,-30,-53,21,-29,-4,-48,-21,-41,19,15,-17,7,1,-25,-63,-15,-22,22,3,-28,-1,5,-15,-34,19,-77,48,19,-2,-18,-13,19,17,-51,16,6,-8,1,-5,47,-2,40,39,-13,-3,-39,16,51,27,60,7,-36,-11,46,58,30,14,32,-44,-8,16,-17,-27,-75,-73,20,-12,-103,31,1,50,-42,54,-42,-9,-2,0,2, 
  /* [5][0][][] */ -61,0,-18,-16,29,-10,-31,2,3,-3,-16,10,7,37,3,23,-23,28,-15,-102,48,-11,-28,106,37,-6,9,24,-54,-36,31,-4,16,8,-7,10,85,-20,-36,-44,-5,44,-54,-23,-19,0,-23,-75,-47,2,-44,-95,14,43,54,-29,-26,-127,-90,31,-33,-20,-15,74,-25,7,26,-36,39,-34,46,59,14,15,-11,-26,85,-65,36,73,-11,-14,70,35,-75,-3,-19,-5,-33,-31,79,-38,41,-14,49,-46,-13,23,-45,1,10,-4,12,-5,48,35,-45,9,-20,-16,71,-30,58,8,-17,37,12,-38,30,100,-10,14,14,-12,-33,12,48,37,-1,-14,-69,6,17,40,6,-28,-60,35,2,53,-3,-22,-4,21,39,10,-19,-31,-29,16,-46,-1,49,5,-13,-55,-53,2,5,78,-19,42,-4,-2,-66,0,-51,-43,10,-36,34,18,20,-46,-3,-75,19,-121,40,-21,-20,60,-15,-100,-19,-4,-24,-36,5,15,69,-59, 
  /* [6][0][][] */ -9,-57,25,5,-47,20,21,-6,-49,40,9,40,-8,52,1,-18,-23,5,37,16,6,47,-58,16,-36,-76,38,42,65,69,53,-45,15,-27,-83,-53,39,-18,-9,22,-15,38,-77,-7,43,40,-18,21,-127,-33,29,55,-20,4,-6,-100,29,56,9,-64,2,40,45,-43,1,-9,-27,-21,-44,37,8,25,45,38,24,0,-45,21,30,-2,116,59,-33,25,-4,-3,-50,-28,18,14,-10,25,13,29,88,72,-42,-50,23,-97,-63,-53,-60,35,-35,-63,12,-26,46,-1,58,-7,54,-48,-29,88,26,-34,-49,-3,61,-42,-19,-16,-10,37,11,29,-53,-3,-103,52,-82,-52,-27,48,-13,-19,35,-20,-46,76,27,-47,33,-38,-30,16,48,0,-104,-9,-63,-18,58,19,-20,42,-36,28,31,39,31,-56,-22,-29,-15,-4,77,2,1,-5,26,-14,41,18,-1,-5,40,-1,-4,35,-2,-49,-32,41,14,11,56,24,94,-14, 
  /* [7][0][][] */ -56,31,-41,-48,-127,2,-26,-29,-60,-11,3,-59,-63,29,-43,-32,11,7,16,31,21,24,4,-45,53,-84,42,-3,-3,-81,-91,50,-21,1,33,10,-37,-8,46,-53,-4,-49,31,3,-3,-49,26,-78,86,-55,70,-60,24,-43,14,88,-22,11,-88,-69,-10,69,-28,31,-2,20,47,-8,-6,-56,16,16,-56,-45,4,37,-54,-17,6,35,38,-30,24,15,27,-33,18,20,33,18,-16,-50,48,-30,-13,-27,26,35,53,25,-84,27,39,79,64,22,-41,-32,15,-51,12,126,-119,-32,12,9,3,-4,-11,-103,6,1,-36,-60,-5,25,-9,-44,-17,5,36,115,-94,-21,-20,-9,-33,-4,-6,-102,-32,-14,27,-56,-43,-14,7,11,-21,-7,23,-7,-12,44,-45,15,4,27,-31,25,55,-45,-52,-39,51,-95,1,-77,10,47,24,40,-13,71,-4,-3,38,56,-6,-54,-19,13,-28,-41,45,-29,57,-53,1,62,41,72, 
  /* [8][0][][] */ -61,-40,72,-34,-48,14,-31,16,33,17,-19,6,127,12,-48,58,24,-27,45,-10,36,-28,35,93,28,-52,-64,-39,-2,-21,-31,-9,-12,-35,-66,-12,-58,-30,-12,-17,-21,-9,32,-40,-1,4,-44,-25,47,19,-19,-13,-44,-23,80,-98,11,-103,29,74,-54,46,19,14,-46,22,105,-39,5,-5,26,-20,90,1,7,0,-36,-52,-28,53,-16,33,-29,49,-22,-21,-11,30,-48,64,18,-22,13,-28,-14,37,96,43,-56,18,16,1,-4,97,-5,20,-30,-26,-69,-32,25,-35,44,-28,-6,-33,10,10,-27,48,24,-3,-1,-89,10,-11,40,-97,41,40,-25,-5,-88,-43,-25,21,6,26,-55,-14,11,10,-31,31,69,-60,-27,21,25,-24,41,-35,-41,12,-11,9,32,-9,7,0,30,-29,35,73,89,-28,-18,40,-49,-7,13,-33,-57,-32,45,46,-11,-59,-35,-28,4,32,11,24,2,-15,25,-59,2,15,-27,12, 
  /* [9][0][][] */ 5,83,44,31,-9,-47,5,29,0,58,109,-3,35,-31,22,82,-15,39,-2,-46,12,-30,35,-36,-35,49,-1,-15,-31,-39,16,-16,-7,-34,66,55,34,-76,35,5,-127,-9,1,9,-2,-4,-57,73,-38,26,34,-12,-51,-12,-94,18,-4,-25,-15,9,2,22,15,24,33,-8,-40,17,29,-50,20,-29,2,-25,48,-7,-63,31,47,28,19,-22,-51,13,80,27,-15,-34,24,-15,-31,26,-31,7,-18,55,-55,79,-11,28,40,-41,-44,-25,-51,-22,-25,10,-26,24,20,4,-117,7,-2,4,-27,38,-6,18,13,-20,56,12,11,-24,-3,18,-69,24,19,9,-48,-73,16,-15,-4,9,27,0,-77,-6,4,-10,27,-30,-4,59,6,0,40,-13,-37,0,-4,-55,54,13,-5,23,-18,18,-6,-15,13,-4,-20,-2,16,-52,32,-23,-12,65,16,-19,28,28,-57,-11,62,64,28,-43,-69,16,-62,-13,43,-41,23,44, 
  /* [10][0][][] */ -16,-40,-3,-66,68,2,1,73,-15,-15,-56,23,40,27,4,-30,-8,9,31,35,-28,-36,65,-75,5,-29,50,-6,45,-5,-106,-17,11,-38,-1,-55,-29,-9,33,-28,81,-69,-30,8,32,22,-29,46,-26,58,-17,-38,68,-31,37,68,24,31,-65,43,25,18,-20,15,-51,-73,-28,-12,3,-27,-100,18,-11,-68,-46,-23,-34,6,-33,12,13,-53,-34,41,36,-15,9,5,-75,32,11,-49,-30,-17,23,-28,36,-80,-7,-2,54,7,-85,-48,-62,-2,9,-43,-34,-1,-14,-49,18,-27,3,87,28,2,23,127,29,-35,-18,-32,27,4,7,-2,2,-18,49,-7,-46,20,14,37,7,-7,14,-4,19,-3,-34,-21,-64,23,-22,94,3,-27,41,-30,-39,19,-60,-14,1,1,-2,45,-43,11,56,7,40,52,14,-58,14,-34,51,-10,-50,14,-31,-38,38,-3,18,2,-91,-7,-21,-19,-26,3,15,6,-5,41,-35,2, 
  /* [11][0][][] */ -98,-13,28,-50,-3,-55,-56,71,12,-16,16,38,-64,-14,64,-30,-26,-5,-32,-83,33,-2,-19,-3,-3,24,21,33,-9,57,-16,56,-30,47,-54,21,6,12,5,29,-7,49,-50,9,48,66,45,65,2,15,-37,-17,-4,74,-47,-58,-25,13,20,-62,-8,63,-14,33,36,27,82,28,-11,73,-72,54,-51,-25,12,-11,-9,-11,-88,60,-59,-21,7,40,47,-1,14,70,60,-107,7,-39,105,28,16,-5,52,-77,-15,26,1,45,127,3,15,69,28,-127,90,8,5,27,45,-53,-41,71,43,21,-25,7,10,-19,8,-6,19,72,9,-8,66,102,-28,-78,-124,-74,-2,-57,27,52,-51,-52,5,-28,34,-38,49,10,2,24,5,22,19,-26,-35,14,70,29,51,-14,-4,13,-66,-73,23,1,41,-28,-35,9,-5,-35,-11,4,23,-50,64,-45,-8,54,-92,-52,43,24,43,-93,-14,13,-3,16,58,47,-3,-55, 
  /* [12][0][][] */ 45,33,-5,22,-37,-82,-9,-3,75,-8,114,24,-9,4,4,-42,-10,-31,-40,9,-47,-3,127,0,126,109,74,51,56,-10,-46,55,2,-55,12,-88,-12,11,58,-5,-27,17,-13,-52,4,7,16,-7,-62,-28,-17,15,20,23,-44,-38,32,-3,38,0,-40,-28,5,66,30,23,-4,14,49,7,26,44,14,-53,-24,-33,-38,-11,29,-45,35,11,-1,8,-65,5,14,49,13,-12,41,-28,70,-41,-13,-29,16,3,0,4,9,-31,-7,-34,-11,-23,-16,-20,-7,1,-4,-36,-4,-20,-1,10,32,21,-67,77,-18,-16,-52,2,-11,-36,-16,-32,11,35,-26,2,-80,8,-52,-3,-42,27,-42,-22,35,-89,-17,13,-87,11,23,-11,-46,-50,3,-6,32,-4,-76,55,29,-50,36,-80,62,24,83,-13,0,-34,-10,90,-70,72,-30,-9,-53,-5,1,-6,-33,0,107,78,74,-24,29,0,-32,-40,-7,8,10,40,18,-3, 
  /* [13][0][][] */ -15,14,2,15,-1,20,-34,-55,6,-6,63,-38,-2,-5,-33,-1,36,15,-31,-96,-2,1,-46,-47,-7,-28,-67,3,-16,28,-17,-71,19,10,-23,3,-21,64,-1,2,46,54,-9,-28,1,34,50,39,13,-44,-41,-35,-24,-28,44,15,26,57,-6,42,-3,-8,-16,-32,50,19,-50,-13,-21,42,22,42,-69,-47,26,-20,26,7,1,-35,64,36,-9,10,27,-24,-51,-3,9,-112,35,-45,11,-2,-27,58,-6,-17,1,-65,-4,-37,-36,-81,-57,31,-18,-46,-7,-5,-9,67,61,-6,5,-18,39,13,-24,85,14,28,-43,26,34,-11,-15,55,3,43,92,18,57,-51,-7,-78,-8,-6,17,-1,-59,-2,-45,-40,72,-9,45,-8,7,16,-47,-14,-34,3,-47,-41,1,-30,-8,60,16,-15,65,-10,-39,17,-24,73,-33,127,11,1,15,-80,4,72,1,19,-19,0,-94,34,15,-4,22,41,8,-13,8,-4,23,37, 
  /* [14][0][][] */ 15,-2,-39,63,-15,22,18,10,0,-41,-75,-5,10,-54,19,58,18,23,-18,35,-18,21,-34,-15,-12,-80,86,22,31,-42,127,-15,-20,-33,65,26,-61,-47,53,-35,-17,5,-24,-17,-10,-35,0,16,-12,-10,26,89,-3,55,-19,-2,-45,80,6,32,72,30,40,-27,73,-58,-18,-8,-28,11,10,13,39,-52,-38,-27,54,11,-49,34,-70,-20,90,-17,-28,-10,-17,-3,25,-10,69,-67,-110,41,33,37,-2,67,-70,54,-62,39,15,-12,-12,21,18,-62,13,0,-42,-80,-9,58,35,21,-41,-10,-13,-63,1,-92,61,-16,8,-97,-57,21,-15,10,-12,80,24,-8,-14,-28,-16,53,38,49,8,3,-20,-25,15,-70,-2,45,-9,-7,-43,44,2,15,-87,-89,-27,-35,-21,-42,64,48,-47,33,13,-36,-50,25,36,98,58,-45,29,-24,17,-74,52,56,12,-39,73,1,-18,-110,126,37,-105,67,5,61,39,-21, 
  /* [15][0][][] */ -11,-101,24,47,15,52,-24,17,-39,-12,48,-54,45,-1,-1,48,13,12,-45,-75,-9,4,83,-7,-8,-21,-14,-30,-44,54,-28,24,-4,19,-57,9,-7,-34,-34,18,-70,-23,-7,15,-17,-20,29,-50,-53,-25,15,-15,-56,8,53,127,16,29,30,-80,4,-43,41,14,43,1,-29,-1,40,-13,-52,56,77,-5,-32,20,-31,41,-9,42,6,33,-8,-13,36,-53,7,19,-35,-81,-49,77,-20,-5,21,-10,-3,4,-28,25,-40,49,22,75,28,38,20,-16,30,-3,-5,-34,-54,-33,13,14,-10,-24,58,-32,25,48,20,5,-11,-9,34,43,48,63,87,51,41,8,-21,-43,31,-7,41,-12,-55,-57,-24,-49,71,-2,-32,-36,-28,24,-107,-22,31,-18,-26,21,60,42,-54,-34,-17,-2,-8,-24,-20,28,-10,14,0,-18,-37,-61,36,12,10,-26,-2,30,50,18,-14,-19,62,-5,39,25,-2,9,43,1,53,18, 
  /* [16][0][][] */ -4,31,-12,-13,14,38,27,23,-32,19,-14,-77,-75,38,45,50,-52,-16,19,-46,38,13,98,-30,-17,14,-3,-4,-30,23,36,11,7,-9,34,8,-50,39,-45,-6,8,-20,21,19,42,-20,-15,-32,22,45,-23,38,-17,74,40,33,14,-10,24,60,51,14,30,-65,-8,-23,9,-15,38,62,-29,-29,41,-18,-43,-25,5,16,82,0,5,79,13,-22,-69,-11,-34,-77,-40,68,25,-54,5,12,49,-8,9,-66,-31,-16,-17,23,-24,12,-35,40,-12,-8,30,4,13,30,82,-127,1,-51,-8,-7,-10,66,-43,-18,5,-16,4,-24,-22,56,0,88,30,-11,6,58,0,-17,38,-11,25,44,12,-18,0,1,50,49,9,7,-3,16,8,-14,9,-11,45,-28,43,-28,-17,-59,-4,-9,-47,-16,-11,68,-27,0,-81,-36,-17,25,41,-15,30,79,12,-52,-14,-49,-5,35,30,-71,7,9,48,-3,-26,-81,59,-29, 
  /* [17][0][][] */ -75,8,30,73,34,-21,-16,41,35,39,-14,-84,-60,7,46,12,-102,-54,-69,91,-14,-35,40,-33,10,-75,6,2,-5,77,-30,-20,3,28,-17,27,52,3,-22,21,100,-75,0,-24,-31,8,-9,4,24,-30,61,87,16,-35,-39,-15,28,-76,-12,-16,2,83,50,7,2,-13,23,-39,-28,-35,113,-65,99,15,-22,45,16,-57,-16,53,29,-29,60,-80,113,7,-6,43,-4,-19,-9,-43,9,-35,-4,-82,20,-100,-90,7,-38,-10,30,-65,-55,92,52,8,-47,-36,39,-8,8,84,15,9,-22,45,-45,-25,1,15,58,-5,14,-53,3,37,7,51,-86,-82,54,-32,13,-79,-16,-18,-4,-127,-8,5,45,-73,114,46,-22,-2,-10,-46,73,-25,10,38,-97,45,6,26,-38,-60,27,53,57,-55,-26,-7,60,7,21,-39,54,-40,-26,37,-30,40,16,-24,97,-60,25,-76,43,70,25,50,51,-74,-7,30,-10,15, 
  /* [18][0][][] */ -17,-4,42,-14,31,1,-6,-68,12,-45,7,-80,-74,22,38,15,16,1,-25,54,12,3,-50,34,-22,31,-50,-35,25,-73,-30,49,-21,-15,-47,7,29,12,36,-31,-26,23,-70,-69,-22,-65,-4,-47,19,-3,3,31,-12,47,34,-14,-7,-77,-21,43,127,3,101,7,9,-68,-26,10,-24,-43,-17,-36,53,-19,-43,-16,-78,-15,-40,20,-4,24,2,11,5,-27,30,11,47,-15,62,-50,4,60,30,11,-53,40,-52,-37,56,3,-39,-1,-41,-6,16,25,-26,69,-11,-7,-4,-91,-22,15,15,32,12,1,41,-2,-34,-14,3,6,-32,18,35,-34,66,-40,-13,54,-23,-29,2,-7,-33,-114,-27,35,5,-62,56,-7,30,4,7,0,-5,5,49,39,3,18,-16,-15,35,31,-10,-60,64,2,-33,-36,-10,53,-36,-37,36,27,24,15,48,-9,-29,15,39,-38,-25,-16,22,16,-28,19,47,-7,-32,-11,-18,-26, 
  /* [19][0][][] */ -19,61,6,21,28,-42,32,49,12,-10,-93,-12,-80,-105,24,69,33,-6,-19,-51,28,25,40,11,-4,12,-46,21,34,36,44,21,-4,-8,116,-12,18,16,43,52,-88,-64,23,-41,-39,-19,55,31,-45,27,42,-126,24,-51,1,51,24,31,22,-27,-62,54,81,-13,26,83,11,15,14,43,-25,-14,-9,18,-23,-1,69,9,25,41,-64,17,0,-19,24,-29,2,-14,8,25,27,32,-24,78,-70,-37,119,59,8,-65,42,50,41,-103,104,-41,-63,19,-19,-19,-10,10,-55,-14,9,66,46,28,-74,-117,-22,48,-59,-12,12,84,-8,29,62,63,-2,-14,29,27,-31,-27,-17,13,-40,36,-127,23,11,-1,3,3,-51,41,21,-29,-40,-27,-11,21,65,-63,12,-2,-10,-45,-3,-5,28,-51,-6,17,19,-26,29,6,-3,59,3,58,22,33,13,62,6,39,-120,105,-1,19,68,15,-4,-23,25,-65,-24,4, 
  /* [20][0][][] */ -6,38,11,8,57,59,-26,60,-30,16,30,-42,-35,-1,-28,45,67,-28,4,67,-48,15,-29,12,-21,17,59,56,70,37,-47,64,-18,5,-29,39,19,31,43,-2,-2,-35,52,0,45,50,72,9,-27,-4,-8,-10,-4,17,91,1,0,-52,62,9,-20,59,42,59,4,-28,25,-13,48,14,13,-62,28,-15,9,7,-28,35,4,-27,-30,16,-14,22,-52,15,45,88,22,19,48,20,11,17,-66,74,18,20,-14,-13,-29,23,-27,-63,-127,11,49,-18,-8,-31,62,-2,66,43,44,44,31,18,51,-46,63,-24,18,39,-14,-2,38,55,22,-5,-67,124,47,25,-20,36,-30,24,-28,-5,5,67,-9,53,39,27,31,18,37,-17,45,-1,-2,-23,59,10,84,13,-19,9,14,8,-18,45,-6,57,-48,-76,-34,-12,2,80,-11,-49,24,-17,-32,-78,-54,27,-34,39,21,-45,-8,13,-46,21,67,-20,5,-8, 
  /* [21][0][][] */ 71,21,-18,-26,0,15,-21,-25,-28,55,-13,-127,28,-17,-48,-16,20,-36,19,85,57,20,4,35,-55,-16,20,66,0,15,6,-6,13,8,11,13,35,-54,-2,4,15,-11,-65,55,-5,-13,39,-54,-7,17,-2,41,15,-37,53,-9,-28,-12,-24,-44,-36,-32,10,6,-17,-16,23,22,-7,23,-58,41,-25,27,-2,-33,40,-1,-6,-48,-67,41,-4,-5,31,-11,31,-20,-30,-25,25,-28,12,-22,12,7,13,-2,7,13,32,-42,-54,18,-32,-81,11,14,-18,-27,1,-9,74,-25,-7,-43,-57,-19,-21,8,-27,-19,10,45,-2,53,-17,-55,55,-36,-13,-11,-84,-95,-4,-83,74,-8,-25,-47,29,27,-20,3,-10,-18,14,-61,13,-7,57,0,-18,37,4,-64,34,58,22,12,92,32,-115,-38,33,-2,-32,-37,22,26,11,-48,36,-27,-19,-16,37,39,66,64,39,1,-10,19,-32,30,17,-30,-43,38,-32,-33, 
  /* [22][0][][] */ -54,-13,-18,30,-13,-39,-11,54,3,78,-30,-91,61,13,-7,10,73,21,-10,-86,15,33,-68,-4,38,-30,58,-18,-57,80,27,62,-33,2,-127,14,-40,-28,65,10,-17,12,0,-2,6,38,8,57,111,-63,-13,-27,-20,59,-19,-1,-19,52,-34,11,36,-4,-68,54,-6,-46,-36,28,-66,-15,24,42,-28,25,-1,-22,-5,-4,22,-12,85,-2,10,-25,-12,0,-5,-73,-46,44,-16,-57,-53,38,21,87,113,17,-50,23,77,-26,37,50,6,-32,29,31,-81,-15,-18,66,15,-3,-18,127,-7,22,-38,4,13,-23,30,4,10,31,52,19,41,-4,-46,-10,39,-47,-19,48,34,-14,31,-88,20,-70,56,-21,-15,-10,0,-18,-36,20,-12,17,-40,11,-41,-55,-12,-50,58,-36,8,-58,41,-58,-77,21,-12,25,-47,18,9,6,7,-67,14,101,9,-31,-29,-7,4,-75,-32,4,-62,-29,7,13,-56,-41,-37,40, 
  /* [23][0][][] */ 59,-93,-5,33,-34,6,4,-25,-4,18,-24,-43,32,56,-10,30,6,38,65,-46,-65,24,-38,14,-7,3,-11,37,-28,-2,36,10,0,-9,65,-41,0,-33,-22,49,-81,31,-39,-45,22,-23,13,-17,-52,40,-40,-2,19,-5,16,-33,60,4,-8,-87,65,-6,49,22,42,34,28,-71,25,-78,3,-9,2,-13,20,-23,54,-26,82,-76,-63,-12,-26,16,4,6,5,4,-43,-15,-51,-40,-52,-64,-14,-4,-17,-39,30,-6,69,9,50,84,-21,-42,30,13,40,-17,-14,-60,-17,51,-38,15,7,0,-91,127,-20,21,-15,8,39,-113,-43,20,-47,52,21,124,-59,-58,11,2,-10,-25,-87,-27,41,-9,4,-41,48,67,30,17,8,-35,27,32,23,2,19,63,12,-24,91,-11,-33,38,32,22,18,-5,-16,-66,-53,26,7,-49,-73,0,-55,-13,-14,33,1,-2,17,-31,-18,-78,-74,-34,-32,-4,-59,12,-17,5, 
  /* [24][0][][] */ 10,41,46,45,-18,25,-35,0,45,-13,-9,20,-31,1,35,49,-34,-10,-14,49,1,66,8,28,24,-64,13,5,-13,33,94,-115,-34,-20,-26,-5,20,17,2,29,17,-109,-21,-27,-54,94,-50,-20,7,117,-67,42,13,53,41,100,27,7,3,-49,127,-67,94,96,-62,91,-27,17,27,6,98,-9,-6,-29,44,-8,-11,-59,-114,-1,-44,-43,-5,20,-121,-6,49,5,-43,53,-28,11,-27,59,-20,2,40,-76,38,-1,-27,-42,95,-20,-3,-41,25,-72,-61,4,-13,3,-34,-20,22,-26,49,10,45,85,-2,47,8,19,21,-8,-34,-67,-53,-40,32,-94,13,-74,25,4,-16,3,26,-3,-65,-15,10,-22,9,-30,-59,-28,1,12,8,24,-21,-2,-47,-24,10,25,41,31,18,-28,-57,-14,25,-76,-57,-8,-51,23,-30,24,13,3,-32,14,27,-81,-35,-8,39,-63,4,-9,-34,37,-15,48,52,25,61,85, 
  /* [25][0][][] */ -16,4,44,17,-32,106,-23,3,28,-42,12,-95,-113,55,-16,-17,-40,20,47,-27,-31,-24,-15,54,17,62,13,-37,-36,-80,-19,-29,-23,22,60,-17,-101,-1,74,12,-11,17,80,13,59,6,48,-51,-24,12,-24,13,-29,-35,-12,-68,55,-20,6,-21,-58,11,21,-20,-42,50,-56,35,-31,39,55,37,-12,7,8,-35,-43,-14,24,18,-37,-53,80,32,-61,11,-27,72,-11,1,9,22,-99,-3,-11,31,3,5,51,-3,-55,50,1,-44,79,-3,-14,-10,6,-31,75,-21,82,-16,4,33,54,13,-7,83,45,27,-49,52,30,67,-4,-39,-20,-32,-25,-6,69,-31,-10,51,40,4,-5,-88,-20,-2,-49,-76,56,19,-4,15,2,-81,51,114,15,27,22,-45,60,31,63,-8,-37,41,-127,-20,97,7,-18,45,50,-5,-47,112,-22,36,-18,12,30,54,-19,-32,14,-65,67,55,-73,-78,-120,15,12,24,-8,-20, 
  /* [26][0][][] */ 0,-15,63,12,47,-127,49,-35,15,-28,-22,-47,-60,-8,38,23,23,29,39,75,59,62,-33,40,16,-88,101,7,-57,6,-51,70,10,35,22,37,-31,-13,13,-6,39,-27,61,-7,14,-40,1,-38,94,8,-41,36,-8,-50,-64,0,-8,61,17,-43,64,-115,-108,58,-29,60,17,12,85,1,42,-1,-67,-14,-18,-3,79,-11,-57,45,10,-47,-42,-57,-73,-43,-59,-94,-13,43,66,-21,16,39,-15,-7,55,-7,-41,-80,-58,-27,-44,7,2,-13,23,9,3,-20,3,-11,28,-51,32,33,13,-9,-32,-18,-74,-14,8,4,-18,22,17,27,1,-14,7,68,-19,21,21,106,1,27,-58,16,6,53,44,53,-15,4,23,70,33,-27,-45,16,-40,-62,-42,15,32,58,72,22,25,31,-32,8,-2,-2,49,69,13,-8,30,42,3,75,-59,-32,-24,39,-15,36,38,115,4,43,-29,41,53,33,-34,-8,-34,-8, 
  /* [27][0][][] */ 25,-26,-26,16,22,-15,47,-6,-61,45,41,-35,15,41,-41,4,52,70,-16,-17,-65,10,7,61,9,47,25,12,-9,31,-45,-22,59,8,-5,61,-10,-28,-34,19,72,3,-27,-7,9,32,-10,76,-19,87,-15,-29,-24,-37,9,90,-3,-66,-58,-76,7,-127,-17,-5,27,-32,21,16,-14,-3,50,-5,9,6,-14,22,-16,-12,100,4,0,-44,34,-52,4,-38,37,42,86,54,-1,-31,-8,-32,0,-25,-34,-25,-71,-24,29,49,-14,-5,-24,16,71,-30,18,3,18,102,29,20,68,23,10,23,-10,-22,-8,-35,17,20,9,-58,22,-5,-8,57,76,-26,-10,-35,39,48,14,64,-2,-13,12,-6,-12,11,-30,-76,15,-70,5,-3,-55,75,79,81,-25,-75,-41,0,38,-86,1,-26,63,-24,25,-29,23,25,36,10,-39,17,9,-3,25,0,-22,-1,-74,28,-15,-80,-9,0,-16,5,12,-36,-16,20,-39,-38, 
  /* [28][0][][] */ 5,-15,-44,19,80,37,-9,6,24,-42,-22,-66,9,-47,32,49,-25,45,11,-12,38,-21,-13,45,-15,106,42,16,-30,51,47,-21,-28,0,51,-77,8,47,17,-10,-50,44,65,-73,3,3,70,50,-16,-6,35,47,13,17,-18,-48,37,5,-3,-33,78,45,-127,54,42,4,4,-17,-25,-41,-33,97,-1,25,-28,-24,-11,-23,-3,-10,27,-1,7,31,49,11,-22,61,3,39,-74,-19,25,7,-3,-63,-34,-80,-87,19,11,36,-9,16,-54,7,-38,-33,5,9,-23,-97,27,-75,-8,-17,66,-27,8,-92,27,7,-41,-26,-4,-44,-4,10,-82,32,-43,15,14,-13,-12,23,61,-20,32,-46,-6,-55,-11,-32,40,-45,17,26,-27,16,8,-19,-6,17,-67,-8,19,5,6,-38,32,18,-90,-37,-46,19,3,41,54,36,-3,0,-58,5,10,-34,36,-88,-17,-30,-34,27,-34,37,29,42,1,-52,-44,10,50,-32, 
  /* [29][0][][] */ -24,24,-10,5,-20,-51,-17,-13,-14,3,23,17,-14,-12,24,1,30,22,-29,44,-2,15,17,24,21,-119,51,31,-54,18,29,76,45,0,-51,1,-38,31,-127,-3,-53,20,68,30,-56,5,61,-3,-93,28,-30,-42,-47,16,2,-14,-33,-25,10,-28,29,39,-64,-37,3,-62,77,6,-53,-40,-19,37,-78,30,-53,1,23,-35,-19,-33,-10,38,30,-24,-3,-10,10,12,-22,-7,-39,51,33,54,-42,45,22,44,9,19,-50,-39,-6,21,23,-81,16,32,-18,-20,-1,48,34,29,-19,14,-18,7,1,-42,16,-2,-18,-60,-14,1,-16,22,45,21,-11,-9,-19,48,-10,67,-42,27,106,-14,-20,55,35,28,17,9,-34,11,16,58,43,-10,-15,68,43,-23,32,48,111,63,-11,12,-10,-8,5,22,-22,71,-100,14,30,-55,-31,8,-43,-41,9,14,116,-25,-30,-27,-37,24,-79,-69,27,-10,31,-14,-21,-10, 
  /* [30][0][][] */ -13,-50,30,6,85,85,22,7,-73,-37,34,-46,36,-19,-7,-10,24,-30,-49,14,-48,4,26,21,119,-34,-108,0,47,37,-14,24,-20,13,6,43,98,15,46,-13,9,15,-74,22,38,-28,-20,94,-41,-5,-9,34,3,12,-11,66,-24,-23,91,-6,71,-28,35,-15,-26,12,108,25,-17,31,45,36,-35,16,21,23,-30,-28,28,-1,49,-23,-41,14,-15,29,-10,-6,-23,-96,23,-56,3,54,-34,-9,-14,-15,26,19,-8,-14,46,32,-32,-12,16,4,-32,-65,7,29,-15,36,19,-50,3,9,-14,53,-63,49,-36,-36,-5,-86,-18,7,-60,-49,-20,-35,-70,32,3,92,-24,8,-6,-31,3,3,-50,-9,1,-61,45,76,-1,37,-8,19,-6,-20,14,-24,-70,5,38,-49,-94,0,2,17,-40,41,34,62,1,52,-27,7,-43,-17,35,-68,12,-127,18,24,-60,-14,-41,54,19,0,-23,23,13,-38,-67,20, 
  /* [31][0][][] */ 7,13,14,107,-6,-5,-23,-8,-22,18,11,-21,-44,23,-50,85,-24,17,19,98,40,36,52,116,-81,-57,47,30,0,16,-13,1,7,4,76,19,-4,-37,-88,-11,-37,22,21,-18,6,-12,55,36,-13,-26,52,19,-34,19,-41,36,-33,9,-3,46,-39,-57,-13,6,41,14,-26,-14,-21,16,16,-95,30,-21,-15,56,-58,71,-31,-4,63,-24,18,-14,34,23,-59,28,-5,-103,-31,-4,80,-37,20,22,19,-29,-11,58,43,3,-16,54,-17,-25,-18,4,-24,5,-15,95,20,-21,-40,-27,6,-12,-26,127,27,65,31,-18,-35,17,-58,-15,-65,-44,98,-19,89,18,-42,-34,-18,-44,-36,-10,-26,30,34,-42,-85,-78,-7,-12,18,13,-10,-29,-11,16,47,38,-16,-28,-55,-31,50,-57,27,-8,41,9,42,-34,-32,30,2,6,40,-32,17,-36,-21,-9,5,42,-73,-9,8,-6,14,21,-31,-50,51,21,2,-52, 
  /* [32][0][][] */ -7,-34,-80,3,5,-114,43,29,86,71,-20,-27,-19,46,-3,56,98,21,-32,-64,15,22,3,-37,-29,-93,-56,-18,-35,-29,-60,68,19,-51,100,45,18,20,-56,26,-71,30,18,-50,59,36,79,-90,-27,13,-76,28,2,-47,73,-5,-6,15,32,13,0,60,59,-112,67,-39,80,-82,-20,8,29,-20,-13,-54,-26,28,-32,2,-57,20,53,-69,-52,-24,97,84,31,15,-69,-22,34,-62,52,-2,-39,-68,-19,8,102,-96,57,-24,7,-39,110,-7,-46,-21,-102,62,-57,-97,66,36,2,19,2,-14,56,83,44,-32,-15,-49,-26,125,8,87,8,-15,-18,64,-34,-108,-16,19,9,1,-65,24,19,-87,-28,1,-34,-39,-20,-71,-45,6,-15,22,106,-18,25,-5,33,50,127,-121,8,5,-51,11,27,-48,-2,-13,-26,47,-29,0,-9,-22,66,-27,-5,40,39,73,100,0,-12,-4,-49,-50,-14,-39,39,43,21,22, 
  /* [33][0][][] */ 2,-12,-2,-11,17,23,23,-75,-8,-119,-33,-52,85,28,19,107,-46,-5,-40,27,-27,40,-10,-56,-14,7,28,32,13,-41,-34,46,36,5,-84,-52,-31,16,-31,5,0,-36,8,-26,5,-22,0,25,-31,-10,48,-21,-51,-47,-28,26,-10,85,-29,46,19,29,-30,9,-59,-88,116,-6,-1,15,-8,28,31,6,-7,39,65,-53,127,-96,-37,125,19,49,46,-28,-83,18,34,-33,27,21,-27,-7,54,34,20,-17,-4,2,50,-18,83,15,-22,-16,49,24,-118,33,-58,-33,-4,16,-20,-21,5,37,-1,-64,20,81,41,-75,8,34,23,-37,47,50,49,1,94,29,-28,3,-48,-34,-77,28,20,-68,63,40,25,-59,72,-31,-32,11,4,3,54,-10,7,-7,13,27,-36,37,89,10,45,-19,-78,-13,12,57,58,-59,-43,25,64,15,4,-27,55,-23,-9,51,-21,-2,16,102,-26,44,25,5,-22,-8,-41,71, 
  /* [34][0][][] */ -34,8,15,22,35,68,-40,-13,-13,30,-52,-46,27,28,6,-62,-3,26,-2,-41,-48,42,71,-21,40,32,26,9,-63,-35,53,-59,-19,-46,46,-26,-10,-31,16,-13,-23,-48,80,59,-22,39,12,-32,-55,-23,15,-6,-9,21,-83,12,-30,58,-2,3,-79,-30,25,-3,-19,15,-22,-35,-13,8,7,4,-25,23,23,13,-88,-46,32,-1,-14,-14,-127,-39,-52,27,19,-107,49,-8,19,1,92,7,23,19,10,-5,6,-70,59,68,-18,9,-10,5,-20,-54,66,34,-85,-34,7,-11,-1,7,-2,-4,-2,-9,-12,35,-8,20,-30,5,62,-13,-23,3,23,56,36,3,-15,61,-53,36,-60,-67,21,-3,0,-11,47,54,-2,40,-7,8,81,7,4,-63,-33,-24,13,-59,-42,45,-15,-57,6,-17,-23,-28,-32,-9,-43,9,21,-28,-2,0,-38,-29,-40,-41,18,-35,-10,56,8,-41,17,60,26,-13,18,12,-60,-14, 
  /* [35][0][][] */ 51,-22,-90,22,-31,-19,-26,-41,-1,-119,25,15,65,68,-54,53,-45,-99,-13,-18,-11,102,115,-102,-104,36,35,1,32,-45,-41,-5,-85,52,59,24,18,-49,-66,16,90,68,-45,62,0,-58,95,29,64,-41,-36,-45,7,-32,-68,-21,69,112,19,-45,-83,-2,80,-9,-38,-41,1,-53,116,43,73,69,17,-25,-21,-32,95,-69,-52,-10,65,-45,20,-14,25,53,31,28,16,65,44,-2,49,-78,-8,109,35,-34,-83,-102,97,-122,-53,-5,19,-81,-20,-78,4,25,5,-55,-78,46,42,-18,8,-10,21,16,21,7,30,62,33,3,-52,-23,-83,-68,-10,-71,-29,39,-10,68,18,18,-127,11,69,37,-23,-7,25,64,-11,10,35,74,25,-14,-38,-5,63,-46,25,-63,23,16,-78,17,-80,16,-30,15,-6,1,56,-46,-6,26,-25,-41,36,15,11,-62,40,80,-17,-13,-12,-42,23,-26,-80,-42,-43,-22,20,-16, 
  /* [36][0][][] */ -59,-24,42,-7,-59,15,25,-7,-11,-44,31,10,80,44,1,-2,-86,1,41,47,-33,-45,-4,-61,-69,-54,-3,8,11,-8,-10,-18,-38,34,24,17,9,0,71,-12,-49,-71,-6,-56,-68,8,-10,-67,59,18,14,-1,-17,-32,31,-127,0,-95,-21,-40,16,-25,71,22,43,-96,54,33,-2,-15,-51,35,-12,31,-75,-48,-49,25,14,1,71,32,-52,-23,-20,9,-3,0,6,-31,-9,2,-19,-89,9,87,70,-53,24,-31,38,-26,46,-23,-6,63,17,-47,32,-33,11,-54,112,-38,-9,56,13,15,-15,-31,6,12,-3,32,16,-83,-49,-44,-22,12,55,-6,-19,30,12,-4,-50,-42,62,43,-17,-6,29,6,-42,36,-45,26,5,6,-10,-60,12,-16,10,-51,-52,-23,-28,-58,-41,32,-37,-4,-31,8,16,-53,63,27,44,8,29,-74,16,-69,-40,3,28,-8,7,37,77,27,-9,25,-3,-22,8,-119,48,-13, 
  /* [37][0][][] */ 81,-2,-24,38,53,41,-9,49,21,105,41,-12,-46,-25,-93,21,17,26,15,102,9,-55,32,-40,6,13,24,-14,-36,-36,41,62,-14,17,30,-101,12,-15,1,20,-7,83,69,14,-41,-12,-70,53,-31,14,26,-59,-26,6,13,31,-7,-74,-80,85,-31,25,-60,2,-61,34,70,62,11,7,-81,82,-70,-71,-53,-18,65,50,-64,-65,62,-30,-53,24,-46,60,35,-57,28,-69,17,-70,6,-54,-8,-25,61,32,-11,-80,-98,-1,24,67,42,65,24,8,-115,-12,13,-44,-60,50,-42,-48,-2,24,-65,-12,50,-13,-25,-42,16,-17,18,0,-75,42,71,0,57,-4,-18,24,-38,-3,9,-31,70,19,-47,127,3,-15,-56,42,11,-45,-51,16,-16,2,11,-8,2,18,-43,-12,15,-59,9,4,-116,8,-39,-9,52,105,-25,-36,43,6,2,21,-10,-3,0,-75,89,33,-71,-57,39,24,23,14,-39,-20,-17,74, 
  /* [38][0][][] */ 92,26,9,-79,-24,80,8,0,-16,105,-43,76,50,-18,-54,-21,17,13,-27,39,-54,9,-70,-117,-29,68,59,61,-5,-38,-37,-28,56,45,78,19,33,19,54,-19,91,67,44,-46,-17,-46,57,-31,87,6,-14,2,39,-29,31,-47,20,40,28,-41,10,-5,-11,16,-57,-70,55,-74,28,-74,12,-14,-6,15,5,27,-19,-19,-11,11,67,-4,-44,-27,-30,30,-17,69,-16,-47,27,24,14,-29,41,53,-52,5,35,102,-28,7,-34,-11,-33,-59,-12,12,-12,10,-88,-52,50,-75,-13,41,9,30,-92,-7,32,-15,15,-10,19,-13,49,-23,-29,38,27,-13,-58,21,-22,7,3,27,-77,12,-29,-68,6,-50,106,-127,-9,-35,-22,0,-61,-29,-52,-18,-8,-22,6,46,-8,-47,-89,7,18,-85,-6,-21,15,-67,-53,-16,81,16,74,-16,19,-9,19,-40,-22,-8,-35,16,19,-12,64,14,-5,-65,51,-25,-47,-27, 
  /* [39][0][][] */ 44,-29,-63,37,1,46,14,104,-11,-24,-40,64,-9,-15,9,48,-37,15,22,-35,-72,-49,6,-13,25,-52,-39,20,10,-18,-119,5,5,-28,-9,50,35,7,40,-32,-15,5,-61,-56,24,-42,79,-96,-46,-26,48,59,-56,-82,-21,18,-50,37,11,23,16,-39,-53,-19,40,-88,27,8,53,47,-79,-3,-87,0,-53,13,-2,-27,15,-25,13,11,19,-20,-34,-54,-21,-13,-35,-19,-73,13,54,24,-47,-77,-96,51,-126,84,-4,-11,83,64,-10,34,14,85,64,-22,-41,-67,46,21,-58,31,7,35,32,4,-43,2,34,0,-9,105,-37,77,23,-2,8,-29,74,-65,37,-12,-67,-50,-52,-14,40,1,-25,-24,44,11,23,127,-9,-54,108,-26,-5,13,22,-72,-26,70,-23,12,24,-80,8,13,30,-18,5,46,-43,-14,-21,-27,43,34,-70,59,-18,2,58,-11,107,20,40,-52,-25,-31,84,7,38,-6,-39,-92, 
  /* [40][0][][] */ -19,7,67,-35,10,11,-33,31,-2,-34,-54,87,-17,8,-20,0,125,41,-9,-47,10,43,-127,-17,13,-55,17,36,-16,-10,64,-51,-32,10,-44,-50,-40,48,17,71,2,101,-60,111,11,-18,-20,-123,64,36,30,-9,12,-46,105,-35,1,-106,65,-36,-18,-4,94,38,9,-98,5,-19,26,-60,-31,39,-40,-39,15,89,36,5,9,7,39,48,41,57,30,0,12,-5,-16,-30,-24,-86,96,-9,0,9,-62,-104,-52,43,68,8,36,-48,-13,-6,10,-1,9,16,-15,-70,-33,18,5,-26,-25,34,17,-68,-15,-43,-79,-19,19,-38,13,-31,-65,67,-53,35,77,1,17,-33,-45,31,-45,23,37,-1,-6,7,-43,22,-31,-43,5,37,0,-20,94,-39,-47,31,49,-69,-44,-4,-19,-18,-6,-85,-19,-7,-16,8,-30,-27,-39,-15,-12,28,-12,-1,-4,34,63,43,-16,-76,5,17,41,-9,-53,27,28,-18,2,3, 
  /* [41][0][][] */ 39,-75,3,-9,-43,62,0,-33,48,-105,101,-12,35,-13,-19,-23,-76,-2,-6,4,-24,53,-14,21,39,-4,19,2,-49,31,49,-3,45,-60,17,23,11,55,-24,-10,71,4,-8,-70,-35,47,8,34,-70,-5,-11,-60,-3,55,69,-35,-38,20,-7,13,-20,36,23,-44,-74,-3,5,38,34,-31,-52,13,2,26,41,0,28,3,-65,10,-34,4,50,-57,0,-9,17,-50,-31,-20,-25,-19,-42,-15,-57,-30,6,63,17,12,40,9,-42,-1,63,35,1,-46,31,-18,-53,51,12,21,30,84,-27,1,-54,-16,-39,-6,33,13,-7,-60,-2,-35,-8,47,45,-34,50,68,4,13,15,75,0,-22,45,-1,38,-7,-73,38,-2,-54,14,16,40,-34,26,22,62,11,11,24,13,-83,-10,-70,-86,19,-52,68,13,-55,51,-22,-15,-10,-18,31,3,-10,39,-1,-19,-15,25,21,-13,-10,18,66,127,-21,7,89,-25,11, 
  /* [42][0][][] */ -27,42,15,-25,-43,93,-73,-24,-30,-83,100,29,42,61,16,43,55,-34,-18,-56,-8,3,-14,93,31,-9,68,7,27,17,-78,-30,-2,-15,51,71,13,5,-50,-17,-27,124,-109,-72,-6,-13,-17,60,-14,-15,3,34,6,15,-26,5,-55,-39,33,-30,-37,-118,-18,-13,-36,-23,-20,-16,12,45,13,-20,46,-61,-68,-21,-125,-74,102,7,-89,23,62,-27,33,59,-37,-16,5,-3,-1,-65,18,62,-43,-64,65,25,5,37,46,3,91,-57,-30,40,24,11,-85,-26,31,-35,-1,6,55,61,-52,15,12,-59,3,-40,-6,32,3,23,21,-9,-13,6,3,79,52,44,11,28,-34,6,45,-34,12,17,-12,-11,93,-94,-71,6,18,-13,-48,-8,-50,5,57,49,-13,35,-17,-79,-33,-49,-24,55,-84,-26,-75,-9,-22,-46,-47,26,-52,68,-42,9,-5,-56,38,-54,-127,53,6,-85,-11,0,75,36,8,-27,18,14, 
  /* [43][0][][] */ 2,56,7,46,77,-35,-36,-3,12,-18,-49,-44,-15,35,-2,-6,19,-71,-24,-44,3,-52,71,-73,-95,18,19,-10,-28,-80,20,10,-13,-11,23,-67,43,-77,28,-29,29,67,-18,-78,60,1,61,-6,80,-62,-34,93,45,-74,6,5,-1,2,-55,-37,115,74,33,-19,-38,82,-50,-34,78,-29,26,40,-12,5,39,30,-52,3,-25,-49,3,54,-63,31,-38,-27,-41,-32,-27,-4,-25,3,60,-30,3,-27,108,-2,81,40,-6,78,-41,-19,73,58,4,-36,-41,-26,-26,31,27,30,-54,25,-48,31,34,-9,18,-22,-21,23,-13,7,27,-3,-9,33,-37,-11,-5,101,-28,-67,11,-8,58,15,-2,37,50,-46,-59,49,1,-13,-3,30,-66,20,-10,-40,14,-15,-14,5,62,-52,66,23,77,-2,53,19,15,15,-36,-60,-45,-30,-5,-3,30,-50,40,-34,-127,-19,-90,11,-29,-1,50,-11,-58,-56,-15,57,-29,35, 
  /* [44][0][][] */ -2,25,5,7,34,110,-8,-5,28,2,2,-72,29,-1,24,-8,-38,1,-12,-29,-34,-34,5,67,-82,28,11,-36,-10,52,-14,2,2,15,33,-25,-10,4,65,8,-53,58,-29,-45,7,36,-24,99,5,4,72,-23,18,-13,105,8,33,72,9,22,-127,-71,-5,-24,-26,-8,61,-7,-38,41,58,66,-55,-27,31,-10,-26,-35,-88,41,28,9,-58,-11,-78,-8,-12,9,-18,25,51,48,-37,2,-12,-64,-45,-22,-48,62,-19,65,13,-72,-15,-47,23,-19,-7,-35,-59,39,-24,42,-2,9,55,1,-7,40,4,-36,-30,-4,25,16,-1,25,-60,24,29,-27,-64,40,22,22,-22,45,2,81,4,-8,-2,-9,34,41,49,-59,2,-4,23,7,-47,-31,3,40,33,69,-88,-36,76,5,20,-18,20,-14,18,53,-2,-31,-3,-1,19,-27,-21,-94,-63,125,48,18,12,-27,20,5,-17,60,10,-36,-7,43,-41,24, 
  /* [45][0][][] */ 54,33,-71,53,93,86,-14,91,12,-5,-69,4,10,-10,-18,-14,-50,-42,-16,-25,-62,42,-64,80,-62,-77,-62,-21,7,74,72,-47,28,8,35,1,-44,88,-28,-12,6,24,-48,-50,3,-46,30,33,-10,-28,-63,-13,-42,-3,13,0,-43,-30,-22,-23,37,-59,-52,38,45,-1,-6,17,-5,-53,-28,51,51,-6,68,47,9,-19,28,-43,62,19,-21,65,-53,-18,47,-58,42,3,1,-54,59,8,-2,66,37,-53,-13,31,-51,-70,15,-38,32,63,29,-25,-21,48,-25,-23,-36,54,20,-43,-8,-39,36,72,-9,51,8,-2,-44,3,19,-32,6,46,-46,-3,3,59,-24,-110,35,27,-43,-4,-84,92,69,-37,34,4,-42,54,36,33,-16,6,-27,-15,-28,49,-62,-15,87,7,37,38,61,-11,76,-45,-12,-66,52,-19,-41,6,10,-16,-7,-82,-2,52,-48,-5,41,-36,-26,-55,-74,20,83,47,29,-89,-127,-26, 
  /* [46][0][][] */ -7,17,20,23,-15,3,-4,41,25,48,81,-92,27,-65,14,74,22,101,-21,-2,-127,13,75,-14,-25,42,-36,-73,4,71,50,0,74,10,-22,-69,29,-31,-85,19,49,1,13,-38,-92,-39,49,-37,-30,-28,-81,5,13,9,-43,-108,-70,27,-14,83,118,60,27,39,22,35,-33,12,-18,-40,-108,-67,-31,-18,45,22,-45,9,-16,-4,11,-39,73,-1,-8,-57,-67,-44,-10,17,30,-8,-3,-14,78,-5,-91,-34,-116,-34,-101,70,-33,-66,66,3,-43,23,-12,-40,-15,59,43,92,-19,-68,-22,-39,14,-46,-30,80,15,-3,-66,1,7,-29,53,-35,-34,-53,6,21,-49,28,-21,-4,-73,13,5,-46,-76,-35,-53,-95,36,104,-17,-35,-75,55,-33,-2,33,29,59,30,67,66,7,-43,-73,-7,-25,16,-7,79,38,-20,5,56,-78,5,0,5,1,80,-29,59,-10,-17,-24,-52,-49,87,-2,-7,100,-99,-53,45, 
  /* [47][0][][] */ -20,28,10,10,88,-73,-18,40,-43,-4,33,81,78,-8,-11,-40,17,-25,11,14,3,-29,45,75,-22,62,26,-3,23,-31,-3,30,-14,-10,-29,4,34,-15,26,35,-29,-67,26,70,17,-45,2,-54,7,-80,-8,68,4,-22,41,-22,-18,64,-5,-10,-44,-44,14,-24,-8,9,-1,-14,7,-44,-87,-3,27,69,-24,37,24,-38,50,15,11,-4,40,-11,16,-17,14,45,-19,-90,-16,-9,-127,21,-5,13,13,-37,0,-98,-9,-57,-60,-45,25,-15,-21,7,50,27,-62,82,58,-78,37,-24,-19,45,81,8,3,35,-7,-16,-5,27,-47,-47,-11,-16,-63,32,54,55,3,-71,-37,-47,76,-66,20,-14,1,-10,41,-8,50,-43,-6,0,32,-30,44,-45,-6,8,-50,-19,11,-25,-20,-66,27,-73,-24,-31,3,-55,18,-30,-13,-9,-75,40,6,-69,-21,91,-69,-29,49,-64,-18,-29,-92,15,28,-13,-37,3,-50,60, 
  /* [48][0][][] */ 42,-124,32,-19,47,51,-30,-8,13,58,-32,37,-1,-78,-30,-55,58,19,-19,-61,-3,20,107,-22,-66,82,-52,81,-32,-77,-21,8,-5,4,-68,27,-27,30,-18,7,-90,0,45,-1,56,11,10,-11,12,17,69,57,-72,54,-44,15,36,-4,34,-96,-47,103,12,40,-95,-41,55,-1,12,-5,63,-36,-41,72,5,-14,66,45,89,-43,-76,-8,21,-25,-72,-11,-30,-47,4,-96,34,-73,-13,-10,12,-7,46,-91,-3,115,27,-52,-54,60,-11,-60,-40,-51,5,28,35,39,29,-10,43,-39,20,-41,-69,-80,118,18,-65,6,-13,-70,6,18,51,-71,47,-46,-2,24,-10,-45,-36,52,30,-59,-33,-33,-30,-65,-1,34,-3,36,-28,74,-37,-30,-32,127,67,-14,-35,11,-51,-2,-15,26,36,68,-3,-9,15,37,73,-7,25,-2,-16,-16,-16,-14,34,17,51,-10,73,-70,27,40,-18,17,-36,-17,34,-40,62,25, 
  /* [49][0][][] */ -1,-72,40,23,44,-73,-48,16,27,-32,-48,38,72,41,55,-24,-36,20,-8,27,-63,-8,-37,-52,-5,14,-62,-20,-33,16,-58,-18,-47,-2,34,-94,-3,39,-25,26,54,-12,98,-18,44,-23,-65,91,-15,-11,14,-21,-18,44,-90,-10,-37,18,15,2,-87,-65,79,66,11,2,9,8,29,6,3,2,-74,-13,-49,-31,19,24,-20,-18,70,39,72,20,-19,7,-63,-15,1,-30,6,-73,-43,59,52,-6,-15,-12,89,-6,44,16,-18,83,-13,16,-7,-16,-47,-15,-19,54,54,49,57,11,-46,2,-22,33,-23,36,-36,-47,-3,4,-6,22,47,-10,-15,-29,-9,-34,-20,-10,-46,-39,60,15,7,20,24,24,43,17,-26,-34,4,-21,39,-29,-7,-34,-40,15,29,20,-26,-39,30,-46,-127,2,82,21,-57,-30,-52,15,0,-5,-43,-3,4,60,-7,3,44,-35,-63,-5,-34,-60,15,-44,-6,-80,12,-58,31,13, 
  /* [50][0][][] */ 6,18,-27,17,0,1,55,44,7,-20,-60,-26,37,43,62,-48,-20,-12,-20,-20,-8,17,4,44,50,80,37,-6,59,-3,24,37,32,-42,-55,53,-46,10,71,46,-61,-127,-31,21,-17,-20,-25,78,-11,50,39,-23,-17,-7,7,-56,39,15,-45,54,-14,16,-58,-14,31,-71,-56,-24,56,5,-23,66,71,-35,21,-27,-21,26,-75,-68,17,-6,43,-20,-32,45,-36,-61,-6,-4,77,-43,47,1,-37,17,32,-35,70,43,52,-19,87,10,77,34,-20,-1,41,-79,-8,-19,63,100,-17,-80,40,-18,32,126,64,11,25,1,21,-71,70,19,48,47,32,97,-32,-5,34,-33,9,-42,11,-50,-28,2,60,-27,45,-43,-40,-7,8,-19,-72,-40,-17,56,-2,20,-8,-52,-16,69,23,15,-79,-97,44,16,4,55,-24,-45,9,-15,-75,29,14,-25,-49,-65,55,-32,-56,-24,-2,88,1,6,50,8,-20,20,29,-21, 
  /* [51][0][][] */ -30,29,-79,27,52,-23,7,39,-39,12,41,9,-35,-9,26,-95,-28,-3,-10,92,-51,6,8,-51,18,95,-101,-18,-59,27,61,-1,-5,-17,32,44,-14,8,17,23,84,82,9,-76,-32,99,48,52,7,47,4,-44,15,31,-4,-115,13,26,-26,23,-42,-123,33,39,-118,27,4,-41,-23,-35,-3,-16,-43,44,-53,47,37,25,-77,26,14,2,-5,50,-1,4,-28,17,-13,-72,-50,-31,21,-12,-8,32,-37,-49,-71,92,-28,-22,-66,-18,-40,16,34,-83,-57,-63,-49,69,-97,-84,-16,-127,23,23,-14,1,12,76,60,-7,24,59,-11,8,12,69,-15,113,-10,-2,9,-24,-25,-9,106,4,-9,30,21,-41,60,19,28,9,27,-7,3,41,56,-32,24,-57,4,-18,-26,-3,-45,49,28,-15,1,-29,33,-3,115,-83,-19,-2,-46,17,51,45,-13,-34,22,-29,-8,-13,36,10,81,8,-52,-52,-78,41,27,73, 
  /* [52][0][][] */ -35,28,1,-61,19,70,-4,22,-14,-51,59,-31,80,31,12,22,51,45,83,-70,0,-38,-29,43,3,-47,91,42,-32,-83,46,81,26,16,-29,-34,-58,-11,112,33,13,-81,-14,31,10,-37,83,-11,2,-11,-44,-1,-2,18,-7,-57,-4,-30,-5,-44,51,1,-1,10,-93,65,39,4,-4,51,18,-64,66,28,9,-54,-3,-15,12,-38,-21,-1,-59,-31,105,19,-5,-55,2,85,-45,2,-29,42,-32,40,28,-12,31,-8,14,47,43,-7,32,15,-2,15,-26,9,68,27,6,29,6,-120,28,-14,-44,43,40,3,13,45,8,99,27,-35,-23,-14,29,-72,15,4,-3,11,-16,25,36,4,58,-10,-2,-59,38,-101,-2,19,-5,-30,5,-13,28,15,0,24,-31,-8,84,-49,-6,-82,20,-47,65,45,-8,-32,66,-28,-6,-5,-11,13,-9,-18,-61,-24,63,-65,-34,-11,-26,-79,-23,-22,-13,-36,9,-55,127,81, 
  /* [53][0][][] */ -8,1,59,-33,-88,-19,11,-7,-12,59,70,-24,-42,-53,-53,-45,-102,-25,13,35,-44,16,1,106,32,-71,3,-46,-50,-19,30,41,-11,-30,-52,48,-88,40,-26,40,71,-23,14,37,-44,17,-10,-55,42,46,-9,71,33,6,-70,69,35,-2,-13,6,42,-46,1,1,26,-74,-19,15,-35,32,-63,59,33,71,20,-25,46,8,10,-8,27,-42,-15,30,-52,47,-58,34,48,-28,-7,45,-9,-53,65,-109,25,-16,67,75,85,21,-22,-9,73,-85,43,6,-56,17,-30,-41,30,84,-9,-37,50,5,18,-127,-8,25,-39,-19,-12,-11,23,77,46,29,-9,-7,46,35,-3,-30,78,-7,34,-86,-1,-7,3,-31,33,-33,-28,30,-10,54,90,49,21,-40,46,-19,3,21,0,17,-51,12,84,18,-25,2,24,-34,11,26,-48,26,-15,-25,7,-101,7,-32,-1,26,42,95,-42,-72,-75,-97,-9,22,-28,-17,-15,-6, 
  /* [54][0][][] */ -22,52,103,25,-41,60,21,19,-23,-79,-57,74,11,3,-3,47,-51,-13,-8,-48,23,-6,64,-65,-14,-24,-13,3,6,-6,127,-1,-46,19,39,19,9,-10,-19,6,-11,-8,3,-53,13,30,-6,36,80,-23,-2,-42,27,-6,42,-88,-42,5,32,-62,24,9,-28,-56,-36,-55,-89,-18,21,45,-101,46,-23,-38,-91,-36,-3,8,-40,10,44,37,-37,-10,28,32,-42,64,-30,31,16,51,-21,-9,46,30,-46,-38,-32,49,-25,31,29,-93,-75,-42,-85,-8,-101,38,-43,13,65,64,42,-26,2,36,-13,17,24,36,7,25,5,-5,0,18,27,24,51,45,-63,-37,16,43,-25,41,45,-31,56,17,-56,-14,-5,-81,-18,-23,11,54,59,-62,2,72,-1,-41,52,-15,-27,-45,5,2,-9,-3,21,-6,37,55,-59,40,29,17,-18,-61,-27,-11,22,8,16,-23,1,30,10,-51,29,-28,36,-28,5,-27,-31,12, 
  /* [55][0][][] */ -89,22,38,44,-35,-54,-4,5,-10,37,28,-10,54,-7,39,-75,-25,31,11,66,62,11,36,49,-45,-2,-6,-5,-127,-6,-13,-14,59,-26,5,-57,66,5,0,-56,24,-38,-30,-45,-17,20,42,12,-13,-38,120,-91,9,4,100,47,3,9,-31,-33,-62,-12,-44,-19,-12,4,29,26,-3,-80,-21,104,50,45,19,37,39,23,89,13,-53,18,-32,19,60,8,1,1,-15,-16,60,-12,75,-19,-17,35,52,0,-83,7,22,-25,24,-43,39,24,1,-28,15,57,21,-1,7,-55,-11,0,6,-6,3,-15,-35,7,-1,3,-3,-5,27,-23,71,-29,-65,-48,53,8,-7,53,57,79,-3,7,37,56,-70,-13,59,-66,22,27,21,-65,-81,12,-54,-30,-26,49,-8,9,-118,-39,-12,67,-19,20,2,57,-6,58,-43,-1,3,16,45,51,-38,-29,-56,-30,-57,-11,9,-77,-42,22,2,53,-17,27,-53,-26,86,-28, 
};
const TfArray<4, int> tensor_dimension70 = { 4, { 56,1,1,192 } };
const TfArray<56, float> quant70_scale = { 56, { 0.0030702196527272463, 0.0030034903902560472, 0.0023571397177875042, 0.0025187134742736816, 0.0034946158993989229, 0.0030721176881343126, 0.0026368426624685526, 0.0028615137562155724, 0.0029351133853197098, 0.0032482754904776812, 0.0030540640000253916, 0.0026154611259698868, 0.0029974794015288353, 0.0032046709675341845, 0.0022828851360827684, 0.0030066450126469135, 0.0032632357906550169, 0.0026999269612133503, 0.0032982411794364452, 0.0027252365835011005, 0.0026495193596929312, 0.0036771290469914675, 0.0026097903028130531, 0.0029213530942797661, 0.0026602055877447128, 0.0024436102248728275, 0.0024147634394466877, 0.003235100070014596, 0.0032142587006092072, 0.0032245684415102005, 0.0028671084437519312, 0.0031941430643200874, 0.0023999495897442102, 0.0028446957003325224, 0.0035752963740378618, 0.0023871590383350849, 0.002780769020318985, 0.0027897183317691088, 0.0028917731251567602, 0.0025530061684548855, 0.0026312223635613918, 0.002816252876073122, 0.0025907815434038639, 0.0027170190587639809, 0.0030194008722901344, 0.0027040108107030392, 0.0022603429388254881, 0.0027796693611890078, 0.0026717155706137419, 0.0030552491080015898, 0.0025755281094461679, 0.0026657362468540668, 0.0030179647728800774, 0.002993026515468955, 0.0027944135945290327, 0.0024948990903794765, } };
const TfArray<56, int> quant70_zero = { 56, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant70 = { (TfLiteFloatArray*)&quant70_scale, (TfLiteIntArray*)&quant70_zero, 0 };
const ALIGN(8) int8_t tensor_data71[336*1*1*56] = { 
  /* [0][0][][] */ 77,-35,77,2,93,5,43,47,-85,-31,-61,-69,-58,8,-29,88,-35,51,-54,14,8,-69,-20,-78,48,33,62,54,-25,-95,79,127,-29,-56,-90,22,24,-26,29,52,-66,-87,-87,-14,31,-72,-58,45,38,-64,20,-44,121,-76,110,33, 
  /* [1][0][][] */ -77,-41,-29,-38,127,71,18,0,52,-41,27,-17,10,-46,-59,-64,8,32,-23,-42,15,33,-91,16,53,-107,-39,7,63,-51,-67,7,-68,17,12,-13,26,64,37,27,43,44,-17,9,1,39,-57,11,-27,84,-13,-111,-8,57,67,11, 
  /* [2][0][][] */ 19,97,-1,73,-72,70,93,60,-54,-26,1,-63,-34,1,-29,-38,11,-29,16,9,-23,-64,-22,-44,29,-6,27,13,-28,-95,99,106,126,125,68,90,19,-6,-29,-66,-8,-88,-10,-127,15,58,109,-47,20,8,89,33,-35,-6,37,-50, 
  /* [3][0][][] */ 14,-32,-49,-14,-22,46,-45,-16,55,-19,14,70,-110,92,22,-127,7,11,17,-29,-82,-46,29,-78,6,6,-69,-17,39,-18,95,32,-16,-37,-31,-31,-124,-11,46,-28,-48,4,34,-26,59,-35,-13,64,8,-62,-85,-17,-6,24,46,-63, 
  /* [4][0][][] */ -48,8,23,9,-15,76,-1,-46,-44,13,-24,-1,55,81,-8,-19,2,127,-29,-21,-41,-15,-16,38,-27,5,53,45,37,23,39,-10,-93,-6,33,6,-40,30,59,-13,39,15,20,-31,-63,-73,6,73,-21,-62,33,39,5,0,-12,-66, 
  /* [5][0][][] */ 71,-42,-52,-71,9,-36,-62,-54,43,-26,6,-35,17,40,89,-39,-36,-34,-18,16,70,20,-41,95,-3,-58,-83,10,11,-60,16,37,9,-31,-93,6,-78,127,-21,64,-7,23,20,-42,-34,-47,-47,-3,4,-36,34,-32,29,58,80,78, 
  /* [6][0][][] */ -81,78,44,48,-79,-46,-21,-76,-3,-127,111,47,10,22,76,81,-15,26,26,-58,117,62,76,14,33,12,-118,-68,96,-16,-13,100,-20,-126,10,-31,-29,-7,-38,-74,109,-15,-5,88,-122,119,-19,-26,-62,-48,-73,106,-18,-118,111,25, 
  /* [7][0][][] */ -52,16,-73,40,29,30,50,2,23,-49,-2,11,97,-15,-17,63,-42,51,3,20,-46,7,4,44,31,33,127,21,-43,-9,-13,46,-44,4,-69,53,11,102,-12,-78,-8,4,-25,4,-4,-58,60,-10,-33,-51,-20,33,3,44,65,-35, 
  /* [8][0][][] */ 71,-22,60,22,49,-62,22,-7,0,-38,19,41,38,-42,34,47,29,-31,-57,57,-26,-35,-19,-61,46,22,21,3,-83,-18,-14,-31,79,32,1,-36,112,-20,-16,2,13,-54,51,-81,-67,18,-9,-33,-15,-127,26,24,-101,15,-25,11, 
  /* [9][0][][] */ 37,0,42,-19,68,-68,2,-22,-21,11,-98,-80,65,-14,-80,55,5,-26,-25,25,41,-52,12,-23,-27,31,51,-70,-42,11,-89,-36,19,-1,50,-81,55,43,-1,1,-127,64,-6,-10,-13,-22,-57,-82,-20,-26,35,-48,-35,-18,-13,1, 
  /* [10][0][][] */ 86,-8,12,-102,89,-33,-94,87,-35,54,75,7,-10,111,84,-44,73,50,25,53,-23,116,73,57,-52,-14,30,-53,-54,-3,127,7,-28,-34,18,28,38,37,77,-35,89,63,-92,-32,89,42,16,32,12,45,-47,-7,-21,-13,-116,-49, 
  /* [11][0][][] */ 14,-67,69,-22,53,-62,33,15,67,127,43,-1,25,73,30,-24,-1,84,-54,52,-19,-12,43,-76,-12,54,-63,-28,6,-71,69,14,-82,-67,-14,3,-28,17,1,47,-13,57,17,-43,67,-5,12,-41,32,34,-62,26,34,-45,48,-44, 
  /* [12][0][][] */ 22,54,-25,-24,74,6,47,38,-77,14,-6,-42,-4,-28,-33,74,64,-44,14,9,2,-23,-40,-27,76,52,-10,34,22,-38,104,14,-44,45,-28,4,47,56,0,-89,-42,42,-52,-127,36,11,5,59,-118,-56,61,-23,63,-6,-3,-25, 
  /* [13][0][][] */ -19,39,-5,-75,38,53,-64,-17,-70,-30,23,18,-92,44,-127,46,-84,21,-13,116,23,-19,13,-12,93,11,-93,50,42,-38,23,-41,-81,25,36,21,12,14,30,43,1,-34,-82,-53,-90,90,-126,56,-35,5,32,-17,0,-75,-48,37, 
  /* [14][0][][] */ 29,-89,-13,-13,37,5,-87,-36,13,5,-105,-25,-3,-99,-13,38,-88,41,27,-51,101,-90,24,56,-36,-42,-80,-25,-17,6,-127,-54,64,-118,17,-9,37,24,-17,34,-31,2,-95,-6,19,-9,-64,-67,92,-116,61,13,79,-18,34,-3, 
  /* [15][0][][] */ 38,21,-62,-63,36,34,32,48,127,-52,-64,-10,-93,91,52,-39,107,96,-38,-81,6,-72,-70,51,-20,60,44,22,75,-82,-41,-38,66,64,49,25,21,52,-17,12,-14,4,10,-27,-85,-53,33,9,26,-59,97,-41,-7,16,109,-100, 
  /* [16][0][][] */ -78,16,9,-71,-85,7,-24,41,79,-12,-59,25,51,2,-93,89,108,79,-1,-54,-3,-44,-90,-23,124,-64,11,10,36,-29,-7,-21,39,51,95,-37,-83,38,56,-76,-65,64,15,-41,-13,-54,-127,106,-43,18,19,65,-51,-19,-14,-21, 
  /* [17][0][][] */ 40,-41,54,-4,-31,-62,22,-50,-33,-23,-53,-73,63,-44,23,20,40,-43,-71,-33,8,-75,-11,84,-51,-20,78,-21,-54,-51,-5,-5,-43,-22,-81,-2,78,-85,-102,-127,11,-12,0,3,3,6,23,-75,-10,25,-9,8,-22,15,-93,52, 
  /* [18][0][][] */ -49,26,-6,-9,23,19,-82,-1,-9,-15,38,17,-77,16,-17,-18,-60,89,23,-33,44,-87,-17,81,1,-77,12,44,-24,-4,-30,-29,21,7,24,-45,-53,67,31,112,-40,36,123,-13,47,58,-77,49,11,-12,127,14,46,-5,99,-68, 
  /* [19][0][][] */ -8,10,-77,-31,-34,-29,16,-32,29,56,34,-24,127,-35,-19,6,35,79,31,49,93,-80,52,11,10,69,52,107,58,-19,-85,14,127,40,-22,-24,3,-2,65,-90,-24,23,76,11,-25,51,-28,-72,-12,-62,-79,-93,0,27,1,-12, 
  /* [20][0][][] */ -6,9,-33,25,12,-37,-38,56,-37,-54,10,26,-41,22,-119,21,-66,-53,98,-16,113,89,99,-25,-68,16,24,-6,-14,2,-55,-4,-6,29,45,18,19,-29,-54,28,-110,5,-7,4,31,2,59,-18,11,-57,-54,78,-3,34,127,-4, 
  /* [21][0][][] */ -23,3,35,-68,29,63,52,87,-5,-127,-80,62,105,17,-79,23,-92,17,-45,46,91,-5,-45,58,18,-25,-30,106,-26,-85,-4,45,-32,52,-5,75,-63,-21,-22,-28,-25,-63,8,91,-74,-24,30,-63,16,32,60,-100,113,18,32,114, 
  /* [22][0][][] */ 41,58,-54,-3,30,-63,-48,-52,-17,-11,-62,-61,37,-11,30,-50,-23,-1,19,18,-30,127,20,3,-56,73,-28,-47,51,87,7,-23,-80,-124,80,-53,52,12,-43,-67,-21,29,32,48,20,-3,-34,65,-51,-39,-41,-18,19,-14,2,80, 
  /* [23][0][][] */ 41,-58,4,69,9,20,37,4,43,-52,-26,37,43,107,18,-69,127,39,20,42,-61,-3,84,20,78,104,14,-68,-67,-13,20,17,-92,31,-68,-10,-18,-14,28,29,-27,-8,-20,53,-27,-6,20,123,35,47,63,70,56,-67,-16,-53, 
  /* [24][0][][] */ 21,13,81,52,-54,77,-8,-26,7,-10,39,98,127,9,-9,-54,64,8,3,16,-32,29,-38,-109,31,-6,-78,53,42,-100,-30,10,-98,25,86,-32,2,8,31,42,-47,-34,-22,19,-30,54,-8,29,9,54,-24,-44,26,108,36,-114, 
  /* [25][0][][] */ 80,79,-32,-22,-73,-10,122,-13,66,16,-48,-47,-5,-34,29,-30,-40,28,116,-41,69,55,-8,-54,-92,37,104,-10,-29,47,-23,70,21,34,39,6,83,62,-45,43,-127,32,-13,-55,20,25,15,-51,-48,30,102,46,25,4,-55,-32, 
  /* [26][0][][] */ 31,-5,-47,17,53,39,92,60,3,-4,61,-8,-100,0,-59,-69,120,-1,-53,-40,-65,-5,68,-37,3,55,-23,-28,28,26,60,53,11,-31,71,72,17,50,23,-22,81,41,11,-43,33,-42,-8,41,45,-5,29,19,-46,-27,4,-127, 
  /* [27][0][][] */ 75,-43,-7,-10,80,-19,21,-15,36,34,38,-31,48,27,-15,22,-16,-18,-81,-63,-22,37,56,40,30,15,-77,65,-51,43,-32,72,18,-60,-42,61,-34,38,-42,34,2,-18,44,9,-101,33,28,16,3,44,-127,43,17,-2,23,47, 
  /* [28][0][][] */ 16,13,11,45,8,-10,-37,127,27,-19,55,-15,24,50,-44,26,44,46,-4,-28,7,-105,71,10,11,26,-48,29,-55,-58,19,107,-14,86,-22,-5,-46,30,56,19,-19,28,-56,-81,33,-14,67,30,-21,-17,-54,49,-10,11,-17,-20, 
  /* [29][0][][] */ -45,-19,36,2,-5,-7,21,-10,10,27,-32,13,84,-51,-31,-30,28,26,-71,-20,-69,54,-46,-53,40,-23,42,63,65,-56,95,-19,-19,34,-42,7,39,-58,30,-59,35,-38,65,-8,6,-3,50,57,-127,-107,-113,36,-40,-12,1,100, 
  /* [30][0][][] */ 72,103,-66,40,-42,-85,14,107,-35,52,-57,24,9,26,62,-14,42,74,12,2,24,-30,21,41,92,24,-12,-39,-38,11,28,-29,-13,-26,-67,-61,94,-8,51,127,-47,-30,18,23,89,-7,-28,33,-94,25,-43,-93,12,-37,17,53, 
  /* [31][0][][] */ 43,-103,54,104,3,-17,9,-7,-12,8,-9,81,19,18,-51,80,21,56,-4,8,2,-102,50,-36,124,-12,-47,-57,47,-73,0,-5,-23,22,7,-94,-60,73,31,53,-127,-8,-67,16,-55,24,61,6,-6,81,48,-9,-19,-38,-26,50, 
  /* [32][0][][] */ 60,-70,1,-29,-7,-45,15,54,42,-58,3,-70,4,-70,77,-13,35,-66,-15,4,-41,-110,62,-1,81,70,-48,-43,38,-44,-21,64,23,-127,11,53,-13,83,-3,73,1,-9,78,-47,-123,-90,-26,64,-3,19,70,57,-94,51,19,36, 
  /* [33][0][][] */ -72,44,-19,82,-30,33,-127,-49,12,-31,-26,-39,98,-1,-47,-5,15,-38,4,91,22,57,42,-10,71,-75,13,-35,5,34,-7,-19,-53,-88,-57,10,29,-80,39,10,56,-56,-39,-19,-120,101,-23,-20,6,-79,91,-80,-122,-108,22,-58, 
  /* [34][0][][] */ -10,11,-47,-15,-33,55,-7,27,-62,4,-21,5,-64,53,-78,-93,5,-4,48,30,19,-21,-58,5,-14,32,127,19,34,-46,73,-32,56,-14,8,15,-28,-67,-30,-83,47,40,70,-16,87,0,5,-14,-14,38,-6,-9,70,83,-29,26, 
  /* [35][0][][] */ -28,60,19,-70,3,24,127,1,26,20,-16,4,27,-43,-23,23,31,35,15,39,-57,25,-2,-35,52,15,-37,84,94,1,34,-13,-55,78,-30,-7,-44,24,39,-21,72,25,-60,-34,-50,38,5,90,-67,15,-1,-20,19,-3,-32,20, 
  /* [36][0][][] */ -12,54,38,-6,1,2,17,-45,88,127,112,-6,-28,-22,80,5,44,-13,66,-59,-13,-19,-61,-52,-11,-2,59,6,5,13,48,55,-11,-14,66,9,-13,-31,-63,27,8,5,-111,55,-2,-17,33,50,30,-45,-57,52,-39,32,40,-48, 
  /* [37][0][][] */ 39,114,-28,18,-52,33,8,-62,-53,29,11,-4,-46,11,-9,-40,-118,53,-48,39,-67,-24,11,20,72,-48,-20,3,29,16,-15,-21,-68,-83,-53,16,31,-9,64,17,-30,-73,-127,-3,40,4,-102,43,-65,43,-3,85,-18,16,40,-7, 
  /* [38][0][][] */ 36,-7,-7,-4,-16,-13,-33,55,-40,59,127,74,27,10,17,15,23,63,45,-60,-112,-66,5,39,45,-42,13,29,-5,-1,-24,-88,-96,-5,-2,-92,60,79,-35,-44,-27,-57,66,-32,-72,32,64,47,-75,-58,36,35,-11,-83,-75,21, 
  /* [39][0][][] */ -31,-61,-25,3,77,-3,7,17,-68,-83,7,-15,-28,76,-37,-56,-50,-5,10,10,-48,-13,-86,60,-85,-9,-4,-48,-21,-17,-14,-9,-91,19,-17,-20,62,-25,-3,-127,-49,0,73,-9,-66,-7,0,-62,25,51,29,-55,28,75,-2,25, 
  /* [40][0][][] */ -127,-117,10,-46,-30,2,-15,-7,-35,52,-10,-11,38,-55,-38,-35,-34,39,24,-12,17,-78,66,48,-26,-6,56,-52,0,18,28,17,19,8,-63,-11,-4,-47,-37,-68,-10,67,-13,-43,-29,50,-37,-7,-18,78,-1,-53,49,4,43,107, 
  /* [41][0][][] */ -9,-10,26,26,20,23,-59,-122,50,-127,-37,63,17,5,28,-39,-33,-28,15,-41,-5,67,40,27,-11,7,10,-11,0,-4,19,31,-27,-32,8,-10,68,-52,-16,24,-27,-60,-47,11,-17,-11,6,41,39,-10,85,-63,43,-8,-50,-18, 
  /* [42][0][][] */ 127,-8,56,68,-27,-72,-30,-94,-31,-4,32,-68,-95,-70,36,32,85,-48,-97,78,19,-77,12,14,17,-33,93,10,-65,4,-31,-46,76,26,-42,-31,18,-17,-68,-78,42,8,-12,-54,-2,16,-18,-36,28,-52,-15,78,5,-65,-26,-64, 
  /* [43][0][][] */ 42,3,25,1,-20,-70,127,-8,10,31,43,-34,55,27,41,-11,68,-34,1,66,-63,12,96,-14,-4,81,-17,-15,65,-22,7,114,-19,-38,11,-1,-69,32,100,40,42,111,-58,-70,-57,22,21,34,-13,-18,41,-10,19,42,-62,56, 
  /* [44][0][][] */ -114,23,39,-103,8,55,26,38,36,-5,-1,-47,53,-107,-105,16,-16,52,60,8,8,23,30,90,-70,-57,-16,-8,9,-45,30,100,-127,-50,-36,-18,-84,46,14,-40,114,15,-36,44,1,38,48,7,-20,10,-31,-57,13,-4,29,101, 
  /* [45][0][][] */ -26,-37,-97,61,-127,-6,61,-24,-27,55,40,16,-7,4,-9,23,-51,70,-71,6,-22,54,5,35,45,44,-18,-11,11,11,-16,42,4,37,23,-32,-8,-10,-27,-8,-53,-46,64,-6,29,-45,-32,-33,-20,-14,-62,43,23,-48,36,-47, 
  /* [46][0][][] */ 19,29,14,-45,7,29,-111,-14,4,12,34,-7,-26,-24,13,10,-127,4,-14,29,41,53,41,-45,-8,-106,-59,-34,-32,-26,44,-19,-18,-49,-3,-46,-8,123,-24,-16,19,-63,88,-41,-36,-108,-65,-53,22,-58,41,-23,22,77,7,52, 
  /* [47][0][][] */ 127,-28,13,-41,34,21,12,20,-30,-75,95,18,45,13,107,25,37,-34,-76,58,8,-8,21,18,11,-38,-10,-29,118,-42,84,59,7,-2,30,25,-13,-27,-44,24,-44,-59,18,11,-29,-41,30,-21,-6,60,12,-78,26,-7,14,-38, 
  /* [48][0][][] */ -43,-36,29,-9,76,-87,-66,-8,37,47,-9,41,23,-25,35,-33,77,-34,-37,-1,-88,89,88,42,-34,-13,57,-11,-26,-117,62,127,14,-9,30,-2,84,15,22,52,74,82,39,33,-6,29,23,-65,-51,27,-62,-70,-3,-3,-34,-91, 
  /* [49][0][][] */ -4,13,-18,-113,-54,3,24,42,-53,35,-9,35,-23,-20,-33,-38,1,-21,-58,-108,52,-127,59,31,46,-50,-75,-34,-14,28,-8,19,63,15,-61,4,-8,57,-20,49,5,29,-37,-55,20,39,-49,26,20,4,-25,-46,68,-69,39,0, 
  /* [50][0][][] */ -1,8,44,-127,62,31,-44,-1,-19,-3,-10,8,-36,96,110,-95,-8,-24,68,45,-33,-20,-104,-44,-61,51,70,-54,-84,-19,43,-62,-43,-81,-26,-38,108,-19,-94,-9,15,38,51,-98,121,-37,-77,1,-3,45,37,-106,62,68,-4,39, 
  /* [51][0][][] */ 34,-40,27,-5,-31,23,-70,75,-101,-58,53,-53,-20,-23,-31,44,38,-10,-127,8,-46,11,-3,82,-9,58,-92,-24,-7,-72,22,-64,-32,92,32,-93,-17,-55,-28,-47,-33,-33,120,-35,23,94,43,1,24,-9,110,-96,47,40,41,60, 
  /* [52][0][][] */ 38,-48,27,-13,-96,-85,-32,23,-13,28,0,-26,83,41,61,-121,32,53,-11,36,-62,-78,96,58,-52,33,41,10,-21,38,-4,-3,-41,-45,-74,23,-39,0,103,44,5,-43,-127,50,16,-74,-54,-3,59,-9,-7,20,-19,28,20,42, 
  /* [53][0][][] */ 33,-4,56,-49,-85,-10,68,101,1,117,-25,-32,77,-31,-127,-34,54,-22,-5,54,-22,-49,-6,57,63,40,-8,26,-79,-45,-62,-22,35,122,-45,9,-79,25,6,-41,-38,58,54,36,124,-23,55,0,8,66,-43,59,-9,-23,21,0, 
  /* [54][0][][] */ 127,5,57,-8,68,-39,-1,2,-6,97,-1,95,-4,-52,16,-34,-41,-37,-18,-9,-74,-31,7,18,-17,60,-7,32,-98,-5,-26,-70,19,33,-68,17,34,-70,-91,71,11,-59,83,5,85,42,-40,-61,45,0,-10,-47,-45,55,-32,-12, 
  /* [55][0][][] */ -14,-72,23,-24,15,-10,14,54,51,-6,2,27,-81,-12,20,-11,-15,127,27,-33,-29,39,38,54,3,51,27,-26,-29,-18,88,-21,-22,-32,64,-40,13,-19,-56,25,26,17,36,-47,30,52,-7,11,-13,30,-22,-10,-72,-30,73,22, 
  /* [56][0][][] */ 81,-34,24,-9,10,-71,30,-10,-44,63,-18,43,30,-21,-22,-11,-17,80,-18,30,-2,42,-41,0,-7,-37,10,27,-50,-19,-127,-1,36,68,-59,0,27,-36,6,-29,-68,-53,20,-14,23,14,18,-26,26,16,21,-8,-67,-23,-44,44, 
  /* [57][0][][] */ -46,-54,66,-24,29,28,44,38,29,-3,-115,102,127,61,48,57,99,-43,-17,25,-73,37,-23,-31,31,-31,51,67,13,-48,18,35,60,-38,91,-46,65,37,68,-16,-48,-35,-73,96,-1,-53,-68,35,82,-57,-46,-35,-65,71,-3,40, 
  /* [58][0][][] */ -47,76,-26,6,-5,19,-3,23,56,-35,-31,-9,18,16,-23,-10,127,-3,-20,85,-38,-43,36,63,-51,-18,-41,-23,-27,1,-34,12,-102,34,-30,7,-10,20,100,-113,70,62,20,-29,-52,12,-63,-36,-22,-1,95,0,13,-5,-83,-24, 
  /* [59][0][][] */ 8,30,12,-14,-12,40,53,47,-34,22,-24,62,49,-2,-50,-4,61,21,-46,-32,-7,37,16,-42,5,-21,14,-34,29,-23,127,115,11,-2,-43,17,-18,-34,-8,12,-12,42,77,-36,42,-8,14,43,-7,29,-15,38,-55,23,28,7, 
  /* [60][0][][] */ -127,-67,70,30,47,43,1,23,-22,-32,3,-30,-7,35,-12,77,-1,6,-28,-63,-28,54,-3,-7,2,13,-4,-3,-36,-50,27,35,-83,15,-52,48,33,-44,32,-26,34,1,-29,-36,37,14,4,8,-37,-63,-7,47,12,75,-32,85, 
  /* [61][0][][] */ 14,29,42,82,29,42,-43,28,47,-39,-81,52,-37,77,-78,-14,-71,-9,46,-127,-11,29,6,-96,39,111,-41,5,64,84,13,2,-52,-20,29,35,-5,27,88,67,21,-34,-59,-19,-24,-70,-32,61,65,17,-81,-10,0,61,-33,-89, 
  /* [62][0][][] */ 6,50,-2,-20,3,16,65,120,19,-113,-16,4,80,-8,-44,2,82,54,-11,52,28,-47,-72,69,26,2,57,18,42,96,-29,-13,-46,1,47,57,41,127,68,-30,37,-47,16,-78,24,-29,-29,44,-55,22,-5,4,47,16,-112,71, 
  /* [63][0][][] */ -127,12,100,64,-48,-85,22,-35,-70,-27,-8,-27,21,-46,20,-1,-52,32,82,-26,-21,-35,-103,-78,7,-37,1,-29,66,-82,-26,-42,43,-94,-90,-72,31,20,113,32,-42,39,-58,89,7,-29,-12,-7,2,53,-24,-61,-44,23,2,88, 
  /* [64][0][][] */ -31,41,-82,-127,31,-32,-118,-71,-26,-24,75,22,-42,-66,37,-78,-65,70,14,92,74,-32,63,59,76,18,19,20,38,21,-4,-29,35,-8,-92,5,18,44,10,74,79,10,21,-33,117,-53,-47,-5,-31,-95,-9,-11,58,-110,32,71, 
  /* [65][0][][] */ 110,-62,-127,27,-30,72,9,22,31,12,-55,58,-16,-73,-10,123,13,14,63,69,-18,92,71,-46,62,1,-15,-77,22,11,58,44,-14,-9,35,-78,13,4,27,-19,30,-2,8,-10,-67,-30,-8,29,39,-17,57,56,118,90,38,33, 
  /* [66][0][][] */ -26,41,39,44,41,32,-10,18,-99,-41,-119,21,-35,-60,58,-15,-84,-21,19,32,81,12,-84,-11,-8,-19,-37,-39,71,51,-43,-127,29,-64,67,20,14,-85,-32,55,-63,-88,-32,76,-119,19,-70,7,12,-13,42,-57,5,46,1,42, 
  /* [67][0][][] */ 20,14,-53,7,38,-14,75,13,-11,-31,-45,42,-71,-71,-114,55,-31,-92,-40,-124,-5,-6,-39,-100,68,-4,22,-53,62,15,-80,-43,124,50,-16,64,-8,-27,-5,-92,-34,5,127,-77,25,62,-2,-64,-22,97,-17,-8,11,-27,40,-17, 
  /* [68][0][][] */ -70,-48,0,103,-48,11,56,63,35,-127,-109,87,-102,-39,-14,-42,-67,50,29,60,37,32,-62,-52,7,-65,-23,-9,36,72,67,50,25,26,120,-27,-60,29,-21,45,-33,-19,-73,94,34,-54,26,48,-32,127,5,-25,12,20,20,67, 
  /* [69][0][][] */ 2,-87,9,32,-32,-21,-20,-80,-15,127,-20,-18,20,-4,73,-28,48,86,-41,65,-5,62,-79,-47,7,-11,2,54,-28,-41,-28,-47,-68,-108,39,-5,17,-30,-57,-22,-40,-44,52,-21,9,-51,-20,-4,20,103,12,1,96,100,22,26, 
  /* [70][0][][] */ -13,-74,88,63,68,8,16,-7,-4,-18,-89,-5,121,-50,-26,37,41,-7,-85,-74,-127,56,5,-26,-8,64,-28,16,7,-57,17,37,-51,-33,10,6,108,7,-44,-14,35,-85,117,-4,-27,27,101,-47,18,-82,4,-102,-67,-43,-15,108, 
  /* [71][0][][] */ -29,-46,57,127,-29,-46,46,22,51,-25,24,42,7,46,64,-82,36,-62,89,37,-24,-97,-41,13,37,-23,-122,27,3,19,-4,-15,-52,-22,-24,29,-41,-25,24,40,39,13,-13,-9,-26,-3,-23,61,-25,12,-94,21,51,-58,-53,-16, 
  /* [72][0][][] */ -14,-11,-66,42,83,-104,20,-13,20,105,104,-2,17,24,-7,50,26,-5,-33,51,-53,-24,-106,-4,-71,-47,104,-102,-84,40,-69,-90,-51,-28,31,-50,66,-17,-127,-39,28,91,64,90,-32,-28,-37,-16,30,87,1,-65,-41,34,6,-54, 
  /* [73][0][][] */ 41,-65,15,-110,56,16,-67,-20,-28,79,56,94,-15,4,23,-127,-70,-16,36,-90,-54,23,-2,37,-48,-37,42,-18,-45,43,21,2,-76,-37,-74,-19,-7,-16,26,-8,93,-48,58,101,93,-71,-59,-28,32,10,-86,-7,-50,-44,-2,-10, 
  /* [74][0][][] */ -73,28,32,114,80,-68,-46,29,-58,72,-95,-5,64,8,49,3,43,107,75,-39,1,40,-59,56,61,-75,35,-50,-39,-17,-13,-64,39,-2,-58,-85,127,-60,15,-61,13,39,-67,-13,-41,49,-111,19,36,31,51,-6,-123,29,-24,-64, 
  /* [75][0][][] */ 110,54,64,108,2,-122,-32,0,-3,-21,8,1,-26,-9,127,18,104,-74,22,27,35,-49,-25,-30,86,5,75,70,-103,-6,-23,-3,77,33,14,-70,74,-69,11,1,14,-18,45,-49,-54,40,-58,-63,-7,-95,69,88,-89,-5,-59,-50, 
  /* [76][0][][] */ 34,48,-25,59,-10,112,105,70,-63,-63,3,30,-47,-35,107,-40,96,-17,-65,-29,22,46,-15,46,-91,8,3,35,-19,-127,35,-18,13,91,23,-110,56,1,-71,41,-62,-109,-13,-80,-21,-55,55,-81,-49,13,62,25,-85,55,124,-74, 
  /* [77][0][][] */ -19,13,-23,20,51,86,42,64,-7,19,27,-41,-26,56,-13,-123,44,59,25,-33,-66,-8,-45,-32,98,28,-10,80,-39,2,-25,-55,-76,-20,-15,55,105,38,6,127,-69,3,55,1,-46,74,-61,-1,78,-62,-7,-7,-26,-2,-2,-44, 
  /* [78][0][][] */ 9,-16,-30,-8,47,3,-8,10,48,-11,17,-6,-26,19,33,-14,-37,-24,-38,33,-54,42,17,-18,-36,-28,-25,8,-54,8,61,32,-24,-29,-56,0,-41,127,-9,-5,-27,31,7,-42,-30,18,-43,15,17,-17,19,40,16,23,39,-33, 
  /* [79][0][][] */ 17,80,34,-14,100,22,62,95,-18,46,-2,-23,32,54,99,-33,127,-55,-39,-45,11,-52,-39,-91,42,-54,-41,-48,1,-31,49,21,67,1,-42,55,-28,19,40,-47,74,-69,62,-13,-27,24,60,57,48,5,93,0,-38,35,-83,25, 
  /* [80][0][][] */ -39,-2,-4,-8,8,17,19,-37,-10,-75,26,47,-37,-53,36,-100,22,-4,-14,-69,1,-10,29,23,27,-31,0,-9,-43,-5,23,-33,18,8,-20,-1,-24,24,-30,58,48,8,-20,-85,47,53,-33,32,-59,13,-34,-18,30,-63,127,25, 
  /* [81][0][][] */ 121,-57,-8,17,63,-29,0,-22,73,31,92,-52,-27,68,68,56,-58,-74,16,87,-72,-34,-5,36,22,62,83,123,-26,111,44,-27,22,7,87,-127,-46,-26,14,-76,96,12,28,109,-87,-57,82,-28,-5,-31,24,24,-65,-20,6,-127, 
  /* [82][0][][] */ -35,-127,43,16,45,71,-76,-19,-16,-62,-100,-5,-17,86,-4,55,-64,69,-22,47,-28,-8,-35,79,-51,-28,10,-110,-27,-25,4,44,-126,-25,40,-11,-100,-12,-78,-117,-19,16,-119,-76,-67,40,-34,-18,77,62,-64,-67,81,-20,1,72, 
  /* [83][0][][] */ -62,-33,8,-83,46,-115,-41,-50,67,28,28,35,-2,-74,76,4,-24,28,20,-27,-36,-32,40,112,114,0,29,40,-20,17,42,45,-16,-38,-31,6,-31,28,-55,-35,117,9,81,-23,42,2,10,8,-63,-46,-26,-23,62,-115,-23,127, 
  /* [84][0][][] */ -9,87,69,70,-13,60,62,53,32,-57,-2,108,55,-58,-7,35,-6,-30,47,-62,-49,-8,-10,-11,26,-126,-116,-7,127,-57,-52,51,16,37,46,20,-56,-32,24,8,-49,60,-5,-50,11,9,33,-12,8,115,24,-26,38,-17,-19,54, 
  /* [85][0][][] */ 3,-28,-60,8,-41,-29,14,-51,127,-13,30,70,83,11,-12,-6,-8,9,31,47,29,-11,16,98,-60,-33,-28,-18,-15,-51,-38,-21,3,-24,-1,3,15,-13,62,7,-27,-31,-39,-44,-39,-16,-52,21,25,-40,-17,16,8,59,-45,6, 
  /* [86][0][][] */ -21,75,-48,27,-32,23,-16,59,60,69,-27,-85,-63,86,-43,65,-99,-32,8,-89,-20,-66,94,36,-21,93,38,-98,-70,101,-15,89,-13,31,-99,30,96,89,112,-11,-33,117,-21,-6,54,-28,-70,-117,-127,-45,-7,50,-98,-77,-5,88, 
  /* [87][0][][] */ -72,36,21,-38,47,53,-40,25,36,-29,-17,-48,-24,-77,-65,28,-15,-42,-58,37,6,87,4,55,-46,-26,82,38,-11,-76,103,54,35,26,53,90,22,47,-25,44,42,-127,-65,-77,-81,16,-11,55,48,-12,-25,-54,-73,16,15,84, 
  /* [88][0][][] */ 106,43,48,-24,127,29,21,-73,78,-32,55,89,-44,39,41,-37,-35,-84,39,101,-18,105,-30,-18,116,-4,14,59,27,-21,-4,22,9,-62,66,29,18,-90,-18,-11,29,-87,76,-85,-20,-12,-92,-26,-61,27,24,12,11,70,-35,9, 
  /* [89][0][][] */ 74,-27,-43,-21,-2,0,5,13,-67,-47,-15,-31,-36,15,-59,28,35,-9,-35,-60,-40,-26,20,-30,-21,-86,-7,-38,65,29,27,28,2,3,39,36,19,46,-19,27,-18,-88,61,-19,-26,41,-70,50,-66,1,-16,13,56,124,-127,31, 
  /* [90][0][][] */ 60,-1,-8,90,52,-33,58,-54,59,24,90,-74,-28,19,-32,38,49,-38,2,6,68,-72,79,-15,37,76,-24,-29,47,-3,-7,45,-33,-73,-14,24,13,-8,-27,29,29,34,-65,59,2,15,-83,40,-52,1,-127,112,-67,39,6,-113, 
  /* [91][0][][] */ 34,-46,-9,-44,110,70,-54,-69,-27,-46,-68,-127,-18,-3,24,-48,-30,-77,14,20,-45,-17,107,-101,-8,-16,-20,-47,-4,17,-77,-23,58,4,-8,-22,3,-33,-48,113,-46,-5,28,-1,-58,-5,22,-62,49,57,-28,-8,-17,47,-6,57, 
  /* [92][0][][] */ -43,-64,-23,-75,30,76,-27,-30,4,77,-53,-32,2,15,-70,73,17,-48,48,60,-117,-52,31,-5,92,14,-12,4,57,-10,78,79,-127,-40,14,76,-33,65,72,23,59,103,-46,-2,-1,5,-124,27,-42,67,-39,-105,76,-55,-8,31, 
  /* [93][0][][] */ -12,46,45,-13,-45,-108,12,50,-52,28,-71,-61,-23,91,40,-78,15,-14,-86,-6,21,-102,7,72,38,-3,-39,14,31,-41,34,-14,-13,-18,67,-11,49,86,26,37,-67,66,46,51,-35,-53,39,85,-56,-2,58,8,-36,-75,-127,57, 
  /* [94][0][][] */ -40,-45,-21,10,25,52,43,39,52,13,59,78,88,35,-11,-1,68,-67,18,-39,95,36,114,64,-4,-1,17,127,84,-79,-22,-5,-64,67,-45,39,51,71,-4,-63,14,79,39,-47,31,119,59,28,-48,0,-27,-71,-30,39,-56,-50, 
  /* [95][0][][] */ -127,22,32,115,-26,67,-10,-21,-48,-15,-29,48,93,-50,-45,29,63,8,-48,-83,-32,-18,-81,23,-81,28,-76,-34,103,-62,-34,-12,-92,5,-37,8,38,-80,-66,-105,-9,38,-43,-13,-29,-30,-9,-100,5,-13,31,63,78,-62,-57,73, 
  /* [96][0][][] */ 5,-100,37,-18,30,-37,-31,18,31,62,11,-127,44,2,44,57,9,25,24,10,-34,-22,37,40,61,-16,-25,4,13,-36,42,36,-16,-67,-30,51,62,23,-23,38,5,-2,-45,-25,1,-21,-22,36,-1,4,-33,-15,1,-49,11,55, 
  /* [97][0][][] */ -13,-76,38,-34,-40,-4,57,93,-115,46,-12,34,127,103,15,-99,52,67,-18,-63,77,-22,51,-28,25,23,-113,31,-15,8,112,-66,-80,-86,30,-69,-34,29,-21,85,83,-33,41,-3,-35,-45,-61,-35,-97,-50,-22,78,-76,56,-7,-2, 
  /* [98][0][][] */ -75,10,31,15,-25,-16,17,-6,73,22,39,-74,34,-42,-84,35,44,78,-11,-43,-41,-27,-29,35,-3,-5,50,-127,-49,-8,-7,57,5,34,27,-72,44,-48,-32,-45,-2,9,48,-40,14,-4,-50,24,3,-65,36,-22,-21,-24,70,-15, 
  /* [99][0][][] */ 1,26,-49,11,-17,4,-54,-66,51,-73,65,-127,-77,93,28,-22,43,12,1,71,16,-9,34,1,1,27,-47,-49,30,61,-26,-34,-85,-98,-29,7,-33,53,-66,-8,-95,20,-25,93,-76,-72,-4,60,41,53,-49,32,-45,-12,-36,-51, 
  /* [100][0][][] */ 41,-122,19,-1,-44,-43,-52,20,82,-27,25,-5,46,-4,42,-8,70,50,-42,-15,19,47,15,-1,-25,-83,45,-88,12,39,93,38,42,61,-12,-32,-98,-49,-27,28,21,49,-35,-32,42,-21,-20,73,-120,91,-95,118,13,127,-117,22, 
  /* [101][0][][] */ -49,15,-26,29,-5,-23,18,32,-13,-17,-57,-2,-44,27,2,-11,13,-18,-58,43,18,40,6,5,-48,-66,19,-2,-50,14,38,-98,7,10,-31,63,49,24,17,-19,-37,-33,127,-72,-86,-15,-8,25,42,-126,36,56,-81,28,33,-43, 
  /* [102][0][][] */ -37,-41,0,-2,-60,84,-28,-68,36,9,-75,-14,-20,127,44,-41,9,41,-7,24,-46,-1,-107,25,3,-15,81,56,18,35,66,-7,-75,31,27,-3,-62,0,7,-34,17,-38,16,-27,-16,-16,34,56,-32,-26,19,-8,50,33,-18,-67, 
  /* [103][0][][] */ 53,13,6,-21,-37,75,19,31,-60,30,26,4,20,75,72,31,23,46,106,-89,112,-34,39,-127,3,39,-85,-100,7,-10,63,25,43,-46,-37,60,-13,-83,-116,27,-4,24,27,-15,-16,105,-59,-25,-79,-3,11,57,84,-47,95,-73, 
  /* [104][0][][] */ 37,13,13,55,18,127,46,-14,44,0,39,53,-95,46,48,-31,42,28,1,93,-19,1,3,-75,23,0,-13,63,5,17,-81,25,90,5,-29,11,25,5,43,-60,77,-11,7,-93,-30,-46,24,-53,23,-38,60,54,-51,91,44,-21, 
  /* [105][0][][] */ 23,-64,2,42,-27,8,0,16,-20,46,-22,53,4,-17,9,21,106,-28,23,-52,92,-20,-6,-123,8,40,20,27,-23,-29,-46,-104,84,59,-74,77,-24,-23,-45,-104,20,75,70,-8,26,57,34,-25,127,33,5,86,-34,68,-15,-7, 
  /* [106][0][][] */ -1,-22,-2,-63,0,4,-29,15,-19,-8,-73,-24,-43,78,-57,-20,-58,-58,25,24,-23,-9,-127,66,-54,25,28,-16,-24,-32,10,5,-80,35,-51,-8,-38,-53,-44,-89,-6,13,81,-67,56,3,-72,-51,12,115,90,-27,-8,72,-36,-17, 
  /* [107][0][][] */ -79,39,62,9,-19,30,72,-13,-20,-17,-69,36,71,-54,50,9,85,38,-103,-34,5,-7,-16,9,38,5,8,-66,-3,1,65,-32,-85,60,-127,-29,101,-77,-96,-60,38,-42,-1,-56,34,59,46,-93,-30,-67,-56,23,-38,7,-110,79, 
  /* [108][0][][] */ -3,-1,-8,29,65,-44,96,-17,9,78,-29,36,38,-12,44,-44,12,-48,-12,23,-127,-43,-33,46,-12,95,51,-87,27,-54,46,19,-33,1,1,18,-37,38,-9,22,-51,12,16,13,64,-12,26,-11,-16,-11,29,9,52,29,7,-38, 
  /* [109][0][][] */ -2,5,-40,-91,-17,12,-14,107,-89,-33,53,-26,-20,-2,-18,-26,58,-7,20,-26,30,20,33,74,9,7,-8,15,-50,49,31,-4,-30,17,-78,9,-12,0,-39,-16,0,-57,94,-12,-7,52,19,-127,-3,31,23,-34,65,47,22,66, 
  /* [110][0][][] */ -16,51,26,13,9,23,35,-91,46,96,80,20,-16,-115,21,-47,-28,10,54,57,109,-2,127,100,-39,27,95,102,-17,-36,0,-26,100,47,97,-21,-6,-51,-64,28,-17,39,-41,-14,87,6,65,1,-2,106,-43,-21,76,-41,-25,13, 
  /* [111][0][][] */ -61,-21,-81,46,-115,97,-13,38,14,57,-21,-36,14,54,7,-46,-11,15,52,-27,64,75,-121,-28,-17,-50,113,9,-49,-127,60,-79,-5,92,34,17,-8,-57,-19,-68,-4,-78,13,16,-22,1,-6,-46,50,26,-43,-59,9,-61,54,16, 
  /* [112][0][][] */ 45,-41,-7,22,27,-51,-14,2,-127,-81,-64,4,-28,-43,75,-35,-18,-20,33,36,-28,-52,-98,45,1,-57,57,17,-35,-19,-25,-88,-18,35,29,-28,62,-26,-126,-20,-25,48,22,7,11,81,-7,-9,56,14,-5,35,21,49,-3,56, 
  /* [113][0][][] */ 127,9,13,17,39,-30,33,7,6,-55,-46,26,-27,37,73,50,22,0,4,20,34,9,-23,-23,-9,37,-3,70,-23,23,13,-17,18,49,16,31,-16,-36,58,33,-19,-86,47,-11,-27,-4,25,11,-19,-33,60,62,-41,-5,-6,-80, 
  /* [114][0][][] */ -18,-40,-11,27,19,29,-10,-38,-17,-41,75,11,-35,46,53,-127,15,33,-27,-14,-44,15,61,-73,19,12,-42,-87,87,79,51,16,-68,-2,-8,30,57,21,44,11,51,5,-25,7,7,-11,-22,17,25,55,75,-35,55,-35,-83,-53, 
  /* [115][0][][] */ -75,10,47,-6,36,-28,-39,38,-49,47,-49,42,5,-10,-29,-20,-45,3,127,-22,24,-25,13,9,-7,26,-9,32,17,-9,-32,-3,0,-25,-39,101,-21,33,34,-43,30,71,-78,-25,42,10,-27,38,13,27,-41,3,70,-48,-7,37, 
  /* [116][0][][] */ 17,29,0,30,-49,-74,14,-39,2,10,-45,-42,41,21,11,6,36,-63,-125,12,-54,-32,-84,-64,19,-124,31,-72,-11,-16,40,-24,18,-29,-94,25,73,6,24,-9,62,-12,17,12,28,-127,6,6,-33,-11,-55,26,77,-58,-111,30, 
  /* [117][0][][] */ 4,-30,16,32,59,-127,26,-63,5,-70,-30,19,-12,-26,-65,-6,46,-23,-26,38,-102,-64,38,111,50,22,38,-72,2,-18,-40,78,32,-29,-36,-39,6,-3,-16,-46,1,-56,78,-106,-30,3,-11,-64,62,19,55,3,62,26,-38,-6, 
  /* [118][0][][] */ 48,-47,-57,-87,63,23,71,-55,40,18,-38,-43,-2,-4,45,52,49,96,-12,-21,-55,-76,-28,-14,83,40,66,5,-6,-21,5,-19,37,-13,20,89,-112,-99,119,3,-78,-83,-12,-11,48,5,-127,72,-4,7,54,51,42,63,0,32, 
  /* [119][0][][] */ 43,-31,45,-48,52,4,15,-79,-28,22,121,-62,1,-89,57,-1,36,-14,-74,66,-2,55,-36,-48,-79,35,127,-11,-65,-21,-53,-30,4,71,-11,-22,32,-46,-8,-49,58,-67,95,7,24,8,-43,-39,-37,-79,17,55,-25,-42,-8,-90, 
  /* [120][0][][] */ 35,47,-127,57,-10,-76,-42,-26,74,2,86,8,-60,33,11,-10,-34,-79,-36,-89,0,-24,-79,39,-82,-2,31,-20,-39,-13,-26,-33,-35,-44,17,-41,-17,-24,-69,82,-23,-4,49,51,-26,-20,-17,-36,28,51,7,-28,-39,40,58,-10, 
  /* [121][0][][] */ -19,-60,3,-64,-29,54,107,22,-70,43,-33,-53,51,-18,-41,-72,97,-10,-77,-66,-127,-62,64,-18,46,2,27,39,-105,43,62,98,44,35,-71,-27,-17,61,65,9,13,78,-7,-53,-76,42,-115,66,30,-27,-14,-14,-35,-66,86,111, 
  /* [122][0][][] */ -52,-90,-19,33,30,-14,-10,38,-88,-42,16,61,-11,-2,-15,-16,-25,80,-48,-2,-127,109,40,43,30,-24,-44,-17,-68,-18,92,-23,-96,-61,-1,-24,123,9,32,2,-15,29,87,-78,-19,45,65,-4,-15,-46,-27,-13,-91,6,71,45, 
  /* [123][0][][] */ 3,-79,29,17,24,-6,7,-26,18,-98,-7,89,-8,-71,-55,45,-74,-126,-12,71,-52,36,-9,6,76,10,-10,-33,-2,3,-9,58,15,61,-81,42,22,14,-39,70,-37,-127,-3,-21,-20,21,-67,43,-78,-73,17,28,49,17,10,-12, 
  /* [124][0][][] */ -1,50,84,68,89,0,29,71,-15,-61,-39,86,9,-49,-52,56,91,-25,8,0,105,-17,12,8,87,73,106,74,-89,-52,-75,-122,7,86,-1,-19,-41,20,12,52,32,12,0,-127,-66,8,76,-19,65,70,101,-40,25,-53,1,68, 
  /* [125][0][][] */ -24,27,-8,15,32,-13,-40,-22,65,-78,11,-56,28,-74,46,-40,27,-28,40,-71,15,58,37,6,-31,3,-41,-33,63,-34,127,62,-61,3,105,45,-3,14,-81,-11,6,-30,-7,27,-49,-36,33,42,72,-14,-5,-3,-12,-40,-36,-8, 
  /* [126][0][][] */ -62,-101,1,-31,10,8,-11,46,-53,60,-8,-83,41,-51,-90,50,62,-20,-14,-17,-11,-27,-15,-47,-45,84,37,28,34,-50,36,47,21,61,38,61,86,57,38,-50,-17,-33,-62,-26,-30,-8,2,51,40,-127,-50,-22,-23,-24,33,85, 
  /* [127][0][][] */ -13,-28,-67,76,-89,73,-12,-51,-10,-16,-28,27,-15,12,54,72,-76,57,-31,11,127,48,34,-118,42,-51,-12,58,-68,-40,-37,-3,23,42,-48,-24,-117,3,-79,-16,-29,-36,-43,46,-6,-31,43,-42,5,48,30,-2,-32,-10,121,12, 
  /* [128][0][][] */ 8,-29,-22,6,120,10,34,-54,0,-10,-72,-48,31,122,-78,-39,6,23,-7,-39,55,-21,25,52,1,25,77,27,19,-40,68,-27,46,127,4,75,13,-16,-91,38,42,0,14,-77,-62,-40,16,33,53,34,26,29,35,28,96,-9, 
  /* [129][0][][] */ 44,10,-12,48,18,-89,-14,44,-17,35,12,-28,-41,-6,-13,10,-3,-36,-4,-57,-35,37,16,66,-16,-43,-65,-77,-51,-42,-51,-36,-22,-127,-12,-27,1,5,-54,89,-67,-26,-36,21,58,8,-33,-5,-18,33,-27,49,-40,-12,2,-6, 
  /* [130][0][][] */ -4,30,-46,48,-20,-39,99,-46,86,70,-45,9,11,-67,29,1,115,-42,23,68,-15,-77,12,-82,-9,14,109,46,-48,37,71,-127,-67,-48,-48,-96,28,-30,70,-33,4,-31,-7,24,-7,-109,-49,70,-66,39,-101,61,31,4,-42,-99, 
  /* [131][0][][] */ -40,-66,-55,31,17,-31,31,-27,92,-54,23,-51,-52,-20,11,-6,-79,-74,-42,11,-96,14,-50,7,34,-33,-3,-11,-3,0,18,98,-107,-37,-31,11,23,13,-18,12,41,-127,9,35,-40,21,-52,15,-30,-70,-38,-4,78,-4,1,-56, 
  /* [132][0][][] */ -59,-17,-3,-77,19,-34,-7,100,-60,64,-5,-60,65,15,-101,-109,111,30,-14,38,-42,-23,64,26,-23,-25,80,-28,71,-10,5,-22,-9,24,55,32,-69,-19,29,-37,36,-65,-79,78,-25,-99,22,1,39,-52,127,4,-15,63,9,-9, 
  /* [133][0][][] */ -8,18,-16,-98,89,-95,-87,-63,-6,36,13,47,-30,46,27,4,127,91,-110,-44,0,28,81,-8,-5,-5,13,-3,-96,29,-85,-7,-88,-45,20,-78,-2,35,-42,51,110,-30,-30,27,22,-115,-9,41,-58,-66,121,-41,-58,-109,-119,-68, 
  /* [134][0][][] */ 41,-68,24,2,-26,-73,21,-16,24,-15,29,-101,52,-72,78,58,98,-7,1,3,20,-127,-10,-7,68,73,-39,-50,71,20,2,67,5,-85,-29,51,83,72,12,-12,-96,-17,71,50,-93,-103,-77,35,6,23,34,-24,-9,1,42,8, 
  /* [135][0][][] */ -93,-6,-53,57,-116,111,-41,-82,11,88,-6,48,-71,-6,-49,69,-24,37,-81,-54,16,13,-127,62,-61,-16,97,6,-36,-38,-41,-110,65,69,114,-39,-18,-103,-99,-16,-79,-110,-122,-25,69,12,68,24,3,0,-6,60,78,-52,99,-2, 
  /* [136][0][][] */ -11,-88,-2,4,-35,-42,-71,4,-40,-70,46,-6,102,-31,-80,15,-36,-12,-17,-56,-9,-63,-97,60,-90,-62,14,-127,-14,-47,20,-14,15,-1,-28,-9,-16,-21,-6,-29,-6,8,-29,-25,-67,33,-33,26,31,61,13,-120,-23,-28,96,70, 
  /* [137][0][][] */ -115,27,11,7,-99,93,-56,23,26,-22,-49,-14,-84,11,-37,-16,-52,44,58,33,29,22,-25,-12,-27,-50,127,9,40,10,58,21,-57,0,27,-10,-33,11,84,-21,44,-69,-8,18,6,0,33,-12,-28,51,-5,-112,19,-52,34,-3, 
  /* [138][0][][] */ 19,5,-14,5,23,-70,-92,-11,-10,14,-39,-55,90,-65,83,26,-82,41,26,16,-60,54,-13,21,-119,127,-27,-56,-58,25,-59,-13,-113,-36,-44,-109,57,20,-7,104,-113,-108,-81,-81,16,-97,-12,-44,18,-61,-14,-12,68,38,8,76, 
  /* [139][0][][] */ -15,40,-1,-65,42,-6,14,3,46,3,17,6,-60,42,-21,-20,-69,76,41,45,71,-100,-66,42,-66,-25,0,-3,45,-6,-2,26,-59,-23,-32,-7,-48,37,79,-41,-83,94,-116,-115,37,-14,-10,-1,46,21,68,-127,16,82,92,38, 
  /* [140][0][][] */ -23,-101,-50,-81,-26,-24,35,28,25,28,48,-14,0,53,3,56,127,-40,78,-15,-2,52,69,49,55,-42,20,84,-48,56,73,-10,-42,-61,-106,-7,20,-38,19,-34,45,-35,35,26,-31,5,-7,45,4,-79,-49,-28,15,-27,10,69, 
  /* [141][0][][] */ 82,-52,-97,21,69,19,-3,24,53,-2,8,-26,-102,2,44,-26,-24,-17,24,21,-48,-51,-34,3,40,-84,91,47,4,-58,-51,-32,-28,32,82,-48,-10,27,31,49,-36,-17,85,-67,-48,25,-4,73,32,-9,89,22,-58,-83,127,-117, 
  /* [142][0][][] */ -14,-8,-50,16,-27,-23,-91,-26,51,21,-24,1,20,-42,-71,102,-15,75,19,-30,127,-33,41,-71,27,-4,24,44,-47,-59,-46,-24,27,-82,-9,-61,-42,-32,9,-33,-65,-4,-40,62,-37,-16,27,-58,51,74,-7,-18,64,-1,112,38, 
  /* [143][0][][] */ 127,-15,-22,-29,4,50,-21,-18,-15,-2,17,20,-24,-47,-3,-30,35,-20,-50,35,5,-30,37,18,-32,-14,11,71,15,-13,-33,-59,17,17,12,25,-49,-20,-46,-41,5,-16,-3,-25,52,10,59,-52,-34,84,41,-3,22,30,23,46, 
  /* [144][0][][] */ 57,56,35,-36,54,52,-8,-36,37,-6,-81,-42,51,47,-27,-55,28,-35,-15,-16,-42,10,-40,-42,-8,-21,19,-111,94,-39,33,84,37,21,22,-46,0,47,-11,-38,-63,1,107,-46,12,65,86,19,25,-57,59,-13,15,-67,-63,-127, 
  /* [145][0][][] */ 5,-6,0,66,-38,-10,-21,21,-43,20,55,20,47,23,42,9,37,-45,4,-75,-35,-29,127,9,32,71,11,-29,81,-5,126,-17,7,-2,28,27,-5,-22,16,-51,47,25,53,-20,26,-24,-2,25,-20,24,25,37,-59,-32,-36,-28, 
  /* [146][0][][] */ 27,-26,3,0,-57,-93,-118,-41,-48,-11,115,13,38,-18,-56,-22,99,60,-2,44,62,1,-36,-82,-52,-24,8,-33,74,27,30,25,-117,-93,20,26,-78,59,-96,-42,-22,-115,-33,43,-66,-44,-80,-46,127,24,56,40,-56,61,41,-15, 
  /* [147][0][][] */ -23,-24,-19,67,-75,-8,-60,-54,66,-28,6,-46,24,40,2,51,-21,-22,52,7,26,2,-65,-33,11,-127,73,11,30,19,-89,-11,119,-11,-8,-8,3,-71,-88,-43,-57,22,-34,69,-17,-63,50,-31,-23,50,-51,-33,78,8,44,-49, 
  /* [148][0][][] */ 60,82,10,-19,-27,-31,6,68,-38,-34,36,-5,-94,-24,35,66,-28,-66,18,-50,83,35,45,21,42,29,54,14,3,32,-2,-31,127,14,-23,-83,-18,-35,30,18,74,47,69,-5,-53,40,78,-39,-1,-54,29,16,-82,-11,-13,16, 
  /* [149][0][][] */ 46,-26,-52,-105,-4,-45,39,-35,86,6,9,-49,25,61,38,29,-28,94,-32,-17,63,-36,-36,20,-28,40,42,38,-4,16,-46,23,-12,0,-41,87,-80,62,71,-15,-41,13,21,3,48,-2,-127,23,6,-18,59,52,22,58,-34,21, 
  /* [150][0][][] */ 2,-80,18,78,14,6,-41,-110,11,-24,-39,-72,-25,-47,31,-49,80,-38,56,74,-124,-80,-32,-12,-7,-91,12,103,-13,114,-37,-10,-45,56,55,-80,79,47,-32,-127,-47,32,-22,-15,-23,-74,-5,15,-36,-79,-50,21,47,-22,-78,24, 
  /* [151][0][][] */ -12,68,16,-2,19,-87,-47,43,28,-26,-34,22,-45,-62,79,-59,127,-72,44,-43,-16,-26,53,-61,-47,-34,39,6,19,2,-14,45,45,-52,2,-29,38,-23,75,-80,67,-6,115,-43,20,47,63,6,17,33,35,-1,16,52,-102,16, 
  /* [152][0][][] */ 7,-15,-9,-17,-13,-18,-22,-32,55,8,-62,127,-4,58,60,83,-17,26,17,-6,-54,4,-68,31,62,-79,-10,-5,-24,-31,43,-5,-36,-10,-15,4,-76,22,0,18,0,-21,-55,-52,1,40,37,-14,-8,24,92,-61,-9,-90,68,34, 
  /* [153][0][][] */ -12,-9,-13,-127,-13,-84,-42,-60,-3,35,-75,27,-51,15,55,68,-29,60,89,59,30,-4,-37,82,-45,-5,120,22,-5,25,36,1,-66,-88,18,-63,76,30,36,-2,70,12,45,-1,65,-83,-64,21,-118,-56,43,-45,108,-52,-35,104, 
  /* [154][0][][] */ 27,-10,78,7,102,70,-3,-23,108,-72,8,76,-52,-85,-85,39,0,-45,-24,-39,88,-43,127,-2,-34,83,-12,-80,-9,-53,-19,13,71,24,-16,-27,-17,-35,-106,41,1,4,65,50,-61,19,28,-57,-18,25,51,25,-99,-68,23,-89, 
  /* [155][0][][] */ 41,-73,-67,-18,10,-12,-33,12,57,9,-10,50,-90,15,36,26,-51,0,48,58,-69,-9,43,-35,38,-2,26,54,-55,54,-7,3,56,21,85,0,-64,-19,52,90,22,0,15,-98,-5,52,-61,65,1,-27,91,54,-33,13,127,-103, 
  /* [156][0][][] */ -86,16,108,112,-27,82,-99,44,-4,2,-68,-82,-121,127,126,-45,-89,79,16,46,-21,-89,-67,-86,-30,28,53,-101,-37,40,121,15,57,64,43,78,-102,-69,-68,-74,15,-67,-17,-5,18,41,5,-1,32,54,32,-103,45,-31,22,7, 
  /* [157][0][][] */ 63,103,106,-13,-65,-9,83,8,-42,117,59,-54,-21,-71,-70,-34,95,50,38,4,-50,-49,10,-41,127,15,-33,-36,-109,-64,107,-81,-60,-7,-68,-59,-49,23,65,21,64,-32,13,-124,21,47,33,-34,25,95,-47,49,-30,-12,34,9, 
  /* [158][0][][] */ -42,59,21,29,-28,93,80,-38,17,-74,-39,49,71,69,-10,-7,6,-23,-50,-119,78,10,-17,-90,-12,20,30,-53,-52,50,-8,74,127,125,-54,-36,-3,-19,-9,-10,-68,47,67,46,13,126,-106,103,10,-43,-46,-16,18,-28,-52,-29, 
  /* [159][0][][] */ -12,-106,16,-19,15,-53,-27,-48,29,-19,59,-98,50,-25,-13,-51,-127,30,40,41,-55,71,0,0,-109,83,-15,-16,-4,-38,22,-13,-22,28,-18,32,-93,50,-47,-24,76,9,83,7,-10,34,-16,-50,-66,-73,-61,26,76,-66,14,-11, 
  /* [160][0][][] */ 73,9,-2,-9,-39,-5,44,7,52,-24,-45,0,-22,-14,102,89,36,-14,18,89,-43,42,37,-127,-6,20,33,98,-25,-8,-12,-1,-2,-25,41,-21,-40,20,16,-13,40,-27,29,9,-19,21,-43,-4,1,-98,-11,42,-57,25,-17,-91, 
  /* [161][0][][] */ 55,-51,43,-43,11,-54,-57,10,40,-111,10,26,-5,39,59,-4,-16,102,42,3,-66,-6,-127,3,-38,-40,-7,30,36,-51,1,41,-48,-42,60,44,53,-52,17,52,-92,8,21,5,-2,16,-65,78,-28,-98,125,33,61,61,28,-80, 
  /* [162][0][][] */ -45,3,-42,16,36,-35,-11,-2,-64,6,-76,-82,-41,34,-127,-28,14,102,-78,9,75,-18,-14,-77,22,-24,68,-68,44,-14,66,44,5,-69,-60,-78,15,-38,107,-43,-69,65,106,120,22,57,17,-70,-20,-94,114,-3,-83,15,18,34, 
  /* [163][0][][] */ 63,40,-76,7,-27,-35,-13,-51,8,-63,40,79,-55,37,-64,-17,-108,-7,34,-58,127,-102,-39,-68,45,-55,-51,-61,-12,47,-76,-38,84,-19,-17,14,-36,-15,65,98,8,-95,83,-36,30,-32,11,2,-8,30,59,-5,-8,38,63,-20, 
  /* [164][0][][] */ 8,-57,54,-25,16,8,23,-5,-81,-46,-25,-42,-17,90,-72,29,8,-61,-2,33,-20,-11,-7,-10,47,107,-31,-68,3,-35,43,63,-63,-1,-2,15,-39,67,-36,57,-94,15,-37,-60,-10,-67,-44,32,46,-40,-127,51,62,-126,14,-63, 
  /* [165][0][][] */ 65,91,10,34,-91,80,27,-61,2,26,-42,18,-32,1,-40,5,19,-7,-15,70,48,-37,27,-39,-32,-3,-23,-67,-61,-7,40,-41,4,45,-43,-127,61,-71,-4,-6,-38,-116,-21,-31,49,-83,48,-95,-57,15,3,-82,63,-74,48,87, 
  /* [166][0][][] */ -12,0,-3,127,29,29,14,-25,-37,-22,-27,13,36,12,-18,56,-20,-11,-27,-12,12,-10,26,-96,-33,-35,51,47,-28,27,8,-46,86,12,1,-66,10,-2,1,-23,-30,-13,69,37,13,110,31,-83,48,-120,8,66,-36,-6,-13,-30, 
  /* [167][0][][] */ -20,47,72,15,14,41,65,30,6,22,-25,-28,-3,-65,28,-18,12,-22,14,8,68,55,-10,-53,20,77,-47,38,-83,69,26,-12,58,127,5,-6,-56,38,-36,-28,6,23,-1,-53,-9,-4,-33,-24,-10,-45,21,-81,17,56,8,-6, 
  /* [168][0][][] */ 28,-18,54,-40,-69,-4,11,-48,-22,-13,-1,-53,36,-5,65,81,62,-43,-76,24,-11,-15,-50,43,-18,-1,63,-49,-43,-45,9,9,-31,32,-75,0,62,-100,-35,-127,5,-76,5,4,-27,-48,24,-70,-13,-46,-9,48,3,37,-102,90, 
  /* [169][0][][] */ -29,-62,-20,57,-20,-2,-60,-18,-35,56,9,85,34,5,15,55,127,50,38,51,-37,25,-24,-62,-63,-38,-18,17,20,10,54,50,-4,-6,26,13,-17,116,-23,-38,-7,-53,-26,73,-75,-17,-34,41,0,25,90,-39,1,-46,-56,67, 
  /* [170][0][][] */ 78,8,-10,-50,82,-51,18,-67,-1,1,8,-62,24,-127,39,3,5,56,-33,28,-42,-98,-7,29,43,1,62,-16,20,-85,65,46,35,-60,-44,81,96,50,109,-67,-88,-59,101,9,12,-15,-32,-4,-27,28,0,-68,38,7,-27,-6, 
  /* [171][0][][] */ -9,4,46,25,57,0,-14,26,-25,-19,-8,-61,13,-23,30,41,44,61,35,-48,19,-38,25,-117,-74,53,-27,24,-23,22,19,-52,48,-127,-19,-9,-21,22,26,-67,69,-13,6,44,55,15,-48,-3,-37,10,51,-70,-72,-27,-37,-21, 
  /* [172][0][][] */ 30,18,-15,-46,-33,-98,62,-21,21,1,-38,5,35,33,-9,67,30,41,79,13,45,-127,27,-38,-74,-40,7,-15,-15,41,-11,17,-11,4,-113,57,-58,-2,-14,54,-41,-56,-29,-23,60,-30,-1,-62,47,-27,-26,-8,29,61,-70,-6, 
  /* [173][0][][] */ -19,-33,-89,-29,36,-81,17,7,67,14,-44,27,18,-20,-1,-29,-43,59,-14,-20,-27,-3,-127,31,-42,16,30,-26,-27,17,-27,-41,39,-19,9,30,57,-6,41,10,-50,74,-36,42,-18,29,14,-72,50,-61,55,42,63,-13,46,7, 
  /* [174][0][][] */ 67,29,44,0,-25,22,54,-11,-19,33,34,-59,-1,35,7,9,-88,-29,4,-60,59,-21,-12,-10,8,-111,-71,-17,-8,-23,-17,-106,-43,-27,21,54,46,31,-4,7,38,-48,-50,-127,6,21,27,-68,55,16,45,-1,26,-33,-66,-31, 
  /* [175][0][][] */ 96,12,-72,-56,5,21,7,73,91,86,119,27,-57,19,-76,-43,47,-49,32,-14,-7,28,24,-25,-1,-21,-80,-127,2,-2,-1,-81,48,45,-52,-43,-104,-2,75,27,62,15,45,73,-25,-76,55,7,13,91,-41,-26,-5,23,-67,-46, 
  /* [176][0][][] */ -67,-44,-101,-20,-38,-47,53,-69,39,-18,-82,38,-10,-51,-92,22,78,-20,9,0,-18,39,-21,-36,-36,5,32,71,12,9,-8,-35,-4,-48,-14,-60,-49,-7,-9,-2,-64,1,-3,71,35,-127,-46,-50,4,-60,-51,-29,-41,-18,-12,-30, 
  /* [177][0][][] */ -43,-119,73,-36,6,-16,-57,13,-78,31,68,-8,60,-38,-60,-38,-61,52,37,-53,-7,-89,-86,93,-70,-80,8,-4,-27,14,-118,-57,-97,-35,-10,68,127,-24,-65,104,-89,29,-41,-38,5,-120,-3,-81,88,-1,25,73,-15,-80,71,-69, 
  /* [178][0][][] */ -64,117,1,-60,11,-17,17,-20,34,18,7,31,29,-39,-24,19,-81,46,-20,-66,81,35,-16,92,-28,19,-9,-86,-22,-19,-36,-60,-2,-9,-3,-41,-8,-38,-58,-5,25,-36,127,0,58,-36,38,-8,-32,-36,23,6,2,-41,54,7, 
  /* [179][0][][] */ 28,-8,-70,-15,8,-2,62,-68,57,-27,20,-37,-39,26,25,75,-78,127,8,-60,20,-40,-49,28,-52,63,39,21,-55,67,-68,32,-65,-35,0,-61,5,39,45,-19,-40,-116,48,-22,37,28,-61,7,-13,-19,7,21,28,43,-32,83, 
  /* [180][0][][] */ -4,-17,-86,0,-18,8,-15,89,87,19,95,-62,-8,95,5,-4,94,-48,-29,37,5,-45,-11,37,60,-5,-66,-3,-127,6,-59,-17,4,3,-107,-99,0,-60,56,42,52,14,-13,-33,8,85,-3,-31,-4,-98,17,-8,-14,-2,53,54, 
  /* [181][0][][] */ 34,-96,-77,-56,-31,-127,95,-31,38,-28,-11,-31,73,-75,-26,3,40,-11,-22,65,-33,1,12,21,-50,-6,-28,-78,44,30,-49,69,24,-76,-31,15,82,65,49,58,110,75,38,42,-39,0,-79,26,-44,-22,5,-49,7,-3,-22,43, 
  /* [182][0][][] */ -1,-26,4,53,-19,-36,-53,0,4,20,-46,37,-85,32,-60,17,-21,27,-21,81,-16,17,-88,11,-73,-127,-77,-1,36,-43,-100,-11,56,-27,48,9,66,-47,-71,31,-30,-9,6,-1,-9,9,-26,47,-32,73,43,-25,18,-76,-23,27, 
  /* [183][0][][] */ 32,-36,64,32,78,-44,-18,22,28,26,57,6,-4,61,-14,5,-53,21,-23,81,-76,-24,-15,-13,26,36,-64,-51,19,-4,-27,41,-29,-110,-36,42,38,127,26,41,-26,-26,3,-67,19,-65,-43,58,-42,-28,44,-33,5,-14,-35,-39, 
  /* [184][0][][] */ -27,-19,41,-6,-39,-60,-26,7,-43,19,25,-43,54,-74,16,44,10,-41,28,-10,-43,55,-5,-2,8,-42,23,-34,23,-75,-41,-13,-10,-29,-26,21,30,-4,-37,-13,-102,-56,57,32,6,11,62,-6,-12,127,-74,-52,-8,-1,-13,30, 
  /* [185][0][][] */ -57,-5,19,66,-103,29,0,38,-46,-53,30,13,15,-25,-27,95,16,44,-25,16,-33,16,13,90,52,-50,127,42,97,9,-4,86,27,100,63,59,-81,50,-36,-50,-28,17,126,-47,6,-25,-9,-37,4,4,54,-76,63,-49,-17,-49, 
  /* [186][0][][] */ -16,-23,-7,-14,78,78,-43,-19,-52,47,19,-2,-95,-109,12,-8,-17,-18,13,6,89,47,-5,-30,-16,-8,19,-65,-29,-59,127,-43,-22,-18,34,-111,28,-21,-33,6,13,-47,-9,49,82,47,9,16,91,5,-30,2,-87,-26,3,89, 
  /* [187][0][][] */ -81,20,41,61,5,26,-24,22,-59,-61,-20,49,53,-46,-16,-42,77,-55,-36,4,-23,-70,-66,30,127,-28,-41,126,-34,53,-35,-74,-22,-32,-52,-69,105,-18,19,5,5,-5,-69,25,21,34,2,28,-58,0,58,-4,50,80,32,58, 
  /* [188][0][][] */ 3,-14,41,37,-53,102,37,1,-38,75,62,34,-9,7,18,-29,26,62,-33,-14,-6,-45,-27,46,90,55,52,-14,10,-47,-10,10,-17,-24,-46,20,-75,32,-12,10,-4,45,-127,39,126,-46,37,0,60,9,-14,-21,4,41,45,-100, 
  /* [189][0][][] */ 71,-34,-41,-2,14,-79,-19,7,11,-60,-47,33,-47,2,86,-79,56,2,-34,-40,3,-99,-35,-47,53,9,56,45,-70,16,-37,18,57,-3,-4,-19,15,-25,-12,26,-65,-1,127,-105,-38,54,-86,-8,65,-40,49,33,27,35,15,-58, 
  /* [190][0][][] */ -46,-78,-20,7,15,-22,14,-11,-25,31,18,-19,45,5,-68,-40,3,0,-6,-127,-4,-59,1,-8,-20,-9,-10,5,6,87,6,9,51,-37,-104,-21,20,27,-23,-36,-21,87,-11,-38,-19,71,-65,30,4,38,-6,-41,43,-22,38,94, 
  /* [191][0][][] */ -42,-57,107,0,-114,-33,20,14,-71,32,-25,20,64,-73,56,-27,62,-73,-22,17,4,-4,32,53,15,88,-6,-40,-22,-32,103,-25,-127,39,-19,-26,32,-121,-103,-35,42,78,-78,-19,64,4,65,-76,-36,68,-17,64,13,-12,26,-53, 
  /* [192][0][][] */ 23,4,-9,-66,-8,16,17,45,13,-5,-20,127,-61,4,-23,-47,26,79,-23,-42,-44,-5,5,-82,-6,15,-110,105,37,26,66,36,-68,37,30,106,28,77,64,67,52,6,-28,-46,42,37,-4,-6,-89,55,61,-7,34,-28,65,62, 
  /* [193][0][][] */ -10,-81,61,44,57,-47,27,90,-2,-35,8,7,27,93,-96,127,-40,-18,17,60,-46,20,-90,-41,15,-71,-52,-29,-52,35,-64,64,53,66,-68,14,37,-31,-20,-30,-59,-33,45,45,62,-70,-65,-6,27,91,-15,-65,-6,42,-23,-1, 
  /* [194][0][][] */ -9,-82,49,-2,-20,17,98,-38,32,-22,12,37,65,7,6,-49,-9,34,48,-76,-67,-26,33,-33,17,-22,67,-55,44,27,-74,-26,-96,-6,-23,30,33,-2,-33,56,19,-29,-127,83,26,73,-66,71,-33,-59,-33,-20,12,36,25,-78, 
  /* [195][0][][] */ 66,-9,-34,-16,-20,-43,-17,29,25,0,-52,-43,-12,52,127,52,-31,-50,-63,-21,62,7,-13,-21,-2,-14,-11,120,-71,24,-20,-29,47,32,-13,-8,-52,-30,-66,-9,28,16,37,54,-29,-19,23,-9,-72,-20,-7,82,11,0,0,-9, 
  /* [196][0][][] */ 11,-37,46,-28,-39,-16,47,41,-25,-50,-26,46,2,-2,97,25,79,35,-87,10,42,4,24,42,6,27,-13,-88,-53,-66,127,49,-7,14,-56,-54,17,-73,-71,-70,14,-32,2,21,28,-48,26,-54,-82,13,-68,21,31,36,-62,108, 
  /* [197][0][][] */ -60,-16,-28,-6,-65,59,-19,34,28,15,12,-36,26,29,27,-13,-20,-21,72,-34,-75,86,1,-88,82,22,2,-127,1,35,-48,-10,112,9,-17,-57,-14,-66,-2,47,-28,-26,77,-29,-11,-51,108,-53,46,57,4,6,9,61,89,109, 
  /* [198][0][][] */ -12,87,29,-4,39,-42,-33,54,59,-11,-1,20,45,16,-13,-11,86,-53,39,21,-50,-127,25,-1,-41,-20,3,-67,-26,-40,122,61,14,-28,-45,-26,65,10,-12,27,-18,68,-55,13,36,104,-14,31,64,38,53,74,5,67,8,64, 
  /* [199][0][][] */ -7,96,-92,-64,-33,-4,51,-46,25,73,4,-3,-23,45,-21,-7,-21,45,-7,-58,-13,-93,39,1,49,22,-38,-114,0,-79,-14,37,-7,2,-61,127,-47,-12,42,-6,3,27,-29,70,8,-59,25,26,13,-43,-7,-1,-82,-7,-60,54, 
  /* [200][0][][] */ -9,6,-52,58,1,-1,-1,7,-25,-30,-69,-16,16,-19,-8,49,17,31,-9,-2,-28,-42,-56,3,-13,-13,45,-32,7,-40,-110,-16,-6,22,-45,45,80,-13,-28,-65,-127,26,4,17,-11,-13,-3,-70,13,42,30,-28,10,39,-31,-55, 
  /* [201][0][][] */ 1,-57,13,-44,95,44,56,5,-36,0,4,6,2,14,-26,52,-31,-41,-3,41,0,-86,127,-21,-8,-45,-38,46,-3,51,-42,50,29,6,-37,-24,77,-36,3,-76,-40,45,24,8,75,-5,33,75,-43,0,-17,-30,-61,18,-52,71, 
  /* [202][0][][] */ 92,-106,55,-34,-47,-77,-49,-127,-29,4,-117,94,-5,-64,-22,74,19,-29,-78,17,7,114,-18,-70,12,32,-37,-91,-67,-52,26,-31,108,72,-34,-51,49,-79,-77,31,22,-87,0,63,7,-20,38,-31,11,33,-3,62,-6,-4,-25,75, 
  /* [203][0][][] */ -75,67,-13,-57,-32,33,-44,-61,17,-127,3,5,-3,-2,46,-23,-13,7,-30,102,55,64,-29,81,10,75,-70,35,-39,-23,-25,72,-45,-58,-2,-31,95,26,20,-11,27,-23,-27,-65,-62,-104,-82,8,-7,-58,-15,-33,-42,59,-59,9, 
  /* [204][0][][] */ -2,-8,-29,-16,-5,-14,16,28,127,-13,-77,-52,-29,90,-24,-34,63,-11,50,31,72,13,-89,74,16,61,0,-15,31,12,43,-21,-36,50,-39,61,9,71,17,-50,-21,-6,-47,-22,28,26,83,60,-10,-14,49,-126,5,22,-71,26, 
  /* [205][0][][] */ -20,61,-73,-106,51,37,127,-38,-42,120,-28,79,-110,-47,92,-3,-11,-26,12,-97,7,81,-17,-1,-69,70,3,44,92,34,22,25,-126,-48,28,70,22,-10,-39,-12,37,-11,23,70,20,30,4,54,-108,69,29,-7,29,-94,3,54, 
  /* [206][0][][] */ -24,-68,-55,44,-66,81,-45,22,46,23,68,-35,0,6,-114,67,-90,-61,127,-37,13,44,-35,-17,-4,-39,50,-67,55,-15,-81,-24,29,6,88,16,-110,-19,-58,-69,30,39,-50,-8,-34,84,-1,13,40,109,-55,-22,-70,-16,125,29, 
  /* [207][0][][] */ -69,10,-8,48,-55,-15,-73,-79,48,-45,-53,-31,-37,127,83,22,-13,-23,-21,-86,-4,-37,-9,-2,-12,-4,-13,-26,25,-21,-16,80,-7,-45,63,-31,64,-23,-34,23,-40,-67,-66,48,-18,41,-46,0,-80,36,108,-15,-27,-58,-26,-58, 
  /* [208][0][][] */ 55,57,-13,-96,40,-65,26,10,-11,-40,1,-18,-15,-31,15,-13,2,-9,-29,26,-29,-42,100,10,62,1,-64,-11,-7,44,9,127,-26,12,36,13,72,-11,-68,64,28,36,47,53,3,-17,-46,15,22,-68,1,56,-27,-24,-53,29, 
  /* [209][0][][] */ 4,-48,8,-28,-13,61,30,66,-21,-73,18,54,-17,60,53,28,101,-10,-98,39,116,8,18,37,-42,31,-63,25,28,-54,104,-24,62,-8,-74,-38,9,-124,-75,12,-7,-4,27,23,41,19,34,-77,-30,-21,-127,34,74,43,-99,17, 
  /* [210][0][][] */ 106,-7,-72,-88,103,3,11,2,10,51,10,51,-38,7,115,32,73,61,-17,100,-50,13,33,1,8,67,-2,38,86,-76,58,-5,-29,-16,-59,93,-45,33,57,48,17,107,-5,-127,34,-49,21,-23,-37,-26,103,17,46,-13,65,-95, 
  /* [211][0][][] */ -90,-40,29,-12,11,-82,11,28,-24,37,-33,-2,123,-25,-43,36,40,-18,12,-1,80,65,4,16,-15,42,49,27,-94,70,8,-66,-84,-8,4,-21,114,-24,-64,1,56,15,4,70,-52,35,99,-127,-36,-38,-45,-52,32,11,-24,-56, 
  /* [212][0][][] */ -41,67,60,-16,-54,-89,51,-26,47,-43,-21,12,-49,5,20,-13,56,-4,53,-30,39,-33,46,25,60,4,-127,47,46,0,40,25,-3,-18,4,8,-76,63,7,63,37,45,-9,-49,-50,-47,-20,22,-60,-20,20,17,-4,-9,-6,74, 
  /* [213][0][][] */ -22,14,-86,-49,-27,-81,-77,-32,36,81,-30,-53,38,-127,25,-41,-59,-37,-93,9,-105,78,23,87,-3,3,-24,24,21,60,-34,83,-105,22,-38,-45,113,-95,83,-58,-74,-112,49,-13,23,-101,62,29,50,-82,-56,-4,2,72,87,-52, 
  /* [214][0][][] */ -76,-36,-46,38,-11,1,-89,8,-40,48,-22,-75,55,0,-43,47,10,-29,-16,25,-55,-14,76,-10,-69,-48,-127,45,-2,29,6,-13,2,-58,29,11,11,-84,3,15,-6,-60,87,-5,1,31,26,-34,-74,8,3,30,-33,53,-22,29, 
  /* [215][0][][] */ 107,-55,13,-95,-9,-95,-58,39,105,81,59,-18,-33,86,32,3,-57,22,23,-7,-46,-49,-18,11,44,73,-47,-57,-18,95,-127,-28,56,76,-41,-31,119,44,-84,111,-109,-47,32,17,6,-123,101,39,37,-106,-20,-78,23,-8,-98,23, 
  /* [216][0][][] */ 16,-68,57,23,34,-97,61,42,50,-101,82,-29,60,-121,121,69,-8,-14,-117,77,-85,-29,69,73,119,99,41,-19,-16,-2,37,45,82,-57,-14,125,47,28,-121,126,-48,-127,-41,-42,-40,86,13,59,16,-29,-10,63,42,-40,84,95, 
  /* [217][0][][] */ -20,-72,-53,-28,15,-65,-23,-64,-42,59,-1,-24,52,77,61,-34,9,73,-41,-70,-125,-11,-49,43,-17,25,-48,5,22,1,40,-17,26,-19,-5,42,32,13,-42,-69,83,-54,114,14,-48,-127,-57,78,-44,-55,-33,70,-14,-34,-39,-58, 
  /* [218][0][][] */ -65,0,2,-14,21,18,-112,26,54,-24,-20,43,-23,-37,49,62,-28,85,29,-127,-21,10,-61,57,37,-19,43,43,-25,28,17,3,69,-52,-73,-37,59,19,43,-32,-64,-49,60,-17,-57,72,67,-9,3,-24,26,-21,-20,-28,10,39, 
  /* [219][0][][] */ -14,-32,58,51,-3,16,25,-55,20,41,-42,37,34,-27,-4,-95,2,3,-55,-127,68,-61,97,97,14,14,52,-60,45,38,71,13,45,-26,-42,-14,23,70,4,-7,-2,-45,3,-21,9,57,27,96,-18,23,-3,15,-43,-108,-54,-7, 
  /* [220][0][][] */ 37,-61,67,7,36,51,17,17,6,19,-66,-61,-24,42,19,31,29,35,-61,7,-49,-13,-69,-68,61,75,-68,-3,26,5,82,127,10,-12,64,108,20,35,-41,30,-32,56,85,-12,-52,-24,-10,63,12,-44,-28,8,42,25,62,11, 
  /* [221][0][][] */ 37,115,54,33,-33,51,-27,18,51,-9,-65,24,15,-26,-2,49,-35,41,-22,-13,38,72,-56,-127,-47,52,-51,20,-26,0,-32,-36,7,27,46,10,32,108,61,56,-67,26,-43,13,27,-26,12,57,32,66,-41,-32,-24,34,33,-58, 
  /* [222][0][][] */ -127,22,107,-60,64,29,-55,-45,111,-1,29,52,-123,14,-26,-65,29,-34,63,-30,-17,-65,-101,-48,-37,-22,25,79,-21,44,35,-32,25,-122,-64,-50,15,-93,-79,-65,88,-49,61,-51,19,72,-33,-19,49,12,70,-42,-43,85,-19,-7, 
  /* [223][0][][] */ -74,-47,-42,-42,127,-97,-28,29,-59,-69,19,100,-37,9,37,2,62,-9,86,-62,-38,78,0,58,-40,-107,31,-24,-19,-68,22,-45,19,72,11,-39,-14,-12,68,97,-68,-2,104,-49,58,23,-23,41,-67,-67,-62,11,18,-14,2,-41, 
  /* [224][0][][] */ -59,-123,-36,49,-69,56,28,-85,-64,70,-47,-33,49,46,-37,-41,25,50,55,-48,-62,127,-22,17,7,-48,-17,36,121,77,63,21,-23,51,4,33,-23,-12,-59,86,-61,0,56,-35,-4,-76,-14,-72,41,-14,-24,77,93,32,-12,19, 
  /* [225][0][][] */ -81,-61,62,-25,-28,56,5,-45,33,-92,126,7,-16,82,8,-53,-14,-1,70,21,-60,67,84,-45,54,-40,70,0,-27,8,51,98,-73,-54,-92,-80,-28,-93,-13,2,-10,-6,13,1,42,-9,-27,115,-31,-16,-127,115,-16,-11,-41,-68, 
  /* [226][0][][] */ 13,16,23,-7,48,-15,53,-37,-50,63,30,-55,34,-30,15,127,-6,8,-41,-25,47,-47,23,46,54,69,115,13,6,-62,-6,-99,64,31,10,24,-2,-8,4,16,-25,9,-3,66,6,38,75,27,-47,-21,79,-10,103,31,60,52, 
  /* [227][0][][] */ 33,-68,2,23,-4,-64,-44,-47,47,24,-25,21,-112,25,7,51,7,-88,14,-63,79,-61,-28,47,-45,-70,127,16,26,-23,-72,-14,14,-62,21,-20,24,-9,-22,83,-109,-56,1,43,65,-7,18,-96,6,-33,35,0,-4,-29,38,20, 
  /* [228][0][][] */ -1,-9,-8,-8,-34,28,59,77,127,-3,-74,-4,41,-58,48,-67,-36,57,-19,-90,15,55,66,-2,-8,97,-88,-57,-24,-53,43,-28,36,-35,50,21,3,39,-73,-119,-35,57,-39,31,41,24,22,-2,87,-32,-110,86,-91,39,36,-32, 
  /* [229][0][][] */ -14,-127,-1,61,-18,3,-72,-48,-24,-29,14,62,-51,13,20,40,-21,-29,37,-55,-62,-49,-24,-40,-2,-78,73,26,-51,5,-27,-23,-30,5,57,7,-11,-44,89,99,52,-1,15,-70,-19,-13,-79,57,-44,1,-12,6,34,44,6,59, 
  /* [230][0][][] */ -16,-10,-65,-1,-21,-54,-65,-83,27,1,-4,40,12,4,-44,25,-19,33,27,-13,-68,6,2,-127,84,8,-27,4,-22,44,-25,-25,9,-30,-43,73,-48,-30,40,-31,-33,62,37,-38,34,29,-50,-22,0,-24,-69,-34,47,-29,-15,55, 
  /* [231][0][][] */ -21,30,-81,-32,-11,5,-61,6,-10,-40,15,36,28,-48,117,13,-42,-8,-27,25,-108,33,-19,78,-56,6,-82,-25,-84,89,-51,-42,83,13,-8,-34,-34,-74,36,0,21,-30,4,53,0,-37,-15,57,-12,-117,10,28,23,99,-127,-47, 
  /* [232][0][][] */ -19,127,-22,20,31,9,22,16,10,-12,39,-48,10,88,31,-20,-44,-47,-81,9,2,-57,-67,7,16,-50,-22,4,-16,-32,-65,-33,-17,-9,-63,15,-58,42,-16,-5,12,11,10,-41,-36,-42,-61,25,5,8,-31,-26,-6,30,63,-1, 
  /* [233][0][][] */ 49,-76,-111,-2,-33,42,-21,-37,-90,43,53,35,-62,31,27,-14,-28,-82,17,-6,-31,44,-70,-97,38,-127,-57,-65,105,23,-65,61,-52,-26,-11,-11,36,-66,-60,-52,-17,-35,-53,4,-45,-38,-11,50,95,12,-100,102,-51,93,-45,35, 
  /* [234][0][][] */ 64,-25,-20,-28,48,-112,98,-40,-9,-72,-32,-29,-27,1,-21,-49,65,-50,116,26,-80,-44,36,-77,58,0,-25,49,-9,-87,-18,41,66,39,-31,2,-85,19,46,-80,5,4,-28,-66,-42,55,-101,9,-9,31,80,-20,31,-13,48,127, 
  /* [235][0][][] */ -38,79,-65,-53,13,-104,-34,-86,21,-21,14,-75,-18,23,-14,3,-66,40,-12,74,127,-12,-2,32,-15,16,76,51,17,7,-23,29,-44,-46,-43,51,50,29,55,-58,23,47,-27,-8,12,56,-108,25,-66,-81,45,57,82,-91,-21,89, 
  /* [236][0][][] */ 45,-72,-4,49,-94,-9,127,-41,-25,-64,-2,19,29,-6,3,73,-46,-4,19,55,-44,7,27,96,97,69,-73,54,-8,-19,-52,12,-78,83,12,83,-124,51,-53,93,-104,12,66,-13,-53,-23,33,-8,-38,-77,-36,83,2,-12,31,23, 
  /* [237][0][][] */ -42,11,-69,51,-17,-37,-58,-20,0,5,34,54,-74,14,-45,-21,-42,66,13,3,-77,-6,14,-65,12,-117,-72,4,-27,3,-50,-23,5,-56,18,45,-60,15,22,45,51,47,-21,7,-39,-19,-23,-9,33,43,10,-37,10,-56,127,27, 
  /* [238][0][][] */ 50,-43,-127,-71,7,-35,-73,23,61,14,-20,-30,5,43,17,28,-1,39,-29,-5,48,-49,-60,45,4,5,-101,2,-15,26,-27,-8,-5,11,-68,38,-29,72,6,-29,8,-71,40,43,9,-31,-52,18,26,22,5,3,23,9,31,-7, 
  /* [239][0][][] */ -18,-14,14,1,-6,67,2,12,-18,-28,5,55,66,72,-2,20,45,49,-90,13,29,21,-23,-45,45,42,62,-4,14,-39,113,56,-38,69,-44,-67,6,-88,48,-31,50,66,-35,-44,-51,-55,1,-94,-127,-79,13,21,6,6,-8,75, 
  /* [240][0][][] */ 47,22,-8,21,-47,70,43,52,18,-9,-16,-2,-35,31,9,10,36,-8,-40,2,-16,-47,-24,-15,-11,26,-13,15,-17,-18,-13,32,51,23,22,-33,20,-13,-5,15,13,-59,-20,-4,-1,-63,36,10,22,8,-8,-23,-38,50,-19,-127, 
  /* [241][0][][] */ -100,-53,3,-11,-16,-55,-105,8,41,1,29,-72,-97,77,105,74,100,58,65,43,25,7,-105,-51,-1,-55,36,-38,-60,69,-71,-119,-13,61,9,25,-99,-57,-74,-73,-14,-99,-54,-93,0,51,82,127,37,-44,85,-30,69,-46,-74,-48, 
  /* [242][0][][] */ 37,-52,7,18,7,4,71,74,-55,74,-4,-127,37,37,26,45,7,30,-52,-27,-66,-32,106,-21,24,-22,-32,-7,-12,-75,-14,-20,-3,-78,-54,62,1,5,0,-48,7,27,-20,76,14,42,12,51,77,-11,-2,-9,3,3,28,-14, 
  /* [243][0][][] */ 45,55,109,-31,100,-8,-96,-4,30,47,6,-102,42,-105,113,21,87,10,66,-52,-1,51,34,-65,-72,-31,-13,-56,-7,52,64,6,53,-20,7,69,-23,1,-14,113,27,29,-15,34,-63,-5,12,43,-84,7,45,-127,-59,19,-89,32, 
  /* [244][0][][] */ 8,46,32,53,-33,32,0,70,-11,28,-75,-49,10,12,-4,-127,37,28,37,-58,26,-51,6,11,-6,-41,21,50,30,-35,28,19,20,-102,-17,-4,-5,-11,-19,36,19,19,26,-12,36,-16,40,-17,89,0,-10,-7,-6,11,-60,33, 
  /* [245][0][][] */ 10,2,5,-19,14,-54,-42,26,-34,59,5,-24,78,27,127,13,-4,35,-76,-44,-16,39,50,-23,14,13,-1,27,18,73,3,35,43,35,-75,-53,-25,3,15,6,24,46,8,11,34,21,19,-92,71,15,54,12,32,85,8,-16, 
  /* [246][0][][] */ -63,-8,-51,17,4,-127,40,51,-92,-65,-34,41,18,68,-7,-127,-33,13,25,13,-14,73,-123,73,115,-61,37,24,6,-91,-52,93,-46,-17,13,81,26,124,53,21,-23,45,10,-37,9,34,11,10,32,107,15,-7,-2,22,-59,56, 
  /* [247][0][][] */ 60,6,-22,-127,-57,47,-29,66,52,3,-33,-3,30,-110,3,-10,-10,-8,12,71,-76,2,60,-102,35,13,-62,48,-43,-5,-72,80,-23,69,-26,82,38,-52,-23,92,99,-80,15,31,-24,20,16,30,-29,-93,-11,16,-12,59,3,34, 
  /* [248][0][][] */ 20,93,68,-7,-14,-3,113,5,20,13,19,55,9,-93,10,27,45,-26,33,-80,-5,3,0,-13,-3,58,9,31,62,-13,-60,-36,30,28,49,36,25,-17,-3,-33,-41,-14,32,42,-39,14,46,-17,127,67,-42,-9,-20,69,20,-87, 
  /* [249][0][][] */ -24,-85,37,55,-4,11,-17,-75,8,0,-53,11,-51,-88,-4,43,2,-61,3,-43,7,24,-33,-90,44,78,39,13,-9,34,-43,-66,55,70,23,29,58,-58,-127,-37,53,-29,66,-48,-30,17,-13,3,-61,40,80,-14,-62,-36,47,-76, 
  /* [250][0][][] */ 29,14,-40,19,68,-5,-15,-62,14,23,-3,-8,18,15,26,-42,-42,34,127,65,3,21,43,36,-17,-33,0,-53,12,6,-5,53,-13,-23,18,36,-35,13,-56,-31,6,-11,-28,44,50,-16,7,-50,-44,28,26,-4,44,6,48,46, 
  /* [251][0][][] */ 30,-14,7,-41,31,50,16,-41,26,84,-26,-22,-10,76,-11,-33,-23,-45,19,-127,-48,38,-37,3,-59,-50,-43,27,40,13,43,25,-30,3,-6,10,20,7,15,21,10,-48,-1,82,27,-25,70,28,-7,-67,-28,-23,-10,-5,-26,55, 
  /* [252][0][][] */ -59,75,-16,87,34,95,-2,38,1,46,70,-28,14,-31,-30,20,-61,37,110,6,38,-17,89,-122,35,112,-53,41,45,109,73,35,-67,-101,-26,-7,6,-83,-32,1,4,-69,40,-21,91,-15,-53,64,-15,-33,-53,31,-37,127,37,-63, 
  /* [253][0][][] */ 81,32,-19,19,-13,77,11,-127,-3,91,-27,-39,100,50,31,72,-67,-27,-83,-51,52,-68,6,27,-33,-21,39,-60,-8,-22,-6,-36,-18,-85,88,-26,37,-45,-69,9,-51,61,-67,41,17,13,-49,9,-25,-13,-75,-46,-6,-58,-4,-58, 
  /* [254][0][][] */ -41,-44,-29,59,-9,68,-16,-34,34,72,6,-10,-43,82,35,3,24,32,-26,-83,-82,63,54,-8,60,-4,-9,55,10,-84,44,118,-75,101,83,47,-95,83,27,-32,52,-18,72,-39,11,52,127,19,-115,55,34,-62,-28,20,-23,-104, 
  /* [255][0][][] */ 82,30,-14,-3,40,-24,-46,-37,30,55,11,-10,39,18,-32,-12,1,7,13,28,-95,102,-15,13,55,-26,81,-79,27,-32,-47,-64,-29,-10,9,43,52,-46,7,21,-15,9,3,-61,19,-67,-66,-22,52,-19,24,-44,-41,43,23,127, 
  /* [256][0][][] */ 53,-12,-7,108,-28,-45,-37,1,1,49,17,2,10,71,1,78,-60,-35,-9,8,-20,13,-83,5,-21,-60,123,7,27,-68,-107,38,39,5,-40,-62,74,-62,-127,-35,-13,-3,-33,-65,19,70,-93,16,-29,-12,14,-30,24,20,101,19, 
  /* [257][0][][] */ -100,53,-64,-42,-54,84,-21,25,37,31,-48,11,-42,-27,38,26,-62,69,6,-57,-40,-6,5,-41,-4,-19,79,34,54,-1,-6,-20,2,-41,45,12,89,51,-109,16,-47,-64,-28,-12,-13,-53,127,0,-100,-34,-107,-17,52,-44,68,-18, 
  /* [258][0][][] */ 87,-124,67,49,-29,80,18,-101,-15,-33,-118,-70,41,59,86,-115,-44,114,-16,-84,-47,-124,-122,42,18,-31,21,54,10,-103,39,-127,-28,-52,15,52,-58,4,-79,-97,-20,-94,73,6,-59,41,25,40,-92,-4,-63,-57,33,-38,-29,97, 
  /* [259][0][][] */ -51,59,-16,-52,20,-33,-19,13,-15,63,-15,-107,-12,15,-60,-14,98,22,-97,47,-6,32,-67,17,33,118,44,-114,14,-39,-16,-27,68,-2,82,-37,52,-9,35,-17,-48,127,21,-95,54,60,-10,17,21,20,-3,-5,29,-90,22,7, 
  /* [260][0][][] */ 18,12,111,-25,-54,20,106,3,-41,28,12,-1,111,10,24,37,46,-39,-27,-27,10,-67,-2,-17,-16,-67,73,-8,40,-37,121,93,54,-37,-124,-67,50,-34,-45,-109,64,-25,-58,-7,47,-64,-5,-62,13,4,-62,-15,21,-3,-71,127, 
  /* [261][0][][] */ -1,127,20,16,-11,-3,50,27,26,-121,-49,27,-45,78,-9,-19,-41,24,13,7,-21,-75,35,21,57,-48,53,24,62,11,44,-32,30,-10,45,16,-42,36,48,29,13,93,-25,39,-19,-48,-19,40,79,-50,73,2,-26,-6,-37,-95, 
  /* [262][0][][] */ 22,-31,40,-3,-22,-60,28,-42,44,-50,-25,-7,41,-65,7,-45,-52,8,-5,29,24,-119,13,-31,-9,-33,-56,70,60,-9,-21,13,-1,-1,56,33,-32,-52,0,2,-10,44,-13,-27,-28,1,-24,-14,12,11,-23,-21,-13,-10,-127,-69, 
  /* [263][0][][] */ 42,82,106,-38,65,42,-90,-30,-8,-93,74,-47,36,-4,-16,-25,102,-36,59,92,57,107,98,127,-108,35,28,23,34,-111,37,-37,-14,55,-19,-42,-101,-39,-17,60,69,-41,124,35,-27,32,68,48,113,42,5,74,-62,-23,106,-55, 
  /* [264][0][][] */ -7,-46,26,-34,-16,55,-23,-39,15,-2,21,34,20,-14,1,-42,-12,-27,-5,-11,-13,19,27,1,24,1,24,-4,-62,22,-82,-9,12,11,-42,-22,37,-68,23,57,6,-127,-58,-45,28,-9,-3,-12,-9,-16,-20,-59,30,-15,46,13, 
  /* [265][0][][] */ -70,78,47,1,28,53,59,23,-27,127,-18,-13,31,78,-86,31,44,23,34,115,-18,-33,44,77,101,-3,3,51,5,-33,99,61,30,79,-68,20,16,78,50,4,4,124,48,-20,88,-14,-13,11,-51,82,-72,40,-15,-28,51,-30, 
  /* [266][0][][] */ -26,-17,26,-45,86,-54,-3,-7,-60,-51,50,73,19,22,60,-54,-10,-14,55,-30,-21,51,-77,68,-25,0,25,-38,-7,-2,-15,-70,-20,-89,5,-37,23,-44,-34,-97,-5,-49,56,-42,-33,50,-62,-127,65,-29,8,8,-82,28,34,-30, 
  /* [267][0][][] */ -21,85,-16,-2,61,-100,-44,-23,47,-53,-32,9,-18,-67,71,-11,94,-25,75,8,-72,-56,-16,8,-59,-28,50,-79,-31,-30,-84,-4,31,-66,-8,-63,115,-44,53,-125,-4,-13,12,-50,-37,127,24,-21,40,4,17,-45,-39,78,-80,-13, 
  /* [268][0][][] */ -34,45,12,-79,-42,-28,11,-67,-18,-32,-71,38,20,-31,-45,37,93,-38,13,17,-29,23,81,62,51,-48,-5,14,72,14,42,9,-12,-75,-111,83,-42,23,-56,-4,4,-38,38,79,14,127,-69,-65,-47,-36,-25,74,36,-37,-75,61, 
  /* [269][0][][] */ -26,-60,-6,5,42,-6,36,-18,10,-1,-6,-9,38,65,-25,6,-57,0,0,12,-32,-46,-59,29,47,-14,-31,80,-67,26,41,57,-27,24,-52,22,-33,0,26,-22,44,16,-30,30,43,16,-127,44,2,-40,-26,8,44,-73,-7,31, 
  /* [270][0][][] */ 33,-112,-74,-57,-115,-102,55,-62,-7,-8,-52,-111,127,11,-19,94,112,94,102,55,121,26,28,-32,-22,-28,38,2,-100,-102,-94,25,-81,-48,14,97,122,23,-29,-56,29,-93,-110,14,-41,117,-35,109,-67,20,74,58,51,111,-60,-54, 
  /* [271][0][][] */ 14,18,-4,5,81,-25,12,-86,-2,-98,21,63,56,-14,9,-127,42,-52,52,11,-16,-56,1,-74,-31,47,-11,-46,-42,-4,-7,-21,16,11,32,-38,104,-4,14,43,26,15,13,-20,16,-32,-13,-17,-32,-30,11,18,-19,38,-43,-16, 
  /* [272][0][][] */ 15,36,58,-63,98,-71,8,31,51,-82,-8,7,-8,-92,3,-5,-3,-17,-23,-85,-81,16,53,-79,-114,-30,-103,19,46,-49,-100,-39,95,-44,34,-90,36,-8,-93,127,-85,-63,116,41,-18,34,41,-91,25,-38,-33,6,-34,-3,13,-46, 
  /* [273][0][][] */ -36,-44,-11,-26,-38,13,-28,-90,12,-21,-57,89,-127,11,-56,116,-72,2,16,20,22,97,-25,-82,20,48,113,51,4,48,-7,58,-1,78,60,-16,-59,78,-67,57,-75,-47,-87,30,-1,25,26,22,-60,93,28,42,35,-40,15,-5, 
  /* [274][0][][] */ -42,-98,-64,-34,55,-43,-25,-11,-59,-60,-38,-8,-63,-67,83,10,-51,70,15,77,30,19,16,108,41,-21,14,0,-23,109,12,-27,-88,-10,-6,-42,-53,68,16,37,17,-38,16,35,10,31,-94,-25,-62,-13,-19,80,-47,-16,-8,127, 
  /* [275][0][][] */ 53,26,-14,-86,101,-18,-18,92,14,-71,-86,-25,88,90,3,-10,-94,64,-37,-26,58,-87,-65,24,101,5,-10,-96,-16,-3,0,-2,31,6,6,4,8,50,-30,42,39,80,66,-101,95,68,-103,-85,-68,45,-59,-33,-29,-127,63,7, 
  /* [276][0][][] */ 10,-60,-84,-73,2,90,51,-62,63,23,-73,-24,-116,26,70,-16,0,90,-51,-75,-38,-47,3,-17,47,-23,81,22,-18,-6,18,0,20,8,9,70,-108,17,93,89,-70,-14,25,-34,32,-49,-118,127,6,9,52,42,-28,56,60,-12, 
  /* [277][0][][] */ 82,116,4,103,6,3,42,-108,65,72,50,25,72,68,5,29,-127,-78,97,-6,-22,-12,6,-64,-50,43,-15,3,75,-28,-54,-6,-59,-48,111,109,-68,-12,35,8,55,69,-36,-9,-67,37,33,-25,-10,-7,-21,66,-45,8,-78,-44, 
  /* [278][0][][] */ 4,13,25,5,19,-50,51,26,-4,-11,46,-10,77,84,-62,48,51,-21,-11,-6,75,0,-90,37,127,-23,26,18,48,-22,-63,0,30,10,-49,-9,10,-49,-13,-37,-70,-86,17,-84,-9,-1,-23,70,-28,90,1,-16,-7,-4,46,-19, 
  /* [279][0][][] */ 21,49,-69,-100,47,2,-23,-26,-125,66,-5,-50,44,72,-16,1,42,-39,-47,77,52,-19,20,3,5,46,-2,-48,-8,-5,76,-7,35,53,23,36,63,106,2,6,5,35,127,-45,-2,-35,-38,60,61,-33,-37,-51,32,-13,-25,40, 
  /* [280][0][][] */ 20,-15,16,23,0,-59,-34,19,-70,-8,-40,29,-38,-17,-9,-54,53,91,-66,7,38,-74,47,2,-33,85,6,-27,-31,-17,34,36,-14,-41,-18,32,-32,19,127,-6,23,13,-67,-25,76,-15,11,1,10,-27,23,-69,18,16,-39,-29, 
  /* [281][0][][] */ -127,50,-79,26,-45,-84,16,-12,82,-2,-5,-2,-27,86,81,-48,-60,50,60,64,-31,-26,66,8,19,-9,-56,-25,-19,-29,42,-37,-52,-58,20,-61,126,35,-57,39,74,9,42,57,-2,-109,18,-39,-93,-5,6,-47,-18,63,57,-16, 
  /* [282][0][][] */ -25,59,52,5,-19,-7,30,-2,-7,-5,-24,14,16,-15,2,-19,4,47,-32,24,-16,-22,-26,26,-52,-29,14,-127,10,-46,-13,21,31,-27,-8,-3,38,-43,-41,-72,-32,-19,17,2,-14,-23,-19,-2,-43,17,-9,18,25,-14,-17,61, 
  /* [283][0][][] */ 40,-24,82,-22,-28,-18,126,46,32,19,64,-66,-56,-25,40,-40,-63,-36,102,15,72,81,36,-3,44,-34,49,63,127,55,49,-26,-81,-21,-27,13,-48,-11,53,-61,7,41,-61,94,-108,-23,-10,74,11,69,1,34,38,-34,-4,-7, 
  /* [284][0][][] */ 71,-11,68,-15,27,0,86,5,3,-66,-4,-94,9,67,2,19,8,-27,-41,12,-13,-70,114,-36,39,20,-20,78,-15,-35,-23,35,1,-28,44,-27,7,34,2,38,-9,71,-22,21,-40,-5,42,-32,-37,-29,78,82,-39,-51,-127,51, 
  /* [285][0][][] */ -20,52,-35,-12,-14,7,-36,4,79,49,84,-64,-11,-69,49,127,-36,-47,-9,-36,-99,0,54,42,-4,-59,43,69,72,-29,31,58,7,-21,21,91,40,49,-42,-9,-58,-15,63,75,55,43,77,11,33,36,-1,58,-53,-40,57,-4, 
  /* [286][0][][] */ 47,-16,-45,16,-10,45,-16,120,-50,-2,24,-37,1,-56,6,65,95,9,33,-66,-48,-83,2,64,-5,-30,-39,87,54,-127,-6,11,39,4,-26,-79,-69,113,-93,-48,39,29,8,-69,78,27,-16,-8,-22,64,-75,-61,42,9,45,78, 
  /* [287][0][][] */ -73,-39,-29,32,-3,15,-64,-15,-19,25,-80,-21,-54,-24,-39,-5,8,-64,-36,-11,-32,20,-53,-44,35,-24,-24,14,-5,53,22,94,70,-5,-97,36,-71,-55,-127,-35,76,21,108,-2,-6,-17,22,82,28,61,3,31,-80,29,39,28, 
  /* [288][0][][] */ 7,7,-59,-86,-7,23,93,37,-52,7,-57,91,17,8,-61,127,30,-14,-62,35,-35,50,82,-107,7,16,-54,74,-38,7,-33,3,-30,110,2,10,-71,3,24,55,68,71,-100,-31,-21,-55,25,50,-82,-51,54,-29,77,-3,-39,31, 
  /* [289][0][][] */ 12,-103,-36,5,-30,-40,0,29,99,-5,-48,-19,18,3,23,-72,-22,-88,-6,31,-57,28,64,9,-3,60,-25,60,-6,83,1,2,3,57,-45,11,-63,-45,-35,-31,27,-64,-74,2,-79,-15,-62,-127,9,29,-34,65,23,-43,14,-4, 
  /* [290][0][][] */ -88,-17,6,-36,-45,36,-33,-28,-47,23,-31,2,27,-21,13,-34,-127,-2,30,-56,3,-92,55,40,64,-22,49,-10,-26,63,70,2,35,-55,-65,-11,23,99,9,-96,-7,52,13,-13,-73,48,-20,19,19,-19,1,-77,-13,-117,3,38, 
  /* [291][0][][] */ -30,24,1,0,-5,26,-23,-49,-23,-30,-3,37,3,-13,-6,6,4,86,-23,43,35,35,-43,-47,-78,-97,-1,19,-49,-14,1,-61,-34,114,94,1,25,-39,49,10,19,-39,-7,-61,-30,4,127,51,46,74,81,-26,42,-102,5,19, 
  /* [292][0][][] */ -56,-27,90,46,52,-3,5,-40,-21,-91,-50,32,4,-3,38,-62,-40,-24,54,38,-16,99,47,-127,-43,-55,0,-46,33,43,-42,21,-39,-93,48,16,5,8,51,74,-74,39,-60,-48,-25,0,2,54,52,26,-40,-51,98,8,-68,-13, 
  /* [293][0][][] */ 29,-42,62,23,-15,58,-72,-49,69,-37,47,-19,-80,-27,38,110,-50,-82,-127,-96,-45,-72,-13,51,45,-67,-67,21,-20,-55,48,-50,81,-23,27,-63,-40,-91,-1,-22,55,1,-18,-21,-72,-36,-35,41,-15,24,-7,-100,-16,-20,2,-62, 
  /* [294][0][][] */ 89,-45,-10,19,61,10,-50,55,38,31,-7,-2,87,-29,-67,-51,-49,31,-72,-18,-57,55,-33,-20,68,31,-32,-23,23,55,55,-25,-24,-44,15,27,-1,-25,21,-55,-37,14,-2,-7,-36,40,32,-25,-127,-43,43,23,12,-10,50,-8, 
  /* [295][0][][] */ -35,17,-19,4,0,-47,-1,-49,-2,-32,45,-54,85,-4,127,6,41,-42,-43,-41,9,68,15,35,-57,-58,-8,-75,-29,-42,-69,38,52,-69,50,-58,23,-15,-4,32,-46,-51,3,-19,-6,28,-64,59,-39,11,-3,12,99,-60,125,-4, 
  /* [296][0][][] */ -24,10,-64,14,-23,51,106,97,-29,53,-37,61,61,38,36,32,127,-12,-15,95,-30,-8,48,-94,27,22,-4,67,98,1,92,-3,-47,-13,13,12,27,110,14,39,71,61,-31,21,73,21,-55,55,-92,28,19,5,39,-2,-6,7, 
  /* [297][0][][] */ 31,58,-49,92,-44,34,-7,81,27,93,-69,50,-110,86,71,0,74,36,15,8,55,-7,-68,-9,-19,-35,0,41,15,7,69,10,12,-67,45,34,32,-54,-19,-44,66,29,-28,-58,127,37,99,96,-30,6,12,-80,62,50,-103,-57, 
  /* [298][0][][] */ 30,-79,35,-42,-63,-75,-7,-26,61,-19,-5,51,-5,-15,68,-3,63,-9,-127,-10,36,-2,-14,12,-29,-104,16,-65,-16,-25,103,58,43,59,-16,-61,3,-60,8,-39,58,47,46,-35,40,-54,17,65,-91,37,-63,96,18,22,-72,54, 
  /* [299][0][][] */ 38,-10,17,0,-13,24,-24,-20,1,-127,-33,51,9,-32,91,66,-39,-88,16,48,0,23,-75,-11,49,-29,8,7,-20,-35,65,8,13,27,4,-46,64,-81,-57,-50,49,-36,-47,45,2,-34,30,-84,-53,-19,-43,21,100,34,-50,79, 
  /* [300][0][][] */ 68,0,9,104,-70,-44,-11,-53,24,-10,-71,5,19,-16,-93,-3,-32,-51,-42,-65,-72,-72,19,15,-17,58,-28,5,69,99,9,-127,36,35,52,-38,88,-54,-9,26,-20,-23,-27,6,-5,-23,-85,-7,40,-48,-62,60,-16,-45,64,73, 
  /* [301][0][][] */ -61,24,-1,-48,-26,-67,-116,40,1,10,21,17,12,-56,-22,-17,-12,-69,22,80,50,68,0,-117,1,-35,-16,12,127,-6,-22,-56,21,10,27,27,-59,-1,-16,-24,-58,-56,7,4,44,-73,47,-12,11,65,84,-32,-57,84,13,82, 
  /* [302][0][][] */ 21,-9,114,-13,10,-37,10,-27,-69,22,62,78,103,-42,-18,104,13,78,36,14,14,-81,-20,35,1,-20,-10,-13,-60,-10,-118,-82,-36,108,-90,22,56,-71,-117,-82,39,59,33,57,82,-4,-85,5,38,-127,-65,15,-90,15,-114,5, 
  /* [303][0][][] */ 2,71,-83,81,5,65,11,-35,38,6,108,42,-50,3,-4,-10,-34,-44,7,-127,-52,-22,-52,-53,45,11,-35,-11,62,6,42,1,86,-82,-12,-43,-76,28,12,8,23,6,-37,75,54,-5,68,49,-96,2,-16,-21,58,47,61,-99, 
  /* [304][0][][] */ 122,115,-59,-59,-69,-1,18,-124,71,-1,35,44,-42,20,-19,56,9,-28,-69,49,103,-117,93,-114,19,-95,97,-81,-39,23,48,-36,22,55,-71,-107,77,-116,-36,7,119,96,3,-39,48,-127,-12,-5,-40,-35,-47,-83,61,-30,44,4, 
  /* [305][0][][] */ -44,-16,66,-6,62,7,-79,99,-20,105,13,-66,96,1,44,-41,30,64,-127,21,31,-36,79,81,75,33,-56,20,-4,50,61,-21,47,57,-16,-44,-17,68,-4,1,-35,43,-70,49,37,30,71,-24,-32,73,-22,29,-78,-47,-15,4, 
  /* [306][0][][] */ -85,-14,63,-5,-32,-85,-96,-76,15,-68,-127,0,-24,-6,-21,25,23,-46,-31,-17,43,0,-56,-86,50,-18,-7,-77,-16,67,92,37,60,-53,37,-19,-1,3,5,-40,-3,34,100,-8,-22,-6,-39,33,-93,-87,15,-93,-1,-6,28,47, 
  /* [307][0][][] */ -5,34,18,16,37,39,53,127,-38,-51,7,-57,-27,-12,55,10,41,-40,-16,-20,42,-27,-38,96,-68,-36,13,-60,20,-45,-6,49,12,17,55,-30,28,39,-95,22,14,-62,20,-13,6,-37,52,-33,-29,-22,36,6,-59,60,55,-59, 
  /* [308][0][][] */ -48,-105,50,-99,-22,-101,78,119,-33,-33,51,9,15,18,111,-93,47,67,17,88,19,76,79,97,2,-15,-34,25,-97,-88,41,16,-127,-57,-26,-106,-43,73,-30,-18,65,5,-35,-9,93,-52,-19,-28,-18,3,-54,30,34,27,-50,44, 
  /* [309][0][][] */ 127,16,-16,18,30,-63,1,-12,-18,-14,23,-20,24,33,71,29,43,-15,-21,51,63,42,-65,28,-53,-47,72,91,-33,-25,-29,-44,-3,28,45,-64,-27,-60,-33,34,-22,-49,73,9,-8,-17,22,-26,-4,-20,67,54,9,24,61,-48, 
  /* [310][0][][] */ 21,-45,0,-127,-19,14,-52,28,-18,-37,11,-55,46,-55,-52,36,-6,84,51,-42,67,0,65,-5,14,-29,-54,88,44,-25,-33,45,103,-49,24,-7,-60,34,-35,-2,-10,5,7,-64,-28,25,20,-65,-4,7,71,17,45,25,66,109, 
  /* [311][0][][] */ -1,76,-96,-46,46,31,-50,-99,4,-93,-25,8,-44,51,67,-51,-58,-13,-51,94,39,-9,-50,78,-25,-125,-55,-17,-10,-17,14,24,-50,-27,-11,-5,-77,127,-50,0,32,-8,-28,-99,6,-30,-89,-1,25,-65,94,-5,3,-25,83,-48, 
  /* [312][0][][] */ -35,3,-20,21,-71,-68,-91,-58,1,-13,48,9,-30,4,7,-76,-83,11,2,-63,-40,84,-1,-57,-51,6,-127,-109,2,-1,-37,-45,-20,-28,-58,55,-14,43,-50,102,-27,-1,27,-18,-7,-54,3,2,0,-11,-93,-10,48,-7,81,-71, 
  /* [313][0][][] */ 3,46,-61,-1,4,-27,22,19,34,8,58,-43,39,11,-15,-50,-20,-9,56,-69,45,127,-59,-9,-42,-18,-9,19,91,-20,-45,44,109,-12,-58,0,-52,17,15,-17,50,-37,-83,6,-35,-8,21,28,61,-63,16,28,24,-7,-45,-23, 
  /* [314][0][][] */ 13,-95,-22,14,-11,-26,6,-25,-9,-127,2,11,-33,5,19,-21,-96,6,4,-54,-31,39,32,-2,48,-70,-37,31,10,5,-26,49,4,-17,3,22,21,63,-56,-47,-74,-57,30,64,-64,-51,-15,-54,26,-53,-72,41,15,-28,57,-54, 
  /* [315][0][][] */ 32,-27,-24,-5,42,-87,-12,-68,8,120,105,7,-62,21,40,-80,17,-28,-5,-53,-84,41,-92,37,-59,-12,30,-60,-64,83,-21,-72,-87,-74,-35,38,0,8,-37,6,7,27,41,75,127,47,-50,24,-5,-11,-104,35,-27,1,-23,-20, 
  /* [316][0][][] */ -68,-55,-10,26,-44,-42,16,-61,-24,-45,-71,-19,-35,-31,18,-39,-42,29,-3,-55,-7,49,-72,35,52,-48,23,40,2,-32,-7,16,-53,-9,10,37,-64,16,-25,-32,-14,-58,-47,24,-1,-127,29,-39,-13,-65,-47,-27,-17,-11,28,-63, 
  /* [317][0][][] */ -36,45,-112,6,-9,-93,5,11,-15,-31,28,-17,57,-20,-64,29,125,-16,127,69,-22,-64,93,75,98,11,-53,-98,108,-61,48,54,-10,-58,-68,39,-70,69,45,44,115,107,6,-20,7,76,-78,52,-5,13,-101,-4,67,-82,-108,90, 
  /* [318][0][][] */ 2,-25,69,-22,-51,-10,10,-24,-12,-18,17,59,25,38,-21,-47,0,46,6,52,1,-21,127,50,-39,22,4,-17,-44,-17,47,11,-69,-85,36,-60,19,-56,49,-31,-41,40,31,-31,33,-10,39,-30,8,-13,19,-13,-39,-40,43,-50, 
  /* [319][0][][] */ 13,20,1,28,-39,-30,-54,-32,20,14,18,-72,23,-21,10,44,10,-4,1,-47,48,-38,75,7,-7,3,-63,4,3,-33,84,27,-54,44,-6,30,-41,-61,11,3,-68,113,-42,-58,-35,-10,-42,-89,127,-26,-36,63,34,-13,11,-33, 
  /* [320][0][][] */ -41,9,-26,-21,-24,29,29,39,58,25,28,9,113,35,97,50,73,-3,-7,49,55,31,-63,-47,-80,93,19,71,82,5,-18,-64,66,20,-7,-5,-2,-52,8,-28,-3,13,1,-5,-54,-44,-20,103,-42,-88,-40,37,-1,48,-127,-88, 
  /* [321][0][][] */ 82,8,55,51,35,-34,76,4,4,7,58,-85,-20,18,-17,53,-15,-63,20,12,62,-7,-18,45,-127,-44,90,-16,-35,2,-32,-101,24,78,40,-73,-32,-14,-65,-18,28,40,-11,11,13,-47,-5,-2,18,-52,76,67,2,11,29,-66, 
  /* [322][0][][] */ 60,25,-19,-35,60,1,-23,32,44,-85,59,-36,-66,-60,-7,-8,-76,-50,-68,-57,-20,-15,38,-73,53,41,-127,-43,12,25,-117,93,99,-16,9,5,102,-82,-77,-61,51,-32,24,-6,-2,11,-36,-55,52,-28,27,62,-16,50,-76,9, 
  /* [323][0][][] */ 8,-48,-42,-19,16,36,2,26,-29,-70,92,-16,3,-3,26,-60,35,-127,34,9,21,20,-1,28,-3,-74,20,-30,10,-27,-58,-35,42,27,12,16,-107,82,33,46,-19,45,42,-38,-8,-29,-50,35,3,35,27,46,-18,-74,57,-125, 
  /* [324][0][][] */ -127,-23,-34,-79,75,46,36,92,-33,-58,57,40,15,30,-58,-63,-26,86,-35,-102,79,-23,72,58,-11,48,-90,-17,29,-45,-42,37,-32,-31,21,12,-15,-6,-114,-48,-96,38,86,-5,83,89,9,62,58,115,-40,-55,7,14,14,85, 
  /* [325][0][][] */ -32,-41,-44,23,-70,58,-24,-40,-84,65,-77,-56,-42,62,-73,14,-80,127,23,-20,46,63,-27,6,-11,-24,15,5,5,-107,-7,-40,-70,9,71,19,17,-15,54,84,-90,-58,-64,20,-30,-100,50,-10,-24,0,-5,-54,-22,-63,58,-3, 
  /* [326][0][][] */ 64,-19,46,96,-28,-7,-66,-2,25,32,61,44,40,52,-38,92,-30,-35,119,18,-58,85,40,-18,-32,-21,10,21,-48,43,-32,-26,33,-10,127,13,36,-36,-14,-24,15,-47,69,-60,-13,29,-19,-79,-106,5,27,-1,50,13,51,34, 
  /* [327][0][][] */ -43,14,-50,-80,-47,26,-3,-94,18,-21,-21,12,-69,127,5,0,15,13,38,73,-17,41,-113,54,34,-31,19,42,-47,84,56,-20,-63,7,-30,25,-75,9,-32,-44,51,1,-60,-11,84,32,-36,55,4,-23,32,-13,22,62,-19,-21, 
  /* [328][0][][] */ -82,-40,-2,55,79,25,95,7,-11,87,-29,13,-4,78,36,-83,13,28,-76,38,-127,-1,63,54,56,51,-34,1,-57,28,63,-2,-88,11,-8,-33,89,23,85,-33,45,70,8,-121,46,-69,-14,49,-26,-17,17,-7,15,-2,-11,-49, 
  /* [329][0][][] */ 0,-20,-31,45,42,-2,26,39,-7,-48,-41,8,-76,-13,73,-64,21,-58,-31,-44,-49,-127,-5,-73,41,22,35,-100,-24,-42,81,120,-11,-4,36,36,-4,25,-62,-49,34,-37,-25,34,-41,20,-70,-67,-16,-104,-27,17,38,39,-36,32, 
  /* [330][0][][] */ -26,-17,-12,12,-6,12,-13,-17,-32,-10,-42,-34,20,37,50,26,-33,-35,-39,-36,-39,4,-52,52,-28,37,-102,-82,44,-12,0,18,-57,-106,38,-15,-18,36,-8,127,-85,-49,-3,114,32,1,-40,26,-43,-52,-85,-33,46,42,-8,-41, 
  /* [331][0][][] */ 20,62,44,-36,41,24,-15,-75,-14,-38,-32,-41,6,-18,83,-7,-87,15,-127,-51,44,-53,-23,-1,-13,-88,26,2,-62,-50,47,-89,27,21,-36,-30,-29,39,-3,1,109,-10,-55,-42,10,51,7,51,-30,-74,-8,78,37,7,39,96, 
  /* [332][0][][] */ 41,6,24,-3,-8,-28,-63,-47,-34,-115,-62,16,5,-72,78,55,23,-1,-69,23,65,-45,85,-4,79,1,-42,-46,-14,46,-17,26,29,59,47,-41,5,10,-15,71,-127,-17,67,-75,-92,1,14,-73,-75,44,-9,90,-79,-4,-12,14, 
  /* [333][0][][] */ -97,58,-39,24,30,32,2,-54,-82,-1,38,-63,13,6,45,-31,85,-7,28,92,-28,-27,54,-12,37,-53,17,-7,19,37,41,-29,-44,-30,63,3,-83,5,9,-33,49,99,-127,27,42,17,-98,37,-61,-30,69,32,20,60,-47,-40, 
  /* [334][0][][] */ 17,-108,-83,63,-55,-50,-42,11,50,23,71,32,-97,-83,-72,47,19,-12,14,-23,85,-6,67,-39,-17,57,10,-65,32,-1,-52,-27,47,6,3,127,13,-57,68,-94,68,33,17,62,14,46,57,7,-12,54,60,11,-12,0,-12,-47, 
  /* [335][0][][] */ 51,-45,61,-35,2,54,20,-35,-3,33,40,-111,4,-61,-38,-88,24,46,56,97,-17,8,86,56,-61,-39,-55,91,-7,52,21,78,35,-32,-36,-63,-25,16,32,0,27,-15,9,40,58,3,-127,-8,-48,-105,-14,37,6,9,31,-16, 
};
const TfArray<4, int> tensor_dimension71 = { 4, { 336,1,1,56 } };
const TfArray<336, float> quant71_scale = { 336, { 0.0020901551470160484, 0.0017250812379643321, 0.0012803672580048442, 0.0015297122299671173, 0.0020887714345008135, 0.001307143596932292, 0.0010866580996662378, 0.0024946108460426331, 0.0012777080992236733, 0.0017890898743644357, 0.0011292933486402035, 0.0018814040813595057, 0.0021303039975464344, 0.0016971311997622252, 0.0014909293968230486, 0.0012806893792003393, 0.0015307702124118805, 0.0013086936669424176, 0.0015779423993080854, 0.0020299984607845545, 0.0016384952468797565, 0.0013525689719244838, 0.0015151776606217027, 0.0017442883690819144, 0.0014202047605067492, 0.001658641966059804, 0.0012408554321154952, 0.002014493802562356, 0.001650933874770999, 0.0018032949883490801, 0.0019448277307674289, 0.0016820675227791071, 0.0013282423606142402, 0.0017186494078487158, 0.0016108544077724218, 0.0017464678967371583, 0.0019346647895872593, 0.0018487765919417143, 0.0018915674882009625, 0.0019282274879515171, 0.0014274638378992677, 0.0018466233741492033, 0.0014683889457955956, 0.0013391996035352349, 0.0010631994809955359, 0.0020773927681148052, 0.0018379440298303962, 0.0016131367301568389, 0.0017869864823296666, 0.0016163627151399851, 0.0012710271403193474, 0.0015263995155692101, 0.0019522355869412422, 0.0014145359164103866, 0.0016679565887898207, 0.0028949948027729988, 0.0025238129310309887, 0.0017168027115985751, 0.0016294717788696289, 0.0023093398194760084, 0.0022177044302225113, 0.001718782470561564, 0.0012350298929959536, 0.0020049826707690954, 0.0012535098940134048, 0.0018168097594752908, 0.0014360989443957806, 0.0012277245987206697, 0.0013902955688536167, 0.0017736151348799467, 0.0013442657655104995, 0.0019910242408514023, 0.0015631081769242883, 0.0016952904406934977, 0.0015531620010733604, 0.0011437917128205299, 0.0013942549703642726, 0.0018030023202300072, 0.0027585159987211227, 0.0015841023996472359, 0.0021794736385345459, 0.001496100565418601, 0.0012069470249116421, 0.0014240420423448086, 0.0015842510620132089, 0.0021113210823386908, 0.0012770133325830102, 0.0017029534792527556, 0.0013554553734138608, 0.0021254029124975204, 0.0016299226554110646, 0.0017605710308998823, 0.0011444865958765149, 0.0018535470589995384, 0.0019769598729908466, 0.0014648670330643654, 0.0021606981754302979, 0.0015226474497467279, 0.0023269355297088623, 0.0014229654334485531, 0.0016532497247681022, 0.0017760494956746697, 0.0015710609732195735, 0.0022604209370911121, 0.0017630398506298661, 0.0012561698677018285, 0.0017159035196527839, 0.0012900680303573608, 0.002617749385535717, 0.0017046246211975813, 0.001823603524826467, 0.0013868769165128469, 0.0016658676322549582, 0.0016558803617954254, 0.0018141547916457057, 0.0019458660390228033, 0.0016889766557142138, 0.001832079840824008, 0.0018292312743142247, 0.0016044507501646876, 0.0017972129862755537, 0.0013341858284547925, 0.0018766450230032206, 0.0016692978097125888, 0.001232498325407505, 0.0019844460766762495, 0.0017218611901625991, 0.0014580623246729374, 0.0020279788877815008, 0.0019719775300472975, 0.0018737619975581765, 0.0016790770459920168, 0.0017972426721826196, 0.0017120341071859002, 0.0016425343928858638, 0.0010173437185585499, 0.0017170906066894531, 0.0017019542865455151, 0.0014787802938371897, 0.0013869517715647817, 0.0020611754152923822, 0.0012037842534482479, 0.0017482186667621136, 0.0027399365790188313, 0.0017353510484099388, 0.0020901300013065338, 0.0016057282919064164, 0.0014310560654848814, 0.0017449612496420741, 0.0018476019613444805, 0.0016635154606774449, 0.0018897432601079345, 0.001745512941852212, 0.0013356673298403621, 0.0013195619685575366, 0.0014960335101932287, 0.0013643314596265554, 0.0013005089713260531, 0.0016545403050258756, 0.0019637653604149818, 0.0016527296975255013, 0.0013442669296637177, 0.0016992960590869188, 0.0017680171877145767, 0.0017258177977055311, 0.0019795033149421215, 0.0015923840692266822, 0.0022855966817587614, 0.0014992912765592337, 0.0022191393654793501, 0.0017345976084470749, 0.0023298647720366716, 0.0023224859032779932, 0.0023228619247674942, 0.0021278795320540667, 0.0015117365401238203, 0.0023255355190485716, 0.0013811916578561068, 0.0023825652897357941, 0.0020222992170602083, 0.001599061070010066, 0.0015502289170399308, 0.0019612456671893597, 0.0017069769091904163, 0.0020450386218726635, 0.0018721896922215819, 0.0016775424592196941, 0.0020054257474839687, 0.0016413648845627904, 0.0012628815602511168, 0.0017163117881864309, 0.0014022828545421362, 0.0015407276805490255, 0.0019195821369066834, 0.0016796622658148408, 0.0022732105571776628, 0.0015299699734896421, 0.0018334125634282827, 0.0022340836003422737, 0.0016666374867781997, 0.0020217369310557842, 0.0024212824646383524, 0.001249179826118052, 0.00151428347453475, 0.0019808693323284388, 0.0015341107500717044, 0.0013814914273098111, 0.0018467855406925082, 0.0017042991239577532, 0.0016319549176841974, 0.0013763636816293001, 0.0013349896762520075, 0.0017628633650019765, 0.0016833720728754997, 0.0022708605974912643, 0.0017003493849188089, 0.00109970907215029, 0.0022778364364057779, 0.0019936778116971254, 0.0019670131150633097, 0.0018854065565392375, 0.001787218265235424, 0.0012904610484838486, 0.002051270566880703, 0.0017799583729356527, 0.001445296686142683, 0.0017632883973419666, 0.0014116715174168348, 0.0018436269601806998, 0.0019332958618178964, 0.0022417334839701653, 0.0018606963567435741, 0.0022715106606483459, 0.0017429676372557878, 0.0016040639020502567, 0.001695222919806838, 0.0014884616248309612, 0.001737588900141418, 0.0021483369637280703, 0.0015813021454960108, 0.0020330999977886677, 0.0014283054042607546, 0.0021655871532857418, 0.0015669333515688777, 0.0030717146582901478, 0.0026568728499114513, 0.0017638658173382282, 0.0018111505778506398, 0.0016097065526992083, 0.0011138730915263295, 0.0019288432085886598, 0.0025492666754871607, 0.001681544235907495, 0.0018625719239935279, 0.0015750547172501683, 0.001988439355045557, 0.0013858333695679903, 0.002052870811894536, 0.0014832891756668687, 0.0014632837846875191, 0.0015219997148960829, 0.00165624322835356, 0.0021200117189437151, 0.0011682407930493355, 0.0030799692030996084, 0.0014416506746783853, 0.0019377694698050618, 0.0015526500064879656, 0.0018387624295428395, 0.0021538091823458672, 0.0013361555757001042, 0.0022714082151651382, 0.0013402396580204368, 0.0013273798394948244, 0.0016117204213514924, 0.0013507968978956342, 0.0013564013643190265, 0.0015841888962313533, 0.0025977417826652527, 0.0014597320696339011, 0.0023113253992050886, 0.0019954454619437456, 0.0029233591631054878, 0.0016839980380609632, 0.0017463961848989129, 0.0020524966530501842, 0.0016059472691267729, 0.001653762417845428, 0.0015660169301554561, 0.0019134250469505787, 0.0016082476358860731, 0.0018246531253680587, 0.0012599313631653786, 0.0016586454585194588, 0.0021396791562438011, 0.0019535059109330177, 0.0015673766611143947, 0.0013876851880922914, 0.0018527848878875375, 0.0015731073217466474, 0.0016069881385192275, 0.0017435019835829735, 0.0014689784729853272, 0.0020005346741527319, 0.0017052356852218509, 0.0015864577144384384, 0.001530312467366457, 0.0021227614488452673, 0.0011383075034245849, 0.0014958301326259971, 0.00173423090018332, 0.0012410345952957869, 0.0021164894569665194, 0.0025905766524374485, 0.0017606646288186312, 0.001522093778476119, 0.0020940785761922598, 0.00097509322222322226, 0.0025804168544709682, 0.0027054105885326862, 0.0016451393021270633, 0.0016744760796427727, 0.0016578425420448184, 0.0019376266282051802, 0.0013289834605529904, 0.0019160124938935041, 0.0017146402969956398, 0.0015821573324501514, 0.001471935654990375, 0.0020970406476408243, 0.0015927954809740186, 0.0019817186985164881, 0.0018610123079270124, 0.0017560597043484449, 0.0017795192543417215, 0.0017030806047841907, } };
const TfArray<336, int> quant71_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant71 = { (TfLiteFloatArray*)&quant71_scale, (TfLiteIntArray*)&quant71_zero, 0 };
const ALIGN(8) int8_t tensor_data72[56*1*1*336] = { 
  /* [0][0][][] */ 32,18,16,31,-8,47,-74,69,-57,1,16,46,-17,-44,-12,9,18,-11,62,-34,6,62,-42,-20,57,-4,43,-30,104,61,86,31,-42,58,16,-49,-61,-26,-63,38,-33,-63,70,-55,1,-25,3,-34,34,90,41,89,19,40,118,31,13,-22,43,-56,-77,21,-15,-37,-65,-37,5,-76,-11,87,-1,-24,61,28,9,-61,-73,-43,-5,-56,38,32,-84,-78,34,-3,17,-42,37,13,-29,-2,-39,-19,-19,-18,-52,-5,16,-48,35,-62,30,13,57,47,-16,-1,-31,7,25,-20,38,-55,-28,-88,-28,-38,-16,85,40,19,10,-18,71,-62,-20,-74,-11,-14,20,-54,-36,32,-29,41,-85,-32,49,11,-19,-46,94,53,60,-14,53,-6,0,9,59,-57,18,-21,23,27,-51,11,102,-15,24,-37,-31,-19,16,6,68,-8,18,-2,44,-83,-31,-57,-2,-69,-75,-35,-32,-35,42,-27,19,-48,55,25,14,-32,-2,-127,-11,15,-3,-19,-54,41,-51,-21,36,13,-13,-51,18,-48,5,11,16,-12,5,9,-47,-84,40,-31,-96,22,-54,-52,1,60,71,-12,29,-32,-29,10,-74,-41,28,-33,63,-19,-104,-12,50,-3,20,-55,-9,-21,14,-43,83,18,61,34,-1,-54,-29,71,23,4,10,79,-26,67,-93,27,-12,12,-7,-15,25,-50,35,21,-21,-51,4,-7,6,-66,-17,7,-24,17,0,-64,-12,11,75,0,24,-20,12,-11,-56,6,39,-10,-11,-34,7,-104,37,-18,-10,-32,6,-20,77,37,-77,40,9,-63,-49,-27,-27,-72,41,68,-22,-30,-9,-70,-47,-102,-9,55,-66,-10,7,56,20,-42,93,-7,27,3,-48,-40,-8,-66,-8,28, 
  /* [1][0][][] */ -46,56,-28,-21,25,-35,52,-12,-17,11,37,2,58,-2,-44,-32,4,16,32,37,33,-20,33,1,-24,17,-7,19,44,-45,-2,-12,2,35,-5,-37,-30,-20,57,10,-98,2,-43,-2,-79,47,-44,-42,-60,51,15,-21,58,-22,18,-11,4,25,-52,0,-11,-9,25,43,10,40,13,-28,-14,37,-54,8,-38,63,-50,-97,-2,-45,34,-39,-21,67,21,-6,35,13,7,23,14,-11,44,59,-88,3,-6,34,2,25,-2,-12,-43,57,17,26,-89,-20,7,14,-9,-107,16,-64,29,-16,-4,-24,17,-24,-90,-6,-34,1,46,-36,-53,-22,-29,-15,-23,4,23,0,16,44,-10,3,14,37,18,-91,-29,-21,12,50,9,23,24,-17,12,-10,-53,-42,-17,-28,20,-59,5,-13,8,3,2,59,17,-43,-1,-15,16,-28,15,0,-5,-54,6,10,22,37,4,51,37,36,-22,-32,19,58,15,9,-46,-38,20,-127,-36,-27,3,-19,25,21,-81,-31,-30,-48,-20,4,40,-23,-26,34,30,11,48,-35,15,-30,2,-16,-74,-19,-8,5,-14,-31,-12,-31,25,30,22,-61,35,53,8,4,2,8,27,30,1,21,-6,19,29,-64,-60,-44,29,23,-53,-17,19,-29,-48,-5,34,14,-32,2,-34,40,49,-9,-20,-27,-64,9,11,7,-6,-15,5,-2,-7,67,-8,30,2,-6,-6,20,-18,-107,-20,48,-11,-1,-24,7,-30,50,-11,26,42,-27,-28,25,-3,55,10,41,53,-77,-71,-12,7,-22,-60,-36,-4,4,25,-51,-68,9,7,5,-18,7,15,12,-102,22,-20,-2,-11,-50,-89,40,18,-59,69,13,-29,51,30,53,-91,5,-20,37, 
  /* [2][0][][] */ 57,81,11,-9,62,22,36,14,-94,-16,41,-68,-22,7,36,15,12,10,-21,-26,13,49,-51,-44,65,-6,-42,-55,7,-5,-2,33,61,18,-80,48,-28,-67,-11,51,50,-73,6,-25,-46,38,-59,-17,-9,23,37,-15,-5,-20,-44,14,-5,82,-34,-29,65,-17,-26,-39,-22,31,52,-3,-21,36,-5,-45,25,-18,-82,-96,-8,-1,-40,-46,-36,9,-29,-33,30,-35,-3,65,67,17,19,28,68,53,37,49,23,-27,-14,-58,29,-34,81,31,65,16,6,-42,-42,-127,-16,11,-7,-6,-31,-29,62,1,-12,38,46,8,20,-64,45,-12,25,-21,25,10,12,8,35,63,19,19,52,-12,40,-92,-29,54,65,42,40,54,33,62,72,-7,60,-20,-9,16,21,-14,38,-47,12,6,48,16,29,47,-44,32,-21,2,-11,-9,42,29,-20,1,22,29,-62,22,39,27,15,65,39,-62,-18,13,-54,15,12,-46,55,-37,62,62,-50,33,-38,24,8,29,-29,-47,23,52,-36,16,-20,26,38,5,-39,-38,-58,-13,-29,-48,-77,-41,-16,7,50,-42,30,55,-61,-22,18,25,-4,47,-11,89,-9,11,-35,2,71,-43,-7,-32,32,-35,17,89,28,-40,10,32,-34,18,31,-52,-83,13,7,-1,40,39,-10,-17,-5,10,8,-12,-9,5,-6,-35,46,-54,-6,-34,27,7,-30,-29,-4,5,-8,-4,-29,-33,-24,-22,13,-2,29,-50,6,21,59,-5,37,10,3,-16,-45,7,13,-79,-13,17,-49,4,20,-20,0,13,-46,52,-5,49,37,19,-4,-71,40,-47,-54,9,8,-9,64,2,-5,41,24,2,-6,52,-88,45,-45,-37,15,93, 
  /* [3][0][][] */ 91,3,-30,50,-1,-33,-25,6,-8,-31,70,-15,64,7,42,7,24,4,-78,-18,-5,-14,-25,4,34,33,39,-38,-16,-6,33,38,35,7,-57,-11,-21,23,40,29,-26,-55,13,-41,1,16,-51,-19,59,-24,-67,24,-12,-54,12,-2,79,62,51,32,-18,15,-39,49,-18,61,31,70,20,30,-5,0,-31,-23,7,-29,-73,-63,48,-21,-15,-15,47,-22,42,-90,-29,-23,29,-55,-2,1,-13,-12,-5,-5,-18,-70,-16,-55,-45,-33,-2,-6,-37,30,-101,-19,17,-127,-1,-26,-8,-54,43,-45,-4,5,-16,-40,6,-44,-26,48,23,26,-31,44,18,33,9,-19,53,-25,-41,3,-43,70,-14,-1,-49,-6,-64,15,13,41,-89,-2,-3,31,28,-2,53,-10,35,-21,9,-27,-37,97,2,-19,3,16,49,34,-24,-29,-17,38,-49,31,71,-12,8,-35,-22,-51,-27,-58,-9,30,-36,37,-18,77,-58,44,47,7,-10,32,-15,-7,-19,-85,-13,-19,52,11,10,-60,-15,16,-5,31,-12,9,7,-52,-55,60,-90,30,4,4,-75,-9,-1,-10,-1,-3,-24,30,-65,27,7,-19,-2,-20,71,37,25,-24,-36,-2,-33,-19,25,4,1,40,-33,-20,8,31,55,-19,-39,-24,11,-22,21,-47,-31,31,92,-53,-6,17,12,44,34,-13,32,10,-60,29,-39,-22,-62,-70,31,-30,49,-22,-1,-29,29,9,-17,41,-3,67,-43,-76,0,-16,-25,47,5,14,-14,15,-10,9,58,-10,-70,0,40,-13,56,-1,-35,20,-15,17,-34,-30,-53,17,19,15,-65,21,3,40,-48,-6,14,-45,20,12,40,-3,69,12,-28,36,-24,5,9,-41,-30,-4, 
  /* [4][0][][] */ 95,77,4,-22,-36,-67,-22,-58,-50,54,-8,21,106,-44,-14,21,92,-40,-15,12,-31,-27,29,38,0,-12,21,-4,-20,2,-27,19,-79,-33,58,-49,-52,0,13,27,5,-36,-33,-4,-51,0,11,42,39,21,-30,-48,-1,23,16,4,-1,24,4,38,15,-7,43,41,-20,17,-23,-127,76,-40,3,-2,-31,-50,12,-70,22,55,-17,102,-48,1,-6,-53,35,52,-48,67,0,-29,-12,52,61,-103,35,46,-40,1,68,69,-10,-89,-32,-7,-46,98,-28,48,127,60,-39,-105,33,88,-22,-31,42,-39,49,74,46,-61,-28,-6,-17,1,-5,-37,71,26,4,49,47,32,-38,-3,15,-2,7,-21,-18,-10,-41,-26,-47,-59,-19,-15,8,55,49,-11,-26,-66,32,33,14,10,-12,-21,20,60,40,18,-100,34,-55,-85,-95,70,-48,39,-14,59,28,-13,46,-50,-39,-2,-25,-20,44,-26,-54,34,-14,17,-66,-47,-69,9,60,29,-4,2,-40,37,-38,62,-2,-3,15,21,-13,5,-18,110,-91,-20,-10,-12,71,-75,72,-11,9,18,-22,6,13,-31,103,9,-21,-34,-4,36,-5,25,41,67,58,35,-21,-13,35,-8,22,21,-14,-55,45,20,-5,-34,76,-33,27,-36,-12,33,-48,-25,38,76,47,-29,4,-52,-33,52,-20,7,-38,18,-13,-70,-31,-47,-59,55,-51,-38,56,36,6,-41,33,4,-56,-55,46,-11,12,69,17,-10,29,43,-11,21,91,25,85,-126,-35,-11,-11,57,68,-13,45,-50,-36,-73,-25,-9,-25,-65,-38,-26,45,24,-75,42,60,51,-18,-23,36,17,-26,-53,78,-19,15,-23,-45,86,24,5,-10,21,22,-50, 
  /* [5][0][][] */ 15,-8,42,-21,-45,-53,-30,57,10,-67,-8,89,37,-28,54,-19,-1,36,-9,-7,28,9,52,47,1,-26,-27,-55,-13,7,-80,16,-53,-12,-20,-57,4,-29,36,56,-83,3,-6,71,-44,50,92,12,-40,43,-8,5,-78,13,-103,36,38,10,6,-47,-41,13,-9,-16,-92,-1,-4,-49,6,-45,-88,28,36,-117,-20,-53,73,38,41,-22,-2,-32,-7,-92,84,46,-20,-17,26,-19,-34,0,37,-56,-34,-11,-97,-33,-13,17,-20,-1,-55,59,23,19,-1,14,1,30,-3,-69,3,71,-39,26,-53,-41,-48,12,-25,-46,-21,-23,40,-74,63,-76,48,-86,42,66,-29,20,-53,-9,-67,-44,-92,8,-51,-83,-42,8,50,-26,-48,-95,19,-36,30,27,-58,-60,-43,-22,36,35,5,-57,-24,48,-10,-1,35,-5,-40,-57,-6,56,-86,34,-73,-26,-30,-45,11,-17,-26,24,-71,-22,75,0,13,43,85,9,30,20,-65,29,55,4,91,-25,-68,-54,14,-47,19,22,117,64,-32,-13,16,-72,-33,-22,36,-3,50,0,28,46,22,49,-34,36,-4,-59,27,28,-12,-81,-11,-13,0,35,0,-66,0,15,30,-76,-22,-33,32,-25,-13,24,-27,15,45,26,-11,-7,16,-127,-29,12,-25,65,8,28,-49,11,36,-48,-35,-47,46,-26,29,-26,59,-50,20,-58,-72,70,-33,-62,-40,-47,-37,-26,-20,27,3,23,-57,-47,-2,-19,51,25,-25,44,-20,5,-76,34,15,2,108,-25,-35,13,4,-83,11,48,39,14,-26,34,-105,-91,37,2,-3,36,5,-16,29,26,56,7,2,11,30,-26,60,13,23,-31,-44,10,-6,-13,13,-15,-75,-26, 
  /* [6][0][][] */ 56,-2,109,-3,16,-18,6,38,-7,-19,127,42,-15,-18,-43,5,1,-3,-11,20,35,-29,9,6,-11,24,28,70,2,21,-41,-11,-73,49,-29,-8,29,-39,-5,-29,6,-34,-45,-33,-43,-14,-66,-24,21,53,-19,48,1,-44,-7,20,-14,18,-4,101,8,-59,76,8,3,-12,45,-96,41,20,-7,-78,-19,17,-32,-40,-5,9,11,11,-29,95,-5,-15,19,24,38,-21,31,12,-5,-22,-32,13,-18,48,2,18,-48,-11,-112,100,-63,11,-20,-15,8,-22,38,-45,31,-82,-17,9,-35,23,88,30,45,30,3,-15,-21,37,44,37,-2,5,-9,-42,26,-73,-20,30,-37,-16,31,-11,48,12,-34,6,-32,-82,-40,1,-24,11,28,15,48,56,89,-3,5,80,10,47,-2,-1,-12,54,-2,2,7,32,26,19,27,4,10,-28,-25,36,79,-14,-7,81,38,-50,-46,8,51,43,0,58,-36,37,26,-29,-22,6,-50,-28,-68,46,-24,41,-20,17,-8,-27,25,30,-32,17,-27,68,-2,46,27,-48,-108,29,-35,18,-52,38,-32,-9,-15,10,-59,3,-31,28,11,45,-22,-13,-44,-22,4,-11,-31,34,-26,-74,-4,-40,-14,-5,123,-24,-65,-42,30,20,-49,-48,-41,-39,-32,-98,15,-8,32,-58,11,-57,-24,-1,-33,21,-19,81,39,21,-48,-31,1,-18,-5,-1,49,-37,58,-38,-14,79,-72,13,-31,-35,-16,32,5,-5,84,-96,30,-40,-6,38,-57,5,4,-86,-91,-5,-23,123,-25,21,-70,-35,46,-48,-55,42,34,54,18,8,11,19,27,-18,-29,3,37,25,21,-20,27,-40,20,43,-53,19,-56,27,-26,4,69,17, 
  /* [7][0][][] */ 63,13,34,-63,-53,20,-115,-31,-89,-16,-66,-30,66,-16,-85,78,51,-4,18,-35,-24,-56,15,-30,-40,30,-18,14,-68,-9,49,22,55,52,-21,-24,-17,-4,-23,31,23,34,-69,-92,51,-27,13,38,36,-95,35,43,48,16,44,50,18,-18,-39,33,76,42,-26,0,-23,-11,-47,8,-40,-61,27,4,-20,14,-17,3,42,72,61,22,-71,31,-5,8,-31,-13,57,5,3,-21,20,-48,-96,32,-22,-22,27,45,-22,-30,14,-87,-84,-28,-73,-20,28,64,-44,-1,24,70,-61,112,35,-14,81,23,-3,-65,-44,39,15,-39,63,-25,-36,-6,100,-46,-20,9,77,2,0,81,10,-80,-13,5,-20,82,25,17,33,-46,13,-58,-40,40,-56,27,7,-20,8,-22,-18,-5,-44,-77,68,49,-3,16,65,14,30,-30,-44,19,15,-38,-11,1,8,-65,-41,20,-5,31,22,23,-8,-21,-11,-14,-23,-17,38,2,-11,14,-13,30,-7,27,-39,-56,23,68,-43,43,88,-18,-21,-2,-30,58,34,-61,-34,-115,-12,15,35,-52,18,21,-61,-15,-3,10,-14,-20,-29,2,-20,-25,19,-93,1,8,11,6,-78,-24,-70,0,123,28,-39,24,-25,-15,57,-13,0,48,-47,88,31,22,-14,-16,43,-6,36,-6,-21,-3,-56,37,-39,-81,13,0,7,-11,-63,33,-18,-31,-46,-30,-26,28,20,28,25,79,38,-23,49,0,-20,-26,89,-23,-3,-86,66,32,81,24,1,3,115,-77,-64,-34,-46,-6,34,15,-29,123,-54,-53,65,50,-5,25,-39,17,-57,13,-36,67,-59,35,-20,-40,-46,-86,-41,17,-21,-63,35,72,-5,15,-49,-127,-74,-63, 
  /* [8][0][][] */ -31,-18,18,-5,2,32,-11,-27,51,2,50,65,-8,28,0,10,-27,39,7,25,48,0,25,-8,9,9,-9,60,-36,28,18,-7,-10,-16,-4,-40,-11,2,4,20,24,38,-13,-65,-3,38,-41,-13,34,-36,48,-9,-27,-30,10,7,-25,-14,-17,-48,-20,-26,39,12,62,1,-65,4,-18,-10,68,-9,-29,25,-12,36,37,-17,-28,-13,-51,-12,-3,36,20,-12,-16,61,-28,-7,-75,-10,-85,-49,-48,-4,18,-10,2,27,44,68,14,-33,1,-67,70,-15,3,-9,8,7,30,-7,20,9,-36,33,32,-18,-48,33,0,-19,-19,35,-19,44,20,-20,-22,-68,-24,14,18,-13,-17,20,-24,19,14,46,-1,-38,-66,-39,18,-34,47,47,14,-4,17,61,-33,-25,-3,100,7,-26,40,19,-4,-53,9,40,-18,-17,41,-20,36,-9,51,-23,2,-38,7,58,6,-34,26,-22,-28,-2,14,27,-37,51,7,-23,30,3,-36,1,36,-43,20,2,-6,-43,-4,47,-10,-21,62,44,-17,-127,-41,5,25,-11,-36,10,-28,-27,20,-32,-14,-20,-29,1,13,17,28,18,-11,-2,39,-67,-22,9,24,11,0,45,44,-17,-33,14,-16,-10,-17,-1,-49,-11,-2,-13,19,48,-21,27,46,50,12,28,-5,-1,7,80,-19,18,-38,32,-16,-30,-24,60,19,62,47,-35,-12,24,-3,-4,43,-16,-29,-25,-24,61,38,42,-10,-1,-19,-42,-20,-51,-37,-28,41,4,6,-7,32,8,41,5,23,25,2,-11,-35,-43,100,-33,37,68,-50,21,-4,2,-43,57,-3,14,-51,7,-28,-62,-11,-23,11,19,-22,30,14,23,32,9,-21,-28,49,-40, 
  /* [9][0][][] */ 9,-19,-10,-6,-27,28,42,-41,-90,-16,3,72,0,-20,83,51,-25,60,18,7,21,38,6,-22,42,47,42,-9,72,-3,14,74,-1,18,-90,74,-12,60,40,40,18,120,-17,-18,-29,9,23,36,51,7,-26,-54,-78,-78,67,66,-26,-10,-12,-63,-1,-21,4,43,-6,-35,-7,39,17,29,-48,-5,-61,-21,-20,-49,43,21,-48,12,-16,-20,11,0,0,-29,4,20,0,-4,41,-50,-22,45,78,19,-74,-20,37,-2,-27,21,-91,-66,-24,-5,-46,-51,32,-17,25,-6,29,-15,9,40,-13,27,-22,20,-25,-69,10,-22,4,31,43,-13,19,-67,3,12,-11,62,-24,15,42,-35,-3,-13,-39,-56,-51,26,-35,-16,-31,-37,-50,-34,36,16,85,0,65,37,19,-34,-29,-45,-41,-7,38,-17,39,-25,-59,-105,19,-56,18,-36,28,-15,62,-8,37,-14,6,19,9,-28,-67,32,30,24,-16,30,44,33,-47,11,-80,27,-34,77,8,17,7,34,16,-3,30,-21,-42,52,49,-29,-19,-45,-49,32,33,72,27,7,-8,34,43,-33,27,37,9,32,52,61,-48,-3,58,15,29,127,71,-46,56,-14,-21,-3,-28,-37,46,-2,11,-41,32,14,31,18,48,8,-5,-60,-1,-83,75,32,13,-23,-2,16,-2,6,-57,60,-38,60,11,-40,-19,-21,2,-10,-7,-43,-62,-31,-72,-38,37,24,-22,72,-30,10,-90,-7,37,-43,-17,-45,-49,-73,-57,-23,-28,10,-12,30,-36,0,-49,63,-40,-55,-50,-113,-59,13,-15,6,-71,1,45,-11,54,-75,45,28,-71,96,0,31,6,-91,12,-16,53,-72,-23,10,-58,85,-33,51,12,21, 
  /* [10][0][][] */ 26,32,-7,42,26,12,6,-25,48,-61,60,-47,30,49,85,-1,48,23,-25,-45,-6,111,9,7,-56,-62,-51,50,10,29,-16,13,-5,-15,2,-26,-34,20,29,-34,18,110,-48,6,11,-99,-18,-32,-9,31,-21,34,64,-27,29,-48,127,47,2,-57,-5,43,-24,12,-2,33,-46,0,30,14,56,-14,-19,11,19,4,-17,30,10,49,-14,-61,5,16,-38,36,42,-49,22,-41,-1,-34,19,-40,11,38,49,36,13,32,-9,7,21,25,26,23,7,34,-3,-6,-43,-53,55,52,46,-46,9,-83,48,27,51,24,-31,-29,13,5,-11,11,31,21,61,60,39,41,32,-9,-10,2,-27,-44,43,39,15,30,22,16,-46,3,22,13,-11,61,-32,5,-45,66,-50,15,-41,-24,27,-78,-5,-10,17,39,43,14,27,-19,31,25,0,65,-2,-34,-9,-18,-33,22,50,33,-54,-34,20,-32,12,67,-14,5,2,31,32,1,50,98,-17,-13,-59,-7,27,22,30,-5,-42,2,-82,-51,1,53,-11,-42,62,-5,-22,-52,-25,6,-46,20,39,18,106,4,23,-6,-5,-21,-36,30,-20,31,-18,-5,-44,25,-2,-52,61,39,-4,-21,-9,12,8,33,23,24,-10,39,18,8,-12,-31,-44,-15,-76,-36,3,-51,8,16,33,-45,18,27,22,-87,36,-2,-18,-11,2,28,-24,3,51,28,25,8,66,-28,-8,35,-9,21,-33,22,32,49,20,14,-103,-27,23,-34,-5,0,-31,-47,13,44,-6,35,-9,-59,68,63,-15,-25,15,-2,16,-34,25,-27,12,-6,-25,-1,-48,74,-49,92,10,-7,-57,-34,32,-25,-25,1,8,47,5,-11, 
  /* [11][0][][] */ 2,39,-115,-4,39,19,58,-33,-42,-21,-16,-4,-24,-35,-10,-4,-40,-1,-51,36,-34,-8,8,42,9,8,54,9,-8,83,30,36,71,70,10,-28,-56,25,33,10,-2,-16,-39,18,-18,-14,-2,4,14,40,-42,-38,21,-78,-17,-18,16,14,-18,-7,39,-31,3,28,-15,-25,8,19,-29,-31,7,68,-31,-54,-30,-55,-57,22,30,31,-69,-15,-18,-13,69,27,-39,49,-53,4,4,1,52,-35,34,-54,1,42,9,8,38,-127,31,50,20,-27,44,13,15,-52,-37,-38,12,-98,14,42,20,14,-42,-80,58,-40,-4,9,-65,-47,-5,-25,27,26,63,88,6,34,53,39,-84,-17,-44,64,16,47,-25,36,51,11,10,-2,-19,-52,-16,23,-23,-18,27,-2,-3,47,47,2,90,-16,-10,44,-40,10,-31,46,46,57,-12,-33,-31,9,-37,-12,31,-8,63,62,7,14,-24,-36,8,18,8,-36,-3,-9,-28,18,10,8,-13,-50,70,41,-57,31,-21,6,51,5,34,-16,9,30,26,13,-1,57,-39,-16,14,13,20,13,-4,24,-36,30,-27,39,11,-34,-13,12,13,45,64,-17,-23,-27,-25,-37,-92,37,-41,74,-66,-1,29,-4,35,-27,-19,3,-16,31,4,4,4,-24,29,-6,32,-18,18,2,-4,25,-31,10,27,-12,-3,5,16,3,14,-1,-2,46,-42,-2,-13,-53,0,-20,-35,-11,-53,-10,-5,57,0,-2,22,54,-38,19,14,26,29,-45,-4,-15,51,23,15,-22,38,14,-13,10,24,28,41,-17,-33,14,16,35,-72,23,-12,-7,28,-2,51,42,23,-53,-20,11,74,51,-2,-58,47,5,-23,-54,-7,-42, 
  /* [12][0][][] */ 38,-54,74,-62,10,61,42,13,-106,-39,46,14,-31,-20,-24,0,1,13,29,102,-19,-23,-24,-5,39,23,-81,22,-93,-7,-30,-13,71,-12,29,16,41,51,-33,13,30,-7,14,4,-8,-79,-2,15,-60,25,14,-46,54,50,54,-5,-18,-25,32,60,-55,-45,17,33,27,-7,-46,-15,2,-4,-28,-9,13,53,21,-23,10,15,-36,37,42,-57,31,12,-7,-15,-57,21,-17,-51,-4,-6,6,-37,-16,-40,38,59,-69,-4,20,-26,-10,25,-25,-9,-23,11,64,9,-14,0,24,19,-3,3,3,16,-25,-41,-43,27,47,27,36,-19,-111,-61,9,35,-44,-33,-36,-18,33,46,54,-46,91,-75,-10,26,58,-59,-53,-38,48,-60,25,53,-79,26,15,48,15,-48,-56,67,55,-30,127,-5,27,-8,41,15,-8,24,17,-40,9,-1,39,-4,14,57,-14,-4,-1,9,-23,-8,-7,-14,7,-30,2,-25,-28,-12,73,-13,1,11,6,47,0,49,-16,-50,44,42,15,-1,-4,-2,-30,-17,-32,-8,-98,-1,-32,-31,53,-20,-24,54,-23,58,-23,-22,-15,12,-15,-24,11,28,-33,23,-47,-25,5,-6,-57,11,-18,2,27,-27,43,18,30,-16,4,-44,-23,-33,34,42,45,6,-37,-8,22,1,14,4,-5,22,12,-5,-13,53,-15,11,27,9,4,32,30,-30,-49,6,-27,6,36,1,-23,17,-50,-74,-18,2,0,16,-41,-18,-30,-10,29,-61,27,-4,4,2,-5,31,26,-1,9,-8,-70,28,33,13,19,-30,57,10,-76,28,0,-19,1,-33,20,-2,-16,11,68,14,-14,-56,-38,-35,45,-44,-4,9,-54,-5,-15,17,49,7, 
  /* [13][0][][] */ 30,-5,-13,-21,-28,-18,-37,-14,21,11,45,-29,127,-8,29,-22,21,-46,40,37,-46,38,27,34,-14,-38,-6,59,-13,10,1,21,-1,-32,-4,7,53,-28,21,-68,8,76,-57,-64,-22,-8,-30,43,-3,49,10,59,21,21,-29,-11,35,-60,29,40,29,-20,-1,49,-13,-25,-75,-24,3,26,35,22,14,52,18,-30,-16,16,28,30,46,65,80,-15,-43,-41,-12,-22,26,-11,50,-10,-18,71,56,-55,61,3,-9,-43,12,124,-26,-42,13,-31,7,-32,-58,9,37,-69,-33,41,-5,-17,15,2,42,-19,-5,36,17,-20,33,99,81,-21,-18,-11,34,4,27,97,-15,4,-26,-24,48,103,21,-12,17,-3,-22,-18,-58,-52,-46,18,22,25,92,-7,-24,76,-14,93,51,-41,-32,16,-39,-15,30,42,96,-28,-34,-4,-6,31,26,-67,28,-34,-52,31,6,-19,16,-43,-11,-16,-18,22,-3,14,-14,-36,42,-31,32,65,-4,-7,-3,17,65,-25,13,-17,-15,6,23,-12,33,-65,53,-40,-44,3,-6,15,22,49,19,-19,-22,35,1,11,49,-47,-2,15,-12,-12,-52,34,-52,106,-55,-14,-44,-1,-2,32,20,1,-50,-5,44,-21,-37,27,50,-17,20,7,41,-5,-4,20,19,6,9,24,43,12,47,-18,22,14,-84,-126,67,-46,-31,40,-24,-25,49,4,-3,79,53,-25,-1,-6,-46,60,-4,53,-113,51,9,-5,5,-14,36,-47,-56,-56,-30,-7,29,-85,-12,73,34,20,34,-5,-17,-36,61,1,-4,8,40,16,3,-32,51,-18,-45,-67,-71,-82,0,-7,58,-8,-26,-66,31,14,-16,-25,29,-38,23,43,6,4, 
  /* [14][0][][] */ -16,-31,-15,-23,7,28,29,34,45,-42,-21,-8,-55,8,-12,86,-78,64,7,11,7,-44,1,-40,-6,13,-14,-16,28,-43,52,-24,41,92,-101,14,19,14,1,23,-23,-18,4,-41,26,10,-10,-43,-73,49,22,-16,-54,56,2,8,63,45,14,54,-47,70,-17,17,35,-8,73,-24,60,-18,24,9,-69,12,2,19,-11,41,13,-35,-26,54,-40,11,-23,41,-80,-8,-56,-69,53,-6,-39,33,-4,26,-32,49,92,47,-34,-34,-1,-11,37,-47,-48,-42,-11,-11,-28,-2,-25,-41,-32,32,-10,-25,6,-7,-36,-11,30,-78,-93,-19,-43,14,-34,22,-26,13,-72,-18,45,105,-61,-60,-19,-18,-37,-2,65,4,-28,-43,-20,9,-18,-51,43,19,-36,24,-36,-45,21,26,21,-17,-81,3,-33,-33,35,-54,-46,22,35,-51,34,26,-10,-6,-1,-33,-42,-15,-25,42,-20,11,-82,6,-14,-33,-18,5,28,14,-32,5,-45,-82,-30,3,-4,-41,-4,-5,-30,-1,16,-33,17,29,-45,-2,-65,2,20,4,-21,-20,-19,-11,-118,-26,-30,-61,-17,8,-76,55,-3,53,-3,-59,-33,33,2,1,39,-80,9,-9,51,83,-17,-6,2,-3,24,58,-3,-27,-11,-22,-13,59,-49,17,46,6,11,24,5,-80,23,51,-16,4,-27,60,24,3,-40,-17,-11,-46,14,-4,35,80,-35,-5,-24,-9,6,-8,41,42,-25,-12,-76,-11,-13,14,-58,-12,-65,-44,26,12,-48,-59,63,20,-47,17,-59,-48,-5,-21,22,-12,1,-32,36,-7,-43,-18,-26,-3,47,-73,127,-60,-22,37,32,25,7,-25,-12,73,-73,-53,48,8,-30,56,-57,32,48,-58, 
  /* [15][0][][] */ 14,16,25,-61,-28,61,2,18,-42,4,24,106,-15,22,54,-1,27,-3,-2,-36,15,-36,19,-68,-45,-79,-75,-63,25,45,19,64,87,-52,49,18,-8,-45,-65,-24,-60,-32,67,-92,-13,32,38,-24,-39,101,-27,-56,-85,-3,2,1,-23,-10,37,-30,38,12,0,29,114,8,-34,-98,-16,68,-46,-30,69,23,56,34,34,-45,48,2,40,-96,-42,71,-37,48,-84,-1,9,-14,-97,-10,-35,1,11,-108,55,-20,43,6,-54,74,-61,32,121,30,-4,42,-32,-13,5,25,21,-24,-5,-93,12,82,17,46,64,-38,77,-27,6,-73,20,61,-7,-30,-29,33,21,-2,53,39,24,-34,-6,27,32,45,29,-58,73,-59,-12,-8,14,-13,-35,-30,19,-2,12,-52,29,85,42,-22,13,3,-30,-2,18,35,-11,21,32,13,-3,-61,-4,26,-27,-23,-28,-58,78,-11,12,-63,40,-29,-5,10,-7,-6,-92,38,-63,15,-41,18,-23,-53,13,-20,-26,2,64,5,-47,15,-43,-9,-46,8,18,47,-32,22,-10,-39,52,27,61,19,-30,-63,-26,-43,-34,-19,16,23,-25,-43,-15,29,9,-26,-8,-28,-65,-16,-52,-8,49,27,-23,19,59,-11,39,36,24,-37,22,-33,-54,-29,85,77,7,-53,-48,-71,-15,-31,-61,-6,55,-76,61,-94,-7,36,-17,52,-29,-23,-49,-51,-31,65,-1,57,-49,70,-8,20,-24,34,3,-12,-14,46,-2,5,-49,-1,-2,39,-74,-16,-100,44,-16,6,85,-7,-15,42,78,-48,18,-64,-71,21,-47,58,-30,43,8,11,-88,-65,8,14,-25,-91,12,33,127,-48,42,22,-38,9,-17,42,-19,19,27,-44, 
  /* [16][0][][] */ 17,-19,37,-69,7,14,-60,-9,-18,63,51,12,38,-99,-41,39,70,47,-26,63,14,-20,-39,-7,45,-46,15,-16,62,42,6,51,3,-28,5,-21,-7,22,-6,5,22,10,64,-69,27,36,-29,-49,67,18,61,109,-47,22,41,21,-33,-23,-101,61,-27,1,77,13,-30,-29,-58,-36,0,-96,41,-12,-19,51,-7,29,-93,-18,-54,-31,27,58,-125,-32,28,-32,-43,-42,62,-43,8,28,94,63,-35,-37,50,8,-45,-26,22,10,71,-20,-21,102,75,-26,53,-5,22,68,-29,-52,22,-5,37,84,65,-40,-35,68,-61,-68,70,-7,27,12,-8,35,-53,-23,-62,-1,28,14,-28,-39,6,32,79,58,-6,32,-54,22,27,-32,-11,21,55,-32,-13,4,-47,12,77,25,-52,-44,-11,0,37,40,-27,57,-22,-24,10,65,0,54,-31,-6,-97,1,103,-19,-1,7,15,-5,-24,25,-24,19,30,-53,-46,41,38,29,-19,-48,63,62,-49,22,-41,46,116,-4,17,-31,-3,-41,58,-16,123,-49,-61,-53,-94,-51,73,21,-38,35,21,-87,-40,77,7,58,-25,94,82,1,-67,-18,-2,-6,21,-36,-36,-26,70,-54,-24,15,5,-58,-11,58,77,-11,-73,-16,21,30,109,31,-3,5,-34,-5,-61,-25,-6,80,38,-69,-38,54,-45,-59,-5,-21,-47,-60,21,-37,-55,81,-42,-83,74,119,7,-69,-2,-39,1,14,-8,-10,-52,-43,29,-39,-66,40,-17,25,-90,-4,25,-26,-6,-24,-127,-58,-21,-30,-54,67,-71,37,-25,-50,0,39,94,-50,-12,-10,25,-18,-22,-2,35,38,55,-43,53,20,57,41,34,-48,-81,-13,-22,23,3,57, 
  /* [17][0][][] */ 18,-66,26,0,32,-73,36,-26,-50,63,48,35,-85,3,-15,39,37,-6,22,60,32,-68,54,-14,27,20,7,-37,-25,11,43,14,61,-45,74,-19,-14,9,-4,-14,-37,12,-68,95,-36,3,56,104,2,-35,-59,66,47,80,-25,-19,31,-35,88,-2,34,67,84,-59,4,-45,-21,11,10,4,-15,38,74,20,-9,-83,38,35,-20,-31,39,-14,14,-5,7,8,-55,-82,-2,-5,48,5,-15,-71,4,-110,2,65,-10,-14,1,-45,32,-10,23,57,-94,38,26,78,-71,20,-70,71,55,19,82,-46,68,-60,-4,-84,-22,9,-3,-10,58,0,-12,16,-40,28,9,-9,40,-27,69,-8,7,1,11,0,67,14,41,-29,33,27,12,47,5,-30,1,-14,-42,105,37,-53,11,6,-30,-5,24,42,-56,-5,78,19,-63,57,-11,-13,-40,43,-43,36,-40,-1,-22,-15,-14,5,43,-22,23,-8,3,5,11,7,-30,64,12,5,-127,61,-35,1,27,-34,-35,-5,16,-90,-30,-38,-3,79,-6,-6,-6,-26,98,-36,6,-7,-39,76,-32,-15,-12,-63,2,-7,20,-3,-72,-33,-7,-56,-51,-43,-5,9,-39,-1,-44,31,1,-7,-9,74,-37,7,20,-63,-51,-22,-82,-9,54,0,42,51,4,-30,11,58,10,-27,48,-29,15,17,35,32,-12,-24,-2,16,59,87,24,0,84,56,-17,14,12,-1,-93,18,-6,21,59,27,-11,-23,-6,34,45,29,15,-11,53,62,-65,-15,-19,76,3,-6,-7,-35,-5,-77,-59,76,-2,-60,8,-30,-75,-19,67,8,-28,63,98,13,96,34,0,48,-18,66,54,-5,-62,24,-27,-26,41,21,30,-11, 
  /* [18][0][][] */ 8,38,-13,-6,26,-2,-52,12,-36,23,16,26,-9,-31,9,-15,17,-58,67,-33,-9,44,-48,-8,-30,56,-61,-16,62,-64,-7,-20,-24,9,-80,-41,-15,107,100,-27,-21,4,-8,-68,-19,17,-52,-32,4,57,26,-65,-12,-46,13,61,46,10,-42,61,-61,31,-11,21,24,43,45,-59,0,-20,-23,6,96,38,-99,-14,-73,-2,-35,7,-79,-37,19,34,-56,7,6,-85,26,-28,-37,31,-3,-84,8,63,98,40,-23,21,-52,-7,-9,-6,-32,-6,38,-27,-38,-41,3,-115,69,-37,0,94,84,-72,28,26,39,17,23,-46,34,23,-17,79,1,14,8,11,47,52,36,-54,111,-61,-18,-90,102,47,32,-8,15,36,10,78,88,-59,51,-86,22,21,-64,4,36,-22,-4,-50,-86,-34,-4,-1,43,45,-31,23,32,-38,-6,66,28,67,12,-31,-35,44,-35,56,39,-39,84,113,52,75,-79,51,-39,-27,-28,53,11,32,40,20,25,13,-33,13,48,-69,14,28,-11,-2,4,16,16,22,73,13,-49,-16,-7,-33,-127,22,-43,-43,-96,73,87,30,-25,45,-26,9,37,95,57,16,81,31,25,-11,37,47,-10,-79,-10,-31,-20,-7,-30,25,31,-79,30,56,-2,31,33,-29,-38,-9,-24,41,16,62,-9,-16,100,-43,31,-25,11,0,53,-40,85,-2,-44,9,17,-39,31,-45,15,38,-21,82,46,-9,-57,36,-68,-18,6,-46,-71,1,26,-30,-53,44,23,-86,-70,-5,86,-37,-24,11,-107,9,-8,1,104,15,-70,-25,23,-74,-68,1,-53,32,-68,21,-30,15,82,-2,111,0,58,-48,-12,2,-52,62,-38,-40,34,41, 
  /* [19][0][][] */ -11,2,49,-20,-13,-12,-14,-13,17,-43,-2,-27,38,5,8,-22,5,-51,-7,-23,-19,32,-68,-32,54,-38,-29,-15,23,-13,-15,-9,-29,12,-38,-11,25,22,29,20,1,-15,72,-22,0,27,-4,-23,60,-7,-46,-17,34,-103,-30,73,50,-17,-12,8,-53,-5,35,-13,-26,-8,20,-19,-2,-21,-26,-94,-1,12,-39,66,19,1,-3,21,-23,39,71,-24,-64,11,-16,4,-55,-44,-65,-32,15,-35,-10,11,-9,-11,36,88,-31,127,-49,4,12,-25,33,-92,-19,22,16,-19,21,-6,-39,-10,56,12,-25,91,-19,-20,7,15,26,-18,25,1,-42,1,-34,-5,2,4,20,-53,-48,-1,-9,35,-25,-8,35,-7,-7,-1,19,19,94,-40,11,0,72,-31,10,-5,1,-6,24,-31,-57,81,19,-74,7,-7,-45,11,-3,-11,2,-3,2,-8,-2,-15,11,68,-31,13,-35,24,33,-20,10,31,-21,-37,21,13,-29,-5,4,-29,30,2,2,41,-7,17,-3,1,-38,-40,-28,-29,-16,28,-20,61,43,77,-44,-7,8,27,8,-39,17,-41,25,-12,20,22,12,66,-9,-9,14,-4,-9,22,-24,5,-33,-5,7,-44,-9,-42,8,4,-32,0,31,-41,35,39,54,30,-15,-47,-47,-20,9,38,-15,36,-22,12,-42,-15,-36,22,-14,-50,12,-28,-6,-2,18,-46,-11,-28,-22,-52,-24,-4,-10,4,-39,-4,31,-3,-1,-43,8,10,47,-20,-11,36,56,62,-25,-25,51,9,-36,-48,21,38,-13,-30,-62,-31,36,-3,-6,-12,-15,-5,41,38,41,35,-51,27,-25,-42,-8,-85,3,-3,30,-22,31,35,-9,31,7,9,76,5,18,36, 
  /* [20][0][][] */ 68,33,58,-51,-22,-80,34,60,33,-18,-4,-7,47,39,61,-14,18,-9,-4,4,-16,31,27,-3,-25,-19,-86,36,6,-40,42,43,-18,38,44,-40,-9,17,-63,24,-73,9,31,-96,-69,41,5,61,17,-8,-25,28,-96,9,-53,37,-28,67,-10,-47,-70,28,26,16,-40,40,35,-13,-33,60,-12,12,7,32,26,-39,96,-70,40,12,0,-26,-18,-23,25,-7,0,15,59,-34,-11,-36,-60,-39,54,18,-9,-29,-36,-8,-38,25,2,-4,37,-43,-10,-44,11,-31,-36,-18,-36,-11,3,-48,-34,-25,-51,8,6,-43,26,-38,12,30,-35,-13,37,50,64,-18,-11,69,-38,-2,-5,22,-3,14,-10,-48,47,20,-23,1,20,-69,5,-50,-64,18,9,66,-53,-69,-24,127,-24,37,43,36,45,-16,50,82,38,-19,-53,81,-24,-15,27,20,24,-45,-18,0,33,-32,-29,114,-71,-24,-4,22,18,-14,-22,-50,-5,17,84,30,72,-72,-40,-12,-3,0,-35,6,-42,-35,23,23,-41,-7,72,59,-76,-20,-35,16,-73,3,86,21,11,36,-55,-36,-3,-24,10,-36,24,15,15,70,-65,2,0,-9,-51,124,-69,16,-13,-29,59,-11,8,-28,50,56,62,-32,14,-18,-9,8,24,97,-39,-97,57,5,-26,-18,-5,44,103,-15,12,-94,10,0,26,3,43,3,-47,-20,61,-60,-58,-29,-3,106,-2,6,23,14,-100,17,3,14,53,51,103,28,-78,-19,-64,28,-46,-10,12,-13,-15,-7,-44,37,98,87,68,-81,-58,-22,-3,-1,-21,8,-11,23,15,-43,-1,46,-5,-54,-7,54,-2,41,-89,8,12,74,87,48,-1,-52,-28,-22, 
  /* [21][0][][] */ 16,54,-7,-9,-97,24,56,-1,37,-46,-4,52,-60,7,-34,-11,-2,-52,-58,-29,-56,51,-46,-28,27,-13,-32,-21,42,45,-9,-88,-24,34,41,-57,48,7,8,-108,-10,-47,-37,29,-16,-58,46,17,-22,73,-4,-2,-109,-32,-12,-27,-8,101,88,-78,44,-36,-23,49,24,11,112,-24,60,-38,18,-48,-35,-87,-57,40,28,44,-35,15,-17,38,-104,12,-20,62,79,29,-104,-25,71,-5,19,-19,39,16,69,-52,3,-13,-8,74,-63,-19,-25,8,41,-6,-30,-21,-17,67,-5,17,52,17,35,13,-55,18,-15,-38,-38,28,8,-12,0,-100,23,-118,-10,40,2,-11,-26,26,-20,22,45,38,7,-15,-30,12,-25,32,42,-29,-17,-17,-28,60,6,3,-29,50,3,-14,96,-66,-2,12,46,55,-4,1,4,-46,-64,-102,-77,-41,-66,65,27,7,96,62,-93,6,63,-30,-79,-31,-17,-12,-51,26,21,127,-16,-50,20,-3,65,17,-95,7,7,81,-40,57,-65,19,-29,10,-3,12,-48,91,62,0,57,-15,17,5,-44,75,19,4,-34,-64,-48,90,-7,35,16,17,11,36,-42,17,64,-4,29,69,-84,-25,-1,-23,25,50,15,9,55,77,-13,-27,69,-82,0,-28,-6,-91,-61,13,-19,26,-31,-103,5,-57,2,-17,17,61,51,-14,-23,-68,-4,-27,5,-14,-54,-14,-45,57,46,44,48,-112,15,0,7,-31,-64,32,59,35,-31,-52,-9,3,82,36,-69,18,-112,-61,52,-91,62,37,-52,70,-5,-96,-66,-44,21,20,53,-9,-91,-33,-50,-55,-54,46,49,91,13,30,-13,-3,19,35,-89,47,13,26,74,20,-40,-22, 
  /* [22][0][][] */ -66,48,43,-48,-17,-80,-12,-40,-1,-35,-41,-76,12,40,36,-30,-14,-66,-4,-24,-20,67,-76,40,2,-58,-83,-39,-28,-7,-55,38,-45,-15,-2,91,65,51,-81,66,1,31,15,17,34,13,-1,23,-19,-51,-28,-16,104,-9,-36,-28,39,12,-55,2,-51,42,-127,-46,-71,-3,-24,16,-54,25,-7,50,-25,36,-72,82,-24,-6,37,-24,-68,-1,-65,-11,-6,-10,-14,-4,-18,13,-66,32,-68,-23,75,68,-25,40,-18,45,4,80,-75,-19,46,-32,9,41,31,22,-24,77,44,-5,-38,-13,-54,56,16,-1,14,8,-48,-61,-23,74,17,43,-18,-40,-8,-50,13,-39,-19,77,-7,5,-74,-15,48,-59,35,42,21,-54,0,8,76,11,32,20,-44,-53,-44,-69,-17,51,18,17,-38,-29,6,46,-28,25,-62,65,-64,3,-4,-37,30,-81,11,21,-100,66,50,80,-6,-56,50,44,-57,3,4,-68,-86,94,-9,17,14,37,-8,8,2,8,5,-40,-1,69,-68,5,-51,-34,-48,-32,-30,-25,-36,0,-20,26,-8,14,-33,4,-35,-58,-25,13,-76,-24,66,73,28,-90,0,36,-41,-10,64,27,106,-80,-15,25,-14,-3,26,83,59,13,54,-9,31,-8,25,39,15,-24,-3,45,-16,-21,-6,35,-30,43,-2,23,-10,-13,15,12,-19,8,99,-5,9,-46,17,8,-81,0,-20,42,-29,99,7,118,61,-71,14,41,93,-5,25,6,19,-6,-20,45,-21,-2,55,91,9,-22,47,1,43,33,-35,-5,43,-81,48,72,41,-95,78,46,15,15,9,13,70,-17,-1,-123,76,-57,-18,-15,-1,-43,45,30,9,-41,32,-72,5,85, 
  /* [23][0][][] */ -65,7,30,21,48,54,-12,-51,42,27,39,16,-31,-13,-51,50,-7,-8,42,93,-1,41,8,22,-83,28,15,-4,70,-25,-59,14,6,18,-5,2,28,12,-20,60,86,109,2,34,35,-37,-96,0,23,46,6,-1,9,-15,45,-31,42,-94,76,-34,-37,-9,28,41,50,1,37,6,33,-11,42,5,5,-17,1,44,31,-50,-55,-96,-18,-39,-45,27,-38,28,-2,79,-14,8,-23,-11,68,-43,-18,27,8,-12,-5,71,-11,-50,127,-30,-19,100,-1,-69,75,2,25,10,-5,14,-28,-17,78,-24,41,-8,-3,45,59,-67,-21,-40,-29,73,20,13,-88,-21,-16,-69,-31,-23,90,75,-12,28,103,61,24,-46,28,11,-77,-11,-64,14,-83,-60,-57,0,26,-3,12,-71,-25,-20,78,-50,-23,-37,4,-32,-43,-50,-9,-16,7,-74,-11,30,37,28,24,68,44,-27,-7,-117,29,28,21,-6,-36,-29,60,-22,123,-81,-16,81,23,7,-28,34,3,-40,-55,-55,-63,21,62,6,-47,-37,-96,35,35,27,-25,-42,1,-55,-50,-111,48,46,-7,86,-103,-3,61,-13,-1,44,-11,-21,23,-48,56,17,75,-28,19,44,-62,-14,-55,-73,-35,-11,-56,14,-51,-89,13,47,16,30,-9,-22,49,51,65,-24,-50,-91,-33,6,-20,39,38,-2,14,87,-18,-8,-39,-37,55,94,-19,55,48,30,-45,65,-82,-60,32,-38,0,-16,51,-36,2,-27,-46,-34,-67,19,50,-30,-6,40,-14,-30,0,34,-7,80,-14,17,-100,8,-7,57,-73,6,33,-39,-2,3,-51,41,54,78,-30,-52,-1,-59,7,-64,33,89,3,-37,-35,-30,24,-3,23,26, 
  /* [24][0][][] */ -16,-11,-69,0,-2,-51,-1,4,84,31,48,14,57,-67,-71,-73,91,47,12,19,-8,18,-6,-27,68,3,50,-82,33,-20,58,74,40,34,-33,-2,-7,-39,28,-9,3,71,12,-77,43,26,0,15,-2,80,-27,6,-35,-72,-109,37,-48,76,82,52,-22,-35,16,62,-24,-28,10,-23,-49,-15,1,12,42,93,-88,69,-12,0,-44,17,-51,15,-41,-9,-32,14,-75,-1,28,-49,-42,-51,53,73,-48,-10,24,-55,53,52,-7,0,56,-26,-109,-45,37,-39,-37,38,27,76,-55,-82,-12,36,-7,101,37,6,1,1,41,-52,9,33,37,-16,-41,1,15,-28,-46,26,89,12,-28,-59,-40,-18,37,21,3,19,-30,45,23,59,14,-71,25,31,68,-13,28,-57,48,56,1,-5,-31,-7,42,-42,72,-13,13,8,19,-9,48,3,-51,-27,56,-49,31,41,-11,15,-19,38,50,-44,-1,8,-64,-12,72,5,-11,-2,73,-12,-17,-50,41,-4,23,-69,1,24,-70,-69,-28,4,39,-7,127,-83,10,-25,22,-20,-3,65,-32,-36,85,-35,-17,9,-54,38,66,25,-13,43,22,-60,52,71,63,-1,-21,-32,-28,52,55,-41,-26,-33,82,-24,-9,-78,25,-5,-6,-4,22,-3,-65,-50,40,51,25,4,44,-37,-98,-18,-5,35,-46,27,-31,-11,-53,-13,53,-1,94,-70,46,-2,50,-7,23,-17,-13,95,31,-44,-70,-10,-45,20,100,7,11,-3,40,68,30,-59,17,39,7,-36,16,-13,24,12,-58,46,36,44,18,-3,35,-52,-45,14,16,27,7,19,-41,50,-34,8,47,-65,21,67,26,70,10,18,-1,83,89,-42,-2,-30, 
  /* [25][0][][] */ -26,3,-17,-8,26,11,-12,39,-64,13,-29,-45,-74,47,60,-24,-43,-32,41,-2,20,14,-20,41,-29,6,31,-14,-66,-25,21,24,40,13,-14,91,2,35,33,-46,-17,27,-36,44,-37,53,-65,-8,-43,-34,31,-3,67,11,43,3,72,18,-27,5,29,-25,1,0,1,29,6,11,-15,-40,-6,45,-57,-35,-8,-61,3,38,39,-17,-7,21,-34,-5,-36,-78,33,-41,-60,-49,-54,-52,83,-56,-54,17,-12,17,3,14,-73,10,-32,0,42,-12,-11,-17,-7,-41,-60,59,13,-1,18,35,74,31,28,-3,1,-25,-13,-81,-5,1,10,14,-28,7,-8,12,29,-19,79,7,-8,-76,27,58,0,-28,52,-41,28,-86,-92,43,75,44,0,11,43,17,2,2,31,-4,10,49,68,-46,-7,16,-40,-7,34,55,-52,24,51,-18,1,-82,-33,31,5,23,-9,-58,-12,-5,95,9,29,18,-58,18,-17,-50,9,-32,-34,12,64,47,-26,-51,5,-107,-19,2,-15,-64,-67,14,-100,-64,-127,72,10,0,3,-6,-15,24,28,-9,-5,-31,33,-41,-20,46,8,-22,-37,-37,3,11,25,14,-1,62,27,43,18,10,-51,-47,-52,6,49,44,77,-30,36,-52,-59,2,0,-47,27,22,-8,-10,2,-68,19,27,-45,31,28,33,98,-3,-29,27,76,-15,6,14,16,-24,-7,-10,18,6,43,-33,37,24,54,30,-21,-20,118,117,-29,-49,-79,-41,-58,-57,2,16,-22,31,-64,-38,13,20,-17,61,6,-50,33,91,12,45,27,-4,-26,14,-23,17,-13,-78,81,-28,67,15,27,-32,-34,5,-70,-39,4,55,30,18,27,-9,3,13, 
  /* [26][0][][] */ 16,71,67,1,37,29,-36,-40,57,9,96,9,11,-58,47,6,-1,-28,-20,21,21,-11,-28,33,-43,36,22,-23,-61,50,34,-40,5,-31,-56,-51,4,-42,-6,6,-9,-22,-52,-3,46,-43,8,20,32,4,88,0,-52,59,55,-13,-32,6,10,-6,28,-45,93,23,50,-5,19,-11,46,-1,96,-83,53,-79,41,32,77,51,-43,44,10,22,35,31,-18,48,51,15,90,30,-38,-20,44,-7,-26,10,63,24,18,4,62,86,66,-3,-42,4,78,-26,11,25,-21,85,-66,14,-70,14,48,-12,66,94,-33,30,-21,-27,94,-1,-2,14,0,11,-46,-19,-46,16,26,65,-25,18,39,-35,41,27,-73,-19,-38,0,33,-44,10,50,27,-70,-15,54,-15,-95,69,16,-35,-33,-1,45,10,46,-4,-6,-5,-65,-50,23,85,66,-117,34,-25,-25,16,11,45,-4,69,0,-14,46,-30,-50,-7,31,33,-24,-7,-25,30,51,-83,-5,-7,-11,-58,-26,79,-17,-32,43,-40,-60,30,-5,-11,-48,34,-3,-2,-21,-45,-32,-9,-33,1,26,-51,32,-55,36,-36,-34,-14,68,11,-57,22,2,13,43,-16,93,-14,-45,-9,68,-9,17,22,56,-39,-41,-30,-6,37,62,5,6,-38,-30,48,-15,95,-26,-15,-77,-83,29,-14,-21,-23,61,-22,-38,-27,-127,-30,68,10,88,45,-35,70,-12,-22,-46,-53,-14,102,-30,-71,-37,-30,6,-73,-24,97,-12,-9,50,15,-71,8,-39,17,-51,-5,26,-14,44,0,-47,18,1,65,10,23,21,4,-49,45,-57,6,35,-2,-87,26,-24,59,-70,19,24,14,58,63,-15,-103,18,-6,31,65,-15, 
  /* [27][0][][] */ -30,-19,-3,-20,9,-9,4,7,44,-44,41,41,-7,-10,-26,-7,46,13,-60,37,-33,-15,-12,-26,51,-9,-13,28,20,-16,-58,-5,38,10,-2,-46,20,22,22,-15,32,0,11,43,53,39,39,100,-29,15,-15,-5,15,-6,-33,32,-32,8,-67,-47,77,52,10,36,1,-14,-44,-26,-69,8,21,-7,-34,20,5,54,-67,21,14,-32,-84,-4,-12,2,-38,25,-5,1,-15,19,0,10,27,-10,52,24,21,-42,5,26,-6,-57,66,-86,-32,-23,23,40,-41,-7,13,59,68,31,49,26,127,19,-57,-6,8,16,-28,-5,-24,-17,91,-1,45,-5,-55,-60,19,24,14,-12,-111,-28,-47,-68,18,26,1,33,29,1,57,-42,29,35,56,63,14,-12,43,3,-28,-27,68,-82,-119,-83,-40,-30,-23,6,-32,-47,7,-7,-43,-68,-72,-43,25,12,34,46,-40,-31,34,-101,-80,28,-10,-17,37,-58,53,47,31,-27,23,-9,40,33,17,-50,61,24,-47,9,41,-72,-24,-71,2,-57,81,-17,7,28,44,38,13,67,115,1,17,-7,79,-31,21,23,53,51,-31,-24,54,15,84,-1,87,-5,-9,33,5,44,121,29,35,8,0,-96,40,-72,-35,8,-1,-17,-22,53,-1,-57,-21,15,28,-47,66,42,-19,-3,-54,11,-75,-24,-28,-20,13,25,6,-12,21,-18,13,-69,-36,-23,5,-22,-40,-63,0,-10,1,-6,91,9,37,11,36,18,-9,18,-38,54,-55,-51,-28,-5,11,26,-31,-15,-103,-98,-94,-21,-19,-17,38,32,21,33,-11,71,87,-54,-24,118,45,-83,-26,0,12,100,33,50,-22,-32,-84,2,4,107,-17,48, 
  /* [28][0][][] */ 30,-2,33,-32,31,5,43,46,27,-6,51,-56,40,47,-13,-26,59,88,-12,-19,-9,-35,37,-19,36,34,35,-66,-3,-16,-40,18,29,-15,-30,-18,4,45,18,-2,49,-39,42,-83,5,-22,60,-19,-42,-23,-57,53,-6,-13,-26,43,-34,-10,4,5,-39,9,5,35,30,-7,0,-2,13,-29,-41,-13,-12,40,101,28,21,16,37,-16,85,-37,68,-16,71,27,24,-25,55,45,-8,-30,-18,-1,42,9,7,9,74,-72,-63,-5,16,9,-39,0,-49,23,-29,8,38,44,17,70,-20,-9,38,8,49,-21,-31,-51,-3,-13,104,-8,29,58,38,1,-42,30,86,-48,8,49,36,27,4,-91,21,19,29,53,9,25,-16,31,-20,-4,22,13,8,-42,21,49,-6,1,-8,-21,17,-11,21,6,48,39,127,10,49,20,24,17,14,-16,-7,70,75,-23,-80,-14,-9,58,-60,-46,34,-58,51,3,0,-1,25,94,7,4,13,40,11,-2,-14,-1,-24,67,14,4,-25,13,-42,-10,33,64,-66,-7,51,-51,-6,9,-25,53,-48,85,-2,42,25,-24,-44,-31,-36,60,-25,-35,7,-25,-10,-14,42,28,-34,-55,74,-18,36,14,-46,-51,6,19,0,33,-29,-64,-27,-4,28,21,22,38,-50,-45,105,-46,31,-57,0,8,-12,-2,28,-56,-23,-98,-42,9,-37,26,-23,9,64,60,54,-72,-81,72,-50,-44,-25,-10,8,48,48,8,7,67,-23,13,11,-39,103,56,-19,20,46,-19,3,-2,17,36,32,16,-15,-16,-36,22,-84,-38,39,62,2,83,3,89,16,65,-30,-6,50,50,-57,-52,-9,-12,8,19,45,-57,-3,-53, 
  /* [29][0][][] */ -52,79,9,-9,54,3,-32,-2,2,10,23,-40,59,-36,-14,59,20,-20,42,0,-14,87,-29,-2,-41,29,-10,6,15,23,30,10,29,17,-13,-35,-20,-23,-3,11,-6,24,55,12,-69,42,-72,35,-62,94,-57,-29,10,7,33,19,33,1,14,59,-49,-28,60,-25,-41,12,-26,-3,-1,53,-45,85,-20,0,-93,5,5,28,-22,74,-60,-14,-53,-6,29,65,30,0,-78,-16,-9,-1,-7,-33,51,-46,42,5,61,-35,60,93,6,56,93,-20,-2,-70,36,13,-41,15,28,17,-14,3,5,69,-7,73,40,22,-15,-33,-28,81,16,8,20,48,2,52,50,29,59,-9,-22,20,45,16,64,-12,49,-57,-25,1,-44,28,42,-31,81,16,13,-102,-78,26,64,-59,-2,-69,-97,23,73,-49,-1,-6,16,-52,20,-62,0,13,19,-5,45,21,-3,99,-42,-22,30,-9,-72,28,58,44,18,-29,33,-59,-20,16,-9,-63,0,-10,-4,1,85,-6,-55,30,30,23,1,-8,-15,-11,-16,-63,-22,-32,14,12,-7,2,-53,-14,-19,-24,-25,-29,65,17,-13,50,60,-17,-6,25,-37,15,-56,48,-7,-72,32,-62,-127,10,17,-28,-29,17,20,-33,0,-6,27,-103,121,-20,33,-18,-51,15,42,-63,12,76,4,-58,89,-28,-7,-10,50,-44,-54,12,-27,-65,13,24,-69,-72,22,66,39,-77,-38,-6,21,-35,5,-44,-43,12,84,9,37,9,62,70,32,-7,-35,3,1,-49,29,37,-28,-16,-5,-78,65,-102,-96,25,20,-59,8,11,-21,-49,13,-34,25,12,-22,-43,28,-20,33,45,45,-51,-21,22,23,48,56,-27,-11,-5, 
  /* [30][0][][] */ -47,-39,-36,49,-26,-64,-1,3,-23,-82,9,-84,-2,12,0,-17,-10,-56,11,-29,22,-21,13,3,59,59,91,15,-25,-40,-28,-47,-6,26,-71,2,-44,-3,82,3,30,-2,-5,6,-17,-2,-72,-56,32,5,28,16,-32,-26,-53,-15,-94,30,13,26,23,37,-34,75,27,-15,-26,-87,-18,26,-21,-14,1,3,8,15,-6,0,-2,19,-58,-13,15,-6,-46,10,48,36,-15,34,-12,-72,-11,29,-47,6,-10,-37,74,4,78,99,-49,21,8,18,20,-81,9,-49,-50,-42,-41,32,24,52,35,42,-33,1,31,6,-27,-39,-34,-21,3,-16,-52,42,-24,49,68,-38,-29,-39,16,-85,-33,-43,10,25,-71,-25,22,-39,65,89,34,84,12,-65,31,-18,-17,-96,61,-53,-57,13,-34,-26,60,41,-61,-24,13,12,-50,79,-82,-8,11,-53,49,-51,-26,45,66,-43,-10,18,61,52,-5,21,-2,-11,16,60,17,17,-25,-18,19,-24,16,27,-20,32,6,31,-18,-38,-19,-8,-21,47,1,-55,61,52,-59,14,-57,20,-27,-4,4,54,32,-8,-8,11,-23,4,6,-78,1,-26,-10,-16,28,-14,-20,-12,-37,104,-17,13,21,-61,27,14,-15,1,16,-13,36,-27,21,0,13,30,25,35,28,-41,-7,26,-1,13,-63,44,75,127,11,-24,-44,38,-35,-11,59,2,-4,14,-13,47,77,24,-20,22,34,-42,-68,-18,36,-33,-89,-17,-22,-39,-37,27,-9,61,77,-11,34,-20,-58,-28,45,24,-36,40,33,-63,16,58,-49,-70,0,15,-12,-66,-66,-59,48,0,20,8,38,-96,17,9,-3,-44,48,31,39,-12,12,-31,-31,-95, 
  /* [31][0][][] */ -12,-69,0,-40,36,50,0,-80,6,10,-56,-14,15,7,9,-31,-2,29,-50,90,-24,-50,38,1,-9,12,12,-52,-62,45,-1,-26,52,-48,18,71,-12,-6,25,-19,14,25,-7,-4,-14,-31,87,-28,-30,-60,10,-30,-41,-8,-46,-66,-8,-93,13,-43,50,8,-34,-26,14,-28,-80,16,-16,-15,7,-39,-9,76,59,101,-20,15,-20,-45,22,-68,-11,23,-25,-68,47,-24,26,-22,2,-49,30,15,3,2,-26,10,-116,31,32,-41,22,-39,-8,-13,20,73,-11,9,64,77,10,-49,-40,-4,-26,47,2,28,3,28,34,-41,23,15,4,57,-49,53,-106,48,1,45,36,119,22,-4,-31,-82,-26,89,-84,-93,-45,-75,10,35,-24,24,20,36,70,-25,15,13,34,-27,-43,-64,-67,34,-15,68,-13,-36,-111,68,13,-22,86,78,-9,-98,-68,12,8,-11,-1,97,91,22,-25,13,-33,12,33,-49,-76,28,47,-6,-45,11,-54,8,24,-2,-15,-127,40,-4,45,-44,-52,7,1,-34,-9,49,51,44,55,-84,4,-24,21,-67,15,48,-16,38,-52,-36,-51,-33,-5,-67,4,32,17,2,-44,13,41,-28,-26,-38,25,50,-61,-31,-30,58,-45,-10,-60,-1,53,15,-42,48,-16,72,-32,-2,-45,5,7,34,9,-49,-32,-2,20,58,38,15,-54,63,33,-30,46,79,-40,58,45,37,-58,-41,-40,-37,-45,-32,75,34,-1,-27,25,116,-46,36,13,-32,8,-1,19,91,55,-32,-45,25,-49,-8,41,19,32,23,22,37,-31,28,-22,6,19,-2,-33,21,5,-77,-50,17,-18,19,5,34,38,15,-4,-40,-110,-60,35,-88,14,32, 
  /* [32][0][][] */ 38,-56,5,-22,44,53,-28,-23,19,-42,-64,59,-38,14,20,35,5,33,26,73,13,-25,22,20,-90,-9,-107,40,31,-12,-20,-49,-2,13,11,1,6,36,-39,-87,89,-10,31,88,127,-19,20,17,4,-14,-25,-79,19,10,8,-64,53,65,-28,21,-57,-54,-72,-79,80,77,41,56,-38,4,11,-42,-17,1,28,67,26,-75,31,38,48,-41,87,97,45,24,-4,49,-72,-47,71,22,-118,-16,65,-54,44,-50,-29,-36,-7,-11,80,66,6,-9,-3,21,53,35,-35,-25,24,67,79,24,-112,-110,47,2,-16,22,80,10,-36,-62,-4,-9,-17,-50,-18,-21,63,-5,-31,-11,-29,51,-7,-36,30,17,-18,24,-44,23,-83,-1,-101,37,-117,22,-77,36,-2,124,-93,68,-4,26,-11,-22,-16,-34,73,1,5,53,66,-46,-66,-1,-17,9,-6,-2,-53,23,-61,30,-25,43,1,-10,-17,20,123,-21,-62,22,52,31,9,2,56,-53,39,-86,-34,-55,-12,-20,30,-19,39,-26,-49,-48,-3,40,-101,17,60,-56,8,21,69,96,-10,72,41,-41,21,-71,-4,10,31,30,-9,-79,31,41,-36,-21,26,3,5,-82,64,-13,46,-6,-33,-9,45,-29,12,53,-4,-20,-12,59,-22,27,-7,-36,-33,46,-59,-83,39,35,1,-64,-37,-23,-11,31,27,29,-49,-6,-18,2,29,-6,67,93,-4,30,62,-21,-48,-1,45,-19,31,-32,0,18,71,42,-67,30,1,15,19,-13,28,11,17,-18,14,-10,22,-6,-26,-19,5,27,63,15,52,8,-57,24,23,-10,19,43,15,-32,-61,-49,-65,7,-22,63,2,17,-1,-73,-41,-3,-42,-1, 
  /* [33][0][][] */ -9,27,20,-18,-1,-22,-20,6,-13,18,-39,-31,3,34,-55,15,-29,-51,38,-6,-98,-36,-26,22,18,8,11,28,-127,-15,-90,12,66,24,9,-69,59,13,-3,26,19,39,34,-61,30,-31,-69,-18,-7,47,9,-46,25,-63,-4,-42,-31,20,-31,8,-10,-35,-2,-44,-48,-13,-91,13,-88,84,-10,-61,28,33,-7,6,-23,-22,-41,29,-45,-3,-43,15,23,38,5,69,-51,-5,0,35,-3,-63,2,21,-4,-12,6,6,62,-42,-30,48,21,-39,-17,-102,-7,-54,-24,25,84,-68,-11,-11,-56,5,-27,-5,-43,-1,41,0,14,22,-54,-86,32,12,-99,-38,-26,-1,58,3,-71,31,5,16,-51,-21,49,74,-25,45,15,-66,-13,0,24,4,-42,26,-35,-79,38,-87,62,32,-16,-19,-5,-78,-15,-6,-18,-19,-16,-61,-17,-82,-30,23,13,-37,-4,17,-35,52,-12,-70,110,17,-14,5,-19,-2,53,5,19,-71,101,-12,-21,93,2,-28,55,-17,-9,-45,-49,79,42,-6,-16,63,36,9,-13,47,-53,-22,-44,16,-22,-15,66,-10,-45,-4,-79,-23,-19,12,-31,63,58,-9,-7,9,9,-14,-31,-2,-3,3,-27,16,-21,48,-48,-31,11,30,6,-57,-1,-23,20,34,-35,-11,41,81,7,26,-13,21,-29,38,-14,-37,-79,-99,2,31,21,-4,-23,-52,-29,-47,-2,5,-32,53,-20,55,0,-59,42,-66,-36,8,-10,6,52,-65,22,46,1,75,-82,-10,-9,18,20,-17,13,18,-8,17,-74,-61,10,-85,-4,8,-7,-76,63,18,-68,15,-63,-46,-75,37,-28,57,6,19,-16,2,-57,-21,-9,91,-53,25,92,30,-61,36, 
  /* [34][0][][] */ -58,7,7,-17,-28,-68,-58,-5,-53,-7,-31,-15,-21,3,17,48,-10,-13,6,46,6,18,-13,-43,37,-42,8,15,-57,1,-13,14,-8,-43,10,-35,5,31,49,-21,-52,44,7,-51,-18,22,-31,-11,-36,10,11,13,-57,30,7,-89,8,49,6,35,3,-31,-8,8,-61,10,-5,-5,-30,-11,2,7,46,84,-11,-42,-3,-58,1,-49,40,-27,-50,38,30,-7,-3,13,-41,43,-38,-1,24,41,-69,50,13,1,-10,-13,19,-104,-48,-27,-11,-19,31,-24,22,13,-2,15,45,39,-4,15,-71,-11,84,-1,18,-10,-40,-32,-47,35,36,40,-6,14,-55,-26,-11,24,14,1,53,-24,-105,-14,-25,-12,49,8,31,6,-50,-1,66,-26,-47,-17,7,-42,-55,59,-31,5,34,16,43,-37,-4,17,71,-45,23,-28,-12,-34,41,-40,4,7,15,51,21,18,16,-42,21,6,0,84,44,-12,-45,-30,-35,-13,26,55,-78,-2,67,18,48,-35,-26,-17,-48,11,-38,8,-26,7,-92,5,-3,-6,39,4,19,-42,45,2,56,-10,14,-14,29,6,-44,-104,-1,83,-3,63,-44,-30,-4,13,6,19,16,-92,14,75,-40,32,-11,-53,-30,41,11,77,20,57,-36,-5,42,-31,-15,8,3,32,-10,26,11,37,23,-36,18,-26,38,0,15,12,23,10,-9,38,-25,10,-21,36,6,-42,17,81,13,38,36,59,-40,-4,42,62,33,4,-41,-27,-49,-55,11,7,14,-20,56,46,-2,-9,6,21,-1,-13,49,-22,21,-2,14,-112,31,17,127,0,-68,-2,10,-16,-52,-27,39,-3,-62,-50,-23,-58,30,32,-28,6,-11,0,-29,8, 
  /* [35][0][][] */ -8,-25,51,-25,3,41,-14,3,-7,-52,-27,-31,36,-15,39,9,-41,25,9,-36,23,45,7,-8,-22,-5,55,-48,26,49,50,-3,15,-92,-7,5,-6,-54,-78,-108,22,42,-48,-3,23,-6,5,16,67,-36,44,-44,52,16,29,-10,33,-72,-77,-26,2,25,61,-1,53,-47,34,8,-12,-38,49,-29,26,23,-11,-77,-30,101,20,57,37,88,-45,39,-3,-12,12,-25,22,53,-27,-59,-25,16,-29,-16,25,12,-52,-49,13,33,-21,44,-63,-34,81,-10,12,-57,-18,-34,10,-80,-7,-11,1,77,90,-70,-3,81,-11,36,97,80,127,70,7,-51,21,0,-49,-65,2,-45,71,-33,-43,48,-38,1,14,36,1,-15,-62,-83,13,1,19,-38,86,24,37,42,10,-54,-58,12,8,-7,1,-27,50,38,41,-23,64,13,-15,-14,34,-4,-6,-1,-52,-12,55,-8,-4,2,26,36,55,-26,25,-1,21,-14,58,-10,-13,60,-46,38,7,94,-2,23,65,-49,-14,-33,50,-18,-14,6,-27,-18,-9,-35,17,-1,-30,44,4,-20,-11,11,-47,7,-51,-62,-12,-5,19,58,26,-1,-72,31,-74,17,-32,15,-7,-4,40,-26,29,-29,-29,-39,7,-8,25,-60,-9,9,-71,10,-81,2,13,-50,-100,-23,1,-30,-5,-54,-35,-7,-51,-11,60,-15,5,-2,1,-30,5,8,22,80,90,-28,42,94,-13,35,-35,-34,18,-22,36,16,-3,-40,-2,21,12,-33,29,40,29,36,7,29,21,55,-12,32,2,83,19,28,15,47,16,10,-6,-40,-45,-34,7,53,65,-17,18,-3,50,-22,7,-41,-2,17,44,10,30,-17,-9,-9,-3,-35, 
  /* [36][0][][] */ -92,0,-71,-45,-24,15,86,13,-25,88,-21,9,43,21,-30,-10,43,-47,42,13,-68,-27,43,4,-16,39,58,-31,9,-24,-7,-4,16,64,42,-23,-4,47,11,36,-2,-8,39,35,17,-28,15,36,8,10,38,5,32,1,37,-18,-5,-23,-4,46,64,-14,39,44,37,-29,-33,22,-4,-26,-41,35,-34,-56,-29,6,34,-29,31,-4,2,56,-44,-17,-33,31,33,21,-35,42,0,8,-32,20,-65,-47,22,-3,4,-5,20,-41,16,-20,-38,49,64,-65,-5,14,-14,-5,-73,60,-81,49,1,-78,-76,5,-66,17,-23,-15,-35,27,98,-26,-6,-73,-40,42,-6,-76,67,16,-92,36,-23,8,8,-6,-52,41,0,-76,-41,-31,-76,57,-27,-40,-30,12,-57,-61,-41,-47,-11,-14,44,19,3,-38,-43,-44,-18,40,-59,44,-25,41,-3,18,44,86,11,56,-26,20,9,-7,5,-42,-40,-37,9,-11,11,-5,-29,-32,9,21,-48,16,-53,1,-101,64,65,41,1,-34,1,-6,21,-67,10,-36,44,25,127,-9,39,82,-16,-29,38,57,41,-1,68,16,-1,-10,80,-31,29,-82,77,-45,12,55,26,81,-27,9,15,1,-64,-37,22,10,-12,-60,1,-6,-19,28,-45,18,14,-31,39,46,26,9,2,-42,-39,54,-64,34,25,39,-32,9,-29,15,119,-3,66,-31,-21,-4,-88,-40,-7,-38,28,22,63,5,27,27,81,-1,-63,33,-19,29,54,-30,66,25,117,-10,-54,-42,16,39,23,68,10,54,8,33,49,-47,46,79,-10,29,1,-22,-22,5,-20,-42,-24,-49,-93,10,-29,-66,-16,38,16,-34,11,-26,18,-28,-26,-37, 
  /* [37][0][][] */ -29,-36,-46,-18,-14,85,41,-10,-4,0,3,-37,26,-32,-46,18,17,20,41,52,9,-29,-11,43,-4,44,50,15,39,-9,7,-29,16,16,13,18,-8,22,11,-74,4,40,-12,-4,-62,-22,60,57,23,-21,0,-77,13,-12,-41,21,14,20,-14,-49,27,31,79,74,30,-14,-50,-8,5,-34,26,35,-4,14,22,6,-30,-8,20,-26,36,-20,33,-27,-67,9,38,-25,-36,55,-42,-21,45,54,-2,36,23,-8,-36,-63,71,-19,0,-76,-8,14,40,22,17,-34,36,-48,-35,33,-1,38,38,-26,-93,23,63,28,24,36,-1,5,48,34,17,-14,4,-14,-23,-34,29,43,59,-4,34,33,-45,-12,-31,25,-34,-41,1,19,2,-109,31,-16,32,-61,24,23,-5,-3,23,8,-7,35,-12,-70,-33,0,19,7,28,34,-38,48,-59,12,17,3,11,-29,17,40,-7,-39,11,11,39,-13,-11,-3,63,-59,39,18,-61,-20,-48,15,24,46,-51,-7,55,1,22,52,-17,-41,-39,1,-65,-41,6,19,14,42,14,-5,9,-55,-3,96,73,-14,59,-49,14,49,69,-16,22,2,70,54,2,37,5,-74,60,27,0,-19,-23,22,34,32,59,-70,66,16,32,3,7,-40,5,-91,-32,-14,-53,37,33,-7,31,-39,-26,32,7,48,48,-47,11,-43,-15,5,11,42,17,-14,-94,-22,39,-12,-39,-4,54,14,-127,-28,73,-38,32,-16,14,-12,33,-11,45,-30,2,-4,22,48,58,70,-63,-11,38,10,23,12,17,53,23,72,37,-38,-4,-9,-17,-13,12,13,12,-20,41,-10,85,-12,-56,38,12,-10,29,-11,-13,65,62,60, 
  /* [38][0][][] */ 62,-40,9,127,-63,23,-2,27,-12,-42,27,21,-42,15,-61,-43,14,58,-28,-6,48,-50,-16,6,-25,-30,27,19,6,9,1,29,12,24,-11,-5,26,70,19,-64,43,40,12,48,37,-54,-23,-73,11,9,-70,15,10,-42,-53,-10,-10,-5,-24,-82,52,-2,78,-25,23,-47,59,41,-4,27,12,-34,-22,27,5,-28,-38,-58,-80,-4,2,8,-2,6,19,35,21,10,-16,-13,-28,-12,100,-21,-3,-5,12,45,8,35,23,-37,-79,-11,32,-90,6,34,-48,-10,11,3,29,-32,38,4,22,34,43,4,-53,-4,5,27,65,-15,42,-78,0,29,60,-6,-19,-20,-12,15,-5,-28,-27,-28,28,-1,61,-3,38,22,10,94,-24,-30,24,-21,3,-60,-32,75,-1,-26,60,-23,-39,0,21,7,30,36,10,49,57,-8,-8,33,-46,-4,62,-56,-13,28,-37,8,21,17,-12,63,-2,-1,-16,-27,44,-27,9,8,59,23,-38,-30,33,18,23,-58,-1,-26,-30,68,-11,10,13,32,-24,-10,31,-15,-55,-66,18,-4,51,-16,13,12,-34,-8,-43,-18,-5,9,47,-32,17,18,22,7,-4,8,11,-6,-65,26,-12,-16,5,-59,26,-6,33,7,-26,-8,23,33,-41,8,6,15,56,28,-31,-35,-21,29,-8,2,54,-20,-36,31,-18,-5,-3,-53,21,20,-11,26,-6,-103,37,-54,25,-95,-75,-32,-16,-16,24,6,-6,33,29,15,26,-36,30,13,-26,25,-55,28,26,-43,1,-8,5,-11,18,-17,-2,-33,29,23,2,-37,31,7,2,6,-15,-92,-2,9,11,-27,-53,12,-1,47,-49,-71,-61,-22,-55,40,62,-33,-22,-17, 
  /* [39][0][][] */ 36,50,-35,57,-63,-24,22,-15,-87,-9,-29,3,33,-8,29,-28,12,-109,-6,35,10,-3,25,-24,36,43,50,-49,-3,12,54,45,-87,27,-50,6,-57,-14,-8,26,-71,-35,-86,9,-78,40,-29,-42,83,70,-6,-10,-22,-6,55,8,18,12,-11,-39,9,-49,74,3,-28,17,29,-44,-20,-19,-26,-27,-21,26,5,-99,-32,93,3,-15,-53,37,49,-31,56,-27,37,32,57,-1,5,50,-37,14,16,12,0,-56,14,-21,42,62,-26,-27,-19,-24,-24,-49,-41,-7,17,-11,-84,-80,-1,3,-1,3,5,-65,0,-57,-24,50,19,-32,45,-65,-3,-17,18,-47,18,25,-60,12,10,-27,50,-37,15,-70,-6,23,1,35,31,-15,-54,-16,6,16,27,-22,79,-45,29,-18,-32,10,25,1,-4,-3,-48,28,-34,-64,-127,-16,-11,-15,-40,15,-4,17,25,-37,45,22,20,17,-78,-4,-25,51,-88,34,22,-20,-59,3,53,-67,50,-31,-28,25,35,29,1,-8,74,-21,-37,64,4,20,5,-6,20,-51,-67,76,0,-23,-19,13,38,-14,10,-18,17,-33,22,27,11,68,62,33,-1,56,8,36,3,-5,10,45,30,15,-6,-4,-11,-4,34,-7,-2,21,-24,-34,14,-14,-36,11,73,9,6,8,-27,-40,-13,3,-46,55,-29,-21,-17,-55,44,-24,28,-47,-4,-46,-15,-25,-35,-37,-3,-35,-10,18,7,41,21,-48,-29,-6,6,3,24,24,-20,-9,-29,7,-3,-20,11,21,42,35,7,-5,-14,-26,-24,44,-55,-46,-57,-24,-48,-16,6,-35,22,-9,-37,-17,17,49,59,-8,-2,-37,31,-28,-42,27,-5,16,-14,-34,-11,24, 
  /* [40][0][][] */ -56,28,-40,27,71,30,68,-62,80,-8,51,56,-79,-45,3,28,-71,52,-13,-11,31,52,-54,24,2,-40,21,1,32,83,-44,-46,27,-11,-27,33,10,-34,-6,-37,15,16,47,114,-30,14,-44,-58,-25,81,28,-14,-29,-38,-19,-40,-123,-4,-10,-72,61,3,41,22,26,72,56,26,37,-50,51,-21,-8,-33,-10,80,13,-32,-22,-26,9,-39,1,-19,-11,11,29,2,-42,36,-13,45,-6,9,25,-34,16,25,-17,-53,50,32,93,3,-26,2,3,-19,-25,20,34,65,45,24,-63,9,-97,102,-51,48,67,30,-13,71,-13,91,-9,-10,27,50,-14,-15,-5,12,7,-11,-14,40,-50,68,9,47,-57,-9,45,-13,-40,16,32,-10,-2,16,32,20,-17,12,20,37,-4,20,41,-3,28,6,-52,49,36,-2,61,-1,-58,14,-8,43,5,1,-76,75,95,-21,33,-41,28,-11,86,-29,-17,49,-1,24,36,32,-49,-67,-12,-49,57,18,-65,42,-35,-5,-5,-57,-14,11,-9,50,74,-48,111,-6,-28,21,10,46,9,-21,-38,7,-38,39,-1,4,-45,20,-19,29,12,-84,34,-5,-23,-41,15,29,-4,-10,-47,38,-1,25,-50,-36,8,5,14,44,29,-52,-35,28,32,-11,5,-48,9,7,-9,-29,53,-48,-12,2,-72,83,-1,-38,3,-36,42,-23,40,28,-16,12,-3,-9,-19,42,-5,36,-97,-13,0,27,7,-33,28,-23,-29,57,-73,25,-3,-28,-127,-20,85,43,64,18,35,48,10,-15,-31,-54,4,110,-28,39,26,8,-32,37,45,-25,-91,11,-30,-34,-15,-52,47,107,49,77,-31,-25,-39,16,-19,31,-46,14, 
  /* [41][0][][] */ 13,-27,58,52,-10,10,-18,-4,9,-16,12,-14,4,-25,107,34,6,-43,-62,3,14,-13,13,-13,22,-13,-23,-4,1,34,5,52,-36,50,-8,41,42,-2,37,9,-43,2,-49,-94,-6,-17,-7,-2,76,-13,-15,-30,-26,31,13,40,34,-12,-25,-35,22,30,-43,-11,9,4,-34,-33,-26,41,-2,-28,76,88,32,-32,78,39,43,-15,10,-45,17,27,60,38,17,-1,83,-74,-29,26,-15,16,16,-21,18,23,-51,-33,-29,51,20,-25,82,-45,11,66,-4,12,-18,-64,2,21,10,4,-29,-6,-127,-37,51,-41,-67,-35,38,6,-19,46,-15,44,-39,-75,1,37,-34,8,-32,-17,12,-81,-32,38,10,4,9,-43,-41,54,-15,-44,11,-38,-38,20,-22,-47,-19,40,2,-15,5,-1,64,78,36,18,11,38,21,-57,-26,-30,-3,72,-56,15,-14,24,1,-8,-16,29,1,77,35,45,17,-5,-45,26,-23,-10,-24,-26,-44,9,44,15,-44,62,11,-20,12,-8,7,53,-21,64,26,19,14,17,-38,-13,-23,-30,-25,20,-20,44,52,7,7,5,72,-21,-15,-83,-1,39,-38,-4,47,-28,-29,-7,-10,4,46,53,68,-81,-51,-33,-32,-1,33,-10,44,-23,-82,20,20,50,10,21,-46,38,-17,-31,-4,21,87,4,10,35,-9,8,38,51,-42,-5,0,-42,85,23,-57,-47,21,53,-47,42,6,21,-42,38,22,39,47,-27,62,-13,-11,17,33,30,-4,-51,-3,31,28,69,-9,-33,16,-4,24,23,-7,16,53,85,-34,3,119,38,-14,16,30,45,53,17,12,-12,0,-24,-16,75,28,15,-58,25,-70,5,37,28, 
  /* [42][0][][] */ -13,38,-11,-1,32,-11,11,-68,42,19,26,-32,-19,4,-22,8,-51,-5,9,35,-25,10,15,42,-50,30,-4,-11,69,54,9,-28,68,62,40,-50,22,6,10,-2,-12,10,-21,10,41,-85,-29,-25,-25,80,68,3,-50,5,14,-27,-6,-5,56,39,0,-6,29,40,34,11,-37,43,29,-4,48,-16,34,-43,-43,14,103,-9,2,34,-62,68,-51,64,-4,119,-42,-2,-19,71,12,-16,-63,48,-21,4,31,42,17,9,3,36,66,-9,-20,-31,27,45,-24,4,-3,45,5,-47,32,-46,2,-40,20,8,13,36,47,14,-29,23,-43,-28,-34,11,28,23,-46,-71,127,-15,-74,8,-23,44,-28,30,25,-21,-14,-24,13,20,-37,-31,-67,-24,-37,41,-20,0,-7,-8,24,23,17,-10,31,-19,-41,-11,60,24,22,-16,45,47,12,-94,30,-47,-2,48,17,-27,7,-10,-12,-44,28,-66,34,25,-27,17,-2,42,-29,19,-4,18,38,20,-70,65,-13,-10,-72,63,30,29,-26,61,-47,59,1,34,67,29,42,10,-9,-62,17,-24,-44,-12,2,-41,-43,-39,-18,-22,-26,18,-47,-19,2,60,-61,-37,22,51,-102,64,-6,59,-48,31,44,-15,-27,-16,-16,-25,51,37,-15,-86,33,10,62,-28,35,-24,7,-44,-12,15,16,26,10,15,-32,57,-81,-20,-34,18,-31,38,-25,-47,-35,82,-36,-26,16,24,22,-5,44,-14,-6,9,-37,-73,34,9,-3,13,-14,3,20,-12,6,-1,43,-33,-21,34,-3,-27,35,31,-7,-43,-5,7,-20,-10,13,60,39,-53,1,-1,-1,-11,16,-1,13,4,70,-29,-38,15,7,-38,-22,23, 
  /* [43][0][][] */ -27,-54,19,2,-84,-19,13,-41,8,-15,11,22,-59,-68,-13,18,10,12,21,51,58,44,15,25,9,16,5,60,-29,-31,-6,2,-8,-4,27,8,-38,-22,7,-31,11,60,-36,18,-32,14,-20,12,-64,22,-39,-6,10,32,10,-8,-13,-11,34,21,36,0,31,25,-9,8,17,25,10,-12,-11,-15,1,-45,-11,-31,60,20,-24,-7,-3,52,24,-13,6,19,-30,14,-21,25,-2,-10,-14,20,-23,7,9,13,7,43,-31,-41,-44,27,-33,-80,10,38,46,14,6,7,10,51,3,-9,5,4,-30,-1,-12,-31,-28,-10,-17,37,-38,-52,30,-7,11,-42,-14,-8,6,-17,-10,12,8,-7,0,7,-69,-10,-19,-4,51,-25,-26,-3,19,-28,3,-33,41,36,10,-37,0,-2,12,-21,1,3,9,-30,4,-21,0,-3,-2,-7,10,-19,20,16,-5,-2,2,2,29,6,-26,7,-39,48,5,1,5,6,-17,-26,-37,-14,-17,18,-39,68,127,-25,-9,1,34,39,17,43,54,-18,14,-12,10,2,22,41,39,-45,43,15,-14,-45,-10,16,-13,55,20,-38,-3,45,-18,-2,-15,31,40,16,28,0,17,-10,1,-31,17,-35,19,-15,-13,-13,47,23,3,-39,-26,-19,42,2,-7,5,34,-29,-13,55,3,-35,-59,41,-17,20,9,18,30,36,17,-10,36,-38,-13,1,-24,-37,-22,-52,-22,38,-21,-1,12,-21,-23,9,-19,17,-51,-13,-5,17,18,-19,11,-7,-54,14,23,29,-6,-35,30,-25,21,7,-21,-15,-13,-27,31,9,-36,-36,-48,40,12,37,10,-12,41,-44,-12,-13,-5,-10,-45,11,19,32,-2,33,-38,23, 
  /* [44][0][][] */ -17,-7,5,-62,-67,-35,-37,16,60,-14,-90,11,-6,-18,35,-67,23,-25,48,-98,70,26,-27,18,93,15,31,57,-18,19,56,16,-107,98,-63,-9,-24,3,82,48,2,51,41,42,14,-44,51,-14,23,-12,11,-17,25,-52,65,84,-28,-10,-20,125,28,-80,-24,-26,-26,-5,5,-2,-35,24,7,-56,-20,-18,-118,42,-43,7,17,44,15,63,-14,-13,-73,0,-103,21,-9,23,68,-47,-71,-76,28,0,-49,-28,-69,-1,15,-66,-41,-42,73,29,-14,-56,39,-13,45,-67,-26,-70,9,58,56,-34,85,42,58,18,-4,-46,-36,27,-44,92,-26,-113,-55,78,57,3,-114,-118,29,71,6,-23,7,-43,-113,-44,14,-34,31,-41,37,56,52,-2,15,0,-73,17,-101,50,-7,58,36,14,25,-29,-25,3,-62,-4,-92,36,31,77,62,-106,24,96,-19,-53,46,-45,49,77,-13,14,86,-23,-33,-38,34,-12,22,0,26,-91,34,-19,29,80,-85,8,-42,98,-55,-34,6,13,68,51,22,-46,-11,-13,18,-26,-73,-17,-22,-15,19,-45,10,17,20,-9,-21,-53,21,12,10,69,93,-43,-58,61,29,19,-6,-74,48,10,-31,0,27,-2,28,124,25,26,66,78,-8,-4,-30,8,-71,78,58,50,-7,10,15,33,-34,21,9,39,-10,17,44,55,31,-88,75,-24,-47,-22,71,-8,-22,95,-10,64,-1,49,30,29,115,-32,-65,-15,-107,29,-1,42,-27,-44,27,-33,33,-14,-14,41,7,-22,-8,18,-21,8,-20,-41,1,8,59,36,44,-127,48,62,-31,37,29,-42,11,4,-61,26,83,15,-12,18,-54,51,13,91,93,-40, 
  /* [45][0][][] */ -6,-33,18,22,-44,17,10,7,67,-14,-34,-22,33,57,47,25,-12,-8,-19,41,12,-69,27,-15,-92,-54,-58,10,32,26,-16,-33,-11,17,-2,21,0,-37,23,-3,53,-42,-12,-98,71,7,1,-7,43,23,40,10,-96,22,52,58,-37,-12,-48,20,-6,5,-52,31,12,-18,-28,-7,36,-8,74,-127,-28,-11,1,9,19,12,5,-68,-39,-86,-36,-34,-70,-27,-5,15,-15,-16,-43,19,5,-75,31,53,-12,-4,-10,-33,-81,-1,49,0,100,66,-3,-23,-87,-22,52,-28,71,7,50,-14,15,-10,-36,24,10,75,-42,-9,54,-59,-36,-15,1,19,-10,24,10,29,-40,-11,6,60,-40,-30,36,69,-60,23,-36,11,6,42,7,60,-17,-76,-42,26,-46,-47,-43,33,-19,3,23,6,25,-25,11,39,-65,6,46,28,12,-74,0,-5,-34,14,-69,-62,-5,-52,34,-4,98,42,11,108,41,27,-118,25,35,37,-30,-73,-61,67,60,58,52,58,-1,-16,-37,-37,23,-8,-53,-38,-37,9,-18,-12,-29,-70,26,-24,-108,-21,-44,12,11,24,15,-40,-8,-32,-59,-67,-56,23,-30,-24,15,-65,-11,96,26,-10,-10,61,47,-32,55,26,-16,41,52,65,-2,36,-15,1,8,-11,-14,-39,-60,-38,-14,-24,-35,28,17,-76,4,-85,-19,94,48,32,-23,-47,-5,82,-13,-15,13,-45,-6,-2,86,-95,1,32,-69,-30,9,4,-51,-29,-28,48,-52,-78,-22,1,62,-71,2,-15,34,48,10,73,-56,10,-10,-1,19,21,32,39,-6,49,2,13,7,-10,-45,44,-41,49,-92,26,8,7,32,66,-41,-46,-5,37,-36,-59,-43,-68, 
  /* [46][0][][] */ 43,8,-39,25,42,79,-9,79,-51,6,11,-1,85,-59,7,21,-31,29,-51,16,28,54,19,82,55,-37,55,-81,5,41,-37,-8,-13,40,36,-25,-6,25,-55,16,70,-35,40,-83,107,-33,-24,-30,34,27,-26,77,-56,30,-23,-1,-28,5,-3,-98,-8,-35,-81,-21,8,2,-21,-9,-36,89,-7,-23,15,-1,-64,49,-61,-127,-23,-20,-22,88,-27,-38,21,-13,-50,28,19,-23,-21,34,-34,-12,2,-50,-37,16,35,-18,-67,-74,-28,26,-58,-77,28,-69,-17,54,-13,-15,18,-28,-46,29,54,2,-46,3,-8,31,-28,-1,35,-13,40,12,23,-10,34,22,53,-4,-31,80,-8,53,12,-17,34,67,-108,37,-34,81,-61,-7,-39,28,0,26,-22,-40,100,23,3,74,-11,74,23,33,-6,-12,47,29,-30,25,88,-90,-26,31,100,9,47,-7,-47,66,-16,-2,13,24,-56,-3,-78,4,-30,-16,76,105,14,-114,23,67,46,-74,-12,14,-38,28,-8,41,-30,49,88,60,18,-43,-20,-2,68,93,-7,8,7,-20,-31,-25,33,-1,0,0,-45,-4,-4,-17,-16,1,-11,80,41,-30,39,37,-23,-61,26,22,-8,28,4,49,33,-12,-29,21,46,34,-10,-29,-37,0,-49,-67,3,-16,-26,-8,31,-66,-25,22,-28,43,-46,-21,-71,-41,-56,-77,13,-4,-91,54,-10,-52,13,24,30,-17,-43,33,9,-13,52,-63,-47,-52,-19,12,5,18,3,46,77,36,47,-24,-67,-47,-16,6,-33,43,-4,36,-42,45,63,-34,-46,-25,54,21,-15,72,-55,34,-37,21,23,-46,-30,-15,32,17,80,-12,-21,-16,80,42,-52,-87,1,-71, 
  /* [47][0][][] */ -45,5,38,7,-10,7,13,-45,-21,75,-1,7,15,-14,-69,25,9,78,48,-28,14,59,-17,78,59,8,75,-2,105,50,-11,-24,28,29,24,109,-12,96,25,-42,78,-85,23,-58,8,-12,7,57,10,43,-11,-40,-14,-36,37,14,-51,-27,29,1,44,-19,31,40,8,-40,-20,-26,-36,42,-19,41,10,18,-30,-12,18,-14,-74,39,-41,-71,-35,-12,6,-56,-101,2,56,12,-43,-4,27,76,71,90,-11,-29,-72,48,120,37,15,-26,-20,-91,-12,59,-42,-15,58,28,22,61,-76,23,-57,40,-3,21,19,10,70,29,26,-45,75,-67,-61,13,2,74,25,10,26,10,48,-39,33,48,26,10,-25,-11,-15,17,34,51,24,-62,1,-1,55,16,33,53,-11,-21,63,-58,101,-11,-2,2,73,-26,24,-20,50,5,5,23,-2,-53,-24,15,-17,20,15,52,-3,-49,-25,20,-8,8,-52,-43,38,17,47,18,-7,44,-25,47,71,58,-36,34,-54,-25,-101,-41,30,-64,58,47,57,71,-44,26,-28,43,-82,29,-21,-22,-16,21,72,5,24,-45,31,2,43,-28,45,-13,-22,29,69,43,-15,20,33,18,40,20,30,-15,21,2,-12,-23,17,69,35,-93,-32,-19,-78,-46,-38,49,58,14,105,8,32,11,35,85,-32,74,14,-12,33,-51,39,22,-21,-7,-58,64,0,8,48,27,5,-9,0,-25,-21,-16,45,-59,82,-28,6,-22,49,-41,-15,-19,-9,-100,127,-2,25,11,-24,32,13,21,-60,-39,21,29,9,10,-28,15,65,-52,-29,-62,-64,18,49,-38,-29,-63,-21,3,-21,52,-35,-52,44,-24,-7,74,-7,1, 
  /* [48][0][][] */ -20,4,-32,-85,78,108,-111,13,93,-50,-91,21,8,-20,8,25,0,67,-45,-44,12,35,-32,21,71,-18,-24,-5,-35,41,-8,-41,38,-44,29,-113,10,-41,88,-59,72,30,22,64,83,21,-37,9,-43,-26,30,-2,88,31,-22,26,-15,2,-61,48,-22,19,-106,-37,-6,27,-23,108,114,66,67,24,-36,-45,-32,103,10,-20,2,42,-20,-34,22,56,13,-2,-46,16,52,-37,53,-12,-44,-63,21,69,5,-9,-40,30,-73,65,84,-28,-31,8,36,34,90,-47,-17,-44,62,19,-61,-76,25,103,28,37,-3,46,-21,-23,16,19,57,-56,37,3,85,-33,-39,83,-4,-2,46,71,-21,-9,21,106,-5,-16,-2,-57,5,-33,51,-31,44,-60,-20,59,-60,20,12,-96,5,30,9,-6,-117,13,-32,6,6,-2,123,-26,13,4,-62,70,5,-27,-24,-31,-78,-39,93,8,-7,-19,0,29,24,5,48,6,59,2,32,-22,23,63,80,-22,-6,-11,-98,-44,17,-7,1,26,-55,3,48,6,-51,-51,-19,22,-21,-47,-62,-82,-64,11,-30,2,-37,24,-9,-45,61,-11,57,38,-54,37,-39,-14,-45,-33,-1,-31,-3,37,-8,-25,39,-51,6,-25,9,-58,-127,70,-10,51,35,31,-116,6,1,3,-21,-40,-25,7,76,-94,-83,82,37,-31,47,-26,-46,-4,-43,64,45,53,72,16,58,23,85,-10,-98,13,-29,-11,42,-58,-8,58,-29,50,-120,-14,-93,-60,72,25,-8,32,4,-59,-87,11,-36,-18,79,57,26,50,-94,86,89,-34,-83,17,16,45,45,-71,-87,-31,44,-86,65,2,37,90,21,-17,16,-44,-56,-66,66,-89, 
  /* [49][0][][] */ 48,10,-8,-12,-20,-53,-43,-61,80,-64,8,-20,18,-24,9,6,30,7,11,-33,104,28,-36,44,13,69,-46,19,-99,-33,-47,21,11,-9,-7,-3,27,28,41,-20,52,58,-32,-95,-2,106,-25,19,-14,20,-72,-22,-57,-35,11,-5,-10,-3,64,-43,-123,-53,42,-11,-80,37,-73,-21,-16,4,20,-49,-40,-41,18,-52,-27,-14,-14,-115,62,27,27,-127,24,8,-58,38,2,-43,-17,9,86,17,41,15,-36,-7,-66,0,31,-99,-9,-30,15,-63,5,27,-33,-11,39,52,42,18,25,12,-88,119,21,-44,-121,-40,6,110,58,-10,-43,-110,40,-64,58,-74,30,-53,-2,53,8,-1,-6,46,-38,-2,12,-26,61,36,-11,-1,-80,-49,4,-85,102,-89,26,22,48,-3,-45,69,105,-12,-24,-21,92,62,41,77,-1,-99,21,-90,51,26,46,-17,-81,0,61,73,-30,-1,12,-97,24,78,-35,70,-43,-70,9,80,-76,-2,-38,6,24,2,123,-54,-69,2,-38,-8,-92,87,-10,-4,3,-12,-36,23,-44,79,23,20,49,66,9,56,26,-44,-9,25,42,79,-61,27,-58,75,72,68,-16,-90,29,-66,-14,-100,-12,40,-2,-62,60,-17,-17,36,92,75,-38,-34,43,-34,-37,-38,90,31,21,-37,21,29,-4,-21,2,-17,-19,-114,-45,103,59,-60,6,-67,14,-45,-62,29,-15,16,50,-3,43,79,-27,21,-55,-5,44,25,-62,-15,7,-50,-72,33,-50,-57,48,1,55,112,-44,43,21,34,-26,37,-33,111,34,-77,71,-8,-87,2,-50,5,-66,5,-22,38,15,30,79,39,-99,14,47,57,11,50,-64,33,6,-83,-48,-93, 
  /* [50][0][][] */ 29,-7,11,34,-24,31,-17,-31,-36,58,-22,-19,76,-8,0,42,80,60,7,-38,75,-54,-48,2,14,9,74,-7,51,18,52,0,-30,-12,-52,10,-3,11,-34,91,38,-33,-28,43,-35,-52,17,21,38,-35,9,39,1,-78,-39,30,16,4,1,-92,-14,-31,38,1,32,-53,23,-23,-50,-83,15,-64,10,66,-60,-20,86,-11,-27,68,-25,68,87,49,12,-20,53,30,27,-5,-10,5,36,23,7,-48,6,-106,-46,-2,-59,49,-25,81,15,17,-25,-21,-18,-19,56,21,-27,-1,1,-33,62,21,59,-41,9,-25,17,-76,88,19,-69,88,28,-25,-109,-5,13,41,-34,-6,0,-38,20,70,-49,-20,-54,81,-30,25,-44,7,2,-17,42,38,44,59,-8,-16,56,-87,45,-9,48,-27,21,-99,-48,10,-56,45,8,52,11,71,-25,28,18,-48,-43,36,8,-21,15,40,7,-7,-27,-39,-13,-79,-14,53,59,-51,26,44,-68,-56,16,-22,-89,-23,25,-44,20,48,60,-19,-28,-63,-19,-1,-27,7,-127,-59,3,13,-20,-2,29,5,-2,18,61,-26,17,36,42,31,52,2,-60,41,27,16,-33,79,10,-2,75,14,70,-25,-6,21,84,7,-56,-93,-32,-6,-15,-8,-60,-22,3,-30,9,-13,-56,23,-25,45,-34,-5,-13,-94,6,-36,4,15,29,1,55,16,111,-81,2,-46,-41,-40,-38,-27,26,-74,-16,-69,43,-74,21,24,114,57,-64,27,30,2,3,36,-22,-43,-9,-55,24,4,-43,45,-18,-57,-59,-23,-51,22,42,37,18,8,9,82,-51,-17,-16,41,-6,-32,22,5,43,24,8,-28,-12,10,28,24,-27,-5, 
  /* [51][0][][] */ -24,16,42,-31,10,34,3,-7,46,-13,-37,-22,23,-16,-19,9,72,31,-27,-73,-78,27,-26,99,-52,2,-51,-32,-127,18,-55,59,3,-6,-25,-59,9,-8,25,29,37,69,26,56,63,40,-11,-22,-20,26,-23,-6,15,34,-61,-22,51,-47,-65,25,26,7,12,13,46,-58,-65,30,-33,-55,34,-6,-38,-11,-25,4,54,36,-35,-15,-28,31,-63,10,-28,50,-31,-22,-2,43,-24,7,-8,-3,7,29,-47,37,50,-30,14,48,-11,24,19,-13,10,42,14,-15,-1,-13,60,1,19,-57,-8,25,5,13,16,26,-58,-37,-24,-57,-16,15,30,23,-41,21,-14,-8,-32,-33,-59,11,21,-37,-26,70,83,8,-19,-18,-70,63,34,-33,-5,-58,-58,35,19,51,6,-23,-18,-48,-50,-30,-58,28,-16,-3,-1,104,37,-3,-62,-67,-60,10,-60,12,26,-32,-29,2,3,-17,-11,7,10,3,22,-33,-47,9,4,13,-34,-27,13,-18,42,-42,101,-42,-32,3,15,11,-19,-58,10,-51,43,12,31,-32,53,30,15,-1,-33,-14,-23,-31,50,46,-22,-13,4,18,-21,9,-41,-8,-23,-1,-17,-36,62,52,37,-38,-18,70,28,-41,-35,-76,-34,5,6,40,21,14,-75,17,-17,-34,-21,-29,36,-23,7,41,-4,-65,-11,-22,4,-73,-37,2,50,18,2,-34,62,-3,19,-7,62,-47,18,-14,34,-12,-5,-20,16,25,18,47,67,18,-18,44,-42,-25,37,-11,25,19,39,-2,20,-44,-12,3,-8,23,-49,-77,57,28,-5,31,51,-46,0,4,-18,-16,37,13,-45,29,2,29,-29,1,60,36,44,-98,-45,-43,-21,-22,-57,-36, 
  /* [52][0][][] */ 32,-29,-48,35,25,-72,-8,-40,23,-30,-46,4,47,36,-29,-19,30,15,6,-36,-7,-57,-93,50,-35,4,-96,15,25,34,-80,-1,39,-44,37,-25,28,18,24,1,13,-89,-2,19,4,-3,31,-43,-11,6,23,27,-29,-14,18,-21,-56,4,-41,19,41,-21,8,9,-89,13,35,-56,-22,-28,-54,-77,-39,12,44,2,-49,79,62,-14,-10,2,22,-48,-7,-1,-4,-36,42,31,59,19,1,50,-70,43,-75,-32,5,-55,-18,21,49,38,67,-18,6,2,14,23,-41,25,0,-17,-52,38,6,78,26,-27,-6,34,-13,98,36,-4,12,-20,-13,-47,-20,-8,23,9,63,-3,59,-6,26,-18,9,43,3,37,6,8,-1,0,-31,-16,64,-42,42,-7,17,38,-20,-62,-55,48,79,-48,-69,-27,-26,78,13,-35,45,33,33,-15,9,-43,-40,-19,-30,-44,-13,22,-4,-72,37,12,-40,-6,-2,125,-14,43,-5,-21,26,33,-3,21,-19,41,-2,49,81,-10,113,-15,-7,47,12,-38,7,61,-9,5,-86,23,15,6,17,36,46,1,65,2,-46,-9,-74,11,-19,-94,18,20,49,25,-58,81,-69,-68,-45,-11,18,-6,47,-31,9,8,-3,36,14,-36,52,-2,-42,21,-9,14,26,-20,-91,-17,8,46,4,15,-86,10,59,12,-4,37,112,-25,-52,40,-9,-31,39,-55,9,40,36,65,21,-21,39,1,41,-5,-6,9,42,-64,-26,14,44,-57,-25,33,71,-25,-61,36,-72,19,-30,6,-13,24,-11,127,-52,-22,0,0,25,-25,4,15,-34,18,88,-73,32,83,-19,13,-75,-28,-28,63,11,44,-43,-4,-18,31,71,77, 
  /* [53][0][][] */ -10,23,51,8,45,67,-105,66,10,46,-3,-13,0,-45,21,-2,24,4,6,35,-36,10,11,32,43,46,42,20,-16,36,-28,-15,23,-50,-91,-36,61,-8,-16,-14,-5,-102,-24,36,-2,64,-11,-50,3,47,5,-24,60,-62,-5,19,32,-79,-34,-14,61,32,-1,54,50,-19,-10,26,-43,-38,79,33,-33,69,-1,-8,15,12,-14,18,-35,-12,36,-14,-13,25,-28,40,-64,67,-53,-12,0,-34,-9,15,16,56,-38,-65,79,42,45,-23,13,2,3,-14,-21,-24,-19,15,95,-4,56,-52,-17,43,-1,-54,15,-18,-48,-101,57,72,16,-1,-37,5,-31,-44,-18,-29,19,29,-5,6,-13,-18,-77,24,-22,-27,-27,-75,-33,0,11,62,35,9,49,12,18,-23,60,32,-38,-58,10,34,10,-51,47,-13,-36,26,0,-40,-29,-49,22,4,21,-66,-30,-24,-45,-70,-118,89,49,0,4,70,69,-18,-21,1,-10,-24,-11,-4,6,35,32,26,64,30,-22,26,-49,26,20,57,-44,-42,-96,-6,-52,-11,7,55,-29,38,-127,-42,-60,-43,-48,11,79,-87,66,-55,39,38,-9,2,-5,13,85,-10,0,-9,10,-33,26,58,-9,-33,-68,-48,-33,-48,36,-53,-12,16,-76,-9,-39,36,-12,-11,41,-50,21,-72,-60,20,33,0,8,-31,-35,16,13,-65,52,-27,-15,5,33,-42,13,25,30,-8,2,68,-15,14,3,-14,-13,14,-39,-32,-78,-35,-9,-39,-39,-14,34,63,51,-79,65,57,-34,10,27,58,24,97,28,-14,-45,62,28,-19,2,-27,36,27,52,5,23,62,7,4,100,-9,-62,77,11,-35,71,56,36,34,21,-15, 
  /* [54][0][][] */ -12,45,23,47,21,34,94,-1,18,6,22,-53,-20,5,70,21,-30,-52,6,7,17,-50,-22,49,19,-53,43,37,-20,27,8,1,21,-14,-20,-19,-52,21,-8,5,13,-23,-89,53,-20,63,2,3,43,-48,-36,26,31,-36,-6,32,-50,36,19,-12,-18,51,-36,3,13,24,-14,-60,-9,-27,44,-1,36,7,65,-53,-12,-24,34,-2,53,44,103,-1,-3,4,-30,13,49,-66,-3,-13,-34,-44,51,-27,74,44,-57,-37,8,82,-8,43,12,23,-3,19,47,3,24,-35,-27,64,47,3,-4,-47,-31,-41,20,-3,1,1,8,-16,66,1,-47,-14,28,-3,32,-24,67,-2,127,-12,8,-37,8,9,8,-15,16,-3,59,-53,40,-11,-2,-52,52,3,-15,72,-22,-8,-42,-24,38,0,-24,19,-9,29,39,8,-26,16,1,-22,-14,51,11,27,-40,32,81,33,-5,-26,-30,24,4,-17,-17,41,27,-44,25,86,-8,-15,-49,-35,29,-30,30,-7,-13,-11,2,-40,3,49,3,18,-13,-42,-11,-45,23,-49,-24,20,5,6,-30,50,11,-13,30,-10,-45,70,26,-49,22,-17,-19,65,-44,-61,-10,17,-46,15,-9,27,7,-60,43,-4,5,-86,21,-51,-43,-38,65,15,0,-15,24,1,17,-5,-50,-9,61,-18,56,-2,29,2,-16,17,21,27,-3,0,56,-45,70,2,-26,-16,13,8,-14,-24,-34,26,-45,7,-40,33,-54,-14,40,-14,-36,-42,1,-5,-3,23,33,83,16,8,4,18,61,9,9,-27,34,0,46,43,-94,1,-83,37,-47,-31,-3,-41,-58,-12,18,-16,17,-24,-47,52,27,-10,-21,-33,-3,-5,38,-37, 
  /* [55][0][][] */ 24,-38,-2,-24,-42,88,80,83,-57,-20,83,-15,-36,-15,-40,21,-40,49,24,40,-43,-16,-32,-51,-36,-11,-17,8,20,43,-1,97,59,-13,-26,-54,17,-13,30,34,38,78,-44,-25,-6,-18,9,4,-47,21,43,43,-58,-17,1,-22,42,-62,-13,36,34,-65,30,-70,35,-9,48,-47,-27,-33,39,-35,37,1,-67,3,-5,3,-31,13,6,-12,-57,-40,17,-41,97,76,-3,16,6,27,64,27,-23,-64,-25,-15,-14,-29,2,-87,-101,43,74,-99,2,-21,-88,-47,1,-21,-2,-3,24,96,73,17,-1,-44,-67,5,12,-127,29,14,-26,-125,27,11,-40,-55,-72,21,13,27,29,-57,36,15,-30,96,69,27,-14,-8,-38,-10,-71,103,2,11,-10,23,-15,-23,0,-22,-19,-35,-40,-46,19,-30,35,-59,41,-68,58,-41,31,-22,-7,14,-4,-24,-8,57,-48,-5,12,13,6,-54,-5,40,13,-25,10,44,15,-13,21,-13,-7,79,12,-36,45,-12,-22,23,12,-19,14,53,61,21,-71,22,-18,2,-35,-20,44,-5,-82,-4,30,-45,32,6,-27,50,27,-25,-30,75,-58,-25,74,-11,6,-18,8,86,59,31,16,38,101,7,-10,13,17,-25,-22,20,28,48,-21,33,-44,4,-50,105,46,-30,-5,3,-31,-8,14,-43,-24,-11,-12,-41,-3,-30,-33,0,-7,-19,13,-27,39,49,2,31,17,-7,3,67,-26,-39,57,53,-89,-16,-10,-8,-22,6,-31,-49,73,-43,-2,-50,49,3,-54,-26,-80,-12,-75,-39,-6,25,-92,106,35,-26,47,52,-41,-70,-58,-7,10,33,-20,-6,-1,-16,92,-53,20,2,20,-15,-21,15,-23,-1, 
};
const TfArray<4, int> tensor_dimension72 = { 4, { 56,1,1,336 } };
const TfArray<56, float> quant72_scale = { 56, { 0.00093009293777868152, 0.0016044910298660398, 0.0012646442046388984, 0.0013037195894867182, 0.0013017712626606226, 0.0014294384745880961, 0.0011359832715243101, 0.0010548933641985059, 0.0016318755224347115, 0.00136067986022681, 0.0014051535399630666, 0.0013734656386077404, 0.0014706193469464779, 0.0011379767674952745, 0.0012596407905220985, 0.0010836783330887556, 0.0011913436464965343, 0.001462381100282073, 0.0010612634941935539, 0.0015578879974782467, 0.0013521002838388085, 0.0011126674944534898, 0.0011533641954883933, 0.0011477336520329118, 0.0012362065026536584, 0.0012697768397629261, 0.0011755771702155471, 0.0013226311421021819, 0.001415735692717135, 0.0012038111453875899, 0.0012221456272527575, 0.0013224310241639614, 0.0012512519024312496, 0.0015199080808088183, 0.0014392375014722347, 0.0013851096155121922, 0.0012291683815419674, 0.0016483991639688611, 0.0013730588834732771, 0.0018864437006413937, 0.0012925929622724652, 0.0014283076161518693, 0.0016006078803911805, 0.0020290331449359655, 0.00096570234745740891, 0.0012456470867618918, 0.0011603476013988256, 0.0010393174597993493, 0.0011156277032569051, 0.0011289464309811592, 0.0011155428364872932, 0.0016350762452930212, 0.0012209359556436539, 0.0013793172547593713, 0.0013339300639927387, 0.0012318966910243034, } };
const TfArray<56, int> quant72_zero = { 56, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant72 = { (TfLiteFloatArray*)&quant72_scale, (TfLiteIntArray*)&quant72_zero, 0 };
const ALIGN(8) int8_t tensor_data73[336*1*1*56] = { 
  /* [0][0][][] */ 55,37,-58,-1,53,-49,33,-10,-98,78,38,12,-6,12,-32,-30,22,9,-88,-63,-39,0,-42,-43,127,9,45,-17,21,-26,111,95,-105,7,-67,24,95,57,-52,110,101,-64,3,6,51,-76,12,89,-21,37,70,-23,86,78,-8,-61, 
  /* [1][0][][] */ -8,-36,-112,-23,-61,-12,26,-4,31,6,-8,-18,-8,-13,-6,-84,55,-35,34,75,-33,17,58,-127,69,-58,-8,-21,-88,82,-36,20,73,83,43,-11,8,-23,-8,-122,15,-43,-16,-19,16,62,-74,50,5,2,-30,16,-99,22,-67,-121, 
  /* [2][0][][] */ 25,-30,-97,40,116,86,77,-12,76,50,3,-27,70,84,13,91,-15,-17,16,72,-57,33,27,-26,58,90,85,-30,0,39,-6,23,-76,2,-65,-20,-105,127,100,66,37,-15,-52,-1,34,13,-19,67,-62,105,8,-29,70,41,-5,-108, 
  /* [3][0][][] */ -12,47,34,65,-3,26,8,-85,-62,-82,31,64,-69,-36,-11,0,-104,15,-59,-9,52,30,14,-4,127,-66,-24,15,61,-24,-54,91,29,-44,39,-2,-6,3,-127,99,2,21,37,17,-61,-31,1,-27,52,-15,-59,44,-31,-27,3,-25, 
  /* [4][0][][] */ 5,16,-26,-14,50,19,-45,31,5,-58,-65,58,32,-70,35,-55,99,-13,-30,-13,-18,17,11,47,34,-46,-7,-100,-9,21,60,-64,2,-52,-72,4,-5,-44,-20,45,-50,-36,-3,75,2,-30,-29,22,-52,15,-127,23,51,24,-34,-5, 
  /* [5][0][][] */ -7,77,3,85,40,-7,-56,43,51,54,-2,48,43,68,43,91,35,10,18,127,-3,-4,42,48,87,69,8,-10,-26,-77,9,1,20,52,32,-30,25,35,51,-28,-94,13,115,-20,-71,44,-15,12,-87,-49,30,-93,-47,72,-83,-10, 
  /* [6][0][][] */ -70,-17,-44,46,-14,-21,-35,7,-74,12,22,8,-49,93,-127,-44,-15,-7,24,37,-16,2,-45,107,46,-34,-4,-57,7,70,-26,1,-60,12,-48,-61,49,-24,41,-107,-86,3,-9,-18,51,-42,-46,31,31,-66,-4,-57,6,-49,16,86, 
  /* [7][0][][] */ -59,67,-47,80,-9,79,-34,4,-28,-127,-25,38,-63,-89,-29,28,2,42,38,-65,52,15,-7,-31,-53,-38,-81,-25,19,30,12,-60,30,-14,54,-18,-2,-38,-59,-68,-42,-65,-18,-74,62,46,25,-38,3,-32,-61,-6,-2,-10,74,-88, 
  /* [8][0][][] */ -18,13,-1,-14,-28,-17,37,-54,31,102,-89,-37,56,-33,-59,33,-78,54,22,-52,-7,56,55,-18,37,-104,46,-50,-31,68,-26,-91,-10,25,-69,3,-30,20,-24,-25,-57,21,8,-45,-65,89,-118,23,-57,-77,127,52,8,-46,-30,-33, 
  /* [9][0][][] */ 45,96,43,11,-37,41,-126,-1,-32,-24,26,22,15,104,24,49,-33,-22,41,-80,22,-25,-29,-39,32,7,49,15,-27,26,10,13,8,53,53,81,4,-44,2,74,7,27,-63,-26,57,84,-89,74,74,0,-105,63,36,7,66,-127, 
  /* [10][0][][] */ 40,-47,-9,21,-31,-7,-1,2,33,-48,3,-9,-56,-63,0,-10,12,-51,24,6,-32,18,30,-15,14,-3,-17,52,-25,-58,-90,31,127,64,-12,-20,42,-32,-101,39,45,-9,42,-29,-23,34,6,-30,55,-17,17,51,-19,40,21,4, 
  /* [11][0][][] */ 51,68,-10,-41,3,41,53,31,29,51,-20,-3,5,-16,22,43,14,5,-33,-3,48,26,-15,-11,-38,9,16,35,-61,38,12,46,13,69,-36,-41,-40,-34,-54,-2,9,-54,127,37,29,-19,-15,-48,-42,-47,31,21,-15,-23,-12,-70, 
  /* [12][0][][] */ 36,99,-21,-30,-61,43,96,74,-55,-53,15,-39,-2,-32,-57,55,45,26,73,-102,28,-41,4,-66,50,-21,-20,-26,-12,-62,49,23,127,57,-82,-25,62,-43,-77,-93,24,5,122,-56,22,40,50,68,37,-8,-3,27,-99,-54,13,-4, 
  /* [13][0][][] */ -24,6,68,42,-20,-124,-49,-18,127,59,-5,-55,16,15,80,6,-34,-58,-46,-35,50,-50,56,-21,42,8,-62,4,-11,49,-22,15,27,5,66,15,-39,-29,-61,11,72,61,-41,-20,-37,-33,27,56,44,-20,-65,-36,37,60,-47,26, 
  /* [14][0][][] */ -62,39,3,-80,-6,34,-51,-4,42,-123,42,45,-16,12,-52,-61,-5,59,-57,19,-38,-92,-6,92,48,117,127,7,33,5,12,62,26,-35,-22,29,89,5,11,-59,42,89,-35,-28,22,-59,21,28,73,-33,-29,34,62,-35,3,-49, 
  /* [15][0][][] */ 4,84,105,-5,1,35,77,-56,20,31,-46,-7,-15,16,41,72,-8,127,-28,-15,50,-61,1,-11,33,-1,107,-74,15,-83,-31,-42,-4,-1,-65,10,87,27,78,-42,-5,-119,25,-52,-10,-68,46,-17,19,2,-1,-11,68,25,10,13, 
  /* [16][0][][] */ 5,97,22,-33,44,-4,-43,-13,28,-95,28,55,31,-7,-105,64,17,61,-42,81,-51,-49,-7,26,-32,85,-50,7,-66,-70,88,28,-30,15,0,-61,80,-11,48,46,35,4,56,-16,48,-80,15,-43,-127,-56,-42,11,-18,-42,-49,-33, 
  /* [17][0][][] */ -25,73,48,-3,50,-68,-32,33,28,90,2,-56,105,127,-27,16,83,26,3,76,-30,1,-67,79,32,-28,-17,39,-91,33,28,-22,23,4,-31,-49,-23,42,32,69,20,-13,28,47,115,-57,-41,-77,3,-78,33,36,32,-21,-29,-56, 
  /* [18][0][][] */ -83,-22,-117,0,21,78,60,-13,-90,5,117,7,18,-18,-34,72,2,15,47,-47,-40,-46,43,19,-74,75,16,-17,-32,45,46,11,-35,21,-10,68,-41,-74,-95,-110,20,-13,6,14,-11,-101,18,-67,19,-18,-30,8,-127,-27,79,-46, 
  /* [19][0][][] */ -19,-44,-36,19,-59,21,-38,24,15,-15,-39,29,45,-24,6,29,13,2,60,14,-5,42,5,1,-22,-44,-64,-35,-79,-32,10,127,-13,16,5,9,33,4,-3,-20,88,-66,38,-3,-49,-14,-38,-18,-8,11,24,12,-55,12,25,-34, 
  /* [20][0][][] */ -37,39,-127,14,49,-29,4,-32,-32,-1,45,9,-33,3,-116,-13,-44,-17,7,8,87,-4,27,-73,-51,22,-37,-14,-8,8,-13,9,-7,-4,89,34,81,-9,-80,-36,-52,32,-22,43,19,-54,44,5,90,78,-52,-73,-85,-6,-69,38, 
  /* [21][0][][] */ -34,-16,-33,-48,61,-30,-20,11,56,-6,-7,-26,70,25,60,-36,-80,26,-64,-69,-85,-9,23,-8,-10,80,13,-127,-21,-50,16,52,-48,-83,12,-11,13,37,-118,-58,11,-75,28,77,115,14,-98,-48,0,58,-89,-54,3,14,-22,-10, 
  /* [22][0][][] */ 125,2,-60,75,-4,5,-54,-38,54,-13,-44,-1,12,3,51,-25,-51,-1,-87,8,-9,-23,-8,-62,48,-19,78,10,15,127,49,-74,32,-76,-101,-33,18,-10,-14,23,46,49,-10,-36,-28,-21,99,-1,-9,-35,26,35,34,-15,-112,-48, 
  /* [23][0][][] */ -8,32,-6,48,44,-8,22,22,30,21,2,9,-15,14,88,92,-74,-47,12,19,-55,-12,-44,-5,71,77,-36,40,-73,-47,-39,76,-11,85,22,-64,18,81,127,-77,79,-1,-8,8,70,-43,50,1,-24,23,-90,-9,-31,2,16,7, 
  /* [24][0][][] */ -34,81,-23,61,-3,2,1,-73,23,9,76,7,-117,6,-52,-27,-74,67,64,-6,21,13,12,-27,-21,65,-127,51,61,17,-16,-29,-24,7,47,-47,-17,50,-42,41,64,49,-74,79,49,-11,49,-53,-71,87,-17,-86,-8,-5,25,-23, 
  /* [25][0][][] */ 27,44,28,33,-5,31,-36,24,59,-87,35,31,-1,-17,63,15,-42,-49,39,1,40,-11,53,67,65,11,-127,-38,-51,59,6,-55,-17,58,34,5,-8,-72,-100,22,0,21,39,-52,-14,28,-7,-27,61,62,-50,92,-70,-1,-9,110, 
  /* [26][0][][] */ 15,-9,15,4,72,14,96,-14,-9,-1,50,-3,-68,-45,-49,4,-22,30,-58,0,-31,8,-21,107,-12,8,39,-85,-26,73,-65,-76,-77,-68,-62,-41,54,-27,-11,-51,-67,-36,62,-6,10,10,-24,-69,-127,-101,-35,-40,-91,-17,-29,98, 
  /* [27][0][][] */ -32,-64,19,-36,-31,-34,-28,10,-34,45,52,-28,38,20,62,48,-11,15,19,79,54,11,5,64,24,-26,8,-36,-63,-29,-57,-100,-127,-53,-65,-33,-48,-16,93,52,6,23,-43,13,-35,-26,-66,33,-50,34,-73,33,37,3,-7,-19, 
  /* [28][0][][] */ -39,51,41,127,13,-2,39,-15,-31,35,-11,-72,31,-22,-13,27,7,8,81,36,-18,-42,-41,78,-15,-4,-65,-48,31,-8,116,120,-1,-8,-25,-42,-74,35,46,31,-71,50,-71,-24,72,40,-30,-9,-74,-14,35,-14,97,80,72,-28, 
  /* [29][0][][] */ -42,-27,97,-23,10,-81,57,37,43,0,-69,-20,110,-48,23,20,-39,-60,55,-22,-59,15,-6,81,-31,-17,85,-4,21,-27,-8,-30,-26,14,-93,-22,-61,-39,4,26,-6,70,-27,-73,15,60,15,21,-25,25,8,-68,127,22,35,-1, 
  /* [30][0][][] */ -7,47,28,-59,0,71,40,-14,61,-127,-60,54,49,-44,3,67,24,-22,32,-18,-60,68,-5,78,8,-17,-57,-25,52,-37,39,44,16,44,-5,-49,-3,48,60,-41,-18,-10,26,1,55,-17,-39,39,48,13,66,-56,8,15,-1,8, 
  /* [31][0][][] */ 33,66,-47,-103,-107,124,-9,-39,-52,-29,-54,77,-72,-69,-62,-53,10,12,29,11,30,110,-31,11,-12,40,-44,-12,-78,-77,111,-36,89,59,-26,32,-8,34,127,42,81,-14,95,37,67,-23,77,54,30,-30,-72,-77,-21,46,113,20, 
  /* [32][0][][] */ -88,12,-57,16,-42,-34,35,17,-5,44,-52,127,-30,-15,16,-47,-85,2,53,25,40,18,-31,-5,-94,36,84,42,-1,67,44,88,-41,5,22,58,55,0,32,12,-9,-8,-8,85,-19,-4,-62,60,-48,47,85,-41,-37,-42,-29,66, 
  /* [33][0][][] */ -11,-46,41,-16,20,34,-86,22,17,26,-13,-42,-39,62,54,-68,-4,-2,47,-28,48,63,-60,-19,-91,-16,95,19,-76,-30,-33,-54,-127,-69,3,54,-29,-24,40,-59,1,-77,-21,48,36,53,-46,2,-51,50,-92,-62,65,-80,40,11, 
  /* [34][0][][] */ -29,41,-15,-39,-19,27,6,39,-37,-48,-7,10,-3,10,12,4,19,39,-22,-25,-20,-127,34,3,41,35,-1,5,3,3,28,14,33,5,-1,-11,11,33,16,-9,-5,-8,-9,-27,17,-85,-67,-67,-14,-40,13,59,3,-49,35,-18, 
  /* [35][0][][] */ -53,-90,29,57,-65,-34,-4,-47,75,-16,-22,3,-54,34,-7,-28,-34,-86,-7,28,-127,10,-69,102,24,32,-41,104,-76,-1,-57,30,11,19,16,9,-17,-28,-47,50,-18,-50,-28,63,-29,-6,-29,-10,-5,32,6,61,43,-6,-20,-23, 
  /* [36][0][][] */ 9,-10,-34,5,41,-11,78,79,47,-38,-19,-15,94,-29,-14,-27,36,-23,-45,32,64,-73,73,-8,127,-8,28,14,45,-35,-11,108,16,63,-47,84,-6,17,47,33,40,48,-5,41,-6,53,25,39,-47,80,-17,-42,-31,-2,-13,27, 
  /* [37][0][][] */ -45,34,93,10,9,45,2,38,-34,75,96,-29,-46,-51,24,127,-80,-28,-15,28,-56,58,-87,-30,-7,43,102,-11,42,-34,-39,-13,-9,-1,99,-71,65,2,-43,-16,13,-87,-52,11,61,-56,-5,17,-52,78,-41,31,38,9,-99,-12, 
  /* [38][0][][] */ -71,-30,-98,-37,-37,11,10,-1,-46,-69,-26,60,65,34,34,77,14,127,102,61,-2,77,-20,83,-91,81,-19,-53,-37,1,-67,9,-73,-34,-44,-57,-28,16,99,-66,-52,27,-25,17,96,-30,17,-56,-82,-29,-63,-14,-38,-9,47,-15, 
  /* [39][0][][] */ -46,-71,32,-17,-8,-59,18,-57,32,59,44,-20,97,105,-40,23,-35,127,9,67,-40,20,30,2,-17,56,3,-18,-47,11,3,40,-58,-24,-16,2,-47,-12,28,29,-26,9,-63,-3,-10,-55,-30,26,25,55,-25,-2,-28,32,64,13, 
  /* [40][0][][] */ -11,34,7,49,-27,-94,-24,14,-127,31,-24,-15,65,15,-54,-2,50,3,44,-57,-9,-7,70,31,45,-52,106,14,-23,-11,6,27,-1,48,-32,49,-77,47,33,1,-19,-94,-42,-26,40,-57,-48,-35,-42,67,-88,-28,-49,-27,2,22, 
  /* [41][0][][] */ -43,67,79,23,-127,-1,5,-46,21,-21,-17,16,49,-33,56,-68,34,27,-31,33,-75,21,-10,109,8,-31,69,-31,-13,38,21,14,-79,-76,-23,-29,52,125,-20,-74,51,-8,-29,-65,-66,2,-37,-98,60,-50,52,-6,-52,85,-10,90, 
  /* [42][0][][] */ -113,-98,-35,-11,7,-55,61,-51,-44,48,-20,-10,71,-102,-23,75,-41,38,-30,43,-92,-16,-25,-10,-18,-59,3,-35,-96,-67,-121,91,93,-48,-52,88,88,73,-80,-92,-59,-5,-127,41,-46,66,45,-39,4,84,24,53,16,21,-84,1, 
  /* [43][0][][] */ 24,-48,117,-121,-36,-16,80,9,-14,-57,92,-114,108,9,3,69,-48,-28,-34,-52,106,-61,-114,52,7,-14,-127,-65,-59,33,77,-18,12,-58,-62,-33,113,-9,-13,-101,41,-8,8,67,-8,103,16,-118,-52,78,-12,90,12,84,-75,73, 
  /* [44][0][][] */ 12,37,48,-46,-79,-110,59,33,15,40,-101,2,-36,-9,32,-94,67,-107,99,2,-22,-21,37,97,-84,10,-4,-48,74,15,-23,29,22,-56,33,-8,-47,76,117,-113,38,-26,5,-75,25,7,127,-24,-28,-51,76,-27,-98,42,-39,-9, 
  /* [45][0][][] */ -52,-34,21,-89,33,49,4,-48,-40,67,-31,-14,-18,79,39,-62,-16,1,34,8,-10,-4,-63,10,44,-3,-44,15,8,0,89,-71,-127,-111,-4,-11,-42,20,6,105,-19,6,-68,10,-7,-86,-77,22,-91,2,7,-73,85,-19,46,53, 
  /* [46][0][][] */ 43,2,-3,-23,42,89,51,-8,-12,-61,48,-11,55,54,-90,120,-24,-29,-53,84,45,21,33,-49,-89,107,75,22,-24,93,-43,74,-23,58,-81,45,-127,95,-66,-67,49,58,25,-43,11,97,-45,-2,67,-70,-15,1,20,59,8,-66, 
  /* [47][0][][] */ -90,97,-26,76,-68,68,-17,17,55,43,-89,70,-41,-91,36,20,-20,23,6,7,-37,11,-25,9,-34,11,127,8,-23,-10,96,-13,14,50,-3,62,96,-46,4,-68,-94,-73,9,-15,67,55,97,3,-10,61,-18,-21,11,-15,98,-35, 
  /* [48][0][][] */ -51,-43,-48,19,-15,17,26,23,52,41,-32,47,9,-8,28,4,65,30,26,40,-1,-8,-13,42,-33,-33,-88,25,52,81,23,-10,-16,103,-64,-9,46,-36,32,40,19,36,32,82,127,-53,-19,19,-53,-39,33,-37,25,-19,-12,-16, 
  /* [49][0][][] */ -40,-17,42,10,-22,17,11,-35,29,17,20,-25,-10,90,25,7,-11,41,-2,38,17,-28,0,-35,83,27,-15,-87,-43,40,36,102,-9,-14,-37,-9,-72,-10,-13,74,-20,-15,-127,-14,-24,28,-29,60,-41,-12,3,-24,65,47,-16,-8, 
  /* [50][0][][] */ -4,42,17,-1,79,68,47,-43,-33,-56,-13,-53,4,-15,18,-41,-95,25,-29,5,-1,-21,-11,81,-74,9,-127,-66,-15,-34,-11,-79,-41,-26,-3,-36,51,-5,99,60,-112,-14,-21,93,-21,-23,-36,-77,-87,8,-16,-18,-4,-3,30,3, 
  /* [51][0][][] */ 1,28,25,1,57,-43,-4,-57,76,62,25,11,-17,-45,-20,-40,-1,73,-68,21,-28,-8,46,47,66,-30,-53,-2,-24,0,72,-33,-74,23,-53,26,77,27,27,38,0,94,57,-47,64,-114,63,9,-127,-51,26,-50,-8,0,-7,-83, 
  /* [52][0][][] */ -25,-52,85,50,-42,30,-70,-74,-54,-6,-6,-11,24,34,30,16,-55,19,-13,-127,-8,13,-54,48,-32,59,2,-67,-47,-12,2,-48,-30,16,47,11,6,-21,-45,-4,-8,50,-4,-31,15,-56,18,25,-104,-69,-38,-90,-61,2,50,-48, 
  /* [53][0][][] */ 5,-20,-127,18,-9,-87,-21,-59,63,-44,-60,-48,-51,73,110,-11,-81,47,13,13,-63,-13,-71,-13,5,-66,-7,87,60,-117,99,-28,24,-28,57,-96,60,36,28,-10,16,56,26,-12,-120,29,-17,10,-56,-11,-51,-55,12,27,-44,7, 
  /* [54][0][][] */ 27,-46,-6,10,53,-14,40,48,-68,-3,-14,-5,40,-37,-127,20,93,33,-25,-88,-25,-40,-18,-9,38,8,24,63,-2,13,-2,12,-36,-63,18,-5,52,100,37,-80,1,72,-12,21,-53,48,-19,56,26,36,21,65,-14,21,-1,19, 
  /* [55][0][][] */ -9,-106,5,-84,-7,-29,-46,-3,-11,-7,-34,-3,7,21,69,-46,-69,56,11,45,-5,24,-73,93,32,-94,-1,52,-4,44,-21,12,-91,-7,-21,-7,-62,69,-17,8,4,-72,-4,38,-40,-28,-34,-51,-33,8,-12,-8,50,-68,-6,127, 
  /* [56][0][][] */ 20,-17,11,-81,-1,38,-23,-50,-10,92,25,-11,17,25,10,-13,23,26,-5,-7,25,33,-11,27,35,59,-49,1,30,60,69,-18,-127,-34,-2,34,-89,24,91,33,10,86,-83,19,11,-8,-78,41,-32,-5,-19,18,11,-4,-31,0, 
  /* [57][0][][] */ 78,-61,4,11,8,-12,37,-47,-1,23,-16,-63,-18,40,-127,20,51,27,38,-91,-8,-17,-56,-2,32,25,30,-9,10,-79,16,34,-2,-26,-43,-6,-20,32,-45,68,-14,-49,6,15,-45,26,55,-32,6,17,0,-8,-22,17,-5,-5, 
  /* [58][0][][] */ 47,-53,10,-59,60,-117,-28,-84,25,-56,55,19,15,-76,36,-33,63,-54,-64,-10,-90,-43,-7,22,-33,8,44,8,-30,-47,-101,76,100,22,-80,20,79,23,-22,-53,36,-21,103,-127,-48,68,16,-4,73,-42,33,19,13,20,-2,-1, 
  /* [59][0][][] */ 42,73,-25,-49,33,-24,35,120,-72,106,59,-70,46,2,-26,40,40,-18,6,9,75,45,52,-6,-36,28,-49,-127,36,-27,82,-69,9,-19,-43,47,12,22,23,-20,22,64,62,-90,120,29,-17,56,-11,-23,7,-21,-13,-61,-9,15, 
  /* [60][0][][] */ -83,41,-57,-76,-25,-14,59,66,34,9,-11,61,-33,-45,-61,47,13,15,-37,100,-39,-30,26,75,-52,28,-11,79,-127,67,40,27,89,18,15,-53,11,24,88,-100,69,45,29,-7,83,-46,-46,68,-74,-99,-17,72,-89,-37,-13,68, 
  /* [61][0][][] */ 71,38,38,-92,69,113,41,-12,-67,-37,-18,-117,-25,-47,-22,19,-52,-6,-32,94,40,-42,-48,-72,80,-74,-51,-15,63,29,-47,-23,41,-91,32,1,3,-2,-11,95,-89,-27,-11,33,-29,6,79,127,-52,8,18,-36,-52,-65,-84,103, 
  /* [62][0][][] */ -127,14,-13,12,9,-99,13,-34,-16,72,-10,73,81,50,-17,-3,-18,2,58,43,-18,-42,81,-32,102,-92,49,18,-5,-61,82,25,-52,-36,4,66,-18,-52,19,74,56,11,-6,70,-29,79,58,-34,-36,55,12,45,98,6,58,33, 
  /* [63][0][][] */ -55,-7,36,20,-39,-71,-16,47,-6,35,3,-42,-59,3,39,21,-9,-7,-2,77,53,-39,8,8,-52,-127,21,10,-85,3,-70,-109,48,9,-69,-53,104,-83,-73,-29,30,-85,20,33,51,-67,-2,-47,51,-12,-16,86,-71,17,22,-61, 
  /* [64][0][][] */ -19,14,83,39,21,3,102,26,96,82,25,55,35,-40,71,-62,6,-109,86,90,-74,10,-4,42,116,-4,72,107,-37,2,-35,-58,-80,77,33,63,-89,75,83,126,-8,-79,39,-100,22,109,79,38,-41,127,12,-16,-85,10,-2,-1, 
  /* [65][0][][] */ 15,5,49,-17,26,-27,-5,-17,-24,55,-35,-36,7,90,33,120,-58,27,-36,11,-46,15,58,9,-21,-34,-11,4,-127,1,-93,-12,-11,-33,-47,-48,15,34,9,120,-77,33,-9,-66,-10,-47,-4,-76,-7,5,-24,21,43,-115,26,-22, 
  /* [66][0][][] */ 96,-40,91,15,74,-42,91,-75,-59,64,-1,32,63,-68,7,-57,-13,127,-19,-24,-52,-34,-34,77,-98,-28,-38,-84,19,13,-101,-28,-13,-70,-77,44,-33,-60,-35,43,-41,-107,-44,15,-24,-108,58,-24,116,109,37,-89,113,84,69,-5, 
  /* [67][0][][] */ 58,12,-108,40,40,32,64,52,16,40,13,12,37,90,6,38,15,-80,-11,-3,6,17,-33,127,2,-23,-4,-9,-4,-10,13,-96,-76,13,8,-32,50,-67,68,38,-85,121,-29,-12,31,-25,-58,-39,-105,8,-79,-16,27,14,66,19, 
  /* [68][0][][] */ 35,-47,73,-30,59,-24,104,10,52,-65,-44,76,13,-49,56,69,-52,46,4,57,-70,-23,120,80,-47,21,-24,-27,-7,106,60,69,-5,74,-19,15,51,-8,44,-127,9,-89,66,-89,40,-36,-2,8,29,-55,-17,-118,63,11,-39,30, 
  /* [69][0][][] */ -89,-59,-28,-4,113,-127,-52,29,-50,-98,-25,56,-63,-32,2,-104,8,30,54,-30,-22,113,98,79,-12,27,20,99,9,-56,61,10,-7,-15,127,-6,-59,-14,55,66,-94,110,15,39,22,120,47,84,-62,-43,-23,-2,-77,66,48,-50, 
  /* [70][0][][] */ -13,-9,-68,51,42,-13,-34,10,-93,30,-57,-2,-65,-41,-22,-32,12,-22,37,-28,67,-39,96,90,68,-16,-8,-31,-21,42,3,-87,11,47,20,14,-101,-49,-14,90,-17,-19,16,14,-38,-22,42,127,-19,47,12,-107,-31,34,69,-58, 
  /* [71][0][][] */ -54,-89,109,-40,78,90,54,-54,-54,-55,52,59,-88,88,-100,24,-54,-29,-93,-114,-82,-27,-121,-127,86,18,62,3,65,61,18,-112,68,26,16,-57,-47,-13,17,28,-53,-29,78,-37,-72,-15,-22,-47,19,-23,24,50,-42,-106,70,-115, 
  /* [72][0][][] */ 30,127,-40,-16,72,-6,-85,61,-45,70,41,17,10,-2,50,-1,26,55,-46,23,-9,-21,29,4,-52,64,-4,-27,-16,20,83,-8,42,-1,26,-27,84,-15,69,-36,63,-19,2,-62,-13,80,-49,26,11,10,70,47,-6,28,-29,78, 
  /* [73][0][][] */ -40,-93,-57,79,-70,-35,-16,-30,-68,-65,-74,-21,7,-27,17,16,-33,93,-104,-93,44,35,36,0,-62,74,-53,-50,79,-33,-12,85,6,-127,73,1,-27,-21,21,9,-45,-33,-10,57,50,-38,-60,12,-10,-20,23,-108,-22,2,59,-40, 
  /* [74][0][][] */ -54,-28,-127,26,-9,51,-9,-14,63,13,-17,34,9,-52,-39,108,-11,-18,19,-87,20,1,-92,21,9,62,-4,31,-56,-2,18,30,74,-22,-11,21,-10,-42,-4,-6,7,18,-1,-15,-82,-61,-29,-84,29,17,-19,-23,-5,-40,50,6, 
  /* [75][0][][] */ 72,-72,53,-14,96,5,70,-37,5,-5,-52,-56,-37,9,-45,-17,41,-71,14,107,-32,76,4,33,78,2,-6,32,15,31,55,65,-86,-13,-4,51,-50,18,44,-36,59,-10,-23,-62,1,20,80,127,-25,32,21,-18,80,-33,-94,34, 
  /* [76][0][][] */ -59,-38,100,12,81,-40,48,-2,-84,46,51,-61,127,27,80,50,-33,114,26,62,-60,82,23,-6,10,60,4,-101,-9,-2,55,28,-100,-105,24,-67,45,24,12,35,-26,-51,15,9,-85,28,13,-111,-10,109,-10,-7,114,-103,-28,-98, 
  /* [77][0][][] */ 15,-4,19,-50,-8,63,-14,20,-5,0,-9,37,61,-77,-14,66,-20,-3,-50,-37,-39,33,39,2,-18,27,4,21,-12,65,6,8,4,-11,40,-9,31,27,-78,-22,-61,-3,127,28,-45,0,-6,5,-13,25,-8,-49,-57,18,-34,-26, 
  /* [78][0][][] */ 21,-23,47,-27,38,11,5,3,-28,30,-16,-18,14,-16,8,60,69,29,-41,11,-42,-29,-6,15,-13,37,127,-44,-9,-3,17,1,40,-17,-56,-24,-33,56,23,-11,30,-4,12,-42,-39,28,-25,-26,21,-60,-2,46,14,-14,-3,-15, 
  /* [79][0][][] */ -42,-20,-21,73,-107,56,16,-59,127,34,-29,1,-1,23,-17,-8,-68,35,0,-41,14,-26,-68,36,-42,-84,18,3,1,-33,-24,50,-30,-20,1,29,-68,-26,9,-38,14,1,-84,41,-35,40,11,-83,-16,63,-5,-5,63,50,94,-76, 
  /* [80][0][][] */ 75,26,12,39,-91,-9,127,59,-36,110,20,-14,70,17,-1,75,64,83,80,-28,-15,-32,-78,-75,-15,111,-63,79,35,-8,-41,7,-63,1,-27,-50,30,30,42,-31,-25,21,38,-45,74,-32,-8,-23,-49,-75,73,-52,53,10,-102,99, 
  /* [81][0][][] */ -27,60,-106,6,-46,65,58,-56,46,-84,34,5,-57,29,66,16,-30,-53,38,31,-26,18,23,-68,-48,61,8,27,-127,32,26,110,-34,-14,5,-85,101,38,85,13,80,8,21,-21,-39,94,-112,15,38,-96,24,54,-23,18,-64,-74, 
  /* [82][0][][] */ -50,-33,52,7,-21,10,-32,-30,12,68,-44,21,-12,25,29,-27,60,-119,30,-25,-101,42,-62,57,-69,-2,67,-4,-59,-65,-34,-2,27,67,17,-28,-4,-60,-12,-94,-5,35,88,-127,42,14,7,-84,32,32,37,-35,-14,59,-34,-28, 
  /* [83][0][][] */ 90,10,40,105,8,108,59,-2,-72,73,78,12,23,-30,48,9,102,83,112,89,-90,-37,85,-66,-120,13,102,101,-11,58,-73,23,14,27,95,-4,24,-34,11,-67,-2,-4,-78,35,16,127,-67,-44,-14,9,68,72,36,22,-11,-30, 
  /* [84][0][][] */ 118,6,-54,-34,-30,-43,-32,-46,5,-79,-61,-33,-25,111,76,6,30,7,-79,8,-37,-15,-77,-74,-48,0,48,-76,-7,-34,-59,-104,49,-49,39,30,-50,-82,-57,-51,-85,15,-25,39,-127,-3,-12,26,-34,-17,-66,-41,40,-37,88,-81, 
  /* [85][0][][] */ 24,-6,-59,21,-15,-37,-108,-127,17,43,44,60,-15,-21,13,75,-10,-71,50,36,58,20,-2,56,-26,-96,17,-61,-59,-14,35,-9,108,11,26,-3,45,-41,-30,42,2,51,-17,10,-32,-32,36,0,-51,46,40,21,38,-31,-58,-25, 
  /* [86][0][][] */ -9,64,-41,-16,-46,20,75,101,-89,52,43,4,32,32,-3,-113,63,23,4,-8,38,59,-60,-24,-51,17,-57,11,-8,4,127,-93,-118,-27,4,20,-47,120,-33,64,38,123,46,35,89,57,-39,22,-40,15,-102,10,19,-30,-100,76, 
  /* [87][0][][] */ 8,53,1,-3,-6,7,-12,-37,40,40,66,-16,-14,-12,-25,64,-66,-39,98,-32,-31,37,49,-78,0,-3,-20,-47,79,40,-50,77,-3,-27,92,-20,32,40,-6,43,39,16,29,127,43,-7,61,-21,27,77,-32,-66,-71,5,-38,-4, 
  /* [88][0][][] */ 5,-33,1,18,17,-91,4,4,5,-6,46,40,-17,14,79,-90,-77,-94,-37,-19,-58,-12,-68,-103,-29,-25,25,22,10,-31,-4,-19,-31,-2,40,81,93,1,-75,23,-127,-65,-9,-52,-27,80,-40,-71,5,27,55,8,24,20,-13,36, 
  /* [89][0][][] */ 32,-32,-16,-117,44,-31,-26,21,-21,-43,-36,10,-11,3,-64,15,127,11,20,-23,-48,-57,4,-46,63,-107,13,-19,30,-26,-10,56,-27,-5,33,67,-20,45,-31,-3,39,-35,-28,40,8,-3,32,4,-47,-89,11,-9,38,20,68,-73, 
  /* [90][0][][] */ -7,-54,-57,56,15,-101,-73,67,14,30,11,4,-27,-8,-4,11,2,41,-13,-32,-49,4,22,-17,-12,-53,-3,46,-127,52,-18,-45,12,-2,8,-6,70,-42,-4,63,-29,26,28,-11,-30,-39,-14,-37,30,-45,56,14,-37,29,39,-12, 
  /* [91][0][][] */ 4,-26,44,88,0,-10,82,63,-25,16,48,-26,-39,-127,20,60,-8,-12,7,-64,54,-3,96,-19,-18,-9,-52,30,-23,100,-31,-44,-33,-42,49,49,-118,-40,-16,-44,14,-41,58,42,-30,-43,-28,31,-68,-8,-46,-8,-70,31,-39,-56, 
  /* [92][0][][] */ -91,-28,-17,-127,14,-43,28,52,-94,-5,-52,21,-57,-19,-20,-35,-21,99,-29,-83,-4,32,-50,59,26,-35,10,16,29,-38,-39,61,-15,6,4,30,13,-25,-12,-10,-58,-18,25,13,-16,18,-41,3,52,63,96,-63,-57,17,-23,15, 
  /* [93][0][][] */ 12,-40,-3,-35,-90,51,-41,-60,75,13,-96,-58,-70,36,-25,21,-85,55,12,-86,-19,-4,20,16,-66,-30,-54,-17,8,-97,-40,9,-122,-127,84,51,28,-98,-66,-9,-84,-22,-83,-75,-50,-17,-47,-42,-51,8,-25,-39,11,24,-45,-67, 
  /* [94][0][][] */ -36,27,-36,-22,-2,-16,9,-35,-31,-1,-75,23,-47,69,-13,-34,-107,64,-12,20,1,-10,-23,16,41,8,-105,-32,96,-14,8,-15,-47,-66,11,-63,29,7,-6,127,27,16,-3,48,29,-77,-22,3,-16,9,-49,-56,7,23,-33,23, 
  /* [95][0][][] */ 34,-45,43,-63,-17,-13,12,-6,0,29,4,63,-39,-10,79,-29,5,28,-8,5,-28,33,-28,31,44,41,127,33,-3,8,-6,34,-1,49,-55,-35,-9,-18,-8,-14,71,41,23,-34,24,15,-72,55,45,37,32,-8,11,32,-21,11, 
  /* [96][0][][] */ 92,-31,-21,-77,-116,42,70,-106,6,-12,14,-34,22,24,86,-28,-2,-9,5,-64,-110,79,30,-12,-8,-61,-107,38,66,-24,-21,-60,50,-24,6,-100,12,-42,1,59,18,-35,-58,67,-19,64,-127,21,-39,-20,39,-76,51,56,-25,51, 
  /* [97][0][][] */ -55,96,-23,-38,3,126,76,7,-14,70,-22,0,-33,30,-65,-5,4,-35,-12,37,-19,1,-62,-63,63,2,-67,122,-1,53,-8,-52,-101,-84,-28,9,-52,-31,-36,94,-30,46,-18,100,-23,-49,-85,-11,-127,67,11,13,67,53,-33,28, 
  /* [98][0][][] */ 127,10,0,59,2,-18,-1,-30,-60,67,6,60,-45,22,24,-26,-12,78,31,12,-18,28,-5,54,-8,30,-36,-29,-91,-52,76,36,-82,20,-28,59,30,-8,-62,35,67,-32,-24,94,19,-38,-63,39,-33,-96,67,-7,-36,9,-41,-18, 
  /* [99][0][][] */ 23,32,-10,-2,-2,65,19,9,-34,-46,-32,3,19,30,-1,-65,-26,3,8,-127,-19,-74,-5,-54,-80,86,32,34,41,-103,14,-88,72,47,-10,51,63,-26,23,-2,-14,-36,37,29,-10,6,-41,-66,6,-51,12,14,6,-29,101,-91, 
  /* [100][0][][] */ -85,68,-23,6,29,-72,106,117,21,43,-43,-37,46,-42,-62,9,26,16,28,-17,27,-71,111,11,83,23,-37,-71,-11,58,34,-52,-82,39,-82,24,59,27,17,51,-55,-53,127,-12,15,106,-48,20,64,-32,-41,-10,-75,16,13,22, 
  /* [101][0][][] */ -6,33,119,-114,-55,29,38,40,-38,120,39,72,28,120,-6,-9,-5,-15,-36,-51,-49,-76,7,16,-3,49,30,6,78,-16,-41,59,-127,-83,33,-27,-79,83,102,42,37,6,-7,59,0,-86,-75,56,-67,127,-20,-70,35,5,-8,-87, 
  /* [102][0][][] */ 116,111,-41,-64,-28,-43,17,56,10,-26,-5,-21,33,73,0,17,-75,-47,14,89,45,-121,-22,-122,100,37,110,37,102,-37,-105,-18,-4,-73,-16,9,-33,-25,36,127,17,6,-6,-66,-71,41,29,-32,43,-61,59,-25,-67,83,-110,-116, 
  /* [103][0][][] */ 76,-15,121,-86,-70,99,15,-36,-48,-22,111,-105,23,86,-52,14,79,69,68,6,22,44,127,-63,-57,24,-55,-43,50,-20,-59,-27,-48,-41,126,-5,-90,106,11,42,70,49,-55,-14,28,-26,25,0,-71,83,-29,65,-33,28,27,-104, 
  /* [104][0][][] */ 6,-31,71,31,-10,-57,6,-29,-5,57,25,-40,39,-127,-20,-5,33,-105,-14,-16,28,-2,-33,70,-45,22,93,15,-29,-11,-5,-53,20,72,-1,-61,49,-25,-45,-63,23,-18,26,19,-68,-3,43,-16,-35,-39,-14,1,-14,-24,-10,-51, 
  /* [105][0][][] */ 21,35,-27,44,-19,-40,-11,34,-10,53,-94,-60,98,75,76,87,66,-29,-30,-21,-61,-37,-58,115,-63,-27,-56,2,-19,14,23,-24,-29,12,67,3,21,30,-1,-47,46,-61,-68,-39,-33,-63,77,53,-57,-48,-26,-23,-127,20,-28,-89, 
  /* [106][0][][] */ -109,-19,-8,-48,41,-72,-96,-102,48,54,-43,-40,54,-30,-35,33,-100,-15,9,65,61,2,19,24,9,21,93,-5,4,60,16,-27,-56,-64,-1,7,0,-55,51,-55,2,115,24,7,-8,63,-127,43,-24,-43,39,44,107,-119,-32,87, 
  /* [107][0][][] */ -38,46,72,23,10,87,21,-77,-51,38,-5,83,-6,4,-24,-40,-1,87,-69,30,-3,-11,-41,127,15,-48,61,69,10,32,-15,-47,20,50,50,-36,57,7,-77,-12,9,-40,-5,-21,71,-21,37,19,31,-33,-34,0,-64,-11,16,19, 
  /* [108][0][][] */ -85,-73,-19,-53,-54,-10,38,49,-10,-83,47,-22,-31,-10,-25,22,-18,-2,3,-14,45,15,-19,30,-33,-22,-41,20,14,-1,20,9,-32,-23,-52,-28,22,14,-53,-28,-11,42,-40,13,-13,31,-47,24,9,72,-17,-27,-32,14,6,127, 
  /* [109][0][][] */ -57,44,5,-30,1,6,-22,-27,6,-34,19,41,88,-69,-43,9,103,12,76,127,82,7,-7,16,11,47,-38,70,27,35,42,65,-9,-13,16,17,-54,39,54,-117,67,14,7,-5,18,-61,-35,14,-67,27,9,4,-10,-46,-6,-20, 
  /* [110][0][][] */ -24,-47,41,36,11,2,-58,-19,29,-39,-32,82,-23,-68,28,-21,-30,-23,0,24,13,98,-16,-26,-32,-67,120,53,10,98,-121,-46,57,-82,11,-38,9,-51,-91,-1,40,-20,-42,58,-97,8,-33,-21,-6,29,26,-127,70,90,32,23, 
  /* [111][0][][] */ -127,43,10,68,-4,7,14,67,15,62,40,45,-42,106,-55,21,-93,-49,11,-12,2,13,-126,-7,62,-67,-30,6,17,-119,-25,-84,48,35,16,-12,33,-16,15,49,-53,8,-48,-36,-7,-52,63,28,-53,33,89,-119,8,-47,54,9, 
  /* [112][0][][] */ 25,-53,-36,5,11,-13,37,67,-28,-29,-62,127,-12,2,-5,-58,13,-10,-83,14,-2,-27,-35,-4,43,-68,-26,40,-43,-46,-20,-38,70,56,-49,-27,-84,-30,-2,-73,75,53,25,-60,73,35,-8,87,-31,-16,0,22,-30,-60,21,-9, 
  /* [113][0][][] */ 37,0,63,31,-56,2,6,6,-9,52,-15,42,25,-46,18,-11,55,-91,26,-60,-7,9,-30,54,-64,-15,127,21,-94,-32,21,-51,37,71,21,-45,9,-28,53,-120,-10,-41,71,-2,-31,38,87,-25,-4,4,-12,0,-26,14,-29,-123, 
  /* [114][0][][] */ -36,101,48,-3,6,114,98,4,56,41,-70,19,51,19,2,28,-3,34,39,127,4,19,25,69,62,-89,-26,-1,34,16,110,-17,-55,80,19,-17,38,-29,118,13,-72,17,9,84,-17,-7,33,15,-107,14,20,26,55,-83,32,64, 
  /* [115][0][][] */ -5,-34,-21,-7,-22,96,-47,47,10,-60,-89,16,43,42,66,-75,-4,-34,-95,76,-58,37,-17,-39,90,-17,59,1,-54,78,-43,-49,-8,60,-41,-97,39,-48,55,109,-68,-16,-32,8,-2,-35,27,-84,-127,-32,101,-95,-75,-54,-68,45, 
  /* [116][0][][] */ -81,-38,8,-5,-15,-26,-7,-48,-50,0,40,-32,73,-18,-34,-14,-1,-14,-1,-127,-25,-16,-17,80,-7,31,29,-31,-11,-3,-106,-44,27,34,-74,-11,0,29,19,-30,-27,57,40,-16,-21,18,-42,-6,18,15,17,-48,-37,19,28,54, 
  /* [117][0][][] */ -4,-23,-74,-44,12,-99,-35,95,-21,-32,-19,32,-127,52,-39,6,-43,-13,22,4,-44,46,21,12,-14,10,16,37,-33,28,54,-4,9,-82,36,-43,8,4,69,-14,38,22,89,70,-65,17,67,46,-16,-40,20,12,37,-30,14,-20, 
  /* [118][0][][] */ -84,-54,29,-31,33,-53,58,0,71,52,-67,91,-4,-89,126,-53,-62,19,9,96,45,-39,-41,44,19,-101,46,127,-16,-64,96,52,-96,-87,25,29,-36,7,-73,39,-28,-87,22,4,-38,-56,-29,15,-71,55,57,-10,88,19,80,127, 
  /* [119][0][][] */ 127,-113,-44,16,-41,-62,1,-62,5,49,-52,-30,20,20,52,73,-78,43,29,23,-49,-53,108,-18,35,34,48,52,-39,52,18,28,26,-42,-68,-11,54,-45,-101,-34,-21,-52,94,49,125,-45,-12,-68,-38,-43,-10,-22,-75,-72,-71,-23, 
  /* [120][0][][] */ -14,-2,12,34,-22,-91,-16,51,127,12,-22,-38,23,74,13,-34,-27,-67,16,2,-10,52,-62,32,-4,-36,24,-7,-12,1,-41,2,-23,9,96,-54,8,-31,-32,-8,-62,-25,-26,-58,-82,2,-18,14,10,4,-8,-14,56,34,-30,55, 
  /* [121][0][][] */ 14,-119,42,-127,-69,79,-8,60,-9,30,17,-60,4,-3,-103,-54,-35,1,-92,-65,-28,-75,-2,-79,-99,-74,20,-50,47,-18,-57,12,19,-47,-49,-33,-28,3,-31,-43,-67,34,-24,-32,5,30,5,59,-11,121,-22,65,50,-67,47,2, 
  /* [122][0][][] */ 87,-20,56,127,-14,-51,28,-71,-11,12,-68,53,-26,-53,49,127,-46,52,-51,13,56,94,20,-8,67,55,105,32,-42,42,85,-100,-50,-114,-17,-89,-7,-98,6,-10,-28,-73,81,-44,31,0,-53,29,-70,13,56,15,-50,46,-97,-92, 
  /* [123][0][][] */ -30,-23,-28,-12,86,18,0,-49,-74,-34,-11,20,-18,-50,-1,26,7,-29,-34,-50,26,-1,-70,2,-48,-60,38,-22,-43,-29,-81,-127,-17,-1,-29,9,-41,-15,-6,-21,-67,-15,-42,31,-69,-44,75,11,-16,-49,23,0,17,30,6,-23, 
  /* [124][0][][] */ 52,-29,35,120,127,59,49,-62,65,6,59,-113,49,98,-126,30,28,-58,56,-74,19,-15,3,-30,28,40,61,-64,9,-72,8,0,-30,-17,15,20,-39,82,5,15,-55,-6,-50,-46,-25,61,48,-7,14,101,-54,-79,12,31,-48,-32, 
  /* [125][0][][] */ -17,-24,6,-77,117,127,80,-39,5,60,59,-59,5,-58,-2,29,-94,-30,-3,98,-66,23,-26,64,-15,-31,10,21,-52,-2,31,39,25,7,-19,-82,26,79,-16,-45,10,61,19,62,12,7,-54,35,-27,-42,-32,7,-41,-14,-70,-38, 
  /* [126][0][][] */ -42,49,-87,-22,-24,2,84,93,-39,-32,-83,-8,76,127,-5,2,68,-41,-22,-32,-34,-25,55,-39,-11,-24,-87,-12,-68,-20,38,23,56,28,-80,99,25,25,-93,-38,-93,3,87,-2,37,77,-68,-41,33,8,-110,102,-44,-49,33,20, 
  /* [127][0][][] */ -41,-7,14,-11,-127,-81,-16,27,11,7,-47,63,77,-79,49,-23,48,-48,-42,-21,-46,1,-5,71,43,26,86,11,-41,-14,-9,2,-8,87,26,66,-41,15,62,10,22,-12,67,66,-50,-3,71,47,38,-6,50,-27,-61,29,-88,68, 
  /* [128][0][][] */ 72,8,-18,27,90,-112,-29,-34,79,-47,56,7,-17,21,71,85,-54,-60,92,127,14,-42,-93,25,-40,21,72,25,49,-55,30,-1,-24,-66,-21,-75,-12,-53,-41,-78,14,-39,-11,46,27,-64,-26,-2,-10,8,-51,68,102,-26,-91,-47, 
  /* [129][0][][] */ 19,32,-13,19,42,-74,43,6,60,-43,9,-4,31,-52,33,-42,34,-32,-3,15,-73,-94,1,11,-52,-28,-127,19,-4,-72,-21,-6,39,-121,9,-36,31,2,101,25,40,11,20,-31,13,39,-33,35,-75,29,32,-19,4,28,-27,0, 
  /* [130][0][][] */ -54,10,2,-107,21,5,6,-38,50,-45,34,9,87,-38,91,-39,8,25,-2,102,3,54,-17,60,-87,-44,17,13,-75,-44,40,-50,-63,-45,-61,-95,-75,-10,114,81,-110,57,-127,26,70,36,-50,-24,57,46,-21,-41,67,19,-17,11, 
  /* [131][0][][] */ 11,-11,-12,-5,24,61,45,-60,3,90,48,21,33,61,73,-29,-9,13,-39,9,-87,25,1,0,9,-2,9,0,-15,-36,18,13,-68,-23,27,-36,-1,49,15,71,37,47,-82,127,26,-113,-40,36,-60,31,-28,-26,4,-44,-9,18, 
  /* [132][0][][] */ -56,2,-7,31,81,-47,31,47,48,-10,3,-110,63,45,-61,75,77,44,50,-5,76,26,20,-93,-59,-63,106,43,50,38,-36,-19,-37,23,-60,-27,-30,47,39,31,-38,33,-19,127,-29,23,59,-50,-15,67,11,-91,31,13,14,2, 
  /* [133][0][][] */ 48,-21,18,-57,-6,7,-50,6,-31,-45,48,-51,40,26,127,7,-28,7,-11,-13,32,18,-36,21,42,-22,63,26,46,-1,-4,20,-8,-15,-95,-46,-40,-90,65,-105,-26,57,-38,33,-27,50,-58,-19,90,33,-31,16,13,-97,-48,-61, 
  /* [134][0][][] */ 60,13,17,21,-74,-64,-57,-20,29,-21,15,69,5,113,127,4,-50,-33,-77,-14,-83,64,-100,16,59,-51,96,8,38,-52,-8,38,107,-13,-8,-15,99,-51,-4,-37,61,-76,-29,96,-36,-46,65,34,-67,-40,69,18,-15,-69,-80,-7, 
  /* [135][0][][] */ 98,-29,-66,-5,19,7,51,4,-79,-69,-15,17,-47,-65,25,18,2,19,15,3,22,-47,7,-2,46,51,-24,13,-25,-13,9,-17,-56,6,15,-23,-61,39,106,93,-73,85,-12,-26,36,1,-127,28,29,-4,71,32,-27,32,90,28, 
  /* [136][0][][] */ -21,33,-9,24,-37,-21,5,0,-29,22,19,3,127,18,11,109,70,37,-30,0,-23,-43,-55,-11,17,-42,94,-107,-57,-45,-99,14,20,-30,40,6,53,-74,-109,67,-53,-107,-52,35,22,-36,-33,-81,87,19,-11,-24,27,28,22,-45, 
  /* [137][0][][] */ 21,-45,-92,-6,-34,-35,-8,-22,93,-71,-39,2,-3,19,-32,69,25,-29,-25,-38,-22,-75,-57,35,21,-25,-7,45,-58,19,12,-11,9,16,-24,-12,10,-27,-2,-127,6,31,11,5,-50,23,16,67,-63,1,46,13,-8,-46,-9,-97, 
  /* [138][0][][] */ -71,-35,23,15,24,22,49,5,108,-80,4,-21,-6,-73,-42,-90,22,29,-93,-20,-11,41,-6,-7,-23,19,-81,15,51,12,16,49,-127,-68,61,-50,17,48,52,39,48,42,7,-35,69,72,58,-16,-75,-9,34,-30,11,55,-55,2, 
  /* [139][0][][] */ -60,77,3,-98,-20,-83,48,12,-50,15,29,-2,-50,10,-60,4,-20,-40,30,3,-81,52,-3,-2,127,50,5,-64,-56,-2,2,9,8,-52,0,-38,-39,65,-25,49,-68,-8,38,-17,52,-25,33,62,-36,-9,-31,17,3,-15,-24,76, 
  /* [140][0][][] */ 30,51,-35,-98,33,-24,76,-29,29,-11,11,40,-20,-50,-35,37,23,65,-20,75,-41,-15,48,-30,24,21,53,16,-62,56,38,127,44,53,6,-47,85,-48,44,-79,85,-32,-2,-5,5,96,-6,55,-21,-109,43,-17,-51,-41,5,71, 
  /* [141][0][][] */ 4,34,7,-63,99,-50,-67,88,-61,-6,19,10,-20,3,-32,2,71,37,-98,-21,57,-76,18,-73,-1,75,7,-22,18,24,127,-27,84,-82,-75,-24,29,65,80,-48,52,89,30,2,14,38,-17,61,51,-62,39,-21,-58,-12,-66,21, 
  /* [142][0][][] */ -37,-46,-44,-17,-39,11,-63,62,21,53,17,27,11,43,72,-127,-30,46,26,-37,33,-40,-119,-55,-73,-85,67,-30,-14,26,35,-116,-35,-7,44,-39,33,-101,26,-80,16,15,57,-5,70,8,-15,52,50,15,-13,-57,0,-59,-1,51, 
  /* [143][0][][] */ -127,42,2,-51,57,109,11,-47,24,16,-28,4,32,-27,62,110,55,100,-23,17,69,-62,79,-14,79,-9,79,22,12,-45,67,-92,45,-71,19,2,13,-54,-24,53,-35,-96,-12,-28,47,-47,61,-1,72,-116,-35,13,64,-75,58,69, 
  /* [144][0][][] */ 14,33,22,-75,14,-127,-17,53,-2,-30,65,15,52,-67,-4,6,1,30,-63,38,-3,-26,36,-94,6,16,-14,2,21,-24,28,22,24,-63,-36,-26,-4,14,24,88,35,-16,32,-5,41,-56,30,34,-11,-14,-44,17,-48,-92,-44,66, 
  /* [145][0][][] */ 1,-13,52,13,-7,7,68,-22,69,69,-7,23,8,-127,69,52,10,22,2,-7,-6,8,-16,36,-52,-74,38,63,11,-4,34,31,-15,16,30,27,12,46,-69,46,-41,-65,-43,42,-17,-30,71,22,-5,24,-32,-10,2,-35,40,83, 
  /* [146][0][][] */ 84,-38,66,-93,-49,-43,-20,31,-35,18,-83,27,5,-47,-28,4,-56,99,26,35,-2,-106,18,-11,-46,-17,15,20,-61,-15,-53,20,1,26,11,20,127,23,-4,-57,-40,-25,58,35,46,-37,-45,73,43,11,-37,19,-16,-89,62,27, 
  /* [147][0][][] */ -91,48,-35,49,60,58,-32,85,-25,-27,-6,-39,60,46,7,-22,70,1,8,3,9,29,-125,-29,-24,-104,64,-60,-7,28,5,-66,-109,10,-9,-39,5,34,1,-17,-127,9,-42,21,-43,52,-20,-29,10,0,13,-86,15,81,15,2, 
  /* [148][0][][] */ 4,-10,-26,-48,37,-40,39,61,70,32,-9,27,43,18,47,54,27,-127,45,56,41,25,4,22,5,17,11,17,8,22,-44,43,-4,65,19,-37,-57,12,49,45,6,-51,35,-1,-10,-16,36,47,37,-12,-51,-56,-26,72,32,-78, 
  /* [149][0][][] */ -52,21,-46,-71,3,38,46,91,-15,22,20,-48,33,127,-71,-2,125,-73,-25,-9,-7,30,-56,72,-87,42,-4,-111,-30,56,-55,-18,45,-4,13,25,47,-23,70,42,-35,76,103,16,-24,22,-42,-45,54,-73,-43,64,-55,-26,-77,-110, 
  /* [150][0][][] */ -49,-3,-38,-37,-23,2,37,-71,2,73,-127,-5,-55,3,23,-16,-17,32,-51,20,-77,-14,4,-31,86,28,-31,-49,-62,-74,14,-74,12,25,-74,-50,47,-3,43,52,50,79,30,-35,10,-8,-24,64,-22,-73,33,38,-103,29,51,-17, 
  /* [151][0][][] */ 69,-13,26,44,13,0,52,-29,20,-39,43,31,-6,94,75,-91,29,93,-65,42,-77,-9,3,9,-30,9,-4,13,66,-82,-44,-20,8,-55,-49,20,127,64,-17,1,14,40,-70,-6,-45,38,38,-13,-65,-13,14,-42,25,-37,-66,-68, 
  /* [152][0][][] */ -88,0,76,-18,-35,38,-31,-21,17,-24,-69,89,17,36,127,-36,13,69,48,69,31,-44,6,95,-27,13,18,13,-25,32,16,6,45,-78,-20,83,10,-57,57,115,84,-5,73,87,7,-1,-27,-26,-120,34,26,-94,35,73,-24,-84, 
  /* [153][0][][] */ 113,48,27,76,71,-33,23,16,-75,11,19,-30,-13,93,-81,-38,-73,-14,-84,-110,32,8,38,70,68,62,-3,1,28,-121,15,39,29,-30,-60,83,96,-7,7,71,-71,25,111,73,81,-29,6,-40,-127,-34,-26,-41,-45,-43,8,-62, 
  /* [154][0][][] */ -79,39,-33,82,18,-3,8,-67,7,-20,-33,2,-25,-42,92,-5,-107,-33,23,-4,-79,68,-42,51,-6,-9,18,33,27,123,52,17,-46,-66,90,64,-84,-30,13,29,45,-127,-65,32,-115,-53,75,5,-84,59,-53,9,72,35,68,-59, 
  /* [155][0][][] */ -71,-102,-24,38,-81,18,-40,-78,-59,51,65,38,-7,74,-27,26,89,64,-40,34,11,29,106,-127,21,43,11,20,-103,-27,31,66,3,-56,-29,59,51,81,59,-92,6,-36,-44,-86,41,-96,74,19,-29,35,88,-55,-38,-41,59,21, 
  /* [156][0][][] */ 40,-48,-50,-23,-63,-17,-12,-8,-76,-17,-46,40,12,31,47,14,-47,67,-59,-10,-17,-21,-21,57,-4,38,-14,8,13,-95,-32,5,-41,13,39,2,8,57,36,14,-127,-17,-18,-2,-29,-50,-2,-37,-39,-23,-42,-14,44,-5,42,28, 
  /* [157][0][][] */ -22,17,-12,-12,81,84,28,28,87,-48,35,-55,-58,-24,-17,56,-36,45,76,70,79,-54,50,-59,-127,-45,-47,6,88,26,25,68,-5,50,17,52,-75,8,-27,32,20,11,-84,55,-33,-17,24,-59,-30,-58,-88,-45,-47,-33,100,-91, 
  /* [158][0][][] */ 30,49,-52,75,-61,-99,31,75,82,-7,45,-9,9,24,-9,-44,25,-45,104,-1,55,-33,1,28,81,-28,6,-95,-18,-55,-19,-74,52,78,115,37,26,33,-100,-3,-15,56,6,8,47,39,-127,-28,15,30,-36,57,37,-41,33,-37, 
  /* [159][0][][] */ 60,35,-5,68,-70,-35,-62,-43,-19,-40,-25,-27,3,57,59,37,13,18,-45,1,0,-52,-32,-9,-12,-86,107,-14,24,13,-15,34,31,-34,-1,-37,127,-4,10,-107,-17,18,-52,80,-64,-56,27,-58,4,12,-15,-31,-3,23,-84,-4, 
  /* [160][0][][] */ 2,-70,0,-6,78,23,-30,-48,-32,16,-61,14,28,-127,28,117,-37,-25,-30,-8,-41,23,57,76,-29,8,48,3,31,-28,40,49,-77,-83,-97,45,50,30,2,17,60,-21,1,2,27,-47,-13,0,-23,21,96,7,-6,24,70,-54, 
  /* [161][0][][] */ -1,4,48,47,38,101,13,38,-57,51,-55,-19,-60,56,-127,-14,-1,46,54,-51,37,-41,-56,-19,-5,2,-3,-21,24,-67,60,-20,-64,52,10,22,-34,-23,77,2,-21,28,-83,-48,0,12,-37,-49,-19,30,12,-47,17,-48,86,-74, 
  /* [162][0][][] */ 42,6,24,21,26,13,17,16,84,15,1,31,40,-29,-40,-80,-8,34,71,-57,42,12,16,-4,-32,33,-40,11,-54,8,4,43,-31,2,46,-52,1,-8,-32,-36,-36,-34,-8,26,27,-76,-127,-37,-14,-7,7,14,84,17,-27,27, 
  /* [163][0][][] */ -61,11,-50,9,74,37,65,10,-63,19,-10,127,-1,11,-29,6,38,51,7,-69,16,34,-39,-112,73,52,13,15,-39,51,-66,-62,-25,62,-13,-63,-31,-37,27,-36,54,-19,-35,-51,3,29,67,0,2,113,78,-47,-77,55,-10,-7, 
  /* [164][0][][] */ -29,-60,36,-36,1,-56,-20,-21,-24,-18,-65,-51,-41,87,30,-53,14,51,6,73,-29,-37,-60,103,-6,36,-31,-6,3,13,118,-8,1,-20,-37,-23,-22,123,-25,7,-11,117,-38,-29,-17,-65,-127,-3,-3,-70,-19,-26,62,-43,-26,51, 
  /* [165][0][][] */ -12,-40,-7,3,17,127,39,-76,-1,-14,-60,-55,-5,20,25,16,31,-75,46,74,-60,-6,24,40,-32,103,-40,17,66,14,-33,-23,-60,19,2,-14,-15,10,80,-87,57,63,-58,10,-48,122,-6,-46,-103,-52,-12,-69,38,-68,108,32, 
  /* [166][0][][] */ -8,42,13,-4,39,51,29,57,-43,-19,70,-41,-10,-18,-127,62,-49,-10,25,-39,12,-51,35,-24,-50,54,-6,-16,13,43,-5,-16,2,-6,57,21,-44,33,-28,21,44,81,-37,-27,39,95,-64,-36,6,106,85,58,16,-24,54,-10, 
  /* [167][0][][] */ 17,42,32,42,57,-40,16,-7,10,25,57,30,-15,-127,51,5,37,-8,12,-8,-11,4,-29,0,-4,17,-40,-7,-10,26,-15,-41,92,-29,-10,-40,28,-13,66,22,64,18,50,-4,8,26,-53,-20,25,25,-7,16,-47,0,31,-1, 
  /* [168][0][][] */ -60,-21,-22,24,30,-13,-22,37,80,-70,-22,56,16,11,19,67,-38,27,-3,-4,10,3,126,85,103,58,45,25,-56,67,127,-25,-11,10,-16,-66,16,-50,-33,-54,-14,9,53,44,-37,-62,15,-5,-25,-6,-6,33,14,37,1,-43, 
  /* [169][0][][] */ 17,-127,5,-24,-17,19,-20,-12,66,-69,21,59,-9,-52,-15,19,-46,-81,-21,25,21,73,-53,-68,-27,-53,23,-39,22,28,-39,-65,-17,-66,83,2,-25,-22,-24,-27,-28,-37,-46,20,-52,-3,14,55,-22,-49,65,-60,20,17,20,-20, 
  /* [170][0][][] */ -70,42,-16,-97,36,117,76,-13,-35,18,-20,86,-68,-59,41,-87,68,59,-29,-27,-6,7,73,-46,-28,-67,-54,45,9,31,20,-41,-41,-15,-21,73,-86,114,21,55,-45,118,-14,36,104,26,6,65,-63,60,-43,-36,77,-65,44,127, 
  /* [171][0][][] */ -69,37,-31,5,-35,-73,41,66,-13,30,15,-91,-31,16,-50,15,67,51,113,3,48,-10,-10,1,36,-6,-65,-31,59,-127,45,-43,-6,-62,14,60,-42,41,-44,63,-18,69,-40,4,50,12,59,21,-25,54,-24,-18,-2,-15,17,14, 
  /* [172][0][][] */ -5,24,12,-25,-71,24,3,-80,37,-85,25,5,-11,100,45,-29,9,-1,26,12,-14,-57,-46,-34,-100,72,-91,39,5,127,14,-30,32,-13,-10,-4,-41,-23,-1,-1,-55,55,43,-25,14,-7,-36,29,-7,68,50,-71,-31,41,6,54, 
  /* [173][0][][] */ -1,29,-50,28,-14,31,18,30,43,42,-10,-60,10,51,11,26,-85,109,-3,58,5,50,127,-40,-51,11,-97,-33,6,28,-33,62,34,-88,39,0,-54,18,-97,-8,-26,49,-17,78,72,-35,-16,-2,-18,40,-20,30,16,-51,0,21, 
  /* [174][0][][] */ -35,-83,34,-41,81,0,11,-127,8,121,-44,-38,2,-51,-1,-53,21,26,-34,-36,-47,39,-9,-47,-3,-21,13,-41,50,84,73,83,-8,-75,-30,-45,-25,41,98,-12,81,-58,-26,-59,27,69,73,47,-11,30,-34,25,-55,23,-49,24, 
  /* [175][0][][] */ 31,63,77,40,-30,-58,66,31,86,69,10,-16,-29,6,-68,3,-44,-95,47,16,67,40,-10,-14,-15,-96,41,2,28,-7,-59,-2,-39,31,-42,127,-9,5,-22,41,92,22,-39,86,24,-35,96,67,116,69,90,-68,52,90,51,0, 
  /* [176][0][][] */ 2,-26,-35,-30,-70,-19,-91,16,27,-73,10,-8,7,1,14,10,47,28,-2,-32,16,18,17,-95,47,-13,-31,42,40,0,45,32,69,58,42,-49,-43,-25,7,-127,-43,-30,5,-10,20,57,20,-42,55,-54,-10,22,-42,-1,-7,49, 
  /* [177][0][][] */ -27,-66,-36,15,-8,-11,-33,6,-3,-4,5,42,-11,-8,-18,10,13,-49,-17,-105,-16,66,-61,-36,-18,-31,-28,-68,-14,-127,-27,0,47,24,-82,27,11,-36,-12,-19,-10,-25,22,-14,-22,-65,-12,-14,18,47,2,-58,75,31,91,19, 
  /* [178][0][][] */ -22,63,-28,47,-9,-26,-48,39,57,125,75,-21,50,127,-30,29,-24,58,-25,54,-9,-22,2,35,15,46,28,0,40,-1,33,-121,-65,-44,57,-38,-19,-31,-25,36,82,21,-14,-92,9,32,33,57,-7,-49,-45,27,-3,-14,15,-18, 
  /* [179][0][][] */ -14,42,3,-47,34,-69,-6,64,-104,56,12,20,-34,-43,-70,28,37,20,10,88,21,9,5,15,6,-3,59,-113,39,-47,10,-56,-38,-2,-76,-4,-20,127,-12,-50,-2,78,65,-29,41,-65,26,4,48,-120,-9,-27,-107,-15,27,37, 
  /* [180][0][][] */ 48,-3,-5,26,-62,17,-54,58,26,35,13,16,-33,15,13,16,7,34,-14,-31,19,18,25,-37,-11,29,-24,24,49,-77,-43,-17,127,-27,23,-8,41,-125,-44,-44,24,40,-15,3,-71,-8,13,-7,103,19,-24,21,-46,15,7,-23, 
  /* [181][0][][] */ 68,-79,36,-1,66,-90,12,-42,27,-15,-5,-66,-55,-18,70,75,-32,-20,-8,-1,-127,-22,-34,6,18,15,110,-22,-16,-90,13,56,-51,-70,36,-8,53,68,-24,-37,86,-21,64,1,4,62,-5,9,21,-27,-49,-7,-50,-95,9,42, 
  /* [182][0][][] */ -50,60,-18,4,53,127,101,-23,-93,34,-37,55,-23,-15,-38,-27,-79,22,-15,51,18,23,-10,-14,-31,-13,-57,21,-29,26,31,-115,-16,99,-1,-90,29,-70,35,110,-80,-21,-45,32,35,-95,25,-25,-64,10,-6,-45,6,-43,6,15, 
  /* [183][0][][] */ -13,-46,-16,1,-1,1,-3,-25,-12,6,18,7,74,5,-9,28,9,56,25,4,38,-29,-56,43,-31,-3,80,-47,-13,-49,-5,-11,-127,-9,-38,29,-18,28,50,49,-14,32,2,20,-35,26,-30,-49,21,-9,3,-29,4,-36,42,-9, 
  /* [184][0][][] */ 12,-46,67,-28,-15,25,-41,-24,127,44,71,0,57,116,14,6,-80,111,20,51,-2,-48,-53,63,-9,127,-21,-2,-94,25,-77,43,-46,36,-52,15,13,-15,72,4,51,-92,1,21,106,-25,-65,-70,12,-54,-20,-5,4,13,-110,22, 
  /* [185][0][][] */ -33,-30,-23,-12,-74,12,-76,58,-77,-8,54,37,56,-19,90,35,29,-85,44,37,-14,-40,22,88,37,27,34,-27,-37,45,38,-127,12,-121,100,62,-59,39,-37,-46,-4,-5,-29,28,88,31,-28,-6,13,19,-23,6,117,-35,-30,13, 
  /* [186][0][][] */ -35,-26,-59,21,27,10,-8,19,22,6,-37,-17,81,-76,-45,-55,42,17,-21,5,-127,-16,-68,-39,59,-103,42,15,-76,-67,19,-19,-15,-12,-55,33,53,54,9,-33,55,28,-8,-20,15,-7,23,45,-17,-19,-28,8,-61,-40,41,-6, 
  /* [187][0][][] */ 37,8,49,-18,-18,-47,-6,-124,36,40,35,22,82,42,-14,26,-2,51,13,20,-49,4,87,50,-78,-7,24,-127,32,15,-13,7,-23,41,-11,16,-106,7,-47,-2,87,5,-21,29,13,-104,2,44,-19,15,-41,27,-45,6,-23,-25, 
  /* [188][0][][] */ 42,60,-14,47,-17,-26,57,-29,-37,54,-16,96,-5,-21,-23,-88,6,75,127,-4,43,-4,42,-55,7,-14,20,31,-63,-21,-23,48,-51,23,13,-25,97,20,23,-11,-34,25,-16,-1,-36,46,30,18,-20,-39,-3,56,10,2,-81,-7, 
  /* [189][0][][] */ -6,-18,-92,105,-105,0,51,42,-18,50,37,-9,57,7,-51,34,14,27,-28,-44,2,2,-45,-68,-34,-16,25,-19,57,-31,-71,-68,127,-45,5,9,45,-50,-27,-32,-75,19,-25,22,16,50,38,-15,80,-62,-31,82,0,51,-48,11, 
  /* [190][0][][] */ 14,-82,-9,42,-79,-71,84,-26,34,-36,2,-21,43,-68,-2,48,79,-69,16,67,-42,17,100,22,93,45,52,17,31,-44,2,70,9,21,53,-30,-71,12,-18,-127,95,-8,16,-10,-44,8,-8,30,19,79,47,103,-24,37,-89,44, 
  /* [191][0][][] */ -45,20,-19,-62,24,66,-17,40,-24,-52,5,1,91,-16,-71,127,-68,-5,4,23,47,47,21,-28,-42,49,49,-2,-53,64,-64,18,-5,95,-56,33,-82,60,31,-82,-45,9,-5,-13,24,55,-32,-57,-8,-37,30,-24,-10,27,41,-86, 
  /* [192][0][][] */ -76,-71,43,-27,-77,1,-18,-19,9,-33,-127,3,9,-13,-1,-6,-52,-24,20,-34,-23,-6,0,4,-14,-17,5,-33,-8,-1,-58,1,-47,21,7,68,-9,-3,-41,21,-36,11,-28,-1,-57,-99,-8,-47,-9,-25,33,4,29,-8,19,-105, 
  /* [193][0][][] */ 97,-12,-26,-18,-8,28,-6,-35,73,-73,56,-26,-36,33,-33,127,-30,58,-5,17,-19,-3,-96,-52,-88,-63,-53,-11,-78,64,11,9,-15,-1,-4,36,-55,-117,41,-6,13,115,-6,-40,34,5,24,-46,-77,-36,-35,56,13,-9,-47,-87, 
  /* [194][0][][] */ -108,-24,8,-26,13,-5,67,-50,-22,-66,62,50,-54,-66,-82,-42,89,-42,36,-51,-85,23,104,-62,-29,45,16,10,50,25,116,-23,57,-21,9,-33,66,-62,15,-8,8,55,26,-28,1,32,94,49,-107,127,-6,-91,-91,-104,36,-117, 
  /* [195][0][][] */ 72,108,12,-73,30,5,48,45,-18,-19,33,36,-49,82,24,-19,75,40,-104,71,-74,-11,-12,-21,38,22,-85,-13,-38,-73,-38,9,-30,127,5,-13,-53,29,-5,20,27,117,-12,20,-58,-32,-101,61,-37,46,99,98,51,-55,10,-42, 
  /* [196][0][][] */ 8,-24,52,46,-32,54,115,10,24,23,64,-127,17,45,-1,18,36,15,-22,27,-28,56,21,-72,-70,31,26,-20,36,54,-28,-15,27,-27,24,60,2,0,22,26,-37,92,32,-14,12,64,-99,32,56,16,21,1,-6,-35,38,-20, 
  /* [197][0][][] */ 61,100,3,76,36,75,-51,-21,-102,-16,31,60,-70,27,-73,38,-23,-17,55,37,5,24,7,12,-60,98,-38,-61,-56,19,1,-76,-18,46,0,-127,74,-3,-27,85,-35,-21,-88,-100,45,22,-40,-92,-111,-54,-10,-53,-80,-61,57,-72, 
  /* [198][0][][] */ -58,52,89,-40,45,10,-16,-127,-99,79,-24,103,-22,-73,-55,22,-52,92,0,-66,-13,96,-30,23,26,-79,55,-45,-11,93,83,-62,13,-31,-47,81,-35,44,88,-73,-24,43,-10,75,-11,-81,27,22,11,-4,-71,-42,73,-52,39,97, 
  /* [199][0][][] */ -24,47,19,-105,99,68,14,103,-79,-32,22,-65,8,-44,-73,73,-84,4,64,56,-23,35,89,127,-24,80,33,32,-25,-78,-47,-30,-22,17,41,46,-70,50,-29,-12,79,51,87,-36,49,24,35,-67,63,91,72,-26,-31,-6,119,42, 
  /* [200][0][][] */ -23,-36,26,24,-23,-90,-12,22,-11,114,-70,-1,-28,102,-76,3,16,-49,-3,-38,20,19,-59,127,28,35,-24,-40,-8,-85,-52,-23,1,42,22,63,56,-60,-56,-51,6,94,0,-64,0,15,-21,-18,92,41,16,-64,-55,33,2,-1, 
  /* [201][0][][] */ 107,-123,9,38,-98,-38,-42,-28,74,21,127,18,-47,24,38,30,-8,-7,-15,67,72,21,23,87,-82,-5,-53,36,10,55,-29,-51,-46,-62,28,37,-47,-25,-28,71,-77,-97,18,-31,40,-26,16,5,51,20,16,26,-15,-21,94,21, 
  /* [202][0][][] */ -35,75,-18,15,-49,9,58,105,18,2,-43,19,-9,50,13,-39,-5,-17,-13,22,25,1,40,-127,-3,-37,-49,-22,20,10,3,-52,42,29,31,18,-25,-17,-65,33,17,52,-94,59,51,31,1,-23,33,-46,24,-40,1,37,8,-6, 
  /* [203][0][][] */ -29,48,-15,-32,-44,-46,1,-6,-27,-77,-56,-9,17,-65,-27,-58,-59,116,-66,-83,-23,-92,48,20,34,39,-63,44,-42,92,-46,-15,-81,64,-88,66,-14,18,32,-24,6,32,63,-53,-40,-127,62,-38,16,3,-20,42,1,58,48,-68, 
  /* [204][0][][] */ 38,-41,-70,3,-127,101,34,5,60,29,61,0,63,-40,12,39,-67,42,-64,24,-53,-33,79,78,-42,35,54,57,28,24,14,-20,-33,30,81,65,-56,31,-15,37,-22,-13,-69,59,-3,35,0,17,-9,73,-55,-3,44,-58,46,61, 
  /* [205][0][][] */ 29,-37,46,4,-22,49,10,-46,-14,-8,28,15,-10,-24,-12,-24,45,-34,-60,-22,-74,-27,-24,10,40,93,-27,36,-32,-32,23,62,73,-2,-73,39,127,55,73,-42,-13,-29,17,-6,-8,52,11,42,-40,7,-79,-19,-66,-52,47,-13, 
  /* [206][0][][] */ 30,-95,113,44,49,45,45,-6,71,-101,47,-123,81,51,-127,57,-40,-64,124,36,55,0,-20,-49,-85,12,-17,-43,-13,51,-28,-86,-21,16,-64,-8,16,-17,-66,-3,-6,-22,-46,-22,0,-44,-92,-3,2,-10,-71,95,-47,11,39,-9, 
  /* [207][0][][] */ 59,127,-17,-19,-112,31,9,-122,36,-28,74,28,15,-50,20,28,34,-54,-86,20,-39,-37,-24,-34,-40,-44,59,6,48,-45,-22,-49,-16,-7,-119,46,49,26,8,-115,-59,-102,-22,-42,-6,-112,-57,-80,-58,29,45,-3,74,2,-90,87, 
  /* [208][0][][] */ 123,13,125,56,49,-13,-25,38,86,-19,-9,5,11,-35,67,-28,-1,67,15,-18,-63,-35,-22,-66,48,-14,47,57,70,35,-115,-44,-14,43,-63,63,83,12,13,-49,-127,31,-104,54,61,-9,7,7,-72,-97,-1,7,-56,-5,-92,17, 
  /* [209][0][][] */ -61,-19,-60,-15,-22,-74,-24,-97,33,0,114,-15,-46,-5,-38,12,-6,-55,-8,29,25,-5,87,65,-27,-75,50,-15,11,56,-11,0,-64,-24,-86,40,-33,17,-76,127,27,79,-29,-17,29,-21,39,-44,-88,-34,-26,-25,39,-1,-70,-60, 
  /* [210][0][][] */ -127,5,-34,-3,-50,-13,-26,48,-3,-48,63,56,29,41,-32,-63,-26,79,-62,64,-51,25,74,-79,-95,37,-92,20,2,56,-40,-71,102,70,108,-61,-22,-20,-58,-36,108,35,96,85,-27,-58,-78,-84,-26,-8,-20,107,-67,18,61,16, 
  /* [211][0][][] */ -10,27,-38,10,9,17,10,-67,-14,90,7,-4,-11,3,8,72,-23,42,11,26,-10,30,-50,43,-24,41,93,-54,15,46,4,-127,-80,-70,38,65,-3,122,20,4,-24,-24,-56,-24,31,75,-25,-3,-85,57,13,-105,18,-3,51,88, 
  /* [212][0][][] */ 0,60,3,0,46,97,-51,-3,-67,74,49,-71,-40,-46,-43,20,19,19,19,-49,-41,4,-48,16,-127,18,100,9,-8,3,-67,-38,37,-1,-9,21,64,55,30,-48,-17,-2,58,-8,19,109,9,-51,32,-22,-33,22,19,-13,48,-100, 
  /* [213][0][][] */ 45,-69,81,33,28,44,-31,-127,35,-127,-77,-34,-12,-44,104,31,-3,1,2,88,-35,71,84,-38,-48,112,-61,104,-11,-2,-19,-51,-34,-41,120,4,-26,-43,-59,-10,28,-32,-110,-65,-18,-57,0,23,-73,33,25,12,-20,39,-1,-14, 
  /* [214][0][][] */ -27,30,-43,-11,113,5,-5,85,-23,-105,29,-58,61,35,32,-98,66,12,-24,-32,65,-23,55,-88,-9,-16,60,77,36,-20,18,23,111,38,-63,14,51,46,-25,-72,127,17,111,33,-44,-22,-58,29,17,-87,50,-105,31,16,6,-56, 
  /* [215][0][][] */ 7,-53,-54,-125,-3,-77,23,-60,-13,27,10,22,24,-15,70,67,15,34,127,94,41,72,-51,38,-50,49,48,-13,-51,57,9,22,-48,-72,-74,-57,9,30,18,116,32,58,-68,-3,8,-39,-25,32,-14,22,-1,-18,24,12,-24,17, 
  /* [216][0][][] */ 94,-21,66,28,24,-77,-3,-78,-30,22,26,52,9,-30,96,22,-30,-74,-6,-32,-59,-1,-105,12,5,31,30,-8,-11,-62,-58,12,37,77,3,-52,-3,-9,-127,28,71,-79,90,-47,-121,15,-86,-27,45,-15,-92,40,25,24,-16,30, 
  /* [217][0][][] */ 0,-74,62,-16,40,122,-39,-12,-57,-25,39,102,-76,-32,118,-12,57,33,84,48,-68,53,-31,9,-80,7,49,-51,105,-26,37,-76,-84,-31,3,-41,-65,-127,-18,55,-8,12,-11,27,-127,-58,-97,-71,-38,44,33,-23,58,80,4,109, 
  /* [218][0][][] */ -83,4,-46,-3,51,-7,17,80,7,56,22,117,18,63,-5,3,85,3,-43,84,100,-101,-55,-22,44,-23,42,-44,-1,-25,31,-54,7,72,38,49,-38,127,2,-16,-38,-5,-85,-93,47,44,94,27,76,-42,60,4,92,122,19,-26, 
  /* [219][0][][] */ -69,27,18,-41,-103,-9,80,-11,-16,47,-18,-62,-12,-29,-18,116,-55,-21,127,-28,70,-61,92,49,39,1,69,42,12,4,6,51,26,-55,-12,56,-12,-13,-23,-34,65,47,-35,39,-28,-43,19,6,-25,-25,10,34,-41,-29,50,-71, 
  /* [220][0][][] */ -83,23,-18,-54,15,10,-34,-23,20,61,-22,11,-44,17,26,-127,-27,7,31,14,-6,-45,-98,-53,-50,20,20,20,21,0,-6,34,23,-80,68,10,47,-23,45,-43,34,-20,52,16,31,-29,-61,27,-58,40,16,-70,-55,-80,-56,42, 
  /* [221][0][][] */ 81,-9,60,-49,20,59,-38,-106,-86,67,66,26,-9,-99,-79,99,53,32,12,33,63,32,6,-4,-69,127,81,-42,-93,1,-103,-7,-6,35,-59,-17,-21,-13,26,-11,36,-15,-40,-99,24,69,-41,-15,12,1,22,73,-53,25,29,-83, 
  /* [222][0][][] */ 4,50,2,42,-19,42,-36,-40,-19,-86,8,7,57,15,39,18,-9,-26,-21,-76,75,-20,86,26,-22,17,-6,-10,-69,7,43,3,40,-1,-32,9,9,-27,-33,35,87,-50,47,-42,-40,-127,2,1,59,-1,6,-15,-32,21,72,13, 
  /* [223][0][][] */ -68,15,43,-53,-18,-33,-25,-8,82,19,-86,34,-25,-29,-25,42,95,-24,11,-57,19,-15,15,-103,-18,17,120,90,-103,-22,-29,-1,-41,-28,14,5,-120,-34,-47,38,57,-40,-60,-127,-38,-26,101,31,34,93,68,-56,34,23,-21,2, 
  /* [224][0][][] */ 26,22,6,-47,-3,-46,46,3,111,103,23,5,-32,0,43,127,9,-51,-79,46,66,17,67,-69,-48,-20,115,30,-61,77,-13,-50,-38,8,-37,-48,-1,-51,-61,12,105,88,65,52,37,-56,14,-1,-62,-26,31,65,11,-48,21,-43, 
  /* [225][0][][] */ -2,-47,20,32,17,-27,7,62,-47,25,7,116,79,-19,32,5,-23,9,27,-56,60,-38,-54,-1,-57,-19,-37,-36,30,58,5,-23,-30,-79,27,88,27,0,-8,30,46,17,95,56,54,-127,-8,3,20,-72,70,-38,13,-40,76,97, 
  /* [226][0][][] */ 58,27,45,-7,16,-91,-27,-60,-57,25,2,-56,-32,80,6,97,-17,9,8,0,108,-1,39,127,-89,-2,52,-28,-60,-6,-18,-25,33,-3,-42,74,10,-28,-3,-24,-21,-82,10,14,-13,-5,-30,40,36,2,25,-77,-59,18,2,29, 
  /* [227][0][][] */ 127,64,51,-18,43,-5,17,-5,59,-6,-34,5,0,25,15,100,62,-8,-41,48,-25,95,48,-22,-31,46,55,30,-22,37,66,-22,36,25,-41,-54,2,-50,86,-67,-2,-7,13,61,-66,-12,-22,21,43,-108,-7,22,-61,20,-24,-67, 
  /* [228][0][][] */ 28,-29,-1,-25,6,-127,33,14,-23,49,-24,-64,-1,-41,36,29,16,15,66,14,23,-68,-20,-79,42,56,26,-94,66,61,8,38,29,11,76,-15,-82,45,29,-52,-23,61,22,-52,-45,1,30,-58,-88,36,66,-41,-77,-32,2,10, 
  /* [229][0][][] */ 10,58,34,94,5,-20,3,54,-34,11,7,-2,-17,-8,-79,0,15,-14,18,-32,78,-43,-27,-29,7,-83,-15,-7,6,-27,-16,-43,-32,20,48,48,-28,-22,-30,127,-10,34,-127,-28,18,-38,17,28,62,54,95,-57,21,31,44,-11, 
  /* [230][0][][] */ 11,87,-6,10,-16,-23,-39,63,-112,77,3,-36,-10,124,-39,-51,1,47,7,-37,42,-14,-127,66,-96,-52,5,-41,-48,29,56,-109,-33,-45,-60,-62,-80,-28,-27,-60,17,44,-46,-109,45,-40,-30,53,56,-7,40,-69,1,69,-19,-54, 
  /* [231][0][][] */ -78,-47,-54,-19,61,24,67,-40,38,55,-95,-47,22,4,3,39,-127,17,0,-52,3,-71,-15,9,28,-32,-29,-2,-44,14,-12,-39,17,42,65,78,34,-16,30,77,57,8,19,81,63,-62,-68,13,-38,-65,-8,-66,-42,-13,-57,9, 
  /* [232][0][][] */ 37,9,36,49,-15,8,31,29,-25,-45,60,-25,-52,-10,-3,-4,52,-42,-51,-15,3,76,-28,48,-30,-8,21,-8,-11,-15,-10,-20,13,27,-22,-59,70,-20,-37,-14,-11,-127,27,-33,-35,-42,66,-9,-18,-40,40,15,-10,34,0,44, 
  /* [233][0][][] */ -28,-4,-78,37,-41,-2,51,24,-34,-91,-127,-7,9,10,59,18,46,-44,-45,44,13,51,-20,4,-75,-31,-7,4,-11,-59,-3,-42,-4,15,-10,-12,29,-31,60,-4,-86,-59,51,5,-59,-58,-63,10,-38,-92,23,-45,-23,44,-47,-43, 
  /* [234][0][][] */ 67,99,2,-41,-14,18,81,35,127,64,-8,9,38,27,-20,-2,17,57,-15,-28,-14,-34,-18,31,-19,-43,-21,-1,-30,-30,-8,-24,33,-23,-62,61,5,-5,21,26,30,-18,56,6,-42,33,9,-41,14,31,89,-50,1,83,82,77, 
  /* [235][0][][] */ -70,8,12,-40,-30,-41,-30,56,-67,53,86,55,52,-19,-7,74,16,12,7,-6,14,-55,-108,35,0,25,86,51,-72,35,91,77,-3,-51,-78,53,22,-20,-100,127,-71,7,-38,57,53,-42,-1,46,3,-1,-8,-6,-60,-17,64,-8, 
  /* [236][0][][] */ -32,13,-39,-14,-2,-19,2,-52,6,40,-38,9,-30,-7,44,-38,-58,-34,8,2,-12,-11,11,24,-51,65,-21,-39,24,44,11,16,-127,-21,90,-25,19,69,-8,39,39,38,-23,126,28,53,-40,46,-65,3,-57,-36,117,41,-12,-65, 
  /* [237][0][][] */ 15,-38,1,-49,49,15,-23,-48,5,-31,-79,46,-21,84,16,89,-11,-17,53,31,39,13,-70,20,-23,56,58,-60,-5,20,10,-41,-127,-25,-28,32,56,76,3,-28,-19,-120,-15,-84,38,10,-4,-8,-23,1,-17,22,-13,-25,32,14, 
  /* [238][0][][] */ 14,-22,47,-10,14,26,-24,-23,17,-29,15,-14,-19,33,-23,-35,2,-41,51,51,56,42,-10,-6,55,-88,-30,34,-41,-20,-6,32,-127,-31,-62,-14,5,-25,75,20,16,35,-26,-40,-44,-5,35,-10,5,-15,20,4,84,22,8,0, 
  /* [239][0][][] */ -1,-80,-91,-43,15,13,26,-57,-27,-52,-44,27,0,-121,90,-38,-62,-9,-24,-74,-5,88,-60,78,-68,-24,-104,-19,-41,1,-7,-82,-29,-45,-75,11,33,-20,4,127,-34,-94,27,-39,0,-5,-1,44,-3,14,-40,38,-8,-36,99,-79, 
  /* [240][0][][] */ -55,-43,-29,78,-32,17,10,-80,22,75,-55,6,-6,73,-11,-28,46,62,-114,-89,2,-53,-88,1,21,67,-47,-68,-127,-78,-4,56,-8,78,68,76,39,-33,46,26,-91,35,-18,-8,10,17,-21,47,61,-95,31,61,-60,13,40,-23, 
  /* [241][0][][] */ -11,-94,63,25,-8,-28,-107,-21,12,6,38,-59,56,-51,25,-21,-19,-5,23,-16,33,-21,50,-61,71,-42,19,38,16,-44,5,127,81,39,-72,-13,18,4,54,-109,22,-36,118,4,34,20,4,-57,46,9,31,59,-93,24,57,46, 
  /* [242][0][][] */ -24,68,-85,88,122,71,9,-52,3,55,21,0,-17,30,-44,-74,-15,-12,-20,53,-23,104,31,-81,-30,-57,77,108,83,17,127,30,-58,-20,126,-85,113,-114,-1,-22,4,-40,-46,120,-115,-36,65,-124,66,-3,-90,-92,29,116,-120,-47, 
  /* [243][0][][] */ -5,-7,30,0,-2,-72,4,-28,14,26,-36,-79,10,41,-57,19,32,-28,-14,-27,-77,11,57,57,-52,34,85,15,-78,33,-1,49,-63,-12,-45,-37,-27,16,-32,40,77,26,58,-5,-39,-6,-36,36,2,-127,-41,4,-1,-35,-77,-39, 
  /* [244][0][][] */ -7,5,39,-56,-24,96,-5,21,-9,-6,-116,48,-10,32,-13,-24,-28,10,-8,-85,-36,-89,-45,67,17,51,39,22,-12,127,81,55,-4,-58,-8,-3,-46,-119,23,-25,29,-91,-11,25,98,-41,-67,-55,109,-40,28,-23,-33,74,-71,-48, 
  /* [245][0][][] */ 36,-51,38,15,-31,-14,-22,-14,-5,40,66,24,-34,-85,-109,-46,-71,76,9,-43,-46,-37,-7,6,-46,67,41,81,-13,37,44,73,50,-52,-13,-22,6,31,62,-127,21,-48,-61,84,111,-8,-52,-7,-12,-62,22,59,-35,-21,97,-24, 
  /* [246][0][][] */ 63,-24,54,67,-16,75,29,-43,-1,62,24,-12,35,97,61,-45,-32,65,-12,-53,4,7,-8,18,60,-1,93,1,54,-96,65,86,-52,51,-127,62,69,23,93,27,-12,-40,120,39,12,-5,23,29,-15,-8,-45,-37,-71,-37,80,-35, 
  /* [247][0][][] */ 1,-57,70,-14,127,-75,34,14,37,-106,57,35,47,-9,-35,109,40,-42,-15,25,53,17,30,43,79,-6,-28,33,17,-15,-7,23,33,21,12,-14,80,13,-32,1,24,48,-22,18,-28,-20,71,-9,-23,-34,-34,70,43,36,-2,41, 
  /* [248][0][][] */ 9,4,-21,75,20,-31,19,3,23,41,-20,-63,-20,65,-11,-10,-41,-14,-35,20,68,-55,13,114,0,-2,29,-62,-14,-6,-13,-48,52,-75,-9,92,67,61,-127,26,-6,-16,63,47,45,2,57,28,27,23,-39,36,-3,-4,39,-101, 
  /* [249][0][][] */ 24,32,74,-94,66,-25,67,30,15,18,-98,12,48,6,127,-29,111,-1,-67,22,0,-23,6,-9,36,-80,75,39,-56,61,118,71,83,98,79,-112,74,-61,31,35,-91,-102,15,49,-8,-26,22,-43,-51,-70,-18,123,6,-14,-41,-37, 
  /* [250][0][][] */ -27,-27,-1,-8,-55,-31,26,-46,66,39,21,-9,-5,21,58,-50,11,-63,21,-36,-73,-23,-2,41,16,-21,-19,-39,-1,-8,13,-46,37,-8,-1,-59,-54,-64,-18,-46,-20,-35,64,-50,15,-19,50,-17,22,5,19,-43,-55,77,6,127, 
  /* [251][0][][] */ 2,-9,-45,-52,-3,-63,127,-12,25,51,-23,62,-46,-41,-40,-42,-21,-74,32,-19,45,16,-33,-29,-84,-45,23,52,22,16,31,45,-74,5,18,46,71,12,8,-29,-58,-4,-11,27,-20,-18,-30,-83,-45,33,45,-32,-36,-47,-9,31, 
  /* [252][0][][] */ -64,-60,9,-23,-24,20,31,-17,-38,-22,-5,-19,70,-15,27,-5,7,-5,73,100,2,22,83,-3,-127,-3,35,38,-13,-19,-22,2,-29,-22,-46,-15,32,-13,28,1,-2,53,-37,-19,-42,-47,-11,22,-43,0,-18,0,22,-64,41,-18, 
  /* [253][0][][] */ -83,-10,99,-5,6,33,11,-10,-5,44,24,37,-37,0,-39,-88,-33,26,-38,95,34,63,-27,-22,8,-47,-8,5,127,-5,44,-56,-96,31,58,2,21,22,-9,72,-10,-16,3,-41,3,-12,77,35,9,11,77,-65,26,7,-49,-10, 
  /* [254][0][][] */ -26,-22,-77,-71,-17,26,13,39,-10,-97,-24,55,28,3,127,50,-4,25,9,34,-76,23,110,9,-48,-21,-17,50,28,14,13,71,-3,-33,-7,-92,-20,99,30,-66,24,-1,99,3,17,-43,-90,-16,-96,-28,3,34,18,-101,22,-42, 
  /* [255][0][][] */ 57,26,29,82,-66,-29,7,-11,-96,82,-33,95,89,-30,-36,28,23,96,50,-71,30,-88,29,55,19,-21,28,48,-127,110,-58,8,44,1,-16,64,86,-48,-25,-19,-50,-68,54,-61,23,90,16,-20,-65,-10,27,-21,-58,45,-44,19, 
  /* [256][0][][] */ -61,-10,21,-18,-80,-119,-57,17,-14,-20,-56,14,-40,12,-40,-85,-74,75,1,34,44,6,-53,-60,6,-18,8,25,-41,-37,9,31,50,-127,21,-86,-4,-82,-31,-67,-72,-104,-22,-53,-30,-23,48,10,2,-62,23,-56,-41,-17,-36,37, 
  /* [257][0][][] */ 112,26,-36,-42,32,-16,5,-12,-30,-97,18,62,16,-49,47,9,15,-92,-30,2,17,11,-35,72,-43,-24,80,89,-57,-36,15,-11,11,38,15,-70,7,-24,0,-67,-38,-127,78,-15,-63,-82,102,18,-30,-47,60,88,13,-3,17,-101, 
  /* [258][0][][] */ 36,31,-8,-56,0,49,1,-1,-31,127,4,48,13,-1,22,-15,-5,49,28,-2,12,-8,56,-37,13,0,-4,81,80,38,39,47,13,7,-23,-31,3,-32,117,-26,106,5,58,-52,28,13,3,21,-8,53,6,18,5,-3,15,-15, 
  /* [259][0][][] */ 66,-21,29,-7,127,125,72,-3,-24,12,-53,-1,-35,11,7,63,-60,-32,-34,-45,66,23,10,-62,66,-78,6,-63,18,78,-24,83,-67,24,20,14,18,26,17,118,-48,-29,5,1,-110,-48,-35,-11,-42,62,26,0,-45,-21,30,-44, 
  /* [260][0][][] */ 59,-28,-9,33,69,46,3,-32,-62,36,-48,-23,-11,-52,51,-28,38,3,34,90,-13,-60,4,-34,34,-61,22,112,7,25,-37,11,-56,18,-27,-49,13,28,94,62,18,3,-14,30,63,6,35,43,5,-18,6,11,93,-92,-127,-40, 
  /* [261][0][][] */ 76,21,-12,-36,-33,-29,57,50,-44,81,-17,-38,-33,50,17,127,16,-58,22,17,47,50,42,-86,54,-27,-9,37,-12,127,-33,-71,-43,-106,-14,95,37,-47,-11,-25,-79,-17,17,-81,30,-43,89,95,-48,115,0,97,24,-15,35,-93, 
  /* [262][0][][] */ 14,-16,84,-10,22,-31,-117,-40,-75,-88,42,-58,-20,7,80,49,2,36,-8,-36,-33,-47,-66,76,-32,55,-7,-94,-9,-25,-5,-17,13,-127,13,-84,18,4,-89,30,-2,64,5,27,24,-17,-88,15,49,-56,-79,87,24,-27,-4,-53, 
  /* [263][0][][] */ -23,-26,127,-71,8,-32,-50,33,4,-48,-50,8,-27,-14,72,-36,74,12,-72,43,-21,39,-52,79,-70,-20,38,-46,35,-33,-107,-19,-86,2,-62,1,-7,3,11,88,-12,51,18,-6,-16,-10,9,90,-16,0,-37,-105,32,4,17,-83, 
  /* [264][0][][] */ 63,79,-33,-23,-73,57,92,44,15,82,-22,17,-92,52,-45,111,-54,42,24,-1,10,-14,34,63,-60,59,-38,-65,-24,-26,-65,-45,19,-67,37,123,-107,70,-100,102,-72,36,-43,34,58,25,-83,-12,-75,97,-26,29,-52,-6,127,31, 
  /* [265][0][][] */ 3,52,20,-25,64,72,13,15,-26,-10,-20,-34,-12,-31,73,64,66,21,12,-22,-45,101,59,9,8,-81,100,-60,-17,24,27,22,-29,0,-37,-48,-21,12,36,-4,22,3,40,-127,-81,-8,-67,9,-44,-63,-4,-13,21,-49,-47,31, 
  /* [266][0][][] */ 14,3,-10,-10,14,4,6,-100,57,61,-34,-25,17,-28,74,13,-30,-29,28,50,2,63,-52,62,7,-70,113,-38,62,63,-93,-33,-81,-36,60,-21,2,-14,-61,19,-7,-127,75,-21,80,18,-90,4,-18,54,19,-47,19,-40,-89,26, 
  /* [267][0][][] */ -107,-108,39,-12,26,35,76,31,28,25,-10,27,44,0,-17,-12,31,75,-61,-17,-33,-66,-61,58,30,43,46,-63,20,-57,-34,45,-74,-28,6,-5,11,-3,-7,-41,-7,13,-38,-33,-127,-54,-20,75,-23,56,66,-14,19,29,-3,-49, 
  /* [268][0][][] */ 111,86,-38,21,2,-40,-24,-64,-74,2,109,-40,5,44,-89,-66,-89,37,-101,-46,-16,-99,-127,-123,94,-31,93,-47,66,13,-99,-92,2,-6,6,-38,-54,-26,100,-9,-14,-61,-15,5,3,-8,-31,-70,65,28,-28,-57,23,44,-47,23, 
  /* [269][0][][] */ -33,39,-65,26,-13,-4,-30,95,-58,-21,-17,34,14,54,-75,-41,-44,44,8,-54,-36,-50,17,23,-18,-76,-30,31,-38,42,25,58,-28,79,-85,-77,-18,-50,12,-127,-7,2,5,64,54,-61,-89,-64,14,6,55,14,24,22,26,-53, 
  /* [270][0][][] */ 54,15,36,-17,-16,-8,-103,28,5,-17,-30,-39,79,63,56,20,9,77,44,-9,-72,31,-51,70,2,-68,-8,3,-21,-34,-1,35,-60,-70,63,66,-33,93,-9,-26,-15,-22,-127,-16,1,25,33,57,-19,-78,6,-98,11,33,17,1, 
  /* [271][0][][] */ -32,122,-26,77,107,90,-20,67,-7,-124,-31,-85,-111,-28,-58,48,-76,35,-27,17,72,-88,65,-85,-70,-12,-93,-19,33,61,-8,-88,76,-79,-32,-107,56,-29,-38,36,-108,-44,-45,56,102,19,63,20,-127,-42,-67,-80,-27,9,-1,-61, 
  /* [272][0][][] */ -8,-86,3,107,11,3,9,26,-16,21,29,-16,13,116,-14,46,-31,66,-45,42,-19,-88,20,66,-3,50,-22,-54,-3,-75,43,-5,-69,-98,-24,54,64,27,127,56,-12,-79,-81,-56,93,-47,54,16,-34,-52,-6,-45,4,-27,-16,-53, 
  /* [273][0][][] */ 27,-21,48,-43,-21,14,33,-12,46,-21,-19,18,87,40,-53,31,-17,21,-11,10,-78,-5,-4,38,-16,-18,-44,-54,1,-53,-15,-15,-127,20,-1,-10,-41,28,71,-8,-61,86,-84,17,2,4,-31,-43,-32,7,-87,-45,97,-57,11,-97, 
  /* [274][0][][] */ 65,-35,-15,-9,3,-30,68,-3,-58,52,-63,4,-7,-1,-42,-59,-2,-32,-10,7,34,-6,2,-35,78,18,-96,6,36,-3,44,-4,1,-37,49,-88,-2,-41,-68,127,15,54,-52,7,-40,-74,-65,55,-50,26,1,-2,3,15,-35,38, 
  /* [275][0][][] */ 11,10,64,16,-18,-126,-86,0,12,28,-31,-43,45,-87,12,-87,-66,8,12,-92,2,-79,-114,79,-15,4,2,-25,-42,-85,127,14,-27,-10,66,-15,50,-82,-55,-96,17,-26,30,62,-12,-58,54,-16,-13,97,74,-54,11,-52,69,63, 
  /* [276][0][][] */ 10,-73,2,-22,-5,-24,97,-33,-24,-84,50,92,-22,34,93,-13,21,-86,67,25,-110,12,-70,-75,112,-9,11,-6,81,87,29,92,47,-17,88,3,72,-5,-26,-42,127,-59,-2,-3,29,92,3,99,11,-8,-65,26,57,38,15,-15, 
  /* [277][0][][] */ 21,16,-48,17,-4,-4,40,-18,38,127,72,4,-30,67,8,39,-18,22,32,37,-11,-17,-31,31,-54,29,-6,32,38,-3,-66,8,-8,73,17,16,7,18,-18,23,71,14,9,5,26,-7,7,-43,10,44,28,-57,29,39,21,-17, 
  /* [278][0][][] */ -16,54,-43,22,64,57,-11,23,-119,2,4,64,94,-20,31,-22,112,57,7,19,25,23,-38,25,22,-85,107,-26,61,1,32,-81,67,-15,-33,9,46,35,37,-127,68,52,87,-87,101,65,-58,23,63,31,10,-38,-84,-76,-111,31, 
  /* [279][0][][] */ -3,7,-14,34,74,-37,51,-53,-55,-46,-67,71,0,17,73,50,-98,68,-46,-41,-75,-43,-30,127,46,91,-82,-3,70,-35,24,66,-96,18,25,-24,49,3,88,-109,14,63,-4,-94,-62,5,-54,-31,23,-62,-21,67,-72,-30,-65,53, 
  /* [280][0][][] */ -20,19,-127,-5,-34,44,-12,2,-1,-46,97,14,-16,56,78,-61,20,-6,31,24,62,-30,84,40,-3,-76,-63,-58,-31,-52,22,7,0,23,-14,-47,-72,-85,58,42,-19,-58,75,-55,-53,-74,2,14,20,47,19,-40,37,-70,26,45, 
  /* [281][0][][] */ 67,18,78,38,16,17,55,-17,-70,-53,32,-1,33,-22,30,-15,4,8,-7,45,-111,26,112,-10,14,-14,0,-57,53,-30,0,-27,-27,-45,54,-25,63,-43,127,22,68,25,-21,-105,46,-15,-72,86,17,18,47,-65,22,-36,-52,13, 
  /* [282][0][][] */ 19,-95,70,49,-17,37,2,-94,63,-33,-20,-2,-81,-72,31,42,-94,-67,116,56,83,127,-17,-68,-45,40,106,-4,44,76,4,-93,-88,-108,110,-94,-28,-34,38,54,63,22,-72,-32,-94,40,-25,-37,-27,38,-17,-98,48,99,11,-3, 
  /* [283][0][][] */ 43,-4,0,32,-1,-47,-7,13,72,6,-32,33,16,29,3,-44,-78,-29,-36,5,-127,91,-63,10,37,-7,20,50,16,24,23,-17,-30,-79,14,3,5,-18,-8,38,33,18,-9,45,-3,-12,47,2,-85,5,63,14,-7,-18,-50,-51, 
  /* [284][0][][] */ 53,25,7,22,38,0,-4,7,-85,-10,-27,-24,-37,-7,19,4,93,29,-48,10,81,-31,-80,12,73,-127,0,18,57,-71,-8,-11,21,43,-49,-9,20,50,21,122,-4,5,-73,21,-44,4,26,-3,-20,26,109,0,38,4,77,20, 
  /* [285][0][][] */ 22,60,-28,19,-72,-127,70,86,5,48,-12,-63,54,-55,10,17,10,-59,-41,-24,21,-61,-13,23,-12,-41,76,-14,5,38,60,1,-25,-39,65,-29,-43,-58,-66,-5,-45,-24,3,-41,-44,-6,61,69,56,-40,-2,37,-9,52,13,-25, 
  /* [286][0][][] */ 51,62,13,-37,38,-13,-4,29,-80,-13,-21,-18,10,13,7,10,14,83,15,39,0,-7,56,21,-19,18,104,74,-2,-75,13,34,83,67,-56,-99,-39,16,110,-44,21,13,127,5,81,-3,-23,37,-25,-19,-18,-39,23,31,-34,-81, 
  /* [287][0][][] */ 61,49,-23,20,-7,9,82,-84,-3,38,-21,68,-36,-44,28,-40,-16,-30,-78,-27,-34,2,-23,53,30,-127,-24,23,-76,41,5,-20,-7,3,-6,52,62,-93,46,67,-22,48,80,-29,26,13,62,-4,27,-11,53,-54,-33,-30,29,13, 
  /* [288][0][][] */ 0,-16,40,-96,-48,-43,0,-11,-9,-72,6,66,121,-25,14,-24,-15,-6,-25,112,-7,35,-28,-21,32,-31,-69,103,-36,-8,48,69,21,10,13,-85,-36,8,-51,-127,39,-8,66,-89,50,22,26,76,67,-17,24,-6,-22,-5,3,0, 
  /* [289][0][][] */ 14,-52,5,75,-26,47,43,-21,22,12,-8,-27,-27,19,-51,16,41,23,-18,-21,-9,-48,-103,9,-10,40,-5,3,41,-8,-22,-24,-70,-24,-30,59,-31,45,73,89,15,29,-20,-16,-17,-11,23,51,-99,20,23,-10,68,-1,-14,-127, 
  /* [290][0][][] */ 84,78,127,-62,78,-54,-7,-72,-60,10,49,37,-45,-94,1,15,-6,-88,5,6,5,107,35,31,46,63,-10,19,-78,7,-36,-36,-1,73,-53,0,-20,-24,25,46,82,-40,94,-9,34,48,29,-73,81,17,75,3,-53,52,-28,26, 
  /* [291][0][][] */ 11,22,15,9,-9,-42,48,-51,40,-4,-72,-47,49,15,46,12,28,-38,47,35,36,-60,4,3,51,-40,5,3,-3,45,-41,-51,-41,15,5,19,-47,50,75,110,-28,92,-127,18,13,29,-23,-12,-21,-69,77,9,108,-50,-16,96, 
  /* [292][0][][] */ -74,119,-80,-15,6,30,23,127,27,-21,-10,-100,9,-2,38,-31,5,-6,2,-30,67,-17,-13,11,91,-58,40,-11,79,-90,-54,85,-18,-33,-34,82,-12,32,20,-14,-72,29,57,11,-10,68,-6,74,6,14,-49,-34,-10,36,-2,24, 
  /* [293][0][][] */ -23,-74,-110,11,65,-104,-6,16,20,16,-118,35,99,42,-32,-21,-90,106,114,-18,-127,89,10,-47,46,-18,-51,67,-8,30,16,-50,-9,27,6,-46,-3,0,32,-12,-48,16,49,-57,7,24,51,34,-58,21,73,-34,-113,4,70,1, 
  /* [294][0][][] */ 25,-9,-28,-44,127,18,-20,87,-80,68,76,-31,80,40,32,1,57,-25,-18,-11,71,-30,52,-62,-28,64,-18,-42,-4,-45,59,-36,51,-5,-11,-6,21,15,73,-31,32,48,41,-70,105,24,0,71,-21,-13,75,-55,-31,-68,-64,59, 
  /* [295][0][][] */ 37,127,67,45,54,47,-31,-98,-39,39,-9,55,45,-58,-37,11,-15,-75,-33,17,-14,65,-61,48,-17,-17,42,11,-16,-10,-107,2,125,-27,56,-38,50,-37,8,-7,-30,-57,-6,-74,17,59,7,-70,55,12,-9,30,12,30,16,-34, 
  /* [296][0][][] */ 13,4,-26,-24,11,-3,-50,44,-4,13,-41,-50,-16,3,1,31,7,13,-52,-46,11,6,-52,127,-14,-17,-15,-2,49,-71,-48,-30,-49,-9,40,49,32,22,-55,34,-71,-69,-23,1,-61,-3,37,-30,-4,14,8,-37,0,61,-6,31, 
  /* [297][0][][] */ -10,-36,56,32,-3,-13,20,-3,65,-98,36,118,-8,-52,-22,-109,-41,-27,-46,-32,-87,-43,82,8,62,123,-64,-19,-35,-19,-118,-89,19,30,-83,78,91,93,-84,-1,-10,-127,-4,-26,-71,51,-9,-101,-4,-36,66,102,35,7,54,-93, 
  /* [298][0][][] */ -102,-1,-32,-33,51,2,-37,-98,-111,-116,-54,-53,53,-94,34,60,-29,93,-124,67,-48,-37,127,91,-44,38,26,-46,-99,66,16,-50,-50,-69,-9,-4,-20,5,-33,-36,-42,-95,49,77,7,7,-14,-13,-58,-64,-53,-1,9,-44,-25,-9, 
  /* [299][0][][] */ 46,-32,9,30,92,-17,72,-53,-36,-7,-124,-2,-27,-63,-127,16,-15,-79,36,-9,-53,-29,122,-25,64,108,-73,9,-3,-87,27,84,40,14,-82,-78,20,23,-20,16,-9,-54,64,51,-51,-34,5,-9,-63,-13,-13,-46,31,109,-28,-51, 
  /* [300][0][][] */ -1,-31,-6,10,-64,-40,69,29,-18,11,60,-61,-26,81,2,-14,49,45,-83,83,-23,-37,-36,14,-76,40,-43,-71,19,-120,98,36,-99,55,3,23,-54,-52,-45,15,-6,4,127,-39,-35,-91,104,-41,-54,-47,118,44,-93,-15,10,-74, 
  /* [301][0][][] */ 11,25,-127,-68,-1,15,58,31,27,-9,58,-108,-94,76,5,-75,-65,105,-39,-10,3,38,-41,12,7,65,-34,46,-107,-22,6,-4,-20,22,-70,31,-83,57,-76,35,-15,-78,-28,3,16,0,-9,-10,-63,-29,23,28,-3,-69,99,21, 
  /* [302][0][][] */ -48,71,81,106,56,-23,-48,4,-69,14,-38,-3,-16,-58,-110,47,9,-3,61,-41,39,-127,25,100,-20,18,-22,-14,0,-44,-66,-80,-78,-59,39,51,27,35,-86,27,-42,18,-42,5,41,-15,-26,-30,-5,20,41,-49,-38,3,19,-62, 
  /* [303][0][][] */ -75,31,32,38,42,46,62,57,-29,-68,-20,75,84,-21,46,-51,36,-11,-127,16,-55,-52,20,-89,97,64,83,85,55,-83,3,-8,76,47,100,62,8,68,77,30,9,45,35,2,25,0,-31,2,-48,89,40,18,-22,40,-38,-52, 
  /* [304][0][][] */ 49,-26,30,64,-8,-1,25,16,42,13,-91,-106,83,-66,-1,-127,-57,-57,-37,-17,-90,6,7,9,104,37,86,20,-13,21,-36,-37,45,-112,71,-48,-35,0,-26,66,-28,102,-68,-28,-53,-74,25,-29,18,-24,50,64,32,108,-82,18, 
  /* [305][0][][] */ 70,-6,-127,19,-65,-39,-53,-46,-113,-66,-70,79,-23,-59,17,-32,60,-30,28,-39,-31,29,20,36,13,-49,50,77,10,-33,-40,20,89,-12,-83,100,45,-55,23,-38,59,-42,-17,-57,0,33,123,56,-14,24,0,-70,-106,90,-85,26, 
  /* [306][0][][] */ 6,-54,21,-17,8,-85,4,5,-6,4,-32,47,49,39,-15,21,-35,-23,-51,1,54,-30,-25,82,-29,-65,-16,-120,36,-94,21,30,127,-3,32,71,-29,-8,54,-20,30,23,25,-9,0,-96,2,-21,6,5,1,-72,-81,-34,104,-39, 
  /* [307][0][][] */ -22,-82,-75,-127,12,81,-61,22,72,-30,103,-40,68,-45,32,-24,8,40,-30,-3,-6,-74,65,76,34,23,10,56,81,8,71,7,-13,40,0,20,9,-15,-84,26,50,-58,-23,28,33,-70,12,-66,1,0,-78,45,2,3,4,20, 
  /* [308][0][][] */ -9,14,69,-11,-81,17,2,-105,-4,30,2,-25,20,-98,39,38,-33,25,-58,-58,-9,16,2,-40,28,-17,-12,77,7,-57,-8,-43,-3,-31,53,-18,7,-10,-23,55,11,40,-53,6,-72,-26,-9,-24,-3,-53,-32,86,-23,-17,127,-25, 
  /* [309][0][][] */ -2,14,-61,-6,35,-53,23,97,53,-25,20,43,-21,102,-45,-33,-4,26,83,-104,90,1,57,-31,-17,-34,-16,-49,46,-127,4,5,-3,2,65,-61,-66,-12,15,15,-15,28,-13,-6,2,61,17,-40,81,33,13,-31,8,7,2,-62, 
  /* [310][0][][] */ 29,-127,18,-68,-83,-46,15,-41,10,43,20,22,46,-39,-19,23,51,-7,9,46,37,-24,58,-51,21,-21,19,23,-10,-54,22,18,20,-73,-70,14,-125,61,64,17,-20,-13,-42,16,-42,37,9,39,26,-49,48,22,68,-38,-15,44, 
  /* [311][0][][] */ 41,-54,125,120,11,41,59,-71,13,-36,12,91,-72,41,-52,-13,-111,58,35,-16,-79,83,-69,-12,45,-45,-30,46,30,-17,-76,35,5,63,21,13,-14,-25,-127,-5,-15,-100,53,-6,-4,16,-5,32,-40,-61,8,68,76,-7,0,26, 
  /* [312][0][][] */ 1,-75,-19,6,-2,-69,-40,-40,-62,58,101,10,-82,12,-22,-39,-32,119,-25,12,7,-17,-3,-66,-25,60,-2,-4,-33,55,86,9,-102,-78,9,-20,20,83,-29,23,-17,-120,-127,89,26,-68,-116,-20,6,10,-57,-27,3,-28,13,-4, 
  /* [313][0][][] */ -10,44,53,10,-39,33,-48,-49,58,-59,-29,48,-3,-16,61,69,-76,18,-13,0,90,88,18,-13,62,-28,-81,-36,-40,10,-28,-85,34,83,-1,25,61,-19,-17,-30,-127,-25,50,72,10,30,20,2,36,51,-30,-21,-46,80,-50,-23, 
  /* [314][0][][] */ -37,31,6,-7,-48,-33,-26,24,51,27,-3,-107,74,-49,25,-71,-12,-58,-10,-7,-28,-12,53,28,51,8,9,31,4,-12,-78,-22,36,6,-27,25,127,-74,14,-38,-28,-13,1,-24,34,58,78,-12,82,-17,-10,21,-97,26,-76,15, 
  /* [315][0][][] */ 79,-26,17,-23,49,48,104,13,-18,-33,42,-24,-6,55,-18,-30,44,45,-18,52,31,-34,22,8,60,-41,-20,7,48,-43,40,-66,-28,-66,-29,-18,-34,4,68,66,-1,73,16,-49,39,2,29,-1,-127,58,70,5,21,-45,32,-11, 
  /* [316][0][][] */ -61,-21,18,-22,-31,-16,-12,21,-51,91,-68,22,38,-56,-59,38,12,-28,-64,-61,-98,-127,-32,-22,-45,13,78,-9,-9,39,-16,-7,-97,-70,-44,60,-37,16,2,43,61,-22,-24,13,21,51,-28,-14,-91,8,63,11,-1,-36,-21,-69, 
  /* [317][0][][] */ -48,-65,60,29,2,43,-22,8,15,-21,-19,45,-78,88,-1,-46,-23,-34,-71,-75,52,26,16,8,-64,39,17,20,-66,107,-127,-26,37,-26,-25,-65,2,-19,-19,12,35,1,-32,26,103,-24,31,-28,40,-50,50,26,-14,34,-33,-39, 
  /* [318][0][][] */ -11,73,5,19,-73,27,62,30,67,-94,89,-44,45,-65,17,-38,124,15,91,22,-76,-50,-73,-114,-56,-103,100,66,-37,-116,-19,-127,34,97,45,45,40,-26,66,20,-32,10,-34,-103,-35,72,49,-100,-37,8,1,59,-19,-120,47,4, 
  /* [319][0][][] */ -81,24,-46,-90,71,-92,-103,36,66,-65,32,20,-56,49,-70,12,20,23,28,-101,51,85,82,7,-31,13,-11,93,-127,-45,-53,-90,59,26,-66,-55,68,-9,-49,-83,72,-36,5,60,-15,-71,-68,-27,82,-46,-111,114,-107,-4,44,-28, 
  /* [320][0][][] */ 33,-17,13,10,-77,32,-50,43,-27,34,71,-2,-4,-17,-13,35,-69,-8,28,5,72,-101,122,-3,10,89,-21,-52,14,-57,-35,-31,-5,-127,2,-16,-52,-31,-19,32,19,77,-36,-9,0,-27,-24,4,-32,4,-55,-18,35,40,-4,-25, 
  /* [321][0][][] */ 21,54,-15,-19,31,34,36,14,52,8,-31,-16,-12,-13,-18,125,48,-53,17,24,-99,72,-67,-75,106,-12,46,-45,9,2,24,-62,71,35,44,-55,104,-63,127,2,18,19,49,71,113,-59,4,-17,-9,-31,34,65,-76,13,-12,-51, 
  /* [322][0][][] */ -63,-33,50,127,117,34,19,-27,-34,-55,76,2,-4,26,-25,-103,-3,-68,33,17,65,12,56,28,67,-62,29,-88,64,-114,8,-72,-1,73,-28,-15,49,15,-45,-8,-16,-61,65,-100,-116,-16,14,16,-14,88,17,-50,-32,53,32,-64, 
  /* [323][0][][] */ 17,-3,-36,-100,-75,-14,54,-3,-36,-58,-18,57,-3,6,59,127,-29,82,17,44,-117,-63,79,13,-19,58,-3,-86,-53,-25,-13,33,-26,-64,47,-52,67,13,99,-30,43,69,44,-47,16,-3,30,-18,4,34,-89,27,-25,-73,11,37, 
  /* [324][0][][] */ -73,-27,79,-13,-22,-35,6,-56,-127,96,-71,48,-39,12,-11,77,29,63,-12,-72,-65,27,17,-13,0,-30,-29,-11,-99,24,-11,-47,-9,1,-45,-39,72,-26,-1,27,-60,0,51,33,45,13,-3,-22,-9,21,-10,31,8,-43,-22,8, 
  /* [325][0][][] */ -21,-127,-63,-51,-82,-1,21,-14,41,11,-31,-36,-55,-12,-114,-31,-75,47,-10,61,-35,19,35,-16,-11,4,-84,21,-11,44,-23,33,7,109,37,-79,51,-28,16,-109,-38,43,-51,-2,-6,-106,-23,36,-46,-70,54,-20,-71,-23,-66,47, 
  /* [326][0][][] */ 19,7,9,-2,23,45,-62,-35,-89,6,-40,90,-35,-127,-1,-44,-24,23,-41,44,-67,-39,-49,56,59,31,-63,47,-35,10,-26,-80,-19,24,-19,-106,78,-53,33,-4,-28,-15,38,66,-34,-31,-31,-64,24,20,-46,29,-30,14,-84,49, 
  /* [327][0][][] */ 2,-46,45,30,-6,-8,20,20,-5,-39,24,68,6,-12,-16,-26,-39,14,65,55,26,0,17,8,29,-48,-75,-31,-16,-8,39,71,-42,21,-48,14,66,4,41,79,2,7,-5,22,6,-15,-6,77,-23,36,32,63,127,64,-64,1, 
  /* [328][0][][] */ -50,-37,29,-24,-10,3,-31,-20,-35,57,-4,30,6,-13,5,-53,-11,47,33,-7,33,-30,12,22,54,-2,3,12,-1,42,-1,-27,16,5,-41,9,-3,11,3,5,4,21,-5,-9,23,33,-22,6,-37,70,-26,-29,51,-42,-15,127, 
  /* [329][0][][] */ 107,73,-3,-113,-79,-8,42,-22,35,68,-24,-36,-22,119,19,95,6,-79,-36,43,26,54,3,-100,29,86,58,-12,-65,28,-39,-63,60,47,-57,69,7,-44,66,-79,57,-67,-66,61,-14,-28,12,-65,-23,-93,-71,-62,-10,-127,-38,-37, 
  /* [330][0][][] */ -26,36,24,15,-38,55,-76,78,-47,127,17,-70,-57,-92,-83,51,45,-8,78,-43,82,9,-42,95,-90,34,-17,-85,-28,23,99,-60,-65,-44,-64,96,-45,6,32,16,34,7,2,19,71,69,114,44,31,-4,-112,-121,51,-13,74,-87, 
  /* [331][0][][] */ 49,-9,46,-25,17,-78,-24,6,52,-44,-109,81,40,29,77,-31,-57,31,17,39,-28,-3,-6,-46,-14,57,-33,36,-27,-43,-36,-59,-52,-53,14,68,5,-118,-43,1,-87,57,97,0,-97,-127,47,-24,26,-25,35,-8,-26,28,37,-85, 
  /* [332][0][][] */ -35,-29,-6,17,-93,64,57,14,-16,-29,61,-94,-53,17,-15,34,13,-81,-39,35,80,88,56,43,8,-33,-22,-14,-43,-40,-32,38,-55,47,127,110,-92,18,-68,-20,16,1,4,29,77,11,10,16,-34,10,10,47,-11,-35,-24,-50, 
  /* [333][0][][] */ -32,46,44,54,-11,-47,40,37,6,-12,-70,-3,-36,22,13,-68,29,21,-23,13,34,21,11,24,32,-26,-14,-11,-9,-24,16,-26,29,75,-33,-68,16,-42,70,91,7,-49,22,-47,29,18,57,-39,66,72,116,-55,-27,-2,-23,127, 
  /* [334][0][][] */ 14,-28,-12,-13,-93,26,26,-79,20,7,39,12,-27,-25,11,59,-48,-42,37,-75,79,38,47,21,5,50,92,-9,-65,79,-22,-31,-65,-70,-13,47,-7,54,-28,31,-10,23,14,9,-29,-83,127,-4,17,-65,0,32,18,-106,-52,45, 
  /* [335][0][][] */ -32,-127,20,25,-55,-35,-15,-6,-40,-36,16,-39,-8,-27,86,14,11,-67,0,-13,-24,-16,-49,58,35,-6,-12,71,8,-32,-33,60,-26,52,-3,26,-16,9,0,-33,-79,-2,-5,21,-21,-51,27,42,-49,-30,-21,48,14,24,44,57, 
};
const TfArray<4, int> tensor_dimension73 = { 4, { 336,1,1,56 } };
const TfArray<336, float> quant73_scale = { 336, { 0.0016002958873286843, 0.0015688095008954406, 0.0010175147326663136, 0.001640510163269937, 0.0018426816677674651, 0.001596739050000906, 0.001574515481479466, 0.0015871046343818307, 0.0015048565110191703, 0.0013859821483492851, 0.0015492482343688607, 0.001969433156773448, 0.0011387915583327413, 0.0014758503530174494, 0.0016658758977428079, 0.0015080777229741216, 0.0015170517144724727, 0.0015592643758282065, 0.0013130336301401258, 0.0022771016228944063, 0.0015485223848372698, 0.0012416117824614048, 0.0014275555731728673, 0.0017636638367548585, 0.001344278221949935, 0.0017525062430649996, 0.0012736974749714136, 0.0014200488803908229, 0.0013359702425077558, 0.0016104265814647079, 0.0018158224411308765, 0.0011682581389322877, 0.001651712809689343, 0.0014089904725551605, 0.0022516003809869289, 0.0012342117261141539, 0.0013583895051851869, 0.0016798503929749131, 0.0013750941725447774, 0.0013933097943663597, 0.0017654007533565164, 0.0016828547231853008, 0.0012759589590132236, 0.0011489070020616055, 0.00155562290456146, 0.0012816217495128512, 0.0012862024595960975, 0.0012317763175815344, 0.0022229547612369061, 0.0013828788651153445, 0.0016518996562808752, 0.0016879281029105186, 0.0016125418478623033, 0.0014281622134149075, 0.0017351092537865043, 0.0012396329548209906, 0.0011514631332829595, 0.0021207281388342381, 0.001008071587421, 0.00090373161947354674, 0.0012277764035388827, 0.0015054796822369099, 0.0014319969341158867, 0.0012659358326345682, 0.0012319975066930056, 0.001632374944165349, 0.0013154807966202497, 0.0016206498257815838, 0.0015219860943034291, 0.00126371078658849, 0.0016343418974429369, 0.00095405377214774489, 0.0014761562924832106, 0.0014155441895127296, 0.0017133415676653385, 0.0012876166729256511, 0.0011394176399335265, 0.0018415801459923387, 0.0021000748965889215, 0.0012506310595199466, 0.0015494292601943016, 0.0012766848085448146, 0.0012393705546855927, 0.0011159935966134071, 0.0013383086770772934, 0.0016757065895944834, 0.0011033511254936457, 0.0013849659590050578, 0.0015716982306912541, 0.0021005007438361645, 0.001673785038292408, 0.0012899719877168536, 0.0014821892837062478, 0.0011136342072859406, 0.0016257204115390778, 0.0020074739586561918, 0.0014415135374292731, 0.0015702028758823872, 0.0019058374455198646, 0.0014510425971820951, 0.0011733270948752761, 0.0012103839544579387, 0.0011893766932189465, 0.00085956597467884421, 0.0013052623253315687, 0.0016477308236062527, 0.0010725040920078754, 0.0015893032541498542, 0.0018051626393571496, 0.0013986016856506467, 0.0011393814347684383, 0.001266305916942656, 0.0014491787878796458, 0.0011088200844824314, 0.0013625479768961668, 0.001095655607059598, 0.0015606050146743655, 0.0018593653803691268, 0.0011667046928778291, 0.0012959274463355541, 0.001704517169855535, 0.0017711608670651913, 0.0012094242265447974, 0.0014397496124729514, 0.00134734355378896, 0.0017911636969074607, 0.0014384393580257893, 0.0014972933568060398, 0.0011927633313462138, 0.0016397888539358974, 0.0011717649176716805, 0.0017179985297843814, 0.0015101855387911201, 0.0019827682990580797, 0.0011091991327702999, 0.0014238080475479364, 0.0014272246044129133, 0.001778705045580864, 0.0015950936358422041, 0.0017111720517277718, 0.0015746888238936663, 0.00098122970666736364, 0.0011858292855322361, 0.0015018883859738708, 0.001505753374658525, 0.0019181697862222791, 0.0017917401855811477, 0.0012921174056828022, 0.0018509406363591552, 0.0013566188281401992, 0.0016652138438075781, 0.0014559450792148709, 0.0014138710685074329, 0.0012202841462567449, 0.0011069508036598563, 0.001626100274734199, 0.0017838195199146867, 0.0011031345929950476, 0.0013358022551983595, 0.0014601168222725391, 0.0021291240118443966, 0.0014157935511320829, 0.0021146556828171015, 0.0012994863791391253, 0.0013452403945848346, 0.0013263062573969364, 0.0012910631485283375, 0.0020118581596761942, 0.002185778459534049, 0.0017064978601410985, 0.001082145026884973, 0.0012910256627947092, 0.001694669364951551, 0.0011586277978494763, 0.001402179361321032, 0.001290550222620368, 0.0022602691315114498, 0.0017634511459618807, 0.0015086181228980422, 0.0013258799444884062, 0.0016361508751288056, 0.0014556902460753918, 0.0015167403034865856, 0.00224902736954391, 0.0013741482980549335, 0.0015831381315365434, 0.0015167719684541225, 0.0014605646720156074, 0.0019560025539249182, 0.0012447854969650507, 0.0014787173131480813, 0.0017889882437884808, 0.0017435759073123336, 0.0014267426449805498, 0.0012505867052823305, 0.0011465931311249733, 0.0014260830357670784, 0.0016688555479049683, 0.0012940758606418967, 0.0012320218374952674, 0.0015831467462703586, 0.0013475387822836637, 0.0015929522924125195, 0.0020047752186655998, 0.0014125078450888395, 0.0015108088264241815, 0.0013551804004237056, 0.0013003837084397674, 0.001396770472638309, 0.0013714733067899942, 0.0014091805787757039, 0.0014909367309883237, 0.0013684411533176899, 0.001079968293197453, 0.0013236853992566466, 0.0011281792540103197, 0.0012398010585457087, 0.00126738625112921, 0.0011008619330823421, 0.0015451491344720125, 0.0016317120753228664, 0.0013713502557948232, 0.0022029995452612638, 0.0013637191150337458, 0.0016723042353987694, 0.0017546900780871511, 0.0016474619042128325, 0.0015021777944639325, 0.0017110146582126617, 0.0013444812502712011, 0.0012203645892441273, 0.0018919738940894604, 0.0014931667828932405, 0.0015422386350110173, 0.001879796152934432, 0.0017734019784256816, 0.0012416171375662088, 0.0019440802279859781, 0.0018378989771008492, 0.0011993392836302519, 0.0013864237116649747, 0.0014666214119642973, 0.0010665674926713109, 0.0017946613952517509, 0.0014937166124582291, 0.0014684891793876886, 0.0015175888547673821, 0.0016251950291916728, 0.0015787268057465553, 0.0012208649422973394, 0.0019323070300742984, 0.0025620320811867714, 0.0018066784832626581, 0.0017437149072065949, 0.0014742352068424225, 0.0011941938428208232, 0.0013775191036984324, 0.001044427277520299, 0.0018089645309373736, 0.0017096197698265314, 0.0019240116234868765, 0.0014034899650141597, 0.001349101890809834, 0.001512645510956645, 0.0010438165627419949, 0.0017456281930208206, 0.001357264700345695, 0.0017280211905017495, 0.0012993817217648029, 0.0016539250500500202, 0.0014506460865959525, 0.0013815065613016486, 0.001477991696447134, 0.0012936758575960994, 0.0018879281124100089, 0.0012327891308814287, 0.0013550624717026949, 0.0022763039451092482, 0.00097265094518661499, 0.0015140485484153032, 0.001444830559194088, 0.0013477259781211615, 0.00096099695656448603, 0.0017897121142596006, 0.0011672551045194268, 0.001850527711212635, 0.0014351969584822655, 0.0017530997283756733, 0.0016313352389261127, 0.0017886586720123887, 0.0015542086912319064, 0.0010974793694913387, 0.0014827605336904526, 0.0014988835901021957, 0.0011670587118715048, 0.0013370541855692863, 0.0018926667980849743, 0.0011368143605068326, 0.0011760829947888851, 0.0013488573022186756, 0.0014410255244001746, 0.001506198663264513, 0.0015596749726682901, 0.0011695771245285869, 0.0014684831257909536, 0.0012397763784974813, 0.0018722693203017116, 0.0016928330296650529, 0.0017476883949711919, 0.0015319782542064786, 0.0017891937168315053, 0.0012252408778294921, 0.0013253539800643921, 0.0015985820209607482, 0.0016551018925383687, 0.0014146104222163558, 0.0019502532668411732, 0.0017588594928383827, 0.00097510544583201408, 0.0012872648658230901, 0.0014456413919106126, 0.0013612060574814677, 0.0013951708097010851, 0.0017861524829640985, 0.0016041691415011883, 0.0016928522381931543, 0.0012032417580485344, 0.0017454074695706367, 0.0019773447420448065, 0.0014887596480548382, 0.0010454119183123112, 0.0013238927349448204, 0.0013728669146075845, 0.0013595230411738157, 0.0016957428306341171, 0.0018660002388060093, } };
const TfArray<336, int> quant73_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant73 = { (TfLiteFloatArray*)&quant73_scale, (TfLiteIntArray*)&quant73_zero, 0 };
const ALIGN(8) int8_t tensor_data74[56*1*1*336] = { 
  /* [0][0][][] */ 81,26,-37,-58,-72,12,-95,-16,110,111,-47,-87,50,24,21,38,-42,-13,55,-70,53,46,-108,78,49,30,23,3,-31,-18,66,59,24,40,27,22,30,33,48,34,-42,34,-6,15,6,-22,-21,49,-45,-57,46,-29,-2,-1,-8,-12,-100,38,-69,-50,-51,34,-74,84,-78,26,-18,-88,-49,-1,-4,-78,-30,63,-19,17,72,15,20,23,28,-28,62,-108,-5,35,15,8,9,28,61,26,21,-19,-41,-36,1,58,62,-3,-27,-82,-4,61,18,-32,75,-29,-95,0,63,49,42,11,12,-6,-18,54,-12,-4,58,-24,56,-33,-6,-5,65,-13,-25,62,65,9,14,-37,14,23,-23,-23,-3,18,1,100,-17,-23,-9,19,120,41,-17,-5,-35,61,-68,62,6,-25,32,8,-81,-7,41,-30,-127,22,58,-23,-21,-6,4,10,19,-22,-26,-19,7,-11,20,-11,-14,56,85,-46,-81,28,16,-79,17,-59,-19,-40,14,12,53,-26,-45,6,-47,-12,-18,26,-51,-11,-23,67,13,-53,-39,12,36,72,8,2,-45,-28,10,61,13,9,52,16,-71,14,1,64,19,-40,48,-44,-23,53,10,-63,5,13,70,-1,-50,36,-50,6,-12,33,48,51,-51,116,45,6,12,-121,7,95,13,81,10,-29,-47,-67,53,3,60,13,-36,-7,-89,41,15,6,9,14,-16,-20,-25,-32,37,33,76,49,40,-22,-75,-10,-91,66,51,-17,-37,75,117,26,5,-69,19,-53,-62,-28,-59,-44,24,4,51,31,-44,-34,-21,103,-18,94,36,8,48,77,40,37,7,9,-76,-126,-13,-13,-17,-35,-59,21,-66,61,36,-49,-30,-43,62,-39,-23,-83,-42,-9, 
  /* [1][0][][] */ 5,56,63,0,52,56,3,69,14,-44,24,-19,-6,-22,52,52,-36,8,-6,30,14,28,115,-27,79,52,-15,19,-54,69,2,24,32,-58,10,27,-31,22,24,2,10,21,20,23,-6,-60,-41,30,-78,-58,28,17,-11,13,108,-30,97,0,-110,-9,6,-44,29,-51,85,-38,46,-9,-30,114,-46,31,-92,20,27,-5,2,53,16,-53,58,-8,52,17,-53,97,7,92,13,25,90,7,-43,-5,20,49,-22,1,50,47,-38,34,-48,8,96,16,-50,43,39,50,-6,-18,-32,62,76,17,29,82,44,-36,-3,48,8,-48,-25,5,-45,57,-16,10,-56,27,87,-1,-5,-93,14,-67,16,20,-40,75,64,-45,-4,27,-26,-6,21,-40,-16,3,-40,-125,-76,-27,-75,-3,2,31,-49,24,-10,64,-52,57,-19,71,-44,37,35,43,-22,52,-94,92,-21,87,-7,11,47,-28,-90,-82,49,22,-44,14,8,-105,-11,-43,14,127,23,-15,-41,16,21,-43,29,40,40,13,-12,-30,51,53,79,56,49,-23,-9,-28,-6,54,61,-19,-13,27,37,-52,91,-112,25,-56,27,-52,-24,-63,-32,-57,-46,29,-34,-14,-85,4,71,-17,15,-77,-20,-25,3,20,37,50,-78,71,24,-8,27,-30,60,80,-6,28,-57,-9,-38,-26,-126,15,-3,-15,-31,-31,55,-16,-64,-15,-34,54,-47,-3,-2,7,28,4,-5,78,-75,-10,-87,0,-32,-8,50,32,48,-34,-27,42,8,4,-18,-24,10,22,-10,-27,-22,28,25,24,-6,70,-24,82,29,53,-38,29,6,21,46,3,-26,21,49,58,46,14,37,-61,-3,2,-24,16,19,19,26,-94,38,-38, 
  /* [2][0][][] */ -99,-32,-20,31,33,-62,-12,19,4,-2,5,35,-24,-60,61,30,-11,69,-4,-74,41,39,-9,27,-4,31,-44,22,-31,4,-3,36,-11,-46,5,26,-5,-32,83,64,-19,16,-34,4,9,-9,27,19,-9,13,15,27,20,-22,-42,-36,3,40,-57,-33,-13,7,-55,-7,13,-55,-29,-58,32,-24,-37,89,48,67,45,74,17,-21,-16,-45,-57,59,-25,33,-36,2,10,-45,34,-58,63,20,-41,-55,-19,1,27,-5,-4,-32,49,9,-49,6,32,15,-23,32,4,-16,-21,40,-25,-31,5,-12,37,-79,-18,-18,-53,-9,-17,-72,-10,-29,-5,-45,10,45,-7,-19,10,19,-62,47,127,-38,36,0,23,58,10,-23,-6,15,13,-12,-40,22,-15,2,50,30,33,-29,-26,-21,19,-28,-37,63,-39,39,7,35,-68,33,-38,-90,-29,21,15,2,-62,56,28,36,44,-89,24,16,-44,-33,-30,-14,-48,-48,46,-8,-37,29,-6,-7,-6,69,4,68,43,24,24,-9,0,8,21,-30,-2,11,8,14,31,51,7,20,-20,38,-45,-34,-35,45,-5,-23,41,-66,53,9,10,-10,-7,-20,-18,-24,-29,-29,43,-8,-8,-63,-49,41,-18,-82,25,11,-4,48,2,-35,-21,77,12,-21,-36,23,-6,38,-51,19,10,-29,4,-4,11,-77,13,30,28,108,-58,38,-6,23,55,3,-22,10,12,21,-22,27,112,-54,57,-38,-4,52,13,-9,-46,24,-18,-14,-24,64,-25,-17,-37,-30,-20,23,-67,17,-19,30,-11,-61,2,25,-8,-17,56,-23,77,-52,10,1,-28,52,21,-29,-31,-54,33,-29,51,34,-42,19,31,22,-18,33,-12,-19,20,-4, 
  /* [3][0][][] */ -23,-38,33,-44,3,66,-11,37,9,16,37,-38,-45,-6,17,-9,-5,19,-47,30,48,39,-24,-37,41,13,-53,-13,38,53,-59,-65,30,17,-113,-24,-41,-2,101,-33,34,-15,15,48,-21,-114,-40,38,65,9,12,17,-56,20,26,-13,68,6,22,-50,-26,0,-15,-9,3,33,2,34,27,-5,-48,15,2,19,-25,93,-8,-11,14,-8,15,80,-69,-72,30,17,-2,68,-7,-67,-19,33,33,-44,20,-40,-16,-20,127,15,4,1,47,12,-16,28,94,-8,-8,27,-62,44,-27,-22,10,-14,16,38,21,51,-36,35,21,-39,25,-35,-33,-16,-1,13,2,-20,10,-2,-50,15,-43,52,-37,-17,13,14,-2,-33,-14,-4,3,-23,-22,-14,-26,36,21,33,-6,57,-17,-2,-28,0,-41,-1,49,48,-50,31,-9,7,-5,-3,-40,32,38,34,-16,58,-20,23,-29,24,53,29,60,-35,-10,31,-18,-56,-2,33,20,-14,-3,59,-6,-19,-35,68,-14,-41,-8,40,45,-34,45,-42,-21,38,-45,-44,42,35,8,-4,-8,-19,-15,-57,-13,-5,-23,-18,70,1,4,27,-15,-27,31,0,36,15,-21,40,17,-7,-7,-13,-39,-42,-20,5,34,-48,21,12,8,-80,-7,-57,24,-23,-2,6,-23,-1,83,-23,-50,6,38,59,15,70,20,16,17,62,-15,-4,-31,38,47,110,0,-3,48,38,19,9,10,15,39,-42,-24,-31,8,38,-53,17,33,-45,18,26,-6,-31,-2,-17,3,27,-16,70,-34,26,-75,72,-33,6,-29,21,-28,-17,0,-5,-39,8,-40,34,15,-27,6,26,-35,-21,-14,-28,10,3,-15,19,31,-11,41,28,15,9, 
  /* [4][0][][] */ 41,38,-18,63,-31,-36,-25,73,17,-20,-10,6,-59,-14,-26,32,-8,18,39,34,-74,9,16,60,-19,-1,32,-82,11,-8,-4,23,-15,60,4,96,14,-17,-44,47,-50,15,4,27,51,-56,26,15,-33,-85,16,3,-14,59,-67,53,-24,-65,-79,61,-60,-41,-52,-20,3,6,-3,23,-68,13,25,-1,3,-11,-57,-37,-26,61,-36,123,18,-17,-21,50,26,0,-16,-1,-93,-11,0,-17,14,-41,-106,-10,38,-33,68,9,53,-33,13,-3,-32,-13,38,60,-20,-13,-37,-68,63,23,-5,-44,-21,23,6,-34,-25,1,19,101,-80,-3,20,-53,25,3,110,127,-18,36,-102,24,35,13,-52,-8,27,-29,51,-57,-14,-3,-11,14,27,-10,-29,-49,-22,80,9,8,31,-6,-27,-106,60,62,-71,-21,-14,13,25,16,-14,21,-51,121,-35,-31,-24,26,54,-79,-23,-40,5,-12,-48,-4,50,33,69,36,-20,-85,-41,-9,76,30,-51,91,14,20,47,-15,-24,44,-40,-4,-14,-16,-26,67,35,10,16,-7,84,91,20,-97,-37,-27,37,90,5,77,-13,-5,15,32,14,-15,-16,-84,3,37,-13,14,-61,-78,-57,18,11,-67,53,-54,-26,50,-40,39,44,24,-5,-42,24,-16,-23,8,4,-4,-47,14,5,-13,26,-20,-116,-16,8,-20,-33,-15,-59,-21,12,22,6,65,95,36,8,5,22,-16,21,-22,-39,-41,-63,25,-9,42,-11,39,-18,4,-19,-17,-46,-53,25,25,59,4,20,15,-56,-94,60,67,12,-8,59,16,-24,4,-32,-17,-28,38,-5,-27,40,78,81,7,11,-25,67,-80,-2,68,78,120,-9,-65,-3,-12,-72,-111, 
  /* [5][0][][] */ -7,2,0,-17,-68,10,-21,-21,16,34,-1,-26,-2,7,28,-54,-36,-127,61,20,42,17,-9,11,17,32,-23,45,-51,1,-9,30,-78,78,67,-78,-17,-22,-67,-35,-4,25,38,-1,38,-38,-27,-62,-16,30,63,-19,0,-2,36,-38,39,29,32,21,21,33,68,-19,-18,-23,-62,17,-23,-46,29,26,-4,-50,6,1,23,48,-11,-17,6,-22,-11,-16,43,-3,-26,15,-74,0,23,19,-28,46,-31,10,-30,31,-45,-13,27,2,-74,2,-18,-9,-19,20,40,9,-6,26,3,-49,8,13,13,3,-3,-58,-31,-18,38,-21,-24,6,-27,-80,-3,10,109,67,13,-66,-9,-12,-35,41,16,1,-53,-9,-43,0,-33,14,19,10,32,-40,-18,24,-50,59,25,63,-11,-23,86,17,-16,-21,9,0,7,67,34,37,-1,-9,-13,34,16,-4,-13,88,-27,-26,-14,7,63,4,19,-14,66,43,41,56,17,35,27,-14,-36,32,25,-40,-12,-13,18,-9,5,-17,-14,-4,55,-10,-2,31,39,28,12,-25,-27,-10,-2,54,-54,21,27,17,-3,69,4,-7,24,31,-12,-13,45,-58,-23,-1,10,1,-22,-8,-70,9,67,-4,1,11,9,27,15,91,10,9,35,42,24,-75,31,3,78,-34,-24,-72,-46,4,48,-21,-42,3,-10,42,-53,6,8,5,37,47,-5,6,-13,-34,3,-67,-53,-5,6,8,60,-8,-31,12,-69,53,5,-30,-5,-49,-62,-16,-20,-41,46,-17,-73,-7,35,56,9,35,-36,-1,53,26,-13,-21,96,6,25,3,-4,117,65,-12,45,78,3,-12,-18,25,-19,-28,49,-3,-22,-45,-63,58,-30,34,-3,-48, 
  /* [6][0][][] */ 20,114,-41,21,10,-1,42,-75,-3,-48,-114,-31,51,67,-72,30,-64,-17,29,1,-37,-40,86,-54,-42,-53,-37,10,-3,-21,46,-64,67,-15,22,3,20,6,32,-61,22,58,27,-5,38,39,56,-22,36,-8,25,-77,-2,83,-4,46,-14,-23,-3,68,4,76,-30,-8,-40,1,-7,-12,-72,-16,-24,-59,-12,0,-127,-17,-4,29,-42,85,37,-84,-1,33,57,-43,-54,-58,-52,40,65,-33,-31,6,-88,-60,46,39,-11,-75,31,21,1,-24,40,25,-86,-9,-10,2,-28,76,26,-12,-34,55,-23,-27,55,13,16,12,33,84,2,17,-98,-5,-31,-29,-5,22,-43,19,-38,-4,10,51,10,-22,66,59,0,-56,-32,55,-22,89,7,-51,4,-23,-27,42,30,8,-77,-15,-43,-61,58,56,14,-26,25,-22,-59,-17,-4,-34,-12,-45,52,-23,18,-39,75,-43,-48,-49,-4,-34,2,91,-20,-38,37,-5,-28,35,-38,38,4,-39,2,-37,67,-18,44,61,-9,-20,-46,-7,36,39,-37,-17,67,-30,27,-70,8,44,28,-24,27,-7,17,-21,-8,61,-85,-24,-40,16,26,42,-28,87,77,76,-36,9,-19,1,-11,-45,-4,-26,127,19,-1,-45,-3,-10,38,23,32,37,44,77,-10,9,10,-18,-8,3,18,-25,-13,2,22,-20,-15,32,-73,16,-29,20,-51,-87,3,45,5,-50,-43,-67,-2,-6,88,-3,-26,-63,-68,-44,59,46,21,-31,-30,-1,14,-36,-62,-68,29,8,84,21,-61,-48,60,47,9,8,21,-20,80,69,-26,-40,-51,-14,10,36,-26,23,3,7,14,-63,15,-86,-34,-23,36,68,-2,0,31,-6,-42,-121,20,-6, 
  /* [7][0][][] */ 71,-39,48,-65,18,-37,40,-37,-9,-8,3,-50,-17,21,-79,-5,35,29,-32,29,76,30,24,-62,45,44,19,67,-34,10,18,-31,-15,-127,-23,60,26,38,12,9,-15,-1,-24,0,-44,-11,-25,-54,47,57,-1,22,-56,19,-6,-28,13,-5,-47,52,-83,-81,-21,-2,-22,0,71,-17,10,-44,13,-23,-29,41,-13,30,39,41,48,78,18,35,9,-36,54,-37,-8,50,-13,78,12,0,-13,-28,-10,27,-40,-50,8,110,57,-2,33,-6,4,8,-49,-17,-15,51,18,3,6,-22,6,-6,27,-62,-12,71,-17,14,-11,-56,6,-40,-59,46,-24,-53,84,54,13,40,-8,-11,65,12,-13,-23,42,77,32,4,51,-1,71,8,-33,-25,-22,127,10,-6,1,94,-48,28,-6,-67,14,90,15,-8,12,-35,-59,19,-39,77,-45,-36,42,16,-119,20,26,-45,-14,-2,42,-41,-63,42,-55,34,10,48,9,-21,-3,-20,63,-14,36,-11,67,-34,11,47,-26,-9,-33,-53,0,-8,-42,6,-66,-2,-9,-47,-11,-76,9,-17,11,42,-64,8,47,-12,45,4,21,24,-77,15,60,22,-2,-30,24,33,-37,3,14,-21,17,54,28,67,-24,81,74,-35,3,-11,-57,-6,-27,23,-23,29,-14,-35,-35,86,-36,24,-57,26,-16,-25,34,-12,-60,35,0,-61,32,-48,57,-51,-52,-9,38,10,97,-14,-37,-5,-87,0,-4,-18,76,-4,8,-15,-49,-6,-5,11,-60,5,85,-11,-4,-78,-5,43,-84,2,25,2,-6,-7,60,-29,-17,-29,0,51,-9,34,64,27,-7,-7,-66,15,36,-7,26,31,42,-33,100,26,-26,-55,2,-93,68,-22, 
  /* [8][0][][] */ -29,19,23,32,57,-2,84,6,48,-24,-21,-96,-8,-17,-65,-4,8,15,70,7,-1,-38,-41,59,-2,-46,-41,-46,-21,-24,-26,-61,33,43,-24,-72,31,2,-34,-40,-64,16,-46,14,-35,4,1,30,36,57,24,13,-9,-40,81,19,31,-29,-40,-70,52,2,5,-67,36,-2,91,-30,16,-53,-23,-33,15,-10,-63,-63,20,64,35,-39,41,-6,55,21,1,1,23,-5,-16,-29,50,-25,-21,31,-11,-24,-59,-21,-3,-13,-32,54,56,-15,50,8,-57,7,-48,-37,-84,57,-21,43,1,25,36,-12,31,-27,20,11,31,27,43,32,-29,44,35,37,-50,-77,-41,33,85,-41,50,25,2,-8,66,-39,31,16,-1,48,-17,40,-26,11,10,50,24,-15,32,-6,-25,5,-28,-17,67,61,35,-70,-20,-90,-52,-27,31,46,38,43,-44,-62,42,-33,-12,-11,-20,42,-33,-68,-68,24,-47,-55,14,82,-48,51,-4,16,85,-37,-40,-5,73,-77,-3,80,-13,-42,-17,4,-45,21,-1,-30,74,46,71,-10,-61,3,23,28,55,78,-72,8,41,18,-14,37,-47,-2,11,55,17,-22,-46,6,7,-4,-34,-18,5,-33,54,19,76,-59,-69,-11,-27,-14,6,-65,39,-15,-16,40,0,-44,-50,76,-43,104,60,-26,-58,23,-1,22,-77,-25,-34,-63,-18,-24,-51,-62,-39,-9,-34,31,4,20,25,-4,-51,-65,-21,65,27,25,16,-36,-90,-20,-19,-1,36,-22,127,-23,-17,-25,14,31,41,-38,34,52,-14,-11,-4,-6,15,8,0,-115,-69,-31,-50,45,-48,-21,-55,47,53,-9,14,-12,-81,19,9,-8,-59,57,60,3,86,-11,-39,11, 
  /* [9][0][][] */ 37,-16,-31,-18,22,-25,-36,-100,29,29,-40,-68,58,-39,-11,83,-40,68,35,-5,-24,-61,7,78,-40,25,55,-33,-75,-40,18,1,-39,-12,-33,72,-71,22,99,-58,-41,46,23,-51,-67,24,75,44,47,27,-21,-58,85,31,-36,40,-94,91,97,56,43,29,16,54,-74,-5,65,-48,77,14,37,26,26,-84,7,-111,87,-24,17,22,-34,-20,-42,10,59,-10,-25,-19,-31,14,32,35,-37,41,-51,-67,31,-31,-56,56,27,18,-27,-14,-29,39,-94,41,51,-26,-17,-34,-16,6,-15,47,-37,30,-19,-37,-23,12,35,1,35,62,-74,26,70,-1,17,37,-118,39,32,27,-54,-22,70,31,51,-12,-58,-8,-61,-6,30,7,27,31,43,19,-45,-38,95,7,-102,7,53,41,-10,-53,18,-80,-40,-7,21,-75,60,47,-38,41,66,-102,6,-55,63,-118,1,115,-8,-9,38,30,-63,-73,47,-12,-15,43,-6,32,65,-25,37,37,70,-80,18,102,-42,-10,-72,-20,-69,-14,22,27,-5,-52,48,-12,25,-40,-15,-46,-87,42,-21,-11,-51,94,-56,6,-74,-40,44,80,32,55,-51,56,-32,18,25,-41,-18,34,17,20,1,12,54,32,-85,-72,-27,-85,127,1,12,7,-12,8,-95,-33,-47,-2,51,33,60,40,63,15,-72,31,100,0,32,-10,11,-52,-46,49,24,5,-12,-32,23,-13,-16,-17,-4,-14,-17,13,4,15,44,-32,-80,-26,11,26,-17,-31,20,9,-58,-36,20,-56,53,-25,5,47,82,26,31,-79,5,-56,-44,-26,44,73,44,-27,42,77,31,-104,-15,-51,-45,101,34,50,30,59,-30,-70,1,-31,46,-80, 
  /* [10][0][][] */ -50,-31,-35,-50,59,-39,34,26,-32,1,-19,7,-77,37,7,25,11,44,-65,-36,-9,95,-14,20,31,-30,-36,-57,-25,38,39,19,-83,47,40,7,-46,-11,-3,9,-16,19,0,-37,10,5,-15,-82,14,12,-39,66,33,1,0,29,-41,21,0,-8,29,6,-9,14,56,3,39,-46,25,32,-38,28,-3,-45,97,37,-58,61,-9,26,58,30,43,-13,33,14,14,77,69,-55,-5,79,47,-25,1,-49,23,60,-16,-34,76,-17,-65,50,-41,-33,-22,-39,28,75,44,10,-6,0,36,28,-19,-18,5,34,-37,-35,100,-23,-53,-9,34,2,22,-40,-7,-7,28,-38,37,-53,-3,45,23,35,-48,-9,-89,26,6,-32,7,-30,47,-35,-11,12,-14,-80,11,-22,-27,9,82,-61,-12,41,32,-17,-42,-45,-51,2,1,39,5,-51,41,3,51,127,-54,56,72,82,5,63,50,-11,4,-40,55,36,33,-36,24,-20,18,-30,-4,3,18,19,11,-10,-36,-36,-4,-13,33,-56,1,-12,-2,-72,8,-23,53,-30,51,91,-39,-101,-6,12,-54,-26,28,16,-35,-4,79,-38,69,31,-31,-41,22,-76,-23,54,-28,-36,49,-27,-26,-25,3,-69,-96,52,-4,-87,13,-40,58,-56,0,37,28,83,-66,-20,65,-39,-25,-21,-80,32,-14,55,48,71,33,14,-12,4,28,-8,24,-32,-49,1,43,-13,-43,73,-34,2,-30,-23,-35,3,-33,35,50,-27,-13,-3,-74,-37,-39,31,-48,17,19,-10,16,96,-1,40,63,39,-11,52,-34,40,-3,9,-48,-2,-59,-12,-8,-24,-40,27,-49,25,-27,-15,-16,41,-8,49,3,73,14,69,1,-12, 
  /* [11][0][][] */ -34,-34,-17,-16,-9,5,-78,3,49,-20,37,-42,26,-12,16,1,25,-23,33,-7,0,-8,124,32,3,-3,-2,-17,-35,-29,3,-18,103,-42,25,-24,47,7,-39,-19,-21,23,21,14,33,2,-19,27,49,70,-101,-15,16,-80,-28,-16,23,26,2,27,31,84,-4,64,16,1,-44,69,-19,-25,51,13,-81,-32,75,-85,35,24,-50,34,81,-53,33,-8,-40,73,-20,5,16,39,-44,-10,7,-9,-10,43,40,33,-1,-39,-53,15,-11,-12,-47,-49,-7,25,41,43,-25,-80,-12,-42,24,-61,24,-46,25,-74,59,17,-8,-64,-21,30,-17,50,32,-13,36,-46,3,1,-46,38,14,-13,38,-22,14,-24,-75,6,24,22,-13,-1,4,55,35,13,-15,-56,29,-14,23,-79,-47,-50,-4,-59,-54,-71,-16,35,-51,29,-33,-12,45,48,-8,23,5,57,-1,12,18,-68,0,-49,71,-6,24,20,-22,-5,73,-13,97,11,-1,-54,90,71,6,10,20,-14,13,50,18,20,36,49,-21,24,33,-6,25,-39,-12,-11,-2,21,20,26,-99,8,78,-49,19,127,41,103,15,-105,5,7,12,-89,-11,12,35,14,-71,-47,10,-21,29,46,20,-15,25,-9,9,53,-2,-5,-54,58,26,26,-39,-30,-32,-72,33,-3,-15,51,-56,-36,10,35,-11,-14,-22,-50,-53,29,-68,-36,-50,35,-48,5,-99,11,64,-5,-5,-9,-34,12,-57,28,36,-14,11,21,31,-8,-5,41,-13,-13,39,-55,26,-5,-30,11,-7,-18,16,-40,-41,-21,47,-7,41,54,-25,-18,26,-61,-7,4,-23,4,1,78,-4,-46,-102,7,-65,53,-22,-28,-5,39,29,-18, 
  /* [12][0][][] */ 14,9,-66,-20,0,2,-14,-62,-27,-103,-6,-5,-7,5,-25,15,-27,38,1,-13,-32,-6,-84,25,-46,2,-52,-18,46,-13,27,76,-81,49,6,76,125,-6,-55,-2,-44,4,-20,-12,37,3,24,35,4,50,6,-25,0,13,-53,20,22,-6,-9,31,27,-11,-31,50,22,38,16,-37,60,-4,16,-15,-14,3,9,10,-22,-27,-34,17,27,31,-17,44,7,11,-21,-50,-11,-7,-61,-49,-8,-51,30,-13,-48,-39,-23,-39,-127,17,16,12,11,35,38,22,-52,-42,18,10,8,32,-9,-15,110,6,12,-24,34,-32,-49,1,-14,-6,-65,-24,-18,-75,-46,61,20,-44,7,7,38,23,-32,21,9,-2,-18,45,27,-24,-24,-7,-21,41,27,-53,-17,10,3,-27,32,57,-73,56,16,24,41,-26,30,-72,3,-16,-17,14,-11,-24,-16,-100,23,-29,-74,14,-19,-92,-33,-40,-41,78,-41,-3,24,3,25,-9,19,29,35,39,-65,-57,11,23,1,19,-26,-43,-45,-38,10,50,-16,-7,-51,-10,-6,14,6,58,86,-36,-10,45,28,-25,14,35,-15,32,17,22,-38,-30,-19,-9,57,0,49,29,-21,5,42,16,-46,35,-18,85,5,-5,20,59,80,-11,39,-32,1,-79,14,56,20,-69,-29,-34,17,55,-4,6,54,-71,-13,39,-43,7,-3,-48,-57,-3,-23,-18,18,23,-12,-16,-48,-8,-6,1,-57,78,3,-40,67,-53,-29,-35,-45,-15,55,-46,-15,-96,46,33,-10,55,-2,-25,-44,43,18,-28,-31,-55,32,-51,39,-27,-36,-13,-21,-49,45,-16,-1,36,-90,25,100,-56,30,-34,19,-16,-19,-37,24,-17,63,-3,-18,15, 
  /* [13][0][][] */ -23,5,46,-28,44,32,17,0,-11,9,-3,16,97,-28,-9,18,21,32,-7,-33,11,-24,9,-47,31,24,-23,37,19,-9,-26,8,23,33,-2,-30,19,-17,-17,30,24,-25,16,-21,-19,57,18,-9,36,6,-12,15,-52,50,18,-36,24,-5,-13,-18,10,13,-20,-21,-3,23,8,-29,-22,-4,9,-30,-42,16,16,42,-7,11,-19,23,13,13,4,15,21,-55,-9,24,2,-31,-46,9,13,-69,-47,-9,-2,-15,32,30,12,40,39,-21,6,23,55,12,-38,16,77,-8,-58,-2,-22,-7,-27,-13,-38,29,-1,-8,3,-13,-36,-27,-48,10,-33,-36,54,42,-1,-7,-6,-5,49,17,47,-36,67,-49,12,-34,5,-70,-23,53,-52,12,5,18,-12,-18,-75,-3,17,40,-11,-6,32,54,-46,-21,8,-31,0,11,0,-8,-5,39,0,-35,-21,49,-16,4,-8,14,-29,-3,-5,20,8,-15,-1,17,15,23,10,1,64,-33,34,22,-13,4,12,2,-20,8,-53,-31,-55,1,-57,-41,-31,8,51,-31,-3,-64,-12,29,-31,12,-4,35,11,16,-29,-11,9,5,57,-12,-1,16,-40,43,21,0,0,-127,26,-7,27,41,-45,-16,25,44,-13,-12,24,5,34,3,44,-31,-25,41,-1,1,32,6,-15,-5,-31,2,28,-7,0,6,8,-7,49,58,-39,-39,32,-3,-9,-2,10,14,41,-11,-26,-5,-54,-19,26,-44,-34,-5,-29,-23,2,-11,49,-1,-11,-43,-3,-8,33,-6,-11,40,0,21,-35,15,-7,2,26,-41,-64,23,44,-34,-43,-24,-41,18,-21,2,44,8,-18,-34,23,3,8,3,28,-27,23,-33,-35,-78,4,-14, 
  /* [14][0][][] */ -47,25,-29,-35,-35,-77,-60,11,-1,58,37,-12,12,-69,55,10,-32,-40,-31,-23,-8,-26,46,8,-2,-41,0,-1,-6,-75,-31,-15,7,-3,17,-2,34,-39,-93,13,9,-13,-48,3,30,62,-36,33,-19,6,-71,-44,-79,107,75,-7,10,-21,41,2,57,-75,-43,-13,40,-6,2,-36,48,-51,23,-11,6,-4,-32,-9,-23,-33,72,32,-26,43,-113,-12,-12,-38,36,5,71,-13,-33,-34,-33,-21,52,62,34,9,1,53,-7,19,26,8,31,1,20,-1,69,-14,-22,-31,-20,-60,72,71,-3,-10,11,17,54,8,-59,28,-31,52,19,-39,-36,-22,-15,9,-32,4,60,22,22,9,28,-12,8,-30,-46,-66,4,-6,-45,12,26,20,24,-124,-2,-37,-14,15,16,33,60,63,52,26,21,14,-21,-17,20,-57,59,1,-11,-8,-55,-21,26,13,-10,37,23,-59,-26,22,-39,1,63,27,-17,7,-22,-30,-9,-21,28,12,35,13,24,-5,-49,-35,10,-29,-10,40,6,18,60,-54,-46,62,-25,-2,-41,33,83,14,22,26,-12,-60,38,-12,-28,13,10,-13,44,-32,61,5,-94,-57,14,10,-62,-33,-34,-87,14,-13,-11,48,-56,-89,-9,-52,26,-4,60,-33,-36,-5,-38,24,81,-3,-24,20,-50,-25,-3,-56,71,-12,18,-26,27,-44,55,-5,-30,46,-59,-17,-66,-44,1,7,16,9,-30,-4,-39,32,26,30,18,-67,-127,-17,-27,43,68,-27,-39,-55,-43,69,-67,-52,13,-76,25,-37,-8,-39,48,34,-48,-58,-3,-15,-56,-30,-4,-36,-52,-5,-43,-2,8,16,-49,78,20,-102,-74,23,-53,-29,-55,36,-23,61,-7,27, 
  /* [15][0][][] */ 83,-67,30,-26,15,-49,4,-29,-2,-14,-8,-51,12,-29,-39,37,35,36,40,-5,-10,-90,-70,6,-10,9,-24,72,30,-48,21,35,-49,47,75,-18,5,-15,27,34,48,24,67,-5,22,-33,10,46,45,-12,-32,-17,10,-38,-103,-30,-49,42,-19,-14,-38,25,-6,16,-48,25,2,9,-5,0,-29,-13,1,1,-22,-47,-31,26,-29,41,-7,-19,7,16,37,3,9,-103,-42,22,-11,-87,37,-21,51,-55,-21,-40,62,-31,50,25,-65,32,75,-11,-24,-14,54,-32,51,-24,42,106,-5,-42,5,-51,-25,-113,30,41,127,0,53,72,67,38,-57,36,11,0,8,16,-32,53,-11,20,27,37,12,-35,7,46,90,28,-3,97,-43,-20,-23,81,-16,21,70,53,38,30,-20,89,56,39,-55,45,40,-3,-19,31,46,16,-4,-25,-38,59,3,-19,-29,-45,7,-6,-47,-90,37,43,-2,47,-37,-48,49,-22,32,48,-31,-49,-22,-30,1,-30,8,40,4,32,2,16,24,-14,-62,45,-45,-3,2,54,33,27,-97,12,8,57,-48,-30,-46,17,-30,8,16,-38,-68,88,15,36,35,38,14,-43,0,95,-1,51,34,42,-1,28,-11,71,89,-54,-75,9,-22,9,-62,-23,-4,-22,-19,-38,21,45,1,41,48,-27,-39,9,-52,30,0,-23,-21,-23,31,17,-97,28,-53,-2,7,66,-23,-19,-15,4,-38,-53,-33,39,16,10,-24,-38,-65,-83,16,-3,54,-101,-21,7,5,-17,16,80,-55,-51,20,64,-39,-50,32,38,-34,36,13,-26,23,35,82,-34,8,-19,43,-19,39,1,-18,-23,121,15,43,-44,-17,40,31,-19,-13,92, 
  /* [16][0][][] */ -13,-17,-24,69,17,5,-50,10,-26,-23,8,23,29,43,17,23,33,71,-27,45,-34,-23,31,-34,-13,-32,-38,53,16,2,-95,63,15,11,-93,79,92,10,24,-61,-22,14,-19,-2,-12,10,-23,13,34,45,-7,41,-50,27,-8,-45,-38,-55,-1,-15,20,39,-37,57,31,79,-47,0,-56,-3,23,-2,-18,41,-46,118,-18,38,-1,20,-63,9,78,54,16,-42,-42,-27,17,-42,62,13,-61,24,-38,58,11,-24,11,-71,-33,-22,47,54,-4,-15,-20,72,22,16,-37,12,19,2,-25,-23,34,-14,8,-23,7,-39,-102,-67,-2,-18,-54,-18,-2,-13,-127,8,19,19,3,46,8,64,-1,-14,-31,-51,-6,39,0,62,12,-42,-24,6,6,-66,-12,-28,29,19,-7,37,-61,7,10,50,25,-107,20,37,97,-58,-23,-41,25,-48,-65,-51,22,-5,7,6,-16,58,-29,-40,-63,2,-68,-20,-31,-3,-20,-39,-21,40,-45,-2,20,8,39,44,-21,-17,8,66,-6,9,-72,-33,43,-25,21,29,44,-28,19,-9,18,42,-33,-25,30,16,36,-36,-74,-5,-70,9,6,30,-42,41,-53,-47,53,25,31,-24,74,-26,-91,7,-7,21,59,53,-31,-52,17,-97,44,-41,-27,27,-85,-7,65,-40,-23,-37,-24,15,65,-18,89,-30,-57,-23,29,23,-48,5,-20,4,-5,-23,73,-35,-120,41,29,-13,-17,-50,-27,25,-36,2,-5,15,67,-20,0,45,40,24,-52,9,-14,-79,17,-12,-84,9,14,-92,21,-51,31,-27,-40,-4,-94,-28,-8,-16,-20,-61,-24,2,-43,10,-13,-31,21,-50,65,14,-11,15,-89,71,-25,-31,-44,50,2,74, 
  /* [17][0][][] */ 2,-73,8,-2,30,18,55,-12,-46,44,-10,77,9,9,32,-113,92,-5,98,-42,50,37,62,2,54,3,-20,-64,-58,-65,30,-19,-5,52,20,19,-3,-113,36,81,6,-73,32,-33,9,-11,-53,7,-8,6,-11,-60,84,21,-55,6,49,-31,58,49,-4,11,4,32,-39,36,6,-3,-51,-64,24,-46,-44,-39,3,-20,-42,37,-27,-26,3,44,19,-43,74,-41,5,22,77,6,-62,5,-9,18,13,15,13,-5,7,88,3,-31,37,-4,18,-29,-127,1,-32,49,68,-26,-39,36,22,-20,11,-31,30,-74,25,-4,11,36,41,51,41,-86,44,45,49,45,23,-35,-33,-10,-44,-2,14,45,-1,27,15,-48,106,48,38,-21,-49,-18,-20,-38,103,-75,17,-103,53,-61,-62,-14,-42,-63,-51,3,60,20,63,0,-69,-32,-10,43,27,-17,10,-14,-4,-14,-17,-35,56,66,37,30,-25,34,95,-33,-4,28,38,-37,23,-55,-13,65,22,-53,51,-20,49,35,-66,59,41,-19,-6,-68,6,9,-52,22,-17,42,22,-43,-29,-9,-6,71,-19,1,-43,-26,82,-51,109,-73,-39,-10,1,22,30,-1,-30,-66,-32,-42,-67,73,70,66,39,-15,-81,-84,34,37,-14,37,51,-46,-47,-1,61,-2,91,-32,108,74,-36,19,37,23,13,-32,-53,43,79,5,-23,8,-81,20,-54,81,-19,54,-12,113,-85,0,-30,-19,88,78,17,-41,-91,-35,41,-40,47,-13,-58,111,23,-78,35,-78,-52,44,-59,51,-14,-62,16,24,40,13,3,-11,124,-18,14,-17,-88,-65,-41,63,23,83,54,65,-4,43,94,-28,18,33,-26,-85,82,-22,-25,-114, 
  /* [18][0][][] */ -102,66,7,17,-57,-2,-10,-16,16,24,-3,-34,65,16,39,22,-40,23,2,14,-60,14,80,-1,-94,-47,7,-41,-1,15,35,-41,-6,95,6,-11,21,78,55,-41,45,14,-17,-26,-30,-8,14,18,48,-34,5,-9,-25,15,26,-2,-18,15,-70,-3,-2,61,-43,-25,69,0,-25,-4,21,73,-2,60,16,-11,-22,64,40,1,8,-20,-33,-50,75,20,36,-23,-13,-83,-14,-12,-18,17,-8,-15,3,36,-12,12,46,13,-5,67,6,-11,-5,3,127,-25,-5,-12,10,11,-40,11,-15,-9,-14,-17,2,-51,-24,34,33,-10,15,-8,27,-1,-21,2,-39,-35,18,70,-20,66,-8,17,105,-2,-95,-30,-22,-21,-7,18,4,-34,-31,23,-20,42,0,-18,-3,4,-59,-3,-18,-36,15,31,47,14,-24,38,1,38,63,6,15,24,-7,-25,-34,-30,-38,32,38,40,-46,-62,-36,22,38,-4,-10,42,-21,17,11,-6,-34,-43,63,24,101,5,-46,3,-38,30,11,25,-9,15,-44,46,30,-52,65,-30,21,-18,-26,-14,-3,54,31,-29,-22,-14,-31,-34,-11,50,42,-12,29,64,-46,-3,-34,-51,-23,3,20,-39,-63,37,-8,-17,16,16,-28,-7,5,-52,16,48,26,31,46,19,20,-12,-34,-34,-23,7,27,30,-11,31,-42,14,-19,19,18,15,-3,24,94,-36,26,-14,13,-32,-34,-4,-34,-6,31,-38,8,-54,-35,66,30,25,2,-31,13,21,11,-31,-60,33,-29,-15,36,-12,12,1,17,1,1,-11,34,-52,17,-4,-22,-2,-13,-3,-40,16,-21,-7,-34,-47,-48,23,3,50,59,-87,-8,15,-28,14,58,23,-3,24, 
  /* [19][0][][] */ 27,93,-87,4,-26,-27,56,-54,-22,-6,-43,34,-44,0,5,-14,-25,45,-11,4,3,14,11,51,-49,-34,-18,-5,10,-11,32,-43,-14,-7,15,41,1,13,67,26,1,26,-28,25,-19,28,63,1,35,-51,-26,74,-60,-31,26,29,-16,-7,28,61,-10,81,52,-38,-22,-46,53,-59,73,47,3,-55,-13,14,-28,-19,31,-1,27,-5,-18,9,40,24,2,11,-39,-15,-7,33,20,-27,-36,27,-1,4,6,-3,-3,16,-7,46,-43,-3,37,-44,-39,15,-23,2,-7,-1,-44,82,-50,30,-50,84,8,27,-11,43,11,15,56,36,72,48,28,67,-53,-47,-8,-6,-15,47,24,28,18,-3,-14,28,-28,8,-26,-33,6,-31,28,-1,1,-51,16,38,95,1,-62,22,21,-11,-3,37,18,-28,-3,-39,42,-37,-8,-39,-10,-30,-24,-33,33,-45,-43,-80,-42,27,-99,-41,59,-11,-42,12,-32,-7,-9,35,-6,35,-18,-37,-37,-42,44,47,18,7,-34,-22,-35,-13,54,31,7,42,3,0,73,0,22,84,-24,10,22,3,-31,16,-39,-8,4,41,-120,-8,-23,56,7,60,64,-24,-67,44,-13,85,-7,-47,22,10,11,3,46,-42,16,32,-16,74,50,-10,-1,-28,69,-35,10,-15,-42,-32,25,3,42,54,-4,26,-8,104,15,-16,55,44,-19,-49,11,-74,-56,-62,-71,-61,28,33,1,-60,40,-27,1,60,-35,13,37,-57,-64,-56,-17,11,-18,0,34,-8,-33,30,-46,-47,10,-6,3,-5,-19,-25,51,57,-26,-7,-11,-2,-4,32,-19,-14,-5,34,-54,-81,41,-55,-39,14,13,23,-22,33,51,-16,-23,-127,71,-57, 
  /* [20][0][][] */ 11,12,21,-45,-10,80,-5,80,-18,47,-11,1,-19,-72,9,9,-27,-28,-46,-7,-37,-16,-48,-25,-35,57,19,17,-52,15,50,28,39,64,-45,45,2,-35,18,-11,20,41,-26,-8,-45,-15,-34,-37,22,-29,55,11,-66,-11,-14,6,-6,33,31,-2,40,-1,-57,-46,-23,36,-108,43,16,-8,-33,-62,7,31,22,127,28,70,-1,18,24,-24,-46,-50,36,-5,-58,-12,-6,16,11,3,-7,-80,1,-8,7,-3,-6,44,-26,26,-26,21,26,57,-76,6,1,45,15,46,34,-10,-6,62,4,-13,29,7,-26,63,-33,-39,-61,13,-7,22,-37,-48,12,-42,27,-24,-26,17,-1,3,31,-58,3,29,-25,35,-67,61,-47,19,55,-37,-31,30,-26,28,-5,73,7,0,-13,18,9,31,-11,11,0,14,14,51,41,-15,-40,-86,6,46,9,34,-6,-4,9,-58,-5,-31,69,-54,19,55,-59,-27,-29,-11,23,2,2,-6,-16,-9,45,10,-4,-34,62,-45,37,-30,11,2,-17,-1,4,22,-54,37,-21,-21,7,-25,-24,7,-31,5,24,-22,48,23,7,10,3,22,4,-19,-11,5,9,-23,-16,5,35,19,21,-24,-38,9,-7,22,-6,49,-15,18,-47,11,16,17,34,-38,25,-13,27,22,-15,-8,-13,-42,-34,4,22,-36,3,16,-26,-55,-22,31,-29,-30,21,30,27,-5,18,2,30,-32,9,-48,-13,1,-20,-4,42,51,38,-31,-62,10,-41,-73,0,-55,15,24,4,40,-7,-9,33,39,-22,54,27,19,50,-43,40,29,-53,6,-3,7,-13,44,-5,21,25,38,-15,3,33,50,78,-26,-18,-9,7,-54,-39,7, 
  /* [21][0][][] */ -22,26,7,-6,-14,7,-14,-56,-29,-20,-31,-34,-47,28,-10,-24,-38,15,4,0,25,9,57,-18,-53,-20,55,-14,-21,5,56,-51,6,62,10,31,-41,29,-49,-23,-7,56,8,19,36,-15,57,-16,-17,-33,-20,-35,46,65,20,15,-41,-30,45,-21,-31,-41,7,8,-27,53,-11,37,9,127,-5,-11,-25,29,-9,-77,-27,56,-51,43,66,-37,-22,23,56,47,59,-86,19,-9,-47,-21,6,-14,-14,18,1,51,-23,-58,7,-21,-20,33,-92,-53,-68,-38,-10,-24,-98,-37,15,-31,17,61,-4,-2,-24,36,-59,21,23,-29,-68,-3,47,-43,54,-77,30,19,1,67,-2,7,-22,6,35,-64,-9,14,-32,-13,-14,-21,-8,-17,43,0,21,-29,-24,-27,-17,64,9,68,52,-49,44,-16,17,-26,54,10,44,-21,-13,-7,-5,21,-11,-40,17,-27,-44,9,7,79,9,2,-7,53,10,36,28,7,22,-10,45,-3,49,-15,26,-28,55,19,14,-3,-30,21,-2,-53,-20,10,13,25,10,-28,-68,0,-10,-14,27,-11,-29,-3,-4,16,-41,25,-52,83,-99,-63,-14,15,1,-1,16,-31,4,-6,66,6,30,26,47,19,35,18,47,27,-21,-9,-19,-61,44,41,-8,32,49,3,-28,-19,43,15,-16,42,-24,-14,47,-31,7,24,33,-24,-49,-24,-28,11,-31,37,-1,-63,22,5,-25,-10,-10,-11,28,8,-12,24,34,16,-69,43,-43,-4,32,26,7,-44,44,55,6,-49,37,4,16,2,-13,76,-2,-79,23,-1,41,32,-6,14,-1,62,-8,-6,19,15,67,-53,-31,4,26,-16,-55,9,-13,52,-14,5,-41,-15,8,-12, 
  /* [22][0][][] */ -40,-40,-10,50,30,-29,-31,18,47,4,34,19,-16,-39,20,-34,46,3,65,-58,30,-103,-94,12,-71,28,48,10,75,-56,-61,-22,-42,20,42,1,28,-6,-39,-24,66,5,-17,10,56,0,51,-59,3,-44,-18,76,-66,-127,45,10,-27,-28,81,88,-7,-40,35,-45,51,-42,38,-58,27,114,30,14,-73,30,4,-39,18,42,45,19,-61,-1,-4,-70,2,-6,11,-62,-11,3,-40,-1,33,31,21,48,35,-43,-18,0,103,-64,-33,-4,14,-34,13,-33,2,-15,50,-11,42,9,-30,-41,-9,17,-31,53,15,23,31,54,60,28,-72,-6,-49,37,-8,66,-42,-5,33,95,110,16,27,39,-50,40,-31,29,-64,-10,19,94,-38,-36,16,-47,10,35,-9,-16,11,5,-97,-38,65,31,-49,8,-30,-30,0,46,19,-28,50,-37,78,65,-7,15,-1,10,-10,-10,-68,28,-7,4,-5,-56,-59,8,-53,44,-19,33,-55,-46,8,23,41,35,-10,-43,-16,4,23,79,-29,57,29,54,-43,36,19,83,-37,7,-28,51,-42,91,26,7,-33,27,-33,20,-10,26,-43,17,44,2,26,46,-56,-2,-52,2,-2,13,-14,-38,-53,-37,-60,95,100,46,46,14,-9,55,36,39,-32,29,38,21,11,60,-78,-68,30,14,10,1,-5,15,-12,-30,-2,-75,102,24,-50,-41,-51,-45,-50,-7,-12,-6,-5,-13,-37,-3,110,42,-18,11,-3,-32,-45,104,-51,-9,-54,22,-80,1,43,-28,-20,34,44,73,-59,-50,19,-45,-4,16,8,-43,-26,-50,79,39,-31,-2,65,-14,-55,-7,0,51,11,46,20,6,-95,-38,47,-2,-73,53,-23,-48, 
  /* [23][0][][] */ -16,13,-15,39,34,-58,-69,-26,30,-46,-10,-22,-14,-25,-12,15,5,-4,50,42,-20,-47,35,4,-9,-93,-26,46,-24,-6,-93,-82,-17,50,73,-14,11,31,-1,58,-30,-21,-30,25,-27,52,-13,-13,53,1,-18,34,53,-53,-33,-5,-43,-73,-17,39,6,-14,-2,0,19,-43,6,-45,20,-82,1,-32,-24,30,6,27,-25,-41,9,-14,-14,-40,-29,70,-93,-14,-2,16,-52,-93,41,11,-37,36,24,26,5,-32,66,-44,11,29,-61,-24,100,108,56,88,-31,-65,-97,-54,-38,49,21,-62,101,-52,-15,-11,22,-49,-25,-5,17,21,-16,-15,17,34,-4,39,8,18,-8,-66,101,-36,-9,80,-17,-10,-14,13,-69,-7,-34,-8,24,10,-83,27,61,28,-101,14,-45,16,-5,-33,-24,50,-63,-52,-11,0,27,-12,4,5,47,-1,21,-3,22,-35,-31,30,-46,25,-84,7,-87,59,-55,-75,-59,-21,38,-15,4,-16,13,15,-45,-86,-13,46,54,-26,-98,-2,-11,15,-17,30,-9,79,15,-34,59,-19,68,-89,19,3,-11,6,-32,-41,-8,2,1,-13,-65,-12,34,-20,-12,-21,-24,-15,-45,60,43,19,-32,-1,55,52,32,-39,94,29,47,51,49,-32,-2,7,-107,5,-28,-32,56,3,-98,61,69,44,-56,18,-27,-72,-29,-22,66,57,-4,9,57,13,-21,-23,-59,61,83,15,-32,0,-8,47,-77,55,2,76,30,-48,-74,-32,-41,25,72,19,85,-8,35,-1,-49,-7,-52,19,15,-14,15,-17,21,45,-31,-55,22,58,-38,-63,24,-68,-59,69,26,13,-28,-25,17,-13,51,-28,-81,-11,127,46,0,37,-17,-16,30,-40, 
  /* [24][0][][] */ 49,13,15,27,4,-31,-4,76,49,72,-66,16,58,1,17,83,-43,-126,-89,4,50,79,36,-3,32,-63,35,22,-2,52,-19,-20,-19,-29,-3,59,117,-35,22,47,-6,3,-14,-15,70,-15,-12,-5,-70,80,-2,0,-51,-5,-31,-16,7,-32,120,43,11,4,-27,-48,32,4,-12,64,-6,-79,71,20,44,17,12,81,26,-6,8,17,-76,-28,32,-11,-84,10,50,6,-1,31,-4,28,-60,-47,-19,-10,61,-11,-4,57,22,94,18,-3,-15,-77,106,25,-28,-72,-1,29,9,-13,36,15,-36,-30,-21,-18,-37,54,21,-10,8,-21,-23,6,-40,-78,-48,-63,51,-18,-19,48,31,-3,-13,-127,-23,26,-10,42,-32,-82,-16,-39,18,-18,-15,27,-20,84,34,-17,-28,-7,29,17,41,-2,65,-40,-56,27,7,-51,-20,-20,35,-39,-38,-1,25,21,-7,-10,18,24,-2,-88,79,53,35,-50,-27,27,-3,11,-60,-35,3,26,58,64,-10,18,-9,-8,-4,-7,-15,27,-9,-2,-31,-14,47,13,35,-25,-32,7,-58,-31,38,91,-10,3,-21,-5,-45,41,1,-48,15,-38,34,-20,36,-42,51,-75,-30,-47,37,-109,1,91,-48,-26,13,-26,77,35,46,79,12,-92,-9,-54,12,-8,-60,-22,-23,-81,46,25,86,-21,37,-4,-10,44,21,-82,-30,-43,-15,-47,59,34,4,28,-73,22,-38,2,16,19,-7,21,16,-59,-5,-47,-5,-16,10,29,35,2,-17,-4,-40,-81,30,-43,28,-17,-51,-99,-40,20,-6,-7,18,-16,52,-43,43,20,-13,-81,-28,11,69,10,-31,-38,56,-62,-42,20,11,-44,9,-15,10,-34,-50,-45,13,-20, 
  /* [25][0][][] */ 30,50,72,8,2,-7,-21,-54,29,27,-22,-102,2,-20,63,-1,38,-34,40,-47,-19,-45,-42,12,30,-8,-44,-57,27,-31,-9,3,-11,-7,127,-60,-24,0,41,-13,-41,-55,-15,7,-1,1,-23,-4,39,-27,93,0,18,8,-53,-17,-63,42,5,-10,-8,45,9,-39,-13,-6,26,-51,-13,20,15,37,-9,-27,31,5,15,-36,6,46,37,14,5,1,32,30,-58,7,-5,-46,-3,-38,-18,49,22,-42,-5,4,38,-36,39,-2,-32,-32,-20,-21,7,-33,46,15,49,48,-28,29,-3,-23,-34,24,-75,3,17,25,-15,-15,28,-28,11,31,7,-7,114,10,21,-20,-27,15,-8,-13,0,-2,10,43,-5,-22,-13,-68,-45,27,-55,16,-49,19,3,-9,-36,36,47,-9,-27,-22,-36,-65,-24,-18,2,29,21,-6,27,12,-32,-20,-43,10,24,-4,17,9,-43,15,-12,-13,37,21,25,-74,-17,-17,42,-23,38,-27,-4,-8,-9,-10,-63,13,20,-18,10,-14,-32,-11,1,-4,-46,8,-5,-14,-18,19,-3,-33,-19,-37,-41,-11,-43,7,10,-1,13,-19,16,-20,13,-11,-1,-10,11,-35,-16,-29,4,-1,-36,70,-50,23,-12,65,-39,32,91,28,-33,18,12,-33,41,-7,-4,36,-37,-12,25,19,29,-76,2,43,-27,-7,29,8,-33,24,55,69,31,29,21,18,6,38,19,46,74,17,11,43,-43,0,30,-11,-23,24,-33,-67,-9,21,-1,11,11,16,-2,50,10,-15,25,-42,5,36,-23,33,10,41,23,34,-29,28,-25,25,19,53,15,3,-1,17,-31,13,-9,24,-5,-13,53,-41,-20,-31,60,-23,-10,19,29,9, 
  /* [26][0][][] */ -22,26,30,-23,-37,9,66,4,-6,-11,-41,17,14,36,-64,-59,52,26,-3,-75,-52,43,-60,-5,-27,-29,2,-76,-15,31,-18,50,70,-46,47,38,45,5,-20,68,11,21,-38,24,-22,40,-59,55,-21,62,-7,-8,-3,48,-18,21,5,-14,5,57,40,-58,-48,-60,-7,4,-15,-32,-18,-4,-29,22,-28,20,-29,8,9,9,-55,43,-25,-13,-3,-9,-29,14,8,-43,-82,27,-54,-45,-37,11,10,33,-27,-16,-67,-29,15,44,8,-9,22,-35,4,45,-40,32,-4,83,31,-2,-90,-28,-7,-16,-13,21,-11,-66,33,-20,52,-74,96,61,41,49,-56,38,-12,-28,20,42,48,27,-19,-3,-60,80,13,41,22,-26,44,-76,-25,10,-57,0,54,70,57,-84,50,19,-15,-67,-44,52,-23,-48,55,-59,-53,51,-48,-65,-11,86,-6,8,26,-12,17,-43,88,-39,40,4,-42,68,-91,-21,38,3,-29,-52,32,-56,10,-1,-46,10,57,-25,-29,51,-17,42,5,-62,19,30,13,-46,-16,-46,32,-35,5,-16,45,-98,36,-65,4,-2,43,14,-36,6,-48,-46,15,-10,9,12,-11,-18,-88,-27,-27,-33,3,-4,5,-9,-16,40,12,33,22,22,48,14,32,24,-8,28,-13,19,20,28,27,3,34,28,-7,8,45,-1,-4,-30,-7,8,-56,-51,22,-71,1,8,-2,26,1,-30,-19,-20,0,-6,47,63,-108,-13,40,-26,-27,-44,24,-15,2,33,-98,-23,72,45,22,15,-20,18,-13,-6,57,29,46,27,107,22,-30,-40,-47,-52,-40,-13,-49,-13,-54,27,8,-127,-14,-23,-34,51,37,-65,-13,-16,14,-21,22,-64,40,3, 
  /* [27][0][][] */ 44,-14,-40,30,47,-3,-57,-46,-61,23,-13,-17,17,26,-9,2,45,27,-51,-75,-51,69,8,48,-43,51,88,43,3,23,56,-43,-15,21,36,-111,16,-11,24,-11,22,-15,-33,-5,-24,17,-7,-65,1,16,-23,-54,-29,58,4,-19,-33,5,56,-25,35,-26,30,26,-36,21,-14,28,34,-40,26,39,5,-33,62,24,5,-26,-30,-28,25,-42,-8,-56,-11,-32,50,-5,-20,50,21,17,-45,15,-50,-9,-17,31,-55,54,-62,27,-101,-4,-62,-15,27,14,-5,24,33,21,-42,-51,-48,34,-42,-16,23,-7,-8,37,-127,25,-3,42,-30,-5,58,-28,1,-11,19,45,27,0,43,9,-22,-23,2,-81,42,1,42,52,-23,-6,54,3,-65,-21,-8,14,7,-22,-34,32,37,-12,58,66,-16,-50,10,-8,-17,-86,-3,97,-3,-18,-48,-33,4,-16,18,-60,1,45,42,0,78,-14,-71,29,19,16,3,26,7,-1,17,-13,3,79,37,-44,23,15,-32,7,-14,-41,-10,28,-40,-2,33,29,-8,-15,12,55,39,21,-13,56,-34,-31,12,51,-61,-15,-51,22,55,40,-5,-1,-2,61,11,22,-12,5,31,12,7,5,52,17,47,31,20,-2,17,4,36,-18,-40,-17,-11,37,-38,16,-41,8,50,18,-9,16,52,-35,28,-15,-19,-21,10,-13,-6,-19,-6,-7,29,-15,-42,-19,8,-37,40,6,-59,5,0,9,55,-20,6,47,-48,24,-22,-36,42,6,35,-2,-19,-12,1,-21,21,22,19,-16,87,13,-22,-6,-10,1,3,7,30,15,47,35,19,30,54,4,70,-43,2,35,-58,0,21,25,5,-16,-3,-46,29,-14, 
  /* [28][0][][] */ -8,-34,-15,-12,25,28,-21,-30,-75,-7,-95,5,9,19,-21,62,2,-48,-77,24,-22,-16,-33,-13,-44,60,-34,-1,29,-39,-2,-34,8,15,-17,69,-13,-4,-13,5,53,39,10,5,-22,-46,14,21,6,22,59,-8,57,55,-14,-29,95,32,106,84,-110,-17,-6,-15,21,40,3,20,-51,-58,-37,25,-53,12,-87,47,-60,25,36,-2,22,-42,5,13,-2,-75,17,13,-27,-11,52,-35,63,-33,13,46,61,23,45,35,20,32,60,-20,-16,127,9,-6,17,10,42,48,-11,35,1,2,3,-67,-32,-50,-8,-17,-26,3,37,-4,59,6,-9,-58,81,-18,65,23,32,0,7,21,-14,24,-110,6,-36,32,56,-27,-48,-32,17,-24,-49,-17,-35,-19,51,-6,-35,-42,36,101,23,1,34,52,-54,10,12,-22,-47,-69,-8,-26,-17,-4,9,-28,-10,-89,68,70,2,-20,69,85,49,-16,-7,54,25,45,-37,52,-37,22,34,-14,11,-25,-18,26,0,-34,16,-8,46,-70,24,25,-8,50,68,-74,0,28,-15,-3,-6,-7,-24,-5,-39,72,-18,-25,19,38,-5,4,17,-36,66,27,56,-35,-34,-35,31,-15,33,25,-30,38,24,-36,34,1,4,-71,27,-16,28,-14,-27,-1,73,-3,9,-6,-45,-48,22,18,67,46,9,-8,16,13,-51,-3,-2,-18,51,38,53,-45,-22,-18,3,37,-10,9,13,-20,13,-67,5,22,16,-47,12,-9,-5,-77,-72,-72,34,41,-33,49,-29,44,-45,40,-50,0,8,-19,-34,41,62,-27,68,-4,36,50,48,57,86,-104,-4,-4,36,-56,-15,-2,38,13,26,35,34,-41,73,-74,26,28, 
  /* [29][0][][] */ 16,-6,12,34,-41,-56,-4,8,56,-35,-61,19,-32,71,17,-28,-10,27,-42,7,65,-8,-122,-19,-49,-4,10,57,-12,-85,-48,-15,54,2,-68,50,-66,-55,-59,-60,5,42,-29,64,-73,12,38,-3,80,-79,58,60,-17,-28,39,25,29,-56,14,-78,-1,-32,63,-50,-56,-22,-50,23,-20,20,21,2,64,54,25,-97,3,46,-26,-16,-9,-118,-38,22,1,34,-58,-16,40,100,39,14,-11,-54,-81,-22,8,13,-103,37,-8,-29,-4,-37,-62,0,31,68,-49,18,-81,-73,27,-8,34,27,-27,79,-18,35,-94,29,-19,33,-100,74,-8,67,-41,24,51,63,-100,21,-7,31,19,3,-65,59,72,-88,-18,-27,-11,-10,7,50,16,44,-27,6,20,-33,-103,41,-33,39,-13,-65,-16,96,2,-8,5,-25,-5,-40,-55,-14,-40,20,-22,-1,-10,-30,1,-32,-27,-29,-33,57,5,-127,-19,-1,-60,-72,-5,48,-6,-3,27,32,74,53,0,-4,-1,-18,45,17,-22,-1,18,-77,52,27,37,22,-19,-43,-11,-5,84,34,40,-40,63,-25,-25,32,-16,10,-63,11,-20,43,46,91,-29,39,-34,-37,29,-4,26,71,-22,13,57,-8,-22,83,-15,-33,-69,30,18,17,79,54,-88,-54,41,5,-32,8,-18,-69,-35,-5,49,-55,-64,-17,-5,-40,-3,-24,37,-54,-96,41,-12,-22,-70,-30,8,-31,27,11,77,-10,-46,39,11,-25,8,56,-55,9,25,-32,111,44,7,-87,-7,-14,38,34,4,15,40,71,-24,63,9,-23,-21,26,-30,49,39,-60,-7,-33,0,7,90,-51,-5,-24,56,60,20,4,7,-94,-30,83,1,-88,-66,-44, 
  /* [30][0][][] */ 86,-13,-69,53,39,39,-24,-39,-55,1,13,-29,76,-7,66,-71,19,12,29,-33,5,-17,-33,-7,-25,-33,-11,-2,-21,-32,68,22,3,15,31,51,35,-15,-63,-25,55,13,-5,-63,-33,9,102,-5,-54,9,54,16,-94,-20,8,-53,18,-24,-51,77,40,53,-34,-8,-19,6,44,27,-30,-123,59,-37,-27,-45,19,-67,-4,-12,-61,26,-17,25,34,23,-36,-57,-127,-21,-64,24,-40,-37,-20,8,6,-64,-65,-29,115,-2,52,55,86,-43,-47,-32,-48,-2,-4,7,20,-5,-93,0,12,-35,42,27,12,6,-2,1,-20,16,35,38,-42,32,-21,-16,-98,-42,-40,12,-33,59,21,-12,-24,-27,18,44,44,6,23,56,9,91,-77,12,-25,-39,-51,16,-76,-26,-29,-55,2,-37,-16,-9,-1,52,-13,-17,-47,-12,59,-42,1,-23,13,49,-52,-2,34,63,-32,-81,-42,-38,-11,7,-5,-46,-38,97,-1,80,60,45,-11,-4,18,0,16,14,58,17,24,12,16,97,-52,-13,-40,23,-2,-10,40,36,-47,-46,-39,98,-12,79,-52,25,9,49,-7,13,-23,31,4,-15,80,1,-5,-27,-31,-10,-47,66,18,-27,52,6,-10,-41,7,77,32,-36,-11,15,32,-45,20,9,-61,89,-65,84,-4,56,-65,-21,15,41,7,62,44,33,3,-73,-32,10,27,5,13,-61,-26,33,-19,31,40,13,77,8,42,10,5,-28,-16,4,7,-18,-2,-15,-33,17,-92,-81,-53,23,16,36,-33,34,-12,26,-57,-38,29,-40,9,-39,-10,47,-29,-45,71,-3,-80,33,2,63,48,101,49,-47,16,13,-59,-40,-32,-18,-70,5,-83,-7,-10,-13, 
  /* [31][0][][] */ 39,-48,-37,-43,1,-23,-69,-49,-34,-48,-74,-9,63,21,-44,38,-28,-25,4,-6,-8,-7,-27,-46,-6,-42,-5,-15,10,-18,-2,54,68,-19,-26,-1,13,17,-15,38,-61,-29,16,-39,11,-56,20,72,6,71,-45,-69,67,11,-3,-23,49,29,19,29,65,-58,2,62,0,4,61,-42,14,18,-12,-25,-6,11,39,-102,-25,-2,16,-127,9,61,-35,-33,40,10,-5,2,-52,-13,-16,-12,87,14,14,25,-40,-16,20,12,2,49,25,-5,-36,11,13,4,53,-55,43,-11,23,-11,-66,-53,50,-16,27,-11,-20,-31,91,8,62,-8,-73,-12,6,-9,3,64,13,-57,16,-13,-58,18,40,5,55,10,17,41,35,33,11,19,-48,26,105,37,71,41,41,-61,60,-19,3,27,-29,37,11,47,-11,-14,10,60,-46,19,-1,8,-45,9,30,27,3,30,98,5,14,-6,-22,60,-2,-12,-5,45,-52,-2,-60,5,-78,-18,-20,-47,32,13,19,-13,-54,40,23,-9,-58,-44,37,12,-115,-65,22,25,-57,9,-1,-2,-25,25,51,-39,-20,25,-17,32,29,4,-30,64,14,-29,-29,60,19,-12,10,1,-57,-20,-4,1,-57,-2,34,10,30,-1,46,-49,51,6,-31,82,5,37,-11,-15,-35,18,0,17,39,-15,32,-24,-42,43,82,-32,25,-88,26,-32,-84,20,11,25,-23,56,-11,-8,1,-23,-99,-1,81,0,38,-27,34,-9,-11,8,16,-20,-30,-55,-48,67,-104,40,37,2,-5,-59,-31,-25,12,-72,-91,24,-38,5,8,-37,65,17,-49,16,13,-87,57,-35,12,-88,-52,-42,-81,54,-35,3,53,-50,-17,-13,9,-2, 
  /* [32][0][][] */ -43,0,63,-9,-18,-28,47,121,-3,-5,35,57,-52,-23,27,29,-27,-17,-28,3,44,90,-34,-35,56,75,29,-18,12,80,-43,49,-52,20,-91,-36,-2,-28,-11,-79,-59,-17,12,-56,47,-72,-56,-120,-47,67,6,-62,-34,64,67,20,32,16,-71,-108,76,28,13,-45,60,5,-23,24,-13,28,-56,13,-68,-9,5,69,-51,14,127,3,-12,-25,62,-92,-5,-30,73,40,68,-15,-82,44,-7,-27,10,31,-6,81,-8,-12,-100,-48,61,23,-33,23,-53,-18,-77,30,-12,17,-11,17,54,7,-23,-72,-27,26,21,27,-25,-29,-41,26,-43,-44,-67,-13,-80,-2,44,6,49,-42,-37,56,30,-12,5,80,27,62,27,-50,-8,-39,17,-72,6,-39,34,-39,-65,53,11,-36,-25,91,-19,-31,78,34,32,14,8,-21,18,21,76,-44,25,41,-75,50,24,80,3,43,51,46,14,-87,7,29,-58,24,47,-15,-46,-68,-29,22,10,13,-49,52,-4,-81,7,-35,101,-83,-12,-32,29,0,20,61,-108,-2,-27,-85,29,16,69,-23,36,-34,-11,-82,92,-52,4,-29,14,-15,60,-24,-8,43,10,-26,-13,-6,22,-22,-20,47,-3,-12,-31,-21,16,71,-15,-32,-7,25,63,-93,54,-38,-19,7,-31,33,-10,24,-75,-14,-4,-14,-35,-9,11,60,-37,29,-39,28,-8,38,-27,-18,29,66,33,-49,26,61,-61,24,-50,-32,-9,-5,10,27,97,26,-47,37,-35,6,-21,-14,13,26,74,-14,-1,29,7,-7,-96,-26,-3,-4,84,-36,29,19,-23,-7,-4,83,-34,16,24,9,20,-26,99,-23,-22,86,23,-54,-26,36,11,69,12,-45, 
  /* [33][0][][] */ -32,37,19,-35,-24,20,12,25,9,-44,43,17,-67,-5,10,-5,-32,-6,-16,-24,37,74,31,-30,37,37,26,-27,24,52,34,24,-64,-20,22,3,28,-2,-13,-13,-43,-35,-23,-12,-51,-47,-40,0,58,25,-41,-8,22,0,-4,2,17,14,-15,-23,56,-33,-2,-53,33,-34,-4,-29,-30,3,0,2,-30,30,55,9,40,19,39,-76,48,8,-48,-6,18,1,51,8,39,23,-82,55,-49,-59,22,24,8,25,11,33,-53,-35,28,33,-23,7,-32,-31,16,37,74,-32,-23,-37,52,8,-23,27,-21,16,-20,41,-7,-22,-25,6,6,-3,-29,-50,-16,-18,34,-20,12,-20,10,31,14,-17,40,18,15,2,-34,-12,-18,-64,67,6,30,6,-58,40,6,16,-40,-10,-26,-12,19,29,-24,-2,16,8,-21,-13,-57,-6,-37,-3,38,41,-10,49,-75,27,4,16,23,-26,13,-37,-31,48,11,44,22,-21,11,-28,54,42,10,-20,-46,28,-10,-54,-19,-7,-11,-12,-43,11,33,15,5,-11,-10,4,8,-18,41,-17,19,-5,-15,10,-32,-56,60,6,-21,12,-3,-71,27,-32,1,-26,0,-56,25,-24,-1,-48,30,14,-35,23,-5,-50,-40,127,8,-12,-22,-8,14,-41,64,-56,-20,28,16,-7,3,47,-29,11,-2,38,-47,21,28,-16,42,13,-3,37,36,29,-22,18,-1,2,20,13,-17,29,-33,-6,-39,28,-43,-55,28,37,17,-37,-36,-1,50,-7,33,-8,-21,35,-16,-19,8,-86,24,12,25,55,19,20,-24,-49,36,1,-36,-63,-14,9,-56,-36,30,1,46,57,-39,32,-28,-14,-19,26,-30,7,39,31,-2,-3, 
  /* [34][0][][] */ 2,96,60,-57,-5,-5,17,1,37,-40,-48,-29,-38,-7,47,-28,38,-9,-27,96,-29,8,20,-44,71,-28,11,-14,65,94,-12,35,-34,29,79,3,-20,68,24,-95,-5,-100,68,-11,2,10,-72,-18,-33,18,21,17,55,-9,57,-34,7,2,33,22,-24,-11,-5,-46,82,14,18,10,-83,-15,-21,-34,-48,-2,-6,69,33,-1,75,-36,-50,56,-26,-71,-33,55,13,46,11,61,-73,93,32,-43,-10,-48,58,40,2,22,-22,-32,8,5,37,-1,89,11,11,-3,9,54,43,-39,24,-11,34,3,-12,76,-33,-30,33,44,9,3,75,21,38,-59,-2,-10,3,-17,65,30,-83,-24,-4,11,0,65,8,20,-15,1,32,59,2,3,33,39,-22,-15,-77,7,-3,-14,45,28,-2,17,55,6,-127,-17,-41,42,-24,22,-23,40,32,4,-79,60,-14,25,-47,-58,-11,15,-10,3,36,3,-17,13,4,35,-40,-24,-10,6,42,-25,-95,-48,-77,-31,54,-57,2,-31,-4,-29,66,57,23,-21,-45,-26,19,-15,-42,-70,-45,-26,37,40,-52,-15,92,-20,64,5,-80,-38,27,46,-4,-22,52,37,-35,-58,-24,46,-54,-61,-63,21,27,-5,-52,6,-68,-18,-14,95,-17,11,-25,27,-29,-1,-46,14,-29,-21,-15,-20,32,-74,61,-45,18,9,3,7,36,8,-20,42,-21,33,24,0,28,-11,1,8,43,-3,-23,-47,20,-35,34,-76,-18,28,32,-27,7,-27,-21,65,14,-5,-10,-66,-65,-11,-42,-13,-19,3,8,26,21,-4,-4,78,3,-48,17,-5,-11,-50,10,73,59,36,-14,-31,6,-50,7,60,34,68,-67,62,30,-24, 
  /* [35][0][][] */ -5,45,-3,-13,-36,-69,7,-36,-46,49,43,-8,60,-4,-58,31,-56,11,47,-12,-60,-93,11,-25,-10,-6,31,-3,-9,-32,16,55,5,-6,41,-27,43,13,15,43,-68,-14,-47,0,37,71,46,-5,5,56,47,40,70,-65,30,29,47,-61,-11,-1,-7,10,-9,18,-68,35,46,-11,-40,-46,-33,-31,8,10,-65,-1,1,-26,-18,22,-74,-48,27,4,-10,-25,-45,-5,-52,-61,10,0,-17,47,-14,-4,-69,-51,5,41,24,54,7,-127,52,-30,18,-24,-4,-33,29,-51,34,-18,-59,31,32,-23,61,-5,46,-60,52,28,-3,-92,-10,-39,23,20,49,11,-81,-54,-28,28,72,-45,-27,29,-62,-49,-2,10,-34,98,-27,-9,-14,-80,87,46,71,35,19,24,-4,16,-43,-13,49,-43,-21,-11,1,-9,-23,-51,-14,-31,17,17,15,42,44,-32,32,-48,-36,61,-45,-15,-100,31,-8,-9,60,1,-62,28,49,35,13,-42,10,-18,22,-33,42,67,-5,-40,13,43,39,71,-30,-70,-58,-10,-33,-88,-66,-11,-9,-54,50,33,-32,-6,2,19,-65,21,24,17,-1,24,-4,-6,-2,6,22,12,-43,57,38,40,-6,35,-66,81,52,31,9,55,66,5,9,5,-45,95,1,6,-8,5,41,12,-18,39,-20,59,58,-65,-1,4,-11,-24,-11,28,-32,-5,67,-16,-40,45,-6,45,-16,-54,-14,-64,-24,5,18,-66,19,-12,3,-44,-51,46,68,-39,21,21,-35,-92,-36,-69,-18,60,21,23,13,64,-56,-55,13,5,14,2,41,40,8,-66,71,-18,33,-16,6,33,-22,-43,-49,94,53,-3,59,-67,-2,-40,-50,-68,-53,37, 
  /* [36][0][][] */ 1,0,-4,-4,21,19,-21,39,2,-41,50,13,42,58,-14,58,-12,-27,-5,45,-37,7,60,6,50,-18,-17,23,-13,52,55,-50,52,13,-41,-8,-33,26,-63,11,-66,-34,50,-11,-3,2,10,3,5,-1,-13,45,-24,27,38,-20,38,-66,-57,55,-35,-30,39,-31,-11,-14,-15,37,21,-22,22,10,-89,-53,21,-12,-17,127,40,88,28,4,101,-6,30,1,37,-53,-26,-65,41,-10,-47,81,35,7,13,12,-1,-33,97,-4,30,-5,-18,-54,8,20,-17,-32,17,-39,-26,60,-51,-42,16,3,-15,-11,20,-37,-62,-1,-15,-32,-45,-10,12,-7,-27,50,17,14,-27,-76,-45,10,-3,9,12,15,-13,-17,17,-21,-5,-64,49,15,-21,-18,-16,-11,-49,19,-47,-71,46,-4,-10,-2,22,27,1,-11,-5,-22,-28,20,28,76,2,46,-50,31,-1,27,33,-12,30,19,-70,28,-35,-17,6,-2,-11,-93,37,20,-9,-20,-23,-39,-64,-8,13,-23,-53,-1,35,26,-34,14,13,-15,1,47,-11,19,43,2,25,-101,37,-68,-72,25,16,-44,-6,4,-15,22,24,-2,-11,-87,60,-43,-9,-21,-4,7,7,23,90,61,-2,-30,13,11,18,17,-10,-33,-5,-12,-16,15,61,-30,70,18,-35,12,-48,-24,-43,-18,-68,14,40,-63,50,-28,-44,-6,-38,16,38,21,-28,-1,-6,36,-3,-49,-5,7,53,34,3,-5,0,-23,-38,-45,20,29,-50,27,-55,16,37,-20,-91,21,52,-9,-28,-59,-6,-11,28,-16,-18,20,-60,5,-52,-19,48,15,9,20,22,22,16,44,57,-6,47,-24,-33,-26,6,14,4,-13,-10,-5,37,-2, 
  /* [37][0][][] */ 20,-22,29,-1,78,52,-2,-82,75,17,-62,24,58,30,-45,82,-2,44,26,13,-31,-98,59,-10,-22,-23,7,-126,80,-95,-47,-7,-5,73,-2,34,-5,3,28,-66,4,16,-34,16,33,33,22,81,-15,-22,22,47,22,32,55,-32,-95,-22,1,113,23,0,36,54,19,63,-6,-95,-9,-3,-29,41,-32,-46,-20,4,26,-77,2,68,16,-6,7,83,-23,63,-83,-37,-83,-53,55,-1,52,10,-56,34,-5,-30,63,-26,78,-7,3,-38,4,35,96,39,33,-59,48,18,-62,30,-91,-88,28,12,-23,13,36,-53,-33,-30,-7,28,-21,-16,-53,-11,-19,30,23,67,4,30,35,-64,10,-7,-102,-22,-12,-53,13,-14,-82,94,-4,29,-38,-11,-46,-1,-78,-18,29,-50,34,41,22,-22,-37,-19,-36,-84,43,-7,58,-60,-14,7,-21,-52,11,-51,50,-40,-11,-58,-78,-1,25,64,26,-52,-2,98,-2,50,-4,-19,32,104,-37,33,-43,-49,19,70,-67,-7,-77,-38,-6,79,-59,31,-34,63,61,-61,43,-16,29,-2,-58,-28,-17,7,-44,11,-44,41,-4,-14,33,59,-41,29,87,51,24,-23,-46,-39,-1,63,-54,49,7,57,4,-15,-70,-54,1,-54,127,-19,-54,11,-17,72,31,48,-102,54,-2,-5,46,78,80,-13,1,56,54,-3,13,97,22,-35,21,-80,97,12,10,2,-69,-63,-97,-40,-73,-21,8,-27,62,-47,-30,-15,-81,46,63,-14,-72,-29,-24,32,2,44,58,5,14,-38,12,-17,50,-49,14,-50,-12,86,-34,-74,19,1,0,-2,60,75,12,13,-34,-72,45,-9,-9,-1,7,38,33,-36,-73,-32,-13,-40, 
  /* [38][0][][] */ -82,-16,-15,-10,-8,6,17,-35,9,-54,26,38,-4,95,-16,27,-25,84,-13,-48,36,35,-17,57,80,15,8,-40,-8,-7,-11,-8,72,13,-17,44,19,30,-14,73,72,4,-59,57,34,-83,-15,26,33,28,4,-66,-79,34,-4,-61,-42,62,-27,54,28,36,-76,36,-36,7,-108,-63,-22,-44,-23,22,-49,-4,-6,-40,45,-12,-67,28,-22,8,12,-20,-12,22,61,-34,-54,20,-10,-54,26,-44,46,-19,3,-15,-64,60,4,7,10,-10,-22,-15,-23,-59,-15,30,-11,-16,-3,-17,-22,16,-25,-76,-105,-98,17,54,-121,7,51,-5,-43,41,-86,15,39,-59,50,53,34,13,57,-6,4,-5,-9,8,-60,-54,16,12,37,-50,-35,119,-33,-16,50,-70,72,-33,68,-1,-120,21,56,-10,-15,-19,43,-27,11,-6,7,-4,80,34,-77,-20,127,-36,-61,12,9,-8,-5,-86,22,12,11,70,-12,2,-9,57,45,-30,21,-36,28,-34,-46,38,-23,-23,79,90,-11,-2,7,-16,38,62,78,59,18,17,-70,-19,5,-13,-19,-102,-44,-60,39,21,-27,68,16,-8,82,51,24,-16,-15,50,-48,-12,-34,24,-48,-109,2,-26,72,28,40,-71,29,-29,-12,33,2,-38,-3,84,-26,-29,-39,43,27,59,66,6,40,3,11,58,-37,42,31,8,71,-92,13,32,8,7,-2,33,-34,53,2,86,30,-28,22,-26,7,9,-37,88,3,41,-41,-100,16,-34,-22,34,-65,-50,10,-15,16,-15,72,62,61,6,15,18,-58,69,44,-12,64,-44,31,43,3,-61,-38,-22,-44,-63,-22,30,-47,53,-30,-27,-52,-3,-10,-6,-3,-33,42,53, 
  /* [39][0][][] */ 74,0,-17,-2,2,-3,-12,-51,-52,73,-11,11,103,-35,-39,-53,1,23,15,4,-26,-18,83,33,-43,96,7,59,39,85,41,-22,-94,-38,-105,-23,1,-39,54,90,59,80,61,-80,-12,-29,61,70,125,31,11,-23,-35,73,-37,-19,-106,127,-51,2,-72,33,-23,-28,-34,-53,-58,-3,-33,7,27,-10,86,-64,-26,19,22,-15,28,33,54,-26,22,106,-62,-35,9,-20,8,76,8,28,-127,65,-54,-43,9,-31,-123,11,26,73,27,44,-39,22,-17,40,102,33,3,75,-54,20,-49,67,9,86,-37,43,-12,55,6,-5,105,-95,9,70,27,-19,31,114,-66,24,-56,57,-16,-45,-24,-57,-81,71,-16,-41,-54,18,0,-50,-24,-11,-85,-20,8,-34,127,-13,-83,87,-23,-105,38,19,4,54,39,25,9,-75,5,35,-47,-38,35,-37,-14,50,70,-48,-53,-77,37,-33,-55,22,12,-6,-15,5,37,6,-40,49,-32,-33,53,-10,34,50,-11,81,18,8,-49,-49,-3,-72,-72,93,-28,-10,46,-14,98,17,29,5,-52,-76,-35,61,-94,79,0,-64,-6,23,58,33,5,-8,50,9,32,114,13,-74,-116,2,97,-74,-4,-30,3,-25,-1,-45,-33,-28,-39,60,-3,-70,-41,-98,-17,4,-67,-30,-22,2,64,-53,-76,47,-3,-22,13,-66,-70,-92,-18,-60,-5,111,82,-34,45,-26,55,59,1,17,2,-19,-33,10,-14,39,22,-75,-11,24,-16,54,62,-107,14,-15,30,37,55,40,-86,-29,-19,39,92,59,56,-18,2,5,9,-20,0,84,1,-12,22,-33,1,11,13,-27,-38,-81,67,-30,-115,47,-3,-16,35,-82,-11,-8, 
  /* [40][0][][] */ 20,-1,-11,46,59,9,22,33,-4,6,-76,-7,-21,-11,-24,-14,-27,33,41,5,-2,-19,-21,69,-56,-18,-23,-5,44,-38,45,-18,-15,52,-1,-12,-17,45,19,-108,-17,23,4,-24,7,15,7,-46,58,23,59,-121,12,-49,-46,34,0,3,25,30,76,44,-77,73,13,-32,-26,24,22,52,-96,25,-127,-14,-6,-48,-42,-20,20,89,34,-40,-56,-24,-50,22,-29,-24,-82,8,-6,-28,8,27,-41,-72,26,-38,106,25,-22,-1,36,-33,8,64,8,-53,-20,-56,-72,-39,-33,8,-66,8,-20,9,-27,-49,-2,44,53,84,44,61,76,-30,-23,-7,-66,1,-34,-37,65,-6,2,-9,-34,54,40,35,-6,-7,0,-45,-13,32,-79,-16,-17,36,74,27,-38,-37,-16,57,-18,20,22,-12,-22,-30,58,-1,-20,-34,75,-85,-7,-28,36,-38,54,-16,30,-55,-37,2,-61,16,78,43,-73,-34,11,-14,-23,49,-15,3,29,36,7,-31,36,-22,41,30,3,65,-50,86,9,24,12,20,26,-39,7,24,-36,12,25,3,-37,41,21,-12,-26,51,18,-6,-25,51,-11,89,-3,79,29,69,-79,-27,8,-78,47,12,-56,-21,63,44,7,5,-80,13,-37,-44,76,-61,-15,-51,-45,-22,2,54,8,87,12,11,43,81,63,60,20,87,54,-26,-16,-81,74,-36,8,78,25,39,-49,-41,-24,17,1,-2,27,10,31,14,-4,14,104,53,-46,19,18,-7,-100,-18,-50,-53,34,60,6,24,72,-44,-11,-3,14,22,24,-30,-32,33,-33,-23,3,58,20,-18,-6,40,56,-8,-76,-2,-40,11,-28,4,8,9,8,-2,-56,64,-64,-32, 
  /* [41][0][][] */ -5,-56,-31,31,38,-54,-2,-19,-10,-28,-24,33,58,-37,-23,-42,0,-26,6,-40,-100,-49,-28,1,-25,-45,39,41,7,40,1,9,-15,61,-6,5,20,-13,-11,1,-7,42,2,38,-18,3,30,-2,51,2,-1,48,29,29,-41,22,-29,15,-8,57,-42,0,18,-19,3,-3,-3,-57,52,-32,31,2,67,-34,-34,53,65,-13,-44,2,-59,-19,15,46,62,-7,-14,53,-44,20,-25,20,43,51,-23,27,-54,50,-30,-15,9,11,-17,5,-34,-7,-38,12,-26,-15,11,82,16,-15,-25,2,18,-38,1,-23,6,9,34,13,52,35,-63,127,1,38,20,36,-22,3,10,40,-27,11,-28,-19,47,-33,-19,-22,-7,-25,46,-1,31,29,27,-48,25,8,36,-47,-48,-5,-39,15,32,58,0,1,-10,82,-77,29,22,-4,-27,-51,24,-29,-26,30,1,14,-11,-42,-16,19,-5,69,15,-16,30,29,20,41,-73,19,12,-77,16,42,41,-62,11,20,10,58,-48,-2,-14,33,-11,9,-25,-18,9,6,48,-39,-14,2,-55,65,61,14,-39,7,-32,-40,-9,-10,-4,27,30,20,-39,-31,61,-26,10,-7,-23,-11,36,70,-10,-19,-4,9,-51,-51,13,-37,-6,2,-17,-15,51,29,-22,4,-69,0,-9,-8,-4,11,32,9,40,-45,-72,38,-29,21,-53,1,-36,26,41,-8,9,-16,15,-8,1,-12,40,-15,-11,-8,44,31,-18,-48,-1,-11,-8,-34,-31,-14,14,-30,24,5,-36,-14,-31,36,-2,6,38,25,38,21,17,28,26,-7,68,-30,-11,-75,-10,72,5,-29,-21,-33,-39,49,62,57,38,57,-12,-73,-11,-43,42,40, 
  /* [42][0][][] */ -40,-6,-7,-9,23,23,-26,-44,-64,32,9,-11,-57,-15,1,19,-7,-6,41,2,35,27,33,21,9,16,35,10,15,15,-54,-50,22,-26,22,2,-11,-27,18,-14,-34,-45,-3,28,1,16,13,-52,36,67,-62,26,-21,24,5,-41,48,-41,3,11,67,-1,-26,-7,28,29,47,28,-23,-27,-22,6,12,3,46,-17,77,-38,-16,57,127,-36,-33,-54,-22,-39,3,-10,30,27,-42,-31,-28,57,18,10,10,7,-16,23,19,29,-30,17,-26,-32,-8,-55,-12,-29,4,-8,-51,-62,11,-23,-35,-35,-17,47,7,-28,-41,8,-89,3,-19,10,6,-25,-15,12,13,-22,9,-41,-25,-51,3,18,12,18,-8,41,48,-13,-56,-14,15,53,54,66,39,-18,-6,17,-25,16,53,-14,16,26,-25,2,10,26,-5,-62,36,-29,-37,24,19,20,1,48,-10,7,-29,-5,25,16,2,56,-2,21,53,13,-3,17,34,9,32,-17,89,20,3,18,28,-2,-43,-17,15,34,81,81,-16,-1,3,29,-16,45,-9,-7,75,-2,6,-9,38,0,29,-6,-57,-39,-35,27,-12,-44,-34,-24,18,-7,13,63,-14,13,-23,32,-2,24,-49,12,-11,-27,19,17,37,-3,-10,20,-58,0,10,-8,-74,83,10,45,4,12,-17,-10,-15,-45,-20,5,23,-40,-25,19,-42,31,14,-27,36,28,-9,26,-64,-41,56,-2,-6,-6,-9,22,28,-48,-32,64,17,-24,-1,-28,-55,37,17,47,-36,13,-25,53,55,-9,20,13,5,-49,-5,-21,79,108,73,4,-30,-63,23,-24,6,-58,7,-35,-39,42,71,-31,-16,-11,49,32,-7,14,-10,50,21,-31, 
  /* [43][0][][] */ 27,1,-43,24,20,-12,42,0,68,4,-3,-45,23,17,-39,22,-54,20,9,92,-11,-59,10,20,0,11,34,-35,6,-51,53,-18,28,9,-57,-15,-36,-5,-56,-45,-27,29,1,22,0,-51,34,8,-31,30,72,-80,-63,19,-16,-13,-96,10,3,-14,38,-76,16,-16,-64,37,11,17,-28,-27,13,-1,32,6,-49,-53,25,28,-8,28,-42,-17,10,25,-47,30,-65,-42,-19,61,33,-10,-35,34,-66,-38,-3,-16,47,-19,58,-31,16,4,-65,-67,-22,4,-8,7,-55,-46,33,-19,38,62,-14,6,-15,24,-31,-4,29,36,6,77,-80,38,12,-14,-5,77,-27,60,-7,-2,-68,11,3,4,-25,-98,32,-12,32,24,64,28,-5,56,18,28,24,21,-70,17,21,-10,-24,-31,30,-27,-31,7,-10,18,55,27,37,35,-13,-23,-3,-31,-53,-7,21,-24,-54,43,10,-10,-39,55,-28,-51,-49,-36,-21,29,-13,-23,43,22,10,29,-27,-53,-8,39,11,0,-43,-45,14,-19,-4,-7,-5,21,1,5,-19,4,-7,34,-71,48,39,13,-8,53,-35,57,-24,69,44,73,-35,0,51,9,-32,28,-32,42,-6,50,24,73,68,32,-40,127,-18,-56,8,2,35,-33,-16,16,0,49,-15,43,-31,43,-28,-1,-8,66,-1,61,15,-35,36,-24,16,-32,-21,-16,-72,-4,42,33,-17,6,-19,-61,-21,-12,-24,-4,52,16,19,30,7,35,-76,-40,-16,8,111,45,19,25,58,15,23,16,-2,-6,14,29,24,-50,41,-15,3,38,-61,5,48,-18,28,-19,49,59,6,35,-23,-17,36,24,14,35,6,1,-33,-55,-20,-20,41,-8, 
  /* [44][0][][] */ 75,-30,-69,7,47,-34,-7,-66,42,-19,-57,31,48,-21,39,0,27,99,33,-9,25,-57,27,48,2,-10,-34,88,-78,22,45,-62,22,14,-42,16,-54,-11,-33,22,45,32,18,-11,-8,40,-11,-43,96,11,7,46,39,-77,-12,32,6,-50,51,46,43,23,92,-39,-45,19,72,12,43,22,-15,12,-2,-63,36,-63,-36,44,-4,35,-5,89,-1,6,24,-5,-41,-2,17,24,79,-13,-29,85,-36,7,42,-22,-35,-80,14,-32,6,-7,29,4,127,26,-9,-31,57,30,34,-16,-58,23,-22,25,-6,-30,-14,22,44,3,66,-10,-46,9,29,54,-46,19,-82,55,0,53,4,-22,-47,12,38,14,-31,10,-29,-32,24,72,4,36,-5,52,4,-35,-7,-13,-20,25,28,-41,18,-56,19,-78,-10,-53,-30,-7,-23,-46,55,2,-63,3,9,-87,26,-55,-39,-1,-15,67,16,28,-72,-21,-12,-70,3,0,24,14,-2,20,-49,8,7,-26,-31,69,-37,-28,-51,-7,-13,-8,-20,-6,3,-13,22,0,-40,64,-50,-46,20,30,-23,35,-49,52,-85,39,-30,29,6,5,-16,20,-36,45,-26,-33,-23,21,22,35,57,38,32,-12,-21,28,35,-45,17,58,20,-42,30,23,-1,-8,43,7,8,-61,-40,-71,41,3,-29,-14,35,12,-41,-34,-93,-43,-26,-45,-26,-18,-60,-6,13,-4,-51,-44,57,8,-106,-23,31,-17,37,1,11,-57,-53,10,0,17,-92,77,-38,-18,-22,1,32,-41,-29,18,14,23,-25,5,16,-46,55,-15,-42,20,16,27,-7,39,-29,13,10,49,68,-27,21,44,24,26,-50,6,-30,35,-1,-38,18,-8, 
  /* [45][0][][] */ 12,29,-10,-27,-5,2,-37,-9,-58,-46,2,-84,44,0,19,-42,61,-40,-18,-15,43,15,10,-18,29,45,-54,47,-42,-7,-7,11,48,-20,16,9,29,25,27,16,13,4,0,10,-19,-29,-23,11,-50,19,-36,18,-32,62,-3,9,52,3,-8,-110,-37,-7,-35,15,-3,-25,-81,16,-54,-47,-44,23,2,52,-7,71,9,14,43,-48,38,21,-42,-55,52,-43,-39,-9,-8,8,19,22,-1,-23,5,53,-19,56,49,-18,-42,-7,-6,30,-25,9,18,-4,-25,5,33,15,-68,-35,24,2,32,-52,46,29,9,-8,1,-16,25,-14,14,59,-25,48,35,-127,57,-51,47,12,6,32,-5,-38,-8,2,15,-8,46,2,-16,-35,23,13,20,-28,41,22,-23,21,-27,47,12,-9,-24,-24,35,-6,-32,6,-38,2,3,33,-2,22,-16,10,-30,-32,-12,-21,15,46,59,-41,-25,22,-23,9,-20,58,12,-7,12,9,27,4,-36,-3,-30,-28,-5,-11,7,17,20,-57,-6,-7,18,38,60,12,51,-5,-83,-93,-70,14,21,-35,-16,-30,8,-52,15,12,-37,16,6,-27,19,-23,-5,-33,35,-50,-1,22,37,-23,-12,-7,-5,39,-3,-1,-42,10,13,14,-10,5,-23,-2,1,18,-1,-32,-21,47,9,-34,-11,2,-14,-29,1,-58,-18,-15,55,-7,-55,-14,25,24,-31,-26,29,-4,48,29,-14,33,-32,15,-38,-30,16,-30,29,-6,48,-49,25,-74,78,-21,22,55,-33,38,14,2,-45,-75,19,-19,51,-18,8,46,34,-85,15,12,-32,51,38,-4,-12,-37,-8,-42,27,-3,37,-24,3,3,11,62,-63,29,6,-12,15,-25, 
  /* [46][0][][] */ -6,-40,34,-11,24,34,17,-33,44,-11,-2,20,32,59,-41,-17,25,-27,-32,-6,18,12,10,-8,56,-15,-2,-79,-17,14,5,-43,14,-2,-7,35,24,48,-8,9,-3,4,21,57,4,-25,-22,52,-20,15,-59,2,43,-27,35,44,48,12,29,57,34,-3,2,58,-23,33,-42,-27,-30,127,47,-1,-85,9,10,-39,51,43,16,-21,6,-5,40,11,-6,19,10,-34,-42,19,-27,19,38,32,26,28,31,32,-32,25,-10,29,22,10,-66,32,35,-12,-4,32,-4,3,34,-25,61,11,6,8,-25,-11,42,2,-49,-41,30,-8,-65,-39,-5,-9,46,-49,-44,23,39,5,-21,-7,-6,-51,-51,13,1,-35,23,-25,6,35,6,-8,-28,-10,16,-10,52,12,-11,-22,-43,1,53,-47,-10,-31,-59,31,27,35,-32,-40,25,-25,57,10,12,-42,-11,-32,21,35,52,-42,5,5,27,21,-20,20,25,40,63,-33,18,-97,34,-19,37,-14,-41,-15,52,32,29,-26,-26,30,36,91,19,7,46,-33,-59,34,3,-62,88,-9,-20,-20,-7,25,24,25,3,-46,-7,8,22,-60,18,-25,50,-3,34,69,-7,5,-18,15,11,-12,-34,-33,-15,10,49,-4,4,28,-5,15,42,-22,-23,-16,-4,-28,18,3,45,-14,35,-13,45,-23,12,-30,-80,1,-40,13,23,-31,-54,24,-106,81,-27,5,3,14,11,40,12,-58,1,44,6,33,-10,2,-2,8,-17,4,-1,-26,7,-44,-26,25,13,-9,42,-9,-5,5,-6,31,70,-6,-2,28,60,7,57,-19,36,14,49,-56,24,-13,-17,35,-18,54,-23,71,-38,18,35,-33,-19,0, 
  /* [47][0][][] */ 63,45,-43,71,-40,-40,21,-58,-24,-127,-68,-64,68,30,-38,-12,-2,-82,-45,-4,-21,-48,26,13,-60,-100,-60,-13,8,-16,-2,29,-42,-70,-60,32,-2,64,22,8,-55,-36,-39,15,20,70,60,6,9,-4,42,-24,-52,-15,-30,-14,-26,13,106,88,23,47,26,103,-62,20,80,53,33,-45,61,4,-40,20,-20,-30,18,-20,-9,36,-114,-30,-78,51,17,94,-24,31,-42,-37,17,26,-34,63,-90,74,57,29,56,-38,-26,45,-14,-22,3,29,-65,-6,24,-64,-109,-56,-25,-17,-58,-6,10,-23,28,-22,-77,-88,34,97,45,3,-51,24,53,-27,71,-23,-40,-21,-17,-31,46,29,32,-23,14,56,-37,-11,4,9,90,18,-31,-43,23,6,-2,-19,110,11,-110,77,47,14,-6,29,-14,5,-69,-24,17,-49,61,13,-51,68,19,-85,102,-84,14,-45,3,-31,-73,-32,113,21,36,7,42,-58,-47,63,32,52,53,70,32,5,-26,-25,-60,113,-35,-10,-27,49,-20,21,4,22,-58,-20,42,-13,77,42,-6,-43,-46,31,-34,42,-29,60,-41,-23,28,13,57,32,2,47,-7,23,65,21,24,37,89,-42,-45,-10,29,30,25,-4,-9,-33,17,38,108,-57,-32,-111,-37,8,-8,-60,-74,9,70,-6,50,-2,108,-15,-20,45,40,23,14,-23,19,-102,15,9,23,-21,-67,-21,-54,-58,0,-12,-17,-36,52,-33,36,19,29,-35,-101,80,-24,-103,-32,20,16,36,-6,19,-63,-50,-60,28,30,-45,-29,-73,-20,24,-12,-42,-52,-73,40,30,-29,30,52,-35,26,-34,37,-66,-70,44,19,-77,23,4,-11,-99,-56,-2,22,41, 
  /* [48][0][][] */ -40,-68,5,-19,-27,-25,26,86,27,27,8,-22,22,-28,-15,26,-60,51,-23,-15,-15,60,-55,-20,26,-23,-3,-76,-1,64,25,60,-19,1,-23,-7,-101,39,-31,-13,-127,-8,-49,28,61,7,-102,9,15,59,-33,-45,-45,-68,78,36,100,-13,-42,84,15,-27,10,-7,52,6,30,-52,20,76,-76,15,-83,-7,-8,36,-43,102,41,15,4,-8,-12,-15,-76,1,25,96,105,-25,31,-3,23,-81,27,34,-32,61,30,35,23,-44,-7,21,35,-8,83,2,-37,-23,17,-53,9,15,-17,-65,10,-75,40,74,0,32,34,-9,-36,-57,-48,-30,-10,69,-14,-40,-31,-16,-14,-20,-54,16,-25,-45,-26,64,15,41,-22,7,21,-60,4,-7,85,4,3,39,-72,-43,4,12,40,-68,-61,83,-4,59,34,22,-21,70,51,-39,31,-43,16,38,-26,84,-29,12,25,-46,21,17,-7,-12,-2,29,-13,33,20,-5,4,-95,-23,-9,-13,27,-8,4,-4,-89,-26,-21,80,33,-3,-14,34,39,-33,40,6,-49,-38,-16,38,32,72,0,0,3,25,-93,100,10,-32,40,-1,-26,71,7,-10,-6,-16,-38,-11,-55,-44,25,31,-43,-29,-86,-47,1,29,80,3,-8,-32,-8,0,-26,32,0,54,36,13,16,-5,30,-30,-5,-44,41,-1,-9,-11,-3,51,-45,-6,67,-14,28,-68,12,-31,-9,-15,10,-7,11,47,-20,-16,-48,12,-10,-34,117,41,34,20,-34,-48,50,-41,17,69,-21,40,39,-6,-30,-18,26,27,-4,18,30,32,20,42,-26,-63,-67,12,72,-33,1,23,4,7,47,-12,24,31,13,-11,80,-28,-17,7,103,-60,-76, 
  /* [49][0][][] */ 67,-44,-10,-2,-20,34,18,-25,46,-3,2,61,92,7,-17,62,56,-45,-53,24,-52,-59,-17,28,-21,1,-31,-37,31,-52,73,2,53,-18,-35,-37,30,61,-8,42,53,45,51,-16,-10,-34,-25,74,-20,60,-27,12,-22,20,-30,-23,5,11,73,-16,-57,-10,17,36,-25,14,61,-1,44,-1,-11,-43,7,22,1,-9,-46,83,-47,-5,43,74,-46,-5,-53,65,64,-4,-87,29,-11,62,4,-15,-35,18,14,-12,-75,-3,-62,-24,46,20,-3,27,71,-42,-18,-12,32,21,43,-49,1,100,25,11,14,-36,-12,10,66,-29,51,0,-36,4,99,43,59,-25,-53,-44,42,33,10,-8,31,-51,-74,6,63,14,53,-53,69,-103,4,17,-28,24,27,2,27,70,-52,94,27,33,65,-10,-4,-46,-63,-60,-70,-24,18,19,4,-41,-38,-21,-16,-100,46,-32,42,44,39,1,8,72,31,18,28,13,77,56,-42,-10,127,74,101,-36,56,12,-8,8,-9,-45,41,-7,14,7,-40,53,-39,-40,51,-20,-32,-30,-61,68,3,42,-5,-1,-13,14,24,-11,57,-9,53,-28,42,-25,-21,-57,-10,-50,87,18,-25,-51,-26,19,-2,-20,13,-39,-19,-120,33,4,42,-25,42,50,-11,33,-55,-10,35,-97,-13,17,28,-33,21,34,-7,50,-39,21,55,-14,-49,3,32,-25,-46,19,-20,-59,-57,-42,-4,-38,-109,12,-12,-72,0,4,-24,-29,-15,16,30,9,64,17,98,-49,35,-74,23,33,-50,-20,34,38,5,1,70,6,79,-97,27,-28,19,69,8,-43,100,78,11,39,65,-39,-8,39,87,7,15,38,24,-8,-3,-63,67,-12, 
  /* [50][0][][] */ 50,-16,-14,6,-51,22,34,-26,33,43,-12,-29,39,30,-103,41,41,-77,33,68,65,44,36,85,-39,35,93,4,85,29,-36,7,-19,-7,-15,44,23,-76,67,70,-28,-7,-75,-5,18,28,-32,-49,77,62,-30,75,-61,-20,14,6,-45,59,40,87,-44,19,-10,18,11,-1,65,-6,18,-66,-30,54,-13,24,46,-22,8,-12,-33,13,20,-3,37,-24,3,-9,-4,-15,60,-9,64,-47,-16,58,48,-25,-19,6,50,-5,42,53,-66,-21,8,4,-127,2,98,20,-54,6,-38,24,5,-37,45,41,-48,10,17,42,-11,25,71,18,19,-28,15,17,14,-80,-81,5,-38,51,51,-3,-21,-2,-70,43,-42,5,-16,-3,31,109,-25,18,38,44,18,30,69,39,-34,18,-61,-54,4,43,-37,-61,-2,87,-59,9,-25,-46,19,63,-39,-27,26,-32,11,28,-53,-54,-11,-87,43,3,-7,-33,-38,-8,-7,34,9,-13,15,14,30,-5,-54,9,-11,-26,17,50,-60,-55,-61,-34,-46,-33,-33,90,-32,12,-40,41,2,-45,18,-67,-50,-22,-4,-30,-50,77,-51,55,37,52,50,41,-41,13,-10,-4,-55,23,-23,6,-44,-23,-2,96,26,-27,41,-14,-42,48,-42,12,-4,-9,-13,12,-77,49,-27,-4,-31,11,-17,29,28,-23,47,2,-39,-3,17,-22,40,-24,-34,16,-11,57,0,-28,1,-42,35,-86,-34,-15,15,49,-37,23,-15,28,-20,-86,59,58,-88,28,-18,-109,-43,-69,-66,23,-17,-115,-43,-48,-23,18,1,-59,-2,24,15,12,39,-111,11,12,34,-17,55,40,38,-63,-48,66,-88,0,31,15,72,-21,-33,-32,-79,-64, 
  /* [51][0][][] */ -10,5,28,1,24,-65,-51,19,-47,50,43,-15,-71,23,65,26,49,59,-25,74,-16,0,-11,31,29,18,53,8,6,3,26,51,8,-21,31,-120,-95,37,-74,8,1,-49,16,14,32,4,22,-4,-31,32,4,7,-22,34,-5,11,45,19,-50,-57,63,56,7,-18,14,-50,-9,41,-25,-20,-37,95,49,72,43,33,-43,4,52,-58,-68,76,-23,-20,38,-6,-37,78,59,-79,11,61,-7,-35,-33,16,29,5,-15,39,49,3,-48,4,51,-23,-77,13,11,43,78,-13,-13,1,-39,-59,-21,-35,3,23,11,-44,-21,34,-23,0,6,-17,38,34,19,17,3,-30,16,-37,25,1,-41,41,-39,17,13,18,4,36,21,-4,30,-52,63,-48,-16,-54,-45,4,-70,34,-28,-5,-45,51,11,80,15,-8,-55,-28,-1,9,81,11,-5,-20,18,98,-45,-26,2,30,-5,32,-18,-1,40,-6,-23,-16,-16,-24,-50,57,38,2,-30,27,25,18,-2,-32,13,-31,17,74,0,35,12,-29,9,-17,-29,-23,38,-32,-72,-89,-20,3,-22,10,40,-112,14,-49,-30,-19,-17,12,25,-33,17,-31,-13,-63,-8,-22,26,15,-10,18,-20,-68,-25,-25,0,60,-1,16,-16,26,-1,-3,-24,-43,63,24,-55,39,-11,-23,-4,-63,13,-29,-51,-55,-59,69,31,24,-22,35,-14,0,-27,-92,-26,-5,48,30,31,-13,-85,-4,-5,-51,14,-25,11,29,-11,64,8,-23,127,-3,16,51,-83,14,-119,7,9,-21,-81,-29,48,36,-46,11,6,2,25,46,-42,-21,51,14,29,22,-79,-87,-29,2,50,-26,-23,14,89,10,-15,42,-5,68,-31,19, 
  /* [52][0][][] */ 69,9,-26,-8,-1,-31,-67,-3,55,-95,13,92,53,71,-75,71,-108,72,60,-82,8,-100,-28,64,-70,-25,-43,26,-26,-27,-28,43,-52,-71,87,-39,8,41,17,-77,-9,-1,7,-50,-9,120,59,-47,33,-37,-9,20,-13,29,50,6,-38,0,80,49,-18,8,-63,24,10,61,14,-38,-38,-7,43,-81,25,-47,-43,-20,-1,-19,-3,26,54,-23,-46,23,28,-38,-25,15,-65,86,-14,-22,22,6,-71,12,8,3,12,-35,2,66,14,-40,-38,-58,70,31,-49,-8,-79,37,12,-42,-78,-26,-38,-52,76,-38,-19,-97,-54,-6,61,-50,37,21,55,-25,-19,-36,-16,-21,45,13,-65,54,-75,-26,36,47,7,23,-85,1,-60,-107,65,-55,34,-38,-2,-22,127,-68,18,90,-40,68,66,32,-56,26,19,7,27,-43,-8,58,-20,-18,-38,-61,-33,-119,111,-4,-53,-20,-36,-11,23,-49,22,-14,59,25,-67,35,-84,0,-32,8,-34,-12,115,-12,40,74,-68,-21,-53,19,-24,42,-3,-75,-39,-35,76,-68,16,-30,-44,-25,-27,-5,-90,-8,-37,42,-5,-62,-33,13,-12,-37,11,-48,38,10,-16,61,22,9,2,19,73,1,-26,-40,22,-49,85,66,-11,4,43,30,-1,20,-69,42,9,56,2,-54,-72,-65,83,-5,-48,-1,34,53,13,-23,54,-48,-85,-26,63,24,9,-15,-54,-16,20,-49,22,-93,85,24,9,-37,-36,6,75,-70,-37,48,11,-38,-44,-3,6,54,29,39,21,-30,92,-23,-23,82,56,44,-11,-36,-108,-65,-10,-45,31,-9,36,75,8,35,-42,-3,1,-100,-5,-59,55,81,-38,-7,19,-33,-60,-103,78,36, 
  /* [53][0][][] */ 50,-26,52,23,15,-24,-34,-8,29,-36,2,23,19,-59,-10,-73,6,-57,-11,-61,16,-23,6,-3,-56,-25,-56,-17,-2,18,4,-13,-62,-24,-66,-31,15,-37,-65,-18,40,58,-91,-11,-38,34,-17,-14,-7,-56,39,28,-47,-5,52,75,-71,36,-16,59,-43,-36,51,37,63,-18,-15,-7,-27,-122,56,40,32,21,-26,-15,25,-69,26,-58,-8,-81,-84,-4,16,28,20,23,-58,52,5,10,-19,-6,25,-9,22,45,49,27,16,19,23,28,17,9,24,38,-7,-9,-54,25,11,-66,61,-47,13,57,41,-65,6,37,-42,55,-65,-25,13,6,-9,-41,1,35,-19,23,-20,-33,-127,-42,-71,-2,-35,-20,9,19,-12,-93,1,6,15,-9,-79,7,38,17,9,94,-36,43,-51,-38,-30,-56,104,29,-7,-31,31,-19,52,-90,-6,9,22,-17,10,-9,19,53,10,-36,8,-35,-50,-68,-10,-26,-38,-2,-31,-28,50,7,-13,-27,-51,-53,43,-7,-27,-3,1,-2,34,30,-29,-23,30,28,-34,-18,-49,-17,-45,0,35,35,-28,46,-22,11,11,-45,-8,31,35,-34,53,61,45,-30,-92,18,42,10,-91,-50,49,102,54,55,21,86,-16,28,107,28,-50,3,-6,34,52,-49,15,-51,7,14,-15,12,-45,-3,-18,81,35,3,-25,-41,9,-35,-81,23,-54,28,3,-61,-57,-29,-30,-57,-37,30,15,63,73,-15,24,-49,37,23,-13,-32,-23,-27,-1,23,91,-31,-31,-31,-79,-63,62,-72,69,61,2,-35,32,-17,-17,-6,33,-75,-44,-27,-37,-12,-47,9,-29,66,-5,-35,-4,-9,-28,22,-3,2,-76,-18,-19,-9,31,37,43,-3, 
  /* [54][0][][] */ -1,39,14,-46,-52,43,6,1,8,19,29,73,53,-29,25,36,-47,41,33,-10,21,-83,-3,-72,9,71,-16,-39,-25,-44,78,67,-16,52,-57,-67,-19,-73,4,-62,7,5,-5,33,-14,46,-88,16,78,11,-3,0,54,41,42,19,-41,6,-106,-26,-43,55,-85,48,-18,45,-45,-31,-6,37,-34,-32,3,12,21,-79,-34,5,-44,-4,35,-36,-7,-42,-52,-79,-58,38,18,11,-44,-37,57,0,50,-27,-26,-72,22,32,16,-41,77,1,-5,-53,-60,-42,-78,56,29,-12,33,50,-21,15,62,2,35,1,43,-31,-14,-23,38,2,14,-17,-61,66,-28,8,-32,-2,14,57,110,-19,59,48,58,40,-23,-37,-18,9,-17,-59,-59,-40,2,67,-85,-122,-48,1,62,-29,8,4,5,-61,-14,-15,96,11,-32,32,42,-4,21,18,26,7,-47,-47,16,127,-53,-66,11,28,-53,-37,-15,40,66,-6,-14,-85,58,-15,0,-59,-23,-13,-22,4,6,-55,-47,-12,1,17,21,12,-3,-37,-36,2,1,2,-42,-39,-11,-54,43,-42,-101,-60,8,-8,-14,16,36,51,20,-19,23,35,-11,-80,-4,21,-19,-43,-60,-3,-45,-24,7,21,31,-30,15,-16,11,-17,-20,64,15,-27,-42,-29,-3,60,32,92,24,12,-75,-6,-8,-39,-57,2,-40,16,17,-27,-19,36,6,-70,-55,41,48,27,-21,-31,16,-68,-25,-28,29,36,0,31,6,-7,86,-36,20,-6,49,17,-66,-1,-31,5,23,19,7,1,44,-33,-17,-24,26,72,-13,20,9,14,-14,-12,31,-49,-17,50,0,17,46,49,-43,6,93,-78,36,39,-39,-51,87,-19,-25,52, 
  /* [55][0][][] */ -60,88,21,-41,-31,-42,0,-97,-1,-43,17,50,-17,72,-9,13,-2,-48,0,-58,-16,47,28,-81,23,-21,-44,75,-7,43,35,-34,66,-14,19,28,45,25,26,-34,-10,17,-2,8,22,50,19,15,20,59,-40,-53,-79,37,-28,57,88,17,-68,78,48,-45,-17,-17,-56,-31,-65,-16,29,-12,-11,-62,39,-6,44,41,-22,-21,-6,57,89,58,-10,19,-24,45,39,-113,-34,-7,43,36,-40,26,36,30,-52,28,-88,10,7,47,-10,6,14,3,44,-40,51,44,-4,-21,-47,7,60,25,48,-10,100,49,16,15,-109,-27,32,32,-14,-39,25,-6,13,-48,8,-59,0,-34,36,-36,31,-95,-22,4,11,-5,13,18,80,-30,61,-30,-18,-51,-58,43,31,25,-14,62,-22,-16,24,12,-17,8,27,-8,58,-35,-48,-33,23,-127,22,-31,-12,-48,-76,4,-26,15,-7,-16,-13,-39,-13,26,-36,-8,24,81,-14,-2,60,-23,53,4,73,32,-26,-72,79,-1,49,-57,-27,-21,4,-19,-39,-9,-13,-60,-65,-48,21,-55,13,-19,13,-31,37,-34,-6,53,41,-8,53,-30,24,-33,21,-57,-16,-41,-43,-38,-30,-49,37,-26,25,9,-49,-87,-33,10,-9,-53,-2,35,25,38,-35,-58,-23,49,-36,-33,13,45,-25,54,113,27,-64,34,-18,49,-3,24,-6,26,-22,-30,-42,-18,21,-65,27,46,-23,-25,52,-12,-46,-19,35,-2,46,65,-35,34,-32,3,-71,-28,56,-37,38,-31,-17,-35,65,2,45,-47,-11,-72,21,-4,10,-50,37,18,-9,12,-16,-27,-25,-7,-10,-71,54,-6,0,41,-29,-44,-64,-37,-8,-37,-2,-24,42,10, 
};
const TfArray<4, int> tensor_dimension74 = { 4, { 56,1,1,336 } };
const TfArray<56, float> quant74_scale = { 56, { 0.00094772729789838195, 0.0016039608744904399, 0.0014046699507161975, 0.0015319105004891753, 0.001268389169126749, 0.0016610537422820926, 0.0011303146602585912, 0.0011889608576893806, 0.0013358762953430414, 0.0016143482644110918, 0.0013358196010813117, 0.0013266748283058405, 0.0013682360295206308, 0.0017513240454718471, 0.0011058284435421228, 0.0011750258272513747, 0.0011794536840170622, 0.0013363645412027836, 0.0016135879559442401, 0.0015364571008831263, 0.0017244555056095123, 0.0015415939269587398, 0.0011127761099487543, 0.0011909577297046781, 0.0012223394587635994, 0.0017174236709252, 0.0014113733777776361, 0.0015563067281618714, 0.0013901041820645332, 0.0013204915449023247, 0.0013294442323967814, 0.0016028854297474027, 0.001449931412935257, 0.0023432325106114149, 0.0013905678642913699, 0.0013400441966950893, 0.0013918433105573058, 0.0013634889619424939, 0.0014148855116218328, 0.0013899614568799734, 0.0013456258457154036, 0.001481454586610198, 0.0015439748531207442, 0.0021659473422914743, 0.0015251839067786932, 0.0017583572771400213, 0.0016005805227905512, 0.0011544715380296111, 0.0015304672997444868, 0.0013441547052934766, 0.001262176432646811, 0.0014813102316111326, 0.00114211137406528, 0.0010681397980079055, 0.0011438310611993074, 0.0012248589191585779, } };
const TfArray<56, int> quant74_zero = { 56, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant74 = { (TfLiteFloatArray*)&quant74_scale, (TfLiteIntArray*)&quant74_zero, 0 };
const ALIGN(8) int8_t tensor_data75[336*1*1*56] = { 
  /* [0][0][][] */ -127,-29,-107,13,29,-17,43,-42,53,-58,39,50,-39,-56,-22,-9,13,-97,18,-46,68,-71,-76,-24,-32,71,-29,125,12,84,29,107,-65,-74,75,117,15,-75,-66,24,-77,-38,-49,0,-59,-76,25,-78,-22,6,-19,31,-35,-55,-4,100, 
  /* [1][0][][] */ 36,26,-42,42,-127,-14,87,22,-44,39,32,37,41,-37,-98,-24,-36,-25,-26,16,-11,-5,24,111,93,-44,7,32,48,-90,-42,2,-10,20,16,39,-48,41,-4,100,25,32,-28,-10,-18,-53,-15,-14,2,-56,-38,24,84,-13,59,-42, 
  /* [2][0][][] */ 18,-8,-4,68,-29,13,38,0,127,-6,24,56,22,-18,19,9,-9,-4,-28,-64,-33,36,-54,18,1,22,-12,17,-29,44,-22,50,3,9,-52,18,16,-17,-42,-14,28,3,-47,63,10,-39,24,-14,-75,11,32,25,-16,-8,2,-98, 
  /* [3][0][][] */ -17,30,-32,-41,-9,-1,-53,39,-17,-15,38,-74,70,127,40,-34,26,-7,-27,75,-50,39,66,66,87,27,-93,-64,-31,-47,-50,21,-88,-36,-64,-15,-33,5,41,25,77,42,22,12,42,-30,36,45,-6,-98,-30,-3,12,40,11,41, 
  /* [4][0][][] */ -48,14,-6,-13,15,-19,8,-87,127,-78,-57,6,12,114,36,-22,38,-28,44,-12,-34,22,1,27,-93,33,-52,65,8,101,8,17,33,-70,-20,-19,14,-61,-47,74,45,-38,-4,38,72,-23,68,42,2,51,-25,-7,-1,-54,18,26, 
  /* [5][0][][] */ 17,27,-17,-36,-127,36,53,-76,-20,-54,4,21,-4,-39,32,114,-74,94,-30,-65,-104,-60,-10,93,-19,-57,48,-9,54,32,-88,8,-68,-73,36,-13,40,11,-50,-61,-98,-50,-24,87,92,-19,26,40,38,21,-55,25,31,-9,35,-115, 
  /* [6][0][][] */ -101,-60,-37,-31,-12,-3,50,6,-11,4,13,43,10,-49,32,-39,-21,62,23,-9,-94,66,-14,-17,127,-54,7,-24,-53,39,-27,-13,29,-24,-64,17,15,6,-5,23,-36,42,42,-34,36,78,-24,24,40,-58,28,33,-46,14,-38,7, 
  /* [7][0][][] */ 86,-4,-93,-61,-127,20,18,-27,4,-57,13,-96,-6,88,28,50,32,-33,-117,43,50,58,-19,-78,-52,6,-19,14,-18,-17,48,112,-89,57,29,9,-75,45,56,16,15,-4,-94,48,-20,31,-39,-13,-83,-92,9,59,17,18,99,30, 
  /* [8][0][][] */ 52,-66,61,-57,-20,-35,47,19,-46,-68,-8,-82,-41,-1,30,-35,-18,36,-12,40,-37,-127,21,19,-1,54,-45,-74,93,-89,99,-4,-95,-119,51,109,-9,61,38,8,-36,36,33,-119,8,0,-2,52,27,-53,31,108,90,-22,-49,-31, 
  /* [9][0][][] */ 17,-1,22,8,-58,101,74,61,61,21,-19,38,37,-61,74,-78,76,35,-13,127,47,6,-16,25,-85,91,53,53,71,-36,52,81,37,26,27,32,-2,46,-7,-9,48,44,3,8,-8,34,96,-38,-31,-26,80,-85,-44,75,16,-105, 
  /* [10][0][][] */ 5,-73,-74,-77,-72,-4,-52,43,-37,31,127,-86,-31,63,53,21,96,61,11,89,41,-64,9,115,56,-17,-5,11,26,-101,-15,2,-85,-60,-105,-18,-55,12,3,53,66,-14,22,102,37,-5,46,72,-30,12,111,-84,72,65,79,38, 
  /* [11][0][][] */ 23,-9,-6,17,24,-16,19,88,-39,-14,3,-29,1,59,19,-66,40,-29,-41,-2,-13,-95,25,-18,-44,40,22,-3,-69,-32,-29,-32,-28,-127,33,32,48,34,-31,-28,88,41,9,31,41,13,-111,84,-21,-31,22,-71,24,43,-64,18, 
  /* [12][0][][] */ -23,-80,23,40,-61,9,-19,8,68,15,39,42,-48,7,68,-46,16,60,-79,-64,-33,61,-63,28,-50,-60,-1,74,85,-73,-127,9,-11,-14,38,4,92,52,-8,-66,-123,-26,-6,29,-64,-3,-13,-90,-83,15,65,47,32,3,55,-66, 
  /* [13][0][][] */ -119,101,-1,49,36,22,13,77,29,102,-37,32,-69,5,25,-1,77,58,79,3,28,-62,11,0,5,-17,41,94,-45,11,36,61,-32,0,-127,49,-51,74,-15,-44,30,-71,-8,76,26,55,40,73,-30,14,-80,-36,49,-10,70,10, 
  /* [14][0][][] */ 82,-54,20,-27,117,-48,51,12,50,73,16,-11,7,32,-45,2,-5,-35,-5,24,12,12,9,0,86,59,-118,-76,-10,-50,-32,-21,-60,-20,-85,-35,16,58,39,76,-77,6,42,-50,-46,-127,-30,63,-48,0,-1,-57,24,-51,-43,-30, 
  /* [15][0][][] */ 39,-71,-48,17,13,25,39,-46,84,49,-78,39,-68,-4,40,-39,25,-29,29,63,-46,21,-20,48,15,-42,4,-26,92,35,-28,-76,-83,-48,83,42,-20,102,101,-29,-9,-77,-3,78,71,36,-127,51,-65,3,70,-10,-38,-1,71,56, 
  /* [16][0][][] */ 38,-33,1,-50,53,-87,-56,-22,77,-12,3,-40,-21,-70,-92,-18,127,-24,15,12,2,-33,47,-40,24,-78,-53,-73,28,-23,-84,62,14,-40,-69,-117,37,37,7,2,-19,-47,11,-22,-35,18,-6,-42,60,-31,-74,28,14,-28,-22,-10, 
  /* [17][0][][] */ 21,14,-27,-5,-12,1,57,-38,-40,59,-29,41,21,113,-35,-51,86,-20,13,-4,20,27,6,-10,48,-2,39,67,-13,-10,107,127,-13,-45,-24,30,-46,28,-15,-9,-10,19,-2,55,38,31,77,34,-8,110,26,5,16,-51,-5,-22, 
  /* [18][0][][] */ 18,-5,-14,-27,-4,-44,-37,-33,-30,-79,-4,40,-15,-14,26,-16,5,6,-43,-37,7,-96,-64,58,-68,42,36,46,95,-16,-53,86,-3,-22,-58,25,89,-24,-64,47,1,5,0,-18,-27,45,4,-2,71,-10,-38,-38,67,-42,-14,-127, 
  /* [19][0][][] */ -15,-64,-71,-17,-64,5,127,62,1,72,37,59,37,-5,-30,39,18,49,46,-68,36,-23,35,16,2,-66,-49,-51,1,-11,115,-18,-20,-11,-5,-39,52,37,28,36,47,-27,-4,37,29,7,-11,24,-61,14,23,3,63,17,-44,-10, 
  /* [20][0][][] */ -127,-60,-35,-32,-14,-27,-88,-19,-20,-107,-66,30,-91,8,12,-26,20,32,36,43,-13,-11,-43,1,-62,23,-20,58,-75,-11,-12,69,-23,2,-21,-47,99,89,-67,32,-106,18,32,57,20,3,18,-41,-20,39,28,82,-1,-12,14,-42, 
  /* [21][0][][] */ 13,6,-12,-48,48,18,40,11,60,-25,-7,22,-127,-27,43,-5,-33,49,15,-38,-24,-33,-5,22,30,33,31,-14,47,-31,-53,68,48,-70,2,48,-100,41,30,10,-77,-44,47,14,37,-67,-110,111,37,10,46,38,-3,35,-31,41, 
  /* [22][0][][] */ -16,7,-50,45,-68,-3,106,-13,-25,-32,-55,27,61,-16,59,67,-20,0,-69,127,-90,-25,34,-14,-7,23,-46,-15,-27,-30,-20,-15,31,-40,17,59,48,71,16,29,0,93,30,28,58,-32,14,122,12,-1,59,-22,2,2,-48,-2, 
  /* [23][0][][] */ 66,-25,-54,-96,13,-43,-5,-8,-12,78,-27,-66,-31,-11,49,-88,-29,-45,40,63,-25,-89,14,58,-18,-23,-30,44,-85,-28,7,85,-89,-45,-123,-9,-100,-35,-13,-30,49,24,-47,58,-2,-24,16,-127,-1,-25,-26,-42,11,-42,100,11, 
  /* [24][0][][] */ -61,-55,-44,-7,6,77,77,-34,31,21,-103,-35,-101,-62,-11,-14,20,-32,-24,-125,9,-114,-12,42,58,10,56,2,-16,72,34,37,83,88,-41,18,65,87,-4,14,-127,66,-40,-27,28,37,-32,91,50,89,-49,26,-28,-23,-15,-105, 
  /* [25][0][][] */ 57,-8,-6,26,-20,-19,-6,62,-30,-41,63,112,-127,-4,41,87,2,49,21,-22,-55,-10,-28,63,33,-99,-23,-30,-17,-69,-36,-10,61,-69,-23,-43,27,109,39,-9,-24,-4,43,32,79,-46,-51,31,-64,-26,118,-4,-10,-30,23,49, 
  /* [26][0][][] */ 5,-5,-56,-38,26,1,-1,40,13,39,39,-13,14,39,26,-24,-65,-45,-76,-19,-39,-13,0,73,-96,71,7,-85,-84,-75,27,-24,-6,-72,11,-3,-22,38,-35,-25,-32,36,32,-41,127,-33,-53,-27,-22,-35,-53,-4,23,1,-42,-59, 
  /* [27][0][][] */ 104,9,21,28,8,24,-14,-6,2,97,46,-5,-23,-44,-68,127,66,-22,14,18,10,-49,12,105,7,82,48,-20,-34,-61,12,9,30,77,-68,-59,18,-8,31,-54,9,7,25,-16,80,-14,94,-15,17,-33,-18,34,-33,46,-41,-13, 
  /* [28][0][][] */ -17,-27,-71,-60,18,10,24,-25,-102,14,-80,9,-93,-21,-43,-8,-36,-10,-1,-54,-8,-68,57,74,1,-27,22,9,49,127,-40,-6,-5,-64,-77,31,24,23,-43,-63,30,-72,-11,72,3,82,-67,80,18,-26,-66,1,5,44,50,-1, 
  /* [29][0][][] */ 78,40,90,7,84,-19,13,43,-9,-54,6,-109,31,38,1,-40,36,105,18,95,18,40,48,23,34,-14,83,-104,-45,-3,-52,23,3,-10,-26,-85,127,15,-17,-28,-42,72,91,-52,62,-40,-8,-32,46,58,77,-121,83,-47,-106,-86, 
  /* [30][0][][] */ 19,-116,-40,-58,-7,-63,-16,6,-12,25,16,-48,64,-12,-11,52,-4,-2,13,-3,61,25,31,-84,-40,21,-2,39,66,-74,-46,82,-5,-2,17,34,-114,80,-6,-127,-1,32,-19,-33,-16,32,7,-38,-5,26,-113,52,67,20,21,-50, 
  /* [31][0][][] */ 24,-30,1,-41,36,-38,75,64,50,11,127,45,62,77,27,-52,-5,-44,69,-21,-56,-26,-7,-22,-87,3,-62,-27,44,79,-5,54,-3,83,43,11,-79,44,-45,-7,9,61,37,-37,71,100,4,31,-22,5,50,-43,61,45,-48,29, 
  /* [32][0][][] */ 24,-34,16,-3,-57,-9,13,29,33,41,61,-65,-5,99,-46,-30,-47,8,-11,1,13,32,8,-34,53,46,-40,-20,21,-15,-62,31,-61,-16,5,8,90,28,55,103,-51,-48,-52,46,28,-30,-7,14,-127,70,-75,-76,-9,44,20,-51, 
  /* [33][0][][] */ 1,-68,7,17,-81,-11,-45,21,92,3,6,8,6,43,27,39,-31,17,-76,-40,35,-61,-35,46,-53,78,13,31,11,-52,-75,67,6,-108,43,-1,-47,-51,-63,-30,-56,26,-84,-3,-83,53,17,20,-65,127,-73,-5,50,-37,43,-66, 
  /* [34][0][][] */ 71,-97,29,-19,24,48,-2,-6,4,29,83,11,40,114,112,-31,39,-42,-20,113,-73,-37,-30,127,-21,-32,-11,-94,28,-54,122,-57,18,-118,65,45,87,57,46,-16,12,112,-16,-37,126,-28,-34,43,-37,-108,-10,-11,106,-59,-21,48, 
  /* [35][0][][] */ 8,41,58,7,41,-26,44,96,5,44,-44,-22,4,14,-59,45,-3,-2,-62,83,62,2,-8,54,-26,-48,73,-48,16,-11,49,-26,77,-41,10,21,55,8,72,-24,28,58,118,-16,-25,-65,15,0,-25,-20,19,-5,-81,36,127,-38, 
  /* [36][0][][] */ 19,-7,-6,-56,27,-64,-9,-50,-30,7,11,7,59,-22,19,9,7,-64,42,52,-28,29,31,-19,-56,-32,2,73,127,-12,49,-30,-78,-45,-1,56,29,-59,-17,57,-20,-50,-48,18,6,-22,12,55,-22,-18,-9,-29,-3,4,63,64, 
  /* [37][0][][] */ -48,24,49,-51,80,68,33,127,-45,3,11,32,-4,-53,43,-37,-15,37,-59,-54,25,-27,-48,35,0,-14,-11,-36,93,-50,-35,-38,-23,-20,0,56,74,78,28,82,22,99,92,-28,31,42,30,-33,54,38,-37,-60,54,-22,-70,52, 
  /* [38][0][][] */ -40,-13,70,26,55,1,6,-24,5,-16,-13,-49,-51,-32,-28,75,21,-13,-79,-62,-127,35,5,-33,-81,-32,61,-28,25,-19,-22,-60,7,-49,39,-12,61,-23,4,35,34,23,17,-16,43,9,12,58,25,-10,58,-40,19,0,-22,-9, 
  /* [39][0][][] */ -77,-61,111,37,-10,-49,12,-9,-9,-26,-14,-4,44,-43,23,93,36,38,21,-16,-17,39,-52,-55,-4,-49,61,17,127,-45,58,1,-29,7,79,-38,28,-109,14,21,57,-46,-5,33,-43,-8,-21,-64,-26,19,59,-79,56,39,-35,68, 
  /* [40][0][][] */ 44,-77,41,-25,14,41,-46,-47,-14,-66,-61,33,39,-1,55,57,-114,16,-22,78,9,107,-17,-72,-52,-22,6,-16,64,-127,13,-64,-77,-61,84,-50,-25,-6,-79,73,-48,-51,-28,-12,2,-94,47,-31,14,-30,27,-14,38,-65,-72,13, 
  /* [41][0][][] */ 5,-68,20,-31,8,12,-1,18,-24,84,-43,46,-36,4,-14,-9,29,42,22,30,58,29,-24,17,-20,-34,16,-79,47,1,76,84,-9,-17,16,64,127,59,44,67,38,-51,-4,35,65,26,52,6,43,-28,-84,3,22,-5,0,-18, 
  /* [42][0][][] */ -28,20,8,-26,-59,-61,-3,-50,8,-29,29,8,84,85,98,-79,-40,30,37,-127,-108,102,-59,-20,-42,1,29,38,69,44,-16,-3,-46,-36,18,-3,30,68,4,41,-101,-3,-25,51,-2,28,12,-93,-21,47,-26,-34,10,24,71,-70, 
  /* [43][0][][] */ 72,-10,-38,-71,-14,95,84,14,41,99,-18,-101,20,67,2,44,65,47,-33,-4,9,-127,-23,34,31,90,20,13,85,60,-17,-47,52,-12,-19,52,-19,-3,2,1,-28,-95,-126,13,106,-50,-83,-50,-44,55,-12,-53,-3,7,-79,-1, 
  /* [44][0][][] */ 16,52,-18,-35,-40,-35,-3,-4,-33,86,-39,87,-15,-71,-9,-23,3,34,11,11,-49,-47,75,76,-37,-10,-66,106,-2,-72,93,-34,37,42,100,36,70,56,-63,-39,-51,-16,46,-56,18,4,-8,28,-12,-31,75,9,-22,-83,-127,7, 
  /* [45][0][][] */ -34,-43,125,101,-22,-14,-63,-88,93,-58,-56,-15,23,18,-2,79,14,-56,-117,-2,-74,-13,-66,5,-11,46,-62,110,76,-31,-115,-125,56,48,98,-7,-31,-61,37,-82,-16,-14,50,-30,74,-83,-47,-59,26,23,63,30,-28,-32,127,78, 
  /* [46][0][][] */ -86,-71,-20,-127,-24,-4,35,68,-26,52,80,-56,29,51,-9,28,52,4,37,-17,74,-15,13,43,12,-29,-36,16,-102,-40,20,77,10,50,-68,-76,-63,-13,-58,38,-54,-17,-22,-2,4,-40,90,-90,-82,-10,-110,30,-47,82,18,66, 
  /* [47][0][][] */ -64,38,14,-62,14,-16,113,98,46,26,-60,-108,-1,-12,15,-19,39,18,-82,46,121,20,60,23,-105,-32,51,-20,44,-38,87,-36,-9,31,-43,-76,-23,11,-36,-24,30,-35,57,-18,-44,17,16,16,-45,-38,90,127,-79,16,8,-25, 
  /* [48][0][][] */ -64,-13,-38,-60,-33,-80,116,-24,-9,-6,-21,59,-10,70,24,1,-22,49,9,-7,-22,25,-23,88,7,-42,-21,-16,-127,31,-24,-18,-60,-34,-12,-9,-57,-50,-98,-52,66,96,-105,11,28,-72,-18,47,15,-31,-101,-11,50,-34,-39,-97, 
  /* [49][0][][] */ 12,54,2,5,79,10,92,51,53,60,31,2,15,-30,-93,56,31,-17,82,3,-27,-122,-31,-5,-65,28,90,10,9,-93,-32,-17,-64,39,1,47,21,59,-25,127,-15,111,-28,-33,1,42,-87,22,50,-2,14,0,57,28,19,-4, 
  /* [50][0][][] */ 39,-51,-54,26,-74,-25,-16,36,41,4,-22,11,-74,28,-124,-6,-50,-11,52,67,-122,58,-76,6,16,-38,98,21,13,-54,-126,-15,-51,10,4,-35,86,-127,-21,-13,-26,72,-72,-3,42,-120,-13,-75,28,6,35,-24,-6,60,11,-9, 
  /* [51][0][][] */ 18,-10,-1,26,-9,11,55,27,-21,79,112,66,40,-21,19,-38,99,-27,-53,73,-27,-63,74,11,-58,-30,7,-31,-15,-43,36,-27,15,21,-3,20,113,-28,72,-66,110,19,41,57,20,45,20,-65,-54,-44,-45,-31,-9,18,-49,-127, 
  /* [52][0][][] */ 15,23,-52,-39,-53,-21,-21,-84,29,36,-24,-73,-39,-66,-5,45,51,-116,-7,62,-50,-3,-57,-8,55,-32,-65,19,56,40,-10,28,-71,-28,-46,-13,-10,-37,-11,-79,39,-12,-39,-9,-26,-18,39,77,-41,35,21,-29,48,-127,33,6, 
  /* [53][0][][] */ 68,71,102,-38,91,117,46,23,-11,92,-79,52,39,-35,-71,122,69,-106,97,91,-35,1,-92,-127,50,58,70,8,29,57,38,41,-125,20,7,34,36,-43,85,45,-8,20,14,98,116,17,85,-4,4,36,13,-19,-45,64,-73,-90, 
  /* [54][0][][] */ -46,60,18,-3,-22,-67,-44,4,13,49,-17,58,-54,95,31,76,40,-58,22,51,54,10,-33,36,38,24,41,-39,-29,1,-73,39,-127,-25,-12,-68,-55,70,-46,71,-39,39,10,-13,-38,-62,-48,-26,-51,104,25,-53,-36,-9,-58,-37, 
  /* [55][0][][] */ 36,42,43,40,70,65,58,-67,32,90,-69,33,0,46,-44,78,5,-51,55,87,76,17,54,16,43,-22,-11,-47,26,36,-52,-17,-98,59,-18,53,-12,-36,37,1,-39,8,-47,33,82,59,47,72,-126,69,-41,-72,9,-21,-127,14, 
  /* [56][0][][] */ -34,24,29,-20,20,46,14,127,-70,119,14,35,-7,-22,-36,-33,74,12,-21,-81,76,-49,-13,-15,-9,-8,72,-80,-52,5,-1,-18,-47,-37,-25,-10,-16,47,-54,-93,-3,-26,-63,-44,34,56,33,57,25,-109,13,-6,3,39,27,51, 
  /* [57][0][][] */ 15,-40,46,-38,-57,0,16,-62,44,25,-53,13,23,46,118,4,-11,48,69,82,-11,76,9,48,-28,-113,-16,36,-33,-37,-30,-62,-54,-56,52,-4,4,5,-32,21,81,15,6,-10,-14,70,-27,127,19,-38,-15,-53,54,73,-10,36, 
  /* [58][0][][] */ -23,-17,4,-47,-29,3,-109,-127,-102,-9,-42,-19,29,-89,124,-20,-59,27,68,44,37,-10,-12,-34,-31,-74,-70,34,80,60,-60,4,-26,-84,42,27,-7,-32,15,-8,65,-7,-34,-66,-39,-23,-31,-49,54,28,60,-103,73,-36,84,100, 
  /* [59][0][][] */ 44,-4,-34,14,-14,-8,29,17,-34,-6,-10,27,61,-8,127,15,-19,28,89,-69,-56,11,-19,-47,-24,-45,103,33,10,-10,-41,-1,52,-51,-51,15,9,-8,-5,42,-103,-56,-10,10,18,28,0,-5,6,50,32,114,29,-97,-83,-104, 
  /* [60][0][][] */ -9,52,-35,28,43,-24,65,19,-46,14,-45,-33,70,-117,98,32,62,55,19,-15,53,-69,-9,66,61,46,102,65,65,35,-69,33,63,-101,-35,13,93,26,42,115,-71,117,71,-64,-5,-41,-4,105,63,12,-25,-30,-5,25,-2,127, 
  /* [61][0][][] */ -6,-86,32,38,-94,23,62,-68,77,-28,-54,-24,-89,43,1,51,-75,6,66,-31,18,-32,-86,27,63,-59,-12,75,60,-50,-70,54,-108,10,62,-76,-48,-8,-127,18,-102,-14,-84,83,28,-91,65,-3,-81,-110,-66,-20,19,1,26,-63, 
  /* [62][0][][] */ -50,-8,11,34,75,-47,-3,16,62,3,-88,-11,-20,72,11,60,25,42,15,21,-31,20,-41,34,-9,66,10,24,-46,60,44,-64,-26,-17,25,53,81,37,62,5,27,32,-9,-19,-13,-43,15,98,-18,23,37,-50,127,29,-4,-51, 
  /* [63][0][][] */ -41,-22,64,26,31,23,13,19,127,22,-56,14,-83,-13,26,0,-26,-18,10,-54,-82,13,-6,-24,31,2,14,7,53,43,-16,17,-11,15,-9,58,70,8,43,-20,-20,8,53,-6,-16,15,7,0,0,-63,11,-33,55,1,26,-66, 
  /* [64][0][][] */ -108,-17,-42,29,37,54,-11,-21,57,77,-111,9,-86,45,-37,86,-84,-31,53,-50,-47,12,22,-54,37,5,127,8,-1,61,22,33,98,-35,22,39,52,45,72,-69,56,46,-30,-41,-28,52,14,15,-6,3,21,-28,-20,-70,-72,83, 
  /* [65][0][][] */ 2,1,-8,-9,51,23,27,69,36,55,-17,40,15,-79,56,-38,60,-44,-17,76,-44,62,-14,30,-8,-8,61,48,-11,127,-48,-56,-32,36,16,-24,8,-50,26,83,31,82,16,-14,-33,48,-46,51,-31,53,59,57,83,57,-39,-13, 
  /* [66][0][][] */ 46,55,14,32,55,-103,69,73,-8,-59,-80,-109,23,60,25,94,-127,-110,-13,-18,-39,-54,55,3,95,-50,65,-13,-51,-42,-22,-18,-39,-109,-40,-13,22,-66,-105,19,-54,3,20,-34,-101,-30,43,46,23,-30,19,-18,-11,-90,50,-102, 
  /* [67][0][][] */ -19,-23,-7,-28,53,-13,-54,-13,-59,-5,0,-8,-26,8,26,40,-6,44,-2,-45,37,11,11,45,15,-19,-30,-51,81,10,-29,0,-6,-24,-27,16,38,31,-14,-19,-127,-34,-34,-34,42,-61,14,-21,11,24,17,-19,30,-6,32,26, 
  /* [68][0][][] */ 75,52,-107,-1,-45,15,46,-32,-8,89,-45,29,-61,-46,32,36,-29,-21,127,-9,70,-11,17,10,-51,-38,-68,35,4,-60,23,28,-30,-65,41,24,-8,22,-68,8,21,-75,-10,24,19,117,50,-39,-114,33,0,-17,68,61,-80,-23, 
  /* [69][0][][] */ -53,-13,116,-24,113,-29,-46,-98,35,-74,-53,-67,-41,65,-56,14,3,-6,-7,-6,-4,35,21,3,-29,1,14,29,8,-4,-35,32,12,21,-78,-60,33,-19,-67,127,-26,-47,-37,-19,-46,-81,41,39,-11,105,-20,-17,21,3,12,-28, 
  /* [70][0][][] */ 28,-50,57,116,17,62,73,3,86,-9,29,50,26,59,-43,-86,-12,-24,-41,81,84,-74,-127,51,72,-33,54,80,27,-68,6,49,-10,-2,-37,-8,-98,-3,-41,-3,44,87,-6,-27,-36,20,-20,-75,-46,-28,43,0,-14,16,-75,-65, 
  /* [71][0][][] */ -26,-33,-127,-7,-40,-24,42,-20,-75,6,-49,31,92,5,-72,26,38,-50,78,53,12,-20,111,-24,35,60,-17,44,-3,-98,-60,32,-42,-14,16,36,88,11,38,-7,87,-8,-23,7,-15,6,29,24,-38,25,68,35,-28,3,-19,-4, 
  /* [72][0][][] */ -14,20,-117,-92,43,-60,44,55,51,29,-7,-48,-9,56,-20,-25,66,-4,22,-5,-10,-13,6,32,38,-12,11,-34,-26,-25,-31,-36,23,22,-65,-53,-22,75,15,27,-2,0,32,-14,127,42,22,8,2,65,-40,-5,-1,17,-86,70, 
  /* [73][0][][] */ 37,5,-97,-39,-26,-38,-57,20,-58,-19,30,-85,19,-22,94,-57,-29,8,6,-17,46,8,-32,97,53,-47,43,-78,-27,58,-47,-17,10,-82,-127,20,19,119,-48,69,-7,25,-15,97,43,-47,-5,-11,26,-26,-23,-14,112,-25,37,78, 
  /* [74][0][][] */ -36,-107,-19,-101,-29,27,57,-58,57,-65,-8,32,-62,79,70,-11,49,21,16,-56,-78,-56,-121,15,55,-48,39,76,-8,-82,-15,-6,53,-100,89,53,26,-21,107,-17,47,-72,14,59,-127,106,-12,82,8,-39,-55,15,17,50,-39,-74, 
  /* [75][0][][] */ 70,40,-26,3,61,18,-34,96,54,44,56,39,93,57,78,-104,16,49,-61,59,-71,10,-127,8,-16,-58,63,-74,17,-6,89,-19,34,-86,26,16,13,-55,50,-21,-40,85,33,-68,104,14,55,85,26,-106,-57,-52,52,117,-35,-65, 
  /* [76][0][][] */ 10,-36,8,77,84,-71,24,-40,82,-15,-62,-75,23,3,-105,44,-21,-19,-34,58,-42,-58,-24,88,41,29,-86,84,-44,15,-33,4,-36,14,-28,25,8,60,-127,39,5,-14,-18,98,-27,-9,16,29,-90,75,-127,57,7,-74,21,-62, 
  /* [77][0][][] */ -9,-69,5,60,-106,-70,98,17,-29,79,27,-7,38,-47,-5,8,39,-28,-55,1,-1,-38,-22,9,93,30,-27,27,22,33,19,21,-78,-82,56,-23,-79,79,-93,11,10,-9,54,93,38,-53,-11,13,-76,-127,-35,-2,8,-65,5,-71, 
  /* [78][0][][] */ 16,-10,7,-10,33,45,-31,-26,98,39,-48,9,52,17,12,35,58,-17,-7,73,7,-13,-20,2,56,11,30,3,23,42,18,-25,-61,97,-11,-21,-5,28,-84,18,0,38,36,44,127,11,18,-1,-5,75,4,-37,-7,-36,-16,-17, 
  /* [79][0][][] */ 23,23,-56,-51,-76,-5,-32,-57,-23,16,-49,-60,8,-6,-16,46,3,-44,5,10,-73,-127,23,-8,-2,52,64,19,-23,39,6,37,-46,-26,-5,53,20,53,17,68,42,-73,45,108,-26,86,-4,58,-42,43,-4,-65,-9,35,31,1, 
  /* [80][0][][] */ -10,26,-28,-10,14,-2,-88,-73,-54,9,90,-21,-35,33,55,-77,-14,33,60,0,82,-1,-2,-33,7,-86,-25,31,-26,-6,-63,19,32,-61,29,27,-8,74,4,65,16,45,59,3,12,-40,-55,6,20,-18,127,-39,45,-5,46,18, 
  /* [81][0][][] */ -16,-17,48,-6,-30,-47,-58,-127,-66,51,-70,33,92,-3,28,-32,-29,-3,-60,-5,-22,-84,-28,8,56,-59,-21,-12,1,43,-77,-15,22,29,-34,35,42,69,2,-5,6,-67,-27,-15,7,25,33,-26,6,18,-8,-69,-8,-13,-106,17, 
  /* [82][0][][] */ 27,-5,127,16,37,-17,11,-44,60,-18,-20,8,8,71,54,11,14,19,-15,-1,-80,0,78,33,-46,50,-26,27,-2,-74,0,-3,16,1,21,14,-57,-9,48,6,-54,45,74,15,61,-25,-87,101,-14,-7,0,-113,-42,-1,-40,-49, 
  /* [83][0][][] */ 115,-32,41,-20,32,-69,32,-16,16,-22,-20,-74,-37,22,93,-9,-11,-4,-49,-23,-46,-60,-17,-15,-1,-53,10,-84,36,9,54,-72,-68,-127,85,-1,34,28,58,-18,-81,13,62,-55,-3,37,4,38,58,-48,8,-29,127,-3,-67,1, 
  /* [84][0][][] */ 35,-44,34,84,-37,20,58,92,60,-1,12,18,51,-1,0,14,-12,36,22,62,-66,-27,104,-8,83,7,-22,2,-66,-117,-50,15,-56,-8,-32,82,-45,49,55,58,30,78,10,25,-75,42,32,25,-126,-48,125,-86,50,33,-127,3, 
  /* [85][0][][] */ 32,25,-9,22,-20,-59,-14,-23,55,32,-29,-1,25,66,47,22,11,72,-1,15,-8,16,35,29,-23,-51,-62,-21,-17,12,-25,49,-28,-127,-25,-29,-32,5,-47,32,33,-32,-59,32,26,0,-3,63,-8,22,16,64,54,52,-18,-4, 
  /* [86][0][][] */ 17,12,-3,-50,-1,19,-72,6,55,-77,19,-35,-63,2,9,15,-6,-43,-97,-127,65,-76,-89,95,-24,0,-39,-55,6,-44,18,45,27,-18,-21,-17,-29,28,-15,30,7,23,27,-53,14,-44,94,15,24,67,-6,-12,56,-3,-12,68, 
  /* [87][0][][] */ 120,42,-71,-70,-14,-99,-72,-101,53,-92,45,-22,38,-52,10,-59,15,42,71,127,104,13,-27,24,-79,-63,71,108,-60,14,-9,43,-64,-102,31,70,36,-28,-113,36,-28,24,-24,3,-69,-87,32,8,35,126,20,-46,4,-23,-5,6, 
  /* [88][0][][] */ -6,-104,12,-11,-69,17,-49,-127,102,0,-21,65,-108,34,-25,-19,19,-69,87,-8,1,-44,39,65,62,-45,40,4,-44,83,-18,-46,-27,53,-33,41,-56,55,-24,98,35,-40,-56,107,11,86,-42,-110,-10,52,-19,101,-3,-49,107,-44, 
  /* [89][0][][] */ -37,-45,59,8,4,-51,-12,13,-114,-27,-47,-14,83,16,52,14,59,8,60,105,43,14,-43,-85,55,31,99,-40,42,13,55,-109,58,15,-11,-127,74,122,-3,114,-53,68,-60,-123,43,19,6,-78,68,-32,76,-18,-24,29,1,17, 
  /* [90][0][][] */ 31,-3,-28,37,-45,-20,-15,59,0,127,-33,44,41,-32,24,-2,18,-39,-20,31,24,75,29,21,24,38,-27,25,12,31,39,-9,1,25,0,33,-26,33,0,5,17,25,1,57,28,-41,58,10,-40,39,33,8,-35,51,29,54, 
  /* [91][0][][] */ -50,77,-43,-24,-4,38,-55,25,-23,38,34,-16,6,26,27,-16,-61,-1,37,22,-95,-95,39,2,17,-23,73,37,-43,47,-25,8,-87,-69,-10,-55,73,-34,23,-1,-59,-22,-36,-61,8,-37,-48,26,60,-32,127,-13,-32,-48,67,-89, 
  /* [92][0][][] */ -53,-6,5,-11,-31,-23,-39,86,41,32,-14,-75,48,86,-127,69,8,73,-2,-56,17,-22,-69,5,-46,-33,10,21,22,-76,-24,8,-19,60,-17,2,-23,46,11,-54,-39,31,-27,31,13,-13,2,35,-33,64,-61,4,-35,23,14,-26, 
  /* [93][0][][] */ -23,-13,-33,17,-10,-58,-50,17,82,39,51,-1,28,-21,22,-76,-74,70,16,99,5,-9,-20,57,-73,-25,32,56,-41,-46,24,88,-62,42,-100,37,-10,21,2,22,-9,31,-88,57,41,-75,-64,81,-30,13,-5,1,-64,127,7,-25, 
  /* [94][0][][] */ -4,-71,18,-8,9,-107,0,1,42,-127,-80,7,100,0,-11,66,-18,17,1,73,-36,52,57,27,0,-96,2,2,-17,-92,-48,-69,-96,-45,11,17,-24,40,45,47,7,37,-55,33,-65,-76,-40,-23,59,66,-3,-42,55,-5,-3,115, 
  /* [95][0][][] */ 38,72,-61,-41,-15,9,-3,-45,19,17,-30,-62,27,-17,18,-40,-57,23,29,-2,-21,-12,105,76,-5,15,-43,-20,-25,-23,-109,11,-62,-8,-70,-116,-86,1,-28,-39,-17,-5,-11,55,-31,-58,-127,-51,-57,28,80,55,26,56,-4,-73, 
  /* [96][0][][] */ -16,11,-20,-127,-20,9,-42,-14,-32,-17,68,-17,-65,-39,-29,11,10,1,-1,7,80,-17,-42,16,-22,-54,-16,-12,3,-64,18,33,-51,-23,-6,-24,-30,-37,-43,19,4,-15,38,21,-22,-20,32,-63,9,16,20,-53,59,23,78,38, 
  /* [97][0][][] */ 0,-39,50,-18,22,44,43,-95,50,-7,-70,44,-7,-33,19,6,-66,-3,43,-14,3,32,3,-66,-79,19,101,-13,24,54,-73,53,-1,-63,4,-67,41,13,-117,-5,-6,-2,-18,11,-35,-66,12,40,-16,27,127,-77,59,28,4,30, 
  /* [98][0][][] */ -93,41,-74,-2,-21,95,-7,-49,55,-42,42,-12,1,-74,-1,127,36,-77,66,-80,-17,85,11,13,32,-17,8,24,-63,91,32,88,36,17,-108,0,-35,-4,-27,-40,82,-28,-15,52,47,7,-8,45,-53,-15,-14,-42,-77,10,3,-1, 
  /* [99][0][][] */ -41,-11,-31,46,-18,24,39,59,62,94,9,29,43,127,-2,-27,16,-24,-52,13,-36,-12,-2,72,45,18,-29,-19,-32,-25,14,-54,-37,-6,10,47,-68,89,41,-52,3,40,-46,57,6,-48,1,-9,56,-13,59,-14,8,11,-37,-48, 
  /* [100][0][][] */ -38,-8,-67,-80,-61,-46,75,-48,15,44,118,78,-83,-21,3,-30,78,-65,-63,49,14,11,-107,82,-51,21,-87,10,33,-21,127,66,-5,-73,-84,57,-106,-4,-25,1,-4,37,-89,125,67,-9,-83,-13,-10,60,107,-74,-18,-83,-50,-89, 
  /* [101][0][][] */ -25,-21,-5,-72,-16,-16,-40,-35,-13,54,-15,47,37,56,42,-4,54,3,22,-15,-127,-69,56,-21,-37,-52,61,5,17,-17,26,38,3,15,-2,75,123,-22,-1,-6,-95,53,-72,17,37,-33,-3,-17,16,-59,71,28,-97,-22,-27,14, 
  /* [102][0][][] */ 34,15,20,-60,48,-34,127,-20,27,-70,74,-18,-11,92,-54,17,14,14,-36,-23,-78,-13,-68,123,37,-2,-85,-15,82,-4,-98,50,74,-35,54,86,-8,80,44,65,-96,25,50,64,-69,-106,-83,94,33,6,54,46,83,9,32,20, 
  /* [103][0][][] */ -9,7,22,-30,26,-37,-48,-96,46,6,62,127,-9,-53,-18,-57,27,-37,-3,-42,-83,16,27,16,77,-11,-34,81,-91,-53,-35,34,50,23,-102,84,70,30,37,90,28,-89,100,-66,27,2,-32,-4,3,-59,79,-15,25,-48,-25,21, 
  /* [104][0][][] */ 64,-18,-66,-32,-17,-87,-15,25,-66,1,13,-54,10,-12,66,78,12,7,-1,-19,-76,-78,-127,9,49,-12,7,3,18,30,21,10,-26,-83,3,24,105,2,-9,11,-54,31,-77,-21,-84,-6,24,-5,-26,-80,14,-9,-5,26,-52,-2, 
  /* [105][0][][] */ -15,-17,-32,-67,37,16,-15,59,-100,103,32,-34,2,13,79,9,34,66,-34,42,12,26,-41,25,-24,-57,34,-58,-94,-22,127,-52,-10,25,-40,-23,-67,51,67,-51,-18,52,36,-10,103,11,23,47,-42,43,-24,-70,30,29,-39,3, 
  /* [106][0][][] */ 38,1,3,17,43,-30,95,105,-65,52,1,42,69,-39,19,9,30,14,-127,17,22,-24,22,22,37,-78,29,-21,35,-28,16,27,27,35,-1,28,60,-20,94,33,36,123,-17,-63,85,70,14,104,-35,-50,54,-64,-49,40,-43,-7, 
  /* [107][0][][] */ -18,32,0,-7,51,-33,60,28,45,38,44,-30,60,31,-4,7,79,-4,-27,5,2,-19,10,-2,57,-25,-32,23,-48,-29,38,66,-16,82,-25,9,-65,7,-21,-2,-53,-3,18,73,127,16,10,28,-29,69,1,61,-34,-21,10,-16, 
  /* [108][0][][] */ 0,-10,3,127,86,-43,-64,-37,51,12,-49,84,35,-25,-14,3,-4,47,37,-18,-54,44,58,-45,-32,-125,79,44,27,3,-19,22,43,21,-8,35,-66,5,-78,-95,-63,-37,1,-13,26,-23,-1,11,-59,34,-9,1,-41,-9,78,19, 
  /* [109][0][][] */ -18,-21,-11,5,18,-35,6,-34,18,44,-10,-16,20,39,-18,13,-25,-22,9,-24,2,-2,36,11,54,13,-32,-20,17,6,18,29,11,-41,32,26,1,31,8,-3,26,-19,32,-2,19,21,-3,23,-28,15,-26,-44,-12,6,-13,127, 
  /* [110][0][][] */ -20,-34,-127,47,5,109,31,-2,-51,46,35,34,32,25,-69,-60,-67,-17,-21,-63,36,0,91,35,33,34,54,28,1,-26,19,36,-44,44,-59,22,-53,8,32,-7,14,-89,2,81,92,-68,-44,-98,-41,-76,-72,47,16,-77,52,-85, 
  /* [111][0][][] */ 39,-58,6,47,12,78,11,-50,-13,49,-96,-24,-25,-6,47,47,-43,-11,-5,-65,-25,26,1,1,9,24,-18,-2,37,-36,-6,-36,-50,11,23,-13,-11,9,45,48,-36,5,-44,77,0,26,85,127,7,45,40,-49,-40,-26,-11,43, 
  /* [112][0][][] */ 11,55,73,8,-65,-8,33,-30,-4,58,-6,50,-53,-79,51,-47,100,-66,16,-58,-31,-28,-47,-47,12,17,96,-14,69,-109,61,-4,-29,-32,4,-97,91,-87,-23,41,42,-8,19,15,-51,127,-12,37,-19,101,-88,-3,68,70,-87,31, 
  /* [113][0][][] */ 9,45,21,-52,73,-19,5,109,23,66,-127,54,83,-23,-2,7,-66,5,-41,-47,-71,58,50,-20,14,-68,-32,-14,11,102,-15,21,-51,-28,46,-11,-52,-82,-26,16,87,-56,-47,-14,108,-86,-30,-120,33,-72,42,81,78,60,-28,-44, 
  /* [114][0][][] */ -11,-48,110,105,19,4,36,15,6,1,-86,74,-6,55,-50,3,-6,12,55,2,-48,73,-1,-6,22,-127,0,-11,26,51,-66,-67,-18,-55,77,47,35,-7,-8,-50,94,-31,-19,38,-51,73,-28,6,-115,-28,35,3,50,26,23,15, 
  /* [115][0][][] */ 27,-52,35,-22,92,-53,70,-29,26,-60,-13,34,-20,-57,-39,46,26,-19,5,51,3,-14,-22,-48,42,-1,15,-1,11,-52,-22,33,-2,-4,-24,74,119,-17,7,4,-39,-7,20,-7,25,15,17,127,-5,23,48,-53,34,-71,37,-34, 
  /* [116][0][][] */ -111,-38,-127,-21,53,0,45,-42,-63,-22,-108,-15,-61,30,-92,-4,51,-76,50,-49,-48,62,-69,29,34,-17,31,16,28,-42,10,46,-94,-47,59,-21,0,-7,110,-32,-40,82,-40,-80,21,-47,-17,-70,72,69,21,-100,-79,-27,3,24, 
  /* [117][0][][] */ -80,-10,-73,-5,-40,-111,21,63,-16,62,-121,-59,-59,28,-54,24,-71,-104,-93,-11,-78,12,-67,19,34,127,37,71,-45,-14,74,60,-60,-78,44,-54,-13,49,-77,-6,-70,7,-48,-3,29,-19,-100,30,-24,83,22,59,60,41,-15,-58, 
  /* [118][0][][] */ -22,59,76,-118,72,-46,-92,-44,-17,-124,22,-49,-15,122,-5,-39,-37,6,-70,-58,-88,-1,76,73,26,-10,27,127,3,-48,45,-19,41,19,27,54,14,9,64,-22,62,-92,18,-68,25,47,-9,32,-7,13,6,25,18,-75,23,117, 
  /* [119][0][][] */ -45,-22,-29,-83,57,-15,33,-60,37,2,-13,-15,2,-11,-127,42,-3,-73,116,-11,63,-71,43,1,31,-4,40,25,5,50,-23,0,32,15,-66,9,0,43,-28,5,-21,-60,28,-6,-12,-77,25,-117,28,45,23,55,-61,-86,5,98, 
  /* [120][0][][] */ -29,-12,20,-127,-23,-15,-39,-24,45,11,-67,22,-7,-9,91,95,28,-29,34,-12,-37,24,62,-13,-12,-71,-102,107,25,-6,5,7,-34,72,-26,-42,-71,-27,44,-41,3,-23,27,73,58,-46,-88,-44,-8,62,6,-30,-80,41,9,-101, 
  /* [121][0][][] */ -68,-102,-66,-88,73,22,-15,-58,-30,-29,20,-10,-117,-112,11,38,9,5,23,51,45,-3,-47,73,14,-104,35,27,55,-10,82,-49,-21,-21,-54,33,-25,-9,-76,10,-68,-63,-16,-14,-93,30,79,-35,30,127,-51,-108,73,-4,63,49, 
  /* [122][0][][] */ 26,-2,-56,-39,16,-15,53,59,-29,39,-16,-16,16,33,-5,-82,41,-63,-14,-5,28,16,51,-42,18,29,14,1,-33,31,49,-29,-40,-84,7,40,127,47,15,-13,60,35,-1,4,18,0,36,46,-45,-5,-18,-5,6,-42,34,74, 
  /* [123][0][][] */ -52,-20,-6,26,44,-38,-39,-127,34,-34,-47,12,36,10,-8,24,-27,-12,56,-44,-52,-13,-53,-19,-63,8,62,21,38,1,-47,-44,-29,-91,22,-1,4,-33,-8,-24,54,-38,5,14,-19,-68,-42,-27,3,-43,-11,-8,-14,0,0,-52, 
  /* [124][0][][] */ -2,-49,73,75,-7,-28,20,-12,127,-74,-61,62,53,-44,-34,5,-96,-71,2,62,-59,-18,-21,-45,25,52,2,71,56,37,-23,92,-2,7,32,116,64,110,45,87,-68,16,-40,-43,-8,8,18,-11,-32,-6,15,21,36,-46,-61,-69, 
  /* [125][0][][] */ -29,59,-57,21,28,8,-75,-64,52,-19,-33,-41,-29,-8,-17,-56,52,-49,-29,23,-29,66,37,0,-10,10,63,23,53,-36,-30,-4,-20,-49,-17,-5,-31,31,-71,-9,13,-27,-36,-5,20,-16,-34,35,-14,-45,27,-42,-2,-8,54,127, 
  /* [126][0][][] */ 17,-28,-23,-21,26,-49,55,-44,-16,107,-98,-60,-78,-10,-63,-35,31,-22,-92,-42,-69,-9,73,41,3,75,-108,29,-43,53,13,122,-10,-20,-25,-32,80,16,-40,21,127,98,20,-59,44,-2,-112,-29,-13,48,-24,27,-1,47,-17,-111, 
  /* [127][0][][] */ 64,14,-1,41,68,-19,0,-26,58,-9,18,83,90,80,28,11,58,33,-18,127,-2,-42,-33,38,43,-72,-24,-9,-6,-5,-8,3,-64,-33,29,59,-9,31,37,-10,6,-18,-12,-8,-14,29,30,50,-1,5,-3,-62,30,-15,38,-13, 
  /* [128][0][][] */ 30,-114,-27,116,-5,61,127,67,20,1,-32,30,-67,105,37,-21,-41,-48,1,-27,-95,-123,-18,-2,99,-23,71,-118,-13,-88,-28,-11,30,-48,-30,126,-51,101,18,50,-62,-5,-10,13,-74,79,-26,-10,35,3,-67,-52,4,-13,29,-36, 
  /* [129][0][][] */ 49,83,-33,-98,89,-20,-12,100,-15,-5,-14,-28,-23,47,111,-8,26,-4,-41,42,-15,-49,-15,-44,-10,-26,-37,-39,4,-127,68,-1,-2,-50,-79,34,57,41,25,-11,27,46,30,29,-1,14,28,69,62,73,71,0,-49,4,-20,-61, 
  /* [130][0][][] */ -1,-7,37,-22,12,-17,0,62,-11,47,-70,-2,3,97,10,24,20,-6,-33,-46,-39,28,40,-19,30,13,48,-48,-23,-42,1,56,-28,-14,-78,18,9,127,72,14,36,87,-29,-14,16,17,1,92,6,12,28,-17,23,-82,-33,-7, 
  /* [131][0][][] */ -63,10,41,-9,20,-6,-14,-46,-45,-15,-44,-57,39,25,23,45,-52,-45,9,-23,-38,-106,30,50,59,-119,-27,-23,-93,-3,-4,-16,-59,-48,-22,-60,-9,78,-58,-48,-69,-127,44,22,-35,87,23,-22,-22,14,58,10,59,-25,63,-6, 
  /* [132][0][][] */ -71,-71,16,-60,-9,28,57,31,-49,16,-127,-39,-38,41,-22,-4,-9,32,58,-8,-65,-64,-43,23,-20,-66,42,-19,59,18,-28,11,12,9,-32,-92,88,-31,33,-73,-109,26,12,80,-54,60,-92,67,14,41,-23,-98,0,6,-59,14, 
  /* [133][0][][] */ 53,-40,-10,-37,36,11,87,-39,-25,42,-92,0,-3,-26,50,-11,-53,3,-42,62,-54,64,55,12,-39,55,26,-81,25,82,81,26,75,-80,-67,18,-84,48,-43,57,3,-83,23,-11,56,91,25,-3,-74,50,-127,-19,-38,102,40,8, 
  /* [134][0][][] */ 7,39,-100,-76,37,31,75,67,-4,67,-37,-40,-101,-19,-23,38,59,-22,-119,-55,-68,-30,-79,-62,-23,54,71,11,40,-50,46,28,80,77,18,-77,-38,-40,-98,53,-37,-57,-28,-2,-20,-64,127,-3,64,-15,78,46,-100,47,73,14, 
  /* [135][0][][] */ -42,-39,27,56,-15,-51,33,-19,48,-5,36,25,-59,-21,-55,52,13,-37,-22,56,-44,-62,-127,-35,14,-11,57,33,16,-29,31,4,31,-40,48,32,-67,26,-27,43,-20,5,8,-19,9,-1,45,72,-23,-20,47,36,42,17,19,33, 
  /* [136][0][][] */ 73,-60,16,-38,-79,-8,-90,-27,62,-41,-2,43,-16,-12,3,-66,-7,55,-68,-46,-1,-20,-40,37,-87,-59,26,3,57,34,47,-40,-58,-30,-8,-127,6,39,31,22,19,1,-40,-108,-25,-15,-30,-6,-24,-64,64,7,-8,-39,-82,-16, 
  /* [137][0][][] */ -88,-37,-48,-54,-8,-24,69,-1,-32,25,55,-14,-85,-26,-14,15,-63,11,89,-59,36,-94,110,100,16,-4,102,-42,18,111,97,54,53,-5,-127,-20,-54,10,12,-17,7,-4,-41,-10,-22,26,26,-24,-72,-15,25,4,63,-105,-36,110, 
  /* [138][0][][] */ -42,72,-5,-92,-20,18,13,-86,-39,14,112,-48,-52,-108,52,-5,10,-19,57,-42,88,-28,-39,-12,-4,25,12,51,-86,-51,100,66,-27,-35,-71,53,-35,69,-55,5,11,22,-127,-44,-120,15,87,27,45,5,32,-115,-33,-94,38,109, 
  /* [139][0][][] */ 21,20,-81,43,-61,-83,99,-63,13,10,8,46,-79,-26,64,27,-62,91,23,3,-42,-44,41,12,-72,-72,-24,50,-10,93,119,-2,-127,14,-19,73,-1,-20,49,-27,-17,32,-121,31,-6,49,-11,9,-106,-75,16,-4,11,-23,60,123, 
  /* [140][0][][] */ -50,51,38,-45,-29,-28,-7,14,41,-21,-36,-51,12,19,73,18,8,-72,21,84,-90,2,36,15,46,45,-22,-21,-17,-1,12,16,30,-32,-84,-43,-18,9,-32,84,-30,25,58,-74,75,17,65,6,4,-19,-7,-127,-46,-22,-17,6, 
  /* [141][0][][] */ -37,39,84,6,33,-6,-63,87,-33,19,-42,-34,19,-55,-127,-3,-17,-12,-72,-102,29,-84,39,111,8,12,-27,-77,41,-37,-5,11,-2,-33,36,31,-26,17,-32,4,-7,-9,-23,-77,5,-36,-4,-14,3,10,-5,-69,-60,-8,115,52, 
  /* [142][0][][] */ -18,-16,-46,-12,57,22,-15,44,-97,73,-68,-11,16,127,63,40,-45,-35,-28,-49,17,102,-47,29,-76,-40,27,-35,32,25,-37,-25,-47,-76,-44,-55,110,-49,60,-69,77,29,36,24,76,37,0,28,-37,55,71,-91,32,27,1,-2, 
  /* [143][0][][] */ -127,-40,87,18,-8,-26,-52,-33,5,-18,-53,-17,-103,34,10,-15,-10,-56,-62,-30,-18,-50,25,30,10,-7,94,12,-9,-99,-97,-27,-26,40,-66,35,-46,-43,-61,-24,-78,-9,-8,118,-38,40,2,-8,-54,17,-24,51,48,-9,34,-41, 
  /* [144][0][][] */ 7,57,-106,8,65,18,4,32,-87,-106,26,-39,-26,-106,-40,-81,19,-42,39,-112,-95,-97,19,96,-34,-88,0,37,-127,61,-66,29,8,94,-26,31,39,20,-21,-71,37,43,65,-59,46,-44,43,57,-26,0,19,-15,36,-44,-33,54, 
  /* [145][0][][] */ 41,-51,88,77,47,-127,8,-116,65,50,-118,4,95,10,-7,-44,91,11,51,85,25,45,-18,-73,-87,29,-36,44,-43,-63,-25,36,-98,-39,112,-46,57,-35,46,-14,-19,96,29,1,25,-90,0,-1,-66,-94,-13,45,62,26,-33,-41, 
  /* [146][0][][] */ -19,-7,-69,3,-17,62,71,12,64,28,-16,29,30,-59,23,8,14,-13,-33,2,15,58,73,-2,-32,-1,-21,35,31,34,-51,21,36,25,-45,-18,-36,20,49,-32,127,89,0,46,40,2,-54,56,-76,-62,48,-11,7,-41,-60,-72, 
  /* [147][0][][] */ -48,-1,63,46,4,-3,23,-16,35,27,-49,50,127,53,-12,-37,-28,24,7,17,6,-56,69,11,-7,-23,58,71,-79,33,38,-53,-57,-27,-10,-22,-58,34,51,3,-7,-6,3,36,22,-17,23,1,-30,40,-32,-10,33,4,39,-22, 
  /* [148][0][][] */ -102,-37,74,-11,30,-33,67,86,64,-16,-70,89,51,-90,103,-68,-27,-110,-94,11,29,-6,0,127,-19,-79,-7,66,8,-79,25,-10,124,48,-36,-60,40,90,-10,-96,1,-86,-35,28,39,-64,33,23,-6,-125,16,73,5,-58,-23,35, 
  /* [149][0][][] */ 9,-19,-9,17,29,-5,20,37,5,49,-16,32,12,34,-19,-37,-22,-15,13,37,-66,-11,-12,-89,45,-30,-46,-49,-4,55,5,31,-50,33,12,21,-30,-15,-5,-127,42,-33,-10,2,17,-64,93,-2,-77,8,-58,-47,-36,60,-26,-49, 
  /* [150][0][][] */ -90,2,-45,-68,-7,-25,-15,8,31,-5,-95,-69,-89,-37,21,93,-18,-67,127,-51,5,9,11,-27,20,42,-40,-28,-38,53,65,26,-6,76,-116,-52,4,99,-28,43,-11,16,45,42,54,-8,23,37,-35,-42,-90,-105,-7,-66,14,23, 
  /* [151][0][][] */ -25,-53,39,42,17,-31,115,-97,12,-46,0,-18,1,27,-36,-2,-33,-4,18,6,38,42,5,24,127,-68,-14,74,73,-2,-23,41,-101,-27,1,-28,6,6,-53,-4,-70,-6,-31,-11,-8,-54,46,37,-40,-21,44,-48,50,49,66,-42, 
  /* [152][0][][] */ 42,-112,-10,-73,56,-70,-50,-36,28,-46,-67,-46,11,-22,72,-49,38,-81,27,3,45,45,52,37,22,9,-16,-46,86,-7,101,10,-69,19,56,-11,-75,4,13,-36,-107,66,13,19,-11,-59,-26,101,-56,-17,-127,-48,-18,6,14,7, 
  /* [153][0][][] */ -34,-30,48,13,-34,-17,6,43,10,46,-10,30,0,29,-31,67,97,-30,-32,77,-127,2,-25,19,-30,-18,-46,127,-17,-85,48,10,-39,-76,105,26,-37,-39,91,72,62,82,-23,30,-10,-46,-54,17,60,75,-17,-98,-36,-18,71,-56, 
  /* [154][0][][] */ 64,15,15,29,-3,11,-31,-21,-1,-50,34,56,28,11,18,1,-25,3,18,43,68,26,-2,49,-39,-89,23,75,-51,-74,-41,-11,32,-68,43,-24,-37,5,-40,5,-7,-91,2,17,-44,22,-48,-92,-40,24,-1,18,13,127,-65,-31, 
  /* [155][0][][] */ -127,-59,3,6,33,7,36,-7,-32,-7,-10,-3,-92,-69,17,13,18,-84,-63,-39,-37,-67,-35,-27,-43,59,26,22,36,-21,31,99,-21,10,-48,51,-3,7,-32,-16,-8,-42,-31,82,-4,20,-6,-41,69,55,-13,-78,-115,-64,27,-57, 
  /* [156][0][][] */ 25,25,-11,42,122,9,-8,35,40,96,-54,-24,93,32,48,-34,10,57,-107,51,-65,-3,-77,-62,-25,83,-22,-20,78,-104,26,28,-40,-26,30,29,34,41,-9,-15,-6,61,112,94,106,-82,68,86,108,9,-11,47,-45,-127,-44,-91, 
  /* [157][0][][] */ -47,-60,18,-46,87,-64,11,46,-78,38,-88,38,-104,-24,49,-44,-99,-68,123,32,-8,-2,-10,-52,-70,-3,89,-12,31,111,-76,72,-66,-58,-96,4,5,8,-45,70,3,-10,-3,3,-89,-55,8,-14,-127,-40,-28,-13,109,-55,-85,39, 
  /* [158][0][][] */ -38,-15,-60,4,22,27,-25,33,-60,3,37,-76,42,-62,-31,-36,30,-27,-66,-83,50,25,57,127,81,-14,19,-95,15,4,-13,25,-14,-52,38,2,-44,-23,-53,-17,47,-2,9,-38,-48,44,97,14,-43,5,60,56,96,-25,34,99, 
  /* [159][0][][] */ 30,-8,-13,-108,54,-70,92,83,34,29,-4,45,-127,-9,-16,-45,5,39,92,51,-108,-33,-15,89,-72,45,38,-73,97,-72,54,38,62,39,8,-9,-87,-29,61,-11,-32,-1,27,-47,-26,56,50,107,-11,39,88,88,-44,-82,88,-85, 
  /* [160][0][][] */ -11,-93,-46,-23,4,-7,71,49,39,-17,1,37,-9,-39,-4,-13,-12,-42,-39,-7,0,27,-9,-34,16,-25,-49,73,40,59,0,20,35,8,48,-25,-50,-2,-69,-9,1,-86,-55,127,61,9,32,-38,-25,77,39,-23,-5,64,-10,-18, 
  /* [161][0][][] */ -96,57,12,-14,75,72,-13,-5,-41,69,24,-78,-94,-1,37,-93,-11,37,4,-20,14,-20,-114,27,-34,-127,-1,80,-34,-20,-24,-44,24,-91,-28,-39,-6,9,-120,-60,17,-1,-81,-1,93,35,-72,-7,48,-27,-21,26,103,-20,29,-88, 
  /* [162][0][][] */ -67,97,-34,-17,-25,5,122,18,42,27,63,-50,-68,54,-24,29,-1,2,-23,-59,-8,-76,-4,7,17,9,-28,-20,-36,68,43,-2,33,37,-55,-21,27,94,68,48,-7,16,80,11,57,-8,46,11,-31,-43,-39,45,-68,-40,-89,-127, 
  /* [163][0][][] */ 39,-73,-16,67,-40,26,-21,-61,90,28,-43,-49,18,6,71,-27,82,16,17,30,-38,-10,-5,50,31,-7,-91,90,-11,52,-33,127,-62,-14,36,-33,-64,-12,-70,28,29,-49,-33,66,25,-1,-10,-22,-85,-7,20,-105,69,88,47,-13, 
  /* [164][0][][] */ 64,6,13,92,71,-45,38,-55,29,100,-40,21,16,3,6,10,-113,13,-31,-33,-51,24,-36,7,27,18,72,38,22,72,-41,0,-42,-127,107,90,94,50,46,1,77,-26,-42,23,-13,-52,-62,-57,43,12,-29,-83,78,-87,63,18, 
  /* [165][0][][] */ 11,-13,-40,23,-63,-63,11,29,74,19,-27,21,-53,-82,25,-57,35,-3,25,-61,-3,8,23,2,19,-52,-46,2,-70,3,19,-8,3,32,20,-29,35,-86,-38,-60,6,-30,67,-19,43,49,127,-38,44,-23,2,-16,-60,61,-21,2, 
  /* [166][0][][] */ -3,-11,-114,-97,-76,-66,45,-1,50,-64,105,66,-6,20,-6,72,95,46,5,52,39,-64,-6,25,44,62,-15,11,1,32,-5,28,-16,-29,92,127,32,36,88,41,27,-46,-40,46,-13,2,-7,6,-48,9,-102,-5,-103,-55,39,56, 
  /* [167][0][][] */ -38,-62,-61,-20,-43,42,-56,22,17,-17,-57,-50,2,11,2,-77,7,40,-26,-85,-68,-124,18,25,26,-44,6,28,18,13,-23,64,-49,-10,61,-44,12,6,-28,30,-25,-6,-8,-17,-60,38,-57,23,75,75,79,-56,-58,-59,127,-26, 
  /* [168][0][][] */ 18,-87,127,39,63,4,42,30,-19,-32,-68,4,-1,-5,-10,89,-69,-56,-32,-8,-1,5,66,-69,7,-104,5,35,-24,-67,31,56,-62,-24,-62,-24,-1,23,-105,42,26,-38,43,40,-36,35,-8,-68,-11,5,-80,-88,-17,5,-122,-33, 
  /* [169][0][][] */ -127,-45,-82,-88,-74,33,67,55,-30,-27,5,-8,-60,-34,23,-9,37,-63,-60,-1,-25,-11,1,35,46,104,-44,16,38,-5,57,-37,-35,22,18,74,33,101,63,8,-24,68,-57,30,39,46,37,12,25,-8,18,-94,20,14,40,40, 
  /* [170][0][][] */ 43,-12,-17,-103,9,15,6,-24,15,-70,12,-4,16,69,-2,17,14,51,104,-50,-30,-83,38,3,38,114,73,-84,46,-11,36,63,42,12,-8,12,83,75,-53,-32,41,21,63,-7,42,-127,-95,-15,-45,-13,-10,76,-14,-30,-20,-67, 
  /* [171][0][][] */ -9,-127,40,5,-21,0,-39,-66,63,-109,-101,28,-23,95,89,-14,-71,-9,21,32,-97,26,-63,51,45,-60,78,96,-18,19,-43,75,10,-29,95,-3,42,8,18,70,-67,-12,-32,-1,-46,14,-2,-34,-2,67,-24,-36,18,6,75,-99, 
  /* [172][0][][] */ 17,2,-33,-36,106,-20,23,-52,33,38,-3,-30,-46,-41,11,58,12,51,-41,-34,-65,65,52,22,-36,-11,-48,-106,-48,98,-107,9,-34,-83,1,-92,32,23,-44,35,-37,42,57,17,-42,-127,-6,10,-4,83,-85,-11,-37,-55,-75,-3, 
  /* [173][0][][] */ -8,-7,-40,-37,-13,22,56,-83,-7,46,21,-18,-55,42,46,-63,-53,-62,44,75,51,-65,35,99,41,-73,24,-11,-25,65,-49,-31,36,-2,-92,9,-13,127,49,-28,-11,-6,-21,4,-45,38,-77,90,-25,36,31,-66,-15,-55,63,46, 
  /* [174][0][][] */ 6,-50,43,-37,38,-47,24,-11,127,-11,-10,-32,-2,-56,-4,-20,-1,4,-23,11,-54,-64,31,-3,78,17,30,11,-7,-9,-17,-2,18,14,-9,16,-13,11,-45,36,24,41,-12,21,-51,30,30,28,-45,40,16,1,-34,-8,-37,22, 
  /* [175][0][][] */ -101,-9,16,-27,-52,16,-15,-3,-105,46,-28,-1,-63,80,-112,-58,6,9,-43,-25,64,-13,-127,63,-58,-63,33,-112,-18,-81,-25,-58,6,-27,-125,-59,-26,-86,77,-69,-91,-4,13,37,22,-89,46,23,-32,19,55,-54,92,56,-37,91, 
  /* [176][0][][] */ 127,-5,-40,70,-28,8,-46,-76,16,4,-26,-39,27,38,-21,85,-12,-13,29,46,-21,-18,-10,-21,-11,0,34,38,-42,77,-31,-37,18,-5,-27,-12,36,-34,-1,-14,-37,-10,-29,22,1,-4,-6,-38,5,29,-7,-49,71,-9,-67,-69, 
  /* [177][0][][] */ 65,-6,51,-32,3,-15,13,-80,54,-30,-2,59,43,21,-19,55,-63,11,46,0,53,5,-66,-5,-104,-106,-15,25,4,12,13,-34,45,-50,36,-17,16,-43,21,7,2,22,13,-21,-1,-30,-25,-4,-32,74,79,75,116,51,-127,-39, 
  /* [178][0][][] */ 46,-59,-36,37,29,9,50,2,57,44,-2,3,44,109,-54,-73,21,-4,-41,40,-15,-5,-5,-31,56,127,-1,33,-24,-38,59,5,-25,26,-19,23,38,-13,20,-62,88,63,86,37,49,60,99,24,-8,-58,-16,67,6,-17,58,14, 
  /* [179][0][][] */ -7,-85,-1,-58,-77,-13,2,16,59,-66,-85,-17,77,31,-15,25,-26,73,-12,50,-12,-3,24,41,18,3,-87,10,-72,-18,-15,64,-127,8,-98,43,-35,13,-8,-78,-45,-21,39,6,0,-32,14,-50,-24,-40,-75,44,51,-3,110,-56, 
  /* [180][0][][] */ 25,-1,36,27,79,-46,-101,-37,15,-37,18,-40,21,-20,47,-68,-70,25,-22,25,29,-58,-7,34,10,-81,10,13,-16,-52,-72,-18,-127,-33,86,-23,41,-18,-45,28,18,-50,-33,-5,-101,7,64,-49,0,-12,-7,-98,66,121,31,50, 
  /* [181][0][][] */ 5,-3,-13,-88,-67,-107,43,83,0,-30,16,-23,-3,-99,21,-92,16,66,3,40,127,-90,-82,22,3,38,3,-90,-122,-23,-26,38,7,13,-60,26,-12,95,88,56,-48,13,-40,-62,27,-64,73,42,-38,-21,-61,-53,21,44,-6,-30, 
  /* [182][0][][] */ -92,-62,0,-18,-96,-24,-4,-67,44,-17,-81,-2,32,42,36,28,-111,23,57,-73,-36,13,-8,-44,-48,-1,1,35,38,35,-38,-49,-73,-65,-30,51,-66,73,42,-27,-56,67,-63,21,-19,-3,-5,-98,-56,90,-36,2,-18,39,127,83, 
  /* [183][0][][] */ -127,-40,73,-53,5,-48,-27,-32,-59,-39,-3,-15,8,20,25,30,-47,-89,67,-11,43,-5,16,38,-11,-59,99,119,16,53,-1,25,11,-78,-29,43,60,-55,-74,69,90,70,-95,-8,-2,58,74,8,-42,70,59,-69,103,-51,-20,50, 
  /* [184][0][][] */ 73,0,-24,-63,-16,-50,-37,54,-21,30,-14,-46,-4,-13,18,-34,-14,14,-34,127,2,-46,49,38,57,54,-79,9,68,-77,48,-18,-94,-32,-5,-7,39,84,55,73,-42,4,-25,-66,-70,-3,38,50,60,13,-71,75,84,-31,-51,26, 
  /* [185][0][][] */ 5,-46,-6,-45,16,38,-60,22,74,-16,-12,22,20,-57,-4,-31,-33,40,-39,1,-70,-3,2,5,28,40,19,-29,50,-3,-16,51,0,-25,-14,-18,6,20,-11,18,-28,-73,84,-11,-8,-77,10,15,-35,-38,89,-10,-34,-2,-94,-127, 
  /* [186][0][][] */ -14,15,21,24,-43,-44,25,-1,39,-33,-29,2,-16,-42,-26,38,4,-83,58,11,-11,-18,-21,-16,-7,62,41,33,44,-19,-3,-16,-17,57,-30,29,4,9,127,16,33,-1,-2,-27,-5,1,-39,72,-75,41,37,9,28,8,78,3, 
  /* [187][0][][] */ -77,-1,64,-22,-27,31,26,20,-34,48,20,-39,49,-25,-111,-26,34,-10,-2,-117,-9,6,4,103,44,23,-29,-108,-14,23,-26,55,-31,16,-36,-70,-6,46,21,24,18,-31,-6,38,62,127,-9,92,21,16,10,-71,6,-18,24,64, 
  /* [188][0][][] */ -40,26,66,11,9,28,-61,34,21,86,-38,-50,-72,-28,95,30,-64,70,-71,-13,-13,33,-39,-8,38,-28,68,40,42,96,109,20,-14,-96,-23,24,-44,66,-15,-32,-25,-105,-54,-3,91,8,80,127,-20,-59,-28,-72,100,-78,68,-26, 
  /* [189][0][][] */ -28,-24,-11,-81,16,41,20,-30,36,-22,-17,-23,-36,-77,-48,31,83,-56,9,52,-4,12,-60,-91,-67,8,17,18,1,-7,63,52,10,-127,29,62,-7,110,11,89,-32,3,61,32,-38,-95,40,-9,4,55,-4,-18,-71,5,-81,68, 
  /* [190][0][][] */ -93,-89,58,-52,-17,2,29,-52,25,-127,-9,64,-127,31,7,-50,39,-43,-12,53,-12,-40,-58,-126,10,9,64,-25,38,37,-72,-20,-79,-52,46,48,44,0,-38,9,20,-33,-21,24,29,-10,-32,59,-23,47,23,-122,-44,24,-8,24, 
  /* [191][0][][] */ 43,-10,-34,62,-40,-27,23,-127,-33,16,51,-2,57,81,23,13,-13,-60,7,-6,16,64,127,-55,-11,19,-9,39,63,7,32,57,-13,-89,-29,19,-44,-27,-24,-34,16,-20,-81,10,-40,-108,62,-31,-70,46,-36,-85,20,0,-30,-34, 
  /* [192][0][][] */ 47,35,-42,-74,18,-56,8,-40,22,-35,-127,79,-13,90,-16,-35,-81,28,24,74,9,66,-67,28,-8,5,78,23,-74,-31,28,70,94,-49,44,69,-26,27,-40,6,25,-11,-43,50,114,4,5,46,-53,78,21,40,7,5,-45,-10, 
  /* [193][0][][] */ 54,-70,84,0,-81,13,-30,-47,50,-44,-13,-21,127,-13,28,39,-11,96,17,86,25,43,-18,-17,-62,-69,-56,26,-35,11,-8,20,-27,-74,49,1,61,-9,-59,37,-51,-29,-8,-105,-68,-33,-54,115,-53,-8,-1,-68,39,84,-76,-79, 
  /* [194][0][][] */ -26,-26,-37,-7,-7,-34,65,-92,33,36,-20,7,-50,43,1,-59,41,45,127,26,-13,-11,-24,51,-54,-26,80,25,-19,60,117,32,24,5,-27,60,16,-58,-31,-22,96,5,-29,14,59,-6,-4,33,15,-32,-22,5,64,69,11,24, 
  /* [195][0][][] */ -1,-57,-89,55,49,5,-58,30,15,0,-20,54,-13,23,-3,57,-36,11,43,-34,-51,-26,56,21,33,-5,93,23,-13,-9,-63,30,63,-67,127,14,-26,-19,67,35,-43,-7,36,2,9,39,-29,105,16,-20,31,54,-37,44,6,-65, 
  /* [196][0][][] */ -19,-20,-14,-1,67,65,30,-34,-104,80,-38,26,12,-58,36,-45,56,-52,52,37,49,-23,-17,-57,-2,-19,13,16,79,46,25,15,-11,30,14,64,28,9,6,-34,127,59,115,36,52,22,38,110,22,3,47,43,19,-96,-24,4, 
  /* [197][0][][] */ 113,0,99,99,79,15,51,64,92,49,-34,-29,35,29,-112,-2,-5,26,-121,-96,-102,5,57,-48,109,-17,58,-127,5,-56,-47,-35,5,-16,-4,-71,27,100,31,13,-39,50,-1,7,5,-43,-43,-63,39,-100,42,25,24,-9,-59,-28, 
  /* [198][0][][] */ 116,-69,53,-35,-97,-23,102,-96,31,72,-29,7,-20,71,-18,-32,-37,-88,49,-74,-79,-9,85,10,7,-16,-119,20,19,1,-3,98,-111,-15,-22,49,-19,-9,33,-46,41,-39,41,17,7,40,-47,6,-12,77,31,41,8,-16,-127,-56, 
  /* [199][0][][] */ 66,-31,23,-29,40,59,31,28,33,47,-57,-31,0,37,-52,36,-15,-66,93,-72,-56,19,-43,67,48,-109,-9,-34,-100,16,-56,74,-100,-95,-44,107,8,2,-7,54,-92,-34,-127,-9,-21,39,-2,-12,-86,38,-20,-16,-11,90,-30,63, 
  /* [200][0][][] */ -103,82,14,15,-51,43,-10,25,72,-20,-3,31,-8,-2,22,-28,96,55,31,-26,-2,-46,-30,-12,17,-80,127,-12,76,-22,-28,-50,-23,-45,9,28,-46,-21,-7,-16,9,48,-20,-11,35,1,104,84,28,-36,81,-55,90,5,-70,-46, 
  /* [201][0][][] */ 27,36,6,18,29,22,-69,-46,67,25,35,-116,13,-17,43,13,-122,-4,-1,-53,27,73,16,38,-34,18,45,37,25,49,31,-4,-62,-44,22,69,19,-14,7,-80,2,-29,127,96,-53,33,-2,77,-33,26,58,32,-110,13,-47,-82, 
  /* [202][0][][] */ -37,22,-48,27,-25,11,43,-1,-28,-4,67,-22,91,-21,-16,-103,-11,14,67,-58,29,-7,60,127,-33,117,-23,102,-59,46,20,16,-109,-20,30,40,-83,-19,68,-5,-9,2,-56,-8,70,-3,-1,-24,-106,11,-24,-34,26,-62,-7,-65, 
  /* [203][0][][] */ -40,-101,-23,-54,-41,-67,49,-127,19,-7,31,-92,-19,-111,32,115,-10,62,-21,25,-19,51,116,109,-45,-36,-38,11,-44,-22,17,69,64,76,-95,81,-12,-20,100,55,-38,-29,-21,90,74,-102,-116,-67,-36,20,-76,14,33,5,16,82, 
  /* [204][0][][] */ 91,80,64,-43,-11,-35,15,82,-4,-9,17,40,40,27,-14,-9,44,57,-44,33,-38,56,31,-54,44,50,5,-1,12,-44,127,-63,-64,-48,-22,-24,2,-27,11,-43,-20,101,32,16,45,-45,37,42,-29,-33,44,-16,-9,11,-50,-26, 
  /* [205][0][][] */ -76,-9,26,-43,74,-48,22,-61,27,-82,52,-71,65,26,1,33,-46,14,31,-29,-26,-14,-50,-41,12,-48,-79,89,-6,-16,3,-49,-37,7,-18,-9,14,21,-49,127,-23,-80,6,0,-29,-98,11,-6,25,-27,-96,12,12,-94,59,23, 
  /* [206][0][][] */ -10,57,26,-50,15,73,-69,47,-42,49,9,27,6,-124,-55,-100,27,41,-8,60,56,77,106,17,71,-28,-71,0,60,-77,37,4,24,-89,-47,-42,-45,-9,53,110,87,-24,-40,46,126,50,-13,-20,-50,74,107,-104,37,-44,35,127, 
  /* [207][0][][] */ -78,-58,-91,-26,-7,-31,-26,-42,112,81,-27,61,48,96,-3,36,70,-53,-7,88,-33,-29,-24,100,-35,25,44,-36,42,86,40,67,-64,17,-70,26,-8,42,127,90,-31,24,-4,73,74,-92,10,58,4,-34,-26,48,-35,-72,90,41, 
  /* [208][0][][] */ -59,-79,27,-29,38,-9,54,94,89,-59,5,50,-36,44,-32,101,29,10,-23,36,-46,25,-68,45,22,20,-30,-33,30,20,80,127,-59,-14,-43,62,-27,-15,3,81,13,-40,8,43,-19,29,68,-23,-79,-43,-79,18,88,102,-103,37, 
  /* [209][0][][] */ -8,-42,-12,0,10,-27,-2,-46,11,-51,29,-49,72,-48,45,5,-22,-2,127,62,39,75,-16,-10,0,-32,-8,-1,8,-41,-55,39,-18,-44,-56,29,34,11,-81,59,11,-36,-22,-13,-18,-64,42,35,-31,8,12,37,18,3,-41,73, 
  /* [210][0][][] */ -61,-39,57,54,9,-50,41,-59,80,12,-23,18,-18,4,48,-3,-41,20,41,-14,-1,-64,-27,18,-33,-65,-74,127,24,35,18,39,-71,5,-35,51,-61,17,30,32,-96,-32,-55,50,-10,45,-11,-75,9,-1,75,12,-27,22,-13,-33, 
  /* [211][0][][] */ -54,-75,-59,-35,-15,95,-7,-32,-53,-2,-69,-7,-19,-67,-127,-72,-25,17,51,-8,8,73,-32,78,-23,65,-101,-55,-41,87,-75,39,-9,-93,-79,-1,-83,-20,43,-63,-110,-59,97,55,3,49,62,77,67,34,59,-100,81,100,74,-72, 
  /* [212][0][][] */ -27,31,53,46,19,18,39,77,40,-79,112,67,-82,-49,19,-89,-35,-3,-70,56,-76,56,20,-13,-7,-43,-52,46,-17,-50,23,20,-77,17,-24,-31,75,7,9,12,-8,-10,101,-14,-62,-24,2,-21,72,26,115,18,37,-127,114,42, 
  /* [213][0][][] */ -86,89,-54,-62,32,-22,-13,96,82,55,-16,-89,94,5,-30,-1,-40,-64,121,-25,23,-51,-100,-65,94,-63,-97,-42,37,60,45,24,-64,-65,58,-50,-121,19,4,70,89,19,-2,8,43,20,63,72,-61,-55,127,35,-12,-10,82,25, 
  /* [214][0][][] */ -42,-23,11,-18,-22,-8,16,-55,27,34,24,22,-68,-47,54,34,14,25,-59,-34,-32,60,26,-11,55,-12,-5,37,15,43,44,-50,-30,9,42,51,-39,50,-36,55,26,0,-33,-51,28,-24,11,127,-82,105,-13,12,61,25,-57,8, 
  /* [215][0][][] */ -4,77,30,51,9,22,27,11,95,47,-127,22,95,88,11,-15,50,-47,-72,29,-42,14,-85,-11,59,-48,-61,54,-62,-72,-112,29,-40,-26,-64,-46,7,-8,39,-20,-53,88,7,-26,27,-28,-64,97,65,41,-4,-12,-70,1,73,-86, 
  /* [216][0][][] */ 42,-26,4,-40,-6,58,10,30,20,10,14,24,16,9,-67,81,-45,-21,-36,-47,-20,28,27,-72,5,-4,-38,40,34,89,61,32,-46,-88,-62,-9,-5,65,39,-36,3,-7,-30,-19,54,-18,-15,53,-26,-13,6,20,19,56,127,5, 
  /* [217][0][][] */ -42,-31,-127,4,73,13,12,-35,26,94,111,13,-24,47,-31,-14,29,51,-17,37,65,18,-37,74,-47,41,-107,42,-55,-17,12,-6,-4,-83,-19,-54,1,-11,4,61,23,-26,-51,52,19,-74,11,11,-20,-65,-54,21,68,-49,-4,91, 
  /* [218][0][][] */ -28,-39,-21,-76,-90,13,-14,33,-7,105,13,-38,-91,61,36,38,-37,-31,34,94,-114,-50,50,124,16,-8,-15,-37,21,77,34,127,-44,-70,-64,15,-38,96,9,-74,-22,-13,-50,106,64,37,113,15,-20,35,-16,-33,18,-57,-6,-61, 
  /* [219][0][][] */ 4,-36,49,-37,-19,-37,65,-10,22,-9,-74,48,15,82,27,22,-11,12,-16,11,-11,-14,-29,2,-43,-4,-20,71,6,127,-56,56,-49,30,28,49,-25,41,49,17,45,5,35,29,-9,29,16,-15,-36,21,-6,28,-1,-14,-66,1, 
  /* [220][0][][] */ 82,5,8,-2,13,-41,-12,-46,103,-50,-3,10,11,76,11,1,-42,116,-14,52,-10,31,8,94,-4,-22,6,-18,26,-30,-106,-6,2,6,-15,-9,-47,66,69,16,-97,-87,-61,1,74,-32,-127,106,34,-37,34,-7,37,49,-45,39, 
  /* [221][0][][] */ 16,77,-50,-91,23,9,0,-4,-54,28,-9,-35,103,60,-35,-25,-58,-38,32,-6,49,65,-2,10,0,-19,10,62,-18,-51,41,-47,1,-24,-61,-32,-7,23,-2,-10,-36,-18,-2,-35,127,-91,53,8,72,64,21,-26,-22,-84,21,45, 
  /* [222][0][][] */ 54,-107,-102,-112,12,-74,84,42,59,-32,1,103,-7,21,-74,-20,0,89,15,-126,-73,58,31,-74,-126,127,-41,-33,19,48,51,92,-63,-31,0,13,-73,-77,-2,-63,122,-66,4,61,86,-18,7,-21,-35,-19,49,20,-9,-93,2,69, 
  /* [223][0][][] */ -21,27,-35,50,-64,-87,-4,119,-78,-101,51,49,88,-3,66,0,6,36,-93,41,59,-47,98,34,30,72,79,-24,100,65,-82,23,-68,32,84,43,7,-11,13,-35,-4,36,-33,19,55,4,-98,46,-38,-48,9,-99,88,-33,-127,-61, 
  /* [224][0][][] */ -76,-17,7,-8,-58,15,-74,-105,98,50,-32,-33,-32,-88,72,-58,-29,22,-42,-29,-122,2,29,59,-19,3,71,101,-10,9,36,45,-51,85,71,-40,-31,-68,-18,-9,46,-127,68,42,1,-5,116,-26,18,42,-71,-46,-6,-36,-89,47, 
  /* [225][0][][] */ 26,-22,-41,-30,30,-15,30,25,31,-51,8,53,-5,61,1,-35,-62,-69,-42,-56,-74,-10,-8,22,-60,-60,-79,50,-46,-35,28,53,-34,-43,6,-42,-24,1,-12,42,-104,-23,72,2,-89,-49,-98,10,-38,-127,-29,-31,20,54,-5,54, 
  /* [226][0][][] */ -90,-52,35,-19,-27,13,50,38,-68,53,13,-19,47,29,-1,23,17,-20,9,-31,-39,-40,23,3,24,63,-12,-6,-26,86,56,43,-4,13,-61,0,47,-38,2,10,45,51,2,34,-27,29,127,-52,-49,40,-3,10,22,-31,-17,-69, 
  /* [227][0][][] */ -20,19,-94,-81,50,35,12,65,-24,75,16,-17,51,23,84,-12,-74,-54,66,102,31,66,69,31,97,40,35,76,46,-34,10,-31,-6,8,-27,116,5,2,-78,44,83,-28,70,14,-9,-33,55,46,-73,127,-5,-17,106,-8,4,39, 
  /* [228][0][][] */ 64,-11,23,0,-10,40,127,59,-20,-22,36,-64,-14,-1,73,-26,76,-20,-14,12,-33,-16,18,69,-108,-29,18,-15,18,-17,-22,-12,23,-7,31,-31,16,61,1,12,17,-89,-27,-38,-21,-48,84,-18,-47,41,27,30,-17,57,-22,-70, 
  /* [229][0][][] */ -52,-40,-17,19,-103,88,16,-30,-70,99,-26,7,54,1,-42,-19,-6,27,38,-12,-81,-1,-68,-77,-21,-29,-26,12,-15,-79,-20,-8,10,9,40,41,9,127,80,-9,8,-12,-26,17,-20,11,25,23,-72,16,109,44,-15,-26,92,22, 
  /* [230][0][][] */ -3,-120,56,78,-5,18,2,-2,24,-45,-54,3,60,-14,-21,-38,-5,14,-53,-39,-56,-5,50,-7,-50,16,11,29,6,34,83,-5,-47,-57,103,48,74,21,-11,9,-23,85,-44,-31,11,62,40,10,-17,18,42,6,52,18,-127,-115, 
  /* [231][0][][] */ 56,-50,73,26,52,-54,33,3,-61,-44,-20,24,23,-72,-13,-54,26,-25,-6,26,-23,65,-35,60,13,34,-5,17,-38,38,21,7,-29,-9,20,-3,-25,-29,54,-16,51,-96,-7,-13,16,41,7,-30,-14,50,22,2,-127,41,26,-23, 
  /* [232][0][][] */ -25,-23,-19,42,97,7,-100,-76,72,-77,-105,-6,-40,12,27,-43,-47,-83,46,103,-20,9,-32,7,-28,-56,61,36,98,20,-113,-9,-53,-42,-12,9,-26,-20,-59,6,1,6,58,14,-42,-1,-42,83,-9,30,63,-3,127,32,31,126, 
  /* [233][0][][] */ -89,-88,-50,1,-40,23,-51,36,9,-49,-17,56,33,-111,37,-90,-11,-16,-30,5,19,-35,127,-55,-52,32,-63,49,9,-43,-53,12,-11,48,-62,26,-28,-32,-28,-41,83,9,-12,12,6,-21,-1,30,-111,-18,4,-11,-11,-37,65,41, 
  /* [234][0][][] */ -76,-53,-54,-66,25,-67,0,46,62,68,25,20,-1,-99,-127,-43,87,27,34,87,82,6,3,-32,7,-92,90,116,-26,14,36,62,-60,9,68,120,-74,65,10,-100,70,-59,-59,29,86,-84,-90,-22,-123,-11,37,73,91,46,-60,29, 
  /* [235][0][][] */ 36,-17,100,20,31,51,-74,-82,54,50,49,-19,-60,51,4,-26,7,25,-9,-20,7,-19,61,4,67,-34,29,-1,27,0,-42,-99,127,-2,13,-11,-18,4,-60,74,-70,-69,37,34,-65,11,17,61,-29,-29,30,20,22,-22,50,-4, 
  /* [236][0][][] */ -2,-34,58,-22,-5,73,-3,68,-33,-29,54,20,35,-37,18,-9,-37,26,113,-53,27,-44,-16,33,52,33,-61,-114,60,-20,51,14,-35,-12,30,45,18,48,5,-18,-93,127,-62,12,53,9,-61,-7,-11,51,-62,18,89,-32,66,41, 
  /* [237][0][][] */ -44,-127,-3,71,7,-27,-12,-8,25,62,-82,22,-26,-35,20,-4,6,-50,-3,79,60,105,-73,-9,72,-21,-7,-63,18,62,5,44,-89,-49,-44,-45,-29,18,48,7,53,52,-58,80,-65,-29,-2,32,5,57,54,-1,35,85,4,53, 
  /* [238][0][][] */ -92,-13,-4,30,97,-12,-5,57,16,90,44,-47,-105,43,-75,59,99,-56,-23,-13,-73,2,67,45,76,21,83,5,21,-71,27,46,-17,-20,-117,-45,-27,-10,-21,69,9,127,3,43,-27,30,126,-31,-59,-124,-90,-71,-1,-17,48,114, 
  /* [239][0][][] */ -33,-55,-22,-5,-41,-23,-7,-65,6,-2,3,53,90,9,92,70,-99,98,10,58,-13,43,-103,11,-53,33,-56,-20,48,-15,-26,127,-65,-10,-68,34,-44,75,-54,23,3,-29,-93,44,36,56,-12,66,10,-55,-39,-107,-9,9,-61,-60, 
  /* [240][0][][] */ -17,-18,-7,5,71,2,72,-7,-20,9,-8,-1,33,-22,-75,32,66,-82,2,-56,1,-9,28,-17,-38,117,127,-16,-57,26,70,6,73,21,-48,78,11,104,-33,-45,-12,3,2,36,72,20,11,19,-67,-15,57,37,-14,-1,-51,-91, 
  /* [241][0][][] */ -74,-40,29,-18,10,26,-34,-22,-79,14,-17,-8,25,13,41,-8,-22,-51,32,90,16,64,-7,24,11,30,52,23,-3,18,-73,-20,-66,-110,-20,-39,28,-127,-114,-40,78,-37,1,55,-56,34,67,-91,-9,4,1,2,-26,-20,84,62, 
  /* [242][0][][] */ -12,-17,34,23,59,-4,14,97,28,43,-15,-17,-58,-54,-30,-31,13,-20,40,-11,59,-108,78,-28,-70,52,-111,93,20,15,-39,33,-42,45,30,-30,-80,89,-24,-36,-16,117,41,-24,127,-57,56,-17,-57,85,-51,-9,39,42,66,56, 
  /* [243][0][][] */ 103,-3,-49,28,39,45,10,103,-39,89,36,15,71,46,0,2,60,35,-93,-12,-66,22,88,40,89,41,-25,-101,105,-23,28,-118,-5,-3,34,-63,-17,45,127,9,80,12,113,-42,82,40,-27,91,-33,-40,75,-17,16,-7,38,47, 
  /* [244][0][][] */ -77,-17,57,-127,11,-19,95,125,7,-2,29,-39,75,-95,-113,17,38,70,-69,-119,-39,-14,-67,103,-11,-15,-22,35,82,-68,-37,-58,17,-8,-29,-59,114,71,21,-40,-49,38,-70,12,-8,123,47,-4,90,-29,28,-49,-12,32,-69,3, 
  /* [245][0][][] */ 49,3,37,-12,20,-17,-30,-76,66,-91,127,-4,-23,52,-19,-13,-37,22,-75,-29,-41,-14,35,51,1,-19,80,6,31,-15,13,-30,-52,-55,23,14,-11,-53,-14,3,-15,10,-43,-38,-9,56,8,-32,-124,-9,17,-18,32,58,-67,-38, 
  /* [246][0][][] */ -28,13,-31,83,58,-62,4,-24,-23,14,-15,22,39,27,122,-31,7,36,40,101,8,36,0,-16,-64,-34,-59,-12,-36,-10,-35,3,-60,-127,-8,22,-18,29,21,40,-2,-5,-94,22,-42,-96,7,22,-8,50,-20,-44,18,36,-53,11, 
  /* [247][0][][] */ -47,-74,2,-9,-91,-41,-63,72,-17,99,-11,44,-3,55,-69,-31,-127,51,12,59,-25,-20,61,68,-40,-28,-18,-1,4,40,37,16,-39,-23,-2,-37,44,-27,29,15,5,36,-48,41,11,-38,-69,-2,-68,-30,-59,-21,59,-6,-9,22, 
  /* [248][0][][] */ 20,38,-7,-63,-87,122,-66,-34,-74,20,47,-127,59,87,64,-8,55,-19,-90,-63,-64,74,28,118,42,29,-43,-66,-62,-47,-12,-4,-38,-89,-99,-36,-8,-19,4,12,5,9,50,96,62,33,-5,41,122,-48,-15,0,-6,-32,117,-38, 
  /* [249][0][][] */ 38,-36,-40,-91,52,60,-40,3,33,22,33,-22,23,-10,-23,34,-65,28,-88,10,7,16,76,1,83,-30,-46,-17,-4,-33,-23,-2,-7,-1,-53,-18,-98,49,48,8,-127,-32,29,47,-14,-71,19,36,-1,-33,-61,-39,-80,25,81,39, 
  /* [250][0][][] */ 18,105,-104,-63,12,18,58,-40,-22,115,25,-45,-24,96,11,58,10,-36,-27,-7,-25,-43,25,27,13,8,61,30,-49,-43,-72,84,13,-12,-76,24,-41,40,44,-2,6,-83,26,87,78,-94,-115,82,5,40,20,-35,-51,-40,-28,127, 
  /* [251][0][][] */ -6,-15,17,-120,127,-44,-14,-91,-25,-68,14,-78,15,17,50,44,39,58,37,41,-9,38,32,-32,54,11,-74,-28,79,-26,20,9,-8,-29,29,-21,75,19,2,52,42,12,-23,-3,40,12,74,-16,2,11,53,-53,-39,-13,-61,87, 
  /* [252][0][][] */ -48,-108,-105,-37,19,-13,46,-11,-89,38,-93,-9,23,53,-78,-49,55,10,26,-77,-68,-26,113,8,-117,17,-23,-73,-13,-58,-42,-62,-93,87,-127,-25,-67,-14,-9,-55,-58,82,-49,74,-27,-101,-69,-37,-16,75,-74,-19,8,83,-1,-12, 
  /* [253][0][][] */ 67,19,-71,-30,-37,34,38,17,89,27,-17,111,-50,66,-59,-51,37,1,55,24,-52,-12,-22,111,22,59,-33,32,46,-2,64,33,24,3,-79,30,-60,-2,-34,36,-3,33,-28,43,43,23,-7,39,-127,7,-49,-30,7,-8,-15,-60, 
  /* [254][0][][] */ 34,-86,3,39,2,-41,106,127,-45,20,52,-25,20,43,39,32,50,73,-58,26,2,-73,123,11,30,50,-86,-34,102,-89,93,-84,-27,-30,-23,11,2,31,85,31,-26,48,65,-62,71,-59,-63,38,-1,-77,-12,-29,-77,-53,-78,28, 
  /* [255][0][][] */ 6,91,-127,23,30,53,57,77,69,82,50,10,29,-4,-10,-18,41,49,-13,-25,-2,-94,-13,9,41,41,61,-37,-19,-87,50,46,72,-23,-37,0,-25,54,22,11,-39,15,44,-6,3,-24,15,-13,3,16,36,25,-57,34,-11,-58, 
  /* [256][0][][] */ 12,-30,-30,0,-1,13,11,44,39,1,-16,-84,25,-8,-127,-44,28,-39,31,-21,-7,-1,6,5,-42,-39,-20,2,-14,-29,64,45,-29,4,-19,-12,45,-9,9,-17,-66,21,75,10,31,-35,-16,-63,25,55,20,-14,42,-40,-41,22, 
  /* [257][0][][] */ -11,1,42,-11,36,-61,28,1,-7,-6,-58,-7,21,9,-20,-3,-28,-17,-19,-17,-29,-15,61,-44,41,45,-5,1,29,-15,-64,-22,9,-60,7,-61,29,31,10,68,20,30,78,-39,-5,-29,-6,-45,-21,7,127,-6,40,40,-23,14, 
  /* [258][0][][] */ -79,-25,127,16,-9,64,-41,15,71,-25,-17,-54,0,-3,-1,-41,1,25,37,70,26,96,-50,-26,5,5,-92,68,-25,-12,97,6,18,23,-27,35,-43,65,65,20,18,0,2,9,23,-66,31,49,-26,70,35,-12,3,-8,1,-41, 
  /* [259][0][][] */ 19,-121,-71,-44,0,-66,19,50,63,-77,-50,-4,-9,-88,-64,-32,-3,-20,13,8,-69,-2,34,-30,-37,34,10,-127,-10,5,6,37,60,29,-32,1,26,45,-32,84,59,-34,49,104,-33,-96,-65,5,-82,92,-37,52,52,-63,-3,-51, 
  /* [260][0][][] */ 7,58,-8,60,-127,53,-47,-98,-91,46,33,30,73,9,30,82,100,-41,9,-26,71,-100,72,-13,-3,-65,33,-38,-18,15,-58,-2,44,-36,-68,-44,14,48,-20,-8,79,41,-16,13,29,-86,-11,71,-69,-83,-11,-46,49,59,-84,-10, 
  /* [261][0][][] */ -24,-19,-16,26,28,15,-9,127,-12,-15,76,-38,38,75,-42,31,-5,20,-123,-32,-57,-66,55,33,57,31,43,-13,-52,-55,4,121,-13,-31,-55,40,34,49,-10,72,-80,2,26,4,82,-101,42,1,50,57,-24,70,-71,-74,-16,-19, 
  /* [262][0][][] */ 39,-16,27,38,46,-38,21,-4,-65,52,-34,69,38,-117,-60,0,-22,-49,-30,-88,-33,63,21,29,-36,-26,12,-53,82,59,-82,0,60,-25,-35,6,26,-26,-27,-27,-78,-52,-18,-11,-17,49,12,29,23,21,-45,8,23,-67,11,127, 
  /* [263][0][][] */ -62,26,-3,2,-43,59,-59,1,27,-9,-31,31,-37,1,20,-5,-13,-18,39,3,-12,22,-77,-21,-48,-42,127,2,45,34,-17,-23,-32,-7,-10,28,-19,-12,-6,-12,-5,-37,29,8,57,41,70,9,12,-12,34,-86,42,42,-25,-47, 
  /* [264][0][][] */ -58,-28,-67,21,-5,-26,-11,10,28,-25,9,19,23,23,-65,34,89,61,-69,-64,-103,11,-55,29,26,5,-43,-41,37,-44,39,37,45,7,-114,-76,-28,-2,8,11,49,-22,127,39,-52,21,0,41,-26,-14,-43,4,1,32,56,59, 
  /* [265][0][][] */ -41,-24,-57,-54,-12,6,60,37,-74,41,5,-70,-41,-53,-39,-49,15,-5,23,-84,71,-40,39,35,75,28,-86,1,-28,-43,-68,28,3,28,-127,-28,-18,56,-36,16,-13,45,11,12,25,1,15,5,69,-1,40,15,-53,-89,96,-6, 
  /* [266][0][][] */ -98,70,-60,-41,22,-6,9,90,2,84,-39,79,-39,14,60,-12,48,12,-21,-19,12,27,-32,-5,14,86,73,-2,42,36,28,20,-35,-53,-23,-27,-52,2,44,-93,102,-48,-8,-127,104,63,7,124,-27,52,120,-61,12,58,-24,-119, 
  /* [267][0][][] */ -61,67,-79,-4,55,-76,80,-9,81,37,-11,8,7,-66,-79,7,127,-37,60,-10,-47,-116,-22,14,120,5,-1,8,56,-32,-100,44,-2,-19,10,113,110,52,21,0,63,44,-15,18,-110,95,45,-53,-82,-30,0,41,45,62,98,-53, 
  /* [268][0][][] */ 69,-38,-7,64,27,54,-127,-71,96,-24,-67,-1,46,-27,-4,-38,20,15,-56,61,-104,85,-36,-59,32,-28,29,-32,9,-13,-13,-64,-44,-64,102,-30,-5,-13,-38,-29,61,30,10,15,7,-77,-3,2,-25,34,74,-23,29,56,83,-67, 
  /* [269][0][][] */ 22,-56,-46,30,-58,-20,71,-42,74,7,18,41,-48,-54,43,-24,-10,-3,78,-11,-63,29,41,-127,11,27,36,104,-74,39,-8,-55,-30,-30,-38,-3,-12,-20,10,40,-14,-12,40,38,16,9,47,21,31,-7,-14,11,-29,7,-9,-93, 
  /* [270][0][][] */ 30,-115,-69,24,6,42,0,-83,55,-63,13,-26,-32,9,-13,-4,38,13,-1,28,-49,16,-37,-26,42,-34,-26,39,-13,-29,76,-19,-127,-81,-9,88,-36,15,1,43,58,66,-32,-85,87,-22,38,-15,-10,59,-43,39,-4,9,-79,18, 
  /* [271][0][][] */ -70,-11,-36,16,90,-11,35,-7,1,38,38,-27,54,-3,-84,-60,-46,68,37,10,42,11,-71,56,22,-21,-5,43,97,45,13,28,-57,17,19,-3,7,23,-47,-75,-42,40,-47,52,23,88,28,17,28,127,25,-25,-18,90,-9,-7, 
  /* [272][0][][] */ 22,-29,67,-127,21,7,55,12,74,-34,-52,13,-2,-49,6,-27,-37,23,0,12,-49,56,-101,51,-13,-104,56,-2,23,-38,56,32,71,18,8,-9,16,-2,0,41,-25,32,16,-116,-61,-6,70,-33,15,103,33,-80,20,56,-51,-77, 
  /* [273][0][][] */ 66,-11,-26,-51,0,-47,49,25,127,-14,-21,35,-3,13,53,-3,62,0,45,-26,11,6,48,16,42,43,-55,20,0,21,7,28,-6,21,-6,31,-55,52,-29,20,-6,-1,-28,33,20,-70,1,78,-2,18,25,37,24,-29,-21,8, 
  /* [274][0][][] */ 50,100,-29,23,62,-22,-1,63,69,38,8,-28,-87,56,35,-76,36,-4,-54,-9,-15,-1,34,53,-29,-60,16,-30,101,-127,34,47,46,-27,28,-22,-16,-16,-4,13,-6,48,24,-41,-38,-120,23,62,-51,-72,16,24,-113,8,102,-109, 
  /* [275][0][][] */ -34,10,-12,22,-1,32,11,-95,1,21,-21,22,-34,-2,47,-17,42,26,65,31,-11,-28,-39,-58,5,-93,62,-10,8,2,-10,-44,-36,127,26,-28,65,-18,-24,22,-49,-1,-23,11,45,-15,60,-72,-43,22,-5,53,14,16,-16,40, 
  /* [276][0][][] */ 14,-114,40,127,24,7,5,22,82,19,-35,30,96,-7,-57,-2,-20,37,-114,-52,-12,4,-55,-23,-59,-45,85,-25,17,48,70,8,-22,-17,87,18,122,51,25,74,38,112,20,17,33,-66,86,-44,-15,-31,-39,24,97,77,-100,-17, 
  /* [277][0][][] */ -29,54,-28,81,31,-37,127,45,2,-19,-104,-52,-52,-18,-51,-9,-89,-90,-56,-80,-105,31,-39,39,84,22,40,12,39,41,-66,17,8,-40,56,-6,2,18,-60,19,13,59,-76,2,-31,-30,-73,71,-67,-27,44,11,44,-72,-74,-30, 
  /* [278][0][][] */ 19,61,-70,48,60,61,122,49,64,51,-28,-11,8,30,-1,6,70,-30,-127,-40,-29,40,-44,83,68,-6,98,23,-45,80,51,68,18,34,-26,93,-60,-14,113,-55,19,77,39,74,96,54,-2,39,-47,-59,8,0,-26,-26,62,-17, 
  /* [279][0][][] */ 21,17,18,-33,-7,-68,-28,-127,26,22,-90,-30,0,30,-62,6,1,-19,-35,-52,-10,44,-47,56,-58,4,-47,-96,3,-57,101,-10,101,-30,94,71,-81,-22,-1,13,-41,18,-2,44,13,-45,92,-56,-51,-30,24,-26,8,25,-13,49, 
  /* [280][0][][] */ 127,-45,33,55,15,-10,17,83,-35,-50,-12,32,-47,-11,42,22,13,-42,42,-13,-63,-82,-69,92,6,15,-8,74,-23,-12,-28,-10,41,0,66,-92,25,65,42,-50,56,-35,-36,16,65,-41,112,-9,-30,41,-29,-36,-8,41,25,-9, 
  /* [281][0][][] */ -57,17,-34,-28,0,22,7,25,12,39,-55,1,60,15,-76,16,74,10,27,0,-49,56,-14,45,33,-13,-20,-52,-30,45,77,30,8,-15,-10,-36,-103,32,-7,-39,-14,-3,-17,-79,10,-12,13,-43,-25,60,-3,-10,37,-60,63,127, 
  /* [282][0][][] */ -33,-28,-5,32,31,38,13,18,-14,72,10,-50,69,31,-26,34,51,38,-65,-2,21,-25,-38,-53,28,13,10,16,-37,-79,29,63,-51,-16,-2,0,69,26,22,18,32,21,60,-4,60,16,127,-48,87,-41,2,40,44,29,61,4, 
  /* [283][0][][] */ -1,39,-18,-21,1,8,15,-5,35,5,-21,-25,11,36,9,24,-27,15,4,41,60,13,-26,44,-57,17,-52,16,-23,-31,127,8,-58,-26,5,-1,-25,-20,-16,0,-1,-16,32,23,-3,-56,58,10,10,-2,31,-28,-19,9,33,10, 
  /* [284][0][][] */ -58,43,-48,100,-11,-67,-32,23,35,39,35,-103,-48,-39,-11,37,-73,50,74,-18,65,-20,55,-65,-120,25,-40,-59,86,4,-25,-42,-5,-41,-41,2,-65,-39,-21,91,8,19,68,-15,11,-20,5,-25,54,72,-26,18,-59,-12,127,-91, 
  /* [285][0][][] */ 102,-98,-92,2,-89,64,-37,-43,49,-39,-5,97,-86,-42,65,56,8,124,-28,61,13,-96,-64,78,-57,92,62,-48,-61,60,-7,19,-1,-89,-52,103,-35,-20,-71,-18,106,-105,89,71,-68,-17,-117,-39,-124,-84,-127,47,-5,74,16,-50, 
  /* [286][0][][] */ -80,-39,74,0,20,-121,-62,-62,32,-35,-57,-49,-74,-2,-61,34,-61,12,12,-63,-118,-38,78,79,-15,-50,-69,15,47,-5,-90,-28,-37,25,-49,-6,53,-54,-100,26,-30,13,-60,63,-113,53,-16,-54,-48,12,-34,106,127,52,23,-58, 
  /* [287][0][][] */ -42,-13,17,29,-73,-70,-9,-16,85,16,5,-12,19,-18,-81,32,-52,33,-6,34,26,75,-65,39,-17,28,-127,-38,109,65,-6,-96,79,-55,-97,95,-10,-86,39,-99,40,-53,-33,80,0,16,14,-15,-21,20,-59,-33,120,75,-102,-11, 
  /* [288][0][][] */ 2,-7,-54,57,17,71,-15,-6,-26,-62,65,73,31,7,18,89,37,70,-34,-1,-94,-61,-20,3,24,-76,-66,68,-11,-37,37,66,-8,-66,23,-14,48,-48,28,-17,79,-90,-22,-25,-2,-99,46,-127,-63,17,-11,31,25,45,-111,35, 
  /* [289][0][][] */ -98,-55,-18,30,0,68,-29,-2,-125,15,-2,-24,-64,1,9,-4,-11,-41,23,18,-55,40,24,9,-4,40,19,47,90,2,127,5,23,-103,-18,64,-3,52,10,5,118,44,42,-2,102,-52,-44,6,-71,-20,-18,-100,-63,-4,-56,5, 
  /* [290][0][][] */ 7,-39,8,3,-7,-8,-62,-45,-10,98,40,-19,-1,-63,-78,70,-40,-27,-87,7,-72,1,-20,40,-87,-127,75,-34,-21,-46,-2,5,-8,-101,29,-12,21,-40,-25,19,-126,-46,-44,47,15,46,18,-26,-8,-84,-100,89,4,36,32,-53, 
  /* [291][0][][] */ -15,90,-7,-57,-21,31,62,15,-25,18,10,-41,46,-27,-15,1,-17,9,-18,71,-21,-34,-69,-71,54,35,61,10,19,-22,21,18,-12,-48,-127,40,54,16,4,-76,14,24,-50,-29,45,-53,39,-101,-8,8,16,31,34,2,-1,115, 
  /* [292][0][][] */ 6,24,-19,-25,5,-14,69,-8,9,23,-15,-8,-49,-21,5,-13,-24,-23,59,-8,18,8,1,-11,-14,-12,51,-13,22,-4,39,42,-35,1,-22,-3,42,44,43,18,23,32,27,-12,-31,-12,-32,7,-31,43,53,-127,27,-13,-58,-25, 
  /* [293][0][][] */ 13,36,72,-3,-20,-28,-3,-77,-20,-63,-38,8,-8,1,16,18,-33,-13,59,4,13,22,2,-35,-67,-21,75,42,19,50,-82,-4,-3,-32,16,6,127,-13,16,-4,51,-64,-23,63,-30,33,-64,59,71,27,110,-57,48,-37,-27,-38, 
  /* [294][0][][] */ -50,22,82,31,80,1,56,-8,-41,-44,-78,-7,16,40,-7,-45,25,-26,41,51,-66,-82,-39,-67,-12,127,47,77,59,-97,-47,-10,88,-18,1,33,20,10,13,34,33,52,83,3,-39,-6,36,67,-40,3,82,-73,-12,16,-38,-63, 
  /* [295][0][][] */ 127,21,-43,72,6,-26,-49,-15,70,21,-5,43,28,-6,-3,46,-27,-32,-20,70,-21,12,17,-49,-40,-2,33,67,-32,-7,20,11,62,-26,-2,7,-22,-14,3,4,-16,18,1,-8,80,-113,44,-7,-28,-23,0,93,35,-21,-112,-53, 
  /* [296][0][][] */ 3,-4,-5,-43,127,-26,-86,52,16,65,21,19,38,-6,32,-39,51,-15,45,-29,13,5,-17,-58,-76,11,-24,-14,11,-2,40,-4,32,-43,-69,-11,34,0,33,-2,33,-5,8,-49,-21,23,-31,27,1,31,55,-33,-31,42,-27,32, 
  /* [297][0][][] */ -30,22,74,-40,33,-19,-35,-101,91,-83,-127,-37,3,29,36,23,-59,17,87,2,29,40,14,-32,-28,-35,37,-4,14,104,-50,49,-45,1,-69,-40,12,56,-18,62,-46,-55,11,-7,-54,-41,45,-1,19,48,59,-80,61,30,-5,61, 
  /* [298][0][][] */ -39,3,12,-17,25,-77,-57,-3,-84,-84,11,14,4,-47,-71,-7,-5,23,-22,-99,74,-61,-28,121,-40,-8,61,-127,39,-65,-41,13,-46,-12,-20,-14,-22,-17,-124,-31,7,23,-2,14,25,-6,-17,-8,-3,74,89,-64,-6,5,26,21, 
  /* [299][0][][] */ 0,-21,-18,-13,-94,51,-56,60,-6,-41,103,-8,13,-16,81,47,41,86,46,51,3,-48,60,0,19,-5,34,-19,-29,15,109,42,-37,79,-1,46,87,81,-72,38,-20,31,6,52,83,-39,-15,56,-25,-52,-9,74,-53,-127,73,-12, 
  /* [300][0][][] */ 41,43,-82,-50,96,-84,22,46,-60,85,-40,85,40,51,-45,-21,-20,68,39,20,61,-12,35,42,34,-36,67,-90,7,-26,-49,-9,-37,36,-118,-34,-10,55,16,-32,-15,1,-24,60,40,56,-24,81,-88,-98,4,6,127,0,28,29, 
  /* [301][0][][] */ 68,-36,52,-2,31,11,-10,-62,68,-85,-42,10,127,33,-23,-34,-118,-13,67,28,-72,32,-50,25,-21,61,33,-69,42,20,-18,-100,-72,-96,7,-13,41,-18,18,27,36,68,12,-10,-14,-67,-79,123,7,-19,122,15,40,-48,-56,-34, 
  /* [302][0][][] */ -87,9,-2,-77,-44,27,-96,10,-73,-48,-82,-42,-34,-26,-43,-30,-31,-16,22,58,-56,37,-97,24,-111,21,106,7,-61,49,-66,127,66,-74,-74,-15,-90,-11,-58,1,4,62,55,90,118,-114,-8,67,-56,16,-93,-28,39,26,-14,-14, 
  /* [303][0][][] */ 10,127,-115,43,-12,-1,-25,-42,77,67,-72,-1,65,1,-45,-88,22,83,25,4,2,-16,34,-64,71,78,-66,50,-34,9,104,112,-74,-37,-22,56,-78,99,-50,-14,-36,-14,-1,32,72,38,44,13,-70,3,-65,90,8,-95,-76,-35, 
  /* [304][0][][] */ 54,-13,-17,-2,2,30,35,-11,-66,31,-8,-30,2,27,-5,-15,21,-4,-52,4,-127,-32,2,26,37,47,-8,-25,57,-17,18,-19,-9,-22,38,18,-12,40,65,-12,33,101,48,-26,35,14,15,24,11,-21,-14,-2,-19,6,-30,3, 
  /* [305][0][][] */ 63,-29,-64,14,-3,54,41,47,23,-1,18,127,40,14,-84,-42,-46,-89,-86,-10,-56,-28,29,2,-26,24,95,-6,4,38,44,12,-97,-62,-23,63,-49,60,-26,-36,53,87,-54,31,-92,-57,3,76,-64,43,-27,47,-80,-36,-1,-39, 
  /* [306][0][][] */ -31,-30,-86,5,4,55,10,76,91,27,-64,-6,-6,11,-2,26,43,46,-32,12,58,-17,-7,47,-17,-96,1,-20,38,18,33,-55,-127,-50,-17,6,-20,59,-42,38,34,-16,54,-51,47,34,15,40,65,46,25,-7,-37,-81,0,57, 
  /* [307][0][][] */ -59,-24,-39,-24,-111,-40,71,-19,39,21,12,-17,-23,32,27,-1,5,-48,-50,39,5,-9,43,-32,34,16,39,-36,-34,-80,26,-18,-23,15,52,17,25,-20,-10,12,27,8,42,-127,123,24,0,7,-15,102,-16,17,-27,40,23,-11, 
  /* [308][0][][] */ -32,34,58,-34,21,-20,-127,18,59,24,-3,0,-47,-26,42,32,11,-12,28,43,-35,24,-69,-43,-65,-32,76,-23,-41,5,72,-21,-69,-11,-39,-6,-28,28,-45,23,-95,-43,-26,-4,33,24,93,14,-3,7,37,-96,49,35,19,35, 
  /* [309][0][][] */ -2,0,-9,49,-31,12,-66,-31,34,-21,15,57,59,7,-39,61,-6,26,64,20,-7,61,-61,-16,-51,-21,127,27,-12,45,-79,31,30,14,19,31,8,-72,-7,-21,-4,-12,-7,27,-27,-83,-13,-50,-117,23,80,-4,66,34,-33,-113, 
  /* [310][0][][] */ 17,-63,-127,-23,-33,70,-46,21,52,-35,-88,-18,70,-47,60,-28,-36,-8,-97,-22,12,23,107,76,14,-74,75,-54,54,-107,29,38,-54,-2,-20,116,55,-9,116,-38,105,-14,-26,29,114,-17,-90,38,88,-11,-5,-53,6,78,-4,-1, 
  /* [311][0][][] */ 5,7,-12,20,-17,-16,32,66,11,96,15,47,-14,-2,86,-115,-74,30,121,22,66,-22,127,93,95,-51,-27,34,21,-62,-11,-56,-3,6,-47,-92,-20,-84,-47,-15,-27,13,5,4,-16,38,3,-103,-1,-3,60,21,68,65,1,62, 
  /* [312][0][][] */ 69,-43,52,-25,-64,-43,-11,36,127,2,6,-40,68,72,-51,7,-39,54,-57,7,-32,32,-46,9,-17,-34,8,46,-25,-45,16,-69,-62,-21,2,-55,-11,81,8,56,-20,-8,-8,5,61,-56,-85,90,4,-29,-45,-36,25,110,-67,-13, 
  /* [313][0][][] */ 10,-1,-39,9,-8,-8,-127,-17,22,22,27,90,83,45,-59,-72,-9,-79,-47,98,-72,-57,-19,20,12,-62,60,116,-28,62,86,-6,57,-27,-28,-68,94,4,-62,16,5,21,-61,22,-5,-5,79,-3,-82,-38,46,-30,-4,1,13,-15, 
  /* [314][0][][] */ 4,-25,40,6,12,40,41,26,75,40,-48,16,-5,19,-16,35,21,38,-13,16,-40,-41,-2,9,11,-8,23,-14,-24,59,1,24,-23,18,-59,-34,16,-9,4,8,-37,-20,7,38,22,-40,-42,127,-47,-22,-31,-16,14,-6,-12,-82, 
  /* [315][0][][] */ 80,-39,51,-43,23,-7,69,8,-29,-14,70,-76,28,-81,-121,-15,35,30,24,28,3,-63,127,-54,65,68,-84,-4,51,-79,-36,24,31,-62,-40,-48,60,77,-14,82,30,59,87,75,-40,-54,-24,23,-72,-25,-17,45,-66,-85,-25,50, 
  /* [316][0][][] */ 47,33,-29,-101,98,-38,-40,53,-45,-4,21,-90,30,-28,-31,9,62,-32,-50,64,14,-2,3,1,10,6,50,-105,28,-69,73,-40,78,-127,19,19,73,61,112,68,45,-9,52,-89,-8,13,1,49,84,-46,42,-55,18,-89,-56,72, 
  /* [317][0][][] */ 36,18,-17,-57,-12,-33,-73,-22,70,20,-59,10,89,86,-59,86,-17,30,92,-60,105,-107,-6,-47,31,-3,-52,-37,76,-127,41,121,28,-75,14,72,55,41,58,5,60,98,-18,17,64,21,-44,-42,-88,-32,-60,-85,-22,-31,84,1, 
  /* [318][0][][] */ 11,-103,-44,-39,6,42,-25,2,22,-44,-74,28,-47,12,-2,77,115,-30,54,-17,-58,46,-19,-61,-32,48,-15,-3,67,-54,102,-56,-117,20,19,95,-12,11,-53,-23,127,35,-12,53,-33,24,95,-6,-22,-35,74,-52,-67,-35,-17,7, 
  /* [319][0][][] */ -11,-48,-74,-127,-48,-38,-103,-26,-97,29,39,-30,5,-61,-46,26,-25,32,76,6,13,58,72,-5,-71,29,72,-79,9,-6,-2,-1,-51,-97,-57,11,94,64,-43,17,35,-59,-63,2,15,-40,29,-25,1,-14,-12,20,32,35,21,52, 
  /* [320][0][][] */ 2,-52,12,-74,-16,47,-2,-3,-41,74,-31,28,41,9,25,-5,6,44,-50,5,-58,74,-12,31,-127,-41,-73,-18,-27,8,46,12,-89,-53,75,53,53,-39,14,17,18,2,31,70,31,21,23,-51,10,9,-110,-44,49,4,-13,0, 
  /* [321][0][][] */ -24,40,-73,-48,12,-5,-18,-39,15,5,43,-29,-18,-4,-24,-27,-64,-6,33,21,28,62,98,-27,0,15,-31,-77,-19,-7,1,66,-10,-2,58,-1,-72,-27,17,-33,81,6,-127,35,14,-8,29,23,53,46,-71,-59,4,48,-18,-33, 
  /* [322][0][][] */ -62,-41,-15,-51,-19,30,67,79,-11,54,-38,-78,-61,15,23,-70,127,-20,-98,-45,-31,19,37,34,82,16,-71,-51,-26,-20,41,17,-72,62,-117,8,-57,31,26,1,27,60,68,66,64,-6,32,42,18,-36,-60,-65,8,-113,47,-43, 
  /* [323][0][][] */ -78,-35,65,-89,-10,-25,83,-86,61,127,-32,98,3,-24,-90,64,52,-75,31,36,3,26,58,-14,-5,-32,12,68,32,60,15,-33,-40,-125,60,-88,-10,48,38,-38,20,45,55,62,-7,52,5,-52,87,-98,-13,-105,86,24,-15,-25, 
  /* [324][0][][] */ -49,-16,51,-127,54,22,37,39,36,59,-44,-16,39,16,28,-24,8,26,12,57,27,-41,37,-38,62,0,-71,-16,-43,-37,-8,27,-72,-65,42,20,22,-13,-8,22,13,-23,-52,44,-26,-20,34,-36,-40,-3,32,-15,43,-24,-25,-43, 
  /* [325][0][][] */ -23,-89,-11,21,27,38,11,9,70,63,-42,43,-27,-21,23,65,4,-40,-11,-99,-50,124,10,70,-16,39,24,-84,-33,56,-37,-41,20,-9,66,48,64,-12,-19,-34,127,-8,6,96,-81,24,-49,-70,18,-43,21,-11,36,-66,-56,9, 
  /* [326][0][][] */ -6,-65,12,-12,-59,-119,127,34,-12,58,-36,-23,57,-46,-33,72,60,49,25,17,-20,25,-9,-38,15,-36,28,17,36,38,-20,47,-37,-43,-91,42,96,61,-18,-22,107,48,-107,-8,76,-16,9,64,31,19,19,26,-32,5,97,-19, 
  /* [327][0][][] */ 78,-83,-12,-98,-89,-24,69,76,-66,91,-15,33,-110,-23,-35,-92,11,-22,28,-127,13,10,78,-79,21,-54,109,1,88,10,5,-44,-12,-6,-34,60,12,121,-7,0,18,3,-5,30,-65,57,-9,-4,-52,-9,22,-14,15,1,-43,34, 
  /* [328][0][][] */ 45,62,3,-10,43,-7,-75,-5,124,-35,-111,-65,36,-28,72,23,96,45,-83,91,-127,41,-15,57,45,-2,-40,75,46,65,4,84,-20,-113,95,100,35,-98,-2,11,28,59,40,48,-19,-36,-32,56,-15,-55,-61,-26,-7,-38,11,-10, 
  /* [329][0][][] */ 6,-51,-11,-24,-2,20,14,24,29,59,-71,-82,118,-49,27,31,-36,-44,120,10,-14,-17,-62,22,-27,51,-36,12,-127,41,59,47,-23,-81,-72,3,-10,71,-3,18,-31,32,-41,12,74,-83,-22,39,34,-53,20,-49,-47,-37,-81,33, 
  /* [330][0][][] */ -2,-5,12,13,29,2,61,-58,54,-9,-9,-38,1,33,-40,-72,48,65,6,2,-33,11,1,36,2,52,-21,21,-28,-70,-16,86,-13,26,7,17,61,-55,69,-24,26,127,-24,-26,-5,42,13,-25,-80,-15,16,16,-40,34,-92,-7, 
  /* [331][0][][] */ -14,39,28,54,14,29,6,5,-40,20,-66,-67,72,52,-40,1,43,55,5,-50,-77,14,-36,38,79,-53,28,-56,0,-3,-127,-40,-31,-59,9,8,53,-19,57,11,-104,-30,53,10,79,28,-19,-30,7,17,-12,32,2,40,-18,7, 
  /* [332][0][][] */ 6,-15,37,-41,22,23,-49,-47,-46,-20,71,9,5,-39,69,3,-51,55,-2,-51,-11,5,60,-19,-127,-53,32,-40,10,54,-1,16,-74,-35,38,45,72,-100,-3,-6,37,-17,68,39,71,-14,19,68,-84,-19,-29,-32,51,15,-42,-38, 
  /* [333][0][][] */ 30,23,-38,-111,-8,-14,36,60,-116,-19,88,-31,19,36,-13,-41,35,3,-12,5,79,17,27,61,0,28,-20,-17,11,16,29,9,29,-43,-68,4,20,-8,63,12,63,127,51,-28,65,-70,-52,65,-13,28,41,-37,-9,38,-76,-19, 
  /* [334][0][][] */ 33,-20,25,-13,2,-13,21,-40,13,79,25,-43,6,26,8,69,-53,24,79,27,-3,50,-10,11,56,26,8,-44,-33,-28,17,-30,-127,-96,-25,21,-71,33,-2,14,1,23,-19,47,39,4,-45,-47,-68,-56,-37,-55,93,16,28,43, 
  /* [335][0][][] */ 59,0,32,-67,-58,11,111,-16,-15,-86,2,26,8,42,39,63,-18,-14,71,49,-45,-52,-44,31,23,32,-79,127,-3,13,-98,50,-43,104,2,18,44,4,-59,7,19,34,-49,-2,14,-18,-20,3,-11,10,-64,1,-23,44,-19,72, 
};
const TfArray<4, int> tensor_dimension75 = { 4, { 336,1,1,56 } };
const TfArray<336, float> quant75_scale = { 336, { 0.0010472078574821353, 0.001293703680858016, 0.0017099026590585709, 0.0011178585700690746, 0.0013232833007350564, 0.0011351325083523989, 0.0015440257266163826, 0.00099985452834516764, 0.00074314308585599065, 0.0011074140202254057, 0.00082236021989956498, 0.0011761755449697375, 0.0009214335004799068, 0.00099346495699137449, 0.00097275373991578817, 0.0010491363937035203, 0.0014608998317271471, 0.0014441940002143383, 0.0013505701208487153, 0.0013722857693210244, 0.001019575516693294, 0.00142013153526932, 0.0013743460876867175, 0.00098225788678973913, 0.0010150158777832985, 0.0010334623511880636, 0.0012190489796921611, 0.0013129817089065909, 0.0011116621317341924, 0.0010858215391635895, 0.0010285835014656186, 0.00089663016842678189, 0.0010422865161672235, 0.0010372676188126206, 0.00078194338129833341, 0.0014584987657144666, 0.0014904177514836192, 0.0012331792386248708, 0.0014323398936539888, 0.0012069265358150005, 0.001138280495069921, 0.0015268051065504551, 0.0013987281126901507, 0.0010355794802308083, 0.00091301667271181941, 0.00096082559321075678, 0.0012459727004170418, 0.0013388528022915125, 0.0010801885509863496, 0.00090955710038542747, 0.00070984609192237258, 0.00096245895838364959, 0.001344217685982585, 0.00087711220839992166, 0.0013517015613615513, 0.00084921333473175764, 0.0012240116484463215, 0.0012129386886954308, 0.0011276275618001819, 0.0014023334952071309, 0.0010298542911186814, 0.00088019616669043899, 0.0012841572752222419, 0.0017083638813346624, 0.0010815707501024008, 0.0013325859326869249, 0.0010988874128088355, 0.0016430342802777886, 0.0012460091384127736, 0.00099513446912169456, 0.0011297604069113731, 0.00116395961958915, 0.0013382995966821909, 0.0011924381833523512, 0.00093786692013964057, 0.00092535855947062373, 0.0011997112305834889, 0.001041399547830224, 0.0015810015611350536, 0.0013798540458083153, 0.0013070394052192569, 0.001089214812964201, 0.001329337595961988, 0.0011872506001964211, 0.0010024483781307936, 0.001447671907953918, 0.0011210188968107104, 0.0010434866417199373, 0.0011795053724199533, 0.0010093013988807797, 0.0015558417653664947, 0.0013625114224851131, 0.0014002207899466157, 0.00088202796177938581, 0.0011460962705314159, 0.0012470233486965299, 0.001571404398418963, 0.0012115107383579016, 0.0013164590345695615, 0.0012565444922074676, 0.0010010374244302511, 0.0014073420315980911, 0.001096309395506978, 0.00072061363607645035, 0.0013601792743429542, 0.001123634516261518, 0.0012503158068284392, 0.0014829769497737288, 0.0010345320915803313, 0.0021179511677473783, 0.0009994251886382699, 0.0015977957518771291, 0.0010659639956429601, 0.0011093245120719075, 0.0012307170545682311, 0.0015944029437378049, 0.0011397870257496834, 0.0013290658826008439, 0.00067778839729726315, 0.00096598680829629302, 0.0010842214105650783, 0.0010015929583460093, 0.0013386590871959925, 0.0014788595726713538, 0.0010572507744655013, 0.0017765501979738474, 0.0010040939087048173, 0.0012279452057555318, 0.0011879556113854051, 0.0013497824547812343, 0.0014497996307909489, 0.0010781190358102322, 0.0012562737101688981, 0.00092819193378090858, 0.00098233751486986876, 0.0015968065708875656, 0.0011073893401771784, 0.0012436808319762349, 0.0011064704740419984, 0.0010846598306670785, 0.0012962395558133721, 0.0011128350161015987, 0.0011655745329335332, 0.001216267584823072, 0.00094849214656278491, 0.0009683141834102571, 0.0012031313963234425, 0.0016645614523440599, 0.00061976758297532797, 0.001440715161152184, 0.0012756704818457365, 0.0010924957459792495, 0.0010703916195780039, 0.0011423204559832811, 0.0012652426958084106, 0.0011391195002943277, 0.00092310458421707153, 0.0010211293119937181, 0.0014237483264878392, 0.0011226861970499158, 0.0014047735603526235, 0.0011883877450600266, 0.0013355377595871687, 0.00097334868041798472, 0.0011505542788654566, 0.0012386904563754797, 0.0010063169756904244, 0.0012514059199020267, 0.0012308266013860703, 0.0010972856543958187, 0.001478259451687336, 0.00090238964185118675, 0.00080658408114686608, 0.0011744818184524775, 0.0016968346899375319, 0.00092901004245504737, 0.001332376035861671, 0.0011382316006347537, 0.0013601174578070641, 0.0012325774878263474, 0.0012502003228291869, 0.0012157915625721216, 0.0010665460722520947, 0.0010795375565066934, 0.0011047569569200277, 0.0014372519217431545, 0.0015416655223816633, 0.0010808329097926617, 0.0009827612666413188, 0.0012868507765233517, 0.0013197798980399966, 0.00087339238962158561, 0.0013821455650031567, 0.0011717882007360458, 0.0014986790483817458, 0.0014126362511888146, 0.0011599470162764192, 0.00099927198607474566, 0.0010180812096223235, 0.0012592653511092067, 0.0012817119713872671, 0.0011140010319650173, 0.00093190144980326295, 0.0009177143219858408, 0.0013670953921973705, 0.0013702721334993839, 0.001001995406113565, 0.0010008438257500529, 0.0011462868424132466, 0.0013392040273174644, 0.0014639410655945539, 0.0010408282978460193, 0.00093107414431869984, 0.001011124812066555, 0.0013978139031678438, 0.0011090210173279047, 0.001305739744566381, 0.0011126719182357192, 0.00093333225231617689, 0.0014592338120564818, 0.0011690319515764713, 0.0015319263329729438, 0.00085546611808240414, 0.00089008553186431527, 0.0010561252711340785, 0.0012512102257460356, 0.0014114381046965718, 0.0011008048895746469, 0.0015808084281161427, 0.0012359055690467358, 0.0012116475263610482, 0.0015030561480671167, 0.0011091567575931549, 0.0012789785396307707, 0.00071567605482414365, 0.0013845948269590735, 0.00094988779164850712, 0.0012566648656502366, 0.00099416379816830158, 0.00096539204241707921, 0.0012887298362329602, 0.0012343614362180233, 0.00091519526904448867, 0.00091057555982843041, 0.00092454854166135192, 0.0015321107348427176, 0.0010357134742662311, 0.0012838951079174876, 0.0010485501261427999, 0.0013121664524078369, 0.00080407410860061646, 0.0013653716305270791, 0.001139537082053721, 0.0012358181411400437, 0.0010220634285360575, 0.0010985342087224126, 0.0022712717764079571, 0.0017486826982349157, 0.0012984265340492129, 0.0012357878731563687, 0.0013702675933018327, 0.001403547590598464, 0.0012726855929940939, 0.001576565089635551, 0.0012644157977774739, 0.0013331517111510038, 0.00079909025225788355, 0.0010652157943695784, 0.0011807500850409269, 0.001283642603084445, 0.0011432616738602519, 0.00097566592739894986, 0.0011181673035025597, 0.0014363880036398768, 0.001268323976546526, 0.0014750631526112556, 0.00065158423967659473, 0.00082536845002323389, 0.0010980564402416348, 0.0010040245251730084, 0.00018987896328326315, 0.0013838281156495214, 0.0013490251731127501, 0.0019011709373444319, 0.001015306101180613, 0.00076832040213048458, 0.0011524022556841373, 0.00076401355909183621, 0.00067366840085014701, 0.00105221604462713, 0.0010619228705763817, 0.0013528373092412949, 0.0018939812434837222, 0.001200447790324688, 0.0012252988526597619, 0.0013805277412757277, 0.0014843118842691183, 0.0012602838687598705, 0.0011541878338903189, 0.001453168923035264, 0.0012367512099444866, 0.0011462210677564144, 0.00094528088811784983, 0.0010229097679257393, 0.0016282011056318879, 0.0012699819635599852, 0.0015664588427171111, 0.0013372482499107718, 0.0011662151664495468, 0.001299999887123704, 0.0011483340058475733, 0.00093030935386195779, 0.0011318662436679006, 0.0011458467924967408, 0.0016185255954042077, 0.00067448464687913656, 0.0010697738034650683, 0.0012409241171553731, 0.001167582580819726, 0.0011980042327195406, 0.0010847046505659819, 0.0011029052548110485, 0.001140812411904335, 0.0012183877406641841, 0.0015618241159245372, 0.0012460610596463084, 0.0012275088811293244, 0.00072985899168998003, 0.001043488853611052, 0.0012099568266421556, 0.0014994508819654584, 0.001348974066786468, 0.0011671429965645075, 0.0013020753394812346, 0.00097165204351767898, 0.0012081554159522057, } };
const TfArray<336, int> quant75_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant75 = { (TfLiteFloatArray*)&quant75_scale, (TfLiteIntArray*)&quant75_zero, 0 };
const ALIGN(8) int8_t tensor_data76[112*1*1*336] = { 
  /* [0][0][][] */ -47,69,6,29,-20,0,-33,34,51,-31,4,-3,90,-65,66,55,21,-19,-14,28,-53,22,-8,-23,64,36,38,-30,62,-28,-33,71,30,-23,4,39,36,14,3,-2,-89,-8,-47,7,53,13,63,-77,57,37,-8,19,-17,-5,-15,35,11,-59,58,-7,-108,-10,-63,60,-25,58,3,-51,-19,67,10,94,-44,-11,-77,-66,87,-12,20,41,-58,-79,-25,1,-56,66,-9,-19,-93,-42,-76,12,-25,83,-16,15,63,-3,-17,2,23,21,19,-15,5,-20,-31,54,66,43,18,21,-2,-8,-79,-20,-24,-15,-1,27,0,-16,-48,77,-39,-4,14,0,43,66,-92,33,36,-9,22,17,-23,22,-8,-45,-29,-62,48,52,-14,21,9,-4,47,-18,5,35,11,-31,49,-74,-44,-22,-15,-4,0,-51,33,-73,-59,-38,19,68,47,-27,12,-25,-71,69,-37,25,-37,-53,23,-10,23,70,48,-85,-79,-51,-30,-70,-9,5,34,13,-71,29,46,25,-7,41,-36,-29,28,-47,30,-29,-20,-13,-2,-66,-8,-59,-58,-2,87,-37,-6,-127,12,50,82,-53,-55,49,48,27,14,14,78,32,13,-32,9,-16,14,-35,2,37,19,22,31,-75,42,28,-34,-30,-89,-9,-72,-104,-50,1,-74,2,-9,7,-29,21,-4,10,39,87,-25,-47,-65,17,-33,-29,-13,1,-53,-77,-31,-33,-21,23,36,-2,15,-8,42,-1,77,75,69,-31,0,-5,-16,11,13,3,-57,23,-48,-8,-4,68,-32,-37,85,-1,37,-51,-55,15,13,-22,52,-35,95,41,65,-73,-2,12,-29,-8,48,-49,28,16,-9,56,-65,16,-10,-26,-15,74,-11,14,-28,26,59,8,-18,23, 
  /* [1][0][][] */ -49,-24,-102,-61,38,49,-61,-17,-27,-44,-47,-59,-10,-10,91,-3,-13,-63,53,-1,3,-59,62,96,-120,-55,9,73,-48,-42,15,-20,18,30,-20,-73,13,-45,-78,-42,-67,-78,27,31,25,-5,47,-53,78,-11,-3,29,-99,-38,16,76,1,-100,-20,-38,31,43,26,-18,51,-11,-19,-34,30,10,-35,-14,-59,25,11,53,23,51,25,-75,43,104,-11,58,65,4,22,-18,-10,-34,4,30,3,-25,-24,35,-28,-10,71,-64,-67,-24,-22,-1,48,-67,38,16,29,-58,-43,11,120,101,-27,0,-8,28,-13,75,98,127,32,9,-26,-36,97,-14,-6,12,-46,9,79,8,-64,31,2,-59,-3,-51,-85,-60,7,37,-28,41,4,-39,30,-52,48,-6,-7,-17,-20,-100,29,-6,-29,-44,-20,47,78,-50,17,-5,-26,3,-62,-70,-62,9,-35,15,-67,20,-22,-32,-33,81,95,1,-23,-70,114,-17,-47,10,19,106,41,-1,21,21,2,-18,-36,-21,-84,-20,43,6,8,-13,36,-3,23,-14,52,-26,43,-3,-23,9,22,-103,-29,-16,72,17,37,67,-9,81,38,-4,-31,8,-29,-51,4,-7,21,-51,17,-58,-4,-12,-68,18,-54,-17,-77,52,50,-42,-50,-22,35,-47,-46,51,-11,36,48,7,-55,-80,3,35,-10,-21,56,-25,-45,116,-65,26,-39,-35,-34,19,-32,-10,-42,20,29,-17,36,-41,-125,-33,60,-47,16,32,62,-40,4,-40,67,52,66,-20,37,-14,-10,-76,-105,-44,16,-50,66,38,-30,-9,76,3,-27,20,31,-27,-43,8,50,47,-44,9,19,-33,-31,-21,-13,-5,3,32,46,-10,67,1,-38,-52,-5,-20,-35,82, 
  /* [2][0][][] */ -50,-33,-50,3,4,-6,-24,8,13,-17,15,-21,13,-99,52,11,14,69,71,5,12,-52,-26,-32,43,-12,-2,16,-73,-37,16,-39,-34,-46,12,8,66,57,-7,25,-53,-9,95,13,56,-15,-64,10,4,-27,-6,-63,-35,44,15,0,-49,27,31,-29,-4,-55,14,-13,-17,-34,-3,-18,-75,30,-8,20,13,-35,-25,-91,23,47,-1,49,5,-7,-46,16,-16,46,10,28,59,-92,-19,-32,3,-17,46,16,27,3,-18,-50,-9,-53,-6,22,5,-1,54,-11,3,-26,-31,-41,-3,43,66,21,-55,-1,27,21,56,-87,4,38,10,19,-81,10,29,60,-35,-32,21,-36,29,-65,49,-45,13,-36,61,-29,55,30,29,95,81,-27,43,-20,-28,18,-19,-10,-15,2,-25,55,32,26,13,-35,-26,-5,40,-12,-4,-69,41,92,14,-53,33,-127,-12,-24,88,0,44,21,-26,28,-12,2,36,1,5,88,34,29,9,50,5,-16,3,-17,78,-51,70,51,11,-30,-61,-66,-48,-18,66,38,-31,32,-34,10,52,41,-34,-82,10,28,32,-21,41,36,-2,-15,-2,-57,-35,6,17,-7,-2,3,-54,-15,37,-5,12,-19,14,2,63,29,54,58,11,17,31,-19,-30,14,9,48,42,-4,2,33,16,-38,-28,-54,33,34,-22,12,-7,25,-43,18,1,54,59,-38,27,-67,-13,-64,0,-5,-40,-66,43,19,-121,46,8,35,-14,58,13,-37,-86,22,23,-52,0,3,-28,-8,54,16,-14,-6,-17,-16,-16,10,-63,-1,94,19,16,-36,-39,2,57,36,23,-2,-100,-3,23,-26,31,15,34,-50,-25,-72,-73,-15,-26,-21,-14,16,-34,15, 
  /* [3][0][][] */ -27,4,-43,-15,13,-21,-32,18,34,25,-20,22,33,69,23,16,47,7,-38,-9,-1,-34,35,-15,15,2,-8,42,-31,-1,47,39,27,0,37,-20,1,25,-25,-14,-36,42,-88,-14,-29,48,8,-11,-31,25,-4,-75,-49,-19,55,-20,20,27,-16,16,-3,-115,-8,8,-51,39,-26,-50,-8,-23,54,30,47,23,14,25,-47,-14,-39,-21,-1,-37,-5,-11,15,16,-11,-29,29,40,24,-1,-43,-22,-15,34,7,-35,50,-16,127,29,29,-29,-38,-45,-21,-16,-18,-32,-33,-7,24,38,57,40,6,-7,-3,-14,22,4,-44,-17,20,2,64,25,-52,38,49,-6,-59,10,-48,-10,6,11,-22,-66,9,34,-15,0,72,-101,-29,-19,29,-20,28,102,13,-8,-23,40,45,105,59,4,20,-36,-16,2,-3,-10,6,19,36,-61,-20,-36,45,-43,-11,41,-39,-45,-59,-30,-12,-57,23,35,49,-3,-29,-12,34,7,-28,-17,3,20,-9,36,-79,-12,-61,12,-5,-47,86,7,13,-2,22,-24,-65,-33,-97,53,-3,-13,-1,-16,-43,-27,23,37,14,60,-65,-5,-5,-3,31,0,74,-11,-52,-39,66,-27,23,12,-29,-27,-18,-18,-20,-11,23,30,-20,-50,-23,-22,-1,-23,105,-35,-7,-2,-35,-34,-40,11,6,8,-31,19,-21,-32,-57,39,-61,-85,-31,-25,-1,0,-65,-9,20,31,88,-58,23,21,-83,82,79,-9,19,18,-85,-33,-16,16,-18,-40,60,-90,-28,-65,-16,-44,12,1,-6,43,-56,-1,-29,-9,-6,6,12,-37,-2,-61,16,33,-46,-39,-86,35,-1,-11,26,16,-20,-43,-58,-20,2,-28,24,-29,12,14,91,-28,19,-11, 
  /* [4][0][][] */ -44,19,-40,104,-56,-53,-13,15,59,-3,-26,-98,65,42,59,30,-46,-20,-35,-17,-29,63,-26,-11,-82,-71,-45,6,1,75,39,30,12,-7,-40,-48,-58,23,14,14,-2,53,64,-37,-43,-54,-18,36,93,12,92,22,-48,-31,-30,38,22,93,-63,13,78,-37,22,-24,-62,-31,-17,-6,30,5,-44,-54,30,-29,56,10,39,39,30,-18,37,-2,-43,-52,-26,87,28,39,7,-49,-32,2,75,8,-32,44,34,-25,27,-32,45,23,40,-3,39,-23,38,39,-17,-46,53,-20,54,-73,27,15,0,-41,-21,56,16,-58,-75,-26,14,27,9,15,0,-51,-19,10,-38,-32,79,1,39,-44,83,-23,49,-28,45,-13,-26,-12,34,-77,14,43,34,58,24,-58,-6,33,15,-90,9,-18,-23,32,66,-26,-9,-21,-12,-61,70,17,-5,24,28,-22,19,-16,-43,50,-6,29,-2,49,42,-50,-21,-13,-65,-44,-15,11,3,32,26,-59,6,33,30,-67,-9,32,-36,-4,-13,-41,47,55,-53,-10,-25,-50,-33,-19,-30,1,32,49,14,4,-34,22,-77,23,28,-25,2,14,31,51,-9,106,4,-50,-47,14,-28,10,-34,8,48,-39,-85,70,-33,46,-61,39,14,8,-10,-32,-53,55,38,-61,-58,7,-61,-15,-2,-7,31,64,-17,21,17,-47,-9,-82,-4,-10,75,9,49,99,-18,-44,-80,-50,-55,63,-76,-90,-30,-11,25,49,58,-44,9,22,-58,-21,38,127,-24,36,82,30,68,11,4,-30,-87,-33,-23,-7,19,-17,29,-53,-47,-56,-59,-47,57,39,4,65,-51,25,20,12,-54,38,31,105,-46,-39,-27,14,-70,3,-122,-25,38,63, 
  /* [5][0][][] */ 29,48,-46,16,14,-16,50,-44,-32,-12,33,-7,27,-38,102,38,-106,-39,26,-98,48,-63,-8,72,-7,20,90,-3,112,12,21,-88,4,36,34,-92,42,16,-44,18,-26,23,59,8,0,10,-9,88,91,21,30,-33,46,-9,9,19,-29,-5,82,30,112,33,-20,-70,-3,19,-5,-52,-9,-37,5,-60,50,4,-73,47,53,43,5,-40,-71,5,-102,-50,-5,-12,-2,-32,20,-66,-20,-26,60,88,12,-19,-127,-29,-99,-63,85,27,37,-1,60,-51,-7,-10,-17,-21,-53,24,-34,98,-52,44,57,87,91,-27,-66,-28,-52,-71,57,22,68,-49,10,-14,-52,8,-21,31,7,65,22,21,7,-13,96,75,43,-7,-65,-53,91,-28,12,12,49,-17,-48,-86,-23,24,62,-47,19,1,96,-92,-66,-34,24,-21,54,-56,-29,24,-92,-10,-38,67,-61,-13,-73,-1,4,-82,12,-37,3,-13,36,-76,22,-1,120,62,-83,-71,-6,46,100,-80,-18,9,83,9,48,48,58,13,47,16,42,58,26,18,51,-1,-27,6,-25,78,-54,14,-20,-49,-41,31,27,-21,67,38,-47,-22,32,41,1,-1,60,66,-82,10,-18,-126,-4,32,101,6,-73,-29,37,-44,-102,41,-102,0,-3,96,-1,-103,-47,10,7,-41,53,68,-51,5,-12,-41,53,-28,66,-9,-31,-43,66,-23,29,-10,82,-74,34,58,-69,-37,48,31,44,-98,47,-77,22,-59,22,-74,112,-71,-81,-40,28,2,35,69,-6,-37,-29,-76,-90,33,-38,67,-63,60,8,24,-14,64,-100,-54,29,1,-7,30,28,43,13,8,6,-15,-26,57,-21,9,-29,-2,36,50,68,45,58,-74, 
  /* [6][0][][] */ -70,33,-28,-6,15,-22,-36,-12,-27,-33,22,-17,41,18,86,22,-3,-4,-21,-34,-40,22,70,66,2,4,-44,-9,-58,-56,-21,47,-46,-48,-26,-53,18,-39,68,-38,18,-38,10,33,-24,-3,72,-71,20,-11,-21,30,2,17,7,25,8,40,22,16,47,4,16,4,32,-15,-79,5,-1,47,-32,-1,23,40,17,31,-93,3,-3,16,13,-47,-28,-48,12,-22,48,-42,-22,-19,-23,-24,-33,-53,0,-4,2,-48,-43,38,42,22,-12,16,-97,-19,79,-38,-4,56,5,1,-21,-46,-78,-63,-3,35,25,-23,127,-45,-3,56,16,10,-48,-53,-6,-111,-90,-53,5,-65,-35,52,13,22,-3,-17,55,29,103,-18,28,-69,-107,1,29,28,-59,10,-18,90,11,57,26,84,-70,13,4,-12,-45,-37,-45,46,42,1,16,-42,32,11,79,46,41,-55,-41,28,-3,12,6,1,-39,-56,-53,-2,3,-35,-19,-26,33,-39,31,21,-33,-72,7,-102,-19,16,-88,12,-6,33,21,-48,-105,30,8,-87,4,-11,52,6,10,-1,14,-55,-52,-22,65,34,34,-115,-84,21,-21,-17,29,34,30,35,-60,-2,-21,-13,29,16,9,35,25,-70,-53,7,39,33,40,-35,-50,-45,-66,-22,-43,51,-78,40,-10,-72,-59,-16,-71,51,35,-82,22,-13,60,56,-50,13,-4,55,31,-78,52,-34,-30,23,-49,36,47,-9,106,19,75,5,47,20,-36,55,1,36,16,27,-32,-86,-2,-106,-35,0,5,21,4,41,-64,30,46,-76,9,6,38,-47,-61,16,14,36,27,-15,-41,14,-45,30,49,8,58,-8,-49,-12,14,-39,40,-1,67,-45,-22,78, 
  /* [7][0][][] */ 19,-75,3,-43,-49,-16,3,-9,8,12,24,59,-8,0,4,58,10,-75,12,48,-68,9,-68,-32,13,-23,33,-11,-38,81,12,20,-30,-25,2,-6,-35,-7,9,-55,-32,-12,-19,62,-9,38,-11,-4,-110,-6,117,-26,19,-16,-26,13,20,70,-21,-7,10,58,-7,-14,46,-14,-13,44,18,70,3,9,9,37,27,26,-4,40,14,-44,-27,62,-28,-43,4,56,17,-33,21,-46,90,8,-26,-39,45,2,7,-92,57,43,-29,21,90,-1,-15,-89,-49,18,-34,-8,17,-35,45,-3,0,28,10,6,21,-74,37,14,19,0,20,51,-82,-3,-53,-6,2,21,-54,-51,46,62,-3,-23,13,-12,11,-21,55,104,-9,24,35,44,-59,30,31,26,50,-6,-19,-30,53,-24,76,-1,-27,-32,44,-8,-105,25,-34,17,2,-22,-15,-31,83,24,-37,-30,-2,3,-22,27,55,-3,-16,9,-28,36,-7,27,44,-2,10,-19,12,-54,-49,-12,34,72,50,-9,40,18,-7,14,-15,40,35,-28,12,-90,41,-40,4,-47,71,73,-54,71,-6,-52,-41,-17,-7,33,-27,27,77,28,-62,-30,-41,2,-10,-4,40,8,22,24,2,23,66,18,-29,66,9,9,-40,30,-48,11,-26,31,0,29,-43,-32,-10,41,-53,43,-3,-44,5,-127,47,76,-13,29,51,-12,11,47,-2,8,-60,-5,17,58,52,27,39,2,-19,-14,-19,-63,5,-3,6,-35,-30,53,-22,-43,-28,54,-55,2,-17,-26,-35,2,17,-40,71,-11,30,-33,11,-44,19,0,10,-2,-104,-81,2,-39,-33,16,-6,8,17,65,-45,30,34,-42,-38,56,-29,-38,24,-81,-16,-69, 
  /* [8][0][][] */ 66,5,-90,-18,-22,50,-35,-35,26,-7,-8,-29,-119,4,-5,-87,45,25,19,18,-47,76,63,27,0,-24,-42,32,-10,-38,23,-50,-61,-31,14,-23,29,-35,-11,41,51,-38,-69,-26,-7,-66,0,-2,-17,10,42,31,18,-33,48,-7,14,60,10,41,2,-39,2,29,-18,18,-86,-20,4,32,3,14,8,-65,10,62,49,-91,3,47,-51,-85,-39,46,-26,5,30,3,-35,-58,-2,-34,-34,-35,-30,-78,-14,29,44,-31,30,64,51,-54,-12,70,12,78,34,-15,-18,-12,15,-62,-56,27,57,-48,90,-55,20,-23,53,-77,8,2,-97,-29,-7,-19,-31,-45,-38,21,5,38,-5,-11,-34,-38,68,9,15,-36,8,-38,-22,92,-43,29,-42,-11,78,33,93,-56,-37,-7,-15,-68,-68,27,-31,83,-19,-21,-31,-29,0,41,25,42,4,45,-45,43,-9,-28,-66,46,-33,8,-26,-34,1,34,32,-21,42,-60,43,12,29,-127,44,43,-23,46,86,-1,-41,-38,-11,-14,-1,-90,16,-50,54,-49,-9,34,-39,-17,-109,10,28,27,-6,37,-59,-7,22,18,-14,-13,6,-10,15,11,40,24,46,-58,-5,5,35,-9,39,-44,36,45,25,-27,-1,-39,29,2,-22,-62,-8,-43,-75,35,29,94,13,-45,1,-4,31,11,86,-38,-48,28,-49,-33,65,14,103,-35,17,-50,38,-86,46,-32,-18,-4,4,9,-28,-41,54,51,33,-8,-11,-10,-67,-34,61,-112,38,64,39,-45,23,-31,-17,41,-31,69,13,-18,-58,-37,-38,-63,24,-3,46,-33,2,-27,-63,12,-38,24,6,-25,15,31,-42,-16,26,0,9,31,41,22,15,53,-29,-40, 
  /* [9][0][][] */ -1,-11,12,29,73,25,102,33,99,-31,-11,29,-91,19,47,-1,-66,-21,3,45,-35,10,-46,57,14,79,-9,33,22,-11,-54,-10,47,-3,-71,2,-13,68,10,30,-24,-15,20,-26,-60,-6,-4,-2,-32,-51,67,8,1,-53,0,57,25,66,9,32,13,50,-45,-31,17,15,33,-3,27,33,62,-12,-64,-3,-19,-8,91,33,-27,45,14,-12,-42,45,68,-47,-46,49,7,44,9,49,-4,-35,6,15,-2,-2,-54,-49,-63,-7,41,17,11,7,22,13,18,-4,82,-98,-48,-42,-37,-37,3,26,-27,21,-1,12,-29,-5,28,-76,19,-99,-68,-13,25,37,-49,4,-4,-29,-21,24,-14,32,-42,97,-38,-15,-13,-17,88,26,8,38,-56,-3,-5,-57,52,63,49,3,89,-20,102,-1,-24,32,-41,30,16,-61,35,-46,-58,44,-26,-18,-13,54,-52,75,5,49,6,-52,34,53,-33,28,9,-16,29,-31,47,20,-53,23,51,-24,16,25,-19,30,-29,-106,9,-23,-57,-77,-4,-10,-26,-4,110,-10,8,-47,1,49,-21,-24,-10,28,23,-32,56,44,-75,-66,-68,-56,-24,7,-42,53,113,-1,83,46,-22,-30,-16,104,2,8,-77,127,-44,29,112,8,3,-44,22,40,-5,-11,-57,12,-32,-16,2,-14,37,26,73,8,2,14,-24,-40,-81,49,-4,-3,-9,-47,-8,50,-2,-23,11,70,69,32,-13,-10,-20,2,29,49,2,-14,-38,-7,26,-81,8,-41,60,20,71,5,21,4,49,-60,-88,-24,-32,-85,54,67,-42,-65,39,-43,-16,63,79,9,-46,-42,-15,7,-6,23,1,-8,-56,60,53,-25,-40,57,-45,-62,-78,38, 
  /* [10][0][][] */ 8,90,13,-18,-63,41,4,-63,-1,40,-12,-62,-6,37,-89,55,17,-43,36,47,32,-21,-23,-46,15,57,9,35,20,-38,38,66,13,9,54,-22,-33,25,22,-29,-15,-49,-44,-25,-29,-19,60,1,-1,-14,-38,-5,28,-10,-23,9,13,17,46,2,20,49,-41,18,-39,37,4,-17,-18,10,31,-18,3,7,-10,16,68,14,24,-9,17,49,15,-22,43,19,-29,17,29,-36,-93,-3,-76,-3,15,-21,97,-30,66,35,-103,30,-14,42,59,-5,50,-54,-39,-28,16,69,-34,-10,-5,39,-12,58,18,-20,14,40,33,43,88,-3,127,-95,58,35,-89,-72,-23,-43,13,-95,79,-19,-24,29,73,22,10,71,17,0,-44,19,-49,-15,-27,23,-3,19,-59,32,18,-31,-27,65,31,-7,-30,-92,-82,-15,15,-42,-67,96,19,32,9,-5,-87,-25,49,9,9,45,-25,-92,-17,13,60,-45,3,-19,-5,5,11,99,2,-5,-14,11,-61,-40,-25,24,-44,-49,-32,-54,34,15,14,51,30,28,-50,11,-7,-27,1,-16,-35,14,33,53,-19,3,-24,14,27,61,68,-29,20,-12,17,59,-5,-13,99,-43,-37,37,-96,-8,17,34,10,60,-40,27,39,18,70,-2,28,44,4,62,1,40,-19,116,1,14,-15,8,6,12,36,-7,11,43,23,24,-4,-42,-15,-5,-31,29,-4,-2,20,17,66,38,-44,-13,-3,-2,-11,3,11,-35,27,-24,27,-49,-35,-23,39,-34,-6,-1,-35,-25,-6,9,62,-64,49,-56,33,-20,16,33,71,6,21,0,42,53,-28,33,16,13,-39,-37,-22,37,6,-70,-37,64,71,51,14,-64,-15,15, 
  /* [11][0][][] */ -36,-115,-4,16,70,26,-48,20,77,62,64,7,-2,124,7,-85,-39,-14,98,56,44,-4,35,48,22,39,-59,56,-9,5,15,-58,15,56,-58,-17,50,58,78,15,14,-40,-27,30,-13,-95,8,-105,127,15,2,63,-2,-5,34,-20,102,39,-71,-10,-55,14,-66,43,48,-25,-6,114,3,-19,-60,13,-27,-27,-10,111,-45,-62,24,-93,-29,-2,24,-12,76,113,17,11,-19,-44,-41,14,25,-2,-27,40,2,-71,19,-54,65,-58,-18,0,17,-14,-4,-11,-15,21,-5,10,9,38,-26,-3,42,-5,-42,-8,-34,1,-24,125,67,-21,108,67,-6,17,1,-34,45,-66,-68,79,20,27,-47,-2,-10,-20,-83,-13,-11,-1,-20,24,15,-10,68,19,30,21,36,-77,-95,8,21,7,27,-46,67,62,67,9,12,-3,-53,49,-15,50,4,17,-25,1,-58,-40,103,2,-6,-64,74,18,46,-19,-57,16,-9,18,49,-49,-34,-70,2,-23,-14,26,-79,4,-85,-43,-61,-117,43,-1,73,-73,10,31,39,-12,-22,3,3,-7,3,-29,-52,46,35,-49,65,-91,22,-17,53,-16,-4,123,-39,18,96,-64,0,28,18,-30,5,12,75,0,45,-76,-19,-6,-6,52,2,38,50,-79,-12,22,-89,-51,34,-39,31,43,-4,-14,17,-57,94,-75,-30,-4,-31,-13,20,-24,97,-23,-19,-69,107,73,5,-44,-87,49,-49,30,-77,-76,-25,65,-13,-93,-50,4,19,-28,-13,-1,-6,64,-67,5,36,-4,-96,-44,81,14,42,-55,-25,84,-20,28,-93,-30,20,5,55,-38,-41,10,55,-26,-42,38,-6,-36,-61,6,-47,-4,16,0,-15,-30,12,-8, 
  /* [12][0][][] */ 21,-25,-15,13,30,33,52,-18,12,-7,27,24,-12,37,-9,3,27,27,-3,19,1,-36,45,22,33,16,14,-29,2,-6,-32,-18,3,-50,11,-40,-20,19,-8,2,-40,49,-28,-5,-9,-23,-73,-70,-30,1,-42,15,-34,-34,16,6,-62,31,-19,20,14,-22,10,7,-5,30,-33,67,-74,-8,-25,127,-6,34,13,-17,-24,38,-10,-6,0,-27,-3,-38,14,53,-26,-23,18,-38,16,-25,-5,-9,-9,21,27,-14,23,-22,8,9,-15,28,88,9,-7,17,14,-41,30,-17,-15,-22,-11,-1,-13,17,15,44,-34,-39,-9,17,-19,-25,-5,4,-9,-10,-14,-4,-40,22,54,-37,22,27,6,23,-9,24,-59,-1,16,23,-16,-23,-34,-4,37,20,16,12,-20,-4,-6,-3,49,-40,-14,-13,43,42,18,10,-8,37,-27,-8,21,14,-16,6,21,26,-17,14,20,38,-8,-25,-18,30,-35,13,26,32,-18,16,-52,-28,23,20,9,-90,-61,45,30,17,34,20,9,5,3,33,-31,-12,15,18,-26,19,66,18,-31,-13,20,19,-14,-13,29,-49,-12,16,3,8,5,13,-9,25,21,-16,63,8,-69,-22,4,15,33,-15,6,-1,9,-10,51,5,-54,-62,-68,-66,-3,15,1,28,-15,-15,-12,-47,-11,-34,4,-26,16,-8,8,-20,39,-34,69,-19,-4,-2,9,-24,4,34,14,5,-43,-21,41,-36,20,-42,42,29,1,3,20,10,26,-29,40,36,-27,-37,38,4,-27,1,-77,-29,40,3,32,-11,8,-44,31,-71,-3,2,-40,31,-53,4,-11,5,-6,48,21,5,-31,8,16,-18,-2,-6,6,19,-29,-55,-58,-32,7,35, 
  /* [13][0][][] */ -26,45,19,37,-89,18,15,19,41,49,4,27,44,30,-32,58,-25,21,27,-19,12,-51,62,44,-14,44,-5,-1,47,16,-21,-36,22,-41,24,-21,64,-60,20,-21,-40,-68,-8,-2,13,-67,-31,55,23,-20,-14,-27,-68,45,-60,-5,61,-65,-89,10,27,85,-18,-13,8,-40,-26,28,31,31,-35,22,-26,6,8,28,22,-29,7,-12,30,-11,28,-43,86,-74,-27,41,-9,25,34,-2,13,-26,-59,-32,29,53,70,27,17,-19,-8,14,20,-103,-24,36,-69,0,-53,-14,8,-64,48,-28,30,-65,-35,-51,12,-61,1,-27,-18,-29,-36,69,-10,-1,0,-46,-24,41,-22,-12,56,-57,25,-43,-73,-43,-68,-16,-20,-18,-2,53,45,-17,7,-28,-69,-24,29,36,-112,19,20,21,-25,9,-55,17,9,-36,8,42,38,9,-4,57,102,-27,61,0,-70,-92,20,57,-17,-71,25,-7,9,-26,9,39,-31,-41,-31,-51,19,-29,39,40,17,91,27,78,60,54,-29,58,-13,56,-24,-10,-10,-36,13,12,5,-17,-74,10,-3,22,24,0,-67,-16,-17,-22,1,-52,56,-15,39,-9,-12,-31,59,-3,18,-17,47,50,-22,73,23,65,65,15,-3,-1,-10,76,48,33,31,127,41,-40,0,-54,-2,-12,-12,0,19,13,26,81,72,-17,-16,-8,-1,-14,-14,8,19,-14,101,-27,-13,36,27,16,88,2,-4,-2,-21,4,37,-11,-22,2,-23,37,-9,21,-29,-33,23,-3,53,1,-101,25,65,-3,53,-43,38,-24,61,41,-31,-27,12,-64,-24,36,68,-28,43,-23,-11,0,38,14,-108,-74,-67,25,45,-34,18,-61,61,-16,0,44, 
  /* [14][0][][] */ 40,27,3,-18,22,-31,21,-24,-29,-3,4,37,23,-19,-16,-20,35,-18,-20,-1,36,-21,-84,17,-13,-25,-54,-6,21,7,-19,25,8,51,-18,29,-28,-36,3,28,-61,24,-4,-11,16,-117,-46,-10,12,53,63,-4,-29,-9,-8,26,-22,-40,-95,10,-11,14,27,-27,50,7,-32,29,-19,62,13,-54,-20,-40,16,127,-64,20,-8,-27,-23,8,-23,33,68,-12,-26,6,-19,-18,54,-44,-25,83,12,-30,-65,-101,-7,21,33,-2,26,23,-45,4,-63,15,-21,6,-40,34,32,-3,91,-16,12,-18,-88,-60,39,41,-1,41,55,-25,-58,-79,-7,25,99,-27,62,-55,20,-4,-3,-45,14,-70,6,16,-56,-3,18,88,-20,21,13,-35,-50,80,-15,-28,-1,-45,-27,-30,-25,-2,18,-4,-33,-9,25,-36,12,49,26,-41,53,-23,18,-17,-11,-29,-3,13,-3,19,-59,37,8,-21,-38,9,-28,27,85,-57,1,47,-27,15,27,-23,21,-63,-53,15,-33,-70,-19,-5,41,-41,16,-44,21,-30,-18,86,68,50,1,-20,-54,-62,-48,-39,7,-33,15,-14,7,64,-54,-12,33,-25,2,7,-11,2,-4,31,7,-4,-79,-11,33,27,-20,1,22,19,11,-28,-53,16,24,-17,-19,-45,15,18,31,-24,37,29,-19,65,13,-33,1,15,90,-47,24,47,-6,-50,-7,-7,17,-5,-48,89,-71,22,61,6,-33,34,-20,3,12,10,-15,76,-96,4,-18,-42,-9,7,9,-12,-55,77,-16,12,14,-46,-60,-45,-12,2,-20,-29,32,-55,-110,7,25,30,-45,49,11,76,104,23,35,-25,-45,33,8,62,-14,66,-54,7,-26,32,-61,-26, 
  /* [15][0][][] */ 26,-16,58,40,17,23,2,0,7,4,-45,-57,35,33,-24,-7,17,17,-5,-11,-3,10,5,-9,36,4,12,23,-25,11,15,56,-26,14,9,-8,32,-16,13,53,66,-8,33,40,-38,31,46,-39,42,45,-34,-82,-17,-1,40,-11,-13,-3,-13,7,66,69,-6,56,-16,1,21,-5,-52,-81,-7,-9,-24,-45,-15,-4,-23,7,-32,24,-39,30,-60,-7,32,0,29,47,-13,-1,46,44,-28,-2,-47,49,16,-94,84,-62,20,50,5,37,23,-18,25,-16,-1,11,25,12,-86,19,-27,10,38,13,10,-12,34,9,12,6,53,50,-49,-5,42,-26,5,15,-20,44,-3,8,-19,-1,11,-5,-10,-32,-43,25,-3,63,-18,18,-5,94,11,-57,-19,-14,-2,11,19,38,-3,7,-46,31,19,-3,19,22,-39,11,49,-60,-22,34,-17,19,-32,-4,-8,11,-1,17,-34,44,7,-13,17,-38,-3,-8,57,-23,29,-11,-49,-8,-37,-13,-18,14,17,-63,-50,25,6,-4,18,-13,-75,-35,-30,-25,9,-11,63,-26,24,42,-30,-4,35,33,30,3,-6,-37,-22,-13,-39,0,82,25,28,-69,-16,20,-34,42,14,54,-26,-29,11,24,27,-34,0,25,-17,-15,-14,58,44,14,-20,-37,42,28,38,3,-51,4,4,13,12,-27,-60,-25,-90,74,40,-23,9,53,23,30,19,-15,127,-26,-13,1,17,-16,-17,38,-31,-27,45,-4,53,33,-9,-11,1,6,36,-43,29,39,-46,-13,44,-47,32,-69,22,6,-15,10,-12,-4,25,15,-7,8,-31,-38,-6,-23,19,-29,35,-12,57,37,-69,-42,24,65,21,14,-29,-34,-2,11,27,-8, 
  /* [16][0][][] */ 21,17,40,17,-67,-7,55,-25,7,12,14,-26,-41,-42,-10,8,3,-9,8,-18,-11,-14,5,-56,-2,-56,-83,45,8,26,-67,-42,-17,-12,-67,-40,-4,15,-55,-25,29,-38,-14,25,-69,-1,-43,49,-14,26,7,-56,36,36,-30,75,27,-13,5,-52,37,60,-30,13,24,8,-77,-42,1,-52,16,-63,2,28,-16,15,-8,2,15,-15,-13,-20,60,-19,-7,18,9,77,-13,12,-17,-30,-39,37,-19,-52,-3,-26,25,3,-30,-3,50,-18,-25,-67,11,-35,-21,6,27,-29,29,73,4,53,-18,55,4,-13,-8,-32,29,32,-49,20,65,-8,11,-31,65,-14,-31,-12,-2,-90,42,-34,0,7,30,43,-13,-18,-1,16,-32,-9,17,9,15,-50,-5,-26,-39,-70,2,-28,-25,-21,-38,-34,-13,-14,34,-32,0,27,-49,30,14,36,-52,7,14,86,-9,-25,-16,32,-7,-27,-18,-11,-49,38,-8,11,12,56,28,-11,-57,-57,54,-39,-59,-14,-5,41,-2,-10,50,-25,27,47,4,-6,13,-15,-1,10,29,-10,-30,-58,-35,-23,-29,42,14,23,-52,-86,28,10,51,-13,52,-1,-17,38,-52,-50,39,-40,-41,-34,-2,-36,13,13,26,-9,-47,-50,54,51,1,13,-24,-48,-41,19,17,-16,-42,-18,-19,5,-21,34,-16,-28,30,30,-5,19,24,34,3,38,-41,8,31,21,-68,-17,8,-47,50,-44,9,9,72,-42,8,9,-4,16,-12,-3,41,37,-8,69,37,5,47,-16,42,-2,72,-33,-12,-30,-12,2,9,-6,17,-29,-30,-29,-127,-42,45,19,23,12,-46,12,-35,-18,9,10,29,33,46,-31,-15,2,17,15,28,-10, 
  /* [17][0][][] */ 11,-6,13,43,32,-60,-7,-10,127,66,75,-2,12,55,-54,-9,15,-57,29,-6,-19,-46,-10,17,-25,-74,-68,-39,3,-25,-37,-37,40,29,-43,-4,-77,-45,21,13,42,8,-39,-45,-23,71,-23,49,-76,1,26,13,-19,73,-12,-19,-28,-62,-42,33,30,-30,-7,-41,37,24,-52,31,17,-15,-17,57,33,10,35,71,14,47,-61,79,-12,-44,-43,54,-52,-114,-21,-59,9,8,84,-24,54,63,28,-14,28,76,-63,-3,34,59,-31,-41,-69,-64,-16,-35,-12,-6,-2,-21,-56,-91,-16,57,46,12,64,-9,-29,9,-84,-24,-11,23,61,-29,-7,18,-89,-74,-54,-16,22,71,-11,-48,79,20,7,-14,11,-25,-62,-9,120,29,-25,-68,52,-24,33,-55,51,-45,63,81,-95,21,22,49,5,-17,50,58,-29,-70,56,81,44,0,33,8,-1,0,70,37,-18,-28,-29,-4,12,8,33,40,47,-36,-57,34,25,18,-30,-47,-5,-70,5,17,-11,62,76,22,68,28,98,-41,40,-12,-41,30,10,-51,13,-4,1,9,27,-76,52,17,44,-16,-21,49,-5,-38,-33,-44,-1,44,-12,-6,-18,5,40,39,4,62,-56,-61,-15,-7,1,87,29,34,24,53,-3,81,41,49,27,46,-1,15,-45,-32,-5,-1,-53,44,-42,0,-49,-15,3,8,-43,-3,-25,-33,50,22,-33,21,-7,-88,43,-35,4,-42,29,0,47,18,-10,45,-80,-48,-31,-13,-23,52,-41,83,11,-81,-59,9,14,-27,-3,-47,-9,31,34,-33,14,13,0,67,-18,4,-7,-81,28,15,-35,-80,61,-34,31,8,4,0,81,-37,-43,27,69,-53,-86,-9,2,35, 
  /* [18][0][][] */ -18,-19,20,-60,23,5,4,-14,-7,-14,19,43,39,48,-3,-22,-33,-1,32,-27,23,14,9,-25,60,32,-48,-8,-14,50,-9,38,26,19,59,-58,-46,56,-26,10,-49,-2,-64,-7,-30,56,15,47,8,-55,-56,67,-103,-10,-61,30,-95,-20,60,-6,16,-111,-24,12,61,-28,-45,39,83,50,64,-20,26,-87,42,-5,-19,-13,8,-58,-7,-47,-78,-70,-42,35,14,16,43,-64,-62,42,-22,37,25,86,-42,-9,58,75,-5,-48,6,23,56,15,22,-59,-17,-12,-58,-112,-26,-35,-83,31,-21,34,-28,-18,-20,33,-7,-15,47,-5,-5,-39,6,-12,52,12,6,-13,4,-14,34,29,27,-54,-121,-16,-34,-79,-24,-40,15,-40,-23,-26,0,-1,28,69,-31,-97,50,37,42,-7,59,-53,23,70,10,-60,-12,57,98,49,7,10,88,29,-37,6,-38,-6,-99,-24,-35,32,-83,59,-13,-36,-5,12,37,-43,19,21,-54,26,-13,27,13,62,48,-43,-77,21,89,69,71,53,-48,27,-30,-10,27,-10,-44,-27,-39,-52,-13,-1,-16,-7,0,10,2,31,-34,22,-54,20,10,97,27,51,-74,-2,31,-31,-50,52,16,-3,-43,50,-1,-57,39,31,2,8,63,-9,127,23,28,5,-33,-31,8,-7,-35,0,-21,-42,-13,3,-39,-2,-87,-26,-18,41,76,-21,-82,-9,-14,-33,17,54,-28,-40,80,-20,-29,69,-18,-36,-5,-30,29,-16,16,-23,-24,7,2,-62,36,-53,28,-24,-63,-12,32,-5,-43,1,12,12,82,80,60,-29,-56,-16,5,-25,-49,-37,-1,61,-58,33,-62,2,45,3,50,-84,6,-16,-58,-8,26,-59,-2,54, 
  /* [19][0][][] */ 51,40,16,-32,-22,33,-24,16,74,-83,67,-11,75,-36,4,-26,-25,-28,-30,53,15,54,3,38,8,3,-28,65,67,-5,-4,-31,-37,15,-11,-55,6,-16,16,62,-26,26,14,17,28,-56,-20,-55,35,-4,-37,-93,-37,11,50,46,-22,-5,-64,-39,60,-119,-67,-11,69,4,-12,-29,15,-46,-19,35,9,-37,3,-52,-4,-95,23,-36,-2,13,-58,-26,-74,-91,24,-91,8,44,-4,13,-20,2,23,20,28,41,66,9,44,31,11,42,27,-2,-53,50,-65,25,38,-23,-4,22,-46,7,-38,31,17,-40,31,-3,29,-14,38,21,-14,32,-34,-42,-40,-42,-65,-13,14,-48,-18,-83,11,4,-83,-1,-57,-22,-17,-15,37,-9,-58,-19,-20,84,-6,19,-53,60,126,54,-50,40,7,-98,-9,63,-66,-42,49,52,40,-32,-9,-28,-11,-1,88,-14,52,25,-9,35,-15,-1,-23,-14,38,8,-25,-47,2,13,-54,-13,-23,77,-61,28,-17,-75,32,-46,-30,102,-74,-40,101,30,31,38,30,-97,-31,-22,69,40,-66,70,-30,43,-9,11,-27,-40,-47,-6,-19,-46,4,71,11,22,-32,67,3,85,-37,-5,4,-12,-69,34,19,-10,93,4,-30,-33,43,-22,16,29,-84,-26,2,-5,12,-56,-5,-65,20,-23,8,3,-54,19,-74,21,30,22,48,-40,43,68,-37,-59,27,47,-92,10,88,-16,34,-15,-6,-92,-57,-79,30,-5,-48,-57,-76,16,93,54,92,35,-41,-6,-32,67,78,-14,28,-56,127,-13,21,47,-36,60,-20,71,53,-34,-10,10,13,37,-56,36,11,15,-63,113,-17,10,-52,13,-37,40,-7,54,36,-18,10,35, 
  /* [20][0][][] */ -24,19,18,127,-34,-49,19,-60,-7,26,-10,-79,-42,39,-20,-31,12,-41,25,-1,27,-8,4,13,-9,-13,12,-27,-1,6,-17,-2,42,-36,-3,-32,24,68,-11,-12,-54,18,-28,58,-38,28,-66,18,8,-14,19,61,41,-2,-3,14,-19,81,-1,46,-55,-41,31,8,-5,3,-13,14,-44,19,-56,-35,39,8,-46,4,16,-35,23,-2,-52,39,-7,87,23,-14,2,-7,64,4,16,-19,-29,17,9,47,13,83,50,-18,66,-14,42,46,-12,43,1,-13,1,23,58,-2,-41,-71,-13,39,-17,-30,-5,-14,49,17,-58,54,17,-47,-12,-93,58,0,13,82,-4,7,-17,-40,29,-34,-49,-4,-7,-67,37,-67,-25,52,-84,-9,29,-58,-16,27,-22,13,-9,59,72,43,51,-15,11,-13,-54,36,-31,-37,38,-12,37,43,47,-3,50,-14,42,29,3,-19,15,-15,48,-9,3,-43,-69,-29,49,25,-49,-44,12,-29,-4,5,35,-50,-1,45,4,-13,-30,-56,34,-21,-17,1,44,63,0,-17,-4,15,-17,-67,23,47,37,79,-4,-88,34,16,22,-18,-16,14,-38,-28,-45,15,-6,21,-24,-53,50,-32,9,-9,9,-20,18,-19,17,-26,-37,-42,-15,33,4,-16,5,-10,40,-80,113,-10,-36,41,10,-32,-7,50,48,68,8,-11,45,84,76,-12,18,-62,51,27,-34,-17,27,16,32,26,-72,31,35,33,11,29,0,32,-16,1,-20,19,27,65,-4,-2,-88,-54,-9,-23,-50,62,-3,-38,-43,3,-13,11,-95,14,-22,35,-49,4,-25,-64,31,-19,-42,15,-12,27,33,-7,-62,-43,44,2,-37,-59,-18,3,38,-44,4,12, 
  /* [21][0][][] */ -49,-23,-32,-25,-24,-30,-5,7,-81,25,-34,-16,11,-17,93,-44,-25,-16,18,-4,-19,-6,34,9,35,7,3,20,64,-54,-57,-21,8,-17,-45,-1,-10,101,13,42,-4,16,-43,14,-13,-2,17,3,11,3,-38,23,14,-5,-5,-1,59,-43,28,22,3,7,-35,-7,1,29,-9,19,-13,26,-4,-44,-19,-15,-17,32,52,60,4,30,18,-10,-4,35,-18,-22,-6,-15,-20,5,-5,-10,-16,-8,-13,-44,45,16,-64,10,23,-19,44,-10,-23,23,41,-40,7,44,-15,-8,29,9,18,36,18,-38,32,7,-7,-65,20,18,-56,40,-39,51,61,-7,45,42,25,-28,-8,-1,16,-19,15,-15,-28,-7,-41,26,-55,-10,-18,-23,-35,-17,-8,-1,72,54,-30,12,-17,69,-7,-32,-29,35,81,43,-41,0,2,-27,24,-59,-36,4,-4,-5,-31,61,67,102,-39,16,22,-13,3,66,52,-33,-28,-19,-54,-38,-14,35,-6,12,68,0,-42,36,17,4,-52,49,-17,-49,-24,3,26,57,-70,31,-9,-28,51,7,-16,-5,-18,45,12,19,-17,-19,-55,-44,16,-26,-1,-4,20,1,11,-18,-34,78,-12,26,60,-96,18,-49,23,-39,15,17,-19,-22,31,20,3,5,-21,-32,-46,-23,17,-34,33,-5,-10,-16,11,5,12,7,-14,-13,43,-33,37,-41,-21,46,-4,18,-7,2,-23,66,-46,14,-9,24,-11,2,7,32,-23,5,-24,-7,-47,30,-39,-20,-39,-13,11,55,-81,-8,17,3,127,14,-19,-4,63,-29,-51,-5,-14,-19,31,-6,21,-24,-32,-18,61,-18,15,-3,-14,-54,6,-2,20,-3,33,-18,25,40,-43,-87,-25,4, 
  /* [22][0][][] */ 63,46,14,-78,-81,34,-7,-12,-1,-21,-15,39,125,-4,-70,93,-31,22,33,-23,-17,1,47,-65,-49,34,-7,-14,-18,23,-4,12,-3,5,20,-7,-50,-56,34,-28,-40,3,-91,53,9,93,4,-68,42,-16,-7,-26,-16,21,-26,-19,21,127,21,-14,39,14,-1,13,32,-19,13,-4,-27,-34,22,-3,-18,58,32,20,2,10,38,36,-8,-62,-79,-22,-39,43,59,52,27,67,-85,2,84,-31,-13,-50,-72,2,-45,-14,-26,62,-40,18,56,-83,0,16,54,54,-24,-31,-13,1,93,-29,-42,17,26,11,-30,13,4,-16,48,1,-35,23,-46,76,-93,-77,25,7,-17,-26,-3,27,-24,15,101,-25,5,21,-10,-42,-42,21,19,-5,-44,18,74,-18,6,7,38,-5,31,-51,25,41,19,2,10,18,42,20,-2,-84,-10,-34,22,-89,28,5,-28,115,-65,-51,54,-8,-89,-127,25,13,12,13,-99,7,-13,40,-37,-4,57,-23,-62,-65,84,27,-7,-10,21,29,-98,-23,-36,14,11,15,0,-28,2,27,-86,-61,-30,7,49,34,-54,3,-9,-21,-16,76,10,-30,-84,-4,13,27,-26,-1,119,-33,-37,-16,47,-5,43,5,-86,-24,-4,8,16,8,14,65,-36,-39,54,-22,-39,-38,27,58,-34,-35,-42,-46,-19,33,-27,26,109,-54,-22,-26,-25,-20,-100,-39,-1,20,36,22,-7,3,-91,80,5,87,-12,-55,-13,-67,19,59,75,63,21,-38,40,41,104,-55,30,15,18,52,27,-24,-43,118,-16,17,-8,13,-62,112,16,-7,12,111,15,7,-37,-18,73,26,45,25,-28,1,73,11,2,-39,-4,25,-45,-47,-49,-35, 
  /* [23][0][][] */ -25,-45,-30,44,-51,37,-61,-28,-72,-21,73,32,-27,20,10,36,-1,-44,15,-25,-41,-39,-42,17,-57,24,-4,87,-9,-67,-18,19,20,-33,-41,25,-39,17,-87,-52,-47,-25,-19,-34,23,-4,-58,30,-19,80,39,-90,36,-29,40,-22,-15,-23,-27,-4,-41,-16,93,-31,19,4,-39,-17,-33,51,-43,5,-98,50,-53,-27,31,-57,-8,-37,-35,-72,-28,-30,-13,-60,67,4,51,127,9,-13,-28,27,-9,-23,-7,-121,17,-40,33,-13,48,41,-27,23,-40,17,-68,45,-23,32,50,-45,40,10,-52,-37,-18,-22,-5,41,-6,43,60,21,38,77,-6,-3,35,-43,-20,-1,32,20,-24,-18,-27,-8,27,-104,66,-6,87,-3,-2,-15,-14,-10,10,-61,-88,10,-71,-44,126,-7,-46,-21,-8,52,14,44,-12,28,-24,13,-17,25,-1,-11,-60,-63,111,22,-10,-24,-21,-31,6,-104,-16,4,23,-25,30,-26,16,-34,22,7,-4,33,41,-25,-64,49,11,20,32,-30,12,45,-44,-49,-21,-20,-42,-22,7,-39,-11,-63,-33,46,97,-12,33,40,-9,-67,-59,13,42,85,-85,-8,46,81,6,-15,-107,67,54,15,37,61,-46,17,14,61,20,62,15,55,-38,-38,-28,-19,-14,-61,-57,-43,26,6,0,24,-30,-1,28,6,21,-11,-39,-28,-31,-3,-107,6,-31,29,-26,-6,0,-8,-47,34,37,38,-11,14,17,-10,-5,53,-40,-81,-3,-39,116,-73,-78,-40,14,1,20,28,8,36,-18,-50,-45,-25,35,10,-9,-7,34,125,-3,109,-74,33,35,38,64,19,-1,12,45,11,-44,10,7,3,-26,11,51,7,-21,-76,29,5,11,-13, 
  /* [24][0][][] */ 5,33,7,-9,-1,-38,57,33,13,-15,58,-61,-31,68,17,0,-26,5,32,-15,8,-4,-7,44,-24,13,-10,-30,1,-2,75,51,-34,7,-37,2,4,11,25,16,-14,-5,-54,-52,19,-48,-47,33,22,-13,-1,-71,-15,50,0,29,27,-11,28,27,12,57,5,-7,20,-1,23,-20,51,33,3,15,28,-47,26,0,57,13,14,-18,7,-13,6,46,-40,6,25,-34,-25,6,26,-20,-12,19,38,-5,38,-37,-31,-43,-39,14,-17,55,-55,-14,1,38,4,49,15,28,17,28,-4,-21,-27,11,-2,-25,9,14,-18,23,24,-73,45,-17,1,-24,-75,74,17,-10,-6,-80,-26,36,20,-25,4,-22,-54,-7,43,-52,8,-46,51,16,21,-44,27,34,-21,16,-38,-32,-1,19,19,-40,10,-5,30,-6,-56,-75,-2,-17,-24,-52,38,-127,19,17,-6,-34,44,-125,-15,7,-71,-42,-49,-32,19,34,-11,9,-6,26,0,41,48,-35,5,44,57,-17,1,-9,-35,-84,-11,-24,-21,78,8,-70,-36,64,-9,38,40,2,1,75,54,-1,-35,-53,7,-51,-38,21,32,-4,25,31,-19,-42,-15,-13,-10,-1,28,-22,29,8,4,-21,26,-8,27,-7,-16,25,-44,54,62,-20,43,20,-7,19,6,-10,29,21,23,32,28,8,10,56,19,13,37,22,-86,-18,-12,-37,9,-38,111,29,-27,46,-6,10,-11,-3,13,0,-23,0,-75,4,-24,-12,18,46,28,-3,27,24,-10,18,61,63,6,16,-21,-43,46,-46,35,-49,18,20,21,-6,-57,-9,7,4,-35,58,-20,14,-5,-33,-14,55,59,-3,24,34,-14,-31,-71,-10,5,40, 
  /* [25][0][][] */ 78,15,-39,-63,-56,19,41,-37,14,-18,1,8,-3,41,-5,-49,16,-17,-35,-17,40,28,48,-37,12,43,-24,-12,-46,73,-19,5,12,15,-60,-4,-25,12,-96,10,33,-23,-4,-26,53,-19,-11,21,23,61,5,-80,-7,-39,7,4,-22,-30,21,-46,8,43,-53,-39,-63,-14,-39,1,34,-26,16,-57,-3,-32,-7,28,36,38,55,-23,68,-66,23,53,-49,50,-3,-111,-28,-94,16,27,51,-20,2,76,-24,39,20,-1,-6,4,-10,25,33,5,3,19,-33,-21,-10,57,-18,75,-65,4,54,19,-9,17,-35,-36,5,-12,74,74,44,81,54,-14,-28,7,6,30,-9,-12,27,-95,-20,46,5,-4,-22,116,52,126,-12,64,-38,8,-6,-75,-23,38,90,60,6,71,16,-101,76,52,25,-18,-46,72,7,7,37,24,44,4,70,64,28,8,-43,-84,-77,-75,4,-81,-30,15,-42,24,-8,43,56,-15,-28,-13,31,49,38,-7,-36,-54,-2,-85,55,-11,-13,9,-42,-24,59,-23,-1,21,9,-13,-45,-47,45,-38,55,73,12,91,79,-17,-31,25,-84,71,34,-40,-30,-18,38,-35,-7,-58,12,-6,33,1,34,-11,5,37,-63,5,49,31,-32,39,40,-122,53,-7,21,54,-44,-114,46,21,14,-23,-22,0,-2,-24,-50,81,-62,-34,17,-41,31,35,75,-55,-14,-7,-13,-62,14,-37,42,-7,48,33,-32,-40,-67,-93,36,-41,-52,-5,-78,47,50,71,1,24,-34,-39,-58,27,53,-61,-11,27,-2,-21,-61,21,-15,16,-90,14,-20,-86,127,-36,-12,-35,98,-23,-17,-41,15,-59,41,49,-60,38,-36,65,-57,100,-24,0, 
  /* [26][0][][] */ -13,43,-47,-55,-7,-3,41,-5,34,38,54,-9,12,38,44,-39,-26,-48,24,-14,43,-63,-28,-52,22,10,-73,2,20,-48,-60,18,39,17,-25,43,36,-22,77,-11,37,36,-38,4,16,-12,23,-4,4,-6,-47,-23,-20,13,-5,27,20,34,18,21,62,-79,-29,-7,-47,23,18,-56,21,-1,54,42,-41,35,3,52,-4,-11,44,19,44,-2,-18,-80,52,-79,-78,55,53,-89,11,-17,9,-30,-9,5,24,-54,69,54,47,-14,-15,15,28,-28,-13,0,13,20,-55,-9,-57,-31,32,27,-27,-32,-46,-6,4,6,-47,60,57,38,29,-61,19,30,-31,-38,55,1,35,-28,-8,37,-17,-37,-18,61,-14,-66,-17,126,78,-16,27,-58,41,-127,17,18,64,8,-11,-31,-60,36,2,-19,5,40,-41,-39,-58,13,-26,13,32,34,17,-33,43,25,30,60,-15,24,-21,-4,15,-61,-25,19,-6,22,39,56,25,27,45,-16,0,-48,-29,-12,-2,27,24,-52,-52,16,21,-19,7,-8,-19,-51,0,-44,-37,-1,-19,101,29,19,46,11,-12,16,-53,91,-56,-32,-17,35,-9,-15,44,-18,-41,71,6,-25,40,-6,-5,22,-9,-21,-22,-81,15,67,82,-17,-35,-30,14,23,-27,-15,13,28,-7,62,-37,14,11,-42,4,-36,-12,2,88,-109,66,-61,-36,27,-35,14,8,23,-29,-13,-29,-45,32,14,36,10,-20,-37,26,-2,-54,-63,26,-36,-13,21,-47,-29,-77,-4,33,45,17,-20,-60,0,15,46,-17,-9,32,-5,-6,21,27,-39,61,-19,-33,31,18,50,19,-29,-12,-6,10,-73,-10,-36,39,-39,-22,-77,45,104,10,8, 
  /* [27][0][][] */ 28,-8,83,5,-28,39,66,-3,11,-10,-4,4,64,127,-37,-85,17,4,-28,-4,5,-14,39,-46,-28,11,79,5,-33,50,-55,-51,31,-31,47,-16,-32,-12,24,-28,49,-23,56,52,-20,-97,48,40,34,20,-50,93,25,34,24,27,-36,26,8,-10,-83,23,3,11,24,-38,-41,40,7,35,14,23,-6,-6,-58,-27,23,-9,-67,64,1,46,30,-13,-57,-33,4,-5,-48,-1,65,-1,-13,85,47,44,-32,-25,19,-24,-6,30,-80,-98,81,14,-38,50,49,20,-15,3,45,32,-9,-16,29,-24,-21,-4,14,106,-33,-3,63,62,59,-3,4,46,-8,32,4,-53,13,65,5,58,11,25,24,34,24,25,3,-50,31,-27,-43,75,-14,-38,22,41,-8,5,10,-19,-2,0,-46,15,37,9,1,-55,-48,-3,-23,79,15,-10,63,-112,35,30,-15,66,26,-31,-47,53,102,-1,54,-2,-25,-9,-60,-34,34,30,-55,-3,1,-80,-30,-43,1,-68,53,48,-18,-14,-13,54,50,-29,-4,-77,-1,22,-29,16,-9,51,1,29,-21,50,35,-30,-50,-49,7,19,3,-11,74,-33,60,23,118,39,49,-34,-28,15,37,-11,-75,-82,-64,-25,-5,-47,-8,-6,-51,15,-15,37,-39,-30,3,-56,-6,-53,-120,-49,4,12,-9,-8,-46,45,-68,34,-45,6,11,78,-2,6,55,7,-29,25,15,-2,38,-38,-20,66,-29,94,60,-29,4,-16,-118,39,-22,-18,17,12,15,-83,65,-20,53,11,28,34,4,-37,34,67,73,-9,12,9,-46,11,-7,73,-8,3,-20,-17,-22,32,70,31,-22,55,-51,-29,-35,49,-19,1,63,33,-32,-12, 
  /* [28][0][][] */ -33,-62,59,31,1,16,46,72,15,-19,-99,8,12,24,-5,5,1,-30,8,-8,46,49,-5,-30,-15,-2,58,-8,28,-58,59,40,1,1,19,-42,46,-18,-9,-27,-29,-19,-7,-37,-37,-8,7,10,-20,-15,13,21,-29,1,-16,34,21,-44,75,6,-14,72,2,19,15,-59,-53,19,12,35,18,57,-42,-4,-8,20,-3,50,21,17,-34,-46,-27,-26,31,-52,-5,16,28,-11,20,20,41,10,-3,11,8,-91,26,-38,50,56,-11,41,-39,45,7,-19,-64,-15,58,17,-16,35,15,22,73,-35,36,-35,4,-12,34,-48,-45,79,69,-22,6,34,-3,-41,-64,-18,41,91,4,-51,-9,-10,-39,-11,-31,-34,-7,8,-27,24,4,16,10,-1,53,68,-19,-48,56,-15,42,-28,-28,-29,-46,-34,50,-22,-44,-57,14,-27,-8,-39,26,-13,-27,-8,44,-2,8,-2,-10,45,-31,31,-26,0,-2,-44,-40,-9,-9,16,28,-30,-20,-13,-7,40,-64,19,-8,-4,-54,-30,-127,-14,-5,-15,-5,46,-59,-32,9,28,-46,-24,-4,30,-17,5,28,11,49,56,14,14,20,6,-2,-32,12,-73,15,-13,-26,-16,110,-8,-35,28,-82,-22,44,-107,2,-16,22,74,10,20,-26,68,-22,-12,-9,4,-36,-17,37,5,41,0,-14,104,-1,33,33,-19,4,27,39,-46,-35,-5,-39,-18,-86,30,-12,-3,71,8,74,-56,-20,-25,-44,-48,16,19,8,-43,39,14,86,-41,14,18,23,-25,-12,-49,-88,19,-7,-22,-21,30,-36,57,-20,-3,-50,-20,-12,-90,-14,19,-28,-98,-65,-14,28,22,39,6,9,11,19,78,-42,-6,2,8,1,-27, 
  /* [29][0][][] */ -18,-13,47,14,19,18,20,-18,-44,-67,-70,-93,25,-26,63,-100,26,15,5,27,7,28,-35,-55,11,8,-90,4,54,8,30,-21,4,-15,-79,8,-1,-99,-33,127,12,-2,-10,-9,2,11,28,-32,78,22,26,73,46,-32,10,-12,-21,-93,-23,-21,40,71,30,9,9,-6,31,-20,-30,21,-12,17,-49,9,-11,0,17,7,-28,0,-27,32,-37,-33,-30,54,53,-66,35,10,15,-48,-10,25,-5,-35,-7,40,-34,60,5,25,-62,40,-29,-8,-64,41,31,8,-43,39,-12,-18,-32,29,-43,52,29,8,-3,6,53,-42,45,6,34,29,9,-39,-55,45,-33,-29,-48,-49,-45,-1,-38,16,-22,-5,23,-34,-55,27,15,34,49,0,-17,-38,-21,18,43,24,-7,20,-36,-44,8,-1,28,-17,15,45,12,13,-17,23,-3,33,-12,-21,-3,19,-73,75,-21,-39,-60,-13,34,58,21,-18,-6,-1,-12,-108,38,-3,-5,-54,87,-37,1,7,-75,-29,30,-42,2,62,-13,-10,17,-17,6,72,-1,-4,27,45,-45,-20,18,-47,37,51,-41,0,-35,-54,-35,35,-37,-2,-24,3,-43,19,14,-14,-5,11,67,28,-24,-23,-60,-102,59,127,-8,15,12,22,-9,48,12,25,4,10,23,81,-54,1,-10,15,20,-57,-12,22,-3,-19,-65,-44,-29,-43,69,-50,-12,12,-19,9,18,9,-7,12,88,32,-32,-18,9,-31,10,-80,92,8,44,-21,-12,-45,-37,-34,3,66,-52,4,-28,53,20,35,-6,-34,8,-25,71,-21,-6,14,21,19,-25,0,-33,-39,58,-10,-1,9,-12,-20,5,23,-9,-56,-24,29,44,48,77,-49,-14,62, 
  /* [30][0][][] */ 35,61,-4,-4,49,-32,11,-20,44,-13,-56,22,9,-9,70,127,-36,-59,13,-24,58,-70,-67,3,28,8,63,51,-49,50,-47,13,40,-45,43,-7,-18,-38,-5,76,33,11,10,-39,8,31,-21,-14,28,-33,-24,5,0,-5,-1,-18,-39,-17,-20,-22,18,-4,16,-29,24,7,-20,-40,32,0,-62,4,13,15,15,-29,-1,-10,77,-23,-40,-8,51,-41,-29,40,34,3,-19,25,-15,-43,5,-106,0,70,23,-118,88,-3,-7,34,-24,-39,-32,97,-22,-11,41,-2,-5,-38,-19,50,54,-1,82,-5,21,-2,-32,60,-113,-68,6,-22,41,-14,-38,8,36,44,22,-10,-4,-26,43,-19,-36,3,-15,-38,-6,48,-4,-32,-24,-7,-50,-26,3,17,-26,-39,22,71,27,-18,-63,-16,-36,-50,-14,50,62,-2,-16,46,-42,3,34,39,46,-15,-21,122,-62,-37,43,-32,-37,-17,0,-19,-16,28,29,-62,76,-67,17,7,41,-22,-21,-9,32,-5,-9,1,5,-19,-1,3,-61,-40,-6,-6,-13,71,-34,41,-7,12,-36,-42,35,-14,14,39,-42,25,23,-38,1,23,-15,12,-59,-91,-28,-60,-5,33,28,4,-63,25,51,6,-2,2,56,46,-46,30,3,-93,-49,45,2,21,-44,100,32,-39,23,37,-51,-35,22,-10,-19,-5,27,49,44,81,9,-6,23,9,55,1,3,13,-21,46,19,39,-50,-27,48,54,23,67,14,-31,-50,0,-67,13,45,-34,-23,14,3,71,-12,-23,-8,14,-36,10,5,-12,-81,44,30,-37,-39,3,30,-43,-26,-16,-35,19,-63,-48,-4,-11,-49,-1,84,21,-82,5,18,-23,47,43,-26,16,-18,5, 
  /* [31][0][][] */ 16,-67,9,48,44,19,39,-58,7,-80,-1,-10,-31,-10,7,-15,47,80,22,97,3,-1,62,-42,22,-50,3,15,80,-32,35,85,-16,-127,16,10,-14,41,49,5,-22,-47,-21,9,42,-2,57,78,-23,72,-34,-15,-5,5,-43,1,-22,-56,-21,18,1,-93,44,58,-2,44,-22,-5,-8,35,49,-25,-5,60,-43,-6,-19,21,-29,17,35,48,8,-51,-1,57,-31,15,30,-7,33,58,8,-23,31,-14,39,22,-47,-79,-11,68,-28,-9,14,-26,-60,37,107,8,15,43,-22,6,41,29,-13,55,-30,-21,-20,87,-10,4,5,18,-1,-30,-27,-14,-8,19,-10,-2,36,25,54,22,-28,1,52,-49,99,44,-1,40,39,-11,-12,-50,65,66,44,48,44,-38,25,-60,-26,7,-5,2,57,-5,43,3,44,10,-11,11,-1,33,-23,10,-23,-48,-43,12,13,71,25,71,48,-21,-3,-24,-1,-12,59,-6,18,-71,-12,-45,-32,18,-8,-62,30,9,-71,37,-3,12,59,-45,-26,-88,-18,19,34,-49,-50,-49,17,-34,-37,6,34,-49,4,-46,-36,-5,-5,34,18,-41,31,-43,57,20,-29,43,36,36,6,-23,66,21,-31,-43,24,33,-26,2,-11,66,49,-15,15,-32,-37,-55,-52,-23,40,-14,-13,15,17,15,-40,17,-54,-30,47,-5,58,1,25,-10,21,-59,36,32,-85,-6,-32,-13,85,18,-25,12,-32,12,9,-21,-61,36,9,45,14,-24,13,37,61,28,33,-41,-11,68,9,-15,-58,4,38,39,-127,33,-16,-3,-2,-15,64,-83,55,-37,-53,7,-10,-47,-35,-51,-49,-7,-13,75,11,-54,-28,-14,-12,-50,-8,76, 
  /* [32][0][][] */ -28,97,20,37,-1,-50,-12,-37,40,-16,-33,113,-4,17,-40,-3,-1,13,-8,-54,26,35,46,-1,10,0,97,76,-70,-71,7,52,3,61,69,-18,35,-9,-55,68,-34,74,-42,27,-29,1,-1,-64,22,20,64,61,-18,18,53,1,-69,-26,-15,38,-27,9,-61,-12,43,-13,-1,127,-3,-6,-64,-33,31,6,2,29,-41,-13,42,-15,-22,-35,-33,-3,2,-53,32,2,-20,-11,-14,9,48,32,6,-38,-23,-86,-36,-5,-39,-48,53,-31,-6,-17,59,-23,101,-46,-78,-51,-4,40,-15,14,50,-25,-85,62,-13,8,10,92,29,-4,-30,-2,-42,34,-3,8,40,2,65,17,-4,-22,-55,61,-2,45,28,63,-6,-3,97,52,-3,-47,-66,-22,-10,37,-41,58,43,-28,42,-3,42,14,26,-7,32,-9,32,31,-31,-15,-19,-68,-22,19,86,-45,-24,52,-51,12,33,46,42,-3,-70,-25,63,-60,59,-32,22,-23,15,-30,56,30,42,15,-62,-19,-83,-26,-1,-15,56,-66,-16,-12,-49,23,-58,62,-24,28,-20,-18,-3,-17,18,-5,-60,-25,-14,-30,-6,-38,36,42,6,57,-34,-71,-51,15,-67,20,44,63,22,-6,-54,-88,-12,70,0,-74,-70,11,-43,-17,-17,49,-16,42,55,-84,38,-11,34,53,52,7,-17,68,-34,-34,30,17,70,8,37,80,9,30,19,-54,-36,-41,96,23,-76,-12,-17,-37,-38,-30,65,-20,-5,-26,74,27,24,28,-76,-41,-27,-21,-14,-15,-119,-10,12,-53,5,-18,2,-3,8,91,6,-48,67,21,27,106,1,36,-34,-2,-36,-31,-39,43,-68,-47,76,-30,-32,69,87,-1,16,-37,45,-51, 
  /* [33][0][][] */ -57,-23,-8,63,-7,54,-37,-59,74,-14,-68,-44,-19,48,1,55,-26,111,54,-16,1,-50,68,102,37,-22,-6,11,108,3,28,-2,72,-29,-51,53,62,-58,-3,-60,-82,81,-42,-37,-2,-86,-54,25,32,-6,-47,-35,28,28,-71,1,-39,79,38,-44,16,-7,-7,-18,-51,-55,74,-27,-71,-20,17,-7,-29,50,20,36,-17,-57,-20,-94,6,0,-44,65,44,24,-12,-99,-27,96,30,-49,37,-38,-8,33,-33,18,-29,-37,-37,16,-64,32,-48,-28,46,-64,45,4,-43,51,-7,0,13,-65,46,-39,-26,-106,-21,25,69,-24,11,-70,29,19,61,11,50,10,6,11,-9,-24,-75,-35,-58,-62,62,28,8,38,-36,-35,24,-33,1,27,-40,39,-51,-28,38,-50,-85,88,-11,38,25,-63,-103,-39,21,13,23,-8,-75,40,87,-68,91,-38,74,-55,34,115,24,68,56,61,-4,-19,-57,25,-56,-66,41,20,81,-16,-6,21,46,1,-15,38,-2,33,-71,127,51,2,-77,-3,-67,-87,-28,-95,-45,-56,39,17,-2,121,14,-10,-30,-24,-20,47,-39,57,-11,41,-12,-18,-82,-47,-22,34,-9,2,12,-33,-43,9,39,52,24,-67,-2,41,39,-37,10,-21,-36,-30,-61,-31,-5,14,60,11,31,20,59,-56,-13,-5,-86,52,43,113,-89,13,-12,124,11,6,-8,33,38,25,56,-10,-20,-16,2,-47,58,-14,-61,90,32,-17,-22,-113,-33,26,-74,41,-43,6,65,-50,14,-52,-12,31,-4,3,-20,-40,-67,-33,7,-31,14,-41,-12,-29,-6,-12,57,31,-77,40,-11,-6,-34,-10,94,-33,-9,-17,-38,12,-51,-8,58,-40,76,43, 
  /* [34][0][][] */ -27,39,-24,-68,-68,-7,3,-80,-127,24,67,35,-5,53,4,27,-17,-35,4,54,-1,8,9,72,-70,19,-32,-47,-33,43,-13,16,-17,-18,-25,20,-31,50,-35,44,2,28,-11,10,38,14,23,43,-59,-49,33,32,47,17,-55,-33,-24,-30,-22,-69,14,44,-52,-25,39,26,-6,-94,-39,-43,36,97,-9,6,32,-26,40,74,-17,31,-53,72,99,-77,36,4,-78,-11,10,-3,-13,29,-30,-111,-44,5,12,-7,-7,11,15,-20,17,79,-19,-49,-68,-9,50,-15,-52,51,-8,9,30,59,32,-12,46,-10,36,71,26,87,124,-28,-36,27,-29,24,49,-30,11,-26,-59,-63,25,16,3,-48,-1,5,-28,-80,-3,-32,-11,-54,-3,36,8,-69,18,-37,-22,-70,-28,38,-20,26,40,33,64,-26,0,46,-11,96,51,-82,-44,50,-51,-28,-54,-2,-22,-25,62,-19,14,-9,63,-54,-39,19,65,-105,45,15,12,55,44,45,1,52,40,50,-72,16,-15,-21,26,-51,17,-57,-50,25,22,-60,-2,-13,18,29,-25,5,16,46,-21,11,102,-37,-18,-31,-7,-32,-3,-31,25,-8,16,63,-14,-10,-119,70,-46,-92,16,8,-5,76,20,-18,-12,-56,-96,56,25,-77,-53,-34,17,-37,62,39,-76,2,-1,-60,-24,-33,-11,-43,-7,-21,3,-31,-59,-31,52,27,-65,33,8,22,8,67,24,-7,103,28,-75,36,6,-20,-15,35,-23,-68,46,52,30,-18,-48,-68,-30,12,-7,31,-22,64,-32,-14,45,-50,30,33,9,20,4,-73,-76,33,35,10,-7,14,-78,20,17,-20,-12,-10,-2,77,50,-13,5,-10,-25,6,16,76,23,-35, 
  /* [35][0][][] */ -76,-62,-56,-7,-9,7,-52,-14,-24,50,-65,38,-19,-28,-58,-67,19,-14,-22,2,-15,35,-2,41,76,53,-57,-41,-127,-74,0,-11,28,-51,-31,40,-67,32,3,-6,-39,-73,-91,-47,-30,20,-11,-2,42,-26,-23,-49,-1,-12,73,66,122,-40,-94,-68,80,-26,9,64,71,-58,22,-14,-6,33,-40,-10,18,3,-12,-2,-29,-70,29,26,42,-26,-10,-12,44,51,-31,6,36,-5,18,-28,29,87,36,30,23,10,82,20,-22,-1,55,38,-60,-2,13,-9,32,3,44,39,10,89,-23,47,-3,56,18,114,-92,-45,8,58,14,-40,-34,-22,0,-45,30,-23,18,4,25,3,-29,8,15,12,-56,106,2,-17,44,-73,24,-40,-14,8,-15,-39,-5,93,2,34,-13,35,-31,-37,-13,12,-8,9,-7,-2,-25,20,32,3,-42,-24,-92,-80,-23,-53,-101,17,-40,-54,-4,25,-5,-15,29,-12,19,-38,70,69,10,-61,-23,-16,-18,36,48,5,13,14,1,32,18,31,7,-26,-9,-3,36,-75,-20,104,5,18,28,33,64,26,6,-51,-4,10,21,94,-50,37,12,61,-7,54,-44,50,-12,15,50,-53,-87,24,-13,27,-81,73,-65,39,26,25,-4,-6,38,11,3,32,-12,-1,-3,11,6,-35,-11,14,3,-19,-51,-2,4,-61,72,6,-2,15,-22,-5,1,14,46,-3,-112,-84,2,-19,55,-9,-28,0,20,73,49,29,30,-8,61,-120,84,-28,89,82,-18,1,80,8,-23,0,-49,-16,25,14,-36,11,-20,-10,50,2,65,33,-42,5,-18,4,-37,28,83,66,-40,-39,-43,33,-41,0,-5,39,3,-12,6,37,61,34, 
  /* [36][0][][] */ 32,-17,9,26,-24,67,28,10,-50,-32,12,11,-23,22,-71,1,15,12,0,-78,106,36,-20,-16,9,76,28,39,38,-5,-4,-37,0,5,-7,-12,29,63,-7,40,7,-112,-51,16,-24,-9,41,13,4,55,103,-3,1,-2,-41,32,-42,30,-17,41,-58,9,-13,-63,-41,-7,41,10,-12,7,-13,-21,11,-56,33,-29,30,77,26,7,-15,-57,23,-39,3,37,-19,-6,0,-34,8,-20,15,-20,12,51,16,58,-7,18,-5,-7,-29,22,29,30,24,25,34,56,30,16,-9,-17,16,-67,36,32,39,7,-23,16,-21,39,-2,-38,-61,14,13,72,-14,-19,-16,-3,49,21,-11,-19,-26,-12,53,11,-40,-90,34,-32,-36,30,10,3,-41,-57,0,52,-51,33,-4,-6,10,-20,-37,18,-20,-52,67,-3,39,17,9,20,11,-1,15,-43,3,28,47,-7,20,26,5,-11,-31,-41,10,-42,-16,-30,0,-23,-1,-68,-6,15,-22,48,-37,-15,-63,59,45,-1,38,-55,21,-20,27,-127,-32,-82,-9,4,-26,49,9,-27,17,-51,-23,39,12,-6,13,17,19,-61,-11,-1,-8,-18,-6,-4,1,13,-10,-24,73,33,28,-1,19,-30,-38,-16,24,24,62,-48,21,-11,0,47,11,-21,17,4,-39,31,4,-16,31,-13,-39,-85,-9,60,-28,34,-38,43,20,40,-53,-4,42,-15,-26,53,21,-57,-84,-37,-7,-2,15,-28,-5,-39,-34,-17,-3,-8,56,-27,60,-12,-19,-16,-23,10,0,-68,-13,5,7,60,24,-24,-31,-36,9,3,25,-4,19,-70,-42,-4,51,61,-4,19,-56,9,4,-5,-23,29,16,26,17,-21,-44,10,2,45, 
  /* [37][0][][] */ 35,-28,41,-34,-37,-53,26,-5,-63,-22,22,-58,78,-78,-19,-82,17,36,26,41,47,-64,-10,50,-15,-10,27,60,-9,18,39,7,-40,-4,-13,36,-89,-23,37,-19,-45,-23,34,7,60,48,4,12,20,31,28,10,85,-2,11,-55,-45,-50,46,-62,8,-26,-2,3,-8,-9,-69,15,49,-72,-61,8,-25,28,-44,-13,-13,-48,6,0,-25,16,-13,-79,36,47,16,63,-30,26,-7,-32,-9,84,18,-72,25,-35,-22,-5,-21,23,29,-41,15,-12,-66,-21,-17,0,6,26,7,-45,-39,67,-23,3,-47,8,-29,-49,24,10,13,5,40,10,-57,17,-23,-10,16,9,2,-31,-34,-4,-18,-28,-4,-44,-77,8,-45,-34,-48,10,11,-10,-8,92,4,-2,5,-25,-33,-20,-53,22,-70,-8,-19,-4,-59,-18,10,-26,47,21,-39,5,57,-19,37,29,-10,58,3,-29,-42,-7,19,10,9,41,53,-40,7,-11,16,-72,-9,13,40,-10,2,57,-18,-1,49,-28,13,-52,8,-19,-4,43,-8,1,-39,-92,22,-6,-61,2,-47,80,3,56,47,22,-12,8,-13,-35,-75,-5,-40,7,17,5,7,-1,-33,-36,72,-11,40,26,28,24,-18,115,47,-5,4,-29,11,73,-36,52,-12,46,-31,-63,-37,-13,-19,48,-11,7,22,-16,-27,-8,-5,44,-15,-28,-39,-7,17,0,10,65,7,11,1,-1,-58,14,-31,15,44,-29,-25,4,-65,43,27,52,11,-79,72,-19,51,0,37,-50,-76,-67,6,-76,-61,35,30,-15,-99,-80,127,22,10,20,47,-80,9,2,-74,-58,70,50,-64,36,21,-40,-14,-40,16,-14,-40,-17,52,26,79,-24, 
  /* [38][0][][] */ -24,31,29,49,-37,51,40,-19,66,-10,-11,105,-3,-1,-7,15,-7,50,-9,41,-32,-20,8,-8,-26,5,84,-23,84,-18,15,9,67,-44,-20,-10,-50,3,-4,-38,-10,-59,-13,-39,-50,37,-89,-10,-68,20,-35,-72,3,40,71,-15,36,-119,2,5,-31,3,0,-28,69,-20,-35,15,23,2,15,-2,-18,-11,-18,-30,6,74,-35,-19,-42,-8,-46,-50,-56,-7,-24,95,35,6,-65,35,32,-51,66,53,-37,26,41,-22,31,52,-31,-45,-36,-126,-52,-37,-56,-13,-26,-8,-46,-95,-30,16,41,14,71,36,71,22,-17,60,-33,-20,-62,38,-35,45,36,35,7,-62,27,-27,-35,-9,-20,48,54,18,21,-64,10,7,-41,14,5,75,-45,62,-4,-12,-51,-42,-17,24,6,-44,4,-32,19,30,85,25,-19,-14,-50,-17,-26,28,-3,-123,-27,-65,-26,-14,-46,-32,-1,-36,-90,-75,9,-39,-74,11,20,-3,-26,-4,20,-64,24,29,34,21,-11,-41,10,11,-17,51,6,8,-20,-24,45,54,-50,-60,-23,-41,-12,90,10,-14,-11,26,20,5,-1,-66,41,-42,54,35,-39,-15,-25,11,-31,33,-9,18,12,-34,-19,32,15,-60,69,22,-9,8,0,-74,54,-35,77,10,0,-70,2,20,35,41,78,86,-45,26,45,-21,15,-38,-22,47,13,-36,-13,97,-25,47,6,-48,51,-53,-7,21,27,4,-71,40,8,24,68,-30,18,62,-93,-66,-72,-117,-30,-11,-127,12,-61,-52,17,85,46,-67,-71,-99,-55,-13,-10,1,6,58,-71,40,-5,14,8,3,9,-19,45,-20,-54,30,21,21,0,-38,37,72,43,-32,-27,-68,13,28, 
  /* [39][0][][] */ -14,-77,-38,31,-79,38,106,-127,25,-69,-21,-46,41,-26,-78,121,-7,-25,32,-24,-72,26,-17,-6,13,26,71,-11,-107,65,20,-2,1,-52,42,17,-21,67,19,37,-79,37,22,-64,-50,42,13,8,-59,2,-34,53,-39,74,-43,22,36,-64,35,74,12,62,-11,-27,-61,15,18,77,-16,65,-58,-2,49,23,-49,24,-10,-71,-88,-71,-15,28,-11,-50,58,2,-32,-103,-90,-6,-45,-3,-89,28,-5,-24,-46,-8,-43,91,93,1,16,-3,57,-107,-38,-37,5,105,60,16,-26,40,-11,13,-30,-49,10,-10,36,6,-26,-10,-3,-17,-50,9,-54,-66,57,-8,88,-16,-124,-12,-50,3,62,11,69,-80,-104,-33,22,111,40,86,30,-15,23,-23,97,-36,101,-15,27,40,-29,2,-16,-49,-2,56,49,-51,34,-28,31,49,28,67,77,-71,-36,-8,41,3,-7,19,-84,1,64,92,38,-85,25,-38,29,61,-72,-22,-93,-43,34,-2,-77,-52,9,9,24,-24,28,46,-11,-59,-15,22,12,-39,-53,18,15,-56,-85,15,29,0,-28,37,-72,-32,-15,16,-8,75,-50,67,-10,12,25,-34,61,-20,37,18,-36,-78,-42,-66,45,61,-52,-37,-41,5,-19,9,13,-13,-82,-78,-3,-41,-63,39,-35,8,-12,-18,19,24,9,-67,105,-62,41,33,-18,50,-17,-52,-2,-12,84,43,-34,-70,7,-70,13,27,-9,56,36,-75,45,36,-6,23,62,41,17,-60,-12,9,7,18,-61,-52,-4,-11,-4,4,-19,-41,-21,-17,-32,-77,60,-44,-46,-11,51,-4,46,22,62,-27,-71,24,-36,46,78,-39,6,75,16,-23,-55,43,-24,34,-3,-31, 
  /* [40][0][][] */ -19,-85,37,-49,-39,43,36,-79,43,13,54,-36,-3,-26,-4,-22,-9,8,9,46,-3,-8,-74,-36,-22,-1,-11,-90,46,30,-5,-1,-11,22,18,-39,82,-17,-19,-61,-127,9,-9,66,10,-5,3,30,24,0,-36,20,79,-9,-29,49,-25,50,-84,4,31,67,49,-52,41,18,-18,-58,4,48,30,24,49,51,14,-41,21,0,-39,39,7,4,-4,9,-14,51,0,-51,-24,-10,-62,27,0,12,-16,-14,-59,-50,2,-56,-32,-21,-40,-39,-12,52,21,-29,32,42,-34,-19,-8,-8,-55,23,-34,-42,0,-10,113,-33,83,53,68,-12,-93,19,-11,-73,-9,13,25,-10,19,11,7,-35,-14,-40,1,-48,-38,-5,-66,-60,-25,27,19,-32,-9,27,-77,8,12,27,33,20,-11,-11,86,-38,31,28,84,1,-84,-38,-31,16,-16,3,18,28,-45,6,9,-57,-8,41,10,15,-27,-11,-10,-7,0,-55,-52,-16,11,-64,17,-15,-47,6,7,-6,-9,-16,71,-16,-34,-1,52,-17,-26,6,25,37,13,3,-52,-10,-24,-39,27,-23,-3,-1,-62,78,-60,-16,-11,-40,10,-56,-40,57,30,-17,56,18,8,38,-7,-38,23,-38,-106,-35,-22,-41,32,11,19,-7,14,-4,24,32,6,-25,11,-41,-31,95,30,-34,-24,34,-70,-36,11,57,23,1,28,-14,13,-3,-46,41,38,48,-8,-42,9,41,66,6,34,26,4,-32,-24,-2,2,0,51,-1,79,-11,-54,38,38,27,-71,-48,36,-35,-57,-57,57,25,-51,-23,-53,-2,0,-37,50,18,-75,-15,-71,27,28,35,14,-34,6,-18,23,-26,-18,16,-1,-49,-3,23,-60,7,10,33, 
  /* [41][0][][] */ 17,9,-4,36,37,33,24,-33,37,8,-43,-26,-48,-1,-54,15,-5,-20,-12,-26,15,35,0,26,-66,-19,-10,-7,70,-85,-36,61,22,-9,-26,-35,25,-23,-2,-86,54,0,-2,-17,12,-29,-18,45,-58,9,-90,-36,116,-15,-10,25,106,-55,27,-52,31,-75,-39,-23,-33,13,-24,-55,-6,-19,44,12,-13,-32,26,-38,-21,-14,-4,3,23,-38,39,-15,44,-30,29,46,45,11,-34,19,23,94,21,56,24,-60,61,42,24,33,-1,47,33,-10,76,42,49,-26,-21,23,7,73,-11,-7,-32,-46,-16,99,88,-76,34,-8,-45,-48,34,16,-78,-6,-25,-11,24,4,77,8,-27,-5,27,76,33,-40,4,11,-3,-43,-78,-26,-68,-43,-5,-3,-6,-22,10,19,53,44,58,34,-84,-9,-10,22,-43,26,14,-2,127,-3,-18,-13,28,-61,68,-11,-26,37,50,-5,7,-9,-32,37,14,26,10,-22,40,-27,-11,34,-12,2,34,19,-4,80,27,2,8,-74,47,-15,87,-43,-23,-13,38,84,-4,-61,69,26,-63,-22,-10,13,27,-50,0,9,5,26,27,25,-44,-5,-40,4,-28,-31,29,-92,49,-23,5,33,29,-10,-99,-58,7,11,-24,15,33,5,-97,-17,-34,8,42,-6,7,-27,11,-47,14,-54,-13,15,-73,-54,35,26,-2,-41,32,37,9,-25,47,-12,-51,44,-6,1,16,52,81,12,-93,-19,-62,-80,-79,26,40,-27,12,68,-86,-30,25,19,24,78,-30,-23,-4,20,-38,44,-67,-33,-15,17,-27,-6,12,-71,-15,98,-20,2,5,7,23,26,-17,29,-26,48,20,32,-5,19,-19,-47,18,-45,-26,79,-2,29, 
  /* [42][0][][] */ -64,-19,65,-6,26,-47,52,-8,-58,-49,65,105,7,-105,-16,24,-3,13,6,38,13,31,22,27,10,-38,-9,-55,22,-9,32,73,-19,1,-16,-42,-42,4,-55,-85,28,15,-41,19,30,-24,27,-81,-23,10,67,15,4,32,39,-10,62,21,-74,12,-28,18,13,9,-1,33,34,-18,-8,41,-2,72,-6,-31,1,4,36,-92,18,46,35,28,19,-12,26,-30,-71,43,-33,-52,-1,-52,5,29,-72,38,3,-21,-55,-111,-10,13,-32,-2,14,38,94,33,-7,0,-108,-5,5,-22,81,8,-51,-1,46,-14,-14,-14,-55,59,64,-12,31,9,-64,33,-33,81,0,-2,-95,39,-27,0,9,-8,20,32,-11,-20,6,1,10,-48,-20,-26,14,6,-13,-2,1,-2,8,39,-52,-2,-47,9,-55,-27,15,-7,-60,-15,-18,67,-32,-13,4,45,-2,-8,-17,0,31,-17,32,30,10,-87,-61,-13,-31,-54,75,47,-47,44,19,22,-15,41,7,-54,-21,-14,97,-8,42,51,17,48,0,1,-59,-1,-33,-63,-18,-33,-5,-3,51,-12,-45,111,-24,-26,-1,-91,38,-3,-45,15,-62,-19,-75,-51,-23,-30,-63,5,37,22,-4,10,17,-4,-12,12,23,29,20,53,77,42,-30,12,-50,74,-3,-10,-10,92,-60,-28,37,20,-5,-27,44,33,7,7,-14,35,-12,-11,43,-127,-55,3,-13,-28,-15,-48,-98,37,11,13,7,-59,66,-6,-4,-55,-75,15,29,39,-36,4,38,31,-43,-53,1,-51,84,17,-18,-65,22,21,-55,21,27,6,34,-42,-37,72,-54,-53,37,15,10,-11,-60,-20,18,59,-29,7,-10,91,2,30,40,-32,26,18, 
  /* [43][0][][] */ 39,37,6,-51,55,7,-1,0,-42,24,-62,-54,71,41,20,21,66,33,-37,-59,27,97,51,54,-53,1,11,-26,-12,14,-14,42,-53,-39,-63,-32,41,6,-32,-20,-67,1,-64,64,-49,8,-80,1,52,-34,-11,-75,3,-25,17,-51,90,7,-8,73,1,67,-9,-19,71,25,-6,-48,-43,23,-73,14,71,20,-85,-28,19,21,-17,87,-9,40,29,28,-29,5,83,-23,-15,7,-30,14,-57,3,-54,24,-120,33,8,50,-21,69,-77,36,65,-81,51,6,-10,-2,-18,4,-54,-50,-44,78,31,-13,-58,-114,60,31,54,-72,-77,60,75,20,-59,5,81,2,4,30,-14,-108,-15,-55,-13,-18,-17,-15,-16,-28,-15,-44,-18,23,43,-104,-6,8,-63,20,-80,-39,-47,-18,-1,12,46,13,44,38,-11,-32,-53,-49,84,6,25,8,46,-109,-35,-44,69,42,-66,-8,-68,-5,40,73,-7,19,5,19,111,24,-78,37,14,-44,-6,31,-59,-42,-3,12,15,-52,54,8,66,105,52,-18,36,-5,4,3,-13,7,53,18,-112,-15,-95,-8,-30,9,28,7,44,14,-29,-3,18,-44,1,-25,-38,-56,19,31,6,-23,10,10,-50,-4,8,28,-5,14,-96,-40,-9,3,-82,0,-7,32,53,-78,41,-36,-24,-1,-9,-19,22,-13,-35,-4,-34,-10,5,-47,11,-14,-15,-8,18,-25,-113,31,-7,26,42,64,20,-51,-14,74,58,67,4,-101,7,-12,-17,29,49,28,-40,28,62,-9,-13,-45,15,15,-19,94,-45,-65,127,54,17,-15,-11,-18,32,-14,62,-25,-43,-28,8,-23,34,-56,71,-21,29,48,-24,-2,3,70,-44,-24,-20,44, 
  /* [44][0][][] */ -39,-45,-34,-1,50,-47,34,-14,-12,41,43,-21,67,79,-58,75,-5,-23,1,17,28,43,47,32,-48,29,51,0,-102,-65,-23,-71,-32,104,31,17,39,-51,35,-43,21,19,18,-15,-12,-36,-2,5,15,-22,22,-24,-22,-41,-70,72,79,20,-3,-42,34,-36,24,11,-26,-12,-41,33,-32,-81,-6,-14,-27,59,-19,-3,-72,-26,22,-9,20,-10,-75,-19,4,12,-44,31,61,-6,-10,-4,-50,83,4,-11,-58,-33,21,95,-23,-14,18,25,-58,103,-93,-58,-62,-42,-34,7,16,-5,-31,0,-69,10,26,-93,71,-6,-24,30,76,-25,51,58,16,22,-45,-41,-65,30,16,68,37,5,0,66,9,3,31,47,-43,-9,-30,-41,-57,-126,9,-7,-2,-38,65,11,-26,49,-15,4,-41,-18,7,-65,50,-40,-17,0,-25,-20,27,77,14,-56,56,2,-33,-43,-14,16,-48,104,39,53,44,-34,-3,-37,-2,14,5,-66,7,45,19,-4,-71,0,81,-61,-41,46,55,-56,-33,-3,-32,19,14,16,-23,24,34,29,-48,-82,-2,-35,-61,-23,-3,-39,12,-10,-45,-14,14,-11,-9,-8,-8,16,39,-58,4,38,21,-68,48,16,35,60,16,61,-3,14,-69,-26,28,-67,-4,-29,53,7,30,45,-70,76,0,-79,-5,-7,58,34,-34,-6,-89,-8,110,4,26,36,37,117,-4,41,-12,-48,-6,-13,-18,2,-23,24,36,-88,10,-1,-118,67,10,-64,66,31,-22,8,-53,74,59,-42,24,-44,71,-25,-59,29,-11,24,-7,-63,-17,-68,-45,-92,-3,52,80,16,28,-54,66,14,-7,-20,-127,27,-62,31,-36,41,63,89,-21,-97,12,-21, 
  /* [45][0][][] */ 33,72,14,28,-4,-5,-11,15,-63,41,71,-31,-53,-51,-39,-32,-30,-31,-22,-5,-31,39,79,-27,37,17,51,-16,0,56,49,21,-12,1,32,-23,-33,-57,-50,24,-50,-8,37,28,11,-62,-65,-22,-36,26,-3,28,6,-33,68,-16,-1,-45,-28,37,-12,33,-11,63,-8,-23,-31,-24,-28,-9,58,-4,7,15,-17,38,10,49,-18,-40,-22,-27,14,-64,52,41,-71,-31,17,-10,12,16,-8,95,29,-8,-33,48,-21,28,-17,-35,4,-40,-26,31,30,-102,-82,-37,49,9,-22,80,-1,0,23,2,6,39,87,12,-7,-22,-57,62,-36,41,15,-25,-8,22,14,43,-28,10,34,12,15,-24,47,54,-22,-25,43,25,-11,38,-8,-1,63,-7,9,-38,26,27,71,23,-74,42,-18,-3,-5,53,26,-19,11,-9,-1,-66,-12,-1,-39,-6,-28,82,26,127,6,-18,47,-76,22,-8,87,-9,-9,29,-71,15,1,-35,-21,8,8,21,-45,-10,4,50,-43,-47,2,21,-30,27,-3,-42,14,-48,-12,54,-37,-2,71,0,9,41,14,-36,42,7,-6,10,15,-30,-14,-21,-35,-12,42,-12,-60,73,-9,43,-4,-10,125,17,21,-28,60,-19,-42,-8,-12,18,-1,-16,53,0,20,17,11,-51,-14,54,-23,46,-20,-12,26,64,26,-54,-13,-32,5,23,-7,-30,-66,-83,33,-29,-5,1,-6,-27,-26,17,-12,21,29,-41,96,-29,-22,-52,4,-44,22,15,-68,44,35,-63,59,2,63,0,-16,28,1,18,-26,-40,27,-48,1,-58,-5,-3,-58,66,24,18,-62,13,57,3,37,-27,-37,35,7,-18,70,3,-47,-9,46,8,-77,53, 
  /* [46][0][][] */ -5,23,13,30,-56,-20,10,-61,-50,38,45,-25,15,-49,-1,11,-67,-40,-6,33,27,49,46,8,-9,-18,39,-52,-16,-37,-13,19,75,-42,8,-31,-36,-2,-44,-36,-63,1,-32,-46,-21,24,-13,-45,-3,-30,-31,17,21,-25,-47,17,-80,46,-61,9,20,33,5,16,25,37,26,-27,-101,50,-24,-73,28,-5,-85,44,1,-18,-14,54,-7,52,5,19,-60,11,50,-39,63,-23,-95,-20,10,8,-8,104,-17,-26,-31,26,51,-5,25,27,-1,-40,-27,94,59,-56,75,-26,-47,-36,16,-2,-5,-22,-30,-4,-23,47,32,38,18,-38,3,-44,-7,0,-11,-20,2,6,38,-3,22,-91,-36,-48,-12,41,-7,33,-8,-20,-38,24,-50,87,-2,-8,23,34,-91,-9,12,19,-61,-2,-6,-13,-6,-8,40,21,-26,31,11,3,20,-47,60,66,17,-37,-29,21,-19,17,-10,-64,12,50,32,-38,10,-32,-83,39,0,-84,-45,-26,15,-18,-25,-79,-41,-10,26,33,19,46,8,-63,22,-61,29,-20,-26,29,60,15,24,127,-41,1,15,61,-29,-13,-3,124,67,-41,-13,-54,44,-32,-69,-36,65,-16,-77,65,-9,-25,-33,-53,-28,89,48,120,-28,58,-18,-67,-100,51,29,-71,5,51,-59,17,22,53,-62,10,-30,3,-32,37,-42,45,15,4,64,15,-31,-19,57,-76,0,17,28,-51,-46,22,25,-25,36,16,52,-44,32,41,-46,50,28,47,-55,-20,65,-41,-96,1,-68,-36,-9,88,-41,62,-36,-4,59,49,-1,22,15,-88,43,26,-68,-60,46,15,23,42,-18,-4,50,66,-3,-10,-22,-1,-72,117,14,-35,-3,46,-12,-58, 
  /* [47][0][][] */ 10,-37,-20,-47,-1,-36,31,-28,-54,-77,-52,86,-8,11,-1,-39,-12,27,51,-49,-50,60,-42,62,107,-8,43,14,45,17,15,9,46,-69,-14,26,20,-37,-102,30,82,-79,-5,-78,-41,55,62,-38,-74,-21,50,-27,-102,5,-75,-39,-8,4,39,-34,55,45,-11,17,-45,-12,-78,-28,-24,2,-1,-14,20,-97,39,-8,57,6,-5,-41,4,65,-64,-17,-52,61,6,33,-51,24,126,1,-30,41,55,36,-3,-14,26,-5,61,-71,-19,11,-93,42,3,7,61,15,-15,28,15,21,81,31,51,5,55,-6,-5,30,16,-39,77,-14,26,123,-47,0,70,-28,-12,-24,7,-19,-67,24,-19,-73,-33,-78,56,0,18,37,-21,35,38,49,-60,39,18,-45,-22,43,7,-19,-7,40,22,-45,32,-32,-58,-5,-16,-17,7,65,46,-64,50,55,-2,46,-65,-17,3,-108,-51,-39,-26,11,5,47,11,-41,-55,50,63,-32,38,-35,-25,-32,-45,-34,-18,-19,-27,-46,61,-51,41,2,-87,-10,62,-9,-20,0,38,-93,-41,-44,-10,-37,19,-8,-15,-30,-50,13,24,-61,-27,-1,21,-26,-19,43,-9,33,-11,-40,-34,-42,-12,4,26,-127,-27,3,10,18,0,-60,82,-70,-13,23,81,-49,34,-81,-32,-26,-92,-37,-28,-14,8,91,-6,22,9,-23,39,-31,0,-20,20,2,-24,57,-72,-30,-28,8,41,2,-23,-26,4,16,-6,99,31,-13,4,-9,-55,-16,-62,-76,-4,-37,-60,3,28,13,-74,-18,-29,26,23,21,10,-22,28,-45,-23,-91,27,-15,-9,10,-12,4,15,3,23,3,-26,-63,-41,-15,11,55,16,22,-44,15,56,36, 
  /* [48][0][][] */ -44,71,14,1,11,-39,-46,-22,45,57,-97,-25,-53,38,-72,114,-32,27,-19,-10,-8,-35,-23,9,20,47,48,2,-83,8,15,-12,4,-92,-49,-66,-27,24,7,-70,93,15,-56,40,29,26,-42,-22,-17,-33,12,43,-32,-24,-117,20,-13,-11,-45,65,-26,-43,-40,31,9,41,-49,-37,19,-37,19,-18,24,-40,-48,-65,-46,93,14,-63,-22,36,63,-2,-16,32,-60,58,-38,1,-26,-33,-28,53,6,-73,24,-4,23,74,61,73,-54,48,-3,-119,55,58,-32,-67,-42,39,13,-1,-71,9,-39,-32,-14,95,24,0,19,-21,34,-36,-79,72,33,-127,-26,23,119,-23,43,30,-104,-10,36,-32,11,2,100,-11,-14,70,-67,33,-79,31,25,46,-1,19,-49,9,-33,-5,-33,-22,68,12,-47,64,2,44,-33,-16,7,63,54,-29,3,55,62,-61,99,1,23,-3,-24,33,-9,2,30,75,59,69,-48,-24,-27,-2,-26,-39,-3,41,-23,50,-27,22,-37,-25,-2,7,30,-23,40,34,17,77,-26,61,6,70,-16,-53,14,33,3,-6,1,-8,11,29,-53,-37,-87,45,71,6,29,-6,49,-27,43,79,-15,2,62,-20,-72,67,27,-36,-21,26,-5,31,-66,-83,14,63,-43,-61,15,38,-68,58,5,100,20,-77,-6,-87,29,2,-8,13,-121,-38,9,-76,18,-54,-33,9,-71,79,-28,-59,-25,5,34,-80,-20,63,80,-121,-13,-32,-104,49,-31,57,-39,67,-65,66,-24,27,-6,-22,49,0,-13,-23,76,-31,-32,44,-42,26,13,-11,28,-53,62,-56,-97,-58,25,-28,28,-16,-20,-81,-9,12,6,-15,-37,15,19,19,0,84, 
  /* [49][0][][] */ -5,5,1,12,29,23,30,1,13,50,59,-67,-58,61,70,-3,-46,-39,17,-31,73,-11,-17,9,-5,76,41,-2,-62,54,-42,-79,-32,-9,42,62,0,4,-111,0,92,47,0,-19,-12,-48,-42,39,2,-9,-39,-18,-11,-1,-25,-11,59,127,-19,-58,18,10,-75,7,15,4,-26,-2,1,-14,0,59,-3,2,-37,24,-18,-13,18,-44,78,-69,-12,35,-52,-22,43,-92,-82,6,-20,17,43,-40,90,-30,-32,19,21,-61,11,-37,25,41,11,41,2,0,-33,-102,45,82,48,26,-49,12,32,-6,-6,33,49,15,42,-20,62,1,-2,30,-7,-23,7,21,-9,33,7,-3,-53,44,88,3,-14,-22,9,-67,-7,42,-37,-95,-8,-26,24,-5,12,22,-44,-123,-17,-1,15,21,-14,58,60,-51,-70,-43,37,-94,48,-4,-55,24,14,32,-58,-60,66,53,-68,-22,-108,-48,0,-70,-5,-13,2,-20,54,-10,22,-12,-27,-92,40,-12,42,36,0,27,21,0,43,62,-70,-18,-62,-16,6,60,-11,28,13,13,45,26,-3,-5,27,-46,-14,72,-28,38,-44,-45,-23,-5,-31,-1,66,45,21,9,31,57,66,-37,-15,-14,-6,-36,9,-92,-16,41,-21,-4,4,50,97,-11,26,2,29,-81,-59,-45,-14,87,16,21,39,32,48,-85,119,94,13,25,56,46,-7,-96,22,-54,-43,54,2,-9,55,24,47,50,72,-73,31,-6,-10,33,31,-42,11,-36,-65,22,-26,-57,-5,-26,3,-21,96,-14,-10,-53,17,58,-24,53,26,-37,-23,2,32,56,13,-2,51,-44,-83,16,-35,11,32,25,-70,-5,-27,-26,32,27,-25,-85,61,-6, 
  /* [50][0][][] */ 35,18,17,-83,3,34,55,27,39,54,39,-65,-19,17,8,45,-38,-23,-39,-38,7,-3,31,-42,22,17,57,3,-33,-2,-12,-20,34,26,61,39,6,-6,19,-32,75,8,26,-9,24,25,7,-21,-89,55,12,43,19,19,-32,29,10,8,-28,-26,14,-7,-19,27,76,-2,20,-22,-23,58,-32,-48,10,-22,-15,60,-61,47,-23,39,71,2,-127,16,24,-21,36,-38,-6,-76,-22,-45,13,18,-3,-30,-43,-5,-25,-33,16,-20,25,1,29,-52,-85,-17,44,19,-3,81,-5,77,-40,34,-39,-43,10,-56,15,63,12,11,-116,12,49,42,16,-4,59,72,-22,29,-12,-21,-43,6,-37,-32,-47,92,35,-52,-48,63,16,39,55,-32,17,24,4,19,-41,60,-31,33,54,-54,33,47,-49,41,10,-16,-36,8,21,58,51,25,-56,-71,0,-6,-56,40,-55,79,-9,12,-58,-54,-20,-51,22,-14,-51,-1,-6,-14,25,-59,-41,38,-40,20,-46,10,61,-19,50,-6,4,26,-7,46,71,-24,-11,3,-54,34,24,-17,38,-7,-28,69,-26,-17,25,-35,39,34,-31,39,48,11,19,8,-10,-79,33,31,-28,1,46,53,77,-24,-4,-43,-16,24,41,52,69,-49,-45,-61,37,46,3,59,18,-10,62,6,61,-12,-26,-8,-59,-25,-57,8,24,-45,2,-7,88,-3,65,30,-112,74,-44,28,-8,-20,-85,12,10,27,-12,-11,10,-39,-24,-17,-17,-13,21,-49,92,40,-13,-39,-23,18,-13,-36,-72,9,22,65,-7,-26,23,20,-11,44,-70,63,-31,-34,-52,16,3,-19,-20,1,-17,-22,14,68,-46,11,-23,-69,13,-27,17,-27, 
  /* [51][0][][] */ 49,-35,22,3,-69,32,10,20,-79,24,24,44,-57,7,-3,118,29,31,26,-18,-23,0,-18,11,76,-49,-53,-20,-14,-9,-10,-15,10,3,-18,48,9,-26,98,67,37,64,-73,-57,48,20,-64,-35,127,39,-2,6,-26,-9,-14,-90,-36,-39,16,-25,-68,43,18,1,-2,4,-25,4,-75,-55,18,2,5,38,-32,18,55,-40,-49,-5,-15,-4,-83,-25,-34,-59,1,-81,16,-40,-29,1,-5,0,-19,7,27,67,-70,-8,59,-64,7,3,30,77,110,-28,13,51,-19,-41,-28,-35,-17,68,-2,-17,-14,50,-19,-79,3,43,51,-30,29,-28,-15,44,-15,2,18,-28,-63,5,28,94,62,-9,-49,19,5,84,27,13,-11,-3,1,42,1,29,33,32,36,6,-14,26,38,-58,-17,-53,69,-10,85,31,13,-6,-43,-57,-60,9,65,54,49,62,-35,126,-32,26,45,47,-54,-60,59,-43,3,23,63,-29,4,-20,-37,43,-58,6,38,-36,24,-1,26,35,18,42,55,-24,-55,36,69,1,-36,-8,16,-29,-21,-54,-20,48,10,7,39,-7,15,-21,-3,-22,11,-13,23,-28,53,37,80,2,65,-33,-23,-28,-86,2,-90,69,-23,33,28,71,-67,-45,97,54,67,-20,-8,45,52,-17,-12,-25,71,82,10,15,-19,-24,-11,36,-18,-31,59,-51,7,-4,19,43,41,53,-56,-18,-41,85,18,2,59,-6,-16,13,-28,56,25,-36,-10,-17,-11,-3,-98,-15,52,82,-15,78,-35,-11,-49,8,-17,-77,4,-22,-14,11,-47,5,-29,72,-119,-20,6,-13,-69,-88,-50,26,-16,12,58,-41,-4,4,83,54,-8,23,-31,65,-38,17, 
  /* [52][0][][] */ -14,-40,19,-25,0,-59,-13,1,-5,74,-8,27,35,2,-16,34,27,-13,8,-10,23,13,-23,41,-13,83,27,-8,42,30,-23,-15,-1,-39,62,4,-22,-15,-14,-2,12,-3,-27,-55,10,-13,-26,-52,-4,-7,-83,9,66,-21,15,27,15,-24,-21,-24,36,50,10,73,-37,-9,-41,54,19,-32,29,0,-45,70,-39,45,15,-7,-22,-9,11,-29,-35,20,-3,-70,-13,-42,-1,18,-33,-38,-7,12,30,-40,-39,32,5,-31,-32,-11,13,35,-31,40,-16,41,18,-8,33,-41,-1,8,-61,-9,-32,18,1,-127,-29,82,23,30,78,34,18,-35,-15,-43,-17,-10,-44,59,-39,-8,-16,109,32,13,62,-10,12,13,19,25,44,5,-39,-40,16,19,-91,-18,46,-27,-28,-47,-1,-19,29,-38,33,-25,20,-9,8,-44,8,-59,-4,0,24,14,-24,-25,7,-8,51,44,79,33,5,-40,-14,34,-4,31,-73,-15,6,-2,-5,-33,-41,-22,-10,-21,-10,60,13,-23,-45,-41,3,49,71,-6,19,-6,-33,12,26,-4,-32,36,28,-34,15,45,48,-8,-35,-20,0,-21,-46,33,33,23,27,-45,-2,-48,-61,12,-4,44,-4,-33,-16,50,11,-44,23,-14,2,51,8,36,3,6,52,33,21,-28,-18,-8,-44,-21,19,-11,-50,27,-24,9,48,-26,9,10,-21,-33,-48,40,17,24,2,82,24,-18,-81,-71,-41,47,41,46,8,12,71,4,-18,-29,10,41,-12,62,-35,-60,-24,-45,-39,70,-18,2,20,23,26,-33,32,-16,-1,-49,23,30,-11,-19,-55,-17,-18,-50,12,44,13,-8,-24,13,-5,45,95,52,-19,-1,10,40,-17,-55, 
  /* [53][0][][] */ 21,2,28,-4,58,26,-35,-66,0,-55,-5,7,33,-6,26,0,30,-14,3,-30,6,3,50,5,-12,-34,-100,-2,-9,27,-10,-52,48,17,-12,-18,-2,33,7,-36,-11,17,-49,-26,52,-13,-10,24,-40,-11,24,45,11,25,3,30,-12,28,-21,78,-40,-18,-30,-7,-16,-36,-8,-17,24,-52,-47,-33,9,-17,-38,-70,-43,44,-26,-23,14,-17,-5,-13,54,1,-39,-68,-15,-22,-22,3,2,29,-32,-3,-8,-55,20,-23,-2,-12,4,52,-30,-11,-17,25,-60,40,33,-5,3,24,22,-19,-5,-40,-15,64,-32,20,-66,30,-3,-13,-28,47,-22,15,-19,-6,-21,-8,-11,-18,15,4,-11,7,-40,-49,-23,-36,-39,-3,-44,12,40,-22,-37,-3,-26,-18,37,76,23,16,47,-23,28,32,66,-52,18,-34,10,-15,-21,36,2,-12,-127,-2,-37,-1,-17,66,16,39,-10,-34,15,-1,4,4,-36,0,15,56,19,9,9,-26,-26,-56,15,-11,18,9,-18,48,-6,-9,-41,32,3,8,20,-12,7,-33,41,5,-9,-1,2,-2,22,-7,-20,-11,20,-10,-12,-7,0,18,3,-16,18,7,2,-27,21,7,-12,47,-7,-81,-24,-25,10,-38,-23,-28,-1,31,43,25,13,9,-3,-13,46,-67,0,-24,33,-2,-43,-32,3,0,-20,-12,-36,20,49,3,-17,16,-1,-26,1,-11,14,-3,-9,25,76,0,11,-3,33,75,-17,-11,45,-8,-16,-2,9,-53,21,-2,-43,-9,-21,52,5,58,12,-15,-8,15,-6,33,42,39,46,-47,4,-3,9,1,32,-32,-33,-42,31,1,-23,10,-20,-75,41,-55,9,11,5,-20,-16,24,-2,-11, 
  /* [54][0][][] */ 20,-14,28,54,45,44,-30,-4,-39,-19,10,-15,16,20,-34,45,-32,-25,-17,81,-17,24,-7,-98,-3,20,62,-73,3,52,-3,-21,-9,29,30,-44,-47,-16,22,-57,13,51,-13,-39,21,-20,4,-39,-29,5,-35,-64,-2,-17,15,-32,-48,17,-12,8,-23,-54,74,-26,16,-25,-15,-15,-26,-16,30,-38,25,-19,-14,-12,-6,72,-16,28,8,-10,17,-35,-12,-65,-22,-52,-39,11,11,39,25,72,39,2,50,24,18,53,-56,-36,26,40,10,37,-93,-19,40,-24,-41,-35,14,-91,5,32,38,-81,-17,61,-56,-34,-20,2,74,-39,46,12,2,-26,-20,11,42,26,13,20,-3,-33,-11,-59,-16,-61,-16,-73,31,39,-40,-66,-3,34,-30,-15,32,9,-55,0,-30,42,-16,13,-8,8,-29,-57,71,0,-24,-26,-16,37,-44,-54,-68,14,8,10,11,-66,7,-32,29,8,-30,-38,63,-1,-17,27,51,-8,-27,67,23,-15,32,55,-89,-17,74,-2,-5,-51,11,-12,4,14,59,-10,1,-33,-45,-19,30,27,37,-2,-63,-43,-5,38,-21,4,10,24,-41,6,31,14,39,37,-43,-28,73,-39,-27,59,69,-21,69,63,27,7,15,21,10,4,-3,-20,25,-30,-127,-76,23,24,5,8,21,-69,-121,25,8,-8,7,26,-17,49,-2,40,35,29,24,23,11,21,-42,-15,-30,3,-27,-36,-12,-23,11,55,2,-19,13,46,-9,-49,43,-10,-7,54,-16,-23,74,-88,18,71,19,-17,-56,-39,-27,-54,-1,-23,-34,20,-7,-11,10,3,65,15,59,-31,34,10,-48,-30,-60,9,-33,-75,33,22,46,-35,13,-18,22,-13,-19,-49, 
  /* [55][0][][] */ -35,60,91,114,-25,-9,-62,15,-108,35,20,25,1,-24,-71,-54,23,-20,60,36,8,1,61,-36,36,38,-33,52,-31,122,33,-21,30,54,-81,-7,55,-88,-1,-103,69,-27,7,-22,-50,21,-24,-17,19,-33,40,-10,-4,-54,-24,39,33,-66,68,-10,61,2,85,56,21,32,-6,-46,-29,-67,3,-4,-75,32,76,-82,-18,84,-45,124,-20,-112,39,4,-20,-19,52,-85,54,45,8,-72,-37,31,-51,44,-127,-19,-11,-86,-23,-14,10,16,14,-4,0,-23,2,69,-20,-37,74,38,-39,63,22,-36,10,-16,-49,38,-21,-12,51,26,1,-31,37,-18,-9,18,35,17,23,-93,-5,-9,-4,66,-5,34,65,33,-91,-85,-22,-23,29,-29,54,121,32,-45,29,-79,112,9,0,27,-65,31,-114,7,-68,9,-19,14,35,48,28,-41,9,-31,18,8,-46,-57,76,-31,39,-24,4,-10,25,-15,-44,15,73,-65,-40,-60,76,-28,-48,13,-29,-25,78,53,77,28,-11,-25,-22,-19,-27,-36,-59,-30,22,11,-25,74,78,-54,-34,48,13,99,-63,-32,11,-46,18,-13,-21,-37,-93,-40,-108,-14,-16,72,115,17,15,-106,14,-27,42,63,-65,-67,-13,-32,-25,-28,-105,-6,17,-6,7,4,44,7,-68,-17,60,29,-20,68,5,28,-15,93,-5,-62,5,-21,-57,-70,-12,-29,19,44,-31,14,54,-5,-41,-25,-5,23,-25,120,73,30,-5,21,-16,16,-30,-50,-67,-80,-15,82,-22,-23,-120,67,-4,-58,65,-60,98,-29,-19,-22,-56,-10,-48,-17,-28,30,-44,-26,11,-26,-52,-39,-1,-27,53,-109,-57,44,-17,40,3,16,43,-2,66,-2, 
  /* [56][0][][] */ 2,19,-26,-69,84,53,-81,-63,-27,2,53,-24,-61,-26,-54,9,3,40,-30,-24,47,-6,-32,-42,37,-18,68,10,-23,9,-31,-29,28,7,40,-24,24,-5,-41,101,-42,21,18,7,-61,51,25,43,-24,32,62,-39,-39,-13,14,-3,13,70,-2,-49,40,81,-59,-20,-15,7,-10,13,-12,-11,6,81,-3,19,21,-71,9,-24,29,-69,61,4,5,89,33,31,-14,-89,-42,-38,-27,-18,-26,29,8,-9,-49,24,49,14,31,-9,18,-41,2,25,-33,-57,24,-56,71,-47,-12,-69,9,41,-2,-17,-40,-47,3,-37,-45,-62,85,-1,48,-3,-79,12,-99,92,13,-19,55,63,-1,9,-61,79,52,-11,-6,24,14,-10,-16,-17,81,-6,46,-19,83,52,18,51,-60,-20,-42,-20,73,-40,-32,-82,10,-42,-6,40,83,-79,7,9,-23,-31,41,-81,-16,-68,1,58,7,42,2,36,36,-5,-47,-23,-9,-24,3,-45,-8,-40,-3,-40,67,12,-10,-7,-21,61,-28,26,44,43,-46,-51,34,1,0,-2,-7,-16,36,26,52,53,1,62,27,82,3,-52,15,21,19,-16,23,-57,-25,5,17,-68,63,-16,85,-5,-45,-102,-2,-15,52,37,54,17,33,20,44,-55,-39,50,11,18,59,109,22,-23,-11,0,-63,-23,-38,-10,-38,-23,27,7,24,80,-50,57,10,-41,-45,-50,-127,61,63,35,-100,-32,-15,-38,47,19,1,-42,-50,1,38,35,-20,-40,-11,-100,-78,71,-51,4,40,-1,-17,-49,-1,-69,11,-83,-83,-7,0,-56,-51,-8,-23,0,8,48,-43,79,26,-14,45,-47,-35,23,4,-73,52,-42,-27,59,33,78,20,-1, 
  /* [57][0][][] */ -9,31,80,-11,-21,60,-7,50,0,7,0,11,-32,-23,-34,-16,-14,8,5,3,-1,22,-31,29,-7,-4,-56,34,-42,16,-24,41,29,53,-14,15,3,25,30,27,-1,-13,22,4,-29,22,-21,12,-8,-72,-19,32,64,14,-41,37,52,-43,-20,14,39,13,-19,0,-22,22,25,60,-6,54,-33,0,20,19,9,-60,21,-61,15,-10,-84,36,27,-37,-35,21,24,3,-34,36,3,16,-32,21,52,27,8,38,26,60,-9,-33,-4,-1,-77,34,2,-11,15,26,-44,22,-54,5,19,-34,-15,23,21,66,10,19,-57,54,64,53,-17,46,-6,-8,-18,-32,-22,1,2,74,0,33,46,5,14,46,-99,-35,32,-62,58,-8,-1,16,20,61,-21,41,38,-61,-11,-26,12,33,5,-11,22,-32,29,62,-10,28,-35,9,21,59,49,20,21,-4,-12,-41,58,26,-26,-40,42,-17,-40,-16,-9,-12,16,19,42,-2,-15,10,49,-33,40,-2,7,-12,17,7,8,22,36,-11,64,4,-22,-13,13,-22,6,27,43,78,-13,2,-7,7,13,8,26,75,6,18,-2,12,-9,-37,56,18,-79,-64,-19,30,-17,-12,33,-24,-30,20,2,-32,-49,13,22,-16,-5,-46,37,-22,-7,-4,29,-24,19,6,-31,-11,28,-29,29,19,-12,-14,-15,19,71,-25,26,-24,-38,-54,-15,-30,-11,24,23,-3,-27,-10,64,-51,10,13,-82,-40,-22,43,-90,12,-56,1,-45,-45,67,26,-51,-15,-28,-63,57,-47,-26,-12,-51,11,-10,-4,-35,37,7,2,34,127,-18,-17,6,8,104,4,25,2,-25,12,11,21,25,-22,4,0,17,47,6,-39, 
  /* [58][0][][] */ -39,71,35,35,4,-19,-38,-18,-23,-14,-27,75,29,1,12,3,-4,25,6,127,-57,20,-25,26,-52,21,-29,58,-58,19,61,96,-2,-6,-41,40,-22,-4,64,-44,25,-31,-40,8,-18,-10,-52,-15,-40,5,-50,26,-10,3,10,-31,-83,52,-21,24,76,40,-106,19,-21,-20,43,56,-34,20,37,27,-10,62,-35,29,-41,-21,5,26,-22,-5,27,91,74,-8,-9,-35,22,-4,-1,27,46,6,47,42,-56,9,14,55,-28,-7,50,-12,53,31,-1,-11,61,-3,-60,-41,15,40,-7,-19,-5,18,61,-55,14,-15,-41,45,-48,-18,-12,-10,4,-39,-31,-4,-19,-56,-51,-24,-5,-9,-20,-20,-8,45,8,69,-7,-64,43,15,-19,-48,-37,8,19,-84,17,42,-9,58,-54,-29,56,7,31,11,67,14,1,-19,-2,2,-36,0,1,25,-21,17,24,-12,-3,-79,-41,23,17,-80,4,27,-13,39,37,3,35,20,-39,-7,35,-59,-47,-16,10,55,-37,-71,-7,-66,-113,25,-16,-43,-22,24,-2,4,9,15,-3,30,3,-25,15,-6,-66,-50,-5,-7,-82,-16,23,8,10,48,47,0,16,-21,24,38,-25,24,58,2,-31,15,38,-28,-19,-60,-38,3,50,0,-10,10,49,-89,-66,58,48,-24,-17,-10,28,-9,19,-6,-20,3,8,51,24,-18,38,6,28,19,-21,-31,-92,-11,2,-62,23,-15,-14,-51,0,-101,19,25,50,-8,-100,-70,-63,13,19,64,-10,8,-30,-52,7,6,-11,-50,-47,13,12,22,10,32,38,-8,17,33,-43,-12,18,23,46,-40,-48,8,-6,-42,47,-5,-15,-78,78,-38,-15,-33,28,-10,-23,-47, 
  /* [59][0][][] */ 45,13,37,-11,-23,-26,-5,-43,-13,22,29,-28,5,-48,-18,34,32,-7,45,45,14,-43,16,8,65,-9,-24,-38,16,-44,1,-16,15,26,13,41,-10,-54,-67,-19,3,23,-3,-9,2,45,-58,70,-25,-17,13,84,-74,-17,-28,5,-4,-31,42,16,-25,26,-7,1,127,-12,-23,2,-17,54,27,-44,16,20,13,-43,8,-46,41,-21,-13,-62,33,19,42,42,17,-13,46,-54,35,13,11,-35,-20,-1,-11,50,-7,-22,27,-11,6,-4,3,45,68,4,-5,8,-36,1,-20,10,-31,-24,19,-52,1,19,31,6,-62,32,-1,9,-13,-6,32,-31,21,-7,39,47,-15,39,-62,32,31,40,38,-11,-58,-10,14,-36,0,26,-2,60,-27,-4,-55,2,-7,-71,25,22,24,1,-1,22,32,-17,-39,50,28,2,16,20,-8,41,48,-29,8,18,-8,-66,-2,17,-55,-27,6,7,-11,15,62,3,4,-8,-2,23,5,-31,-5,-64,-33,-55,24,-31,42,22,29,-116,21,-26,-6,47,-24,-31,-33,-59,8,47,9,-32,-18,-3,25,55,25,41,-31,23,15,-17,14,15,66,28,2,-11,20,-26,-8,-3,1,-25,2,-42,8,-9,-4,5,-43,11,12,32,35,18,-73,-6,-15,-56,-37,-19,-11,-4,12,8,30,9,-8,50,9,-45,64,-53,31,-55,50,-26,26,44,28,0,11,-5,12,-8,40,22,2,23,-24,12,4,-1,-52,20,32,-10,-13,-17,27,-34,-29,17,48,-23,-18,40,32,20,39,-26,-14,5,26,15,24,17,31,-4,17,14,37,10,-91,48,-1,5,31,-1,27,37,-65,78,-14,52,3,-8,-19,2,-13,39, 
  /* [60][0][][] */ 16,39,-46,91,-2,-36,-12,7,26,-38,-5,-7,-12,-2,28,31,-18,-17,-11,-43,69,20,29,2,-21,40,20,1,-14,4,6,51,-43,45,-8,-4,-29,20,17,-16,-29,-51,12,6,-46,-49,-6,-8,-12,-25,-13,-9,11,-2,-44,6,12,74,-12,37,-26,-38,27,-12,-51,-11,59,-14,-24,3,8,72,59,-48,-36,53,-52,-30,-8,110,-7,-33,15,8,49,-59,54,-100,-38,25,-23,40,56,121,47,-6,23,-41,47,-88,58,-12,46,-53,18,74,-13,32,20,29,-50,1,-3,-13,18,22,0,-6,-17,-10,-10,-71,43,6,70,-2,46,9,-18,-35,-57,7,36,5,-33,-22,-3,34,-17,4,-37,-64,-14,50,-3,9,0,5,-13,-24,-38,68,-40,-39,-54,14,32,12,-16,-10,28,43,12,61,-67,33,-52,-22,-80,24,-10,-7,-5,-7,38,33,-18,102,-28,25,10,71,1,9,17,71,44,22,-27,-23,18,75,4,-127,50,-23,4,72,16,58,3,-22,-98,-53,36,10,42,3,22,-38,60,-74,39,0,17,-124,-2,-39,-100,-13,-7,-60,-21,55,-6,72,10,-16,24,-40,-27,-47,-8,38,-119,-50,-76,-47,-52,2,-6,63,68,-65,-31,105,-11,-45,12,-22,59,-3,-42,-74,-9,34,-29,-76,-61,15,7,-43,14,-1,8,13,-100,5,-8,-72,-14,82,-37,-19,54,15,-25,-45,-12,10,-111,21,48,21,42,-62,-16,-2,12,29,-14,78,18,-27,-33,-48,-60,-1,9,-20,-48,26,85,19,-25,4,-8,44,6,21,-7,23,-24,-6,19,-71,25,36,70,17,-16,10,-36,-44,8,43,-27,-71,-39,77,-56,27,-57,-28,-46,56, 
  /* [61][0][][] */ 59,31,-51,61,-25,-15,7,-73,0,-32,9,-11,15,9,-48,16,77,91,-16,35,40,-43,-8,68,67,92,15,-1,-9,0,-29,-86,61,-39,49,-19,-1,25,18,19,-1,-72,26,0,74,-72,-32,-30,29,57,27,-36,-46,12,-41,48,9,76,53,56,29,-10,-3,9,-24,-70,68,-8,13,-40,55,27,60,-35,-25,57,-1,48,-66,-14,2,5,-50,-2,38,78,-43,-24,-17,-18,-17,-4,-10,-49,-53,-28,-20,-111,4,-6,-2,23,41,-58,14,12,0,-54,-49,12,-127,-14,17,37,12,-21,-63,-8,23,44,42,-37,-43,26,-3,79,-75,88,34,6,36,3,35,-11,-18,-32,-11,60,-15,38,-42,10,36,-73,-26,46,-19,37,-15,-4,24,24,-19,4,27,-38,110,-71,4,-15,-19,43,29,19,-54,-12,-46,-98,17,14,-14,-56,81,47,-19,-48,11,6,-38,-13,-24,12,-19,-32,53,60,54,-24,-37,-68,12,-2,58,40,-31,61,9,-85,-49,-54,68,28,51,-10,48,-79,69,-21,-12,36,89,59,-1,45,-4,-11,-44,-12,-3,-33,-30,-23,-52,-85,-13,88,79,-6,-5,-27,-38,-20,72,-21,-17,26,-7,73,-58,81,2,19,47,-3,-73,30,-25,-64,-39,-10,19,-8,39,-45,46,32,-6,-45,-75,-13,-48,28,21,53,-33,-71,34,92,-31,42,-11,-14,50,48,-25,12,49,-35,-1,13,62,-46,-16,9,-23,-37,26,11,25,-84,42,-37,15,-17,15,12,68,10,4,-27,3,27,-34,17,-65,0,-20,17,-47,61,-49,-83,-16,-18,-43,60,60,-4,14,97,-32,34,8,-38,14,13,62,-50,31,-31,-35,86,57,-83,-41,11, 
  /* [62][0][][] */ -8,-51,-27,-9,19,34,38,27,34,33,63,-35,13,-55,-47,46,-11,-24,-18,-19,-30,3,84,9,-53,19,-50,3,-4,25,-8,25,6,-2,-48,-21,-39,-11,-21,2,54,-31,39,-80,-55,-75,-93,-34,4,24,-68,-55,-86,-44,-16,31,-106,-11,0,30,20,120,-27,-19,41,-16,-60,-4,-33,22,34,57,36,-34,-15,-33,-12,-49,-51,-47,3,12,-34,-51,67,-46,30,-98,55,-1,-22,6,26,3,-31,-56,14,62,36,52,10,-29,-30,18,-10,27,78,-20,54,15,28,-43,12,-1,29,3,16,-20,14,-17,19,66,53,12,-51,11,-2,66,3,81,-100,-48,-25,3,20,-14,17,-48,-62,-70,-55,43,-16,91,-16,-94,-13,-43,-1,52,53,-9,20,-8,71,-63,12,-17,8,44,50,94,29,-15,27,17,-11,-13,20,3,28,16,-33,-49,-55,-12,40,-9,-37,13,-49,3,26,4,24,8,7,93,14,19,-18,43,-55,-3,57,-19,48,-2,30,39,14,-40,32,54,38,-106,82,15,6,-55,2,-39,-17,-58,16,2,-13,40,-2,-21,-5,-22,-22,-73,-5,-5,-43,-73,-22,82,18,41,-16,-49,38,-9,-7,18,-19,-40,76,-127,0,-32,-61,-56,14,-83,-40,-1,-61,-15,45,-9,-18,-84,-22,-23,-10,-78,46,62,-42,9,-4,-70,-8,47,6,-4,-86,-7,6,54,9,22,-20,43,17,-18,-23,90,-51,-67,-63,17,-6,-26,-12,19,9,-5,45,27,-15,-1,24,46,9,51,-37,-6,1,49,68,26,8,-46,-40,-34,27,-48,5,53,25,-48,46,-33,-20,-34,3,-62,8,-69,-38,88,-10,-5,-31,34,-41,69,-47,10,6,39, 
  /* [63][0][][] */ 75,26,-40,-33,6,-40,43,88,-68,-2,9,6,-30,-8,34,34,-12,-21,-65,-10,-24,20,-49,83,37,8,-50,49,23,53,-46,-4,-44,4,57,-4,-7,-1,16,-26,-1,-1,31,32,-30,53,7,67,9,26,-89,-36,0,-16,45,-2,-38,-42,43,-31,-14,16,-13,13,43,-31,54,50,40,23,6,15,36,57,-4,111,-12,33,-12,41,-2,-29,16,39,26,-52,-8,-26,-52,60,-16,10,40,-24,-44,-10,-33,-34,-40,-32,-9,-9,-22,-4,1,-7,43,-19,36,8,-49,-39,13,-78,5,29,15,-25,10,14,-6,93,-98,59,2,54,24,29,-65,37,-24,-50,-7,-10,10,1,-36,-9,34,35,-55,42,-29,11,-38,37,16,17,-4,1,4,127,-13,25,-23,60,-68,25,7,3,-35,63,-51,-81,42,11,8,-59,-10,48,5,28,-7,-2,-12,-17,-18,22,31,-42,37,-22,55,5,49,-8,-14,-27,-8,-38,-1,-15,38,-9,-5,-7,-64,-20,68,-23,-27,10,-36,-17,30,14,-48,27,-28,-41,14,-13,5,-2,26,16,-18,36,-1,-13,-40,-5,11,61,27,-2,33,54,-33,74,-54,3,-67,27,13,-1,55,17,-24,75,-42,8,-50,35,-1,18,-19,77,-13,-77,10,-81,-26,24,61,43,-13,-38,20,-8,-36,-30,4,-41,15,2,-25,-18,-13,46,24,-72,-77,20,-22,43,72,12,-31,-36,-18,29,-53,27,0,-6,26,-23,3,52,24,-54,-37,-8,-19,58,-83,29,13,-30,7,-16,64,53,30,10,-10,26,-100,38,3,-17,-2,-49,-46,-53,40,32,-7,7,43,-12,-2,78,30,18,-30,-15,47,-27,26,56,-49,76,2,39, 
  /* [64][0][][] */ 49,-33,-64,7,-29,-1,27,82,-42,28,-10,-13,40,23,120,11,-68,18,-47,89,30,-41,-49,-83,91,13,-13,40,-20,-29,-5,51,-54,36,30,-21,81,56,-14,-20,73,-18,49,-49,1,-9,12,-38,-1,21,-80,54,89,-33,-78,-63,2,-74,23,6,-14,-9,39,-95,25,-55,-29,-22,12,104,22,2,92,54,2,-92,-40,-56,-22,-111,-56,-19,-80,60,3,34,5,47,28,-87,41,55,-32,74,52,-70,53,-26,-35,-42,21,4,26,-11,16,-3,38,26,-43,-1,6,-39,-13,-15,62,61,-81,-23,-2,92,-1,17,-49,-46,12,46,48,61,-18,15,1,52,-51,-47,67,-69,-52,78,56,-46,114,-49,82,67,-42,-102,-18,-32,-80,37,-36,-50,37,-79,59,-24,-79,0,8,0,43,28,-7,-19,63,32,27,9,-49,-36,0,38,-67,-9,-45,3,73,-77,2,-9,-33,-39,18,-82,40,9,35,-24,-127,43,-64,-93,-6,18,61,50,-69,-9,-19,-50,64,61,-31,-51,71,41,-19,-17,61,-8,50,40,-17,-49,-91,37,-62,-34,44,49,61,-74,-7,-2,-16,57,2,-24,-60,-100,22,-55,19,-5,119,22,73,53,-31,-93,2,75,-18,65,-40,-55,-6,-10,48,13,-7,-34,-67,59,1,-39,-54,-65,-68,-4,-7,47,-40,53,21,2,-54,47,-32,37,21,-4,4,-8,-33,-48,-8,120,-2,87,-118,-29,-6,-40,-8,-28,85,22,-42,-39,18,-73,46,-50,59,104,-35,-70,37,55,-48,-45,126,-30,7,-6,-27,30,41,-52,27,-28,6,-37,53,1,-52,-48,-8,94,-21,-19,-9,-70,48,-69,29,21,-44,31,5,-59,-4,-12,11,-11, 
  /* [65][0][][] */ -21,-8,17,14,48,-20,8,-16,-1,-44,45,-3,-86,89,28,15,49,-8,1,-33,-15,-26,13,-13,-22,47,-14,39,-52,1,-38,3,-2,-22,-17,0,-17,-20,-23,16,36,-9,31,-33,5,-4,0,-16,23,31,33,45,-23,0,-11,-14,19,-69,57,42,39,1,-23,2,5,2,60,2,-23,-7,34,13,-41,13,-30,17,-19,9,35,28,-14,30,84,8,-9,11,11,11,62,-5,30,-36,-34,50,54,1,2,-21,-30,34,8,15,24,-5,12,-79,13,45,36,13,-6,-16,-45,33,22,4,-22,-15,16,-11,-13,-24,13,14,-61,-3,15,-6,49,10,6,43,-13,1,35,-24,7,-2,-2,4,9,-15,-19,-7,23,-24,0,0,-2,1,-22,-30,-14,-15,-26,-40,-27,32,27,11,-14,-1,34,-7,21,4,-38,-39,-22,64,17,-50,49,38,45,-14,30,41,16,-4,14,67,-18,-10,31,-12,4,-19,24,12,-2,-32,20,-37,14,44,6,10,-10,-37,-14,10,-7,-34,-79,-6,23,0,51,-30,17,1,19,-51,29,-15,16,-53,8,40,-31,16,-4,10,8,-24,127,-32,-30,-24,102,9,1,65,-20,-10,36,-22,-11,41,17,32,8,-23,-11,33,2,-17,-23,41,56,-21,49,-29,-55,-34,9,-9,21,10,6,-34,-2,20,-24,17,23,29,11,-27,98,-33,5,-1,-34,-5,42,-4,-4,-10,-28,10,-55,27,-24,12,-48,10,36,-7,16,8,48,-79,-51,-35,1,-20,0,-18,-5,-20,1,86,-5,-10,-14,-26,35,82,29,-35,2,29,28,21,43,-15,-1,-37,23,-22,-48,16,-84,20,25,61,-26,-94,2,-16,-41,56,23,-38, 
  /* [66][0][][] */ -3,76,10,27,-8,29,0,23,1,-44,103,-3,16,56,6,-13,8,32,-23,-52,-57,-10,30,-17,23,18,-87,-11,-40,-8,-6,50,-9,-55,-27,-37,27,-24,32,-66,-21,36,-38,-40,-8,3,0,-21,-43,-13,51,-42,-42,17,-61,-20,15,-23,-50,-37,33,44,40,-35,64,1,-27,14,28,-49,7,-37,-5,14,11,54,29,6,15,23,42,-13,42,48,-67,53,36,-2,-44,-32,-1,11,-20,-18,-1,5,-16,-37,14,65,24,-7,-30,12,34,53,-29,-39,-18,17,-30,0,53,-21,-33,-10,51,-7,22,24,37,72,-36,-16,48,-32,45,24,27,5,47,63,-34,10,-5,-34,46,19,-18,88,32,28,-8,-30,-7,37,1,38,44,24,-8,-13,15,32,-32,-28,-23,-26,29,28,-22,-21,12,-12,9,2,44,26,10,-93,-6,-43,19,-3,-48,-2,-127,20,3,87,5,27,51,17,42,-2,-15,-1,-4,-3,-1,32,3,-61,-62,-33,9,-58,-21,10,-7,-2,26,26,-16,31,-11,2,12,46,-27,3,29,-5,-57,5,7,16,-3,2,-46,-2,16,4,11,-35,-52,-38,-33,-38,-44,9,18,35,-53,-31,18,-46,4,19,35,-21,14,100,2,-50,-45,-63,-65,20,-10,62,29,27,-46,-26,-43,44,36,-53,-8,10,-57,-11,-15,-19,5,8,-51,-8,22,-39,9,29,35,0,23,26,-6,-39,-119,76,-13,2,20,-88,-71,-32,2,-50,2,-36,-26,22,109,-26,18,24,-22,-12,21,-33,26,-6,-27,-45,6,46,-17,22,-10,-34,15,-19,52,-57,-60,-2,-21,51,-56,-22,-59,-58,56,-52,-8,13,-8,-37,-10,-12,31,-7,-10,35, 
  /* [67][0][][] */ 35,30,71,68,47,-22,-30,-40,18,3,-17,65,20,13,16,-2,-71,6,-36,-25,16,-7,33,-88,37,12,3,-46,-36,18,7,33,-14,-39,11,-40,-34,-74,-42,-42,68,9,-38,0,48,-17,52,11,32,23,38,15,56,2,28,-28,27,-29,14,-19,-26,-19,-53,-9,30,-21,-22,-39,23,21,14,-36,-35,-26,52,-41,1,26,-42,-45,-70,27,-32,-21,-53,-33,-48,3,24,-2,-30,24,11,63,14,13,23,-80,9,-3,0,7,-26,-17,19,-26,41,-9,11,37,53,90,-37,-52,-21,61,0,54,-10,-8,50,-38,-31,37,-78,-7,-73,6,-47,105,13,32,3,-56,37,2,34,-32,3,36,-72,38,-18,25,22,-49,3,-48,91,56,-51,74,-39,39,41,-36,17,47,-40,-6,-58,-27,57,-12,18,-20,68,-38,-22,-14,-27,-10,-13,32,-23,31,-16,4,-10,-46,-33,30,-77,126,-61,74,-13,-88,-54,-13,-27,-38,-42,-45,21,-57,-3,-50,-7,-8,39,3,15,4,-68,-42,-36,-29,40,26,20,-28,-30,21,20,44,31,2,9,-27,22,63,19,106,-68,-6,60,-38,33,-67,-41,-2,39,-35,-28,-59,-7,9,53,34,60,3,41,-65,66,44,36,47,-60,-37,-98,-30,15,-21,9,-67,-17,20,110,-9,-10,0,28,41,41,-11,92,-72,31,-4,-59,-49,0,50,-19,-48,2,-31,53,-90,-127,-102,21,43,2,-13,47,-15,-26,-102,53,54,50,-83,-28,-61,100,-4,-56,18,40,5,10,49,2,-75,-2,-5,-14,15,13,-21,17,-47,-13,99,61,-27,82,-12,34,-30,-40,-51,-19,31,3,-89,24,46,-24,13,-31,-29,53,40, 
  /* [68][0][][] */ 73,11,-1,29,-50,-64,14,59,21,15,12,56,39,44,-48,53,36,-68,38,104,-66,-7,17,-66,-1,-42,-2,52,3,4,23,23,36,-20,-30,0,21,67,65,67,69,-14,17,59,24,-44,26,-127,25,40,-4,44,35,-15,-38,21,22,-10,-40,-2,-15,-12,-16,17,-47,-23,-95,75,-31,46,-15,-91,11,40,-42,47,31,101,-26,39,42,7,47,-1,60,38,8,30,-31,20,-30,-14,3,87,64,8,38,-47,-29,-2,34,44,10,7,-78,0,-53,-4,-50,18,15,8,-1,36,19,27,45,43,22,-17,-53,-60,-48,21,23,-6,4,53,-51,16,-17,-30,-15,38,-98,-93,-60,49,18,-78,-30,1,-4,-72,4,26,-4,-28,5,49,-54,-108,-15,-14,-10,-37,-65,24,-25,-44,-12,-52,-55,-14,-82,6,-31,2,18,21,-45,-9,13,26,-35,-67,23,-37,64,10,71,-44,-14,-33,18,-1,33,-24,1,-9,11,1,28,55,23,34,49,-34,100,-56,-7,51,88,51,23,-34,-64,-11,-33,0,-18,12,-36,63,17,18,36,-35,34,-41,84,30,13,-18,13,-65,53,26,-54,-55,37,26,0,60,-2,28,-76,-4,-14,-76,7,-93,14,4,30,-13,-27,92,-81,64,-35,-2,-13,-53,-25,-10,59,11,40,-14,-52,-24,-12,25,1,30,-24,39,-35,49,18,6,-27,-68,-33,-24,-78,9,36,-66,-86,33,-20,24,7,53,-74,-50,35,46,109,13,9,-31,27,31,-45,-16,43,-23,-33,70,54,-43,37,-22,7,-1,100,-77,-56,-38,-90,-5,-82,-73,-61,55,-45,68,43,34,-16,-26,22,-15,9,-43,-6,-74,-17,15,-106,-43,-12,57, 
  /* [69][0][][] */ 4,-13,11,36,1,-29,-24,51,-67,-29,33,48,-16,83,35,-49,-72,11,-11,108,68,89,-102,-35,31,58,-69,-14,-5,-12,-21,11,-32,-65,-19,-1,63,-52,-9,-103,63,23,-28,-15,29,-35,-110,-46,-49,-85,17,100,-62,42,-80,-17,-104,30,-76,21,45,-11,-77,-4,-103,17,-29,20,25,-40,11,-46,-35,69,9,-66,22,59,29,-5,80,-23,17,20,-30,3,4,-5,-7,42,-98,-48,-42,68,-29,-67,13,4,11,-111,-22,1,-80,-4,23,-49,74,-37,5,13,-69,58,31,11,45,-7,-22,-4,-15,-21,16,72,10,56,-63,-24,-10,-55,-18,19,-16,69,-24,29,12,14,19,-29,-3,6,43,97,43,-27,-19,13,25,19,6,12,26,65,-52,-61,-29,88,4,10,16,-11,-9,-84,25,65,67,3,38,11,91,62,10,7,58,-20,-66,-75,-69,-51,-42,-20,1,64,-50,56,60,-8,-36,20,-17,37,-4,-58,14,5,-19,-47,-34,34,38,-22,-40,58,-63,32,40,-48,-54,-51,-4,-12,-39,114,11,9,-54,103,-60,-69,-22,-18,76,-63,-4,58,15,9,35,2,46,32,-2,85,21,-4,32,6,-39,-53,20,-75,49,13,-46,-67,-34,72,56,-51,-4,73,-51,17,15,-39,-36,21,55,-15,27,16,-35,65,12,69,-38,50,40,16,35,-33,10,46,74,-18,-45,22,11,-7,61,-21,-49,47,31,-16,78,36,-15,-29,32,-44,21,27,-34,15,33,83,-27,91,43,-10,33,-61,-31,26,37,-42,4,11,12,-43,44,47,-18,-60,40,12,-16,51,33,-91,38,-39,13,104,65,127,52,-18,20,-4,-15,-74,54,33,7,74, 
  /* [70][0][][] */ -6,38,9,-8,6,-60,5,-3,-2,-70,-84,-14,-5,74,52,-66,46,-18,-64,-6,13,97,16,37,-51,28,-72,47,63,-1,41,-45,33,19,-11,30,-36,29,44,21,58,32,-36,-42,41,45,19,-25,-41,-11,22,-58,27,8,-19,18,-27,-35,-38,46,-127,17,25,13,-51,-14,54,16,-60,-55,-30,35,-4,1,11,-11,41,2,28,6,17,-27,-80,65,57,-26,59,-16,-26,-11,-42,-3,-4,-77,24,9,58,-54,-37,62,55,-22,-42,22,-35,6,-26,40,44,-17,44,-100,1,-2,-9,-13,71,-19,49,61,-41,71,66,23,36,-36,-14,-63,-46,-27,-2,12,27,-4,60,51,25,-99,8,-37,27,-50,78,-39,42,-9,-64,55,-15,-19,-40,11,21,-63,-3,-16,-25,10,-42,-54,-25,-19,-32,18,-32,2,3,0,-91,53,5,-25,37,21,-20,-43,-22,-29,25,15,6,-8,-6,89,-50,35,-8,66,-32,83,-35,32,-4,-13,4,20,-25,-26,65,54,61,-14,1,127,48,32,26,38,-39,2,11,-6,3,28,72,-17,21,68,-21,-72,-20,25,-16,-71,-3,-25,-14,22,35,32,21,-18,-62,-60,64,-49,-5,-28,-5,99,43,-23,15,40,8,7,-51,46,-42,7,72,42,-5,-29,29,-35,-19,-36,-69,-8,4,-28,11,-3,8,-81,83,19,86,2,-1,21,-22,75,12,-2,-51,-33,-48,-73,-24,-13,6,-8,27,-59,-22,-89,-22,-56,8,-45,-18,-15,50,-82,-37,-81,38,-87,24,24,-19,13,-2,-21,-44,16,76,53,16,-26,39,-50,-38,54,4,-88,-17,-39,-9,35,23,-49,42,-29,-42,42,68,2,-38,-63,15,28,-76,4, 
  /* [71][0][][] */ 0,20,16,-41,91,-36,-52,-14,-6,51,-74,-30,-33,-71,-24,12,47,15,50,38,-20,31,81,96,2,57,-37,-1,26,32,-6,-30,19,13,-1,22,-4,-7,-30,1,-7,27,65,11,-7,-34,-20,17,-9,5,6,48,-36,-22,-38,33,63,-23,56,-35,-105,76,-37,-30,10,20,-60,13,17,0,60,-2,55,-7,48,25,-37,-43,-42,8,20,42,115,29,1,-42,7,78,-34,-34,72,25,12,-34,-27,-24,-29,-31,-45,79,29,-17,-56,-13,47,-2,44,17,-9,1,-5,19,9,-127,-55,-35,-43,-2,17,-17,-4,-12,-29,-38,71,-18,-7,-31,60,6,-22,-6,5,24,7,-41,55,9,49,12,5,-29,4,66,20,-15,22,-36,-25,24,12,9,19,63,9,45,20,8,3,-5,-49,9,11,14,32,-22,-14,14,33,24,-60,-29,-43,-45,-30,-16,-7,22,-10,-29,11,-39,27,-45,-78,-26,-43,19,63,-47,77,0,10,29,26,3,-43,-57,-10,5,-32,62,-60,56,1,51,18,-90,58,28,-45,-13,-26,31,-82,62,8,8,22,-39,31,-18,-37,54,0,10,70,-16,30,18,-2,23,24,5,22,52,-33,1,59,-12,41,-19,-8,11,-7,14,-60,-25,-25,22,16,12,-16,-8,-56,-7,-35,-12,-42,27,39,-1,-45,0,-21,27,13,10,24,-47,30,-52,-14,16,17,-17,-33,-16,-40,-35,-31,20,-11,51,5,51,-17,-37,-22,-36,37,51,23,-22,-22,-7,44,9,37,30,2,72,11,-30,0,19,-44,9,1,10,-22,15,-25,-24,-115,-32,-8,-22,-6,56,10,-17,-14,-43,30,-33,56,28,11,25,-44,67,2,-24,4,14, 
  /* [72][0][][] */ 72,-4,-27,79,22,-44,55,15,-3,-35,11,30,-16,-13,-50,4,78,16,39,63,17,59,9,-39,-10,-55,-57,-32,-19,-11,61,4,-13,-8,-90,30,-22,-60,-18,-27,-3,13,50,-80,-17,17,24,-10,-40,-63,-17,-1,7,23,40,-15,-65,-34,76,44,-43,-28,8,50,39,15,-26,69,-43,-90,56,-87,2,-5,-6,31,28,-24,56,-38,44,-59,-13,-7,-17,-18,29,49,-6,1,-37,1,-30,-61,13,13,-75,-17,60,-79,-21,-39,-13,-50,-30,-44,85,49,-59,-8,29,-17,-25,44,-119,-26,-8,4,-5,-16,32,31,15,70,-48,-10,51,22,-35,8,70,-28,53,9,8,-3,-28,29,-37,-58,-48,-46,-10,45,67,-63,15,-23,47,23,20,-10,43,-91,-12,30,33,-24,2,25,8,-44,-5,-9,48,25,15,-3,22,-5,-73,24,39,-11,30,-37,-44,11,2,67,-119,-45,-14,-67,42,14,23,18,-62,-7,21,0,18,-16,47,60,56,-17,-8,19,7,29,3,-43,-40,6,59,60,-11,55,-12,-37,-67,-27,8,127,3,6,-8,88,-49,53,-65,19,0,1,7,18,35,9,1,-49,-21,28,35,-24,6,40,44,-40,71,-9,-7,22,47,-7,38,2,-49,-51,-69,47,-7,-15,58,-90,14,26,-27,-7,17,-8,68,-41,-15,15,-3,1,-61,37,-47,31,10,44,25,8,-38,24,8,-30,47,18,26,1,-24,-6,11,-28,-42,38,33,3,46,0,27,-47,-35,123,30,-37,50,3,-40,4,-18,-55,-23,-35,24,1,-6,13,53,19,61,18,-34,16,38,56,-15,-52,-45,-51,-56,21,61,-3,-86,-32,-12,-18,6,-38,-52,16, 
  /* [73][0][][] */ -42,22,10,28,1,-77,-27,-13,6,3,84,18,-10,23,-4,-18,32,16,24,39,16,-32,-36,61,-25,19,12,35,55,43,-1,43,-29,47,-19,-49,-37,62,-16,72,-25,76,-1,12,14,5,-5,-81,11,64,-2,-6,-4,-3,-42,5,10,24,-12,14,55,-60,3,-12,-24,34,-26,-12,-6,6,-6,-11,-31,-43,-65,-70,2,-16,-48,5,11,96,-53,7,-45,-26,-24,-3,8,12,26,-1,-22,-40,-32,4,15,-23,-52,14,-36,9,10,-105,15,18,-66,6,25,33,20,-10,64,65,42,-9,-4,60,-9,97,38,-41,-41,30,47,30,15,89,-15,-16,60,12,39,34,-34,-34,43,10,4,-18,-7,16,44,-49,33,-42,-6,31,-87,13,10,-36,19,-5,-52,53,-103,17,16,57,-11,22,8,39,21,23,12,49,22,32,-13,13,-25,-2,0,14,-61,-26,-25,3,-36,-17,-54,5,-52,80,-34,19,13,14,22,10,-54,7,38,-73,-2,-81,-34,7,33,2,-40,9,-30,9,19,0,-14,-42,-4,-74,-31,27,5,23,-20,-79,-21,-18,2,-56,25,41,-9,24,13,-39,-44,-35,-23,-86,-16,-16,5,22,2,-8,-41,51,26,-32,69,-127,9,7,20,32,-22,-32,-1,25,2,60,74,8,32,11,-6,18,34,-4,-24,29,97,-40,29,-18,12,-82,-21,-17,-35,18,-17,21,-2,-19,-64,35,15,-41,-30,46,-37,41,36,-23,-13,46,28,0,-70,-76,46,-17,21,-25,46,-21,22,19,-9,63,7,20,34,-12,-68,-15,23,-7,-16,18,-32,-45,39,-43,-61,-107,5,-28,-1,12,7,9,37,-17,-6,-10,33,-19,2,-1,-13,-18, 
  /* [74][0][][] */ -4,-57,-42,-29,43,-42,-5,-65,-29,-2,-39,-10,-6,21,17,5,-16,72,44,-51,-17,20,-18,91,-9,1,20,-7,21,-21,-15,27,-3,55,-12,4,-48,54,52,-26,18,-32,85,46,23,40,-9,-2,-32,-85,-80,62,16,6,3,-18,64,-24,-6,-47,46,31,70,-73,14,-16,47,-27,-7,-27,-44,-72,-29,-66,23,-74,-5,-9,-7,7,23,-23,47,-52,29,-1,32,33,-63,11,2,-74,-93,24,-14,8,59,20,-29,-22,8,26,-4,-62,2,14,17,-65,70,-51,30,19,-29,-21,62,3,-20,32,-36,-57,-19,-36,-28,-10,-29,12,9,-12,-107,37,49,-56,55,-9,58,-49,8,44,-15,-29,13,3,-22,13,-74,-3,32,54,28,-71,-14,61,50,32,6,-48,42,-81,-7,-23,58,-43,-15,-51,-8,-36,57,9,46,-55,15,-11,-27,59,-29,-81,68,-3,26,-11,-5,-16,-76,-60,-3,-16,-10,-39,-43,-11,23,47,26,65,0,43,-127,-56,-25,7,34,-15,15,77,14,-45,13,79,-8,41,-2,29,-7,-10,21,7,37,49,-21,42,-25,-5,19,-28,-46,-8,32,-14,-32,18,11,6,57,0,-44,15,96,-10,19,-17,9,-85,9,-72,-5,-24,-24,28,-54,-20,8,-7,0,9,60,-43,9,-48,25,14,-18,-2,4,-51,-57,-73,-25,-22,-9,-21,15,40,-23,-95,3,45,24,-35,-53,-8,81,-18,26,-5,-47,-33,-34,-10,75,-35,-23,4,4,-29,1,17,38,5,67,-10,-6,-36,25,-116,38,-63,23,2,-15,61,-58,-25,-59,22,-17,14,35,-65,-7,14,-40,-62,-3,6,-92,52,-25,23,-37,87,-33,-23,16,32,-6,44, 
  /* [75][0][][] */ 55,-80,38,-33,88,1,-12,-35,-12,-42,-29,3,74,7,39,-30,10,-4,8,5,29,1,64,25,-10,20,16,-17,59,43,-35,-47,-4,-35,-36,-53,53,0,-57,70,-31,12,74,-30,23,-31,19,-33,-28,-20,-110,46,50,-15,-11,46,-13,-40,65,7,-48,-22,26,-28,92,82,33,-60,26,6,19,27,3,38,-40,81,-24,26,-23,60,-30,9,-38,14,39,22,-53,19,20,30,21,28,-27,23,-73,-12,-1,36,-39,5,-20,-35,-9,36,34,-95,3,2,99,-16,4,-20,5,-6,32,-80,-23,14,-25,-69,-12,-7,-32,-13,70,-7,-127,-80,27,-17,30,-22,1,10,6,49,30,68,31,7,-41,-35,-35,21,44,-109,36,-28,-1,5,32,-27,77,-64,37,21,-18,-104,42,-20,-46,23,-92,40,0,32,-54,-60,-2,38,15,-13,-34,-11,30,4,-30,24,9,-3,7,-25,47,-9,-5,38,-6,-32,7,45,5,-42,-21,62,-35,-34,3,13,-1,-84,46,-67,31,-1,-48,-55,28,43,-36,-6,22,-28,27,47,-27,-29,-12,41,-48,25,-90,21,0,5,-7,47,-38,1,-47,-50,42,9,-19,-7,-1,-39,21,-39,36,-44,-4,40,65,-19,-36,-18,26,-16,46,-17,48,-26,2,64,-66,26,-21,32,81,-14,-12,38,68,-39,3,30,-15,16,-25,7,60,-40,2,22,-38,53,-8,41,-13,-15,-59,-50,-65,-58,-21,42,15,-33,-28,-21,56,-70,-75,39,-105,44,-32,32,93,17,60,24,-20,-75,44,-46,34,-50,-116,31,43,-43,-29,-13,55,-22,54,-26,80,7,18,33,6,33,68,-14,23,-65,-69,42,4,32,22,-17,19,27, 
  /* [76][0][][] */ -13,-2,-29,76,8,-46,-15,-26,-1,-6,-23,8,30,-35,-15,127,-26,57,-16,20,-67,-34,-40,12,-40,56,-24,49,19,37,64,-17,-56,-28,69,-17,-6,5,67,-6,-21,11,49,-10,-6,-46,56,-34,-43,29,29,30,-1,24,-67,15,-77,-52,14,-12,38,6,-83,33,3,24,6,-48,12,-57,0,34,-22,-55,29,-47,54,-33,-38,26,0,20,-12,41,-18,-49,71,-32,24,5,-24,-101,-74,31,73,26,33,-23,9,-33,-29,68,-8,16,-16,-19,-40,-26,-31,-69,-16,60,20,-76,3,-74,1,27,-61,26,-12,-113,-33,-63,-76,-17,-37,-32,-30,31,-9,17,-33,8,-20,35,-43,-13,-36,56,0,82,-19,16,-54,-42,36,-15,27,-1,26,-59,4,51,-34,-21,60,-11,13,9,-11,-27,29,23,46,13,-42,-12,-33,-54,23,3,42,60,-61,-11,-48,60,-15,24,-5,-15,11,115,69,-38,26,-2,-6,-13,55,-30,-113,-16,-6,-17,-31,-86,-27,-16,-25,-31,-2,-10,48,2,10,-77,4,-21,18,55,-1,100,33,0,19,-3,24,-4,-31,37,-4,-55,-22,84,18,5,-22,29,60,-85,17,25,16,47,33,-19,41,22,67,18,-12,-13,6,33,31,63,-9,9,-19,-21,-23,-13,16,-80,37,7,62,-40,37,-26,42,-71,65,-53,-67,66,30,5,17,-50,20,24,5,-6,4,86,23,7,31,34,4,-16,-37,61,-85,57,-25,-49,45,-41,19,30,-39,-50,-65,59,5,19,-9,10,35,35,-3,38,41,6,-40,-27,-36,65,59,-40,37,28,-27,-28,-83,68,34,30,-7,-101,40,-41,9,0,57,35,-16,-19,73,-2,62,-20, 
  /* [77][0][][] */ -12,-34,8,24,-20,8,14,36,-13,-34,-127,-31,-15,-4,-38,52,-28,-22,37,-7,-5,30,17,-38,4,-2,-65,15,53,22,-9,21,17,22,-24,-2,-23,66,-27,-28,-4,-7,7,38,10,-22,-50,-25,16,-70,25,-13,-35,31,49,-45,-62,-28,26,-12,-45,-40,-65,-4,-42,-33,-29,0,20,-73,59,70,15,9,-47,-23,-24,-6,-57,0,-43,36,-19,40,-24,12,0,-65,-5,16,-30,-16,-30,-26,-24,14,23,15,8,-36,0,1,-15,-4,33,5,-5,0,26,-33,-15,23,39,42,-13,-22,17,-20,21,-28,-14,24,10,-43,4,14,51,1,27,21,53,-21,-27,31,43,14,-32,-12,13,15,-29,-14,28,0,4,39,-75,63,-20,23,-29,-19,21,28,-4,-45,-38,-4,-45,4,26,14,-11,35,-16,-58,15,-37,-34,29,-33,-4,7,-36,-12,33,13,-20,10,-5,-17,24,0,-22,23,-20,37,-14,6,-29,16,-5,-27,-21,23,-28,43,-24,6,-1,82,-10,6,22,36,-9,1,41,-12,0,21,13,-12,-31,-23,-12,-29,-25,29,-28,45,7,28,-38,19,-15,14,40,-17,-19,12,38,53,20,-40,39,-19,-22,76,0,-15,23,34,-2,0,6,-36,11,-12,-21,19,16,-8,-19,-37,14,-14,39,8,14,-3,42,-35,-56,14,-3,-9,-71,11,-11,-32,-8,-22,-7,8,-11,-35,-3,14,56,12,-13,-3,30,-21,-62,-7,39,-5,83,23,-58,-6,19,-18,16,14,7,19,-9,-31,25,7,-14,-30,58,-8,-4,3,55,-6,-63,22,-22,27,24,-40,14,-15,40,40,16,-45,7,13,30,-24,-9,-18,7,23,5,-50,37,19,33, 
  /* [78][0][][] */ 15,32,-16,4,-26,39,-31,-40,22,47,-24,20,35,-56,1,49,31,-31,15,31,-35,-4,-46,-10,-24,-4,22,-13,19,14,-1,22,10,-19,40,-4,41,-38,-8,-2,19,-38,-13,-28,22,-39,7,8,26,5,62,38,28,33,-36,-12,-64,0,-20,4,14,28,34,44,-31,-16,-41,-34,26,50,2,57,-65,-10,53,-65,-34,-38,29,-8,33,32,-27,6,-14,-5,19,-5,-83,13,-41,29,-43,-58,-43,13,-46,-34,19,-16,91,-11,-4,14,39,11,30,-13,42,16,36,-20,-25,69,-11,18,-47,34,-3,2,39,12,-45,-53,-40,-22,49,-31,-21,-48,15,52,11,-7,-39,41,-23,-36,-2,-2,43,15,-24,-69,-29,-34,23,-2,28,12,-68,11,3,6,26,25,-8,-51,52,-49,-54,16,19,54,24,-1,-28,-14,10,16,19,-13,-18,-5,-8,-17,-22,69,45,16,44,5,-11,-2,-9,-15,39,11,28,32,7,57,-28,-27,-23,-9,-80,37,-10,-28,-96,127,33,35,-53,-33,6,41,-82,43,9,32,42,5,71,-28,-35,-50,-29,30,-12,-51,-31,13,-2,39,24,27,-5,-14,-3,25,33,45,-32,5,14,-11,12,15,-17,-6,34,13,52,-13,8,-7,56,-20,12,22,18,-91,-24,2,-16,-62,1,-62,26,-13,38,-9,-12,-62,33,9,-22,-37,-30,25,-18,-24,1,-29,18,2,30,20,-46,-29,-50,-6,-20,-50,-16,29,20,-26,-42,6,6,11,-35,10,8,33,67,41,-44,-5,5,66,36,1,2,-22,38,52,-36,-48,-5,-17,7,-116,36,2,22,10,-12,-14,-28,-22,-32,-62,37,-19,-78,-33,26,7,-10,18,30,-16, 
  /* [79][0][][] */ 45,9,97,-26,-43,-5,45,-76,-55,-1,-42,-12,30,50,38,3,26,-17,-17,-63,-24,25,-57,14,42,10,-70,-10,96,63,-68,0,-80,3,40,-34,-14,-39,40,-40,99,-41,63,79,-2,-29,-20,8,35,-36,-23,-37,-100,-78,23,5,1,60,31,7,48,2,38,-50,-20,64,-21,-55,-19,-50,37,50,-52,-14,14,93,23,85,16,-62,-12,-3,8,-37,113,38,47,-14,92,24,-50,-26,-15,35,-12,-8,58,-28,11,-14,-110,-4,-74,15,3,-34,17,38,0,0,63,14,-26,-80,15,-50,-17,-24,-1,109,-51,11,33,11,2,-15,28,-12,61,61,43,49,-5,-10,-97,120,8,17,-21,19,60,2,56,-123,-17,-13,17,8,8,4,-62,52,-17,-45,-44,78,36,52,49,60,-5,33,27,41,64,27,-1,-65,-31,-37,-53,-21,58,-47,9,1,-17,10,-55,13,8,66,14,-26,9,-68,-35,30,89,-89,51,-14,4,55,19,-36,15,70,43,-28,-27,11,2,-21,22,-50,68,-9,-48,64,-32,-27,17,-2,40,-48,33,77,-27,25,31,-119,-45,29,21,24,1,-11,28,-24,107,-27,-38,25,9,-23,69,-6,28,-49,-21,-28,-20,20,-31,-65,-22,11,50,-27,-32,-40,31,0,-8,-59,28,16,-2,23,43,-25,-82,-109,41,40,-44,32,0,27,-7,-20,-13,38,-15,51,-123,-23,71,19,-37,92,79,28,-71,-58,38,56,-27,58,-69,35,39,-50,-45,-25,-81,-85,63,-29,-29,-81,-78,3,-31,-26,21,22,-14,-33,-15,-118,10,10,-38,-92,-44,-16,-23,127,60,24,8,-61,10,54,39,-28,20,23,-21,-24,-57,13,12,0, 
  /* [80][0][][] */ 22,-48,-29,-26,-2,23,-43,-35,12,19,43,-21,-48,53,-36,-28,17,-8,27,-20,-49,54,77,17,32,-32,62,45,-9,43,-60,59,-11,-40,5,14,-25,-67,-23,43,20,52,-14,-20,2,28,-23,4,66,46,-7,105,17,0,18,-5,13,-35,14,-67,14,14,-69,21,87,-11,37,7,26,37,69,-27,-82,-17,10,7,39,37,8,-18,-24,-22,-31,28,12,-19,36,-24,27,12,-18,44,29,29,36,36,40,29,11,68,17,-19,2,21,-4,-30,-13,-9,-28,-27,-20,-20,18,22,-11,-51,-10,-34,6,14,-64,72,-16,-32,-49,41,-20,27,-41,3,23,-27,-15,33,33,-2,-43,-76,41,-35,54,71,-60,-63,4,21,-23,-12,7,-16,-15,-42,-18,-37,-39,47,4,22,0,39,34,6,23,-16,-19,-48,-15,12,-16,-11,-64,23,40,40,-61,25,13,41,55,69,-66,-29,73,-50,-9,23,1,47,17,87,-22,24,46,-27,-27,5,-45,-27,93,-34,48,-19,-127,54,1,-9,51,88,15,55,31,49,75,-22,5,17,41,-43,-63,-19,-2,69,28,-19,14,27,60,-19,-47,-25,-41,55,-13,40,-48,-14,-78,69,-40,30,-112,34,33,-30,48,4,-66,29,-15,16,-108,-50,-11,-57,-7,65,-9,-29,-64,-27,75,55,-19,-23,0,52,46,14,7,-38,-49,11,-22,-63,-28,21,65,19,-23,29,19,-3,-100,-38,22,-41,19,87,-51,74,-23,72,-12,5,-20,2,-54,-2,67,54,22,-40,-52,-54,-51,44,56,17,-34,25,-39,36,-23,-10,5,9,-9,-33,12,6,-3,11,-45,-113,17,-77,-9,-60,25,28,-12,-49,41,-106,58,10, 
  /* [81][0][][] */ 47,-33,-16,-15,13,-6,-3,-2,-25,65,32,88,-25,-11,28,1,-34,33,58,-89,61,3,13,53,17,5,-24,3,-51,58,10,-44,-25,-41,-62,-23,54,-22,-28,-67,3,-33,50,3,8,22,70,-23,53,28,-46,-50,8,50,-15,43,-23,35,17,4,10,-5,74,49,22,15,-96,11,36,-9,-23,14,6,-8,-3,-62,-45,-8,-25,38,4,44,-97,44,-31,31,-48,-59,100,-45,5,-18,-49,27,-31,31,97,17,34,-55,9,21,35,6,11,-84,5,5,-30,16,9,-24,-29,-33,1,-43,76,43,-71,14,6,61,-27,-24,-39,-49,53,73,-59,29,14,47,-14,-35,-92,8,26,44,-16,45,-11,-113,30,23,25,25,26,-51,-38,46,-4,30,19,40,29,43,-17,64,-17,-6,-18,-9,-40,-64,-28,55,46,127,-38,42,-47,50,-27,-47,-23,25,95,72,-47,60,-43,7,33,-27,-24,10,-2,-57,4,-43,66,-16,18,-2,-18,2,-31,37,-19,18,14,16,-89,68,-10,-56,-11,-44,2,-74,18,15,53,-4,39,-39,5,-44,-19,-6,-106,31,-5,38,-19,-17,22,-27,-54,55,0,-4,66,36,11,-9,22,23,57,-43,71,47,-11,3,-13,-33,46,-3,22,14,-49,21,21,-31,67,96,-19,-20,7,60,80,55,-25,87,-48,-2,65,-28,-22,-16,-31,14,-9,-19,-19,-43,-46,-32,47,-38,-40,12,6,25,-20,-53,-55,-32,83,50,-9,-5,-44,41,-14,40,-21,-5,-6,37,5,41,-48,17,29,-25,-16,55,20,5,-30,37,65,-16,-12,69,-71,14,-42,-45,-55,49,7,-15,-13,-35,69,-33,-22,-8,-16,7,46,22,3,-40, 
  /* [82][0][][] */ -1,-48,2,-27,42,-1,-9,-56,-25,35,-33,48,-13,22,16,20,-90,-36,12,58,8,-57,-12,31,102,3,-28,20,99,22,54,26,-14,28,-60,22,15,-31,-13,82,1,-32,32,-78,-15,56,-23,72,65,-62,43,-13,-30,25,-11,25,-7,8,2,-3,9,68,18,-18,21,21,41,25,24,-24,6,-10,-49,1,-22,1,-12,-8,3,41,-16,-59,-95,-14,33,-10,-78,-23,75,39,-18,-8,-21,21,-72,67,43,-13,51,-10,-99,-43,9,14,17,-16,-51,34,-66,-65,-67,39,11,16,-36,36,10,40,-32,4,70,-6,6,-11,-46,7,35,127,-31,53,-9,21,-62,14,-33,-15,2,-21,-22,42,8,-58,62,89,-25,81,-6,35,0,-48,17,-49,35,16,26,59,-29,-108,64,21,-53,41,-69,28,0,-8,-35,-45,37,25,-13,-27,-39,21,-36,48,38,-5,47,-39,83,44,-28,-42,31,13,-2,-17,23,-11,-33,36,33,44,28,53,-65,-79,-48,-34,9,3,-5,-7,22,9,-11,-69,16,34,4,-41,36,9,-5,-16,-12,-33,17,-112,60,41,27,8,-78,6,-84,-6,32,26,101,97,38,19,-48,-15,31,-70,55,11,-33,-83,33,-5,39,13,42,55,-92,-27,35,17,14,10,4,-1,26,1,-65,84,-28,32,47,-40,36,6,30,-18,38,-75,-19,-6,9,9,31,6,22,-93,25,-12,-101,59,-69,1,-27,19,-2,-72,-44,10,-11,75,11,75,91,21,-7,44,-65,-37,-3,-63,-2,17,5,-13,-25,-48,-7,-11,16,26,-15,1,53,17,-22,40,-3,-9,-28,-9,5,21,92,-2,55,-2,18,5,21,55,22,-52,1,0, 
  /* [83][0][][] */ -5,59,-7,-47,-19,-2,26,-38,76,63,-1,-33,9,51,-48,-40,16,-13,39,9,-20,-15,114,5,-69,13,-6,-18,25,-18,6,-3,44,-17,12,-9,51,-15,-82,19,-11,-45,-1,8,-24,5,-36,-38,-24,-20,46,-11,1,-5,-10,-27,-25,33,45,26,-20,-49,19,32,63,-40,3,-7,33,-25,8,-32,-17,27,26,4,-16,-43,44,12,-14,-43,17,50,11,63,-15,0,19,-8,-26,-20,-20,10,31,-28,55,12,94,-16,-43,-47,-46,28,-45,68,1,-41,3,-12,-5,47,8,-68,47,-46,-19,8,23,53,0,7,-60,0,-26,11,-44,-56,-81,49,38,-6,9,14,30,-4,-4,37,-11,-92,-44,23,36,30,-18,52,73,-20,-42,2,33,37,-33,-18,17,50,-38,26,58,-57,45,-16,39,21,11,-6,7,-19,-8,-37,-23,29,-33,-71,14,59,-16,-38,69,15,-32,36,-127,42,35,-22,21,-52,-35,23,32,42,-9,-27,-13,14,13,-15,-7,2,-44,17,-67,36,53,9,15,-11,54,-67,-18,2,-23,49,74,-5,-10,-58,16,113,32,19,0,-15,11,1,-14,-15,-15,-46,14,-4,0,35,-49,59,-32,-44,-20,-62,5,-31,-66,38,-67,-15,-38,-32,38,61,12,-21,11,48,-58,41,19,-37,-59,69,10,-1,-8,24,30,33,34,24,-75,-19,50,56,15,53,-82,56,8,12,1,-28,77,47,-32,-24,2,-33,-43,6,-22,-37,56,3,-83,31,16,-41,80,15,-7,-24,-5,20,64,31,-20,15,5,11,-2,3,0,-31,-22,-20,-26,-79,38,6,5,-13,-15,7,29,-8,11,-6,33,-15,57,13,-50,19,32,9,105,16, 
  /* [84][0][][] */ 25,63,-9,-5,-58,30,-5,19,0,67,55,80,-30,18,-69,42,37,-33,11,-25,11,38,-12,-5,8,-9,60,57,-2,-22,24,29,-13,9,-41,2,14,-14,32,-8,-32,41,11,63,64,-63,-30,-29,-8,23,61,31,-43,5,-21,8,99,-98,37,36,44,-3,-22,-24,-36,-20,-2,34,4,19,16,60,-33,-31,64,-3,-15,-67,-18,42,34,9,-3,-12,-32,18,-23,-59,-9,16,-10,30,-7,-20,58,55,3,42,35,-27,-52,-47,-48,-39,7,-10,88,6,82,19,68,40,-21,0,-12,-12,-23,35,-28,40,-13,-2,55,16,61,25,-59,-60,-15,21,91,10,-67,8,21,-52,-63,-67,13,-64,30,106,33,-11,52,47,29,-23,13,-37,-1,43,27,-42,68,-7,22,-32,16,-3,-2,14,-9,50,-7,-5,-34,-37,-51,-18,20,45,-71,28,31,-54,-79,10,-43,61,8,13,25,66,-14,18,19,-71,30,-58,-34,31,36,93,-26,-100,46,-8,2,36,-44,-14,-11,34,-24,17,-31,14,-67,-34,-18,6,-19,33,-42,44,-40,44,-34,17,-98,27,-49,2,4,12,-6,15,77,-4,10,22,34,11,-8,0,-6,96,42,-1,-78,-96,19,-9,-28,8,4,25,-19,12,-43,-22,-34,0,26,-53,-13,11,-64,58,59,-23,32,69,-11,18,-1,-58,40,42,34,-67,-12,-5,-36,23,15,49,-2,-32,-62,84,14,65,5,-3,58,-27,7,-6,-26,-24,-64,3,-20,42,-124,42,13,-41,19,8,-58,28,-52,10,5,-13,-20,-26,-50,42,-101,-73,36,-8,91,84,64,-127,71,-31,22,-37,21,-49,6,36,-39,-34,-8,1,-15,-39,81,12, 
  /* [85][0][][] */ 20,21,31,0,-67,0,-26,-15,-16,20,9,-58,-61,26,5,-20,-20,-12,-62,25,7,8,13,12,3,-44,-20,3,20,-27,-16,2,52,34,-54,19,56,-29,1,-37,-56,39,78,-18,10,32,-13,-9,-13,28,19,105,0,9,12,16,15,-41,14,-29,-7,25,-11,-16,-36,-38,-10,-29,-5,-28,18,-25,-63,0,6,8,-2,-16,26,-5,20,3,-7,-8,127,13,10,66,-44,-48,-56,-7,24,30,-41,-60,2,3,17,-29,-33,-15,-7,-3,32,-24,49,30,-4,-18,-64,-9,1,25,-9,0,19,15,-29,-71,44,9,-23,26,41,-41,-2,-45,54,-20,30,-16,1,35,24,28,-50,-34,-1,23,-25,-18,38,-46,25,-19,14,17,-25,48,19,-45,-9,-44,-41,61,15,-67,-53,-11,-48,-18,36,35,3,-32,6,-12,1,-42,-27,10,5,-8,-8,-49,86,42,22,-16,28,3,-19,61,-27,42,-14,22,72,46,23,-48,-11,50,-42,-7,-12,43,-14,-24,23,12,-7,33,-40,2,-9,59,-6,-2,-48,-41,31,-48,24,-97,-14,28,-8,-38,24,-35,40,-25,-5,17,49,13,-69,36,-74,16,82,-17,-32,-8,28,-15,12,-8,-28,-11,44,-28,-58,96,27,-125,37,-5,-14,39,5,20,23,-22,35,-34,-6,23,-21,-22,-23,-5,-80,19,10,0,1,14,-20,-58,-13,0,-9,-48,-73,34,7,12,8,-21,-7,-32,8,-33,-8,-2,-12,22,-52,-53,30,75,8,-3,-6,-45,-62,6,-29,61,23,29,-29,-18,0,-31,8,-27,23,0,-28,-11,-33,26,-103,-25,-64,-15,53,-24,29,21,-18,-22,39,-4,22,-2,-9,-13,6,-55,47,-9, 
  /* [86][0][][] */ 35,-43,11,56,-10,-43,-69,-45,67,2,52,-73,-23,27,-80,-7,-1,-124,40,-78,42,87,-27,12,53,-5,49,46,54,7,-36,26,27,-24,-6,11,100,-59,112,36,-76,-39,-102,74,67,-12,8,25,-89,-31,93,-3,41,31,-7,-2,57,21,19,25,-39,-54,-44,21,38,-26,-9,16,17,11,3,13,32,48,-24,-44,-8,-27,21,-5,-1,37,2,12,57,-47,61,115,4,34,9,-39,66,28,-31,-24,18,76,9,-16,37,-13,67,-3,6,11,-39,49,-42,18,85,-40,61,70,-3,48,41,-88,27,-56,-40,-39,-18,12,20,-19,3,13,-1,-6,-3,19,54,18,6,-29,22,24,-5,-25,85,-60,-26,34,-46,-9,-1,-24,41,-4,-33,11,27,59,84,-44,-21,52,-25,-35,52,-24,28,-74,-16,10,-8,-1,-27,-44,32,-127,-22,15,-22,0,21,11,97,70,-20,25,-62,11,37,37,-6,19,62,29,11,-32,27,-1,-25,-26,-25,-71,31,10,12,-16,49,-28,44,-2,-76,-26,-5,97,-85,47,-83,-8,32,12,-14,5,-9,-14,120,33,8,50,-15,10,-60,-43,10,50,16,25,-43,92,-4,-11,-45,38,95,24,14,46,-36,52,-63,12,68,-92,-31,-23,13,-67,4,13,20,5,17,49,36,29,84,-41,-23,66,22,-10,-4,17,-91,-64,10,44,-55,10,-25,-35,56,-15,-56,60,59,-24,-55,3,20,9,39,-66,58,68,-97,-44,-50,77,-27,-43,-30,-1,22,-27,-15,-59,-4,33,33,37,5,9,-16,13,10,10,5,70,-15,49,66,-12,12,7,-4,14,-55,57,51,67,40,-10,19,36,-11,-11,55,-44,-95,23, 
  /* [87][0][][] */ -81,31,10,-74,38,31,8,-47,46,43,61,72,-21,-4,-2,37,-28,73,-53,19,-48,8,-9,-12,-26,47,-8,-18,18,-17,-31,12,-53,-33,-1,43,-18,-22,-57,-32,-43,8,22,77,61,-17,-27,-6,65,-35,-31,85,-33,-17,60,51,53,-79,-86,-46,62,-7,-79,24,-28,1,16,-42,-15,39,-19,-8,-12,-21,49,44,-17,93,16,-31,-13,-14,10,40,-57,-19,11,11,-5,24,58,-12,11,-3,1,5,-42,-19,17,-30,88,10,29,32,-21,-40,-53,-9,-7,24,38,-68,-25,0,-7,50,44,22,-68,-24,9,67,3,-23,17,-39,-39,17,-64,7,-88,-51,39,66,0,-35,42,7,-75,-17,-71,72,4,-63,-4,16,43,13,-3,21,1,10,-17,33,78,-127,12,-33,19,18,-79,37,23,-36,10,19,-31,54,-53,25,-36,48,-49,-12,32,72,69,41,-42,-1,-23,-40,-22,68,25,32,79,43,-13,17,-56,30,18,3,61,38,28,11,-17,36,-49,-17,-11,-40,-54,-50,-4,13,-34,-22,-77,-84,-87,55,-8,67,-2,-61,-58,66,104,57,-34,-20,41,8,-67,-47,-55,4,13,-5,13,-62,7,-66,23,40,25,-7,-2,-36,30,63,-27,-12,74,-12,14,14,-56,-22,4,-42,-63,-6,17,27,-3,52,-22,-1,-60,-87,-5,-24,-10,11,24,-30,1,-69,20,-30,-14,33,11,-70,-4,65,-22,32,-6,17,15,-41,35,-1,59,9,57,26,58,24,-37,76,47,0,7,57,-33,69,32,27,1,16,-37,17,34,-82,-29,-111,-88,13,-8,-79,-69,-54,-36,39,-42,13,-34,-11,50,-4,-29,-26,1,-42,31,-97,57,4,28,-16, 
  /* [88][0][][] */ -36,73,29,19,-46,-101,13,15,6,0,24,2,55,45,62,10,26,5,-14,-33,1,80,16,-50,17,5,-54,-9,39,-6,0,19,80,55,-10,-11,-42,-80,19,-57,-20,35,68,25,-18,-3,81,27,-4,-62,37,6,33,-25,87,-14,0,-51,-9,56,-60,48,65,18,41,16,-64,-59,-15,26,62,5,10,49,-12,13,-4,-109,27,33,-6,-35,-56,-4,-23,56,55,-4,-38,27,11,-65,5,23,-18,-13,53,55,-17,-4,0,-18,-66,-78,2,-48,-72,35,15,-6,-77,-51,-8,38,68,-12,-47,29,36,-27,22,-96,38,-6,-87,-127,37,-21,48,-66,9,-79,0,5,-19,6,-2,28,4,-33,19,-18,-69,38,-27,77,17,21,-80,-10,119,-23,-44,2,-11,-19,105,10,8,60,53,45,42,-47,-80,66,6,-51,57,24,-31,74,-26,31,37,37,23,-15,5,-5,-20,0,45,-27,-14,-16,9,21,74,-24,-100,36,-10,-74,-13,107,27,-21,41,-36,-57,67,43,-52,-14,-60,-23,53,58,-19,-2,-43,-3,40,9,60,-10,-21,33,-44,6,-11,28,11,60,27,-81,1,46,21,-43,23,-1,91,95,49,6,-1,33,15,12,-2,-1,-91,40,18,-66,-28,46,-52,53,22,11,-10,-15,27,28,-28,84,-68,5,36,9,6,-29,10,5,45,2,37,21,-28,26,-73,-17,-13,14,-23,-36,-34,32,-71,-50,-22,-8,4,-81,-11,-50,62,10,28,11,26,-29,-26,-52,-3,17,33,-17,50,-51,-54,23,-14,17,-41,-20,-74,41,-13,-27,-92,-25,-17,2,59,-22,-41,35,-21,-60,-3,79,78,-24,-15,69,-47,-28,75,27,-22,73,2, 
  /* [89][0][][] */ 9,-12,-35,-3,25,32,100,26,-122,-32,21,32,-15,26,69,29,39,36,50,41,68,-64,-34,-66,21,6,-61,-12,-33,5,-18,27,-17,-31,-3,-25,-51,13,-18,40,-11,2,46,36,74,-23,-43,-57,-12,9,-21,-18,-24,-49,36,36,116,-39,48,-17,-19,37,-17,-38,21,19,74,38,-15,-24,39,-48,-21,33,-2,48,-30,-27,15,-7,-34,-38,12,53,-42,53,13,-8,45,-2,-54,-28,-32,27,-37,21,-13,72,-43,-67,21,-1,9,15,88,56,-87,-65,-27,18,29,0,-12,-65,-83,-3,12,-7,-4,15,-16,-127,35,18,36,31,43,63,-7,31,-17,23,-20,-16,7,59,-59,-43,-25,0,-11,-31,-20,35,28,-31,-4,-7,-41,50,19,9,9,64,6,52,-36,-14,21,-6,8,-6,-5,38,-22,-1,-33,-16,17,-62,9,40,-14,20,32,-32,0,-13,7,-3,-1,50,-97,-66,-4,10,32,-8,65,-23,36,24,30,-97,-15,-21,-37,-7,-43,36,-6,-2,-74,13,-31,18,-32,36,-43,51,-6,14,-11,64,-21,-75,-78,-4,1,45,45,-52,-10,43,19,-7,-32,32,-36,38,-1,1,-47,3,52,-20,-47,15,35,74,38,-97,-38,-22,-17,-27,44,1,13,-10,0,-16,-14,-50,-59,29,-24,-29,66,-61,11,67,-3,17,22,65,-41,49,13,38,-40,55,14,10,-10,-41,39,-28,-48,37,31,-19,23,27,8,-64,10,-30,-85,-1,-2,72,-56,68,12,-82,-40,-67,-31,-37,-101,56,-103,6,29,112,68,48,78,50,40,-26,-23,-5,-18,29,36,16,-34,28,2,23,53,-82,-12,67,-5,2,4,-21,3,44,71,16,43,21, 
  /* [90][0][][] */ -32,28,76,8,-1,-26,15,9,29,-2,-2,20,8,-25,28,-32,6,-4,24,13,40,-36,26,48,24,-16,-32,30,-37,20,23,-53,-12,43,62,35,58,35,74,63,-86,32,-54,8,-46,-53,6,-43,-53,-41,-108,-24,-47,54,-66,3,-28,-7,-41,-32,87,127,80,-11,-3,-11,-9,58,-10,-62,-49,-37,7,-15,-23,18,75,-11,8,-16,22,24,-36,-22,-77,46,-28,-42,-15,1,79,16,-22,-7,42,43,-56,-68,-33,-56,22,19,-53,17,45,81,15,-53,-77,-33,-67,45,-46,14,-29,-38,23,-33,-33,45,48,-38,30,-82,-52,-18,-15,-9,36,-36,20,-6,-38,-8,73,35,-5,-23,46,-45,10,38,72,7,-51,50,48,-59,28,24,32,52,-36,-21,-16,40,28,-1,39,10,79,-11,-25,63,-75,-88,-23,-19,62,9,-17,29,45,-36,1,43,-24,97,41,21,65,-25,-18,-45,57,-49,7,0,-5,19,8,-59,-20,-74,57,31,62,-47,48,43,38,-109,66,-46,-58,72,10,-29,-19,-24,26,-10,53,14,-28,-15,16,-42,59,-39,34,-36,24,64,27,26,63,-38,7,4,-9,43,11,12,-28,-25,-34,30,22,17,20,41,24,-24,52,-32,-43,-26,67,1,-86,25,7,3,-36,-41,23,-7,-1,30,9,-28,-17,-54,-69,-2,38,-4,3,18,-29,-49,46,-42,-36,-6,-27,-16,-17,52,-81,29,-53,-91,31,55,-9,-71,17,102,-56,72,0,-11,-53,62,1,1,41,-27,-58,-1,-36,-35,-15,5,90,41,9,43,-21,3,16,8,-75,20,98,-40,49,22,-19,-3,-35,-63,-52,7,32,89,67,-17,35,2,-21,39,14,58, 
  /* [91][0][][] */ -34,-28,-49,33,56,39,-56,-22,-61,-41,40,-23,-45,6,32,20,6,18,-16,4,-4,-1,37,-20,35,-20,23,9,-13,3,10,-16,22,-18,-3,73,-33,-1,-29,-18,-75,-29,-65,59,27,-12,11,24,-19,-7,-29,-127,-4,-7,-25,-4,-11,-16,53,33,-10,-37,-26,-24,-6,-21,49,7,-4,-39,-9,5,-35,3,-20,36,1,8,-26,-34,15,12,21,-14,-40,62,-28,-8,-43,21,-16,20,5,51,-2,-8,-39,0,-62,7,-9,38,-15,-25,-12,-3,-63,5,-3,67,-73,-45,10,-10,53,-42,-42,13,57,-49,-12,11,-23,-8,-8,3,12,-72,-25,20,42,-10,0,2,-11,8,-21,-9,11,31,25,20,-36,-3,23,20,-36,-38,-19,9,24,-60,9,-17,-3,52,-7,41,2,31,-25,-31,-25,-1,32,0,50,-29,14,50,-19,62,89,20,-25,14,29,-25,-16,27,-1,4,-26,61,-2,43,8,50,-1,6,-17,46,18,-23,-20,4,27,47,9,-23,-19,-19,20,24,-15,-5,-47,-49,40,-21,-46,-38,-50,59,-34,-25,-25,-20,-8,-41,-31,-52,1,12,4,-41,3,9,16,-14,-18,9,-24,32,-3,65,-2,23,-13,-40,-51,-21,-40,-21,-21,25,-73,-27,-22,1,10,20,-25,35,-12,-18,-12,-18,-20,-26,18,-11,36,50,18,-73,-1,14,62,-53,0,-13,11,-39,20,-4,-30,41,1,109,-19,45,4,3,20,-17,-18,-37,19,-5,48,15,29,63,-17,73,-3,42,57,-3,7,-7,15,-43,19,9,29,-18,14,-1,12,-49,-6,11,34,55,-13,-35,11,-17,-5,-16,-7,9,8,-16,0,24,-7,73,7,28,-6,61,-70,-7, 
  /* [92][0][][] */ -29,-47,-9,36,-19,-8,-12,48,0,-51,-11,-15,-20,3,-22,47,0,8,7,-30,12,-15,40,31,-11,-6,-47,22,7,19,0,16,19,36,-2,35,2,-47,33,62,-13,-7,4,-2,-17,7,-55,-3,-17,2,24,5,-5,11,-35,1,-32,9,-65,9,1,-28,-64,31,-31,23,48,57,21,24,-3,12,-23,-34,30,46,-18,11,-21,-24,-44,3,2,12,-1,30,-17,-60,18,7,8,17,16,-49,-5,9,52,17,27,-22,-5,-19,-3,2,-13,-34,11,-84,52,-3,2,31,-16,-19,-45,47,0,12,-44,-61,-24,7,-5,19,-26,-52,24,1,-41,-38,30,7,28,-1,-35,30,-20,0,-14,-25,35,24,-15,-41,24,45,-6,-23,-25,42,28,12,-55,-14,-30,30,48,-58,-17,25,-5,-17,14,-14,2,-10,17,31,12,80,-8,31,1,4,3,6,54,-37,-24,21,13,-38,-15,9,-19,20,10,-10,-17,16,-12,53,18,-15,-13,-16,-2,-31,28,-2,-5,-14,13,-68,-62,10,1,54,-1,19,43,-19,18,4,-4,-28,-9,40,-8,0,-46,-13,-36,-28,-19,-19,-8,20,-22,-31,-30,-42,-24,43,32,-34,39,-13,12,-21,-51,-4,2,-22,-4,42,-9,-23,12,-7,63,-43,-9,48,-28,-31,-30,11,-52,26,-7,6,-7,22,30,-16,3,-57,-36,33,26,15,-21,25,9,6,-4,16,-4,1,-3,-27,17,41,-20,10,39,2,28,1,51,45,-13,-45,127,-12,-23,-15,18,-3,33,-12,-19,-4,4,-18,-25,4,39,67,26,-1,8,10,-61,27,15,-20,-12,1,42,-27,2,-42,-13,6,36,-32,-10,32,-10,56,25,2,-21,-19, 
  /* [93][0][][] */ 99,-7,-42,-36,-2,32,-19,68,38,-18,20,6,-19,71,-30,24,-21,-24,-50,4,7,-20,48,32,115,14,-29,58,-5,-27,58,-39,30,72,34,25,0,18,-4,-17,101,-5,29,-1,65,20,39,49,36,-32,24,-9,-51,20,-11,13,41,67,-45,8,-6,-10,65,3,-1,-2,19,50,13,127,-42,32,-2,25,-7,11,13,-51,-15,-25,46,7,13,87,-66,-36,-73,57,-44,56,-39,47,41,45,20,-7,18,-71,31,-10,-48,40,-37,15,43,-100,27,-5,-9,67,59,-8,-24,-15,-13,-68,-28,-44,47,-28,-59,45,14,13,-18,20,-33,-16,-16,-28,-29,18,5,20,2,5,36,10,27,-24,-6,-35,-7,16,-38,14,-15,-19,4,1,-8,-51,-15,10,-32,-63,22,-1,5,-19,-6,-35,-32,12,36,-7,21,-10,67,-7,-2,6,-24,33,92,-10,-30,-30,35,44,42,-73,21,4,62,10,22,-28,12,2,37,0,1,1,75,-41,-8,20,25,49,-9,-8,-39,-29,54,-17,67,-42,-34,87,15,-19,25,38,5,-46,-9,26,-10,27,37,-14,-9,7,17,-48,-3,13,1,57,-25,-59,-79,7,-97,24,-67,-34,10,-36,62,0,23,93,41,18,-42,-45,13,-52,56,-22,-2,-15,38,20,14,17,20,4,-3,-28,45,37,-2,11,43,3,49,15,15,3,-53,-30,7,31,-15,-46,-19,34,34,-54,-35,-29,-16,-12,-21,15,-63,-55,-10,21,62,7,-24,-20,11,-26,50,-31,59,9,-26,44,19,5,-30,-17,51,-33,122,-10,-98,28,10,47,-33,-37,-19,-118,-26,0,-3,-51,24,61,14,50,54,20,-38,54,15,13,-39,-43, 
  /* [94][0][][] */ 10,31,94,3,-2,-31,63,18,24,115,40,-54,-28,88,-32,-52,-7,47,50,-113,-121,13,-126,11,53,28,7,43,-19,-15,-26,35,58,-52,35,7,-77,-46,-13,-13,127,18,-55,52,45,72,17,-14,-51,-11,22,-14,-1,34,-52,42,-70,-18,-49,-15,-1,23,21,31,-29,66,-74,-46,29,-8,28,-49,-12,18,26,36,28,-50,38,32,-86,111,-6,59,117,32,-83,-123,85,-11,-54,46,22,-18,-18,29,-75,91,56,8,8,81,62,36,-40,-14,50,-22,9,20,55,-36,-7,25,77,-2,0,-11,-6,74,-122,-50,22,-1,-22,-7,8,20,30,-101,9,-70,-24,10,-6,19,-26,20,-75,23,66,-67,93,46,-51,19,46,-10,83,33,37,-30,109,34,-51,41,-94,-36,3,23,45,-9,-60,-7,8,-19,56,-22,17,10,-17,-16,8,20,-34,33,-22,4,-23,8,53,55,35,-12,49,-44,-12,41,11,26,-72,-23,50,27,30,30,59,-1,-8,-5,-55,-40,-43,-11,49,58,-15,7,-35,-4,-5,-82,-24,39,-97,23,59,-61,3,3,-1,41,-60,14,-23,6,107,-19,-22,20,-93,-31,-14,-56,5,-23,60,-15,73,41,-97,-61,-67,21,-13,-29,-62,-104,-6,98,84,19,10,2,55,-96,-90,-9,-40,23,2,43,97,-9,1,-45,54,11,3,27,7,7,10,3,22,14,115,63,-31,-22,10,-13,21,-51,-87,74,-45,46,-10,35,58,22,-40,9,-17,11,-31,29,23,56,-38,17,21,-12,6,-14,-61,5,32,50,-39,-11,-63,73,-99,47,-18,36,2,-35,-77,-52,-24,-21,43,-11,-73,-40,-105,-24,-81,92,75,-14,-49,-59, 
  /* [95][0][][] */ -49,3,22,72,-23,1,25,7,-7,-51,-23,23,20,20,-81,-36,28,14,-59,53,-25,-66,48,5,-59,23,7,-13,32,-22,-38,40,-6,-3,24,38,-48,-42,-38,42,-21,-33,3,-23,32,-4,-37,-54,-62,21,-2,-43,29,-28,-52,9,-36,-16,39,-91,-13,121,29,-34,-84,-37,-42,4,-3,16,-78,-12,103,17,-13,-30,-64,-54,-19,73,30,54,13,-87,13,21,67,-14,14,-25,-32,32,-87,72,9,11,-62,-6,-65,-12,-18,-11,24,40,-28,30,57,-13,-39,19,17,14,-43,14,-10,56,19,57,-11,-46,-5,36,40,34,-76,13,-53,58,24,-23,-40,-4,-37,8,-68,104,-10,-58,35,-49,-83,63,-31,-75,63,51,-18,71,49,-45,26,88,56,-26,-2,32,-9,74,-75,-13,-29,29,21,-46,13,-74,46,-46,-8,-53,72,-45,-37,-2,-8,-44,15,-14,-16,19,-7,-37,-37,-34,-75,5,46,0,43,-22,-1,42,-41,-5,-17,-35,15,60,-3,-90,-57,-22,-27,-19,59,37,-52,6,-42,25,-24,-10,-13,-21,-18,11,-21,-57,24,-28,-23,-39,-12,-37,-3,5,36,-34,0,-25,-24,78,47,57,-39,-18,10,0,13,17,3,119,-90,-28,8,-11,15,32,-92,-63,22,-14,16,19,-9,-20,-73,-5,22,-20,7,53,33,-21,-43,18,127,27,-91,2,33,-36,41,19,21,-15,67,14,-56,101,-126,-18,15,81,12,4,16,25,-14,-68,-24,22,-102,58,-29,-39,45,-27,46,-11,6,-28,9,-60,28,-46,-40,52,36,-46,22,-16,55,-9,24,16,-44,-37,-5,-8,-7,-14,18,-3,-6,48,-7,-30,-26,-2,11,5,-63,66,10,53, 
  /* [96][0][][] */ -38,31,43,-100,32,2,70,54,38,21,60,-77,-68,-7,55,15,-43,-1,-51,-4,12,-42,11,-30,107,4,12,-40,-31,14,-10,0,-22,8,10,-27,63,-10,24,65,-56,-41,-44,-18,16,40,42,-77,-20,15,-22,26,-3,-51,28,52,17,-36,41,-31,-29,16,-27,-24,-41,45,-24,-11,27,-23,-13,0,53,-45,65,-10,2,-29,-20,-11,-14,25,-66,29,37,69,-16,-89,6,16,20,42,9,28,-86,51,31,-73,1,-28,-33,-32,-45,5,-27,-9,-9,-38,-5,17,-17,-110,-46,50,50,16,70,-48,-15,3,-60,-65,-15,46,19,-21,-83,-64,57,28,15,8,25,28,1,-86,-2,29,56,6,26,25,61,6,21,-8,16,-60,39,-6,50,54,-11,7,16,-75,15,39,-42,-1,48,25,3,-32,1,28,-6,-24,-36,50,28,-37,8,-92,45,-10,-56,-21,14,-30,19,-55,-29,50,25,-30,-19,42,14,-62,-24,-31,11,-55,-30,7,-89,-121,-47,35,-33,11,95,-11,17,6,-12,43,-49,46,3,8,-62,-4,-56,41,-38,-3,-11,-7,37,-86,32,87,51,16,20,-31,-38,33,24,0,127,12,25,20,4,31,-36,10,-2,-78,11,-78,10,-7,-11,44,17,33,-20,12,-21,-102,-74,11,-19,-3,-73,7,-34,32,-30,-57,-24,-45,-34,20,-17,26,-16,35,-6,69,-56,39,-20,-70,16,4,34,-20,24,9,-10,71,27,-8,-59,50,-2,17,-60,108,40,-16,-1,17,19,-14,-10,-53,34,78,81,-42,-51,-38,-66,75,7,54,35,-42,50,-45,-59,-43,38,-22,40,-57,-104,-49,-4,23,12,105,20,89,37,13,-6,-48,29,-51, 
  /* [97][0][][] */ 1,-16,23,15,60,-16,11,-88,-106,34,-6,17,-9,-37,43,66,72,26,26,-25,18,11,56,-60,27,17,-64,-6,35,-7,56,-16,-58,70,-59,68,77,31,-57,29,6,-10,-48,25,4,6,1,-12,-82,-28,-10,-6,-21,6,-16,-43,33,-17,39,39,-38,-29,-9,4,37,34,-2,-42,-7,43,-60,49,16,57,5,47,98,-28,31,-68,3,-20,0,41,8,-4,-17,-43,35,57,-3,-10,26,69,-32,127,-21,-24,16,34,-58,26,37,-62,79,14,24,-28,-78,-22,-3,4,-1,32,-3,43,-24,34,-61,0,-53,50,0,28,31,34,-34,78,-27,6,-29,-32,12,12,15,-2,21,89,53,-18,0,-2,8,-67,3,-4,5,15,-40,7,-18,22,-54,37,1,-23,-6,-7,37,0,17,-2,-7,52,41,-9,27,59,-19,62,6,-11,-31,-16,34,14,67,9,-60,38,2,0,-49,-26,-25,17,44,40,-9,31,18,-67,28,11,-24,1,73,-64,-18,-75,-48,-7,-48,49,-6,-51,28,16,20,-12,6,4,-5,-15,63,48,26,-35,-8,-24,-54,-32,22,-34,-29,-47,55,-9,39,-53,-64,19,1,-49,-7,-29,8,-52,-1,14,61,42,-5,-48,40,47,-17,-23,-40,33,-67,-38,41,10,-13,27,-60,-53,-57,-58,1,-9,-14,-67,-33,26,-56,17,-5,14,-23,-7,55,31,-43,-44,-33,39,-50,-31,45,1,22,-36,41,35,-14,12,34,67,-64,18,-17,52,3,63,-9,-15,-2,-39,46,-8,-32,-6,-11,20,-36,-22,1,-8,58,27,17,17,17,-69,-69,11,-11,-23,2,35,14,-20,-48,46,-79,-52,-15,-15,42,34,-7,-31,-2,25, 
  /* [98][0][][] */ 24,9,-3,-20,34,-15,9,31,26,15,-95,50,53,34,-32,-9,44,-43,-43,26,38,-6,7,-59,-114,-15,-68,48,10,2,-21,-79,-91,-27,-50,-7,6,49,-39,-37,-64,15,73,2,9,-26,32,45,-65,-7,-52,34,26,-30,-10,46,-2,-30,-2,-62,-13,61,-26,60,-94,20,-47,-10,15,105,27,19,-26,-55,28,-34,-6,-6,14,45,-8,5,-127,-4,10,6,-33,-75,33,-22,-42,11,33,8,39,14,31,6,32,33,7,51,47,-31,2,-3,77,1,-35,26,-31,3,36,-27,4,-28,-23,-2,20,-2,-20,-2,8,19,-15,-56,-29,41,12,-33,-3,-1,2,-6,-22,-49,-3,24,-55,14,-60,49,-43,-15,16,93,10,35,51,59,16,58,50,79,7,33,-13,49,34,-2,36,-25,1,22,50,-50,-5,-65,-11,31,18,21,93,65,124,48,10,-48,65,-61,17,4,15,20,-13,5,-63,-8,65,9,22,-48,-29,-34,-35,27,-29,-44,3,50,12,1,-10,36,-58,-49,28,-43,36,-21,4,36,-45,-18,29,50,-53,-27,8,10,39,-10,-46,-17,13,10,-114,35,5,-30,9,-23,-32,-39,6,-31,-20,-65,-63,-28,12,-37,-23,35,10,-29,-78,-35,-26,-28,5,13,-9,16,12,69,-30,-40,21,-79,5,-32,-75,-9,-38,-1,62,-64,-18,-18,49,15,-26,-11,15,-25,49,-34,-26,-2,-44,-26,22,54,-56,-9,-30,18,24,-17,23,-20,38,-24,-6,67,-50,-4,28,47,17,-112,57,-14,-1,-8,32,25,-16,4,0,72,-6,-23,-61,55,14,-12,15,-24,-2,36,-56,5,-17,45,28,12,-45,51,11,40,15,-66,-16,-16, 
  /* [99][0][][] */ 8,-20,-35,-26,-14,-12,9,63,-6,13,29,12,8,-73,-11,31,5,-93,-12,31,-25,55,25,28,41,74,-39,41,17,-2,-9,23,-37,16,-32,-23,36,52,-79,2,-28,40,-34,-7,43,-7,-19,-12,-42,22,20,19,-22,-52,-6,1,13,53,-40,16,25,-34,51,-54,-43,-46,17,43,-9,83,7,-44,-24,-45,-5,-62,-35,15,12,49,-35,-51,-29,-17,17,14,-24,45,43,14,32,-29,58,-45,-61,-23,-72,52,-22,31,7,50,0,32,-29,-21,10,-3,37,-16,55,3,-25,-2,-38,-13,76,-47,17,10,26,-85,26,-49,-20,-12,84,-54,-22,-19,45,18,82,18,-1,57,45,19,20,29,-44,-16,40,1,-16,-17,-58,6,-13,7,-2,20,-17,-20,-3,9,-10,-35,14,82,-16,-30,3,-31,50,-50,23,18,16,24,9,18,5,-94,-68,7,11,3,-17,37,-27,33,-20,-20,-27,-10,-47,-19,-3,-1,26,40,-8,7,-28,30,14,48,0,-14,49,-38,4,36,-49,3,29,0,24,39,8,-4,6,51,16,27,51,-102,50,-18,2,-27,17,-56,44,47,-29,-21,41,-31,35,23,22,50,-43,25,15,-16,-6,-2,-40,23,-53,17,-44,-26,19,-36,1,-51,-26,33,15,47,41,-76,15,-31,-23,-33,-14,-57,20,60,32,-32,31,3,61,-39,-16,17,39,54,17,12,11,-4,-43,24,-127,39,39,-35,-36,-15,-18,2,-32,-29,-16,-53,8,-42,-33,-9,26,-68,5,-11,19,6,25,-46,31,-28,42,-20,-39,103,16,42,-65,-23,-44,-103,25,55,-32,-9,20,-17,-7,-40,-8,-39,-38,-19,2,-8,8,-19,56,18,6,2, 
  /* [100][0][][] */ -22,52,-10,-57,22,-100,-22,8,36,-3,-11,57,-64,25,-27,6,-34,31,45,-16,-46,34,43,104,-59,-9,-47,48,-54,9,-40,21,-93,23,33,32,9,-69,38,-33,-32,-42,-23,33,32,20,-30,-21,17,13,-95,127,-81,17,-93,84,-32,10,24,-30,12,53,21,-67,-21,18,-33,23,-39,-28,-57,-41,76,-19,-32,-86,42,79,-38,8,-67,5,-1,-37,-25,-4,-51,0,40,2,46,-33,-37,-39,49,31,1,-12,57,1,-5,-27,55,-41,42,53,-24,-14,-104,18,68,-9,-31,-39,15,59,-8,2,9,34,-16,18,35,-32,85,-25,-9,-60,29,-55,44,-2,16,-55,-11,3,-113,50,-47,43,93,-76,20,64,-18,-2,-36,22,-23,-18,16,-16,19,-100,-2,-8,31,73,-31,21,15,35,20,-32,86,21,-15,-55,4,14,-32,-18,-66,-25,0,17,10,42,30,13,7,17,9,70,23,-87,40,-71,-53,42,-87,-80,-69,10,64,-28,-56,-5,0,-70,95,33,-63,-61,31,-40,6,-94,51,-22,-9,37,37,-25,39,29,12,65,3,21,41,-76,2,54,-2,34,-119,32,69,-8,-46,33,-64,-41,54,39,61,30,-120,22,32,-82,52,-9,83,-12,-15,89,82,116,-17,53,24,27,57,23,6,10,36,-18,-4,-19,46,-28,-39,-71,51,-121,57,-50,55,71,5,29,20,-44,40,63,47,-41,60,78,-29,29,-29,-28,18,-5,38,-51,-38,-3,-46,115,2,-79,86,-3,7,-62,-27,20,-121,-19,-15,-5,-40,-80,-7,78,19,-87,-16,16,-35,75,-12,10,7,44,4,74,-74,-26,35,40,15,69,-62,-76,44,-43,-25,-83,87,3, 
  /* [101][0][][] */ -64,67,-21,-8,-21,24,49,-26,-33,-22,30,-30,-22,-28,-37,28,64,16,-47,3,-2,-74,-25,-28,29,28,-33,-45,-24,-60,54,66,26,-17,30,7,21,26,-127,8,-58,-20,1,10,-50,14,41,-53,-69,-15,28,57,10,68,46,-14,-5,65,9,-77,87,-66,32,-3,-8,-41,-14,25,-29,-24,45,-32,-39,37,19,45,-57,-12,-31,-4,9,10,-28,88,43,-51,38,-6,47,0,-43,-69,-17,-53,-36,2,-21,2,-56,36,-30,-17,-33,-70,-21,18,-13,7,-18,57,34,5,-51,-23,-12,-11,-56,30,9,43,-1,-57,39,-41,-1,-50,0,-44,-37,34,-48,27,36,-33,-45,4,-42,-10,-53,11,12,32,-47,45,45,30,-16,17,-37,31,-6,4,21,-2,35,-9,-27,-16,-27,35,39,11,-39,-28,16,-78,-23,14,-47,3,66,-6,2,-70,15,-13,9,-32,-6,30,85,-6,37,70,-55,18,12,13,37,30,84,-3,-7,12,-23,29,-74,-29,62,20,24,7,-11,-79,75,1,-44,-3,-31,-26,14,-15,37,-13,-5,-31,-15,41,38,-29,25,8,-14,-41,-15,-6,-24,-21,-25,81,71,-10,79,-39,-37,-27,84,-3,3,-28,21,-12,28,21,-22,-14,-24,-23,-11,39,41,41,-60,-38,7,-35,4,-30,6,9,10,-7,-43,60,2,15,31,-34,10,5,44,6,-10,24,14,9,-19,88,-48,-2,29,-4,7,-47,-50,74,-28,-10,-6,-7,39,69,26,19,-77,-34,2,-20,71,-43,2,-4,-29,-45,-30,15,82,74,29,44,-13,-26,-77,-8,37,37,40,-36,76,-38,-55,-26,-46,69,24,22,-18,-67,65,41,-23,10,-98,-44,-36,-24, 
  /* [102][0][][] */ -51,46,-11,-14,-13,39,26,-12,-34,14,-82,49,-53,-14,-29,-52,-4,-99,11,11,-8,16,54,41,26,-48,12,15,0,-29,24,37,-57,-29,-30,-8,3,79,34,52,27,-32,-23,11,27,-40,35,81,44,53,50,86,5,31,-14,-20,-22,-54,-37,27,69,10,106,-50,-28,4,2,40,-23,-50,-37,6,91,-12,-7,-35,-53,-106,19,-47,-17,52,25,25,15,15,-9,-42,-39,-49,-14,36,-28,-20,-24,45,13,-45,-7,-37,-46,-6,51,13,-35,-36,-54,41,-5,12,28,17,59,-93,-48,46,-9,-14,-13,-60,53,21,39,-59,45,-26,44,42,35,-50,-40,22,29,21,49,35,-4,8,55,40,-75,4,43,-66,-30,-9,-67,0,-41,-21,-13,61,36,-29,-21,34,64,29,7,34,73,-8,-13,67,-35,28,-10,97,-9,-23,24,-2,12,20,2,-6,29,48,79,20,-41,13,-94,-36,-32,-36,4,72,-23,32,-23,28,-4,66,-40,39,-60,-36,17,74,-70,-24,72,-88,-28,-7,10,-33,-58,4,-5,-54,-7,2,50,61,-6,5,-6,127,0,-24,-3,-50,16,-37,78,0,9,6,-20,34,83,-3,38,-32,53,118,-3,-20,58,-16,-53,-68,44,6,-41,-113,9,44,-3,14,10,39,9,40,25,24,11,27,-42,-25,-10,15,30,-25,10,5,23,-17,23,27,-13,-6,-37,-26,-31,-67,34,-10,-28,-83,-38,10,-23,-13,-9,-9,-19,15,34,-41,13,-57,-6,73,17,25,36,14,67,-44,52,12,31,12,-30,30,29,-44,-56,-24,-71,-14,-16,93,8,63,23,14,29,37,120,-2,107,-23,-6,8,0,23,-28,39,-4,12,-14,-61, 
  /* [103][0][][] */ 3,18,13,-7,-31,-46,31,16,-27,32,63,19,37,20,-28,35,-9,48,-18,37,51,-19,-39,35,50,2,-86,32,26,-10,26,-7,-4,32,-27,-58,-46,4,-41,8,24,-35,-25,-5,-44,28,48,-32,-19,6,-29,4,79,-2,1,-18,7,21,38,4,-9,-58,5,4,-19,40,-5,57,18,-41,3,-37,66,-10,20,-50,-44,-17,8,7,-20,-52,40,-26,-38,6,-79,-56,-58,-18,-24,-17,17,-50,-28,-37,30,-41,-30,-61,-46,-22,29,-9,-8,-39,-9,-39,53,-8,31,32,43,-2,42,-13,-13,-66,-8,25,-6,31,27,-9,-44,3,5,58,26,1,-49,43,12,5,-8,70,12,-28,-8,-36,13,2,-58,3,48,-10,41,70,-26,-33,51,12,-20,35,39,30,71,-6,14,-55,-15,-42,-19,-25,-12,-38,-30,-48,25,-51,35,3,21,-18,-47,-21,-14,68,19,5,27,11,13,16,33,-12,21,68,-24,-60,40,12,-22,25,4,41,49,48,-24,-9,-32,-45,-30,-7,-5,10,30,70,47,-82,-7,-27,-10,11,12,0,27,-21,-31,18,59,-30,-3,20,0,55,-19,-7,-10,-55,9,-10,-27,12,-22,-3,-5,-3,-38,45,-16,28,29,-1,127,30,-38,59,-29,63,-21,-23,-7,12,-26,62,31,24,-60,9,-15,38,2,12,21,-98,-22,-41,87,-24,1,42,-38,-11,-36,4,-37,-12,27,7,-50,-12,-52,-15,-10,0,6,62,19,21,-75,-30,48,-11,27,-36,-44,27,11,28,20,-25,5,-15,49,-20,3,37,81,21,-38,21,-62,9,2,40,35,-2,-10,12,5,5,7,-40,-4,-2,23,14,-4,-9,24,2,50,-45,-7,2, 
  /* [104][0][][] */ -23,-20,-7,-3,-24,27,-23,-47,9,18,-51,-68,-6,-14,-60,5,64,58,-44,-27,-34,-33,-16,-14,27,23,-32,24,19,2,-44,40,-23,-12,3,18,20,-11,67,-50,43,-33,-39,1,-67,47,-58,-59,1,-11,13,28,-2,-13,31,-4,-11,58,-78,61,15,-9,-12,-17,12,-12,-4,5,38,28,-10,69,8,-4,-3,-42,12,-12,-25,0,-9,-56,17,-28,-34,2,-70,-15,-8,-23,59,7,-19,-42,1,-36,-78,-39,-26,14,-50,-31,37,-9,-19,-27,-27,59,-127,-76,5,19,19,-30,41,2,-7,-10,19,69,-49,23,-29,11,-36,5,-1,-35,-57,22,13,17,-23,-33,-7,8,-15,-39,7,43,-75,-5,14,29,17,-15,-13,29,-13,-15,19,-10,4,-54,-22,16,-7,-4,-64,-57,33,-30,-6,-5,46,-37,-22,25,-8,-22,17,-26,10,-49,-23,-30,65,6,19,2,-33,35,-9,-40,-40,17,-19,-63,40,51,30,-58,27,-62,2,-21,15,-40,11,35,-1,-10,48,-47,-5,-53,40,49,26,26,27,-1,35,-14,22,-16,-24,39,-16,-22,-18,-20,-27,33,17,12,1,-30,-13,-29,38,52,30,56,-42,8,87,18,19,12,-18,-48,-17,23,-26,6,-17,9,-14,-33,42,21,-9,-28,101,25,-11,-25,-46,-21,-39,-12,-16,-24,-6,22,-26,-41,-13,-14,30,21,14,13,49,-23,4,-26,-65,1,-107,-43,-25,4,46,-32,-56,-34,28,7,53,14,-79,-18,-36,-25,18,69,35,16,66,17,-2,-1,24,45,-30,-36,-69,-85,17,-23,-47,-29,78,-17,-16,-25,-63,30,-37,-8,13,30,-9,36,2,37,3,32,47,-6,88,46,19,-4, 
  /* [105][0][][] */ -65,17,-18,24,10,0,-20,-14,0,11,-22,79,10,64,34,-14,-15,-21,-60,36,-27,11,32,3,37,17,-50,15,27,-32,6,-16,6,37,-45,11,-50,58,-32,-14,-41,0,12,41,-81,14,-51,48,-98,16,1,66,50,-31,26,41,-9,-14,-16,-12,22,17,46,-14,-35,-1,-23,23,-44,-49,23,-24,16,-28,-41,-2,-17,-28,21,-36,-18,28,-41,35,-57,25,-25,-20,-5,-17,59,27,-20,16,73,-14,-34,15,116,12,-16,26,-19,-19,-28,3,14,64,38,-38,-7,54,-35,1,86,-50,-45,-1,87,-38,8,9,12,-55,-55,-7,-14,2,-5,39,-20,5,3,-7,-34,-53,35,48,5,-14,24,-6,-87,12,37,40,14,48,-26,17,-86,-4,-27,10,-10,-3,-58,-39,-70,0,-87,-12,-17,-12,1,48,-16,-52,0,10,-16,-20,-36,-30,78,7,9,16,10,85,18,-13,-17,-48,-30,0,14,-28,-50,-34,23,-3,62,-74,-49,-84,20,-42,51,82,-21,51,52,66,28,-40,51,-31,14,25,22,2,44,-1,-22,-127,-3,59,21,-5,13,39,15,4,-24,-13,-42,30,-5,20,-56,3,41,-34,6,-11,18,26,24,52,6,17,-112,-45,20,20,-35,37,6,39,0,-75,30,17,-45,-56,52,-24,-29,-14,3,-34,7,7,-14,4,-47,-4,-9,19,-22,-2,39,-28,56,-42,63,79,33,62,-68,-29,23,22,-19,-13,-14,-63,-41,-36,-7,6,-2,-4,44,17,-4,21,21,52,-97,22,-62,33,18,-39,-5,-7,-18,23,0,-27,-14,-21,-12,2,63,-14,59,29,-46,41,-25,-8,-22,39,40,-26,36,-24,44,81,2,48,22,-46, 
  /* [106][0][][] */ 25,-59,13,-48,-10,-18,-33,-43,113,46,2,57,-49,7,-14,62,53,64,-23,-91,-7,-90,-63,-22,23,-50,-91,-17,53,-5,13,-12,59,61,-41,16,24,15,-38,-87,41,-121,-76,-34,21,-54,-33,-65,-14,7,-7,61,19,25,15,24,57,17,66,3,49,-17,-10,107,-40,-35,79,-81,52,3,78,-31,-23,-42,-7,11,32,6,0,13,-109,93,-44,5,26,14,3,-61,0,89,-14,-17,42,-36,42,-26,21,-60,-13,-4,-11,-13,40,28,39,127,-35,-59,51,-45,-1,-3,-61,-52,-10,12,-23,11,55,-20,31,-57,-47,22,82,-32,-9,-69,19,-28,78,-6,-7,-21,28,-16,6,-4,73,-13,-78,47,50,18,43,12,44,99,-21,41,-4,-34,-37,51,-83,-26,9,-20,63,80,-21,48,-17,-21,-3,-48,87,-13,-19,-68,-24,13,-69,-44,-93,-22,4,8,10,-24,-61,-14,-39,32,46,-7,-19,-34,-17,81,-44,-1,4,-10,97,-17,-20,49,13,21,-34,8,-36,36,58,5,87,-49,-26,-54,-53,13,-45,-60,-16,-73,-2,-4,-17,66,23,30,-26,-55,0,20,-69,24,36,71,59,-34,-8,57,15,-11,10,48,38,56,35,3,-1,46,0,-25,-87,57,2,-24,3,-42,44,6,-34,31,-41,-89,36,-43,-2,21,-1,100,15,127,65,-30,15,-20,-9,-77,47,15,104,-37,-107,-60,61,59,-35,-11,-18,-70,-21,-11,25,-21,-68,28,18,19,24,22,-25,-41,-29,12,-65,-18,35,-46,-10,98,6,-46,5,10,-47,-43,-20,-1,-69,1,11,49,-6,-32,44,7,21,-40,-54,34,20,-77,-58,4,-120,-2,-49,23,103,-70,-33,-33, 
  /* [107][0][][] */ -7,96,22,-46,15,-2,7,-67,-28,-6,11,127,19,-1,-18,-43,37,-42,8,36,88,-4,20,37,22,6,-31,63,16,-11,-11,25,-2,-4,7,32,15,-14,38,76,52,50,18,-73,-45,4,-22,25,-16,-42,-28,-44,-42,-16,-22,-22,16,-11,-82,-29,-54,-19,35,-74,-25,-22,-5,-33,-36,-40,-11,-24,-29,4,-35,44,-33,19,0,-25,-19,39,-26,24,-11,-2,73,-46,-30,-42,4,-14,-28,126,-31,51,-14,23,-69,-28,6,-18,-19,-39,0,-99,-21,-9,-48,2,40,-1,-51,-11,-27,-56,-37,-6,-44,12,20,-38,68,-9,3,-58,3,-46,18,1,35,-30,-23,-26,-26,51,-7,2,26,-12,0,-36,65,45,10,24,2,4,-58,20,9,51,46,50,34,-40,16,-33,-13,-32,-4,-1,-7,-45,-26,-39,0,-40,-6,-64,75,25,-32,-6,-42,24,65,3,-11,-8,-21,29,6,7,4,16,-16,-8,-57,12,-17,-8,-6,-1,-3,-11,-7,-35,-16,49,44,18,3,40,-39,50,-34,17,-4,-52,-35,77,10,-64,-54,13,4,-60,-36,10,-10,31,-37,-24,-23,-22,-73,-25,-36,-11,-46,12,-108,6,12,-89,12,-21,51,-22,-69,27,12,-17,-4,-48,-14,10,-24,-43,-29,-15,-48,-27,15,12,6,3,-37,-17,-49,14,-16,-1,-17,9,-66,37,-1,-41,-20,-1,-17,44,-15,-14,21,18,-7,37,-2,5,-64,43,11,-18,-53,64,19,12,0,-66,2,-70,-32,25,5,-4,47,18,-37,6,-25,76,-37,-32,-16,25,23,-24,-18,34,26,-19,-9,-14,54,-76,67,27,-45,-11,-17,-42,-34,-34,19,84,-6,60,32,28,50,-4,-4,19, 
  /* [108][0][][] */ -35,5,-44,-91,-23,-20,33,-28,-46,5,30,60,-3,-7,-27,-18,6,59,-30,55,-21,-10,-2,-13,-15,-17,-13,32,-29,-6,-9,43,-28,2,-42,-39,25,-32,-81,67,-8,-17,-31,7,10,-33,55,56,71,85,39,-27,25,-68,-64,45,59,52,36,-27,-20,4,13,23,-69,21,11,6,-29,3,-28,-46,62,-6,-55,21,-10,14,-13,-35,-6,1,47,-1,21,-58,45,17,6,-33,-55,28,-33,-62,-25,3,-25,-35,-43,-4,3,-32,-20,-9,-13,5,0,11,43,-78,-20,-27,-6,-27,-24,3,-6,6,9,9,-61,-27,85,34,-69,-21,2,7,1,-58,14,38,-35,-13,2,44,21,21,-3,38,-32,-33,-28,-37,1,-1,-46,-9,-24,19,-26,-31,-77,-41,37,-28,-18,-44,-19,40,5,-33,-34,-1,-40,38,-37,-16,0,18,68,4,76,-48,-2,-2,-37,44,-21,-51,48,-53,66,3,127,7,7,-89,31,41,-28,-16,-8,-47,9,-26,-17,1,-1,-14,68,-23,-34,28,-42,-46,20,-35,-20,-38,23,-18,7,-20,11,-25,36,5,19,-39,1,-14,19,-14,74,21,28,15,81,2,-2,-19,31,-25,28,10,-37,43,34,21,62,-38,-8,-45,-52,-56,1,-11,-8,59,-42,6,17,22,25,17,-68,47,21,-5,-4,-21,-33,-37,-24,-43,-22,50,-59,-21,-29,12,30,-39,36,67,-4,29,-65,0,6,-46,17,-17,-76,-18,-27,78,-29,39,-43,-71,-35,59,21,30,-47,14,4,1,-13,-7,-6,23,-14,-6,-24,-2,17,-8,-4,22,-35,2,10,-20,-83,56,-53,-54,-33,12,-102,8,-29,-29,53,21,40,106,-55,-8,9,-22,-9,20, 
  /* [109][0][][] */ -83,-32,33,38,-26,-32,15,28,2,2,-10,22,98,34,-2,20,26,-17,4,5,48,-10,-11,36,-21,-7,38,-15,17,15,-54,-8,52,29,11,-6,44,-14,15,-12,-5,8,0,-41,-16,-11,-4,7,-90,-33,8,-16,8,-5,23,-46,64,-37,58,-42,39,-19,19,8,-23,31,-23,33,-23,26,24,-19,35,28,-1,-46,-8,-17,8,26,-6,50,109,-12,-43,27,33,-33,-29,-13,21,22,13,-24,-48,-9,-63,-44,-27,-2,-28,19,5,-75,-12,33,0,13,-20,-29,21,-16,-7,50,-52,-68,-36,-35,7,-64,-14,8,-98,-42,-61,72,-5,-23,-15,-27,-18,-29,18,10,-6,-85,-1,-50,0,-27,-4,33,-19,-8,-41,35,39,-1,9,40,-36,6,-15,26,33,-74,-15,62,-47,22,40,44,44,-127,-52,-1,16,-4,26,-3,-60,-26,-47,39,22,18,-21,10,33,-25,24,38,49,91,51,6,-8,52,50,-26,24,-12,50,51,33,-27,57,-36,-18,6,90,16,-51,36,-5,-1,-10,-17,8,39,-87,-26,42,-57,-20,30,36,-24,18,64,-93,-32,-11,-45,-20,-14,57,21,24,85,63,26,-90,3,53,37,16,-4,37,38,-20,-16,-30,-48,-10,-18,49,-66,27,-47,33,-34,-28,42,22,81,-10,-35,-49,-36,-2,-18,39,-12,2,-33,-60,6,29,-33,-30,67,43,39,-40,3,-5,27,-22,13,-121,-24,23,-44,-9,-9,-23,4,-44,-32,81,9,114,5,5,63,37,-49,-5,23,-2,61,-53,24,18,9,-6,6,-13,-22,15,-37,63,33,22,5,-37,23,8,58,44,-8,10,13,-1,-4,-36,-7,1,5,-55,-7,-29,-61,56,-47, 
  /* [110][0][][] */ -18,5,-19,1,8,20,-24,23,-87,-85,-73,1,81,8,-81,-15,46,3,48,-65,-32,-11,13,7,-1,-2,-9,-28,64,-52,18,-22,-21,-25,-76,-35,-50,-10,33,58,-10,8,50,-30,57,-23,-13,-13,-11,127,-54,-52,-25,-75,24,-35,-45,61,39,24,-27,84,-66,40,107,54,34,-29,62,36,43,-11,38,31,-21,-12,25,31,-15,47,-29,-41,10,46,25,76,-65,30,-49,-25,71,59,-1,42,50,19,-9,11,-56,-10,-7,-19,-41,14,-52,-24,-15,-34,3,-28,22,-41,-32,28,-15,-82,35,21,-72,37,-19,37,-37,8,-10,4,31,21,-36,12,-42,46,28,-25,-46,-39,35,61,-3,80,36,-41,105,-38,-9,-25,7,-5,36,-31,27,39,13,21,26,-34,36,-43,42,47,-21,22,-32,16,-36,-32,-24,-7,-8,101,30,39,-44,91,-50,18,-93,1,-1,-42,18,27,-111,76,64,23,-34,-51,-96,20,-19,1,6,22,-60,-28,28,41,7,8,20,-14,-11,19,-8,-30,8,64,-19,-2,18,5,20,-91,8,30,40,-37,-24,53,-17,37,32,23,16,3,-67,-7,38,61,59,9,-41,19,-54,43,-71,54,-7,-25,18,8,-3,46,23,-43,5,30,-35,75,-46,-72,-17,6,67,85,18,71,45,19,-29,-47,-8,25,-51,63,64,-8,17,-32,1,4,31,27,-45,33,-37,35,-11,26,-13,39,49,11,-91,-43,18,-18,-59,-39,28,76,-61,-33,2,-41,24,14,58,-15,-108,47,-3,7,11,23,-50,31,18,-33,-47,-9,6,-13,-34,37,-23,-27,-3,-1,11,-33,3,33,-4,14,-62,48,-7,-11,-14,-14,-107,-55,6,-40, 
  /* [111][0][][] */ -10,-18,-20,2,9,-19,-26,-20,58,-34,64,13,47,-55,38,-11,70,3,-100,-14,-17,59,-35,36,-114,-15,23,-72,-52,-25,-5,-3,75,-67,18,26,14,2,32,-77,75,13,10,15,-86,3,-28,-32,49,-10,-98,-90,75,21,-45,-2,-44,74,45,-21,31,-50,0,16,83,33,45,-55,3,23,-15,104,2,63,49,-27,40,13,-26,-57,-7,-5,-108,3,57,-10,-67,-86,46,-10,43,-51,-41,-8,45,68,-7,39,-32,53,27,-9,-43,41,-17,24,14,32,26,-1,-4,-5,2,-58,39,28,27,-66,6,16,32,-74,-73,48,15,-40,49,54,-37,-86,19,56,-12,-51,-24,-15,-25,17,-2,-68,-13,31,-4,-21,30,-70,-64,-1,-2,11,1,-49,37,-28,22,-127,41,-58,14,62,35,-5,2,77,20,-40,15,-50,9,-1,33,36,-71,12,-14,-11,38,-22,1,46,45,4,-74,33,8,-7,-31,74,116,-58,50,-58,35,82,-15,3,-20,-29,-43,46,9,-4,-17,6,-98,-9,1,1,10,-9,-75,15,16,-29,-34,-70,-29,-14,7,7,10,-10,32,-19,11,-53,17,-7,23,-29,-67,16,-26,58,-35,-42,14,-23,51,-67,29,0,-61,34,-4,-28,57,85,23,13,-31,34,16,5,-27,7,-12,44,32,59,-34,23,-28,5,18,-78,-69,35,-9,47,-40,-48,-6,-83,33,-35,65,-76,23,42,-88,-59,-14,-28,-26,3,-6,4,-3,24,36,-6,-4,73,47,49,61,-13,-26,-9,-53,-4,6,42,-43,21,36,55,103,41,32,37,-15,-62,-23,-34,-95,7,-10,-88,11,22,14,-19,-64,-12,43,65,84,20,-62,90,19,-20,4,-18, 
};
const TfArray<4, int> tensor_dimension76 = { 4, { 112,1,1,336 } };
const TfArray<112, float> quant76_scale = { 112, { 0.0022829156368970871, 0.0020287737715989351, 0.002342364052310586, 0.002415765542536974, 0.0022320165298879147, 0.0019457489252090454, 0.0022780678700655699, 0.0023073700722306967, 0.0022697809617966413, 0.0021496498957276344, 0.0022460559848695993, 0.0020356383174657822, 0.0033466201275587082, 0.0023606058675795794, 0.0024359279777854681, 0.0029365208465605974, 0.0028404926415532827, 0.0021184610668569803, 0.0022779039572924376, 0.0022112051956355572, 0.0024376153014600277, 0.0029272281099110842, 0.0020789853297173977, 0.0023164039012044668, 0.0025561561342328787, 0.002098114462569356, 0.0023599120322614908, 0.0022392203100025654, 0.0025292451027780771, 0.0024917339906096458, 0.0025037261657416821, 0.0024128877557814121, 0.0022111230064183474, 0.0019920184276998043, 0.0022939390037208796, 0.002286028815433383, 0.0026297483127564192, 0.0025113325100392103, 0.0023234756663441658, 0.0019418623996898532, 0.0027810661122202873, 0.0023721524048596621, 0.0023791478015482426, 0.0021615996956825256, 0.002116926945745945, 0.0024736141785979271, 0.002199351554736495, 0.0022917857859283686, 0.0018608310492709279, 0.0021838932298123837, 0.0025549212004989386, 0.0022481661289930344, 0.0025670998729765415, 0.0030626936350017786, 0.0026215324178338051, 0.0019460994517430663, 0.0021181495394557714, 0.0026947509031742811, 0.0025023915804922581, 0.0029971366748213768, 0.0024507713969796896, 0.0021599147003144026, 0.0023445005062967539, 0.0024662800133228302, 0.0019782506860792637, 0.0029897964559495449, 0.0025428717490285635, 0.0022199032828211784, 0.0022742594592273235, 0.0018749706214293838, 0.0021546743810176849, 0.0024631258565932512, 0.0024032385554164648, 0.0024987130891531706, 0.0022766669280827045, 0.0023667907807976007, 0.0023482495453208685, 0.0030179447494447231, 0.0026071830652654171, 0.0020139792468398809, 0.0020544787403196096, 0.002526827622205019, 0.0022499952465295792, 0.0025432573165744543, 0.0021707250270992517, 0.0025829826481640339, 0.002028206828981638, 0.0022950998973101377, 0.0021575437858700752, 0.0023477950599044561, 0.001847095089033246, 0.0029007596895098686, 0.0033696964383125305, 0.0026575089432299137, 0.0019212986808270216, 0.0023507643491029739, 0.0024216207675635815, 0.0025608120486140251, 0.0025144459214061499, 0.0025211332831531763, 0.0021267326083034277, 0.0023582202848047018, 0.0022999956272542477, 0.002722111763432622, 0.0027993307448923588, 0.0024740374647080898, 0.002240101108327508, 0.0025321468710899353, 0.0027498435229063034, 0.0027771845925599337, 0.002317765261977911, 0.002178235212340951, } };
const TfArray<112, int> quant76_zero = { 112, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant76 = { (TfLiteFloatArray*)&quant76_scale, (TfLiteIntArray*)&quant76_zero, 0 };
const ALIGN(8) int8_t tensor_data77[1280*1*1*112] = { 
  /* [0][0][][] */ 48,-7,10,9,-12,-11,39,30,49,27,-8,93,-18,6,-17,-27,-40,-6,10,-38,-46,-56,-3,-7,-28,60,73,-21,62,59,-7,25,-21,-60,54,43,-29,43,8,19,37,4,-84,-38,-1,122,-16,0,19,0,22,-16,11,22,50,30,53,22,-92,36,37,-9,3,3,12,-91,-12,-18,-68,43,22,29,15,74,15,52,102,-7,31,-41,64,-12,-10,-78,45,-33,-44,26,21,25,-29,-30,36,51,-86,63,-59,55,-90,-45,0,-78,-53,-9,-6,53,-63,-12,-73,127,-13,60, 
  /* [1][0][][] */ 40,21,-100,73,-20,40,34,84,-50,-21,87,-8,23,42,55,23,10,18,-54,-12,-50,-13,15,-54,14,8,46,-25,-79,-127,46,-45,88,34,8,-42,51,2,54,8,32,-7,-54,106,87,86,117,-42,23,0,-30,-72,-59,-18,41,75,59,-15,33,-26,35,-87,-77,-76,-103,-4,25,-22,58,-4,34,9,-7,20,114,35,-29,53,19,-40,5,24,-50,-6,-37,-26,60,25,118,98,36,-23,-38,107,-63,-19,-71,39,67,-28,19,20,-72,-16,14,36,-63,-18,-16,-7,12,49, 
  /* [2][0][][] */ 21,-32,-20,-52,-47,22,46,7,-37,-24,28,12,26,8,-23,-65,-16,32,72,10,46,21,10,2,-53,12,-59,-1,8,64,3,-101,-14,25,-14,30,-47,48,69,-58,59,-21,-31,13,-21,-3,24,-24,-32,-80,15,0,105,-18,12,54,-37,15,2,-47,38,-11,-5,-2,26,-20,78,2,-24,-33,29,-29,19,11,29,-39,-15,-38,95,6,-52,16,3,-11,44,8,9,115,11,-92,50,-7,22,58,-77,55,6,-48,-31,-20,7,34,-77,-70,-5,14,-36,5,15,127,50,36, 
  /* [3][0][][] */ -16,0,-27,-5,-21,-81,38,35,-114,-80,5,-44,80,3,51,31,0,-28,36,-47,20,41,37,-66,-52,49,86,-42,-71,35,41,33,-74,58,-46,27,-41,14,-4,-5,31,-8,-4,127,48,51,-47,-41,5,-3,56,-29,7,7,26,1,-57,-86,-29,-113,15,-13,110,-1,-8,-29,24,-19,20,89,-51,-39,0,20,-35,-45,-46,17,20,-6,98,-41,-36,6,-48,62,57,15,75,29,88,26,13,9,32,-79,-61,-80,-28,6,70,45,-2,-6,29,-69,-54,-22,-51,49,59,18, 
  /* [4][0][][] */ -2,37,4,29,-12,26,22,61,-127,31,24,49,20,12,42,36,116,-72,-64,-16,-4,-8,41,-57,-18,-48,-19,63,-53,73,-49,-39,-43,-27,-78,-9,-4,26,42,6,16,28,1,14,-110,-40,-36,24,81,-5,15,78,-88,-99,14,-46,-64,6,25,58,31,-72,16,-66,-25,-3,-18,-24,33,43,-65,-14,-23,70,-26,-23,-27,62,30,64,-1,19,-67,-38,21,28,17,67,43,20,-28,64,47,37,-6,84,74,-34,-39,-10,-35,56,70,14,-70,28,-24,34,-35,-13,42,-21, 
  /* [5][0][][] */ -73,18,34,-55,6,-14,59,-27,19,14,-97,-10,7,-5,-23,-27,1,-7,42,-12,40,-88,10,-60,22,36,87,68,31,32,-30,-29,123,-82,-75,-67,38,63,39,46,19,-38,18,23,107,11,-42,44,18,-81,25,-54,-8,127,101,39,-37,-53,-32,-56,19,5,20,-8,-37,-8,41,22,-8,12,4,-38,-22,14,-32,1,-38,10,77,40,11,-14,24,-4,7,49,-12,-17,73,-87,-16,-81,-59,-51,56,56,17,21,63,-9,30,-58,0,60,2,43,-42,20,-47,-1,-29,-9, 
  /* [6][0][][] */ 22,12,-19,-37,-24,-28,42,39,-12,-127,-13,-21,-22,37,-11,13,-43,38,-18,-58,42,28,28,-25,26,41,15,42,-19,-29,-22,-38,-76,-29,-47,-75,124,29,-95,13,-36,20,17,10,5,-7,3,-29,5,42,50,60,-4,-27,-28,35,35,35,34,-37,-22,23,20,-49,0,-77,37,32,-31,14,-32,-60,-18,35,41,-8,-82,26,-29,83,53,25,27,39,-71,-82,0,-59,43,-41,-77,52,80,63,-59,26,19,49,-12,80,-52,-42,21,81,45,54,-29,19,34,-7,-45,76, 
  /* [7][0][][] */ 36,-28,-25,-24,-24,-29,72,-12,53,76,7,-9,-73,-37,-36,2,21,-66,20,49,-14,-49,0,-18,39,28,3,-46,47,-14,-26,-49,7,-8,35,-37,22,-18,25,67,14,-9,15,33,-15,53,37,32,27,-7,47,-14,-41,25,11,31,-9,-42,-60,-8,3,21,19,-1,50,-36,-8,-5,-24,34,64,70,98,11,-3,-66,26,-18,7,15,39,22,-43,50,-10,-60,24,36,127,-54,-28,14,69,-26,-1,-33,-37,-9,-24,54,-68,10,-45,-4,-18,-6,-18,-26,-7,-21,3,63, 
  /* [8][0][][] */ -4,21,42,-13,-48,-57,73,-40,-67,-6,76,26,65,-30,-21,9,51,-27,-8,9,-72,67,-44,-64,-65,-67,24,-56,71,-88,71,-50,16,25,8,115,9,-30,-1,-28,-25,3,-110,23,-16,55,39,2,-48,32,24,-44,5,-68,15,11,-6,-8,-17,119,-31,33,-15,-12,23,53,36,-127,54,-24,-98,71,-90,34,15,42,21,5,-50,-15,17,-37,-105,-3,20,51,-80,-20,-70,-37,41,61,-46,75,36,22,15,46,25,6,65,-31,-37,37,36,-28,-61,96,-48,-38,-52,37, 
  /* [9][0][][] */ 2,-6,25,7,45,71,-31,-47,-4,-51,-94,14,-36,43,-13,-43,27,-74,32,14,-4,51,-93,-29,-11,-8,-28,12,-33,-45,-33,49,-75,29,35,-1,9,18,-18,46,8,-39,113,19,-42,-57,-64,44,-34,-70,41,-95,39,-26,20,-3,10,26,-68,-66,63,14,32,-11,50,62,-8,36,4,-2,41,15,-37,-21,23,-48,-5,89,-27,46,82,19,-44,-26,-60,82,-24,3,26,17,-127,-16,-22,21,-3,-119,-65,-23,1,5,42,-5,-20,-72,4,-78,-77,70,85,-30,-4,2, 
  /* [10][0][][] */ -74,28,86,67,4,12,-78,-7,12,104,-11,32,-8,16,-54,-50,39,-21,66,-21,20,23,-2,-25,23,106,7,-31,18,57,-60,80,-5,-20,15,-46,5,-9,68,17,42,-38,-7,74,-18,-67,-39,21,-101,-66,-103,-77,108,31,-83,-24,18,15,19,-32,34,72,-15,35,42,-31,37,48,39,-42,117,18,-1,30,-7,-127,18,-64,-66,45,4,41,-83,-25,-39,58,-57,-84,13,23,-127,27,14,-24,37,9,26,22,-41,30,-8,18,-79,-11,-40,-90,111,80,-120,-61,-67,-95, 
  /* [11][0][][] */ 29,43,-31,-123,-7,127,40,-3,18,23,-63,14,66,-26,-1,-66,-1,-82,66,75,1,-64,33,1,61,67,99,-5,57,-13,-17,6,-12,24,15,-29,24,44,29,-8,-51,-72,-11,106,38,-27,-26,-20,57,-12,-35,11,-60,-17,-62,17,48,-17,-68,32,-56,32,40,23,28,-10,13,20,32,8,-13,42,10,119,33,-9,26,6,-56,20,68,45,-5,-10,-28,-2,25,-8,40,-46,-38,-102,-12,126,-9,10,17,-6,15,6,59,4,-12,55,-6,-12,-24,2,-12,-37,5,70, 
  /* [12][0][][] */ -25,2,27,9,-6,33,71,1,-13,3,-57,48,-48,38,45,57,-20,-75,-8,10,-29,15,-29,18,-5,-14,41,-60,75,35,-14,22,38,-11,47,-26,-7,35,127,-11,-7,14,14,11,-8,62,3,-62,59,-25,-38,25,-49,83,-1,-80,21,50,34,-15,46,-15,23,22,-25,-1,14,-34,6,-104,-46,30,-30,-62,-24,39,3,-72,101,-49,36,48,-45,51,0,6,7,-21,76,-27,-42,-86,-59,-111,11,0,44,-31,-77,7,-61,-7,91,-44,70,27,40,69,-66,96,-91,14, 
  /* [13][0][][] */ -33,60,54,15,-1,-14,-16,-28,17,-1,-7,-58,-7,1,23,27,108,-2,-23,22,-18,52,5,30,-26,2,43,44,-6,63,-12,-70,51,-6,72,57,-18,-52,51,42,50,-38,-16,-7,43,-64,57,42,89,45,-27,-33,34,-12,13,-65,20,-15,7,-37,-33,-18,-27,54,-42,-38,-52,63,68,-53,16,77,4,-30,-54,-35,-22,-9,-58,12,-58,0,-13,-29,85,-14,34,41,46,28,1,48,14,-127,-1,57,-75,5,18,47,31,75,64,-9,39,-27,-3,-12,64,21,-7,15, 
  /* [14][0][][] */ -40,-53,64,-53,-127,6,29,14,50,-52,-61,-12,1,68,-10,20,-32,-4,-46,79,-74,22,47,-20,44,95,15,41,7,35,51,41,-37,4,8,19,5,-72,42,-3,-15,-76,9,7,48,-25,74,-47,-63,7,-27,-2,-11,47,14,25,72,34,-1,59,61,1,-60,-68,-19,-3,-9,24,7,-36,-57,-72,-10,71,-8,-72,-49,71,59,37,-76,-31,47,40,17,45,-1,-35,-8,25,47,13,22,-23,-8,45,37,39,12,-27,43,97,-16,-45,24,58,49,-14,76,-22,32,32, 
  /* [15][0][][] */ 27,31,12,-14,11,-5,51,-51,19,57,22,-27,-19,2,20,44,29,74,14,51,48,-7,-116,22,85,0,-51,19,-43,4,-67,-12,78,-58,-14,-11,-33,-27,-30,-3,-12,-3,3,29,-31,10,-9,55,71,-27,-9,-19,-47,-35,-16,-9,11,43,-42,-22,-59,-33,-88,12,-42,16,-17,36,84,-85,47,-43,8,23,-103,5,70,-70,-44,-6,-127,7,12,28,16,-94,34,-8,-46,46,-39,-53,-13,-37,-12,-21,-69,-52,3,67,-13,-89,-108,-44,5,-36,-13,-35,-20,-36,-66,22, 
  /* [16][0][][] */ -9,-22,16,-34,-22,-19,62,46,5,-14,17,42,4,34,-14,3,-26,-20,39,-63,-34,-6,-37,-75,31,37,16,-56,-30,21,-56,18,14,33,-66,59,46,36,25,-35,24,-2,18,-17,14,24,14,27,57,-23,46,30,48,2,-23,21,65,17,-36,-40,18,54,61,-10,3,15,-73,-27,6,52,-24,-1,20,1,31,-21,-14,25,1,-40,82,-36,-44,1,-6,38,-29,-92,88,-17,-36,20,-7,31,10,70,-27,-60,-23,74,47,17,-39,127,-4,40,-35,85,-101,-62,-89,-32, 
  /* [17][0][][] */ -53,29,37,-51,-48,-31,-4,24,44,-43,12,79,-23,-15,47,-27,25,-23,103,14,-99,93,23,68,-7,32,-2,-23,100,-39,104,-37,-1,-20,40,35,-40,32,-21,51,-86,13,-39,58,31,39,-14,-19,-79,-38,12,27,-22,65,-41,0,-7,14,17,25,63,48,28,50,-37,-68,15,-20,17,95,31,-18,19,56,-2,19,-22,54,-20,6,127,-50,-28,-83,-89,-59,-19,18,70,26,-24,18,-64,18,91,18,12,-71,33,24,26,-16,47,-4,-28,-14,-40,-35,-58,-79,-66,35, 
  /* [18][0][][] */ 10,29,37,127,-4,-79,-69,35,75,2,1,16,8,-23,13,18,64,-22,-6,2,-7,-40,112,-43,2,-64,-2,-46,6,16,17,46,61,52,-85,-78,53,-63,-46,110,-54,12,-4,17,-68,1,61,-17,28,79,-28,-25,2,9,18,57,26,2,-75,33,84,45,-29,-44,-14,-61,18,-105,-62,21,-40,21,99,95,-20,-40,-25,-4,-95,-33,-35,86,31,62,-57,97,25,-64,15,44,-57,-80,68,66,9,62,-87,5,106,71,6,-47,36,-66,-89,11,-30,49,7,52,-90,14, 
  /* [19][0][][] */ 63,-31,-11,8,-38,-57,-34,99,-53,73,-101,-38,34,-22,-42,18,0,-36,-93,-63,-79,-48,24,42,-35,-46,121,62,23,-43,-34,-74,27,-124,-33,-74,-9,-114,49,-94,-112,-25,27,36,27,4,-29,-15,-6,65,-100,60,34,107,-2,-16,-77,36,-2,37,-62,-5,35,-22,-13,-81,50,7,-5,44,-76,-3,44,99,43,54,34,32,-5,86,69,-23,36,42,-127,9,-54,10,-4,22,-29,24,94,35,32,19,19,46,-65,-62,-41,-9,17,-31,2,-68,75,45,-46,10,-37,-55, 
  /* [20][0][][] */ 13,-21,-61,5,61,-45,-34,52,-18,-6,-9,-111,7,-25,56,-41,-11,-48,28,-96,12,-1,-12,-19,59,-47,-36,-39,-46,45,-13,79,0,-71,-12,-82,36,47,-41,-60,105,-40,18,-127,70,-40,-42,39,-4,39,61,34,54,21,52,51,-11,-7,-29,21,-40,64,-56,30,-63,33,57,44,13,30,16,51,-2,0,-86,-43,-42,14,29,-27,-26,-32,-19,29,-68,-23,-13,-28,-17,38,20,-67,-55,44,-34,-83,1,60,-26,54,42,-114,58,-12,38,24,-5,5,-16,-49,-25,-47, 
  /* [21][0][][] */ 62,-39,-82,92,4,-82,-22,-110,-30,-15,38,-81,65,1,15,-25,38,48,-5,82,42,-6,-11,-23,-1,35,3,81,50,-106,0,-3,-45,-39,30,-7,-46,-30,-20,2,46,-41,45,24,-112,7,45,-58,-63,-32,56,62,-34,-59,-57,-40,-10,94,-32,15,-39,-20,15,-10,31,74,-3,93,-59,33,-63,-55,-47,-11,80,-57,-43,49,41,3,45,70,-46,-43,-76,36,-107,-54,-1,-46,-54,8,25,-77,35,-127,-58,80,47,-45,-22,15,-37,1,-41,3,-36,32,-82,-65,57,-8, 
  /* [22][0][][] */ 31,17,43,-7,-98,18,37,66,-18,34,21,16,-15,-2,-3,50,-30,26,-41,-4,-12,74,-74,-20,-46,11,8,52,-54,29,98,10,9,-101,-4,29,24,8,13,33,-29,1,-11,-22,11,-57,1,33,27,3,-63,-17,12,51,16,-3,-58,-106,-41,-62,77,-86,-24,-5,-31,45,-11,-1,-19,30,62,-2,-57,8,43,32,15,41,-89,10,19,-22,33,-29,127,-23,6,7,-20,32,21,-23,-83,39,36,-12,29,42,23,-13,74,27,-43,72,12,-34,41,77,-19,22,-7,11, 
  /* [23][0][][] */ -8,38,-4,-58,23,26,-37,-24,9,-68,65,7,4,44,18,-40,-22,72,46,59,-32,-52,77,-8,-16,11,-59,10,16,-43,93,28,18,16,-23,-19,28,-56,-18,47,83,59,-7,9,-12,12,-13,36,46,-21,-26,-11,-67,-25,16,10,-12,1,12,-42,-24,43,0,-65,-2,-19,-25,127,5,10,-5,0,23,-82,-8,-54,-17,-50,-12,-84,-44,54,16,11,-31,10,-12,-55,29,65,-50,-84,-2,-64,28,-33,38,-15,-24,66,-4,-32,-18,-30,41,-17,-40,-45,5,72,11,0, 
  /* [24][0][][] */ 22,92,34,-87,-4,-17,9,-19,82,62,-50,-82,52,16,33,4,51,-20,-40,-20,17,26,-35,19,21,37,6,-13,22,44,-22,-25,45,26,-53,43,47,-15,-127,16,-2,-28,-5,12,33,-29,-11,24,-58,29,17,-10,-59,49,62,13,38,3,21,-24,-1,19,-97,2,-67,3,27,14,1,66,95,21,57,3,53,-19,10,18,126,69,-4,-20,-9,13,60,6,-13,-59,-3,-105,-11,-44,-3,-33,60,58,-9,5,0,76,101,-62,-26,5,13,-21,-40,-9,-89,-32,34,-29, 
  /* [25][0][][] */ 46,27,29,8,-6,8,-55,-9,25,-17,-6,-82,43,0,20,5,-26,-13,19,41,6,-49,22,16,-41,-40,20,21,-24,26,-127,-17,22,-6,-17,-83,-24,-2,-13,-22,-13,3,62,3,-46,-43,-38,13,0,29,-3,-44,4,-47,37,-35,16,-22,-26,31,-20,-31,-20,-30,-19,16,54,14,37,-103,9,-45,56,-48,-11,-50,-20,6,-19,26,-14,-24,-36,34,-45,12,3,30,28,46,18,13,55,-19,9,11,53,13,22,60,46,-30,9,14,-20,8,14,-26,-5,-6,-45,17, 
  /* [26][0][][] */ 2,17,-50,15,26,-7,-27,29,21,1,43,-23,13,-16,-22,29,-3,2,9,47,-33,-51,27,-64,-58,-30,16,-88,-22,-10,31,-29,25,-18,2,10,12,7,-13,36,-40,29,38,12,10,27,2,11,7,63,-23,28,30,19,23,-30,-29,63,-107,-20,7,52,32,-23,-27,-15,83,27,32,-11,-52,6,13,-32,1,37,84,-5,8,-17,-39,-3,26,2,-57,-21,-36,-49,-5,7,-30,-15,26,7,-127,40,-48,48,19,25,-10,0,-72,20,-8,-37,74,14,-38,78,-10,33, 
  /* [27][0][][] */ -35,-11,-14,-41,19,-4,7,-37,-72,-3,11,85,25,-13,-42,-69,-32,-31,28,-6,-19,-68,-35,6,-4,20,28,-10,-43,-1,-2,65,7,23,-10,-29,6,-52,34,14,18,28,-59,44,37,8,15,40,18,7,-8,-16,-40,19,-7,31,-45,-127,28,7,-4,-65,19,-65,22,22,27,-54,-24,-21,-29,-55,8,44,3,-26,20,6,38,2,13,-26,52,11,29,-14,8,-47,-31,57,-2,9,-16,27,-17,25,28,30,16,-22,-19,25,-40,29,18,-53,-32,-13,-10,17,-41,63, 
  /* [28][0][][] */ 10,30,19,-95,-47,-9,69,63,-43,23,-9,18,35,13,-53,-34,32,127,17,8,-11,81,117,8,-45,12,-11,-9,43,3,94,10,-47,-19,25,28,-79,-1,17,-6,-43,22,30,4,-6,-46,-15,-2,-24,-67,-59,-3,24,-2,77,29,-16,8,-21,-17,-21,-16,51,-54,17,45,-22,-50,-79,6,29,-45,-62,52,22,19,-52,36,-46,-11,45,-37,29,-36,0,-8,-43,-18,44,-79,-59,29,-34,48,-80,21,-75,-68,53,-65,-11,-11,-31,-84,41,19,-4,16,63,-47,-45,11, 
  /* [29][0][][] */ 5,7,-18,-113,-47,35,11,-2,-22,-112,23,-6,17,69,-10,12,-9,-28,99,-63,40,-19,16,-12,32,-29,-107,-8,-51,-16,-80,13,-33,-48,127,55,-3,26,10,-23,8,-27,84,-57,-10,19,28,3,-29,-43,-17,13,45,-18,-7,31,32,-17,29,69,11,84,6,71,37,-19,-4,9,-20,13,58,-50,-51,-55,49,-1,-13,-28,-34,-34,71,10,9,22,10,80,28,45,34,30,-36,33,13,-46,-47,14,117,-11,-76,27,99,35,3,-35,-4,-58,63,2,24,-50,84,-45, 
  /* [30][0][][] */ 47,8,-20,13,-17,0,44,-21,15,8,-28,107,-15,25,48,59,-16,40,7,-107,-64,64,70,-41,41,64,42,43,-21,-72,-44,-17,-60,29,42,46,19,-16,2,-99,-5,17,11,70,59,98,55,16,24,-14,35,-42,-16,-127,-26,49,7,75,82,-98,12,66,-50,66,-16,41,-13,-45,31,-31,45,6,58,-83,-32,-9,-6,17,-42,41,56,25,-16,-61,-84,7,-57,11,38,28,-33,69,14,-85,-36,-75,-48,39,-85,32,-2,-15,35,-36,-59,-43,-10,36,13,-35,55,-14, 
  /* [31][0][][] */ 18,27,-6,-86,-8,12,29,16,-8,-46,7,-8,35,38,-21,42,-34,-2,-33,43,-14,14,-6,-15,-51,61,-26,87,35,-13,-1,-84,29,-90,-3,-1,17,62,62,-9,16,3,10,4,25,23,40,8,12,9,-35,-54,30,31,-103,0,5,-7,0,0,1,17,-60,16,-4,-3,38,-53,58,-43,-3,0,6,-58,23,0,-8,25,-9,-7,-43,-19,-56,-61,-10,-10,26,-68,67,16,-50,86,20,-50,-27,8,0,33,28,37,9,-5,-8,3,32,7,30,50,27,-27,127,29, 
  /* [32][0][][] */ -45,98,1,40,-56,-91,-45,40,-28,-41,127,-34,-21,-45,-32,-25,-26,-25,-81,-46,-81,95,52,-33,-61,-33,19,5,-9,-14,-19,39,1,17,-111,-71,80,-42,21,53,-86,88,-20,115,47,-22,61,-4,-87,23,-76,-24,-25,78,-19,-57,-51,-20,-75,-17,85,65,19,-48,-66,-73,55,100,-7,31,-1,-104,-81,-84,-20,-7,61,76,-40,-27,-76,-3,-6,-4,-99,-11,-17,-28,51,-22,-81,-33,87,-1,20,63,-11,-18,-6,112,10,-55,-65,-95,-56,45,36,15,55,7,-57,-3, 
  /* [33][0][][] */ -76,-108,-2,70,122,57,-34,-56,90,19,-39,-20,35,33,103,47,66,58,100,13,8,-17,-107,87,-48,-58,-43,-14,-79,-67,16,-56,-52,-121,46,64,-42,-74,46,-73,38,-58,54,-64,105,-13,27,52,-15,-50,7,-1,-28,24,-63,-71,54,-33,54,-49,8,-34,27,41,-27,66,-43,-49,-26,-61,44,-17,23,121,-65,32,-15,-54,70,0,-8,60,124,94,-72,6,-15,14,-108,57,-18,31,10,-19,-34,-44,33,-11,-74,-72,-52,79,-57,23,-10,-43,-9,35,19,127,-82,35, 
  /* [34][0][][] */ 17,19,-21,-16,-47,99,-18,27,9,9,63,10,57,-35,-8,40,-37,-20,-22,61,-53,40,56,86,101,71,-87,29,-61,-7,-62,-44,39,14,-39,-26,10,24,-22,127,-38,-30,61,-47,-2,31,-10,44,81,0,36,21,4,-31,17,72,-7,45,11,-42,31,7,-45,-48,7,-9,-22,-5,2,-29,-1,58,21,8,-12,-55,-10,38,-38,22,14,-17,-9,12,-10,4,-49,55,-16,-16,30,-26,-49,11,-25,13,12,13,31,-10,-7,33,-3,42,-41,-77,-12,2,-16,-24,-73,61, 
  /* [35][0][][] */ -41,22,-80,-12,-36,-49,13,-6,-1,44,57,23,-51,27,97,51,46,-23,-30,-4,-25,-19,-14,45,94,44,3,-46,56,0,-26,-24,-40,42,45,-26,68,34,-37,-70,-46,75,-71,-17,81,69,10,-10,-47,101,11,21,127,41,31,-56,20,-9,42,45,49,4,-20,36,59,-42,17,15,-7,78,-29,36,29,-22,58,37,-12,-15,38,10,-41,14,-102,-91,15,9,42,-49,21,47,50,-73,27,26,-5,-42,19,24,22,-40,31,92,-29,-12,-88,25,-71,2,-50,4,-43,-50, 
  /* [36][0][][] */ -40,2,44,-2,-42,-10,-48,-30,61,25,-61,79,-57,22,5,34,19,48,-31,-49,-36,7,54,-8,35,58,17,6,18,-20,86,-29,103,23,54,-19,12,-21,26,-75,23,-24,-17,10,118,19,93,-1,46,40,-75,-13,10,-71,55,54,-12,-48,9,-5,-14,33,-13,-69,10,3,15,-50,68,37,-2,55,-22,-1,56,-3,18,-69,6,18,-34,92,-80,-84,5,65,58,-127,28,-19,58,57,-66,-29,40,-14,-13,30,0,-43,-9,-29,51,0,-9,16,-14,58,0,-5,-29,-23, 
  /* [37][0][][] */ 35,-6,-19,46,84,108,47,-83,109,38,16,72,-31,-27,-13,50,-30,14,1,-35,23,31,63,16,66,8,12,33,7,-17,2,11,42,25,72,20,45,76,43,33,-36,27,14,3,-5,-17,16,-12,-17,77,-92,-60,3,5,43,-10,-6,59,-11,21,64,-55,28,-22,-5,-41,92,-21,86,13,-32,2,-98,50,0,-17,-17,-48,48,-8,-25,19,-25,-23,-67,37,6,5,78,26,-11,34,-127,-65,21,-3,40,23,-44,-59,-5,-41,1,-35,-4,-61,59,-10,-61,8,3,16, 
  /* [38][0][][] */ 10,12,62,1,88,39,30,22,37,7,50,-52,9,-30,-41,-70,34,43,4,0,3,-14,-69,9,47,4,-43,-73,-11,78,13,28,-2,-17,30,11,45,-7,7,25,-5,53,-1,-53,-28,-10,-14,13,-3,36,17,30,-13,9,-21,-65,-88,70,-25,29,-7,13,72,14,-55,-3,-65,119,-39,2,-53,-12,59,-32,40,-70,-18,-35,-29,21,-25,-44,74,-18,-12,19,14,22,-64,1,15,30,-7,12,-10,-24,-7,-19,22,-63,-22,1,-39,1,1,3,-127,13,-54,-17,19,9, 
  /* [39][0][][] */ 15,27,4,-49,-51,-13,30,-19,0,-10,43,74,17,-53,-7,36,-37,118,37,-53,-104,55,23,-89,54,22,-65,-66,-2,-72,-37,-5,-73,-31,-2,89,27,-5,-50,8,66,47,41,-12,82,18,48,-74,26,-11,-53,-89,73,102,68,-42,57,-31,-86,99,-86,56,46,-62,-45,-91,-1,32,-45,-9,127,20,5,-58,-83,-97,55,-53,53,57,2,97,61,114,-15,11,30,0,-40,-30,-20,75,-60,-35,73,-9,-50,-48,-74,-30,-30,-15,8,8,16,-13,55,-51,12,-59,11,-4, 
  /* [40][0][][] */ 42,-10,-98,-40,29,32,82,55,-11,22,31,53,-9,-65,52,-60,18,-1,20,30,58,22,12,63,53,-57,-14,20,7,104,4,55,-67,37,-28,10,-6,43,-6,-7,-43,7,-22,58,-46,-93,-6,-31,11,15,41,74,87,26,-84,-10,18,-9,-75,22,-85,-40,46,36,3,-38,48,61,23,80,-32,-16,49,63,3,60,-26,4,56,48,-13,38,89,-5,-35,-45,-2,-32,12,-32,-29,-55,-32,115,0,-12,39,-9,-11,6,-48,-24,-6,4,28,-27,25,-58,-20,127,-47,78, 
  /* [41][0][][] */ 1,-46,127,40,-68,1,-39,11,-17,34,3,21,26,-89,-61,-69,16,-1,-4,124,-52,-23,-43,-33,-3,-6,-18,-87,41,58,-48,-80,28,-10,-49,10,-50,25,-40,84,18,-67,-89,-9,127,-17,106,-12,-4,2,-19,2,1,47,-6,-35,-13,-58,52,56,93,15,-104,17,-22,-48,-95,-13,14,-80,31,48,-25,24,18,-76,-18,-19,-121,114,-46,-13,-3,74,76,8,1,-61,91,26,-4,-6,10,26,-2,73,77,-14,-55,68,-42,40,-54,104,88,22,11,11,-91,13,14,-67, 
  /* [42][0][][] */ -7,83,15,45,0,-15,18,-9,45,-20,2,-17,-60,-83,-15,-45,-41,65,14,23,13,15,65,28,-29,-12,45,41,90,112,21,-58,82,-1,-11,-26,15,-39,43,81,4,5,1,10,-20,-4,-39,-23,53,-8,-27,42,-5,35,31,-26,-28,11,14,-127,31,30,-34,61,31,15,26,-6,-19,2,20,-25,0,53,47,-39,-47,-11,-12,37,7,52,6,15,-39,-4,-35,26,67,32,-51,-26,-15,73,20,120,-34,-37,42,-23,-1,53,23,-26,-6,-16,34,42,49,-2,-13,-9, 
  /* [43][0][][] */ 4,53,10,-31,-7,30,0,-52,22,52,33,48,1,49,57,112,25,16,-55,5,22,-4,48,-30,16,22,-52,5,30,1,16,18,-36,52,55,-58,58,-29,-22,-10,-60,-11,-21,102,-127,-2,-60,36,-79,-46,45,-46,11,-17,18,-78,111,75,64,-39,75,-47,-72,9,111,5,-8,-72,93,-53,7,47,-42,59,39,5,-16,49,26,10,-83,11,33,19,3,35,-22,58,-30,45,90,53,-85,70,-15,-16,25,104,-19,-21,32,31,-12,-37,-59,-23,33,41,52,-56,-56,9, 
  /* [44][0][][] */ -60,-39,53,-50,-38,24,25,3,41,-49,-45,-37,6,-31,-9,-6,16,-14,6,-22,4,-58,-13,15,30,-36,-47,-34,6,-13,-75,-26,-23,40,8,-5,53,-1,8,-3,-89,-25,-24,6,-8,65,23,72,-5,-35,-28,44,37,-6,-32,28,-38,8,77,-21,1,-34,-3,20,57,-41,-4,14,-9,-17,54,58,22,23,-29,-9,0,-21,6,-9,-30,26,68,-19,47,-19,6,-48,-45,-15,127,-10,40,1,13,-70,-12,-7,-18,-6,-12,-23,-37,27,-36,-39,-19,-16,-42,4,25,-1, 
  /* [45][0][][] */ -39,-13,-60,26,-5,-8,62,-16,-54,10,-4,8,-37,-16,68,-74,-21,52,56,14,40,-60,0,7,12,-67,-3,-16,-68,39,-19,53,-50,29,42,-4,44,23,-29,62,49,0,-17,32,-94,58,3,-15,-116,99,-24,50,-50,-11,8,-27,16,-22,19,4,-21,100,-18,-45,18,20,7,5,-21,-11,50,7,19,-11,39,12,49,-37,-32,4,-89,56,125,34,46,-7,10,-22,-3,-26,-7,-30,0,20,-2,-1,0,8,-53,-44,44,2,-127,-42,-12,-68,40,-35,47,-108,26,30, 
  /* [46][0][][] */ -13,42,-60,-40,-46,-10,-39,1,76,50,-40,9,-119,19,49,56,-15,6,-33,-9,-48,115,-67,-39,-11,-5,43,-95,-24,-9,-28,-99,55,28,-10,33,67,-33,35,66,94,-57,54,99,17,-44,81,-11,-25,1,-47,-1,-58,-9,88,19,-7,-50,21,46,89,1,-48,-40,123,-62,73,-91,-22,-68,16,-14,24,-68,127,91,7,-60,-12,-28,118,-18,-43,34,20,7,72,79,-11,53,2,-100,86,-103,2,99,24,40,-37,40,-51,-13,-82,45,25,-81,-87,-107,-69,1,4,9, 
  /* [47][0][][] */ 20,-63,-59,83,6,-24,55,-16,29,45,38,1,-42,-19,51,-29,-10,10,32,7,-50,13,4,33,2,45,0,8,7,17,44,2,7,-7,29,-8,82,66,51,39,-3,-18,31,-32,62,18,-20,2,13,-18,-16,-22,-77,101,-9,40,-79,-62,33,65,20,-4,-24,-42,9,77,18,-23,-30,44,57,73,-19,37,-40,-7,-22,62,-127,-50,55,-65,-7,-47,-20,33,-29,-9,2,53,-81,0,6,38,22,11,3,-18,62,-24,-37,-6,60,-26,10,17,19,42,26,-44,14,29, 
  /* [48][0][][] */ 63,-36,11,-45,-95,24,47,-4,56,-21,15,-9,-38,-14,50,-53,-26,-14,53,4,42,-28,15,9,-43,-26,0,18,17,30,58,-53,-127,-2,62,61,10,61,-20,-47,-12,-39,23,19,57,28,71,-26,13,2,-38,37,-16,37,-43,14,-10,-19,-20,-8,-26,26,22,-8,-6,-22,-13,37,-61,-48,19,25,-17,10,51,-2,20,-32,-34,43,58,-16,-11,-75,12,23,-10,-3,-67,-29,7,-27,-5,1,55,-30,17,-84,27,-36,55,-49,-49,-56,64,69,0,15,50,-15,-7,-87, 
  /* [49][0][][] */ -64,34,18,-32,43,4,-87,-17,-5,-50,-20,18,-47,-30,36,-1,23,45,-29,-67,6,12,-6,-8,-33,-50,10,31,-35,-25,-13,9,-11,28,-13,-4,21,52,-64,69,33,3,2,-58,6,17,-3,-78,44,1,-31,20,-2,47,2,-3,57,-59,67,60,-4,-19,-57,-46,9,18,15,13,-34,-121,36,-3,-42,36,26,9,23,2,111,-47,-51,127,-4,8,73,-23,-44,2,42,-22,22,46,27,-48,12,-15,29,31,-26,-39,4,-64,-24,-2,51,-32,-47,8,84,-12,19,-51, 
  /* [50][0][][] */ 49,-85,0,61,-35,-48,9,31,20,44,81,-7,55,-7,77,53,-33,29,-48,24,25,-31,-12,12,-19,63,1,12,18,57,-77,-31,19,61,-20,-31,127,-16,35,-24,7,14,27,91,-44,-89,18,75,-62,-36,111,-19,78,-80,35,-9,1,-7,-47,-80,-13,-81,7,-91,-53,-7,16,-33,37,22,60,-7,-28,32,31,37,-50,-61,76,65,41,48,-69,35,-94,-8,-112,48,-35,41,-33,-13,-50,-12,-36,-2,32,-3,-29,55,25,26,-49,-11,-8,-28,-89,35,5,44,47,-8, 
  /* [51][0][][] */ -89,-127,13,79,-22,-127,-22,71,-69,88,-9,120,-52,11,-49,35,71,39,-30,-36,-8,73,30,34,-75,19,30,17,-18,-11,-62,78,17,9,50,14,-26,72,48,21,-40,6,-65,31,-121,-49,73,77,-109,-5,27,-48,-120,-30,33,-15,-3,5,-22,-5,42,27,-6,-48,32,30,-62,-6,-34,-30,61,-64,-12,29,13,89,35,58,11,51,14,-28,21,-12,40,-18,3,37,-34,-77,78,32,37,53,29,40,12,0,47,-4,30,112,-28,-61,27,20,-26,70,92,-41,46,-12, 
  /* [52][0][][] */ -8,38,-8,30,8,-51,61,-21,-39,8,6,60,-11,-57,-35,50,14,30,24,21,-39,-38,17,-88,27,-6,-22,-67,1,34,18,-22,-39,33,43,-10,-14,-13,71,-63,-27,-9,26,-38,-22,-6,77,34,-45,39,-28,-41,2,36,48,-10,21,43,-12,63,94,11,20,-21,-26,-2,-127,-50,5,6,-32,14,-21,-25,-29,-32,-31,10,-15,-21,-12,21,-11,-53,-48,46,25,33,-17,-10,6,25,27,-44,-44,-10,10,16,14,2,-40,14,-35,-61,-16,-51,2,-15,7,55,27,-9, 
  /* [53][0][][] */ 5,31,59,57,-3,-79,70,-8,75,-44,10,46,45,-57,11,44,26,46,10,-3,59,-87,83,-96,-20,-72,-15,30,-96,-8,-30,35,-18,-33,6,10,-18,-1,-91,-3,-41,-1,42,8,36,47,-29,-82,-24,-29,54,-66,22,35,45,57,62,22,96,-33,-71,-3,-3,-114,87,4,23,-15,-93,-58,22,-90,14,6,-45,-22,64,90,14,-23,-21,56,-86,1,-61,39,-98,-3,7,-5,35,127,21,-44,-16,-75,22,-61,24,23,-44,52,-11,-118,-1,-71,-42,-118,6,8,-30,-105, 
  /* [54][0][][] */ 56,-46,-7,-19,23,-4,61,-11,60,-44,-49,-10,-33,-38,11,6,29,42,19,-25,-31,22,31,39,5,-72,-20,-40,91,-18,60,36,15,-34,-21,59,-74,-45,-127,4,-23,-29,-21,26,-34,3,60,-66,-44,91,26,-9,-27,-18,58,8,-6,84,-53,9,1,20,20,82,-35,2,-27,-7,-13,79,44,-33,32,54,32,46,-13,48,76,-7,-95,-10,-9,-62,2,40,24,-36,18,-32,-3,15,4,-23,5,2,-42,15,-19,-40,42,-19,42,-85,-12,10,-2,-27,-30,33,-73,31, 
  /* [55][0][][] */ 32,-57,-76,-14,-40,-32,16,-24,22,-53,-9,-26,32,20,6,56,22,-17,49,4,-32,118,37,60,-6,63,-12,5,9,-3,35,15,3,-31,105,-46,-50,42,-47,-57,-1,0,-17,-76,20,-65,-30,63,12,-24,-19,-36,1,-5,34,7,18,-12,32,14,-72,27,0,3,82,52,70,25,33,2,78,-42,37,7,-127,-52,76,-21,16,-12,75,93,-37,20,30,10,88,13,8,-64,-43,7,15,-70,-2,38,71,38,15,-79,-47,56,-40,-20,10,-38,16,7,-28,-14,-31,-18, 
  /* [56][0][][] */ 44,-18,9,-35,16,11,-15,50,29,93,7,14,-20,46,-64,11,-6,26,31,-100,29,4,-20,-61,-10,-15,87,-59,10,-12,-32,93,-12,23,-46,22,20,-28,5,-33,63,-38,2,29,-36,70,48,58,8,35,-39,58,65,-21,13,-34,-50,-22,-68,-29,76,23,19,43,-30,-35,34,1,22,64,-75,-11,30,44,54,15,18,20,79,-5,18,17,-45,-24,-127,-14,-41,-30,-72,22,13,111,8,19,25,-31,27,-79,84,-48,45,-32,95,-13,-28,-80,-31,-61,-34,26,-37,-17, 
  /* [57][0][][] */ -90,-27,-40,6,115,35,55,43,-33,32,92,-87,16,2,-19,-49,46,-103,5,-36,-18,7,-19,72,-66,-40,15,122,29,-19,39,-47,-105,-57,39,-50,72,-58,-49,35,31,-82,62,3,5,-32,51,51,44,-61,-27,75,50,-6,83,-16,-45,-62,-44,-42,-66,-41,46,37,2,90,5,-67,1,-18,0,-19,88,63,-36,0,-40,-57,-39,-51,32,9,-9,-11,-74,30,-54,73,58,127,-40,-73,-46,19,-17,33,21,-53,-22,66,5,41,-14,13,94,9,-19,-6,-5,22,51,-65, 
  /* [58][0][][] */ -78,65,26,16,-17,64,18,17,46,11,41,-83,-38,54,-36,2,-1,-11,-68,10,44,-18,-13,-33,54,14,8,21,47,41,-15,-37,-45,-20,127,31,-27,62,13,-36,-12,28,54,33,30,-29,-89,-64,-8,46,-8,-10,25,65,39,-6,-43,31,7,-89,20,27,-111,34,51,-2,20,-24,37,57,47,16,-46,29,99,-63,-29,31,-50,50,1,6,46,-58,-48,-4,51,-45,-3,-74,-68,68,100,19,-11,2,-22,26,66,80,7,-42,47,-74,-34,-25,38,-11,47,41,103,-32, 
  /* [59][0][][] */ 69,-11,68,-14,69,3,-68,-8,-73,-7,122,2,22,-9,66,-25,-98,-33,-53,-96,23,90,-7,87,-10,17,-37,-109,87,-15,26,7,-1,76,46,-26,-58,-7,-5,42,53,10,-70,-60,-30,109,-3,19,90,-60,50,-5,-47,-35,26,-68,5,-110,-22,-57,-4,-23,73,-54,-112,67,-54,-72,6,121,14,27,44,74,53,-52,-18,63,-90,-44,26,46,-47,7,93,-31,-65,-66,-7,48,-43,-66,84,19,58,3,-5,88,-29,-10,87,-2,1,-44,-10,11,-55,127,-22,-8,-45,39, 
  /* [60][0][][] */ 2,55,24,62,34,25,29,-30,-93,81,54,28,-127,-35,4,20,1,41,8,-51,69,70,-84,-28,-24,38,-63,32,-45,41,72,-57,5,22,-49,-37,-74,48,34,57,42,53,1,-89,-82,-75,-7,-12,90,-49,-65,-1,-29,-37,-40,-38,1,-84,20,-40,5,-44,73,11,-16,39,-63,1,10,-78,47,56,2,-51,24,-60,-15,5,69,-39,40,-20,-22,82,35,-33,40,85,31,-45,38,9,-4,-98,-33,26,-23,0,-9,51,-54,-42,24,-47,-20,14,44,-53,73,64,55,-17, 
  /* [61][0][][] */ 36,-53,-118,0,32,21,89,-50,-16,-97,72,-66,92,74,30,-46,64,-48,109,-10,-11,6,-14,-33,110,75,-32,-98,-99,-3,-57,13,30,89,72,-3,-36,9,-23,1,63,-51,-38,63,-125,-40,51,-15,-6,-28,47,59,9,12,-102,11,-7,30,-67,-51,84,45,76,22,-34,23,-64,-13,46,-97,-2,41,51,-9,29,-4,19,-6,16,25,37,87,85,127,11,2,68,32,65,2,-14,-20,14,-11,-55,91,-72,-67,70,116,-26,-49,-7,33,74,-77,-23,-12,-71,-39,-116,-61, 
  /* [62][0][][] */ 56,21,-25,2,-6,-47,21,16,-8,-29,3,16,38,-18,67,-16,57,-21,9,-29,-5,-33,-7,18,7,31,-16,63,4,40,-86,-30,-39,-60,87,-18,-19,-13,21,32,-25,-6,45,93,-10,10,28,43,20,23,25,-52,17,-15,-29,17,-9,-25,-41,-24,-45,37,-33,5,-6,10,47,-8,-10,-23,4,-86,14,-27,-20,49,57,28,16,-83,-25,-57,5,-5,-46,-43,-37,-32,66,37,-13,127,-51,-11,49,12,79,-89,-77,14,-27,64,15,-27,-82,-39,-44,34,-12,56,40,55, 
  /* [63][0][][] */ -24,29,-16,-46,-22,0,31,54,-42,10,91,-31,-17,-36,-36,-96,-42,0,-72,-21,-41,16,-68,-74,35,11,-25,-30,-8,11,-37,-35,31,-26,1,-57,18,72,-17,127,-44,-27,-29,-5,20,18,-65,-3,-43,59,16,-31,67,72,29,3,-22,18,27,-2,21,24,-22,47,51,24,36,31,-14,76,-77,70,27,-12,77,-19,-32,-6,91,-78,-99,62,39,29,-13,7,-11,9,6,-5,6,16,79,-19,46,-66,23,56,15,79,88,47,8,3,-35,10,37,37,54,-34,2,55, 
  /* [64][0][][] */ -113,49,25,12,-1,-22,4,14,-98,-46,-83,-24,-53,-45,19,39,-40,-14,-104,-21,-7,39,-19,-10,-40,15,23,27,6,49,-3,11,11,-51,-34,-41,6,65,56,-29,-2,43,-16,10,-41,-64,-31,60,-40,-49,-31,-66,-59,55,27,6,-47,-7,87,28,-108,17,-44,53,-36,-51,19,21,3,-13,-25,127,-19,31,12,-34,39,54,-12,3,-127,14,-67,40,34,78,89,-48,-88,-35,3,118,-22,33,48,-6,-85,-1,-47,-100,-15,4,32,73,-40,35,60,72,122,6,48,57, 
  /* [65][0][][] */ -2,-109,17,-28,-15,-46,5,-37,-22,-9,39,20,7,-61,38,18,36,127,-47,82,-19,-39,-3,-1,43,-33,-2,-34,27,1,11,7,-41,37,-46,-1,-13,-16,35,-5,26,-32,0,-34,-36,15,-56,1,-62,-37,33,-81,-15,14,20,80,-30,-30,-10,23,40,4,81,-55,42,-11,-49,118,-38,-59,16,3,-20,19,-93,-94,-2,4,-1,37,-19,-1,-35,-23,-3,117,-6,58,-38,76,-14,40,-3,15,33,-10,-46,42,-13,106,62,6,-32,-49,-33,74,-41,-39,22,-48,41,19, 
  /* [66][0][][] */ 4,-7,22,82,-29,-25,8,17,-29,40,-5,-40,73,-17,68,15,-39,36,-6,-41,-15,14,-51,25,25,-47,-88,-20,-55,5,44,34,-79,25,47,-1,25,-32,-44,-8,15,13,4,-15,-2,27,1,-14,-11,66,-71,59,-96,5,56,-13,7,18,103,-21,7,28,-12,-10,-65,-73,26,-58,58,-27,42,48,-4,17,0,44,-21,6,11,-1,8,-23,-5,-51,-37,-13,1,28,23,31,46,-3,-48,-5,60,23,127,15,-2,43,21,25,-90,-41,-38,27,33,35,47,10,-90,26, 
  /* [67][0][][] */ -39,19,39,4,-37,-51,-22,-78,-51,-14,-25,25,3,46,50,11,43,31,-6,-75,-15,-12,-50,22,-50,-77,21,-47,29,40,42,14,26,-24,-17,75,82,59,59,-44,50,15,-11,45,62,46,76,-16,43,-10,-1,60,2,20,-56,-51,9,17,3,-43,20,30,29,83,-74,-1,63,-12,20,-65,14,-127,2,-35,-57,56,-23,-10,43,-1,-96,-66,107,55,-11,-4,-57,-1,-53,80,-15,-5,23,-12,-78,-2,-6,0,38,41,22,-75,-37,28,25,-27,-38,-8,-21,19,-1,-33, 
  /* [68][0][][] */ 21,-9,3,-51,-26,-43,-18,-10,76,5,-27,73,-47,-49,80,-11,27,-6,6,22,-92,-6,55,-70,-17,17,8,-3,17,-67,-12,0,34,52,-1,-55,3,-11,-8,31,-46,0,-3,108,-36,12,49,50,-71,19,-39,10,-58,-8,-15,93,-20,62,-12,-34,-40,22,49,1,-11,11,-7,26,-58,52,-16,-39,20,70,-1,31,83,42,68,-17,-27,-29,12,6,-58,27,-53,-33,-17,75,-54,22,1,9,17,76,-13,-84,27,-75,2,22,-5,-66,-58,-38,24,52,-42,-4,-14,-127, 
  /* [69][0][][] */ 23,29,-93,13,27,-4,-34,-40,30,7,-12,-65,22,-45,64,16,50,54,47,99,-67,127,51,27,-27,-73,36,72,-30,-39,-11,-66,-65,-86,-40,-31,78,22,-45,39,-25,-45,-12,-84,78,-75,22,-51,105,-5,-23,-30,-60,39,0,-16,-28,-15,43,7,-43,18,-10,21,-12,30,24,-10,5,-6,105,-60,-42,-24,53,9,-67,28,71,-4,-17,-71,19,-20,-7,82,-91,-50,-1,96,4,-71,1,-23,8,34,3,29,-68,24,-49,-15,45,47,80,-60,-25,-80,-37,-35,45,-14, 
  /* [70][0][][] */ -5,33,51,48,-39,10,-3,24,24,-92,-26,12,10,-34,109,-7,-3,-7,27,-21,-61,-13,-1,-60,-21,4,-63,-6,-61,-34,-11,-52,5,-5,58,-2,-56,-7,38,48,2,80,-63,-31,88,10,4,-5,64,19,21,-18,-53,-48,-9,76,-55,22,95,-27,-42,59,-16,-32,7,-11,-11,7,-30,29,-5,41,-45,-1,13,-13,47,-8,32,57,27,54,59,-9,53,88,37,22,-14,54,-81,127,72,-13,-35,37,73,-25,46,-25,-14,-30,68,55,76,31,-42,-11,-44,36,-34,59, 
  /* [71][0][][] */ -29,-34,35,69,-37,-43,-51,66,-33,-3,-46,49,38,-12,-11,-41,1,-37,-48,-42,-77,-33,34,-39,5,-58,39,0,-32,24,17,-4,-27,-19,-60,-59,36,10,28,63,24,-13,15,12,55,20,26,15,33,-7,-22,-16,-40,20,16,55,-12,21,-71,10,-15,38,-44,36,23,-127,-18,18,-22,35,-28,-13,-19,11,2,-38,29,-10,-15,-77,-13,-31,-4,-6,30,78,11,7,34,56,-37,48,-56,28,7,40,-17,29,-16,-56,-43,-73,78,51,-19,-24,-39,-41,50,4,-66,-13, 
  /* [72][0][][] */ -21,-31,38,-76,62,6,29,-23,-7,24,35,81,42,-84,-68,-5,14,-11,-23,42,0,-28,-17,-11,29,0,-56,-45,-39,-60,56,-6,12,-54,-45,-123,18,46,70,48,17,-49,-43,28,36,-16,12,69,18,-25,-72,-127,45,-91,-25,-60,57,61,-43,5,35,-7,-7,-1,-11,9,33,2,88,-33,15,-23,-12,-18,30,79,-47,5,55,45,-21,-33,-51,-45,20,-1,-22,-20,49,13,29,-94,-8,1,51,35,19,-22,55,-8,-8,11,21,68,39,26,-124,11,22,31,-93,55, 
  /* [73][0][][] */ 13,-19,-8,-2,-8,23,45,-84,8,30,44,-7,82,-8,78,-19,3,16,-3,7,22,65,81,-49,7,62,-2,-41,-47,11,-24,62,14,-51,4,-12,-51,42,-2,-42,-7,8,19,-16,-26,-50,-41,-26,-79,16,56,-25,42,42,-29,21,48,42,37,-47,-65,64,-51,-7,9,-3,-10,41,-27,-90,-33,-60,-26,24,-54,-14,8,77,-56,43,-41,5,-127,-14,-40,-25,-5,-47,35,-66,-56,20,22,10,-43,-27,30,51,-5,-28,30,27,-19,6,15,26,6,-1,97,-99,-31,38, 
  /* [74][0][][] */ -32,-68,49,-7,-19,55,-65,-17,-82,-66,24,-49,-6,-4,74,-4,-36,-15,-13,-97,6,9,-79,29,53,-65,7,21,41,-23,-8,-30,-23,69,-36,-57,16,55,10,37,4,-32,-19,-6,24,53,-53,-14,47,-67,71,127,-70,-39,38,49,33,-2,18,7,-36,5,26,-14,-36,-50,-5,3,-49,125,0,-9,-8,-2,35,0,6,-32,22,70,21,37,66,47,-25,-4,69,41,-41,54,23,-27,79,-50,9,119,-29,40,36,2,-35,34,-22,-19,-29,15,10,16,48,92,-3,-6, 
  /* [75][0][][] */ -35,-22,-10,43,-8,24,0,1,-11,30,6,51,-80,-9,-43,4,4,26,41,1,-12,33,-59,-22,-23,-26,-19,-77,21,13,-14,30,-46,36,24,-22,6,47,-11,35,18,-24,-49,34,46,-54,50,-58,14,3,52,7,26,-14,44,-58,-39,53,-21,-47,45,13,-19,-49,-7,-101,-25,-16,-16,-15,-50,7,24,-12,70,20,-34,-26,26,-21,-33,-32,-27,-12,-18,-4,15,23,29,-58,-45,-7,-45,-12,50,-55,-38,18,-91,-3,-23,127,59,-40,74,26,-29,18,-28,-13,33,-55, 
  /* [76][0][][] */ -25,42,11,-84,78,29,-87,-19,33,-69,-9,-23,4,52,10,109,81,-55,3,60,26,32,66,35,37,106,-84,-17,-52,-38,-117,77,-51,22,90,-75,18,-68,-51,13,-19,-25,88,5,7,-8,56,27,79,61,56,-73,-35,-28,27,-41,7,-70,54,-12,-17,-48,-1,23,37,-43,47,-20,65,-20,-20,-1,-3,7,38,-70,-68,-5,122,92,-43,127,-82,-12,65,54,-5,-26,-35,-15,-118,93,-121,36,-24,-61,-37,-11,10,90,-50,27,8,-114,106,-103,-49,8,14,40,-79,8, 
  /* [77][0][][] */ -47,-18,-22,44,36,100,20,1,-24,-50,13,15,-5,-40,-96,-88,70,-34,22,-80,15,-89,-47,-29,-39,-43,-94,-83,26,12,-46,-18,45,64,56,-49,66,-7,59,105,-54,-54,34,-33,-111,21,85,6,-34,-35,-46,-8,4,-31,52,15,-49,-127,-98,-39,45,77,2,-11,46,2,-21,72,-75,-25,-42,-52,-38,11,-39,-87,46,-9,80,-34,-9,-17,-71,-5,-100,65,47,-31,-76,-71,93,17,-49,19,-20,14,-69,-21,-33,65,-7,-7,6,37,71,-49,5,42,-6,11,50,-43, 
  /* [78][0][][] */ -12,22,-18,-91,-29,-12,-21,0,-48,127,-21,-8,-14,-22,-53,27,-16,8,39,-44,34,16,-10,-28,-37,-5,3,27,66,-47,81,-94,5,29,-41,-38,-8,-37,42,64,5,35,33,45,-55,53,41,13,66,-90,-18,-61,-51,44,32,-7,40,-106,-61,54,-43,8,29,-14,-28,-10,-20,-21,-20,5,37,33,-22,-12,5,7,-3,-37,-83,-19,31,33,-13,-71,-74,-62,13,-80,-4,62,-51,-52,-23,67,-3,71,-47,38,25,-17,-39,40,-7,63,20,-54,38,18,-32,-39,4,-58, 
  /* [79][0][][] */ -29,-10,-20,40,-25,13,18,-7,-17,-78,-92,-48,-82,-59,58,-4,-30,-33,65,-105,-42,7,2,-14,44,-58,-49,33,2,-14,116,-1,-68,2,57,64,7,-13,5,70,-29,-32,122,-25,15,-2,2,75,31,26,-76,-1,-118,1,127,-4,-113,2,-10,-70,-76,-64,27,0,9,-117,-98,-8,-55,36,-1,-100,-13,84,44,-12,-67,26,-24,55,-39,-64,70,-59,-25,18,24,-3,77,2,0,9,16,86,-101,-23,-59,-14,-71,-12,4,-28,-31,-63,-38,0,50,26,58,48,17,-12, 
  /* [80][0][][] */ 93,-40,-31,18,35,-82,-41,51,-39,-47,20,24,-13,-29,59,-57,7,-86,24,18,2,-11,-6,2,-39,-80,-23,36,-50,19,6,-16,-68,-25,-20,-26,0,4,-62,5,24,6,-16,46,30,12,-56,49,27,-61,20,5,2,-15,-70,-30,7,-22,17,52,-48,32,42,-51,-38,-65,10,-6,46,-11,32,-57,32,58,-42,-60,-14,-127,-15,-8,76,33,-34,39,-21,12,-43,15,8,31,28,-3,-48,-32,-80,-67,12,-21,39,61,-51,7,-41,-24,-40,-4,21,76,-9,15,-35,-35, 
  /* [81][0][][] */ -84,-27,28,38,-3,-48,48,10,3,-30,4,-49,72,-8,-15,-56,-29,-31,-94,-55,-45,-61,29,-21,-99,40,-9,90,33,16,-23,-6,-97,-54,53,81,-69,-4,52,-10,84,0,-86,27,-53,-24,-17,-18,4,-10,-54,-9,45,-68,-26,58,24,-32,84,-8,-41,-8,-84,52,-19,3,2,73,-93,127,27,-67,-37,-45,-43,-42,-9,48,19,46,79,19,8,0,-19,-23,10,122,10,-31,-8,-13,64,71,-27,-40,-16,8,-30,-8,-11,14,7,-32,70,-45,-59,7,-47,-76,91,-64, 
  /* [82][0][][] */ 6,-21,-99,65,82,26,7,60,-16,24,35,24,-62,31,5,30,-26,-14,-54,-115,68,44,-110,-93,50,-22,-39,-77,-117,15,-34,56,97,-65,-21,-75,52,6,127,-59,50,57,37,7,-19,-31,-49,41,43,-35,-36,54,-36,-42,40,50,-21,-14,-72,-77,-34,11,53,-74,-5,53,18,-83,-8,-16,-75,29,-11,-55,45,-40,-31,-3,21,11,-98,30,-16,-42,40,14,-46,64,-17,104,20,9,107,60,-40,-48,-64,54,16,-6,-53,-23,-18,7,50,39,-32,-9,-11,18,-13,-27, 
  /* [83][0][][] */ -10,46,16,-22,-1,-4,34,-67,38,-16,2,-35,-56,-17,22,16,-61,-38,-45,-63,3,48,-20,18,-44,51,40,11,-4,-35,-4,-60,-25,17,57,36,72,11,45,39,-4,39,-74,32,39,-21,9,23,7,-22,30,106,8,-49,11,-48,28,-8,23,12,-35,-15,13,-32,29,66,-4,65,-30,-44,32,54,-43,-46,-12,12,0,-49,-19,14,-17,104,-7,29,1,-1,18,21,40,-10,-6,-20,127,20,-91,-16,17,-21,-6,59,48,79,-39,106,-11,-75,15,38,-9,-7,33,-34, 
  /* [84][0][][] */ 31,-62,27,66,17,-35,-17,24,-59,88,-31,66,-26,-16,19,-77,53,60,92,-39,-63,41,-86,2,46,28,51,51,27,-5,41,67,-44,64,60,-37,21,0,-71,30,-102,-35,-39,18,29,41,54,-75,-31,4,10,-3,16,-11,127,-45,23,-14,12,4,-10,73,-26,-18,-2,36,22,25,11,16,12,-76,-9,15,5,-99,50,-4,-26,13,15,-41,64,-15,21,58,-74,-34,43,-18,-55,-22,-57,-28,-4,-14,-29,-57,50,-63,-12,-2,-16,34,-4,-13,39,99,32,-37,-76,14, 
  /* [85][0][][] */ -72,83,8,23,-81,73,-59,72,-3,77,126,-8,112,36,43,23,-13,-55,6,-35,24,-10,-42,25,121,-53,-7,43,28,66,3,18,47,111,15,-17,111,-55,-7,-34,20,9,60,-55,-95,-72,40,-59,8,-6,-80,6,-21,43,-5,-46,0,-19,78,82,-58,7,0,76,-46,127,-34,62,-20,-76,-11,127,-26,51,53,5,39,37,40,-64,-114,-30,-14,-7,41,126,68,103,111,4,57,71,-34,-84,-124,109,-15,110,-55,11,31,-68,-114,126,14,83,-51,-20,-32,-66,27,-2, 
  /* [86][0][][] */ -2,16,45,-35,0,-5,-40,5,20,4,76,7,-56,6,52,-8,-13,-19,-34,20,-10,26,-3,51,-16,-22,37,7,1,-11,-10,-42,21,-48,-40,-110,40,-21,3,127,18,-20,-108,77,-40,-90,33,-46,-5,-79,6,-76,5,-23,38,31,14,21,89,-16,-14,83,24,2,-39,-40,-22,-19,10,-78,-79,-71,-80,-56,20,1,0,8,-26,72,-80,50,-51,105,-63,52,23,43,-2,65,-13,9,19,54,-17,-8,-11,45,28,7,16,-51,-73,-54,41,1,37,48,-2,-44,-58,30, 
  /* [87][0][][] */ -25,67,106,13,42,44,63,-41,-12,-7,-56,-70,50,-24,-24,-35,6,-65,-27,8,20,-58,-5,-43,-90,34,23,-61,43,0,-12,-17,67,-62,2,44,26,-19,23,61,73,5,-10,-77,-19,22,-40,11,74,8,-62,-50,61,28,68,-98,-32,-57,-66,4,-12,41,-41,-29,-10,19,-10,22,25,-55,4,-13,-40,-63,20,-28,50,0,75,-21,79,80,-62,-57,-1,58,-127,-30,34,-65,21,-20,-19,51,40,-88,39,42,84,68,-3,35,-15,-120,20,-30,34,61,86,-5,-75,-51, 
  /* [88][0][][] */ -62,77,-33,-21,-10,-20,47,-5,26,127,75,-91,4,-50,74,5,-70,4,24,58,6,29,-7,-35,18,-12,17,-12,-67,-38,-13,-29,-14,-20,20,9,33,7,-28,32,3,-52,-26,23,52,2,-47,48,-32,12,-14,63,5,38,-32,60,-8,25,0,30,13,-42,-66,-26,-50,3,-35,-39,-14,40,4,57,60,-26,63,42,-38,45,31,46,-74,15,-6,-74,-9,-16,-56,-17,32,48,-1,69,-1,-46,29,55,-18,-1,54,-87,-68,86,-16,-14,-65,-23,-71,-48,-84,-15,69,-78, 
  /* [89][0][][] */ -42,10,-51,-127,-24,66,67,-7,-25,61,-53,27,-10,21,-30,-24,-26,-56,37,8,61,-95,-4,-26,54,-12,58,-6,-23,-15,7,93,-31,16,38,-2,-14,3,36,-3,-10,10,-22,44,21,-36,-15,35,6,-5,10,-34,8,5,33,-41,-39,-42,-39,-8,-46,-40,28,-40,0,50,34,16,16,-7,-31,105,-7,26,-57,-80,-54,61,10,-20,-12,26,15,-5,76,23,54,21,-91,-75,-36,14,-85,-6,-82,30,28,36,-4,-66,4,43,-20,49,34,2,-31,52,-9,-10,25,43, 
  /* [90][0][][] */ -36,3,-11,-55,-61,-48,-65,44,-61,22,-30,36,7,-41,-29,-67,30,25,13,-11,-34,-38,-21,-27,35,-19,-8,60,-24,-27,-51,-21,19,-22,31,-20,3,-22,47,40,-52,-55,-3,-58,127,-9,30,38,-12,-22,-1,28,35,-40,-83,29,75,-54,12,20,107,5,41,-19,24,9,-4,-35,-9,-23,-13,-8,10,-6,-30,-24,38,-17,-26,15,-25,16,8,3,-38,-80,-37,4,43,34,22,10,-9,40,36,13,-79,9,15,13,-32,-27,-1,-77,-19,-8,75,9,56,-32,-43,-45, 
  /* [91][0][][] */ -43,-19,-44,-34,-9,-31,-15,-33,-3,1,-21,17,41,-17,-16,0,34,27,28,-52,6,-98,6,5,-33,-58,-19,27,-17,-13,4,-52,-64,21,-12,8,-43,-8,-18,25,-69,18,43,-89,-81,38,61,112,-22,-96,51,20,-54,-105,-67,-30,18,-25,24,-11,44,33,0,4,15,50,42,-56,-10,-17,-14,44,10,26,-95,63,-21,-7,-34,36,52,-61,22,-19,34,-3,32,101,-71,-44,-28,8,-33,-30,-77,46,-62,4,27,46,-5,-16,-105,60,-23,62,-15,42,127,78,-47,12, 
  /* [92][0][][] */ 11,-11,-28,118,65,23,72,-67,0,-25,0,52,-70,9,45,-69,24,-30,-70,-30,-34,-25,16,20,-24,75,57,9,-72,85,-4,-98,32,-48,12,34,-52,89,46,-56,127,21,-99,15,-114,41,24,32,-29,-79,60,-50,45,-14,2,-26,33,-1,2,-64,26,-14,3,69,15,56,10,-42,-46,56,89,-48,35,-3,-13,103,5,51,33,-28,-31,-80,24,-54,5,21,64,-43,108,120,-22,54,-63,5,-5,-44,-6,48,-3,-4,-5,19,8,62,23,46,-14,-38,16,61,-19,-72, 
  /* [93][0][][] */ 15,21,-86,-2,-69,2,-21,62,-7,9,-9,83,-48,-79,-50,-24,14,-48,-7,-48,3,76,-68,10,39,39,11,45,-34,24,33,-41,-27,49,-29,-43,-1,-91,-58,-34,-32,-11,-22,25,48,12,-69,-38,68,0,-21,79,-18,-54,13,27,-86,61,-42,-81,-46,-61,30,-26,-5,-8,60,80,46,4,0,-15,-34,104,-20,93,-67,6,22,-43,64,53,-48,37,4,-22,-6,17,20,-54,99,-72,1,39,-33,68,-64,-36,47,-127,50,65,-42,22,-21,-37,-1,-51,-21,-16,-41,30, 
  /* [94][0][][] */ 24,15,68,-16,56,-56,11,-36,-45,-2,-7,45,37,-14,18,35,27,23,-49,-4,39,27,-43,56,23,-93,-27,-57,4,-30,-47,-15,12,-10,8,-36,-41,3,39,-73,-47,-10,48,58,2,23,-19,57,-4,-35,-26,23,16,-48,-30,17,51,56,56,-27,9,-9,71,8,-21,40,121,-47,13,53,2,10,35,63,84,9,-69,46,-13,36,69,-68,21,-6,-39,-127,-71,-32,-26,-29,-91,-10,63,-31,26,37,-30,-38,48,-82,-2,-59,-75,-24,86,-89,-1,-7,15,-4,-124,-69, 
  /* [95][0][][] */ 78,2,-47,-13,-5,34,-55,-22,-127,-54,20,15,23,-5,44,7,-11,-5,-55,37,22,40,-10,23,-52,74,6,20,51,47,-65,-33,32,-68,20,-14,13,-33,45,31,-28,8,63,-52,30,-20,25,42,-5,-42,51,-19,15,32,-4,60,37,-66,-73,23,2,54,60,29,5,39,1,-42,28,-13,27,-66,-16,-15,49,67,51,13,-25,-42,45,27,70,-13,17,35,-45,91,68,-3,25,22,58,11,11,9,-53,34,-27,-41,94,-73,-12,-62,-12,-2,35,20,57,-85,21,34, 
  /* [96][0][][] */ -52,32,-53,-58,-106,50,76,107,85,-31,11,12,-18,16,51,-9,-66,-41,4,55,-59,-43,5,-19,114,22,14,33,-127,15,-47,18,10,-63,-14,0,22,40,20,-10,-47,-6,-29,-64,-52,-32,49,38,-58,-14,-13,42,55,-77,13,36,-48,-14,-16,79,-70,-26,-7,85,78,55,16,-15,103,12,-28,13,-96,-42,-46,14,-55,23,100,18,-76,-40,-81,-21,76,7,22,-25,-52,39,40,5,4,-16,-62,14,16,92,-54,16,5,42,-3,-56,8,10,22,-11,42,-33,92,-11, 
  /* [97][0][][] */ -127,6,0,-57,-13,-20,3,-9,48,-19,108,-32,5,61,50,68,-44,-30,-55,39,-15,-13,8,-24,-13,-96,-6,-53,-43,3,-29,-3,-98,79,2,94,-3,41,54,28,-23,-13,26,110,22,-7,33,50,-26,-94,-1,-3,17,-15,-49,38,40,-9,106,1,-115,13,48,-56,-12,49,39,92,54,-44,-66,30,-26,-19,-19,-113,-33,36,-48,-30,-60,6,-72,43,16,29,89,34,-6,-15,-15,-14,105,-1,33,-33,-28,1,50,-13,9,-89,-22,56,-8,8,33,64,22,7,-110,-38, 
  /* [98][0][][] */ -4,16,11,-3,15,7,104,61,41,38,84,51,30,-18,-64,32,31,-1,58,-19,-35,-59,48,-48,44,34,20,45,96,105,27,28,88,35,3,-36,-21,0,66,-67,-25,-3,-21,77,49,34,54,2,78,-35,-9,52,-25,47,66,-33,28,-109,-56,27,-14,-36,33,-17,-69,17,10,-5,-2,-7,-62,-126,79,12,-7,126,55,7,54,14,2,-42,-44,-41,42,-63,-30,-73,-14,48,66,63,-52,6,10,30,55,3,-24,-1,127,0,0,35,-14,72,-44,68,92,73,7,71, 
  /* [99][0][][] */ -2,-16,-30,-50,-68,-39,-26,117,-46,-10,-9,-34,-34,43,16,31,-65,63,-73,23,65,46,43,-34,-64,-11,20,-11,-5,-38,-103,65,10,-20,43,-43,25,22,31,27,9,20,-52,47,35,-86,-14,-6,-27,87,-72,-13,21,-18,-60,-16,-5,2,64,-29,-37,27,-49,12,83,21,85,44,-14,-19,37,-53,12,69,58,35,8,33,-12,37,-27,-18,14,-21,-11,37,-26,45,-33,-68,-52,23,-15,-7,-1,64,46,35,39,21,-31,-65,-23,31,54,127,-66,-94,-16,28,102,16, 
  /* [100][0][][] */ 62,-69,-30,1,-83,-3,4,-52,30,-34,-56,21,-60,-106,6,-17,-2,-38,16,-51,14,-21,-6,48,53,80,63,-36,-18,-46,-7,43,14,-76,-22,-25,-24,73,-43,29,-25,-8,-20,-17,-6,32,33,-59,14,-44,-52,35,-5,34,-15,24,54,10,16,-43,-4,14,21,22,-6,-1,33,-6,-67,-32,6,-19,-68,-27,4,5,43,71,25,-7,-1,-30,14,-9,-21,-34,9,-66,59,-61,27,-21,127,10,-7,-2,-30,5,-2,-30,-43,49,10,-1,40,-28,38,-39,-21,14,-23,13, 
  /* [101][0][][] */ -16,53,-53,-60,34,12,-20,-17,21,6,88,41,-4,-127,1,-28,-43,27,47,9,-22,0,-13,10,-58,15,-44,-42,33,-39,-46,-69,23,-57,-15,0,-21,-18,-36,15,-55,-46,-7,-46,28,41,-2,31,-12,-57,-74,-31,-7,18,0,52,4,22,-59,-8,79,33,45,-25,26,44,23,74,12,17,16,-26,-45,60,26,-11,14,81,1,66,-67,70,-21,35,-5,9,-17,-36,-4,36,-74,-3,44,-7,9,31,-10,4,33,32,-29,52,-64,93,41,3,-64,-33,-24,28,18,34, 
  /* [102][0][][] */ 31,-11,13,-15,3,-100,-1,-14,11,35,22,-13,16,-9,-96,6,-61,41,-45,-12,6,9,17,-40,72,-10,-64,14,87,-50,-33,12,-31,15,-13,-50,40,8,12,-5,-35,-41,5,-7,14,38,37,-3,56,-4,-48,2,-77,-50,74,10,26,-8,-10,-76,8,1,-79,20,4,29,-18,-52,24,11,6,28,47,-127,-21,15,13,40,-64,38,-66,-50,-5,-56,-8,-1,28,32,-66,-3,57,-19,30,-28,-56,18,-88,67,81,-39,-7,-73,33,-57,14,92,61,-8,-4,-35,40,74, 
  /* [103][0][][] */ -32,56,-32,30,-27,-32,-78,74,10,-89,-26,2,6,-15,16,-24,-45,0,-17,4,8,45,28,87,-12,11,-1,-43,-64,-46,-17,1,22,-50,-9,-32,20,-61,68,-28,-7,87,59,-18,1,21,-34,-26,55,0,7,-33,47,46,-24,-16,-11,-102,9,12,-24,0,26,47,-39,35,13,25,21,72,47,7,-21,3,-41,-64,-17,30,-53,-30,61,31,-58,-80,13,-72,16,32,22,34,-61,36,-8,-21,-42,-16,35,44,-127,6,7,26,2,87,-26,40,4,32,-31,19,-8,-43, 
  /* [104][0][][] */ 89,-16,-44,78,53,-33,54,-64,-77,-41,78,23,-14,-15,30,50,-87,51,-8,-12,15,-48,-9,49,29,-101,-21,-25,15,-15,-19,-36,-73,31,61,-66,89,10,10,17,-32,37,73,22,25,124,-102,62,-25,28,30,-1,56,115,125,29,100,5,19,63,8,-50,-94,-14,11,-98,-38,-46,-10,-20,32,-7,33,3,-27,53,-77,7,-31,-46,-107,72,28,45,7,-43,-39,-12,-119,63,-56,-42,-68,-66,-13,2,33,-76,21,-20,-15,2,53,45,33,46,127,64,-18,66,-38,-82, 
  /* [105][0][][] */ 26,-58,-36,-41,1,57,-46,-1,50,13,-84,-105,52,-45,-101,5,-114,-31,28,-3,28,-46,29,-68,3,20,87,27,31,49,-54,2,-13,127,54,-33,-1,-68,-19,68,18,-10,77,1,-83,-4,-14,-51,-24,40,-101,55,-57,-18,10,40,-60,-41,-54,-81,20,-74,5,40,78,75,-16,-69,-21,39,-59,8,1,61,-10,-13,-34,63,-11,-33,69,-1,-33,-1,-14,-73,52,80,32,-10,-13,57,115,-14,-43,96,58,38,-85,-37,-22,94,72,-8,-6,32,77,66,-5,-51,87,29, 
  /* [106][0][][] */ 65,3,-7,-34,30,-14,98,-1,64,76,127,6,38,57,44,-14,-13,5,30,45,11,69,-73,40,6,-41,-65,9,42,-64,34,-46,-12,45,-18,-3,-25,12,2,-64,-9,-5,-108,-49,-52,24,63,-50,-46,22,18,23,-43,-108,73,-53,41,9,-109,16,-6,-105,-48,-11,93,-32,-31,41,101,-48,34,75,73,-35,70,14,-72,73,-28,93,-37,-36,39,3,44,65,-48,-21,-10,56,-61,32,41,35,-58,51,-80,106,84,-19,33,-64,-1,-97,40,21,-2,37,-7,-7,1,-75, 
  /* [107][0][][] */ 27,65,69,34,29,58,-24,-19,58,-4,-3,-58,-3,-53,83,-13,-14,-29,45,48,-5,24,-48,28,8,7,-4,7,-119,46,-27,-46,21,-4,52,14,34,-40,33,11,-5,-37,-5,-60,-10,7,6,28,83,-33,-45,59,30,10,-47,-33,-39,50,-36,99,-41,-15,10,-11,36,-28,13,29,77,-23,-27,-16,49,-61,6,-3,-38,-26,127,27,-67,-14,-10,46,4,15,23,-19,-68,51,-10,42,73,-23,-74,-27,64,13,-13,26,-41,85,26,-19,-2,13,-62,0,20,13,-4,-25, 
  /* [108][0][][] */ -38,-30,18,55,-31,53,61,84,39,8,88,20,-66,64,-19,44,34,26,61,-85,26,8,-45,75,78,6,26,74,12,5,25,79,5,-17,38,65,17,-28,-6,-121,11,-67,-58,6,43,-40,-58,25,-38,17,37,32,-45,-36,-27,-16,-20,29,26,-42,9,-69,-27,-99,-127,56,-87,85,27,23,28,-43,120,20,6,81,-94,-22,13,75,59,42,-3,27,-23,25,15,44,29,7,-3,37,110,48,46,26,-47,-38,-8,65,20,32,-33,-56,3,-9,-87,-57,-37,45,-1,-1, 
  /* [109][0][][] */ -6,-30,-5,-66,46,-14,-27,2,-5,7,40,-5,-20,-23,30,3,98,-75,-36,-4,-66,24,-22,-40,34,4,-3,42,48,59,-11,51,63,20,-10,-29,-72,21,-39,-30,83,16,21,8,32,11,43,23,-11,-47,18,0,11,34,15,-82,-22,-7,59,-6,9,127,-23,-72,25,-38,-26,21,-18,16,-10,-39,-26,-87,12,38,-12,15,-11,14,81,31,18,-47,28,47,50,-23,-2,1,46,51,41,17,56,52,64,23,-6,-51,-25,-20,70,-80,55,64,-71,18,23,-14,-39,-39, 
  /* [110][0][][] */ -7,-25,115,-44,4,-20,36,-27,52,105,0,20,8,-18,-20,-20,92,18,9,13,-61,63,46,1,-45,17,8,-16,56,-15,13,20,14,46,-1,58,-127,-60,-73,31,8,-8,39,42,-55,21,37,75,-106,-30,-23,-29,-68,-41,-27,-10,-13,-79,-23,12,31,-18,-23,-64,9,-51,-22,51,66,-24,7,-27,-31,69,-41,-25,8,-26,67,95,22,-23,-108,34,-23,-76,26,-63,-49,11,11,42,-11,-14,15,15,-9,-22,4,22,-2,20,-43,-12,-6,22,23,-51,46,-2,-14,44, 
  /* [111][0][][] */ 24,-58,-70,-5,-107,-125,-31,48,-124,15,-7,-61,79,7,67,29,-58,-78,84,-25,-33,-3,-5,39,0,-32,1,10,-44,-55,-116,62,-52,4,-39,-107,-3,1,-1,56,17,11,50,-21,76,17,1,-17,5,17,45,-34,51,-8,32,-67,10,25,17,27,11,48,-47,-25,79,104,-64,23,-47,-60,-27,20,-6,-26,40,-45,55,-27,-50,63,10,46,94,-67,-36,127,8,52,83,35,-66,11,39,-83,72,-17,28,1,-97,79,-102,-14,16,-49,-44,13,17,-7,30,-52,55,-6, 
  /* [112][0][][] */ 12,-52,-29,10,8,-9,21,-29,-32,-6,36,-18,-59,2,-4,9,0,-14,-41,1,5,-7,40,-29,24,26,-50,-29,-58,-22,-13,44,-26,32,51,34,2,-78,-90,25,-30,15,27,-3,-37,-4,-24,59,9,-23,-24,7,-49,-13,-35,13,-6,-15,42,3,17,-42,-10,-61,24,-44,24,-62,-58,-6,18,-79,7,-40,35,-16,56,8,13,-71,39,-32,18,35,-21,-17,-33,45,55,36,-17,-1,9,127,-34,51,8,28,13,-33,-23,27,48,7,-20,-4,-16,54,3,2,47,8, 
  /* [113][0][][] */ -10,21,27,-88,50,60,79,-10,-15,32,-50,3,-102,-25,48,-21,28,6,-9,-39,-22,-41,-3,16,66,-66,-1,-17,11,-85,-94,-13,55,74,21,-19,23,4,55,-56,-15,8,118,-8,92,42,19,-29,22,-54,-51,-35,-83,52,-37,26,23,1,30,-71,1,18,-35,-95,-52,-69,82,47,102,27,89,-66,61,-21,89,79,-62,-12,51,2,50,6,-2,-31,32,-85,-87,-41,69,86,42,45,-17,51,29,22,-51,-127,90,-61,35,-42,70,59,32,-39,-6,-52,-104,-11,-32,54, 
  /* [114][0][][] */ -5,39,-42,-7,15,-30,18,17,-61,49,47,24,43,-63,-43,-40,-12,17,14,3,62,-4,23,-12,-65,-41,-19,-32,-12,32,11,-55,-8,20,-41,-5,-23,-30,-42,28,-16,56,33,36,-48,-24,24,15,-14,7,-97,1,-88,-8,46,-38,-26,-49,-6,19,-34,9,40,81,15,20,73,1,33,97,-24,-27,1,4,20,-81,18,46,-52,-16,35,55,-36,17,51,127,54,-10,-2,-43,58,25,14,-32,-8,27,-5,22,17,-46,71,-19,-54,-45,-3,33,43,39,11,-69,5,22, 
  /* [115][0][][] */ 10,-55,30,-18,-59,14,6,19,6,61,-47,1,-55,11,60,-41,29,-53,-26,38,-37,17,35,7,-9,29,13,25,-2,-4,1,23,-2,-6,4,20,-45,-31,45,51,41,-60,51,10,75,-1,7,-97,-8,13,-33,-51,0,-44,29,61,13,-11,-2,-28,35,-29,35,15,20,63,-16,-54,44,-34,30,-70,-63,-3,-20,28,10,2,53,-32,-23,-1,13,25,-127,59,-41,11,23,55,10,-87,-10,-40,-5,-39,-40,1,-27,-62,63,33,-10,34,87,-78,1,25,-6,-32,39,-71, 
  /* [116][0][][] */ 12,-40,17,-14,-13,-21,14,22,76,-10,29,25,23,-9,-48,52,-53,-61,3,-42,8,5,-11,-89,-58,38,42,-3,37,-1,-58,28,40,-58,26,-32,84,127,46,-67,93,12,-1,13,-22,-7,-11,23,28,-37,11,-24,4,20,-69,-11,-17,-8,67,-20,57,58,35,-4,23,23,17,0,23,54,-29,6,-17,-56,-44,37,42,13,24,6,7,42,15,-54,-92,38,11,-61,-1,-34,-45,-23,-3,-21,-75,-70,46,21,20,-43,24,4,-9,30,4,64,-20,56,66,-33,-56,-33, 
  /* [117][0][][] */ -49,8,-3,5,-41,42,5,69,-63,-64,-21,-67,20,52,-54,-3,-77,66,71,-39,-23,5,-49,43,-19,-61,-88,39,36,37,17,73,-60,72,41,25,29,-29,17,59,-64,3,25,47,-55,-13,11,36,-101,44,75,28,-24,13,65,-4,-37,-20,51,-55,39,20,10,82,-40,-65,78,33,-47,42,111,12,78,8,79,24,-51,31,54,-73,-47,-6,10,20,56,76,-67,61,-12,65,-50,24,-51,24,66,32,-127,26,13,17,4,27,83,12,54,58,10,91,-31,-49,36,2, 
  /* [118][0][][] */ 28,34,-45,33,43,84,-19,-8,-8,18,19,9,-17,36,105,-31,21,15,-9,32,94,77,-49,26,-127,14,35,59,12,-62,-18,-32,22,-3,114,4,74,-16,60,-13,15,-69,6,57,-22,-15,57,-16,1,2,4,-37,-23,-39,-3,-66,-19,15,31,-106,49,24,28,29,24,31,35,90,-31,73,5,-15,101,-43,-69,-21,-26,-12,44,-10,-76,6,-53,45,84,51,34,32,21,-78,-19,31,103,71,-25,47,-51,-21,34,-63,31,-16,-35,-6,58,65,-92,-8,98,-20,-23,-47, 
  /* [119][0][][] */ 17,-22,38,36,-11,-1,32,31,5,78,-48,-57,-20,-48,-22,6,-4,-3,19,7,50,31,5,29,22,-27,50,62,45,-32,71,-11,-63,24,-108,-21,-62,58,5,-27,59,-55,10,38,60,-10,-31,-5,-1,-20,20,-55,-21,25,45,-48,9,-11,59,24,-38,-4,49,30,16,-19,-6,-22,-32,31,1,85,-22,-6,28,-10,-73,-25,-61,71,12,56,-30,-40,30,-15,3,6,71,8,9,51,-36,9,46,63,-42,-32,-127,53,64,-45,49,-35,-7,41,-14,96,60,-35,3,-8, 
  /* [120][0][][] */ 8,56,18,89,-27,12,81,73,-29,22,25,-73,-70,-42,-19,1,121,41,30,67,3,-6,-127,-32,-51,-112,-17,-34,-23,-49,28,49,-53,-38,-58,-56,89,12,11,50,-64,48,28,-13,57,-32,63,-56,70,64,4,114,-27,-62,-51,18,4,107,47,44,-46,-32,-13,91,-48,-13,-92,125,44,11,-57,-26,12,53,-56,-15,-20,-17,35,-80,-39,-19,32,34,36,-2,79,108,17,10,94,37,-4,-50,29,-2,14,-82,-34,-29,-33,86,11,-27,-108,-8,49,-76,-18,-25,71,18, 
  /* [121][0][][] */ 6,5,63,-20,-20,-63,56,-36,41,58,-23,62,67,-71,28,45,32,48,27,12,4,22,16,-1,67,24,-41,-42,48,-2,-12,-58,44,-45,-50,91,49,36,-32,-27,16,43,-61,79,2,13,-26,-47,-4,9,-74,33,47,-65,95,13,113,-43,114,0,-84,4,-64,54,-3,39,-62,-31,-8,0,72,-21,82,-29,45,-64,9,3,34,45,-85,75,58,70,-7,12,73,1,95,34,54,20,-5,-29,-24,-42,20,41,-26,-25,-18,-5,-9,9,24,-24,50,25,-60,-10,42,-127, 
  /* [122][0][][] */ -26,6,9,49,-26,73,-2,15,54,72,12,-20,-36,59,12,47,-16,-56,-9,23,57,47,-31,-17,19,11,-38,-19,-23,-20,6,-11,5,-20,-97,-4,-13,-43,3,52,-41,96,-5,51,13,-59,36,-17,-36,-102,-12,-53,63,36,22,0,-127,19,-64,7,-5,29,45,-21,40,-26,-1,-36,26,43,-65,35,-39,29,71,-17,64,105,77,-82,-113,5,36,81,60,-21,16,16,36,17,53,24,63,-16,-43,-5,-59,-29,27,-106,-44,123,38,-29,-33,9,25,17,13,19,24,-34, 
  /* [123][0][][] */ -58,64,2,67,-118,-94,42,4,-29,-59,106,-127,21,-23,91,9,-8,26,-50,-126,11,16,-30,62,59,30,39,16,126,-7,4,65,-54,-6,18,55,78,24,-7,13,-33,-16,-6,90,109,-33,24,-7,-79,-14,-2,19,56,-125,46,6,16,77,-63,39,-29,23,-85,-40,44,-101,67,-82,34,-32,-95,-25,-33,21,48,39,85,-25,-24,9,24,40,64,-46,-6,-24,-11,44,18,-47,88,-15,-73,-36,-31,9,-70,-34,33,-41,-25,-87,94,72,39,-27,-18,-36,-49,0,87,80, 
  /* [124][0][][] */ -34,-1,52,87,-37,-21,-13,8,7,-28,-9,83,66,19,7,-2,45,-4,31,17,-32,25,-11,46,54,-17,-83,26,-44,-76,-18,59,-51,-25,-65,-7,5,-82,-95,-27,55,27,124,-49,-27,35,-67,-45,35,-18,-5,11,-8,-33,79,-28,69,36,36,-95,50,78,-14,-69,-4,-24,49,20,-9,-9,-55,-52,23,93,-4,44,-70,90,3,-4,-40,-19,-6,-9,1,2,-56,26,76,-1,46,35,-57,21,-27,25,-29,18,-62,28,-5,127,-10,-57,57,-1,-118,-32,-48,12,-16,-13, 
  /* [125][0][][] */ 18,7,-25,-60,34,12,45,-23,-27,22,50,2,-14,-5,73,39,-41,41,64,-44,9,76,29,-59,9,60,-4,-5,21,-57,45,20,-18,-25,52,8,-127,9,1,22,-57,-23,11,-32,-42,102,9,46,15,-44,28,-11,29,53,26,112,-38,20,-64,-60,27,-11,-27,33,12,-84,60,-28,13,42,76,16,-89,80,-34,23,-14,25,10,-35,54,-64,-27,-35,-16,3,6,43,-87,11,-58,19,90,28,-4,-79,-59,-19,40,-11,-8,-41,3,11,-46,29,-16,-47,-1,85,42,10, 
  /* [126][0][][] */ -17,-64,-38,-9,-58,77,16,-55,15,-39,3,37,9,35,19,-15,9,-10,-18,-47,-22,-60,76,48,-4,-21,-55,29,-109,-86,38,21,-2,-127,-48,-23,10,-27,21,54,54,15,-61,40,-42,11,-17,72,-14,87,35,58,-19,23,-56,-18,16,-21,20,-9,-5,-4,-30,77,-74,32,62,53,5,21,9,-34,54,45,5,37,-50,-41,-45,-78,10,18,11,-24,-64,65,-7,67,-5,-13,-47,-27,-100,-77,7,56,40,16,29,47,39,-42,83,14,32,-47,13,-42,-36,-88,-19,63, 
  /* [127][0][][] */ 29,-16,-30,-6,-49,87,3,38,16,-38,-36,-24,33,-15,33,-2,-28,12,-7,-57,9,-15,25,-15,18,39,21,17,107,-54,-57,52,-24,3,52,-5,-13,-46,-34,47,18,55,72,7,68,-40,-33,-15,14,-40,-6,-96,-57,40,-34,44,-111,1,-5,-20,-70,53,6,-12,-14,7,-12,-12,-52,-10,-60,-111,-2,22,46,-127,45,9,-81,66,10,8,-65,83,-21,-8,-2,-50,28,33,-96,-11,79,35,-1,-16,-6,-8,38,-68,11,20,46,-47,7,29,-8,110,9,-86,16,-80, 
  /* [128][0][][] */ 15,81,40,-22,-21,-34,-37,76,-28,-12,-51,22,16,-32,5,54,4,9,-15,-13,-31,-7,44,-91,25,-57,19,77,-42,77,17,-24,56,19,-90,-1,-14,-14,-6,-30,-63,55,53,6,-5,24,-5,19,-13,-57,48,33,2,18,34,-35,-35,-53,19,14,27,27,-31,-46,-6,12,48,-30,39,67,-4,50,-44,47,-6,3,-67,-11,115,67,-127,1,-21,22,-17,-91,105,-21,-44,62,-41,-69,25,28,11,-39,5,-23,-1,-74,-26,39,13,-34,2,20,-6,54,113,49,-106,11, 
  /* [129][0][][] */ 44,60,51,15,-1,5,6,-21,66,-61,-6,-21,57,47,15,-15,-18,-66,-35,39,-24,46,-82,26,3,-72,-39,-31,33,0,-42,-11,97,4,-21,-58,44,14,24,33,-56,-2,-39,-50,18,7,28,-45,25,41,41,-5,127,-21,-49,16,-79,11,-11,-7,40,-37,-34,-17,-8,-20,-25,15,27,4,-75,-12,-7,23,64,23,-70,33,-81,23,-35,-32,-9,53,-20,-15,-82,-1,38,46,-84,-14,18,28,103,-8,-22,29,-18,50,11,14,-31,22,-38,-13,-10,-21,-9,72,-43,-6, 
  /* [130][0][][] */ -14,-44,2,-43,-24,-20,-80,-12,26,38,24,23,2,-24,6,91,28,19,-32,-8,42,-4,54,33,10,-68,4,59,29,-14,-86,35,-59,-1,11,-14,-16,6,40,40,-18,53,29,-6,-36,5,-60,68,11,94,49,0,46,29,-58,-91,-20,61,13,127,38,-27,-82,10,65,-77,59,-26,6,-39,0,35,-16,39,19,5,119,-44,-35,94,52,-7,64,-63,-17,45,-11,-26,28,6,-4,54,-105,-59,-68,-47,-35,1,-68,-73,32,43,22,-95,-3,-65,13,28,-41,-53,34,88, 
  /* [131][0][][] */ -12,1,17,30,47,53,57,13,-63,36,-28,-26,24,28,-11,-27,13,78,15,28,-15,80,-20,25,36,71,-24,39,41,32,-4,16,9,-20,57,52,-57,-8,46,127,32,-71,20,22,6,35,54,-38,-8,-29,-53,16,-23,17,22,-19,39,45,-24,-53,7,-4,1,40,-6,-6,-19,-6,-49,-68,-23,-38,20,16,4,-11,48,-49,16,-13,33,53,-8,57,-7,3,19,-43,-53,8,-8,1,23,21,39,-26,22,-10,-74,-9,-12,31,-13,-52,-61,6,-33,20,31,20,-3,-19, 
  /* [132][0][][] */ 3,-43,44,-24,-22,64,71,44,-17,-25,61,3,9,25,-25,-27,32,56,-15,62,21,4,20,9,15,-59,-33,-63,-54,4,21,23,17,-12,73,-52,14,-1,-4,26,-5,-23,73,39,67,15,-18,-15,-37,4,127,-25,10,-10,57,-16,2,34,36,-3,21,64,-91,-65,-19,-9,-11,-5,-46,43,-79,-29,-3,-14,-20,-19,-26,26,14,23,-27,-12,12,73,47,42,16,18,-5,7,-7,51,-10,13,3,95,45,-82,6,-30,-56,41,-45,35,-29,-28,-39,11,-16,-11,-41,-78, 
  /* [133][0][][] */ -56,100,74,-99,-93,17,-116,-15,-43,-41,33,36,-78,-67,-48,44,56,68,35,-33,38,37,-24,24,21,-1,109,27,-2,24,9,-9,-4,-15,101,-32,-73,-72,-5,53,43,-22,5,-1,39,-89,62,4,-63,-32,-78,-2,15,-72,3,42,-20,20,32,-34,48,-1,-9,-37,22,-63,5,-72,-20,32,20,44,7,33,67,-22,-33,-27,52,31,8,41,-110,4,-16,31,-9,54,-36,71,33,-33,-20,101,-4,-44,-76,-31,127,-42,-8,0,-73,29,-17,57,-5,6,-63,-12,-70,-4, 
  /* [134][0][][] */ 18,40,-42,-48,-45,17,0,-12,72,75,-29,-24,40,-40,22,6,-60,-2,77,105,11,-32,16,-17,-127,-18,-61,36,-64,16,18,-68,-16,-11,-54,-61,43,96,-3,-45,56,25,108,72,12,101,-106,36,-9,-76,-31,-43,17,38,-39,40,-97,21,10,-7,-58,12,12,11,-57,-10,30,57,2,20,41,18,-44,26,-64,-77,25,38,79,-56,89,36,16,-27,-79,-23,12,-29,-29,-1,-111,21,38,13,89,-53,-48,-23,-31,-14,50,54,-82,17,-61,2,-34,43,-44,33,60,12, 
  /* [135][0][][] */ -28,25,-22,8,-2,-22,22,67,-53,-37,21,-59,68,-37,-18,-72,-19,31,25,-41,19,18,-61,23,-14,-3,-8,-88,-52,-33,27,38,-21,14,-44,-45,-2,-7,-27,38,-33,33,28,22,18,-9,-39,11,-28,-73,-42,19,-33,56,32,31,-5,41,47,7,-36,90,-3,-32,-26,9,-4,-23,-23,-35,10,-24,-7,-5,-4,-95,-40,66,-14,-43,-13,25,-61,20,-46,-54,-19,14,-20,35,-127,-63,46,7,88,38,80,2,2,54,21,41,29,10,-103,43,19,-19,-36,-11,-73,-47, 
  /* [136][0][][] */ -3,37,-11,-45,34,6,-33,-4,-26,84,4,31,65,-47,-21,-4,-7,-29,16,20,-23,20,-11,9,-39,6,-44,-32,14,-40,-8,-35,-84,45,-17,-82,-41,-34,-8,22,95,26,-70,-27,63,-48,67,39,11,33,65,57,29,-58,-4,-33,3,-74,12,-9,16,55,20,-98,-54,3,-41,13,36,-12,19,40,11,24,21,34,-49,-3,26,-4,76,-9,-65,-65,-107,-14,-23,33,1,-36,-19,-6,29,-17,-35,-49,18,-29,-50,-127,9,32,-1,95,66,4,22,-51,19,-8,-38,-26, 
  /* [137][0][][] */ 17,-59,0,13,-24,102,-20,15,28,-42,2,53,59,-21,62,60,-31,-19,39,-42,5,-22,20,34,-83,-58,-53,-57,4,-46,-1,127,-48,34,-7,-26,-3,69,-44,31,22,31,2,32,32,-9,-16,9,-6,20,-38,-4,45,13,57,-38,9,-8,-1,-23,25,29,-39,7,11,-43,46,18,-68,0,-11,32,-1,100,87,13,6,6,-50,-34,15,-89,22,-14,47,14,-30,49,3,1,-46,-60,-51,15,6,-53,38,60,-5,-90,-17,-31,11,-37,-70,-75,7,117,47,10,-41,77, 
  /* [138][0][][] */ -55,26,-42,12,-16,-16,-10,33,-47,-13,48,-7,-7,29,102,-10,31,44,18,2,-66,47,31,-36,-27,13,0,-3,-24,35,59,-7,46,35,15,-55,-8,89,8,5,-34,-9,61,32,-46,38,36,32,-11,9,61,-50,68,9,127,-53,-6,8,-76,57,-28,-20,-16,-31,-19,-99,29,-20,-82,-26,-25,-12,18,-12,108,-4,-18,14,-11,-3,-22,-1,-42,29,44,58,53,0,7,23,-64,-74,15,58,10,-53,23,-8,12,25,41,63,41,-49,33,-66,-25,49,49,-9,0,-45, 
  /* [139][0][][] */ -29,29,-57,-50,-71,-108,3,-78,-15,-21,-46,38,64,25,-37,127,2,45,61,10,15,-14,-69,-36,14,-58,-14,-28,-48,-72,-4,31,42,-62,8,37,7,82,-46,89,33,59,22,-38,64,102,32,33,-16,-15,54,-1,-41,-21,-39,27,-42,34,4,-87,10,-14,25,-52,22,26,32,-8,-29,21,-38,72,20,14,2,-37,103,99,-51,-56,9,-15,37,41,25,-52,12,-1,24,84,-32,76,49,-22,-19,6,-60,113,24,67,-74,-17,-52,-80,-48,-4,2,30,-27,-36,78,36, 
  /* [140][0][][] */ 76,-27,-43,92,-36,-29,35,-43,-38,55,33,-63,-75,-46,-63,33,-3,-72,-8,41,-16,39,-69,43,43,5,5,82,19,-74,22,-115,-10,36,5,-63,27,-11,42,-76,11,-36,-23,28,-18,-74,-72,-16,40,65,-20,7,-25,17,1,-28,-21,79,-58,6,-38,101,57,15,2,12,-41,38,22,-51,-32,45,-6,-26,33,8,-37,-13,-37,-32,41,-41,-45,36,4,50,-1,14,-44,23,-56,68,7,73,39,69,11,-55,-23,21,39,14,-6,-17,-93,8,12,127,-56,-37,20,26, 
  /* [141][0][][] */ -4,-20,93,-103,-9,-23,0,-74,54,12,6,-24,28,12,9,24,22,21,-9,-9,-48,22,33,32,-3,-35,-87,34,20,-33,15,71,-36,-44,44,-40,-5,-3,3,52,10,-39,-80,-1,-7,65,10,19,-23,40,34,29,-29,-48,-11,3,70,42,44,13,-29,38,-127,36,27,63,2,57,-14,-51,-23,-77,-63,-17,31,-3,12,-13,14,-36,30,-12,27,-23,13,-10,10,50,10,-52,21,-36,7,-21,-4,9,26,-11,1,25,-18,113,-59,-1,25,2,-52,26,55,34,3,36, 
  /* [142][0][][] */ -43,104,-41,-85,-9,-9,-63,-23,30,-31,31,-63,17,4,23,52,-22,24,-17,-71,-23,-27,-5,-26,40,54,12,75,4,16,7,-47,-40,-45,-28,-36,-34,0,16,-10,15,2,16,-19,11,21,-48,-27,-8,-27,69,38,-42,-39,-34,-5,21,-18,92,-77,56,12,57,-19,89,22,-7,4,-26,61,32,48,4,102,127,-11,-44,29,-41,24,-3,-27,-47,-52,-35,-20,84,0,-17,-79,41,48,-39,76,-71,-40,-27,27,10,-11,-90,-3,-29,-32,-49,23,7,2,-20,-41,7,-45, 
  /* [143][0][][] */ 13,56,-5,-58,-7,-26,71,59,37,88,25,13,-1,-34,10,-100,-11,-60,-15,-51,32,-8,-15,52,46,-42,1,-102,50,-21,-11,-7,-26,-25,-31,34,-13,-87,48,7,-31,-23,-43,25,35,5,22,16,-33,-29,87,34,15,124,-38,62,99,56,-1,27,41,21,4,-57,-5,-18,33,-16,-19,48,16,114,18,31,34,68,30,-27,-69,-40,94,-82,19,36,40,-38,-15,-28,-127,-55,-49,-3,-25,18,-35,8,54,-26,-23,35,-41,14,-28,-8,-27,-75,29,-14,-57,-26,-2,47, 
  /* [144][0][][] */ -80,11,-84,26,38,16,98,76,-123,33,-35,57,3,-26,14,48,55,29,-51,37,-50,44,69,-2,-78,-57,-16,-44,-48,-92,24,-9,-23,-32,1,-28,26,108,-4,-26,-3,3,47,14,-51,48,50,-14,13,-65,-20,-8,75,37,-66,29,-49,-33,71,66,-42,23,73,47,39,5,-62,-67,4,-37,4,-16,-13,6,-90,-1,-35,14,44,-83,18,19,-80,-127,74,-85,47,-9,13,-36,-31,-32,-68,-9,-42,-22,49,-83,-16,64,14,-29,-32,24,2,22,-34,-46,1,-15,-70,-8, 
  /* [145][0][][] */ 24,-21,61,72,27,-24,-31,42,-80,8,-69,5,88,39,-11,45,-13,61,-36,22,70,-29,103,-4,-16,46,-70,2,17,-9,-79,-40,-11,-60,48,30,38,31,34,79,-56,-35,75,-15,-18,103,-8,73,-11,35,27,39,13,-40,24,-23,34,-4,-32,-47,9,60,-39,64,-70,75,-66,8,-36,-21,78,64,55,8,61,-127,37,11,-1,16,-7,31,38,-87,-2,48,-27,-4,0,105,-42,-22,37,24,-64,-15,-31,-31,9,13,109,28,-3,-48,-39,61,3,51,7,3,-73,-25, 
  /* [146][0][][] */ -92,-58,-5,-75,-63,6,-43,-26,15,11,36,89,-87,17,8,-75,11,21,99,-73,-73,74,-29,99,11,-53,86,-6,14,-65,-27,1,-86,-111,67,-40,6,-53,10,78,0,-50,44,85,-97,89,77,-57,76,-5,2,-66,19,4,-37,20,51,-58,22,-1,12,3,-39,17,-18,-11,-13,-33,-88,-111,43,-127,31,21,-11,17,-2,43,6,37,-67,-23,25,12,26,34,-18,48,-39,51,-35,17,-11,53,51,-88,-42,61,63,67,-71,-88,49,-95,46,-88,-6,-26,52,-8,96,35, 
  /* [147][0][][] */ -20,43,-2,-36,31,21,-13,20,4,37,-10,32,-8,41,-5,-30,-24,-49,-24,-78,41,28,44,-43,3,-65,-63,-81,55,26,-55,-73,13,-26,32,-18,-9,-42,-17,127,-36,-5,43,-35,33,-39,22,-9,-11,16,7,-20,-15,-45,-30,1,32,-8,-70,16,16,20,11,42,3,-46,63,-24,-56,39,17,59,4,7,7,13,3,4,5,5,-40,55,49,-10,45,-3,-17,77,43,-43,-37,-24,21,-8,-20,20,-51,27,-16,-59,-123,-7,-27,5,-30,8,78,111,1,-26,38,-65, 
  /* [148][0][][] */ -48,38,35,14,-6,-25,-28,-3,-12,-32,-1,-30,-2,-44,-66,-23,15,-14,-67,-63,-35,-30,-18,77,7,-3,23,-2,8,9,-4,9,8,12,25,-42,-49,22,2,7,26,-115,-45,14,43,-45,-9,-89,-80,39,-14,-58,1,12,18,40,49,-11,62,35,-20,2,0,16,-13,-34,7,45,26,-3,-19,-8,-15,54,-7,31,-53,29,64,43,-14,9,-28,-114,17,-1,127,27,-64,-40,68,3,-68,-8,43,11,-82,22,1,-52,-25,29,-31,16,-23,37,21,34,52,59,34,-23, 
  /* [149][0][][] */ 3,17,-49,48,-55,-24,22,-34,-48,55,5,25,25,-32,-11,-39,-5,-17,-2,9,-72,-62,30,-93,-94,98,34,95,-31,-11,18,-20,37,-100,42,-15,2,-44,59,9,18,22,42,2,50,-7,-47,27,-11,-45,7,-17,-48,-62,3,-44,-10,-81,21,75,16,-14,-12,85,-81,49,35,-32,-9,-78,14,-15,-12,-13,-25,9,35,-14,0,-11,32,-26,-56,-56,-16,-9,13,-59,-31,-26,40,-18,-16,0,-29,-30,45,17,-127,-36,18,21,20,70,4,41,-5,11,18,-21,-16,0, 
  /* [150][0][][] */ 35,-28,-12,-9,27,-24,-55,-89,9,-27,86,-3,-6,-22,-72,69,-44,-25,-12,12,-45,6,80,7,34,18,17,-57,7,-84,-6,-34,-41,-104,-33,-48,-60,22,95,58,-30,-9,20,-34,-51,-55,47,3,9,-3,7,-52,127,57,-23,-7,25,-69,77,33,39,35,-11,-21,18,-23,28,29,43,-58,23,-23,-95,-12,-70,-1,-1,-48,-64,-1,-8,40,-59,-25,4,50,9,4,-1,70,21,36,4,-36,22,-32,-72,-23,-9,29,50,-10,-29,40,92,-6,-46,-30,71,35,-30,-37, 
  /* [151][0][][] */ 66,-26,24,50,-68,-40,-60,23,-18,-43,30,63,-21,37,-40,-45,31,-2,65,-4,-36,-74,53,41,37,-81,-37,-85,-112,-25,104,-32,-86,2,26,-83,-4,36,-28,77,1,31,53,2,-25,-10,-36,-12,1,-12,33,11,39,-9,20,36,-43,16,11,78,38,-48,-24,-31,16,2,-54,-13,59,-33,-3,81,16,-31,-67,-29,-38,-13,-127,-25,20,-30,54,-14,28,23,-56,10,54,-39,25,-70,11,0,84,23,-26,42,-58,19,34,71,17,17,41,51,-45,36,-27,17,-38,3, 
  /* [152][0][][] */ 18,16,-27,-52,-39,-12,0,-10,0,-28,62,-10,47,30,13,96,-5,34,-51,25,-26,-68,6,39,-17,10,-39,-8,-7,34,44,39,9,59,0,-29,24,11,-11,4,34,4,3,9,-32,-34,18,19,-57,22,89,-10,56,12,3,-19,2,55,-18,-12,23,58,-77,5,-29,-52,26,23,46,5,27,-93,12,-49,-69,-51,-28,-50,71,-32,-9,-43,44,-64,-42,30,23,-55,38,-19,-25,61,-30,-127,26,-16,46,27,-21,-33,26,-28,-50,-38,7,20,31,43,-24,-19,16,-2, 
  /* [153][0][][] */ 7,-8,-98,7,-69,-56,13,-31,-33,-68,35,-30,17,-26,-76,5,13,41,58,15,68,24,68,53,-48,69,40,-36,-31,74,16,3,-98,-4,38,31,-83,41,-90,-24,3,82,57,-50,-16,55,52,74,-51,-92,-55,-68,-61,-19,44,-6,58,-21,-100,24,56,49,-30,-104,-13,-97,37,62,36,-40,43,82,-7,-19,70,26,50,7,-50,-54,34,56,-22,-93,83,25,3,-24,2,38,127,-5,24,-40,49,37,56,70,-86,3,-30,-19,-65,-33,5,-91,-79,-8,61,57,-30,-7, 
  /* [154][0][][] */ 5,-15,-31,-28,6,-35,-78,29,35,95,-26,-11,-30,15,60,14,-41,35,31,52,-104,125,40,7,-56,-127,-53,5,28,101,14,-15,-25,30,126,-36,17,35,-3,-36,1,40,64,22,10,76,-46,8,40,-73,44,66,-43,38,18,117,-28,40,-45,13,-59,56,-13,-102,28,-19,32,41,-100,-106,20,68,-16,-69,-47,30,-27,56,-11,-15,-19,-8,126,39,8,59,17,-25,-15,54,58,125,81,-84,47,-34,-9,38,27,-10,-105,77,49,-43,-15,-48,9,85,-9,-16,-126,1, 
  /* [155][0][][] */ -7,47,-15,30,-11,-33,-25,22,4,18,-66,-17,-20,-67,-35,-34,-34,-15,6,36,68,-9,28,8,-15,-29,49,31,14,-62,9,-80,1,-51,-98,-11,27,-49,-100,-8,20,-2,-17,50,34,32,83,-51,-2,-82,33,-19,127,83,9,18,54,-62,-56,61,-18,-22,-12,10,63,-14,54,-9,7,23,4,-48,-2,11,-76,67,9,29,30,64,2,90,10,-20,-29,-29,-6,-27,-43,-15,86,-35,30,-35,-9,20,22,-78,-10,-39,-68,-35,-16,-15,62,-33,55,-9,10,-64,-29,-43, 
  /* [156][0][][] */ 6,-58,23,1,-50,-32,-28,18,87,-31,22,-33,45,-69,37,-25,-38,94,-13,-7,96,5,26,-38,-102,-11,21,36,-40,56,57,63,-16,85,10,6,-17,-107,4,46,29,13,57,-4,56,43,-39,19,-46,-95,-13,-96,8,77,53,-47,-32,-16,-1,31,84,-24,-50,38,28,39,49,2,-59,-29,-5,5,25,-31,-22,-87,35,67,49,-65,-5,-15,22,17,-11,-44,-3,-18,-127,26,33,89,43,60,-11,-79,-73,-34,-3,-46,3,31,-41,-33,-4,30,-84,-93,-51,27,13,7, 
  /* [157][0][][] */ 41,-74,-6,56,-65,-85,86,9,-49,-7,-39,39,35,75,-84,4,-18,46,2,22,-47,-18,3,41,69,-22,-25,-25,-36,26,42,99,-4,58,-9,-3,11,66,-12,-34,52,107,-14,-15,-5,-19,-27,-10,21,8,56,-15,-62,-70,-33,38,-71,48,28,69,-34,45,31,-76,-126,-11,34,-83,31,-5,-41,43,-20,-28,43,38,80,-17,87,38,-40,55,37,-67,-58,42,9,-22,-127,3,21,35,-49,7,-111,10,-14,41,87,74,-11,-33,-76,28,29,33,61,114,-36,25,-5,-60, 
  /* [158][0][][] */ 12,89,69,29,98,1,-41,-59,-53,-77,-14,-63,62,55,-23,-39,-5,14,-54,1,3,-67,-7,35,25,0,-7,1,-104,-4,40,6,6,-1,57,-3,15,122,-8,37,-14,-19,-3,32,29,-19,7,-54,-38,46,12,66,28,7,-77,-7,27,27,98,15,-52,-7,-52,-26,-34,28,26,-3,-16,28,25,-3,-30,28,-7,-17,-52,5,13,35,13,66,-42,-36,-30,77,16,127,42,-52,49,-6,16,-2,38,0,-12,42,26,67,43,-3,-49,-11,-40,-35,23,71,91,-5,45,-17, 
  /* [159][0][][] */ 75,-33,-28,-69,-31,24,76,16,-27,-97,85,-48,11,-32,19,49,-15,-75,-86,-51,-3,-28,8,44,24,-41,-15,113,74,-25,40,10,-1,-100,10,81,19,-113,0,35,81,-35,-15,88,52,71,-44,23,-15,107,-20,77,-17,32,-5,35,-16,-126,77,-38,60,-52,-98,-9,52,-67,20,-4,11,-26,24,-40,58,127,93,120,62,85,28,-52,-74,-11,-21,29,-4,11,-44,110,-61,55,59,-117,-58,-42,64,-73,94,-22,-38,-26,21,-3,65,-33,-82,-66,-1,21,25,50,-77,-5, 
  /* [160][0][][] */ 94,4,3,23,-52,17,101,28,23,53,-84,103,12,-30,-56,-86,64,12,19,52,45,-39,10,-33,-33,67,49,58,20,-2,-40,-17,-7,32,-32,34,17,30,5,-65,70,-2,38,69,15,-14,-70,64,-51,-9,-30,-7,-2,-38,-35,-14,-117,-58,-67,-23,2,114,10,-127,-76,-12,-45,16,18,49,8,-35,-34,11,-5,14,36,37,-26,-22,-17,17,4,-94,43,-65,12,2,49,85,-3,-52,-9,18,35,37,38,-29,43,11,-45,11,-21,35,12,-18,-62,-2,53,-54,-62,30, 
  /* [161][0][][] */ 12,-5,-28,-32,-2,25,26,-21,-13,35,-3,-54,-22,-7,44,-56,-3,-9,-9,13,-4,84,70,-26,18,22,9,-26,-28,-21,65,7,-19,55,-5,22,-54,-25,90,65,57,8,57,-56,47,-34,-65,-29,53,-55,-8,-48,45,42,55,31,32,22,-6,32,102,37,-4,7,-84,33,31,-3,95,29,-13,33,-26,12,26,-41,-11,26,14,-1,16,79,3,7,39,-41,67,-48,10,78,28,-46,45,6,37,40,-9,-12,41,-8,-16,2,-39,41,10,-38,39,-17,2,-17,-127,-43, 
  /* [162][0][][] */ -77,96,12,-11,6,28,9,-30,17,-62,-35,10,-1,1,34,43,-8,-37,25,24,-19,-9,23,49,8,-44,38,35,28,-1,7,-87,-43,-22,11,-52,-86,8,-11,0,34,22,16,55,10,-21,39,-3,18,-69,-70,-70,18,57,-42,-10,30,-93,86,79,-32,-34,19,-35,-59,-47,-7,-54,55,-15,71,-37,-62,-8,14,-37,-28,43,-18,76,-83,-13,-18,36,37,-37,31,-6,30,-47,44,-19,-5,-16,-15,-12,14,-19,-25,-73,-54,-86,27,37,-33,-42,6,57,127,-42,-46,-8, 
  /* [163][0][][] */ 30,6,-48,57,27,-24,86,-1,-17,11,33,18,-52,-75,-40,1,-13,-25,30,-50,-3,82,-52,32,-62,2,-34,-33,10,-81,-18,-40,-36,1,21,-31,-124,-56,36,-127,3,-40,-98,51,-81,-22,-6,8,-56,58,-1,15,66,-55,-69,13,11,-14,46,32,-8,32,-40,-21,-64,-54,58,50,47,-47,-28,-1,-36,-22,-4,-44,13,-23,-48,-11,39,48,-10,-36,4,41,-32,34,43,-47,-28,-12,47,19,1,1,53,-42,10,21,-2,-54,45,-29,23,-54,36,32,19,8,-25,-14, 
  /* [164][0][][] */ -50,3,25,15,44,27,-13,-7,-17,-32,-1,5,30,-3,-36,40,0,10,13,67,-4,17,18,39,-14,14,-10,-41,-20,-14,47,29,-77,57,38,7,50,20,-17,18,30,11,-61,7,-21,-10,40,-22,35,4,-28,86,-1,40,33,-29,32,127,-18,-6,-45,15,78,-39,13,-32,-47,-47,24,-49,0,54,-32,7,14,-30,-52,-55,-13,-3,8,43,3,7,17,48,19,-54,-84,36,40,-7,44,-22,-4,98,51,24,3,-16,-9,-20,-117,-33,23,-8,48,71,18,31,63,-45, 
  /* [165][0][][] */ -5,-78,32,26,-37,-12,3,21,61,-83,3,3,-95,55,8,-9,49,-34,-2,-71,3,23,71,-2,-41,45,-75,-14,-75,-69,-78,52,-16,-9,20,12,-13,-110,15,75,15,47,3,21,-54,-60,6,85,11,-48,-48,-41,7,18,60,56,-21,63,14,109,26,35,85,-73,79,-49,24,-28,0,51,36,-2,-65,51,29,50,21,81,41,50,122,57,-123,23,-70,126,127,5,-12,45,16,66,21,48,56,34,25,-44,15,-24,-65,-38,63,33,-7,-70,-31,27,59,-78,-17,-6, 
  /* [166][0][][] */ -93,-14,-23,49,22,25,-22,-28,43,106,-20,74,-9,-21,-65,12,107,-104,27,-67,-48,-41,47,59,-49,35,27,20,-12,-45,64,-44,54,-127,-10,3,14,-21,-32,-15,11,-54,-84,26,58,-61,48,46,-56,-14,-19,72,14,5,-57,3,119,3,-33,105,45,32,80,7,17,14,75,-40,-38,42,-42,87,-58,20,-109,44,36,50,-43,-42,101,-97,-12,-91,50,-15,-39,-34,-14,-8,-44,97,58,-64,-19,96,-17,-73,68,121,21,-31,-50,-106,72,-55,-52,2,-77,-71,23,45, 
  /* [167][0][][] */ 14,18,-56,14,-8,27,17,78,-13,72,53,49,23,-69,-12,81,31,-32,23,-115,127,21,-13,-34,103,-8,7,8,69,58,-52,-70,-16,54,17,-5,-39,15,28,-51,10,9,8,-36,95,-2,-21,38,58,-68,49,-49,-11,5,-24,-39,-11,60,-72,-13,16,26,13,14,-77,-8,23,-13,38,10,-5,-2,-24,11,16,-18,-28,-18,20,-10,23,-9,37,6,6,-24,-44,-11,13,-38,-72,94,-9,35,-21,-5,-66,36,10,13,-5,49,-30,8,-1,27,-2,26,2,54,-57,-1, 
  /* [168][0][][] */ -4,-80,-3,35,66,6,-35,-21,20,-47,81,-21,-15,-59,-23,-17,-49,10,-27,-11,-11,-37,-9,35,-47,46,-69,81,-39,53,6,-13,-23,-13,-27,-74,41,15,-26,-51,20,-8,-26,6,59,32,22,54,40,60,-53,-20,17,9,9,25,-49,15,80,-56,89,46,-19,15,-95,-33,-44,64,-67,19,33,-127,17,-46,43,-52,-15,26,37,65,-56,40,111,-25,38,13,-24,11,35,5,17,-14,0,37,7,-45,68,-17,70,64,26,63,-27,-15,-34,-14,26,-34,-58,33,-24,3, 
  /* [169][0][][] */ -23,-76,-32,-26,-27,12,7,-9,-127,-46,18,7,-22,-46,-6,-18,-15,19,27,6,3,11,34,-42,-7,-9,-25,64,7,-36,1,-22,19,73,31,-24,-46,66,4,47,20,88,-38,23,12,-2,9,-84,-69,8,-15,-5,-64,-11,68,73,51,-38,-35,22,-39,17,23,37,-25,-37,47,-4,-81,-25,-25,18,5,70,101,-22,42,39,-84,9,69,-12,-38,-5,62,-15,51,54,30,-90,-23,46,-5,5,-6,23,67,32,1,-34,-51,-11,-75,-63,-94,36,56,-39,-25,-9,11,71, 
  /* [170][0][][] */ -33,-3,18,-8,-31,-38,33,-67,18,66,-54,14,20,-19,-37,-62,41,-21,-57,17,-9,-62,11,-1,21,96,-18,66,-39,-12,-54,-43,-28,-68,-53,15,-11,-26,-22,65,72,14,14,-61,-12,-46,2,33,-38,-22,30,-44,16,-24,-16,30,36,-20,-1,109,-60,6,-53,-8,44,-28,7,33,-21,-24,-6,-28,-51,-7,12,-127,71,-18,20,12,-6,2,24,-58,-9,54,45,-66,-12,-20,-12,43,-27,40,-102,4,-45,-8,-7,25,0,12,5,25,-5,26,72,73,-9,6,12,37, 
  /* [171][0][][] */ 33,8,-37,-21,-35,46,48,-57,30,-7,-26,-18,19,31,-13,12,17,-51,27,-22,2,-36,-105,75,41,-32,-77,-52,-37,-89,-24,-93,-41,-127,-78,-58,58,-31,-15,-67,51,-53,57,-19,-31,2,127,7,53,33,41,25,31,-88,13,-30,-6,-67,-60,56,-67,-11,40,-12,5,-32,16,42,25,61,2,43,-2,-10,-42,25,32,-60,12,11,3,-27,14,36,-13,26,9,-15,44,5,31,-51,48,11,-47,-38,-20,10,78,-30,102,-44,-91,1,74,39,-24,-40,-11,17,-21,-21, 
  /* [172][0][][] */ 60,-19,-44,-1,-27,39,-12,8,16,44,9,8,34,-31,-3,15,-41,78,1,70,6,-27,-20,6,-33,20,-103,-72,-12,-36,12,-16,-42,-26,-49,25,-59,4,-23,-74,-17,0,69,26,18,-4,-38,-30,-21,-20,-1,5,-24,38,-47,27,-87,12,-6,-112,-90,-24,13,-32,6,-29,-32,54,2,38,-16,-127,19,-48,-56,10,9,-40,-31,5,-22,-85,20,11,13,-14,7,-7,-61,49,-6,-9,-38,21,-46,48,110,28,-84,15,-31,82,24,-30,12,-81,28,-72,20,13,15,-22, 
  /* [173][0][][] */ 46,43,-29,-52,-75,-6,40,-57,-102,-12,47,67,13,13,61,43,-57,51,81,-75,-4,5,-44,2,-28,0,1,32,20,26,63,0,26,-13,10,6,46,-76,25,-7,32,-48,-4,-7,44,0,26,25,1,-18,-8,27,9,-1,70,-6,85,26,4,106,-50,78,30,33,-9,13,-60,-37,9,127,73,7,23,28,89,23,89,83,-18,-60,64,-36,-56,-30,-42,-16,-19,26,108,27,-6,85,4,-38,18,6,-34,-32,-18,-41,-61,19,-24,68,-8,2,-3,-23,-29,-40,45,-44, 
  /* [174][0][][] */ 36,26,2,82,-86,-79,25,-48,-25,-72,-127,-14,-45,-53,4,-11,44,65,31,-69,40,14,-4,76,-23,78,-67,-29,-3,-41,52,-98,-20,-109,68,-74,-61,-88,-33,18,10,-22,20,-61,12,-19,38,2,-54,-97,31,-28,12,57,35,116,91,58,-17,-8,-38,-14,28,-35,28,71,-36,3,-23,26,85,-48,-4,38,50,-29,71,-39,-29,37,39,33,-18,-1,2,21,-9,50,-3,-10,-11,-4,51,-33,3,11,42,-49,-53,76,-79,51,-102,-18,-31,1,18,32,-25,38,-22,-43, 
  /* [175][0][][] */ -61,-25,49,-23,-21,-91,124,-17,-76,25,-20,44,0,38,70,22,25,78,-59,53,-30,53,84,-62,-28,14,-83,-7,19,54,-36,-7,0,-69,38,15,-66,-31,-20,42,-74,10,79,-4,-56,72,-82,28,-19,-25,-21,-28,56,-34,-29,61,20,-33,-79,98,-70,-40,-73,11,40,31,56,-75,-12,49,69,20,-51,-66,53,-59,19,61,72,54,108,-33,22,41,127,-10,13,-57,-30,47,78,8,34,25,81,-50,-34,105,-101,59,31,-71,3,-54,-9,17,76,51,105,18,-1,-2, 
  /* [176][0][][] */ 85,-79,26,33,-55,17,58,54,-6,-20,12,7,127,-41,-61,26,58,18,0,-21,-33,-71,-49,-14,12,-103,13,-105,7,-7,25,-25,7,64,-28,78,-26,28,76,-87,0,73,-31,-16,-7,37,36,68,-47,33,-40,16,-23,31,-4,9,22,74,73,5,6,-61,-35,41,69,33,-5,-38,34,14,-72,19,-67,-92,35,-60,-100,41,-23,49,62,-4,-33,-14,-35,42,-95,16,55,29,25,63,-2,18,-5,-7,43,-77,19,-95,69,16,-12,-2,-57,46,77,102,-23,49,-98,-5, 
  /* [177][0][][] */ -18,3,-20,-6,1,6,-7,-49,45,12,27,-50,-3,23,-90,56,49,29,11,-33,-9,63,-13,-3,-21,42,23,-18,-37,-58,-64,-12,22,3,-40,-64,-21,-36,-66,-12,13,-70,57,5,46,24,-12,18,49,-52,-27,-17,-32,23,-32,-24,-65,46,-13,41,18,9,91,9,-20,-40,7,-23,111,16,-44,23,-68,-35,13,-15,-14,7,-16,31,56,-13,-72,21,-21,-23,77,-29,42,-8,-4,-19,-27,-15,-127,4,2,93,40,-16,-28,-29,-7,31,7,-6,-17,15,-28,-37,-21,-2, 
  /* [178][0][][] */ -10,76,-8,68,-23,30,-1,91,5,-15,38,-16,16,-20,-64,-64,-29,28,-43,28,23,-11,-40,27,20,37,63,-47,-99,-16,17,-6,37,-1,22,57,-31,-58,-50,-18,-2,53,-13,-36,19,-21,71,74,70,25,43,66,112,3,36,1,2,-127,-32,6,-33,-10,49,-9,55,-73,37,-34,-62,-29,-51,-24,5,-58,18,43,-3,57,-58,20,-8,-51,8,-2,11,-30,-32,-1,16,5,-98,48,61,66,8,51,20,19,-26,70,23,36,49,-9,-14,-24,-43,-29,-31,46,-27,4, 
  /* [179][0][][] */ 27,46,55,-35,-73,-1,29,-72,-19,-35,-70,14,-9,-3,25,-9,8,25,18,58,52,42,39,-25,44,-40,27,28,-2,-18,-26,-84,-22,-32,-42,40,86,-81,49,-7,33,63,42,36,81,-9,25,33,-18,19,-37,56,-28,-56,-44,85,45,-37,-7,43,-72,63,-8,7,-14,66,23,25,19,40,62,9,-16,57,-25,-52,-34,-6,0,59,-14,-55,21,67,-58,17,-14,-94,-3,-37,18,60,-33,-93,32,37,73,-77,-19,10,-3,61,23,-62,28,59,-35,1,127,64,-47,10, 
  /* [180][0][][] */ -67,73,8,-35,-43,-3,-65,31,-42,-1,2,39,41,-28,-16,7,-33,24,15,-47,86,51,-80,5,-6,11,-19,-16,63,38,-44,29,1,69,-43,55,20,-79,67,54,6,-32,-111,-22,-40,32,-23,30,20,-34,-17,-35,76,-16,-54,-10,-8,40,-16,39,67,80,79,-12,-1,-127,8,-3,-39,39,89,25,-73,31,34,-25,75,-99,-57,-89,35,53,-27,24,-52,21,-61,25,-9,21,-31,48,-22,-85,-48,77,11,-56,-15,14,-19,123,19,125,-11,-85,-42,127,-90,-33,-103,92, 
  /* [181][0][][] */ 7,2,1,3,21,-76,37,16,67,55,27,-40,88,-4,18,42,-3,78,-24,44,14,78,10,51,5,66,-48,-30,102,-94,77,-64,-74,-31,56,-35,19,-20,91,-26,3,-39,39,19,19,87,27,-37,59,60,-43,34,17,-96,-56,70,-19,-76,-28,-26,24,-28,-24,-43,75,47,-29,-36,-33,-46,93,50,60,-46,-29,12,87,-1,-62,-19,23,15,115,-36,16,21,-28,15,73,4,-35,66,18,17,30,68,-27,-24,22,-1,19,57,-5,-72,7,-25,127,-11,-51,-2,97,-74, 
  /* [182][0][][] */ 22,90,-8,34,71,-4,-53,-20,4,-33,-65,-36,21,28,10,-65,12,22,101,17,-82,73,33,-9,13,81,-6,64,45,23,23,-30,15,-18,-18,-10,-9,-15,23,15,35,-32,11,-90,11,26,16,-60,-12,-46,40,-10,-21,20,27,73,23,-73,-89,34,96,37,13,-12,-64,55,-72,23,-9,55,-66,6,-11,-61,-68,1,121,10,-38,19,-1,54,-28,-55,-45,-123,14,-55,20,61,-92,92,73,-127,-41,-26,-101,-51,3,7,-17,-11,10,15,27,113,25,5,25,-54,-30,19, 
  /* [183][0][][] */ -22,-40,-2,41,-64,-57,22,-11,8,-11,8,66,9,-24,16,-1,127,-52,-8,-53,-40,-11,6,-82,11,3,-91,6,51,49,-36,51,-8,-3,31,-62,-28,93,-8,-4,-23,-23,11,43,4,15,-80,-36,76,-5,18,3,-40,-65,45,-17,-24,-25,-40,-77,-27,29,38,36,-42,7,-27,-37,-34,-33,-8,-17,-2,20,27,-23,76,-6,0,27,36,3,5,-37,64,-59,42,49,-4,-24,40,21,-14,-6,-60,-30,-9,56,-27,26,18,-90,4,-59,-14,21,-77,2,92,-16,-8,36, 
  /* [184][0][][] */ 16,3,-21,4,19,-35,-76,20,74,4,85,82,16,-10,-92,30,34,-13,54,48,64,-18,-35,25,94,21,-44,16,1,38,2,31,84,-64,-10,2,-34,-86,-3,30,6,-31,-19,18,22,-99,68,18,60,-127,60,13,-58,10,-37,14,-10,-73,1,5,-43,-7,-28,-24,9,-43,-56,-72,-50,2,54,61,3,29,40,29,-77,76,-22,17,-23,37,50,-28,19,-95,6,40,-4,47,27,17,-58,39,47,93,64,-6,14,-74,-54,-6,0,-64,-67,71,21,39,12,-44,-73,-24, 
  /* [185][0][][] */ -7,77,-23,-24,-24,-2,19,31,-28,44,29,25,14,-53,50,2,27,18,48,1,67,58,34,-77,-67,80,24,66,8,2,-95,-18,-53,47,10,-28,27,33,-51,45,13,-28,-67,3,14,-127,-14,-35,-41,12,29,-13,22,1,30,25,23,-67,-4,-3,31,63,54,-11,72,18,60,17,-55,-73,-48,19,-34,-28,1,12,38,88,4,-41,53,14,44,-26,5,78,20,-22,27,33,27,-8,-13,79,-47,29,56,-52,-40,-74,15,-5,-26,50,11,3,26,53,-76,5,-18,-4, 
  /* [186][0][][] */ -8,-67,-83,-49,18,26,12,-20,-39,56,10,8,46,-16,56,-21,55,-48,55,1,8,-32,56,35,-81,3,-63,47,88,-22,8,-94,-6,-18,114,-45,26,57,59,-49,15,33,-33,-11,62,-10,-40,62,-36,83,-2,9,67,38,-6,-17,-75,-22,-8,-15,-16,-31,27,-105,101,-58,76,-21,-88,28,-12,-16,71,-35,-1,52,28,15,-36,80,-6,57,60,35,-40,37,-38,-32,100,-1,-11,-17,31,-60,-94,-1,28,127,18,70,-66,32,-98,57,15,-43,-29,83,74,40,21,-21, 
  /* [187][0][][] */ -24,21,-17,-14,-22,54,-51,-45,23,49,14,-38,-53,-69,78,-41,47,36,37,26,-10,-42,71,52,30,-10,-42,37,25,-64,-3,7,-20,49,24,-18,-65,-17,92,42,-46,43,28,-32,14,-64,24,32,58,-48,18,-53,-22,51,7,21,6,-42,4,-67,2,-19,49,-47,61,7,25,-9,-30,-45,-18,-31,93,-17,36,-51,20,-59,76,-18,-18,28,52,-37,-52,-59,-59,-67,55,11,-4,125,-9,-77,-127,-2,-11,17,102,5,14,38,-16,-27,-57,31,2,-29,-22,28,14,12, 
  /* [188][0][][] */ -33,15,10,47,-35,81,44,21,-8,54,-6,-13,-29,46,-72,32,23,-83,-20,-45,-62,-54,-31,0,-31,44,66,44,17,9,29,34,73,2,-43,39,89,-21,-38,37,-42,-18,-85,18,17,5,112,28,33,13,25,-15,-36,-2,-56,-3,-33,65,38,8,37,-48,48,-93,-56,4,-31,-46,8,-22,-11,25,-5,21,-89,-9,-33,12,17,-16,-71,25,-79,41,-46,-31,-24,-73,25,-21,43,-45,18,99,37,127,42,-29,3,-42,-57,-10,1,73,-18,-31,5,33,-9,19,0,-67, 
  /* [189][0][][] */ -51,83,-23,17,48,-5,-6,-11,-50,24,15,-47,-19,16,-48,33,-12,30,-5,66,-42,5,-49,45,31,-19,-40,2,76,8,-52,9,30,54,54,7,36,-48,13,-21,-11,-45,30,-18,45,-9,-39,1,-50,-60,81,48,-50,93,-57,-2,8,-20,-16,-19,-23,79,-53,-34,-20,-127,-18,-77,3,-39,95,18,-25,-9,-61,44,-52,-61,-63,-8,68,59,-31,-95,-51,-120,78,12,69,38,6,60,21,-13,-9,0,39,26,0,32,38,85,10,14,-6,53,-90,49,-29,-63,-34,62, 
  /* [190][0][][] */ -10,6,-49,32,-14,6,-80,15,-10,6,44,26,-91,-41,127,68,-16,29,73,-37,32,14,75,23,16,-13,-41,11,23,24,33,-44,-30,-25,-49,10,28,26,56,-9,-59,6,31,-15,-50,29,31,-12,-43,-17,33,21,82,-19,-6,10,0,41,-9,-41,-41,-40,-1,-23,22,-17,-19,15,-50,22,118,9,8,79,50,10,20,34,5,43,-48,37,-46,53,6,28,17,-24,5,2,44,42,21,18,-30,12,35,-30,-53,-46,-14,18,20,-20,-20,14,-49,-17,17,-10,51,-22, 
  /* [191][0][][] */ 9,2,62,6,44,-40,-107,37,-37,-11,-20,15,56,4,-5,-4,-4,-40,1,-53,-109,58,23,-1,6,27,-65,-38,-21,-54,-34,-89,3,59,27,18,-20,18,-30,4,-1,-7,54,50,57,-74,21,32,-10,5,47,-102,1,-6,-18,20,-60,5,-10,-2,3,0,43,-93,-99,-56,-7,-1,34,27,25,-36,-24,-25,-69,41,41,-20,-127,46,110,-59,-34,-42,37,-17,-24,11,48,98,-47,-45,14,39,30,18,-9,-7,39,66,11,-3,51,74,-44,57,-102,104,-6,6,42,43, 
  /* [192][0][][] */ 24,-90,-60,-35,35,-6,-20,-61,30,102,-2,11,-20,-29,-18,-43,44,-47,16,-18,-11,-15,1,97,98,106,20,51,108,-33,34,-26,-107,22,-37,36,51,23,-68,1,117,-126,-52,4,34,-37,-18,4,12,7,23,95,47,15,-34,-45,97,27,-39,-51,7,-26,-32,-38,-60,17,-28,-26,-50,-82,3,-30,14,5,-52,-127,-39,10,94,-5,3,95,5,5,-3,-66,-49,79,113,-114,-18,-18,-43,-17,36,119,19,-88,-64,55,-78,77,-39,-61,-6,-5,19,95,-83,-1,-2,-41, 
  /* [193][0][][] */ 43,94,-50,-27,-76,11,62,74,-17,8,-45,-3,4,61,-16,-45,-82,-80,-15,-8,-21,-37,25,-15,27,114,85,-28,28,13,52,33,10,-125,36,-124,17,-32,-58,68,-54,40,-25,-8,64,-38,30,5,-50,13,1,-74,-26,-12,71,-56,-61,13,0,-62,-27,44,-35,-85,-88,-66,8,-34,114,12,-65,-8,-35,59,-42,18,51,12,-109,-8,-21,-10,-109,-23,63,-77,4,40,5,-61,-65,-101,52,4,19,80,32,95,-54,9,2,-38,-17,88,85,-30,23,66,47,-5,-51,127, 
  /* [194][0][][] */ 18,6,-40,-33,-1,-34,14,-57,24,14,57,13,-23,35,81,46,-38,-17,-39,-67,-22,-52,19,-59,-15,58,-21,45,-31,-78,95,-12,23,-18,111,5,37,-109,-59,-64,112,23,14,-20,59,24,-3,60,-4,3,-19,83,69,21,31,-38,-25,20,-1,-88,25,-1,-72,-27,32,38,48,6,-42,-28,74,42,32,97,45,48,121,-49,75,-50,7,-33,-57,44,62,-93,-7,-4,49,-53,-59,89,94,44,-127,-38,62,-29,55,22,1,-2,24,-54,9,-60,-59,28,-26,43,-19,-1, 
  /* [195][0][][] */ 28,127,9,-53,-37,-72,-6,-23,47,-68,-73,90,-43,-33,-71,-29,-85,-57,35,29,-96,-20,-53,-19,28,73,12,-18,43,46,14,-68,-18,18,-2,-23,-1,-31,13,62,61,34,-25,-30,58,34,-15,46,-24,41,-2,25,-43,-59,41,-104,16,25,44,49,-75,44,-10,-2,16,41,72,-94,30,-21,102,27,-35,-81,-1,70,43,62,33,-22,35,23,10,-41,55,6,35,-53,-31,19,-46,-33,39,7,-22,-89,-1,23,32,14,-8,-31,4,82,-22,-32,43,51,-27,26,-1,29, 
  /* [196][0][][] */ -2,37,-16,82,-53,5,26,-60,-41,-4,-13,29,-21,-27,-41,-46,23,-89,53,6,1,77,76,-17,34,-22,-58,-43,64,14,92,-91,-76,14,-3,-16,1,0,-49,-49,13,-16,26,-2,15,59,17,52,21,-93,4,-6,57,39,-15,-52,-53,33,-127,-89,21,26,15,-41,43,33,55,-18,50,4,-29,27,-43,18,-95,11,-68,9,-68,-24,36,-13,-52,26,-20,-32,22,41,27,41,33,-31,21,9,34,52,36,-40,27,-16,3,31,33,60,51,-32,-8,49,34,14,-39,23, 
  /* [197][0][][] */ 50,0,17,-4,32,-3,44,3,7,-2,19,23,-31,2,-8,-29,-22,42,24,63,-35,26,-27,-11,-48,48,-7,0,4,27,29,-14,21,24,13,23,59,-13,59,49,17,26,-81,51,3,8,27,21,-10,-11,-9,-127,15,1,18,9,20,-1,-30,-12,32,5,-39,-18,18,56,30,-4,12,28,-37,-14,-16,-45,-4,-11,4,18,16,-4,4,8,81,18,52,8,15,-22,18,5,-23,-27,7,-26,-9,-20,-38,-25,13,-67,15,0,-46,-38,8,21,-12,22,-9,62,-34,54, 
  /* [198][0][][] */ 108,52,34,62,-51,-45,-15,20,-59,-6,-56,8,4,-53,-85,-13,-14,127,2,69,72,-7,-30,-31,-17,-4,49,-56,-2,110,16,26,-49,-41,-9,-83,-51,-18,14,29,-48,43,0,2,-42,50,-8,-42,-46,-23,-108,-36,27,9,36,65,-102,49,1,-115,-51,55,34,96,12,-93,-53,37,-75,82,10,93,-8,-9,20,-15,5,44,-48,19,-91,8,-12,-4,23,-19,-48,14,101,-10,-8,-39,-13,43,24,85,-4,-14,17,-23,-77,56,-11,-8,-65,5,60,-90,-47,60,-83,-63, 
  /* [199][0][][] */ 28,58,127,-11,-46,-21,24,-57,33,-25,-2,8,5,-29,-38,-72,-57,33,28,60,-3,-18,7,-68,-5,-34,-44,17,-11,28,-31,-5,-1,-22,18,51,30,-10,-19,65,27,-26,-21,43,-34,-13,-39,0,-64,-42,-7,-5,-7,-10,-57,-8,-24,73,33,-3,5,23,-31,-42,65,-73,-2,68,34,11,41,47,13,13,12,75,-29,43,31,92,81,8,36,-51,-67,-8,43,-10,-19,32,-4,23,17,27,57,-11,-35,-22,28,-26,61,5,-10,9,-62,39,-9,-26,-8,10,48,-27, 
  /* [200][0][][] */ -21,48,-68,-42,-43,-54,-5,66,-71,2,-73,-35,42,-50,10,-6,-30,-51,-33,-46,0,-2,87,-42,21,-61,-11,42,12,6,-22,26,19,-9,24,-46,-29,-44,59,-6,-66,61,62,-16,-13,-9,-18,54,-113,-15,-97,91,-59,46,127,-22,43,23,-7,17,-27,-73,-24,119,37,22,19,0,39,13,1,-4,14,60,49,-19,-1,-35,53,4,-53,22,16,-57,26,-1,-45,40,-55,-10,72,-57,93,55,47,27,-65,52,-25,-74,-15,92,16,62,-44,-46,-33,-87,-68,-59,10,-17, 
  /* [201][0][][] */ -52,61,-30,62,-17,7,16,41,-16,-8,-17,-80,-61,3,35,-78,-10,-42,-17,6,28,-46,-13,50,-69,54,36,34,-73,29,77,-18,-30,-34,51,27,39,21,6,62,34,3,42,11,69,23,-68,-10,-96,-17,1,1,-127,-1,-29,-7,29,54,52,-34,37,19,-18,-82,-27,22,60,64,-72,43,57,76,-43,-89,-18,101,-1,42,-19,-54,55,9,58,-61,-18,-16,43,-36,-76,7,-18,-50,107,-89,85,75,-37,-3,-39,-55,-66,9,72,-9,-40,9,42,-64,18,-46,31,42, 
  /* [202][0][][] */ 77,20,35,0,-11,75,8,2,15,-71,17,-55,-56,-39,46,46,-4,-42,75,-72,95,-28,28,57,-1,8,33,-68,10,47,42,-83,-43,107,53,-20,33,30,43,56,-79,16,57,30,6,58,-23,-28,40,-32,-42,24,61,24,84,16,-38,-46,74,66,9,70,25,-21,45,-6,46,-63,54,23,-22,-29,-53,1,-22,58,0,68,-79,42,-40,-26,30,-54,-6,18,127,-68,-22,17,-5,31,46,-23,-57,-9,-86,-21,-52,77,-4,-4,-65,-1,1,-22,-24,62,25,-44,11,-95, 
  /* [203][0][][] */ 70,-27,-43,9,4,46,10,30,-20,-45,-3,-6,83,-66,-27,21,-25,-59,-42,-60,109,-22,55,14,-17,41,62,2,41,20,-28,-48,46,10,67,79,-77,17,-22,-16,54,-30,66,9,-64,-73,23,39,56,67,67,33,30,-29,5,-52,18,22,-21,89,-14,20,14,-28,17,26,127,39,-27,-59,-26,-35,28,-34,-33,-24,28,-10,-27,54,-29,-87,-7,62,33,-29,17,-91,-82,50,-52,39,11,39,-57,-40,-58,71,-4,-24,17,-37,-51,59,48,16,-11,-43,23,-58,-58,-88, 
  /* [204][0][][] */ 18,24,-68,-27,18,2,-40,52,-12,11,42,-30,-5,59,-84,48,8,9,-4,-48,-18,82,14,88,0,-117,-60,-57,66,-28,1,-51,-73,-88,67,72,-32,-69,16,87,28,25,-7,-4,-37,107,-48,-35,-55,-52,53,-61,4,68,66,58,53,0,28,87,-7,51,-80,-91,4,-27,100,-1,-23,33,-43,6,-18,22,1,9,-64,45,-70,44,10,-29,26,-46,20,-113,-32,58,54,-4,-33,3,-12,26,0,-41,-23,4,-127,89,-49,66,-63,-113,18,-92,110,-44,121,-12,-52,-68, 
  /* [205][0][][] */ -41,-49,-78,-9,-34,-38,54,61,-55,-53,7,5,-39,31,53,-30,11,16,24,11,45,-32,-22,-106,7,-1,-60,26,29,63,-127,-16,-49,28,-8,5,-29,-12,35,-38,-37,-30,60,-37,-38,41,-112,-33,-106,34,51,-66,15,17,97,15,25,-122,7,20,-42,2,-9,-33,83,-13,-21,-51,62,11,19,-49,36,90,89,-39,61,77,-3,-23,16,-20,-10,-29,-82,47,4,-5,-28,-19,18,-17,-91,68,-96,10,-23,50,86,77,-13,55,96,23,-7,-1,-23,-12,88,21,-65,23, 
  /* [206][0][][] */ 31,-3,61,-63,-10,31,-31,3,26,26,-2,-10,23,3,-7,79,32,-15,19,70,-6,-11,38,45,-7,25,-28,-52,-39,-32,17,94,-47,63,-47,0,6,-52,-39,29,47,0,-40,-34,7,-32,104,65,78,-40,-42,12,-32,21,78,-34,-101,77,-72,-20,35,-32,-21,-15,15,-30,-16,-7,10,-6,-33,17,8,49,-1,-21,-2,-10,-12,26,-54,-2,-65,-6,38,-25,17,4,56,81,50,33,127,-23,-17,-6,36,-33,-12,-37,-4,-44,-58,21,29,-32,-56,-11,10,31,-26,47, 
  /* [207][0][][] */ -59,14,49,56,-8,-43,46,-56,-33,-5,-27,-25,-100,-33,-38,-35,-8,-98,-19,8,82,-9,-8,32,40,34,-21,-33,-73,30,-13,-109,-127,-51,-43,-26,60,4,-62,57,20,-83,36,37,31,-55,-4,-23,-22,-14,27,-1,31,53,-41,48,90,-53,22,7,20,29,79,22,34,115,-10,14,-17,10,31,-26,-55,17,-57,-74,57,-16,-8,-23,17,-25,-4,50,15,-32,-33,-38,52,-18,3,-12,99,-8,9,-2,22,35,-118,-54,48,-60,-30,6,31,-47,-8,63,80,-72,22,3, 
  /* [208][0][][] */ -26,-74,-99,89,-72,91,12,33,8,65,-48,-17,75,13,42,79,-49,44,15,-55,-39,-98,50,-50,29,-10,16,-15,-28,60,-86,-66,-33,40,44,-16,-43,38,86,-22,-19,-4,-48,38,-5,-54,-54,-6,8,-59,-45,32,56,35,83,32,-4,66,2,56,33,44,34,-35,6,16,-41,-111,21,-127,48,-90,28,-15,-25,-13,2,-64,-20,-56,4,-1,-12,-111,-45,-18,20,-30,76,-59,6,-87,-31,15,-56,14,-51,2,-23,112,39,74,-71,56,-64,-112,-8,-46,2,-4,-14,-21, 
  /* [209][0][][] */ -25,23,-40,37,0,-53,-3,-15,35,-4,-20,-73,8,9,-29,41,-51,-44,-3,-19,-29,96,24,21,-11,31,41,127,-1,-38,-85,-75,-67,-7,36,34,34,-41,70,-4,1,37,-25,26,-10,52,23,-50,-19,13,-32,-22,-72,19,10,6,28,40,-62,-12,72,-52,55,-17,-63,-69,37,-63,40,2,-18,3,25,41,73,79,-80,79,42,-52,-15,-17,-2,-7,-28,10,-41,-7,1,-33,33,-2,82,-14,-59,-3,-32,42,-41,30,15,54,-26,10,-24,20,-18,13,-53,5,14,9, 
  /* [210][0][][] */ -23,35,-37,41,55,50,117,5,-32,65,-48,-12,-34,26,-82,-83,-116,-55,0,-41,-28,46,-28,-43,64,89,-38,-41,-11,-40,14,-20,-15,-127,29,31,70,24,27,-19,21,-2,-34,-39,11,-2,54,25,-72,-50,16,52,54,39,33,-60,-38,31,17,-45,17,7,43,-10,31,-8,-27,-40,-60,7,0,109,-9,-24,60,-12,-43,12,27,4,-9,24,43,-36,-13,0,45,-28,21,-29,-26,-42,-1,-10,-33,-26,33,3,55,-2,-103,89,-26,29,-57,-119,70,36,29,-1,15,99, 
  /* [211][0][][] */ -28,-18,4,30,-33,-43,-32,13,-37,-59,11,63,-7,-15,34,43,-4,53,68,20,16,59,-30,-34,-44,-104,-2,25,56,8,-29,33,-26,69,1,-15,-51,23,-82,-24,-33,11,6,27,36,-6,-38,55,92,-7,-9,54,-40,-113,-64,3,38,43,-3,15,-53,-51,27,-78,-4,-17,-9,-74,-14,-56,16,-30,-34,21,-11,7,-82,-94,90,47,-82,-31,-55,1,-26,18,-2,32,78,-6,24,22,5,-4,-25,12,0,48,66,-127,-35,19,-53,-38,64,86,-80,28,29,25,-29,18, 
  /* [212][0][][] */ -2,-45,4,3,-44,32,64,-27,-34,25,61,-75,46,-39,-21,-23,104,36,-46,-127,-72,12,0,57,-71,55,33,38,-37,91,10,-73,40,-77,102,-10,3,-53,26,-27,67,-40,82,27,36,15,-28,17,-54,-19,43,7,-50,0,37,-54,53,54,-33,-53,37,47,-37,-26,6,5,36,-6,-52,1,-44,-5,10,-4,6,63,35,-27,-48,-26,-24,-7,-89,-13,-1,18,58,56,81,34,-31,-109,-42,33,-24,-29,-36,2,9,48,48,7,35,48,-3,-18,35,-17,-15,48,18,1, 
  /* [213][0][][] */ 1,-56,-30,29,37,-34,8,35,-53,34,27,-48,40,-42,36,37,18,-74,-18,61,23,38,67,18,-33,-31,-21,-41,49,-49,-7,24,42,127,-117,-12,-65,-12,116,-69,-22,30,33,-18,-13,-3,58,24,26,62,8,-2,89,-5,39,18,70,-9,86,4,74,24,79,-20,-23,50,9,12,114,-36,26,-28,-59,66,-13,-11,-15,46,75,28,59,26,-59,89,-1,-7,9,-43,120,11,-41,-41,82,-1,4,0,69,-22,-5,-14,32,-12,-60,-84,1,24,30,80,61,-66,-7,26, 
  /* [214][0][][] */ 1,-8,-42,-29,-40,-24,43,-2,-12,-17,-1,14,22,51,76,-63,30,3,21,37,-8,57,52,-32,-36,35,-33,-16,-35,-20,3,-9,-81,-20,0,7,39,-14,1,29,-39,37,21,-24,78,4,46,9,-41,26,67,-64,44,-5,28,58,-35,50,-6,-8,16,37,-22,53,21,46,-17,51,40,42,-7,-39,11,-55,16,4,33,46,-20,-27,-1,5,-15,-127,-13,-24,-19,12,92,-9,84,30,42,-14,-15,18,-18,8,-14,-116,10,-42,33,17,35,-102,-11,-53,8,-28,-44,-58, 
  /* [215][0][][] */ 28,46,56,21,-5,-64,-6,-29,-35,19,110,-18,61,35,-37,-49,21,-2,-7,-11,9,14,-89,58,-14,-71,13,-79,-16,9,23,-41,13,-87,5,-84,63,-6,83,78,-50,39,-7,-41,-6,77,-37,9,98,42,-2,-72,-10,-76,-36,11,-52,-42,39,-85,-24,-49,-24,-40,57,91,34,33,20,15,1,-35,-9,32,15,127,56,-47,-34,-49,-56,106,-28,1,-83,89,-62,-30,-97,77,37,-68,8,-26,-3,21,-33,5,10,-28,-97,2,-45,39,23,-41,56,-66,-35,15,39,6, 
  /* [216][0][][] */ 37,-25,-8,25,79,4,11,-64,-7,1,-20,-34,-1,-28,76,-3,-22,19,-77,-12,26,19,-101,-33,-11,78,-18,4,67,-6,-66,-127,-58,-37,93,27,3,-33,23,61,32,69,33,54,62,-11,-81,42,22,75,38,-35,101,52,-12,34,-64,-22,-23,-41,61,59,37,-24,19,-22,-64,-22,43,50,-36,7,-70,81,25,31,-24,1,3,-25,32,-1,65,38,-12,-53,31,-40,17,-38,30,-5,-29,60,-22,8,75,-7,18,-100,-2,36,-11,35,-35,-36,32,88,-100,26,-22,-59, 
  /* [217][0][][] */ -25,-16,32,91,-81,-59,62,-19,-56,-22,-5,-71,15,-30,32,59,2,-36,33,-36,25,35,-61,-6,-37,-56,-127,97,-78,-38,53,-47,-30,46,-39,29,-37,57,-80,49,30,61,33,27,-47,57,24,-92,67,41,-42,11,52,-61,-9,-29,86,-7,-48,34,34,-63,59,75,-21,-4,43,-6,53,-25,-2,2,25,29,44,16,-5,-56,33,-59,-109,-72,45,-22,-18,2,-101,-124,-77,73,-22,-56,-12,18,66,-51,-52,-30,-5,44,12,-71,22,-31,14,-59,-96,-48,28,44,36,22, 
  /* [218][0][][] */ -27,101,-77,-85,-59,52,86,-30,17,-45,48,-65,-14,-74,108,-1,-2,12,20,0,-55,-3,-7,4,-53,-25,-30,-37,9,2,-44,-19,-73,-69,12,-44,-11,36,20,-111,6,7,48,65,5,-23,16,-1,-24,-24,-35,5,-13,17,22,-105,18,90,-13,47,-33,26,31,96,-56,-8,-1,1,-14,50,98,10,-92,9,18,2,-45,38,-6,-13,-97,-22,68,-82,-53,64,80,32,1,45,127,-8,37,-9,18,48,-24,-62,45,23,12,-40,-49,-50,69,11,-42,11,57,-37,46,-46, 
  /* [219][0][][] */ 45,75,-4,53,-16,7,29,-11,1,-41,-37,24,-45,-42,55,-42,-52,63,42,-60,-72,9,-5,26,60,89,18,-91,-38,62,-44,42,11,-14,-25,-9,-88,-10,85,-11,36,-47,37,-31,41,-45,-11,-27,-36,-8,46,43,75,-37,-58,1,15,-127,36,-9,46,-42,71,-55,43,-119,-59,33,23,-54,41,-21,10,-34,-96,57,3,-61,-4,4,98,-21,-23,14,-20,-31,78,-12,117,10,-25,77,-38,34,15,124,92,-3,-60,-7,-24,28,-3,-6,45,-58,46,-3,73,-14,38,-14, 
  /* [220][0][][] */ -74,-15,-74,-46,-3,-59,36,55,-9,44,39,-63,34,9,-10,-38,32,-53,-19,2,16,36,68,-46,-28,-33,-38,33,-26,13,81,-97,-34,58,-44,-3,8,-40,-61,-48,-70,73,70,127,50,0,30,6,-11,56,9,-49,71,-42,-8,-17,48,-60,1,23,46,81,-7,-18,38,74,27,0,-7,10,18,-36,58,9,23,25,29,12,-18,-37,-43,17,-23,-15,3,83,-39,26,16,58,22,-39,-6,-8,-40,41,12,14,62,45,32,-55,60,-64,46,-13,12,-39,-4,6,24,35, 
  /* [221][0][][] */ -123,-2,34,33,2,9,55,27,-2,13,2,-69,-55,-27,14,-97,4,29,46,34,50,-13,-36,33,-42,33,-95,41,-127,24,-44,68,24,9,-45,-2,77,27,-17,-1,13,-4,31,102,-35,64,-125,-47,-56,75,-6,-32,5,26,30,9,-22,-38,17,-10,-60,9,-10,-60,3,-46,114,-7,-86,81,-55,28,-27,-52,86,-78,80,52,-37,7,61,-75,-69,-51,-24,-100,-40,-16,-59,5,1,-71,7,-81,-27,-2,-55,63,23,-32,-51,-83,28,29,8,-91,-10,10,-4,-23,52,32, 
  /* [222][0][][] */ 28,-40,60,19,-69,57,50,11,83,-32,-35,3,-19,13,-77,84,36,-25,0,26,12,33,8,23,2,-9,108,-85,-48,-80,-17,13,-45,9,-52,29,40,-28,-37,84,-43,-41,64,-68,38,53,52,-4,33,53,-8,-79,49,30,108,-14,-71,2,57,22,22,5,-23,-107,9,-93,-10,38,-39,36,-10,-56,-15,-34,-67,8,-31,13,-2,32,85,107,56,24,-34,79,-68,-12,-58,13,-91,24,53,30,32,-74,12,23,39,2,26,36,127,48,24,-48,49,60,-69,73,36,-23, 
  /* [223][0][][] */ 61,31,-12,-16,-24,-2,-23,-13,-25,-33,0,31,22,-87,-10,-3,-13,24,100,33,-44,-60,45,108,-19,7,-45,22,-58,-7,-37,-23,45,6,-23,96,58,8,24,-6,-75,67,-22,41,-32,-34,-16,3,127,-58,39,-19,-5,96,-71,-8,32,-6,-34,-13,99,-55,-36,-32,-9,45,-56,28,2,49,40,11,-30,65,-71,44,-2,-69,20,-41,5,35,-40,-35,-21,71,-40,61,-17,104,20,71,81,-64,-16,-65,-54,-35,-32,-114,-111,58,27,14,-5,-7,19,-95,-47,17,48,-4, 
  /* [224][0][][] */ 49,-17,27,2,-25,-23,22,39,-4,-13,6,-4,5,9,11,14,67,45,-3,6,-49,-88,27,-4,-8,16,-46,-1,77,0,42,-62,28,22,50,-60,-72,-38,22,-34,5,-1,31,-26,3,-17,51,-44,19,32,30,-1,97,-18,-7,-4,22,-31,-11,73,22,-69,-30,-2,-26,16,1,-59,42,46,32,-11,-41,0,10,58,-19,29,-22,48,-46,-16,51,-9,69,-60,28,0,-19,-30,97,60,-85,-52,-23,-1,18,25,-3,44,-9,-14,-25,-22,73,19,-10,-1,43,-9,-127,30, 
  /* [225][0][][] */ 6,12,-90,-8,22,123,-79,-14,1,15,-9,-52,-4,44,24,-12,-46,23,-11,0,4,-38,-56,-106,-2,2,-21,77,-5,5,-93,-6,-91,-46,63,-69,-6,28,-5,47,70,-40,58,28,101,-59,-5,31,-51,-27,31,-20,13,107,1,-31,57,-27,28,-3,-45,20,57,-13,-87,45,-35,21,37,-91,-34,-33,63,1,-77,-39,-37,-29,19,-57,-98,-9,61,-7,-42,14,64,65,-5,-9,1,-60,44,-85,-44,59,-33,-1,-42,-63,92,-6,-20,-22,-88,88,27,114,-35,-58,-15,-127, 
  /* [226][0][][] */ 4,-64,-83,-39,-49,32,30,-54,-5,-120,-13,-30,-127,53,-28,6,-1,-94,6,17,-45,19,-49,-72,-119,-3,-5,-79,-4,117,109,-85,-25,-40,21,15,13,47,46,30,23,64,123,-21,-34,32,33,-32,-58,-56,-9,31,21,2,39,20,-15,-8,-11,40,-21,2,-12,7,111,92,36,-3,81,22,10,52,14,57,-78,30,31,79,-71,-53,18,-5,-20,14,55,68,-58,-65,-110,-30,-57,56,-78,8,-99,112,88,-58,-10,21,1,-2,-34,-72,100,-120,-62,36,-13,33,104,-27, 
  /* [227][0][][] */ 14,-35,33,-34,27,-52,-28,-30,-55,61,-8,-53,26,14,6,23,-5,41,36,32,-7,25,4,-6,15,-62,8,-17,31,-31,-66,10,-121,102,-25,20,64,6,1,22,39,-69,51,19,34,23,-31,35,113,30,-61,-6,-42,-6,23,-31,49,-45,77,-76,-45,39,-98,36,-10,-72,-21,3,24,-5,79,83,-4,-24,-11,9,-55,-63,-17,-122,37,-8,-91,16,20,127,-16,53,105,33,-29,-3,1,-13,100,-69,-7,-19,64,-26,45,-16,-16,-25,60,-4,-24,72,58,-45,-25,24, 
  /* [228][0][][] */ -18,-72,31,34,126,45,-12,-94,-26,43,-95,68,46,-47,58,-57,-6,0,-71,-8,-7,87,-10,-57,63,3,72,-7,82,8,26,54,-88,-18,43,61,24,23,33,-36,21,-30,4,-38,-35,-86,122,37,41,14,127,-55,56,18,-50,51,39,64,-82,60,-93,-38,17,-17,-4,-41,39,8,101,-78,32,-50,-3,-83,-97,64,-87,-38,69,91,71,71,-73,101,-82,24,-22,13,-31,65,-96,-19,-3,-51,-11,-118,-12,-97,7,-28,74,-8,7,-51,43,40,-36,29,4,-9,-26,13, 
  /* [229][0][][] */ 0,1,15,15,-18,-2,50,-9,-43,7,41,-5,12,13,37,-33,8,14,-65,16,19,127,61,-8,11,110,-43,3,47,9,16,18,-16,-91,-2,-32,75,32,89,-81,-55,82,-30,-44,-47,-40,3,-53,7,21,-91,-27,-45,-61,-86,26,62,-37,-8,5,-54,-46,23,28,-59,72,54,32,-60,26,-12,-71,60,-11,-25,6,3,43,14,-10,-12,35,51,-79,-6,16,-5,-27,44,43,-77,40,15,4,46,7,-14,28,16,-56,-23,-48,-48,-69,-18,28,-64,3,1,30,18,48, 
  /* [230][0][][] */ 6,-32,-23,56,-101,-2,-34,-36,-32,70,-50,17,-17,-81,24,-46,-1,5,65,21,-17,-25,1,50,22,-37,32,13,18,25,34,-44,-6,1,2,35,69,-28,41,42,27,3,35,34,70,20,60,23,28,-27,13,59,-30,-77,29,-71,-38,-46,24,13,1,-7,78,-68,127,21,40,-86,-86,59,-42,26,-1,78,25,59,13,15,-75,-58,84,-25,7,47,-5,-74,-20,61,66,2,82,-12,33,42,11,6,3,-59,-19,-53,-49,38,-25,-24,-7,17,30,-29,-73,-27,-21,-42, 
  /* [231][0][][] */ 5,55,-26,-1,47,26,53,16,-38,-41,67,-25,41,-19,30,32,15,3,-52,-46,-79,28,85,-10,-63,-44,-59,-20,-69,-72,31,-86,51,18,-76,10,-47,-57,42,16,52,30,-17,56,10,35,-42,80,65,-66,13,-29,12,41,-8,10,-2,-7,-48,-17,-80,25,26,-2,17,-18,35,-27,1,16,25,-11,48,-34,-5,20,-36,-42,25,6,-95,69,53,0,-13,-44,22,-8,-86,-4,-8,-16,26,-62,-18,-70,-61,-32,-25,-32,-9,-14,-24,-127,50,3,2,16,6,39,21,-27, 
  /* [232][0][][] */ 41,38,37,88,-21,-50,-41,-1,-9,-40,41,25,4,-30,-10,34,-22,34,-81,-78,19,-13,21,-15,-16,-23,-90,-71,-31,75,-23,22,99,26,127,19,50,-62,-7,-15,-23,33,17,-1,26,35,-10,-18,41,32,28,8,-20,-44,34,-34,-61,58,48,-28,13,-38,-47,-17,16,-19,41,40,-73,34,27,27,12,9,53,-36,5,-5,-66,13,-1,-29,-6,-99,-50,57,-33,3,-23,62,59,74,-55,-39,-18,-7,-41,14,-25,-33,-2,-16,42,6,-28,-94,7,17,-19,60,94,8, 
  /* [233][0][][] */ 48,-35,14,-5,29,26,55,-41,12,-25,-3,-17,8,-24,-83,6,53,4,11,55,12,61,-16,-9,-14,35,23,25,-23,16,24,-18,-41,-21,-73,29,8,-20,-39,61,-18,4,-24,20,124,52,-53,-17,21,-29,-8,30,25,14,29,-28,53,6,-3,-11,51,-3,8,2,-52,88,3,-44,30,67,-8,-59,65,104,72,-16,-70,31,23,-43,-7,7,44,-12,-24,-86,39,40,-13,127,-19,-36,-71,31,-19,-6,21,-88,-29,-37,-68,-2,20,58,-54,-34,-28,71,32,-63,-35,-24, 
  /* [234][0][][] */ 1,16,0,79,-59,-47,-18,-31,18,14,-24,22,79,24,-52,57,-1,-16,46,-94,-40,-42,-26,-10,52,-25,55,4,-5,-5,56,50,-11,-103,-3,10,-45,-14,-33,70,45,44,34,-23,12,-1,10,58,7,5,-86,-92,7,-27,0,0,-41,-27,-13,-79,-33,-32,21,-45,-35,-51,66,33,-9,15,18,-78,-95,26,20,40,76,-80,-43,-42,-47,-15,-8,-50,-20,37,104,-15,33,-20,69,33,75,-26,-7,28,-1,9,-30,51,-58,14,10,-127,47,-34,51,7,39,14,-1,-63, 
  /* [235][0][][] */ -1,-46,-22,-56,1,-19,3,-24,56,-84,56,-13,-27,-41,72,15,-80,39,28,-14,-93,11,-10,49,-50,-52,-14,40,-3,-98,82,-21,-95,46,-12,35,-11,-60,13,-28,98,81,-60,79,45,53,75,84,-27,21,-19,6,19,71,25,55,58,19,-48,4,-11,58,78,26,-10,-25,-33,-38,99,83,78,4,23,21,39,38,-83,-70,2,8,76,94,25,-65,45,19,-82,-30,48,15,15,46,4,-5,-22,70,17,-7,106,-20,25,-5,-90,21,-41,-19,63,127,27,-39,-60,37, 
  /* [236][0][][] */ 19,104,59,-30,26,-40,1,-41,10,-38,-24,30,71,-51,-71,2,-61,117,-32,105,-47,-27,60,46,69,-28,-28,-7,-69,-58,-12,44,-58,46,-69,-55,38,31,42,41,-42,39,21,-1,-69,22,8,63,15,11,31,-12,53,-55,-54,23,-10,-20,28,54,45,-17,-97,-38,53,16,-45,-50,1,-17,11,17,65,-12,9,-10,-8,-37,4,127,-59,0,-51,32,-2,-56,-63,-30,-52,6,-63,20,-22,45,-37,6,22,33,34,56,-27,-70,-47,-54,-5,-37,13,-96,0,17,-39,-19, 
  /* [237][0][][] */ -32,-56,-40,30,-66,19,-84,73,38,10,-31,18,-40,-12,16,-13,26,15,-73,27,-24,30,100,72,-49,-25,52,66,-28,41,-39,-53,-10,-28,-4,-8,50,-41,-6,-42,45,37,16,-21,61,-38,76,33,9,37,-53,30,7,0,7,-16,-66,-127,55,-14,21,-54,34,2,4,13,-57,-65,-33,8,-1,20,60,85,19,31,-49,4,-37,-3,24,-57,40,-35,-55,-28,-31,18,13,10,-48,-47,-28,26,46,-13,-22,-47,-14,-32,123,46,2,44,21,14,-39,27,9,-23,-43,42, 
  /* [238][0][][] */ 66,22,-77,10,-47,58,39,-26,45,-38,-84,63,16,-4,102,124,4,-77,35,12,79,47,9,-91,-89,-2,-72,-63,46,27,-23,24,42,85,77,-93,-54,89,127,9,-60,24,4,-34,-61,-44,-21,58,-18,-64,-22,-15,-21,21,37,43,-19,-26,1,-76,-37,40,70,-10,-3,75,12,-8,-87,82,-18,36,-30,-21,-11,-58,72,-64,-13,76,-4,83,-63,93,-111,46,-17,-17,26,-12,-60,8,71,-48,-38,49,-121,-11,-14,-20,-80,-62,26,84,49,-5,11,-46,21,46,-19,53, 
  /* [239][0][][] */ -52,40,-34,-92,-23,-26,-64,-55,51,-17,50,55,-14,37,-28,29,18,-28,16,11,16,6,-36,56,-42,10,-74,-29,-54,-53,64,-4,-34,-6,54,19,-12,62,-24,24,22,27,-76,2,2,-18,-23,39,23,9,1,24,-59,-29,-31,11,27,-39,22,57,-7,-30,15,-6,12,-22,7,68,-1,76,50,59,16,12,8,22,-26,36,19,12,-13,45,-6,26,57,39,105,-8,-2,-20,-57,127,19,-28,4,-23,-49,12,17,-57,21,-114,-48,59,92,-39,-60,-74,56,-20,39,103, 
  /* [240][0][][] */ 11,43,-18,-84,14,-35,-20,28,-51,15,17,51,7,17,42,23,14,34,13,-22,13,36,4,-27,28,4,-20,0,28,22,-45,-12,-20,1,44,24,11,-12,27,26,38,16,-26,-1,-27,43,10,-5,-11,-11,-50,7,44,26,-3,-5,-127,40,22,5,-74,87,52,25,3,-21,-29,-86,-50,53,-52,-6,-9,48,-17,5,-5,38,-53,42,-1,93,-24,-26,18,34,-45,81,-21,-5,29,17,31,-52,-43,-73,3,73,25,-65,-10,6,-45,-45,1,-35,26,75,-36,37,69,65, 
  /* [241][0][][] */ 93,23,-43,-22,-36,51,8,24,60,-47,-35,-46,-56,-39,61,80,-15,19,-34,-70,-7,47,-89,-67,-84,36,47,-3,58,9,87,-22,-13,35,0,93,44,12,109,-79,43,34,39,69,46,-30,29,-11,22,-15,-52,8,-25,80,39,-10,55,67,-25,-2,53,-72,-38,-7,17,-62,-8,20,48,119,60,44,-35,22,3,16,-64,36,61,73,-36,-13,-60,-35,39,-47,57,78,40,14,-42,-104,-90,23,6,-2,-5,51,-11,0,4,-48,-24,-1,-41,7,-56,94,15,22,-40,127, 
  /* [242][0][][] */ 46,66,-8,18,37,52,-61,31,55,17,14,14,-15,-27,64,46,12,24,-18,31,-2,5,-33,-97,-62,87,-18,60,-22,35,15,38,23,15,-22,-18,-7,-84,36,-18,-30,20,64,-16,-6,60,9,-31,46,-22,-14,-20,9,63,43,-122,-32,35,-111,20,5,86,22,115,-81,1,-3,-32,51,47,-19,48,63,15,-9,21,13,3,-32,-47,14,42,-119,-73,-16,57,-117,1,1,11,-24,-127,16,22,41,38,-21,-31,-65,-32,75,0,51,101,-53,-3,20,-50,-73,19,-31,36, 
  /* [243][0][][] */ -79,-2,39,-90,-30,-71,-35,90,-17,32,10,0,67,14,-98,-68,12,-36,-5,63,-34,-25,25,14,9,-14,88,-17,127,36,-11,20,89,-53,29,-108,23,15,-26,24,-22,25,-118,-31,15,-15,71,-32,-6,-21,-14,-13,-11,-38,0,-26,-25,43,-34,29,14,40,-16,-1,14,-13,9,-38,-11,54,10,26,2,11,-10,26,-2,33,-30,68,23,-7,-1,-4,-29,19,17,-19,2,5,0,-42,-49,40,11,-6,-48,37,-9,-10,38,44,-36,-32,29,56,-18,61,-6,-69,-43,15, 
  /* [244][0][][] */ 15,-28,19,-37,-41,-18,26,28,56,-33,-69,-24,40,66,-1,-53,-111,-23,74,32,-29,19,-7,27,46,-44,-64,-20,-127,1,70,-8,55,-31,15,-2,-58,-40,-53,123,-46,-5,18,-40,-49,44,-14,79,-51,8,-39,9,17,-19,-13,-112,-107,-36,65,21,71,-48,-22,-45,-21,11,43,-64,50,-61,3,46,-8,-26,2,-84,3,-37,8,114,21,61,18,2,40,7,-69,-64,-67,7,-49,94,53,27,18,-19,27,-25,68,74,-47,68,-58,45,47,-45,-55,12,-43,11,-111,-7, 
  /* [245][0][][] */ 17,127,54,-34,-10,-52,-32,-27,7,-1,-33,25,-14,17,93,-44,97,41,6,-11,21,23,19,42,-104,-9,-56,75,49,14,10,10,27,10,0,9,57,-18,-47,65,-60,-28,16,-30,56,-23,-60,1,-12,-51,13,-39,-89,30,17,82,-2,-54,35,18,-81,-86,-84,-13,20,20,-17,-57,-8,-18,81,-10,115,11,25,17,-53,-3,-22,-36,-26,-12,-26,-71,45,-51,-13,35,-34,-48,-24,41,-27,-43,92,-34,48,-23,2,26,-93,45,-1,46,-3,51,-4,-80,-5,12,-32,57, 
  /* [246][0][][] */ -78,-9,-69,-24,28,-48,-37,14,77,127,15,5,-14,9,-13,-55,-19,-54,12,104,-45,-8,-81,-23,41,37,16,-87,59,-6,22,17,44,53,-22,-95,48,-19,95,43,-35,-15,-36,-3,64,17,17,22,57,-19,-6,-6,81,61,-52,-41,-87,30,-104,-61,-29,65,-48,-91,29,38,-123,-37,86,-43,-42,22,48,4,-21,-18,-46,34,-31,-32,-59,-48,23,6,-47,-57,-6,-18,-23,49,8,-7,-42,-30,-39,-56,-23,-62,59,14,-17,33,-76,31,64,25,19,-35,-89,-52,21,-47, 
  /* [247][0][][] */ 47,20,-3,-42,121,-47,14,-127,-54,7,12,-46,75,3,-13,39,70,-90,36,-23,-9,-23,-4,50,27,9,36,14,34,-19,-38,-63,6,-4,103,-78,4,60,15,-109,32,12,18,-54,8,8,53,53,-11,-51,70,5,66,14,-34,-104,79,6,-59,-32,36,41,8,36,-3,6,-1,-73,35,-58,-11,3,20,1,-28,-51,109,23,12,58,-36,-41,-94,-111,-61,-54,-25,-55,-77,78,-13,73,8,-69,30,-34,-9,33,-63,64,-39,-90,29,63,60,-13,-35,93,64,-76,8,-23, 
  /* [248][0][][] */ 17,27,-65,-7,-10,48,-41,47,-42,-17,-4,-119,-7,24,1,12,17,27,27,-68,-32,-39,4,7,-78,-19,19,-18,68,-4,-14,47,127,56,-48,49,-28,12,0,-64,58,-6,38,13,83,27,45,-2,0,-10,-4,36,-73,16,20,-73,16,-7,35,3,26,-38,64,-28,-7,-36,8,-47,-30,46,51,33,-18,13,3,11,-60,10,-15,-4,44,-12,27,21,-2,-62,-59,-46,16,-91,-35,-59,43,-15,-63,19,13,35,-6,-7,-10,-36,15,42,35,-17,-23,8,53,34,-15,69, 
  /* [249][0][][] */ -3,-52,69,26,-8,1,17,11,54,-58,-16,12,36,68,-54,-32,-36,50,54,-61,-13,49,-20,-46,39,24,-8,-23,-44,42,-2,2,-127,55,67,-25,-36,41,-19,-22,-20,18,17,-26,-26,14,83,94,-39,-58,-62,21,20,-51,3,15,-103,-13,13,13,13,10,58,51,-35,-29,9,32,18,-37,6,42,28,-95,-46,12,65,31,13,19,-19,-28,59,38,44,47,-57,-26,39,19,5,13,-47,4,42,-40,-23,21,122,18,-30,23,12,8,35,25,-23,-59,7,-7,-11,-68, 
  /* [250][0][][] */ 21,-4,-10,30,-36,6,16,-17,-24,48,-29,53,49,6,-62,9,17,-127,-10,2,-120,31,-30,21,-5,-74,-27,-1,-2,9,-37,73,19,23,35,-49,56,37,32,20,-40,-50,-3,-1,27,-24,59,120,21,-65,19,-15,-33,24,-24,-66,-78,-38,-7,84,12,-20,-44,-72,49,-56,79,50,25,26,-95,-41,-31,-18,8,-15,-32,-69,-16,33,10,38,-65,18,-46,49,-53,118,3,48,-61,8,64,-34,-7,1,32,-12,26,75,-10,26,-57,-55,-48,-58,-76,-50,-35,21,26,43, 
  /* [251][0][][] */ -24,-22,23,-49,30,29,118,-28,-46,-22,-14,-59,-73,12,18,62,27,-92,-32,32,0,50,24,-20,-16,-19,-127,12,-9,-11,49,-35,22,-28,-49,-45,-29,26,-32,-14,12,35,-28,-16,-23,-36,-84,-41,-40,-31,50,34,73,46,59,32,44,30,-54,-62,-44,-17,11,71,-5,-1,49,16,-50,94,50,-119,57,32,-2,-73,19,59,-24,-43,49,4,26,-3,-19,-12,9,37,19,-12,6,-41,42,95,-44,-14,-3,-9,-38,37,-40,-50,36,114,-30,-71,38,-42,89,74,-12,3, 
  /* [252][0][][] */ -22,44,32,-17,32,30,24,-8,-9,90,-54,51,-45,-4,53,-53,51,74,45,-29,51,38,19,-125,58,12,-26,-16,-113,27,-96,-68,17,-26,-42,1,-8,-43,1,1,-67,83,12,-78,15,-14,-30,59,53,-26,-23,-12,-6,-42,-18,-38,-3,-2,17,2,2,37,-61,-74,-44,16,-1,127,48,-16,-17,-4,33,-92,-74,-15,33,11,41,-35,17,-36,-70,48,-1,-2,-34,-31,8,-37,-126,-25,46,-40,-3,-103,-71,20,-50,18,61,27,-18,52,-33,-73,-39,-74,63,11,-63,44, 
  /* [253][0][][] */ -69,94,-41,-87,6,49,64,-54,10,16,-12,15,-51,73,-68,-63,6,-92,-31,-49,124,5,-1,-28,51,-54,8,-58,-8,32,-79,-94,-23,-29,-30,-63,-73,39,49,-2,-29,-108,-75,-37,-5,29,31,73,-24,12,33,-73,-38,-28,-52,84,12,127,47,49,-26,40,-16,-89,7,-18,92,59,-61,-20,-81,53,-43,79,5,15,23,31,79,12,5,-19,-36,-7,-1,-50,19,1,49,-6,-1,-4,22,16,30,80,6,82,115,-43,25,-71,-65,41,19,-53,28,-83,56,1,17,-66, 
  /* [254][0][][] */ -15,12,-41,65,-55,-66,18,69,58,-31,1,20,101,-30,-67,-13,42,99,2,12,-23,40,-11,28,-65,-17,-102,-92,5,-45,4,127,-11,-55,-26,-47,6,-15,-16,52,91,-2,37,24,-8,-68,26,-3,-75,-67,-11,38,-17,-23,0,36,89,-88,2,22,-25,39,7,6,-13,37,58,-42,-101,-14,61,-101,-83,17,-90,31,-19,-39,-65,-17,-40,0,36,-25,4,10,47,36,8,50,-23,-16,55,-105,-8,5,53,16,41,70,16,-42,-79,-2,-34,-18,71,-102,-26,1,2,-26, 
  /* [255][0][][] */ -38,24,8,-30,80,22,112,-50,20,-2,127,-29,27,-25,56,-34,33,-17,48,59,-33,120,-79,27,37,-84,45,30,8,22,45,14,50,-75,-68,2,6,63,75,9,-42,26,16,19,-20,-12,-41,-10,17,1,1,-34,-15,61,-20,-8,-2,-15,-8,11,-8,65,-19,5,-26,-30,19,-26,24,12,-37,11,-7,-13,26,-1,-29,-2,59,-23,-12,-38,75,16,15,-24,63,-28,-44,7,-1,31,-56,55,31,-20,-86,2,34,26,57,41,-58,-24,39,-26,-101,35,41,33,61,-79, 
  /* [256][0][][] */ 101,-5,-62,27,23,-83,-10,-19,9,-30,70,10,2,-42,-34,32,2,60,78,61,50,11,-41,-13,-51,37,-64,85,22,-75,-31,48,-30,22,32,-8,53,-59,-31,-26,-4,-29,127,48,-88,-44,-13,59,69,-57,35,-19,33,38,27,-32,22,-21,-37,48,-40,75,-109,-5,-92,-33,7,4,36,16,-36,-56,-71,19,35,48,-34,47,-59,21,61,-45,-9,-16,-35,23,55,-31,-18,-23,-41,57,-54,10,4,35,50,-31,-38,-63,74,60,23,23,120,-9,-64,81,71,-66,-9,62, 
  /* [257][0][][] */ 48,41,48,-2,0,119,16,-5,5,29,56,-6,-28,0,16,-35,39,54,94,61,-78,-32,9,30,-12,52,-23,21,-39,-3,-85,-54,33,9,72,25,76,1,-28,16,-116,2,32,26,63,-11,41,-3,10,-8,-37,-74,50,-19,28,45,-49,-33,61,68,-4,-101,-23,29,39,-89,2,-10,-33,-43,21,4,-58,-2,-16,-9,-26,-34,81,36,1,38,48,-19,-32,-5,-40,-4,-62,-46,79,38,127,-52,63,34,33,85,-39,13,-15,-25,-57,-42,-12,-43,67,5,-34,24,30,-46, 
  /* [258][0][][] */ -26,-36,-7,27,-58,14,7,-31,15,24,16,23,13,-47,61,53,39,21,-1,54,11,71,47,-73,-23,25,-2,44,-15,1,-58,-8,-23,13,-44,19,-95,4,-8,10,39,14,33,-98,35,-6,17,-28,74,-8,-18,-4,-4,-28,-9,14,25,-61,-37,16,-15,27,-15,-32,-42,29,-38,2,40,-6,52,-127,-11,-11,-21,4,56,-33,32,-5,-25,-17,29,15,34,-13,-38,-13,4,-22,79,61,49,22,-3,15,11,-9,-2,8,-55,-2,45,-10,0,11,-28,-19,-18,-10,5,-42, 
  /* [259][0][][] */ -87,-54,-77,73,15,48,34,-49,103,39,-68,-19,6,-13,15,24,100,-90,36,96,37,-40,-4,31,-5,58,-22,77,-31,61,-16,-15,-58,-1,24,19,45,35,-12,108,-13,-50,7,3,79,-2,64,31,-119,4,-18,-68,5,-71,45,33,47,-26,-60,-75,0,23,52,113,40,7,-47,-105,-81,39,57,-103,-26,-39,-25,-55,-27,-15,-35,19,81,102,20,-19,-11,98,100,127,18,50,-23,-12,-96,-1,-17,2,-11,-32,-23,-20,-62,-93,33,-109,-2,44,95,-26,15,-30,-47,10, 
  /* [260][0][][] */ 6,31,-52,-70,39,-7,14,25,22,-66,-58,1,-35,19,-21,-58,21,-22,-31,-77,-38,-65,52,-51,3,8,-93,-38,-3,22,27,16,-14,-63,-45,-99,3,-45,-6,-73,-40,27,1,-1,127,-47,-38,-87,39,1,-70,31,-88,-22,-85,40,-19,-37,-28,-38,9,-12,-37,-25,-3,-32,-68,69,83,55,117,-113,73,-17,-44,-69,23,-32,119,59,-50,-51,31,-49,45,-30,112,24,58,22,70,13,-32,-36,-43,22,69,18,-24,3,-61,4,41,-7,1,68,6,-30,24,-74,-78,71, 
  /* [261][0][][] */ 16,-46,2,12,-42,-81,6,34,45,-31,-38,-45,-11,29,31,74,-21,26,-36,39,-21,-81,-42,21,63,-54,-75,31,-38,26,-14,-62,-13,27,-6,-2,20,33,13,35,-17,25,127,-22,53,-4,-36,-48,-34,60,2,-26,8,-7,17,19,-9,-22,26,26,10,26,-31,1,10,-22,28,5,-98,3,-8,48,53,-40,37,-38,7,-10,67,1,-54,-29,12,-12,-55,80,58,29,-33,-10,-35,-42,18,17,-13,-27,-65,30,36,10,-36,-8,11,32,-19,-17,-14,-49,-20,25,32,-55, 
  /* [262][0][][] */ -17,-36,64,-7,22,-33,51,51,20,43,14,-53,-36,-77,-29,-28,23,43,17,-5,-112,9,9,22,16,88,-15,16,-87,-65,42,57,62,26,18,-6,32,45,-15,-1,-4,-20,-15,-6,-10,-89,-41,-63,29,-34,-17,-5,-9,76,6,-101,85,68,30,26,102,-50,31,13,-104,-35,-31,-47,-3,-9,24,29,-31,35,39,-19,-34,45,4,-72,-127,-14,14,38,-24,-22,68,-13,37,-71,-30,44,-125,-41,4,-1,45,66,-8,14,-7,5,-46,-23,96,-14,-25,111,-50,-66,14,3, 
  /* [263][0][][] */ 23,-63,-96,60,-11,46,13,13,88,-6,91,25,-39,-56,-23,33,-46,5,60,41,3,-7,41,-40,-15,-62,-10,-76,27,77,100,-90,33,62,100,-96,23,66,-39,-80,6,27,-7,85,-74,-1,12,-52,-64,30,11,-23,-22,74,40,-48,-127,-90,21,8,-13,-68,76,-27,-35,33,61,-57,-1,-33,-62,16,56,11,-31,-45,-11,23,10,10,29,-98,-15,-71,61,38,-54,-29,32,13,-39,37,-53,17,-51,-12,34,-15,17,17,24,-10,-1,52,34,-4,-97,44,-58,16,-14,10, 
  /* [264][0][][] */ 85,28,-28,-57,-32,-33,50,19,73,67,1,-17,-61,-9,-48,33,127,30,-42,-6,-58,-24,21,2,9,24,21,-5,25,13,-63,23,18,4,39,64,-94,-6,-5,-29,-26,-40,-36,9,-49,19,18,-35,-42,-25,15,56,-15,-48,-24,-32,-16,-60,-46,93,-8,37,-21,-3,-72,-74,-15,-34,-48,31,-49,-7,77,67,9,12,-23,-9,37,18,-4,-4,-16,-36,-17,4,-79,-2,-66,-29,65,-44,-23,-10,-8,71,53,-21,1,-51,-22,56,56,21,-5,-6,-14,-29,-40,30,-11,5, 
  /* [265][0][][] */ -11,-66,32,-68,-18,55,76,-78,4,11,28,2,45,-25,-61,-17,-30,-3,8,-35,3,38,45,-22,-27,47,-3,28,25,-34,-7,-34,14,-5,76,-30,-8,-26,61,-2,-32,8,-34,-4,14,-33,32,-6,56,-31,8,-1,-104,57,-2,1,-8,34,35,-35,-35,-5,-33,-69,7,43,-24,-7,47,-96,-3,34,-63,30,43,-10,-73,-5,1,57,-65,53,18,46,97,13,21,65,18,-70,56,-46,77,31,14,-40,-40,-33,-5,-28,20,52,-34,-14,123,-56,-40,2,34,8,-127,31, 
  /* [266][0][][] */ 37,-4,-47,37,3,-44,-13,-24,-50,-5,56,-82,-48,-32,-2,-31,38,-58,-117,7,-25,28,6,-27,-16,38,25,-3,-34,-83,-19,-25,-52,-50,2,8,19,23,45,29,4,28,-1,62,63,-51,68,41,-31,-30,1,-38,-32,86,-1,71,62,-20,-46,-39,24,55,-24,-38,-41,28,-1,-7,-57,-3,21,1,15,85,-83,-17,44,-91,18,6,5,34,127,-2,-61,29,45,62,29,32,-15,13,30,9,-24,-35,4,-17,37,0,-37,54,8,-17,-9,-30,-70,-18,59,43,64,-26, 
  /* [267][0][][] */ -82,-75,37,-24,-32,17,78,25,49,-43,-35,-33,-6,29,-95,17,-68,6,-7,-9,16,28,32,-4,40,-18,10,82,-14,58,-29,12,19,-27,67,-22,30,28,18,67,-111,-57,127,93,72,6,-49,-2,4,-12,25,66,94,-42,59,34,78,-8,32,-72,109,-2,33,38,91,-53,104,-73,22,-25,25,-5,-84,-46,4,-6,-13,-7,-76,1,10,43,-1,-29,-79,-78,-22,43,-42,-13,99,-75,83,-38,73,109,-31,-74,-66,39,87,24,7,-61,26,-23,-18,18,42,-17,-53,-8, 
  /* [268][0][][] */ -29,20,-6,77,-23,-63,71,13,30,-94,-27,-24,-21,70,-64,-48,25,-85,51,6,-16,-15,17,29,36,-5,13,-22,9,-22,39,0,-7,-17,3,-56,23,4,0,-2,-50,17,45,35,22,10,41,-19,-32,-3,42,81,-51,10,-56,-11,-51,1,-36,-96,23,68,13,-38,39,-4,51,-8,3,127,-11,35,107,-56,-1,-8,-42,29,-40,-5,-1,16,0,-16,-47,48,3,70,44,15,-16,-71,-6,-24,-24,1,99,27,-13,82,47,36,45,24,55,-24,-58,50,48,-41,54,-26, 
  /* [269][0][][] */ 18,-13,-25,-80,21,41,-78,7,66,-41,39,31,-88,60,50,18,4,51,7,-43,-2,-57,-22,78,-73,6,-58,-23,-70,-19,0,48,-42,-10,78,47,-67,16,-85,-35,62,19,-43,34,-19,76,11,-12,55,-14,-62,-42,59,-5,27,8,-29,17,11,29,-40,-52,22,57,46,3,-31,68,79,-78,65,-48,54,-45,-20,-1,-2,16,72,-56,-40,7,-80,-61,-40,-14,-34,106,-75,93,-10,-66,-44,61,-33,124,37,-10,2,12,35,-15,2,77,-66,-18,-12,9,28,112,-127,30, 
  /* [270][0][][] */ -31,54,0,-33,-58,45,-14,82,-7,-68,-78,-41,-24,-37,-79,1,24,39,-21,-68,20,19,54,42,52,39,15,26,66,-17,-43,-3,-26,4,8,60,-15,-62,-50,3,92,-15,2,11,34,-39,49,-30,-108,3,-38,99,-10,-33,8,-26,77,-30,-68,-4,3,-3,-7,-110,29,82,8,-74,53,-25,57,-17,-69,87,45,73,-54,110,28,-72,-127,6,12,-59,13,-52,64,23,-4,-30,6,87,51,36,-55,21,-78,-89,34,-48,23,36,-64,12,70,11,7,10,-42,71,38,7, 
  /* [271][0][][] */ -18,2,-5,-60,-58,8,45,57,12,-21,0,-69,-29,-12,54,123,78,-47,-28,24,39,107,20,28,-33,29,20,-40,-8,-64,-36,29,-101,-6,10,-55,115,73,-58,-69,14,37,46,28,53,38,38,-67,-25,9,-127,38,19,26,60,64,21,-110,28,-76,-78,37,-67,62,38,24,-33,-28,-31,97,-9,-36,-30,71,8,72,93,17,-36,86,121,-75,-55,-54,-37,90,-42,59,-11,-74,-68,5,17,20,61,26,-42,7,124,6,-84,49,-4,4,-57,-33,-119,19,65,0,-52,28, 
  /* [272][0][][] */ -2,-8,-67,-20,-6,-80,22,17,-38,-6,-70,1,-8,-64,3,-38,-33,-18,-14,-72,38,-23,-9,-8,-21,-94,-14,-72,30,-24,-21,-13,-34,-1,22,-28,24,87,35,51,38,-60,62,32,10,4,102,18,-80,33,3,14,-19,-52,61,44,127,66,-113,-56,28,-61,3,-24,59,-34,62,18,-40,0,38,-12,10,2,-21,21,26,-40,71,41,12,42,12,-101,15,-10,21,-42,14,99,-21,-86,-11,-26,-61,36,-43,-69,-7,-8,8,-17,-19,-36,61,-11,-8,14,42,24,23,-6, 
  /* [273][0][][] */ 59,73,5,-101,-52,-27,14,-21,-20,25,-45,-62,-84,6,-6,2,-22,-92,-9,-8,-57,3,80,33,-32,-48,53,29,-7,22,-76,-53,15,-98,-2,-11,-74,-8,-10,-84,111,34,1,40,-34,16,-42,81,8,-86,72,56,-28,6,31,25,9,10,29,-38,79,0,41,33,-9,-125,-20,-92,43,2,115,58,-57,-70,16,121,38,-27,-11,37,47,-15,-56,16,-37,-24,-43,-28,8,4,-20,17,-4,-33,-29,-3,-10,2,25,82,19,20,-40,59,4,-39,10,36,-33,69,-127,-37, 
  /* [274][0][][] */ -82,-19,6,-3,-2,41,-15,-18,69,-11,25,-3,-74,-29,-73,20,-80,-10,61,-17,38,49,103,44,7,-2,-12,-82,51,-10,13,39,90,-29,63,-126,-6,18,19,42,-120,40,-57,-90,-106,-27,90,2,18,-29,-62,-40,-16,-14,62,-50,-52,93,57,-17,37,-14,25,-13,38,18,-68,-15,-10,-27,-7,23,-16,-27,97,-32,-54,-21,26,14,-45,-34,20,-10,15,0,33,-15,33,25,-17,36,54,114,-79,-58,-65,60,5,-25,57,31,0,-96,-68,-62,-58,31,1,-127,34,-79, 
  /* [275][0][][] */ 4,31,-69,-40,37,-16,-15,63,49,3,38,19,7,-36,53,-38,94,-38,43,-53,-61,-56,18,-52,3,-22,-43,61,-69,38,90,75,11,16,-20,-26,-50,2,-43,-55,-56,51,-65,24,7,57,-31,23,-17,70,-107,-2,4,23,29,28,23,45,23,-12,46,-2,0,8,46,67,-42,-31,-2,-28,0,26,-75,-68,-9,11,13,64,-57,-28,66,47,7,-32,50,-68,22,-27,19,-25,-20,-21,-5,115,-14,80,24,21,-75,39,1,-127,-7,73,78,-16,-13,-24,-53,38,47,45, 
  /* [276][0][][] */ -39,35,-3,-21,-3,36,-18,20,-50,16,54,16,-81,39,77,-58,-42,34,56,104,64,3,-62,40,-79,-27,-14,-25,4,-69,41,-11,-25,100,13,-6,24,0,-79,51,70,-73,-10,30,23,57,100,36,122,-26,52,-42,27,7,-51,-72,27,-77,25,1,38,-106,41,-85,47,44,32,69,-71,-19,75,57,48,-127,-28,-20,23,-61,-76,37,-14,-107,39,-9,4,61,-81,70,35,11,-16,99,-20,-49,-105,40,-39,7,4,51,22,-60,-15,23,61,0,-12,53,20,49,-12,-4, 
  /* [277][0][][] */ -81,-94,-5,-5,84,-15,-67,-49,35,35,26,-20,-67,-74,37,-5,26,-25,49,-7,-47,40,49,127,11,-11,-62,-15,26,24,-13,40,4,-8,-15,-109,89,-11,39,-41,45,-26,65,33,-32,-126,-9,-22,18,77,-49,27,-107,-23,-8,43,-65,14,36,-9,9,17,-44,6,89,2,-113,40,106,-60,56,36,-23,28,91,-66,-26,1,-89,61,-64,125,-70,20,-54,49,18,-27,-14,118,70,-3,-8,68,113,13,18,41,49,-101,28,38,-29,-48,-92,-11,-6,82,0,-35,-65,13, 
  /* [278][0][][] */ -14,2,111,103,16,-26,-61,-112,-80,-27,103,-86,119,-22,81,-42,47,-23,-36,-112,28,31,33,31,-73,-127,-6,15,-56,35,-36,-54,92,25,23,24,-35,-89,24,4,-22,-15,-29,61,47,60,-43,-54,42,24,48,106,47,-22,29,-68,-23,40,-13,-27,-34,-18,59,-96,-48,4,94,65,-30,35,-89,11,-99,-65,40,-62,48,-2,-30,50,-7,1,13,80,-67,56,-7,-67,44,54,-36,40,-22,52,-21,15,-40,53,-30,30,34,27,-40,29,-13,-36,-119,99,29,-94,-10,-31, 
  /* [279][0][][] */ 44,94,-11,-9,-66,8,-40,-60,44,47,58,-17,48,-37,25,-4,13,39,71,-72,44,99,15,-43,47,52,-19,25,36,-3,-19,-27,-107,26,67,22,19,18,-20,30,1,69,-11,8,-39,-33,-49,15,-5,95,30,26,-21,22,39,34,-5,70,11,-33,20,-38,-47,-26,-27,-40,-13,-50,72,-42,42,18,-9,-9,10,21,26,25,8,30,-24,-33,0,-5,-29,-61,32,-71,-20,-13,-64,92,-10,-24,65,-42,-35,4,-127,-69,-13,51,-62,-25,57,29,-17,0,17,70,89,14, 
  /* [280][0][][] */ 12,-46,9,-43,-44,-3,23,-19,38,0,-26,1,6,3,24,8,9,22,-13,-12,32,-26,49,-24,-14,31,-43,30,16,-15,-44,30,10,-26,28,19,9,20,77,-9,-12,-11,17,-14,44,30,-22,16,-27,6,13,-40,-54,-24,-127,5,2,46,-22,37,-38,-30,8,4,39,6,20,1,8,41,17,-5,50,25,-22,-3,30,-17,-41,-55,10,-2,23,13,-31,-10,13,0,1,-24,-13,15,44,-39,-12,2,-13,-13,19,-20,40,23,27,-19,-70,8,-25,-42,-29,6,13,42, 
  /* [281][0][][] */ -37,16,-95,62,34,-43,66,53,7,-28,-22,-15,-12,40,43,0,66,-13,-66,-82,92,68,69,44,45,33,7,-61,59,-46,54,7,29,8,-55,10,7,35,7,-43,78,-43,4,-4,-16,28,30,-26,-35,-20,13,19,-4,11,32,14,44,-6,-8,-38,-18,37,127,-40,44,-43,-13,-23,-77,48,3,56,79,21,-7,9,9,-2,24,-17,-23,-36,-5,-40,25,40,24,24,-19,-62,112,40,-56,5,-18,16,-80,-20,-3,-1,10,-36,-38,33,-39,-18,14,56,0,36,56,-29, 
  /* [282][0][][] */ 7,-17,-17,-46,-1,29,74,-30,-16,-17,-64,-63,21,-65,-96,46,-5,-17,-46,-4,-25,-26,-47,-22,77,-45,-8,-15,-29,-29,6,-57,9,-35,13,-64,65,-47,4,76,-28,20,49,-53,21,-35,53,57,-22,3,-30,127,91,-9,51,-27,-88,-57,70,-21,-34,-25,-87,32,-50,32,74,14,50,21,-80,-9,21,33,-1,35,-3,-38,0,71,-46,-85,31,-15,-68,-16,-52,-24,12,-29,-24,-67,17,-18,-102,-51,-31,14,18,33,30,74,-25,101,-65,-19,-44,-68,-44,22,2,-29, 
  /* [283][0][][] */ 32,78,-34,8,-13,6,11,34,-53,69,-33,2,-14,84,36,8,47,33,22,24,-6,29,-3,-29,56,-8,62,43,-39,-45,-16,-19,-19,11,-9,46,-17,40,57,21,-53,-14,-81,21,-2,-36,-12,4,-19,-48,-40,-4,16,29,7,9,-8,11,1,45,-41,35,-29,-19,-11,4,-44,-57,-4,-5,127,-34,10,-69,-4,-47,-5,3,33,-38,-1,23,-11,-15,3,54,1,9,80,43,-7,-13,21,-4,-27,53,-19,-48,-43,-9,-38,59,-16,-32,-29,24,60,-4,58,44,-63,-6, 
  /* [284][0][][] */ -105,-21,27,125,43,14,48,106,-61,-24,-2,17,-13,-33,3,18,39,-10,0,-90,-10,-28,-6,-70,-26,62,-20,-9,-38,-10,78,8,-45,23,-49,10,68,-29,-16,22,-22,66,-17,-81,-16,74,-45,-3,63,46,26,27,-54,-127,94,36,-21,12,-20,4,-66,104,32,23,-24,56,91,-32,47,-32,19,-29,32,-32,-53,27,1,-7,65,13,27,39,21,56,27,29,-92,-74,-77,-16,42,74,-22,47,-20,79,-24,-23,-22,5,13,-26,63,-51,22,-42,23,97,33,-9,-16,-14, 
  /* [285][0][][] */ -122,26,73,19,34,-56,-6,12,-14,-1,69,-43,-67,63,-50,103,-4,19,70,-15,32,-15,-51,-108,6,-2,12,-63,-29,-5,65,-83,-22,86,31,7,20,-21,5,61,-6,-6,2,-32,-32,-19,-24,-6,30,-29,62,6,42,67,-65,28,-59,49,-39,-18,5,-21,9,-59,46,68,53,42,25,72,-22,37,-20,-26,30,0,19,-42,-1,40,-50,-35,-9,49,-1,8,25,33,47,22,43,16,-8,10,-37,27,-127,32,91,15,-17,-31,-9,-26,34,30,-15,41,126,29,35,-16, 
  /* [286][0][][] */ 51,26,127,49,-21,39,9,97,-27,93,27,-4,-89,81,32,-34,-21,26,5,10,-17,14,18,4,48,-1,-44,-24,-3,-32,22,9,14,2,-8,20,7,8,15,22,-31,16,40,-32,38,-9,10,54,4,-52,27,-56,12,-18,102,-17,-21,23,-68,-55,7,1,46,54,7,-28,-57,-25,-4,57,18,-30,2,21,-15,-32,-7,-16,29,-59,-40,55,-4,-6,10,20,-40,-52,-3,-21,16,-16,62,-20,2,98,70,77,75,-32,-20,-34,-1,39,23,-79,-22,86,-24,14,-74,-15, 
  /* [287][0][][] */ 47,36,-76,74,41,51,-35,-26,-3,-91,16,-2,-7,-92,-16,-33,-64,45,-104,-26,21,40,-20,-20,5,-30,42,-25,-18,-21,-8,19,60,-107,-21,-46,-127,84,73,43,63,-33,-30,-52,33,7,12,53,1,-34,-35,91,23,20,11,-29,-45,-34,27,27,50,-29,-9,-89,11,-94,60,20,-39,87,41,-66,-34,-44,-26,54,-21,20,-24,-37,36,-100,28,-92,-26,-40,-18,-97,-17,98,25,-27,-38,47,-4,-69,92,60,1,-5,2,68,-5,43,-4,-65,-1,-41,77,-28,-23,8, 
  /* [288][0][][] */ 2,-72,88,23,-12,-62,-17,-64,-11,-9,-62,34,23,-46,-122,-55,3,88,81,4,-50,64,15,-41,28,70,28,-12,-19,122,-20,45,63,-14,89,-79,37,-8,-48,75,21,55,-53,50,33,53,116,-47,100,-112,-101,51,-34,16,-58,51,63,-76,-2,51,22,37,-4,7,-127,30,-68,-74,-105,35,33,1,-5,81,-111,-10,22,-120,-70,62,70,-32,-30,19,-94,4,-87,20,-82,-32,23,-43,-54,-54,-47,124,-25,-1,-82,5,28,-17,4,-9,-18,-30,-42,47,-24,90,-38,-34, 
  /* [289][0][][] */ -78,-127,32,6,51,-32,35,57,-34,-18,-12,-19,-27,46,-4,-15,41,-28,84,-51,-9,24,-34,46,22,10,-28,5,100,-15,-28,-14,9,57,55,51,23,13,41,14,4,27,-11,-36,-15,-1,43,33,29,-6,-36,-81,3,-12,43,56,-1,-48,-74,26,-24,75,-29,-55,57,-29,-54,-19,62,23,2,-49,-32,-47,-80,-40,48,-36,24,33,72,36,19,31,49,-24,6,42,1,-15,18,43,-87,-13,4,-17,28,14,10,-9,-38,-29,64,-65,-13,-35,-13,48,53,44,-19,13, 
  /* [290][0][][] */ 104,-36,4,-13,48,-31,14,56,20,-10,95,-5,-3,2,-54,-80,15,44,-81,47,42,-32,-36,-25,-41,38,3,40,-15,50,-19,41,8,75,78,-22,-28,-43,-73,58,35,13,58,42,-68,-13,-12,28,-111,42,127,16,-70,-57,80,48,-77,5,-48,-23,103,23,39,-27,12,-42,53,-54,32,120,-65,13,-16,47,107,17,-21,93,-77,9,46,-13,-33,5,78,-57,-17,-71,-40,61,16,43,25,18,52,-39,-88,72,7,-84,13,-37,-5,43,-41,55,72,66,-3,26,-113,25, 
  /* [291][0][][] */ 50,-72,-46,-14,7,11,30,-56,11,7,-33,57,-6,6,-71,-66,41,5,-79,-33,-73,-27,47,-69,16,29,3,31,-86,-26,-40,57,89,-38,0,-103,39,-92,-49,8,13,-61,-6,90,-62,-7,39,4,-26,-6,21,-54,-33,22,-30,-4,46,18,24,57,54,28,-38,43,18,10,-29,-41,44,48,37,-75,-48,-48,21,73,23,26,1,-70,72,44,11,-127,-76,62,25,-88,99,0,71,-41,-46,-57,32,-5,50,43,28,-62,-84,-24,6,5,7,-5,7,15,-118,-10,35,-60, 
  /* [292][0][][] */ -63,41,-89,14,47,-7,-41,-40,-52,-74,42,-7,-84,32,9,9,-55,-33,79,-88,64,5,-13,-10,25,-48,-33,-25,23,6,48,86,59,31,-101,35,64,39,-105,-22,29,-80,0,127,24,21,8,-17,9,-32,5,105,-80,97,19,38,49,-15,65,26,39,-71,55,26,5,42,117,-44,14,92,31,8,-20,85,-52,-2,51,-14,-36,-48,-3,78,-98,24,-7,27,30,67,69,-14,-7,-64,-17,82,-46,98,-21,-64,-23,-14,78,-105,-13,103,-59,109,-17,9,-64,-12,-6,55, 
  /* [293][0][][] */ 41,76,-31,-5,12,-15,35,15,10,-68,-27,-127,-19,-40,0,-14,47,-118,72,-1,-24,-13,19,75,-31,33,30,-3,104,13,11,-20,-39,12,64,9,-13,-33,81,60,-9,-52,46,-17,39,-38,6,13,-19,46,58,76,-42,67,-87,-69,20,63,-30,-16,-11,68,-5,36,-49,47,26,-25,111,48,36,92,-46,-23,-20,-48,1,6,-28,-47,-58,12,-78,-55,-38,-61,-29,92,25,-38,31,-20,5,6,-50,53,-78,-86,-35,16,-33,-36,9,12,-41,20,-3,41,14,-85,-66,-37, 
  /* [294][0][][] */ -5,-7,-50,-13,-78,-31,54,-28,12,-6,46,-102,6,43,48,-2,16,34,-12,-71,28,127,17,24,1,-35,12,67,-64,29,-65,53,-100,-20,10,9,7,-48,49,20,30,-34,-24,-20,-8,-7,-26,17,39,3,-13,13,-26,-23,1,51,75,-41,-64,-80,-11,-12,-85,52,-31,-63,-18,-15,-43,-10,10,1,10,-56,66,17,12,62,34,-63,25,9,-27,-19,-4,-14,23,-7,3,-36,-4,-51,-21,-7,11,-48,-5,-45,27,-65,15,2,79,-31,-9,13,-11,-59,29,68,22,20, 
  /* [295][0][][] */ 63,103,16,-3,102,-44,3,-62,75,35,-2,-86,-108,54,39,-22,-1,-12,35,79,-45,6,-50,16,64,-36,-67,-17,40,-11,105,-87,-77,-87,85,-67,-63,-68,29,48,-19,36,-107,-67,-50,33,-44,53,4,-23,55,-32,73,71,-14,16,1,58,21,55,20,-4,33,81,-36,106,56,-46,90,69,77,72,71,-100,-14,17,-52,-1,-28,25,-6,6,38,87,-3,-34,22,-34,6,-22,-13,-48,-49,-19,-48,93,-47,11,1,43,21,-127,-103,124,-106,0,66,45,-43,-21,-4,75, 
  /* [296][0][][] */ 37,-31,-19,-19,16,34,2,43,-4,-59,-63,0,95,-5,-3,-40,21,-41,39,-86,36,11,3,-34,107,-15,-86,-28,-12,-13,19,-11,29,36,10,-47,-73,29,-93,4,-61,20,15,10,84,-94,40,-38,-29,11,71,-7,60,67,1,64,10,58,-14,-99,49,127,-5,-25,20,-88,-87,34,-2,25,-71,-5,-26,19,-89,1,53,-25,83,35,56,-43,-20,-44,-46,-64,-41,48,0,-78,4,14,33,-7,-51,75,43,39,31,-19,51,35,-82,-96,-38,1,-122,-1,-5,12,-25,-16, 
  /* [297][0][][] */ 11,41,-49,-127,-55,-28,-55,26,28,-15,49,-52,8,-29,13,23,22,-64,-88,19,-15,74,11,-35,-37,16,22,-60,-18,54,-102,42,20,-117,-13,68,71,61,27,2,-22,3,55,-35,101,14,50,4,10,7,-17,85,-22,29,-4,44,-27,20,9,-86,-17,10,-35,23,63,-36,-42,10,-43,-40,12,-37,1,53,13,15,23,-30,65,8,7,11,-73,-28,-111,-20,45,36,-5,43,-41,-10,52,-20,1,38,69,55,-26,-20,-50,23,-35,1,-103,-3,76,-51,-6,9,-8,-37, 
  /* [298][0][][] */ -63,58,23,-41,-18,43,-22,2,-39,16,23,50,-27,-60,41,46,44,46,66,-22,73,-35,33,-12,20,-49,-11,-29,17,40,23,127,-26,4,21,-4,34,30,9,-46,-11,7,-59,73,-2,57,-114,-59,-40,60,9,5,-6,15,-76,29,-3,56,59,74,-26,10,-28,-14,4,-20,82,69,16,1,6,-53,38,-22,17,-20,-57,24,31,0,1,0,7,15,-62,-21,-14,-17,21,59,-39,-30,43,22,-32,-49,1,32,-22,-99,-71,8,33,-29,-33,-62,24,-103,36,-9,-3,40, 
  /* [299][0][][] */ 61,-31,44,-13,2,19,-6,19,36,-8,-37,31,-19,-94,-78,-48,-72,-125,-18,-85,57,8,49,-15,87,-68,58,63,21,33,-95,22,9,26,-84,-2,17,24,95,73,-19,3,34,26,20,-7,22,35,91,-78,-30,13,35,80,85,-76,-39,11,36,-68,-1,46,-1,-59,-90,3,55,111,5,-33,39,25,54,-41,75,-18,24,12,-23,4,127,112,-57,-16,-55,-56,-71,-26,124,-46,8,-20,86,50,40,6,48,-96,45,-19,10,90,13,-11,-91,-32,11,-46,6,-58,-15,57, 
  /* [300][0][][] */ 38,-15,-4,43,36,-43,-4,2,43,11,3,-3,-9,-4,-52,-25,10,-36,0,-42,-82,41,-30,-14,-7,3,-18,-52,116,-83,-35,-9,3,-3,23,-36,-127,22,-46,17,4,-46,35,21,-67,-32,-12,-13,11,-86,-57,22,22,16,67,-22,-59,16,-52,-24,22,22,46,-13,1,46,-29,-2,44,38,23,-19,-79,14,1,-28,-35,48,-36,-29,8,-6,29,-13,-29,-15,36,69,-22,19,26,-9,61,12,-4,23,-39,-49,27,-51,12,-40,9,0,9,44,22,-26,84,-106,21,-77, 
  /* [301][0][][] */ 11,-67,-19,-29,8,-14,52,13,32,-84,-6,23,50,-13,94,-38,10,-13,27,-50,57,-46,20,-7,-66,34,7,78,-12,-17,-44,-59,-127,28,65,-35,71,62,23,-78,33,45,-69,-32,11,17,23,-9,-4,-11,-19,46,32,30,-26,56,-37,-17,51,76,-6,-27,-58,64,-9,-18,95,9,62,-6,26,-16,-55,25,51,-46,50,-8,33,40,25,12,-9,-2,12,23,37,-67,-57,-19,16,-32,-71,-41,-54,-10,27,15,21,18,-31,30,-20,50,-30,35,12,2,-37,40,26,15, 
  /* [302][0][][] */ -54,-82,14,7,-23,49,78,36,-19,3,-69,42,26,-44,-34,6,38,59,29,51,-33,-20,-7,-9,-19,-47,-23,19,-12,-73,28,78,10,68,-16,-6,87,-46,-27,63,-95,4,-11,-13,-2,-44,-17,22,64,35,2,79,-3,-42,-28,19,38,35,-9,-32,43,62,-47,-38,-17,-108,-25,-14,-18,-47,-45,49,-45,46,13,-127,-51,46,50,61,50,-13,33,-25,-5,-11,3,-64,72,-26,-31,-35,-48,23,47,4,15,-47,15,18,-53,-6,-38,-4,67,-103,-30,-56,38,21,-73,42, 
  /* [303][0][][] */ 21,-15,-1,-58,0,-44,50,54,-6,69,88,-25,-35,50,64,32,-49,-41,20,63,-25,-58,-4,83,25,93,48,-62,-27,38,22,77,-28,-7,-78,-51,-45,54,72,25,17,-7,18,71,-43,60,-13,23,76,-84,-48,38,20,35,-3,-37,32,-7,5,-47,110,85,-55,22,-35,-62,1,9,-21,1,3,-89,14,-13,-12,-83,-14,-55,4,-49,-19,38,-11,31,-83,-31,-66,-12,-29,49,-46,-127,-37,71,32,-5,-62,-42,-41,27,71,66,24,-1,14,-40,2,-30,-35,63,37,18, 
  /* [304][0][][] */ 25,-13,48,-50,-12,-21,40,10,32,-20,127,17,-39,33,1,14,-3,31,-33,5,27,2,10,-25,-22,-27,-4,18,-27,-62,-23,4,20,-43,-12,-23,-26,-28,5,6,7,51,-53,10,-42,0,4,-46,13,47,105,-21,28,44,11,3,-21,65,1,-55,89,-14,-98,3,-42,16,-10,4,-10,1,8,-41,60,-52,24,4,-53,26,-34,-3,93,80,-38,62,16,-69,11,43,35,-3,48,-26,6,-21,73,-50,-5,45,-10,80,-13,-16,-6,-69,15,50,-31,-29,15,-40,0,62, 
  /* [305][0][][] */ -14,17,-48,39,13,82,26,30,-51,46,-62,-87,96,28,-67,-45,55,-90,-37,39,-59,-37,-74,-3,2,43,97,47,-12,-8,-71,-30,-54,-22,0,-54,-20,-10,42,11,69,-4,9,35,-82,-78,15,6,-47,68,-20,-61,44,-48,-9,23,-36,11,52,18,-53,-25,83,-65,-76,-127,103,118,-21,4,42,-86,11,9,24,-28,-66,42,11,35,20,29,12,-30,36,51,67,37,-58,-107,39,-13,21,10,-25,14,39,8,-13,64,32,44,53,-27,59,-17,15,58,33,59,-12,30, 
  /* [306][0][][] */ -23,5,-41,-83,-38,3,-7,15,-7,-64,-57,-43,-8,-34,-22,-50,-43,-37,-70,-58,57,-3,-12,10,-57,18,64,-47,-6,-69,-4,-2,-16,-54,-66,50,-51,60,36,-49,-28,-19,-109,77,36,-2,-31,16,-127,-48,-71,9,9,38,-8,28,-67,85,-35,-10,-6,38,-14,61,-1,23,-9,-80,-52,33,-78,25,38,41,18,6,-45,12,9,-25,23,-56,-52,-67,-76,21,33,14,-10,-11,-59,28,8,71,-36,45,48,11,12,-71,68,15,-36,64,-80,7,-38,87,-42,49,-16,-31, 
  /* [307][0][][] */ 18,-25,-67,13,-54,-1,-10,-11,-24,23,-20,-47,-28,-26,-53,68,12,-15,-32,15,-32,20,-25,-10,0,-55,25,8,-14,-20,4,-28,27,8,2,-16,-26,11,37,-23,-8,-26,-29,24,46,-23,1,45,15,-4,-21,-67,-50,24,13,127,-26,-7,-22,69,-75,6,-29,-61,16,26,-42,-35,11,11,30,-52,12,10,-16,66,-10,-21,-33,17,29,-39,33,-26,-39,20,16,-30,-25,-28,50,-21,24,-31,-24,34,-6,6,-47,-49,-20,-57,-61,14,33,25,10,-15,-4,-1,-34,-44, 
  /* [308][0][][] */ 28,-108,-17,-34,4,30,44,9,68,36,-9,-30,80,57,37,48,-59,67,15,56,78,15,27,-10,47,-12,32,-2,-32,0,-19,35,-56,-20,53,-25,-90,37,4,7,43,31,59,127,65,19,24,14,-14,-31,-40,53,-21,-59,-82,-96,22,14,26,50,-37,44,3,-37,5,-81,54,-44,-4,46,-55,-65,17,26,-15,-13,-1,-28,34,82,-34,77,-47,83,9,-73,-32,10,30,62,-40,63,62,23,5,-44,45,-92,44,-16,-40,18,15,-17,-34,-43,43,65,-26,-19,-90,-127, 
  /* [309][0][][] */ 70,-57,-1,51,14,-8,58,41,48,17,-64,22,-67,-76,-43,-42,-9,18,65,-41,-70,-17,-37,-1,-45,75,-5,-33,8,34,110,-8,-2,8,62,61,127,-38,-34,-8,-15,55,20,16,-17,32,19,28,58,-38,-28,-21,-10,39,-65,1,-32,-38,-52,-36,54,26,-23,-22,14,3,-37,6,59,-36,10,-36,24,51,13,-40,-27,-32,39,-79,75,3,-3,-30,4,33,21,-28,-1,-20,-6,33,-42,33,6,-31,17,-110,-60,28,22,45,26,-42,-35,35,-58,4,-9,-28,22,98, 
  /* [310][0][][] */ -50,-37,-38,16,27,48,24,40,43,-59,-17,5,2,-20,-12,-8,-4,-18,-43,-83,11,96,-48,1,69,-2,-7,-57,-45,-49,19,-10,11,-52,-2,-38,-19,71,33,-67,-1,20,-127,-11,37,4,71,-3,44,-29,-17,112,52,9,7,69,27,9,-11,37,-40,11,9,-54,-30,-41,55,82,-15,-55,-8,-22,-32,30,116,-26,-71,10,110,44,67,21,-34,24,-38,20,-22,35,11,-27,-12,38,-58,-28,-60,-79,50,42,72,-2,-24,-47,63,4,9,15,-98,-70,33,-5,-5,11, 
  /* [311][0][][] */ 22,3,74,77,29,-38,-29,23,57,45,-22,-12,-14,-18,14,-18,-25,39,-64,96,3,58,-52,45,-44,-19,-25,-51,32,-40,-9,-89,-23,-33,-6,66,56,52,-49,-5,-12,34,-22,-92,76,-25,19,-91,-58,-19,26,38,119,36,18,-56,-15,39,2,-48,56,2,58,-56,30,47,79,30,15,-25,19,-57,-38,24,40,-5,-27,11,88,-47,36,25,-40,3,64,-32,-67,-30,32,49,6,12,-37,1,69,9,-127,86,33,-1,-32,-61,11,-36,-32,-18,-18,-83,7,-30,88,21, 
  /* [312][0][][] */ 16,91,-90,-86,17,6,42,17,-50,53,-69,-35,20,-31,-5,22,-42,-3,-62,33,94,27,123,-51,21,49,-57,21,-29,39,31,-35,-59,21,38,27,-101,-9,12,-52,7,9,-83,-33,-10,2,-24,42,2,-64,-50,24,49,5,26,-48,14,-74,-127,-23,-43,-48,-13,39,61,-50,50,-4,-21,10,-98,53,53,-61,-28,-62,95,18,-37,-53,-20,1,-93,4,-30,-65,-19,-2,-31,54,-12,-9,-91,97,-55,46,-31,12,-4,-56,-43,8,13,-58,-9,-126,72,-78,-36,82,-24,26, 
  /* [313][0][][] */ -6,-51,-63,27,3,-9,2,-36,-16,-16,53,24,64,-64,14,10,-38,-5,7,-74,48,86,-21,-57,-80,55,25,-11,63,4,-12,85,43,44,16,68,39,-18,-65,3,12,-25,-25,43,31,-18,38,14,-18,47,-1,41,-54,0,41,72,-22,-22,31,29,-36,17,19,60,-10,-27,-16,-69,-109,-99,-14,12,-11,12,37,-59,48,-36,39,-66,64,-16,-35,-16,-53,23,3,-48,56,8,26,-8,-64,45,-38,-55,-11,26,0,-83,-37,127,14,1,-49,31,70,4,-96,-7,-11,9, 
  /* [314][0][][] */ -3,37,14,14,45,19,-43,-30,-14,74,-24,-5,12,-45,9,20,4,-13,-35,-38,-34,-8,-62,31,19,33,8,35,8,-75,30,-22,-36,-41,27,52,-8,12,35,16,-22,-3,-70,11,-25,41,100,107,-69,-2,30,-57,-33,21,-30,11,33,-37,-30,29,-20,-25,-31,8,-37,24,-33,27,90,5,22,66,-19,-22,-61,-35,39,-62,21,-2,15,9,2,-34,-46,-127,-4,-55,0,20,0,-28,-110,-54,5,-52,8,18,-24,15,-56,43,68,20,-27,7,-1,-25,-13,-16,37,-62, 
  /* [315][0][][] */ 38,-125,35,96,-26,5,44,36,-121,32,1,43,1,-34,-60,35,64,81,25,-29,20,45,-30,100,76,13,9,10,-11,-127,-11,-11,-48,0,-21,116,-4,14,-39,10,103,-84,-36,86,23,-93,6,51,-74,-11,-20,-69,52,-79,-8,69,60,-18,24,-16,-18,19,59,72,16,-77,-4,-55,-80,89,46,26,15,-47,-5,-12,18,-44,55,26,55,20,-7,-29,-57,75,-17,10,-65,27,23,33,-9,-72,-9,23,31,0,75,-63,21,-62,-27,-81,6,-13,-4,103,-28,-41,-37,17, 
  /* [316][0][][] */ 31,-25,6,41,-26,-32,60,-4,-11,2,-46,2,117,-75,-24,-5,-38,-12,-55,-75,7,4,-88,0,-85,-111,-36,0,27,-93,-60,-21,41,27,-66,0,-47,74,5,6,58,-53,22,55,1,-3,38,-30,56,-14,8,-6,-30,-37,68,-48,57,-69,-121,45,55,23,81,-51,-86,-30,8,-28,67,5,-32,-54,-124,36,-26,26,-5,-16,-61,24,11,-56,-57,52,-24,-40,23,-17,-118,-8,76,-94,15,-24,127,99,41,-47,-11,-57,-14,3,23,56,-9,-46,26,-41,1,43,-124,-47, 
  /* [317][0][][] */ -43,-57,-42,31,-19,-79,-23,-5,-5,-29,51,-72,-47,34,-17,21,-28,-10,57,-62,23,-36,-20,12,-11,-106,-28,-12,40,-30,17,-36,46,-29,10,-25,-22,43,-78,-7,-27,-20,66,-55,26,63,-5,-71,72,67,69,12,-9,-34,11,-17,16,8,24,-48,-117,-2,20,-19,35,68,-115,48,80,-41,67,-16,39,-22,-124,26,20,4,8,-71,-31,22,8,34,15,-38,-43,19,-23,6,-65,1,51,-74,-12,-92,-20,82,19,-29,-61,28,-28,127,25,18,63,8,-10,31,-45,13, 
  /* [318][0][][] */ 31,-24,5,11,38,-9,79,-48,-45,-95,41,-94,-14,14,79,-35,-64,-41,53,-33,-50,49,-103,72,31,31,33,13,-27,44,-60,19,-101,51,26,98,15,18,24,-47,49,19,36,25,14,-32,45,-89,40,6,-4,-97,32,65,-78,0,-31,76,-11,-85,11,78,63,-65,-106,-45,-13,43,-26,0,-9,-80,9,50,-12,-38,-34,118,113,80,13,8,-13,6,-15,49,45,3,66,60,-9,8,-18,-68,70,-103,82,48,-31,-70,-56,47,-11,58,45,32,-36,50,4,40,-127,-16, 
  /* [319][0][][] */ -28,-55,75,-34,21,87,25,-32,-12,-6,-38,-114,18,-54,-30,28,1,38,-61,-31,63,30,13,-30,51,20,-90,-2,-30,-49,29,0,-5,-79,81,-30,-53,-18,-17,14,1,14,-13,13,-64,94,48,26,90,4,-105,-32,98,-10,-21,41,-38,20,-56,-125,14,2,-42,-63,44,76,3,27,48,118,15,-48,38,-70,13,-54,79,-6,31,33,-11,2,32,-10,-68,85,-30,127,-2,12,-25,64,-38,37,-6,17,26,57,39,-14,-34,84,88,30,54,-86,-114,-9,117,-2,-25,-63, 
  /* [320][0][][] */ 72,62,15,11,40,10,23,4,9,-46,-5,-7,77,-87,4,-10,65,-40,-2,21,34,28,18,16,16,-48,63,47,-30,-16,-30,49,22,28,7,62,-34,-18,26,76,24,-2,-51,17,82,-116,27,18,12,-64,-67,-7,-31,7,-26,36,46,-53,-9,-30,-43,59,-16,-58,29,-59,12,-53,-30,-43,-43,-24,-28,18,23,-5,-25,-11,-46,8,41,-3,14,25,-90,-91,-92,-16,-29,17,-120,14,0,-1,-48,-13,-6,-14,-19,3,-33,-29,13,-52,-127,-14,-60,21,113,-2,-29,31, 
  /* [321][0][][] */ 6,-17,-40,-23,-80,-71,78,-61,21,38,10,-5,-9,-23,-3,-63,-74,-69,-17,-25,-53,-93,-127,-18,20,66,-2,-48,-45,-5,2,-15,-5,12,-25,-103,27,-44,-29,-30,26,-7,-30,77,16,-13,-22,24,-75,21,24,48,-50,-18,-7,70,-29,-32,-72,-64,34,22,-58,51,1,-63,-12,47,-48,4,-75,35,-42,3,66,35,39,-11,14,-49,20,-21,-13,-3,0,-18,61,40,22,39,94,49,-38,-7,7,-52,12,49,23,41,-35,-26,-58,8,60,22,-15,-3,42,-43,-33,73, 
  /* [322][0][][] */ -42,52,67,43,98,-61,-51,23,-50,43,-56,0,-63,-16,-12,-68,49,-65,-25,38,-7,-31,46,-95,-39,-20,62,32,-47,-1,13,-15,-86,10,-9,15,-4,-23,95,-37,22,-76,-48,-59,-4,61,90,124,-13,-85,-62,44,-42,-120,-55,-10,-96,39,41,-16,-105,44,84,-1,67,92,-3,30,6,73,-23,-1,19,-12,-31,-26,35,37,-42,127,40,-32,-1,10,3,-3,-25,-80,58,12,-54,-4,15,-34,-44,-34,-63,20,33,-90,77,33,60,39,-32,60,29,41,57,31,7,12, 
  /* [323][0][][] */ -33,99,25,-13,-80,53,-23,-12,-52,47,-71,2,45,72,3,7,-48,-50,50,-95,32,60,77,42,-1,10,5,42,50,-34,-60,-77,-35,-24,6,7,38,35,-26,22,82,9,-44,42,-26,16,26,9,2,-26,-60,4,17,-21,70,14,2,-29,-12,-49,47,23,-11,58,26,19,10,-25,-27,-10,23,-71,1,10,31,-4,86,108,-46,25,41,-12,-43,55,8,21,61,16,72,-16,-14,-70,32,44,59,45,-127,63,-29,-32,7,-17,61,0,71,7,59,5,6,34,8,-4, 
  /* [324][0][][] */ -22,-40,50,63,-30,-1,39,-55,92,-1,68,-55,-5,10,67,-30,26,-109,87,-6,15,-41,23,22,-52,-34,-127,-78,-59,-41,-42,46,15,-3,-17,-68,34,-29,36,56,-68,38,-2,-41,-68,-3,10,-19,23,-85,-10,15,-18,-86,-97,27,-22,7,11,-51,-41,12,-52,-1,-18,34,-6,6,34,9,-14,-1,-19,-107,-80,35,-27,-73,30,0,13,-25,-65,33,-16,3,1,-48,-37,47,-97,45,17,39,68,-31,2,-89,-17,-79,-24,-4,20,-3,-24,17,-17,50,78,-70,-51,-9, 
  /* [325][0][][] */ -74,-51,-30,46,-86,-97,44,24,46,-12,53,-87,26,44,-50,69,-13,-59,4,10,5,-37,-72,37,-2,-87,34,12,-65,-41,14,70,-31,34,29,34,22,15,-18,15,23,-53,-17,37,-9,-14,25,10,14,-1,40,25,-28,19,97,6,-127,85,-25,-73,4,48,8,7,-22,-40,44,-70,-23,79,18,24,-65,26,-10,-15,-14,-4,2,71,99,-124,1,29,14,43,57,-4,-26,36,-1,22,-18,18,32,73,-13,32,19,-59,-52,2,-37,74,19,-48,23,55,66,-15,-58,-9, 
  /* [326][0][][] */ -29,-91,-12,5,-88,38,48,-48,-1,-16,24,88,19,22,57,-29,127,-19,0,-25,-27,-64,-1,29,24,-7,20,-24,26,-20,0,34,5,-3,69,-27,-3,20,-3,78,-71,-32,-28,34,55,-32,72,-36,-34,5,28,-9,59,-91,-41,-65,-18,-51,-30,0,60,-25,1,-8,32,-23,-68,54,-22,-26,-35,32,30,48,-31,23,39,-60,-21,101,31,7,118,70,51,38,29,-44,-36,-30,25,-29,58,-27,14,48,65,-25,-58,3,-79,39,29,1,-14,-7,98,8,-64,51,-3,-64, 
  /* [327][0][][] */ 2,-92,-79,-11,-15,-63,37,-33,62,14,-65,-38,73,-30,72,-45,-3,-35,86,46,-109,-36,-5,-31,6,3,-8,58,18,51,51,22,-59,50,117,-9,-21,-13,-88,82,15,102,32,34,-37,35,37,-8,-81,58,68,39,-11,-81,-31,21,-85,-35,-38,-5,-29,-36,-127,-14,-51,-7,-55,-28,55,35,18,-18,-14,11,-7,65,-12,-11,-8,-27,54,-2,64,26,21,50,12,-49,40,56,3,-67,7,7,76,28,-27,32,10,9,7,32,99,22,19,67,64,41,17,38,12,33, 
  /* [328][0][][] */ -4,-39,6,-1,-3,10,-22,33,12,7,-1,-67,-19,-1,-5,-1,-4,-31,25,-24,-16,17,-17,23,-18,25,34,17,18,1,-17,9,57,-58,-26,-19,-35,24,16,-36,-38,-27,24,16,70,-43,44,6,37,34,-63,-12,48,127,-19,-12,-17,-8,-4,61,27,-36,36,24,-40,16,19,-2,18,22,-13,-85,-23,-54,13,4,6,7,1,-59,22,5,68,-96,30,-15,55,-10,40,14,80,-44,41,15,-19,21,5,-30,53,-15,29,82,-2,-5,-5,-16,39,17,20,-30,1,-40, 
  /* [329][0][][] */ 19,31,69,-69,5,20,14,-29,35,-15,105,-20,-117,-10,-15,-32,-50,69,-36,-21,16,-29,10,0,14,-54,-35,38,47,-12,24,-82,-57,21,-24,-14,-37,-70,11,28,-15,-55,48,-5,-35,88,-32,-76,-7,37,-35,-13,-72,-7,13,-18,-17,-40,-3,60,-9,13,12,-38,27,20,-31,1,-44,60,18,23,91,2,29,-11,15,-19,4,-127,-42,37,-45,-98,53,37,70,15,-18,15,-10,79,-42,56,25,-39,-40,66,16,12,40,57,-20,-18,-36,67,4,-14,7,-15,-12,38, 
  /* [330][0][][] */ 0,-49,93,113,-7,-8,-75,67,50,-26,-97,-76,46,95,-11,-5,42,-23,-63,-30,-9,-106,24,45,-22,-8,-48,-20,9,14,-5,-24,-97,82,4,88,6,-40,59,-20,24,-2,-82,12,1,22,11,59,-118,0,-28,106,74,28,56,-32,-58,35,-23,16,79,-30,-17,-95,43,9,-14,19,103,95,42,40,60,46,57,81,-75,-41,-7,90,0,-94,40,-78,-11,-117,-53,-68,23,89,-46,-42,42,-45,-7,-39,-4,-8,-84,74,-49,26,-47,-33,48,-46,2,-8,-9,-87,36,-127, 
  /* [331][0][][] */ 16,38,-32,1,-51,11,-15,98,78,-48,-66,42,15,39,-32,-12,11,-22,5,-62,29,-13,30,-7,1,42,82,-2,3,24,-51,19,12,-10,46,-59,23,127,68,-67,-63,24,47,73,-49,14,-15,31,41,-71,17,-46,47,52,-36,-95,-9,-10,48,25,-34,50,24,4,-3,-34,53,-30,-31,-25,-75,51,-33,-24,54,-13,46,40,12,-6,-30,71,-48,5,-41,-16,-53,-114,-8,-11,9,52,-58,65,39,11,-51,11,-9,91,23,-31,-11,5,19,-75,-86,-44,-4,-3,38,21, 
  /* [332][0][][] */ -4,-15,-13,-17,9,-64,-11,14,1,-19,76,-56,-8,12,20,-37,40,-73,-51,-48,28,29,71,-91,-119,75,3,-110,16,32,-43,21,-80,-18,-1,-32,10,85,111,20,-91,20,91,9,-22,19,60,-31,71,-22,11,-40,-4,-47,2,15,-78,-26,-46,-50,6,69,-27,-53,23,19,2,-9,-12,6,-22,36,-10,67,-30,88,10,61,26,-22,17,13,7,-57,69,-58,-54,10,32,-18,-111,15,-34,29,-34,-46,89,-38,-3,13,-14,18,-44,-127,-28,-25,84,13,39,-45,10,-15, 
  /* [333][0][][] */ -23,-42,21,25,11,-6,-52,-18,120,5,39,3,-20,-52,42,11,2,45,-4,26,-17,-17,0,29,23,65,-30,42,2,-53,5,78,37,56,-3,-71,-14,-5,14,-1,4,-58,-22,22,23,19,-39,-14,-39,14,-15,20,-9,-34,69,-9,-65,-28,127,4,-2,-31,37,-66,8,-53,-16,48,63,-47,22,24,-16,11,-29,-17,-37,-14,-26,-21,-34,28,21,40,-16,-7,15,54,45,-20,-11,-43,40,-50,-39,-24,-25,48,-34,-53,38,58,2,116,-34,50,-8,-39,39,-41,-25,13, 
  /* [334][0][][] */ 80,-3,-97,-94,-34,-36,60,72,20,-127,44,101,5,38,-44,-19,26,14,5,-16,100,-30,55,-19,55,25,32,13,-1,55,-13,36,34,6,9,-11,10,27,-44,-38,-12,-26,-46,63,20,68,27,-30,7,15,-48,62,12,-58,-3,-42,23,31,2,-45,77,11,-101,-24,14,-45,27,-50,-41,66,-45,17,-11,29,-36,-29,-15,26,-1,4,-20,12,-30,87,-43,-60,43,18,-11,-63,9,32,-15,-42,24,-73,-2,-54,15,-6,-31,109,-79,-5,50,29,-24,-6,-4,17,-97,10, 
  /* [335][0][][] */ 23,-50,8,4,54,76,58,-73,16,-69,3,41,30,55,-17,-44,33,-35,-29,-124,40,-60,-13,21,26,79,-6,17,30,-8,19,-67,-102,37,-28,23,-52,81,-11,20,44,70,19,-18,55,69,-11,42,53,-83,33,101,-41,-22,43,-3,28,-29,49,4,79,-29,-43,72,-42,-55,-63,-24,13,-21,108,12,-12,1,41,30,-11,42,35,-82,-2,19,-33,35,-52,-43,-25,58,100,95,38,-127,-32,21,23,-25,29,-40,18,2,-1,17,-78,15,20,64,41,38,16,-36,-58,-12, 
  /* [336][0][][] */ 34,-11,-38,61,48,-67,-52,-55,31,-25,-10,-34,20,-17,-78,1,53,-3,28,-4,14,-33,33,1,17,-39,-125,-23,109,-26,-42,-12,-64,0,49,51,39,32,-58,56,-26,20,19,-40,-45,-36,11,6,-11,-24,-11,-60,0,8,16,-62,-38,19,63,-59,3,25,-22,19,29,21,26,-31,36,-20,50,-64,74,-75,-10,22,-33,55,48,13,25,-1,6,39,-67,-13,24,-32,46,30,-117,127,99,-63,-59,-66,-37,-29,-41,2,69,-111,119,-8,30,-46,-114,108,-25,3,-36,76, 
  /* [337][0][][] */ -13,-13,41,-15,-90,-36,-12,-23,19,72,-55,6,27,15,10,17,38,1,-28,24,-5,-24,-61,127,27,-10,22,22,-31,-18,-78,35,-75,7,16,-16,8,-6,0,-1,-54,-28,-65,46,-40,26,-10,61,-9,24,-33,36,8,70,-62,-37,24,87,-1,-53,29,96,12,-21,-16,-39,46,-3,-29,36,-22,21,-79,-71,-21,68,61,28,-43,-13,-32,56,-51,-38,12,67,-3,13,15,-17,-19,-52,75,32,24,21,127,29,-65,19,10,29,-23,8,-27,-40,-18,25,-76,-45,-6,112, 
  /* [338][0][][] */ -11,108,45,-17,-7,-61,30,42,-69,-35,-65,26,72,58,-16,-50,5,-42,-46,42,65,-44,-28,43,35,44,127,15,-1,23,-61,-95,-15,6,-57,39,-81,36,39,-7,0,0,-48,9,4,39,83,-50,30,11,-26,62,-54,39,-40,18,80,-44,-74,-42,52,-39,30,54,-25,-28,-79,-59,-42,6,15,-10,48,1,-59,-6,-30,37,65,-2,7,14,-4,-14,-43,28,30,20,-26,41,-19,-66,-16,20,1,-51,1,4,21,-118,-31,117,48,17,53,27,-7,-2,103,84,-68,52, 
  /* [339][0][][] */ -31,74,-15,5,8,-38,-11,-48,-22,-24,16,36,-27,-4,-4,64,28,-75,13,18,5,-44,11,-17,-21,-2,50,-33,63,-65,-41,44,-16,-45,27,-15,29,8,29,72,53,-9,16,49,82,-52,-2,40,-8,-3,-47,73,29,-39,-11,74,22,10,86,44,33,12,-12,9,57,-55,-21,-5,-16,-16,-6,51,-50,1,79,-30,14,68,-58,90,-11,52,-5,2,72,21,-82,28,10,-11,63,65,-57,56,51,127,22,47,15,-70,19,11,5,-37,55,28,50,-31,6,33,-17,-24, 
  /* [340][0][][] */ -61,127,-25,-23,-10,-35,18,-14,42,8,-40,28,99,-30,-93,55,4,-76,-100,82,3,31,-26,-32,1,-79,101,-88,-94,-23,62,-34,-75,-11,-42,-95,11,32,45,-36,13,-78,41,-20,-58,43,80,48,-17,-18,110,-15,-10,62,46,-7,6,60,77,7,26,5,61,18,-106,-41,115,-37,109,41,-14,-33,-57,-33,-39,-21,36,2,-11,32,61,2,6,-71,125,45,57,18,-22,-49,-56,25,42,-3,-1,67,88,-8,11,81,111,26,-17,-16,30,-15,-27,66,29,-94,-30,5, 
  /* [341][0][][] */ 63,34,88,38,8,-99,3,21,-59,-15,70,13,-3,15,48,-56,-22,74,9,-21,76,-15,-51,3,-83,-35,43,-21,-20,-8,13,-19,-30,-32,18,-15,3,-21,-28,16,77,-20,19,-6,-35,-61,-77,-13,-44,-55,32,-72,-40,-22,14,-64,21,0,1,-40,69,-39,7,-65,59,43,-51,-1,35,29,48,-23,-76,-57,35,15,64,-113,-19,-82,43,-27,-36,-68,-106,-26,19,100,-39,-81,-14,63,-29,-96,7,84,-38,-105,-89,26,50,-60,-30,19,24,-3,15,35,127,-6,27,88, 
  /* [342][0][][] */ -47,-42,93,-69,-36,56,-64,-7,18,-73,-16,-32,-9,-28,79,80,-33,-43,-3,-57,49,-39,8,30,12,-48,46,-9,-34,-48,17,11,35,-20,13,-1,-41,-79,31,10,-14,44,-59,-1,-39,18,67,15,5,21,-48,25,-19,-93,-2,17,91,-21,88,-43,127,35,8,18,-66,-78,99,30,-21,-35,-112,8,25,-34,38,-27,43,38,-52,32,-10,-86,-83,-61,-73,-10,76,-17,17,28,-17,-62,13,60,-35,34,16,42,28,99,50,42,-46,64,92,-5,-64,-57,5,0,15,20, 
  /* [343][0][][] */ -8,9,96,26,76,-65,1,120,-1,2,-2,1,42,-2,-57,-3,11,-17,47,83,127,-64,4,12,-41,-43,50,-30,60,13,-96,-90,-87,-24,5,-122,-3,127,-49,-34,-33,-54,113,0,-6,4,2,8,15,-90,73,-7,-40,74,-32,-43,45,-18,-83,80,19,13,-65,19,-14,79,-109,-20,-91,-35,-72,25,99,84,39,-15,51,-17,110,-18,48,-58,-15,-26,51,-7,-70,-35,46,-34,45,-44,-80,119,-45,57,44,-65,-32,63,-1,-115,81,-12,-57,-30,19,8,26,62,23,47, 
  /* [344][0][][] */ 13,-75,-50,-70,-6,73,-17,29,-85,40,1,-60,-28,36,16,-59,-37,-59,-11,-57,34,-83,-43,-92,86,-34,7,29,34,-15,-15,48,-77,-8,54,69,-6,-10,16,-33,-22,31,-51,89,25,58,127,45,-104,0,-6,-21,24,39,-77,49,6,34,-36,-65,-42,17,-82,-39,-11,-26,-71,4,-58,39,-59,-15,41,16,31,1,64,26,-1,-15,59,16,15,47,-18,-79,-32,-86,48,-63,-7,-95,27,-51,66,-87,-33,-15,-97,-101,-22,2,122,-102,-41,-69,-23,1,-15,1,-7,-60, 
  /* [345][0][][] */ 22,73,-20,-37,48,-57,121,26,-38,9,-74,-32,43,-44,-117,24,14,-33,62,6,4,20,113,-57,-103,-60,-16,56,24,53,-72,21,52,15,126,51,19,-15,-49,-16,69,-92,26,46,-42,72,-94,-44,-39,74,62,55,15,-9,39,-53,36,-52,48,47,-21,98,-61,-42,-44,18,-50,-7,1,60,-30,127,32,44,-64,-70,-86,-45,-80,10,21,40,41,-40,7,3,-5,42,19,-67,29,43,24,95,-5,19,-64,-57,-66,-21,17,27,-8,38,41,41,84,34,24,-21,40,72, 
  /* [346][0][][] */ 10,20,-7,-25,-52,40,-12,53,35,-2,46,49,-24,-27,92,-30,5,-88,-9,-13,39,57,-45,-6,23,42,91,40,-57,-2,54,26,-48,-50,-69,22,24,38,47,-35,30,-57,-35,-31,-51,-12,23,36,-56,-90,-106,79,8,-17,22,-50,-13,-27,12,108,16,33,-43,12,57,5,-14,-74,-44,-16,-22,-4,12,60,86,24,-20,-64,-109,127,-40,88,-11,56,78,-6,86,23,-9,28,94,-118,30,36,37,84,30,-60,33,38,-3,-74,-23,25,43,-27,-15,-4,109,-27,-33,17, 
  /* [347][0][][] */ 39,-113,-29,40,81,37,87,-53,57,-116,-22,4,24,10,4,-103,-14,-26,-50,71,23,26,-28,-45,-7,81,-20,15,-41,-18,-26,-22,-26,-33,76,33,-88,42,-6,-46,-39,-77,25,-4,21,5,26,32,-17,-71,-74,-44,39,19,-10,67,-14,-69,61,-5,64,-35,8,-64,0,42,19,-6,23,-46,-12,-25,-69,-84,-38,0,19,-22,-35,42,76,34,-34,45,-34,57,9,-12,-49,-12,-61,-53,63,-9,-7,1,26,-13,79,39,-40,-54,-17,28,-127,-34,13,-75,-55,-4,-10,-17, 
  /* [348][0][][] */ 9,-39,46,61,-14,41,25,-13,-27,-9,-39,28,40,22,-5,-10,47,-1,-2,124,40,99,-11,42,-43,-3,-85,40,-7,40,-74,102,0,13,35,-11,7,-12,-5,4,127,-26,-13,92,-75,-72,78,-36,-48,-55,-17,23,5,-2,-34,-13,-38,28,1,-9,60,-26,-30,-13,-14,2,74,32,98,-72,51,-40,-66,27,-1,58,67,35,-37,-4,42,68,67,14,-20,-122,11,91,-29,-35,57,37,7,-50,13,27,111,-35,-2,-43,-20,1,-24,20,-8,3,78,-8,73,16,-52,-99, 
  /* [349][0][][] */ 2,44,9,29,-17,-56,75,31,35,13,8,-127,54,44,-77,-45,-23,-24,-30,26,-25,-66,20,-51,-20,28,-58,10,2,8,-24,-85,41,-3,-22,-30,-6,11,-5,-15,-34,-12,32,-21,92,-17,22,-20,28,-14,-59,53,-42,19,-20,31,-84,-2,6,12,-29,63,-23,15,31,55,19,-19,36,23,-10,-17,-5,0,-50,-35,-3,0,-97,15,49,-52,3,19,-54,-66,-4,73,48,-22,23,67,-17,-56,18,-59,-1,-18,-39,21,-42,-15,61,21,-25,91,61,34,-19,20,20,-27, 
  /* [350][0][][] */ 10,53,27,34,-127,-41,97,-5,-29,33,29,-37,5,-75,83,21,-37,-58,10,-10,-23,-19,-28,-56,49,45,3,-15,73,30,-54,-85,8,17,-54,6,-64,51,5,-29,9,2,7,15,-49,21,22,-12,1,-49,16,0,102,-43,-10,-53,12,70,-47,-6,2,48,108,34,-57,-4,3,117,64,46,-33,-6,-65,-38,-28,-73,29,-40,51,8,35,-2,-67,40,42,51,39,-38,-20,19,-66,40,-9,-8,23,39,-57,-39,28,-18,33,-24,-11,-33,-51,-37,38,3,23,9,65,56, 
  /* [351][0][][] */ 47,45,-24,-14,-48,-4,-26,19,7,-11,40,79,58,-9,42,79,5,6,68,-53,-31,-47,-44,-27,2,24,-65,-126,19,-60,5,77,-62,-9,-33,-40,77,54,-64,-45,-3,1,36,-56,-50,22,123,35,25,44,44,-43,-31,-20,-42,44,-45,-8,60,-19,68,42,28,8,5,-26,14,89,7,-28,28,30,38,103,-17,-95,20,35,13,39,-4,-39,64,12,-14,10,-127,-67,-35,8,-10,-28,66,-57,29,22,43,37,-34,-34,-33,-68,-93,77,70,-37,-14,0,3,107,28,-32, 
  /* [352][0][][] */ 84,-127,50,-47,-44,8,14,-49,25,30,-70,48,34,51,-5,-84,48,-10,-48,24,-93,-5,1,3,67,-17,-32,1,77,-5,8,9,-48,-12,-13,-29,-2,39,-47,40,12,23,-3,62,0,54,22,1,6,67,-11,-9,-21,-28,8,27,-36,-2,74,-16,15,-94,-4,71,-19,9,35,-3,-56,-7,109,22,12,63,-58,-9,78,-20,63,45,9,-54,102,11,-59,52,-43,-25,0,6,35,34,70,-47,15,-107,-27,27,54,-80,-77,34,-9,2,27,-1,-4,32,1,31,-23,31, 
  /* [353][0][][] */ 29,24,16,-19,-22,-29,-3,29,11,26,-74,25,1,-72,-38,5,1,23,-24,-18,-44,14,22,-31,78,23,43,53,-38,-9,-24,30,-69,-25,-48,-40,-9,21,-45,18,83,-9,-20,-26,20,-38,-11,-23,-29,-38,-32,-4,23,-68,-14,78,-52,-60,12,-9,-23,23,-39,42,16,-47,-3,18,70,98,9,5,61,3,63,7,14,-17,-80,32,-26,27,-89,-44,-65,-4,-46,58,-57,56,73,-43,-127,-56,17,96,27,-67,6,120,37,32,-55,44,27,71,-43,-8,-33,59,-7,56, 
  /* [354][0][][] */ -80,-33,27,108,-26,20,110,82,-95,44,29,79,-45,-18,8,8,30,-74,-62,-31,-27,-53,-13,93,48,28,-50,-17,36,39,-25,-29,68,-127,-90,66,-49,-58,-40,18,7,47,-55,34,-32,56,69,60,62,-68,-44,-20,89,7,-12,-94,-21,-13,-39,-83,124,-41,45,-8,-65,-104,1,13,-20,66,-27,-112,14,16,-84,-84,-69,24,38,-17,41,-1,113,27,-22,-19,14,22,30,55,80,-18,-56,119,-78,-52,50,-40,-4,35,-89,83,-27,-66,-18,60,-22,52,2,-79,-17,18, 
  /* [355][0][][] */ -10,-105,-9,40,-8,-22,32,79,-28,-50,36,26,21,100,22,-4,-63,-10,-35,6,-65,-63,-60,24,40,69,-12,54,57,88,-20,54,-11,-84,49,-28,0,57,-28,47,46,-27,58,21,47,-84,86,-48,-119,-60,106,52,76,63,18,-1,48,98,31,25,56,43,-72,70,-63,-85,-41,25,-34,-71,-19,50,94,-75,1,40,5,-37,-110,-45,37,-27,65,-54,-79,47,66,35,-73,-6,-33,40,-87,-25,-2,-49,-28,127,-6,59,71,38,1,-105,101,24,21,-55,-67,60,55,-7, 
  /* [356][0][][] */ 99,-87,-37,-17,-84,-62,47,-69,-52,-11,54,2,45,-114,-4,-101,-8,19,-50,31,-3,93,1,4,-51,-32,-37,60,4,-96,9,-15,-85,-41,38,-109,4,27,25,50,72,14,5,104,93,-51,-11,-23,19,14,48,-63,-38,-31,-78,-59,3,6,62,94,-106,-56,-34,-87,5,26,-111,-55,8,49,-50,-7,-77,23,-36,109,34,32,-17,-21,-95,24,-43,-127,32,76,53,18,26,29,-32,-7,-63,19,-31,36,-39,58,-46,10,-18,15,5,3,-17,8,12,-45,9,-20,-42,-53, 
  /* [357][0][][] */ 6,-52,70,-21,-25,-54,122,3,16,-47,-30,37,59,-34,58,-49,-42,-5,-12,24,56,54,-13,-9,34,39,-104,65,-36,-58,9,-87,-34,-31,-21,-15,-49,-7,2,-64,-123,3,42,-27,92,21,27,2,31,-53,-2,19,58,36,-59,-19,-94,-51,16,-69,-99,0,-51,17,110,56,-46,52,-21,-75,-40,-19,-91,23,18,52,-39,83,40,83,-25,9,2,-127,119,-121,3,26,86,-35,-37,18,-30,16,-41,-41,-14,79,-56,82,-76,-124,4,-41,78,-1,46,6,44,-50,-28,-72, 
  /* [358][0][][] */ 35,60,27,18,-30,-46,1,-17,-69,-80,49,-127,20,63,52,-9,24,21,-42,20,45,83,20,-34,-11,36,-2,-16,21,-18,-1,38,59,-21,-2,-23,44,-24,-95,40,48,5,62,-7,5,-114,47,4,-23,44,9,35,-111,35,-24,-1,-30,-63,44,5,111,35,66,17,73,-60,8,-75,32,-40,-35,-4,97,60,63,110,6,52,13,-16,49,-22,102,-3,65,73,59,19,-9,0,125,42,56,-30,25,25,31,14,122,7,2,-95,20,37,-44,-11,-106,-62,-17,-12,-7,58, 
  /* [359][0][][] */ 37,-61,32,-33,-59,16,-86,-88,-13,23,-9,126,-63,-101,-20,29,-14,-43,-20,-44,48,22,35,-24,2,-45,-9,-37,79,49,98,-18,-78,22,51,-47,5,-27,26,-13,-8,40,48,43,-34,-41,-1,15,5,-33,-58,-39,41,-2,15,-4,7,-76,-12,107,101,-21,38,87,42,48,-5,1,-3,124,91,-64,-80,19,-86,-91,-21,40,74,49,40,14,-86,-96,34,-31,-11,-11,-68,49,-21,50,2,54,47,-76,-9,-27,0,-30,-73,127,-12,-76,86,46,-47,64,60,82,-23,-100, 
  /* [360][0][][] */ 13,9,-28,54,-3,-52,-51,-46,-10,27,26,93,-86,-6,-127,24,-16,-82,-44,-27,60,-48,56,-10,-83,-90,25,-23,6,80,-21,-54,56,51,-40,-43,-16,-42,6,6,-48,-77,29,-28,-83,-6,65,-1,56,-49,87,-29,79,-48,57,34,-20,29,5,45,105,22,-89,-31,-22,21,70,41,25,19,53,3,-44,-37,23,89,-70,7,2,30,-49,124,66,-84,16,49,-62,-19,82,10,28,7,-20,8,21,44,-40,-42,-32,43,-11,6,-35,32,40,-18,-76,-12,-20,55,-7,50, 
  /* [361][0][][] */ 18,7,-6,-2,-74,-6,54,11,29,58,67,29,69,-78,9,-13,50,-20,-37,-18,55,30,21,-26,60,127,-15,70,43,-34,22,6,13,-41,34,69,-41,-4,55,35,-25,-33,0,59,-26,-40,18,-111,-7,-5,-10,-14,-4,24,42,25,-26,-19,21,-30,-32,-24,24,-28,44,-6,57,43,-14,17,14,-44,-20,68,50,64,-6,-1,-31,54,77,-11,54,-4,-21,30,45,-14,97,-48,8,-10,-14,-43,8,17,-53,48,-70,-18,-11,-32,78,45,90,-91,-13,-24,19,-13,-13,-21, 
  /* [362][0][][] */ 0,43,34,13,-59,71,-13,21,-77,-75,100,-58,87,-42,-109,31,-42,21,-43,83,27,85,-40,118,98,33,-123,-1,-14,20,-91,127,12,-22,5,20,-43,79,40,73,57,-72,15,-30,-8,-60,111,8,76,-5,46,73,-31,-37,11,-39,-39,18,36,-6,-4,7,47,-65,-81,-63,68,18,15,-38,-100,-32,-39,-40,-89,-13,99,-69,35,103,2,44,-20,-18,64,-87,-38,-2,-29,-20,-15,33,-49,-114,32,-31,48,76,107,63,23,37,20,-9,107,37,-98,60,23,41,-72,-3, 
  /* [363][0][][] */ -44,68,27,-54,-66,-83,22,-99,48,-46,-37,34,-23,-35,-36,31,-32,26,17,-25,4,-38,5,-79,31,32,-14,13,-57,-62,-86,60,91,-127,-34,12,-61,-111,31,2,69,-52,-27,-35,-12,22,71,-49,-8,-21,-12,40,54,4,16,-63,44,12,-33,24,-4,63,22,2,39,87,88,59,-39,107,18,-89,0,-69,-67,24,18,-9,17,23,-57,0,-40,36,-14,-9,30,-45,-41,-5,-94,96,20,-1,10,18,91,19,57,-59,21,-11,-16,-6,-46,27,19,41,24,22,59,-51, 
  /* [364][0][][] */ 8,8,25,36,-86,-51,-45,8,-62,28,28,-5,92,27,40,82,122,14,24,-7,-42,24,10,-44,-29,35,-42,-8,-24,-29,-48,-32,-97,-14,-58,-80,64,28,77,0,62,42,-5,-1,34,0,-14,10,-7,-53,58,24,54,45,-38,55,19,-8,-28,-43,18,-10,-41,-82,-8,70,-2,-33,-58,76,-20,-16,73,-55,55,49,34,80,-57,31,14,38,127,51,-3,59,-13,93,19,-63,-45,0,66,-19,-5,38,-12,-50,-62,-19,2,-19,-26,-4,75,-20,-11,-34,35,-32,6,57, 
  /* [365][0][][] */ -41,77,-69,-7,-21,-2,81,-14,20,-7,29,31,0,5,120,-57,-14,17,-71,22,-30,-22,-33,5,-118,-11,-14,-25,32,74,-81,53,67,-34,-15,-47,-13,35,127,-75,2,-3,-31,75,-66,107,50,-7,-1,33,51,22,15,-59,11,58,2,-87,-16,52,2,-29,58,22,29,-42,-28,-51,23,0,-6,69,-79,24,3,73,-54,94,52,-38,2,16,67,54,-67,-38,55,-38,4,10,66,-67,19,-1,51,50,50,89,-90,47,-97,14,-13,68,-90,5,-46,-32,-12,10,31,9, 
  /* [366][0][][] */ -49,-30,64,61,38,-33,-1,2,52,-34,-84,-50,-29,0,-8,44,56,-21,-25,-78,-93,-9,-30,-6,-34,-64,-5,45,-34,-8,-7,27,-12,-38,-65,-80,-8,-31,27,4,-31,-53,9,-7,-24,0,-90,48,31,-21,-40,21,20,3,-38,-19,44,71,47,0,-7,66,-11,41,-33,-26,-22,-15,-65,-4,-20,-125,-13,-41,-77,-14,20,-91,-8,-22,23,35,-28,-78,-27,33,8,34,-22,24,27,-5,22,-33,-26,-56,32,5,-8,74,-82,35,67,-21,-66,-4,-26,103,20,-33,-127,-22, 
  /* [367][0][][] */ 29,-94,-26,-21,-46,68,-9,9,86,22,2,-109,-47,-12,-102,-10,45,-97,65,38,47,-8,-44,119,-2,-98,-31,-102,-55,-15,-109,20,52,35,-30,-18,45,23,-49,72,-74,13,45,20,127,24,31,-33,4,-40,-24,46,-1,12,-31,10,-55,-48,-22,59,16,30,46,51,32,-11,34,68,49,-18,-3,57,-2,-16,-22,9,-68,-37,-55,0,12,87,-75,12,-81,37,30,16,-1,73,78,-58,-86,-28,28,97,74,-43,93,-58,23,-29,-1,41,36,-55,-8,-57,-6,-1,-77,-3, 
  /* [368][0][][] */ 38,36,54,-33,-27,47,-44,17,-59,-8,51,19,-17,12,-38,-15,-22,4,-27,13,-72,-39,-25,-42,35,1,-5,-57,5,-32,-21,4,30,40,-6,15,6,-76,12,127,-29,32,-61,13,0,14,-1,17,-4,119,-40,-41,59,-55,42,24,-17,29,80,-19,-21,55,-75,-23,23,-22,60,-6,-32,19,-21,-92,-45,18,41,-63,-29,-29,22,-85,-36,19,-68,-27,32,6,5,2,-8,-39,-26,48,8,-32,-3,19,-66,41,3,-65,8,43,-10,-40,-19,-43,-43,10,-27,-23,8,29, 
  /* [369][0][][] */ 7,43,17,-33,48,82,-79,55,-50,4,-53,69,-25,64,0,55,-27,-38,-18,-55,-13,-91,37,82,9,49,74,44,10,13,-74,56,-28,6,-44,55,-94,-30,51,24,-54,-11,-27,-26,41,17,-21,-26,64,24,-79,96,41,70,-58,4,-61,-41,30,53,38,71,31,-3,-12,-18,47,23,-63,46,27,19,-44,5,-20,-21,51,46,77,-53,52,15,-14,9,-44,-1,34,-46,12,66,52,10,54,-15,37,48,-22,114,-40,-7,-13,127,105,22,-15,6,40,-21,-7,0,1,57, 
  /* [370][0][][] */ 21,2,99,-20,-52,-2,-12,56,15,-89,-21,11,17,-4,-27,-27,122,23,1,-70,-75,-34,62,-27,-43,-59,-46,100,30,-50,0,-29,-19,61,-34,23,-67,-127,-52,21,-79,120,-8,35,5,1,-103,-17,-30,23,74,51,-36,4,-48,-45,-26,-107,-12,60,22,-5,26,21,-17,17,90,55,65,-16,-27,-57,22,-57,-9,18,-91,-48,-34,-17,82,-78,1,43,43,37,-49,-24,-72,35,22,39,-19,63,-33,17,-17,-15,40,97,55,-62,58,-32,-97,-17,28,-48,-77,-67,-98,51, 
  /* [371][0][][] */ -73,-17,-39,-4,-3,-36,69,-13,53,-24,5,79,48,85,2,3,15,23,-39,-36,-78,41,54,37,24,13,-47,-7,-4,-52,-1,-24,-7,-4,42,4,-12,-84,-26,-37,-34,-20,44,80,22,54,-6,-21,-23,10,14,99,-70,41,75,56,57,-3,-54,-102,-29,-57,7,-21,39,43,100,18,57,5,26,-30,-20,-53,66,-13,-49,-38,111,64,-31,-36,66,61,-43,-127,18,-45,4,-33,-41,-77,101,-46,45,-47,-100,-1,-2,0,2,5,49,46,43,37,43,31,11,53,-39,-63, 
  /* [372][0][][] */ 49,-127,-16,13,-17,11,-20,1,-15,-52,21,-74,-55,12,-51,21,83,36,63,36,-12,-32,30,18,3,-17,-23,26,56,81,-27,28,-9,31,41,-18,91,51,-27,82,11,25,95,-15,26,7,-8,-30,3,-16,-30,-28,-45,17,3,9,0,53,11,7,13,11,-29,-19,-1,39,-25,-32,41,-9,-5,-24,-34,-3,26,-39,-20,-58,-50,37,-20,-11,13,-2,-71,16,-63,113,61,-59,60,31,-8,-25,-101,-8,31,-57,11,65,31,79,-22,-16,23,-35,-36,32,-24,-57,25,9, 
  /* [373][0][][] */ -27,-29,-66,56,72,37,-20,-21,-25,47,14,23,-37,23,-9,-11,45,-80,32,-22,54,25,36,-17,45,-64,-14,-11,-19,6,-14,-67,-7,-1,-74,-34,58,44,-57,25,-94,-88,68,0,-15,-54,15,52,57,-37,-38,-9,22,-51,40,-60,69,16,-20,-36,41,-76,68,-14,3,92,20,127,15,-40,7,-26,5,48,27,24,6,-15,8,62,-51,41,-45,29,90,40,-30,29,18,-7,12,-5,3,41,-28,111,31,-13,15,10,-11,-72,-37,-24,34,-34,35,-8,9,24,-67,17, 
  /* [374][0][][] */ 24,16,36,-20,-33,-11,-18,18,-5,-25,14,19,-5,96,38,-26,-13,10,54,-34,18,8,-8,-64,11,-40,-38,72,-16,-9,64,48,54,-113,21,9,27,-51,-68,-34,19,19,32,18,63,-19,50,-28,6,28,-22,-87,-24,33,32,-7,24,-7,-49,-40,33,-45,4,127,7,-35,-41,-33,-45,-28,72,-17,83,10,-28,-13,20,23,28,29,-16,-55,-39,21,65,44,73,47,35,-6,1,38,-52,-92,4,-63,-39,2,-110,-41,-46,-2,-33,-5,46,69,-9,32,45,46,3,7, 
  /* [375][0][][] */ 6,-11,25,-32,-47,-2,-19,-1,4,-2,-53,104,-40,29,-8,-3,-1,12,84,-38,5,54,1,37,67,13,-10,-73,-54,50,-47,57,-12,-14,57,22,77,25,43,-49,55,24,26,48,60,86,68,74,66,-15,-2,108,78,17,-39,-26,-11,38,-65,-32,19,-4,-59,-31,27,-127,-33,-1,-19,-37,-9,53,28,-33,-23,26,-5,-23,-14,-20,28,-14,75,-42,-43,71,7,-26,83,48,6,-87,-77,0,39,-45,-47,17,0,-17,43,11,-29,35,-5,-18,-32,-62,-21,-12,30,33, 
  /* [376][0][][] */ 14,14,55,-45,-90,-5,18,-11,-19,-22,-48,-15,54,9,4,53,4,-1,-75,26,62,29,62,0,15,64,-21,57,6,23,38,-24,-111,-41,-20,39,-17,-61,-36,-7,24,29,-16,16,6,-84,47,44,-29,-50,-6,52,50,-51,-23,-91,38,-22,-10,-14,-88,27,-71,41,-26,-127,-7,54,17,106,56,8,81,48,0,-63,-30,39,-2,-6,-14,46,12,6,32,-30,37,-66,56,-46,21,-8,-24,1,76,49,-40,-7,-41,23,60,-42,73,28,68,39,-7,73,26,-34,41,0, 
  /* [377][0][][] */ 25,-42,-40,-11,5,40,5,80,-50,-1,5,37,20,-50,-20,80,-26,-54,-64,-7,3,49,-14,-38,0,-35,32,-43,-56,-19,-97,13,-127,12,-43,29,-61,-43,-32,-41,124,-66,28,21,-49,49,28,-21,-42,-12,-50,9,16,64,3,-20,7,10,33,54,-10,24,-45,-34,-13,36,67,28,-53,-42,-47,-77,-107,-26,24,-22,-6,-27,-4,-16,-24,46,76,-46,36,32,-84,29,-43,-20,-56,-37,-4,11,25,-18,-8,38,0,-41,7,40,4,35,-19,-109,-7,21,-9,-19,-40,5, 
  /* [378][0][][] */ -127,-3,-47,-44,22,21,85,-29,-46,-69,-15,10,36,41,59,-30,70,-45,-13,-63,-99,-9,6,-30,-56,-5,36,21,37,-39,-53,16,43,-12,96,-7,22,43,75,-57,77,-56,32,-22,-29,-33,-30,-26,61,-14,82,17,24,12,-35,14,-29,59,-44,66,-9,46,-65,62,10,30,-74,21,-35,-110,66,-10,-108,-1,19,-6,1,40,11,-22,55,-44,-16,17,-12,61,16,53,92,17,-14,76,-76,-30,-110,22,-14,-3,47,-2,-1,-17,79,67,-33,-33,23,103,-88,9,43,8, 
  /* [379][0][][] */ 70,35,1,-9,-91,-60,-12,-40,-31,93,-52,10,3,-59,-13,-36,42,82,3,22,-49,-17,-7,21,11,24,74,-37,25,19,14,15,89,4,-34,-7,-2,23,-26,-53,-48,74,105,93,82,-2,-60,-3,-12,-91,12,-67,-47,23,4,55,95,9,-79,-127,86,59,20,52,60,1,39,29,-18,-23,109,76,-8,-42,-36,-81,-3,14,-78,-15,103,-50,-26,25,80,-27,75,50,63,50,-4,29,-12,-69,-73,100,33,-97,4,30,25,2,-28,-43,92,-2,3,19,-44,-44,-57,-49, 
  /* [380][0][][] */ 19,95,-54,7,25,5,70,-25,38,37,-14,-79,57,-64,9,8,-10,-44,82,24,-24,-41,-39,12,53,24,29,-6,-54,-26,-22,1,-76,43,-42,0,30,-9,70,-28,-86,29,96,66,103,-23,88,-60,35,-1,68,-47,42,36,-72,-12,-12,-28,-1,31,-60,56,-3,9,-48,54,11,67,26,-17,19,23,-46,-28,-68,-5,-16,-26,45,-81,-25,42,-22,-4,7,-26,-17,-34,-19,-127,-24,-16,-44,8,-1,-42,4,28,-12,102,-21,32,2,2,-13,-41,65,12,-51,16,-44,-63, 
  /* [381][0][][] */ 127,-49,6,-38,-41,-27,-16,13,-13,81,41,-76,38,-2,114,-48,10,31,12,-14,42,22,35,-22,-109,-14,-12,30,82,9,21,-27,-76,18,13,-32,-41,-93,81,-46,-27,45,45,43,66,-3,-24,-11,6,70,-55,26,-25,-35,31,-32,26,5,-5,-9,25,-12,-41,-77,12,-15,56,-74,-39,-3,3,-31,-40,-1,51,-30,-21,104,-35,-12,-67,40,-71,0,-11,-10,-48,24,7,-57,60,-8,6,14,-35,7,-19,23,10,-8,-38,-5,2,-78,-62,5,11,-22,19,31,-6,-52, 
  /* [382][0][][] */ -18,-23,25,-16,21,29,19,19,-2,-3,31,12,59,28,28,34,54,42,-33,-32,87,-43,-4,5,-14,-31,-24,57,35,-7,-34,-50,8,-10,0,19,124,-5,-59,28,34,16,-39,20,58,-15,51,-20,20,2,49,9,2,-17,-37,20,-53,18,-46,24,-48,82,-58,-9,41,-34,38,-4,21,12,44,-5,59,11,7,-36,5,-3,127,-36,-39,49,-19,-20,16,16,-28,83,3,11,-26,-43,-14,-36,-4,-36,56,-12,-13,-74,-4,-17,30,-36,61,-29,-36,-64,-5,11,13,33, 
  /* [383][0][][] */ -46,84,-11,81,29,-61,-33,-7,-58,80,-64,-69,-19,18,12,-43,13,32,46,-58,68,-73,-50,29,-42,-13,60,38,-1,-39,-49,-32,-16,69,0,19,55,51,48,46,-35,11,-21,-10,41,30,3,39,52,79,-14,-34,-25,26,86,-42,-12,-8,-54,33,-20,96,127,74,59,12,21,-32,30,59,-55,19,18,8,-39,-45,-80,38,3,-76,-69,-99,-81,-1,-1,70,13,-38,10,-18,30,-49,-72,-48,-15,15,74,6,-102,-6,36,97,21,29,-37,3,4,3,26,1,50,43, 
  /* [384][0][][] */ 6,8,51,76,-30,-39,-91,37,-23,-8,53,52,37,9,47,-127,-3,26,-27,-48,-7,-37,23,31,-25,-87,-29,-6,-8,-19,-2,13,-69,52,70,-52,9,-8,-62,-18,-31,-48,-36,7,-30,10,-18,29,-31,-88,-4,-25,35,-76,60,-19,-2,-37,21,18,17,18,-43,-46,-38,-5,51,-22,-123,-24,93,-12,-45,22,4,38,-26,-20,-97,88,-14,-56,49,2,-20,58,29,-10,120,24,22,1,-67,8,17,4,47,-12,-60,47,-37,-44,-16,-16,91,19,1,-14,0,3,52,1, 
  /* [385][0][][] */ 8,81,45,-12,-42,13,17,5,2,-10,4,-61,-6,7,34,61,-31,-53,-18,49,127,67,7,-1,-11,6,27,18,16,14,5,-9,-37,-42,43,52,-2,-82,-49,50,-72,-5,-73,-48,31,56,-111,-8,-4,-12,-21,12,-76,42,93,-39,28,37,-96,28,-1,31,-28,38,100,-58,56,28,-9,17,-13,-5,10,10,-25,63,12,49,-21,-11,-16,32,-4,-4,-71,54,66,-20,-12,13,-28,-3,-80,32,59,7,-87,17,-52,23,36,-4,-22,-107,-6,-15,18,-41,-24,-103,43,77, 
  /* [386][0][][] */ -46,-65,29,25,-17,56,73,23,64,-78,31,-24,41,-4,2,-3,-42,49,-14,-64,79,-54,-16,-67,-19,6,-91,-43,-46,-36,8,20,-16,-47,-9,-10,56,-12,-72,-28,2,-6,26,-35,-38,-31,-18,-26,-3,-39,-32,-5,-59,-13,19,5,3,-47,-97,-25,27,19,127,-13,-33,54,-22,13,-22,35,-124,-3,10,37,-41,-30,-40,70,-45,7,8,-44,20,-14,18,33,34,81,-68,9,91,69,55,23,-18,-7,34,73,56,59,-62,-46,-9,-51,-44,-88,-10,-51,88,29,20,61, 
  /* [387][0][][] */ -23,-16,4,28,-30,-106,-24,-29,32,-57,-63,-3,22,-5,5,16,47,28,35,-89,-88,9,-2,-95,127,64,-34,51,53,-78,38,-8,33,-16,-61,4,22,75,-17,14,-12,17,-4,-7,-4,-12,26,32,-102,-24,39,-43,39,-16,26,-72,33,46,-7,12,-45,56,34,-52,-16,67,-38,-48,64,-22,44,51,37,-26,-7,6,-56,-8,91,-8,21,-24,-124,-10,-32,-6,50,-11,17,-48,-70,15,10,4,-66,-38,57,78,60,51,21,-34,-27,49,-47,76,27,2,37,1,-5,-36, 
  /* [388][0][][] */ 18,-27,-6,-2,51,-122,-49,-33,-50,20,34,53,-25,19,-72,-76,37,-21,12,-32,21,-127,-17,20,-85,-66,64,-24,-27,41,-7,-60,-21,17,32,16,11,54,1,25,30,-44,75,35,-97,30,12,25,-8,-43,30,-8,52,32,-4,3,18,-84,-57,-11,68,-21,50,-10,19,40,46,-14,-25,75,23,56,-108,-2,-79,-17,60,48,-34,-71,16,34,35,40,34,45,61,-40,18,-11,-25,21,3,-15,22,-21,79,-26,-28,25,14,-4,-16,30,25,-3,39,19,-1,27,-69,-77, 
  /* [389][0][][] */ -49,6,46,-70,-85,-31,68,32,24,10,92,22,-66,-16,76,56,-7,-34,18,-70,-1,33,84,-28,-53,-24,5,35,-32,48,-13,54,-13,83,-10,59,-68,-17,50,78,-2,56,13,-23,-20,109,-78,48,34,-46,-11,-32,-127,12,57,4,-3,-85,-42,21,37,82,-30,66,-30,51,38,34,-15,-16,75,11,47,22,100,60,22,60,-50,-78,29,-66,-10,68,32,30,41,19,5,1,-36,-59,-66,15,-56,12,-45,10,-1,15,-31,-73,-18,-1,-30,-42,-53,-32,-18,-16,-6,37, 
  /* [390][0][][] */ -127,-46,29,25,17,15,-21,39,12,7,-25,17,-15,25,32,-19,-40,-23,47,-23,19,-19,-23,-11,37,19,-41,10,-25,-19,59,32,29,-15,49,52,12,28,15,-9,42,3,-34,-26,-27,-1,-19,-40,29,-74,7,-2,-3,-11,36,-103,-21,-46,-24,-28,57,-21,3,66,42,7,19,32,18,-34,-13,-55,-13,-82,82,-34,13,17,-71,28,56,-29,-48,22,47,32,34,-45,0,-13,-26,12,-47,63,3,32,-21,-52,-3,4,33,-10,43,-36,-21,-71,0,-64,-19,41,-33,-23, 
  /* [391][0][][] */ -52,7,52,-15,23,43,-32,30,-19,15,71,36,-55,-1,34,-48,-71,58,-3,-73,127,51,5,-22,14,16,-81,95,44,9,-7,20,-37,21,15,-12,43,-12,-1,-68,38,-17,-36,4,18,8,15,23,21,-39,-11,-7,-45,-6,42,37,-5,-27,21,20,-19,50,111,-64,-36,-27,-53,-26,-13,7,42,-71,-36,-37,-60,44,12,7,-23,49,28,-86,-28,-59,8,-42,-47,40,-56,-81,-21,37,2,116,-68,17,-19,15,-14,-24,54,16,43,18,-9,-3,-39,-10,59,-59,-14,61, 
  /* [392][0][][] */ 42,54,-35,-34,-36,-27,-21,-41,-9,89,4,-55,-54,73,-9,39,-2,74,-15,-39,-17,-60,9,-53,-67,-35,48,-55,-20,5,18,60,3,-43,-5,4,-56,11,-35,3,49,25,-41,-25,99,-41,17,25,80,19,46,0,2,-11,-2,39,-31,8,28,19,-17,-1,49,5,7,-16,18,-36,19,-37,56,78,17,-22,-65,10,-8,72,-61,18,1,-43,15,-25,73,-3,77,-34,-31,-3,-15,-45,5,-24,56,29,-55,39,-96,-17,-50,-50,55,18,127,0,1,-33,-54,29,-37,39, 
  /* [393][0][][] */ 53,-6,-60,-41,57,-40,44,-22,-40,59,82,-41,6,-47,33,-47,-71,-15,-37,-4,5,0,3,-4,-22,18,-18,119,-68,16,-50,-24,-102,32,5,12,21,-6,8,59,-87,27,69,81,48,-42,-1,86,-89,-54,-27,68,-31,-28,2,8,-26,32,-83,15,19,104,-16,69,-9,14,127,-51,-58,37,62,48,8,-16,-81,-49,-6,-39,29,-103,-96,33,-82,-8,2,76,12,99,-124,-38,-17,-21,14,49,6,94,36,-46,-47,14,-11,51,-25,-30,-10,-33,43,42,-30,-3,5,50, 
  /* [394][0][][] */ -52,14,7,0,42,-24,-21,-48,-31,20,31,43,-30,-89,-42,-23,46,-35,-30,58,30,23,17,-81,-12,81,48,40,-17,20,-17,21,58,10,-49,15,22,24,40,11,-10,21,-33,18,-8,-20,-4,-21,-5,-43,-27,18,-1,11,-50,62,-13,-13,56,30,-91,22,127,-39,20,-59,37,-96,22,-51,-12,-17,-31,27,-17,17,-11,-6,70,30,12,14,-1,22,27,-20,24,-1,-24,-23,-12,10,-9,-15,-26,24,-14,39,48,-1,-48,-16,-87,-10,-35,-29,24,-1,5,-1,-12,-7, 
  /* [395][0][][] */ 17,6,-1,-10,31,40,-34,-1,-28,-37,21,10,31,28,12,-19,68,-55,34,32,-31,13,9,127,-32,5,0,69,61,-13,-11,-31,17,-73,33,-37,-14,46,-21,55,-34,-54,-4,28,28,-35,31,-1,-66,12,18,23,-101,-59,28,3,52,8,81,22,-15,-1,-3,8,-27,-1,68,14,-19,65,32,24,-52,73,18,70,8,-67,-14,48,-51,66,0,-26,45,31,-12,74,-21,-27,10,-39,29,13,-44,-24,-4,41,-66,-45,-27,23,-18,-17,-19,-24,8,7,22,-10,41,-29, 
  /* [396][0][][] */ -38,-29,30,-91,-25,7,3,4,-52,104,44,4,9,-1,27,-26,35,35,7,103,-38,-2,4,49,-10,68,-36,76,-57,1,-12,-39,-9,78,-22,-10,97,25,79,10,2,-1,30,33,-21,22,-97,18,-106,-34,-3,33,-18,48,89,-79,-59,24,1,-35,91,-103,-5,-19,-42,56,9,-51,-72,-10,57,31,7,55,70,-127,-78,63,16,-62,-11,32,6,-73,-15,21,-8,-28,105,-32,37,27,-42,58,-12,-15,-86,-3,-49,-49,7,60,-13,35,13,-9,57,-42,14,3,16,-85, 
  /* [397][0][][] */ 8,-127,-48,10,-72,68,28,82,65,-27,8,115,46,6,31,-6,-13,-61,0,-38,-49,-50,-29,29,27,34,36,-20,38,-35,4,46,68,16,-42,44,6,-37,-4,18,22,-55,-56,92,-37,5,-13,55,108,27,13,96,-16,-14,31,-69,54,-27,-22,-45,16,29,-110,-62,61,43,-9,36,2,-58,24,-6,-20,73,69,20,-46,-4,-30,18,-17,-82,78,31,51,45,19,75,64,-75,14,-38,-22,20,-30,63,21,-46,-43,-101,45,2,-40,14,36,28,-94,1,6,92,1,-19, 
  /* [398][0][][] */ 33,-50,2,-2,38,-24,-73,-80,-3,-49,-36,-50,-7,14,44,8,-20,45,-22,0,32,33,2,64,33,13,-5,34,12,-73,-26,2,-29,73,30,19,23,-113,60,-14,-2,-37,-49,41,-31,9,-24,41,-92,-16,10,13,-72,79,52,0,56,43,94,-12,43,42,22,14,71,-12,58,-17,1,36,53,-23,41,3,115,-20,45,-80,11,15,-23,104,-27,23,10,71,2,33,19,14,64,127,16,-62,-17,14,-2,-15,-7,12,6,9,6,3,3,27,-59,-44,24,-45,62,-9, 
  /* [399][0][][] */ -7,-75,-82,27,-5,42,-30,7,-26,-2,17,17,-10,-43,-25,-53,-32,36,14,-40,-107,-22,-32,6,-3,-5,27,-3,-49,25,13,-72,-39,52,-37,-52,8,23,-29,-54,45,-48,-11,18,-23,-2,60,55,67,-37,-1,-10,22,-61,-35,-84,6,-33,14,17,22,31,-60,-34,-28,-79,-47,-30,13,9,-8,16,-53,-67,-23,48,-26,6,-46,-24,19,2,-50,-27,-7,-42,-127,-55,-2,34,-34,-43,-44,-29,-11,48,36,15,57,-31,18,58,30,-11,-48,-43,24,-39,-23,4,-40,32, 
  /* [400][0][][] */ 60,15,48,9,-10,8,68,-44,-52,57,20,55,46,17,29,-7,-10,-24,22,3,-16,-27,-19,-5,27,-25,-3,-25,25,-29,-25,-6,-22,16,-43,-31,-1,-19,14,11,-38,4,15,16,-7,-43,-8,12,44,-1,-12,13,53,14,51,32,-38,27,-6,-65,-13,-9,-13,-75,-64,-50,7,30,127,-7,-24,-30,-36,24,-70,-42,-30,-27,-46,21,-30,51,-9,-19,-14,-17,-19,45,-4,2,35,-28,-6,-27,-17,-6,25,-25,7,-47,-37,10,9,10,-6,-42,2,31,17,2,-60,5, 
  /* [401][0][][] */ -4,36,93,7,-31,26,-55,-71,23,-4,0,127,15,22,62,-42,17,2,-18,80,-14,-18,24,9,-60,24,-29,49,0,-1,-46,61,-62,-64,28,8,61,-7,28,17,-84,-7,-29,93,17,58,72,7,24,-65,-16,-17,3,29,-54,37,8,-1,16,9,35,-22,-29,64,0,5,-31,23,4,-3,47,-98,15,71,11,-61,-21,55,8,-82,27,99,21,33,-50,47,-117,65,-47,-35,2,22,-15,-35,-11,102,0,1,1,-60,35,-89,13,51,-40,-2,44,-62,-24,-33,-27,-21, 
  /* [402][0][][] */ -47,10,-28,-19,53,-21,-38,8,59,4,69,-5,52,21,12,-20,-63,-8,-13,48,17,12,49,-6,-19,-58,-34,4,47,27,36,55,33,-55,-19,-17,21,-6,-54,26,0,21,-18,59,1,42,4,26,-39,57,21,43,9,6,-6,127,-69,-18,40,-67,-29,-4,-38,12,-22,-16,40,13,-58,6,-47,71,8,9,1,-2,-8,-2,-43,-49,-28,-64,-45,-29,-6,-22,9,65,-8,33,9,17,18,2,-12,-8,-30,53,38,6,42,80,37,38,15,21,-13,5,-52,-27,-6,46, 
  /* [403][0][][] */ -34,-64,-71,-58,-1,-65,-62,-38,6,-113,-71,74,23,-55,3,5,-10,-38,-18,-19,42,5,25,-17,-30,15,71,44,20,26,-72,-33,99,6,68,-29,48,-11,-9,-17,-15,-66,67,62,-57,-43,37,-7,-23,1,-30,-38,-7,7,-24,-20,-1,-34,-114,24,-9,-29,16,-50,46,26,-22,74,40,21,7,-61,-16,-13,-3,3,17,-2,-46,30,25,-46,25,-54,43,-15,18,18,75,-28,22,10,-7,-4,-12,43,-93,-28,-13,-127,-15,79,-36,-8,12,63,-9,-85,44,-78,-38,-55, 
  /* [404][0][][] */ 59,36,-13,10,16,24,-43,6,22,-10,0,-127,-14,4,-39,76,14,-45,-41,-44,-44,18,-52,28,-18,-33,-78,41,26,-38,80,48,-118,-2,-7,-75,86,11,-48,-24,-40,-6,42,24,7,39,-31,-59,-67,15,-6,-1,11,-50,-17,39,-47,49,-70,-112,-2,107,13,13,-52,46,-36,21,-31,6,37,11,-30,0,21,-11,0,33,23,-32,-23,5,-59,-7,-78,53,12,-18,6,-35,-65,-40,-45,-52,-5,-2,32,4,-26,-36,10,-47,-25,-64,46,-9,-51,101,74,23,14,-1, 
  /* [405][0][][] */ 90,-9,-10,12,77,-66,-46,77,10,-9,-27,11,25,19,-30,32,107,-63,6,104,74,45,58,66,-101,77,-21,38,-37,36,-48,-68,66,-3,-52,75,-21,-44,38,-2,-36,28,25,-22,127,-14,-16,-45,2,-97,104,16,-21,27,66,-59,-48,6,67,126,-107,21,77,-41,90,17,-29,6,28,57,13,5,-56,17,-7,81,-117,-15,-17,35,74,19,-30,39,-24,-24,73,-25,-60,-26,19,-3,56,32,-5,26,48,-48,-33,-93,-60,97,-26,15,25,-61,-67,94,72,33,32,-89, 
  /* [406][0][][] */ -4,-127,26,-37,5,-55,87,52,-59,-24,51,24,-12,54,25,16,-43,71,-21,26,20,-9,-22,41,10,-35,30,25,-61,39,-32,-58,-41,-52,-6,41,-58,-32,1,2,19,11,-23,-35,-48,13,6,5,-19,-42,80,50,-14,97,8,-39,5,-53,-43,-23,-12,41,7,35,-28,6,75,-51,-29,24,11,50,7,-30,20,20,20,-11,-26,-78,-44,-43,32,-2,-56,3,-47,43,-24,-53,-69,50,-53,35,-94,-110,-39,1,27,-21,-50,98,16,-82,-70,16,51,23,7,-10,25,-21, 
  /* [407][0][][] */ -85,39,-80,75,-39,-62,-81,49,-15,52,-11,-116,100,-65,37,15,-31,-76,18,39,39,58,-127,75,25,64,-2,12,-38,-9,-53,-30,47,-18,9,-34,46,70,5,-31,94,33,55,61,82,-31,32,5,118,-35,-29,95,-60,-46,-27,-14,83,-16,87,-38,-88,-68,-14,94,17,-11,-65,51,-4,56,92,-36,-6,49,75,-54,83,61,82,7,74,-22,-3,-80,27,-31,75,14,8,-39,36,2,-9,-10,-47,-29,100,19,-33,-1,-26,-77,10,48,12,-5,102,-3,36,51,17,-38, 
  /* [408][0][][] */ -5,91,-17,46,15,-79,-16,-9,-12,-96,55,-23,37,-26,-15,47,30,51,20,6,-36,2,-52,24,127,16,20,-31,14,64,-70,2,-52,-56,-53,-31,-5,56,9,-31,-16,-87,71,-16,35,-2,13,-50,72,15,-7,-56,-37,87,-53,9,43,27,70,-110,-42,-14,-12,49,-85,-44,36,18,26,-23,43,75,34,25,67,-17,-4,-3,5,-48,58,27,44,-1,-63,22,-8,71,-23,20,0,19,-63,-23,2,-29,-61,-40,-56,-22,-24,-34,29,5,-38,108,41,-71,-20,-21,22,47, 
  /* [409][0][][] */ -8,71,48,8,-7,26,-80,54,27,19,-82,-24,22,3,91,24,-14,29,9,64,-6,42,-12,-14,7,-77,43,74,-58,-31,34,55,-38,30,-6,-4,98,3,-18,27,70,-6,-14,20,90,9,13,30,-30,81,-85,101,-68,-5,2,14,72,23,-9,49,-3,36,-43,73,19,-34,32,-56,-5,31,97,-29,31,-53,-29,-56,-15,-76,45,37,-17,21,-6,0,-20,12,108,-46,25,43,-127,-52,77,-122,48,-25,102,84,32,-4,40,17,54,80,-36,-73,103,-34,46,58,77,41, 
  /* [410][0][][] */ -2,9,-67,-56,-44,-46,-21,47,41,29,-9,24,-4,11,27,-5,-61,-27,8,-23,-87,-78,29,-44,-53,24,26,-65,101,25,45,-13,-47,-15,0,-127,5,34,-26,-37,-27,12,45,22,3,89,98,-77,31,51,27,-19,-11,61,-17,-78,-36,1,-37,7,58,-41,37,-5,66,-55,-23,77,24,48,6,-8,-33,11,54,22,-21,-73,-27,33,-42,37,-88,-22,16,17,19,-85,-37,-16,53,42,28,-58,61,30,52,-50,-82,-20,-56,16,-18,-8,81,20,62,90,41,-45,7,39, 
  /* [411][0][][] */ -37,12,19,17,-16,-17,102,-17,20,65,-6,35,-44,11,-88,-80,24,-8,-76,1,6,61,-26,24,60,30,-19,-48,74,38,-24,-41,8,-28,-94,-32,-28,-2,-44,19,6,-34,-31,32,-31,-20,19,47,-11,-63,42,28,62,-25,105,-40,85,2,13,-35,120,34,27,-4,-22,17,-43,61,17,41,-26,95,67,64,37,2,27,101,21,127,-34,-53,-113,2,121,27,71,105,37,-49,23,6,-37,-41,47,58,-64,12,112,10,60,-14,-30,-68,52,68,39,40,-18,7,-79,26, 
  /* [412][0][][] */ -31,-43,-109,-5,-88,-20,37,77,-41,-20,14,76,-32,-42,10,-3,-57,15,0,2,-28,4,16,-14,-31,42,99,60,-13,48,31,28,46,23,72,61,-42,18,21,51,-52,46,-27,-25,64,65,5,-6,-10,-82,41,44,-27,-21,5,87,-57,-22,-15,-5,90,24,-23,-12,-35,-47,-40,-71,32,50,56,94,30,42,-11,19,29,18,40,-26,25,-20,-10,-5,-31,-48,13,20,59,0,-51,38,70,-41,-70,21,-91,7,-63,-2,19,42,-8,17,57,-39,28,30,5,-67,15,-127, 
  /* [413][0][][] */ 19,-33,-20,-10,49,6,-38,-5,75,7,17,22,-26,-17,79,-29,-42,-18,0,41,34,-10,23,1,7,-38,2,-62,-27,2,-83,-65,5,26,76,68,11,26,5,-13,-27,-59,-43,67,-49,23,-32,11,55,37,-9,3,-38,-96,16,-44,-127,15,1,-72,19,-74,-1,-42,-12,-26,-8,49,-48,-2,67,-21,1,42,97,-15,18,-45,-1,-47,-1,29,48,-47,-5,21,40,-53,-62,-33,22,-30,11,-32,-72,-32,-72,2,58,30,30,45,-4,6,12,-65,21,1,-53,28,-35,-10, 
  /* [414][0][][] */ -6,-32,-78,-111,55,-31,-17,-3,-28,14,-44,-18,29,-27,25,10,-33,53,34,-51,-1,8,-23,-53,-28,-24,-26,20,41,3,127,26,53,50,13,38,-49,-9,34,-74,-9,60,107,49,5,56,7,-51,-43,-49,-61,33,1,52,-30,36,79,-13,-61,-18,19,45,-10,-10,11,22,56,-39,-77,51,-31,5,-19,-1,15,-46,-21,56,-19,-30,-29,-72,51,-53,-26,-2,18,-30,-32,-29,23,-1,-25,-19,-5,2,-95,0,-4,-29,-124,11,86,-73,3,-18,39,-57,29,-56,-34,-33, 
  /* [415][0][][] */ 8,-12,-7,14,-55,-17,21,-21,1,-9,-86,45,79,38,-32,-42,7,-12,42,-6,-69,-97,5,23,42,-6,22,78,-36,86,-32,-62,-23,23,-28,-80,23,4,10,-4,-13,-36,42,-39,-1,12,56,55,7,-26,-9,-2,27,-17,28,-26,11,-127,-41,24,-28,18,2,9,22,36,33,28,-38,2,40,13,-18,-46,1,65,38,115,3,39,-15,-39,-18,-17,-33,-75,-50,-63,19,-48,2,-46,34,-10,-15,-5,18,-23,-69,-14,21,-23,-100,12,-37,42,51,60,17,-21,18,-5, 
  /* [416][0][][] */ -12,-40,-37,87,-87,-49,24,21,-42,-16,42,66,11,45,-29,-25,-13,-20,-2,-28,-16,-16,-11,18,-10,24,60,-14,47,-29,127,-95,42,10,24,28,-3,89,6,-8,29,12,18,60,-24,13,-28,81,41,25,8,82,-23,13,26,-15,51,70,-5,25,20,39,13,10,-71,-34,25,0,-19,-12,17,-86,9,-70,7,-3,-7,49,-13,21,75,58,-68,79,20,-10,-53,-3,51,-54,36,-34,52,28,21,-24,46,-49,-36,-70,-46,30,35,-44,-15,-21,3,75,11,35,-19,83, 
  /* [417][0][][] */ 75,62,20,27,25,-31,-5,-14,-48,105,-3,-4,52,-3,17,77,35,96,-48,-17,-8,38,-11,2,-27,-18,-79,-24,-22,-122,-14,47,-37,-16,-49,-44,-23,51,-42,39,-53,-29,52,52,-46,36,-26,-29,-4,25,61,-46,-19,-28,118,-23,56,62,14,14,14,-66,-12,17,-79,15,6,-19,-35,26,-30,62,10,-1,-24,-49,22,-47,14,-28,-27,-19,-63,20,-85,20,-30,-14,17,19,-127,-57,-14,-53,-27,-24,-42,12,-84,-56,-30,1,2,42,35,-12,2,38,-75,24,18,-70, 
  /* [418][0][][] */ 3,36,29,33,-43,69,28,-12,-19,-2,3,67,-41,1,-12,0,30,-21,46,41,37,-7,-21,-26,-40,-82,28,-53,24,29,-24,-15,14,-31,7,30,53,45,22,10,-36,-16,-77,-14,47,-45,-2,46,86,-7,-7,-24,37,54,-53,47,-73,1,-127,-66,-30,-6,59,-18,73,77,-56,-12,-41,-12,3,-16,33,-58,-51,-41,-19,17,-19,37,-3,-16,-9,64,-18,-18,20,-3,-14,34,56,23,39,8,61,-33,-109,14,-23,-91,-48,38,-17,-37,-41,-24,-31,-68,4,44,-74,6, 
  /* [419][0][][] */ -70,6,51,17,-56,78,95,69,76,15,12,42,25,0,-3,-111,-20,3,-17,82,18,59,-15,-47,-4,55,-111,65,49,-5,-47,-29,-17,57,70,-91,19,30,75,-10,-20,-62,-28,11,8,-32,-40,66,-50,29,49,-45,3,14,43,-4,-15,-10,-58,46,-10,123,0,-7,-16,-115,66,5,-32,57,1,58,-18,-66,54,7,-82,8,-127,12,59,39,-55,15,49,37,36,92,41,-54,12,-33,-77,-52,-21,-57,30,-2,-23,29,124,30,-39,22,-21,-53,-6,3,-39,-76,-40,86, 
  /* [420][0][][] */ 75,16,-105,-25,-1,14,20,12,-17,32,68,-27,-8,79,-30,-1,-33,57,48,23,48,-32,-7,47,-93,-25,9,-61,-85,39,51,-84,10,42,-4,-68,32,-9,-33,0,-38,33,-64,19,4,1,33,-74,26,-71,-3,-16,28,84,113,-27,19,86,-23,-34,41,6,-88,9,-61,-7,14,-10,24,88,90,9,63,48,-27,39,-63,22,109,-55,-22,55,43,-69,39,-127,-7,-26,-15,8,-52,-18,-55,-39,36,53,-33,-79,-58,67,-44,-13,90,17,28,-17,-56,-52,37,87,6,-33, 
  /* [421][0][][] */ -8,-20,-43,50,-61,-33,-5,36,70,-11,-2,-59,-52,-20,118,-70,-37,-105,17,6,-14,41,8,9,-14,-36,33,24,-35,-59,9,19,79,82,4,-79,-41,91,83,-17,19,55,-18,127,4,19,10,-4,-59,115,-4,-8,-11,27,-12,21,-29,40,-8,-51,8,-21,-26,40,37,-25,-6,-47,25,6,-2,-24,-18,16,121,7,-23,-27,99,-49,-68,-24,-60,-32,4,-35,21,-12,7,-22,1,-50,85,-10,-23,23,42,29,29,31,13,-40,2,-42,-101,15,20,-90,46,-36,-53,-32, 
  /* [422][0][][] */ 29,-9,-78,-49,-87,-18,31,-127,44,-66,-39,-27,-30,-27,25,-39,41,-48,-1,-27,44,-43,-25,66,71,-3,48,55,-45,23,-34,18,-9,-26,50,26,-33,-33,37,-20,-11,14,13,-2,-24,54,34,27,2,18,-68,4,-62,-81,26,19,59,56,-22,-35,3,-4,64,-52,44,-27,-13,16,-4,-34,19,27,-33,-69,46,-37,60,-45,13,1,6,27,-10,41,26,-26,53,-102,-40,27,-3,63,50,-8,-29,-78,-43,32,-47,4,-21,-5,13,8,-36,22,-89,-96,-8,81,15,36, 
  /* [423][0][][] */ -6,32,-12,37,3,-40,14,80,53,-16,-24,5,-28,18,-4,42,48,-50,-4,81,16,-2,14,40,-52,-38,-18,-126,5,76,16,25,-17,4,34,44,21,56,38,-19,21,-22,45,25,0,-76,104,-4,-29,9,-21,-46,52,67,-8,56,-125,-23,-85,24,0,-2,31,-40,-38,35,-84,17,-64,37,-17,-36,39,-2,-23,15,-76,-10,4,-9,80,20,-47,73,-62,-33,81,-37,94,-86,-42,-19,73,-35,-69,75,-12,-61,-56,19,71,-90,17,47,37,-109,-127,-11,-21,28,-65,-14, 
  /* [424][0][][] */ -48,-20,-29,-60,79,-31,19,26,7,-11,-20,29,28,-13,20,20,57,-47,-34,-35,65,-46,127,-55,-6,22,-85,-49,27,14,-29,-14,-45,-46,0,-56,-70,66,-60,-48,45,-21,49,-57,30,77,34,-13,-38,67,12,-28,-43,-48,23,20,79,-13,11,10,-11,-86,73,-63,32,0,-28,37,39,37,-44,-31,-87,1,-51,4,41,-56,-27,-29,11,-52,-54,1,-47,-6,-7,74,38,-66,-85,9,26,17,-83,-22,28,65,-32,8,64,37,44,6,63,-5,10,46,-24,6,-51,-48, 
  /* [425][0][][] */ -32,22,0,-52,2,-57,34,2,-75,1,-73,86,32,-83,57,-72,77,53,-16,40,76,68,-44,19,44,-32,-75,-72,-6,127,-45,-11,-62,33,-39,-56,-43,32,33,16,-72,12,-62,19,-40,-6,10,-26,-34,37,96,80,48,46,34,-6,-2,5,48,-46,-12,11,-35,10,16,22,8,28,1,23,-60,2,-22,39,-34,-23,-56,75,61,42,-28,108,-35,-14,24,1,-72,-95,68,-46,-48,11,9,-64,-51,9,7,-10,-46,23,-38,29,-3,-52,76,-12,-35,16,-38,0,-68,-16, 
  /* [426][0][][] */ -21,57,-19,41,-101,80,45,3,32,-12,17,-13,5,-32,-38,-45,-4,67,14,-2,-70,-68,17,-127,2,-30,-14,-39,-22,-37,24,-22,52,17,-24,38,83,84,10,-22,-50,28,64,21,16,54,-11,-14,44,-36,-4,6,65,35,64,41,-68,33,-94,-104,-75,54,-58,-2,-62,-84,-33,-55,33,-35,28,29,-1,-5,14,75,-16,4,85,-91,-34,-36,38,-27,1,-66,-76,-81,84,103,-20,44,-17,-32,20,-8,25,-3,17,54,-101,26,-11,11,-33,-53,11,-63,-47,-17,27,18, 
  /* [427][0][][] */ 5,120,38,-106,-19,34,62,-36,4,51,-60,30,22,-94,-91,-66,-31,33,-18,-2,45,38,-10,-63,-72,-119,-32,-4,-17,-36,3,-30,57,15,-40,-3,2,-13,46,-75,31,-80,-20,-6,-18,-62,80,16,-35,41,24,-32,52,69,-19,-23,-36,41,-34,35,31,-13,11,-35,22,58,7,-37,0,6,-14,5,-29,-14,-7,-56,-27,48,10,37,66,-31,-6,-59,29,-8,-36,-82,-29,-11,-46,127,-10,-20,90,-29,6,22,57,7,3,-103,-53,-31,23,91,-78,-21,-1,-58,-15,-15, 
  /* [428][0][][] */ -5,-40,40,-55,5,-2,19,-8,68,-7,-71,35,-36,-56,5,-32,76,-54,0,-59,108,29,89,47,-32,-91,-8,-97,-53,-74,-58,-47,-66,74,-34,11,-48,-127,4,-52,34,-106,-28,-21,0,-24,60,0,38,18,13,-10,24,46,-14,-37,90,-91,103,-23,7,95,125,-117,0,-2,50,-1,78,-101,62,-44,45,16,-50,-22,43,-46,3,54,77,15,57,24,-10,13,30,-15,50,-14,76,15,-100,-60,43,9,39,-71,0,66,-55,-15,-30,-38,-34,-35,110,23,74,-37,-89,-57, 
  /* [429][0][][] */ 56,-12,-52,90,-8,54,-14,-20,-64,30,-23,-18,16,77,32,45,57,-45,-11,-84,-34,78,24,-18,71,35,-53,-23,-12,53,29,-45,-25,49,-14,-88,-25,-44,47,-99,45,89,16,46,-62,69,37,-13,-89,-95,15,-12,-18,76,45,-44,-13,-17,-84,-69,44,-22,44,16,21,-1,-2,-74,28,56,5,12,-34,-18,13,34,0,12,-71,23,-88,52,71,1,28,29,30,16,-2,-67,-14,-11,47,93,7,39,61,28,31,73,3,93,-14,-5,-30,24,127,42,-52,4,-7,-25, 
  /* [430][0][][] */ -54,0,22,-7,-26,-47,88,0,-1,28,46,-74,-10,-35,-3,-26,-46,23,7,-23,26,88,53,49,-1,24,-52,-81,35,56,-17,7,7,61,44,-47,-44,9,-35,69,35,38,53,-16,67,59,-54,-39,-62,35,-52,9,42,20,40,18,-29,-71,-9,14,41,29,-61,-26,31,39,-40,-51,-44,18,54,-16,-22,68,78,17,35,45,76,4,48,31,31,10,-37,-63,-127,-53,-13,-97,-3,-49,59,32,-16,-27,30,51,-5,-87,-17,0,-41,-18,-36,-11,67,24,8,-100,-2,-73, 
  /* [431][0][][] */ 51,13,44,-23,-65,-45,12,13,-19,105,-15,29,61,-26,-21,-16,-8,78,-28,-44,-127,43,-23,40,45,69,-79,42,-68,-31,63,32,-72,-43,-39,1,22,-57,-37,-61,-4,0,-12,-59,-28,72,24,12,-66,18,79,-22,-41,-11,-6,-1,-5,-30,-75,4,24,-21,20,-55,-97,31,-24,72,-25,-6,-4,-53,-41,-33,-20,89,14,74,-14,24,36,-8,-20,-90,-7,-30,-1,-22,-60,-19,-68,-11,-34,-64,-28,-25,-10,-19,-29,-53,5,66,53,-21,71,-3,-31,88,-16,-23,-95,-2, 
  /* [432][0][][] */ 85,21,34,63,74,41,8,-46,5,-29,4,7,31,38,79,89,-24,6,16,-67,-13,31,20,13,20,47,-43,-39,37,24,-70,85,64,54,15,-65,-72,17,-22,-3,-6,-7,-105,-10,-61,-4,36,-6,-53,-2,63,8,-127,36,-10,69,12,46,37,-16,65,-20,-45,48,-18,15,-31,-17,34,62,-1,12,-9,-53,-44,75,18,-25,-48,9,-17,-25,66,-78,-53,44,-43,-25,-39,61,-53,-46,-8,21,-16,43,-11,88,53,6,59,-19,4,82,-36,-20,49,30,-23,-33,-17,74, 
  /* [433][0][][] */ -12,-31,7,1,-38,-23,-1,-86,3,-14,65,0,-9,62,-1,17,-54,-22,33,-7,9,-19,13,15,58,39,-95,-2,57,9,-7,-4,-21,8,78,46,36,82,-39,-51,-14,-59,98,-37,36,40,-21,31,-37,-2,-17,91,-118,-47,-14,-39,10,-36,-1,-99,84,-20,-33,32,3,-57,28,-24,24,-12,94,61,3,-26,13,52,33,-43,26,96,-24,-54,127,-11,8,14,-18,-2,-9,-28,9,14,73,8,-9,35,27,11,1,-42,-12,-4,-3,21,52,-81,14,-11,78,14,-11,-37, 
  /* [434][0][][] */ -29,18,-5,63,-3,-73,46,-39,-48,0,56,-18,116,-83,42,-35,-27,10,-25,-9,73,70,-42,-74,-39,-9,-26,-50,15,14,19,-49,22,50,48,-39,-54,20,127,-14,39,-44,75,14,16,-23,53,31,9,-12,-104,-20,47,-17,-21,10,122,-31,55,-55,-15,66,0,63,68,3,-50,-57,14,34,-65,-20,32,2,-47,67,4,-1,-81,-81,19,22,-55,0,37,36,-25,-11,45,-59,-16,52,60,-70,21,45,6,-80,-25,-65,-26,67,10,30,-49,70,30,-26,111,-34,-51,-121, 
  /* [435][0][][] */ -8,-50,-36,10,62,19,26,-102,71,19,-35,-55,-19,-42,28,23,58,-127,31,4,-17,-57,-94,67,-111,31,60,-21,50,38,18,17,-52,-33,-57,38,1,-4,16,97,54,-75,-51,-56,6,-45,30,-14,82,-15,-16,23,9,10,-75,1,-13,-6,-33,-14,62,-19,94,119,-45,21,18,-14,21,68,47,-19,-32,66,-13,15,15,16,27,-49,66,-26,-93,-28,-42,34,37,25,-12,11,38,-29,-3,40,37,-40,79,-62,-30,-79,77,-86,-34,10,-83,47,-75,-6,-12,94,-14,41, 
  /* [436][0][][] */ 25,56,23,11,90,-10,8,-69,12,30,20,-65,32,91,-6,34,-38,-39,29,55,-21,-6,-53,-26,-45,-56,-112,-68,-27,36,-30,19,-39,-17,-61,27,-66,31,-75,-50,80,-5,24,43,-71,0,-123,-31,-4,-41,56,17,35,1,68,-53,16,-35,-82,17,30,74,17,-5,-64,73,55,-61,28,-59,42,35,-2,127,-2,39,-40,43,3,-26,114,38,-77,39,-39,-3,-20,-26,-26,-29,-93,-46,-28,-42,-9,-19,29,31,-30,53,24,-19,-97,6,50,-12,42,89,31,33,-39,-29, 
  /* [437][0][][] */ -120,-23,25,0,90,33,32,47,-47,11,44,-30,40,-75,-12,41,-52,-127,-37,18,91,-13,17,-69,2,-10,-15,-17,69,-15,34,-49,-30,25,-77,-2,2,11,21,-101,4,-96,109,40,-38,-21,-74,-37,79,15,45,90,12,-54,16,-19,-34,-47,-15,-35,46,22,-10,-23,36,38,-46,-73,8,-80,-50,32,-11,38,-48,-14,-75,79,-14,1,43,-50,21,43,-43,-7,-7,-62,-2,-5,-57,18,44,25,-59,-34,-32,12,-48,6,67,39,57,-24,7,-60,40,-2,11,-35,64,-66, 
  /* [438][0][][] */ -15,-3,67,0,-57,29,21,-54,17,9,11,-52,36,-39,-53,-41,60,21,-85,17,-22,42,-62,-7,-40,122,-89,18,-43,-31,-31,12,15,-78,46,-127,-28,37,-32,1,19,-5,-17,-32,29,2,-4,53,-5,35,3,-22,-17,-36,-31,23,-29,-27,-34,-69,-4,-53,57,-32,-52,77,31,9,55,-81,-74,32,-43,-22,-63,41,-15,66,8,12,-10,-41,-31,10,-11,45,37,23,-49,-44,60,84,14,-11,55,-30,28,35,-74,54,28,-33,-9,6,-7,11,13,40,-52,9,-34,-41, 
  /* [439][0][][] */ 23,91,-7,-61,-1,-75,-45,63,54,79,-10,6,-15,-111,108,-22,16,-5,-9,-7,-57,-50,-43,52,-28,17,22,77,-105,7,-42,21,-97,-2,-102,-91,-3,11,-72,12,51,31,94,32,17,62,104,18,40,-67,29,22,14,76,-15,-127,72,-97,-21,58,-70,6,47,56,-1,0,-76,3,1,-67,-20,-17,-48,31,-27,9,7,-35,-42,-4,-54,-2,-1,29,-27,-19,-3,51,-33,96,28,96,35,-2,73,5,-19,-73,60,80,-61,-124,-70,22,77,-68,-69,65,-3,-6,-10,-16, 
  /* [440][0][][] */ 34,-25,-27,29,21,19,-37,-44,-67,5,7,26,-42,18,10,47,37,21,23,-46,3,22,49,29,65,22,11,-50,-22,3,7,71,-35,14,56,-34,-19,57,-76,-17,15,33,49,1,-68,-11,55,-29,3,57,18,-32,-5,33,-22,59,49,72,-38,-38,-34,-14,28,-2,-14,39,33,-7,33,38,14,-27,25,2,-84,-7,-59,26,-5,-12,7,-29,-26,-37,-25,79,-25,-31,-61,18,-30,54,22,-47,-45,-7,-23,127,-7,34,63,2,-76,16,61,-37,-79,26,56,40,-37,-3, 
  /* [441][0][][] */ -61,-36,-26,36,31,28,8,-31,13,-7,-10,-3,19,58,15,63,-43,22,-15,-2,34,4,7,-28,4,-44,31,-12,-77,-52,19,-39,-67,-52,10,16,9,-33,3,-115,9,28,14,-25,51,40,8,57,-7,28,-26,33,-10,2,-11,-19,-24,26,22,-9,14,-70,25,13,-7,12,-8,-12,33,-127,66,-34,-15,49,-16,-43,-2,47,10,12,-82,-50,27,4,-41,5,-15,-86,-50,-1,-22,15,22,22,22,-32,-1,19,27,-68,15,31,34,23,35,-67,7,4,-10,26,-27,-37, 
  /* [442][0][][] */ 38,1,12,-92,-36,34,1,-47,-30,55,95,-81,6,48,60,-54,32,-120,35,-62,78,22,-41,35,-51,125,-6,24,13,-31,-39,-61,-37,-20,-89,28,-95,-16,69,23,34,-3,42,37,25,39,5,21,15,63,-5,-73,50,-54,6,-26,-2,-59,100,70,-66,43,-4,56,-41,32,46,95,0,-17,-20,47,5,-11,-22,-48,98,73,1,-118,-18,84,50,32,41,-15,16,-3,127,7,-28,9,-7,-16,-66,-109,5,66,-24,-36,2,10,-32,98,57,-59,0,70,44,-28,36,34, 
  /* [443][0][][] */ -20,36,20,-4,8,20,51,-22,-75,24,22,13,26,4,39,3,-7,23,-30,-49,36,33,-26,8,10,31,22,58,-26,-39,-7,-10,-4,-20,3,33,5,-19,11,-4,-18,-5,-7,33,5,18,52,34,-2,-14,-21,-17,-27,-39,-70,29,46,-127,18,-44,8,-23,58,-27,36,1,17,-75,10,2,19,-12,1,-26,2,36,-5,10,80,-53,58,28,-69,10,28,51,24,43,-21,10,6,-62,-22,13,20,12,-15,-19,-7,34,-15,-7,-36,-48,0,19,-28,-19,-4,-41,-6,-23, 
  /* [444][0][][] */ -16,-42,-23,-41,-46,1,-42,14,12,-71,15,-34,14,29,-107,-38,-58,-58,53,-58,34,-26,-70,31,-9,-79,15,35,-21,67,36,79,-56,4,32,-11,102,11,-48,26,-104,12,-14,69,19,53,11,-34,-15,43,-76,80,-44,-7,59,-36,-50,-50,-17,-78,-29,14,-62,7,24,69,15,50,-46,23,32,-63,93,-29,127,11,-44,43,-50,8,-42,-7,-84,-31,1,96,96,23,59,-20,16,20,21,102,80,-125,-33,41,-21,47,-55,7,-53,8,8,15,-72,-47,-7,-8,-31,-9, 
  /* [445][0][][] */ 5,-30,-8,-20,-4,15,26,75,-59,-23,-17,-28,-2,-22,38,109,70,52,-29,-49,50,1,-25,16,10,-50,63,36,-22,75,55,25,15,16,106,39,-21,33,7,-32,37,16,-83,-25,42,50,31,-30,10,-34,-71,8,-8,46,27,-27,52,19,10,5,20,-27,-23,7,54,20,3,-94,-61,-47,31,-53,-94,25,73,51,-17,-6,14,8,26,-16,65,-5,8,37,52,6,-15,-15,18,60,127,-8,-37,61,17,-40,-84,16,22,57,-16,3,-70,-13,6,4,-60,-24,25,5, 
  /* [446][0][][] */ -60,-86,45,1,34,37,53,-3,78,-64,4,-55,-63,-4,55,15,30,-17,51,-21,38,13,57,63,-61,-60,-64,62,21,7,7,41,-21,39,-9,-62,125,-90,63,5,27,16,33,8,-82,31,30,63,-34,27,48,48,56,-46,15,13,-6,9,77,29,12,-42,-11,-27,86,82,98,63,-37,16,-13,-20,23,35,2,1,46,38,-12,-49,-96,-3,-22,127,46,35,-8,-29,-77,-15,-64,-3,51,53,-87,-4,-47,73,67,-54,60,41,26,16,-10,-40,25,7,37,30,67,18, 
  /* [447][0][][] */ -29,17,21,-86,-26,-33,87,-64,-9,-65,-54,81,-2,19,-120,2,106,-17,32,15,9,24,49,-63,-7,42,-122,-33,-41,27,-12,40,-85,51,34,-113,52,-64,-26,-36,-46,60,-90,-61,41,6,127,56,-26,30,50,45,-5,-70,86,-86,-38,-44,4,-56,-7,95,53,-71,-21,27,-99,20,-48,-119,36,61,88,40,-12,6,9,49,82,78,-42,-70,20,66,1,57,48,-16,-37,-87,28,-79,43,57,27,-58,15,37,-2,25,-2,28,-82,82,43,-48,17,-7,-53,55,-27,-41, 
  /* [448][0][][] */ -50,29,101,-7,-64,96,6,-26,15,-15,26,6,-68,51,49,18,-20,19,-20,38,33,69,38,79,-29,54,-5,-55,-97,-14,65,71,-56,30,84,71,-35,-20,-9,-12,-73,18,0,-65,2,8,-8,-64,-31,-16,15,111,-20,-12,78,11,-52,55,10,65,60,-13,63,14,-10,25,12,-40,-34,88,-3,23,-8,-4,9,-49,12,14,127,29,-30,15,100,7,87,-51,71,-19,-11,12,-54,11,26,-5,40,25,-48,24,-13,20,-74,22,46,-23,36,-46,-11,-43,-24,3,-1,-11, 
  /* [449][0][][] */ -86,-92,-6,-9,21,-88,8,32,-51,-6,90,-32,-60,-87,-10,-78,38,-3,-77,-32,-55,-5,50,60,59,70,50,67,29,-48,127,12,-27,55,54,-65,41,102,63,17,-100,-62,33,-43,-5,21,35,-48,-40,-23,-76,20,-24,89,-1,23,28,34,-20,106,-17,-7,27,25,-82,-9,92,48,0,43,-55,54,-93,46,-9,-36,-21,-14,1,-117,63,84,-35,-33,4,111,-12,-66,-28,-9,50,28,21,21,-38,-39,43,-45,-46,-47,16,-13,47,-84,-63,-41,41,-26,13,-104,5,-61, 
  /* [450][0][][] */ 53,102,73,85,-25,-20,-80,-78,-16,-26,-22,-56,94,6,-37,20,127,-8,6,-2,-72,-6,78,69,-55,-3,-56,-43,-74,13,10,41,-21,23,-56,26,38,78,78,-34,-40,-7,-64,41,-5,-36,103,80,86,94,-43,64,-38,-95,5,32,-23,-103,103,-17,-27,65,31,-13,-97,-84,-22,13,-7,6,26,35,83,-46,15,55,-24,-36,22,43,55,12,-99,-20,-67,96,-125,-22,9,-5,16,-77,-51,-50,43,-100,6,9,29,67,87,-19,-53,-4,-5,1,31,-85,-87,56,-25,-59, 
  /* [451][0][][] */ 18,-99,-67,16,56,42,-42,50,78,-34,63,28,-9,-3,45,27,31,-8,10,75,-63,-17,-26,36,90,-56,16,28,-69,56,-15,-1,-3,14,0,-5,46,-54,-12,31,6,4,18,38,22,-35,-99,18,37,-50,-30,43,-56,53,-15,44,-34,-43,15,1,-14,-24,-7,-99,-13,-72,-10,-1,37,36,-34,-25,46,42,47,34,-32,28,-38,-37,-34,-53,-2,102,-16,0,17,23,11,-12,57,38,16,4,24,86,-60,-31,-31,-88,-32,-13,-88,9,4,38,11,-127,56,40,-3,86, 
  /* [452][0][][] */ -127,54,-38,-116,123,-41,-62,-27,105,-38,-5,-7,47,63,31,-30,50,25,-49,-31,25,-48,52,30,33,35,-64,-23,63,-73,-22,10,26,2,-23,88,26,33,22,43,-96,-78,53,19,38,67,13,57,66,-3,-4,2,-25,-21,8,47,3,-47,73,-18,-75,-102,38,-62,50,44,52,71,43,28,86,-29,-44,-28,2,9,110,55,34,114,59,-43,23,-44,-13,-64,-73,-78,30,-10,45,-9,-15,-7,1,-49,-28,119,-35,-24,-72,100,63,36,-17,-75,-6,-114,-23,-38,-51,-60, 
  /* [453][0][][] */ -32,19,-12,10,-37,-11,33,6,-14,-7,-18,42,-73,103,29,-82,10,-23,12,-31,-11,-4,-39,26,-31,-18,21,-57,17,61,-38,-18,-90,48,127,-12,10,47,-19,-72,52,65,52,35,22,39,-24,-38,-98,29,92,30,-119,-30,43,40,-14,100,8,-17,-28,31,9,-1,27,-43,47,-2,87,-4,95,-19,32,-66,66,-8,7,43,-47,68,-29,-61,-35,14,-49,-36,8,-28,3,-54,19,32,-92,-60,-74,-46,-76,-51,36,43,-48,-13,-59,69,62,-49,-2,36,21,15,-29,-6, 
  /* [454][0][][] */ 21,6,20,13,30,97,46,-90,-45,19,59,45,82,3,16,-8,-41,64,127,35,15,18,12,-22,84,16,-15,-33,-11,25,6,-30,66,-56,3,-1,56,-69,-59,47,64,39,6,21,-28,-25,-14,12,25,45,21,-13,107,39,13,-7,-29,-26,21,-20,-67,89,-13,-31,30,39,-19,-64,17,20,30,-2,-31,-61,-32,55,-32,-31,-17,-34,-119,68,83,98,2,-58,-15,-41,8,5,57,-74,23,-23,15,-75,-35,-13,-11,16,-19,-11,-16,27,68,-14,2,49,63,43,6,-20, 
  /* [455][0][][] */ -32,14,-6,44,33,-21,35,-29,38,47,73,9,42,1,-74,-66,-11,6,18,19,-29,127,25,-34,-33,8,-28,78,-30,-19,17,-3,-21,-5,33,-8,45,6,-40,-38,24,-33,-37,57,-7,1,6,-37,-70,-91,40,-27,44,34,37,-11,13,34,-50,-25,-50,81,82,-41,47,9,-28,5,53,4,-32,-45,16,-44,41,-24,52,-21,46,-103,-45,37,-49,-34,53,4,31,41,85,39,-57,65,-2,-22,-13,-55,1,7,-40,-13,14,-41,-53,-36,72,-3,17,15,2,0,-2,-73, 
  /* [456][0][][] */ -9,44,-39,64,46,-67,-57,47,-66,1,111,77,-51,47,-38,94,-7,-91,-82,-88,49,27,-6,20,-115,42,89,-66,50,-59,22,-4,-109,27,-65,-87,80,68,27,-29,-74,-57,60,30,14,-41,-50,0,12,29,21,3,98,6,19,-24,80,55,11,21,84,25,0,1,77,73,-47,-20,40,3,-25,45,-71,20,57,89,-33,-33,-94,-127,23,24,-95,19,20,42,1,27,36,109,-20,6,1,83,-42,46,5,8,29,21,2,23,-84,-34,-40,-63,34,18,-25,-64,16,46, 
  /* [457][0][][] */ -27,46,-19,26,7,-17,-40,10,-7,7,10,34,-23,-22,72,-66,1,-54,43,-14,21,-2,34,23,15,-16,8,50,-55,43,35,-127,26,58,61,92,63,58,4,45,23,-50,-4,-62,6,8,-43,-57,-29,-25,-77,-25,62,37,-11,29,20,35,-42,51,-78,42,17,55,-11,8,-30,-4,35,17,67,-27,22,-9,48,-76,-55,-49,2,-56,42,25,23,68,-28,-74,24,-60,110,48,-17,-8,-62,61,24,-26,-58,-19,-47,16,-8,1,41,5,-8,29,8,40,-3,-30,-51,-6, 
  /* [458][0][][] */ 35,44,-28,53,2,-36,-13,11,4,42,-4,-14,5,2,27,-33,35,-32,12,-43,-56,-14,-40,28,-11,18,34,-25,-15,-68,30,-67,12,13,-31,-67,45,85,27,8,4,-7,58,-25,-10,-29,-35,-75,30,38,-65,24,-26,-52,-18,84,-14,26,52,11,8,27,49,9,-6,1,-47,-51,52,14,-20,-42,-9,-33,26,-32,29,-37,-24,-31,22,34,-42,18,-4,31,36,-43,35,-31,52,-21,2,-16,-13,127,-9,-47,-4,48,-3,-96,-15,-2,-7,57,37,-62,-89,-50,-7,-27, 
  /* [459][0][][] */ 78,-63,1,-29,-58,-58,30,-26,17,0,48,-32,100,-27,-29,-47,-13,8,-21,84,50,59,6,-25,-21,6,40,20,71,66,-113,59,2,5,40,-67,1,-54,-34,-15,55,-28,-20,57,-15,-39,-50,26,-4,43,15,-4,-57,-49,-11,64,-47,21,-80,51,42,7,-18,34,-49,-83,-32,33,-14,56,-24,-1,107,41,28,-62,-12,21,9,34,56,14,33,2,29,24,-15,82,16,26,-5,37,-127,-40,63,56,-10,-24,-37,6,62,-29,21,35,2,55,-3,-83,-34,-10,-34,7, 
  /* [460][0][][] */ -41,38,-33,-44,69,-19,23,5,-12,-13,34,-32,-13,26,19,13,-20,-126,-5,11,54,71,26,58,16,-71,38,33,-11,-45,16,-71,-49,10,127,-52,25,-29,79,-22,-11,-21,-18,-26,-31,-22,-27,-40,47,-35,-26,-17,82,65,-9,-77,-61,47,37,-63,-105,28,-10,-20,61,38,55,-77,7,24,60,8,-17,51,-19,-73,62,-70,-27,-18,7,33,-49,-87,-68,-99,-6,12,62,45,27,-90,-5,71,-43,4,33,20,95,-92,-93,90,-12,96,-32,81,-54,-42,-65,47,38,-87, 
  /* [461][0][][] */ -58,-80,-41,23,11,45,-2,-4,63,61,13,-71,-29,86,60,-53,-50,91,-64,87,6,-20,-40,-60,43,25,-53,-12,-49,29,90,25,8,63,34,-19,112,46,86,-95,3,-50,24,-22,-13,21,10,-32,-16,33,-18,-68,49,5,56,5,-121,-33,84,50,37,-32,-22,-20,32,19,18,54,-59,-127,27,-75,37,-47,1,44,-8,31,-34,-59,17,12,74,-13,35,28,-34,-5,-1,-22,61,44,-9,-45,39,26,20,-15,-32,89,-49,78,-39,-22,-7,-59,61,97,94,-40,17,-29, 
  /* [462][0][][] */ 5,-1,39,-15,-12,29,-35,9,-39,-6,20,20,59,-27,10,-68,20,-12,-4,17,10,-6,-20,-9,-14,19,-3,74,-10,-4,-57,5,8,-13,3,-25,5,-1,4,99,-20,-7,43,96,-2,59,-5,-40,44,-13,-22,26,5,3,11,17,-49,-34,47,21,-127,26,-36,8,-82,19,-14,-54,14,-39,-55,-15,-10,-18,-3,45,20,32,-6,-23,-74,7,-8,62,-22,-15,-13,-3,-39,-24,48,-47,40,-25,-1,-45,-6,26,-20,-54,-24,-8,35,23,15,53,-35,-65,-21,5,-14,-49, 
  /* [463][0][][] */ -16,17,-43,74,35,-2,-53,10,-6,6,48,-57,11,-58,-86,71,-45,24,-23,-18,-12,14,53,-38,-9,-127,58,19,-15,-104,16,-20,-6,38,-5,11,35,18,55,-18,2,22,42,28,-16,38,-29,-34,35,61,-16,-19,-23,-14,39,-6,-51,-4,54,0,-48,-31,41,-50,-35,95,-41,30,20,-66,-36,-4,5,-28,43,-41,-55,-26,14,44,-38,-16,20,-53,3,4,43,18,16,54,70,68,14,-5,-41,67,-33,37,28,20,-42,13,57,-57,-17,76,55,7,57,27,4,-31, 
  /* [464][0][][] */ 36,-28,66,-47,46,-1,40,66,30,-80,9,19,-6,-69,-43,38,-51,31,38,-58,-23,42,63,-26,-24,38,-6,-30,-26,-32,16,37,-12,95,-53,-16,50,-47,9,-12,49,21,-6,-1,-64,32,6,63,-37,-20,-13,48,-28,-30,68,-3,-78,62,31,6,7,68,-38,-59,10,-30,8,64,17,-43,-11,-23,-43,71,127,67,-6,30,-36,107,-30,99,-19,24,-52,-2,-98,-2,-37,8,70,-37,-9,24,60,49,28,-52,-47,-38,22,30,-81,-63,37,10,4,60,73,-61,55,71, 
  /* [465][0][][] */ -3,-125,-16,44,-40,-24,22,52,-82,-52,75,20,29,25,72,-19,-122,27,17,127,49,-50,-6,-13,78,-84,7,11,-85,-16,-24,26,-45,36,-54,32,22,5,-25,-24,-64,-24,-13,56,-33,66,61,19,-47,-96,8,84,2,-94,47,-7,1,57,-38,-4,-6,-62,53,54,-22,-42,-87,46,-12,4,0,-6,20,-19,-59,50,-53,55,-34,28,-29,2,-88,-55,42,-28,-66,19,-54,-54,-122,-13,-32,-34,-73,-62,-26,6,-29,-40,32,20,-57,76,-9,-68,-40,27,26,86,-46,34, 
  /* [466][0][][] */ 18,-4,-35,12,-8,54,-62,-5,29,-22,-91,-127,30,5,4,95,92,-8,42,-68,-38,42,-54,34,-37,-23,-9,40,8,-25,40,54,55,10,60,23,-11,40,3,-61,70,-28,72,-41,107,11,39,-23,17,73,-2,21,-72,-35,-13,-44,71,-34,-56,81,-11,-20,29,32,35,-18,-119,-13,53,-55,46,-5,-47,76,-15,36,-48,-42,-74,-22,5,-11,-58,-74,68,107,86,62,-75,27,2,45,-51,19,-60,-42,8,34,-52,-72,11,-40,-12,-16,3,-53,36,-100,54,-68,80,60, 
  /* [467][0][][] */ 15,-27,-4,-68,-88,-56,19,117,17,-22,-57,-63,92,39,-4,-65,-74,-2,4,9,17,16,21,-42,-24,-33,-32,-42,-11,59,68,-38,14,47,5,47,-62,-13,-76,16,17,80,-22,9,-20,14,28,3,-20,-9,13,10,77,58,-22,-1,18,-44,7,-22,-17,-6,43,-70,101,3,10,4,-63,54,-14,52,12,85,55,68,44,20,9,45,20,-57,-5,60,4,-31,35,-32,36,55,-15,-3,114,-10,-68,-46,14,-65,-47,-36,-42,43,20,-36,-16,-17,-17,-8,127,31,-39,30, 
  /* [468][0][][] */ 15,-22,77,20,-46,-36,-11,-4,45,-49,27,76,-78,2,29,-82,-5,-46,-14,-68,4,-14,13,-31,-89,25,62,64,52,-11,127,10,-5,53,126,-28,-44,37,61,33,-12,68,-2,11,-19,19,37,68,-34,-23,-45,-55,-7,-43,-39,-15,19,-31,37,31,53,75,16,-43,10,23,-13,-25,34,-62,76,-19,-7,-58,-52,44,72,-40,-14,-81,19,-37,51,82,-7,-97,-26,-29,17,79,-38,34,39,-83,-6,17,50,12,35,35,8,44,12,13,-15,40,48,-68,-4,66,-9,-69, 
  /* [469][0][][] */ -31,50,77,-75,-78,30,58,15,40,-1,33,4,78,-24,48,104,61,-22,41,21,-21,-19,35,100,49,-66,14,38,-38,72,-61,21,22,-57,54,-70,-22,58,12,-12,-14,-22,-74,43,1,-101,74,-11,-22,-86,-27,-89,-22,-84,20,-19,-42,-95,16,126,-33,-7,-3,-2,-91,3,4,72,127,14,-22,-67,-119,49,-5,34,-18,90,-92,-16,1,88,-25,-38,39,32,55,-54,9,-69,-8,-37,-2,72,69,45,103,36,-8,-23,15,-64,56,-9,47,-5,18,-16,35,60,24,75, 
  /* [470][0][][] */ 13,-88,-7,19,-8,33,-6,-23,-6,24,-16,20,-33,-101,-43,83,-27,46,33,17,-18,47,-38,19,-42,-33,89,9,30,-35,21,53,-52,34,11,-18,-37,-19,40,14,-78,-68,32,-11,-2,-28,33,-98,-74,-112,-34,19,3,10,-25,-1,27,63,30,42,41,41,-28,-36,11,64,-21,-17,33,12,-7,-48,37,2,43,5,-76,51,-48,-8,12,41,-46,-38,-36,-15,-61,9,-62,51,7,26,-24,44,49,7,2,10,63,-16,127,-16,-43,-54,-41,37,9,99,29,-26,-33,-20, 
  /* [471][0][][] */ 24,-63,-33,-47,-15,-35,65,-127,-27,22,36,-16,37,-7,47,-57,34,-5,103,26,28,47,-38,14,-37,60,-72,-2,2,-55,-35,-28,81,8,3,39,-89,-5,27,0,72,-31,122,4,67,-66,-81,-26,72,-45,-3,-30,41,-55,20,24,-23,-12,25,-48,-22,23,24,-27,20,-40,31,21,-62,-24,29,30,30,-28,-17,0,-7,-5,11,102,-6,48,48,6,37,-3,30,30,-25,40,30,-20,-80,-42,-36,-22,-30,-45,-2,-24,-25,24,14,-33,46,0,6,-18,43,78,-61,21, 
  /* [472][0][][] */ 1,-60,83,48,12,39,-34,80,-56,-60,-41,32,-44,48,6,50,-81,8,-37,36,32,33,-55,-19,20,-30,90,-10,-60,46,-50,75,61,9,98,-12,-16,-32,-32,95,-17,29,-54,-33,-62,63,-71,57,-42,-18,-16,-21,9,-42,-17,3,12,-3,26,41,96,-14,-49,-60,37,-110,-17,-114,-127,59,61,33,-77,-67,-13,-63,-12,12,-30,32,41,12,49,-67,54,28,-7,-27,26,-53,-62,-62,19,40,-77,-11,2,73,-17,15,-57,-31,-53,-16,-38,5,34,52,27,-2,-85,-11, 
  /* [473][0][][] */ 12,-2,6,-56,22,-15,51,-14,-10,8,70,3,75,-13,-7,-62,-3,28,64,97,9,-6,50,92,-24,61,-9,-57,44,55,41,-26,-63,-48,61,9,-54,-28,87,-58,-14,-16,-29,29,-34,30,12,-14,-33,-54,-4,-70,-24,-26,33,-45,52,-9,65,-14,-20,127,56,-47,-50,-19,-30,20,1,43,74,7,-8,54,-32,-35,28,-35,-38,-27,-20,88,-44,32,58,-39,32,75,11,-65,31,33,-44,-27,14,-10,-66,1,-95,52,25,34,-5,103,-11,-5,-45,63,-33,12,-8,45, 
  /* [474][0][][] */ 5,23,-24,-20,47,-49,26,70,-32,76,33,29,0,30,-23,-53,28,11,33,3,-124,-7,15,53,106,-25,14,-51,-33,-53,9,75,26,-27,-4,57,24,24,-18,-3,5,-6,30,32,-38,34,78,9,46,-69,13,19,67,44,-6,6,98,-45,39,-42,-4,-74,94,-22,-53,-63,-74,-12,-6,-55,-29,-11,7,-9,68,53,-19,-6,10,100,48,79,-85,12,33,-2,-41,-8,-6,26,-38,-90,-37,-60,4,33,19,69,-50,-56,48,-11,-41,18,-16,6,-10,-13,49,-24,-127,-71, 
  /* [475][0][][] */ -6,-41,4,46,12,-10,-38,2,19,-16,-11,-58,-79,42,-50,-66,11,-47,20,-87,-3,32,-33,4,5,-58,57,11,-33,28,-71,52,-22,36,-37,3,67,-32,-50,-7,0,11,34,-26,-18,-54,16,18,4,-63,26,38,53,127,39,-40,-4,-1,36,-27,6,-35,35,-16,-86,-32,49,45,24,-8,59,-11,5,-4,62,-25,-42,-10,42,-36,37,-16,126,18,16,12,-45,-9,-97,47,88,105,22,-9,-43,-93,32,-36,26,41,-68,23,-13,-81,19,4,-49,-19,-23,6,-46,-53, 
  /* [476][0][][] */ 16,-28,-49,-14,10,-32,13,28,26,-16,-23,-7,30,6,-19,33,31,-74,37,16,-38,2,35,-13,17,-10,18,-57,-13,-4,-127,20,93,-7,21,-69,-38,66,-67,51,23,-43,13,79,-75,54,-41,25,13,38,-29,21,-20,-38,-6,-23,-6,-30,16,-16,2,-25,-81,51,-5,-58,2,-32,-41,9,-4,-47,-3,-33,74,-12,-4,68,-14,79,35,-21,-7,-59,-58,2,-31,-4,24,59,44,25,2,-6,30,19,10,-27,11,5,-13,-38,-33,-49,-9,62,0,0,12,-8,-7,-24, 
  /* [477][0][][] */ -36,37,-127,49,-17,-33,39,-80,22,48,32,33,26,-112,-38,-21,-17,54,55,-23,-54,60,-9,-20,-60,-33,11,-28,-58,55,7,-6,25,-59,-18,-46,55,22,-49,-88,53,-102,116,14,49,122,-3,-26,-17,-92,-10,18,-47,14,49,-7,-20,60,33,41,-69,76,71,-11,-40,106,10,-18,36,36,119,34,-39,19,127,76,-45,9,42,-40,-73,20,115,-76,20,17,-9,-53,-102,91,15,44,-43,-28,31,-5,74,4,0,-38,29,-41,-60,-23,24,30,9,-61,27,6,44,-50, 
  /* [478][0][][] */ 26,56,60,40,9,81,49,-29,51,34,-18,-45,-56,72,72,30,-34,51,37,27,-58,-2,50,8,-27,73,-121,10,75,-116,-9,127,36,12,111,-40,-93,80,-59,-122,104,30,-36,103,-53,29,74,-42,61,-20,-45,-53,-29,90,34,-38,111,20,47,-3,46,-44,-57,-38,-55,-4,-16,40,-7,-4,10,31,-21,72,3,-44,-18,-47,-7,-3,40,8,47,-39,5,65,9,-72,1,34,-35,-2,78,-42,114,8,38,-14,45,-1,41,2,-69,32,85,-20,-36,-47,-13,18,-55,6, 
  /* [479][0][][] */ 23,36,-3,-89,40,-10,-55,-11,28,-6,35,9,-28,-21,-70,23,-4,21,-31,53,36,4,-40,10,45,-82,-46,4,-20,-10,-43,53,15,13,-10,-16,15,-19,-74,35,-4,39,16,-39,-43,-14,-9,76,41,-41,38,-9,-55,60,-61,27,73,-26,24,32,55,-44,4,-27,7,5,70,28,-6,4,-30,-8,90,-7,-35,-18,34,16,-25,24,96,31,-19,22,-47,-81,-33,-17,-16,127,-52,-34,-38,-29,14,-5,-16,5,44,-12,49,39,40,-5,-4,28,-22,-15,23,-2,-32,17, 
  /* [480][0][][] */ 54,-72,59,88,24,-18,63,28,-3,45,15,-54,-38,27,-65,-91,13,-56,19,-55,14,-79,-70,38,-72,-25,12,-12,72,-7,-29,-63,23,-52,-2,43,-13,39,88,-75,-25,-43,62,77,23,57,49,-90,-27,-25,13,-38,-73,-31,88,-58,-69,36,-16,-61,-9,-116,71,-12,-54,24,-3,15,0,55,-47,-22,30,-5,-27,55,45,-41,127,37,78,-27,21,-28,-30,-23,-76,-63,-40,-37,-30,37,12,15,-21,-12,-9,-5,-12,-52,-2,8,-36,-78,-84,-66,14,-44,7,-23,37,-124, 
  /* [481][0][][] */ -94,37,102,46,63,-9,27,-1,-41,75,56,13,80,-7,-93,-25,-51,-14,1,35,39,-43,-66,87,32,-67,64,-97,-5,41,34,-50,50,-40,-6,-54,24,-62,-51,-17,-105,7,-17,30,42,-108,43,-61,97,-17,-55,-24,-57,5,-4,45,71,3,4,-34,-66,3,-6,-50,18,11,-2,121,-32,33,88,41,-74,49,-52,16,-22,26,-71,75,52,18,3,-65,38,14,83,10,35,-89,-12,3,-58,-42,-75,67,-7,21,-53,10,57,-21,-1,-39,127,-35,18,93,-40,-59,-5,-8, 
  /* [482][0][][] */ 69,-23,-14,-27,-18,6,31,-49,7,9,-63,101,-27,19,-76,92,5,39,14,-7,62,4,88,-66,1,-69,-22,51,-40,-61,17,51,-63,1,-23,76,-89,-7,-17,-40,33,-51,-12,65,56,-74,110,77,44,33,43,-5,-75,-16,32,77,-106,-23,58,-18,-74,-30,-23,-14,59,7,-10,-12,74,44,47,-17,32,3,7,20,19,-19,38,-35,7,-69,-50,-118,30,7,61,-89,20,86,-79,87,37,0,-4,10,23,-40,90,-49,-55,50,44,127,7,4,-49,-17,-89,43,-51,33, 
  /* [483][0][][] */ 1,-81,76,-15,-20,-44,-46,-77,48,53,16,33,56,12,-81,-49,51,68,4,-60,-29,60,39,-51,9,-29,-70,-32,-19,-96,-61,-34,-94,33,23,17,-67,19,-90,18,99,-29,0,66,-90,24,69,1,22,10,103,-49,79,30,-41,-1,-22,-19,-84,-13,17,33,26,-77,-14,-5,-120,-25,25,-48,59,83,-90,-77,21,-41,53,-39,93,76,3,53,40,-8,-34,27,25,-83,3,7,-29,22,47,-14,-103,-112,127,79,49,-41,43,-76,-3,-63,-11,-97,8,38,-44,39,-15,-11, 
  /* [484][0][][] */ -44,27,29,-88,17,74,-11,-39,75,30,80,38,61,9,123,83,73,127,44,-54,26,51,-7,59,16,-57,-60,27,-9,21,9,46,-63,-31,73,8,-69,-37,-25,42,-17,-30,62,-52,30,-48,45,31,-80,-48,-71,5,88,14,70,76,-68,27,-47,-67,-37,43,-22,-23,-17,6,122,13,10,38,-67,-17,-56,12,-35,79,-73,51,-41,35,-112,90,15,-26,43,-67,-2,-62,-33,34,-60,-44,-62,-71,112,6,-19,-36,29,22,19,-70,38,34,-6,-66,-38,62,34,10,-58,-3, 
  /* [485][0][][] */ -30,-25,-38,-72,29,-44,-50,4,68,11,30,17,-37,-37,86,-79,-46,55,40,17,-14,19,-92,71,27,69,-103,-39,44,-66,69,18,20,-65,78,-7,27,-30,37,30,-75,61,1,20,7,-15,42,44,-10,-31,51,91,-38,12,29,10,61,-18,-25,15,61,89,-61,-16,12,-17,-26,-2,-11,53,53,-7,25,64,-9,27,-51,26,-23,-7,6,49,52,-10,79,20,57,-21,-6,58,89,-45,57,-41,-44,-71,97,-57,-32,112,-63,2,-9,-33,46,-22,20,-41,-38,-127,52,19, 
  /* [486][0][][] */ -31,-13,52,-14,-31,-13,-22,-17,5,29,-39,-5,-56,-40,8,23,12,-27,-6,-5,-5,-35,15,-46,64,-6,21,24,-127,-30,-10,64,67,-33,41,-12,-34,-41,4,66,-33,-48,-51,46,-10,-38,-20,-34,-16,16,12,24,22,61,41,-24,-39,42,-44,-71,-17,61,-22,-59,-30,-75,29,33,7,-39,2,-44,-123,-39,54,21,-25,36,-20,60,38,-23,33,3,-10,5,-54,58,-27,59,10,-31,86,30,22,11,50,3,50,-3,13,0,15,-26,-43,-30,-33,-82,5,56,-17,2, 
  /* [487][0][][] */ -14,-39,13,-26,4,33,-34,-30,33,46,-27,-15,35,-12,-3,-127,60,-4,-2,-8,-18,12,13,17,-12,24,5,22,63,-25,55,-8,20,-18,-41,15,9,17,-6,37,21,-27,31,28,-6,-22,27,-48,53,15,44,-5,3,32,31,27,-33,-10,-42,-37,-4,46,17,6,-7,16,-31,2,-18,3,-9,-3,0,-19,-59,3,11,-66,-21,-38,33,28,4,32,-3,22,-7,12,22,28,-11,8,-29,-36,4,19,32,23,-34,42,-17,-16,69,-2,-4,45,17,-39,-40,-14,18,72, 
  /* [488][0][][] */ -28,14,30,5,-4,-2,21,-26,-23,47,53,-2,-21,66,23,18,14,-5,-17,-14,26,22,1,18,-29,-27,0,-23,20,-32,0,-31,-7,42,2,0,0,49,32,-6,36,-27,46,-16,-65,-21,-2,-29,1,-33,-13,-4,-12,7,38,5,127,17,37,50,18,-12,2,3,-25,3,1,11,-4,-50,81,18,-24,-2,47,5,-32,-18,-13,-29,-5,-16,24,12,53,17,11,-5,55,72,14,16,-1,17,-8,-13,-17,-1,-4,31,6,-7,-25,-14,38,19,23,41,48,14,28,-15, 
  /* [489][0][][] */ 11,29,87,-9,-46,-28,-19,20,127,-6,53,3,24,-26,9,-62,5,-27,71,-34,67,-38,-17,-20,32,50,17,-34,28,-15,-3,14,-66,37,15,19,-1,-28,-52,70,-41,-60,-17,-50,-37,-9,51,-30,44,-23,13,-45,-11,-106,43,-10,-65,-108,8,-50,46,-12,95,29,4,73,-15,34,24,0,74,23,71,26,66,-47,-22,51,-8,-28,-83,-79,-9,-28,27,60,44,-46,-29,-15,13,-19,55,81,57,-46,-92,50,-5,-37,-28,-68,26,-2,7,-40,-19,2,77,-34,-8,16, 
  /* [490][0][][] */ -72,-82,49,9,61,15,28,35,-15,14,33,-69,24,-11,-11,3,-10,-51,2,-36,-68,8,-70,23,28,-77,-76,32,6,-12,2,50,76,-5,-28,33,14,-50,7,15,-43,57,10,41,85,-16,45,29,50,27,-16,59,-32,80,-9,-26,-6,35,30,18,22,-43,-20,-59,-30,-7,38,8,12,-42,-9,1,-49,12,-23,21,-7,19,-19,2,-43,6,24,16,-3,-9,-25,5,127,-27,17,-24,9,-11,-13,-2,16,-22,22,-7,9,0,-19,-2,51,-77,-2,4,0,-22,31,-24, 
  /* [491][0][][] */ -15,-108,-63,3,66,-29,10,56,1,21,-32,25,-24,31,42,31,43,-47,3,29,-103,-29,-63,27,4,-15,-15,96,2,-127,-96,19,51,-95,-17,-57,8,-17,1,-71,-9,-70,-51,-44,-33,-53,22,23,77,-97,-36,-47,84,-20,-2,-27,11,-7,-14,67,-64,-5,33,-124,-16,-3,16,9,-59,-62,66,-32,6,-58,51,62,-49,61,49,49,-4,50,-81,29,16,-32,12,30,-12,-14,76,-35,-62,-66,-8,-9,34,-49,-17,54,-1,-34,-11,67,-36,-53,-79,41,-36,-64,-75,-49, 
  /* [492][0][][] */ -47,-16,47,-50,46,21,89,27,37,-22,75,-45,70,-38,55,98,-109,-13,59,2,-33,-56,31,-1,24,70,-108,-35,-13,-17,56,43,-1,28,75,38,-127,29,-7,-22,80,-6,50,23,44,13,-115,-14,-68,14,-16,-35,-67,-32,19,-44,68,12,26,26,-2,-86,7,-2,4,17,74,19,-17,60,-24,-92,61,4,-19,-56,-109,-6,29,-21,-50,-27,-26,-6,-27,-10,-100,-27,-93,-23,-52,-66,19,-67,14,-53,-81,52,-32,-3,-28,21,76,-111,-10,39,40,-3,-8,7,-74,-18, 
  /* [493][0][][] */ 62,70,29,57,-21,48,-52,-13,42,11,22,-14,-39,-60,29,-83,-8,10,-41,-45,-38,99,-65,31,-20,-21,14,-35,-2,-16,58,-19,-57,-10,74,14,15,-84,-19,79,-43,-43,17,4,3,-22,52,36,-42,-15,-22,-10,72,-25,22,-59,-62,-16,-37,-34,78,-6,-33,31,-78,-52,77,85,29,-21,-39,-58,8,28,59,50,-36,-24,-58,11,27,51,-45,-83,70,53,74,-28,-83,-6,-38,-22,51,-13,4,-69,8,35,-127,-38,14,-46,59,-10,-14,-82,-2,36,-11,23,-17,25, 
  /* [494][0][][] */ 31,-35,67,-17,-37,12,27,57,110,44,127,-44,16,-11,34,-27,-14,15,-32,-81,-28,43,13,-28,26,-67,-34,2,-30,33,19,16,-14,10,-47,-17,27,-4,-33,-13,-3,-110,52,-19,15,-43,57,7,51,23,20,-61,17,-38,78,29,-15,-6,-1,14,-36,-32,77,66,-34,11,-14,-22,23,6,24,-33,61,35,39,66,-49,-17,11,15,0,10,19,16,2,107,-56,34,-23,-14,30,13,-28,-71,42,22,6,-45,45,-12,-8,-44,-32,-84,7,-26,-22,10,39,58,-22,47, 
  /* [495][0][][] */ 44,-35,-13,-18,16,28,0,3,-28,36,-15,40,35,-6,-5,33,26,-36,53,38,-23,-20,-27,-2,-43,61,-15,-30,2,7,9,34,54,57,-16,-3,-15,38,55,-5,7,42,0,-54,-36,5,-2,64,31,-45,-2,27,-56,6,-18,-24,-22,-62,4,58,33,48,-1,-38,-9,-11,-36,-127,29,12,4,34,22,-27,50,-27,-42,23,-42,38,-23,-38,-39,-29,-2,-65,-8,2,-67,-25,-9,6,28,-9,-2,16,-7,2,17,54,-19,-28,-52,5,13,-3,-24,-15,-13,1,-30,9, 
  /* [496][0][][] */ -32,-10,-96,-24,80,-5,57,20,13,-80,88,-10,-1,65,36,-57,-34,96,31,-27,-88,67,50,-69,-39,55,2,21,48,-65,44,-52,-20,-4,54,30,-16,-47,-3,30,37,31,28,-99,-42,-1,-12,-36,36,20,-33,32,48,23,12,-43,23,29,-36,-3,62,124,-52,32,-8,-82,29,12,-62,7,2,-30,-52,-2,10,8,-49,75,-36,-53,-28,26,65,18,46,78,3,14,42,-23,7,52,19,-74,19,0,-51,42,-39,-49,7,0,-26,13,61,5,31,127,-33,-19,38,-16, 
  /* [497][0][][] */ -1,89,-51,39,-106,47,9,-27,-72,12,51,71,-66,-20,-11,-28,-12,91,36,0,71,90,47,-95,-50,59,33,56,-16,-7,44,5,-95,54,127,10,3,-21,75,-13,67,30,11,62,48,13,-36,-24,-43,-53,73,18,58,109,-61,57,31,31,-41,37,-10,-15,77,-14,36,-43,-16,13,-14,29,78,7,47,42,-45,-68,-61,112,-37,-38,6,10,49,62,80,3,24,65,-50,52,7,58,-113,14,109,33,-22,-94,78,47,14,48,27,-96,26,-72,-60,53,75,90,-115,15, 
  /* [498][0][][] */ 0,65,-21,-8,28,38,0,35,-21,43,30,-48,-37,-7,-2,-14,-9,-43,-34,31,81,51,-36,20,-26,54,-75,13,-7,-10,-22,-18,4,16,-33,29,-34,33,27,69,127,38,-61,-2,4,5,20,20,-27,-31,6,-99,22,32,107,-23,32,-29,-28,24,-76,20,-17,52,2,29,-74,37,67,19,27,3,-26,62,21,-32,-14,-10,-38,-16,56,16,-33,-21,57,28,0,59,-18,64,39,13,-18,-18,-27,-33,-36,21,-81,12,27,-39,0,8,57,33,-100,1,15,-47,-8,32, 
  /* [499][0][][] */ 34,-50,-66,3,11,-34,41,-37,-102,21,-46,-82,70,-55,44,-19,-23,124,-20,-24,57,-16,-107,-105,-68,39,64,-29,55,48,-10,-30,32,59,52,21,32,97,-5,-56,76,1,24,-41,62,51,15,56,-59,61,-6,13,-24,28,53,68,-80,-2,-32,-56,-96,4,48,-56,69,98,45,-81,-58,59,2,0,-23,68,1,-127,-58,-26,47,49,-18,-40,-45,54,-86,101,-105,-39,-40,16,-46,-68,16,105,4,-22,59,37,-40,-101,-29,-61,-34,-62,-53,-8,-26,5,-6,9,17,-124, 
  /* [500][0][][] */ 35,122,-1,-27,-18,97,-40,21,89,10,114,68,43,14,36,30,-32,-8,21,-77,46,63,13,13,35,-36,-62,52,38,-24,-31,51,26,-127,-42,53,-34,-17,-59,14,39,-3,-4,37,7,85,-13,52,69,-64,-85,-12,30,58,63,-27,62,-9,1,-100,-119,-57,-13,123,39,-43,103,18,57,64,84,-20,-30,72,-39,-16,26,44,52,-72,-46,55,-43,73,-60,22,-94,53,107,-81,39,-45,77,-14,-65,35,24,-91,124,5,-14,41,-62,84,80,72,-13,-71,-10,-6,-40,106, 
  /* [501][0][][] */ -38,18,-6,-18,-11,2,63,-32,-18,-73,-19,46,9,6,45,-16,-58,-2,64,23,47,9,-22,-7,-124,-32,-31,-16,-66,40,48,-27,-80,-66,-14,-11,-64,-23,35,99,2,-36,47,4,-90,5,-102,95,-40,-41,7,19,7,60,-44,-67,1,-16,14,-22,-27,-68,-2,-59,-13,27,36,-6,-9,-12,55,8,-69,-54,-54,-27,-108,43,28,-23,-42,-14,-51,23,-19,-38,-79,-19,-14,47,41,-76,-102,-38,39,32,24,92,107,-15,-22,-48,3,69,27,28,-21,-18,127,-58,-30,-52, 
  /* [502][0][][] */ 14,35,-54,-40,12,-44,9,57,-43,57,15,55,-27,-25,56,37,1,-74,-34,22,-17,7,-28,20,17,57,56,3,-55,35,-37,34,-48,-9,18,-127,-13,8,12,36,9,-15,-2,19,55,-19,-27,66,40,-44,-13,0,-46,-25,-54,37,-33,1,-22,-1,26,-32,-17,17,-41,27,25,27,72,-22,46,61,-44,3,-39,-25,17,4,26,74,-43,84,5,84,7,10,-10,24,22,-44,5,-44,36,-12,41,12,-12,10,-38,-33,51,32,53,18,-8,45,39,42,49,14,-37,15, 
  /* [503][0][][] */ 18,-14,-25,-1,-11,59,108,50,34,-27,-23,-52,10,57,-3,-14,-98,-63,67,45,-25,50,77,45,37,51,46,-49,-54,50,35,65,-68,-4,-25,-58,65,61,-90,-35,-64,18,56,-14,-62,84,25,30,72,37,80,-11,71,43,-24,65,-16,-37,-60,11,-7,-34,-26,101,-29,56,15,-72,6,103,7,-16,35,-100,5,4,-95,-28,-36,15,40,77,-74,-127,23,-61,-97,-9,-84,49,-65,10,-53,-10,-14,32,-61,-33,4,44,97,60,-16,-67,83,-30,27,1,-4,-27,38,-45, 
  /* [504][0][][] */ -58,-56,-40,79,51,-11,127,-12,15,-53,87,-86,23,-18,53,29,-46,3,-20,4,-14,-6,-5,78,-14,-58,-77,-41,1,-104,41,-85,33,74,51,-4,-35,-26,48,-31,-50,-46,24,42,-10,5,-72,-45,-11,74,9,-20,-101,-48,7,72,-75,-4,-58,120,-16,69,3,1,-56,12,-73,37,69,-79,85,65,85,47,65,31,-35,-92,-31,10,47,-3,65,48,-14,-2,-32,8,-74,-19,32,54,-45,-89,-28,-103,-81,-20,15,26,-26,-91,48,-70,12,23,7,11,7,28,5,9, 
  /* [505][0][][] */ 9,-127,-15,22,10,-11,-25,27,-20,-69,-100,18,34,-44,-98,-54,-56,-38,2,-30,27,39,5,53,-53,-76,48,23,38,42,-50,-9,16,33,78,27,88,52,22,26,31,46,50,23,31,43,58,10,-6,-55,-109,33,-32,-35,21,14,28,-37,17,71,-73,-9,-28,40,44,-39,-13,-10,66,6,-4,-24,64,58,71,1,-57,-70,20,-51,-81,73,25,-84,-3,50,-2,-3,28,-59,121,-33,-71,25,-2,2,17,82,71,-77,-88,62,7,-35,-20,-103,76,-47,-27,29,-51,-78, 
  /* [506][0][][] */ -11,-47,32,-56,-9,-54,-53,-48,-16,53,-18,-55,28,39,-43,47,35,1,-13,-35,-15,-70,-26,17,9,-6,42,39,64,-63,-46,77,36,18,-46,-2,-34,72,45,-51,14,18,-18,-1,91,-57,23,72,26,62,-29,10,-69,-25,34,-37,58,-87,-41,-92,11,-11,127,23,29,22,-6,-99,15,-14,63,27,-20,39,19,21,-31,-13,-89,28,-26,102,-9,21,9,-17,26,-53,-7,65,53,-25,35,29,-9,53,32,-6,-61,-6,39,20,50,78,17,-6,-81,-29,9,-15,10,16, 
  /* [507][0][][] */ -31,18,40,-30,18,-68,4,56,-37,-49,-22,2,-36,19,27,-46,-4,-78,36,-27,-44,-21,-59,-12,14,27,-2,51,22,29,70,-41,35,-53,73,-46,28,-43,-16,26,-76,-105,-21,-24,-52,62,-11,6,-78,25,-25,48,43,-24,127,-16,60,14,-43,74,100,72,-46,-22,-35,-27,-44,-15,23,18,-25,-53,-33,-22,87,61,-41,52,36,-55,20,19,44,-50,-59,-102,-36,59,-5,-17,-47,25,57,81,41,6,32,-2,-22,-8,-62,30,34,-25,-56,49,-9,44,71,-12,95,21, 
  /* [508][0][][] */ 127,-26,-11,-1,-10,3,-37,9,24,39,-15,-23,34,-28,17,66,-28,-41,-26,-15,-29,-26,-30,19,-19,15,4,18,9,-15,-1,-46,-9,44,-49,46,-73,22,-22,-48,-56,-62,-18,-51,-24,48,12,30,66,37,-1,70,-9,48,-37,13,-4,-8,24,-8,57,-55,-46,-8,10,17,-23,7,5,-44,12,-5,21,16,-19,-77,-17,-22,-64,10,73,-40,-19,-28,-21,36,-62,49,33,32,-37,27,-36,52,-16,-5,-69,-1,15,-6,33,7,5,87,11,5,-19,-49,-94,40,-55,-18, 
  /* [509][0][][] */ 0,32,-52,-46,14,-23,19,28,-4,-21,-58,1,-48,-24,3,6,-48,39,-20,31,39,-1,89,-10,43,51,-9,9,-5,11,-41,-40,15,-18,40,-28,42,35,-3,-12,-39,44,27,-38,-31,8,14,41,-36,-28,38,-51,54,28,28,-37,68,2,24,99,-11,-7,-41,-29,-31,127,47,21,-13,32,53,-27,45,-5,33,-48,-32,19,62,-31,-8,16,-63,-50,24,-62,14,1,-11,-53,34,14,7,30,56,25,56,-14,-21,56,1,-24,-3,-27,-30,-82,87,-24,-58,-23,49,6, 
  /* [510][0][][] */ -41,-30,-18,42,-55,35,71,92,-9,58,9,-48,20,10,-42,-4,58,28,18,-57,34,-38,45,14,49,24,-43,82,-2,-16,-16,17,50,27,-50,-54,31,-2,-25,5,-14,47,37,24,-24,-57,-46,-97,-21,-11,45,-55,41,42,51,-74,-22,27,-7,60,-50,-17,-88,5,-5,-66,57,44,28,53,-36,105,65,13,92,64,-78,41,-104,88,38,-40,-21,-70,-28,35,48,-5,-13,22,-72,-26,31,-78,68,59,-14,6,-7,5,5,-6,127,-28,-17,24,-57,13,-27,-33,26,76, 
  /* [511][0][][] */ 23,-104,-19,60,93,86,38,-7,-27,-36,21,-27,38,99,-34,-47,-98,-80,-30,-86,-70,-37,-117,20,4,43,-52,65,45,99,56,7,-5,-40,56,37,-49,15,73,-18,15,-33,3,69,61,-35,67,122,55,-127,62,72,67,-14,96,3,-62,-37,-33,73,43,22,127,-84,9,19,-47,-23,65,-63,-68,46,-59,-48,-48,-57,19,12,59,-1,9,19,-61,-28,16,-39,-30,7,7,-39,26,-86,108,101,-60,-17,-14,1,-57,-55,-28,18,-101,26,-2,-3,-2,21,-10,15,-40,28, 
  /* [512][0][][] */ -31,-36,-15,-42,31,14,-27,-3,40,-30,108,-5,17,92,56,4,77,2,64,-127,38,79,110,-44,59,81,19,72,-52,103,-12,-78,49,-1,21,0,27,-70,14,-52,-9,25,-17,23,0,66,-38,8,18,89,-99,41,-92,-47,-14,-27,69,-21,17,70,34,30,-19,30,-15,-49,64,-16,-11,-2,33,-28,-86,-37,-17,-50,56,-44,-17,88,17,30,58,-119,-9,13,7,10,-36,47,-95,29,-39,26,-40,87,-56,-92,-7,51,-65,-46,-34,-12,-68,-16,14,-71,-1,34,10,-38, 
  /* [513][0][][] */ -83,53,-16,45,-9,-14,-1,53,-8,-57,-5,44,-13,46,-5,-53,4,-32,9,1,-25,-17,13,22,11,-28,64,-85,-39,19,15,45,42,-55,-11,-35,-51,-35,69,49,-18,62,51,46,-127,-2,20,-25,-3,-19,4,-6,-60,31,86,51,-101,-112,1,-4,-15,-33,-13,22,84,76,-83,27,-15,10,36,-92,-12,-44,-87,-34,-57,113,-37,5,42,-20,-44,-60,66,-13,59,-77,-45,-31,-67,-17,10,-16,-90,14,-48,82,87,-49,-18,-30,66,-66,6,70,72,4,61,-11,-11,4, 
  /* [514][0][][] */ -21,37,93,-67,-47,-48,-54,-11,98,2,17,10,-18,-7,15,-43,6,-73,12,-109,-79,43,45,0,52,-63,-4,78,13,-49,-41,-14,71,-13,22,-75,-4,-19,5,-53,-53,-50,-21,19,21,10,19,-58,11,14,-28,-2,-12,20,-6,-35,81,-38,58,4,-8,31,-41,21,-8,-22,-5,-7,-1,-29,-26,-85,-36,-10,97,53,10,24,-29,65,22,36,13,-30,-15,-9,-6,-50,64,1,-59,-3,6,57,-15,50,21,67,28,127,13,-7,57,-43,34,-45,-6,-41,-31,-26,65,-14, 
  /* [515][0][][] */ 24,13,-103,39,12,-87,88,-43,-67,-127,26,-36,24,-1,54,87,-83,-4,17,86,90,-20,-111,-24,15,-33,-26,-95,-49,-27,-58,-26,-102,-70,-27,-13,77,8,44,75,-16,63,-31,-66,15,-26,-93,73,-96,-21,46,85,-53,-66,-54,-13,-79,-7,-11,100,41,40,-23,-34,1,-3,70,81,5,72,112,-21,-1,56,-11,2,-109,19,83,26,-49,42,78,14,40,41,54,98,-13,40,69,22,87,-24,-31,-12,58,-70,-80,-34,-68,5,75,5,45,8,97,-51,-69,79,52,-37, 
  /* [516][0][][] */ 18,-91,-36,87,9,31,-59,52,-103,13,71,121,19,-51,12,84,9,-71,12,-87,98,-97,-23,7,-2,-70,-38,84,32,-117,86,-65,-107,64,28,103,0,-19,11,5,-35,19,-44,15,-71,7,-93,73,-91,89,57,39,-71,-9,67,-53,94,27,3,28,63,-11,-2,-32,-40,49,56,11,104,56,37,-26,-17,-32,45,95,-30,89,16,-92,43,47,-13,-58,98,-7,-84,-49,-17,-28,26,-62,-13,19,-125,-27,36,6,-14,-15,-50,127,-26,119,-28,15,18,-39,-88,-10,16,23, 
  /* [517][0][][] */ 46,19,12,-12,-18,48,-14,127,15,-1,11,-8,-13,-20,25,0,-31,-1,63,5,20,70,3,-31,62,-8,40,18,-3,-55,51,-45,-47,7,-13,15,8,-7,-69,-2,-27,-66,-42,64,33,20,-77,26,12,56,14,-61,2,-3,49,-36,-37,-6,9,46,-4,32,-30,-44,4,-45,25,38,28,-32,36,-35,5,31,24,-48,6,4,22,-6,52,57,-54,2,13,-23,-45,-24,53,-20,-29,14,-35,-66,5,-16,34,-22,6,-9,63,45,53,8,26,-69,-66,48,-13,16,-66,9, 
  /* [518][0][][] */ -79,-19,-54,19,17,28,30,9,-17,7,46,-9,-50,-18,58,32,-3,-53,7,-2,-114,-28,-20,95,-73,-21,-108,-70,-79,7,13,53,73,70,33,-19,-33,71,-19,63,-15,41,-14,-23,21,30,-3,80,26,29,84,-42,3,10,73,35,-26,27,-39,127,-12,-11,-15,31,28,36,17,-20,-24,-26,22,27,-8,56,8,17,-54,6,121,-40,53,20,23,28,13,-68,-118,-50,-20,43,4,21,-12,25,-73,-78,31,-21,35,-3,15,-81,3,80,-31,-21,-49,47,-45,28,-31,51, 
  /* [519][0][][] */ -64,-58,-100,-9,77,96,29,-40,-22,-127,29,-11,-29,15,40,-39,19,-126,-7,-27,-55,-17,-19,76,58,-38,-29,38,-46,-62,-79,-33,-48,59,55,-44,-77,59,8,9,6,9,49,14,-38,-38,26,26,-8,26,15,69,-2,-2,13,39,-27,15,-20,18,-17,-43,-27,-40,-43,52,-1,20,-8,-36,-64,-23,-46,15,15,-34,-42,76,54,-57,-74,55,35,-26,-43,-15,-20,-46,-21,-46,67,49,31,26,-62,13,81,87,22,11,-71,104,11,-28,9,12,-64,-26,-8,1,-14,-5, 
  /* [520][0][][] */ 77,-1,63,-61,54,-16,3,6,61,-43,11,-40,-49,70,-18,-33,-10,60,39,115,-2,26,50,93,-28,-38,19,-47,59,23,-91,-22,30,22,13,-37,-72,-42,20,56,-34,-17,-95,13,-61,93,-7,89,-41,-67,-27,-66,-67,-90,15,15,-34,12,-90,11,-13,36,-60,41,-17,-17,127,-10,-66,80,37,-1,22,88,17,103,11,20,43,-23,33,74,19,-4,-4,-50,-59,-8,-52,29,-6,3,23,-82,35,95,-26,52,16,-6,-97,-20,-35,8,26,-55,19,-28,-2,-33,32,25, 
  /* [521][0][][] */ 27,-68,79,-3,9,34,-87,56,-76,13,40,49,22,-65,17,26,50,38,19,-97,-35,65,17,38,102,-92,-118,-63,58,43,25,43,-29,-33,48,-42,-33,-15,31,-38,37,20,0,66,27,22,-12,31,92,116,-30,-58,71,68,12,4,0,-34,49,-10,107,75,-2,75,-59,-41,64,53,18,-107,72,-68,-36,11,-26,-39,22,27,11,56,-7,-33,-25,-61,-40,29,-8,-52,19,44,-85,-54,120,29,14,-26,-62,-40,-87,-59,19,-15,-127,36,-21,36,-11,30,105,-52,-93,-43, 
  /* [522][0][][] */ 57,-12,22,-19,-48,-57,61,-46,108,-32,-58,21,-39,38,35,-27,37,-19,-54,-22,-21,-13,-46,-25,-15,19,-47,3,-15,-34,-22,2,24,29,64,-96,-7,-9,3,-3,-38,-12,98,-127,-7,100,23,-60,45,14,44,4,-17,-32,31,4,-68,22,-41,-43,29,57,32,-23,-69,36,29,-46,32,18,-111,-39,78,-23,-18,-18,-22,-94,36,-35,-6,-14,18,-6,-29,-2,-101,-34,-88,30,-11,15,28,-23,49,-25,-17,-17,86,-23,18,-68,-11,-54,27,12,-42,49,6,38,-59,52, 
  /* [523][0][][] */ 28,112,-62,-19,27,37,20,41,-49,63,-14,1,-70,119,43,22,43,4,-15,10,-54,27,-11,-12,-27,-43,24,-35,-76,-35,-26,86,-23,43,-17,16,-9,70,43,-37,-97,-29,-127,47,-9,-24,-39,39,-76,84,28,-46,-63,15,10,-46,-42,3,-80,-38,54,5,8,-67,-60,-72,36,-5,97,-9,35,-15,-79,-18,60,82,-23,60,-104,-19,17,52,35,-36,-33,31,72,-61,-15,79,6,-15,-30,-22,-62,-4,-46,47,60,-61,-11,2,14,-7,-8,8,58,-7,-25,-104,-37,13, 
  /* [524][0][][] */ 40,0,-38,-36,-28,29,13,-103,3,19,-101,-48,55,-10,-25,78,-37,-41,-15,21,0,-60,67,-32,12,-58,50,-10,-13,-38,44,15,50,10,38,-20,-51,127,8,-3,-33,-16,28,-43,-74,-43,37,-7,-104,-8,18,-74,-29,75,-23,-44,-58,45,-106,-1,42,28,-39,-57,79,35,17,-47,43,-60,24,10,37,-31,-115,-116,-15,10,16,12,-11,54,-25,-35,-54,5,-46,-34,-28,-31,-100,-85,55,-44,0,-22,-4,35,-33,-6,75,107,29,12,10,36,8,80,-28,82,12,2, 
  /* [525][0][][] */ -44,-60,23,30,52,10,-2,28,76,57,-56,-9,-26,58,-105,28,59,-34,-127,53,13,-84,54,-63,1,51,31,-43,33,67,-79,-43,-53,-37,29,-13,1,-70,117,28,-111,-50,-89,44,-32,-39,-16,123,27,78,-13,23,73,-81,57,-16,-71,13,-55,49,59,25,-37,69,25,-52,22,-22,-2,15,-85,26,47,0,-73,-3,37,-19,15,-69,94,-73,-51,24,35,33,-40,-54,-10,67,-97,30,-55,35,2,109,-60,11,58,-20,47,-4,-34,25,-109,-32,-30,45,-94,90,5,70, 
  /* [526][0][][] */ 41,-79,-79,-116,-55,-36,16,-18,-46,-44,62,22,-67,-76,15,-36,-83,32,-5,-12,11,27,-60,-29,24,-39,48,30,-1,28,100,9,25,-87,-47,14,-20,49,4,22,-8,33,-12,-10,-65,72,-6,37,-36,-127,-44,74,26,125,-32,5,88,17,36,46,24,-15,5,-96,-39,21,-3,73,61,34,64,-71,-67,-6,-30,12,-74,43,43,-100,-44,5,57,61,99,-74,-31,124,-90,53,74,100,44,12,30,50,-2,-96,-13,-21,-78,-4,-20,-104,-81,4,112,35,16,-30,-61,91, 
  /* [527][0][][] */ 63,19,14,56,-43,-38,-23,50,-14,22,28,-22,37,23,4,61,0,96,-60,-85,37,127,36,68,-67,-58,-37,-46,-28,-26,7,33,15,40,40,-14,-19,-73,-6,104,-12,51,-14,34,-66,37,46,-50,-72,-46,-30,-15,14,-58,-60,32,-29,-25,-13,-40,24,-74,-24,47,28,20,55,-62,9,42,-11,-14,41,5,65,-13,-79,18,32,19,-18,90,-22,56,-12,23,-6,37,-11,95,28,-29,17,-58,6,-64,-50,-54,19,-58,-41,31,-3,-58,-45,-67,30,-70,61,-50,-26,33, 
  /* [528][0][][] */ -50,-33,47,-49,-35,-10,79,2,56,44,-30,21,-59,12,-126,-35,-40,-34,42,6,-89,46,14,41,29,-7,21,-27,-12,18,-122,48,-9,-32,54,-53,34,39,79,-9,-25,16,7,69,9,-65,12,-86,-2,-35,46,25,87,50,33,-3,-127,22,-47,28,44,16,89,10,31,-62,-54,14,53,-2,-19,-79,-114,90,17,-53,-50,33,80,55,28,65,17,-9,-30,-39,-56,44,38,-90,77,-40,1,26,30,-52,127,13,-57,-36,67,-72,3,-89,-19,-9,-105,104,15,54,11,-11, 
  /* [529][0][][] */ -24,31,-26,43,32,-22,-11,-24,-4,-49,34,4,10,-12,-21,-49,44,10,-23,38,-50,-71,4,22,4,-22,33,-22,9,-64,-67,-19,59,-60,46,-41,46,59,38,-47,77,36,66,7,110,-10,47,32,-1,81,-12,24,-26,-49,16,47,-41,-53,27,70,-21,-9,-68,64,2,12,-6,11,-18,2,-22,-4,-45,17,-73,13,4,-6,27,-11,-58,-2,-23,-32,-5,21,6,-41,-37,20,27,40,2,-88,-12,-23,23,9,39,72,34,29,-56,53,39,-19,2,4,-14,31,127,26, 
  /* [530][0][][] */ -27,-57,-13,48,11,3,-38,73,25,5,-37,-24,13,-21,22,-127,-28,-49,32,3,-22,-54,-30,-54,-15,-10,67,-34,-79,24,-8,47,29,11,-17,-71,31,-24,99,99,-12,-18,-3,17,-5,-45,-11,0,8,13,-72,-52,-25,-13,-56,20,-33,-2,59,15,23,-34,13,0,56,7,10,27,31,-57,71,29,-2,-1,8,-17,-26,-26,-45,42,37,18,18,-4,-67,42,-36,-23,-9,24,-53,1,26,57,-13,-12,-54,-44,-16,40,20,-12,-12,19,-34,-22,-4,-5,-37,22,12,12, 
  /* [531][0][][] */ 55,-17,-75,-48,-44,24,12,-118,-65,-21,-47,32,33,97,-59,48,-63,121,28,-35,64,45,63,23,13,37,43,1,-52,11,-30,-44,-23,-48,-40,-28,100,-11,24,-24,47,-8,10,69,11,4,48,87,9,-54,-62,-53,86,75,-26,-8,127,0,-16,94,-50,5,-48,-21,-28,-73,26,41,-24,73,36,80,-53,-38,-55,74,55,-78,31,-3,11,44,-92,-70,-76,-36,18,-5,-21,-64,-4,-32,-56,-12,-11,-32,13,-56,22,-9,-29,-59,-45,50,-25,-3,127,-81,-33,64,45,-95, 
  /* [532][0][][] */ 49,-65,26,12,28,56,-26,-72,-47,-52,18,25,32,-8,-91,-29,7,-60,39,-48,-29,-58,-46,7,72,34,-32,-90,-54,-15,-51,49,17,87,9,-13,2,-6,-122,-31,127,-41,20,26,-33,-12,3,44,16,9,30,54,-53,77,-26,82,-10,-6,102,-79,-16,-22,-2,71,21,57,-65,12,-56,20,-15,-41,-66,20,-80,-8,-15,-84,-1,19,101,-21,17,-15,5,7,-2,35,-88,25,69,-10,-44,-46,-16,-98,4,2,-10,40,-19,44,25,-26,16,18,-53,80,-29,34,45,9, 
  /* [533][0][][] */ 13,0,-36,-38,54,117,24,5,18,28,33,-15,-86,-86,45,-38,-79,15,22,-28,-16,-9,-62,20,14,47,-51,10,14,-36,-16,-70,-49,55,46,-28,-2,8,-14,18,31,-18,22,21,13,-24,-59,22,-6,-86,43,-4,2,-8,-16,17,-127,-2,-3,42,-75,50,47,45,-36,37,-28,-40,-6,31,18,-34,43,24,35,-81,34,-23,54,33,38,27,-32,23,52,-26,-21,74,-57,-11,28,-22,54,11,27,6,25,-23,-29,7,-28,-41,10,14,-91,-14,-2,41,20,-25,-14,40, 
  /* [534][0][][] */ 24,-55,-39,42,16,-37,-5,36,-12,-100,7,-1,-3,-29,25,17,59,15,-85,50,7,16,68,-42,13,-3,15,-5,-28,10,-5,-24,48,-48,-13,60,-20,-14,15,11,38,6,31,-21,0,61,40,-25,27,-33,-32,-26,43,1,48,69,-25,-36,-45,44,-42,-127,-8,-126,19,-5,-10,-79,-45,27,-4,17,36,31,-65,43,-11,-26,80,124,18,36,21,-11,14,-52,13,24,-8,-60,9,52,-19,4,-105,-15,-23,-7,-17,26,56,67,8,-16,23,-21,45,26,-42,38,12,25, 
  /* [535][0][][] */ 59,-36,15,20,-2,-19,-127,-12,21,-9,48,23,38,-72,36,18,-54,-22,59,-25,-11,-55,-49,0,-24,27,17,9,-114,-10,31,-53,40,-17,26,8,-65,11,95,-4,33,20,-19,-36,11,-15,-59,53,-38,-42,-91,-52,16,88,61,4,-73,6,5,24,42,43,11,-82,-94,-33,-4,26,18,-85,46,-67,-46,-46,100,77,-39,-37,69,21,-28,33,-53,-63,-14,42,20,-51,2,8,-26,98,-74,-13,29,-18,18,-38,70,43,-66,-23,-67,24,-43,-9,-39,29,-40,72,-67,-21, 
  /* [536][0][][] */ -20,49,-68,-24,7,17,60,19,-15,-47,34,-26,11,15,51,-49,-44,-33,-65,33,33,57,-7,31,-4,-11,-23,27,-11,-6,9,-6,42,-35,46,-10,63,-28,12,-5,5,112,0,-28,40,-9,15,30,3,11,75,54,-23,-27,-45,39,-23,-31,9,73,41,-2,55,-9,37,-8,-35,26,-27,12,-6,-49,80,-34,-38,-7,-3,-50,-20,46,-27,-18,33,35,-30,50,-23,51,-43,66,-9,41,-25,36,-127,54,24,-20,-19,-3,26,-11,17,50,9,-3,17,68,0,73,-63,50, 
  /* [537][0][][] */ -26,-53,-1,15,2,17,33,30,36,-24,-23,-37,86,-54,5,34,-2,-72,-127,-2,21,44,27,-21,-33,-36,-44,22,33,-25,-11,55,-56,46,-37,15,-3,-49,-33,-8,12,-39,65,-42,-45,-79,29,16,-60,92,31,-23,5,14,51,-22,5,20,34,56,-11,-1,4,9,-56,30,-42,114,52,-20,-69,-44,40,47,-7,-4,-42,21,-3,81,-9,-52,-12,11,-35,100,-1,-25,68,9,20,-57,-29,-38,3,55,-57,55,36,-75,35,-34,-2,62,6,37,62,45,83,2,-71,-45, 
  /* [538][0][][] */ -44,58,45,-7,44,30,-59,12,20,-10,-6,-30,-68,-29,1,23,44,59,13,-4,-27,86,48,-57,-40,-9,-36,-41,-1,-22,-29,-127,-37,37,-26,22,-24,27,110,-32,-9,-47,-2,4,-4,15,34,6,67,-25,-4,1,-21,9,60,13,-29,-58,-53,27,-43,67,76,-50,-18,-15,1,-45,29,0,33,46,62,112,6,58,-75,-15,45,43,-21,-54,7,0,15,-29,28,26,-36,64,-45,88,-46,62,36,34,-4,-18,36,26,5,-52,-19,14,13,39,-16,-19,65,-104,17,9, 
  /* [539][0][][] */ -52,-39,-42,-22,49,30,65,53,-10,24,5,41,-39,-20,127,62,36,21,44,63,13,44,-72,48,-15,36,18,49,-37,35,43,18,-50,-28,84,-40,24,21,41,-64,76,-52,33,-3,-25,-35,-12,34,59,8,33,51,-73,-53,26,-31,-52,-22,-31,-1,23,-15,20,-44,39,67,-71,-39,-44,-65,52,35,-22,57,-24,104,29,-2,-17,55,-61,-38,-53,-3,89,-75,-64,56,-21,-84,73,34,70,21,-47,15,79,9,-26,7,-28,2,-23,82,38,-86,6,-3,-17,-67,-52,23, 
  /* [540][0][][] */ -54,0,60,109,34,61,-32,-35,-60,63,26,-6,34,41,38,-47,89,-11,19,-36,-57,-15,-38,74,-11,101,-23,21,47,0,50,-25,32,54,2,-55,73,-10,-27,38,-34,-38,65,-45,72,-100,-39,-61,-10,20,9,39,38,-1,117,15,-33,-35,3,-1,-34,-120,-12,50,4,-62,17,-2,-50,5,12,-36,13,46,-32,11,62,3,122,-54,18,-18,-33,-127,11,-40,58,0,31,9,2,18,-61,-44,-15,-50,18,-67,-24,-52,-21,-22,12,13,6,-23,24,31,75,-30,-63,17, 
  /* [541][0][][] */ -6,51,43,-31,-93,-12,92,18,-86,8,-6,-81,57,9,22,-43,-7,22,-42,-73,14,-27,-19,-22,-11,-59,18,-22,-2,97,35,-96,27,36,-3,39,-35,49,52,63,-19,31,-30,-72,-10,-41,-30,-26,13,18,-27,-23,1,-16,-2,-82,-46,51,-67,-127,-14,2,-26,-106,6,-42,26,32,-63,41,-19,-64,73,39,53,30,3,-79,-30,-65,19,36,36,-46,12,-44,-19,16,102,25,-98,-78,17,-26,-44,20,-62,63,-20,-14,69,29,7,-32,-66,-56,-90,-40,14,35,-4,24, 
  /* [542][0][][] */ -22,3,14,-11,31,10,-1,38,-46,15,96,16,-18,-23,-7,32,-14,5,15,-83,20,28,15,38,-25,32,-127,94,26,80,84,92,-8,54,48,35,-12,-96,18,69,-64,-25,-15,112,-21,29,2,10,-34,-20,-57,43,53,-14,105,-3,32,-25,-15,18,-33,13,7,43,-10,-92,17,65,-54,33,6,-39,42,33,-8,61,-24,-5,-81,14,-13,-11,-50,-33,83,6,-41,6,-27,-105,23,-32,124,-65,-55,120,2,-62,8,35,-12,-20,-28,6,82,74,-68,-25,-15,-7,-47,9, 
  /* [543][0][][] */ 35,27,-20,50,35,12,27,-1,46,12,27,-55,54,7,21,44,1,58,39,56,34,9,-31,16,-14,10,13,8,32,-12,15,14,8,-10,36,24,-5,88,8,-5,127,-76,19,3,-7,-17,35,-26,-14,-5,-38,4,25,-9,50,8,6,-37,-62,-3,-92,-62,46,-30,32,63,-5,41,59,-24,17,-19,35,-5,16,-117,-40,-38,7,57,73,32,-41,-9,7,40,-10,-9,29,-12,-31,53,-50,-32,43,31,-58,-49,-6,-20,0,-8,47,11,37,-28,-16,15,2,70,28,-72, 
  /* [544][0][][] */ 50,-38,24,-85,49,50,-61,-47,29,-55,-50,-3,-1,-19,110,9,48,-38,-7,-8,-101,52,38,52,-7,9,-55,9,51,65,-44,-92,95,48,32,-6,4,-13,-33,8,-26,74,99,-92,54,15,74,18,-48,-21,14,50,24,-25,58,-34,-102,45,-57,-127,48,-20,-69,88,-31,-39,-4,25,-27,4,19,5,12,28,-26,37,-21,-64,-52,31,0,45,-24,-23,-76,-84,-14,79,6,5,24,-73,6,-71,-18,44,19,-43,-58,-12,42,75,-46,59,-19,-19,-72,-26,2,89,28,-50, 
  /* [545][0][][] */ 3,-115,6,14,78,-45,-21,2,31,28,57,-79,-22,42,-23,-95,42,19,49,-49,6,-40,2,-17,49,10,-43,-43,-28,23,-12,55,-127,3,-54,-27,33,-73,-30,8,21,-43,-48,-71,27,-30,32,67,47,-109,-22,-1,56,65,17,6,-83,11,-71,-38,-15,13,88,-5,-41,26,58,50,2,12,-68,-107,24,-47,-72,93,1,-15,11,48,61,66,-16,-16,-98,-15,-19,32,5,52,-34,-61,-43,-37,-53,32,32,54,-19,3,-80,-20,-5,-73,-12,-35,5,46,39,55,-67,-12, 
  /* [546][0][][] */ 2,-38,-26,-63,-39,35,66,58,-92,-17,-64,-5,62,-34,-127,24,-49,-44,-6,-23,-7,-46,5,-27,24,-83,111,-22,-16,56,33,60,10,30,5,11,23,-21,-33,34,-72,43,17,-2,23,60,88,-21,79,-19,-86,4,10,-23,25,-54,-19,44,1,84,29,50,-12,80,-27,19,4,19,9,42,-9,27,8,-28,35,8,-75,32,-27,3,28,-60,1,-122,-24,8,-47,-81,-12,71,-40,-72,8,-68,95,-19,-41,-71,16,0,-24,29,-5,-73,6,14,-87,10,-65,-6,-69,13, 
  /* [547][0][][] */ 39,-12,-41,-103,53,-30,72,-12,25,-81,-5,18,58,13,26,-43,22,0,3,-39,53,-7,-39,-33,14,-74,-25,11,67,-96,42,-3,35,26,11,-27,-101,125,-33,-43,12,-2,44,87,39,127,47,-75,-95,-12,-43,-16,77,9,-34,-34,-3,-26,55,-1,-11,-34,-35,-36,2,88,-2,-94,-41,57,87,-121,45,32,-111,-43,-19,-58,13,41,61,8,65,-57,11,-2,-41,49,-22,-8,-26,-41,-62,80,-1,-44,29,-15,-15,50,-52,-22,10,2,21,-36,-41,-68,-16,-2,-33,51, 
  /* [548][0][][] */ 12,-64,-75,-10,-26,88,0,-24,84,-54,4,30,-66,50,22,61,-36,-57,-19,-9,116,-1,8,28,14,79,46,-41,-65,53,68,-51,-82,18,-43,23,14,-21,85,-34,71,84,104,41,-10,55,-59,13,28,30,-82,10,30,102,-60,48,-36,44,-5,9,5,24,16,-22,11,-52,103,-9,-17,78,30,74,22,-71,-13,-127,51,36,-25,-87,67,-14,-65,0,-115,-54,38,56,30,2,6,34,-10,73,-61,-43,-42,-45,-36,-24,-14,16,41,-2,-7,-9,-39,-61,-4,10,16,41, 
  /* [549][0][][] */ -13,-14,-49,-5,-47,-4,56,-23,-95,-8,20,-34,-39,52,72,-17,-84,105,22,24,-63,99,-33,-97,74,44,28,-35,64,-30,70,-39,12,7,30,-26,-64,-20,22,78,15,38,-104,-29,-32,-127,-76,-38,-48,10,-45,-36,-9,23,-37,53,34,-50,36,102,11,46,-5,-58,62,66,-35,-42,33,-83,-48,22,-34,51,59,-67,-62,-42,-82,32,-23,97,102,29,-42,8,19,-26,-36,21,52,-26,27,45,-17,66,-80,106,-116,89,32,25,0,-14,-18,-4,32,-14,-3,-36,51,8, 
  /* [550][0][][] */ -3,-42,120,-22,-24,36,50,26,-29,35,-6,-29,13,-33,-61,-95,4,8,25,38,21,-13,-5,-1,-23,-36,-17,-63,18,-1,55,5,51,49,76,0,-28,28,-21,41,15,49,44,127,-13,-25,12,48,55,-4,9,-38,31,-14,62,-63,-20,-39,-33,2,63,-76,-40,-70,-9,-89,34,74,-50,-67,-114,-41,5,-72,3,-12,-50,28,15,-38,13,-21,-46,12,66,20,-67,5,59,7,-55,19,-11,-16,-73,-60,-63,47,67,100,6,-33,38,82,-34,-14,9,53,58,-77,-27,-19, 
  /* [551][0][][] */ -67,-46,-77,-16,66,-24,40,15,127,-96,108,98,32,51,-33,-25,77,75,70,-75,104,1,22,4,-38,15,-34,3,40,-49,25,-9,-42,63,123,58,-25,-60,24,-65,11,-41,6,66,11,4,51,8,27,63,44,34,-10,62,26,-101,89,69,48,-26,-16,40,12,-42,-17,-74,-12,-39,13,9,34,84,46,-66,75,94,1,99,-9,17,-51,-5,7,-18,23,5,-77,-25,-41,33,81,55,-67,12,-26,-37,-8,73,9,47,-35,-10,-62,-14,-22,-33,-43,-6,-37,36,8,27, 
  /* [552][0][][] */ 43,-32,-35,25,35,-39,-5,-37,22,84,24,35,-19,64,27,3,5,53,-58,-31,-6,-11,-17,-38,63,60,-44,-34,26,-30,7,-45,-21,36,27,-127,-44,74,-17,-83,-35,63,17,-7,-20,-5,31,38,48,1,48,-20,-3,-16,21,11,14,22,-3,-4,-11,26,6,-41,47,17,-15,-36,-45,33,-12,21,-3,-29,-53,60,-29,4,-6,-91,-17,2,-10,-35,28,14,-62,-75,22,-5,-55,14,9,5,-4,-14,43,51,-44,-43,0,8,5,35,3,16,123,-35,-39,-93,14,16, 
  /* [553][0][][] */ 22,-25,-44,47,-23,-20,45,-16,23,-39,-2,-7,15,-24,20,-19,72,26,-1,-73,-70,69,-6,-28,-24,-46,53,-39,-20,17,-13,22,-15,39,-59,-24,-40,-66,44,-1,-34,-55,39,3,-9,-68,-42,-47,-7,59,36,-24,46,85,-20,35,5,-29,41,-29,37,23,80,18,-14,-6,7,127,-42,-80,-24,-40,-50,45,-14,51,32,-20,-71,-11,3,-42,58,-22,19,97,41,91,1,42,68,-44,22,-18,-36,-15,-5,40,-27,-28,-41,-6,-20,-23,-41,19,-17,0,70,-43,-29,47, 
  /* [554][0][][] */ -32,-33,29,58,-48,-75,0,-27,-27,-19,-19,-33,16,-16,-52,31,32,-49,38,-23,-18,49,15,-48,33,-9,31,-55,13,59,0,-20,45,-13,14,-22,29,25,-15,33,-3,14,47,-10,-46,-39,30,-44,-8,23,25,11,19,37,67,-53,3,13,-42,-25,68,27,127,24,69,-48,-32,-29,-63,-27,11,0,-37,78,-49,-7,39,-38,-89,-48,5,-30,-11,40,-34,-22,65,-35,-3,-10,70,35,-23,-10,-20,-70,20,11,27,-43,35,-17,-7,-16,-25,-16,0,59,-47,14,-29,-8, 
  /* [555][0][][] */ -21,92,49,34,-4,-34,15,22,49,6,-53,-65,22,-76,-35,-35,29,8,-46,-20,-30,32,29,40,-70,-40,-16,-18,-34,17,18,-84,37,39,38,6,-5,-24,34,-11,-82,-7,-14,-24,-98,16,-37,-44,-46,-26,28,-10,3,-25,116,-98,-57,74,-21,1,-32,57,-108,0,22,-10,104,43,-2,-85,-18,33,-111,-77,31,61,22,30,44,31,-68,-41,-37,-31,2,-31,62,-67,11,34,91,-46,44,-127,-84,-64,32,14,-71,11,-25,-65,52,11,-1,-29,-14,61,-23,-45,10,-110, 
  /* [556][0][][] */ 10,29,45,-33,-46,43,35,-5,70,11,-112,-60,15,57,-64,54,13,73,104,-25,34,-25,28,-2,41,-47,-16,34,33,-20,47,37,-45,33,26,-34,58,21,37,-49,53,28,35,41,81,72,127,-15,-17,2,9,-8,34,37,81,-52,7,84,-8,-61,18,63,6,0,65,32,32,-60,-56,25,-19,-24,73,23,52,-81,45,-56,-75,-37,-73,-15,-52,-14,24,-29,-49,5,1,7,34,15,-25,22,54,23,52,-19,-7,28,-121,19,23,45,10,-1,-18,-32,6,23,-15,-32, 
  /* [557][0][][] */ 79,56,-62,54,59,-4,-12,-19,46,-74,51,43,13,29,10,-16,-111,-28,-60,52,57,-29,53,74,4,-86,-1,105,29,102,-92,-27,-92,12,-36,20,-13,-77,-68,-6,-21,20,-9,73,-19,-18,-42,-5,-19,-13,-79,43,-39,-10,53,10,11,-54,43,55,-33,2,-9,13,29,55,56,-13,-89,-30,46,33,76,75,9,32,24,102,-127,97,49,8,-23,-39,-32,18,-30,-2,-22,-85,17,28,64,-6,-100,67,4,-5,-99,-52,-77,57,-97,-118,-55,-82,0,-43,-45,11,-15,38, 
  /* [558][0][][] */ 4,-6,-6,-23,38,-9,-6,81,-26,15,8,-36,-36,16,40,-83,-24,-25,69,18,-22,-44,1,26,-16,-88,-27,-52,7,-7,26,-57,68,60,-20,17,80,27,-36,-38,16,24,30,57,-51,-39,62,47,53,36,-16,47,25,32,-5,13,-6,13,101,16,12,-41,-42,12,-36,-67,-3,-42,9,49,66,-37,21,52,-42,-21,16,-5,-90,65,22,-4,5,-23,-59,-127,-15,-47,-24,7,-77,-16,-30,-73,-4,10,32,-12,-62,-30,-17,-38,51,52,1,8,47,49,1,20,-7,-7, 
  /* [559][0][][] */ 36,31,66,-70,77,12,-54,41,6,-58,98,-65,-79,62,-95,31,-44,-18,-15,-104,12,-16,-40,40,-7,23,-39,2,34,62,-44,9,50,-95,121,-71,-6,-4,-127,29,-86,-12,71,42,-51,6,-3,32,72,125,-74,10,-10,-12,104,6,-9,-21,69,100,-110,-27,-57,-5,-49,-92,9,93,94,71,-73,-47,83,-24,23,-15,49,-25,-68,-30,44,8,-33,-47,-24,61,113,104,15,33,47,-28,-51,-15,-47,-18,-25,48,-63,41,40,27,10,-53,-2,27,31,25,57,7,24,115, 
  /* [560][0][][] */ 118,20,-110,-19,-78,7,-35,-5,-10,37,5,28,97,0,54,62,-84,127,11,3,5,97,75,40,-3,16,-33,-71,-63,-35,66,34,-38,-45,-52,42,-36,52,-18,12,44,21,55,52,88,-40,10,-9,-9,-7,11,-26,-22,1,51,46,54,4,-15,-1,31,-41,46,8,1,-13,22,7,-63,-23,81,32,23,92,23,33,-78,-37,-48,54,-22,29,-14,-17,-13,-23,114,6,53,-75,-55,-48,85,-51,-23,-5,-38,-57,-44,13,-22,34,18,31,106,-25,45,33,127,39,-25,-4, 
  /* [561][0][][] */ -31,-27,30,37,-33,33,55,-65,-72,58,-32,25,-116,-15,-18,9,85,-2,-84,-42,17,5,-93,40,62,81,64,48,6,-87,7,12,-48,2,7,63,-23,33,77,-11,-30,-42,22,-34,21,-52,-7,-32,7,1,19,14,100,-73,23,-65,-23,127,65,40,-72,20,-25,-57,-14,28,37,-66,9,22,-18,-59,-88,-63,-32,11,12,-13,-48,44,97,-5,-62,-84,115,41,-31,-5,-2,3,20,-32,48,-35,-3,115,44,7,11,-27,-7,39,5,79,27,-49,35,-64,-68,33,29,32, 
  /* [562][0][][] */ 52,-16,-16,-75,-14,39,-1,26,-42,29,40,28,37,11,-19,13,69,-56,6,-22,-11,4,-82,120,39,9,-19,44,-69,49,-25,-8,-35,62,-15,59,37,115,-55,-56,17,51,-60,3,66,-15,-6,-28,1,-10,61,36,56,-5,-7,10,43,-61,-32,53,-13,0,-66,-17,17,-32,18,-30,-19,-15,7,15,-7,127,16,99,27,-73,49,-20,95,10,-22,-28,34,88,-32,33,-54,72,-16,-15,-93,22,-33,104,32,-63,-95,34,21,33,-43,-112,107,13,5,-58,-17,-30,-62,29, 
  /* [563][0][][] */ -55,99,-7,-89,53,-1,-55,37,17,31,66,27,-54,-54,-68,23,38,-71,-72,-7,79,-51,41,9,14,3,-10,11,40,38,-117,82,15,39,-127,-22,-106,3,38,33,0,-84,9,72,33,-100,-3,22,37,-39,0,27,-25,2,31,5,39,-104,4,44,-39,46,34,69,-32,-4,26,-1,-102,-41,-99,-46,-59,83,6,-40,-26,35,9,-8,-65,9,-98,-24,-74,31,45,-50,31,44,52,75,-34,2,-21,42,-14,-11,-94,-70,-13,-93,23,35,-85,-16,-11,17,82,-33,18,57, 
  /* [564][0][][] */ -3,-34,13,-16,-36,-1,8,-7,-43,60,-58,1,-7,-6,-20,127,-40,54,-30,-44,30,-9,-16,-26,65,-112,-51,-108,-38,-18,-103,66,-18,28,-65,69,-43,-73,-110,1,33,87,-27,-82,-16,-37,-37,113,-105,6,-7,-53,62,-34,9,47,11,16,-46,-24,-28,-22,42,-7,61,-39,-24,-19,-59,-39,33,-19,33,2,48,-43,39,-64,-52,106,-9,-21,-11,77,20,13,-6,-25,-41,-101,73,34,-12,-28,-50,-30,34,34,-13,17,-15,-6,0,35,20,-78,-19,9,-33,-72,-47,45, 
  /* [565][0][][] */ -58,4,-53,-36,47,3,-18,-1,-54,87,40,15,-77,64,-10,-46,14,-41,0,-26,-47,-21,24,38,90,-24,-8,22,26,22,-27,-127,27,3,51,-1,9,-51,42,24,-32,-24,27,-9,18,33,-9,43,3,-18,38,-71,13,37,-87,52,-55,18,-10,83,0,43,73,-15,24,32,49,51,-28,-46,-19,-26,-29,16,2,43,-24,75,58,-48,38,49,-39,38,35,31,-60,-45,-7,17,-52,-14,-34,-12,-92,-30,-49,32,-42,4,14,75,-45,-38,23,-8,-9,72,28,1,24,-23, 
  /* [566][0][][] */ -2,39,-24,-48,-2,-53,10,23,41,45,-37,19,-51,83,40,-12,-20,-69,-43,22,22,25,-9,6,-51,-57,-50,11,22,21,0,-17,-29,28,-9,-6,32,-50,41,12,-67,-17,34,-17,-55,29,-20,-19,64,-15,23,7,1,-1,11,53,-35,-40,-42,21,-3,-71,-37,-46,-11,9,-22,15,8,9,18,-24,-31,8,44,-21,34,31,64,32,68,-90,1,64,12,-13,30,57,41,4,-127,-14,28,-8,-54,20,-39,-100,-61,17,60,-5,2,56,79,-42,-13,21,54,33,47,10, 
  /* [567][0][][] */ -8,-9,17,65,-21,38,-8,59,-25,7,9,-33,64,-52,21,39,64,-40,23,18,-2,-71,-55,-10,15,4,-60,-33,-85,58,24,103,-28,15,-99,51,60,11,-62,29,-19,-25,-24,-58,-16,-33,-26,-21,32,-47,18,56,-92,-7,-17,-53,7,28,-25,10,-25,-21,52,30,-2,11,-56,-2,-13,-72,-55,14,-23,-6,-17,45,15,63,-24,47,127,-15,-36,70,-54,56,-19,67,-50,-1,9,26,8,76,-24,76,5,36,21,2,28,-9,-111,32,-24,-29,-22,34,-1,9,-44,73, 
  /* [568][0][][] */ 52,30,-7,-22,-14,93,70,1,-16,-29,-5,27,64,-56,-11,-41,-17,-66,100,-118,49,50,-17,-56,-85,57,-13,10,48,124,-21,-15,92,-83,57,-57,-38,9,10,15,-95,54,6,-53,50,71,-16,-12,-4,74,19,91,-26,5,91,-70,36,37,21,-42,36,112,-40,31,67,-53,43,-109,58,1,-45,-53,9,-37,-28,-71,111,-78,-63,-68,-76,-50,-20,-1,-57,-27,-26,-111,-87,-70,77,38,-84,-43,0,62,77,32,-32,7,59,-52,-17,9,-127,14,49,22,-1,19,-36,-28, 
  /* [569][0][][] */ 3,-103,127,22,-6,18,64,-80,-6,-7,44,98,-65,26,-31,25,-9,9,33,-33,-28,-54,-1,73,77,-49,-44,43,-44,-76,20,-35,29,-28,31,17,59,-33,-21,18,19,-96,-55,-59,-14,-40,-12,-30,-59,3,20,-62,4,56,5,-32,30,71,34,54,40,-12,-8,12,-5,-40,8,47,8,-11,22,34,19,-84,2,-25,18,-8,7,63,32,-13,51,-61,-20,-21,12,29,3,-50,-21,126,-6,9,-16,-38,-8,71,55,33,10,-28,51,-31,-62,25,-1,-3,8,61,-12,52, 
  /* [570][0][][] */ -2,56,19,-48,-1,28,0,44,-7,31,-8,-49,-55,42,4,23,-44,-32,8,53,37,98,-39,-65,9,16,-7,-34,-53,29,41,-14,-71,65,16,6,29,-2,40,-64,34,75,-43,-57,-13,-26,-2,7,-36,-5,-10,44,-9,61,48,-93,-41,-31,2,-48,-48,0,26,-61,-25,13,-65,38,6,-10,78,34,0,-2,-18,36,-38,62,70,-5,-8,-1,-7,-12,35,-42,16,-21,88,-93,-55,5,-22,21,11,-3,90,16,-19,-61,-18,87,5,60,64,-23,34,7,127,-17,72,-2, 
  /* [571][0][][] */ -52,65,31,-18,13,-52,29,11,-2,-69,-93,-59,-44,15,-70,25,31,-13,55,-7,-42,47,25,4,-47,-44,-109,55,-39,-70,26,-13,99,66,63,-101,0,47,0,-5,51,-14,75,-95,-20,-87,65,14,-31,-73,-40,76,-89,7,-53,-34,34,43,-9,74,59,61,16,-58,124,-9,96,0,30,78,25,13,-74,-106,47,58,-11,66,7,45,48,6,-6,40,88,-44,10,-23,-42,-28,-29,-127,-45,-38,-53,83,-26,4,111,-27,14,68,-26,4,75,-50,37,-59,8,-57,-36,-13, 
  /* [572][0][][] */ -93,25,-87,-20,-75,13,4,-5,-7,127,39,34,5,8,-66,43,-16,34,-33,-29,63,10,-81,-21,-35,-77,37,18,56,-15,-17,-96,-17,-82,-13,64,-14,8,8,-47,68,-14,14,82,-45,45,26,-24,-39,-20,-40,-35,-41,-11,-101,40,28,-25,-45,54,-51,12,46,11,-7,36,1,-32,7,-67,1,-10,-61,-12,28,-33,2,-12,-43,47,-30,18,-16,-80,71,0,-18,14,-18,27,52,100,70,70,-112,-2,-11,54,36,50,-47,42,22,24,-61,23,24,-6,3,38,5,-7, 
  /* [573][0][][] */ 39,-62,-13,-25,-36,63,68,88,31,-1,-13,55,22,-5,8,-66,-39,-13,-76,52,15,-32,-79,32,-52,51,-1,-48,-46,25,-41,77,4,-67,-22,33,13,-34,-15,17,17,-29,35,-28,29,-13,15,21,-45,-6,-16,-2,-4,-52,1,1,-80,40,-61,-40,-17,-22,-1,-18,42,-36,-65,21,-14,-79,-17,-33,0,127,-13,-64,-82,100,55,46,-14,-2,-33,25,-70,1,-100,93,-110,-8,-70,-70,-35,51,-26,-19,51,-19,31,-3,57,77,38,-49,1,-44,-50,-24,-43,-29,-107,13, 
  /* [574][0][][] */ -34,-61,71,11,-17,8,-61,-127,37,-62,-5,-19,-9,30,21,19,-40,-51,-27,7,-29,-31,-37,85,65,-67,-67,-68,-42,0,19,28,-74,-43,-126,29,-44,-6,-68,57,27,-2,110,45,16,-15,-28,70,12,-25,1,-37,70,46,75,108,1,-58,-20,-57,-19,99,-24,54,-24,49,2,7,79,61,56,-72,7,-30,7,48,-51,-22,-72,7,1,24,-41,66,-31,57,-4,89,18,61,31,-78,-41,-109,31,-12,-34,-27,-32,54,-4,-60,-9,35,-44,17,-96,-70,-37,-44,2,-48, 
  /* [575][0][][] */ 21,11,22,9,-24,26,92,-52,-20,-6,56,-90,-43,50,-40,-11,42,-5,-40,-72,-85,19,-24,-7,7,50,-29,-39,33,25,-62,-83,14,-13,34,-38,53,36,4,-45,27,65,-22,5,-20,30,-9,-25,-30,79,3,1,62,-96,-6,34,77,-10,32,-5,48,-39,2,2,17,-40,-5,48,64,-45,30,-26,8,-3,34,23,-23,-31,127,4,55,16,-7,-13,23,-15,-25,25,-11,6,-47,10,22,61,1,6,11,-58,15,26,14,-78,-25,-7,25,-68,-80,-23,-18,41,72,-100, 
  /* [576][0][][] */ 41,-51,30,66,3,-64,6,19,-25,-13,-42,0,59,-41,36,6,-15,-32,-20,6,12,-76,-25,28,-19,-44,71,-46,14,12,18,17,-40,-12,-29,17,5,10,16,19,57,14,-37,54,-124,100,-25,-4,-5,-18,39,38,-21,-8,-49,-34,14,49,-71,6,-12,-82,39,32,-56,27,-18,68,24,37,47,-21,3,16,32,-47,-59,35,-12,17,-20,-28,74,40,-26,-16,25,29,5,42,-67,-28,45,37,-6,-49,42,2,-63,-51,103,41,7,-81,-41,-7,24,127,-25,-20,25,-19, 
  /* [577][0][][] */ -2,-27,-35,-85,-18,-61,-21,43,-35,-10,127,-5,33,98,25,-49,19,53,15,54,-23,77,47,66,-53,-66,-39,65,14,1,16,22,-86,-21,44,-17,-77,-23,-32,63,26,2,27,71,-2,-21,-5,-56,3,-7,28,48,-47,-32,-9,84,22,10,88,-71,-37,17,-63,-43,36,58,-19,-5,10,-31,-36,15,-48,72,-40,-26,-15,28,28,-91,15,17,65,69,-70,68,-3,108,-80,27,-26,45,-12,-2,66,-11,-38,14,-7,-42,-69,-9,1,-98,-12,10,-22,14,1,37,-52,-67, 
  /* [578][0][][] */ -7,-75,23,8,7,-47,28,-25,10,18,-48,-61,-16,9,-8,-75,30,24,-8,51,35,-46,23,-33,-6,-127,0,4,-42,12,0,-46,-6,-8,-19,-18,-25,23,30,-12,21,-30,-41,16,10,-29,-9,11,15,-14,11,12,-32,-25,-40,-10,39,-43,-23,8,3,-5,21,-65,28,50,-30,-42,8,-71,-12,28,-5,-3,-24,55,12,-3,26,21,35,-16,33,34,65,-31,-13,19,-5,0,-6,33,67,7,29,44,58,-19,-9,-12,-15,10,-29,-49,-14,-23,-9,-32,-26,-4,-23,5, 
  /* [579][0][][] */ -42,-95,-73,-33,-27,-31,-65,91,-1,-81,-10,-9,-17,6,17,35,-27,-17,-34,18,25,89,67,-38,-33,-6,-65,-90,31,80,35,127,-2,-17,-78,4,16,3,27,-1,-71,-2,18,-25,4,23,-12,4,54,54,66,28,-102,11,74,27,19,57,54,0,-3,93,-34,25,53,-66,-14,48,68,3,53,-44,11,-16,-74,-6,-35,53,-37,14,-79,-80,-61,11,-57,-79,-17,-1,-33,-11,7,5,-34,-28,-71,-72,-63,9,71,-15,28,22,2,-17,78,-8,-31,2,29,-36,20,7, 
  /* [580][0][][] */ -63,9,1,15,-60,-7,-15,31,-82,9,45,-10,-5,16,43,40,96,47,-17,38,-14,75,-127,-6,-52,-40,-27,-34,6,-12,98,14,-34,-11,8,-1,31,-32,21,19,-61,57,-20,-15,22,-68,14,9,-81,26,-21,35,16,-57,-27,-47,-8,15,-56,-69,61,29,14,3,-5,-32,-59,50,-55,-82,-28,93,-41,103,33,30,-77,21,-10,-52,-98,-17,29,86,42,62,-26,40,-26,13,34,-81,-24,-53,105,56,-46,-41,-65,-65,91,-65,-25,-56,10,-30,-7,29,44,12,-78,3, 
  /* [581][0][][] */ 2,23,-7,-28,20,-67,-52,35,16,8,1,43,14,46,-96,117,2,43,-27,-60,-55,109,18,-5,-43,-65,72,22,-5,-75,-88,-1,-47,3,-41,-37,21,94,71,-32,41,-61,-40,-38,-5,63,90,5,49,-65,-13,-10,3,62,-36,72,65,-17,-59,-56,-33,33,10,-46,127,-62,-48,-37,-53,-21,-81,-42,40,24,-4,-19,-51,-11,101,42,80,-5,-18,47,15,-9,86,73,87,46,-78,59,27,11,-44,53,49,19,49,46,21,74,19,-37,-9,35,41,35,13,-50,71,-58, 
  /* [582][0][][] */ 4,22,-16,-17,3,5,8,15,64,36,13,-21,56,11,45,-30,-24,42,-48,-28,-15,55,48,-1,-42,9,-68,-26,28,-18,-35,18,-65,-42,9,45,-24,82,9,4,53,9,61,-25,68,1,-55,-49,-17,-78,-15,25,-17,-17,44,43,-84,5,5,-101,-84,21,56,-21,38,28,56,12,-9,-10,60,26,-70,29,13,60,-18,40,-2,7,-6,127,4,8,1,3,-9,101,34,35,5,35,19,-5,-29,92,59,81,36,36,28,1,-22,43,-16,-82,-59,4,91,54,38,-47, 
  /* [583][0][][] */ -54,24,-105,-24,-1,-39,49,-37,-73,-53,29,22,-26,-30,-45,41,-28,27,-28,-55,30,55,-45,35,-19,20,-26,42,-13,68,18,2,26,-1,91,27,17,12,52,-24,28,40,-6,-3,-39,-28,-10,7,-14,50,3,-30,-30,-25,0,2,0,15,-91,-21,-66,68,-43,19,87,-66,-86,-55,-77,-57,8,32,-15,28,-24,19,-6,32,127,-9,-40,40,-69,-6,0,42,86,89,34,50,22,-1,8,-45,-52,40,-48,3,27,-86,3,-36,-17,-44,5,-9,59,23,11,38,24,23, 
  /* [584][0][][] */ -17,-99,-18,-78,10,18,31,-35,106,-28,-24,-42,-74,-46,20,67,-17,-85,-23,-119,-66,-63,16,-77,79,20,38,40,11,-111,127,15,-74,3,50,46,-22,-74,47,-51,32,-37,-27,108,-39,-66,38,-46,0,-5,-38,-68,-81,36,39,36,65,48,-83,0,109,54,15,-93,-27,-15,-8,30,117,113,73,-90,-84,-14,28,-9,111,53,6,15,51,-36,-30,80,-35,95,52,-4,-29,-68,-43,-27,13,-89,-24,-50,40,-72,37,124,41,106,-23,-32,7,-18,-34,8,-46,-68,4,-22, 
  /* [585][0][][] */ 57,11,-37,17,14,-75,57,56,0,81,-47,1,-16,-84,92,38,73,6,64,24,-11,0,60,-1,27,42,-41,-8,41,-28,-79,23,-24,-8,-72,-14,32,15,2,54,34,34,-72,60,-5,41,-10,53,-5,-19,54,8,-15,-80,18,32,38,37,-73,-72,64,65,5,22,34,-77,36,28,51,69,88,52,-15,53,9,-32,11,14,-18,43,61,55,-127,40,-1,19,-28,20,17,4,18,7,33,9,85,-48,-29,70,-65,-4,64,10,39,-35,-33,14,-21,-26,-22,5,-27,45, 
  /* [586][0][][] */ 31,-46,84,-18,21,30,34,-115,69,29,-11,-79,124,-63,-50,68,-40,-50,-35,124,-63,-47,12,29,29,-57,-1,3,111,29,-127,35,-56,59,-43,-12,95,94,7,47,-45,7,25,36,28,31,31,12,-19,95,-41,18,-84,21,40,-46,-68,5,60,-108,5,36,-61,12,6,-50,-16,15,0,-54,-9,104,108,-5,-41,-84,-80,10,-12,45,-45,36,-24,16,-7,54,45,-24,31,-120,-35,-30,115,-31,124,44,-29,42,-4,-5,21,8,57,-19,-81,-1,-1,23,-17,-6,-39,7, 
  /* [587][0][][] */ 44,41,-5,-67,-39,61,-59,-1,-40,63,-87,24,64,-43,30,-46,-36,35,23,-6,29,127,89,33,-63,44,69,-45,24,11,60,-4,-45,-5,26,60,5,-13,-16,-30,58,5,33,27,-16,29,-23,41,-78,4,40,-38,65,10,20,-8,87,-41,-48,-21,-14,-10,21,-2,8,27,-4,-64,48,-17,53,1,50,65,12,23,-20,9,0,-77,38,-45,-59,-11,-89,4,-86,18,16,24,-100,29,-11,-44,16,-43,-33,-35,-5,-90,-46,15,-28,-32,-34,-9,106,1,-10,-4,-29,-32, 
  /* [588][0][][] */ -5,-68,14,-115,9,53,-9,-41,22,-92,-29,-34,-14,45,11,34,-1,64,-20,49,83,79,87,-34,-57,-44,-8,-5,-62,-63,32,-45,-47,-41,118,41,5,-41,7,13,43,-63,31,34,106,40,8,-8,6,-74,-109,-48,-60,-16,7,23,2,-98,65,7,0,14,-44,10,43,107,106,-56,-30,-26,-9,-14,0,46,-6,3,14,77,-8,5,45,-70,-72,-52,-72,9,-57,49,-23,30,75,-127,-54,73,24,0,14,13,19,10,-29,-25,-53,-25,13,-70,-83,-67,10,66,-4,8, 
  /* [589][0][][] */ -49,39,-28,63,-6,12,7,-93,81,46,62,-13,34,-42,35,6,92,87,-32,20,-127,5,-31,16,-26,-61,-28,-24,43,37,27,93,118,37,-15,-91,-28,43,64,-2,32,-75,-10,-61,-43,-40,-42,-101,24,-61,-7,-65,-18,78,71,19,30,-11,-97,12,37,-13,10,-4,46,71,-24,-23,-51,-47,41,-36,35,-4,-1,-16,13,91,21,61,-37,-17,47,-23,3,52,53,32,-8,-22,-4,-73,-8,16,18,100,-48,83,-38,-51,-25,-31,-23,27,94,-46,-14,42,11,61,-6,-100, 
  /* [590][0][][] */ -16,36,-63,-74,-9,-54,34,-8,-5,2,34,36,39,-4,56,-11,-80,-7,-19,0,-18,18,43,71,41,17,-41,-8,-16,-37,4,-31,55,-68,10,-17,-68,-71,18,57,5,-17,30,-30,23,-1,52,66,50,21,-34,30,77,-96,-127,-28,52,1,-17,-66,6,-6,88,-3,-15,-33,47,37,-6,26,-17,25,8,31,-23,12,3,-21,82,24,-32,6,-31,11,-17,-42,-43,-34,20,38,-5,20,30,-9,40,-98,20,-38,-29,55,49,36,-39,-3,-4,-26,-11,-11,-20,16,-31,52, 
  /* [591][0][][] */ -28,-1,71,-26,52,21,-30,15,8,43,-38,2,55,-57,19,10,-14,14,32,2,19,3,3,64,-87,3,-34,5,-33,6,5,24,-25,-69,-62,35,35,19,-6,-73,24,-54,-13,-8,1,-27,-41,57,119,-11,52,9,33,-31,-8,-12,-4,12,24,-2,27,-11,26,-80,-30,-22,-17,-71,19,58,51,-22,-49,14,-29,17,-31,56,-40,-58,4,-8,-35,66,-49,-127,-49,54,-82,44,19,-39,19,13,93,6,-10,-33,-31,0,-8,-31,44,19,-64,5,38,-75,3,51,53,89, 
  /* [592][0][][] */ -35,18,27,-31,7,25,-5,51,-7,127,-11,32,-11,-40,41,-8,34,13,10,-41,-3,21,-65,-31,-28,-25,-59,8,-22,-34,-54,-46,4,44,-12,-31,-6,44,74,-30,-5,-15,15,39,-24,-49,11,28,32,11,-25,36,-64,10,24,14,-12,3,22,10,36,-30,-3,-26,-7,7,15,-13,-26,-21,105,-34,-28,18,52,-33,-10,4,21,-10,44,-66,7,41,-11,-46,-12,-2,43,3,-5,-7,57,-13,63,64,9,-4,-20,-9,-29,18,6,-17,0,-7,-13,19,35,6,-8,-37, 
  /* [593][0][][] */ -7,17,7,5,70,-12,5,28,12,-77,-57,-73,-32,28,-127,47,-16,-33,18,-20,5,-33,-50,48,-37,-63,51,12,83,-21,13,20,-22,2,88,10,12,-36,-19,46,29,27,18,55,33,26,-19,86,19,-31,41,-38,-10,-31,-19,-34,18,-23,-29,-59,-32,8,10,-71,9,-89,109,-6,79,-18,7,16,-42,31,18,-1,-77,43,0,-52,43,20,24,40,-85,-57,19,18,-65,21,-27,-4,-64,20,7,14,3,-1,14,-33,-49,-7,48,-6,-11,4,-49,14,4,14,-34,14, 
  /* [594][0][][] */ -10,-62,-20,-66,-21,-52,8,8,37,23,-52,26,-50,16,-19,0,-16,-4,41,33,9,5,12,23,-14,11,127,-11,-3,25,30,65,-31,-6,48,-47,79,20,6,-27,-5,44,-8,97,33,-4,-38,-16,-65,22,13,13,63,-74,9,-48,18,55,-75,-29,9,-13,44,12,-22,-76,-29,59,-17,48,61,-67,-23,9,-55,9,17,-38,-5,-5,19,50,0,-62,-57,-4,-11,34,46,-6,8,-16,15,13,-23,96,-2,-19,23,-41,-68,60,15,5,-36,0,50,29,-1,49,30,-7, 
  /* [595][0][][] */ -15,-25,-26,-17,-5,-37,-11,-1,-5,104,17,-68,-18,46,36,-45,-15,9,17,-24,34,-35,-41,51,-20,18,-13,-60,-47,-5,-2,19,-4,12,114,-29,45,19,0,-22,-46,23,-14,1,67,35,13,19,9,46,16,-58,-4,88,-62,6,22,-15,84,-70,-26,41,-47,10,-54,56,56,17,-25,24,-9,3,7,-69,50,3,-104,-127,6,-1,11,117,-15,-35,-29,-59,29,51,49,-28,28,21,45,-48,82,10,22,-26,-54,25,1,29,-88,-42,21,-3,-59,-98,24,-4,-27,-16, 
  /* [596][0][][] */ 22,-17,43,-6,13,-81,7,63,16,1,68,-89,67,-16,27,-14,52,-64,38,50,18,-19,7,20,-26,44,-40,77,45,-50,13,9,-28,30,2,20,-23,35,11,-30,-102,-12,48,-32,-12,-17,-42,-57,29,-28,-3,13,0,-55,0,58,51,9,-76,27,-3,34,-47,-1,-52,-32,-17,-12,-19,10,51,-50,30,26,69,22,-25,59,38,8,31,15,12,-14,-20,17,-46,-87,11,-24,33,10,-46,-20,126,23,-31,-127,-10,-18,18,-24,19,-25,-14,-15,-12,4,69,-31,-1,-1, 
  /* [597][0][][] */ 66,-22,-49,-40,-69,53,7,72,-19,2,49,-15,13,-14,-23,6,17,1,-58,-13,24,15,-15,-30,-61,-43,-30,-42,36,70,73,-17,-37,54,-37,-32,127,2,11,-46,9,-49,51,81,107,-9,39,-52,33,-29,-7,3,1,2,-33,-24,10,-39,-9,25,-17,51,13,74,19,-91,-40,-109,-23,-19,-8,66,-6,36,11,79,-74,63,-40,-31,41,5,56,-2,10,58,15,48,-10,2,42,42,3,-22,28,2,3,-57,-59,-82,-25,76,39,-62,-51,-56,32,-63,16,-15,32,77, 
  /* [598][0][][] */ 37,-78,-2,-14,-89,65,-21,16,-40,6,6,4,66,-45,18,28,19,9,65,-99,63,-2,8,41,45,29,25,83,104,50,-88,33,107,-5,-7,27,74,-56,-52,107,-1,-52,127,54,70,-11,-26,83,13,75,58,104,13,47,-74,-38,-9,-17,-53,-2,7,-70,-38,106,-36,72,24,-49,79,-31,7,-103,-38,65,-26,80,43,19,-13,80,48,5,68,74,-7,-2,-56,16,123,9,-12,-15,11,-72,-22,37,-72,-15,7,-30,-34,-37,93,-22,-2,83,-26,71,-26,51,-64,95, 
  /* [599][0][][] */ 35,-26,1,50,-37,-61,5,71,-63,69,5,-14,-14,32,-109,-64,60,20,63,-127,-5,-23,121,-62,-6,-6,-31,-51,-1,-64,40,43,-44,40,-94,-80,-35,16,-54,-76,43,-1,-21,4,-44,0,11,-77,31,-18,-11,14,-9,-2,17,-17,126,31,-20,26,35,-6,-11,-65,20,-26,14,13,10,33,-52,-63,71,-31,0,15,20,39,-74,24,84,-45,-12,-21,-5,-22,-7,-3,-19,47,-70,11,-59,3,-8,121,8,-49,-68,-56,-64,61,7,-109,-90,-13,66,9,47,44,41,-11, 
  /* [600][0][][] */ 33,-99,-44,43,14,-46,63,15,-1,20,-37,-105,-40,36,-50,-18,-68,64,-113,-23,120,71,70,31,-10,108,43,95,89,97,36,-122,-127,-20,-2,59,-89,86,70,-7,23,-53,66,61,-11,-29,100,50,97,58,28,85,67,-28,9,-54,106,12,43,-20,92,4,76,-30,-30,-30,9,-2,-64,-15,-37,-55,-78,36,27,-70,106,11,68,-47,117,-34,1,-24,16,81,-42,59,-15,-3,35,8,28,-15,-39,76,59,-116,-87,44,-34,35,32,-59,78,3,-74,63,21,-15,26,107, 
  /* [601][0][][] */ 12,-13,-1,61,18,69,82,2,74,-4,8,39,8,-33,-71,-25,23,-49,-20,-41,21,-51,20,-1,35,14,19,4,116,-42,-2,9,98,-20,5,-28,-107,51,21,3,-26,-24,54,8,5,-51,127,-3,77,65,-35,41,28,-49,-68,-31,20,28,13,61,43,4,-87,-27,-21,-60,-46,-62,-17,-3,-24,-39,-1,-36,51,-20,-49,-65,44,24,-100,4,-25,21,-39,-8,-15,-4,-102,-13,11,-40,96,24,16,31,-4,-49,-9,31,29,-29,-8,-10,27,6,-54,30,-7,-26,4,8, 
  /* [602][0][][] */ -31,-18,44,127,-8,-18,17,-23,-110,81,9,42,42,-16,-22,-103,105,5,35,-2,-38,23,2,-81,7,-34,-50,26,77,24,-15,15,-24,-7,-30,-5,-42,-4,36,7,34,-97,-77,-75,-32,5,124,-14,114,8,15,-28,87,71,43,35,17,-51,30,-9,-39,30,99,-48,-68,27,19,-53,-21,-12,28,-22,-21,-39,-114,-57,-17,78,-46,89,49,-31,49,32,52,43,-12,34,-31,-57,-9,-25,44,22,68,-5,98,46,8,10,12,-59,41,-56,38,-12,-3,31,76,115,32,41, 
  /* [603][0][][] */ 15,37,-41,-34,-70,27,97,79,24,23,37,-32,-42,94,-14,-29,81,-7,54,-83,19,41,1,36,81,40,31,7,-69,-22,-1,74,40,-4,-13,46,-25,42,-49,-116,96,-40,-53,-34,-41,22,5,17,-23,41,-30,-34,55,17,-1,-32,52,-29,-37,-9,1,34,-41,55,-27,-25,85,20,-31,61,-7,10,15,-34,36,-41,56,51,38,-54,-36,68,64,-47,-13,0,104,18,20,-38,-2,-127,12,-27,-65,-9,30,18,-20,83,-25,-14,-68,-25,-8,25,-61,21,8,-17,25,36, 
  /* [604][0][][] */ 54,-93,28,58,61,4,24,12,-18,-5,32,41,-24,-51,57,-48,14,48,-68,9,-127,68,14,-34,-46,30,-21,81,63,1,14,86,11,27,46,-88,45,67,46,-51,-1,30,39,-42,-71,-14,57,-8,5,27,-14,17,41,-68,-40,11,48,4,67,23,58,40,-33,31,57,-24,1,-70,-64,7,-39,-40,22,7,22,14,-5,14,-34,-7,4,-33,-6,65,1,27,-45,30,50,-4,22,8,-19,16,24,36,24,-27,-22,32,15,15,24,-85,-22,32,33,-47,-39,-40,-8,44, 
  /* [605][0][][] */ -29,-12,14,7,1,46,21,-69,35,49,37,-49,-29,77,51,-32,98,-35,-18,27,16,-24,-19,6,12,-40,114,90,-36,11,24,25,-4,-19,-21,-6,-34,5,-79,55,-12,-15,66,61,-69,-16,4,-40,51,18,-97,-28,10,127,-10,-58,-78,69,15,1,-11,-34,41,23,-60,9,7,-22,-22,-77,-5,-18,1,-42,-12,34,22,-89,-16,16,-72,5,17,-16,109,45,12,-123,-55,71,10,-4,-89,12,3,38,-61,0,-50,96,45,-32,54,-6,-9,-12,-45,-53,8,50,38,-3, 
  /* [606][0][][] */ -11,46,-11,-4,-39,-124,-2,-7,-11,79,-20,-103,-6,19,-21,6,-34,-11,56,24,-77,-21,36,-23,41,3,2,-49,-22,9,3,-54,87,-42,77,-50,44,-22,-20,72,26,-4,9,-40,-19,57,27,-51,14,-56,26,71,-16,52,-31,37,62,-65,15,-36,3,-41,-31,11,13,-2,13,-14,-36,-72,73,-19,3,20,41,7,3,35,57,-41,-8,-75,8,-70,20,5,-3,25,74,8,22,51,10,-6,24,-22,-33,-32,19,96,53,-1,-50,-7,-39,-43,50,-43,-127,-36,64,-26, 
  /* [607][0][][] */ -24,-46,-18,-13,32,-43,33,6,7,26,-1,34,-56,-13,-56,-21,-36,1,-60,68,-79,13,-74,-43,39,43,-24,-18,2,12,-17,14,-26,-30,57,53,55,13,13,10,39,-8,-35,74,-39,30,-32,22,-73,17,21,48,-16,-6,-5,45,-1,-53,10,-24,-28,33,-30,-35,-4,25,-43,-30,-60,127,16,-76,59,32,18,24,-82,49,4,68,57,58,60,-24,46,39,4,3,-9,12,-50,32,80,5,-38,-44,13,20,43,37,13,45,42,-55,-29,-6,9,-37,-38,-5,24,22, 
  /* [608][0][][] */ 80,-48,44,77,-19,-25,31,-42,71,57,-65,70,36,74,42,60,5,69,-37,-107,35,-119,34,5,-13,24,-32,31,18,80,17,52,-75,68,67,8,7,-80,-6,-57,15,-17,8,-47,11,75,62,61,70,62,67,15,-55,-12,83,15,7,0,32,-69,-19,15,-69,-127,-43,-74,-53,72,-15,-60,-31,-14,22,-52,-74,-22,56,-75,-70,39,7,24,44,98,3,-10,-72,21,1,39,53,10,47,-74,-4,114,-14,9,46,79,-20,-40,-94,-54,28,2,-17,7,-39,-2,-84,0, 
  /* [609][0][][] */ -17,23,6,-95,-33,-26,-41,2,48,53,-58,41,1,-62,-25,64,-17,6,-60,-22,58,-49,33,-45,11,7,-54,-44,-2,73,-6,-19,2,33,32,-3,15,29,48,-81,-127,-21,4,-1,-56,-6,12,95,1,-20,-45,-49,27,17,-33,8,-24,-18,-65,-62,-2,18,6,-49,-2,-18,-8,65,3,11,16,31,-68,29,-67,-15,-10,-21,-110,31,69,22,-91,14,-39,-10,35,32,-15,-12,43,-54,-7,-18,-3,80,-3,-57,55,56,52,14,50,-75,57,0,1,-39,-73,-90,-29,11, 
  /* [610][0][][] */ 88,-27,-8,-10,8,54,39,59,106,-49,83,-50,60,11,91,2,25,10,-6,-39,-11,-65,-43,-18,6,77,13,61,55,-2,13,-67,-55,67,47,29,26,-31,55,33,-1,23,-24,0,-32,6,31,-48,4,-35,7,127,-30,-5,7,36,27,37,-43,-17,-30,-34,27,-58,-21,-18,-7,-49,50,54,-83,5,70,-31,-1,-28,47,20,75,-18,-8,10,69,46,-46,-77,-13,-8,-19,16,-61,-8,51,88,-27,7,-27,-47,50,24,36,-47,-18,-64,-60,24,1,5,46,-9,22,-47, 
  /* [611][0][][] */ -21,-60,80,-42,8,-50,-63,63,22,-35,47,-21,65,-55,39,20,54,-127,62,-43,-14,-106,-116,-37,-34,-36,26,-72,43,60,50,8,42,44,31,62,-28,10,0,49,-35,61,-60,-123,-66,58,-47,16,34,-36,-28,-5,49,24,27,7,-63,67,-27,42,121,-24,-19,59,-97,-6,79,56,72,75,-76,47,-5,-8,68,43,13,-23,-13,-84,2,56,-104,3,4,45,51,-23,12,16,-44,-13,-27,66,-61,-65,-43,72,-33,61,-54,-48,-53,47,-52,-31,-22,11,7,-38,-55,21, 
  /* [612][0][][] */ 19,42,-23,36,30,20,-4,26,-29,-79,-27,-86,-70,-61,-8,31,61,-23,-26,-76,43,127,-35,-14,-3,-42,-60,8,-86,109,3,58,26,41,100,54,40,18,-21,54,-37,48,28,-38,36,-64,-7,-30,56,35,15,-37,-16,50,39,2,87,-58,38,1,-8,29,12,23,69,-19,-57,-5,-5,-5,-31,-7,40,6,3,-39,19,-22,27,-5,-15,-31,-60,-27,0,-9,3,117,8,44,-5,58,-33,-50,-81,79,-2,80,-55,51,-43,39,0,-37,-28,5,-23,-8,36,-57,53,-13, 
  /* [613][0][][] */ -19,51,116,11,113,83,25,-6,75,-8,-17,-42,-57,-80,101,46,2,28,-35,-3,19,109,25,-7,20,-75,-1,-63,-42,90,78,112,-11,36,76,-24,-30,58,-47,-12,-17,33,-10,-11,-57,-34,-39,-85,13,-43,-39,-15,-5,56,46,99,19,94,-21,7,-33,-20,48,54,76,25,0,-37,3,-3,-32,0,99,62,17,9,-69,77,59,47,-57,85,5,-33,1,86,8,35,117,85,-94,-74,-118,77,9,-18,24,48,-11,127,-20,39,98,-39,94,-25,-80,-74,10,16,-97,40, 
  /* [614][0][][] */ -24,0,-25,53,25,-84,14,-23,13,16,69,3,4,-22,-19,-14,83,-8,28,30,-56,-69,-31,-108,-14,-78,-27,-9,23,-39,52,49,20,6,7,11,-44,57,4,38,55,-31,-23,22,-68,1,-58,-22,34,61,102,8,11,13,-7,-30,-15,25,62,42,-27,-75,-23,-65,-1,-32,33,-14,100,-27,56,1,-127,20,-28,8,-49,20,-21,15,79,-65,-29,-6,-56,-19,-44,50,0,21,-33,-70,-60,-37,39,42,48,-30,46,48,65,-42,23,-27,-71,0,77,36,-12,-20,-56,-38, 
  /* [615][0][][] */ 101,48,-39,-43,5,-31,-24,-18,-53,5,21,11,-30,43,80,23,13,90,-114,-28,-58,27,-32,-49,-121,-8,-11,-27,-6,34,98,-55,-14,6,44,70,52,1,51,-27,-108,40,-56,2,-36,12,-5,-34,39,80,-28,81,-45,1,94,-49,-7,-26,-11,12,-36,28,-7,-51,-48,63,-11,-18,-51,-43,11,-20,53,-29,-4,71,2,13,-12,28,-108,-10,-39,-78,-50,-33,-49,-23,-46,113,-31,7,0,43,-72,91,-7,63,-59,-49,-8,3,75,20,104,-83,-117,-39,127,33,21,52, 
  /* [616][0][][] */ -13,78,37,-43,27,61,-13,-3,-24,-12,-22,1,28,34,-43,37,-10,-53,-27,8,67,51,-12,-35,54,-65,-109,-28,-96,-82,11,10,-15,-55,-58,-52,-26,17,-27,-46,24,-18,-31,-15,1,-71,-35,84,12,-37,-17,-57,36,-40,39,-60,15,22,57,9,-40,-46,23,-78,61,-18,-15,57,29,-93,-37,43,-25,15,33,-35,-29,23,-39,106,77,-7,-51,-19,44,19,127,88,85,-14,-39,90,55,0,56,35,-20,21,66,-46,-27,43,-50,49,-41,32,24,52,2,-84,-1,-32, 
  /* [617][0][][] */ -43,-5,7,-34,52,-1,37,0,39,-2,26,-49,29,-12,-25,28,30,37,44,-37,-59,-9,38,35,108,-43,46,49,-81,-97,-69,-28,35,-50,59,25,-42,14,-11,95,73,-22,43,8,38,29,64,10,-42,-127,-30,19,38,9,-44,80,25,-90,-32,70,80,74,76,-19,-44,-4,3,-37,8,59,-43,-9,-24,-33,51,13,40,-41,-83,18,90,-39,58,45,80,-76,35,1,11,73,67,-51,20,-41,0,-6,15,-4,13,37,-76,4,75,15,-51,57,23,-58,-19,6,2,40, 
  /* [618][0][][] */ 28,15,-29,-19,27,-36,25,26,127,25,26,29,-3,-2,76,-2,-44,-30,33,54,56,-10,35,10,70,-15,46,14,-10,-59,-36,-72,2,-72,54,-31,-26,-8,-60,1,29,10,-32,-45,-54,32,86,-28,-72,-48,-87,-22,41,60,-66,6,-7,15,45,-31,67,-18,-60,13,-33,-3,-23,11,-10,17,42,45,-17,45,78,-66,54,-3,86,98,35,45,12,-28,79,4,14,37,-9,-16,-49,60,13,30,15,10,58,-30,5,-35,-23,25,18,-67,-44,-17,64,13,56,39,55,48, 
  /* [619][0][][] */ 36,-20,-24,35,-27,43,65,3,-74,-67,-25,-6,49,-42,3,35,-4,-45,3,18,43,-2,-12,26,-8,-10,25,-41,55,7,-24,15,13,29,23,-27,51,10,24,-98,22,41,14,-17,-9,20,-15,1,-8,34,-12,3,-43,67,-6,0,94,-6,-47,-9,-8,47,30,-26,26,-5,-52,-5,55,17,5,-47,-17,23,-127,33,0,26,-12,-6,6,54,20,-39,-6,-38,10,10,53,4,-23,0,-20,-27,-6,7,-2,23,14,29,22,-44,6,-31,5,-42,47,-20,-60,-3,-48,8, 
  /* [620][0][][] */ 2,-4,81,-50,-102,91,-28,-32,-6,64,-27,2,-10,-16,-7,-1,15,11,4,4,35,-36,-41,0,10,-54,-5,-14,-9,-95,51,28,53,-1,4,-36,21,-105,0,63,-127,8,92,-25,-30,0,30,-4,-52,44,-44,-35,-46,0,47,54,-18,44,3,-66,63,-39,-56,36,-24,63,0,42,-9,38,43,-40,-14,62,28,-21,-18,-29,-123,35,-63,8,52,-23,7,-15,44,-16,-57,69,49,4,-2,-45,37,43,-72,-40,-48,21,63,-6,94,-2,-39,-10,11,34,55,37,37,-36, 
  /* [621][0][][] */ 18,-18,23,19,37,19,22,13,5,-35,38,4,-19,-38,58,11,-5,7,-11,-29,9,78,-2,54,-19,-3,-84,-8,27,4,23,-2,-53,-9,22,6,3,-39,-29,-19,21,-31,38,46,-9,-38,11,-6,-16,-43,36,-24,99,6,96,-12,30,46,-5,21,-42,-28,30,-3,-12,33,-2,-7,27,28,12,-43,22,80,19,-39,7,-35,2,4,-60,14,27,-19,-20,16,69,20,-27,-5,14,-11,11,-126,-127,24,5,-46,-8,-10,-12,44,-19,-5,29,-18,22,86,-2,-29,65,-61, 
  /* [622][0][][] */ -4,61,-21,51,4,-76,-20,-10,32,81,-2,36,-69,-4,-33,-37,7,-15,17,-127,15,-68,-27,66,9,-30,16,-76,-117,10,66,10,-104,-55,-38,-116,-20,55,-2,30,36,28,11,-35,4,-28,17,-3,22,-38,86,46,34,23,-49,40,-33,-98,43,-13,-35,10,82,23,-34,-5,16,45,-17,-46,-69,-82,30,18,16,-48,-63,27,-11,34,53,-47,-44,-44,-41,16,89,11,5,12,-57,80,25,83,-23,15,19,-88,58,-99,-34,14,-61,26,-68,-1,9,123,-15,1,-4,-27, 
  /* [623][0][][] */ -6,-21,38,35,8,36,-40,-63,50,-10,89,38,6,-23,-57,25,78,59,-49,33,80,24,-33,41,-38,-58,5,103,-48,-43,-8,-6,-39,-12,-40,-96,-19,14,33,-4,20,15,-9,0,49,-23,6,33,-21,64,-98,-19,34,11,-6,-3,-54,-1,-57,109,-47,8,-13,14,34,46,-55,41,-11,19,39,51,-38,37,-11,21,-80,-18,79,-6,-66,41,72,12,-49,14,19,7,26,-9,28,-38,-26,-31,-61,-127,-34,56,0,-83,-64,-48,-78,98,-9,-7,-23,56,72,13,33,-45, 
  /* [624][0][][] */ -8,10,-28,-61,-29,5,-76,-12,31,112,-2,17,77,11,-3,-7,-25,32,37,30,-73,-6,12,6,37,37,58,-1,8,-17,23,-14,-31,24,28,12,-6,-4,41,14,35,-82,-87,9,25,-4,22,-6,15,-28,-5,2,-81,-12,-82,-6,-51,-6,75,-7,-42,-39,127,12,-33,30,-22,27,-39,-22,82,25,-17,-33,-41,-55,28,-17,48,8,43,23,-9,-18,-17,0,3,-7,-53,-37,-43,-6,-31,73,1,29,-5,55,15,77,32,-1,-37,11,119,4,5,-2,-58,-20,9,49, 
  /* [625][0][][] */ -28,-27,48,35,-3,91,6,-57,-43,31,-36,33,-14,-42,71,-47,32,-17,0,-12,79,-51,-39,-23,-27,1,31,37,-57,-12,57,-3,-20,-14,33,32,-109,-14,-75,-110,47,28,-91,-80,-58,-22,-13,-16,24,-27,65,34,54,63,-91,-84,-44,64,-43,6,127,26,45,-8,-1,27,-17,14,28,59,1,9,-14,-6,-46,-62,47,29,-85,-38,29,-23,-15,0,54,-32,3,-31,-33,-3,-59,48,45,-16,-7,42,53,-29,-49,68,89,30,77,-19,25,12,-54,7,-39,1,-54,74, 
  /* [626][0][][] */ -11,33,33,-41,-11,-17,4,58,-16,74,17,2,25,-26,46,-77,69,52,127,25,-40,7,16,68,-38,4,10,-10,-15,62,77,35,-45,-23,14,-16,16,34,-24,-7,-56,35,-46,61,-30,37,16,84,72,3,-10,41,51,10,-35,-9,-119,24,-78,32,-33,-7,-78,-60,7,-69,4,74,-12,35,76,-33,13,-52,-13,22,-57,5,-54,30,-22,-19,-22,-50,24,-36,-76,33,-31,-12,40,31,-77,56,-52,-67,17,-18,112,-38,-33,-3,14,19,-84,-3,-47,24,-36,40,-9,49, 
  /* [627][0][][] */ -20,-42,-54,25,-23,41,22,7,-70,-42,63,78,2,-1,98,-14,44,4,-126,-106,30,63,-27,34,-46,39,-47,-16,34,67,-127,46,-39,82,49,10,45,1,33,9,54,-36,40,-9,-48,59,-34,2,-24,39,-49,35,28,5,-31,-84,63,-14,64,-18,4,0,-23,43,-45,50,-49,-53,66,14,2,-53,24,-27,44,-27,13,42,35,-36,-20,-1,48,21,31,12,-16,2,59,-43,-3,-16,-40,102,-20,-54,60,26,2,-5,-31,-54,39,-1,33,-30,86,38,11,-7,17,33, 
  /* [628][0][][] */ 4,-31,-41,91,-59,-11,85,69,-44,6,51,52,-74,127,-36,57,-24,12,-3,40,-5,-56,32,10,-17,-37,38,-11,57,1,14,-46,31,10,20,11,80,60,41,-51,42,-16,53,86,-22,28,-33,98,37,-57,-88,45,32,9,-71,-18,73,-26,80,17,45,-64,12,-30,8,-39,-22,-77,-35,80,7,12,63,-6,-13,-15,53,0,-9,40,-43,1,40,-20,-24,20,-5,1,83,70,-27,-18,23,87,-94,23,22,-12,-19,-82,-43,28,62,-48,-26,-28,34,82,12,32,-58,55, 
  /* [629][0][][] */ 66,-22,-18,58,11,75,34,-24,-7,-59,22,31,17,-63,80,4,76,65,3,-65,-69,-5,-2,21,-42,36,-69,36,-60,-20,5,18,30,99,-14,13,12,16,-11,18,45,-3,23,-51,-9,-50,13,-7,-27,-6,22,-97,-40,-37,42,-24,52,-18,20,15,38,-1,-5,-11,-86,-55,-68,6,6,-19,5,24,-60,-20,0,13,-36,-27,16,0,127,73,-20,-1,33,-37,-4,-27,63,4,-34,-18,-11,-24,36,24,58,-8,-54,-5,38,-24,18,24,47,40,20,-20,38,52,95,-39, 
  /* [630][0][][] */ 19,66,-90,-28,-2,10,104,37,19,60,51,-11,39,-74,-12,11,-14,-41,-16,15,33,-28,4,5,-35,10,-13,-26,-35,-20,-58,3,79,16,-55,-23,-9,17,7,0,39,25,29,58,36,-73,-8,32,-1,13,20,-3,-7,19,27,-21,2,-34,62,49,14,-33,20,-34,50,26,-54,-46,-34,37,-58,-34,-23,-20,17,-3,-23,-21,-100,26,-60,53,73,14,11,-43,23,23,38,-79,-36,7,-13,10,-34,69,-48,16,38,63,0,-2,-127,-33,-36,-26,6,16,-6,-51,-42,40, 
  /* [631][0][][] */ -56,36,-74,-33,42,61,4,-48,-32,36,119,28,-51,-15,86,24,58,-16,58,41,2,-10,33,62,35,66,-64,-14,50,25,127,-21,-6,-20,-10,74,-6,48,22,62,-14,-13,39,20,-59,0,42,-52,75,56,-42,18,58,-7,-34,0,12,-19,73,61,9,-82,91,30,-42,95,-31,-68,-32,-9,-14,-27,12,76,9,9,3,25,-83,-42,-20,-24,8,-45,8,81,0,-52,16,74,1,28,-27,40,-4,26,-15,-27,-37,-58,-46,-20,34,57,32,-53,-24,1,-43,28,-6,71, 
  /* [632][0][][] */ -68,-63,-7,85,27,77,-38,103,36,37,56,24,74,14,-28,54,66,38,0,-19,44,-10,-7,106,-59,-24,14,61,-30,-96,2,26,-79,122,-4,-44,52,36,-6,12,-23,54,22,109,-31,44,-78,58,-78,-71,51,-2,73,-86,-22,-33,-51,58,-19,-48,10,85,-81,-28,-63,-28,33,25,75,49,-111,-72,19,-119,-36,-82,17,5,-61,22,-29,127,-62,-2,-38,4,-72,-25,47,-4,-21,-62,27,28,27,7,-26,-42,64,23,64,-68,31,61,0,22,-45,46,-13,69,-71,-40, 
  /* [633][0][][] */ 50,-121,-50,31,23,-37,-18,24,15,41,-125,-51,-62,44,-125,-65,97,-40,-9,-31,-38,9,-30,-17,-65,113,38,-2,-97,82,-7,103,37,55,50,101,-29,-78,37,-124,58,-43,21,-30,83,62,33,-83,-48,68,56,51,46,2,-5,-65,60,-85,-52,26,65,123,-1,-47,36,34,34,-10,13,58,-49,-25,-113,-48,1,-26,-93,50,17,-54,84,1,-35,0,-68,-50,25,-15,9,-19,-84,-36,56,12,-127,-48,83,9,14,-33,11,35,-44,-39,8,4,26,19,2,-29,0,-32, 
  /* [634][0][][] */ -54,-49,-25,-25,-97,-101,-30,65,43,60,-17,-36,55,-47,56,4,-43,4,-51,-102,-33,-127,-10,-34,-5,37,-18,-27,24,27,-67,7,85,6,32,34,10,50,30,-50,-6,-30,-2,-11,20,-3,56,-25,-84,29,-103,-7,-54,10,8,74,50,-57,25,16,46,15,-12,43,43,-25,-11,-95,-23,36,-37,-94,18,-115,-27,9,-3,42,8,74,-8,-2,7,6,-35,-32,-7,23,11,-5,17,29,45,10,-41,-100,-4,98,29,81,-5,-22,-30,-12,47,29,-37,-80,-30,74,-62,1, 
  /* [635][0][][] */ 42,76,69,-33,-3,76,14,-26,-32,24,20,-81,-1,2,-21,27,53,20,39,-42,16,127,57,-16,2,-40,-32,31,-61,6,13,2,-18,-25,3,15,37,-16,37,48,-11,53,19,34,-28,-85,31,27,-48,16,56,-41,-58,-14,34,32,-23,84,-86,18,41,-7,60,-10,19,26,20,-9,-12,58,35,-15,58,-15,-56,67,-12,-28,12,39,-77,30,-10,-56,-75,0,8,32,38,-14,12,-31,-35,-9,4,97,61,10,-31,-31,55,106,-10,2,18,16,-15,30,-19,30,-29,5, 
  /* [636][0][][] */ 90,34,64,-33,-56,-20,-36,45,38,50,68,27,75,-67,51,74,39,-6,36,-43,74,-23,-3,-34,-55,-50,9,-79,68,-32,33,17,-27,-19,77,-22,-59,-37,39,-13,-24,68,-1,34,-14,121,-41,-73,16,57,48,52,-14,-74,-8,-19,-55,70,21,-14,73,100,-3,9,-20,15,-63,11,14,34,-15,67,9,-33,-16,45,59,-54,-2,18,-48,-39,-87,-19,29,-50,81,-15,-45,55,26,20,-40,-73,-21,41,92,-53,61,11,-40,-28,47,-41,-21,2,-24,-7,-51,127,-79,-99, 
  /* [637][0][][] */ -6,-21,-21,45,-30,18,49,57,-8,3,47,31,57,33,-16,46,-52,-39,-18,-69,-34,-21,44,4,50,4,-21,-47,-50,-57,-5,-22,-23,-51,-28,-37,62,67,-111,78,-13,-26,65,26,114,-29,-1,-25,-29,35,-8,-5,-105,27,-4,23,113,-64,127,96,-86,-11,-6,36,-24,-5,-61,6,-50,21,-4,56,36,-31,51,-9,-5,3,-27,61,-103,-40,71,-24,35,45,43,18,33,-55,-44,22,11,-26,-10,28,64,74,-2,43,-91,-18,-27,12,42,35,4,120,-24,14,-36,51, 
  /* [638][0][][] */ -17,-7,21,-66,-26,-4,88,-31,33,-50,19,33,8,48,10,-62,34,-46,-33,-34,-25,0,-33,-39,-32,-8,10,-26,54,-30,11,-17,-32,-14,63,6,23,68,-11,6,31,-12,25,127,49,52,5,2,5,42,-13,-39,-102,19,9,57,38,2,0,-36,-29,18,4,67,32,68,-1,4,-35,4,-31,6,-3,-20,45,-7,-12,7,-42,-22,-52,36,81,-50,-8,74,18,-13,47,-1,29,-4,-19,-12,-3,-41,58,-19,38,-2,-14,-37,56,-41,-16,-20,-42,9,80,97,-21,-34, 
  /* [639][0][][] */ -58,15,21,5,14,-23,-71,-9,21,14,-41,-81,-40,6,-82,-40,-15,-4,49,1,-72,-44,-66,27,82,-34,23,34,-104,6,41,43,-3,-33,-46,-84,75,-30,-9,18,13,19,-6,53,17,-5,94,-14,-33,-60,-19,-13,-33,45,-45,61,82,-35,23,23,1,0,22,-127,15,62,-16,-17,4,-73,7,83,-45,-29,78,-53,-25,1,-78,-37,-5,34,-76,-65,-11,20,-18,-12,-52,36,4,-14,-9,-96,21,27,24,-47,80,93,16,25,84,-21,61,40,39,13,16,-21,-11,-55, 
  /* [640][0][][] */ -25,50,44,-90,9,-17,36,-17,-11,66,-36,-4,68,-28,-48,13,-60,23,-49,13,-30,-85,-8,61,74,-5,15,16,-20,-7,-58,125,27,16,7,10,-14,47,-80,44,-96,-63,20,6,-79,44,-14,-24,-19,67,127,-5,44,-89,-6,-31,67,-20,7,22,47,-39,49,46,-44,-29,34,42,38,46,-2,1,-80,-94,-5,69,-2,14,26,-75,28,2,17,50,-94,-58,-52,9,-85,59,-16,74,58,61,114,-27,-61,28,11,0,2,21,-31,35,-14,47,-48,23,-53,-37,26,-50, 
  /* [641][0][][] */ 68,-8,-9,-23,-54,-108,8,39,-9,-2,-89,15,15,0,37,53,-9,114,-71,25,-71,-12,78,-54,39,33,7,-9,-67,-21,-6,-15,-84,37,-51,33,-69,5,-12,-84,7,41,26,18,58,37,-25,120,5,-32,-28,-12,-28,-64,72,125,-58,-26,-45,38,-27,-67,29,48,52,-127,52,70,-41,121,42,-82,-1,21,-29,-13,-32,56,31,38,17,66,-71,73,11,-55,-51,-118,40,55,-92,-75,-68,-78,-61,90,13,28,33,30,122,2,-37,-32,40,15,34,-21,-10,10,69,-25, 
  /* [642][0][][] */ 5,-14,-17,73,-50,-43,14,-53,-12,-24,-12,42,-15,18,34,3,-3,68,37,33,-27,15,31,-44,3,-35,32,-35,2,41,-71,43,57,-32,1,-29,77,-9,-3,-5,6,68,15,-8,-89,-21,-9,41,-67,31,57,37,5,-13,60,-33,-44,-62,-10,-23,-22,-20,-8,-31,11,-15,-67,39,-24,22,-43,29,-3,-38,36,32,-41,32,-90,29,-103,-38,-7,-37,39,-11,38,-59,72,-39,48,29,41,-63,28,69,-19,63,10,-35,73,-2,-14,4,127,-18,-47,-18,-23,-45,4,50, 
  /* [643][0][][] */ -17,85,6,-6,-29,63,-9,9,-127,21,-47,-86,-115,-15,-7,-16,94,-6,-28,47,35,-7,-39,-51,-25,-62,33,-72,63,-83,20,-98,64,18,53,-123,-124,78,-10,38,-37,63,-6,-95,37,-51,-19,33,-30,76,4,37,52,55,77,-9,-15,24,19,-12,53,22,29,-35,-16,55,9,-109,-3,-20,-29,86,-45,107,15,-39,-9,-22,48,-92,-28,4,-66,-90,13,49,17,76,76,39,36,-72,4,16,-10,-5,8,68,-21,60,11,6,86,12,52,-57,-34,67,-28,-20,-12,-17, 
  /* [644][0][][] */ -30,68,27,-92,-123,24,46,17,-92,42,21,41,64,-66,66,74,17,56,17,-33,-8,71,-1,25,-18,6,-42,-44,44,24,-7,57,42,-51,-38,-39,-22,24,29,-7,3,-15,33,64,13,-55,54,20,-78,-28,50,-25,10,63,-13,-43,85,-19,-55,-2,-62,-26,-39,-31,-34,54,-4,54,29,37,-24,20,19,-62,25,-33,-20,-19,49,-71,4,-26,-10,67,103,-59,-112,23,-23,-81,-15,-3,-54,-24,32,32,127,-64,-60,31,-12,8,84,-4,-17,-16,-20,-73,-17,89,-75,-48, 
  /* [645][0][][] */ 31,-60,2,4,14,4,19,22,-4,-37,54,39,33,-31,-19,-23,-39,-40,19,5,-7,4,-45,-26,23,37,-1,-11,-23,-10,-26,-37,25,25,-90,-31,73,-75,-31,60,28,-93,38,-45,26,-70,-1,48,127,21,-29,-5,1,44,-6,-12,-3,36,-17,79,-49,6,-40,-16,-1,-60,-124,36,0,25,9,31,-57,38,-87,-72,-10,-34,-7,-68,-1,59,-47,27,49,20,11,55,-60,-48,26,85,32,-22,-40,-25,-8,0,-47,-3,-41,-10,-56,0,68,40,20,36,-27,-51,-10,3, 
  /* [646][0][][] */ 35,29,-12,10,21,72,2,-12,-18,104,31,5,65,127,-53,-5,-2,-7,-85,-18,-76,5,36,15,26,-117,-1,57,-72,-33,-61,66,-14,-49,37,-89,-30,-62,-42,-20,27,-83,-37,-13,6,33,-13,35,10,13,-64,52,-23,75,-22,20,-59,30,60,32,-84,32,-28,19,-46,-17,48,51,24,-15,-55,5,14,-100,-60,104,-55,11,-27,-10,-65,-2,30,55,-69,-50,-4,19,-46,-14,-52,40,4,-17,25,-3,21,54,4,80,-112,90,-22,28,-41,20,30,39,-24,64,-14,-28, 
  /* [647][0][][] */ -7,-1,-28,65,17,-59,-32,-52,-37,28,41,-18,-39,24,46,21,8,-11,-60,19,-47,67,-80,25,-7,-79,22,-39,-88,-42,-32,55,43,-43,29,-65,34,127,-26,56,116,80,44,13,-39,56,48,3,49,10,-81,-29,-114,-56,-66,66,-80,12,-43,15,24,-94,102,54,72,-32,61,87,-69,104,2,-2,-44,37,-24,15,16,-8,-9,-14,-57,-70,8,-61,15,-25,111,31,-25,79,89,-39,35,25,61,-6,39,-13,18,-26,-20,75,-10,-41,97,22,0,58,44,4,39,19, 
  /* [648][0][][] */ -44,-10,102,-77,-93,-89,-33,0,-37,98,-20,3,-88,-18,-27,-17,-18,10,-47,-31,29,38,-66,-23,-17,51,92,57,-25,0,79,-16,8,-47,0,-44,28,127,-38,-50,50,-8,-43,-64,93,-10,28,-19,55,22,41,-27,100,-26,-44,-8,11,23,-8,-5,32,32,56,-47,-45,-48,-31,66,51,16,-33,74,-45,91,-28,-8,-52,36,26,-6,115,48,-48,-77,25,-23,-23,92,-13,-28,-32,15,20,-7,44,3,76,40,63,1,83,-19,18,-65,10,-39,-28,69,71,62,30,-24, 
  /* [649][0][][] */ -11,76,104,54,38,-85,62,-12,14,-11,23,-48,-37,-6,-29,127,-4,-69,0,1,-27,-43,68,1,28,22,-5,-21,10,9,-42,35,19,-96,30,64,55,-8,-3,-11,-64,56,29,-29,34,30,15,-24,-23,56,-21,46,-4,27,23,9,-24,52,27,48,-28,-50,-34,45,-38,-31,23,20,54,-13,27,-26,13,-108,61,-36,-44,12,3,-70,-24,-20,-17,-43,14,38,25,10,-25,-14,-57,-49,-14,-49,42,-94,-1,3,38,-52,48,-14,-3,6,62,16,53,-20,33,52,0,-18, 
  /* [650][0][][] */ -3,-46,15,36,56,30,12,-14,35,12,56,32,51,-12,96,16,-7,17,27,34,54,32,-17,21,-92,59,-127,2,19,27,15,31,-12,23,25,17,-42,-41,50,40,97,-16,-7,-41,-23,46,13,57,58,-49,34,5,27,-4,-32,54,36,16,-11,24,-23,-28,35,55,43,-2,23,68,-18,10,77,71,52,52,41,-5,50,-9,36,-12,71,-14,-37,-16,-16,32,-26,97,-26,18,6,18,-26,-33,56,-101,-10,-16,-4,-81,-73,-51,31,48,-48,13,-4,-34,-72,-17,-21,-34, 
  /* [651][0][][] */ -35,29,75,76,22,4,63,-50,-51,44,-25,-79,29,-16,-41,-49,-9,-43,53,42,-127,41,-52,32,-12,19,-67,-39,44,27,68,-60,39,-30,39,-17,15,45,12,-31,23,-5,98,-81,-21,-41,4,-20,-28,-34,-31,14,-29,35,-53,-86,-17,-9,27,54,-116,-2,-29,58,-41,-2,-95,6,74,-63,4,-35,-57,-92,23,34,-30,35,10,66,-9,58,56,-52,55,-29,22,-116,119,-30,-72,33,52,-33,-86,-34,118,83,29,74,4,-68,-28,-102,-13,10,-54,17,7,49,-12,-93, 
  /* [652][0][][] */ -13,76,-9,-14,8,-90,17,56,-21,41,-44,-41,17,-17,127,-91,21,4,34,76,9,24,-32,-25,-17,40,-23,64,-22,55,-29,32,-32,-65,86,27,2,-5,-9,-40,-15,33,22,25,45,33,76,-36,35,-110,7,-9,34,6,2,-88,-9,18,-47,-4,63,59,41,0,38,67,-65,-31,-19,46,42,-20,4,-2,-65,-15,2,42,24,-34,37,2,-22,-78,-47,-80,-9,-35,22,-42,75,-117,-17,17,59,53,47,-19,-49,-39,-63,101,10,-11,73,11,-19,-59,-33,76,121,28, 
  /* [653][0][][] */ 68,40,-48,20,-31,40,-59,37,51,10,49,-24,-24,-39,52,-6,8,4,-53,-67,31,44,69,-4,-2,-69,-13,17,8,-24,109,28,19,111,31,0,15,17,0,-75,31,6,71,-44,5,-38,15,-11,71,16,-4,-24,25,8,124,-13,-46,13,15,18,48,17,-47,-94,2,-75,27,9,16,-108,-43,16,82,-127,38,20,-49,14,13,61,-68,-9,40,-20,-9,-84,-71,-78,62,9,-88,-17,-33,-3,-25,61,-12,19,35,44,-52,47,-8,-57,7,-15,57,32,-66,22,20,-19, 
  /* [654][0][][] */ -75,-4,-67,0,64,31,57,-38,-26,-61,-10,-3,-42,-76,-46,-1,34,-76,13,26,-74,-20,-31,7,16,-22,101,8,-11,11,-31,84,81,-96,37,-42,-1,11,-33,45,4,-34,38,10,-127,38,-62,34,8,63,-19,52,-35,101,28,57,36,14,-31,62,33,-36,34,-5,14,-37,3,38,56,-19,-26,29,-39,23,10,39,-6,-6,-10,44,53,-1,-10,-48,-51,-23,-10,-15,-86,48,14,-3,34,35,-40,-25,-12,-64,-25,-6,94,44,36,46,27,-35,-45,90,15,-77,-67,-73, 
  /* [655][0][][] */ -28,-68,39,9,3,61,-45,-64,41,20,-19,4,34,48,-22,89,21,23,117,-50,-87,-53,-95,-25,-3,33,-2,-76,-30,-43,-90,-2,-72,79,-13,82,62,-40,69,-9,11,41,-30,33,-63,-73,127,85,-22,-68,39,12,8,-85,-61,-42,66,13,28,-9,-20,-12,3,-81,-25,-26,-44,-108,-65,-70,25,-121,-52,15,-35,42,34,10,-31,-11,-50,-16,77,-42,-4,26,3,2,13,17,42,57,-54,-27,-6,38,18,-91,90,-76,-52,-19,80,72,25,-42,1,21,-23,47,36,41, 
  /* [656][0][][] */ 9,-13,37,69,32,46,64,-32,-80,-23,-6,-6,40,-20,60,-19,45,1,90,2,-1,30,-55,-81,-6,70,69,20,24,-8,6,23,30,10,46,28,61,-7,21,-8,31,55,32,30,13,15,-53,12,25,-19,-98,-64,51,-54,88,-7,-15,72,0,-4,-21,-23,68,-10,1,3,-2,-49,-48,10,60,-49,-6,63,-11,-3,35,-64,22,-58,30,2,-28,-24,58,-21,-9,4,-82,-21,-30,-27,103,50,-38,127,-19,0,-56,-2,41,-17,-32,12,25,77,10,39,-6,8,-88,-24, 
  /* [657][0][][] */ -50,-127,18,20,27,-79,22,-16,-17,34,36,-73,22,-31,-67,-41,39,-57,-26,-26,-16,-47,-51,78,61,-26,8,24,-33,-42,-79,-32,19,-82,-14,-79,-56,-7,56,69,43,-51,63,6,-5,-6,-2,26,-34,10,24,-23,65,62,-101,-18,86,12,-16,80,-28,-126,-15,123,23,-10,39,-49,3,-8,-66,15,13,7,-3,63,-31,24,24,13,-31,-25,104,9,9,-26,3,2,5,14,0,-16,29,1,52,95,1,-13,34,28,29,-98,-18,-69,-19,54,6,6,42,-31,-41,-58, 
  /* [658][0][][] */ -83,14,16,11,-55,-24,17,-4,-68,35,-38,-40,31,-35,43,-84,57,5,-33,59,56,-44,-22,39,-58,-8,-11,-27,8,-3,-52,-33,-49,-14,3,-10,32,-86,33,40,15,-32,-15,-28,-40,3,-17,-12,7,15,-17,-31,42,-1,18,-10,43,127,-78,8,8,15,-1,-64,43,70,-16,-60,-31,-76,14,11,19,40,39,-71,-16,44,-35,-67,-18,4,27,-56,106,-73,-69,-37,-31,-16,68,-42,-73,49,-38,61,60,-67,4,-29,-107,-10,-17,-37,15,-47,5,-21,-48,13,-12,51, 
  /* [659][0][][] */ -3,-26,1,127,59,40,42,-70,-11,-5,-29,-23,7,10,-31,-77,74,25,-34,-38,7,2,25,16,-34,-73,-43,12,-40,46,-88,-29,-72,27,16,-7,36,-28,-112,85,-65,-19,97,-91,-10,-48,111,41,-19,-37,-11,-113,-26,83,-55,-60,32,-107,1,18,17,15,103,52,-72,-23,25,-34,34,-10,-61,83,76,-4,-24,-36,-3,21,-36,70,-73,12,-4,20,-40,-37,32,53,1,-115,-82,-15,23,82,-71,-39,74,26,30,80,-86,-72,33,38,-9,40,-22,104,-68,-45,-57,93, 
  /* [660][0][][] */ 25,31,-71,-105,12,-76,-18,15,-75,31,14,-37,54,1,-87,77,14,40,-74,65,3,21,-70,-5,-23,-84,81,55,0,22,43,-127,-81,13,0,-47,93,-46,-10,0,121,23,-30,10,44,-13,-62,-69,27,-48,54,42,-7,80,-30,-14,79,-93,31,-88,7,27,-66,51,-42,-24,-59,-8,24,45,-38,-18,-5,66,20,49,-47,115,59,-65,50,-116,10,72,-24,-10,13,39,43,-38,23,31,-44,12,-81,0,-67,52,-10,54,-25,29,-29,50,-20,99,-35,39,-75,64,-4,75, 
  /* [661][0][][] */ -83,18,-39,-26,49,56,-22,-80,-27,-26,27,-9,37,-96,-61,5,-13,-68,19,-19,8,-12,24,-33,10,-41,-69,-6,-4,42,8,59,-12,-25,-7,-36,-2,-22,-42,78,88,-18,25,-33,9,-31,-14,73,-11,24,-42,28,-26,-11,-127,-20,19,-47,-19,-90,-16,62,6,-45,-21,30,-7,40,-31,20,-55,48,-48,-6,-64,35,-17,-47,-6,64,-42,3,59,9,-71,86,24,-24,-12,-50,41,49,-32,-65,-58,48,17,14,5,-64,-1,64,-32,-12,-86,-45,-32,51,-12,68,31,54, 
  /* [662][0][][] */ 127,-51,35,-14,-44,65,58,1,-44,-5,-44,36,66,-52,-18,-12,23,43,-4,-13,32,-51,22,-49,17,93,8,55,-38,41,-48,-58,-12,104,29,-22,37,-53,94,67,-8,46,-22,76,46,17,-26,83,-39,11,-57,29,-9,-126,-32,-11,80,13,56,29,-4,-96,-112,-40,38,-19,-55,-10,40,31,19,-80,-17,-52,-51,-44,70,-51,88,-26,-15,82,-39,-24,-19,79,-24,-35,54,-87,-50,-15,-6,4,48,10,-69,-98,-56,-117,-57,63,-51,46,38,-7,-7,-11,-37,93,59,-15, 
  /* [663][0][][] */ -15,-31,21,-7,-12,-8,33,17,63,-40,-122,-22,14,0,-20,22,37,-21,56,69,-23,3,-20,-67,51,37,95,-31,-124,-60,72,-26,78,-25,70,14,66,-28,10,62,5,48,-12,-42,-31,-29,45,-19,-126,-34,-5,26,21,61,23,56,25,-8,-103,-38,125,-23,24,70,-9,19,109,-13,35,26,-3,-15,-62,127,51,48,-36,18,121,30,23,-49,4,8,-28,100,41,10,-83,106,-6,39,-54,32,-92,-10,-8,-15,110,-74,50,-22,29,-89,48,-14,-69,43,56,-60,-70,81, 
  /* [664][0][][] */ -16,-21,-81,-61,20,102,29,-31,14,-65,-17,-38,-42,-71,32,62,-105,-81,-23,18,68,-35,35,4,-16,-127,101,-34,39,-12,-57,22,40,-20,60,5,20,80,11,-50,38,-7,-11,-30,-40,47,2,-50,-19,-52,-70,74,-66,31,-36,32,37,-19,63,-18,-3,-101,18,10,-29,-13,23,-69,69,46,7,59,43,33,-51,78,-91,-40,-86,13,-36,69,27,17,1,-38,12,-18,-51,-20,2,-33,-25,18,26,2,-92,51,77,31,-54,50,-70,-6,-96,35,-36,-27,-33,92,-60,-10, 
  /* [665][0][][] */ -85,-69,56,-60,29,-51,71,69,-8,-1,-14,-52,-23,58,0,-29,-24,-4,-33,0,-21,-20,27,-36,-38,-72,-1,9,-72,75,53,95,-41,-127,79,-37,70,-11,-20,32,3,34,-53,22,-80,24,-51,-78,19,59,-48,34,36,-11,18,-8,-83,79,-1,62,-26,-40,56,13,16,26,69,33,-8,-37,8,-58,-27,-14,63,4,-66,-21,91,-5,20,56,52,-37,-76,123,83,-27,25,10,-50,-22,63,-23,99,-12,-41,10,98,-24,68,33,14,23,-1,44,1,119,13,55,22,41, 
  /* [666][0][][] */ 12,25,40,19,-52,-48,0,0,-52,-6,-10,95,-43,-39,43,-68,-18,61,16,35,24,68,-49,51,127,28,-68,-50,-9,-84,18,43,-21,-11,78,87,73,-30,-56,-21,20,-32,-106,-79,-41,-20,8,10,3,-86,60,-59,-26,-34,-40,26,-14,-14,58,35,31,43,-37,-18,-41,-102,-104,43,-30,-22,97,4,-6,-40,53,-27,-99,14,71,26,43,-46,77,-16,89,-7,33,1,-6,39,42,57,-46,15,-51,66,-38,-8,38,5,-25,51,-7,50,60,28,-40,-28,90,-37,-71,49, 
  /* [667][0][][] */ -22,-77,68,93,32,73,43,8,17,3,56,-104,-127,14,48,87,-15,52,-71,-65,-52,66,61,-45,36,54,-74,97,-39,61,17,-32,-19,-39,48,112,25,-41,47,-111,26,-52,96,-77,53,-1,-69,22,2,-45,-36,-15,-26,49,-7,34,49,-124,-11,24,-41,7,77,-24,50,-21,1,-39,-28,3,71,-101,19,-2,-36,-9,19,-55,-8,-52,-13,-6,-23,-104,0,-39,-69,-67,27,65,100,-61,-15,26,2,16,40,72,-18,113,26,75,60,-57,6,-113,-85,-8,-51,-30,16,-38, 
  /* [668][0][][] */ 34,5,-88,-15,-18,-23,-22,-89,-23,11,89,8,-5,19,-17,-11,-6,-35,-59,-36,24,39,-17,-50,-19,-60,28,18,-71,-26,-1,14,-58,-15,4,-12,-22,59,-27,-95,67,14,10,124,-11,-127,-12,94,47,27,49,3,-4,-14,109,9,-4,-35,32,18,5,1,6,33,-58,2,55,-19,14,49,-36,-31,-8,3,65,-31,-19,83,-54,36,-80,58,-81,-21,35,-41,47,46,21,-4,19,66,18,38,-27,-9,-5,-62,32,-28,-2,-24,-56,72,37,3,-40,22,-12,80,-12,3, 
  /* [669][0][][] */ 93,-53,97,49,-38,80,45,-125,8,88,-15,-25,-27,-15,127,29,-3,8,-28,-25,85,48,-68,26,-29,-78,19,24,90,58,49,-28,44,83,-81,-55,48,-10,-59,56,56,-41,44,111,90,-2,-29,122,-33,-55,53,-43,-96,6,102,-6,-48,-33,39,-52,51,-38,81,1,17,-27,-10,-101,62,1,-19,64,14,-51,93,21,-74,-3,-1,-87,17,-25,77,-96,91,-33,22,-1,12,30,-26,-99,50,46,75,8,-28,-91,-6,-19,-83,57,-45,6,-34,-1,17,105,-52,45,-83,-21, 
  /* [670][0][][] */ -87,-12,-29,-10,-31,-69,2,78,-21,-9,-75,-71,-43,39,58,46,16,-54,-64,-33,-38,-26,12,23,-106,2,-3,-37,-62,22,-60,-36,-45,69,7,12,-24,42,0,34,-49,0,88,-54,37,-10,-3,7,-77,-3,34,62,-68,-11,58,-34,41,-73,-127,22,-70,44,-33,-9,58,121,-14,-25,5,-99,-8,17,11,5,75,-11,68,84,-46,-29,100,-120,-28,-23,-24,58,7,4,-86,49,77,-16,81,48,-24,50,-1,-63,-18,41,-68,-30,15,50,-67,-9,64,-5,113,-16,19,-29, 
  /* [671][0][][] */ -12,-43,-83,-22,-7,-57,36,21,23,-4,-38,13,35,3,-6,46,-5,44,-38,29,-31,16,11,28,-1,-109,-29,-10,-14,64,62,-54,-12,-78,67,19,-19,-36,45,-3,-25,-1,65,-4,31,-10,36,124,8,-66,9,-32,17,27,-53,-48,-24,-75,-29,27,41,-25,-19,41,-8,-27,-13,9,93,127,-51,-118,6,-27,55,4,-58,65,-34,15,-27,-75,-49,17,36,115,15,-36,-63,-17,41,-65,-112,-20,-54,-97,-40,24,92,-26,-27,-115,-70,-18,-27,-39,-39,22,-49,-1,-98,80, 
  /* [672][0][][] */ 99,-34,17,-56,-57,97,-5,36,127,-2,33,18,-60,-36,73,36,-50,57,3,98,-27,93,-16,-23,-81,84,-26,0,-36,-17,63,37,-9,-23,-15,-34,78,-13,19,-28,-18,-78,17,-17,-26,-6,-20,-99,35,5,71,-7,-20,32,21,-34,-71,69,-36,-14,56,-111,-25,59,-4,4,-116,57,55,36,-29,9,-24,21,-45,66,-20,62,55,-16,-24,-14,-52,71,-28,10,74,16,-104,-34,-20,-56,94,26,0,41,-46,-15,-59,-31,25,-4,5,6,65,15,-79,45,-55,-8,-25,111, 
  /* [673][0][][] */ 35,32,-5,-82,-62,9,-46,83,-50,15,-24,7,-10,-68,45,35,48,-2,-9,80,-34,-45,7,-56,69,5,-12,20,30,-28,89,17,3,-21,36,-127,-50,49,-58,25,41,-27,39,4,-42,95,-45,38,3,-44,81,-13,-46,4,-10,8,-34,-53,-50,-22,53,49,-6,-16,95,93,55,75,95,58,-40,39,65,-33,73,80,42,-59,44,-42,-44,72,39,18,-11,-112,-72,39,-6,86,-18,-115,72,-98,58,-105,-20,41,42,32,-45,21,80,-13,-37,-85,10,-2,-18,34,-25,24, 
  /* [674][0][][] */ 24,-16,40,53,-29,-62,25,-33,39,4,8,-3,-51,30,127,97,21,25,0,-28,37,-15,9,-52,19,8,47,2,78,-40,-70,-23,84,-83,17,11,-12,24,46,52,-27,-27,9,15,-5,18,-52,25,6,-103,-93,-70,27,14,72,58,-32,-10,-2,-62,9,-35,19,48,-11,-24,0,-5,11,58,-10,10,31,-7,-51,15,30,58,-52,22,47,10,-30,-127,58,24,31,-22,84,-34,33,6,-22,-3,-5,64,-37,-26,-32,63,-20,87,-22,-3,-109,-74,36,-35,87,31,28,-84, 
  /* [675][0][][] */ 27,0,31,-21,-2,-127,-15,24,0,48,116,-22,15,-32,-31,-88,-83,69,75,19,13,-56,-17,57,-12,-43,-50,-46,0,-52,-81,-105,-78,109,-12,-39,15,-24,-30,-30,-9,85,-10,-8,113,17,24,42,-66,45,25,-63,-30,-73,58,-27,-80,-73,27,7,11,-34,-66,-27,-69,13,54,-21,-14,-39,48,-32,23,85,47,-2,-49,22,72,-13,11,-44,19,-104,-26,20,-24,-9,-84,96,13,12,-97,-22,0,17,-78,-21,70,-40,-22,-19,-8,39,98,-7,-48,-59,-55,-39,47,-36, 
  /* [676][0][][] */ -12,19,-43,-46,61,48,7,19,24,6,67,-17,-16,12,9,17,-83,-27,-24,23,-20,10,51,-31,29,-40,17,-82,-2,-36,41,-36,4,-21,39,1,17,-31,-44,-69,-45,87,17,61,-30,38,3,-71,-50,-11,-86,-30,36,-19,50,-43,-14,-3,-13,-4,19,69,25,-28,-47,84,-30,9,120,-7,-10,-42,-69,1,89,58,-30,32,5,12,-68,127,-46,-28,-89,-22,47,-48,-37,85,34,-42,-48,9,-22,26,25,71,34,22,-30,26,-61,35,45,-41,-4,40,-55,-3,21,-58, 
  /* [677][0][][] */ 115,39,-101,-114,-41,-51,59,-9,24,-113,61,-100,-48,-93,66,45,45,106,37,-38,-78,-22,51,4,19,-111,-31,-19,-59,58,-22,73,72,-9,39,-75,56,112,12,41,61,74,31,89,-34,-5,-28,-67,-101,-21,-24,-9,7,8,25,-36,-97,-108,-73,-38,-116,24,25,46,12,50,-48,41,-43,55,43,-39,11,-4,47,127,34,45,84,4,5,26,-7,-108,-10,-44,35,33,-38,34,2,-55,9,-6,-118,-113,-44,-92,17,-37,-76,90,-27,37,-33,20,-3,-64,-44,-47,13,-47, 
  /* [678][0][][] */ -23,-18,3,106,-2,0,51,-7,-70,-8,-105,56,-79,-1,58,75,42,80,19,-95,-22,-22,-1,-30,-104,-20,5,52,-35,104,-8,-46,60,-8,-14,-49,17,57,-26,-127,-42,5,-77,49,0,-42,-5,8,27,-35,32,-11,-39,14,51,-8,-44,-17,-44,1,-13,-25,36,50,27,-52,-87,-81,5,3,10,10,6,28,13,-9,95,18,62,15,79,-66,1,-71,-46,-20,15,34,51,-90,64,-44,49,-54,-75,77,-3,57,53,-48,96,66,34,12,14,9,16,18,45,44,43,26, 
  /* [679][0][][] */ 59,-17,-5,44,-74,-66,38,68,-35,67,-39,22,-118,35,-25,92,27,-25,21,-28,-56,-80,-42,-99,33,-15,-1,66,32,44,51,3,-42,15,36,-33,103,29,-39,-5,46,-37,-29,-64,-85,45,59,16,-21,20,36,70,-45,-26,-10,-11,-1,37,-127,8,106,76,12,-24,-50,43,-7,33,-3,4,62,67,49,-80,62,2,14,-86,43,-10,37,-80,92,-18,-26,44,-6,-32,27,68,0,-2,-35,-30,-8,38,12,-10,9,2,55,-8,14,-11,3,-22,8,-53,-56,-26,34,0, 
  /* [680][0][][] */ 29,51,-12,-37,60,14,14,23,-2,20,56,-29,9,-25,14,-28,-119,51,-15,45,19,34,52,14,30,-67,16,2,-36,70,-52,41,29,31,-105,19,3,-5,-28,-6,-73,-45,-1,67,2,16,20,22,30,5,-39,27,29,30,16,32,-3,25,-20,28,-65,-70,-125,48,-82,-110,70,127,4,-20,81,-70,31,2,-3,39,-64,62,25,65,47,-22,-41,-11,-22,53,56,59,13,29,-53,47,56,-21,110,-23,4,-51,-85,-79,-75,51,43,-67,119,-26,-11,94,-29,-91,21,-57, 
  /* [681][0][][] */ -5,-47,29,4,-7,26,-53,-9,17,37,5,-14,4,41,48,23,-28,24,18,-21,-20,6,12,-1,42,-20,-56,-4,-66,-12,40,-2,12,-16,56,65,-3,-19,-19,-32,-94,17,34,-13,-42,-33,67,-36,29,26,33,64,73,48,-39,5,-40,23,-23,-48,37,-2,34,-39,-20,48,-40,-30,21,-44,27,-51,35,24,-71,53,5,-91,15,-5,-36,-23,45,39,18,11,4,-21,7,23,-17,37,50,-9,-63,82,4,-38,40,37,19,-11,13,-8,76,-127,-4,59,-51,98,6,-58, 
  /* [682][0][][] */ 1,-83,40,-74,-40,35,-48,7,-45,9,64,-90,-18,-73,8,80,-43,-26,27,-68,102,-45,-40,78,-5,52,37,21,-98,7,-65,-49,-33,-41,-6,23,30,-3,60,-21,-28,13,37,47,2,67,-70,21,27,-73,25,-8,-109,-31,60,-20,-82,57,38,37,-64,-88,45,11,38,113,93,-24,63,62,21,-34,22,-83,32,-22,-6,-5,-18,-13,30,48,16,-2,-25,1,-121,36,-127,57,43,-75,23,-41,-89,-30,-81,7,-76,-25,-59,-2,-10,63,-59,-27,67,-92,-73,-22,37,45, 
  /* [683][0][][] */ -77,11,84,-59,97,-17,-75,92,93,90,-25,-8,61,13,65,-7,80,-96,123,-18,24,9,9,-31,-45,-46,-15,103,-30,74,-83,-12,-127,37,24,-46,45,-7,-69,0,10,90,66,8,13,-37,-21,-77,72,1,-39,55,-21,41,-44,-45,-64,27,19,54,-44,-5,20,-16,15,-37,-9,-32,-22,46,37,46,73,-41,-11,-25,-10,-35,-59,1,-40,51,-76,42,-61,-80,10,-63,63,8,-66,77,-29,58,-40,51,24,94,-75,-10,25,-34,24,-89,-60,29,89,35,16,-60,3,46, 
  /* [684][0][][] */ -60,40,-39,-65,-28,30,-13,48,-28,-20,-47,60,15,-55,44,-26,8,-16,127,-48,47,-52,-58,-73,51,-30,-28,-21,17,-22,-62,1,31,-88,5,11,-59,84,-57,48,-2,35,24,-35,82,0,56,8,22,-17,16,-21,70,59,56,-33,61,-10,-60,-11,7,-100,37,-68,32,-16,-92,-56,-5,26,89,2,-83,-74,38,64,-54,-58,-55,43,2,53,-42,-68,84,11,58,15,-23,-33,84,-31,8,-42,-3,-47,-109,-9,42,24,-23,-46,-4,38,12,28,-10,-76,-40,-23,-45,-44, 
  /* [685][0][][] */ -57,10,-7,99,20,12,-55,51,-65,90,-32,109,69,-60,-69,-24,-33,-43,-51,-5,-84,-66,-98,67,-50,-68,-13,-22,-48,4,-75,-34,12,-103,-68,-121,16,57,46,35,17,-78,15,-1,92,50,6,73,-54,17,-30,0,90,-85,45,-90,12,-32,63,-15,-57,49,10,-16,-89,40,-10,-80,14,-20,-44,39,-69,77,31,-44,-55,17,-22,-125,46,47,42,-120,30,17,-14,19,-55,-1,46,9,-66,3,103,-73,3,43,-45,-65,-4,-29,-11,-63,17,82,37,55,-59,-127,-20,-3, 
  /* [686][0][][] */ 47,-33,42,1,-20,1,-40,12,-36,21,-27,3,-30,41,46,43,38,-89,62,74,-57,56,-18,27,37,1,-7,-6,-35,-81,-6,-28,74,-27,37,-26,-12,-3,-20,99,-21,24,-3,-15,7,-46,-64,-3,1,-5,25,-24,-52,-76,-1,38,-17,37,-53,40,23,-22,-56,3,-20,-34,-110,6,10,34,49,-8,76,47,22,-6,-6,4,-4,20,127,32,11,23,14,-61,-58,-48,-44,63,17,-54,-1,-69,33,33,35,74,-34,42,-42,56,85,-89,-33,84,19,22,9,-4,43,27, 
  /* [687][0][][] */ -17,19,41,2,36,-19,68,7,50,28,-84,-25,6,28,-12,3,47,31,44,-74,-11,-32,-27,10,16,-26,-17,-18,-22,-2,-51,29,13,4,-37,-39,43,67,-22,24,-17,-47,-3,-79,9,-44,59,-16,-53,45,39,11,75,17,86,-47,-17,127,31,38,-51,45,3,-40,-52,74,-38,0,-2,59,-41,-53,15,10,51,45,-51,-35,71,-9,24,-9,-36,0,-15,12,-63,-57,26,13,-20,-38,32,41,83,10,42,-41,-8,-36,-98,19,-20,-27,14,20,11,14,17,-19,27,14, 
  /* [688][0][][] */ -80,-15,-2,32,-78,32,-96,102,36,-43,-45,40,12,24,29,30,-3,-58,20,112,73,112,4,48,-31,-31,-52,-17,41,102,-15,-38,-43,41,38,-65,-96,44,-105,48,-7,-41,-111,-22,-55,-64,20,-6,60,14,19,90,39,65,-26,5,-34,25,26,81,-2,-127,6,67,16,-36,6,-5,46,-109,58,-11,4,-57,86,40,-6,74,-21,60,-95,7,27,-21,0,53,65,29,51,0,-70,37,-52,-17,-13,61,-15,8,-42,-27,59,52,11,-88,-65,27,-32,14,-35,43,-108,17, 
  /* [689][0][][] */ -31,-115,7,14,-63,3,-20,-105,49,-55,45,-13,-23,85,-29,3,44,0,62,53,-56,-18,5,114,-22,-127,-26,18,-85,70,9,75,-26,35,-27,1,-22,-113,42,43,22,56,56,-89,-40,-71,100,18,-103,11,-21,-19,65,-14,-11,-39,-10,-78,12,-41,53,-61,36,-60,47,-101,-6,59,91,-76,95,37,-34,-28,-61,17,2,53,-16,64,17,-13,13,-20,-9,-45,9,-33,-16,122,14,-111,-28,-29,18,51,-74,-51,-21,16,-31,-82,7,37,-35,52,-24,-43,-7,-56,-120,-98, 
  /* [690][0][][] */ -26,-127,55,48,-38,14,26,7,0,-33,-70,36,24,32,20,-17,7,-60,27,-24,38,4,-8,-5,12,-48,-45,-12,2,52,-26,-45,-4,-36,6,-22,-1,-15,12,68,-35,-38,-5,4,-8,-11,61,50,31,-18,-73,-18,-16,10,-5,-11,20,8,1,45,-42,-33,26,65,-46,59,52,28,-13,-25,18,12,5,-21,-41,-30,40,-48,-9,15,-45,19,13,63,-20,55,-3,19,-49,-46,-70,7,-9,15,-65,6,-38,24,-9,-9,66,-62,-43,-18,-18,-5,11,10,-19,27,50,9, 
  /* [691][0][][] */ 28,-95,2,-29,17,-19,-23,-24,-46,3,33,-38,0,17,-73,-40,-69,-42,39,3,0,15,-8,16,46,-35,25,-66,77,13,-31,-15,60,45,9,-16,34,5,-36,59,-13,-53,-23,40,35,21,-27,-57,1,-29,14,-64,45,48,3,57,3,72,92,-24,32,77,58,22,12,48,32,-74,-22,-37,-60,-4,-8,18,-60,-52,-51,-4,-33,54,33,-41,-58,81,-127,66,-35,52,-56,-12,24,-15,74,55,-25,32,23,-6,48,-66,13,0,-43,6,-61,49,-8,98,2,0,22,-45, 
  /* [692][0][][] */ 49,21,1,-12,49,-67,-1,-63,-26,48,34,83,3,-21,-83,26,68,-36,2,-6,66,3,127,-45,-50,-12,10,-50,9,9,-53,-32,-59,-82,81,6,3,100,-46,26,-22,108,24,15,25,71,64,-34,-87,-14,56,-40,40,-37,-6,35,42,-3,30,-32,-43,29,-44,58,-51,-25,-10,-40,-20,74,-44,-46,-70,-39,-54,-42,55,57,41,31,-64,59,14,-38,2,28,20,-111,-21,-42,-101,81,-6,-29,5,-31,29,-8,-32,43,-7,-7,46,-44,12,23,57,60,30,-65,-18,-18, 
  /* [693][0][][] */ -19,-4,21,67,-40,10,57,94,1,27,64,115,-31,-62,37,-93,80,-4,-10,-8,78,1,-5,-50,-45,-55,21,6,-22,31,53,38,-23,92,32,2,30,6,-4,-75,-12,-31,-42,-14,23,87,-20,7,-110,-89,51,-31,-9,49,127,10,11,-14,7,65,-14,65,-98,-36,-50,-55,-56,-17,-31,74,37,-57,-13,85,14,56,22,65,90,1,-55,-73,40,-60,67,-4,23,-63,-61,61,48,27,-39,-34,-6,-58,106,15,39,-29,-31,-102,-2,-65,-19,-38,34,-52,-88,-85,-1,48, 
  /* [694][0][][] */ 22,-47,-28,17,18,2,72,-14,79,-65,-49,-18,48,1,-25,-12,-60,-33,-63,97,-33,0,-36,-9,-44,-70,17,13,100,39,-62,-48,33,-59,33,-74,50,-26,-56,101,-53,90,-9,-13,5,8,48,-14,27,46,-68,22,63,88,-118,68,-20,53,-4,-10,80,4,59,-24,-3,-31,-13,8,-88,3,-51,-31,-21,-57,-123,58,-38,-102,21,7,-16,21,1,36,-109,0,94,31,-23,-21,-8,47,57,-81,-127,-110,-31,28,55,18,-75,117,74,-105,-63,-2,-3,-3,-29,-57,-33,-57, 
  /* [695][0][][] */ -41,-3,11,29,-45,32,39,-26,-79,16,65,60,-82,-62,38,-14,-55,-38,-64,-37,12,99,-70,-75,-2,-10,56,29,-79,36,-33,14,61,-11,5,29,35,-32,-38,99,52,6,-56,3,36,-10,26,9,-1,15,-11,43,-37,-65,20,36,16,14,-1,21,-51,9,6,12,43,-54,46,-54,-37,16,34,45,-29,44,44,21,-15,4,109,16,-127,33,38,-8,38,51,-62,-18,-27,-39,-37,20,-54,-32,69,40,-52,51,55,-93,25,57,16,13,30,-27,-8,68,-42,0,-46,-1, 
  /* [696][0][][] */ -40,60,-14,90,44,31,-23,33,-41,72,-12,-28,-10,-66,30,7,73,-1,55,-49,-1,-30,33,11,-27,75,-76,-67,-53,0,92,-57,-6,60,16,4,-13,35,-1,21,127,2,-22,33,46,-43,17,34,-3,-72,24,-1,-51,-15,58,-5,-48,38,-79,-14,90,64,26,-31,-30,5,-8,-90,-30,-6,8,-31,-8,-30,46,-48,-49,46,-1,31,-43,37,-57,-48,80,-18,-33,-7,60,-46,17,38,-31,-56,-62,70,-26,-46,-58,-101,-31,-31,-96,-27,-30,13,-49,37,63,-46,8,-72, 
  /* [697][0][][] */ -30,32,-40,13,-47,-11,28,50,28,16,-34,28,26,-59,32,48,-45,-35,14,19,0,-49,8,-39,-15,10,56,24,17,-48,-21,-40,39,60,8,38,72,27,25,14,45,-31,56,-57,50,-3,-65,-3,17,0,-18,-18,-12,-15,-40,-80,15,-17,-18,73,-37,-7,-7,-50,15,-18,13,9,6,-39,-63,-9,26,71,81,-32,-23,39,32,-57,40,-25,30,36,-29,27,-2,-10,-15,-78,67,-5,48,109,1,26,23,-16,-59,-50,49,-10,-127,13,-45,-65,-56,16,16,45,6,17, 
  /* [698][0][][] */ -18,63,38,-51,-53,4,44,101,26,-47,21,41,-34,1,48,-35,58,25,-12,12,23,123,127,1,42,7,-60,97,-107,-38,105,-19,-95,-53,43,-14,71,25,-10,-41,-64,26,2,65,-12,92,-73,-58,-1,-45,-67,32,93,-21,35,-15,41,2,56,-70,41,26,-62,-33,-4,-36,51,-51,29,22,-25,24,-49,-48,-3,-25,17,4,15,24,-27,57,-46,-11,1,47,-37,20,-13,-17,-11,-8,8,-16,-6,-3,88,0,-4,-26,28,18,-42,-15,-28,-87,43,7,4,-16,-45,-12, 
  /* [699][0][][] */ 46,126,-9,51,-31,-51,28,-7,-23,31,-80,44,2,21,89,-110,2,62,59,-47,-22,-44,79,-78,2,21,-3,-64,-4,36,-68,90,-67,-1,11,-46,-40,61,92,-5,42,-29,-1,-34,2,23,20,1,-73,-27,58,7,11,-35,3,-46,0,2,-13,-7,-17,-30,-81,22,44,40,3,-1,-3,-31,54,74,-58,-59,-87,-25,48,-67,121,15,-86,116,92,-20,29,-105,5,-8,-8,37,-127,67,-4,-14,-34,14,45,34,-58,19,-12,-75,56,44,-39,42,55,77,26,-14,-6,55, 
  /* [700][0][][] */ 6,-15,41,38,-72,-6,16,61,-71,-10,-109,-29,67,22,81,80,12,18,-33,-96,87,-53,18,66,60,-38,-46,-58,-58,-8,-28,44,-46,19,16,-24,-24,-108,-75,58,-57,70,5,11,127,-18,29,46,-53,32,60,-6,39,-5,-88,78,-75,-29,60,-28,-6,78,-32,-6,-39,13,-52,32,-5,-26,72,19,21,-80,-2,44,22,-49,-58,-56,41,-38,-59,-75,37,-36,-22,-44,2,86,45,72,-19,-93,-21,70,6,18,78,-47,4,-84,87,17,-59,13,-5,-53,-58,-62,-11,16, 
  /* [701][0][][] */ 22,-8,22,81,-105,-18,30,56,-53,-1,9,-20,-58,38,14,-30,-16,-26,0,-34,28,-27,18,0,31,-23,-12,-45,45,6,-30,78,45,-35,85,-17,53,7,14,71,36,41,-52,60,26,27,64,76,10,-4,-38,-57,-16,-25,14,50,5,22,-80,-33,22,16,-65,12,67,-80,-11,0,-67,19,11,42,127,23,-15,-54,-9,1,-11,59,45,-73,-61,-57,-10,-5,20,109,26,22,-51,19,45,-56,-9,-61,46,-9,69,72,21,18,29,-8,-65,-87,24,-5,-41,-25,42,83, 
  /* [702][0][][] */ -91,31,2,25,39,-16,23,60,-32,10,80,16,43,-51,-31,1,-1,-3,-51,14,19,-31,-15,-14,-75,5,-11,-70,16,51,23,-37,-79,0,-43,-35,49,-30,43,24,58,-65,-97,-36,20,-2,11,22,-31,-45,-68,65,-82,-90,-8,83,90,-16,46,23,-31,-6,3,-20,40,47,-42,-38,-8,0,28,35,62,127,7,-82,28,55,16,-42,-8,-68,48,-21,34,-15,42,28,-38,24,34,15,-2,82,-16,77,9,25,-52,1,2,35,-70,53,14,64,-16,-44,35,33,-11,2, 
  /* [703][0][][] */ -127,-29,-28,29,12,57,4,-56,68,-17,-61,1,34,-56,2,-103,45,12,-78,22,-44,-68,-25,-28,-48,20,-62,-9,63,35,80,-14,-16,-8,23,-17,-5,-62,52,-67,-111,-36,28,80,5,-55,112,-8,-35,23,33,54,32,-6,10,-34,14,18,22,-54,-32,12,81,-53,-31,57,91,65,70,-49,28,-20,38,-73,-14,-19,-12,-111,51,-14,-55,21,-1,-31,35,7,-85,8,-15,-73,16,92,30,21,-91,-26,40,2,-22,-51,-4,32,-39,79,57,-58,-37,-53,-92,81,-19,-26, 
  /* [704][0][][] */ 7,-13,-36,24,49,28,-18,-22,36,-12,-13,-21,-8,46,40,56,-2,-6,-68,-2,20,-9,64,11,27,70,-58,31,-37,45,-8,-21,-5,-14,25,-26,-5,1,-9,-15,2,-3,39,-19,-81,-15,-127,7,-13,-17,-13,-17,-38,24,-28,-2,38,83,5,-13,-64,26,-44,28,36,52,22,10,-7,-43,42,16,29,24,-21,51,53,53,-3,1,21,27,-31,-30,-4,56,-11,50,-18,-45,-52,13,-23,18,-38,47,-44,-42,-6,-16,-1,6,-24,-25,35,23,-60,-2,-30,2,50,-14, 
  /* [705][0][][] */ -31,76,81,43,12,66,-11,25,-70,13,64,98,-7,37,33,-30,0,-22,-11,75,76,-13,-13,2,36,-39,-26,20,36,-84,30,62,-1,33,-89,15,-47,39,-18,4,6,-7,-102,79,-28,-89,6,28,38,44,36,-103,59,15,27,-50,43,20,27,-66,34,99,48,-95,-85,-9,-12,20,-24,23,5,45,-46,-45,-127,15,-35,49,16,-41,95,-26,13,33,-62,48,-43,-58,9,3,-126,-30,-11,8,112,71,48,-83,4,20,88,-72,-3,24,-19,-39,-52,-54,66,11,4,46, 
  /* [706][0][][] */ 45,-13,-40,48,48,39,-26,-101,-47,75,-32,-23,41,-27,41,-35,11,87,10,-1,51,-38,-22,0,-57,39,45,-23,-78,-43,-37,43,-33,43,-43,-38,-75,24,17,-23,-32,-50,13,55,-51,27,8,6,73,-27,68,25,80,69,-83,-43,20,11,-5,-38,17,-5,42,-44,24,-48,58,-3,49,45,-5,-21,2,-75,28,-8,-64,-4,-127,64,109,53,65,10,-51,-49,16,51,33,-74,-44,70,124,-50,4,-25,-21,-2,-14,-79,-25,50,27,-17,45,17,74,53,24,19,47,-25, 
  /* [707][0][][] */ 75,-110,113,39,57,-86,15,-17,-17,-54,19,-72,-38,-21,-27,-118,11,59,-119,-26,-64,-31,-42,52,63,1,120,34,-116,-34,-76,3,54,33,35,-20,-72,-62,80,5,-5,-14,-24,52,21,12,-101,65,9,7,4,42,24,29,-16,56,-36,84,127,-8,38,-125,-82,0,-79,-84,29,-75,-25,-1,33,-15,-118,12,6,-9,-70,-22,2,-90,32,-11,35,10,-19,28,-31,-6,17,30,-35,-33,-64,-43,19,66,-49,46,52,-1,-72,81,22,65,-26,-60,-37,-25,-74,31,49,11, 
  /* [708][0][][] */ 51,37,66,67,-42,42,-108,-10,50,-17,-66,-43,0,-26,-80,77,-63,1,1,-2,-32,-8,-15,16,49,26,-52,-50,55,-17,-85,-12,28,25,23,-54,37,-67,-59,3,-95,-8,-55,-50,10,-7,30,45,119,13,46,17,-47,-17,17,-59,61,34,31,-13,-69,58,-36,14,2,-84,-64,30,49,-20,53,33,12,16,-44,52,-92,-15,-43,45,-127,18,-74,21,-2,-35,22,-54,20,-5,-56,76,-40,-57,66,44,15,-49,50,-75,12,6,9,6,-24,81,1,-14,40,18,-63,-56, 
  /* [709][0][][] */ 14,-127,27,33,-26,-42,94,-37,0,-4,-26,3,-57,3,-37,-12,-4,25,13,26,-77,-11,3,11,-3,-71,46,-13,-19,-1,44,24,8,0,21,-44,-38,25,-7,-19,-10,27,-29,-20,0,14,67,16,-42,-16,19,22,-39,88,33,40,16,-53,34,-3,20,-20,2,6,-18,7,18,-21,-78,-14,-21,24,21,-38,39,-42,-46,-26,-14,30,14,-23,63,-25,52,-88,-28,-8,-18,-16,57,-24,-23,-44,0,9,12,29,81,21,-38,-57,4,24,-17,18,28,-9,-35,-34,14,-58, 
  /* [710][0][][] */ 30,0,-38,40,17,31,6,15,-9,10,-5,-21,-47,20,27,10,79,-48,-11,57,37,-3,36,10,23,24,-97,-53,-37,-54,-22,-28,-12,38,102,106,9,-73,4,39,58,28,-8,-9,-20,11,77,-46,82,47,46,-46,21,-20,41,13,-26,-18,-5,4,-4,-29,-6,-15,8,-66,42,11,18,17,-27,-3,-24,-17,0,-48,3,-35,-48,41,5,-19,5,-46,-19,-39,10,10,56,33,2,-76,17,-28,-55,-60,34,1,13,-127,-51,63,18,-25,16,-38,16,-44,15,5,-73,-85, 
  /* [711][0][][] */ 15,-28,-35,-59,80,48,-48,-15,37,6,36,-3,-53,9,20,12,-33,-17,5,6,23,-28,-57,47,40,40,7,-2,-78,-5,28,-17,67,-26,-8,17,5,44,-26,-18,31,-52,-3,2,68,53,10,2,-12,-13,-14,45,43,-14,-5,1,15,69,4,-38,28,-52,7,-63,9,49,127,59,0,-25,12,31,-22,-29,14,52,27,11,-3,-5,-37,10,13,-24,-20,-2,-2,33,58,15,-17,28,33,-34,-32,32,42,48,25,0,2,-8,-20,-16,50,-30,-30,34,-30,-1,4,-21, 
  /* [712][0][][] */ -26,-5,-82,79,-62,49,-13,83,-21,-87,46,0,-36,67,43,-76,-32,-24,-32,-69,33,-58,4,-3,-52,-37,2,-27,-4,-3,-12,6,-33,-42,77,13,127,72,7,6,-50,-99,101,108,6,-53,-39,77,-3,37,60,37,-60,-30,22,3,-67,-68,87,29,-103,-15,46,36,62,-53,-48,-3,-6,12,92,-102,7,-5,-33,-72,27,58,-10,-2,-27,-16,-3,-10,-43,57,7,43,-84,0,67,27,105,48,33,-10,71,1,38,3,-105,71,62,4,23,59,10,-17,21,-33,19,58, 
  /* [713][0][][] */ -66,-29,33,-22,-54,44,-62,-53,13,112,-74,4,-12,-9,-57,-35,-13,10,33,-62,-33,57,55,7,19,-15,2,5,-45,-6,-44,57,-115,-32,-26,45,48,16,-2,97,27,2,-13,-35,46,-64,13,40,79,-19,-35,-56,32,-3,-1,101,-72,-87,7,41,-11,26,89,-35,37,71,-56,13,-39,-28,42,-22,-6,73,20,-89,48,-46,8,-34,-6,46,-15,4,11,21,-91,-7,16,45,29,13,-42,54,37,127,-33,-50,-82,-74,-26,-8,-4,-44,40,8,-91,33,76,-21,-14,-65, 
  /* [714][0][][] */ 76,21,-83,46,11,-18,34,-127,-14,-14,40,18,44,9,-27,64,30,106,22,-6,107,49,-4,29,-71,-22,86,-57,11,-28,15,55,-66,32,20,11,-57,-14,36,7,56,-21,-61,-71,-99,-57,25,36,-81,4,67,-62,20,44,-26,-8,66,-41,-10,-13,35,19,-38,-85,40,88,44,45,-40,13,-2,29,-8,-72,5,-88,19,51,-82,-108,11,8,4,10,33,44,43,8,43,-13,8,-35,-33,1,4,-57,-46,2,-7,17,-68,-28,95,-7,10,-14,-15,-110,11,-68,11,15, 
  /* [715][0][][] */ -78,-38,-21,-11,1,0,-36,23,35,-13,3,-8,54,29,-11,4,18,24,42,-17,-42,-28,-59,84,-14,-30,-36,10,17,0,12,70,-2,33,45,18,-13,-3,-83,22,71,16,36,-17,-48,-4,57,4,64,11,18,50,36,26,-44,-10,-19,-74,71,-4,-9,-79,51,-3,-14,104,12,11,-37,-53,-39,52,-26,-11,110,-20,-30,-1,-50,36,82,-23,9,12,-51,41,-16,-42,92,2,-15,-9,-10,28,-12,7,19,127,25,60,-34,21,-8,-14,-62,6,31,-5,-67,-9,-21,-8, 
  /* [716][0][][] */ 29,-23,-60,37,9,64,23,27,-50,-13,12,3,-68,-29,20,-13,-15,-5,117,-95,55,24,-15,15,0,70,37,13,32,-59,10,-81,59,-36,-41,-2,-28,46,53,-13,57,55,106,35,20,-18,127,-36,30,-66,-55,-26,-81,25,-18,-63,-59,-1,-10,-52,-75,56,61,43,-18,0,-31,-33,51,50,78,22,-10,110,-113,21,-74,-70,-38,23,-10,-56,9,-69,-87,-19,-19,-29,45,37,8,33,-48,-83,2,37,-49,-82,38,-79,-29,-42,46,-24,99,16,62,15,-43,-75,4,-46, 
  /* [717][0][][] */ 5,-9,-3,34,20,16,-34,-10,-40,25,70,28,107,-8,-7,-35,23,42,23,-55,13,66,-23,34,10,50,-19,0,-25,-3,12,-13,43,-18,-9,-76,-8,-8,27,-50,-27,-95,21,34,34,-12,-6,-63,41,-5,51,-45,46,45,-28,-4,33,-35,77,27,-13,18,-19,-83,28,72,-35,-25,-35,-50,0,-41,8,52,12,17,3,-31,-74,72,95,40,20,53,-21,-8,-66,-35,-26,-17,-16,32,23,-127,-19,-6,115,-14,-3,2,9,-82,76,24,-13,6,30,28,-36,7,-90,-46, 
  /* [718][0][][] */ 30,38,34,-4,-42,-17,19,-2,-15,42,-52,29,-8,33,20,-28,48,-1,25,19,-16,-23,-7,-15,19,29,0,-18,-57,35,-38,-18,-11,21,54,-31,68,-20,42,57,8,-38,-49,79,127,9,4,-33,8,6,39,-18,24,61,16,-13,58,28,53,29,50,50,-47,-81,18,-11,63,55,23,-17,-35,84,25,-62,44,-17,5,21,-23,15,22,16,-76,46,50,-75,45,-1,-34,-51,-25,12,25,54,62,-10,-28,-41,-32,4,4,-32,64,43,7,18,-36,7,19,-42,88,33, 
  /* [719][0][][] */ 24,-9,-37,-27,50,-67,-96,68,-88,106,30,23,31,38,-27,71,8,52,38,-1,-24,-49,65,-7,-27,-81,57,28,41,-25,43,29,-50,71,35,-34,63,27,8,-54,59,26,-101,25,20,108,81,71,-28,-52,54,81,-102,-55,6,-86,25,6,62,19,27,27,-92,-11,40,17,25,38,-60,105,119,126,-4,56,17,54,-19,-14,-127,-55,-34,17,36,-71,-22,-22,62,13,11,-22,-1,-59,0,-30,15,61,114,1,53,-63,3,-42,-77,36,-18,-30,12,-14,-95,-28,-92,38, 
  /* [720][0][][] */ 3,12,18,0,54,7,-38,-13,-3,-1,74,-5,38,-17,57,5,-10,13,-32,33,4,-23,52,2,19,11,19,-8,-13,-57,-41,10,-74,-1,-1,24,-23,-18,3,-11,31,7,13,-38,19,-7,-52,-3,5,-33,24,-28,19,-39,-42,4,-26,-38,127,51,-7,-17,-12,-58,6,-33,16,31,23,0,-12,50,14,51,-20,33,11,-33,33,61,-19,32,-13,-22,-19,-62,-16,-19,-61,-26,11,33,-1,15,-2,28,-6,-9,-52,-3,-41,-25,-57,23,-3,64,15,40,-29,-3,-83,-15, 
  /* [721][0][][] */ 30,-33,-20,-11,18,24,4,0,127,-16,-22,-6,20,24,-21,-25,-15,-14,-83,8,-88,-33,-70,8,66,6,86,23,-30,-14,-53,14,-36,-45,-39,19,30,39,25,-21,-75,11,-56,25,-31,24,-80,-111,-117,60,-33,57,0,25,-74,-42,65,85,-23,1,35,81,-44,-9,-35,80,36,-28,-16,-74,41,29,29,7,18,-8,-32,31,98,82,-57,66,95,-34,-43,21,-65,63,75,-75,-81,-27,-24,-46,-31,38,0,27,49,46,86,-110,-74,-83,-43,66,96,-11,-55,-36,-74,-59, 
  /* [722][0][][] */ 10,-36,16,-63,45,2,-63,120,8,-8,-90,-26,-72,42,-44,-76,78,-49,-47,30,53,-55,-1,75,63,-22,-27,-55,57,12,6,4,-7,-21,-9,47,-12,5,0,-68,-17,-38,2,-95,55,-48,55,12,15,45,76,-9,-15,-25,2,-79,-38,29,15,40,45,8,-43,13,29,-44,-5,-71,25,53,21,33,77,-28,-8,66,-6,-20,-4,11,106,-96,7,-63,-3,71,11,-27,42,14,-101,-108,102,-54,-80,54,31,62,-26,-16,-77,15,18,-35,-127,7,49,-49,59,75,21,-20, 
  /* [723][0][][] */ 37,33,38,48,-28,28,43,-45,-11,-32,16,-1,2,-21,-10,-29,-32,-38,14,-53,7,83,-69,-66,-51,49,6,-1,0,-18,13,-27,60,27,-23,15,-11,-28,-50,11,70,22,-53,1,-23,26,44,24,19,20,16,50,109,89,84,-41,-97,38,-114,4,51,-5,47,-6,27,7,-45,-2,-28,21,-48,-3,47,101,69,26,13,65,-1,23,55,-5,69,87,13,59,0,-9,53,-20,-90,55,88,-20,-61,-29,-68,25,1,-33,12,9,70,48,-57,-44,-53,119,36,-96,127,-55, 
  /* [724][0][][] */ -84,41,14,-25,-39,-2,7,39,-23,24,-81,-46,-21,6,30,16,-33,-23,70,-18,24,23,22,2,35,51,-17,-17,4,-20,-27,43,6,-50,-54,18,1,70,50,-31,19,1,-46,47,-13,29,-15,23,8,-28,-11,-31,15,19,-11,7,33,-51,-31,-64,27,53,7,-58,77,21,40,-47,10,9,23,-24,-86,-16,18,-43,-35,87,-10,4,56,3,-23,-34,-44,8,-23,10,63,-67,-29,38,5,-27,-47,-6,43,10,45,9,-64,-21,-6,-127,51,-50,-26,27,-6,25,44,-14, 
  /* [725][0][][] */ -13,-27,-56,34,-53,-75,26,-35,-44,-43,-39,-14,-23,-26,42,88,23,73,62,31,71,-46,98,-9,-2,-16,-15,-41,14,126,-10,-103,-74,-1,-89,-23,73,62,-7,5,20,38,31,127,-62,-51,-31,-27,10,-56,-24,-26,39,111,56,-30,46,-19,-94,-45,6,32,-24,-2,-29,-33,8,-33,60,-43,-81,-101,43,14,66,-7,-59,34,-34,8,24,-3,-20,24,-77,5,-17,59,-12,-43,36,42,67,-13,-45,68,8,7,-54,-28,-78,21,-51,48,39,20,4,78,-29,14,-58,20, 
  /* [726][0][][] */ 46,4,60,-89,-23,-8,-67,-26,-45,86,14,14,29,55,55,67,-59,4,2,-40,-16,-40,-66,62,46,55,113,-50,-27,9,71,21,34,67,-37,-61,-8,82,-5,10,86,56,64,92,29,55,-46,31,124,44,-45,-31,2,-42,34,-6,18,-52,18,-19,30,-73,-67,-127,43,59,33,-71,-89,-45,30,-30,-46,-66,99,-47,-53,-27,-79,-55,12,-51,-24,-1,-18,-82,-60,-49,89,26,15,-100,6,-48,-32,-76,-84,-32,-66,16,-110,98,-46,51,28,15,63,-27,65,40,-124,-7, 
  /* [727][0][][] */ 14,-56,-16,-41,-51,53,105,-27,-1,37,17,38,-16,49,78,25,-13,4,8,37,31,-53,-13,15,2,-29,-44,-8,-34,-16,-31,29,-18,-44,33,6,-7,7,-66,-23,-5,-71,-41,-38,-6,66,9,-25,41,-23,-23,-15,38,58,10,-16,85,1,-9,24,84,-42,-19,7,-58,11,-82,-28,39,-76,6,-56,2,-64,14,-53,38,-43,127,-57,-5,-27,41,41,-13,34,-38,42,-4,-71,-32,41,-108,-74,29,8,-37,-16,32,-61,-53,-7,-12,-81,-54,2,-20,55,-45,-72,-61,88, 
  /* [728][0][][] */ 9,-19,-35,-13,-47,63,-80,-9,-75,-59,21,7,22,-74,86,34,-10,-36,42,-89,19,-12,15,-35,33,-85,25,39,-127,-81,-6,-21,-53,39,-101,21,-67,59,45,16,106,-14,-12,8,-28,-6,-45,38,48,-16,-29,-38,23,-77,11,-27,27,-31,-12,22,99,-74,74,22,24,14,-33,7,18,-32,15,-16,-54,-15,-15,-30,28,16,21,1,-25,26,-49,79,-39,45,18,-39,-85,107,-82,-55,15,58,-24,-33,6,8,50,-46,27,-7,-17,79,36,1,-18,-57,-81,-2,23,-80, 
  /* [729][0][][] */ 27,-116,-48,-19,43,-24,1,1,4,-35,-6,-15,-1,-64,-52,-26,67,-12,8,-5,1,29,3,-41,-13,-107,47,-28,15,-36,-53,44,-89,-13,29,-32,23,45,94,-29,-19,1,-1,66,18,73,61,52,1,25,0,-24,75,-41,-18,-24,46,62,9,-49,-12,80,30,94,10,-61,-42,93,-58,0,-48,60,35,-10,-2,-61,12,-52,-17,56,-39,127,16,-16,-31,88,-37,67,33,44,-60,74,-105,-11,-14,-90,16,-77,-38,-9,-6,92,-58,17,11,-78,-64,52,2,28,-24,49, 
  /* [730][0][][] */ -50,-41,1,68,7,-16,-25,20,-83,42,8,-28,13,-18,27,-16,89,-20,5,-16,51,35,44,61,-104,-73,38,26,-28,-54,-39,-13,-25,-25,-15,60,78,6,-12,9,-40,32,3,39,-89,-18,-27,42,-43,5,37,-86,46,2,25,50,-40,-67,-86,123,27,50,26,-16,-127,50,-23,38,-1,43,34,-41,-5,-54,-59,32,36,-4,41,-43,30,-23,53,-33,-29,32,-21,-12,11,-2,-33,11,-30,18,-19,-39,-7,-62,-34,-82,28,-40,56,-53,2,56,-25,-22,-22,-41,-27,-74, 
  /* [731][0][][] */ -53,-10,23,-21,16,61,-15,32,32,85,0,-55,-26,-42,30,51,18,9,-21,-64,13,58,-10,26,-96,32,37,76,-41,63,54,47,-38,17,-93,-43,-30,119,41,-82,-41,-34,39,-2,-68,-108,1,-88,33,15,-9,8,-21,-21,39,-49,-40,12,5,-83,-5,-53,48,48,-57,-29,69,55,-34,-58,21,-2,-18,20,-84,7,-101,-6,20,-110,7,-33,45,-1,71,2,-97,-66,-50,8,-71,68,27,75,48,70,-16,90,31,3,-65,-64,-15,29,-14,-6,4,112,-44,11,-127,3, 
  /* [732][0][][] */ 38,2,18,13,33,43,92,32,36,-36,-3,-54,-4,3,16,-57,-27,-35,14,-5,52,-2,38,-85,-40,-23,38,1,12,-26,24,13,-70,29,-20,50,42,46,21,3,3,-1,2,-39,-24,51,21,16,-33,-9,-15,41,-7,1,60,-26,-8,10,-7,29,-6,45,2,72,4,1,-6,-127,12,46,-19,-35,-18,49,14,-65,-22,37,29,-44,22,50,17,10,18,-27,-25,19,10,20,-47,-19,-63,37,2,8,-28,12,-31,-65,-2,40,7,-63,-52,36,54,-44,18,42,77,3, 
  /* [733][0][][] */ -27,-31,-15,2,-31,-3,88,26,-26,47,20,-14,-94,-33,3,-44,76,60,73,41,-28,-88,-3,43,-5,26,-16,14,80,2,64,-16,6,26,64,-12,-6,1,14,-53,5,42,27,26,113,-8,-35,-30,-2,-35,56,-9,-37,8,26,36,61,72,15,49,11,-30,-33,-114,36,18,-28,-8,50,-44,26,2,-68,26,-40,50,-41,-24,-64,-7,52,10,0,-6,-113,-127,33,-47,-37,-35,68,-31,-33,-16,9,100,-27,28,55,-58,-52,-4,-26,51,-2,25,23,1,-54,18,16,56, 
  /* [734][0][][] */ 12,25,-97,-91,61,31,43,54,-8,26,36,0,55,55,54,68,62,-27,-29,3,69,-42,5,-4,-8,17,66,6,8,-37,55,-63,30,36,88,41,19,4,54,-3,-8,95,28,14,1,-48,15,-27,-20,35,5,-3,5,67,36,-85,-41,52,-27,36,37,38,9,17,29,53,-18,23,60,52,-62,30,-20,30,-25,16,45,-50,40,15,-54,6,2,38,-58,12,55,-82,29,4,42,93,98,-127,-45,-26,-6,17,-12,30,-27,-27,-6,-9,-52,-5,-51,-61,-35,-16,29,26, 
  /* [735][0][][] */ -3,22,7,-9,3,12,51,-22,40,-51,-6,25,-3,-50,-32,0,-118,9,-13,22,95,-4,-4,-10,-20,27,-15,-65,76,-40,-33,26,-25,23,-35,5,-29,89,55,36,-22,-36,2,-23,0,-16,57,16,-4,35,-24,44,37,-19,-54,50,-42,-19,-26,-97,44,43,-72,-28,17,4,64,76,-31,71,59,4,19,26,59,5,-25,6,-53,127,14,-36,45,3,72,-45,71,41,6,-35,23,44,12,15,-28,-90,-17,49,9,-59,-10,-60,92,47,1,-31,-82,-20,77,37,-31,-46, 
  /* [736][0][][] */ -18,-38,-41,35,56,52,-50,-31,63,1,94,-22,1,73,29,53,-51,-46,21,-27,-3,-58,80,-11,-42,11,-12,18,48,55,-62,-97,-11,54,76,-74,43,56,19,59,127,-7,-1,39,10,13,53,-66,6,-22,-51,-70,-38,-63,46,1,25,-119,63,35,21,53,-114,-13,9,15,-41,-12,-34,15,42,15,-24,-58,-62,38,41,-118,-16,-62,-82,-72,-70,-1,-80,20,30,26,-42,-26,-24,4,-25,54,-98,-34,44,42,14,-48,-62,20,-3,38,54,31,-18,32,22,102,25,-5, 
  /* [737][0][][] */ -76,8,-99,-27,-28,-38,-18,-25,-29,-36,-65,90,21,21,4,3,63,-7,37,-26,-11,-46,-23,72,62,-84,63,-67,23,-9,13,52,-38,-12,32,-53,-6,104,-30,29,26,56,21,43,-16,62,73,-54,37,-61,-59,44,-26,-35,6,5,-66,-35,29,-5,-2,15,-13,25,-7,-108,-58,15,44,13,4,-41,29,85,56,-127,-36,30,52,52,13,55,53,46,-5,-26,48,-6,37,6,1,84,-42,-1,31,-96,18,33,71,66,-32,46,-10,23,-9,-61,-54,39,-55,74,12,-120, 
  /* [738][0][][] */ -39,-1,-10,3,-10,-44,-71,5,-9,-60,-10,6,6,11,92,-39,30,-93,-53,11,-56,-40,76,23,50,-18,60,-34,4,-10,-9,-25,-5,39,20,-44,87,16,-38,-35,-56,-89,41,52,22,32,56,-40,1,8,15,127,3,-36,-25,106,53,79,51,4,30,25,2,-36,-22,30,10,42,53,-9,18,-45,49,102,-6,3,-3,-64,10,2,10,6,-40,13,-59,-10,0,22,34,123,48,-38,-52,-32,58,23,101,-46,-27,-27,42,20,24,-81,-2,2,-25,18,-89,-28,-39,-45, 
  /* [739][0][][] */ 122,-26,-47,-115,-127,-26,91,49,110,100,30,64,-41,0,-12,5,-60,26,-38,31,108,-22,26,2,32,66,-29,34,71,-38,66,-66,3,-38,-4,-43,64,-61,-94,11,20,121,-124,-10,18,-24,41,56,-39,18,78,54,-20,-4,-18,-39,-12,87,-31,-109,103,41,-90,-2,-23,109,-44,119,-2,46,69,66,32,48,-23,14,31,37,-7,-22,13,-34,-14,-37,15,31,-1,59,72,6,9,35,39,-32,10,-39,9,-60,-35,-100,27,10,-34,32,-50,-36,-50,-33,-35,-1,92,38, 
  /* [740][0][][] */ 112,22,-41,-19,-45,16,4,1,-44,4,19,1,-29,-37,-54,-47,-41,-6,94,22,-40,-14,-37,26,2,127,59,-19,8,-4,-65,-7,-20,-15,-11,-40,71,60,14,16,11,-12,1,-15,-11,-24,72,-28,-50,-41,-15,42,-56,-23,10,-59,52,-36,15,78,-57,5,71,-52,-38,17,-39,-47,6,7,56,-36,-26,26,29,24,-49,2,-6,74,34,-45,-54,-18,-28,-61,12,-54,-24,5,14,-17,-19,45,23,-33,60,31,-87,64,26,27,-55,-17,35,120,-8,6,-39,-77,22,-24, 
  /* [741][0][][] */ 51,-35,-13,-20,-81,-14,-59,-55,-61,-44,6,1,17,3,63,33,-9,-5,-6,29,40,5,10,-58,35,26,-23,32,-11,80,66,6,32,73,-13,-15,60,69,-40,-48,40,51,19,15,-30,-24,85,-34,2,-34,-13,9,-62,-13,38,4,30,-30,-16,-12,56,76,13,-69,12,-125,-17,-47,-1,-39,26,-23,10,-51,27,-127,20,-12,46,-95,-63,-53,15,-33,75,67,3,-41,22,-15,50,21,46,24,-3,10,-21,0,2,23,13,64,7,-82,-3,-46,41,-4,75,15,9,-23, 
  /* [742][0][][] */ -13,9,90,-20,-47,7,35,-52,17,-22,41,17,78,-26,26,13,10,-24,53,-57,-11,-14,-87,-49,-51,-45,-79,21,28,-49,-40,-54,-28,-31,-13,1,78,14,76,42,1,38,-9,49,9,9,-127,-26,-67,-19,-118,80,-82,87,-10,-66,84,-99,-107,-15,123,-36,42,-55,4,-20,10,-18,56,11,31,-77,-83,-35,23,35,59,-61,16,-36,-36,89,-28,-24,-46,-6,33,115,12,-34,21,22,-8,103,-55,66,-39,-41,-104,94,-22,89,-30,-2,-100,42,45,-27,27,-14,61,-1, 
  /* [743][0][][] */ -26,7,-44,-45,-61,-25,6,-27,-85,51,-45,34,-2,-31,-17,-68,9,-89,-31,-37,4,61,4,-5,34,-81,34,-19,19,34,-17,-41,39,-47,0,12,115,-69,42,80,51,-33,33,22,10,-14,-84,14,24,-72,-29,-56,12,5,-127,4,72,-2,-7,14,-9,-54,-35,50,-1,-15,-27,-37,-92,-87,56,-10,2,45,56,15,-25,-28,34,36,-19,44,85,76,-28,-18,12,73,-26,-42,7,36,-41,43,-2,16,-56,-45,-25,-12,2,-22,-70,32,-43,24,-65,-37,-17,72,-23,-22, 
  /* [744][0][][] */ -13,1,69,24,23,-11,93,7,44,-18,118,92,39,-11,40,-9,-65,109,18,5,47,-6,-50,-67,0,-12,-55,12,45,44,39,-63,29,-7,13,45,-5,21,-23,2,-23,-57,123,-10,-18,56,-36,-45,6,-51,-19,-74,27,63,75,-2,-46,34,61,-2,88,-48,-44,20,22,19,66,45,-116,-27,-17,40,-25,-1,113,-1,-115,57,39,31,41,-35,-90,-64,-36,-7,-55,12,-7,-1,-16,59,30,20,-8,35,-59,17,-1,24,-44,85,45,-20,65,-33,-127,-12,37,37,-89,-57, 
  /* [745][0][][] */ -40,-105,-25,50,-5,-56,-35,-9,-19,-9,55,66,5,0,0,-9,-7,-62,-127,14,21,-4,-53,-64,-10,-1,27,-21,63,18,-47,-101,11,31,-16,91,-43,48,98,-23,-53,-9,-25,-127,24,-9,-62,34,-29,-8,16,5,50,-46,30,25,37,9,-31,0,-63,54,61,25,1,-55,40,7,-44,28,-37,-46,-31,-5,81,-28,8,20,-21,5,13,-16,-18,3,-39,-27,10,-24,-15,66,28,-26,120,6,-46,36,-15,-97,63,31,73,37,-97,-20,-10,57,32,50,93,43,-71,70, 
  /* [746][0][][] */ 13,-80,5,25,30,-95,-12,110,49,3,26,-31,-48,36,51,-32,53,-57,53,-44,18,-57,-91,89,-18,58,-13,32,1,-54,-118,2,26,-25,-9,0,-30,72,-14,-86,10,-3,6,28,-21,-55,39,-84,14,4,-39,63,-8,-93,-57,-64,-26,-67,0,-12,4,13,48,30,5,-15,45,115,9,-47,-43,-68,-67,-42,-20,94,43,-57,-17,52,27,15,-21,21,-52,61,19,-19,-8,111,-94,33,-39,81,-41,-39,-33,-38,-9,64,127,-6,66,-61,15,10,6,-57,1,-76,-3,20, 
  /* [747][0][][] */ -34,-7,39,34,-9,-31,23,47,-34,84,12,1,17,-75,19,-38,73,15,-38,45,-26,107,87,25,19,-9,-61,-60,-75,-9,1,-43,81,-28,1,-37,-37,91,14,-46,-25,0,73,-11,89,39,-3,-127,-116,43,-16,26,2,-25,33,-55,0,82,-59,-35,-2,-75,100,-22,3,5,-21,45,-89,11,49,3,-12,-33,34,-82,-73,-1,28,35,-24,53,-69,-39,11,108,23,23,105,61,50,44,81,24,-35,-51,-53,-17,-56,-85,38,70,23,-29,12,-55,55,44,70,-78,16,-41, 
  /* [748][0][][] */ -44,-32,13,-41,25,-17,60,-85,64,50,-9,-4,34,36,127,7,26,24,31,35,-20,47,-35,-56,32,13,-55,58,-19,-22,-5,-36,-29,38,-5,21,30,25,2,-23,-9,1,-17,-41,40,9,7,-40,-7,-6,63,-12,4,-41,21,43,-59,34,48,44,-53,-49,-3,31,7,74,12,-63,26,40,31,38,-28,37,-38,10,-36,60,87,-31,-11,16,1,-7,-41,-24,-24,40,-21,-23,-15,65,-9,-9,25,34,29,-1,-15,-26,-69,-31,-83,10,-4,-6,4,2,83,100,-39,2, 
  /* [749][0][][] */ 18,-2,-12,28,-27,21,-8,-13,-65,120,17,29,-20,79,-59,49,31,-23,37,79,78,86,52,3,-11,-10,-7,47,13,-113,-71,-72,37,93,-40,28,7,-60,-98,11,49,-21,13,0,-41,-69,-96,1,45,55,81,-101,-17,15,58,-28,91,0,-11,-44,-5,-19,-24,-1,-17,72,-57,46,92,-22,86,54,-16,28,-64,-73,-17,-6,15,-29,-22,-25,-34,-26,-31,-55,18,2,63,-50,95,0,-54,-78,35,-28,-106,59,-43,-127,-4,-35,124,83,68,38,114,-5,-49,-46,-35,31, 
  /* [750][0][][] */ -3,-58,34,-40,-35,3,-4,12,-3,-33,59,2,30,51,-74,6,-27,-9,-25,3,15,68,-12,37,39,-18,-42,-48,58,12,58,59,-62,-25,-14,-49,28,-31,-59,35,30,62,32,1,-76,28,-1,-44,-20,74,10,65,10,13,25,-21,11,127,60,-58,-34,-26,50,-42,66,25,21,11,16,-20,-3,-5,-57,-35,-17,9,-36,7,-60,19,-16,38,56,-13,-31,24,-45,-35,-34,-5,-31,34,-25,-35,-7,3,-52,22,-71,-20,-50,57,0,-33,32,-39,-36,61,23,-52,-40,36, 
  /* [751][0][][] */ -70,50,-47,53,14,-31,54,39,43,48,33,-22,73,-9,59,33,-9,70,-19,14,-31,21,-28,-32,-26,-12,-53,17,-22,72,74,6,20,-51,-77,17,85,-21,-54,-38,0,1,20,62,27,-110,-96,-28,-97,43,34,22,-86,80,53,65,64,0,54,40,-1,47,13,-22,-5,38,-87,21,94,-40,11,35,-92,2,-27,-11,-65,-4,-20,83,31,19,-41,-47,18,-24,92,-13,-29,-63,54,95,46,-51,30,127,41,-68,-34,23,18,-60,-32,12,-84,16,83,-46,0,-19,-29,1, 
  /* [752][0][][] */ 42,-2,23,64,36,49,2,-36,-9,-60,91,5,-19,63,36,18,29,67,-13,-93,42,-77,37,-25,-82,21,-33,-20,-38,-52,32,42,67,-81,3,-61,-19,40,-8,50,-28,-16,-11,14,3,7,-100,-28,-70,5,5,-51,51,-51,55,-25,-25,127,9,-41,46,13,-77,10,-6,-28,-26,-99,-12,16,-8,-9,-9,-6,-86,-37,-35,-69,25,-65,-12,-67,0,12,5,74,69,18,-39,35,39,67,115,60,27,-8,5,0,-68,62,-100,34,49,61,-7,43,-43,-12,-22,29,27,13, 
  /* [753][0][][] */ -80,57,13,53,8,15,127,-18,78,-61,17,53,26,-49,-1,33,-56,9,44,78,80,-58,46,-32,-37,-98,-23,-2,39,49,-30,-58,-66,-33,46,86,55,-92,-21,95,-117,42,-5,87,-18,88,17,7,-9,62,-45,52,-61,-33,-80,-32,39,-112,23,26,-32,-69,-74,-46,22,-40,44,9,2,46,25,-6,47,38,17,-73,-20,3,27,-87,-114,-56,43,17,-47,-66,-81,-13,19,10,38,51,13,18,13,-17,-111,-104,82,-93,-12,-10,3,4,-57,30,57,31,122,5,52,62, 
  /* [754][0][][] */ 30,-82,-49,-61,58,-60,49,40,47,-16,-43,33,-39,-49,-111,-44,-13,22,-82,18,103,41,33,13,-88,23,21,54,118,20,-38,-25,-17,-14,36,36,39,70,2,99,-22,53,-41,54,24,125,-40,25,-16,-28,35,64,39,-94,73,61,-81,65,-20,-3,-34,115,-55,58,-4,-95,14,40,-53,5,-39,85,47,-10,47,20,-55,127,24,66,77,-59,-37,-40,-97,95,-28,51,-73,-4,70,-62,-86,14,18,-3,-15,-24,-116,-55,13,21,-100,-53,-54,6,19,4,101,52,52,35, 
  /* [755][0][][] */ 41,-67,0,-24,-54,-19,6,-81,47,-12,-32,-26,46,82,-16,-56,21,42,-5,10,9,-21,40,-24,51,-8,-90,-5,-60,-22,-1,33,-11,50,90,-41,29,-5,-75,-19,49,31,30,18,108,-45,71,-12,-77,52,17,-15,-33,-88,-4,64,22,-3,56,-12,-6,-80,27,-19,3,-25,70,42,23,-43,-7,-78,61,-55,18,22,46,-56,36,33,49,-89,22,35,-66,80,24,-1,12,-77,-30,-39,-49,62,49,-51,49,0,29,40,43,-17,-54,107,-73,30,-23,127,-67,44,-70,-6, 
  /* [756][0][][] */ -25,-35,30,-25,15,-47,64,3,52,42,-19,-51,2,28,52,14,29,10,-9,-49,9,55,59,-16,-74,-11,31,-49,-7,-5,117,21,30,39,-22,54,21,-43,24,9,-35,-36,-81,-2,77,-4,-48,-13,-1,25,-25,9,7,21,26,46,-9,-4,9,-127,15,32,-25,-32,100,-1,-43,37,-80,36,53,37,-4,47,39,-34,5,21,-6,-19,-22,-24,-65,-48,20,33,54,-91,54,-50,-1,44,48,-24,65,38,1,-8,53,-18,-7,15,-23,13,-46,-52,-26,38,-43,-34,15,-29, 
  /* [757][0][][] */ 11,-57,-86,-28,-78,67,2,-51,58,37,66,-89,10,-33,-18,69,41,70,44,-101,-24,50,-19,-64,16,-39,-11,28,-38,-24,-43,46,78,-13,6,-22,-54,-84,-101,89,-26,-48,-82,-9,26,19,7,18,-27,-4,-54,-55,32,67,-34,46,0,5,41,-20,-55,-70,30,-25,34,41,60,85,99,-46,-72,68,-8,-127,10,36,-12,-52,-16,-19,-1,-6,-62,10,-64,42,-5,39,23,89,63,24,76,-6,42,-21,-33,51,84,0,-19,-10,25,61,-71,-13,-52,-71,31,-1,-11,18, 
  /* [758][0][][] */ 76,-53,-53,-5,-32,-6,15,32,-9,-89,-3,38,49,-114,97,34,-45,-26,-24,100,-33,-48,-82,-82,-6,-31,-63,-91,62,42,4,8,-23,53,-37,-63,83,65,-70,-127,72,17,-109,82,22,61,-98,45,-2,-37,50,10,15,-55,-48,-58,-24,7,38,-62,-57,47,-39,-46,-35,-4,-77,-76,21,101,7,27,-32,-65,51,-68,82,44,-57,-22,-51,28,-2,-43,4,24,49,-26,54,-120,37,-45,29,-6,-69,-69,-83,28,-71,8,-24,-4,23,-32,62,112,-7,103,-53,-12,-52,16, 
  /* [759][0][][] */ -71,-3,-49,-76,-20,-63,13,25,46,106,-90,-87,-71,53,96,-18,18,0,13,-108,-40,-65,-50,47,11,-27,6,-15,-17,-81,-8,-14,-19,-31,49,-85,24,59,-29,-88,-44,54,61,-18,67,54,-2,42,-17,-8,19,73,-62,44,-48,64,-26,-36,-30,-33,-44,-37,-76,-81,-14,27,67,47,2,68,4,-32,107,-50,-35,-70,58,36,25,66,33,15,-35,14,-4,-66,16,-9,19,-52,-106,-12,111,-21,-35,40,79,-18,-127,69,16,3,44,-3,-56,-7,-15,-34,25,32,32,-43, 
  /* [760][0][][] */ 2,-15,-28,73,-37,9,86,-4,-4,-19,-53,-6,25,-12,7,-4,-33,20,14,-25,-43,43,32,-23,-49,38,-25,-10,-75,-5,65,66,33,55,45,-29,-62,-28,7,7,-19,30,27,11,-11,2,-127,-46,5,58,8,48,-73,-34,49,74,-40,-13,31,-18,5,-24,19,9,6,66,-14,-49,-11,-31,4,-34,-55,-2,-8,43,-38,33,-39,-12,32,-31,18,39,-33,10,56,18,8,-27,-80,16,27,-7,-26,-61,12,-5,16,-56,81,10,-23,7,-11,-2,28,63,-43,38,-52,26, 
  /* [761][0][][] */ 60,24,37,28,-30,-56,-45,23,-3,-8,63,32,29,-48,-9,8,-127,-6,9,17,18,85,5,-1,-8,-21,-42,23,3,-47,-5,-18,-79,-3,-7,-1,26,5,-24,87,-4,-21,-26,-56,-31,-3,10,68,1,9,-48,-38,-7,-28,-54,17,26,29,27,-30,-14,81,21,32,-49,-29,89,46,-25,11,-71,12,-37,68,9,-8,-2,57,47,23,-8,-40,-74,5,-40,29,0,-2,11,-8,-25,45,13,-5,-14,-26,-90,15,26,44,-44,49,-40,26,-66,40,-59,73,-36,34,-31,-21, 
  /* [762][0][][] */ 27,-91,67,-14,33,-19,127,82,-94,-44,-64,47,54,88,98,37,14,6,18,-50,42,-31,19,-15,5,30,31,23,-60,-15,-61,53,-30,76,29,13,49,-45,37,30,40,40,-1,81,16,58,113,-11,78,-12,-56,28,-50,-57,-41,3,-44,60,-56,-20,-43,-2,25,8,-2,51,-43,-13,-23,44,45,-73,-32,104,31,-11,1,6,-60,-12,24,-34,-59,-16,-48,-68,-38,-6,68,-46,86,46,44,-53,26,73,-58,-85,25,-18,-6,60,-45,-13,-70,-2,8,56,72,27,16,-23, 
  /* [763][0][][] */ -54,16,-33,77,14,37,-32,27,11,-80,115,49,38,-23,47,-13,106,-20,25,31,-36,3,-13,-57,-75,9,-32,34,-85,-81,-36,-59,41,-66,-52,2,-40,-42,28,-2,-68,-10,-32,-94,-107,21,19,22,68,-40,106,-12,45,2,11,-93,48,-40,-9,44,94,-23,22,-60,-57,-66,26,24,58,-57,-15,-3,-2,-65,67,98,-65,-9,5,-54,6,-52,99,-29,73,-38,11,-127,50,0,86,52,-39,-85,16,97,-54,46,62,39,7,-36,25,-16,81,-63,-6,-109,7,45,-56,-28, 
  /* [764][0][][] */ -43,30,9,23,-92,22,-12,23,5,55,-82,-47,-25,-14,-4,32,25,-68,-33,-50,7,16,11,41,-10,-67,-4,-73,-93,63,76,70,-57,31,-61,-81,60,16,-27,-5,9,47,-83,39,10,57,-8,-5,-14,28,-12,-32,14,-29,15,-1,-23,-28,16,98,20,56,47,52,-66,-21,-45,34,4,-5,63,41,-28,-29,11,-13,12,-34,15,-47,-59,17,-42,38,-10,53,17,-127,42,12,5,-2,12,-36,-44,-28,-19,0,-12,-16,-24,-12,49,63,43,-67,-9,29,20,27,13,41, 
  /* [765][0][][] */ 5,-1,127,16,35,49,31,-19,-15,-24,18,25,21,-1,21,-27,-13,15,28,-49,-28,-54,21,114,-10,-3,-3,-8,43,-68,42,-7,-50,-34,74,-27,52,-27,-118,62,-26,40,-33,23,35,11,5,8,43,-10,-6,14,2,8,-12,-51,39,3,58,-73,54,89,-39,-13,40,8,29,-31,-33,3,-19,-2,18,23,-27,-50,10,-57,-17,36,-12,56,-12,47,7,53,28,46,15,-22,-59,36,12,21,-25,77,57,21,2,87,21,-35,-14,42,-62,23,-40,20,-15,49,-57,-24, 
  /* [766][0][][] */ 37,-6,4,-1,-76,-88,-3,72,-87,56,35,72,83,42,-10,31,36,57,-45,-81,50,37,32,-6,-39,110,-46,27,31,58,-5,62,35,-53,-4,74,-72,-78,18,127,47,68,3,20,-72,0,-38,99,7,16,-49,-64,14,64,57,16,-32,56,-50,32,-1,-12,26,36,-5,44,83,-76,-5,0,41,-37,-22,20,-52,-47,12,39,-22,-18,10,-15,-46,82,-5,-54,10,-27,2,-30,26,-62,-41,-106,-30,5,-74,-17,-2,-19,-42,49,41,-63,13,-73,-33,17,-30,101,10,68, 
  /* [767][0][][] */ -10,46,31,-33,-63,-11,-23,-49,127,19,-29,-72,49,-1,-5,42,34,55,-4,26,14,21,-31,-18,38,-95,55,41,-15,-69,2,4,-9,-41,35,19,-13,-55,-53,12,-36,10,11,-65,32,54,17,-16,-11,-6,21,-5,-17,17,-72,11,30,58,-24,-30,15,22,-51,-50,-15,27,40,-50,-6,71,53,38,-8,-64,-5,39,-6,-28,66,-19,-19,-30,45,5,37,65,9,14,-34,52,-37,24,18,-17,-2,-23,34,-2,53,-22,-62,-16,-24,-50,-12,-34,-8,-20,9,-29,46,-67, 
  /* [768][0][][] */ -17,-51,27,-7,13,64,-15,-42,-57,56,-31,35,38,29,11,-13,36,41,-69,42,49,57,30,33,19,-74,15,6,-35,28,9,58,-15,32,42,18,-51,59,31,-17,-79,-14,6,16,0,-46,-24,3,-70,76,16,57,36,-7,101,-4,-66,20,-31,-15,-52,113,6,-42,-20,18,-11,-42,-80,-26,-78,-37,11,92,-36,33,28,9,30,-22,35,-13,-33,-36,-44,-26,-39,60,-47,-18,58,-49,-33,-45,-41,-55,-58,-1,18,-40,81,31,47,11,-54,-10,-43,45,-103,59,-127,-14, 
  /* [769][0][][] */ 46,44,-59,-35,-6,41,48,-34,17,16,10,-6,-32,40,-41,43,-43,-69,85,-18,60,-48,-33,-45,12,-39,-40,-47,-23,12,58,-1,-46,-78,25,-26,4,-20,44,10,77,44,38,21,48,40,45,53,-19,-74,74,-127,93,68,-38,-11,-27,-28,-38,-53,60,-27,2,-41,53,55,15,53,79,11,36,-28,34,-43,-28,-16,-33,-13,20,80,39,56,12,6,17,10,-13,42,-15,-24,8,-18,13,-4,-33,-25,72,-49,36,-25,-44,-19,-13,-21,15,-36,28,-10,-18,-44,23,11, 
  /* [770][0][][] */ 0,-25,-38,17,66,2,92,40,73,-69,-29,46,-55,-57,36,-51,-4,-24,83,-30,10,-42,9,7,-74,-19,-46,-11,56,18,-33,93,59,29,29,-21,63,65,-41,91,21,-47,-19,127,-17,10,36,-11,-48,1,0,16,33,-37,10,36,12,51,26,-2,-99,-16,4,5,-60,28,42,-26,15,-3,-3,-47,-25,-1,18,-8,-8,-7,12,120,60,16,-19,-27,-25,-12,3,30,-75,-2,-18,69,7,48,-15,-42,-50,-16,43,62,36,9,-40,21,40,-36,-20,9,65,14,-89,2, 
  /* [771][0][][] */ 70,43,47,46,-3,-47,-11,78,-22,17,-109,24,-53,-68,-45,58,114,-89,-57,26,15,-90,22,-6,-26,82,-65,10,-70,30,16,-21,-13,13,38,83,-37,-63,-41,-85,11,-19,20,-7,5,-17,5,-32,-39,18,-6,37,-51,-30,39,-10,-80,-58,-44,21,83,-51,35,34,-2,8,-9,-65,-33,-35,-14,82,37,41,6,53,-59,-60,8,72,-89,-125,63,0,-63,64,102,14,17,30,30,70,67,17,-11,125,0,-41,68,7,-26,0,63,-74,-42,98,-50,127,54,13,9,28, 
  /* [772][0][][] */ -42,-7,-48,-48,-4,-96,-79,13,18,-35,-28,-127,-24,33,-73,-9,43,56,27,41,1,9,-13,4,-41,29,-98,71,41,75,-48,-22,8,2,113,-36,-58,-46,-38,68,-13,-36,-47,-122,-38,47,81,-30,-34,21,76,-34,-57,41,-54,-14,-52,-2,-100,2,-101,20,-37,-120,-7,-24,45,-19,-7,77,-79,-19,87,68,38,17,4,1,80,-43,24,6,-52,-62,17,-29,31,63,1,-17,-32,37,-103,11,3,12,-15,0,24,44,-11,-35,-30,-7,30,73,-73,7,-36,10,-50,33, 
  /* [773][0][][] */ 34,-64,80,-56,59,35,85,44,103,-56,18,0,-27,38,-42,77,-49,-44,-6,-34,32,78,-66,-4,81,28,16,-26,4,2,28,84,-14,-100,26,-38,-103,73,8,-47,62,-21,-11,-50,18,-60,68,42,74,-24,-5,19,-70,0,19,-12,-15,-8,-5,1,15,-78,16,63,-32,101,36,-74,68,-19,-44,-23,43,19,50,-63,-65,-16,-37,33,52,-29,-34,-3,8,-28,-54,14,-3,-67,-127,-68,-11,51,-12,78,-4,88,75,-2,-14,1,-26,-52,81,-28,-73,31,75,32,-13,-42, 
  /* [774][0][][] */ -53,30,38,58,92,47,61,-21,-50,-100,73,-6,-74,-9,70,-58,-9,-61,29,61,20,-62,-46,-31,-17,-19,-33,-46,20,0,3,-11,-82,55,7,-4,-14,89,4,10,-18,-94,-30,-102,17,29,7,-29,28,-82,-1,69,52,-77,-24,-69,-31,22,36,1,-28,-22,64,-53,25,18,-17,35,49,-25,-13,-61,-43,-28,17,-53,43,58,30,-36,127,21,33,88,44,-35,-22,-58,-79,-52,-1,-31,-17,69,52,-55,75,64,-43,-53,-53,2,44,107,0,-52,-8,81,-43,5,-5,-85, 
  /* [775][0][][] */ -19,-14,-30,-91,-38,-81,14,57,19,23,-57,67,-85,-27,125,-38,122,-25,52,54,30,1,16,-14,-34,-75,59,-1,-19,77,17,-25,-42,-34,69,-20,29,-13,-54,-36,-11,89,15,-16,-74,13,67,70,84,-13,40,92,-3,-97,-49,-4,-5,-108,-84,-2,38,81,24,90,14,-32,-123,-10,-50,-19,80,-13,20,44,33,-51,102,-10,-5,-20,-126,-12,0,82,84,61,-21,13,40,116,57,-9,-91,-46,73,-13,-1,52,-46,19,-30,-71,-20,22,-74,6,92,7,-82,85,-10,127, 
  /* [776][0][][] */ 23,-50,-29,70,5,-10,34,-38,22,-35,-44,-62,1,-21,-8,-85,-80,-11,11,27,11,34,-41,35,23,-23,6,-6,-10,43,-52,62,-12,-65,-127,-46,26,-15,16,-17,-32,78,-14,23,41,-54,-24,-19,91,17,31,61,-96,83,-16,59,-9,-41,0,-85,39,-30,-55,-62,-15,-16,-6,72,-35,-72,-41,-34,104,83,11,14,-81,35,42,-13,48,-60,20,15,13,-22,-12,76,-28,-68,64,-57,-38,85,-21,67,6,59,67,-26,34,34,-86,46,-9,-68,-57,1,42,54,-105,77, 
  /* [777][0][][] */ -49,-60,-38,88,16,10,-45,6,-71,-93,86,23,-9,-61,67,71,95,-2,59,-9,-92,11,-4,-94,-7,-64,8,125,-53,-13,35,56,41,-4,102,26,7,8,61,-23,25,-78,-90,-9,-98,-44,62,-6,-21,-46,-39,-22,-108,96,26,-39,81,-35,-60,37,-13,72,19,31,35,23,-3,29,79,-112,-22,-69,26,-106,1,-21,-17,53,-10,30,-33,-1,65,33,46,50,-41,-23,-76,55,-10,-64,55,22,-117,-3,11,-127,-4,11,-51,-1,-12,68,-121,-58,-20,53,-36,-33,11,104, 
  /* [778][0][][] */ 18,-2,-24,46,-31,-37,31,53,14,-33,106,53,-35,53,71,11,72,-34,56,-71,56,-1,79,46,-103,39,32,-10,36,67,-9,20,-54,17,67,-13,-42,92,61,-96,-50,15,114,-51,46,-47,-127,-35,-58,-43,23,21,-29,32,30,81,-86,25,10,-42,71,84,15,-15,-43,39,-44,8,16,19,6,-45,46,109,-77,-3,81,-23,-37,-56,30,25,-1,-59,18,45,-16,25,-18,8,58,47,-48,99,2,32,42,-45,-84,2,-75,59,61,-3,6,-42,56,14,3,44,-35,21, 
  /* [779][0][][] */ 116,58,43,5,27,70,79,-64,8,29,0,69,-6,12,74,47,-38,-25,52,16,-31,79,-19,52,35,-12,14,-45,34,10,-80,69,16,-18,-44,33,-62,3,-38,44,-18,-9,-15,-50,-41,62,-23,-3,26,-23,55,-69,37,91,36,-37,14,85,-65,-62,72,25,1,35,9,17,13,56,-34,-25,-82,3,92,-18,-27,-31,-50,-46,3,101,-127,55,27,-26,81,-16,6,33,25,63,13,64,3,-17,-28,-12,-12,29,-62,65,59,-15,-25,-39,-46,-18,-23,35,-82,-23,-76,6, 
  /* [780][0][][] */ -7,-66,-38,5,-60,64,45,28,-10,-29,-63,-30,44,-70,19,39,22,-29,62,-25,-66,12,-6,-88,74,-20,-30,-15,-28,-8,21,67,-13,-6,16,27,0,-55,1,-9,-1,22,72,-67,56,9,99,43,-9,0,-76,-54,31,44,-10,42,72,-106,16,13,-51,64,38,-17,64,85,-92,43,-22,-37,11,-8,-5,4,1,44,-37,-22,-15,127,-35,-19,15,-26,29,-64,-27,-21,-13,-37,-42,-67,44,-8,-24,-71,44,-1,28,23,-67,-28,-82,-85,26,33,-98,-2,10,58,-56,43, 
  /* [781][0][][] */ -60,-8,-50,-19,24,8,1,12,-10,20,-4,-65,-24,-36,-3,-127,0,1,38,-3,-20,9,-63,1,-82,-32,34,61,-2,10,-19,-45,1,11,40,-38,2,-20,-47,9,-47,29,57,-27,79,-12,-5,-65,5,73,-8,50,55,28,24,-6,-66,-40,-66,-17,1,18,26,-29,-11,14,-7,4,33,-37,19,20,9,-44,28,15,-4,27,25,29,23,89,-16,-17,20,-9,-22,-39,-29,-38,1,-11,-27,-8,53,-36,-19,-31,-23,10,-21,-20,-53,-2,23,-11,48,-8,28,-2,2,24, 
  /* [782][0][][] */ 27,38,45,-28,4,-10,73,-2,-22,-17,-105,48,67,19,-15,-5,41,20,23,-35,31,39,17,-101,-29,24,-16,-9,-43,-17,-13,-28,73,78,2,64,-15,-18,49,10,-6,-51,-37,5,8,49,117,53,1,-46,22,-9,3,-7,42,-8,75,-68,-24,12,27,61,1,18,-33,33,2,-127,-26,-2,35,-17,-62,6,-31,-9,17,-39,33,33,18,-34,-20,-27,21,17,40,-37,12,-40,15,-34,68,-38,42,6,-10,-16,8,54,23,-86,68,90,-25,-17,-55,60,-42,10,-33,-17, 
  /* [783][0][][] */ -3,-17,9,-40,20,-14,-68,-10,-33,87,0,-67,-42,3,-56,80,63,29,17,-80,-77,43,-4,-13,-56,-61,-71,-89,-44,3,7,51,100,28,54,-18,-57,28,39,-31,-67,-32,-16,10,-19,37,-3,80,25,-7,73,32,-29,-85,78,-40,-52,-31,17,-29,-81,38,-86,31,80,8,48,-90,-97,36,25,59,16,27,-22,15,-27,44,-68,25,-35,-17,67,-20,-32,44,-21,-23,121,127,-108,-10,44,-64,-26,-1,-28,82,75,65,48,-9,-46,35,20,-32,48,68,-1,-85,-55,50, 
  /* [784][0][][] */ 0,-48,-50,9,-3,-9,12,50,11,65,0,54,-34,-48,-57,-36,98,-55,43,-1,62,-49,-9,31,43,33,-21,23,-14,-40,-24,4,17,-74,21,-127,-3,-4,-33,-18,-60,41,18,-45,-32,13,3,28,6,5,54,-1,-8,-11,-44,-93,-45,14,9,8,51,-28,7,43,-58,-42,9,-1,-6,1,85,-22,-20,-4,-37,29,-39,-52,-99,25,1,54,17,-55,3,4,43,5,70,-9,-26,-4,-2,-11,-68,57,2,-50,-9,36,0,-4,2,89,75,-32,25,-57,7,17,6,-10, 
  /* [785][0][][] */ -14,26,-63,68,-89,2,-22,24,14,-22,-7,-12,-40,9,0,42,73,-78,-28,18,23,-41,36,40,93,-57,-3,-7,72,85,23,33,103,83,0,14,45,54,-11,-38,-51,-31,59,51,37,41,-3,13,40,31,-60,-20,8,88,-2,-109,105,9,-9,92,-10,88,9,-99,69,14,-49,-55,-12,-89,20,54,-35,7,10,-66,-4,-2,34,38,22,18,28,15,-15,-36,-63,-37,-28,-127,-18,9,-59,-48,42,11,2,-38,-63,22,-2,66,-42,-46,-40,7,34,19,-53,28,-23,77, 
  /* [786][0][][] */ -7,-69,-70,67,-10,-46,71,-68,66,39,9,26,6,-66,80,30,-76,1,36,-25,-68,-63,12,-36,34,3,-71,-45,-41,-23,-74,-35,31,-30,28,-42,-23,19,66,-31,55,26,10,5,-50,14,-60,91,-82,-16,-31,16,-15,-14,-105,98,3,-42,60,-93,31,8,-47,-105,35,-8,-28,49,46,-36,34,-24,27,13,-3,-63,38,-30,27,33,-24,-68,26,-72,-26,-50,96,54,52,10,64,-40,-63,-85,23,-49,34,61,27,101,-38,50,7,32,-36,-32,31,-98,-127,-115,99,-24, 
  /* [787][0][][] */ 85,-30,7,-33,21,-27,93,-48,-14,-18,-4,-30,9,29,28,-39,-25,26,-22,-42,-10,-13,-17,-57,-17,3,-2,-42,12,13,-83,26,22,38,36,54,-33,38,32,-12,40,9,54,-12,41,4,11,-35,-1,1,95,21,-26,54,-26,-31,55,-4,-37,-33,14,-64,-84,0,13,1,-48,-88,-50,14,44,-60,58,-38,67,5,9,-32,-11,-44,-15,-32,35,-27,-15,43,4,12,-11,55,64,12,24,-12,14,49,38,-127,4,-39,-45,21,15,-54,-4,96,1,38,-34,4,37,-5, 
  /* [788][0][][] */ 0,75,15,27,-68,-37,11,-49,127,1,-32,31,-10,28,69,11,20,12,17,26,-5,70,-43,7,26,-64,34,-15,21,-17,20,-37,7,40,70,-35,-41,4,-6,24,24,-20,-14,-7,33,-9,-29,18,-1,66,25,18,41,9,-55,5,19,18,79,-75,-25,76,1,-26,38,-17,-6,78,101,13,-4,-67,-30,67,29,6,20,-21,106,-2,-32,17,-37,73,7,14,-3,1,24,-6,30,-72,17,-36,-3,-103,-51,-67,-39,34,23,42,4,-9,101,-25,-96,37,-49,0,40,-15, 
  /* [789][0][][] */ 1,-3,21,123,31,4,-32,16,28,16,23,-5,31,39,-19,46,1,5,62,-57,-96,-25,-12,48,-17,-60,-57,-42,28,-67,11,37,26,45,18,2,-57,-12,56,-84,-21,-79,-13,-6,7,-12,-5,15,51,74,47,-21,-11,9,114,-22,15,67,-36,-11,-48,-33,47,-2,-57,44,-13,-13,27,18,15,-4,-29,16,-2,23,-6,-58,-9,-81,127,-10,-45,-86,27,-4,-7,-20,50,29,-87,-55,20,-13,-110,-45,33,-55,14,-44,39,15,85,-11,34,-13,-77,-33,-60,21,-62,31, 
  /* [790][0][][] */ -8,85,-16,11,7,-10,-3,16,39,20,-66,22,-20,25,-13,-4,57,-87,12,-34,-50,31,40,1,35,-10,22,-2,32,46,38,16,39,-75,59,-32,-44,-9,24,39,-77,90,-2,63,-6,127,-18,-29,7,-15,28,55,-4,49,0,-30,-17,-20,-9,-30,18,-1,-31,3,-17,4,63,-3,-24,98,-61,-23,-23,-43,15,40,-4,-44,-3,11,-4,25,-13,30,24,-78,40,-55,-57,4,19,-41,13,49,-41,16,60,3,-85,-34,-5,85,34,-9,8,-46,-25,-61,35,91,10,-22, 
  /* [791][0][][] */ -13,13,36,-9,50,-96,-77,54,56,71,-4,35,-2,-11,-31,-93,0,-17,-38,10,84,-11,-94,-43,32,-38,-2,-41,-10,14,-69,-95,23,27,-92,-67,-7,63,-2,-21,-50,15,-51,80,61,30,48,86,31,-3,-68,18,-3,-57,12,-55,-41,8,110,-3,22,-65,-92,-9,-23,-59,-7,4,14,9,39,-24,-30,21,95,-3,-31,-11,-15,68,20,-14,6,-79,-63,1,56,-20,55,-23,-15,81,44,28,73,26,30,12,-9,61,-57,20,39,-127,-5,9,23,11,54,-5,50,-5, 
  /* [792][0][][] */ 35,8,-21,9,-27,-25,67,-28,2,6,46,16,-7,-7,13,-49,-26,-40,3,23,-28,-57,11,-28,-17,17,12,63,-16,-32,-48,-41,51,-13,59,-29,29,14,31,40,56,5,8,-85,-48,-51,-53,11,68,-23,-35,23,30,-29,5,-9,28,28,36,32,-11,-7,-37,-61,-19,-9,25,-44,25,-77,55,22,20,-3,-86,-53,-32,43,26,-3,-8,-2,15,89,-48,-10,-74,-7,-47,35,-127,69,-79,-42,-26,21,-21,24,42,53,96,52,52,-15,82,1,12,6,-32,-4,32,58, 
  /* [793][0][][] */ -58,-50,0,50,40,64,30,38,-8,-20,61,-6,9,-2,40,32,37,-45,18,49,23,47,23,-28,-62,69,10,8,-27,-11,-11,30,6,-14,109,-52,-58,104,41,-9,52,-5,0,42,-105,68,46,-11,-42,23,-23,24,27,-57,6,4,-33,45,31,-77,-39,44,-3,40,-39,18,33,-51,38,56,-95,-92,21,-49,-11,-83,59,-29,-5,33,22,65,-17,-11,123,55,14,36,53,-7,-127,16,58,-64,-12,6,82,35,70,-18,5,-55,74,-1,-32,-115,6,26,-73,-5,21,-3, 
  /* [794][0][][] */ -17,62,-7,5,11,25,21,31,0,-28,46,30,37,24,35,17,-4,27,9,13,-49,-40,53,15,17,28,-33,2,-11,-16,47,0,62,0,7,46,-24,12,-50,-7,-9,-25,-17,-18,-22,50,37,-3,69,-17,2,50,-2,24,37,28,41,-18,0,21,-10,17,-38,-24,19,29,-15,45,-51,-12,-19,-15,16,-7,-8,43,-54,73,-14,-6,-49,-29,-50,12,60,-127,9,-18,0,-16,-64,-1,-45,-81,69,-14,-25,61,-18,29,-35,4,37,14,-13,-21,12,18,4,22,23,41, 
  /* [795][0][][] */ 42,-35,13,-5,34,44,36,13,5,-17,-40,-42,-65,-82,-18,-97,7,-73,-22,-24,-71,11,-25,-12,40,-50,5,-7,47,-65,6,-69,-47,12,-94,29,127,-2,4,-82,49,-48,-114,-30,54,-28,45,5,51,-33,5,48,56,108,-75,0,76,27,-1,85,-79,4,10,-15,-49,70,30,28,-25,-2,-6,-53,-37,55,-26,2,-56,-25,-116,5,21,-15,-61,56,-33,6,-90,-27,68,-80,-6,28,-25,45,-15,21,45,-88,0,35,41,-5,20,-1,52,20,52,44,-4,-14,13,37, 
  /* [796][0][][] */ 107,-73,-23,35,47,-123,9,18,-60,-10,3,9,13,49,45,-54,99,32,83,-40,2,99,4,21,-11,-36,57,74,-3,-43,71,-21,27,-90,69,7,31,43,49,-28,108,-95,-28,90,-30,23,44,-37,-52,-127,-1,25,-24,66,45,-52,100,30,-35,18,42,12,80,-54,-19,-5,39,-17,-37,98,-12,11,-24,-14,-95,91,12,74,-1,-8,-54,25,-66,30,28,-64,-39,-51,52,42,29,-4,-51,-8,-39,5,-46,83,104,-27,-68,-91,-73,-40,47,37,-32,36,96,-46,-23,-78, 
  /* [797][0][][] */ 71,24,23,-19,-40,39,36,-15,-4,-44,78,-102,23,42,57,-32,-48,-61,42,51,55,-12,83,-27,-96,-43,-56,1,-29,9,-50,-26,33,93,-52,73,32,-7,8,-20,-12,59,-3,-54,-22,-22,40,22,82,46,-37,116,-45,30,27,70,80,103,-2,19,25,63,-25,-68,78,34,9,-13,-25,-73,43,-29,49,62,55,-118,-16,12,65,-70,-51,-16,9,83,17,22,2,-21,4,-16,37,98,-36,69,4,-14,-1,4,35,6,63,-71,-37,11,9,-67,-50,97,97,-39,-16,127, 
  /* [798][0][][] */ -59,-16,-16,-58,2,5,52,-3,23,-47,15,-3,70,-59,38,-48,-10,-33,62,35,-28,-20,-7,49,-46,-46,-63,-23,11,-66,9,-28,-44,43,41,-16,21,31,18,28,0,-12,-13,12,34,-22,-66,-30,-48,-22,72,-62,17,23,35,-18,26,-33,-16,-21,-21,-20,-20,-18,73,127,-23,-3,-39,-27,26,23,3,-6,35,25,-28,-10,-11,48,-25,-27,-17,53,24,-54,41,10,14,-42,-49,36,3,-30,-19,-51,36,-25,-63,-16,23,45,22,-4,-14,44,17,-5,-17,43,-26,8, 
  /* [799][0][][] */ -13,-30,12,2,61,-35,-50,-7,-15,11,16,37,44,-15,-11,-70,-9,99,27,69,62,29,58,-20,16,-47,30,-71,52,75,-20,17,-8,-22,73,-25,-38,-81,-56,27,70,59,19,-57,-58,-22,87,15,-32,56,73,57,35,-82,71,-53,-4,7,-12,99,2,-4,-15,-16,-14,-89,39,-15,52,20,88,27,22,-46,-63,47,-17,-46,13,12,-81,-49,-89,-64,6,25,35,7,-61,114,-29,26,-46,13,55,-20,89,19,63,-6,-40,-1,-96,-80,54,-86,-2,127,35,66,-100,-52, 
  /* [800][0][][] */ -71,-8,37,-6,3,0,-7,-3,-12,-33,35,6,-13,-67,-27,45,12,-51,39,60,10,28,-71,83,-20,-23,21,33,-14,-71,-35,-127,-11,-18,-54,-42,8,36,69,-3,-36,4,-4,-29,26,0,5,-21,-22,-31,-4,-30,64,-73,-108,-16,27,8,27,-44,10,44,40,13,13,25,51,7,75,24,-15,16,-31,-34,-38,-32,-53,69,-25,-23,-2,-6,-47,6,54,7,-41,-4,12,38,1,-4,-10,-39,-13,20,-21,-31,15,64,28,-3,-21,-11,25,24,-31,-22,66,5,-4,32, 
  /* [801][0][][] */ 44,-45,43,12,60,-74,-29,-80,-21,27,14,17,2,-35,-33,25,4,77,-31,3,-36,7,13,104,26,-72,-1,71,123,62,-86,-67,25,-74,-10,11,-127,-46,17,125,-24,-13,-35,1,-80,29,68,24,5,48,-39,9,-51,15,3,30,-9,54,-1,-14,-32,20,-19,98,-6,56,-12,38,23,-15,6,-80,-13,-5,56,4,-57,-77,-3,32,76,-80,36,-7,22,-5,17,-45,36,-45,-37,-24,21,99,-20,-66,-119,-35,-11,-38,8,-82,90,9,12,2,-4,-15,33,6,18,-12, 
  /* [802][0][][] */ -56,38,-43,-80,-16,-3,56,-78,-8,10,13,62,-39,-40,-39,31,-15,88,25,-44,41,-3,46,8,86,-72,-35,-48,-12,-9,70,40,14,-60,27,-79,32,20,-7,74,-58,9,27,27,-28,-14,34,23,64,38,-17,-21,-79,25,-37,86,12,1,-23,36,19,11,27,35,-35,-38,5,20,22,-28,41,68,-38,-97,-70,-44,-60,-99,9,-40,-44,-14,-11,3,29,12,-34,-11,22,-25,58,8,-66,0,25,2,23,52,33,12,-71,-47,20,-43,63,33,-22,-21,-34,-5,-127,-52, 
  /* [803][0][][] */ -71,-7,-45,62,-63,6,-76,26,-22,-19,63,-23,23,40,72,38,40,-3,54,6,-63,110,33,9,-45,51,1,-50,-60,71,-71,-12,-61,-70,9,62,-24,47,56,-22,36,-59,92,102,119,54,13,-28,-101,1,-72,-44,29,-37,58,0,-57,16,-41,127,22,-90,28,55,28,-29,3,-37,76,-22,71,-33,-44,-39,-24,-52,-6,-66,55,-52,100,-27,8,-57,-81,-16,-83,29,-18,66,36,-3,58,-24,17,46,7,-87,14,-43,62,-17,-13,-82,15,35,-47,73,108,-4,-68,-61, 
  /* [804][0][][] */ 49,65,39,-47,-20,-4,-50,-67,-95,-22,-23,-34,-79,20,-9,70,-10,-46,3,-14,79,79,-59,8,-16,-80,7,-17,53,-9,5,-56,12,-45,-26,-24,14,48,26,-47,14,-46,-11,-15,12,64,31,18,90,-39,-43,23,-28,-14,-82,93,-19,-127,-4,0,-63,89,0,-44,17,14,-79,-50,-1,11,-7,106,-7,25,-30,-35,-54,58,44,18,-48,32,33,0,-73,-83,45,-78,-125,-41,32,6,19,-94,14,-71,-46,25,26,31,31,-70,-1,26,-5,31,15,45,6,-70,3,-15, 
  /* [805][0][][] */ 49,-4,2,-40,63,42,25,-16,-7,-30,12,55,-33,17,16,67,72,1,-72,26,44,39,-12,21,35,-55,13,2,-17,-48,-108,1,-34,37,22,46,-33,-42,23,-21,-9,-52,97,-15,38,14,-18,-85,11,-61,2,12,56,49,44,-96,36,-27,13,-14,73,-61,33,0,0,-44,19,53,69,11,38,58,-38,48,-97,-23,55,56,-9,-31,-6,-32,14,-127,5,-43,-74,85,-22,-15,21,46,-12,-47,-7,113,-60,-87,77,-20,2,52,102,-2,33,82,-24,-2,71,-32,-29,2, 
  /* [806][0][][] */ -31,7,-1,-59,-50,-30,24,-43,50,-73,-27,57,11,7,31,-13,-27,82,32,-31,-2,9,-13,11,-13,44,29,63,9,37,-10,-104,-29,-35,109,115,36,-19,-69,82,72,-28,41,75,-8,25,14,-20,-11,-57,42,127,-54,-4,81,-48,38,-9,-38,-96,-107,113,-99,65,119,84,28,-71,-101,120,41,-99,96,-40,8,112,93,-3,-85,10,40,54,30,22,-38,-49,-75,89,7,-126,-72,-44,32,17,-8,78,42,108,-1,61,-54,12,23,-23,-38,3,6,-69,113,-37,46,57, 
  /* [807][0][][] */ -36,-120,37,88,13,-10,14,-35,-23,-1,38,41,54,-23,-28,70,-28,11,53,46,-46,29,23,45,-54,35,-43,11,6,6,6,-43,90,-84,-80,-69,12,-58,24,79,-8,-24,27,20,-63,-49,-77,-36,42,-30,-45,12,-18,-47,81,-7,-6,-56,-33,6,-70,18,117,10,3,22,37,-11,127,-24,15,-7,-43,0,-26,83,9,-27,-18,-1,17,3,38,-37,-113,2,-15,-38,120,-18,16,-36,-44,-107,74,32,11,-52,4,5,54,21,-39,-12,-43,-3,13,84,-60,26,32,-52, 
  /* [808][0][][] */ -89,-6,48,-59,-29,35,20,-7,-27,42,-42,13,-91,59,13,-7,7,4,25,-15,11,82,46,75,-27,-24,127,63,-42,57,-6,24,20,45,55,5,-95,-22,-7,-5,50,17,23,35,-21,16,-13,-3,-11,-30,12,-10,-43,7,24,-37,31,-114,-90,-46,-43,-47,-3,30,52,12,-65,-36,-26,28,16,11,117,47,32,-2,7,19,28,26,80,-10,42,70,-17,-65,-10,-12,-52,34,-77,-51,10,19,-78,8,6,-16,10,0,10,-16,29,39,40,-64,16,56,-30,56,-3,79, 
  /* [809][0][][] */ -127,-60,-68,35,39,46,-58,8,50,-73,78,-50,-44,18,-38,36,59,-28,8,51,60,-18,108,12,-3,-20,28,-10,55,5,15,-34,-50,-20,-37,11,109,-44,-8,-15,-15,13,-57,-27,6,-18,17,-9,42,-15,-8,-16,-29,78,-30,-35,-8,-77,-55,-14,18,-2,112,-13,-20,-62,-80,-60,-43,9,68,-52,63,-2,0,74,77,65,-121,-71,-98,56,-34,-89,-28,21,64,27,-19,-17,17,-4,15,53,53,51,-78,31,-38,44,-31,110,-14,25,73,-29,28,-36,15,-15,-18,43, 
  /* [810][0][][] */ -23,36,-83,57,28,10,-42,15,67,-36,-43,0,20,15,16,-14,21,12,-10,-18,-6,-35,22,-31,-30,15,-17,3,52,5,15,-36,-20,50,55,24,-116,29,-19,28,0,11,-11,-1,-36,57,-51,-19,23,-51,-59,39,68,-41,-54,30,27,-17,21,-35,-26,62,124,-1,-47,71,34,52,11,-17,-8,-6,-127,-52,-72,45,-29,-25,11,-62,-60,56,-24,-53,-68,41,-35,-46,10,49,-42,-1,-60,-13,-16,10,-22,-16,-66,-15,-48,35,73,-46,5,-22,40,43,-49,18,-1,-7, 
  /* [811][0][][] */ 110,-19,18,82,62,27,-34,-50,-45,52,100,-37,42,-80,-19,-69,70,36,-72,68,-94,52,-48,51,31,-33,25,-71,-96,-7,-46,-98,10,-14,-34,44,5,56,-39,-25,-54,-22,14,107,79,1,-119,19,-20,8,56,-15,-28,-49,-39,-60,-30,41,45,43,-50,-11,-42,-30,27,0,127,74,52,118,-35,76,76,17,32,-22,-41,-1,39,-5,-25,28,-98,-24,19,-6,-46,5,122,51,-25,-16,45,-11,-13,35,91,-1,-100,21,-43,53,-55,-17,-16,3,52,30,-67,4,-40,78, 
  /* [812][0][][] */ -5,-59,15,44,87,50,-30,-48,-52,-45,116,73,-2,-2,46,23,16,46,4,-61,-79,7,70,31,69,-28,-6,-8,23,-41,-30,84,-49,57,1,-7,-126,93,-11,-35,3,-11,27,33,-62,86,-37,-59,31,37,-37,-103,-28,91,50,62,40,-32,9,-43,-42,4,10,-39,46,6,-3,43,37,59,41,-12,57,-61,22,-9,-52,-35,-83,66,58,-28,-35,-19,127,-80,15,-42,38,-42,-68,-30,52,60,-38,80,-58,-60,7,40,-23,9,-44,44,32,-17,-2,-63,47,-10,3,1, 
  /* [813][0][][] */ -86,41,-6,15,-43,-113,6,-46,57,-3,-45,-27,-4,42,-98,-120,25,-5,19,20,-59,-1,55,0,-14,49,-100,-10,-70,-34,-67,-47,-29,118,47,-6,72,28,75,-2,-28,-61,-45,5,-9,22,28,-29,-18,-30,-117,-39,38,-44,49,-8,-25,-55,20,28,-8,1,-92,-43,-41,17,-18,5,56,-67,-80,-111,0,-38,60,-4,5,-57,8,127,86,-41,-100,-26,-15,44,-38,-58,3,-22,8,-20,11,38,30,-47,3,23,85,26,-71,64,6,-19,-29,-42,-103,-10,-73,-88,33,11, 
  /* [814][0][][] */ -19,-11,18,-12,-32,24,48,-82,-33,-44,47,-24,63,-6,11,-9,-60,24,63,36,-6,45,-10,41,36,12,-26,-43,27,6,-40,23,32,-8,-21,-104,64,-114,13,108,-60,-6,45,7,-33,-8,-22,21,86,12,-50,-102,81,40,-11,-23,57,-59,35,-13,20,41,58,127,-24,-2,2,24,-64,10,41,42,-15,-74,0,9,40,26,-30,-56,-29,-48,51,80,35,78,-6,-77,42,58,36,-30,-35,-69,6,-78,-21,13,26,-20,-27,-53,-45,55,65,-24,-42,-58,-41,-91,-49,39, 
  /* [815][0][][] */ -32,24,-51,-2,-10,-16,-30,44,-6,4,-16,48,64,9,34,78,-10,-4,3,-19,-22,-8,19,-69,-47,-23,11,13,-3,-84,4,81,-67,107,100,-17,74,127,70,-47,5,53,41,14,20,49,-109,58,-37,62,-43,78,-18,-71,18,30,-33,78,-40,-47,-25,-15,-24,-34,-48,-9,-31,-117,-7,-16,-81,-65,13,55,59,-26,-26,72,27,16,101,-12,-122,-118,-44,3,-65,56,-8,3,-19,-58,37,65,-45,8,29,-117,21,-72,11,-51,-18,-51,-18,-73,-10,-71,0,-51,-46,0, 
  /* [816][0][][] */ 22,104,12,-39,35,-76,-28,59,78,26,108,100,-10,66,-51,-17,112,-48,-4,44,-9,25,65,-17,-77,51,28,-59,-18,-45,-11,11,7,-16,34,6,72,-20,25,33,19,0,-41,-25,40,40,3,-41,71,-10,13,27,77,-7,115,4,-68,64,-65,-67,-39,127,53,-42,-55,5,74,-34,57,23,18,-66,-30,-10,-39,-5,-18,74,16,-16,12,-30,-26,-1,-47,-21,41,-4,19,-13,-105,-50,83,11,81,-12,5,5,11,-15,8,32,18,58,49,3,-37,3,28,20,-45,-18, 
  /* [817][0][][] */ -30,63,-52,88,-46,127,30,-63,-116,-62,70,-27,16,-36,27,-13,23,-66,31,38,50,-6,26,-27,-74,31,-93,1,-107,14,-25,-51,53,81,33,35,59,8,10,-53,13,22,-4,43,47,0,-14,54,-30,-25,12,25,-42,-22,3,10,6,-46,-61,51,-60,8,-2,-20,-20,-5,-113,72,33,-3,8,-64,-31,31,8,36,-14,-68,31,17,14,28,-11,-36,-51,-10,37,-32,-55,6,99,-11,-27,-105,9,-10,52,34,46,-15,-65,-17,-12,68,-21,-33,0,30,86,43,62,17, 
  /* [818][0][][] */ 87,31,-20,48,123,93,74,-69,33,-13,-26,126,-40,6,-33,-48,-14,-22,-14,-87,19,88,38,66,-88,68,-19,-12,29,6,-36,42,-9,30,61,19,52,86,95,-34,97,-15,-29,20,8,13,-81,29,114,-117,-100,78,-32,33,-127,12,4,8,-119,74,12,-85,-45,-41,-112,-9,16,-27,12,11,11,-76,82,61,-7,90,2,-42,-21,113,75,-13,-19,76,40,16,-41,-28,7,-114,-1,94,-88,27,-55,-14,15,-40,-16,45,-71,67,5,-23,-16,-9,-54,-14,-15,68,4,15, 
  /* [819][0][][] */ 61,37,66,-47,55,-34,28,-62,48,25,43,-22,-42,-96,-33,-85,23,6,48,-94,1,97,-40,-52,16,88,43,22,36,-111,55,-12,21,60,28,14,-60,-27,50,-18,-7,-82,-45,-59,34,-50,6,9,66,43,54,-52,-38,-103,107,53,-127,88,57,-32,-112,54,-44,31,-24,-40,1,31,38,50,-12,34,-62,127,-33,56,22,-71,-13,-53,10,78,-69,11,-96,2,94,-31,39,-31,-42,-2,-29,-80,-66,3,4,54,56,40,10,-31,-54,-36,88,16,8,52,1,40,-14,7, 
  /* [820][0][][] */ -56,78,58,127,20,40,57,-9,-33,107,-20,-8,-19,28,51,49,40,-41,-23,-70,13,-1,-30,41,25,-50,28,-24,-16,-89,-33,8,-3,38,-74,-17,-1,20,1,65,46,-18,-112,-83,-125,-9,17,-73,-23,-30,24,32,-18,27,60,-10,-14,64,83,2,31,26,-8,-45,-23,29,20,-36,22,40,39,39,-52,-35,9,56,-5,53,-10,-25,-34,-71,29,47,32,-47,6,29,93,-40,-9,-51,101,-74,-95,32,72,44,22,45,-58,-13,26,-10,-74,21,-33,84,-36,-14,-13,18, 
  /* [821][0][][] */ -11,9,28,74,-8,-36,-5,57,51,112,21,127,96,5,-49,28,68,30,76,38,-19,-27,43,23,59,-43,-85,-14,-23,87,-84,34,28,-9,2,79,44,-56,-9,89,27,-22,43,-53,-24,-65,16,-26,31,55,6,20,65,0,-43,-57,-72,26,-28,50,-104,25,-38,49,55,-48,-54,1,-8,-81,-3,-10,-39,-69,3,1,19,-50,-67,33,83,-66,41,1,62,45,-49,0,-12,97,-1,74,13,-37,-3,44,-13,-21,17,-33,67,-49,-16,-11,7,-40,18,-19,-10,7,-61,38, 
  /* [822][0][][] */ -3,-120,-56,10,76,50,14,71,45,-21,127,-111,-18,8,7,7,-88,31,-35,43,-6,40,23,-50,-27,-54,-16,28,-45,-47,48,-47,-40,-3,-82,1,1,59,18,13,30,18,55,91,24,-57,-58,-43,75,42,26,24,70,74,7,1,-65,-45,18,-40,-50,-41,-41,12,57,76,62,18,65,2,-87,-30,-45,7,-79,-4,-25,23,100,67,-115,1,21,61,-35,32,-1,58,16,21,-25,83,72,-51,-41,-16,-54,-26,13,-71,-25,-58,-53,-14,71,-48,-51,-17,42,-12,5,-39, 
  /* [823][0][][] */ -75,-43,28,-23,-47,-102,-29,96,7,4,19,5,-44,-47,12,-14,115,-14,10,-4,32,-29,-28,-30,40,-45,31,47,25,29,-42,4,6,12,-72,37,35,5,62,46,13,24,-39,73,-28,107,33,50,-49,30,-3,77,-32,4,-18,-67,-54,-55,127,71,1,-63,-17,-94,24,57,28,-74,66,95,-97,-56,-7,-13,-34,47,-39,-72,-8,-41,-32,31,29,26,27,-17,-18,-39,-32,92,-19,-59,46,-68,-38,29,74,-37,-49,31,21,-113,-71,50,64,-26,-15,62,-54,36,-64,-24, 
  /* [824][0][][] */ -40,-114,55,14,-32,30,-49,2,-50,-38,8,-7,-1,-99,28,54,5,13,38,-28,-20,-3,-25,48,60,-28,-15,-23,5,42,-60,9,-10,29,-12,19,-5,-92,-51,-44,7,47,-31,7,-41,50,38,-30,8,14,-51,12,-68,3,18,25,-25,9,-29,-63,-31,32,-103,20,-15,-40,53,70,-9,41,-59,-28,42,5,23,-50,20,-40,11,27,28,74,5,42,-42,68,-110,-59,29,-14,-14,6,-127,-54,18,-31,32,92,30,15,-5,-13,-28,-97,61,9,-59,11,33,38,-45,-8, 
  /* [825][0][][] */ -39,-17,-33,64,-42,2,-30,-10,30,-39,-50,95,-34,-5,0,42,-42,8,-9,52,-19,89,-30,17,13,-18,73,29,-43,74,-10,-8,-52,-40,-56,-46,18,-38,-11,-12,-24,21,-39,73,92,-47,29,34,-21,8,-25,34,-22,127,-79,-58,-44,-23,-22,-4,55,47,-10,-21,-3,-36,-6,54,19,-1,-9,-13,-75,-8,2,-28,-92,79,-4,-15,-48,6,-18,49,-24,54,43,-22,-2,9,-13,-18,-36,81,-3,1,42,-87,-1,-40,-16,56,26,-113,-29,-24,1,15,-23,-16,-2,-91, 
  /* [826][0][][] */ 39,71,20,25,-59,21,-76,27,1,-9,71,3,51,25,-14,-19,-34,22,-31,-6,25,26,-11,-10,9,8,-41,22,10,-3,-52,6,24,4,88,-74,-2,34,10,73,33,-3,-6,-84,-51,-1,-42,-31,9,-13,49,12,-30,-30,-18,47,-127,1,26,1,-52,-31,-28,71,-68,3,48,-35,13,1,16,13,27,-123,38,-17,101,-40,21,-31,58,-18,-11,28,-51,50,-44,43,20,17,-45,51,-29,-62,26,19,-14,66,41,-24,-8,-36,3,21,-29,-3,-11,27,1,-43,-21,45, 
  /* [827][0][][] */ -23,-1,59,36,-95,-12,25,73,-53,76,-5,80,-94,-19,-11,-87,-25,-18,34,-40,-61,49,53,-63,-19,0,102,-58,40,-48,126,24,7,91,12,-40,127,58,71,61,45,24,-32,14,-64,-36,102,-84,91,3,-8,23,-35,25,33,26,-71,75,-93,33,-32,87,-21,-41,40,88,-70,-116,-98,-59,-26,5,-57,98,38,-21,-66,98,-3,-101,-88,127,86,16,106,27,-82,-89,9,-70,-37,-45,22,119,59,58,-17,50,101,9,97,80,-58,88,42,-9,9,59,-77,74,80,86, 
  /* [828][0][][] */ -24,-29,34,-9,-70,23,45,57,22,-29,-6,-94,-6,-94,-20,19,30,-19,-43,-8,-66,-36,-112,68,-15,45,9,-35,38,7,49,-53,-33,30,-7,34,38,5,19,-30,-50,35,20,-9,15,-53,38,-37,-115,24,1,25,-51,2,65,-42,-20,64,73,-28,88,127,34,24,-79,-88,29,76,2,-39,35,35,6,-2,119,-46,27,-74,-66,63,-3,7,-27,-6,17,25,-3,-55,-37,-62,31,-9,18,18,-83,6,-56,-22,0,22,36,65,29,-32,2,-3,26,-25,-90,-20,-26,24, 
  /* [829][0][][] */ -30,1,127,44,-33,23,-42,2,-42,2,4,-49,31,-31,-48,32,10,-6,19,52,-17,-9,-87,39,-3,-6,7,-5,-39,-30,-20,7,-34,-83,28,35,104,-24,24,42,82,-45,-21,46,-26,-30,-51,-37,-8,-13,-22,60,-16,21,27,55,-6,-13,-35,-13,33,-34,49,11,-46,-44,37,53,-48,9,-53,-27,37,-24,89,24,-43,27,-68,34,48,-65,86,-37,-37,16,56,-12,35,41,44,8,-37,-3,-5,-45,-1,4,58,-11,28,-11,11,-4,-7,-58,-43,-14,26,-47,-13,6, 
  /* [830][0][][] */ -44,67,-22,35,24,124,37,-50,39,31,26,-74,-42,-2,4,36,-46,0,16,-53,-5,-19,-11,48,-2,-8,6,21,-59,-4,-23,-20,41,127,-35,7,-16,10,92,22,22,-41,19,6,-31,-47,-26,-32,4,-21,11,-30,-42,24,66,-34,-41,-7,-15,-33,-18,-15,-5,-29,-14,-9,-22,33,23,-14,-25,-18,27,-65,69,-48,41,12,-11,-55,45,1,-18,16,-35,5,36,4,-2,1,26,53,-39,-2,-12,-6,-90,-3,-4,9,-21,75,94,17,-5,26,-25,12,-9,8,28,-21, 
  /* [831][0][][] */ -68,36,-21,33,-52,-5,-20,-7,-25,61,-4,-9,21,4,20,34,-28,36,-33,-19,44,42,41,45,-15,9,27,-3,-63,16,93,-25,-44,21,22,17,-36,-5,-11,31,10,49,43,-9,13,22,-43,-38,7,-4,1,-34,-10,22,25,-5,34,-29,15,-46,-19,2,54,15,70,127,47,-12,-58,-28,19,-45,29,-16,37,21,44,33,-7,-56,-76,3,-6,-9,60,34,68,54,-29,-32,12,-38,94,0,12,-18,44,16,-36,-71,-58,70,-48,-25,39,-19,-9,-7,8,28,17,26, 
  /* [832][0][][] */ -8,12,-66,60,-36,69,-35,-10,-17,11,-64,39,12,40,44,-12,-76,-1,85,23,12,-51,-18,-93,25,21,-1,21,-100,14,-31,-22,-10,60,10,9,74,-41,9,65,-48,-39,-15,-40,41,68,58,67,57,33,2,84,-66,26,-35,-11,85,-11,6,9,-110,-14,62,-22,106,77,-27,-53,34,-53,35,36,79,-73,9,-23,1,-42,58,-77,36,11,127,-9,64,32,1,-25,66,-31,-2,29,63,11,-18,-4,21,-41,16,-16,39,4,-4,19,-36,0,-9,-5,-31,-23,-4,-6, 
  /* [833][0][][] */ 16,1,3,28,0,16,-10,69,6,-14,49,-57,42,-10,26,44,39,-8,39,7,-16,45,-27,41,-11,12,-66,-3,-127,-25,11,-31,3,-12,36,5,-90,-42,11,-10,15,11,18,-66,-1,41,-30,61,-27,-71,39,-75,-26,-80,62,9,19,25,-20,22,90,-14,37,-22,-42,1,34,42,-13,-15,80,84,37,2,-55,45,-4,-3,-4,-50,-10,-75,-15,-1,63,-53,-29,74,-7,42,25,105,-71,-34,26,-8,-15,-87,-9,30,29,75,-10,-71,44,-5,30,42,18,-3,-32,-10, 
  /* [834][0][][] */ -51,78,-38,23,-36,-15,-3,72,9,40,-109,-68,-14,34,69,21,-16,46,1,18,-10,33,-19,-68,32,26,12,-54,15,10,89,45,-28,-20,-33,26,-5,7,19,39,-1,-73,1,-91,50,61,46,-25,47,-11,-35,-44,-109,30,17,16,70,-20,9,-9,-61,-43,35,-18,-76,2,-38,-11,-14,1,25,-38,82,37,-10,1,-3,16,-14,11,59,-127,-46,-91,73,-48,20,-31,7,114,10,-47,53,-24,78,31,58,6,38,-65,-18,-38,-6,52,-4,-24,13,26,13,21,-25,-43, 
  /* [835][0][][] */ 102,-31,-14,-1,-85,-25,-127,-52,-9,-8,-6,10,-12,63,31,-33,64,43,16,1,-4,24,14,48,19,-56,-76,4,4,-66,-98,-4,-22,108,-6,9,-63,-38,8,43,2,-22,51,70,59,34,31,-38,-54,-11,-63,59,32,25,-11,-51,-31,2,21,-16,46,46,-20,37,-7,-65,47,116,-58,5,54,-4,-50,1,70,-84,-52,26,63,-13,21,-67,44,16,-28,35,-7,-17,13,-73,-22,32,-6,41,2,-105,50,-39,-91,-53,-52,-8,88,5,68,-6,-23,13,-30,-4,-11,-26, 
  /* [836][0][][] */ -26,-20,16,-7,-34,-22,-21,33,50,-27,5,42,-65,14,-109,41,-28,-19,8,-67,-3,-4,35,-38,-37,-32,15,-29,38,36,-17,35,22,-1,-75,0,-49,19,-80,35,34,-99,38,52,-85,19,46,73,-9,-81,-31,51,-36,-64,-54,84,43,-6,41,-78,28,17,51,-7,47,37,-2,25,-79,5,-1,9,-19,30,127,41,24,-24,-15,-17,56,-37,-3,59,-50,102,-5,19,-23,-7,32,70,-11,48,-40,48,100,-15,-8,54,-59,-20,-5,-62,-47,-59,-39,5,59,-1,-104,2, 
  /* [837][0][][] */ -54,1,52,45,33,28,53,-33,-13,35,42,-30,10,-40,37,-64,24,-51,121,18,-99,-26,-52,44,-30,-34,-75,-67,13,19,64,11,-16,7,-24,-36,19,8,30,-51,40,42,13,17,11,40,13,-17,59,-36,55,-8,14,4,6,-24,-2,-32,26,15,15,-12,11,-93,1,-26,-22,127,79,47,54,81,-55,4,117,-33,-43,62,-7,24,-21,-32,-45,-52,57,-27,36,-37,10,3,-46,-97,-18,-53,-1,7,49,9,-55,36,6,-27,-39,-114,-70,-42,-1,-21,79,-36,-26,8, 
  /* [838][0][][] */ 19,5,-2,-105,-38,63,39,34,-25,25,-127,-30,87,-99,-101,-25,-118,52,14,41,3,7,-4,58,64,-103,47,-50,-19,-1,47,-35,-26,-50,-25,-114,18,15,40,-40,31,34,42,19,49,0,45,-16,11,-40,-40,41,56,38,-58,35,62,67,-8,72,26,13,-17,-113,-87,-13,-12,-39,32,4,-35,62,6,29,9,-55,-60,2,110,81,23,22,-48,28,-19,-13,-44,58,-50,5,36,12,-64,-30,-72,-9,37,-71,13,-43,-108,3,-34,-7,35,-4,8,43,-63,-59,-1,31, 
  /* [839][0][][] */ -44,20,14,-37,-61,-23,37,-44,54,16,10,110,-26,-28,0,75,34,-14,-14,85,-59,15,22,59,1,-62,49,34,-62,-77,74,-38,5,39,-14,-13,-39,-71,-88,27,33,27,-32,-28,38,41,-101,-42,-24,42,-43,-8,-64,-92,-6,11,-30,50,46,52,-16,62,-41,20,-75,-27,1,127,86,13,82,-1,91,28,46,43,-26,-96,48,9,0,-9,-11,-90,46,40,-6,26,8,77,57,92,-25,-47,96,9,-52,82,-90,22,97,19,-97,-18,42,-30,97,73,-25,2,1,-68, 
  /* [840][0][][] */ 16,21,23,25,75,-56,-74,-41,-45,25,-37,-28,-8,17,6,-46,78,79,3,19,-11,34,41,15,-23,-15,-27,-1,88,36,43,-3,9,-66,11,-34,35,-3,-6,100,32,25,43,38,-33,37,-8,42,34,21,-54,-70,25,8,21,90,-27,-33,67,-5,-10,112,-36,-40,14,48,-69,-45,-105,-86,-15,27,-56,11,13,-78,36,-40,16,-24,-89,-28,-69,8,-10,-108,84,0,53,37,127,66,45,-31,49,-74,-21,49,28,9,-95,-79,-35,-14,-78,77,-31,-20,10,-16,40,-7, 
  /* [841][0][][] */ -75,41,11,-25,8,-48,82,-30,41,-23,28,11,-25,31,15,-43,1,18,-17,-35,-26,-50,-36,47,24,10,-8,-72,-37,8,37,116,32,-34,-23,-127,-71,-25,-72,-10,-10,64,-38,-27,19,11,116,25,-37,-17,-48,-12,35,7,0,25,-29,52,33,14,-12,-1,-49,45,-80,-3,41,91,11,30,-11,-1,22,-19,16,-2,-37,-21,-104,45,-5,-53,-7,4,-97,63,-65,-36,-71,19,6,26,-50,28,-52,57,92,0,30,-50,-10,-48,-20,37,-12,-13,-77,5,18,-18,9,-88, 
  /* [842][0][][] */ 1,47,-8,-32,28,5,18,48,-53,49,-26,127,-42,35,112,55,41,95,-51,59,-57,35,-32,-43,-19,-65,-32,-11,30,-23,-68,64,45,-1,86,-34,-24,6,-27,14,-42,22,-32,40,-40,6,51,64,-4,-33,9,36,49,18,53,-58,51,15,83,-1,6,16,-21,36,-19,50,-5,-1,9,-56,31,46,30,-91,38,34,-68,68,21,-46,-96,28,36,33,64,29,-90,-40,22,17,47,-98,-45,-25,44,-20,-70,-15,-24,-35,-110,-62,-79,40,-42,-26,-59,26,24,73,-74,10, 
  /* [843][0][][] */ -9,26,4,14,14,-13,15,-23,-10,-44,-12,-11,-17,46,4,16,-7,2,-28,-2,12,0,-115,27,-20,0,-14,-8,2,6,-13,27,-96,5,37,-33,16,50,34,-58,18,0,-35,-7,0,17,29,-29,60,23,35,15,-31,-83,-29,21,-2,-31,4,20,-23,-3,41,-85,-52,35,-48,9,-12,-70,94,23,-20,-9,50,-48,-3,-64,-23,-4,19,55,-93,-6,47,-4,-43,34,-63,-36,31,-20,-24,1,50,-25,46,-124,16,-22,34,-36,-30,14,-15,12,-35,4,-56,75,-28,127, 
  /* [844][0][][] */ 5,-38,-26,-18,25,44,-5,-58,87,20,117,96,-36,16,59,61,-45,24,63,-17,20,2,24,11,-9,-2,-93,-127,27,108,-3,-18,-61,-62,76,37,-30,-16,54,60,2,2,21,4,28,-94,9,41,-49,42,5,-53,37,-36,62,16,-88,15,26,6,7,-34,-48,-1,64,-44,83,-83,-15,-81,58,41,17,5,55,26,108,-31,-87,-78,-24,6,-112,-104,37,60,-40,35,46,-27,55,81,-25,19,-73,104,-101,119,3,103,-14,-9,-49,-20,9,53,59,2,-23,-55,-37,26, 
  /* [845][0][][] */ 75,-46,-82,85,38,-42,28,-60,15,83,-18,86,49,-22,-3,-51,-32,96,-38,-20,-77,29,39,-124,-52,34,-38,72,-75,-66,2,-25,1,-91,-59,-87,-25,28,98,-47,28,-7,-118,49,73,-13,-4,-7,1,-37,31,5,29,40,37,34,-75,1,-81,53,-35,1,-19,-56,-25,-3,-51,3,-14,28,-64,-12,34,74,-56,56,-40,-29,64,18,2,30,-6,-83,-91,-24,-35,36,-56,-127,-94,108,-4,-125,22,-21,-67,-13,7,-29,-58,-11,16,-11,106,36,-12,70,95,-34,52,-19, 
  /* [846][0][][] */ -9,4,79,110,1,23,-29,21,-56,31,-26,-17,7,12,-127,-74,112,-27,-54,23,11,104,-48,13,15,1,-15,43,-33,-41,-14,-87,-80,-6,34,33,8,48,65,-94,-16,31,39,58,-86,-19,24,6,20,18,-34,16,99,4,6,-59,16,66,24,-23,71,106,-10,-12,18,86,-39,60,26,25,-114,-23,-93,15,-44,17,20,57,36,-50,-11,39,-27,23,-42,-109,34,-59,17,-34,26,-27,-11,6,-4,78,114,-10,-56,7,-56,43,108,10,19,-43,50,-49,47,4,-17,-18, 
  /* [847][0][][] */ 20,5,45,27,57,-49,36,-105,48,113,-6,58,18,-38,-7,104,18,-64,-31,80,-27,95,-49,-23,-12,19,-42,32,54,-24,-50,-73,5,32,41,-107,15,17,90,101,24,-55,14,-50,8,-13,5,-44,37,42,-32,-102,-2,-37,17,4,11,28,-19,33,-46,41,93,-78,-22,31,-58,73,-36,-50,8,-71,-73,83,66,-53,-17,14,-19,-27,-86,57,-1,-27,-9,9,-39,-106,18,76,41,-42,-5,29,72,-24,-42,39,-74,29,91,-74,-58,-63,127,37,-49,13,-32,-96,26,-89, 
  /* [848][0][][] */ -33,10,28,46,-28,-15,-8,101,-17,-69,-9,77,41,27,-74,-21,-14,-1,-89,-39,-3,56,-28,27,-28,-9,12,67,-29,32,-107,-34,85,-74,1,-71,-71,34,22,-47,-24,-31,72,-114,59,7,-14,53,39,20,-47,19,-4,-44,55,76,55,16,72,68,-75,-39,-82,24,56,-35,38,-127,-16,-46,-4,-91,21,10,5,-11,-59,-40,52,51,110,0,-6,25,-79,42,-16,41,-22,46,-67,-8,-50,-19,-105,24,-27,-59,-3,-8,-52,-4,51,-11,-26,-15,4,32,-15,10,87,-27, 
  /* [849][0][][] */ 43,-127,91,12,-3,54,65,13,4,17,34,-44,-27,-30,30,-86,-40,-14,58,-68,42,-85,34,40,-18,-68,-51,-5,-32,-52,-13,53,32,-91,-33,2,-20,24,-24,50,123,24,20,-25,-5,-10,-22,-50,-36,42,14,61,20,-41,35,48,11,21,-12,49,-19,32,-12,91,-65,-76,-30,16,16,-43,-31,-34,-63,-51,-28,69,34,-6,75,79,-61,-35,62,-22,85,10,-13,37,-89,-66,6,22,-20,26,9,68,45,-15,-39,-100,-12,-70,67,-5,104,-25,-13,39,52,-21,5,1, 
  /* [850][0][][] */ 16,-30,-14,-17,6,-7,34,81,-8,-74,-11,-28,21,54,-19,-48,9,-29,30,10,15,47,104,-24,9,10,-14,15,-77,45,12,-3,38,26,-35,33,-16,26,-22,34,19,-37,-59,61,30,-82,42,-93,22,-93,-34,-21,25,53,-22,-20,-26,-62,8,14,-83,12,40,-43,-37,31,-42,-30,-19,4,-49,-77,-25,39,41,-41,21,-6,3,9,7,71,-32,18,48,-11,-127,37,44,65,-4,64,-19,58,-50,39,10,-54,10,-50,-45,-25,36,1,54,-9,-52,-20,44,33,-15,84, 
  /* [851][0][][] */ -127,29,104,1,6,-43,2,-42,57,-37,-40,21,-1,-18,-6,49,-31,25,-108,14,-31,-20,-51,63,-3,11,-15,67,18,-73,24,4,-76,-41,32,48,2,40,-34,31,-82,-55,-109,27,-47,-64,75,-9,11,36,38,-52,-37,50,82,22,77,-9,66,-45,-13,-64,45,39,48,53,-21,-13,-25,-34,29,48,49,-9,-24,6,49,1,-12,1,33,-31,-19,16,79,35,-30,64,54,-74,-43,94,53,21,6,24,-67,-17,100,-37,29,-40,-40,27,-7,8,-105,71,19,45,73,5, 
  /* [852][0][][] */ 96,120,-31,-55,-60,-30,-3,111,-39,-7,-1,63,62,-12,76,-15,7,127,1,-28,8,-5,43,-5,-21,41,43,26,-69,33,7,48,-18,3,-10,-3,-16,19,80,61,-71,-20,-38,-44,12,48,-53,-25,19,33,50,-74,-47,-47,-26,-115,76,-81,-7,-27,-2,106,-68,23,36,81,105,-47,53,-6,13,-45,93,-70,-6,64,-111,65,-74,4,53,-8,-5,-40,-62,-12,-24,12,70,-46,-29,52,5,35,-39,41,81,-47,37,68,53,-25,-91,52,69,87,56,11,27,13,-64,82, 
  /* [853][0][][] */ 31,-74,52,21,-22,-18,59,-40,36,-12,-56,120,93,69,-14,13,25,-12,-23,-103,16,71,-22,4,66,-28,65,57,-51,24,115,-32,72,-6,19,-79,72,-17,-65,109,6,15,17,-36,-28,10,62,41,21,-60,-86,3,22,20,66,23,13,76,30,-13,-11,-72,23,-16,-74,0,45,32,39,-85,29,-17,55,-20,-45,-25,90,17,-26,-76,75,-20,1,99,-16,-22,-57,9,63,32,-46,-28,16,-93,-13,-16,65,-43,25,23,51,-1,-50,22,48,-46,-127,21,-53,28,-15,24, 
  /* [854][0][][] */ 86,-127,8,5,-110,-53,-20,-73,0,-5,-28,7,70,43,116,19,42,-21,-65,-5,-50,66,58,17,27,18,7,108,10,-10,-105,11,-5,32,-60,-2,-75,61,-40,-16,80,-6,-40,-18,-1,21,48,-76,-16,-12,-49,33,-66,0,-54,17,-22,51,-14,-14,-19,63,-4,52,-49,-45,7,-59,16,43,48,-49,-10,24,-54,22,17,-76,8,15,46,-11,96,12,-14,34,-4,103,-30,13,-44,-17,37,-32,34,43,73,-37,-33,91,11,-91,53,-35,12,-7,-4,28,-77,46,40,-31, 
  /* [855][0][][] */ 4,-42,-96,-5,-26,88,81,30,58,-7,27,16,-16,76,52,15,112,14,-37,-62,-50,57,-68,-56,58,101,-127,30,13,-57,70,-89,73,-25,-34,58,14,-1,73,74,-123,89,-4,-26,62,80,51,-119,34,52,-82,18,35,48,96,-63,-30,10,-53,7,-21,24,13,-27,54,-31,-9,-12,-83,5,-109,-4,19,-71,7,75,-76,0,19,11,-66,-42,62,-2,-7,-49,-6,-60,-8,-15,-18,-32,-10,-19,-54,-35,21,26,10,31,16,18,-39,-23,21,44,-45,-42,69,48,-47,43, 
  /* [856][0][][] */ -67,15,42,-50,-66,6,29,20,-37,16,-33,-55,64,48,-2,88,5,30,60,-23,-6,103,30,18,27,-37,-78,36,-39,-60,34,40,1,-96,-18,20,-52,-19,-56,-36,-9,-73,-28,127,15,43,33,-39,-11,-53,-10,-24,-40,6,-35,-43,37,45,3,-31,-33,-52,9,-20,35,36,93,-61,-97,27,61,-9,97,-52,74,26,-45,107,-4,11,-70,-36,-10,-22,2,-37,-82,18,77,-19,10,-30,-52,28,54,-24,-7,63,26,-47,1,70,-33,1,36,-23,-11,-8,41,6,-51,-16, 
  /* [857][0][][] */ 62,71,70,-51,-20,24,3,18,-39,-19,11,64,0,-36,43,-99,-13,52,4,-48,47,78,-23,-58,-71,-12,22,30,-57,17,45,-79,6,19,-42,-43,21,6,34,87,-44,-7,-18,37,18,71,-17,-22,73,6,-79,-44,23,34,10,42,10,19,-9,95,5,11,85,-3,-6,-4,1,-31,11,-40,54,42,68,42,-2,-23,42,-61,110,-68,-62,-8,56,1,-72,56,-12,-127,38,49,24,-35,-10,-48,-67,-63,-4,2,-46,-29,-18,-24,-5,29,-92,-79,-76,17,-3,32,-72,-67, 
  /* [858][0][][] */ 29,27,1,-77,-1,9,44,-52,47,55,-27,-69,12,-87,41,-12,-45,-53,4,-103,32,-32,-56,-16,14,9,32,-4,-29,-28,-13,18,-72,32,3,21,77,55,-75,31,7,-61,27,32,-2,27,-28,14,-8,14,-50,40,20,14,-54,-12,-6,-30,-36,-37,41,15,-45,23,30,0,-48,47,68,13,27,-89,9,-95,-4,8,-13,38,37,-127,33,26,-63,-37,-48,13,-34,-31,36,31,52,-54,21,-19,54,6,67,-46,18,35,3,-20,-3,22,66,-15,-86,15,-53,-46,-93,33, 
  /* [859][0][][] */ -55,11,-51,57,11,-43,3,-44,-36,-22,19,-16,9,51,8,-116,-8,-19,-31,-7,39,-14,-49,-42,-20,-33,-41,27,-48,88,-31,26,11,36,46,25,-8,-93,9,74,45,-38,-55,-39,0,-58,19,99,-15,-26,95,21,117,-60,3,-68,-93,5,47,-127,38,-38,-6,-22,-3,11,-12,53,-32,-25,-30,44,-28,15,-17,-33,-15,12,-40,76,-19,25,-23,50,33,33,52,60,8,2,70,-25,38,-8,9,18,-32,43,86,18,-59,82,-29,-33,-36,-58,-72,-48,21,-5,19,-27, 
  /* [860][0][][] */ 23,-7,-29,94,34,59,-5,-5,-36,38,36,-15,-17,0,-3,-39,28,-46,10,-58,-53,66,14,37,56,48,-53,8,-40,52,1,50,21,-35,32,-52,56,6,40,44,23,46,3,-52,23,-42,36,-5,46,-36,29,-69,-25,-11,33,-89,-127,-56,-19,-37,36,-66,9,90,-4,-85,-54,-47,52,13,27,-73,16,11,-46,-25,-43,32,67,25,30,-86,-40,16,-34,62,-15,6,1,-28,8,87,-15,0,-20,-100,-33,6,58,56,4,41,57,63,21,-36,11,-104,-68,30,-44,48, 
  /* [861][0][][] */ 49,8,-46,-1,-33,24,-13,55,-17,38,90,-50,-21,21,113,-17,-58,-4,-5,-7,102,22,-25,110,-68,-65,70,-40,-7,-9,74,10,-24,-29,-62,6,-39,-35,-91,17,32,3,52,95,15,-91,-102,15,40,1,-13,41,16,-10,18,-13,24,3,13,-53,-33,4,10,-41,30,-59,45,90,15,7,22,53,126,2,83,69,20,87,-14,-44,43,-29,-5,91,-5,21,65,-3,83,124,102,-99,-46,44,-48,28,24,34,-23,-22,38,22,-27,69,17,89,-40,16,-65,6,10,-127, 
  /* [862][0][][] */ -48,-44,3,31,60,-18,-18,39,14,-16,-7,-87,-19,-34,-11,15,127,-52,24,55,-43,-18,-18,-5,-1,87,-7,50,26,-15,-54,-49,-22,55,28,30,6,-32,33,32,12,13,9,15,-50,-55,-29,-16,58,-15,-14,36,-43,79,-23,22,66,-15,-41,-12,-69,73,-5,17,21,-18,27,-52,-4,-59,37,-58,-6,74,-96,58,4,-18,-60,1,30,74,-2,67,34,-35,-60,72,18,8,-54,20,34,-30,-52,99,10,-43,-79,58,77,-23,-64,-76,49,25,-38,-15,84,2,-32,41, 
  /* [863][0][][] */ 95,54,13,65,49,-19,-34,-59,0,2,1,3,31,9,29,-23,-34,3,28,44,34,48,78,93,17,-42,18,-64,52,-17,95,26,18,63,50,-60,-45,53,-43,-25,-25,27,-61,-4,-36,-50,20,61,15,-42,42,-98,40,-76,-23,-65,13,-20,31,-50,8,72,10,-10,-54,-100,74,-33,106,104,-18,69,-23,-84,-2,-72,-47,-34,-27,34,40,24,-92,32,-44,-38,-10,57,59,41,-16,16,-123,62,36,-30,-17,7,-40,-65,61,-63,-49,34,-27,-6,40,-58,-16,6,-127,-18, 
  /* [864][0][][] */ -31,82,56,35,-9,-54,-13,64,94,-88,11,15,18,16,-8,1,-35,98,23,-10,5,127,51,49,60,-35,1,-49,23,27,-23,52,-116,-64,86,-44,-22,53,8,-45,-43,29,-68,44,-44,85,83,-69,-11,69,-17,51,19,53,-43,125,14,-70,45,43,69,-36,-23,21,-43,-12,1,-15,-23,47,-33,10,74,-14,19,-34,64,-35,26,-58,40,-61,-28,36,-57,-71,5,-19,-36,51,-12,119,-49,-8,-19,-55,-21,68,17,7,-57,-29,-30,18,-31,103,-45,82,65,-31,-35,-28, 
  /* [865][0][][] */ -17,-33,-6,-31,26,8,5,-112,-74,-29,48,-31,-36,22,-56,-119,38,-32,-28,-48,-1,56,40,-106,-50,39,-7,13,70,-24,-73,-108,-42,-7,100,90,-49,73,39,26,31,-60,-2,-37,-51,52,63,-51,-31,-17,-13,-24,-60,-64,23,-10,-13,-52,-23,21,-30,13,49,-11,99,-39,-18,65,24,39,58,-85,-81,-61,21,7,30,26,33,-28,-26,-71,2,30,75,62,12,-16,56,-78,40,91,42,-1,-52,-99,-34,-57,-40,0,-75,75,127,-51,9,-88,5,-9,20,59,-27,2, 
  /* [866][0][][] */ -21,18,-6,-57,37,-18,6,-16,-26,19,13,-18,21,12,2,-21,-18,-6,-4,-41,0,25,-33,9,30,34,-10,8,-32,-16,50,18,-46,9,-23,-12,-46,23,-33,-66,6,-75,-64,-69,-7,-6,62,-11,-18,18,15,1,-70,19,-25,-29,64,-26,-10,10,34,-4,8,46,-16,14,-5,-12,-20,-72,-1,-1,-20,20,-39,22,-33,-40,56,19,-23,0,8,9,-17,8,23,-33,50,-12,-4,6,1,15,-64,3,-23,2,65,-61,23,26,19,127,31,-42,-9,35,-26,32,11,9, 
  /* [867][0][][] */ -8,-42,50,-31,48,-93,-31,111,78,-61,94,-50,67,-3,-23,-96,57,4,72,83,-64,33,25,80,-90,44,-52,12,-15,-90,-95,-25,18,5,52,11,11,-3,-74,18,-108,38,-106,-63,-55,43,105,-113,0,35,3,18,-21,-47,-106,62,109,-77,-21,-77,-36,-124,-79,-117,54,95,17,-36,25,50,41,-54,-16,34,25,32,-93,-43,30,68,8,1,127,25,-25,53,-119,3,-18,11,-4,-27,-99,-38,-39,-19,94,75,-1,-75,-15,8,56,-39,-32,-8,69,-44,6,66,-46,42, 
  /* [868][0][][] */ -4,31,41,-64,-37,42,-7,47,20,-24,-15,18,57,79,38,-60,-127,15,2,-31,-11,15,-12,57,9,-50,19,-56,-16,-37,95,35,-47,39,-19,76,69,3,43,95,40,21,-46,53,33,-21,12,45,-93,-32,-42,43,63,-49,18,69,-54,78,18,-19,-36,38,30,-54,9,-56,-2,79,14,34,-11,-68,11,16,3,-22,-35,-26,85,34,-45,-6,-37,-56,-43,32,-39,-8,-49,58,30,-11,46,55,-18,-107,-21,-59,-46,-59,-48,48,-8,-28,-40,-13,31,-48,52,20,-52,-53, 
  /* [869][0][][] */ -47,-51,28,-11,34,46,-27,-16,-37,-101,12,16,53,-6,-63,-7,2,57,-10,21,-93,84,37,27,-32,35,-33,-62,18,-53,127,33,-7,78,12,23,32,35,21,75,72,-49,27,-9,-61,57,28,-9,-14,49,2,-31,35,-20,-24,-45,-46,18,-26,-15,24,89,-25,-9,7,1,1,47,28,2,9,-46,90,64,66,-34,-50,14,-97,22,-9,-31,33,-114,-98,23,-17,-29,-68,19,-5,-9,-2,18,-27,39,41,20,27,62,29,43,-39,-27,47,82,-118,29,-10,39,-6,2, 
  /* [870][0][][] */ 21,3,-35,-52,22,-75,78,6,11,85,44,-33,0,68,-65,-19,-50,29,35,-45,-63,28,62,17,20,-17,-35,89,-7,-69,-34,-71,-22,-12,1,-67,-2,-20,-34,-38,79,9,63,-41,-53,45,36,86,-41,-14,69,-37,-61,127,-80,49,97,2,101,80,23,40,-31,43,-71,3,-58,10,69,-19,44,-89,-39,-30,-59,22,-54,-40,23,42,86,84,29,-40,17,-63,-52,70,17,-20,-56,-21,14,14,31,65,5,-118,52,18,-100,50,6,9,-76,44,-14,4,19,-89,32,-17, 
  /* [871][0][][] */ 27,-36,53,26,-44,33,-27,55,10,59,-36,-8,10,34,-28,87,47,34,-46,-15,56,100,-92,-6,-49,-24,-21,-4,-20,12,-53,36,29,-56,-31,50,14,28,-14,-40,-66,-4,9,-16,-3,-60,-17,65,-44,76,-109,99,58,-90,14,4,31,42,5,17,-67,62,-11,56,-4,-6,40,-5,17,43,-43,-55,-21,25,39,-16,-23,-50,22,78,8,-46,-41,52,24,44,64,44,26,35,-25,33,45,10,127,22,-42,68,-94,27,53,-20,19,7,25,102,13,-46,50,27,21,28, 
  /* [872][0][][] */ -20,110,17,-71,-78,62,-20,-11,54,35,52,-37,23,-40,13,76,-47,-41,-15,10,4,-17,-12,35,-53,-11,-24,52,-15,-22,31,-58,-33,39,17,16,-3,102,28,3,-2,-53,14,36,75,-38,4,-35,63,-46,-21,-85,26,25,-41,29,11,11,39,3,28,57,0,2,-98,-11,-31,11,66,-22,-2,-12,51,-33,0,-1,26,-109,-10,-22,-3,127,19,-12,17,26,48,18,11,42,36,-16,30,8,40,14,54,3,-98,40,-8,30,-15,4,10,41,-3,-22,-21,29,-39,34, 
  /* [873][0][][] */ 2,51,100,50,-114,77,-18,16,-70,72,85,-71,-20,-44,68,-40,39,-6,-12,-26,90,-49,20,-39,26,24,-47,20,-80,-39,4,54,-62,-19,-7,114,35,106,-7,-98,20,-45,-6,31,127,-105,89,42,-37,39,-6,24,62,19,27,106,2,15,24,50,25,-51,74,-22,-31,69,3,10,-27,10,-49,104,29,67,33,122,-35,44,93,-5,26,-100,-72,90,38,69,-24,6,65,24,44,47,-6,9,-52,3,24,-81,-21,-16,19,0,-59,53,-13,-98,-70,-41,71,42,-8,1, 
  /* [874][0][][] */ 47,5,24,-4,12,10,14,1,32,-19,9,-18,3,24,-16,-22,-35,34,17,-40,-18,-11,21,-34,-12,43,-43,-10,-13,-18,56,19,-19,-16,-10,-2,-21,3,9,-17,-52,5,-56,48,-59,12,-19,-33,-73,-5,16,-34,27,30,63,-45,-39,-20,26,-1,91,56,-21,-22,-36,45,34,30,5,31,7,-25,8,2,34,-21,22,127,-33,-25,-13,8,3,-8,49,7,-20,8,23,-63,11,6,8,7,62,39,29,-40,-13,3,-14,-45,-39,-22,-3,-27,-15,30,-1,6,36,-40, 
  /* [875][0][][] */ -20,29,-51,-26,-34,37,127,-21,-43,22,65,14,3,35,-62,61,-20,31,35,37,-5,44,-7,-18,6,30,47,-61,-14,-13,1,26,-13,-40,-62,45,-31,38,-1,72,-90,-8,-10,-70,-69,68,-10,15,35,-40,16,-49,78,-18,109,-51,-9,51,-8,-11,50,-121,40,-27,-18,63,25,26,50,64,91,15,-25,-23,25,-66,-39,-4,19,-16,32,3,27,-35,48,-40,11,-29,-28,-26,45,-16,1,-46,-51,21,-25,-56,73,-126,-8,31,72,-23,71,-52,-24,68,53,-31,38,25, 
  /* [876][0][][] */ -69,-67,-119,25,67,41,-12,-31,-28,93,33,-34,-23,35,103,36,74,-56,-51,-45,8,20,3,-81,-108,-80,-57,-76,13,-25,-111,-38,-8,48,70,65,-6,40,55,103,34,35,-54,-15,35,-20,41,85,-15,44,93,127,-49,-79,-39,-36,-68,92,-22,-11,62,-72,85,-27,-50,-43,-53,-38,14,18,54,-35,72,72,-67,63,73,21,84,-18,11,7,17,3,15,68,43,30,-8,103,-27,-11,19,-44,-6,-65,59,-46,-51,-2,-51,-32,42,-66,45,-122,-10,-4,28,13,22,-2, 
  /* [877][0][][] */ 43,82,-25,45,-6,40,-3,-51,-34,61,34,-42,-8,-73,9,-44,45,-43,-28,21,-12,-2,13,-22,10,-17,-51,26,31,1,-31,67,-18,-19,30,2,-25,98,-73,-86,-18,-2,-14,-79,-31,8,-5,-31,-30,53,30,-28,61,-42,-107,-11,48,28,31,-12,-127,53,75,124,127,8,-69,38,-45,-43,53,15,-31,17,-35,-41,-36,10,68,-53,14,110,-83,-60,-62,-27,-58,-48,-33,-38,-53,57,-31,-83,5,-66,23,-56,-41,62,40,-6,99,-43,3,1,42,48,8,13,29,52, 
  /* [878][0][][] */ 43,30,20,-11,-127,9,52,15,32,-27,30,13,18,45,24,-53,24,70,-31,-3,21,80,-12,19,-35,-26,-9,15,-7,18,-27,25,-36,59,30,-54,86,30,-33,-20,24,7,-20,-11,-31,66,69,49,53,12,14,-18,21,-7,29,-51,-9,42,4,-34,21,40,27,28,-28,17,-13,-58,-4,16,-7,30,8,52,-77,-39,1,3,-69,-5,39,76,-60,-41,29,46,-91,64,10,-55,-13,5,-11,-48,-4,47,68,-12,6,23,13,-38,-20,-37,43,30,-52,79,-11,41,9,-19, 
  /* [879][0][][] */ -36,53,-51,-16,46,-1,63,54,92,-30,60,-18,-5,114,76,87,-21,-92,32,61,-8,-8,-10,-84,10,-3,-35,-66,-19,-32,-54,81,60,35,18,-35,-25,26,11,-32,-98,77,13,53,-11,-27,27,-10,24,20,43,-32,127,26,19,47,119,-19,-39,23,56,-58,41,-81,94,9,-50,-61,65,115,42,-6,-19,49,64,40,41,36,-32,-30,-22,-64,-25,34,-14,-99,-64,121,-95,-51,11,-16,-105,7,90,-27,-24,-70,-35,-26,110,23,-9,99,19,21,36,3,-22,78,24,-41, 
  /* [880][0][][] */ 76,25,-52,-30,-76,-65,-27,-24,-41,-36,-20,37,34,-43,17,16,-26,27,35,-37,81,-63,59,-40,38,-1,-18,-18,19,-69,-89,-21,-31,65,17,33,27,-56,-17,-48,22,-67,29,-61,1,75,-14,38,-52,68,-13,22,-127,-59,50,35,49,-83,72,-27,-10,-121,51,29,11,-40,103,-41,-45,48,86,-9,-16,-43,110,11,-7,-61,99,-33,-57,11,40,-47,-44,91,17,74,-45,3,16,38,-63,28,-2,52,-23,119,-72,0,-15,-74,-33,-80,74,-9,99,-11,21,49,-27,-11, 
  /* [881][0][][] */ -29,9,58,-95,-24,109,-16,-77,47,32,-14,-17,14,39,-22,25,50,3,-93,-18,17,48,-22,47,-52,-19,-18,-13,41,-26,58,20,-23,-25,92,15,26,3,11,-15,-1,8,-29,-58,127,3,-4,18,-14,81,98,8,-41,64,4,-73,-58,-14,62,-25,44,6,-11,-20,46,113,60,20,17,-10,-31,44,18,53,-7,10,-32,26,-38,16,31,-28,-13,-6,-15,-43,-2,7,18,-9,51,36,51,27,48,-47,-78,-6,3,-47,45,24,40,111,12,-49,12,-30,-32,-44,-43,24, 
  /* [882][0][][] */ -55,-80,25,4,-31,0,-26,24,-17,59,-38,-74,-42,22,-3,-8,13,43,-17,20,-37,6,-79,-54,17,-52,-26,-41,-127,59,33,69,-105,56,63,-10,93,-50,-91,5,-64,35,-32,59,28,-8,-22,17,3,-4,16,-32,-29,-26,87,-78,-21,-21,4,80,-64,65,-43,-4,-48,39,53,76,66,-9,-16,42,32,37,-6,7,-47,-4,15,36,-7,19,-7,-46,69,-46,-116,52,18,-36,17,22,-51,58,-5,103,-33,-30,14,22,0,17,-77,-27,108,17,-73,0,-82,-74,-36,-20, 
  /* [883][0][][] */ 70,-2,-19,-17,15,-104,93,-45,31,-16,-63,-105,38,-6,-11,-43,1,-105,-57,-54,-30,45,-24,-102,99,68,-1,-36,-17,14,-58,-117,53,-64,-14,-26,-15,22,11,37,-73,66,48,60,15,123,-12,87,-101,-69,-13,-40,-7,17,-23,-23,-89,36,-3,126,31,54,-2,-22,-106,-41,77,50,-11,-81,-38,-46,-24,-56,41,-15,-72,49,-10,16,30,34,77,5,-1,80,-34,39,-55,11,67,32,4,46,32,43,48,14,-53,86,21,14,-13,-92,-105,-26,13,26,-71,-127,-12,32, 
  /* [884][0][][] */ 7,-6,-3,3,-38,-13,0,-11,-52,25,-46,17,16,-42,-10,-24,76,-16,27,22,-81,37,14,27,38,-4,-28,-68,-15,1,10,106,46,-28,50,-25,11,-39,-28,-57,-5,12,64,127,21,-45,35,-33,-86,-16,29,-57,-54,-16,19,75,8,-38,-26,-12,53,0,-72,-12,-21,9,-42,-21,-33,31,-33,31,-30,61,-48,-21,-68,-5,-16,29,3,-62,-34,2,18,-18,22,-53,-76,-2,-14,4,-39,-94,36,-24,-47,47,-8,-35,37,11,33,-31,43,-34,-3,4,-5,-35,-79,-28, 
  /* [885][0][][] */ -66,67,49,-20,-78,-62,-84,40,-62,-24,-83,-78,14,-40,-83,18,21,120,-42,52,-114,44,17,-46,20,-35,34,46,-52,39,40,63,42,26,-22,39,-8,-41,-21,99,-53,-35,-81,-39,14,-55,-21,17,-52,49,9,10,-34,-49,4,17,-52,-23,-32,9,-44,-21,-94,-52,72,-28,-63,66,-37,3,20,33,1,17,-6,-19,-25,104,57,7,-5,-79,-24,-4,-22,-27,34,-24,34,5,0,-13,25,-25,75,62,-107,52,88,-59,41,30,16,-10,35,-19,-10,-127,22,36,-20,33, 
  /* [886][0][][] */ 13,-19,-23,-9,61,-56,27,-2,-50,24,-49,35,24,-5,35,-98,47,-50,0,-61,-43,44,-49,55,-88,-1,39,-30,-24,-38,18,-9,21,30,0,4,-75,32,-65,50,85,-21,27,83,-26,-17,20,-14,-17,-87,3,-34,42,-66,34,-64,8,47,15,-41,-7,60,64,-51,-43,120,-2,78,76,-104,5,54,-54,-31,5,73,-19,-101,11,-59,4,2,19,-14,-2,-48,0,-21,32,6,-107,-74,-44,-71,-5,-108,-2,-20,24,-40,-10,-40,-41,44,-127,37,19,69,-17,-4,-44,22, 
  /* [887][0][][] */ -31,50,70,78,73,-72,12,-62,7,66,5,35,-32,30,114,-34,5,68,-1,73,31,13,-39,-52,-48,127,3,6,-6,-66,17,-56,-7,-11,-11,-65,-9,52,17,4,1,22,27,84,55,33,-21,-44,-79,3,23,-22,37,63,-35,-24,20,4,-28,62,63,-49,71,52,23,9,-8,-1,17,-2,79,35,-82,-69,-32,-32,-41,38,-11,16,22,31,41,-36,58,3,-54,-119,26,44,-25,37,10,22,102,-90,-19,-2,56,52,-72,-59,101,20,20,41,3,22,10,31,-16,35, 
  /* [888][0][][] */ -18,15,-103,-27,-60,2,85,77,-87,-14,12,14,-42,-2,24,33,35,35,-58,-42,18,-27,15,-99,-58,-61,-2,21,-10,68,-61,-68,5,-49,-63,20,48,-60,56,97,35,5,35,-41,12,-21,-8,-64,55,-20,-6,-20,-32,28,11,-48,53,-36,48,27,1,-8,-11,-20,-66,-37,44,-64,-1,11,-26,-30,-10,-43,-8,-23,-2,-127,-18,-27,47,-63,-46,4,17,2,102,39,6,-46,101,-47,-11,23,-10,101,-14,-125,-76,-32,10,21,43,-34,-45,-89,-66,48,-37,14,7,123, 
  /* [889][0][][] */ 79,78,61,-10,-42,-50,-57,15,4,-1,35,9,-25,-39,18,-3,-83,-53,-22,2,21,27,49,-2,-2,-14,-52,-71,-54,-78,-42,4,-20,37,17,-30,45,59,-38,-1,-76,-10,-40,-70,-45,127,-127,-9,-58,11,25,37,12,-100,-11,-12,60,-27,106,-15,-71,-15,-45,-53,29,22,70,85,-41,-21,-49,22,0,-10,28,17,-30,71,34,52,-22,2,-32,75,16,-26,55,-4,-64,46,-52,-13,-34,35,-21,-32,17,79,-54,98,20,-64,-18,-37,38,53,16,49,91,21,99,63, 
  /* [890][0][][] */ 4,6,-50,61,39,41,-56,-113,-25,-77,63,-45,-33,1,18,-79,-2,-3,99,0,-72,0,-75,33,-56,22,-72,-42,21,-52,84,-13,-14,-11,50,87,127,-60,80,87,-51,-6,105,-21,37,57,57,-35,63,-14,3,67,63,43,-21,29,-77,25,-79,-94,38,35,0,41,51,65,15,-36,15,17,15,53,39,-23,18,-4,12,-70,-87,-95,-48,24,-4,4,-60,3,14,-17,10,72,-34,10,60,38,-25,-87,-59,24,46,54,-26,55,-40,-2,-38,-103,-57,-48,-109,-20,27,44, 
  /* [891][0][][] */ -54,-87,77,-56,-79,77,45,-49,22,66,-45,75,-3,-30,20,-35,-15,-59,-97,79,96,-18,1,78,0,59,-26,9,5,-35,-125,46,-56,-82,-9,-89,-77,31,1,127,118,-7,60,49,-47,42,-21,115,-100,19,-33,24,3,-60,112,34,65,-54,57,-62,-38,9,-42,-17,-74,7,95,27,-68,62,41,-83,-49,22,-11,-89,59,-3,56,20,-48,2,-23,30,54,45,-24,49,26,-110,70,-29,87,-43,-28,-78,40,-112,-25,9,-97,-83,-120,51,-19,-26,-5,-24,-73,37,-94,63, 
  /* [892][0][][] */ 48,104,-2,-77,10,-5,38,23,2,-36,-49,-94,-33,62,-20,-64,19,52,40,53,-73,21,-26,-36,81,33,-60,-7,9,65,40,45,-10,-20,4,-11,-42,36,-54,29,89,33,35,30,-51,-22,-27,24,1,-29,27,-45,8,-68,47,4,-27,56,-56,0,-40,-13,4,-3,73,-68,-36,91,19,63,9,16,-55,-59,-16,25,30,9,-38,33,56,-3,-113,39,20,23,9,10,-64,-9,-80,-5,-65,-67,-38,127,51,39,8,-24,-56,-47,9,-9,-93,26,23,80,-5,11,-31,72, 
  /* [893][0][][] */ 21,-21,21,46,35,14,18,24,16,1,84,-37,-1,-20,12,-16,-2,-19,16,-27,36,-66,-28,16,14,-11,-31,-31,-17,-6,6,21,-14,20,32,4,11,16,-22,26,24,7,26,127,-46,30,-45,32,-11,6,2,-5,-4,50,-49,-34,15,41,-29,-86,74,-32,-14,3,38,7,44,33,-17,-10,-48,35,2,18,0,-49,-17,-8,35,-6,-30,-62,90,-33,-18,12,43,67,19,69,29,-25,-6,-52,10,31,-4,-20,40,-19,-4,4,-8,-13,9,-72,36,-34,-50,-27,11,-99, 
  /* [894][0][][] */ 26,28,-63,15,15,-106,-11,-41,53,52,-41,-31,-20,-21,-49,-39,127,76,44,105,-29,25,21,75,55,-58,-14,-16,-6,105,-43,-59,0,-52,26,-74,-27,65,37,-31,49,-29,-60,-60,-10,50,-5,-29,30,-44,35,-24,27,15,-75,-4,27,-18,28,114,74,-56,52,-2,69,-37,7,43,-97,-21,99,41,8,11,75,-46,-56,-30,103,-24,-5,-60,-28,-20,88,-61,-4,-24,16,35,44,45,-97,40,-58,4,-33,-4,-52,-32,-56,-18,-125,6,35,-51,-7,30,-3,-109,-11,-28, 
  /* [895][0][][] */ 27,12,-8,80,-74,-60,36,-7,-126,9,-9,60,81,-49,24,-94,47,-3,22,12,-10,-31,48,-1,4,42,-28,44,-29,-68,13,-49,-24,1,-54,46,125,-21,79,-8,-10,64,-36,9,25,-25,45,-10,2,-57,-24,-27,85,-66,-93,25,41,-14,127,-29,20,12,-36,37,-56,31,-69,58,-123,-51,31,31,-25,68,23,-18,12,30,-5,-50,-45,-12,-35,-22,66,-59,-65,-42,60,-56,-49,87,-42,41,27,12,-32,17,-47,-34,-8,-26,-36,5,-57,-31,14,102,36,-15,-6,-13, 
  /* [896][0][][] */ -36,5,101,72,29,52,-2,40,15,49,-33,-82,-51,28,-50,-56,-24,-127,-115,-29,-41,-27,-42,-24,-63,-23,47,27,-30,-13,-62,-36,17,4,-4,-7,38,20,-48,18,-107,7,-11,-43,-18,0,-48,77,33,-5,-15,-4,-60,-17,-10,-94,-3,102,35,17,38,-40,108,82,-19,73,59,-4,29,-18,34,79,-51,31,-44,-1,-89,-51,34,18,49,12,17,-12,-16,63,-2,-26,5,-35,7,57,21,15,22,45,-14,-20,-45,17,78,44,-51,-1,38,70,39,77,-14,-91,62,55, 
  /* [897][0][][] */ -52,-18,14,-14,-55,103,8,-19,-7,-33,7,15,-38,19,-11,-30,38,24,-16,-57,-10,4,19,-55,110,34,10,-24,92,36,37,107,113,27,21,-14,14,-9,-2,106,-6,-2,52,-53,-20,-7,114,6,-8,-99,8,-27,126,7,19,22,16,-37,38,-22,6,-19,-24,-38,100,21,127,-72,-67,-76,19,-17,-13,28,-3,-5,42,42,-1,-94,4,14,58,43,66,116,-38,45,67,22,24,23,7,-46,-9,24,-25,47,-17,-29,-42,-4,24,-60,-49,-12,8,-15,-51,-57,-26,10, 
  /* [898][0][][] */ -86,16,-55,-40,40,12,43,61,-47,-127,-22,17,-26,2,-37,-6,26,-99,22,-44,-45,19,5,-60,-5,-3,-38,-52,26,72,20,-37,83,-16,23,2,-53,-7,-42,-95,-10,-39,-3,-30,41,81,-88,43,12,-25,-14,39,28,-97,17,92,21,-80,17,-44,-30,-37,5,-62,-22,27,-28,5,-68,-10,-38,22,-36,-7,15,-1,-29,30,-17,0,-7,-12,-82,34,-29,-104,-16,-36,-15,-45,59,-13,-5,38,-57,-50,-54,91,37,26,-25,-48,-24,0,-77,-4,-57,-97,9,-44,3,-16, 
  /* [899][0][][] */ -46,-36,33,-9,19,35,22,-35,9,44,90,41,-15,-19,12,51,-9,-2,-62,-58,40,8,-67,21,-29,56,-6,9,-16,-26,22,-28,39,10,-43,33,-42,-5,52,-3,-85,-5,21,6,18,-42,-33,54,-24,53,-52,14,127,-2,3,5,-19,4,39,2,-43,-20,43,-3,70,-25,61,-3,57,56,-17,-35,-21,26,11,4,-45,-18,-25,-20,-56,48,-70,52,-15,-15,-13,0,-55,21,24,6,26,6,-13,-26,-25,-35,-25,23,37,41,17,40,35,39,12,6,-29,-41,-7,11, 
  /* [900][0][][] */ 13,15,-41,10,-2,19,-30,-29,5,-20,49,63,24,-12,-9,12,49,28,127,-57,-20,30,26,-17,-9,52,10,14,-37,-9,12,-10,-9,-31,51,-17,-32,28,48,-44,-58,-25,2,38,77,27,92,-57,46,-14,-52,23,-74,57,-46,-80,29,-29,18,-72,-57,9,35,-31,-18,46,-40,3,7,-42,-32,-27,-41,-10,-57,2,1,-2,32,-81,46,76,-32,47,-27,20,61,-33,47,5,92,4,55,62,17,1,25,-5,-18,7,19,-12,28,10,-57,-18,-9,30,33,-65,-5,21, 
  /* [901][0][][] */ 97,11,71,-80,-5,-93,24,-12,16,89,-15,66,-8,65,-70,82,26,16,-33,41,-113,63,-15,-4,60,3,49,105,105,-2,-29,-50,5,31,-12,-35,41,-38,-52,21,-39,-45,-17,54,20,-31,47,-16,4,75,-1,66,40,-26,-67,29,127,33,-2,20,13,38,-24,119,-53,-80,23,-76,-8,120,3,74,17,19,-56,71,-10,-102,0,-33,-29,34,41,30,-49,-103,-23,36,-37,12,-85,-70,54,-82,-22,8,-42,-91,-31,-117,-15,-55,115,19,37,15,49,42,44,-61,32,-10, 
  /* [902][0][][] */ 26,-20,28,-40,79,21,-90,-41,-41,10,-1,74,57,-95,112,49,92,-57,33,69,-20,-52,4,-23,24,-11,-12,-42,-10,59,-48,7,12,79,47,5,-6,26,-13,61,9,62,41,-38,1,-18,72,31,54,-72,-29,52,11,-109,19,-97,55,22,0,21,28,-67,-2,-29,17,1,6,30,61,-24,95,72,-35,-127,-22,-38,32,-16,-27,-57,17,66,-18,-6,96,23,-68,-55,23,-55,-15,24,-23,-30,-30,-21,74,28,-15,-7,-9,43,6,9,34,-16,-20,-33,-75,25,-81,13, 
  /* [903][0][][] */ -45,-38,-16,26,-40,-6,-27,-53,38,13,40,51,65,10,91,-47,13,7,-78,-12,74,-52,-4,-63,-20,-33,-58,23,54,4,-127,42,83,78,45,54,28,-47,27,-65,37,18,-28,-10,-6,7,41,-34,16,48,-22,68,33,-59,-24,-91,9,25,-17,-55,-92,-3,-55,-19,-14,-124,-44,52,33,-68,8,-36,0,13,41,-80,-4,-49,12,36,-20,-32,-31,-15,-81,-32,-31,47,-23,-8,-46,102,-43,-6,-69,-4,21,42,-1,20,23,-16,63,47,-44,-26,39,35,48,98,-21,-17, 
  /* [904][0][][] */ -7,-79,-78,17,60,16,17,-40,-90,91,-43,-5,57,-78,99,-3,-7,-21,-35,-63,22,-37,-30,-68,72,-7,11,-8,53,-53,-121,24,-32,-32,20,18,-66,50,-30,-31,-4,43,-15,46,-127,-16,25,18,-33,65,0,-3,-40,-56,-68,54,7,1,-5,-25,-71,-1,65,76,-21,-16,108,44,-36,-30,-89,24,7,-18,-81,2,58,-84,-36,54,113,-46,41,1,-99,-2,42,58,37,-115,-1,-21,51,-43,-110,-30,-79,59,-94,65,93,4,80,127,5,62,-2,104,-102,21,24,-5, 
  /* [905][0][][] */ -13,-27,12,-93,-1,10,36,15,31,-12,49,-46,12,-7,-28,-46,-5,-10,-7,-57,-3,20,-33,19,56,-3,55,46,-21,-39,10,26,-22,-23,-28,24,-26,-16,-1,14,-31,7,-14,12,16,-27,127,-57,-15,41,-68,105,-36,-16,-10,-14,-31,49,63,-120,11,-8,-40,-37,-36,-81,36,54,-24,24,46,-70,1,-43,23,36,-5,-32,55,-28,-21,-21,102,-44,-52,17,97,58,54,-26,-35,19,-5,-12,79,44,-22,-44,18,10,13,25,40,98,-19,8,-4,15,9,-5,-1,-18, 
  /* [906][0][][] */ -69,51,62,-8,33,-8,-57,-14,-20,-12,-34,-8,-65,-17,-53,-9,12,8,-11,-30,-37,-6,1,-20,-44,-55,22,-23,64,28,10,29,34,-59,-30,-70,-73,12,6,64,-56,15,-64,9,-55,17,6,-19,-19,0,8,-12,35,-3,-77,-79,50,-14,-5,19,13,-62,50,8,5,-25,8,-49,11,7,49,37,-2,1,-66,1,38,11,-5,13,-22,12,18,14,-5,2,21,-34,20,64,-45,37,-7,-78,14,80,-16,127,-17,-5,59,32,19,-52,20,9,44,5,27,30,9,-27, 
  /* [907][0][][] */ -22,-56,-22,72,29,-62,-18,-2,-10,13,18,-4,18,-30,-99,69,37,-42,-9,-5,-47,37,7,30,23,-55,-3,-79,29,8,-54,-20,40,-27,-60,-23,-10,61,-56,90,5,-3,39,-30,-68,70,18,24,62,6,-47,19,31,-51,-127,45,-9,-57,29,25,-37,55,-19,-64,-20,-108,-47,21,-1,-5,-69,-3,-9,33,-72,14,-30,-52,-33,9,65,-37,-14,27,-17,22,37,66,67,11,-30,-51,-49,-25,9,-46,28,71,-36,-5,-27,44,19,56,37,-91,-8,-21,-47,-6,-17,-48, 
  /* [908][0][][] */ -59,-5,-25,-53,-33,-25,127,59,-49,39,21,10,-45,36,16,39,3,12,2,19,-15,-13,-26,-50,69,41,13,-63,59,-35,-28,-9,11,-69,32,13,-35,-19,-12,16,-62,-81,-25,-11,-1,36,18,-14,-88,-43,6,9,102,59,45,-2,-11,25,-26,92,14,93,-30,-29,29,-3,-8,-25,-19,-43,-52,-20,-15,73,-46,-12,46,119,68,-21,-20,-34,-56,-19,8,-17,23,4,-9,27,-40,-12,30,-37,-47,-9,-46,-24,-27,16,46,-37,-50,17,90,-42,3,27,-35,-74,-60,-45, 
  /* [909][0][][] */ -7,11,-26,-60,-45,-33,63,26,-40,-28,12,9,-6,-19,-60,36,127,20,16,-33,-43,96,-62,4,21,36,-22,21,-15,45,-29,-13,-42,42,70,-81,-51,90,19,-56,-28,-27,-1,-34,37,-9,60,57,49,38,19,7,-35,16,70,-14,3,24,-40,27,-47,33,-26,39,51,-23,-78,-35,-8,-34,28,15,43,6,-18,0,-111,-42,-40,-1,-15,-66,-4,-47,77,-10,-7,-40,33,-27,-11,-29,13,-20,16,-46,-64,42,4,-7,-37,0,-5,24,-13,11,-77,4,3,29,-46,-51, 
  /* [910][0][][] */ 9,43,-25,-11,-19,32,-16,2,-52,8,13,7,-13,-49,-13,5,127,-1,34,-33,15,-8,-16,-23,-21,0,18,56,69,-1,-30,-12,-41,17,0,5,68,16,18,18,-47,-11,-25,13,62,-23,51,8,-20,15,-55,13,-52,-4,0,11,51,-55,-36,-4,8,1,34,-13,-17,-37,11,-22,14,-37,27,20,44,21,12,35,20,-20,15,-41,39,-21,7,-58,-20,-2,-51,-33,4,-16,37,-43,10,13,0,22,44,4,2,-22,11,32,-15,32,-18,20,-13,-16,-21,7,63,25, 
  /* [911][0][][] */ 70,12,-34,-42,-32,27,3,65,50,-66,-78,74,0,-26,20,-13,12,5,12,-38,1,3,-34,-10,80,19,0,3,-79,1,125,127,37,-14,59,64,30,-82,-8,-46,-82,13,56,30,29,-52,12,33,8,-12,105,62,-44,23,43,8,17,110,-39,102,27,-25,-41,-87,46,49,82,72,-34,53,-40,-44,22,10,10,-6,10,39,-59,83,-7,50,0,-74,-49,-15,-25,-72,-49,37,81,-50,-9,2,-80,67,-31,51,27,12,-40,-33,-57,-38,36,-74,-18,83,9,34,-59,30, 
  /* [912][0][][] */ -15,-27,-97,-36,-29,14,-1,30,-9,-10,25,38,-4,38,54,87,27,-39,56,-59,19,34,22,4,-12,-7,-69,16,-52,-38,59,20,-18,45,-24,-81,40,26,-98,-24,79,-43,-37,16,-24,19,-2,11,-62,-18,-95,49,-20,38,24,8,-18,-31,-107,2,-22,-36,-13,-38,42,36,-1,-72,21,57,21,11,25,3,127,-86,-68,39,-30,-13,21,29,60,-15,21,-73,-45,-7,-38,21,-28,39,35,-73,-24,-63,-120,2,74,40,16,2,-14,0,-27,60,21,55,56,116,-123,-65, 
  /* [913][0][][] */ 13,64,29,10,94,-52,-2,-45,31,46,-46,69,20,6,95,78,52,31,-37,47,40,-24,-67,-22,25,-1,13,50,-55,-13,36,93,74,-41,49,-53,-49,-24,-12,-78,65,-25,-89,7,-95,51,-32,56,50,-66,13,-5,18,42,0,98,-49,-12,-25,-85,35,-37,-71,23,-50,23,-16,-37,-17,-29,-39,-35,-34,-18,-35,43,-23,-21,91,17,71,107,52,104,-35,40,-74,-61,81,24,-14,127,-25,-81,39,-33,14,24,-27,-12,58,-22,-3,32,-32,27,57,-87,-50,-43,-39,-34, 
  /* [914][0][][] */ 33,51,26,53,-39,-97,-7,-33,57,99,-102,-19,-78,8,5,-100,-6,6,-13,2,-85,-49,-84,104,-24,9,46,-31,-2,-17,-27,1,27,-2,57,-85,76,25,108,-28,-33,-14,-49,-8,55,34,50,-38,-15,48,82,11,12,-43,-41,37,-2,67,-44,-30,50,-64,23,-5,-32,-9,13,-18,28,-11,52,14,127,-9,-2,3,18,9,2,11,98,3,51,-26,-53,-3,-6,-101,-72,91,-18,-12,-47,-31,39,23,100,14,50,41,18,2,15,-48,57,-18,5,-44,33,-13,12,-22, 
  /* [915][0][][] */ -86,57,4,36,29,-16,62,45,47,87,-39,72,-71,4,-9,87,-9,-9,74,-64,-72,75,19,-25,9,69,-127,-68,-16,22,12,102,28,30,9,-109,-11,5,55,-11,41,-8,-63,22,-49,11,-15,41,-45,41,-17,-28,-86,-14,84,77,-23,44,-6,-3,-3,49,-3,19,-29,2,60,1,28,16,89,-31,-104,-18,-27,23,-10,6,-4,24,9,21,-51,1,11,75,46,12,-53,52,-29,-15,55,-44,-13,-28,-2,114,-33,33,13,37,106,-22,24,113,39,32,81,-36,41,9, 
  /* [916][0][][] */ 0,21,-5,-1,18,1,36,-13,22,54,16,-17,28,-41,-75,-7,-19,40,15,9,47,37,-18,40,-42,1,-22,-18,17,-54,64,-6,6,-28,-32,-30,-80,-65,-18,1,19,-6,41,-2,-25,-41,51,48,66,2,-12,-36,-10,-47,-10,7,-13,37,-20,-49,-14,-29,-23,7,10,55,35,-10,-23,-30,-29,-24,-13,21,-50,-66,-14,81,-12,0,-30,-1,-7,-9,7,16,5,22,-54,10,-12,32,-24,-50,77,26,-10,-68,4,-17,-13,9,-18,-7,89,27,32,127,-7,10,-97,51, 
  /* [917][0][][] */ 53,72,22,41,30,-28,-21,-2,41,82,-44,80,-39,-68,-26,-51,24,-22,-21,-13,3,-48,116,21,-42,29,-22,21,17,-91,29,-36,75,24,-47,-75,36,-50,49,-19,18,-38,-20,-53,8,-29,-4,3,-21,-37,-34,-29,39,-17,-13,-19,76,-18,46,-59,26,-104,5,-9,46,2,34,14,115,-31,55,19,-39,110,58,42,22,-41,127,29,-74,21,-4,-40,13,16,77,23,61,-16,10,-13,59,-14,-2,75,12,-59,-21,-35,57,54,-6,63,47,-5,-36,-50,15,69,86,-22, 
  /* [918][0][][] */ -3,-94,-72,-49,0,-123,38,1,-56,53,-18,3,65,-41,-24,-20,24,-56,-6,-57,24,-29,-64,-28,17,-53,127,56,-21,9,-6,-47,16,42,-2,-55,-50,76,44,-48,33,-43,37,-51,35,-15,36,-69,52,-11,-25,9,-16,11,-7,-2,-32,-51,95,4,-68,49,67,-24,-42,4,1,46,63,-81,-101,-31,-41,-13,53,-8,60,69,73,35,-36,-4,-46,28,-1,79,-16,21,22,15,63,81,-56,1,99,-18,-57,45,4,-1,61,-22,-8,-27,84,29,-4,-5,39,19,-3,19, 
  /* [919][0][][] */ -34,-17,-11,58,-59,-85,7,9,49,-31,48,-44,7,-4,-47,24,86,-69,-65,88,55,-50,29,-105,-31,-46,34,-48,-87,41,-70,-15,45,-64,-17,5,-45,-64,-10,-15,69,38,-39,75,7,-107,-5,5,24,26,6,101,-20,-23,127,-26,38,-48,-53,60,5,-26,-17,9,57,31,-38,15,11,48,-24,-19,-6,8,-12,40,50,-37,98,-11,27,-65,29,34,-98,95,15,-47,29,10,35,-61,28,37,-13,-55,-13,45,-48,-17,35,36,-7,90,25,-13,-4,73,67,26,98,27, 
  /* [920][0][][] */ -12,-27,15,13,58,14,12,-69,16,44,127,0,60,0,23,-43,12,-27,22,-5,-41,42,13,37,32,14,21,-2,-10,-1,9,-19,21,4,21,-59,-8,36,31,19,26,38,1,-17,34,-17,22,-14,-11,-23,-62,-7,71,0,-16,-98,36,-10,13,53,-36,-30,-39,11,-43,17,41,-23,76,-13,-4,-33,-72,-12,64,-27,-11,-59,-4,28,39,39,39,80,-6,3,-21,38,9,18,-11,13,-13,-53,-28,-36,-25,-36,22,-22,8,22,7,-1,-23,-3,28,-20,-84,18,14,-5, 
  /* [921][0][][] */ 49,-33,-22,33,102,62,78,-82,-35,23,48,41,-5,-29,36,41,22,-12,-73,42,-52,57,26,-27,62,-67,-38,-115,-73,25,26,83,16,-88,22,32,-17,52,-68,-40,-17,97,-62,77,-64,89,-81,-16,20,52,72,30,-75,-19,26,13,85,82,12,-95,-4,-24,-1,-5,-47,-27,-82,7,-40,-27,31,-2,15,28,-21,27,-110,59,110,-72,26,-34,-26,-23,-48,1,3,-16,-22,-50,-127,10,-26,53,-55,-51,37,37,29,31,-18,75,-81,-1,7,-2,-57,-4,-58,52,-58,94, 
  /* [922][0][][] */ -18,21,46,-13,-54,-127,-3,30,29,-21,-61,-57,17,-34,22,-35,89,34,-32,45,10,-9,-56,19,6,1,-63,-18,-94,19,-38,-9,-60,-61,-26,23,5,44,-19,17,23,-31,-89,56,12,30,-1,-5,-58,-52,44,31,4,-43,1,-2,7,16,-48,-68,-107,19,-59,79,48,28,-93,-11,-2,77,-23,-96,108,-53,42,81,-56,-25,43,78,-37,-71,-37,-3,-29,61,-15,20,7,25,-56,12,95,-51,-5,60,22,-75,-38,-30,64,-68,-10,-16,15,-52,-45,18,42,44,27,-7, 
  /* [923][0][][] */ -18,-11,2,-5,110,35,48,17,-35,-43,43,-1,67,-19,26,1,61,7,1,-46,-29,-22,3,-6,-101,84,24,-64,20,16,24,-9,59,73,-11,29,-26,-20,46,63,-68,-11,-17,56,-83,-10,-49,-59,93,-35,-63,88,0,-11,53,32,24,-33,48,-31,45,-56,6,-93,-14,78,15,-98,-105,127,-52,32,56,68,6,20,-14,-30,-59,-5,92,46,74,40,-61,-18,10,13,65,-107,7,-13,-38,46,-86,6,55,48,-111,-22,-23,43,-11,-60,43,29,34,-38,62,-49,4,-37, 
  /* [924][0][][] */ -21,-33,-51,83,-45,62,56,-73,-43,2,48,-10,-59,18,-18,-27,13,-57,65,17,36,50,-45,53,59,-30,-6,-14,-80,-80,53,-33,-32,-19,10,19,14,7,81,12,-27,111,16,-18,-72,-41,-10,34,-20,14,81,20,-14,38,25,-69,-6,16,-1,6,47,35,-17,-62,-25,9,33,73,-69,-20,16,31,-49,-7,43,-18,42,27,55,25,-13,5,23,-57,57,69,-86,-10,-22,20,-32,68,5,-5,-2,-69,-7,2,-63,-17,-15,63,-17,-47,-18,-127,-68,-18,21,47,53,34, 
  /* [925][0][][] */ 12,-15,-40,-24,83,13,-26,23,-67,-59,65,52,16,-26,-11,-14,-22,15,-22,-1,5,-9,-40,18,39,31,15,119,37,24,-27,-83,14,5,0,81,46,17,-19,41,-5,-14,-36,-127,47,-57,-28,27,47,73,-64,80,-61,-24,-91,-43,70,16,37,18,9,-1,2,14,-23,-42,-48,63,0,-31,85,38,-27,57,-7,2,57,-39,-32,-28,-9,37,12,29,-4,6,50,12,62,17,-30,-1,-64,-1,-54,-7,14,1,-61,11,19,-2,-20,-27,-47,20,-43,-22,-29,25,82,110, 
  /* [926][0][][] */ -32,-9,-47,5,-23,14,21,-37,74,-13,1,-8,-16,25,-79,-20,77,-27,29,-18,-44,31,-41,26,-29,-33,19,-15,-6,-23,23,81,-23,-83,50,11,29,29,27,48,57,-2,16,17,31,64,-6,11,-38,3,-43,15,-11,53,35,-34,29,-96,-40,21,90,-79,7,-79,-8,-77,6,-64,28,-11,-13,12,-38,1,4,58,65,8,-28,65,-19,-37,66,15,-75,20,41,40,21,-46,-11,13,-26,98,18,3,67,22,14,14,-36,17,-31,39,-12,-43,-40,-58,-48,90,-127,72, 
  /* [927][0][][] */ 26,-8,16,57,-105,-15,37,-18,-16,-24,-34,25,47,16,63,-1,15,8,-13,31,-24,49,0,-50,-30,26,49,-55,65,10,1,-41,17,14,28,49,-41,127,37,-119,-88,12,-96,1,-66,59,46,-67,16,21,-2,-29,49,5,-16,-14,-33,-29,6,12,-14,-22,96,22,-13,-21,5,1,-33,31,-20,80,-58,18,-16,-30,-42,-52,-14,32,8,13,35,-51,43,-20,0,-73,47,-120,4,70,-28,-62,-89,18,-21,33,-39,113,36,-17,51,51,-15,32,56,-18,23,-30,33,-64, 
  /* [928][0][][] */ 35,50,-14,43,-18,27,-29,63,5,-54,22,10,16,-39,67,-13,-35,-41,-25,-2,127,-1,-5,-37,-106,-31,-86,29,63,15,25,-1,-18,1,63,-81,7,-76,83,-15,-78,-43,31,67,-38,28,-6,-57,-56,15,6,-3,17,30,12,-10,42,-103,67,40,8,-67,50,73,32,25,105,38,-11,18,-4,8,74,-81,84,-55,10,7,6,-1,51,107,-36,-4,-33,5,13,-71,-15,-32,-67,-16,-90,49,-37,-64,10,7,-94,-21,1,20,83,47,-90,49,-58,-18,50,41,104,17, 
  /* [929][0][][] */ 61,24,-80,-110,-28,20,107,127,20,67,14,-40,59,-49,108,-56,22,110,-7,-13,-9,-35,-18,-50,21,80,30,126,53,95,-34,33,-20,-34,76,19,-76,77,-43,-36,102,41,36,94,27,26,-18,43,-15,-22,-36,117,-73,107,51,-90,-84,-37,-13,-62,-66,-29,14,115,-11,49,-72,-58,-1,-16,-31,-78,-41,5,-59,-32,49,19,25,-20,-15,-53,-4,25,-52,-44,7,-122,-16,25,-16,49,16,-31,12,-38,41,-24,-10,-54,-17,59,6,71,-46,-20,-32,-5,-8,12,-2,59, 
  /* [930][0][][] */ -41,12,39,-67,-76,32,33,-54,-52,74,-29,8,-10,50,57,31,-19,20,16,-71,9,64,51,-61,-38,-36,-46,80,-104,-58,-49,61,-15,-19,-1,-5,93,36,-29,-127,120,-12,92,4,-18,22,-43,27,21,-22,-48,-47,25,6,-12,-45,-61,-21,-61,46,-35,-51,20,-16,-14,34,10,-14,-9,-29,-36,-71,-90,-71,30,48,73,-33,-10,-53,-15,57,-80,-17,75,17,-7,-60,-10,-10,-41,59,3,11,-33,19,48,40,-86,18,-86,0,48,58,-16,1,33,40,-9,51,-20,35, 
  /* [931][0][][] */ -57,-42,-76,29,44,75,26,-15,-98,-45,28,-19,92,-38,20,82,49,34,-4,97,88,-16,71,-71,-40,-85,-58,-74,-63,19,95,1,18,38,43,14,-6,-73,49,10,-40,96,-97,-35,-83,103,-12,-12,-71,-32,74,48,-28,12,20,-12,-20,-20,-28,39,125,92,2,-56,10,-5,-7,-63,13,-24,67,60,35,27,-97,11,-37,-18,-67,-60,127,-17,9,37,50,-33,117,-47,-60,32,42,33,-76,55,-60,4,-2,-109,23,-47,-6,-38,27,25,-78,-56,40,-18,5,12,-37,-23, 
  /* [932][0][][] */ 62,-19,16,27,-28,51,20,35,59,-27,-64,-9,-6,30,23,-34,-29,24,18,62,-28,3,-11,-63,49,-62,-57,-18,-9,-8,1,-21,21,13,4,-110,-45,17,30,43,46,47,-43,29,-61,127,-60,25,-3,-1,39,-66,-35,18,52,18,-87,80,5,29,-24,-49,-62,-38,16,-34,-17,-18,17,-13,63,-64,-42,-41,87,24,-7,-18,33,25,15,91,23,46,3,-80,-55,34,-9,-12,-89,-8,31,-33,50,-21,3,3,-35,-33,21,25,-48,-13,4,75,-60,42,32,24,-37,-25, 
  /* [933][0][][] */ 21,127,14,-113,-17,-10,-15,21,-37,71,31,5,67,-74,-6,-99,113,-83,73,-8,-38,53,-34,-26,117,10,-40,2,-91,-9,-23,29,-2,-51,5,-23,7,-68,-6,26,-32,-58,-26,-5,49,-48,58,53,-15,56,51,-92,21,47,-63,72,13,11,-7,-36,-44,39,-15,54,-12,-51,125,75,-11,-49,-30,54,48,0,-62,82,-55,42,21,6,-116,-13,8,29,-62,6,6,-9,0,51,-30,-93,-74,-86,106,8,-2,96,-2,27,44,-52,-48,-54,67,21,2,-52,-7,8,82,42, 
  /* [934][0][][] */ 20,-57,-20,-32,-27,-74,21,5,-87,58,101,33,40,31,-5,68,11,45,-96,-79,-14,-40,-67,-30,31,49,69,6,17,-108,82,21,61,1,51,-48,-55,14,77,-42,15,-83,-84,-33,-33,-25,7,0,44,21,55,46,3,-4,-33,39,44,73,-44,-127,81,-56,52,-87,-92,-117,37,-116,-20,60,67,75,-23,-45,54,24,5,-13,-77,103,19,-24,-13,-48,49,85,-15,-37,-47,-52,-82,49,44,-20,30,-44,-68,74,30,97,16,68,24,-55,-20,10,-62,0,-70,68,-77,46, 
  /* [935][0][][] */ 34,57,37,3,-91,-3,-37,93,-1,87,3,68,21,11,-44,31,12,-52,-47,-38,1,-57,43,53,11,4,4,-39,1,52,-13,58,-29,-57,-101,-54,-25,-4,-68,53,98,-55,60,28,-25,57,-72,-4,35,5,30,16,-25,9,-10,40,10,3,-10,127,14,12,30,81,13,-64,79,72,45,33,-18,-25,18,50,9,-27,-24,31,-2,-42,-40,-83,-101,-38,7,17,30,43,-63,-11,6,-50,-32,68,53,-3,-96,-42,-65,-31,114,-121,-75,-14,-8,34,-25,55,21,48,-75,-30, 
  /* [936][0][][] */ -21,-3,44,-18,-13,55,16,8,-29,-47,50,-44,-20,42,126,32,35,-3,65,-35,4,92,9,6,-9,6,-35,17,0,-49,10,36,-41,30,-36,-48,127,43,-11,34,-28,-10,-5,-13,82,37,-61,53,7,-38,-59,-97,72,117,22,35,-10,-27,-17,9,25,66,35,41,-8,8,-81,-14,51,-60,0,15,0,-19,22,-7,-70,33,-16,20,18,-30,-52,4,0,-10,44,90,49,-52,71,-66,16,67,0,16,-41,-84,30,-22,-2,-37,-3,-10,-31,5,31,50,43,-20,15,-22, 
  /* [937][0][][] */ 29,19,124,-26,-68,-4,-108,-8,6,20,-79,-45,-92,-80,51,38,126,-103,-47,-12,41,-56,23,73,52,-55,31,-98,-61,-11,29,24,-18,-26,-75,17,7,-80,32,10,-68,111,-22,-47,-53,-40,58,-16,88,-109,-49,-66,49,-46,-63,-62,93,29,-3,58,-73,-19,54,-4,-55,-12,57,56,-60,5,39,-28,-47,120,60,66,-23,-26,-57,5,-58,-49,23,16,16,-105,-22,-29,-51,113,-42,-50,-74,33,-122,37,38,-33,17,-27,54,27,36,-50,7,-59,-9,62,-127,18,-5,-49, 
  /* [938][0][][] */ 0,-8,74,127,-33,43,11,6,55,-58,-62,-34,43,81,76,58,28,-69,13,-75,88,23,38,-4,115,-49,-26,57,-28,8,-10,86,77,-32,0,24,-21,-47,-34,-52,-58,-43,88,-38,-51,-13,6,-20,24,-29,-51,61,11,-6,-27,4,-16,-17,-1,-10,-79,-99,40,-8,89,44,-8,72,18,-19,55,43,42,31,28,-52,73,15,21,-22,-56,0,39,13,-51,-3,43,-54,-11,32,-31,18,42,-27,-27,6,1,48,-56,-20,-91,41,80,5,4,-24,52,25,41,32,39,1, 
  /* [939][0][][] */ 115,-7,-15,-58,-21,-2,-8,-80,-20,21,-24,-79,29,85,66,28,-92,55,-27,46,82,-35,-49,91,23,-27,-46,90,-54,-13,-19,-12,-29,42,-3,-43,1,-74,-45,18,-11,19,-44,12,93,-32,50,-16,-7,20,-22,-13,-23,39,18,22,-83,5,33,-11,89,-69,66,-14,-120,-86,49,-67,14,-41,29,25,14,124,-75,28,14,-51,63,-69,-29,32,-10,78,-11,6,-25,6,-69,71,-101,42,-14,-18,39,-94,5,36,-35,-127,-66,35,-10,17,-26,120,-58,-8,-21,57,-25,-41, 
  /* [940][0][][] */ 93,12,14,-28,-60,-26,18,65,43,101,-21,31,-3,-72,55,-11,127,-96,-14,25,17,-65,10,62,-49,-6,35,108,6,11,-69,-1,1,49,2,-19,-13,-61,23,-1,44,10,-24,37,36,-10,0,-31,-24,-58,7,57,-29,22,42,-98,17,14,-109,63,51,43,14,-10,-23,-19,25,15,8,-19,6,-15,35,-7,60,-50,81,-44,-37,-48,-35,56,-2,-3,-17,-76,-32,8,50,22,-34,-44,-26,-21,19,37,53,-121,26,0,32,-93,43,-82,-4,34,-10,28,-40,48,-37,13, 
  /* [941][0][][] */ -18,-104,-33,5,7,26,-9,-6,-9,36,-40,-127,-28,4,42,14,-2,-12,-80,-1,10,24,23,54,-57,-35,-97,35,-4,23,-51,13,17,-36,-27,-43,-38,-27,-20,2,-39,-84,27,-25,-69,-27,-14,-35,-24,-5,34,86,7,46,59,-11,5,17,-45,-58,39,-5,40,42,40,-49,-26,68,-26,6,-16,-29,53,37,5,23,-1,14,-64,39,-62,39,14,-13,-15,27,51,-11,-8,5,3,-14,69,-18,-36,36,3,20,33,-55,24,-67,66,32,-2,-36,-1,-42,-25,-35,0,55, 
  /* [942][0][][] */ 11,-115,64,43,-27,101,-37,64,3,-14,26,-58,-2,-15,-33,-4,8,-25,49,30,36,-19,7,40,-4,-50,60,-28,-75,2,108,83,36,-18,9,-13,127,-22,-11,17,39,0,27,-8,13,-23,32,6,62,-84,-68,44,74,71,24,47,-77,3,10,-94,46,-40,50,-44,-25,-45,-27,16,-96,22,-13,80,-18,87,-65,19,-36,-60,13,29,-68,60,-55,97,67,-10,-1,32,-52,-77,4,17,-60,-19,12,-59,0,15,72,60,-14,14,-104,-103,-41,-38,-39,31,-10,47,-66,-54, 
  /* [943][0][][] */ -9,51,-32,-23,-22,43,8,-46,38,-72,-59,-33,-72,-36,54,42,-40,-36,-10,20,109,-37,1,-2,35,-7,39,-15,-66,-11,-75,19,-7,-16,-17,-22,11,-13,5,-31,-30,-3,12,-64,32,31,36,66,33,-2,2,-47,83,33,-30,-31,30,8,25,18,49,-14,-9,35,27,-40,-6,-79,19,19,1,-68,28,9,-54,53,-1,37,36,-14,-34,-46,16,-45,39,-50,-6,-33,5,47,-127,16,16,94,40,10,17,67,26,-9,27,-60,-8,-26,-33,-31,-65,-9,56,19,-15,25, 
  /* [944][0][][] */ 33,-12,6,13,-24,33,63,-10,46,-60,39,-25,76,-34,43,116,-24,0,0,-67,12,22,41,29,-35,-3,-11,61,-82,63,56,-28,-53,-31,75,-39,58,-13,-36,-55,47,-127,120,-43,34,-56,-101,23,-21,35,30,59,-81,-27,77,-69,38,11,109,-41,-15,33,5,-19,-24,72,74,-46,-26,-70,-44,49,23,-8,-16,-53,-24,-38,-37,-85,87,73,4,30,34,100,-10,104,-9,24,-3,10,-66,10,-51,12,33,13,0,-14,18,53,-4,37,-30,12,-11,-52,-71,-61,-15,35, 
  /* [945][0][][] */ -6,50,-3,-64,31,6,-62,13,26,-3,-27,75,-43,19,86,52,2,52,-19,3,31,-93,63,-29,-47,83,-1,-41,41,17,31,-29,47,38,-6,31,19,38,15,-33,4,-46,-38,-106,-39,57,-61,31,-22,37,32,26,-53,21,-44,-35,-59,-68,-6,-40,93,-1,-17,7,-24,-47,10,-95,-103,85,47,-1,2,70,17,31,14,78,-9,64,23,2,55,71,-99,31,-127,-64,-10,8,-102,2,-64,28,-61,-3,-56,30,-43,-92,-1,-54,108,17,2,28,-63,27,22,-41,-25,30, 
  /* [946][0][][] */ 14,64,50,56,-1,42,3,-77,44,8,-17,-123,-74,51,-10,-2,15,39,48,-59,-9,-26,-4,51,42,68,-114,75,-6,81,-36,-28,-64,46,1,102,59,11,94,-77,-9,0,34,-46,38,-127,50,-32,-48,-30,-2,-88,67,-36,-4,-42,-86,25,-61,-46,15,17,-5,-27,11,62,-14,117,-66,-14,-31,-28,-2,-82,-8,27,21,94,98,38,41,108,73,99,2,-3,30,-40,-99,-38,101,21,39,-5,5,65,-76,-33,-37,-7,-81,-42,-25,22,-29,113,18,-17,84,4,59,-43, 
  /* [947][0][][] */ 5,-9,-25,14,-6,30,-25,28,55,61,37,2,-48,-23,43,-5,47,42,-34,46,-88,-8,14,-51,91,-52,25,-34,-15,17,-17,-63,28,-43,-43,18,42,-6,24,-34,2,16,-73,-22,38,-22,23,4,57,32,-58,-33,127,34,-54,7,13,-31,-15,10,-12,5,3,-22,48,39,-44,30,-48,-56,-4,91,19,-31,38,-35,-25,-57,17,14,-29,15,-3,38,10,81,3,-45,104,26,-27,6,54,21,-61,-6,2,83,-2,29,51,-62,-7,-52,23,-55,-42,76,-52,29,-3,0, 
  /* [948][0][][] */ -19,-27,-23,14,111,-76,-49,88,41,77,82,30,47,-38,9,-38,49,35,-5,-20,0,-42,-40,-55,-32,-37,9,63,40,36,30,-24,11,65,57,-3,-55,-32,-22,14,63,-75,60,24,-40,28,22,21,68,49,-16,-27,23,14,118,-16,50,-66,-28,61,59,19,47,17,-38,-70,-26,-46,-61,-64,90,-43,29,16,13,-17,66,-55,-47,72,26,63,77,13,29,12,-67,-87,-81,-63,35,127,-13,34,-37,15,-5,30,-67,21,15,-23,-67,-49,-16,13,55,38,-31,44,-33,-72, 
  /* [949][0][][] */ 25,-22,26,68,24,-9,47,-6,33,-54,18,-35,-55,-34,22,16,-46,-32,-91,56,-56,15,-21,22,-17,50,35,-73,-17,-4,3,67,-8,-30,-32,-69,73,42,-4,-23,16,-6,-47,-76,-47,-87,-24,-97,18,61,9,-88,-9,20,9,50,6,-33,32,1,1,64,-12,25,16,60,-60,56,39,-41,42,11,44,-14,50,-5,4,13,30,-13,71,-12,-44,-73,44,72,113,-2,65,32,-53,127,5,2,0,8,-1,-3,5,6,81,48,-25,73,41,79,-57,65,-69,5,29,44, 
  /* [950][0][][] */ 9,61,-16,-9,-44,-94,-19,-23,38,30,33,16,15,23,-6,17,-92,44,-47,11,-77,-34,38,13,-18,33,28,-7,21,16,-9,-41,12,-42,39,-67,-41,50,34,-18,20,8,25,24,-12,15,-46,3,-127,-43,-38,-23,-17,-50,-24,-27,26,-49,23,-14,4,-34,17,17,28,48,9,30,-64,-23,0,-2,-18,-37,91,-75,-3,12,-38,-56,11,-50,26,28,-12,-2,21,-3,-43,4,-61,-23,-31,48,4,36,2,-22,14,37,-53,-53,-10,24,0,6,97,-15,-18,1,25,-37, 
  /* [951][0][][] */ 27,-3,58,-121,20,75,-16,42,56,-71,21,40,21,18,-20,33,16,-2,92,41,-26,57,19,31,28,-15,-48,22,-15,13,-14,11,-44,28,50,9,73,24,53,-69,-71,6,46,-28,59,31,8,16,50,-17,35,-67,-7,-29,66,-28,-17,55,22,66,19,70,1,3,-22,-31,-15,-14,32,-30,-3,64,-27,-68,14,-53,-109,34,8,28,-63,7,-5,83,-66,-9,-65,-25,-23,-47,-10,95,1,-127,16,-17,-46,35,110,-6,119,68,-37,50,-44,58,-13,31,-24,16,-52,-32, 
  /* [952][0][][] */ -26,35,12,7,-5,25,-29,-86,58,22,53,-57,20,2,55,1,75,57,68,-44,-78,63,-13,1,-35,-110,-3,20,19,3,-83,67,17,46,68,38,30,-37,-33,27,73,32,56,10,-71,35,-113,8,67,-100,-5,-81,-77,20,-117,76,-3,-108,-28,-79,-61,45,-62,-27,-15,42,-14,69,112,61,51,97,-59,-2,-33,14,112,-7,19,-127,0,-8,126,-12,-87,57,32,66,45,-6,12,48,-75,-31,-86,-44,-12,39,-81,115,-50,-12,36,30,-4,-52,-49,7,-121,-108,-28,-43, 
  /* [953][0][][] */ -34,13,55,6,-17,-20,7,-24,54,9,-48,10,-30,-1,-13,1,-1,-31,28,-43,36,34,77,-111,21,-8,45,23,99,13,-35,-56,43,-25,-34,31,-9,-96,-10,32,39,-6,-5,15,-6,61,-14,29,14,-21,-42,-10,-18,-40,32,-20,89,-30,-99,-7,-24,26,-7,-14,13,28,18,-48,62,8,-15,-45,-29,27,-65,-43,35,-32,76,-55,-75,30,-2,-30,-40,53,57,53,57,2,30,-23,-30,7,-94,29,38,-21,-15,25,-8,-2,11,-20,62,7,2,75,-127,-52,-61,-20, 
  /* [954][0][][] */ 23,-41,-35,59,21,-40,-27,-50,1,-49,-67,-4,-62,-19,-6,-26,30,-48,16,5,30,-12,-43,-43,-22,40,40,-28,-34,-115,33,-98,-18,32,-66,1,77,94,19,-57,-1,-125,34,-53,21,-61,-47,33,106,-52,-25,-33,6,-23,13,18,111,-26,-72,-25,50,-23,48,-37,23,-6,5,82,45,-48,24,64,-17,-86,10,43,-64,-37,97,6,-6,4,50,-97,-12,-14,-70,-31,-89,56,-59,89,-27,-13,-27,104,-70,-18,71,-27,-9,-127,-72,44,73,1,-35,-29,-36,60,-13,32, 
  /* [955][0][][] */ 50,47,22,40,-75,27,62,12,-87,4,-12,5,-30,46,-4,73,-31,26,-9,-25,33,-40,26,41,-80,-50,51,-70,101,58,-51,25,49,-50,-11,-12,-58,-54,19,22,-6,-49,-4,71,-18,-7,-29,-46,37,14,108,42,12,38,112,61,67,-17,-54,-64,0,57,-37,-14,9,48,110,-100,-62,127,-50,-12,52,-55,12,73,-45,42,-2,18,-127,-25,-30,3,-44,-82,-8,-8,-68,33,66,3,14,-81,-70,63,31,-22,14,-28,51,27,-30,-47,-8,47,18,4,52,-39,-93,-55, 
  /* [956][0][][] */ 31,53,17,-87,16,47,-23,-60,42,-52,22,-29,28,38,47,73,-45,84,79,-27,37,26,39,-17,89,-76,-34,8,11,-14,-88,-36,15,56,-59,-25,-100,-121,-47,46,69,14,-14,30,-77,17,-57,-71,-48,37,30,-91,-85,31,30,-68,0,-35,-63,68,64,-38,-6,-80,-52,-55,7,16,-37,-35,-16,-28,8,23,88,21,18,69,112,25,-70,13,10,-53,7,-52,10,-13,-11,-4,85,-64,-11,-22,-49,-12,-111,79,-48,-79,-13,43,-53,-50,127,-2,56,-37,71,-23,38,-101, 
  /* [957][0][][] */ -127,64,28,42,15,-38,-2,6,7,7,74,44,-80,17,-50,5,-13,-51,-44,-2,58,0,75,-17,69,43,36,60,-10,31,-74,-92,0,-29,37,-62,-9,-21,49,31,28,-12,-79,-46,-98,-17,45,-19,-14,24,-7,80,-12,-8,34,44,8,25,-12,-19,39,82,6,8,-5,-3,-43,6,-61,37,14,10,58,-31,33,6,-46,23,19,-5,-112,-66,78,50,58,-13,50,27,11,-16,26,96,16,1,-77,56,-17,3,-62,46,53,2,62,-85,30,-14,37,-14,-13,-44,112,94, 
  /* [958][0][][] */ -12,11,-62,-16,23,-5,-31,-49,-19,-33,53,20,23,-12,-11,39,15,-1,52,-26,-3,-26,56,11,-11,29,-1,-35,-58,-10,-13,41,45,-10,-7,-24,-67,-49,29,28,-10,-17,25,26,-38,30,24,-32,-11,-74,-34,-4,-55,-54,37,78,55,-23,12,63,-9,16,1,39,-34,-24,-30,10,-39,1,25,-32,-70,-8,-9,-2,-23,-39,-54,22,-63,57,-47,-6,4,42,18,-23,-3,-38,18,69,42,13,-11,12,-57,6,-55,-127,15,-61,4,-15,38,67,9,85,-42,-8,-25,70, 
  /* [959][0][][] */ -94,-24,58,-22,-53,52,69,-34,-28,81,58,-8,-14,104,51,-23,88,-79,-48,39,32,28,29,54,28,33,-55,-20,-1,103,-22,42,-6,-6,37,4,-7,85,27,-32,-14,31,83,-58,27,-4,84,16,58,85,40,45,-11,-41,-54,69,64,-97,-1,15,85,-1,11,17,-20,-104,-57,4,-112,-43,-3,29,5,-12,-39,-86,49,89,-80,42,-5,86,-19,21,67,93,34,-66,13,-21,2,-29,-4,18,12,42,-9,65,17,127,42,-21,70,-13,42,5,-2,-14,68,-82,26,13, 
  /* [960][0][][] */ 6,26,81,-47,48,32,-28,-12,61,-18,28,-12,22,-13,4,13,3,-25,-16,34,-6,-28,-87,-24,-13,-19,-35,-127,18,35,2,33,50,-19,-3,6,-88,0,-8,32,9,23,-12,-6,-4,-7,70,52,-2,-15,-34,-39,-15,-35,-44,62,2,-2,62,-11,87,-40,-16,46,-13,-60,-30,12,7,-81,-23,-6,-9,23,38,-28,-1,-86,82,42,-36,-38,7,30,-76,3,2,54,-44,49,66,6,-77,-33,-22,14,1,50,-1,-35,-18,-22,19,-40,46,-43,-40,-38,18,24,17,12, 
  /* [961][0][][] */ 41,-34,-102,-84,25,-43,-29,47,11,-34,-11,-31,-9,-23,-62,23,35,-19,-29,111,-59,31,-34,107,-18,-11,-119,-9,-12,-17,44,86,-23,16,-28,61,63,55,-4,12,8,110,1,24,-33,17,115,-26,-70,31,-9,-6,25,102,45,38,9,127,-68,-7,17,108,-33,-17,-24,-84,47,-3,26,-38,38,-117,-18,-57,9,83,-3,28,-71,9,13,65,-66,-11,15,-36,9,-21,45,39,35,-39,5,-63,88,-18,2,-81,70,9,-65,-76,-21,-38,28,-58,-2,-51,-27,49,51,-12, 
  /* [962][0][][] */ 50,110,-38,-60,0,-76,-52,3,7,1,17,-17,62,-37,72,35,96,-38,-10,-12,31,13,-9,-12,-39,-72,14,7,1,-49,-21,8,13,75,2,-3,-62,-25,-23,-66,53,-21,-17,41,13,-16,10,-70,45,19,-41,-33,-3,-28,-98,67,14,61,-20,4,42,26,24,32,47,-58,-16,54,-28,-1,78,49,69,-4,15,17,-8,-5,1,39,74,-5,-64,8,-49,-50,42,61,39,52,-29,-26,64,-127,88,40,-24,51,31,-49,16,-5,55,-46,86,58,-45,-63,72,-68,32,35, 
  /* [963][0][][] */ 13,13,-127,28,25,-67,-2,102,28,-6,7,9,-66,-3,-14,-5,9,-17,-15,-61,45,75,-56,47,-30,-26,-10,-23,19,17,54,29,5,-14,-6,63,-22,-35,-30,42,78,13,-88,51,-35,-58,38,13,77,-2,-66,46,20,42,33,-50,8,-11,-38,-52,11,-25,-8,-28,5,18,-9,14,-38,70,6,77,68,39,81,9,-49,-34,-69,59,115,33,16,-9,50,9,-56,-19,-12,49,20,-54,-70,59,-24,-13,-64,-55,49,-12,44,-30,-51,-34,2,-6,98,13,-56,56,-106,44, 
  /* [964][0][][] */ 56,-70,17,27,-24,-18,43,46,-45,-65,13,-2,13,7,23,-22,-75,40,-58,42,46,-62,10,-45,-79,-42,-46,16,-52,5,69,79,-17,34,-2,-127,13,-66,-53,-69,-122,28,-29,15,-9,26,-31,64,-78,21,12,16,-28,68,33,-20,19,-18,33,84,-40,2,-86,99,93,32,17,14,18,-17,-38,-10,-49,-9,115,-73,-11,-29,-33,-48,-44,14,1,11,47,87,-30,27,-45,30,-10,38,-57,22,-78,9,66,107,-16,45,-21,-71,-44,34,11,-94,3,44,-57,71,-56,28, 
  /* [965][0][][] */ 30,75,55,1,23,-17,81,27,-26,-5,-45,-3,16,13,-22,-52,-28,-15,18,39,-41,70,-6,-16,35,12,-48,15,79,-12,-40,-65,-90,-1,-4,-8,-62,8,-66,-86,-16,-64,26,32,-7,8,21,20,-52,13,66,-67,48,14,53,-44,2,-30,16,-28,-30,50,-75,30,75,46,72,35,-52,46,-20,58,12,28,-5,-62,9,125,54,127,7,-31,-23,-25,20,-75,13,-40,-48,-68,-65,-90,-10,4,25,-10,60,-26,-62,-74,-16,-47,31,63,32,-2,30,35,25,31,62,-39, 
  /* [966][0][][] */ -71,72,-33,-33,8,-20,-45,-102,127,59,-78,-50,34,-108,54,-65,10,-61,71,-59,15,-5,-5,59,65,-98,-14,5,79,-80,-116,-9,24,-55,-6,-81,-69,98,-6,7,52,-98,-50,13,72,-80,-1,-91,56,-54,19,19,53,-79,40,37,34,-14,-4,39,-34,-26,17,-11,18,60,-11,9,-9,9,57,39,-110,8,30,85,-7,-12,28,-6,-21,53,-8,-2,15,-30,-18,1,-41,-74,-35,96,-13,-60,-27,60,49,-42,-4,21,27,17,-110,-88,-4,47,7,1,-10,28,83,-115, 
  /* [967][0][][] */ -44,7,75,37,-60,18,67,-79,18,105,-19,30,14,-26,-9,3,6,-68,-53,-16,-26,-51,127,-86,-42,-44,-36,-70,-1,109,43,76,23,83,-28,54,119,45,30,61,-29,12,20,85,5,-3,-68,42,-48,-3,43,-38,39,-93,23,74,-116,-117,22,-9,-37,-11,-55,39,94,-19,32,-35,-17,49,37,-69,-34,67,34,8,102,71,-80,49,66,7,-68,30,3,114,62,-20,82,42,16,-8,-30,-43,-17,53,35,-25,20,-10,62,70,-36,88,-19,-45,35,62,-3,10,23,-34, 
  /* [968][0][][] */ 8,-49,-45,40,18,-18,-43,-23,-26,-12,-36,34,-60,9,-7,-27,-22,41,-39,-45,1,20,33,-85,-7,59,-73,-2,23,10,43,14,46,-16,27,-6,6,12,93,57,11,47,-47,39,5,56,0,-58,10,-33,16,17,40,127,62,32,41,-9,-33,-42,31,67,-46,-21,77,-53,-36,-14,-49,-14,0,-49,-22,-36,18,-75,11,-35,-45,34,-8,43,35,-49,-48,-12,22,12,26,58,75,-27,-4,-10,-20,-4,6,12,45,-17,-13,72,-15,-37,-26,-8,15,-50,27,3,18,32, 
  /* [969][0][][] */ 29,75,37,18,-45,0,30,44,-74,-52,22,37,11,57,78,76,28,33,20,47,127,44,-9,-50,1,10,84,-25,-12,-12,-2,-36,0,-36,49,67,21,-10,3,78,43,-45,24,-44,-48,12,-76,53,73,14,47,50,-34,-11,7,7,-39,17,20,-63,-61,-60,-33,32,2,-7,-84,5,-12,96,-25,35,-11,93,-14,-1,-54,57,-33,-20,26,-46,-58,-13,62,-38,-17,42,33,47,-4,-42,-1,-12,-69,-24,-9,21,-13,-45,42,11,106,25,3,-46,30,-17,-7,-96,-4,78, 
  /* [970][0][][] */ -1,-54,36,56,44,55,48,6,-62,-2,3,-61,-50,-50,-15,-26,26,-83,40,-45,-52,27,18,49,29,-22,-6,32,68,-75,16,-40,-16,-3,56,7,33,35,-16,57,-20,38,38,3,-32,75,13,-37,22,74,-13,84,-81,16,-30,11,40,10,-3,36,-18,-6,69,15,84,103,-20,-127,-49,21,37,16,17,100,-23,50,-19,14,40,80,-52,6,37,4,8,10,36,55,58,-16,54,50,30,-39,-7,-62,-49,14,16,0,-2,-12,23,-17,-37,68,-62,49,35,-6,75,12, 
  /* [971][0][][] */ 59,-64,16,115,-1,38,1,-8,-31,11,20,-4,49,-29,74,-2,33,47,65,-14,87,41,-44,-33,-72,11,-20,35,-71,-14,5,16,-2,68,-12,-35,-1,68,-30,73,2,-4,73,22,99,44,-48,-62,3,-13,-111,86,-35,-66,-35,110,-65,4,-31,-47,17,13,3,50,-8,8,44,-73,-87,-46,72,-40,10,-37,0,16,25,-67,29,-118,27,127,-11,-35,25,100,-62,38,25,25,88,-13,21,-40,-25,-33,-63,32,-33,39,-101,10,14,-110,-11,-72,-86,31,-13,-27,50,13, 
  /* [972][0][][] */ 15,-69,21,-18,-81,32,-3,38,48,-3,-86,-31,-30,51,-29,36,-4,61,-44,78,91,-50,8,22,-9,-101,-61,82,97,95,-7,47,-89,53,92,-20,-95,27,-63,-115,-42,6,-33,-1,62,-57,58,55,106,63,26,57,73,-7,-33,-49,-11,-43,51,-117,-56,-88,-7,68,61,92,29,-9,-110,1,61,-97,69,61,-7,38,59,-69,35,76,-91,20,5,56,78,44,-127,16,32,72,-97,-84,-25,-32,-24,68,-9,12,-96,-74,66,-10,32,-14,5,-28,1,-88,18,38,8,16, 
  /* [973][0][][] */ 72,-114,4,-37,21,-30,12,-60,4,-67,4,-16,25,-71,12,-67,111,3,73,-19,-12,-15,-44,-85,14,11,76,-44,11,59,-70,79,12,31,20,49,-1,80,21,-58,-75,-52,-33,-6,-48,-20,50,-55,9,83,-17,-13,26,12,81,-49,1,35,12,72,-56,34,30,14,-19,-41,31,-21,-23,32,42,-27,-53,-49,-68,-84,21,-91,-49,0,37,35,-22,62,-75,127,0,-12,34,32,-28,11,-17,-27,10,38,54,18,17,-20,92,67,-85,-93,-8,14,36,27,72,-64,54,109, 
  /* [974][0][][] */ 54,20,0,5,97,44,-6,-45,53,34,-30,4,64,35,37,-14,34,-117,-14,18,-9,8,-2,53,67,-15,25,26,29,5,-36,24,92,9,17,-31,-25,49,8,32,24,10,53,24,65,-16,99,38,127,52,-11,-84,51,-56,-25,9,-7,48,9,-13,21,-9,11,26,42,72,-34,10,-46,-44,104,-3,72,-15,-83,-30,51,-73,81,-10,1,-49,40,22,-61,22,-80,-56,71,6,-46,-50,31,51,2,-28,87,6,-18,-55,-10,25,-85,19,26,7,-23,34,27,-50,25,-21, 
  /* [975][0][][] */ -13,-97,9,93,-63,7,30,27,98,-65,36,-27,-19,-77,-22,0,-5,-22,-68,-8,-13,-81,81,-49,-42,35,-56,-63,47,-71,-127,16,103,-37,67,-50,-14,-24,97,40,-23,27,-66,-14,43,61,-6,13,-81,18,-26,42,7,27,66,18,-31,39,25,4,76,-13,-104,5,56,-1,64,-5,-94,16,-74,-14,-51,-51,52,76,14,-13,-93,-23,54,-37,95,73,-60,29,122,-16,43,-14,-58,-1,-5,-27,50,52,99,-28,-111,64,90,-47,-57,-20,-65,13,111,24,28,-4,64,11, 
  /* [976][0][][] */ 15,3,52,36,-83,103,1,21,31,11,5,-72,-52,7,37,96,-26,29,-75,38,24,-17,-7,79,17,-77,-12,-42,57,84,66,42,-72,7,26,-18,42,-33,-38,-22,-44,-31,37,35,-25,29,-40,17,-60,23,53,38,-34,36,-29,-65,-47,-21,-9,71,-51,9,-77,-6,-10,46,3,31,11,70,45,8,15,23,-45,-43,-19,4,-20,-19,22,-54,-12,37,-48,-35,-27,-39,-68,81,-38,6,-36,15,4,-56,-10,-29,17,-57,46,30,-20,20,-127,-32,65,90,0,3,-84,-9, 
  /* [977][0][][] */ -33,-49,-32,78,29,-39,37,35,22,-28,-76,-43,-30,7,-64,64,-44,-26,-24,67,121,18,10,-49,-30,0,-32,-3,-46,86,-31,-21,26,-29,-39,21,96,-15,7,51,-81,30,44,-77,-27,-58,-29,-38,12,-72,66,12,20,-95,80,-24,3,122,-121,-81,68,37,60,-19,6,91,70,-99,-11,88,-79,108,5,65,4,20,-45,127,-29,59,41,-116,-7,53,-34,-93,-43,-54,32,-90,-91,4,73,-14,-87,-32,81,23,2,-77,-35,97,-34,-10,-39,35,-82,43,34,49,-9,-17, 
  /* [978][0][][] */ -57,-27,-7,7,-5,14,69,3,38,-28,-29,-33,-62,-1,0,-58,7,-32,-12,-22,25,18,-45,31,34,70,-60,-32,-34,27,-18,8,116,115,80,-37,-92,76,3,-49,-4,-49,33,-76,-57,97,32,-42,1,-34,-82,3,-8,16,104,8,25,50,-106,-23,-27,-24,2,5,-95,34,-71,58,-21,9,76,31,-77,112,24,-11,-50,60,61,5,64,27,-115,-39,53,-93,-127,-30,24,-18,-39,-61,-6,25,-14,9,-15,-15,91,-94,25,96,69,35,122,-64,26,10,27,-10,-4,-38, 
  /* [979][0][][] */ 127,4,-17,74,7,-106,-17,24,96,71,37,70,47,27,-33,-5,30,-14,-21,-19,16,-27,-41,18,-21,-34,-8,2,54,97,-45,16,22,63,-38,-57,19,32,-96,-26,101,-13,64,31,-15,8,-48,-24,-60,57,3,-15,-76,-6,-53,2,30,31,33,-9,59,23,69,43,-45,-40,60,-16,25,-71,34,22,30,4,39,23,-88,-24,-23,55,36,82,64,-2,-98,45,68,43,-31,81,-108,-26,-49,-11,-4,16,62,69,15,-39,-31,-57,-67,-21,24,25,-8,17,-56,52,-29,18, 
  /* [980][0][][] */ -28,-65,-69,-70,-38,95,55,26,-29,32,21,6,39,-18,8,15,-7,34,-57,-35,0,-33,-9,-4,-65,-1,-77,-15,48,7,24,42,-47,-10,19,-20,-33,-50,-6,-25,-1,1,-8,57,-127,-12,29,29,-16,10,18,-27,37,13,-40,28,27,-34,-40,-14,16,-8,-73,-4,-30,-8,-2,-75,-26,-24,69,-24,19,16,-44,-1,-14,9,30,-51,-18,90,-21,-31,-38,-51,-30,-37,4,-9,-58,-55,-67,34,34,-11,-15,41,32,-22,-50,13,44,37,21,0,-65,25,5,-29,-77,-92, 
  /* [981][0][][] */ -42,64,38,72,-9,50,49,88,-70,-70,15,-16,-50,14,-104,4,-33,16,90,-36,-51,-13,15,42,17,-27,61,-64,10,-13,123,-4,109,11,-44,54,-76,-13,56,71,33,9,-63,19,-47,56,14,16,78,13,14,-10,-32,87,127,-47,-28,-38,-39,40,-79,-45,15,-19,17,6,17,-84,15,27,-120,-85,-95,63,70,-48,-53,20,2,-13,-14,70,-11,70,-55,-39,81,-4,27,-9,15,0,-5,-14,-44,11,-40,23,77,-44,38,37,7,-45,-51,-63,2,42,-75,-51,4,56, 
  /* [982][0][][] */ -35,79,54,112,41,61,-63,4,-48,31,-45,-5,9,-7,32,-50,3,-50,-51,-56,-1,19,89,-49,60,40,-20,29,71,66,11,15,53,33,8,-26,94,26,81,24,-47,42,-31,14,38,53,-20,-2,127,53,-20,-9,3,39,23,-36,24,0,15,-49,-92,-73,29,1,-3,3,-39,-46,-36,21,-62,-34,-88,-53,37,-17,-36,-42,-106,-69,-113,11,-60,-23,7,43,89,49,106,-35,6,30,72,-9,-9,73,-50,30,18,10,51,-26,3,-47,-56,-17,45,32,-31,-18,-54,9, 
  /* [983][0][][] */ 1,-39,-10,-10,-90,47,66,13,18,24,-10,12,-12,0,24,-12,-48,-37,51,-85,-127,-14,-8,43,62,49,-30,-73,-35,-35,-50,49,51,-34,3,44,90,4,-60,55,32,7,56,85,12,-1,18,-15,-43,1,4,41,89,17,-37,-51,-38,-28,-60,-30,-29,122,-40,40,-16,-105,-21,-11,8,-59,-21,-62,-17,-12,79,37,-33,11,18,53,11,-33,64,-43,23,72,-18,21,34,-84,28,127,12,-31,21,-18,6,-27,63,5,-9,46,14,-6,-14,-23,41,1,-32,9,-6,-11, 
  /* [984][0][][] */ 22,24,39,-42,32,-50,58,-55,4,57,19,-19,-1,51,-17,34,38,-4,-35,-28,-2,1,89,-14,47,-14,-54,68,-62,4,-43,-79,-32,21,27,46,-89,24,60,-8,70,-13,39,9,64,-53,30,24,15,35,47,23,39,72,53,-58,13,-29,-49,24,-27,-38,-19,-19,-31,-127,-65,-20,-85,-33,46,-7,-16,30,76,30,-55,-7,-12,30,-61,5,-31,-27,47,-18,11,78,-11,7,-73,-29,-10,-110,-47,58,72,-38,0,80,16,39,40,-93,9,-25,-14,19,13,55,1,-4, 
  /* [985][0][][] */ 6,0,-60,61,-16,-21,-44,-4,-15,7,-26,32,-50,-76,-16,-7,102,-24,3,51,41,-107,30,60,-28,-6,-7,-11,33,-21,-70,3,-71,4,28,-59,-79,20,-2,-37,11,-2,103,37,10,33,-59,123,-72,30,93,67,-55,-63,38,51,-17,22,-14,54,-18,-8,56,44,50,66,16,45,-14,15,127,28,16,-47,-4,37,-40,-60,-57,-21,0,0,-35,-36,-7,41,-100,-22,52,-17,96,18,32,23,11,60,-68,13,-49,17,28,-63,-44,-110,-13,-41,-32,-42,30,-18,39,-36, 
  /* [986][0][][] */ -3,67,-63,-15,-9,55,29,19,68,-4,-14,-88,-29,9,-23,-61,-40,-57,20,-18,104,56,121,35,-36,33,23,-53,39,43,28,-4,61,-89,24,-48,-43,-8,8,-6,7,22,118,-4,29,-54,-4,-15,31,5,4,-6,80,-27,28,17,-78,-1,-54,-41,-40,-19,58,94,89,84,-17,16,127,4,17,-36,-33,-16,14,14,11,-24,-48,-43,-17,86,7,-44,-28,-9,-25,-54,-90,86,76,8,48,12,-44,42,-19,10,48,69,-8,-12,11,26,72,42,-77,-21,16,26,12,-19, 
  /* [987][0][][] */ 17,26,5,-50,46,86,-2,9,5,-61,98,26,-21,13,93,31,13,-42,-53,-27,13,9,-11,-40,1,-127,9,-39,76,-4,47,53,-24,-1,36,58,27,26,13,-75,28,58,-60,27,-77,17,-61,39,31,-52,63,-21,36,-13,-22,-23,35,46,-33,-9,8,106,11,46,45,25,57,-45,-7,5,29,20,-7,24,-30,-11,70,18,21,101,-14,45,29,61,1,28,-15,-50,47,17,-55,-77,-36,0,-58,28,-23,-16,-4,2,-34,54,-10,20,-37,-53,-22,49,39,-38,47,-3, 
  /* [988][0][][] */ 21,36,-89,-116,-71,-54,27,11,-71,-60,-51,9,50,23,56,-16,46,-35,-16,79,2,36,3,-32,-19,-1,28,60,-97,99,-28,-34,30,-76,19,-6,-14,15,78,9,-12,13,77,72,6,-79,-103,-127,-104,24,-94,51,-12,43,-44,36,58,2,-38,-5,-60,96,25,72,45,8,46,20,-45,-33,59,31,-17,-19,-5,31,-7,29,90,-16,-24,11,20,-31,-83,-3,-8,-18,106,2,-12,-43,23,-44,-12,17,-44,34,-1,53,-35,-19,-49,23,-24,-49,-9,26,-34,14,-43,-33, 
  /* [989][0][][] */ 39,49,5,0,5,19,-16,-24,-31,-15,-58,23,2,32,-56,-51,38,31,95,-116,-59,7,-70,59,79,-9,109,-58,-15,13,85,26,55,93,-10,47,-15,-77,-8,35,9,16,-40,46,-35,-93,64,19,-35,-1,43,-48,-44,55,78,10,-34,73,-48,19,-1,-30,27,-28,-109,-81,11,78,52,10,0,28,-29,-51,-27,62,-55,-51,56,36,72,-111,29,47,-48,50,-14,127,4,76,7,-54,-21,22,-29,43,5,18,2,-47,8,-14,3,48,122,84,-46,-48,25,42,21,30, 
  /* [990][0][][] */ -61,-3,-44,-52,44,44,110,-94,-36,-28,-36,-29,64,-65,-30,-12,-38,-11,-27,67,-41,21,6,-10,-2,30,2,-47,21,42,50,7,16,-65,75,-22,-80,-70,92,34,0,11,62,29,-20,8,26,-1,-50,-18,-17,48,32,-22,63,-45,-47,17,32,-64,43,40,-31,-29,66,50,-1,124,21,37,12,-15,12,12,-22,72,-72,32,-79,35,-4,-17,-112,-6,-8,51,85,62,9,25,127,97,115,-75,-22,-87,10,-62,-46,42,-2,75,-119,10,-51,-66,-27,-43,103,25,40,-33, 
  /* [991][0][][] */ 98,67,127,-39,-35,-20,66,-13,76,-8,5,38,104,-18,12,-14,-34,-52,-37,44,-88,-55,-18,-8,-10,40,0,-51,15,0,-24,-6,76,-45,-15,48,-16,-45,-29,-30,6,-21,40,31,27,22,-32,15,6,-14,-26,4,10,-4,50,-32,92,34,-29,-35,6,-6,-36,-8,23,-59,45,-17,69,57,-4,26,-43,24,-36,100,-52,13,3,45,-75,13,22,29,18,-19,-11,-17,-23,-16,-39,28,54,-25,82,-1,80,38,-47,-5,-53,-64,-29,-105,43,14,-29,63,-11,-59,-39,-43, 
  /* [992][0][][] */ -31,0,29,-18,-72,37,93,101,-37,-89,-35,32,14,43,-17,29,84,-21,37,36,-96,24,6,25,42,23,31,-34,-49,8,49,96,-49,7,13,43,43,41,28,-19,-18,53,49,2,-25,-40,-5,-9,-3,-47,4,-68,35,31,17,24,15,-8,5,65,62,-37,-96,-52,-34,15,-13,-54,6,37,33,-31,-27,104,50,-31,-127,-1,-6,-35,35,11,-54,-6,52,-37,-70,-13,-84,1,70,-2,-32,10,28,-25,50,85,-3,-55,-34,-35,-6,-67,28,-36,-24,-55,1,-37,-43,-22, 
  /* [993][0][][] */ 17,34,-4,-83,-74,44,19,-7,-58,50,-47,24,-35,82,-24,47,44,39,-18,-26,57,52,4,-48,59,-102,-69,-33,11,-40,100,123,-45,105,39,25,-7,8,40,9,4,-4,5,18,-3,-31,54,47,41,-20,-16,60,-5,107,29,10,36,-45,-33,19,53,-44,15,28,22,9,7,-34,104,1,-12,-6,-66,-83,-127,33,5,-6,-94,-3,-14,-22,-5,32,47,-69,-65,-7,-48,47,-109,-70,3,-54,39,-34,-20,-52,47,-22,-41,-35,37,-81,12,18,5,68,79,2,-35,69, 
  /* [994][0][][] */ -51,-31,-25,9,-22,-16,7,-34,3,-28,-12,-38,-8,12,46,-24,3,-56,-51,-25,-91,-63,22,15,17,-51,15,11,58,73,-12,-25,15,58,-13,-41,19,12,-15,17,-30,-71,43,-50,70,26,-36,-28,-3,48,-23,7,-23,-13,-12,48,-57,-45,42,4,-2,-34,29,16,47,-17,-17,-11,40,-43,-48,-26,14,41,51,-90,61,9,-6,8,-21,-44,37,28,-32,-6,-56,66,-5,-24,127,-12,-48,68,-50,50,-25,35,-78,-2,-22,-101,76,38,-23,-74,-27,32,-7,36,-30,-24, 
  /* [995][0][][] */ 49,-26,-26,43,0,-20,42,102,-18,-11,17,-46,-49,-42,-29,68,-30,11,-17,18,-40,-27,37,-12,-31,-15,-11,-58,-3,-69,61,-28,59,49,-64,-27,18,-29,-2,-44,-58,54,49,-14,64,-11,-53,7,11,-50,50,-16,57,81,77,52,-8,43,-24,30,30,8,4,-105,46,4,11,51,31,-7,-47,20,-29,13,-23,26,-55,96,21,-78,31,0,69,-113,-37,42,-23,-13,17,-10,-24,23,-84,-22,-93,30,-62,-47,13,0,82,41,30,-101,-38,-20,28,61,-4,-127,-28,-57, 
  /* [996][0][][] */ 35,-45,41,14,-20,17,16,23,-75,-23,27,-4,-46,43,-5,12,-68,-3,-45,-32,15,-39,47,-28,-44,3,33,38,127,35,33,-56,4,51,33,36,74,28,52,22,19,62,-13,39,-19,21,6,59,-21,-23,35,24,13,-16,16,-25,-30,0,-18,-34,-43,-48,-30,77,-17,50,-34,1,3,86,-35,-23,66,-39,54,4,23,-10,-4,-17,-69,58,-18,-16,44,-34,10,4,-1,-2,9,44,-15,-25,20,12,-57,58,24,-5,-68,1,19,-23,-12,52,-19,2,-7,107,-4,22, 
  /* [997][0][][] */ -56,20,26,-91,58,-23,42,47,14,-25,37,9,-60,-11,9,39,37,-52,-75,33,2,-54,72,-39,38,-4,18,68,-51,6,60,-15,17,-103,-12,-14,-32,-24,66,-36,-40,-21,16,-31,57,22,31,31,86,-27,25,86,-19,-16,127,11,40,-22,-66,-32,12,97,56,-12,52,22,-80,-72,-19,-27,67,22,-14,41,-120,-34,17,10,13,-11,38,-5,-23,-9,66,-12,20,40,8,13,-37,61,41,-17,-54,82,-92,-15,-58,24,-8,121,-72,2,-26,-5,-64,70,-27,-39,54,-56, 
  /* [998][0][][] */ -65,48,47,16,-6,-47,-6,-28,28,-24,-127,-8,4,11,-1,19,-15,-29,-26,16,-1,-51,21,-54,-4,-7,-74,42,-26,-2,93,-42,53,-2,6,-10,62,-95,-17,30,13,-50,22,63,-13,14,36,9,-107,86,-53,-35,109,82,39,33,21,-6,-23,75,-14,67,66,-30,-37,28,-29,-28,-107,2,-44,13,-44,-22,32,-10,-95,59,-125,-46,53,-2,98,-52,-5,-28,56,-27,103,-1,-32,70,-25,-55,-2,19,-20,36,58,-30,-95,107,119,-71,11,-41,53,3,-39,42,53,76, 
  /* [999][0][][] */ 48,24,17,57,13,-33,-41,21,38,62,65,-37,37,-36,48,6,92,-72,-11,9,42,-82,-32,77,-3,-6,-40,-2,54,71,28,-64,22,-7,-46,-67,41,-35,-73,39,-61,38,46,-63,-26,4,13,10,8,83,17,14,45,-15,-89,15,-127,-26,-53,-4,-24,-15,41,32,30,9,59,54,-26,38,24,22,5,4,-3,69,-1,20,-11,55,-83,-87,68,81,-25,-87,68,10,-25,45,-66,10,29,-52,-4,-15,-99,5,-49,52,23,-78,-35,-45,50,-54,87,-18,42,-2,42,14, 
  /* [1000][0][][] */ -56,51,22,-25,25,-22,40,36,-26,54,-15,-3,-30,35,-11,-16,9,-27,-4,15,-23,14,-82,16,31,-10,55,-24,78,-4,-59,63,-10,62,25,50,77,15,-31,28,17,17,-59,-27,42,-62,54,-16,-21,44,36,-18,20,66,-12,46,39,27,-69,42,25,49,45,0,43,79,-9,6,-6,24,100,46,-41,-57,42,-35,5,-19,28,-1,63,39,29,18,34,43,42,13,-7,-18,17,69,-23,4,-49,29,7,-47,23,-51,-38,-57,-20,-51,-4,27,14,52,59,-127,26,-8, 
  /* [1001][0][][] */ -49,3,11,16,52,-1,-59,33,-127,-43,55,-42,-3,6,59,-21,91,-13,-34,-38,-22,70,-53,-38,20,-6,-1,-2,68,2,53,-53,15,-41,-33,-9,3,5,-57,2,28,-34,-42,-11,-48,-51,44,-24,1,80,46,41,-9,13,-13,13,35,-66,30,18,-49,31,-28,23,-54,24,19,44,-10,-13,-29,-56,-5,17,33,15,-32,-50,1,-71,-34,19,-5,-40,-32,-41,-23,4,-54,-42,8,-37,22,-20,-3,14,27,33,-24,32,-4,-21,-83,42,3,15,-31,95,-30,-17,-8,13, 
  /* [1002][0][][] */ 23,90,-19,-36,-55,8,11,-37,18,127,-23,46,70,53,-73,31,-33,-35,-25,32,48,6,-30,-54,-1,48,-19,55,36,-15,-32,-65,-32,-55,2,2,90,76,-16,-17,-8,27,-26,-13,75,21,-1,-25,-37,-7,-37,-31,73,-40,-19,-75,32,9,12,49,1,11,1,12,12,-35,-26,-15,45,18,43,35,8,-33,51,42,21,72,-30,-18,-14,25,-65,52,22,-17,14,-62,-51,15,26,18,4,-90,53,-21,-16,-38,-40,-15,42,1,-1,34,11,30,12,51,11,0,18,48, 
  /* [1003][0][][] */ -11,87,-13,8,-15,-48,20,20,-7,5,22,-16,20,10,95,-45,-4,31,31,20,-60,48,23,-1,-11,-85,39,-25,-49,-46,57,-27,12,-63,13,-9,21,24,-4,37,-32,66,-42,-36,49,-42,12,15,-9,-21,30,-10,14,-46,19,40,41,25,-22,16,12,38,-40,6,13,-27,-33,-82,-4,49,0,-31,-9,38,-18,-3,-48,7,-69,-54,-16,10,-18,-47,50,-7,37,-29,6,40,-54,111,-93,-13,3,50,-1,-36,-40,51,29,-14,15,50,22,-1,-32,-59,117,-49,127,-14, 
  /* [1004][0][][] */ 4,67,-4,-40,-7,3,-30,2,68,-63,-80,-29,-1,93,-31,-17,14,45,46,-1,-95,71,100,25,-17,25,-8,-56,-52,60,-83,51,-79,47,-6,-57,4,27,14,32,-59,55,27,51,-85,27,-7,76,-8,37,-113,88,-6,69,-11,40,-12,18,50,14,-25,27,-35,86,70,45,32,-27,-46,-5,65,-37,11,-15,73,-35,31,14,-82,-1,-67,-15,-28,-62,-29,31,-16,67,-6,-9,-23,65,51,-15,-42,33,22,4,40,5,5,39,-54,-60,2,7,-1,55,-21,21,127,-33, 
  /* [1005][0][][] */ -33,-17,-23,23,18,51,85,21,36,-12,72,-76,-23,25,-51,-71,-2,-3,47,27,-28,-28,-7,51,118,44,-69,74,-46,-40,34,-66,1,-4,45,-104,-7,9,0,4,-37,-64,11,32,-11,-8,-41,-127,-56,-19,-42,-41,-79,47,19,-30,-42,-17,51,-49,-48,-11,10,3,40,18,39,46,46,-18,-38,-47,11,-25,-71,12,9,-49,-45,-12,-41,17,16,0,31,29,79,-25,43,-94,48,26,-23,-36,54,66,-32,-11,7,25,-3,-16,23,0,54,52,8,-18,2,-11,10,-98, 
  /* [1006][0][][] */ -28,17,72,53,-61,-39,40,10,-67,22,-10,-66,73,19,-4,-34,96,10,-58,-55,50,44,33,22,-34,-3,-37,38,20,-53,-14,41,-59,-46,127,4,-35,51,-19,-1,-11,18,77,-13,45,22,64,-17,-20,10,25,-45,-83,46,19,-20,33,-27,7,41,-20,-9,24,-101,2,16,43,-5,26,-47,-10,-81,14,26,25,15,25,-25,89,2,0,8,51,-26,34,28,-4,21,24,48,37,-10,30,23,-22,-4,6,-5,4,-3,5,1,14,-30,46,-6,36,57,-4,-47,-21,-40, 
  /* [1007][0][][] */ 42,0,1,30,-28,-49,25,-3,6,-54,27,25,28,-15,-4,11,35,47,-10,33,-29,-47,42,-10,11,12,-32,47,20,-13,8,-125,32,17,41,-30,-53,-44,-42,-40,-70,0,-14,-49,-24,44,80,31,-127,31,3,14,-17,-47,28,14,17,36,10,-3,16,15,-72,-11,-15,-26,41,-31,-16,-34,75,-48,48,34,33,-5,35,0,-24,35,-36,-53,20,8,-29,-74,15,49,-89,76,6,-56,-9,-56,58,-13,44,23,-35,-30,-6,26,17,-52,20,32,-45,-42,12,58,-26,52, 
  /* [1008][0][][] */ 49,70,7,39,-37,10,0,-110,-89,92,40,24,119,-58,-42,37,45,29,43,-86,-7,59,-14,99,-100,7,-14,51,17,-33,-69,-60,-38,28,-115,-17,-106,75,6,38,58,-37,44,-36,-34,-57,9,-3,-38,65,30,-17,10,-27,77,-55,23,-29,26,75,-77,17,64,13,22,14,-3,57,-18,1,68,10,-61,-40,40,40,-55,-17,-39,36,-83,87,-50,-4,32,31,-32,12,30,-82,89,0,109,0,46,27,-86,-41,8,-20,45,-103,-44,100,19,-40,12,110,38,36,-127,-1, 
  /* [1009][0][][] */ -43,24,-42,10,86,-11,0,-31,11,81,-55,30,-22,-5,-34,-45,-14,33,-32,47,-31,-36,-5,-15,56,-44,-39,24,73,-67,-49,85,47,-1,19,-67,-44,9,-8,15,23,25,28,-3,-1,41,37,-22,-97,-11,11,25,-74,-127,-62,-63,-15,14,-48,-7,-48,-15,31,8,50,-34,72,2,18,12,-16,-27,-20,42,-37,8,12,-113,42,32,-37,61,-13,-35,-39,20,-63,-2,-27,18,80,-16,-23,-43,-35,9,65,88,30,-2,15,-5,-25,32,26,-12,-17,53,-65,-33,-27,-42, 
  /* [1010][0][][] */ 4,51,-29,-10,-53,-86,35,38,30,42,26,-45,8,25,37,-42,53,70,31,27,-6,49,119,-21,64,17,19,40,-41,67,-24,39,-57,16,22,18,-15,-49,2,-36,-42,-5,-75,61,35,41,3,-21,36,-1,-9,46,13,-86,36,-14,-127,50,19,-5,-99,47,-15,-29,5,-70,-8,12,-37,-36,18,-24,39,46,30,-10,-10,-25,80,6,-22,82,-39,-22,23,34,45,18,30,-3,23,2,24,64,22,108,41,35,45,84,21,31,-18,8,4,-5,-26,-17,51,38,17,50, 
  /* [1011][0][][] */ 27,-48,34,18,-73,-33,21,48,25,0,-67,-62,104,-23,-9,-7,61,6,20,96,-22,-43,75,34,-50,-14,-14,49,-25,67,-49,-38,-21,-34,54,-20,-12,24,12,-126,19,-32,38,55,-16,-12,55,-13,-15,89,-23,-34,19,-38,86,-34,-73,-72,46,-5,-57,53,-40,14,-60,19,-87,5,-6,-59,-39,-89,111,-75,102,-5,-6,-48,14,106,38,20,-12,46,10,-89,26,-1,-119,-21,-21,1,-20,-28,-16,-86,-127,-66,66,65,-6,17,36,30,7,50,-6,40,5,75,-90,-67, 
  /* [1012][0][][] */ 32,-103,-25,46,-45,-39,-20,25,26,-37,-11,-17,-65,-45,10,-20,-13,13,-42,-53,58,-42,-71,17,-75,13,-19,57,-34,32,38,-34,-59,-103,-3,12,29,-90,-54,-53,23,5,102,-11,7,76,57,-46,-5,-42,2,120,2,17,-22,5,17,-45,40,45,-106,-35,50,127,-34,-127,-34,33,15,52,-55,-92,-3,-96,55,116,90,91,-58,-87,-14,-47,-60,-35,-98,-34,27,-4,-66,21,90,-1,-32,67,69,77,-72,15,-16,2,-7,-10,16,95,-126,-8,44,-19,56,5,42,-16, 
  /* [1013][0][][] */ 74,-16,-31,-74,-62,-13,127,-105,-68,8,28,15,-5,-12,29,-7,83,24,-36,-79,-125,-59,26,56,26,98,-16,-43,-79,15,-23,-106,119,-47,71,45,-77,68,15,-3,-26,9,77,-50,-26,36,40,-24,-17,33,43,-41,-103,12,-19,-3,103,-25,29,54,15,59,-104,-58,-43,33,-55,-33,-70,-41,2,83,-59,-20,-8,-35,3,-4,95,-64,3,-82,15,-17,-18,-5,-4,-99,61,-70,-32,13,-91,-7,-14,-74,97,-5,-20,37,-53,100,6,-28,59,-60,-1,105,-3,77,42,62, 
  /* [1014][0][][] */ -98,-52,41,-35,87,-26,122,-28,76,66,30,23,40,83,-43,-89,72,-18,5,-30,-17,-56,16,17,36,17,-112,-44,74,-22,-4,-65,2,-54,20,54,-17,-46,13,-23,-72,23,-49,-3,15,-1,2,5,-41,21,54,42,56,23,0,-2,-37,119,-107,-47,76,-38,-13,-47,74,9,40,6,-21,26,0,4,77,2,-127,85,-24,5,19,43,31,-76,30,-43,-62,-68,16,15,-18,-9,-21,8,-60,-51,-61,-15,58,-94,-23,14,-19,81,-1,43,-3,-28,-36,-63,16,22,28,50, 
  /* [1015][0][][] */ -35,54,5,-47,-45,-57,59,46,51,73,31,-114,-26,65,-1,-61,-69,-37,46,-45,41,52,-127,-7,-4,62,58,-29,26,-83,34,17,-1,-61,12,-39,11,-19,24,-13,74,-45,-15,-13,64,-17,-58,-14,31,-15,9,-17,36,52,1,-96,-94,-9,-29,-25,15,47,98,-82,-82,-101,-49,-53,-38,-4,26,36,20,88,-15,3,27,28,-5,-6,-10,88,18,99,-101,-24,39,-49,-78,-16,-9,15,41,-17,89,-11,23,56,-108,25,-29,-17,18,-66,-33,37,60,81,37,14,14,-103, 
  /* [1016][0][][] */ 22,-32,125,22,6,13,24,-5,-16,-38,-26,-12,41,23,68,-11,-40,42,-55,-20,-81,-34,31,30,-16,-22,14,61,-3,-37,-29,92,-33,-57,88,10,81,-45,22,50,58,-4,-12,22,-27,60,37,43,86,80,-33,56,23,-47,27,46,-41,-34,-58,22,-48,-79,2,53,27,-33,-14,-19,23,-71,-9,-16,118,-25,14,28,-23,-31,57,13,-52,-43,36,8,-5,127,-52,22,14,-48,20,-30,83,-52,25,-8,-12,-22,48,11,47,-14,22,-59,-51,17,38,-1,-93,-7,24,28, 
  /* [1017][0][][] */ -76,8,22,-56,-36,-9,12,23,-66,-48,25,-5,-127,-89,20,15,-64,-11,-80,-76,-11,3,-27,-47,-3,-78,-30,26,-23,-81,50,-45,13,7,-46,-8,-64,-38,25,3,-29,-2,-37,79,55,46,11,-39,-48,-20,-2,-3,36,28,31,-20,-94,46,-66,52,46,110,-24,-38,42,-26,-49,-62,57,60,73,0,-5,-16,97,-57,-56,35,12,38,21,57,17,-11,56,-63,13,-111,6,-33,35,-38,76,39,-5,3,29,-11,29,14,-23,10,-37,10,44,-3,20,-10,-50,-32,70,-61, 
  /* [1018][0][][] */ -31,39,-26,-5,37,55,22,13,17,23,4,25,33,37,44,11,-23,18,29,-3,-19,48,27,31,-8,7,-24,-62,9,30,3,-73,-14,62,-32,-53,-89,-20,39,-24,-15,-56,33,61,-1,-18,57,-91,-57,-41,-29,-37,62,82,43,-11,31,0,-65,36,94,84,-7,-3,-34,24,48,-49,1,10,-99,-9,-14,-20,-52,55,-29,1,-11,10,4,39,-20,-29,-22,6,-6,-64,37,34,102,-17,46,127,-19,32,1,-118,-1,-57,-29,-17,39,-111,67,-92,-84,5,-29,1,-32,-16, 
  /* [1019][0][][] */ 60,-29,26,-16,-8,-16,14,-23,13,19,42,-68,42,6,18,39,-38,78,12,3,-25,-12,-17,14,41,30,-7,25,-43,-21,24,91,-1,-16,5,59,5,2,-40,-20,45,-32,-59,11,8,9,32,-25,-56,-32,-14,-22,12,35,-2,9,18,18,-3,-28,-43,44,5,-32,48,-27,39,-27,-35,-11,-24,46,21,14,20,-25,70,28,-7,28,-3,-18,-2,62,6,-39,-5,47,-13,-4,-81,-14,-28,14,37,0,25,127,28,-22,28,27,6,-1,60,17,-45,-36,-41,14,15,35, 
  /* [1020][0][][] */ -4,-3,-33,8,-41,33,-23,49,-27,-19,46,-14,6,-69,25,20,-7,-4,-51,-22,-8,-3,-32,6,-27,-29,5,-43,-70,0,1,-45,16,-84,10,-65,27,-4,-8,20,26,6,-5,33,30,-9,2,-17,-3,18,-14,0,49,-22,57,12,-35,-33,40,8,-49,47,-3,-12,-4,-19,34,15,21,-47,-25,-20,-9,47,-9,127,40,-27,5,-27,-30,-34,-34,-53,-8,79,36,29,-35,21,24,18,21,11,60,5,28,4,-41,-33,15,-16,-63,-22,27,-49,-13,38,-33,-72,-17,7, 
  /* [1021][0][][] */ -65,-2,64,27,94,35,11,-6,32,48,-62,31,-8,21,40,-29,7,-17,-4,-1,14,-29,-1,-42,14,62,-107,-56,17,75,68,42,51,-52,26,16,-39,66,25,-17,-11,-7,-50,-19,25,58,98,56,-47,-44,-16,6,74,-83,47,-42,107,63,-5,4,31,34,-29,127,-9,-70,-29,57,-3,16,-87,81,-32,-14,-38,-46,37,-28,61,-46,-88,12,-47,-44,15,9,1,-19,50,-65,23,-10,5,-62,-14,-21,50,75,-12,10,-74,-25,19,37,-54,-22,19,-35,54,-66,4,22, 
  /* [1022][0][][] */ 55,1,-11,13,-11,57,67,-75,21,28,-84,-29,67,4,-38,18,19,35,-33,-25,-57,17,-19,-18,-41,-32,13,-1,13,-55,54,3,-15,12,-16,-53,44,-14,10,-28,-5,63,9,8,-15,9,40,-3,-46,17,-30,-31,66,37,8,-60,-7,-7,15,13,-65,28,-29,-57,-70,27,-44,69,10,-29,-81,-55,-24,38,-60,-11,12,-48,-33,-28,-67,31,-43,11,-6,16,24,-6,-31,16,-20,-35,-24,-43,-29,41,20,8,40,-23,9,-60,11,34,127,-28,15,21,-35,-33,-11,4, 
  /* [1023][0][][] */ -14,-23,17,-42,22,-50,111,40,-93,-23,11,-67,-26,-30,25,48,-20,-37,-5,-76,36,39,36,-3,24,-26,-20,58,-39,47,20,-39,-41,39,41,91,8,74,79,-27,54,90,99,17,37,62,-52,39,-86,3,-49,40,-127,5,28,-3,-1,1,53,84,76,28,18,31,-11,-11,59,-15,12,21,38,6,3,-31,-8,-66,35,107,-36,-68,31,27,-35,-45,-79,-19,40,-11,30,56,-1,39,13,-7,-26,-30,-15,55,5,109,-3,116,1,-50,8,-38,56,34,44,22,22,-4, 
  /* [1024][0][][] */ 49,-43,-17,76,10,-50,79,-14,-17,-9,-45,93,18,-29,21,30,40,-8,-42,-43,-9,-6,53,-37,29,-42,95,34,5,-49,6,55,10,-29,122,-40,-91,47,86,42,59,0,-38,-35,-48,6,23,28,-36,4,7,-40,-6,-37,9,-19,-2,-27,20,-70,59,-4,-41,2,12,2,-44,-44,-28,-38,-41,-14,79,-54,-89,-26,82,62,89,-41,-36,17,36,4,46,49,5,-5,-54,-47,79,32,1,0,-51,-23,-2,47,-13,-45,-20,-39,24,-59,3,-16,-54,127,-18,30,3,1, 
  /* [1025][0][][] */ -45,34,39,-9,-12,-11,-12,118,45,-127,7,-48,2,-24,-9,-30,12,1,81,-5,-76,25,23,13,-68,-2,-67,-32,-33,24,19,13,9,-2,-3,23,21,-20,31,38,-113,-105,-2,-71,-21,26,104,-44,5,-32,-96,-18,-38,20,111,90,71,-18,76,21,15,10,-23,46,-22,-29,48,-14,-12,-22,-19,-35,-60,101,-6,61,-20,-4,-44,-74,-60,-5,78,38,30,1,49,-26,-37,17,-27,-96,-62,45,-25,46,-76,-41,51,-22,-40,-44,-59,60,-5,-2,46,69,-18,41,-81,-44, 
  /* [1026][0][][] */ -27,23,-47,-77,30,16,50,-17,-2,-38,20,-24,77,18,24,-103,-127,30,-74,1,69,-46,67,-37,-13,9,34,58,-27,-34,111,-55,-86,-42,32,-34,-55,-25,28,29,53,81,-59,-9,1,-118,9,-47,26,-68,52,98,29,48,12,-90,12,-69,0,-92,-16,-31,-3,-61,18,59,-63,-69,-44,-40,-23,-1,-21,-33,-62,-16,3,-28,5,21,23,-70,83,-13,74,-31,-6,27,50,-10,-47,44,98,-82,-61,27,-60,34,2,15,-19,-18,-10,12,62,-39,52,-10,0,34,55,-80, 
  /* [1027][0][][] */ 13,67,-87,13,75,33,8,-43,-31,7,37,-37,-21,-30,-43,-17,71,-55,-59,-75,15,32,57,33,-3,55,33,33,55,41,12,53,-50,-9,-52,-93,53,59,15,-32,-27,21,5,-1,40,-44,12,59,0,-10,-33,41,-39,-24,6,-34,86,-36,-13,-33,-1,91,-32,-80,4,-14,-22,-34,37,-51,20,-86,21,-43,-78,-39,-3,-34,2,-19,-39,39,7,-16,39,-20,-56,127,-27,-103,-42,-94,2,-74,-3,113,-56,-12,-49,92,1,87,77,-8,68,65,-18,-13,-18,-17,14,23, 
  /* [1028][0][][] */ -22,44,11,-35,-20,41,24,4,-53,32,10,-21,-19,-32,68,-42,-15,26,-25,-6,-14,58,9,-13,-2,33,-50,-1,29,31,-52,-5,8,7,40,-13,-12,-2,12,6,26,-34,-38,-23,127,-18,2,23,-21,-31,-2,50,-37,-19,-41,3,-7,8,-14,-52,-50,31,1,28,-1,-45,-58,-79,-59,-4,-5,46,32,-13,22,16,6,-14,8,42,14,-49,-73,24,54,2,-22,55,-15,57,-78,-34,9,6,51,-8,26,38,46,56,-5,-1,-8,9,14,22,3,-11,-24,12,40,-7, 
  /* [1029][0][][] */ 35,30,-30,-24,-22,74,17,5,-30,22,29,0,62,6,19,-48,2,-40,-3,33,77,-26,32,-19,-6,127,-57,-4,-20,-1,-21,7,22,7,21,63,37,-14,7,88,29,12,42,-50,-24,4,32,-12,13,-19,-29,17,33,-5,-6,-38,-27,-18,11,-29,43,60,-60,62,35,99,0,-46,-60,-52,-20,-26,42,-7,11,-80,-4,33,29,51,-113,38,31,1,19,-3,-30,-2,26,-83,-23,53,17,17,9,-10,21,8,13,59,7,-47,-26,-11,-2,-23,-20,-19,-13,34,41,-9, 
  /* [1030][0][][] */ 22,-102,78,27,45,6,11,-76,-10,10,-10,-1,7,36,31,-35,86,-32,-10,23,-32,71,68,54,73,-16,-96,-102,-89,-78,-18,27,-49,-80,0,27,22,0,49,88,50,92,25,9,-60,6,-39,-35,-76,-99,25,-4,-7,-26,-5,106,-76,26,-8,-44,-9,33,18,31,-77,-51,2,3,-51,30,-5,83,-12,30,46,-69,-8,-1,-127,57,5,8,-32,29,-63,-35,98,-28,-67,-94,-38,54,60,-51,-39,53,-17,-18,104,71,13,-35,-4,-94,59,25,12,45,-29,-8,77,36, 
  /* [1031][0][][] */ -6,12,-64,-55,82,66,20,-43,24,-40,-4,21,-1,-50,39,-5,62,32,-17,33,52,40,-11,-9,-35,-16,32,-16,-1,-6,-51,53,-40,-127,-1,-59,-86,-107,-93,50,-6,3,-32,-17,0,1,-86,-10,-62,1,20,-31,-34,-21,7,-4,2,2,-70,-111,6,5,66,-56,7,18,19,-42,-13,97,-30,30,-6,-2,22,-7,24,20,-100,-5,3,29,-11,1,-34,-7,59,92,35,52,30,13,45,47,33,29,-34,21,-86,-28,-53,30,-56,-24,-68,-2,-4,31,-41,-5,-35,-46, 
  /* [1032][0][][] */ -28,-55,-58,21,-23,-33,-2,27,-40,14,37,-4,20,34,-25,-4,26,94,-52,-69,43,33,25,63,46,-77,-35,25,-56,-8,55,31,-114,33,-18,-12,-33,-36,-10,-22,41,42,-74,-53,0,-48,98,-6,40,-1,46,55,33,35,-6,-45,-17,83,26,-93,65,-24,-58,23,-69,-22,-65,81,-49,-9,-66,9,11,16,49,13,-12,-10,24,-50,-34,66,-21,-44,59,61,-13,45,6,-19,49,11,-26,-1,-21,-68,-56,24,127,4,5,71,-21,36,4,-116,8,-58,-30,-65,14,-18, 
  /* [1033][0][][] */ -68,-28,-44,49,2,-47,55,-2,-27,-127,36,21,-51,-3,-11,-41,10,-61,13,-72,25,47,96,4,62,33,-124,-72,66,48,-33,16,34,-70,7,-42,-26,67,-83,-2,95,26,63,-59,30,28,13,-33,73,-118,-90,92,-22,92,-76,27,57,-49,-61,49,-97,-15,43,-21,29,16,69,-101,-3,-79,63,53,-6,-42,-48,32,-15,22,-36,5,-18,-4,-32,27,-38,31,-9,-9,26,9,-42,-24,46,57,-82,34,-26,-8,-7,-3,-42,3,-26,-83,-22,87,12,43,-17,17,-27,35, 
  /* [1034][0][][] */ -1,33,-33,-12,20,-39,-15,48,-28,-15,-50,-7,25,-19,-59,-46,19,-6,-65,-24,1,25,30,11,56,-41,0,0,53,-16,51,-16,-10,-66,8,33,36,-83,46,54,79,-89,53,-83,57,-36,76,-47,-37,-50,-3,56,98,-95,6,-48,-14,-27,0,49,-127,86,-33,16,-10,47,-14,-68,-39,-38,-5,-67,53,-23,18,-80,-80,-65,52,-43,-19,15,43,-17,19,-52,-43,-68,8,36,97,30,-76,9,-26,-26,-75,-45,55,-54,-43,-38,21,13,25,57,18,126,39,51,-35,-80, 
  /* [1035][0][][] */ 16,-58,10,13,-38,-24,18,5,9,51,-12,-64,3,-36,38,29,-43,-14,-16,27,-10,23,15,59,-14,48,69,-32,4,-10,-42,21,22,-43,4,91,-51,60,-12,-127,37,-24,51,46,-15,11,24,54,11,-11,-59,11,-61,90,59,-47,-3,0,20,-10,69,3,76,-89,21,24,-45,28,12,-6,-65,-18,-69,45,93,14,10,98,45,27,68,23,-40,24,16,-89,-38,-37,-44,-31,33,-9,-81,71,52,-6,-54,-38,-44,-31,21,-20,-33,51,-11,-6,-70,-7,85,-36,-6,55, 
  /* [1036][0][][] */ 33,19,6,14,9,-127,19,-19,-127,93,70,29,-24,-29,-62,43,-86,-9,-27,-39,-13,-26,-2,-55,50,51,-7,-60,78,76,-47,23,-33,-5,-57,-78,-63,18,-116,-39,8,11,13,2,-76,-9,31,2,-78,33,-26,-32,56,-17,29,0,-27,1,-96,44,-30,9,14,-36,-14,-91,-33,43,-82,50,-41,-1,-50,41,96,-39,-56,30,-28,86,17,-34,-41,-35,-17,-23,-40,-84,60,-22,-67,56,-53,5,-36,-20,-55,74,27,10,33,-18,92,-69,-28,87,95,0,-53,-68,71,75, 
  /* [1037][0][][] */ -78,-91,6,1,44,-25,-11,-14,59,61,41,-29,89,69,-28,-84,66,66,-78,37,-23,-61,48,51,-23,14,15,-7,20,-36,33,127,70,-47,120,-3,116,-112,49,71,-36,33,2,46,40,-100,57,47,50,44,-88,-52,-87,-7,-14,17,-41,-70,112,-44,-7,-15,-74,40,-96,-72,110,39,-4,-29,-26,10,-9,26,-23,-25,-58,6,-3,118,-67,-6,-19,46,-97,30,-22,-69,42,60,31,63,34,-60,-6,-58,71,123,15,28,9,59,-18,-17,-46,-68,-70,65,63,72,-77,6, 
  /* [1038][0][][] */ 31,-43,39,20,-75,5,46,5,-22,21,-45,32,-42,42,12,45,56,-77,-54,-34,41,28,-28,49,-24,1,9,-53,59,53,-44,-127,16,22,29,6,-78,35,-1,21,19,11,-32,-25,47,-23,-25,-52,-9,-45,5,-51,12,-46,25,6,-36,28,41,-59,25,12,81,-79,39,-8,51,-42,-11,-10,62,14,-35,44,-17,61,1,33,-7,42,47,-19,42,8,22,17,-55,48,-12,7,8,-38,15,-54,-61,85,-19,63,-28,-6,-36,-34,5,-26,13,-18,-53,-15,27,46,10,-22, 
  /* [1039][0][][] */ -62,-2,-15,-127,7,-52,-6,-28,20,-46,-23,-29,-14,-70,14,6,-2,-111,-6,67,-12,9,44,8,98,-3,2,-4,34,31,-97,-25,6,41,11,-20,-5,19,41,74,6,5,21,1,-62,-4,-25,-1,-51,-49,-6,9,28,1,21,-11,31,-18,30,27,19,7,-68,-41,22,-22,-13,17,24,-29,-78,64,13,0,-34,-31,31,119,-1,0,-61,32,-39,72,-58,-29,-35,47,31,12,-9,8,0,-80,-10,-38,16,27,-47,82,12,59,35,22,2,36,-26,64,20,28,-68,35, 
  /* [1040][0][][] */ -20,-13,-4,10,22,28,15,-57,-46,-31,40,66,-12,-9,-20,-69,7,12,-30,35,-9,30,-5,-27,21,-28,63,-23,30,-37,24,10,108,28,-11,-10,80,-72,82,116,26,9,-37,58,-2,-45,18,88,-13,28,-25,-13,-45,-103,-29,60,80,-26,67,-11,-68,118,-89,-32,-54,68,21,-80,79,-13,-36,74,-41,-70,-73,23,12,-14,-84,-108,0,56,-7,29,-72,66,55,127,35,13,27,32,-32,4,-9,5,-66,10,14,-2,57,20,-58,7,-84,16,20,-25,-49,-23,27,-29, 
  /* [1041][0][][] */ -62,-20,-25,-9,47,1,-23,-7,48,-127,-4,-110,46,-18,38,-42,17,73,10,-15,43,45,5,0,-3,31,-4,26,7,-13,-20,3,-39,3,79,-36,83,-18,88,-23,13,-22,-7,-41,-37,-35,32,22,9,55,11,41,7,-10,37,18,-1,-19,-28,-35,-22,75,39,-46,16,47,-10,-23,38,-37,10,-59,56,21,-20,38,-24,-22,59,-4,-4,-12,-34,-51,78,11,-17,-25,32,37,18,7,39,-2,-26,-6,56,-15,-31,60,-39,-51,37,56,-40,40,-13,-30,1,91,25,-29, 
  /* [1042][0][][] */ -29,10,-23,55,9,-30,-3,18,-41,4,-51,59,-36,57,12,-22,29,-24,43,42,-14,-7,30,24,40,-79,-20,-12,-43,-31,8,-76,28,-61,-13,37,-36,21,21,-20,36,-21,-27,20,-5,-71,39,19,-36,7,127,78,-43,23,39,-101,99,-12,-27,70,-15,-42,-51,-32,-33,-1,-41,23,35,-53,63,-12,-14,-65,23,34,-115,6,56,-10,6,76,95,-49,119,21,44,-35,97,-65,-38,11,51,-16,-6,43,4,-69,24,16,-15,-18,-16,-105,34,-34,2,27,69,-71,-40,56, 
  /* [1043][0][][] */ -7,-52,46,40,-32,36,-51,-36,32,68,1,-23,60,15,-16,60,-13,35,-13,5,35,19,-8,-24,-1,-107,-127,-66,15,-51,17,50,-14,13,-16,-16,-8,21,13,-1,42,-21,-44,-3,16,10,20,45,-13,-22,38,-43,2,49,-60,-26,22,6,-23,-52,-33,27,54,11,35,5,-29,-15,40,-19,-3,58,1,26,-49,-56,-6,-3,-13,-65,-1,-40,68,38,54,58,16,83,19,-10,-15,62,-82,-18,-20,31,23,12,33,-11,76,-71,4,-3,-3,42,25,-18,-46,-42,-6,54, 
  /* [1044][0][][] */ -67,-54,-116,-98,65,-52,4,-103,1,-1,20,-53,-5,32,-49,20,11,28,-4,34,-32,79,38,-40,-9,37,-22,105,-127,-65,-23,-40,41,-70,61,-8,-21,-32,-28,96,20,-28,-73,5,61,99,-21,16,-22,-80,-40,48,22,-19,-12,-1,7,50,-16,17,6,34,0,12,2,-45,-6,-38,38,-45,63,-2,-13,68,46,83,37,-42,40,76,5,92,15,-16,-63,23,37,40,-115,-60,-10,-14,20,-38,16,-47,-27,115,23,41,-38,-35,0,22,31,-87,18,-17,30,84,-39,-30, 
  /* [1045][0][][] */ 28,4,-5,39,-6,4,68,-33,31,-48,-18,48,63,9,90,-31,-1,33,9,28,12,43,60,-38,-127,-43,-5,81,-9,-43,-8,-74,-31,-88,6,23,-48,16,-55,-11,12,-45,42,16,-35,45,-21,77,-86,-92,-28,-22,-14,-38,12,-11,38,44,26,-22,-19,60,-25,-25,5,65,43,-52,25,-15,3,-16,109,34,-33,83,-10,31,77,-98,-35,-47,58,34,-27,33,8,2,23,17,-7,-22,-6,29,-20,79,-2,-53,-20,-19,71,18,18,26,42,35,123,33,65,36,43,20, 
  /* [1046][0][][] */ -8,-3,34,21,-127,-25,-116,6,-18,31,-28,24,-42,-63,121,22,69,123,49,-83,77,26,19,51,-70,18,33,72,-55,-87,61,88,15,-13,6,84,-113,47,20,-98,-69,38,-72,-37,-52,-1,123,3,55,-13,-57,-7,-21,-95,-82,49,23,-114,-9,88,0,-67,-63,-65,-17,-85,-68,19,65,-111,-5,-58,15,16,12,49,1,-66,53,-20,31,-64,-78,-25,-47,98,-52,-106,15,89,5,30,46,-44,86,45,5,-56,-48,47,-38,-76,126,-28,-66,53,103,-27,44,-8,-43,-16, 
  /* [1047][0][][] */ 50,53,-20,-25,-54,25,-4,9,2,84,-41,-18,42,-83,12,-43,-31,-56,-45,1,20,-29,37,4,-72,-18,69,-79,0,-25,-38,-49,39,-15,-30,0,18,-8,5,27,48,-26,38,1,46,73,-27,21,-45,46,-31,16,-52,-43,-23,45,31,-109,41,-17,2,77,26,-20,29,-30,36,21,2,69,-39,-9,-19,4,-33,18,53,42,26,-15,-9,23,-36,-61,32,-26,1,-127,52,24,8,62,52,-6,-1,10,36,-28,-43,-20,21,-27,61,86,3,-52,50,-25,44,0,-14,-6, 
  /* [1048][0][][] */ -19,6,10,19,40,-56,28,28,14,23,-9,127,8,-78,-87,24,25,-38,55,-55,1,22,-8,14,-102,46,-14,-33,12,21,94,16,6,-57,76,61,-23,-3,79,0,-6,-104,35,37,-23,19,21,-40,-33,-42,25,29,-41,-17,63,4,122,-6,-19,-75,-52,112,-37,-62,21,-63,116,-50,34,34,3,-43,0,8,-29,114,-58,-50,78,-45,91,-1,-7,-68,-48,-10,-64,-44,-13,-69,-24,24,-12,5,13,52,2,86,-14,10,-47,58,70,-60,18,-84,-26,-5,-95,2,-43,-78, 
  /* [1049][0][][] */ 75,-36,17,-85,55,-57,37,52,16,-14,-26,-56,7,-32,13,-12,-31,23,-35,62,-17,-39,-38,55,0,-9,83,-71,18,30,68,1,0,52,-2,11,5,-95,21,83,46,-12,43,29,4,10,-40,-22,-2,-55,-2,-14,86,-10,-13,-3,-27,107,-37,36,-49,42,-17,-43,1,-15,11,-3,-16,69,127,-32,43,91,4,-66,21,-25,14,13,79,13,-75,-36,-86,-63,21,68,-64,45,67,-18,-121,-11,46,-22,-110,-81,-31,-108,-25,22,-18,-63,-8,-45,-41,5,-116,22,-13,-48, 
  /* [1050][0][][] */ -29,-33,-72,-1,-26,-33,4,13,10,48,27,16,47,45,49,-37,-24,49,-73,18,20,127,57,-12,-102,-20,28,5,-58,57,5,-24,15,-29,-30,40,49,4,47,69,88,-99,-94,16,52,-53,24,-21,36,-1,-32,-37,10,45,51,-32,23,63,30,20,51,0,-124,49,1,46,13,33,-113,16,32,-13,-12,78,-7,30,75,-46,61,-92,3,-7,48,-60,81,-11,5,75,39,2,19,-31,-56,-44,-4,120,-42,53,53,28,-16,-13,22,-49,-12,12,13,48,99,-66,90,55, 
  /* [1051][0][][] */ -14,-53,-87,0,-4,22,-38,22,57,-70,11,52,-28,58,50,-59,-39,-50,23,0,20,57,-36,-23,39,-8,3,-12,5,-30,34,127,18,-18,26,43,90,-25,-118,37,-13,29,17,28,60,-41,-40,-46,53,22,-47,31,43,61,-40,20,-19,-41,25,17,-14,-90,45,11,36,-31,41,15,6,18,-42,9,-21,61,14,-14,-47,-4,48,61,69,-59,21,66,-17,71,-10,43,-2,96,31,-33,-39,16,40,69,-42,46,-15,-65,12,64,-35,83,-81,-80,20,-85,63,-8,-22,53, 
  /* [1052][0][][] */ 28,-36,25,78,127,-85,12,-2,-36,24,3,38,34,-2,-2,-54,60,22,56,3,1,-4,27,-5,39,23,74,-51,14,44,-6,40,-17,22,5,-1,-24,-26,28,46,-18,23,15,-24,41,49,2,1,38,-5,42,-14,108,23,9,-28,46,-51,20,-49,-8,50,-10,-38,33,49,1,24,-18,-13,6,26,17,-6,3,-60,12,36,44,-38,56,-2,-25,4,-15,-91,-48,-40,-23,98,-36,-61,22,1,48,-32,-3,-28,-73,-56,-24,17,32,-77,-29,6,7,-10,-25,-29,6,38, 
  /* [1053][0][][] */ 9,30,-48,13,-28,-3,-50,8,-28,6,49,28,31,34,-15,91,1,-24,-23,20,-28,-45,-42,-15,-31,51,-43,-48,-35,8,-28,2,-49,30,-16,15,15,19,9,15,-4,24,-29,53,-24,-47,-63,15,27,-28,76,43,-59,-59,21,-45,-12,71,1,-72,43,-15,37,-72,-38,-34,-20,1,-73,-38,-58,44,-69,29,8,97,-10,127,2,-26,21,-44,3,-42,-48,-77,-2,36,-14,-27,-44,-51,17,5,-13,4,-67,-24,-24,-14,-68,-18,43,38,28,-47,-38,67,-15,-16,-4,17, 
  /* [1054][0][][] */ -40,-22,37,-48,26,28,15,12,-3,-9,2,60,-43,-21,-47,-34,-12,-11,-8,15,-71,-43,33,-49,127,-15,-51,-38,21,-67,-9,3,6,-38,-42,29,25,32,-5,-13,-34,-56,-11,-31,-33,78,53,30,7,-44,49,13,-9,-58,18,35,24,18,22,1,-14,19,-19,0,-51,-44,-10,-86,12,9,35,55,28,44,-1,-73,4,-60,-1,9,6,9,23,-16,17,21,-5,36,-45,-44,-13,-40,-88,17,-2,-31,8,13,26,-73,-22,18,-39,41,12,24,23,86,-54,-4,-31,31, 
  /* [1055][0][][] */ 66,-57,77,22,-59,-43,-14,3,-12,-98,89,-69,-5,101,73,-62,-12,-32,-31,30,63,7,-25,39,-70,41,-10,83,50,39,35,42,48,-56,40,17,-90,-47,-61,100,11,34,-16,6,30,66,-20,-22,-16,-23,-11,10,68,102,-47,-24,-12,-22,39,36,-2,66,-77,27,-28,22,51,-47,-95,-15,-19,-127,4,-45,33,-33,105,7,-40,7,89,-38,-45,-6,59,50,-4,45,-3,11,9,-17,-59,-86,87,-88,-20,59,54,43,-4,-89,25,-58,-48,-70,44,106,40,4,-51,107, 
  /* [1056][0][][] */ 24,-20,-5,-21,56,-11,3,101,-8,-69,-8,-1,31,0,34,-83,47,75,12,36,50,12,2,-17,-3,-68,-42,-5,-27,-9,-14,43,-10,42,-7,-2,46,-7,-40,-11,4,-28,-31,-44,3,115,78,20,-49,-84,-15,29,35,62,-2,-18,54,62,47,-27,56,54,4,-52,1,29,-17,28,-66,-34,-49,-17,9,-36,45,-44,-45,127,44,23,-36,26,-15,-25,3,-32,8,-2,55,33,-38,-72,27,-49,-49,-9,21,15,44,30,-29,-58,33,46,-52,-56,7,-3,31,45,56,22, 
  /* [1057][0][][] */ -36,14,63,49,100,5,38,-84,-23,88,-68,-32,-32,-60,19,-76,26,30,-41,71,-8,-64,14,31,25,18,-33,-11,8,-7,-71,47,-29,95,14,-21,41,50,11,-61,34,-90,-43,-7,31,-38,71,70,-48,-12,-6,-37,-72,-36,60,-3,-8,1,14,42,-81,-32,-8,-16,25,58,-95,21,24,-85,44,38,-63,-56,63,15,93,36,44,-41,39,-19,37,3,47,46,25,13,-36,-64,127,4,-50,9,59,29,80,-43,-65,3,22,-21,25,-31,-20,77,68,5,-81,-41,67,18, 
  /* [1058][0][][] */ 39,-126,-35,13,50,65,25,88,-37,18,-61,-25,-13,69,-16,71,-50,-63,-16,-56,8,-87,-78,4,108,-40,-43,3,-10,-74,-14,31,-38,38,-13,-55,30,54,16,-41,12,43,48,-44,8,7,-44,-49,6,-23,116,20,1,36,-52,68,-14,-11,19,51,99,-47,63,-74,35,-39,-69,94,-22,-67,32,2,-127,-65,-102,-28,-3,35,13,-19,75,-72,-69,-32,-8,-30,29,-23,-66,46,79,86,60,-74,40,-44,-19,-34,-60,7,-26,2,-37,-11,-56,63,-25,44,50,9,-52,2, 
  /* [1059][0][][] */ -1,10,0,-28,5,-71,19,42,-45,-1,-51,-55,-18,59,-30,-22,37,24,-61,-45,-30,-54,34,-59,27,48,14,20,-15,-25,67,8,100,16,-27,45,-11,50,-29,-1,70,-40,-47,32,-6,44,-40,-63,-8,64,1,16,-82,18,80,64,3,-37,25,45,45,-8,-21,-1,-11,-58,13,-19,-43,13,29,11,4,-45,36,36,61,51,11,-4,47,-46,-34,-127,-23,24,-12,47,39,-37,-58,0,10,25,24,78,25,29,37,-26,77,65,12,-58,7,36,-1,-7,12,-23,25,-16, 
  /* [1060][0][][] */ -24,-15,-38,-5,10,-29,29,41,21,-42,-21,-49,-67,-4,-28,24,29,-39,-63,-33,-29,-33,-71,-18,18,-27,37,19,-18,-3,4,35,-4,-11,-29,-14,29,-18,19,36,17,-22,3,46,-6,-36,62,19,47,-45,-20,-17,127,0,4,30,-32,41,-12,46,-39,-39,16,-20,8,-43,20,-20,-21,-15,-24,15,-54,-48,-10,-17,-7,32,2,-48,18,16,-60,40,-46,-18,-46,-14,-18,-19,22,23,1,-28,-14,-36,-6,19,-23,-10,6,16,-7,-19,-7,7,31,8,12,43,-16,16, 
  /* [1061][0][][] */ 26,-60,46,-4,31,44,4,-15,-31,24,-39,-16,-1,0,-37,-14,-4,14,9,-27,-43,-21,-19,-34,45,13,-6,28,15,-15,-21,71,-35,5,8,4,-39,-42,-6,40,-38,60,43,11,-27,57,11,75,29,-2,-44,29,-5,64,-26,-20,-32,45,-7,-67,-71,-27,11,-3,-69,-26,-84,-73,32,-36,2,9,8,17,-26,-22,-25,-4,28,-12,127,-8,-26,45,12,-31,-48,36,18,-9,-76,-41,31,38,47,-84,-2,-9,1,5,-56,-13,43,18,-96,66,-26,65,-98,52,-63,72, 
  /* [1062][0][][] */ -9,39,8,-34,-43,66,-77,-91,28,4,39,-11,22,25,16,48,7,-33,-34,-33,-27,28,-14,41,-34,0,-41,-78,127,-37,10,-15,-30,35,102,-12,-21,47,52,10,19,-61,8,1,-5,-10,-1,-5,-35,-26,9,-46,11,-28,16,-12,-28,-22,22,29,59,-30,17,26,-73,-87,-1,33,96,64,92,-45,-17,-26,42,-19,9,9,113,15,40,-32,-17,-85,29,12,-32,25,-41,27,24,87,-11,-39,-15,-39,45,-44,-48,14,-28,28,30,18,2,45,-47,34,-22,3,13,-22, 
  /* [1063][0][][] */ -34,63,-110,42,13,85,-16,39,-31,2,-34,-8,-41,13,-44,-32,84,-8,87,-26,-60,-3,-85,76,58,-41,-15,-6,-48,6,-16,13,-9,31,83,9,3,11,94,-31,-117,-71,-4,20,75,24,-30,67,-11,46,-25,-40,67,17,6,-100,-19,-51,-34,71,11,-26,60,-41,-77,121,25,9,-31,70,127,21,121,-98,83,-70,27,-34,-84,-59,-55,-5,-29,-28,29,-105,-71,2,-32,-32,9,24,54,20,-40,-22,-110,-2,15,31,14,-33,57,-48,-45,-57,27,44,-78,78,7,-75, 
  /* [1064][0][][] */ -66,108,-60,-5,53,13,116,57,56,-40,-63,26,67,-36,0,56,95,-12,68,-10,0,-39,-26,-2,39,-17,-27,-44,-26,-8,-54,12,38,64,-37,-30,-74,21,-12,67,14,9,-50,4,-6,-35,-50,-94,-4,25,15,-19,17,-107,55,-26,-67,-18,-94,69,-86,86,54,56,-64,-33,-28,-2,59,54,10,-71,-58,-85,-31,-80,-18,-49,103,63,0,-4,-98,18,12,-60,127,-68,-36,-53,-54,-53,48,-28,-6,-57,-15,23,-108,3,-14,-98,-4,119,8,46,-35,-33,-17,37,-31,43, 
  /* [1065][0][][] */ -90,-42,30,37,-18,51,127,-65,-43,2,66,23,26,-54,14,-18,52,-9,23,-19,-30,29,-16,30,-15,54,45,18,-26,-3,21,20,-85,-40,-57,-9,-1,-9,9,-11,27,-46,27,-40,-52,-37,-46,-25,10,-21,32,-91,-5,24,36,30,24,-91,-74,-18,-14,73,77,-22,-20,35,-66,-20,44,-28,25,-1,15,-4,-52,-20,27,54,-22,-28,12,-11,25,-11,61,-5,-15,1,4,-35,38,-36,24,44,27,16,-24,-29,-67,32,57,75,70,-64,43,30,16,32,41,-57,-84,-19, 
  /* [1066][0][][] */ 33,-4,15,2,-48,-75,-93,12,17,-14,32,72,18,-80,-68,66,-15,13,-19,-26,-70,43,18,-33,-7,-18,-60,-38,6,-7,-5,-93,-4,-115,69,-72,-127,73,-20,21,22,43,28,-58,16,-57,22,8,-62,28,-23,-29,-20,-17,56,-37,-29,-50,18,59,18,50,11,-99,-3,14,13,-6,-4,-2,-50,-103,-5,18,60,39,-31,-48,-1,93,64,10,29,-61,-2,17,-45,-21,-55,13,10,-1,46,0,-92,0,27,-49,-17,-9,-97,-91,-2,-81,-12,-43,4,1,57,-49,-47,20, 
  /* [1067][0][][] */ 28,10,58,51,-42,8,124,47,-31,80,11,72,-29,34,-7,-43,60,69,9,-16,-127,58,-29,-30,43,48,33,-39,29,-48,-6,-23,-29,-51,-82,-16,17,37,32,24,-41,51,50,105,83,-61,10,-31,-32,0,-4,16,84,58,38,88,-16,-22,10,-2,-57,-17,-56,15,-70,8,47,-18,50,15,-28,-41,60,57,-20,-9,-21,1,-75,-36,4,-51,0,62,-63,-90,-30,-16,15,21,-5,-33,-29,15,55,15,-109,-92,13,-56,109,-67,-117,33,-67,41,36,14,4,-9,58,14, 
  /* [1068][0][][] */ -35,59,48,52,-62,-58,53,32,-31,81,-18,68,-11,-65,37,-26,-30,-9,32,-73,86,20,-52,-13,-32,-19,-50,69,-23,42,68,-18,-42,-12,25,-36,-38,-42,12,-49,11,44,-42,55,-53,-35,71,43,65,-71,-81,-6,54,-10,69,-94,4,-8,-31,-90,-27,67,48,64,-39,-13,46,-67,-25,-11,25,-27,13,-8,22,-1,-22,34,-34,-43,25,12,43,24,81,0,-94,-24,106,-77,127,23,-26,47,-3,-4,17,-38,11,-24,31,-4,-75,-89,-52,-55,-51,-24,84,33,-86,-53, 
  /* [1069][0][][] */ -1,-17,31,22,-62,33,-23,-1,-74,-112,-74,75,-68,-27,-30,3,35,3,-36,-49,33,-22,22,38,36,-1,-49,-10,21,53,39,39,68,26,127,-64,111,24,-13,27,-18,-14,-89,-20,3,30,66,-37,-22,39,116,30,46,51,-64,58,13,104,-72,23,54,-6,-41,-39,-48,31,-47,-73,-20,-36,-68,33,26,28,4,8,-34,84,-26,9,-47,-103,105,-16,-49,-1,-58,9,5,-59,22,20,-55,-59,-62,-32,-30,25,4,-34,-38,-124,29,-21,-58,-36,11,16,-7,-14,54,-32, 
  /* [1070][0][][] */ 29,-15,-60,-2,13,13,-8,18,-40,-24,-35,23,50,-37,-52,-97,-9,-32,22,-36,-29,12,27,37,35,-96,0,33,4,67,-20,23,-56,8,10,14,-20,32,67,107,23,-11,-16,2,9,-53,11,-66,-50,29,28,-87,51,68,83,-58,19,104,1,-20,25,79,-1,-35,23,34,-28,-8,-45,-27,9,-32,-67,-38,-69,7,-5,59,-127,-51,26,14,36,53,32,53,-29,-11,-38,42,0,-53,2,-3,-50,-8,-46,-36,-77,41,-116,-37,-42,-3,30,0,-66,20,34,-24,-42,-27, 
  /* [1071][0][][] */ -27,73,-11,61,-53,1,-77,-1,-22,36,-44,-19,2,97,4,18,25,6,-26,-69,64,58,33,-26,43,36,1,-28,35,-40,39,-37,35,60,96,-17,-119,3,42,-47,-68,24,22,-87,32,83,-9,6,47,-65,14,50,-44,39,50,-7,-8,-2,48,-10,93,63,60,15,32,-18,4,-53,-85,1,45,-1,15,61,-3,-11,-83,38,14,54,-21,27,-73,23,37,-81,-127,8,-58,1,-67,-37,16,-20,-59,97,44,-19,8,53,-109,33,-71,-14,-27,23,-27,1,82,-40,-20,1, 
  /* [1072][0][][] */ 26,-27,40,112,-41,-52,41,61,-9,-31,-36,-43,25,3,-2,31,66,-2,-39,-30,-68,-4,-26,-47,38,47,51,-10,30,23,-39,-5,74,17,-22,-61,-14,24,-73,-26,-53,-56,14,-75,-32,3,13,41,-34,-82,11,-1,5,6,-35,69,31,15,-81,-30,70,7,104,-24,13,-72,73,38,34,67,36,-69,72,-23,19,-29,15,-38,83,73,127,-21,-8,48,-91,-92,34,-32,34,-63,16,45,-39,-1,11,-15,18,-61,6,1,0,-49,82,-107,-81,-28,-42,1,-62,8,-36,-9, 
  /* [1073][0][][] */ -52,-56,9,28,-1,-17,12,-33,19,21,43,-42,9,15,-77,-59,-2,-38,-2,4,-90,1,-51,-44,37,5,-10,-16,-3,-42,-11,40,-57,60,59,-25,45,-3,27,41,1,-17,-14,55,-62,30,-31,-80,-70,-15,9,-43,16,0,27,-72,-48,69,-45,97,-10,-31,-10,82,-12,-31,49,-15,26,-6,-11,-77,-29,-57,41,31,-14,18,71,-66,-26,-4,-5,11,-4,-27,3,42,-29,33,25,-68,-78,28,17,-37,17,-29,-11,-48,-69,59,24,32,-22,-67,0,127,15,-14,-65,42, 
  /* [1074][0][][] */ -8,-57,-13,-49,-65,30,15,-3,-3,-127,-39,28,-27,50,11,-25,22,-24,-18,1,-36,21,-8,0,42,7,-6,15,-7,-44,-24,28,-21,-19,-3,37,1,71,26,-36,-3,35,7,-15,6,-23,62,57,25,2,-27,-27,-42,11,-35,33,11,-4,11,10,4,-27,-17,-2,6,23,38,32,11,28,28,58,12,-26,-10,7,-29,-28,-73,-15,34,1,-19,-67,36,-13,-2,39,-1,0,41,-24,58,-5,-54,-20,9,45,37,25,8,12,-14,10,-28,-77,-2,-54,-10,-17,-78,25, 
  /* [1075][0][][] */ 94,52,63,16,57,22,-1,107,-12,-14,-53,69,36,-10,66,33,-12,1,-70,-8,-53,14,48,-5,-32,-16,17,59,-52,25,51,-46,10,88,15,63,-41,-88,110,38,41,45,-106,33,-29,-22,69,-73,-32,-94,-15,-5,-42,-61,-28,-14,-78,105,-25,41,12,6,-57,-60,-59,-66,6,33,-65,79,-1,82,26,-30,68,-70,-68,112,17,29,126,-74,-95,-30,-51,-13,29,-51,-2,37,23,127,18,0,-40,-8,-19,-21,31,-37,-24,-1,17,-13,-19,10,28,43,-14,-39,-17,34, 
  /* [1076][0][][] */ -7,-11,-12,-3,26,-6,-25,-83,-75,23,10,-11,-14,0,42,-9,-20,21,10,-68,-37,97,-54,-26,-63,6,4,34,-67,-79,54,-30,4,34,17,26,23,-3,36,-5,-2,18,7,-49,42,-106,-41,6,-41,-26,9,-26,3,-21,-31,5,32,50,37,37,-55,66,37,11,-37,6,-28,-5,27,18,18,-66,1,-22,43,10,36,40,-79,-27,4,8,-35,-62,-1,52,-35,-9,-13,-18,-6,52,6,72,5,41,-127,2,5,-24,-20,43,-4,13,48,-4,-80,23,-25,30,-6,-13, 
  /* [1077][0][][] */ -13,-43,-22,35,5,-57,-48,118,-89,11,-74,12,-38,-36,33,3,10,-17,46,30,87,43,-46,33,68,54,116,-18,87,103,-5,-28,-23,-61,7,44,8,-42,115,52,66,-84,6,-27,-20,-31,-43,25,-11,1,-104,82,70,24,21,-17,-3,-10,-74,2,118,36,12,37,12,80,69,-20,-9,-32,-5,11,-70,43,-39,26,-74,9,-3,-42,22,-92,-98,43,47,-62,16,26,-19,51,39,-29,-37,-3,52,11,-117,-78,7,-127,-43,-2,39,54,6,23,42,4,-38,-47,-15,10, 
  /* [1078][0][][] */ 46,-11,15,87,-25,65,11,-32,-15,-43,91,-31,-11,58,2,-5,-127,18,-35,-18,8,78,46,-23,-37,1,-72,57,-31,45,16,47,-77,-78,55,24,62,26,-46,-47,26,90,77,-49,-14,-54,97,-10,8,-74,-55,26,-22,-68,15,-34,28,36,-1,-11,8,26,-2,-19,102,56,68,-31,-8,106,-23,-38,-4,19,-69,12,66,56,-24,46,-15,-38,-48,33,-2,-29,-24,-22,-18,31,-21,-51,20,-47,64,15,43,19,2,-39,-54,-5,7,15,-35,-56,29,0,14,19,8,-29, 
  /* [1079][0][][] */ 3,20,26,-63,16,-1,23,58,59,-44,0,9,-17,-57,-33,-96,10,-127,-62,21,44,-5,-25,61,-14,40,-35,-28,3,47,-56,-41,-86,-30,-19,-21,101,-32,-54,-36,-87,20,-11,-22,-86,116,-8,79,3,-6,39,68,-16,-87,-51,-4,-21,-111,65,29,76,27,-60,-21,-62,45,35,102,7,-8,16,-20,-12,6,28,57,49,102,-55,80,53,48,-71,-43,-90,-65,-64,-50,-91,-24,6,-10,-106,42,-35,-99,65,88,22,14,21,-7,-75,8,7,-37,-69,71,-101,-63,-46,18, 
  /* [1080][0][][] */ -49,-22,-66,-4,-12,-37,63,-34,22,44,58,-33,-16,33,29,6,74,-34,4,15,-52,30,48,13,8,-18,12,-42,45,-47,55,127,-34,-28,39,51,-43,7,-71,-8,24,11,-20,-25,-14,44,56,12,21,-8,-21,-20,-13,0,3,50,-11,-50,-41,37,-60,109,-32,-42,-24,21,-25,-93,-23,-19,-37,-8,24,71,78,24,34,-34,-38,14,-23,45,-8,-20,-34,-67,-18,53,-9,-1,18,-26,-37,-29,-40,42,27,0,41,31,63,-74,24,5,-47,-107,75,76,92,59,-40,90, 
  /* [1081][0][][] */ 119,39,-18,57,64,22,-30,-41,-19,18,96,-56,127,-33,68,80,18,45,-7,8,80,-31,112,-60,-89,-51,33,-3,-59,27,-17,-64,68,-2,-14,-52,-79,-69,-25,-78,121,79,57,-13,8,42,-53,85,87,20,19,-102,67,2,-21,23,81,33,79,92,-20,-17,-51,-66,-53,-9,92,31,-31,5,-48,-52,-54,113,-56,7,70,34,-59,26,36,-11,27,-89,-33,19,-1,79,40,-9,-5,-43,-24,8,-79,109,-15,-45,-28,-2,-80,-57,95,-8,-7,-74,87,75,-1,-9,113,-21, 
  /* [1082][0][][] */ -4,-51,38,-73,15,38,57,39,-21,52,7,-71,28,28,-41,48,25,78,-19,-16,-7,44,-1,-32,35,-64,31,3,64,8,-17,68,17,-22,45,65,53,34,-78,-13,-11,80,-46,-12,14,26,-51,8,1,27,-25,11,61,44,-2,-3,43,-7,-20,30,45,-9,2,-3,24,20,2,22,6,-10,-3,25,12,65,55,-61,9,34,-7,25,-38,13,26,-31,-24,22,-9,35,-40,-12,-43,-39,-46,6,-9,127,7,22,11,-23,-11,-13,-13,-43,-22,-34,-1,-31,-4,-3,-45,23, 
  /* [1083][0][][] */ -70,-80,50,-60,9,1,57,-35,36,-53,106,-9,-26,-28,-79,-26,53,-23,8,-75,76,83,-54,29,59,8,52,36,31,58,-7,-26,91,31,18,125,-11,-30,-33,15,9,-36,23,-14,49,47,75,-39,23,-50,5,7,57,77,-101,-16,22,48,52,0,86,44,5,-62,69,29,-6,-60,-127,-14,-11,-44,-95,-19,93,93,-38,54,17,-49,-46,83,47,6,-34,-26,92,56,-16,15,-45,-2,89,11,-4,-124,-66,60,65,6,-4,59,30,-12,37,24,52,-9,56,-53,-77,8, 
  /* [1084][0][][] */ 35,23,-40,-14,33,-72,45,-98,22,7,16,25,-47,33,-28,-16,-65,-104,3,-10,-68,67,55,-53,57,0,-42,69,29,45,-75,3,8,42,127,17,-5,74,17,10,81,19,25,43,-41,-50,60,-67,-58,39,-124,-28,-90,-37,-5,-24,13,-42,114,34,-40,96,-30,-8,5,41,-88,-7,-83,-17,21,-12,-15,55,22,-22,6,79,80,81,-43,79,-15,-41,59,71,-14,-71,43,-8,93,0,-38,17,7,50,39,4,-31,52,41,48,-47,118,-6,50,27,-15,-40,99,-3,9, 
  /* [1085][0][][] */ -7,20,20,42,37,1,44,64,40,58,-7,-68,-1,15,-7,-83,-13,-120,-3,20,-55,-4,-72,10,24,-11,0,27,2,-9,-44,-41,-18,-61,65,-5,35,-34,-11,31,-68,43,40,13,37,-31,18,8,7,15,8,11,42,39,-52,-20,24,56,-13,-49,16,15,70,19,-51,10,-19,46,19,6,-39,-65,17,-63,-67,-13,23,-41,-29,-33,-45,-20,-3,67,63,20,-31,-13,20,77,-33,-31,19,-127,26,49,-29,-1,-49,43,21,-31,35,-24,-1,10,-101,13,-53,-21,-24,54, 
  /* [1086][0][][] */ -65,-46,12,-6,23,12,-46,-5,4,45,68,42,-36,10,8,-53,10,5,12,-15,23,21,-40,48,-101,22,-29,17,67,-72,87,16,41,-30,28,8,48,127,8,-28,114,-30,-16,6,5,6,-9,-9,-43,27,-26,-18,-3,18,52,35,-51,80,30,6,-17,-22,59,27,16,63,-23,3,27,-9,41,31,-19,-34,69,24,-6,43,-44,-26,31,45,20,24,0,33,6,38,-49,-48,5,-19,-42,85,9,66,12,86,9,-86,-1,-38,7,55,54,-3,44,73,-12,-17,4,8, 
  /* [1087][0][][] */ 20,69,48,45,-84,32,-44,-23,21,54,4,-55,-2,45,0,-31,41,-12,-20,-15,7,-46,62,17,92,-14,52,-79,-39,-37,-79,45,56,77,-73,-14,104,107,-74,88,56,-56,35,2,48,-48,-27,-46,20,-11,-54,-20,72,-44,61,56,-7,59,-3,8,15,2,-6,-17,49,-69,-44,35,48,17,36,-56,4,-47,-48,-58,17,14,22,127,-85,6,54,-20,10,-45,73,-109,119,1,16,-17,29,-89,-45,62,-34,26,6,49,-34,5,66,14,40,-3,-2,-23,71,31,-40,-82, 
  /* [1088][0][][] */ 28,-69,3,-9,4,48,-6,-22,38,-34,87,-37,-60,61,35,46,36,-5,61,17,-39,57,-66,51,90,65,-60,34,-10,-30,-66,-114,54,5,0,6,-56,-63,76,46,16,29,-12,0,-80,-74,28,48,101,1,53,86,-35,-30,49,-70,-74,-29,-42,-21,-20,-85,17,-65,-1,22,-3,23,26,45,52,-24,-35,-51,55,90,-8,-23,-103,45,76,13,7,27,19,-56,13,-47,37,0,-11,19,60,-53,-16,-9,38,48,33,-1,-53,65,31,-111,25,15,-85,-20,2,-71,40,127, 
  /* [1089][0][][] */ -1,10,-93,-18,-28,-38,-46,21,-18,31,76,54,17,5,37,-43,-33,63,-50,53,12,24,46,-45,-19,11,-50,-21,-64,24,74,-3,-27,-12,-45,-12,16,16,-40,28,-3,-10,4,-3,-44,77,-27,22,-37,45,22,44,4,9,-48,40,-10,-25,-2,-6,28,-25,46,-66,7,-5,17,-8,-20,13,-15,24,29,43,63,13,23,-10,-21,-58,-44,31,38,-31,17,12,-55,-28,-37,42,-59,4,28,30,-32,127,-17,-11,31,-13,-10,-9,-78,15,-56,26,-29,-18,-77,-84,-24,8, 
  /* [1090][0][][] */ 37,8,-10,33,21,15,0,59,27,4,67,31,65,-59,-20,-34,-26,-25,-3,9,28,-15,33,41,42,-63,-28,-127,22,23,-21,-25,-49,2,0,-22,-46,-7,11,29,-44,-18,121,-25,-30,3,27,-26,49,23,-25,-7,-27,33,-40,0,0,-26,40,5,-10,-31,33,36,50,-59,-48,-47,55,22,63,14,66,80,-18,1,20,-119,-41,16,-36,-30,58,4,-21,30,10,53,18,4,-13,-11,-66,8,-28,12,8,-53,-46,-9,-54,31,4,-2,19,16,-9,28,-36,40,-22,13, 
  /* [1091][0][][] */ -36,-30,6,2,-13,20,-35,19,-50,-47,-60,-51,44,19,-50,15,-15,4,27,-9,-17,9,-70,61,-30,-109,-87,33,29,-39,56,88,-48,-1,10,-76,-15,-9,-25,9,-15,-47,18,-15,27,-34,19,127,-18,37,-30,7,-81,0,-43,44,84,-79,34,-26,-45,22,-28,-57,-14,-91,-70,-14,-1,-42,-75,-10,-47,-93,51,-14,17,-6,-67,-9,-9,-17,43,-81,-39,-10,49,-7,-17,10,-6,44,-14,-34,7,-24,50,40,-30,67,-45,-35,46,86,18,59,14,-21,-8,34,-25,3, 
  /* [1092][0][][] */ -12,-25,56,-26,36,3,127,17,-2,-30,73,49,-9,65,-20,6,27,-22,27,-40,-3,30,-15,-15,-6,10,-23,45,41,20,-14,38,46,14,-64,21,24,5,35,39,-24,-20,-2,70,-26,2,39,-10,-11,-47,-71,24,36,-65,37,-14,21,-1,-4,-21,71,-1,-52,-4,-39,58,44,-9,11,49,-28,35,-16,-6,47,-37,-27,111,-7,-7,15,-15,-54,79,-47,12,-113,14,-4,12,-3,-69,-19,-54,44,-41,-42,-12,3,-87,-1,26,28,61,-53,32,-88,56,-35,-27,-26,-11, 
  /* [1093][0][][] */ 48,-67,-26,78,9,-66,-29,50,-39,-16,-60,6,-26,-9,-3,-60,23,37,-16,32,35,20,-11,-34,-1,68,13,17,-30,23,-63,-19,-55,-33,-4,-15,-13,47,96,9,17,-3,5,49,3,30,-14,3,5,-47,-37,17,22,-85,-46,-18,-22,-63,-33,-87,34,-15,35,30,-48,-15,-11,-83,-45,10,19,64,38,-42,-25,-31,-32,-111,-25,-12,4,64,-37,-56,17,-52,27,-50,66,5,71,-21,127,45,-39,17,-7,15,2,89,-17,40,-14,-39,-5,3,60,41,-26,13,-52,-4, 
  /* [1094][0][][] */ -10,-3,-7,32,-15,20,6,24,14,43,7,-2,-88,-23,-42,-13,-2,-46,38,-39,-1,54,26,44,-27,-1,40,65,38,18,22,-49,8,-46,15,69,-23,-20,4,11,15,-44,-1,-15,16,5,-59,-33,-47,58,68,42,-3,-21,33,-43,14,38,-11,7,-22,-10,32,2,18,71,85,25,17,28,-68,-33,23,-22,20,-41,41,9,-76,52,73,-76,-17,-23,56,-12,-6,27,29,-47,37,73,-46,30,-81,127,2,16,-41,-35,17,25,-6,-13,57,19,79,41,-5,87,62,7, 
  /* [1095][0][][] */ -22,77,65,-16,-83,5,-47,-57,-77,31,-27,-11,13,91,-57,-34,37,50,-50,-93,-3,38,4,15,-31,-26,-44,-54,110,45,-9,32,-84,59,-2,63,65,-7,-67,21,-60,107,45,-43,69,-63,83,-51,-30,-7,8,9,25,-31,-91,18,-57,6,5,-108,-5,127,5,2,-30,-3,-11,-12,-5,-28,29,-60,18,-14,38,24,-1,61,-11,22,19,5,18,-52,45,15,71,-23,60,29,120,-27,94,-45,-6,32,-49,98,124,0,-116,7,-37,-15,-15,12,-13,95,75,35,-24,27, 
  /* [1096][0][][] */ -39,-65,-65,39,-47,8,51,29,30,-45,33,-2,18,33,-13,17,62,16,-8,78,-49,-19,-36,44,-96,-66,36,24,-65,-5,-28,-1,-29,28,-37,2,-39,35,14,25,-10,-4,-7,56,19,-2,-34,12,56,-1,-64,84,32,20,1,13,-31,-9,10,41,-33,-6,55,-93,19,-36,50,-8,-15,69,-70,5,3,61,99,59,-80,-19,-15,0,68,-8,38,9,68,-23,17,65,3,44,24,-116,14,127,20,106,15,-36,68,9,-102,-21,17,42,0,-32,-64,-59,8,57,1,26, 
  /* [1097][0][][] */ -52,35,-39,45,28,-1,-56,61,-26,7,35,-51,18,27,-21,-20,43,77,11,-4,23,-40,-49,58,-2,-24,-17,-26,54,-29,-64,-32,63,-16,-4,-18,101,-5,-47,30,-63,-29,-54,54,-44,-80,6,-16,-92,85,9,-7,-1,35,-59,2,10,90,-21,-48,-36,-22,-15,-47,55,33,45,-46,-8,-4,-14,10,15,-30,115,6,-40,-77,-30,-15,-55,-5,83,24,-5,-2,-22,68,-47,49,13,67,-7,37,-39,41,25,2,1,-51,-89,-53,-20,-127,-39,36,-51,-34,-27,-15,-44,-41, 
  /* [1098][0][][] */ -7,4,13,-32,2,14,21,65,6,13,-25,-13,70,-4,102,-81,46,42,-46,-24,-36,9,-30,28,24,43,-6,27,57,9,5,13,-12,-22,-2,-5,53,-27,-5,68,52,122,19,27,38,81,-28,-57,-9,-9,26,72,37,22,-52,52,-77,57,-58,-6,-2,54,-29,10,10,-15,24,-38,-67,-1,-24,35,25,-38,-111,15,-15,-32,-28,-17,31,-127,13,34,-104,3,-38,-43,-41,-15,-60,-49,-29,1,-17,44,13,27,-26,-9,26,-14,112,-11,5,-35,41,-50,-92,49,16,-46, 
  /* [1099][0][][] */ 40,0,10,35,27,8,-22,1,-4,24,12,-20,-19,55,49,34,-28,23,1,66,-90,59,-11,40,34,6,-9,51,-33,37,49,18,-48,25,22,33,-1,31,29,44,56,-1,-44,-18,-18,13,42,-48,-1,-12,-14,-25,100,21,-16,-78,5,-11,-19,127,4,19,27,-34,-40,8,-1,-39,11,5,-14,29,-4,2,0,-87,15,75,21,19,-8,6,-13,-14,24,81,-31,-21,-12,-6,-40,17,-16,3,-39,43,3,24,-6,-51,84,-13,69,-19,19,-13,30,41,11,17,-36,-38, 
  /* [1100][0][][] */ 118,-107,88,-36,7,-55,25,22,14,-29,-3,66,-71,-4,-112,71,87,-81,58,-29,-100,66,-6,48,93,91,18,22,108,68,-13,3,24,-79,-51,-79,55,-84,-60,109,-58,-119,-60,-15,-11,-11,-58,-51,-56,-66,-17,-30,-33,30,-100,60,48,-19,-125,-22,18,94,-99,98,-1,22,-2,93,44,46,12,20,-13,87,5,-57,32,7,-40,21,-20,9,13,-3,16,105,70,23,-11,-27,59,-36,2,99,116,-27,-118,18,-23,10,16,15,84,-95,52,127,-51,48,19,47,24,88, 
  /* [1101][0][][] */ -36,43,0,8,-55,19,-14,-8,-2,44,-5,-127,19,59,-60,-5,-12,11,-30,7,30,24,-28,25,-4,-5,-33,33,-4,-38,-33,12,-45,-31,-36,74,-8,12,40,58,-44,-1,-15,60,32,-22,19,13,0,-31,18,3,56,-21,3,-16,-29,-17,-53,-67,-54,-54,1,-17,43,0,37,56,-48,-28,39,-54,-29,-19,-69,13,-7,-71,18,-34,1,33,43,43,-57,33,-3,20,21,-3,-53,-33,49,-50,44,-2,-44,-72,9,11,58,12,23,51,-33,2,64,-24,-50,-7,-86,-5, 
  /* [1102][0][][] */ -33,7,44,-43,22,14,-26,56,90,9,48,-30,0,-54,-18,-21,-51,43,-45,36,26,107,41,-48,-13,-5,-55,120,52,19,-31,6,-29,15,67,-34,-21,-9,64,-31,-26,52,-22,10,24,-14,15,25,-15,-42,-3,13,-3,-27,13,31,29,-18,-34,-36,-3,-14,36,66,-40,-113,18,-19,127,17,-22,-65,-71,-117,41,76,-51,18,74,27,-52,43,-44,-34,-42,-2,35,14,8,52,53,-50,37,-65,64,-70,-5,45,76,-78,25,50,92,-49,76,-10,-3,-7,66,39,-37,17, 
  /* [1103][0][][] */ 16,61,-40,58,-27,39,48,27,9,-111,7,14,72,17,-28,53,-53,-12,-69,-10,-50,80,14,-127,-25,7,-3,7,93,83,-30,-91,7,74,-8,23,43,48,10,-19,-1,-6,-56,-62,-21,39,44,66,-24,68,70,-19,-30,-84,-6,37,6,39,81,35,74,8,-80,3,72,-50,5,-47,50,54,22,-55,32,3,29,-36,-17,-55,35,59,-69,2,-20,-29,-28,7,55,31,-9,49,10,27,52,15,-19,-35,-27,41,-24,85,28,13,-54,37,-26,23,108,11,-24,20,-35,-14, 
  /* [1104][0][][] */ -7,-39,-95,-50,27,-22,-19,-25,26,-45,82,24,34,-84,-11,21,44,69,31,-31,-38,-33,-67,-45,15,30,27,8,-27,19,-62,-46,43,33,29,-64,-9,-1,-3,49,-16,5,-85,-31,-19,-23,-18,37,26,8,-5,-27,-18,-32,-15,127,33,-31,-36,-7,0,23,75,6,38,-33,-105,-15,6,3,48,-41,-36,-27,59,53,-22,14,1,-29,2,26,-46,15,3,4,53,24,-8,44,-56,44,23,24,78,-68,17,-7,-7,53,46,-19,-62,-50,-32,-13,-38,28,13,8,-61,22, 
  /* [1105][0][][] */ -20,60,-32,-11,-39,48,-13,45,-26,-20,-79,14,-13,28,67,-36,-16,-36,52,36,12,-25,122,4,-46,-57,-19,106,-70,28,-1,-37,44,-5,65,44,-22,-38,-4,-3,5,47,20,12,16,-15,19,42,52,-9,32,43,-12,-35,2,-98,-19,-33,3,63,-23,39,-2,13,-11,-56,18,-30,35,25,-42,46,-61,71,-70,127,57,-1,12,-4,-21,35,-37,56,-30,-54,21,-49,51,-40,33,-21,29,-48,-10,3,7,78,-31,-1,36,121,27,16,39,-81,-11,-17,6,-30,-21,86, 
  /* [1106][0][][] */ -32,-2,-42,-13,-29,6,8,25,-36,105,31,-111,31,-7,27,2,41,-22,-98,9,-100,19,-7,17,27,-7,-63,-30,-10,-66,19,-44,-20,76,32,-92,5,38,-6,4,67,8,-10,95,23,-24,51,-48,-42,-44,113,33,68,6,-18,-1,11,-41,-60,-72,-20,-19,27,-5,-41,15,-38,-12,38,-127,103,-10,33,88,-57,-38,-61,-13,0,51,73,32,-1,-93,-11,17,-22,56,28,26,8,-11,-18,-84,5,-40,54,-62,1,31,19,-61,-18,45,2,15,-14,38,73,-6,12,-1, 
  /* [1107][0][][] */ 55,-27,-53,-21,29,4,-38,18,61,29,-58,38,44,-84,41,-68,-29,112,74,-4,-65,-18,-16,29,54,-75,-127,-1,-8,-15,57,-30,37,-18,16,-64,17,44,-28,-36,31,-3,11,-27,12,2,-15,-39,104,5,57,6,-55,47,0,18,13,-72,-41,35,-100,32,-71,-3,-59,30,-43,26,-9,-7,45,-40,-21,-17,-62,-41,-53,-36,-42,7,74,6,69,-7,-15,55,31,-18,57,25,-100,37,-64,-87,-62,21,80,-78,1,-16,-46,-43,-28,-53,39,45,-106,38,-55,-61,-17,49, 
  /* [1108][0][][] */ -2,1,78,-38,-22,20,-7,25,-29,-58,-26,-28,-50,-27,-87,-12,-34,-60,23,22,-58,-7,25,3,37,20,-39,5,-20,76,-8,-40,-16,-44,35,47,7,13,46,31,-79,13,63,27,-25,37,-40,40,-111,18,-85,-26,-31,25,16,41,-53,-73,-6,47,-8,9,-26,61,28,4,7,14,38,40,58,51,7,4,-1,-60,-40,-28,-51,17,26,10,-4,-11,-13,3,-11,55,-127,-20,21,29,-32,-13,-42,-13,-32,10,-1,27,-63,40,-2,-33,-63,24,33,53,4,1,41,-66, 
  /* [1109][0][][] */ 8,-30,40,-64,29,-77,18,51,9,-32,22,9,74,-31,64,20,0,-5,-37,67,-59,-36,42,-40,-66,12,-16,33,-84,71,56,2,69,-31,-34,57,-47,-20,-39,17,-73,-85,-34,58,-127,-6,-51,-3,-4,59,-27,-31,41,47,-65,-15,60,-26,-26,24,60,40,-27,-51,52,-41,9,17,47,30,16,16,2,36,-4,-36,-26,39,-106,84,40,62,0,-1,-36,-45,13,-2,73,15,-44,52,56,54,-10,-2,-15,7,58,46,29,-35,4,-57,-15,-27,-36,96,-15,-16,-2,1, 
  /* [1110][0][][] */ -9,-78,-43,-32,-64,-19,-6,15,-47,-10,-29,-56,-54,-127,42,19,29,4,-3,81,-36,28,-47,35,-64,57,-10,-11,-110,18,-4,20,8,-72,17,-19,74,5,30,106,-14,51,-9,54,93,-30,-23,52,-81,33,-51,-22,27,42,-16,32,-43,21,-6,37,-99,111,-16,19,39,66,87,-4,-71,120,-12,-39,-117,33,100,68,6,27,70,-33,99,16,-57,-34,-46,6,-29,-77,-29,3,-22,-110,-45,84,-6,92,-72,39,23,43,114,-52,18,-24,-34,31,55,-38,-72,-23,45,-114, 
  /* [1111][0][][] */ -53,27,72,69,34,52,94,-55,35,89,70,27,22,56,-71,8,44,-12,-17,-49,127,23,-10,-95,-3,-11,16,45,67,56,-31,-26,14,9,47,-1,88,-44,-3,20,17,-14,31,-17,-33,-5,-28,-36,-57,-13,18,-46,25,28,17,11,-21,23,-1,6,-30,-6,84,8,-24,67,-7,-19,-29,68,45,-53,35,40,6,-57,2,-43,-57,-72,-25,13,-5,-23,-54,27,14,8,-46,-61,2,-40,-22,49,-15,46,-94,59,11,23,29,38,87,3,-73,-3,11,10,38,-15,-13,33, 
  /* [1112][0][][] */ 29,71,-49,-27,-6,44,9,-21,-17,49,20,24,37,-8,-56,55,-109,2,-67,-11,41,-51,-37,-17,53,-50,-21,-25,-31,62,-72,-127,46,20,-49,-64,-36,-34,-19,59,80,3,24,-45,-5,-58,-70,-51,32,-58,41,-8,35,15,72,85,-57,-30,-3,52,-22,71,12,16,50,41,-55,-48,13,-8,30,-32,-42,-60,-49,-69,-46,-45,-27,40,-47,117,-31,-30,51,-26,16,22,-14,-11,41,90,-52,-52,-32,0,-95,-7,-11,-20,-15,-46,-40,-8,65,15,15,51,19,-57,-41,-51, 
  /* [1113][0][][] */ -27,-7,-44,2,-24,10,9,55,82,69,2,34,16,30,36,60,42,20,-34,42,35,49,-6,-32,-54,-52,18,42,-69,26,-55,8,-127,-8,-60,-2,-8,-49,21,33,78,-19,6,4,20,-16,11,-18,-25,92,3,-21,-76,59,-7,73,93,-74,14,6,-28,2,11,-19,-10,25,-4,24,-68,87,-19,26,18,6,-57,37,39,-18,37,104,-72,0,62,-18,103,-53,76,-21,39,38,-59,105,43,-28,9,-20,-15,-20,10,-2,35,-118,32,-19,35,74,34,21,125,-59,-53,25, 
  /* [1114][0][][] */ -60,-49,15,-123,-36,31,16,39,58,-57,25,6,27,9,1,-22,-32,19,-28,-2,-83,-35,2,11,3,27,9,-46,-73,63,-7,115,-6,-28,4,-69,4,13,-12,36,-27,3,72,-6,-6,19,-2,6,50,5,70,-39,-10,-29,16,45,-29,-127,29,-16,-38,-25,-23,-64,-40,38,60,55,-46,-24,4,-22,9,-37,-43,60,-13,56,-15,67,61,-31,-45,-11,-55,-25,6,40,-30,52,-89,-73,74,-55,43,-13,67,7,-39,-94,-4,38,-13,101,-7,-43,-47,4,24,-36,-46,28, 
  /* [1115][0][][] */ -47,28,93,33,15,79,34,-38,-46,18,-48,11,-9,-26,-44,-121,91,-39,-24,-66,-17,52,18,-85,96,-13,20,-9,11,18,-124,16,89,49,26,14,7,-1,-96,92,-79,-8,19,16,12,22,-83,22,64,20,-51,-59,20,1,96,108,-23,-16,43,82,-19,12,52,-33,-29,-21,-52,-16,31,127,-45,-7,100,-9,-38,75,0,109,14,39,34,-12,-53,0,42,-46,49,-43,22,-66,-30,-47,-30,-55,31,-19,56,102,-51,-11,-75,45,-109,-98,57,-81,76,5,10,17,-18,55, 
  /* [1116][0][][] */ 21,34,-79,58,-63,19,-3,-77,-33,-8,54,15,64,-33,50,2,-44,125,-40,-59,16,-53,46,62,-36,-6,36,-57,-4,7,-82,34,-1,17,95,-20,-37,8,23,-59,-29,-42,-22,21,-12,-13,9,-17,-45,48,-35,52,-65,-40,54,-10,6,-8,-10,-46,17,-32,-119,0,36,-97,-5,80,15,12,-65,-44,78,62,59,58,-77,19,3,108,-49,-18,127,14,-24,8,66,-34,93,-2,18,69,54,-22,37,34,12,-11,34,-23,-23,13,43,-16,3,-6,2,-13,101,28,63,-30, 
  /* [1117][0][][] */ 46,67,81,-8,19,14,71,4,-27,30,-34,-84,45,61,-28,22,-44,57,52,-67,89,-9,-32,85,-12,-16,-22,77,45,-90,52,-56,-29,2,21,37,-104,48,10,-30,-18,-53,10,13,88,-31,-65,-5,25,36,-13,-78,-39,49,-32,20,19,-29,76,-10,-43,-1,-9,-17,-81,7,-18,37,36,-23,59,-98,-20,37,14,50,-41,38,30,7,96,55,56,-16,-51,-36,80,-33,107,59,-66,-23,21,67,120,50,91,-53,-23,-2,-20,127,98,62,-15,78,62,-31,-20,10,60,1, 
  /* [1118][0][][] */ 127,59,75,-60,3,32,-5,-113,-23,-13,19,40,50,24,44,80,15,-31,33,58,-5,-23,-15,36,39,-88,-70,9,102,39,110,-91,-42,-6,67,67,73,-39,-31,-6,72,27,66,48,25,47,15,44,6,-116,-89,-119,-16,2,55,52,38,11,4,-22,-4,-44,11,12,31,-61,1,32,27,63,20,-13,83,28,75,52,-6,9,3,17,-36,-5,-18,1,8,37,-28,-29,-5,30,-23,10,-94,99,37,7,-120,-41,76,-85,-13,-105,79,-88,12,19,-1,32,81,42,30,4, 
  /* [1119][0][][] */ 13,10,-116,-29,37,29,-28,27,-68,-7,77,-7,-24,37,114,86,22,-6,-44,-41,3,4,71,81,45,-119,-59,-59,14,36,-94,28,-21,-21,39,46,-27,98,18,56,-26,2,5,-34,-21,-56,-54,-17,12,-46,-66,69,4,-50,-28,-20,47,-28,38,-22,60,105,28,-23,127,54,-92,-46,-48,125,90,31,99,27,69,-52,0,-26,26,22,53,-5,-22,-44,4,-39,34,52,56,-29,57,-2,-13,-9,-22,-8,15,-11,41,11,8,-25,-32,-50,-57,66,31,-32,-68,-14,-7,41, 
  /* [1120][0][][] */ 22,90,-41,36,-16,62,89,-9,-45,-70,127,20,14,58,-8,-22,-73,-22,28,-52,-39,67,45,-28,47,42,-89,-80,9,-35,-28,-28,-6,-94,51,51,74,80,7,-20,34,3,13,33,-57,24,9,82,10,-50,35,-36,-47,18,-56,21,-44,-1,71,-36,-32,38,-33,-94,39,102,58,82,35,7,-19,76,-49,57,-22,-12,23,90,-40,13,12,30,45,48,12,0,33,35,34,-94,-9,38,-15,-25,34,82,2,64,58,0,-32,28,48,-39,31,50,-27,56,24,-64,65,52, 
  /* [1121][0][][] */ -28,90,-41,26,4,-6,29,10,-90,-29,0,-11,4,29,1,49,-27,10,-17,63,-14,45,-22,-73,-34,-22,-1,-21,-16,33,6,-7,32,2,-3,-61,-5,-55,22,86,69,11,71,-21,92,47,4,-24,67,-122,8,4,33,5,-38,5,127,27,3,-66,4,-62,-5,-15,-56,9,72,-13,-73,22,35,17,-40,-24,-39,-10,-68,14,42,-16,-40,-14,-32,50,10,-19,-55,29,-100,51,-21,-51,43,-56,-21,-15,1,-10,-84,8,8,18,39,12,116,-23,6,-97,65,27,-37,-96, 
  /* [1122][0][][] */ -20,56,43,29,2,4,9,-9,56,-24,66,8,17,56,-19,50,77,41,39,69,38,102,49,-39,-95,25,-26,-33,62,28,-95,35,58,68,75,84,-63,83,-23,41,29,-14,17,4,18,49,-13,-105,-22,20,106,-24,7,-6,-19,-44,-41,1,5,-64,36,-35,-26,52,-18,-99,-16,-11,15,-26,-78,99,-6,-33,-16,26,7,46,60,-17,3,-36,-24,60,-64,-23,26,-44,-25,-19,-27,6,12,-127,-14,-43,-53,27,63,5,-77,12,19,44,-39,105,-46,-38,24,69,-28,83, 
  /* [1123][0][][] */ -32,-19,-14,54,68,-37,-23,-49,6,-14,-23,-11,1,-49,-77,-32,-32,28,-23,9,-28,45,-29,12,18,-61,-14,-65,-6,-39,-18,21,-15,-64,-60,-51,-18,-45,-61,-29,-35,4,-5,-23,-54,-99,-73,15,21,-14,47,21,-33,4,-7,87,-70,82,45,-39,61,-36,46,-68,-8,2,-8,35,-8,-5,53,37,-26,35,-50,-60,-39,22,86,-5,-3,29,-47,-8,-8,18,-43,35,44,-44,-127,53,-2,44,-8,-15,3,61,24,25,-11,1,-5,-52,-25,7,6,100,47,22,-47,-24, 
  /* [1124][0][][] */ -5,-8,-22,-4,-7,127,-44,-16,-66,-99,19,23,-7,65,-20,2,-48,-8,29,-56,20,50,12,32,15,15,-59,-60,-3,-41,6,-8,-11,-6,3,71,-13,10,24,-61,-55,-21,38,20,47,17,55,13,16,73,60,5,69,-84,94,-56,17,-1,15,-13,-68,54,-29,31,-11,2,1,55,38,-6,-21,-11,47,-18,-3,4,-69,1,55,-36,-34,55,-72,-58,34,-35,-4,45,-25,-36,-12,34,-26,-5,47,-16,-35,-46,-29,-100,9,-31,38,-40,37,-35,-14,6,6,-51,5,-21, 
  /* [1125][0][][] */ 18,-51,35,57,-37,-52,37,-92,-3,4,23,16,4,62,83,54,0,2,-18,36,100,16,94,26,-37,-62,-26,11,5,8,26,-21,-127,-50,-18,-37,76,-42,0,-14,72,13,-77,-9,-16,-51,3,25,88,-22,-13,24,-27,-93,-82,39,17,-15,14,-25,14,-6,30,40,-29,39,-37,7,-36,50,54,-19,-2,-32,-72,-48,26,68,-20,47,-38,61,24,83,35,-18,-6,15,9,-35,-4,-20,-16,88,-33,10,37,27,57,-48,20,28,-13,-54,-12,41,9,-19,32,22,-73,-8, 
  /* [1126][0][][] */ -82,78,5,-1,40,36,-31,25,-8,-7,5,-19,13,23,-5,-14,2,24,-41,21,62,41,-10,-19,-78,8,35,76,-15,11,-23,-42,23,-39,-27,14,4,-42,7,-56,-35,-23,-30,7,34,-23,-59,52,51,-42,36,24,-48,-34,10,-59,-61,-7,-46,63,4,-42,127,-2,-57,3,24,-45,-36,22,-4,54,40,-43,-6,-12,25,13,19,-55,26,-36,-33,25,58,-33,44,-21,15,55,-14,10,-32,-4,-3,50,1,25,44,-19,8,-63,19,114,55,3,-40,-8,-35,-10,7,93, 
  /* [1127][0][][] */ 7,-114,-11,-49,-69,-92,33,57,127,-46,4,-44,-41,98,0,23,-41,20,82,-24,-18,41,54,22,-8,-18,-54,-9,-28,24,54,-47,-18,-33,-55,-47,18,2,3,-4,1,-77,63,-19,44,41,70,-24,36,-15,23,48,-14,80,4,-46,70,-11,56,5,73,65,18,-34,-37,31,37,8,27,61,-94,2,-44,2,60,109,-49,43,-6,-19,-39,-68,-39,-79,-48,-57,-26,-53,60,-10,-85,60,3,44,98,-73,-11,-5,-34,-40,95,-2,46,66,20,-35,-51,40,43,8,16,-23, 
  /* [1128][0][][] */ -33,-31,-13,11,0,1,46,-59,-24,36,38,32,64,-57,55,-19,-13,58,1,-28,1,-23,37,53,17,7,-60,13,-46,-10,13,44,36,-85,32,-33,-22,-40,-9,17,-16,-1,-9,42,-59,-41,27,4,45,7,-53,36,-15,-13,42,6,67,-41,39,-4,0,-66,-36,-43,7,6,-4,36,-35,-29,7,-23,-10,6,39,9,26,-1,-23,-8,49,-51,-16,46,43,12,28,-25,-14,-37,-11,18,-60,-12,25,-25,-27,24,1,41,3,-28,17,-6,4,-34,6,-127,31,27,2,-16, 
  /* [1129][0][][] */ -6,-32,-1,-14,-25,53,31,-13,-21,-30,-93,-89,-17,98,18,-36,-1,-112,47,-42,89,-51,21,7,65,-53,-66,29,32,-23,4,27,-4,-59,27,-6,-44,-20,11,-73,37,11,-9,1,82,38,36,62,-59,58,55,-19,82,56,6,-102,-34,2,-38,14,-85,39,63,16,-10,64,111,12,91,1,-46,34,-44,-11,-3,75,-5,-7,-28,-31,-28,-34,3,-42,-89,-7,111,-78,-24,100,-46,-127,67,-81,-57,5,-30,-42,66,12,-37,-42,40,98,-1,-87,13,31,66,49,-24,-100, 
  /* [1130][0][][] */ 23,6,3,18,-22,-8,56,-37,-11,-24,-5,25,-4,-34,-13,31,64,-74,41,-26,6,-36,21,3,18,-24,-22,13,-21,22,-31,-34,-18,11,20,14,8,-22,-71,-46,31,12,12,46,81,7,40,-31,-17,39,27,-44,-43,20,-113,-19,127,21,32,-11,23,-44,-8,-40,10,-63,-8,-12,3,-3,-43,-12,-24,3,24,-11,15,-15,-32,1,21,3,18,-45,-79,5,57,-59,-26,-10,-5,63,7,-38,-4,-20,-2,-9,-3,30,-8,13,19,-41,27,13,-2,-25,-33,37,-22,-22, 
  /* [1131][0][][] */ -2,-71,-34,55,43,-64,58,0,13,11,-7,45,-38,-54,83,1,39,-11,-14,-48,-6,-2,4,-2,-12,-17,18,43,19,37,-6,16,-7,85,-1,-22,-43,37,73,-17,-55,-19,75,-32,50,42,10,-72,43,118,-17,19,-74,-44,-48,-13,-47,16,27,-3,35,95,56,-102,-68,-56,73,-30,-38,25,-59,-86,-18,102,86,13,23,-12,-50,-50,-14,69,-54,-57,19,-127,-30,-33,-22,68,14,-46,42,75,49,-48,43,61,-81,28,-46,37,-62,49,-48,-29,-80,48,-68,-13,41,29, 
  /* [1132][0][][] */ -40,-37,9,33,9,-31,-11,53,-2,-44,-16,28,13,-28,-39,-14,-50,-30,32,-23,-24,-18,-39,-34,67,-75,32,6,12,-63,10,-2,-11,-17,8,-63,-38,13,8,35,-10,-61,13,18,10,-46,-6,59,-11,15,-13,-10,-21,-4,5,31,-1,42,-6,-65,7,10,-34,29,24,127,-12,-2,4,-46,-39,6,-31,27,10,-49,44,-43,-5,-15,14,-24,22,58,-8,-1,8,14,91,8,20,-20,-6,-5,-22,51,-32,33,-7,28,-28,14,-9,0,44,29,27,62,53,-22,7,-16, 
  /* [1133][0][][] */ 49,-79,-67,127,-3,-23,49,-24,30,-67,-30,9,28,-56,28,16,47,-57,46,-44,-13,-19,-91,-5,-68,19,-23,24,-84,14,-9,14,21,-24,78,-11,19,-12,39,74,-36,42,-68,-25,-63,14,-46,-96,-32,-12,-3,-90,34,50,-20,11,-33,-54,30,4,5,-2,-29,-55,-28,22,-5,106,-7,63,-63,-47,6,-78,74,-34,-18,69,-37,36,46,-1,-57,1,-28,-2,-16,-48,-22,-95,55,59,-63,-79,-31,-3,-56,-25,8,56,-16,50,61,-97,-71,-52,-53,-44,-58,-13,31,41, 
  /* [1134][0][][] */ 61,-14,41,86,-16,-1,-25,14,32,85,-51,9,26,-12,11,-56,21,-21,-91,12,-25,48,39,-79,-39,17,16,48,-23,85,44,-57,-65,-27,69,64,-12,-3,68,38,-19,-70,-34,-44,-46,-39,31,-5,46,83,-12,1,35,-12,85,21,0,-10,-92,84,3,106,-40,6,76,-35,-61,16,-34,22,-28,26,-39,20,-7,-48,-47,95,83,36,-58,-20,-110,21,59,32,-56,47,65,-127,7,-31,-42,31,-17,12,-69,60,39,-30,8,8,-15,-14,35,-43,-41,-61,-46,44,-8,21, 
  /* [1135][0][][] */ 0,1,96,62,-22,98,71,-15,20,-51,31,-14,-13,20,-14,109,73,53,19,9,-43,15,65,15,17,8,-63,14,-2,34,68,-46,43,-35,-51,-71,50,0,-31,-43,-15,37,-103,-16,-35,-46,49,19,-2,-37,5,-20,6,17,62,-13,58,-42,62,53,-16,108,-38,-25,-55,-42,-62,-10,-31,15,71,-24,13,3,72,9,16,-7,-7,77,-22,8,-60,-2,108,15,-12,35,-11,-25,-3,-57,-55,-5,-22,42,-65,-53,93,23,37,-5,4,-11,61,7,-9,32,97,10,127,-18, 
  /* [1136][0][][] */ -36,4,37,17,55,-62,40,-4,-52,46,-49,-40,2,-39,-14,-56,114,40,-35,20,42,-29,4,-16,-26,3,0,-59,9,36,-44,-16,90,2,-20,-91,3,28,109,-57,127,35,5,-10,-66,-41,54,-3,-25,-46,-18,13,62,-63,-30,4,-33,26,-21,-11,-74,72,3,20,-14,13,-75,-44,-56,-42,-63,7,17,62,-31,9,-92,-43,55,17,23,58,-15,37,1,26,95,53,9,-30,-23,-2,-40,63,-55,-24,38,3,25,99,-50,68,-13,-63,56,79,20,-56,38,8,-102,18, 
  /* [1137][0][][] */ -14,125,-12,-46,21,108,50,-4,-55,-89,-55,-11,-10,-35,63,41,6,58,15,38,31,57,25,-21,52,66,-26,-32,-53,127,12,-18,-106,37,35,75,22,26,-14,-75,-20,36,66,-54,36,-1,-12,21,-26,-9,17,44,-38,13,10,72,-19,-44,79,43,29,-30,30,-95,68,-6,-71,-96,30,57,27,-98,-14,15,37,-14,-100,-26,60,10,-11,-6,-59,-12,36,78,-78,44,-91,-78,-14,10,51,2,-113,-4,-31,26,-13,31,-26,-8,-1,-3,19,40,61,33,-30,-27,-30,35, 
  /* [1138][0][][] */ 51,2,34,-10,-34,0,50,12,8,-57,60,20,-31,-6,68,47,-53,-4,-2,-35,40,70,92,-63,15,51,-8,1,54,10,82,-29,17,-38,36,106,-50,-65,15,61,5,22,-16,-4,19,46,-25,40,-127,29,-38,55,23,-17,42,-35,63,43,9,-45,17,95,-26,-15,24,47,72,-25,4,22,42,-34,28,-42,-24,-43,45,22,-15,-72,-43,7,-15,-17,40,-28,58,15,13,19,13,-25,39,-2,-26,-6,-44,18,7,-44,-18,46,-39,59,-8,-1,46,-40,69,29,-58,-35, 
  /* [1139][0][][] */ -2,37,31,14,4,44,37,23,-47,8,19,22,-39,24,2,-40,62,3,31,-29,-26,39,7,53,-9,70,-8,-25,88,-40,-21,58,16,68,34,-2,4,-73,39,20,-3,29,-15,2,17,-41,56,15,-2,-24,48,2,-53,-13,18,34,-66,-34,-10,-52,-54,37,-19,-78,2,0,11,-102,-39,32,47,1,91,-35,43,33,-6,45,22,21,33,14,-47,-20,-23,-31,31,-40,8,-49,-11,-43,49,-75,28,-19,43,-127,-55,5,-24,-10,-4,71,-34,7,44,29,23,69,-61,-12, 
  /* [1140][0][][] */ -2,21,10,13,-50,5,21,5,57,58,6,3,-12,-16,-30,30,0,-13,-26,-127,-22,-48,11,-9,42,-22,39,-58,36,1,-12,-19,-1,-8,70,-45,25,73,-3,-99,-19,-48,-70,36,13,4,87,96,-61,59,48,75,-52,-39,-56,-19,4,3,34,-32,-15,51,44,-46,4,-29,-27,-20,-20,1,5,-16,24,11,37,20,26,-53,-2,-34,66,10,-35,40,-49,22,23,9,28,-43,40,2,37,5,-9,-46,59,43,57,-26,-39,-26,21,61,-61,46,-14,50,38,12,5,11, 
  /* [1141][0][][] */ 3,91,-44,-26,-3,-6,15,32,54,-29,67,-63,-57,-17,-24,57,-13,-51,8,-52,90,-14,15,1,-105,-37,-24,10,64,-27,-22,-28,-32,27,-2,5,101,2,-23,12,30,-34,-74,59,-8,-31,65,-4,-36,45,-47,8,17,-38,32,2,-13,55,45,96,18,40,-12,-33,-52,-2,84,-10,47,-7,4,13,-2,85,58,-98,61,-76,60,-45,-57,127,49,-30,-39,26,-29,-37,-24,18,108,21,-64,-18,23,18,-55,-2,-71,27,7,-31,-15,12,12,-1,-32,-61,-66,-18,64,-3, 
  /* [1142][0][][] */ 52,9,-25,-25,23,22,-1,44,-71,-5,-7,-16,1,8,-22,15,42,-16,-24,-20,-13,37,-3,-22,-42,60,-30,28,-3,-35,-51,-21,2,37,-1,-9,-46,-30,78,10,1,-22,7,-3,-44,-127,-32,24,-57,-34,-2,11,-45,-38,-5,30,-19,-10,-15,-57,10,4,-22,-23,34,-10,20,-22,-64,-39,17,56,4,-44,-11,-21,-42,-23,-8,63,63,3,-12,-14,15,-6,43,87,19,-74,10,3,33,-7,-22,-15,-34,-3,-20,-28,-5,21,18,-21,-59,26,-7,16,-43,-31,72,3, 
  /* [1143][0][][] */ -48,12,-47,-74,7,77,52,-59,-59,-40,127,-24,-34,-30,23,25,-65,22,52,-54,-33,124,11,-9,65,45,-42,-23,8,-30,-17,-23,-10,-30,87,-49,-3,-38,-59,104,7,78,24,-33,-7,72,-49,-22,78,-65,45,22,7,48,10,102,-57,29,-18,-67,51,95,8,-3,-1,23,-40,-35,-36,87,-36,24,100,70,-55,-11,3,39,91,-68,4,17,27,61,3,-54,33,-22,-47,4,10,-19,-26,-42,-40,-7,-62,0,1,17,-96,4,19,-15,-59,-48,-65,-27,-101,7,13,-51, 
  /* [1144][0][][] */ 38,15,15,87,-31,-21,33,2,-27,54,-53,86,1,-17,-63,9,31,48,-10,42,-47,6,-32,-8,68,-71,5,9,-34,11,-12,-4,-36,24,-36,32,-47,0,-5,-37,-54,-93,1,-42,-47,6,15,-30,-30,-73,-16,-62,-18,76,29,103,49,-37,-9,29,37,-22,-18,28,28,-10,2,-46,19,-48,-23,-38,-31,27,-12,-74,-6,-33,-16,3,18,-90,-19,-15,28,93,31,-15,-76,26,-37,64,-52,-4,-11,127,33,-62,22,43,80,-29,5,-54,16,68,20,18,-27,59,-17,-40, 
  /* [1145][0][][] */ 10,-23,52,80,-23,-22,-6,41,0,28,-13,-29,57,67,-13,-2,98,-28,18,5,94,3,-39,-32,-21,-58,16,-19,-4,-29,70,25,-64,109,27,12,23,68,-3,-8,42,0,50,-21,19,-29,60,61,33,6,-5,-34,-127,34,-102,-12,-86,29,-2,-4,-54,90,-5,56,20,-9,-7,-41,74,38,26,-15,-87,40,-50,15,-24,31,-27,54,38,77,-31,-12,-25,0,-8,-45,26,10,-37,53,-110,-7,62,46,72,54,-28,-18,-85,-13,-10,5,60,45,70,-3,24,8,-101,85, 
  /* [1146][0][][] */ -69,-11,-27,35,-80,127,33,-61,49,-11,39,-4,-40,-67,15,25,12,-46,35,5,-7,-19,-31,-58,-47,-61,-66,86,-11,-19,-66,107,20,-6,96,-18,-38,4,69,-36,-20,-11,39,56,20,85,-27,20,2,22,-66,20,3,-17,66,57,-28,13,54,-46,34,-6,48,-64,61,-83,28,-26,3,94,-16,62,17,-47,69,101,0,-36,52,-73,-6,29,-2,32,88,11,-14,-19,48,31,-23,-82,37,-6,-69,41,19,-17,-25,-40,-97,-12,48,-52,61,-35,-6,28,27,30,16,53, 
  /* [1147][0][][] */ 63,48,-3,-6,28,-7,-80,-85,-61,-22,32,14,19,-87,61,-28,9,11,8,14,-46,33,-10,-10,45,-32,3,-16,17,77,-54,4,6,-63,41,-49,127,25,0,-16,-6,79,-35,78,75,7,-39,22,46,100,-26,49,-84,26,-18,24,-48,-65,63,-101,-42,-58,47,-11,84,-77,-3,-23,81,31,27,-28,-1,-13,-38,22,86,-80,1,-29,-12,25,2,-60,-91,-54,-32,64,56,49,-70,61,60,-54,-10,43,-67,32,97,-21,-18,47,7,-38,109,82,10,-5,-6,48,-74,-91, 
  /* [1148][0][][] */ -15,21,19,-30,-12,-14,16,19,1,-1,61,104,-28,-46,68,36,60,51,-10,-90,32,10,-30,-58,29,-50,-15,-29,42,-11,2,36,-10,-68,-8,-9,12,11,52,-56,23,22,-45,46,43,54,7,-37,6,-12,38,-38,-68,-11,-76,82,-9,4,58,13,-60,81,-31,-17,-3,23,-28,-99,48,-7,-6,-40,-30,-15,-10,14,-35,12,-120,73,42,14,12,12,-12,-54,6,-3,-26,-74,-24,-44,6,-2,59,59,-55,-20,23,-34,-118,-17,-49,-36,-27,65,105,-2,44,127,3,6, 
  /* [1149][0][][] */ -107,-86,85,16,61,-98,37,-95,85,18,-6,-16,-95,-5,-58,-26,-60,-98,1,123,37,-57,-80,-51,105,-21,86,75,-14,50,-39,86,-39,-64,-44,-27,63,30,68,31,-56,-69,-45,1,21,13,104,-34,15,-11,-22,-66,-61,-84,61,-34,-82,-127,-35,48,51,-13,10,24,-42,-64,-91,12,-19,-50,25,-77,-4,14,30,46,-12,-84,-84,6,-17,-22,82,5,-28,32,58,-54,-5,25,35,-43,74,92,1,22,-54,38,-34,-108,-21,12,70,70,102,-2,82,-14,-11,-30,-6,-126, 
  /* [1150][0][][] */ -77,-52,-13,83,1,-53,-24,-38,35,7,-23,51,84,15,64,-76,-60,-30,20,-119,-32,116,-45,-50,-53,-75,-36,-87,-30,53,82,0,-5,-44,42,10,-19,25,59,-2,27,19,-23,7,4,36,68,24,-58,16,-45,-1,-29,17,80,55,-56,70,40,-76,11,127,81,34,31,-16,29,61,-46,-57,-89,-69,-2,-12,-39,26,-58,-46,-24,-40,-63,-52,11,-70,-44,56,43,-33,117,10,-18,-41,-56,66,-63,54,-22,43,68,82,23,-47,-4,-55,23,-30,45,27,-8,26,21,-12, 
  /* [1151][0][][] */ -112,-21,3,100,-25,66,-12,38,63,-1,114,-47,-87,48,3,-57,-6,-78,8,-19,-102,25,11,48,9,-63,-12,32,13,45,52,-21,-1,33,11,-12,-62,26,61,88,39,23,-58,-43,37,10,-24,90,-5,5,4,39,-98,-109,12,-34,1,-23,58,-104,-16,-30,-78,-40,-9,17,127,18,-76,-62,80,-14,34,29,110,62,-36,65,59,-41,33,4,79,17,-93,78,-60,11,68,48,-20,64,50,-43,-30,-109,-81,-59,-18,-93,-19,11,51,54,10,-100,10,96,105,121,9,-36, 
  /* [1152][0][][] */ -57,49,-56,-58,64,91,71,56,1,-33,-12,92,-81,59,6,13,-43,-64,32,-62,36,8,97,11,-13,-40,-37,-68,70,-16,75,-27,-40,-83,10,-83,27,71,-11,-54,30,57,81,24,68,36,-50,-46,48,-22,-73,9,32,58,21,-75,63,12,70,-11,-70,8,12,45,3,64,36,-24,57,77,-55,40,6,-38,72,54,-1,94,36,-90,38,15,2,-124,45,-24,16,-65,-62,-54,-31,29,-27,-72,24,5,-19,-127,-57,-85,-67,-17,-26,57,-61,-12,-49,-27,21,-68,-9,-38, 
  /* [1153][0][][] */ -68,-48,2,-90,-10,-36,14,-55,27,-95,55,-27,27,-64,-16,38,-24,37,-46,55,21,127,71,-3,-111,-9,-49,-44,22,-3,8,-17,-9,79,23,10,-3,-88,-35,5,41,-24,-1,-31,-76,29,-10,-9,-1,-2,3,-73,14,-89,9,65,13,-60,19,43,-85,-81,-12,-69,84,49,30,-11,96,41,77,124,-1,-34,23,-50,-59,73,-68,43,22,66,24,35,-26,-76,-88,19,45,55,38,-70,61,-71,-84,-27,97,75,51,-43,-76,10,-45,111,19,5,-1,-5,-15,52,-47,35, 
  /* [1154][0][][] */ 74,87,-114,-34,-25,43,-31,-71,4,31,-14,10,115,-50,28,-16,32,45,7,35,15,-32,32,-18,-32,-63,25,-127,20,-17,-108,-47,-66,-6,-16,62,-7,-8,24,27,1,59,-15,-59,9,-18,46,-23,32,35,106,16,-15,-31,-42,4,-25,13,-87,20,-11,65,-54,18,-2,35,-6,16,-54,-95,-54,19,62,11,-77,-32,8,58,-57,-18,17,48,-16,-16,-74,-30,-57,47,-39,93,-36,-62,-87,-30,-33,-96,-33,-28,20,18,-25,39,-11,25,91,-24,3,-16,-22,41,-100,-9, 
  /* [1155][0][][] */ 28,-60,-64,-83,-80,43,-42,-25,65,-51,127,49,-119,-54,61,9,-55,-43,22,-71,10,60,16,-15,47,8,-2,31,108,-105,8,9,0,13,85,-7,-84,-51,16,40,61,-54,13,-96,8,26,22,52,25,50,5,-21,-55,-7,26,-2,32,-71,-12,-116,15,30,64,-28,20,26,-5,-23,-28,-7,3,0,16,9,-13,16,71,-14,-16,-48,55,-31,-52,38,55,13,98,101,-5,29,10,-22,16,-48,-74,33,23,-30,-26,40,71,46,3,86,91,45,-76,-20,35,-24,52,10, 
  /* [1156][0][][] */ 44,8,11,15,73,3,-15,-12,-1,7,-20,-36,34,2,-36,16,21,-44,67,20,44,-49,-34,61,87,-31,-82,18,6,-71,-4,25,3,-17,-35,57,54,27,-33,-8,-7,28,-24,-7,-7,32,64,33,58,-21,-6,27,-23,39,20,-12,-3,-22,58,20,-19,-78,-6,-49,-61,-31,40,0,19,-24,-26,-7,-7,-45,14,55,-1,0,14,79,-6,33,-8,0,8,8,-38,-58,-12,8,-33,127,-12,-91,-38,-49,3,15,-21,-43,-46,-31,-59,-17,-83,-13,57,15,45,2,-29,56, 
  /* [1157][0][][] */ -24,-67,-2,-10,18,11,6,-46,-74,69,29,-4,36,-23,-49,-52,-109,3,-27,-62,92,21,87,79,11,1,-71,1,-45,-55,-7,-60,-41,-43,76,-12,-40,-26,1,14,72,-54,-3,-7,-45,-72,-60,12,-45,-108,-13,-32,66,65,25,7,-17,-81,24,-26,4,-32,-5,33,-9,-49,87,11,-26,-85,4,20,-7,8,34,-29,-45,66,26,65,-39,-44,19,-13,9,5,-12,18,-5,4,-16,35,-2,15,38,-7,-7,16,5,-74,-4,17,-3,-30,-9,62,41,-18,-67,-127,-52,21, 
  /* [1158][0][][] */ 5,31,-29,-12,38,36,34,-49,67,30,65,12,16,11,15,29,73,-30,-84,-45,15,50,-61,-20,-20,-26,-2,-45,-18,-39,-127,-53,44,8,-14,26,-15,59,-39,27,-51,36,-6,-28,59,41,36,30,21,-19,22,-34,126,22,-25,52,-21,85,7,-34,-28,16,33,39,35,20,13,-29,-42,63,-66,47,-23,-47,8,2,22,3,-37,-22,-4,-28,-30,-28,40,4,-52,58,-63,6,0,36,-21,53,-36,-30,-43,12,64,-57,-60,-21,-26,-17,41,32,12,100,-23,-32,20,26, 
  /* [1159][0][][] */ -18,-22,-11,-83,-76,18,-34,20,-9,-24,-21,-127,-28,-32,33,26,51,-16,27,17,31,-34,30,67,-11,-29,15,-5,30,-54,48,-29,-15,19,3,78,-33,17,42,83,56,35,-53,-26,61,-76,-24,47,20,-22,14,37,-25,86,17,32,-33,-76,1,41,-2,-69,-43,-5,52,-18,53,29,13,56,78,4,-33,-30,57,-29,30,-15,50,30,40,40,111,-3,47,16,-14,72,28,23,24,-25,-27,8,10,17,-54,-4,22,28,-30,-42,63,2,30,-27,17,-57,10,6,31,-31, 
  /* [1160][0][][] */ 79,17,-19,36,-14,5,5,42,26,-44,86,-11,27,24,88,-72,-23,72,13,2,-37,56,-24,16,-26,-20,-28,57,-25,-14,11,9,30,-28,66,-16,-15,17,28,-31,8,1,-127,6,19,-17,29,12,-27,39,35,-11,-26,19,41,-17,10,-14,121,10,-77,-49,19,-9,40,5,61,1,-49,19,25,-7,26,85,-31,85,-36,26,24,-19,20,-94,47,67,-8,5,23,2,4,17,-7,-3,45,-17,-82,45,-7,4,-46,-1,-42,22,1,20,-3,-29,-28,21,16,19,51,-23, 
  /* [1161][0][][] */ 52,64,53,57,34,-4,56,-41,-21,-23,-96,-16,75,-17,37,-15,-4,-34,-40,-71,108,36,-41,-16,52,-17,34,4,-67,-126,37,-9,12,-127,2,32,-29,65,-72,-89,70,-5,42,24,67,6,20,24,-104,-52,10,13,43,-15,11,76,-90,-65,88,-100,20,-51,-7,11,-41,-38,-10,-56,8,92,-50,-89,32,82,4,19,-11,33,95,61,32,8,-53,-44,-15,-33,0,-4,44,-4,86,-60,54,-48,103,-5,-25,63,0,11,-79,15,49,88,7,72,-37,6,48,26,36,-37, 
  /* [1162][0][][] */ -31,46,90,-21,5,4,19,-2,-42,4,-65,-23,18,-12,-3,-14,-23,90,50,-14,-12,65,-47,-9,-21,18,18,52,-65,7,-9,31,-16,-64,14,-64,20,34,-38,41,104,-110,-36,-70,-36,-86,74,17,10,-7,-40,5,27,37,-59,30,33,127,49,-34,-25,26,30,12,-40,-9,-15,73,-39,-31,-30,57,-12,-48,37,-37,-44,-52,-45,13,33,34,2,3,39,36,23,24,21,-38,48,45,11,45,67,19,-12,-1,85,59,58,-51,-6,8,-5,104,41,35,65,-98,-39,92, 
  /* [1163][0][][] */ 23,64,-24,85,-66,40,22,15,-58,5,-53,-1,15,11,-13,-4,-29,-77,64,-49,4,-22,-8,47,-67,80,1,22,-31,43,-32,50,18,-98,-6,-2,27,6,-37,127,0,17,82,61,-45,-65,-78,-40,-30,-38,-41,-18,-60,14,40,-70,32,54,-34,-17,-44,24,34,-9,23,26,54,-38,-32,110,-90,35,-13,-32,105,-22,-9,-80,-32,-5,-19,26,-96,-43,-76,34,68,-73,94,26,28,35,32,7,2,-18,-31,-46,-46,24,26,31,70,-19,-22,57,-40,-14,-7,-45,-54,-44, 
  /* [1164][0][][] */ -25,70,-16,-43,92,-87,-17,-60,-92,-31,18,-19,72,-54,-28,-48,33,-52,27,44,0,10,-29,65,-36,-104,30,7,21,-53,23,-63,-82,-52,56,-83,49,-59,3,44,87,10,58,24,-73,-39,42,-10,60,-32,71,-39,65,72,-83,6,42,19,52,-16,-91,-2,-79,-19,78,17,-17,-9,70,65,-125,20,0,27,32,-14,13,11,-51,20,32,53,8,30,34,-5,22,68,-30,9,-1,7,-24,59,-60,81,-101,64,111,-57,-29,-127,-8,-47,3,-62,20,46,19,-99,-37,-50, 
  /* [1165][0][][] */ -47,33,-35,15,-127,-18,85,36,6,-33,24,-4,13,17,35,-1,3,26,39,51,32,15,-24,11,-3,95,-8,-38,-85,7,-12,13,-37,23,-11,23,-14,4,4,-49,-18,50,20,80,-20,-56,-46,-12,-42,-8,-1,-46,-25,9,89,-25,6,-33,40,9,40,-44,19,7,-13,-49,58,-14,-21,-1,16,10,-48,-57,-79,43,-19,33,-39,-46,-29,-26,62,-11,-34,14,50,-17,-20,42,-7,-10,37,-25,44,18,62,-22,16,44,36,-61,0,58,39,8,20,-24,-59,21,-60,53, 
  /* [1166][0][][] */ -23,7,28,42,-6,-79,10,42,21,22,68,-32,-61,-24,-18,32,42,33,76,-3,-42,31,-23,-2,43,-24,44,-74,-54,-29,70,7,13,19,3,-45,21,-31,-79,30,116,-25,-66,-12,-78,52,-41,30,-22,-127,-2,-12,51,-22,29,24,-16,-31,-84,50,-62,37,59,30,39,-79,2,5,96,39,9,12,25,-64,10,96,-4,78,-20,76,121,-38,-84,49,-12,-30,-102,-37,-118,57,-105,28,-35,-28,51,-94,84,40,-48,2,-12,0,-24,-45,6,-44,-49,-46,52,-92,-16,-40, 
  /* [1167][0][][] */ 4,-51,78,-11,-48,9,-127,10,7,-52,85,-19,-98,-48,30,6,-27,69,-37,-25,-47,22,-48,-48,-12,-67,-2,48,31,-39,-16,74,-55,-1,5,32,115,12,-15,18,37,-40,-112,47,-28,-82,70,29,-72,27,0,-24,23,-25,20,8,-13,39,-5,-5,-1,-23,-17,-5,-21,-121,-11,43,35,55,-87,27,-27,-71,54,60,28,-67,4,63,-47,103,100,49,16,-19,-16,57,27,22,-11,-75,-47,-52,-68,78,41,0,16,-21,-51,13,18,29,9,-72,-24,-46,55,-63,119,4, 
  /* [1168][0][][] */ 5,20,4,66,36,-14,82,-17,-21,-26,-38,50,32,-11,17,1,-43,110,-7,-27,-32,-10,2,-22,10,-68,-108,-60,23,-34,48,22,3,43,62,-46,67,15,22,1,-18,19,0,-37,49,8,53,-17,54,-12,21,25,9,-16,26,42,-38,6,-35,-92,24,-41,-41,46,14,42,-27,-62,26,-25,33,-6,-101,-33,-2,-34,-11,8,127,34,-80,-12,-19,-23,13,37,-30,-11,-61,-64,10,18,38,-97,-46,-52,-60,56,38,-22,-14,-23,-51,31,-4,-31,22,-52,-3,17,-63,-61, 
  /* [1169][0][][] */ -14,-51,73,-31,-59,81,13,-55,127,-38,69,48,-37,-27,39,27,13,26,62,36,84,-6,-50,99,-19,-48,-27,-54,-78,-37,-103,70,-23,8,72,-14,23,-41,-16,-61,23,-6,43,69,83,-54,35,53,23,-2,63,-27,-25,-27,21,-8,-40,52,29,5,71,-27,-6,65,23,-34,-44,12,-25,9,-26,-112,-2,10,69,11,-1,-15,8,-68,33,35,51,-60,-12,29,70,-12,3,-13,0,25,39,48,27,30,0,-39,47,120,-51,-88,-75,-3,-38,13,5,-102,25,2,-18,-57, 
  /* [1170][0][][] */ 38,-33,-62,19,-25,9,18,-18,-28,5,30,38,36,-100,65,-2,8,-23,-14,-6,38,-53,15,-59,9,24,49,10,5,127,-20,3,64,-10,7,-8,56,58,29,30,29,28,-14,26,38,0,-20,42,6,0,-59,-17,-37,-11,5,4,-49,36,-67,41,-52,17,67,-7,47,-7,-47,-9,20,2,52,19,-75,-18,-11,16,13,-98,-12,18,-6,47,33,-47,19,-5,28,13,44,7,60,2,-9,28,-24,9,15,14,-50,-27,21,-25,2,29,53,0,97,-43,-45,22,57,35, 
  /* [1171][0][][] */ 32,1,29,49,-11,36,47,8,-26,54,-31,-25,-38,7,-39,11,60,42,-18,40,-62,7,16,-20,-127,21,11,36,-15,52,-42,-1,-8,40,-8,11,-13,25,78,37,63,18,38,-38,-73,31,52,32,33,-85,2,13,51,-20,52,-18,0,22,-4,1,81,-103,53,57,2,47,0,-39,20,-53,-66,-97,-10,22,26,-17,19,37,-8,9,-5,16,30,27,0,-16,8,41,6,63,-32,-39,25,-8,-26,-18,29,-35,-9,-38,-18,-24,-47,-29,46,-53,-11,57,59,25,-71,-25, 
  /* [1172][0][][] */ 27,-5,58,54,74,46,109,61,-21,47,0,100,-29,-35,1,0,-69,-38,10,-13,11,9,45,-111,-57,-4,5,-38,-38,-20,-52,10,-13,48,77,-19,54,41,-47,-41,-8,45,52,47,72,-41,2,27,0,-11,-27,-41,-9,10,107,-26,60,-6,65,-4,45,-86,-34,-66,-5,-30,17,-80,-72,8,33,-127,-22,23,58,68,-88,5,-28,11,81,21,29,-8,-49,18,-9,37,-51,-26,-66,-42,-22,25,13,26,117,-45,-8,55,63,32,-19,36,-20,-9,23,-69,-17,-11,-37,68, 
  /* [1173][0][][] */ -31,8,40,15,10,12,-65,14,40,-57,-4,-67,17,59,-70,-37,-20,23,90,5,65,-8,26,2,-91,-88,-7,-55,-6,21,-14,-66,-112,26,127,-15,74,-37,-52,-20,21,30,3,-2,-43,-5,-25,9,-91,-69,-67,40,-55,-50,28,0,-92,-10,18,-10,-30,0,0,47,81,21,34,-39,-7,50,-12,-19,9,67,28,-13,36,-18,-68,-35,-18,-4,50,-9,3,16,9,0,-11,49,-73,-19,41,32,-60,27,12,-46,-24,23,7,-22,-31,52,27,-71,9,0,-16,-2,-12,5, 
  /* [1174][0][][] */ -71,-117,49,-7,61,43,-13,-29,88,24,36,-7,20,55,-36,-18,66,-67,40,17,-24,10,-34,3,-8,7,-69,-16,6,-55,-18,13,-38,-1,43,66,-3,42,-1,31,-2,-83,28,17,-59,10,26,2,-31,-10,13,-13,14,6,-10,-12,65,34,5,10,17,15,-62,-18,-14,-12,70,-11,-51,-74,30,30,-25,39,127,49,8,11,-39,34,114,28,-36,-104,21,28,-103,57,-7,24,-4,76,-21,-24,18,-19,89,-12,34,-50,-16,-11,29,-54,14,11,-13,-30,-6,-87,-27,34, 
  /* [1175][0][][] */ 8,-29,18,-57,93,-31,48,-36,-8,-79,71,-1,-13,-34,-66,-111,-12,-51,-27,34,-9,49,-27,-28,26,6,0,31,115,38,0,46,-27,41,11,-25,-37,62,-47,71,-16,-17,-17,-22,-22,-34,14,-71,-38,16,22,15,-26,6,-9,-3,-22,0,28,52,80,28,13,27,-39,17,-42,-12,-30,3,77,74,-55,-10,-72,114,4,11,-6,0,-20,3,-10,37,41,-37,41,50,1,-64,11,-14,-77,35,9,-1,-57,26,-58,-19,65,-127,2,7,-26,-41,-42,27,41,22,-17,11, 
  /* [1176][0][][] */ 87,77,96,-6,82,-51,-39,-16,31,-8,-32,18,47,-35,-23,-95,31,-60,-44,-45,9,10,-49,-7,-32,50,15,51,-40,36,-38,40,-39,-43,7,33,-11,127,-105,16,22,-10,23,93,-26,-77,-19,9,-5,-21,2,68,90,8,-117,-67,62,30,9,103,32,-39,-70,58,-84,-25,-36,70,87,-113,-68,-13,-32,-69,-25,19,-59,30,-53,-6,46,-3,-10,14,68,-28,-116,-11,47,-20,21,47,55,1,-6,44,-17,-13,-80,27,-78,7,79,47,-114,39,55,2,-31,49,-11,1, 
  /* [1177][0][][] */ -49,46,-47,-50,-75,15,-1,-33,31,34,37,-40,45,-34,103,37,28,26,0,-41,5,40,-13,-70,-31,63,-45,41,-36,33,8,44,-12,47,36,-51,-13,-12,-30,-53,50,37,-40,41,4,71,-74,24,-20,7,20,-36,-127,-51,44,-21,33,50,-13,-22,-75,63,-11,-11,48,20,-12,17,38,-5,-24,-66,4,16,26,39,52,46,114,33,-30,-11,42,-1,-53,75,-108,30,-5,57,14,-94,87,-16,-34,20,22,70,-65,53,10,6,-89,23,-7,-16,43,35,-33,23,16,-27, 
  /* [1178][0][][] */ 0,43,14,67,-44,-59,-50,-41,-42,56,-33,-38,39,0,50,-48,-29,-101,-34,-30,-14,-25,13,-10,-94,-26,-22,-51,-9,-12,20,120,-8,-100,-25,9,-76,-90,-49,127,50,-31,-60,31,-95,-76,34,44,18,19,35,-61,-65,78,21,37,-15,-94,-60,-6,83,-14,-20,54,4,6,-25,117,15,44,-27,75,-4,49,-61,-82,19,36,-72,-51,62,-74,57,-4,-15,-4,106,116,-16,17,-32,-109,-8,39,-37,63,-83,103,-1,-3,45,45,-35,28,-17,-21,42,-9,30,7,9,5, 
  /* [1179][0][][] */ 24,-67,81,30,6,-39,-24,52,-11,-38,-34,69,18,-84,32,21,43,0,-77,-40,13,113,-26,-29,-9,77,32,32,-59,-27,-9,28,-3,10,-4,63,10,-2,88,79,23,-110,-23,64,-14,-29,-55,-9,-12,-58,-124,-4,-5,-38,49,33,40,9,-18,-73,22,8,-31,8,25,-19,21,6,-58,-30,-98,-66,-31,-5,-46,24,102,39,-48,-66,-40,87,-40,79,-51,79,31,8,19,-64,14,52,2,125,-55,127,-37,3,23,21,-42,59,-36,13,-17,-30,10,67,27,16,-32,-6, 
  /* [1180][0][][] */ 26,-20,-33,31,-39,34,-3,-80,54,7,-8,11,-51,12,-13,-46,-84,-41,34,-99,-22,16,1,-7,-7,26,-57,-23,-10,-16,12,-9,13,-24,20,9,-35,21,-12,-21,11,29,30,47,39,-42,11,-53,-36,-27,-32,-69,52,55,9,-14,9,-30,-3,4,8,-5,72,39,13,90,-81,-14,-9,-51,20,26,0,-24,-27,0,51,-14,-35,127,78,28,37,31,23,-34,56,-29,19,-29,-67,35,-34,13,-26,98,-37,35,14,31,-3,-47,-83,29,-1,-7,9,62,4,44,-21,-23, 
  /* [1181][0][][] */ -13,39,6,91,-125,9,80,81,-8,-34,11,-44,-60,-86,-17,-20,-25,-26,18,-29,-12,-36,-80,24,22,-92,-37,-74,-5,68,-2,21,65,-17,-51,48,36,51,-71,67,-7,19,73,-17,-40,-3,36,-47,46,-19,-66,-15,15,57,-11,29,103,-51,16,-41,-13,71,-93,-64,-2,46,-41,123,-104,-67,7,-42,41,40,56,-45,-75,39,22,-25,31,21,42,92,34,-36,-6,127,63,103,80,-56,-82,-1,20,24,16,-33,-46,-5,-12,-45,48,-31,62,29,-51,-90,-16,-69,19,-14, 
  /* [1182][0][][] */ 41,-39,-32,-109,-34,-21,125,21,44,92,-47,-77,69,27,-30,14,60,-66,30,29,78,89,41,-24,11,-66,42,79,1,-7,-53,26,69,-8,16,-29,-110,29,-35,-56,-33,-51,24,70,88,-43,60,41,97,16,11,19,-31,-27,-25,24,37,52,-50,-82,-46,9,-53,3,34,-7,64,-45,57,25,-86,-10,95,-31,-104,127,-18,63,-9,34,12,-12,3,-57,10,18,35,87,29,-33,-41,-92,89,12,-19,32,66,-23,-33,-23,-48,29,-44,30,48,13,-37,54,34,126,22,-29, 
  /* [1183][0][][] */ -2,32,-48,50,-50,101,-34,44,-74,-9,38,85,-69,-7,52,-14,-39,-27,46,4,19,-11,-65,28,66,-73,-38,0,64,6,22,5,60,21,-1,-88,41,82,-6,43,41,75,-108,0,120,16,-74,60,54,20,5,26,-25,-3,-39,4,-95,-75,4,2,-83,41,-28,13,-4,-43,-28,-50,29,82,-90,24,47,-22,24,-45,-82,-39,-6,-4,56,56,-76,48,-94,-21,16,-9,-62,85,-59,38,-76,98,-48,-4,59,-5,-127,0,-23,54,1,43,2,-10,10,21,-21,7,-47,65, 
  /* [1184][0][][] */ -9,-38,-52,-1,57,40,8,-9,5,49,35,7,-27,-8,9,9,17,-72,35,-56,37,-14,25,7,-36,-9,57,52,-7,19,-5,-45,-41,-18,-15,47,63,50,58,-42,-39,-40,-15,23,-21,13,20,4,65,-9,-20,64,60,28,58,-75,33,127,-85,-24,24,1,49,16,-27,23,16,-52,-24,40,-77,-21,26,7,-25,36,-10,-15,30,4,-28,51,1,-14,-16,-1,-3,-2,49,55,89,7,49,-2,-88,-47,-102,20,15,-89,42,54,26,-97,-5,29,-53,-75,24,-67,47,-4, 
  /* [1185][0][][] */ -1,19,127,55,21,-2,53,-65,-95,71,-18,-47,33,17,43,-28,33,-6,3,-31,-6,3,-51,12,40,-62,-60,-9,-3,-57,-29,-72,17,-27,-33,31,11,7,-36,-41,-69,23,-38,-83,-18,87,17,19,-50,-37,-63,-37,65,-97,42,21,-41,30,-11,-9,61,12,9,-20,-6,-80,-10,-73,-52,-51,40,13,46,-27,-6,-29,44,-84,7,13,27,39,7,-15,20,32,-43,-9,36,-9,-27,-36,-55,-64,27,-20,-29,-86,88,10,50,2,48,5,-107,-8,22,6,6,91,-53,-15, 
  /* [1186][0][][] */ 45,-51,-23,11,-27,45,-11,37,6,-5,2,24,-4,-17,-85,-2,-39,-32,62,8,3,63,36,42,-21,6,6,-17,27,43,-76,-127,-58,-47,49,-22,47,-81,60,38,-12,6,-9,-10,-18,-50,20,5,18,86,-22,7,-23,9,-38,64,-28,-27,-91,40,114,-4,3,-15,54,7,-13,-99,27,32,-32,3,-54,-2,-10,-14,-18,-48,-41,99,-9,-21,23,11,56,-5,-10,66,-112,46,77,99,79,-7,-28,78,-38,-109,72,38,-102,-46,-95,39,32,-35,-29,29,-6,-13,-18,69, 
  /* [1187][0][][] */ 12,91,35,37,-27,-24,17,65,-53,21,5,2,-62,49,35,-8,-7,4,6,-19,-64,-15,49,-3,-40,-2,22,-47,2,-37,-28,28,56,-39,-64,-67,54,6,-85,127,18,-5,-34,-67,-39,54,50,2,15,-17,-39,-51,46,-59,5,58,-13,46,-26,47,-9,27,-55,111,-63,-28,-62,-26,63,106,-8,85,8,-19,47,-72,-64,50,-10,-84,62,-50,-74,54,39,65,49,-32,-7,-26,33,-96,-101,-40,65,66,-39,85,-82,-1,-57,15,22,-75,-84,77,51,44,-71,-4,4,28, 
  /* [1188][0][][] */ -62,61,-73,75,-68,-20,109,66,35,34,-31,-6,12,-60,41,50,-7,95,32,39,-1,-42,24,41,24,58,-37,7,5,-11,49,-19,-21,-72,9,-8,-32,-54,29,66,-51,12,46,-46,-11,-4,-49,9,-17,-69,44,-43,23,-41,39,47,-127,-25,-106,25,65,39,-16,34,-37,50,-20,20,-20,6,94,31,15,50,3,-14,-21,-76,67,7,-20,-1,42,-8,6,40,35,76,-23,8,2,-35,-4,-79,56,0,-46,10,0,-43,39,-46,25,-41,17,6,-9,-1,-87,24,-36,42, 
  /* [1189][0][][] */ -36,7,-40,29,118,-100,60,33,44,-114,41,-75,-30,21,-21,-16,-20,93,21,31,-65,86,-27,81,40,6,-53,-1,-62,-79,-66,-59,53,37,40,-42,120,124,-55,100,-17,-48,-68,6,-58,53,-53,-99,27,-4,17,28,26,21,52,4,34,21,26,87,-20,101,-117,-58,-95,-31,34,-48,64,28,-101,15,-63,-22,11,-25,-51,55,56,-15,-12,23,73,32,53,-112,89,21,13,23,-40,35,-103,-97,-36,-72,14,-39,78,68,11,-54,-98,-81,-121,32,-31,-33,23,-127,48,51, 
  /* [1190][0][][] */ -7,-6,-20,3,21,-4,59,-13,20,19,-75,-5,-44,-7,-62,-26,36,-42,6,10,26,32,-3,4,-17,27,5,44,34,19,29,-68,-26,-24,-27,-7,-8,35,41,-39,-60,48,-10,32,53,28,56,38,-1,-47,-39,1,-19,-17,12,-8,-13,-12,-29,15,-53,3,127,7,19,-33,-53,-48,7,13,8,-24,-31,10,-39,-9,71,42,4,-16,-6,38,-15,42,34,3,-6,-21,-8,-52,-17,-81,20,-37,-79,-63,36,-1,-13,2,-36,-17,66,-38,-2,45,30,47,8,10,-55,-20, 
  /* [1191][0][][] */ 29,-50,37,-23,-35,-43,-67,13,12,-67,-3,-5,33,-3,53,-71,61,-30,3,-24,51,-75,-33,7,-18,29,-75,-70,41,9,67,39,-60,-17,7,-62,19,70,17,-63,11,81,48,97,-29,10,2,59,-41,-7,-61,44,-11,-73,-22,-127,-3,57,13,-41,-19,26,-1,-81,18,73,5,29,-57,28,-30,-13,44,3,-12,-4,-5,-14,-49,5,82,5,-9,5,-13,-15,30,62,-21,-54,3,-35,62,20,-26,14,25,-36,-51,-46,25,99,23,7,-21,-12,-19,25,37,41,11,4, 
  /* [1192][0][][] */ -10,-36,91,-10,-47,63,-46,11,88,58,53,-107,32,60,-127,25,6,-22,-56,-39,-98,1,81,62,-93,-56,-16,23,109,-44,41,-68,24,30,100,69,28,12,29,54,-41,-54,32,-20,12,74,75,10,62,30,57,-33,-71,78,-37,72,-48,4,-33,54,28,-65,0,-47,-90,49,42,-6,124,33,7,-24,27,7,-60,78,42,-6,-44,-16,42,-17,15,32,-68,62,4,27,-86,-10,24,10,-106,-73,-59,-12,-47,66,-86,21,-29,-4,15,-27,14,-39,-70,118,22,61,84,-59, 
  /* [1193][0][][] */ -67,127,-1,75,44,57,-87,71,54,35,14,-82,4,-15,-6,26,58,87,8,64,-55,54,12,4,11,110,12,-45,-53,50,-68,106,57,-41,0,22,18,-67,30,26,23,56,-41,62,-62,21,52,86,10,74,29,-10,45,96,125,-90,-18,23,44,-16,-25,65,-41,44,-66,-74,83,65,-20,-74,42,-7,-19,-7,-40,-31,-102,-44,14,93,-47,34,-6,-25,46,-73,-69,-19,40,4,-54,-37,-86,-66,11,98,-34,10,-29,31,-31,12,-59,-19,-30,38,-6,17,-90,-119,8,36, 
  /* [1194][0][][] */ -12,52,56,-37,-22,-4,-44,34,53,30,13,-23,27,-18,-1,34,-7,-17,-17,-18,-44,23,-6,-2,-5,-24,51,27,-49,-41,-27,17,-17,51,35,33,34,14,-11,-13,14,74,-16,-13,-4,28,8,50,-16,30,7,6,-21,127,-2,49,3,26,57,83,1,74,-38,-55,-23,12,28,-28,15,9,-15,-52,-65,1,41,4,10,14,-12,-38,32,-13,-55,-46,-30,32,-68,5,26,-5,15,-6,-11,5,-11,-33,57,-15,81,-28,-52,7,18,43,-52,-43,5,20,2,-28,-28,-22, 
  /* [1195][0][][] */ 16,-24,36,46,-69,68,38,36,40,-60,32,-118,-18,-37,-12,68,47,25,63,-29,-61,52,-65,-3,-75,8,47,116,2,16,63,2,-103,-20,62,44,-3,103,-55,-27,-5,4,18,6,30,21,-37,-95,-25,-56,35,90,-62,83,27,-67,-44,-15,-77,-34,-10,18,97,-25,-51,-67,41,-104,-3,-7,-56,-9,15,-9,5,51,-1,18,3,13,20,5,-10,-77,-21,5,-127,44,-33,-94,30,47,-34,-28,41,23,-20,18,37,-78,-62,-44,-21,6,-19,3,-52,-25,30,0,25,0, 
  /* [1196][0][][] */ -18,61,-2,60,-31,69,32,68,-12,-9,-45,75,43,80,16,-29,-4,-35,74,-2,26,-17,-70,55,26,4,-6,21,-73,58,-89,68,1,72,39,-49,-32,-19,-5,-3,12,-61,17,11,42,2,33,-37,-9,-56,-30,43,-1,44,37,14,19,52,-17,-56,-47,-11,-27,-53,-40,-38,82,59,73,-48,-28,-4,-28,-59,-22,-34,-53,28,106,-10,-15,22,-62,98,23,52,-55,66,-14,-40,25,-127,-65,46,0,91,45,23,-45,-46,12,-45,14,-93,-48,-70,0,-40,71,-20,-55,-10, 
  /* [1197][0][][] */ 66,-10,54,-19,19,-64,-61,28,21,64,-37,54,61,24,18,-108,-29,-109,29,-19,-40,-72,-90,5,-10,-49,23,-22,-29,-119,-4,-98,-22,-29,-36,-54,-2,-20,-85,51,98,20,-33,10,19,18,17,19,-35,69,30,104,70,-75,-18,-35,-5,59,-26,40,92,87,-43,-34,43,-118,65,2,64,-52,72,-34,-48,-19,55,13,-23,-85,8,91,19,34,17,-11,-127,83,104,-36,38,39,-32,35,-16,4,-24,-44,28,-119,-103,-40,10,57,-4,47,50,-63,11,11,-102,4,21,-33, 
  /* [1198][0][][] */ -66,3,-38,29,36,-19,20,-62,8,35,27,12,56,37,0,103,94,-21,4,-33,13,74,29,-32,38,5,53,53,14,57,-33,-17,-91,-105,-21,-37,-14,26,89,42,12,9,49,30,18,23,17,127,67,-34,-17,77,-39,-23,1,-65,12,27,44,98,-70,44,14,27,-38,37,-50,-19,-19,11,3,-115,-5,13,-19,29,75,-15,-32,-37,-84,26,-31,1,21,-18,0,1,25,-12,-69,-20,12,-49,-22,5,-25,-40,-38,34,34,12,44,106,-17,-25,57,-21,29,115,-5,44, 
  /* [1199][0][][] */ 17,17,-81,13,1,21,35,9,-57,14,2,-4,-6,20,19,23,-43,39,28,24,54,-11,9,-19,6,-38,-62,-18,56,-19,-38,57,13,31,10,-32,-48,-18,-40,54,-32,35,41,40,40,30,-9,94,-8,54,16,-21,-57,-17,-35,-64,-24,-43,-28,30,-26,90,38,36,11,44,-35,-55,37,14,0,1,-52,0,-77,12,-34,19,10,-54,31,8,26,-58,31,-127,-24,12,-45,0,-38,27,48,11,-77,-27,11,-31,1,-92,-51,5,-22,-12,-29,6,-49,24,-1,-42,-45,26, 
  /* [1200][0][][] */ -52,-34,27,-52,-25,-27,9,-16,-71,6,-54,35,7,-35,15,1,-34,-17,45,10,28,15,-17,51,21,7,-21,36,-10,24,13,60,-4,-15,-3,-127,44,18,-42,1,-45,-19,-7,-51,-22,-24,-32,-7,-30,-16,-15,30,-87,-46,14,-27,-99,52,-6,18,117,-63,28,16,-69,32,-10,-31,-74,22,42,-10,52,19,-45,-60,-79,-55,-31,-8,45,-67,47,21,3,29,-48,-78,9,-1,-55,-54,21,21,5,35,90,14,-22,51,25,36,68,-35,-38,32,13,1,34,15,-22,83, 
  /* [1201][0][][] */ 1,38,23,25,-68,-41,74,-6,-80,68,-59,-43,80,6,-69,29,63,5,82,-59,107,18,64,59,61,24,104,38,-54,43,-34,63,0,-6,79,42,-72,-27,-89,-26,28,-38,-2,86,-21,32,-3,106,8,-2,-25,14,-29,68,23,-6,45,45,12,-82,16,-46,12,-30,27,-22,33,3,6,-122,72,17,-68,23,22,-48,31,76,-67,-1,60,-38,13,-44,34,33,-1,-8,101,9,33,25,-81,-127,1,-2,-37,48,45,-56,-43,20,77,77,-42,-115,-57,-7,-40,-41,-106,51, 
  /* [1202][0][][] */ 64,-45,-61,65,-84,25,21,-78,-34,72,-16,5,-31,-81,44,-20,122,-4,56,-27,-66,-4,-106,-20,-70,-29,123,3,39,-26,50,-98,7,-53,24,-18,17,-70,-59,102,70,-16,-28,-5,83,91,52,-35,36,-113,17,16,-27,-106,-58,-45,-58,24,-86,-29,2,76,-17,-39,-27,-64,-84,14,116,127,44,-9,-96,-19,28,61,-89,-120,55,50,34,38,31,-17,40,-24,-89,47,41,101,120,-27,-40,-20,21,19,-108,-29,-23,60,-23,-95,-123,-109,78,2,46,-100,111,75,30,-61, 
  /* [1203][0][][] */ 114,88,39,-79,-21,-54,3,-86,-118,32,-10,-29,-19,9,18,-111,70,70,-77,-39,-26,59,59,-19,-23,-6,15,98,-28,-11,-1,-115,59,-5,-1,35,-65,-63,20,46,70,44,-30,112,52,42,53,83,-119,9,23,60,64,15,-32,-26,-8,43,-33,-86,48,33,27,11,19,78,-8,-62,-127,90,30,16,0,-24,-6,-7,54,-74,-4,-23,-49,16,-25,-64,102,-76,112,40,17,22,107,-31,107,-14,49,11,14,-52,-4,-13,-17,-51,11,-88,13,28,49,-65,-81,-44,61,-102, 
  /* [1204][0][][] */ 28,-106,-65,39,-37,-15,15,11,-5,57,5,34,93,61,-33,48,58,-49,-43,-51,-2,21,-84,16,-54,29,22,-71,9,-40,-63,47,6,-7,32,-43,-8,-9,-25,-40,47,52,45,127,-20,-65,-44,29,119,71,-100,8,-2,83,57,-23,8,-37,38,-33,6,-32,86,-9,13,10,-20,93,-34,13,75,-11,8,-59,-1,-27,-11,-61,49,37,-4,-77,94,111,-1,66,4,76,30,-4,-41,95,2,-8,13,50,59,-96,34,35,114,25,63,-43,6,36,59,3,-21,2,-79,-57, 
  /* [1205][0][][] */ -49,23,42,65,0,48,-37,-4,1,32,-14,4,-41,-30,17,-12,-52,32,-9,-5,-39,52,37,-8,-38,33,-19,-26,-52,4,12,54,20,-2,-3,-4,12,-17,3,46,-11,8,-2,-3,-37,22,-14,6,-33,-5,0,-33,-13,-46,46,9,-47,-38,-2,-36,-29,-21,-40,14,25,-32,-35,-14,6,18,37,1,-14,-12,33,-98,18,11,-5,79,12,6,-18,-4,-5,-21,38,-31,5,29,-17,30,-13,54,127,8,-50,14,-37,17,34,-69,14,37,56,-18,-8,3,4,-44,-5,-22, 
  /* [1206][0][][] */ -61,2,77,107,-16,42,43,-55,-28,24,-58,7,-45,-6,-8,-7,20,34,-7,79,33,46,-21,12,40,23,38,19,29,76,-20,80,-93,-72,16,-56,31,-4,-77,102,-28,-25,82,-11,-1,-52,86,65,24,26,8,-30,9,-32,42,17,1,-4,-42,-17,-30,59,-21,62,8,29,59,109,6,-28,75,-46,76,-52,-127,-42,88,-27,-76,-47,-31,2,33,-11,79,95,-68,19,-88,80,-65,-70,51,16,79,25,65,-12,43,-90,17,61,19,16,67,-13,6,-24,-13,42,81,50, 
  /* [1207][0][][] */ 59,-21,-33,8,-19,36,-29,-29,-36,10,69,30,96,-36,3,-50,4,-31,27,21,25,39,-60,-8,5,33,36,17,7,-37,-93,-8,-5,47,-73,-60,-70,36,31,27,16,-36,7,-45,19,18,-78,-3,-18,-47,-25,-13,53,56,-30,16,7,9,56,12,-18,-26,39,-7,-27,87,13,18,34,25,-10,19,-36,41,-68,41,-37,11,-53,19,39,25,-33,127,-20,-28,6,-21,-51,35,-26,-71,-4,-49,-21,13,-25,-31,-115,27,-6,-5,15,-22,10,16,-19,21,18,-30,-5,35, 
  /* [1208][0][][] */ 22,127,87,69,-11,-5,20,3,-11,24,-34,-39,4,-25,-74,68,-42,22,-9,-57,-12,-62,17,31,69,18,49,-26,-28,-74,22,-100,4,46,-33,70,-2,-17,-27,-24,71,-34,-14,-58,63,-12,60,-8,109,-53,54,36,-2,-28,-47,-26,28,-7,13,-71,49,-45,57,-45,71,127,-67,-77,59,50,96,64,34,36,-20,-11,17,36,9,-17,104,-16,2,30,-13,-46,-57,-2,-12,34,-91,-9,12,-9,-28,-38,-25,-37,13,3,50,15,49,-41,-59,11,56,-25,-39,37,-31,1, 
  /* [1209][0][][] */ -35,-31,-23,-68,-21,2,0,14,-77,21,-60,17,61,-6,-19,41,-108,25,-3,34,60,37,-9,-65,110,-8,-6,37,66,-4,-39,-60,-35,-127,80,-80,51,2,9,5,-11,62,24,-102,12,52,4,-23,-66,-92,27,-42,-77,-92,-7,2,45,14,19,-46,-82,30,41,41,-32,-1,-92,13,-80,59,39,-26,-2,8,-1,57,73,48,54,-33,-106,59,-3,-36,-11,-43,-12,21,-22,-97,-38,7,-1,20,-119,20,20,91,54,82,66,-27,-32,-45,-12,58,5,-6,-90,59,105,-30, 
  /* [1210][0][][] */ 47,39,18,89,-60,-60,57,-34,32,42,92,-86,-86,-79,-59,42,-36,-39,-46,-100,13,52,-17,-58,-31,-5,0,-12,42,-62,78,14,-26,-59,3,-48,-9,104,47,9,29,-54,-47,-62,-25,19,43,-127,-32,72,106,105,20,6,-36,30,-43,-64,-49,-20,39,54,76,-25,10,-2,-35,-46,11,50,10,-66,-83,-68,6,62,14,-48,100,87,-4,73,7,5,-38,-37,-16,4,5,89,30,13,86,-49,23,48,-37,48,-3,8,77,-20,26,-18,-14,-29,-37,-74,21,-74,-26,22, 
  /* [1211][0][][] */ 44,-30,-46,-106,122,-63,-75,12,-35,9,33,16,-63,-57,60,-119,-90,12,-53,-32,-76,2,33,-34,-38,107,63,-33,-43,42,-50,29,-41,82,-11,6,-32,60,63,25,-61,27,-39,34,55,-70,-35,47,-93,117,-63,-50,58,-62,67,8,-112,-42,-48,-52,-90,115,-29,45,10,-6,73,49,-11,-43,57,-7,-15,-43,22,-101,23,-120,32,-10,4,73,-127,13,-65,44,-35,-23,18,14,-10,-42,-9,-12,-62,39,61,26,-48,43,-16,-3,24,64,75,51,-34,21,-66,-32,-79,-15, 
  /* [1212][0][][] */ 27,-3,-25,8,-40,23,72,1,-10,-26,-30,-18,11,32,-38,-27,-7,-19,88,-33,22,-4,-13,51,59,30,-127,26,23,-97,70,-27,48,18,-23,-9,-3,-43,-33,14,56,-41,-5,-65,80,-9,86,-5,14,49,13,7,-18,0,16,35,-17,-73,33,37,-66,-53,35,48,-43,45,21,2,62,19,-12,-46,-11,71,80,-73,-36,44,-46,33,62,-45,24,2,-2,-1,2,-10,-8,-46,78,-11,-3,-49,40,-15,-51,-37,-20,-103,-120,-19,29,-11,28,46,-40,-67,62,51,90,45, 
  /* [1213][0][][] */ 10,-61,61,-62,-101,-68,-5,0,9,-1,-23,13,-19,105,16,-54,25,20,-9,7,-25,84,-25,26,-4,48,13,26,42,-39,7,-77,-29,61,5,41,127,-29,-22,12,-9,-2,-46,36,-35,-59,5,16,125,-26,14,-14,-41,33,16,-52,-36,53,-37,39,28,4,-25,1,8,19,15,-8,8,5,43,25,53,16,91,72,-2,35,-9,68,-35,-4,-10,15,-16,-3,-75,-33,94,36,-41,-28,-97,4,25,-6,-23,-93,10,-32,2,-17,-14,-86,0,-44,5,21,-19,31,-40,-27, 
  /* [1214][0][][] */ -30,-70,30,26,-4,-112,25,17,83,53,-38,24,33,-64,28,1,98,-86,-48,106,20,30,18,12,-37,6,-37,-80,41,44,17,-30,-25,70,75,-11,-68,48,-44,-118,25,50,-42,0,102,-13,77,10,-68,-11,5,12,42,-19,6,-69,-3,92,20,-37,21,-2,28,54,-37,-8,-3,23,21,-18,19,26,-42,106,17,40,-49,75,43,60,101,-53,47,18,45,127,-7,2,-11,26,-10,86,-21,105,13,13,-12,-87,27,-99,-45,-23,-24,17,-22,73,-74,92,-12,111,23,-36, 
  /* [1215][0][][] */ -17,-86,-107,-35,-58,19,-52,2,11,38,-1,30,23,33,3,-43,-1,-43,52,-26,-92,73,0,39,44,64,-16,14,54,-78,9,15,-40,-95,22,-11,21,7,-31,-46,-27,12,-25,-3,43,12,10,-35,-21,37,-47,-23,33,57,95,1,51,-51,33,35,19,110,-25,-37,-58,88,24,-15,35,80,42,-39,-31,40,83,-41,5,51,7,-49,-71,91,-54,33,60,34,-73,69,-25,-66,-31,-64,57,-36,7,-35,-63,-55,33,46,0,-23,-49,-74,76,10,-12,58,-63,-127,38,13, 
  /* [1216][0][][] */ 44,-56,-30,-94,-87,6,6,-46,75,80,7,9,-9,15,28,93,-2,55,17,-26,-54,-42,-9,56,13,2,-42,27,-69,-19,20,-20,0,12,-41,-55,-2,3,-47,39,-102,21,88,65,111,94,7,12,11,-88,7,7,19,-16,-42,52,12,-5,78,73,35,-46,-27,-24,-11,16,15,-66,-7,127,38,34,-32,66,2,-7,-64,31,-72,15,-37,-2,-7,-56,-38,-111,-50,-44,48,-40,-40,-42,20,-1,-5,-16,37,-12,20,19,-51,13,-17,-21,-35,-75,-49,-75,-31,-60,34,-26, 
  /* [1217][0][][] */ 16,4,71,78,-65,-33,13,-82,18,12,-56,0,-51,26,38,26,19,43,10,78,46,-42,-18,15,29,17,-31,109,-19,-1,27,-29,-54,38,57,-96,-80,-52,-43,-19,-15,25,7,-76,-9,-17,16,-34,44,34,-8,10,3,-17,30,28,-44,32,68,2,35,-34,82,-23,18,-34,-68,58,4,-21,127,-15,32,19,34,-66,-53,-22,-3,39,71,-67,-73,-66,25,79,46,51,-52,7,29,-12,-23,-1,38,3,-20,-21,51,59,-40,20,33,72,45,-38,7,-8,-9,0,-60,-40, 
  /* [1218][0][][] */ -22,1,7,-48,-24,-21,60,-21,-52,51,83,7,-59,-57,-4,42,-37,14,58,70,-27,24,-65,-27,63,16,5,14,-42,-43,6,14,-16,14,-58,11,12,-75,-30,49,-3,8,-88,54,-24,-36,-11,73,-30,-51,16,54,43,7,-26,56,12,8,36,42,7,-93,99,-4,-28,50,-46,62,28,-63,-28,-26,63,26,10,-17,-39,43,76,-58,4,127,43,58,-55,53,-40,-10,-9,-15,-22,-29,-46,-27,29,0,-34,13,17,64,51,-80,-4,32,59,57,-35,29,-79,42,-16,20, 
  /* [1219][0][][] */ -60,-20,26,41,19,-14,-51,-8,8,-9,-47,-71,45,-25,28,17,39,-42,-46,-15,5,40,19,-38,5,28,9,-51,-44,66,-98,5,72,103,-14,12,-23,37,-21,-31,36,34,28,-7,-25,14,-82,64,80,38,-107,7,46,45,-91,-16,-123,-16,98,89,-12,-4,-22,51,61,-9,-5,7,64,-21,11,-127,32,18,-46,-77,10,24,15,97,104,38,-42,17,30,-79,56,-31,53,113,70,-13,6,-58,-44,-56,39,13,-12,-2,25,-5,72,36,-11,5,-48,-96,39,57,-45,21, 
  /* [1220][0][][] */ 23,-1,-13,-24,24,-17,37,-9,-81,77,4,-78,-12,-24,27,-72,-29,25,26,-50,22,73,-37,96,43,-52,10,8,-46,-13,-33,-30,-24,-12,-27,53,20,55,59,-71,76,-21,113,53,-7,-127,-70,4,-12,-53,-28,37,1,7,7,33,-63,-32,-10,-53,-10,-14,39,-46,31,52,-2,42,-76,18,16,-13,1,-36,-84,-71,-22,25,47,-7,68,7,19,-77,2,-43,-14,43,-14,-31,83,45,-9,0,-33,7,10,4,23,4,-25,-36,-83,-93,-22,8,31,-29,30,-74,-3,-17, 
  /* [1221][0][][] */ 49,39,-45,-60,-44,18,105,-76,-21,46,52,32,47,21,14,-12,-70,6,50,-68,-14,29,-17,-15,46,-16,83,-11,20,-7,39,109,-16,43,22,21,-49,-25,6,54,52,81,-11,12,-53,-40,63,11,25,66,-7,-42,-25,-27,-39,4,6,-37,-29,24,-8,32,26,0,-19,-104,-4,-30,-1,42,-60,-100,-40,-41,23,-40,11,5,-92,-86,-83,70,-37,-7,9,61,-14,47,25,97,5,-91,9,-2,3,-31,21,37,87,19,53,62,-75,27,127,18,-61,6,-36,46,-82,59, 
  /* [1222][0][][] */ 39,-28,25,20,17,-30,-30,-11,-13,19,45,-2,-65,-2,-59,3,77,-74,9,22,28,11,-27,8,-13,-55,-1,-56,-23,12,18,-69,63,-59,0,73,53,18,69,2,25,-73,-26,8,-38,6,10,30,38,-38,56,-50,51,9,-24,-49,52,25,1,47,24,24,71,-60,9,-14,-41,12,59,44,108,30,-66,-3,7,43,-14,-7,-2,-6,-15,11,-40,-127,12,-4,42,-16,34,-37,47,0,-17,-3,6,29,-39,13,75,-39,18,40,28,19,49,-20,2,-29,-18,-35,-10,-8, 
  /* [1223][0][][] */ 2,30,32,103,-24,-22,-39,16,11,11,58,23,44,-21,11,-100,23,-17,-16,43,18,49,-51,-26,-127,86,-1,-43,54,-15,-23,-112,52,65,-47,2,-18,9,63,46,-21,-43,-6,-49,-63,-27,-98,-51,54,8,115,29,-1,-40,-56,1,71,47,-6,-44,20,35,79,-9,-31,45,-37,-55,-8,56,66,7,-50,-21,-78,72,-90,-22,15,-73,53,0,36,11,-24,-70,-46,-28,-92,27,81,15,-30,101,-29,75,11,-24,-82,35,-72,12,-10,36,43,97,-77,-41,-3,-23,-6,-38, 
  /* [1224][0][][] */ -23,127,-39,9,96,-7,2,9,-26,32,-15,-39,-2,-8,10,6,27,-49,-6,-21,42,60,31,39,42,79,-25,-23,5,-7,-74,-83,71,-26,1,53,30,56,87,-84,17,-53,-4,-17,-16,19,-64,20,56,22,31,-46,86,-31,-38,-10,-7,4,-9,-28,22,-50,-17,-7,33,-66,12,25,25,34,-30,15,-7,-26,12,-12,-57,11,33,-4,108,-4,-18,-12,-51,-83,44,-5,24,6,28,-28,-25,-27,21,-27,-9,16,-61,-43,37,30,-9,-28,-44,45,27,3,-25,-72,62,19, 
  /* [1225][0][][] */ -4,67,-12,-3,34,-38,9,8,17,21,85,42,38,-127,-35,-22,-35,10,3,66,-29,-5,14,25,-12,-15,9,-111,24,55,-41,-71,30,19,44,-23,-64,-69,64,9,-3,59,5,37,-13,-39,-82,-11,-19,53,5,-15,-68,23,-15,-15,-35,52,57,37,5,-44,-42,50,-79,-1,8,-18,58,0,12,24,-43,-41,-20,38,-28,27,-72,-32,-26,10,-26,26,-40,-14,21,10,-51,42,62,-2,-31,71,16,40,-91,7,-9,-5,-76,71,-32,-60,-48,-14,52,-48,-33,-29,-87,-53, 
  /* [1226][0][][] */ 33,-78,2,-20,86,-78,10,3,2,10,11,-44,-13,67,-44,24,-34,49,-31,66,-59,-23,-89,-18,-49,30,2,-14,88,-38,-23,-4,35,-56,27,-19,-47,37,39,-51,80,1,7,-33,18,35,66,32,37,-30,42,1,22,-22,-15,28,61,-27,-18,19,10,22,-35,31,-48,26,3,-32,-17,22,-9,-5,64,-1,-22,60,-28,15,0,17,15,10,-13,18,7,57,13,-3,-51,-5,-1,15,21,3,127,-29,-42,-6,-14,-45,21,4,-16,-18,14,15,22,41,60,16,-24,8, 
  /* [1227][0][][] */ 40,-127,18,-24,-19,-6,-9,71,-45,-24,0,-33,-22,47,37,-3,5,8,9,12,-5,48,19,-40,52,5,6,-33,-9,8,-78,41,-44,9,28,9,33,40,-12,-8,-9,17,-75,-21,24,48,40,-15,58,-12,-25,35,-114,9,-29,35,-6,21,-20,71,62,39,-55,-6,18,-24,7,-46,31,-26,-11,-2,-5,-44,36,9,24,-50,-56,-19,33,55,7,-40,-11,-74,-33,65,18,-58,-53,23,21,15,-48,28,12,52,-12,26,23,-12,-49,0,12,-18,-24,-24,-30,-53,-50,6, 
  /* [1228][0][][] */ -17,44,-3,-32,-32,38,-33,-47,-26,37,-30,-21,-6,41,8,5,26,2,31,-17,-18,40,29,30,53,59,-41,16,17,-12,6,-25,17,-24,-22,0,-15,-85,-9,37,0,-3,9,-38,54,-2,-13,17,-48,-34,-25,8,43,29,66,17,23,-39,-54,23,21,11,5,11,-48,21,48,-15,8,5,-11,18,21,-51,21,-29,10,-56,-24,17,-14,-11,9,10,69,28,-14,6,-6,-21,-30,37,-24,15,-33,-4,5,-7,-2,-11,-15,0,-4,-43,5,-13,1,2,66,14,27,127, 
  /* [1229][0][][] */ -32,87,-19,-45,44,-43,12,-33,-9,-44,-32,3,13,-7,13,61,36,-49,-40,-20,-20,3,67,-12,16,23,3,59,14,4,10,-60,15,13,-9,33,52,-6,-17,81,18,-32,-59,-23,5,102,32,60,28,-82,-64,3,67,18,-32,-44,27,6,17,10,-2,86,8,-27,17,-127,0,-44,-26,47,26,-83,-7,19,91,-27,44,-9,-6,52,12,17,26,6,-29,-67,5,-43,44,-37,-35,44,-68,38,-1,-9,9,-74,-29,-21,5,-3,-5,30,-16,-116,-27,31,91,21,14,-29, 
  /* [1230][0][][] */ -5,-125,91,42,-59,29,60,38,-26,-30,11,47,-16,42,-44,-25,38,11,93,-50,-10,35,48,-48,-15,-19,17,53,68,-12,23,-15,-60,25,10,42,32,33,-36,-34,38,-15,27,97,73,4,85,11,-11,-23,-51,-18,38,-17,61,22,45,-38,13,10,-70,-9,2,20,0,-17,-10,40,48,14,25,-36,1,-45,24,76,107,-68,-67,62,2,33,-79,-81,-42,35,-10,-112,53,-18,52,-20,12,-19,-23,-51,-72,24,31,-26,79,38,-55,41,22,-48,-73,50,127,1,121,-30, 
  /* [1231][0][][] */ 38,-4,-35,-7,-19,-47,41,19,48,20,-71,1,11,-124,69,-11,-72,68,-44,79,69,-33,69,-32,-31,34,-49,-4,6,-8,12,-32,67,127,47,80,-55,-32,28,50,-89,12,45,34,103,-11,37,-23,-38,25,16,20,-38,-17,36,6,-5,-9,-67,28,2,90,66,15,99,10,-47,-28,2,11,-7,20,-9,-5,-43,53,-10,-47,57,-13,-50,11,27,-34,-8,-22,7,-60,-48,28,63,-14,26,45,-44,28,-58,-98,3,39,-17,-94,-43,76,-61,23,-7,-88,40,-50,16,-49, 
  /* [1232][0][][] */ -14,14,9,42,-47,80,-8,-30,10,-9,-46,-98,35,-67,10,3,17,7,-22,34,19,12,71,-25,-67,7,55,-28,6,-20,-11,-13,17,52,-37,1,30,-22,-18,37,34,-17,39,7,23,-20,-31,66,37,-26,-13,61,73,31,-8,52,17,-6,5,-12,-45,-4,37,5,47,-71,-25,-23,29,-52,11,8,7,-28,-4,-42,21,4,11,-50,42,-37,-1,32,-45,42,-38,29,26,-1,3,2,-11,-38,-127,38,-27,-22,91,-34,4,19,0,-18,6,-11,24,-24,-52,-4,-33,-22, 
  /* [1233][0][][] */ 87,44,-46,73,-44,-59,31,48,-48,4,-67,-101,21,-100,-101,-62,122,-107,-102,26,23,92,-7,51,38,-106,3,111,63,57,-81,127,66,-20,-25,-53,58,113,-30,118,-81,-17,18,124,42,19,-62,-62,43,-7,-69,6,32,-105,-37,0,70,36,-40,-43,-47,10,61,-4,11,-82,65,-34,7,27,-99,-11,-26,40,65,53,-38,51,-29,30,78,-31,11,-27,6,91,-17,7,37,7,21,-62,15,-8,-86,64,-19,118,-34,27,76,37,72,-66,-76,-6,52,-37,81,-79,27,-46, 
  /* [1234][0][][] */ -14,0,33,29,-15,18,1,-20,4,47,2,-44,32,85,-29,-6,84,24,-14,-23,-20,6,-102,-14,-37,36,-78,-68,-36,-27,51,22,2,48,127,-45,0,-48,-18,7,33,-33,-9,80,43,19,32,34,-20,-10,27,-16,-13,-39,51,50,-60,-36,-60,72,-79,33,39,70,54,-67,27,-21,68,-81,-37,33,-39,-52,-42,-29,50,-25,-34,-26,-32,-21,27,41,-2,62,59,-78,-51,75,25,58,-57,-87,-33,-34,-20,24,46,15,-38,8,-12,-5,-8,11,43,7,25,30,5,-54, 
  /* [1235][0][][] */ 73,-64,-63,-95,26,-5,-9,-36,4,15,48,-7,5,0,103,-49,-84,-17,100,-4,15,29,-26,21,-96,-3,-91,26,44,-46,-98,30,-95,2,-41,-98,3,30,4,18,36,-107,97,22,-28,-38,10,-14,-17,-6,8,-33,-40,-61,-6,-25,49,-22,66,-40,22,-29,-4,93,24,49,-36,-19,81,-23,34,21,-41,43,-74,-41,52,-33,-127,-23,68,101,11,-2,8,11,69,-42,-27,39,11,2,26,39,52,7,-14,-25,-38,36,13,-78,64,76,-19,31,32,-4,-31,-10,-10,45, 
  /* [1236][0][][] */ -57,-58,92,9,-30,37,0,-5,34,16,4,70,-40,60,28,-26,-13,-64,-25,20,-17,38,-60,58,49,46,-48,-89,104,-42,64,-46,35,-39,53,-35,-1,37,9,73,86,-10,-7,86,6,46,-1,32,-96,-2,64,-86,24,-3,-61,63,25,-26,-32,-27,45,-2,-37,51,92,3,-72,-42,-36,106,62,82,-29,-27,-73,-46,-59,22,-11,34,118,14,-19,61,-8,5,39,127,74,-110,1,-98,-16,-34,41,-10,1,9,-46,-18,56,36,-7,3,53,-16,43,31,-37,-41,63,33, 
  /* [1237][0][][] */ 14,-9,-27,52,40,-2,29,-15,-67,-26,-16,-50,46,48,-1,92,-1,-14,11,19,-18,-16,-40,-2,-52,-36,-18,-37,-97,-34,-8,-35,-67,-34,-39,-25,-6,-2,-15,-2,-46,-60,16,-45,-1,32,-10,-27,-30,37,127,-14,-59,-1,19,57,2,9,26,-7,-25,-21,-3,26,40,-47,59,-32,35,84,7,17,71,-36,32,35,10,78,-18,-14,-9,-36,-28,-11,-14,-3,13,-16,-26,-18,-65,42,28,56,43,29,43,-66,-31,-11,40,14,-9,11,-17,-33,-55,44,-8,37,29,94, 
  /* [1238][0][][] */ -36,-46,-127,-101,49,7,-50,-7,-39,-36,20,22,55,16,6,35,11,-32,-48,-70,66,23,48,-8,-46,-12,-88,24,5,-48,6,67,0,-8,46,44,40,40,38,-57,-64,-17,88,74,-84,-56,35,-10,101,-22,-59,-80,9,18,34,64,10,-81,50,-11,-50,-49,-59,65,-23,37,91,-34,-57,21,109,56,-25,49,19,45,-29,28,-8,-67,28,23,67,-41,-97,-19,14,95,-25,-70,-29,12,31,-15,-57,6,-8,70,31,61,20,16,14,-27,-39,21,-4,-23,81,9,31,50, 
  /* [1239][0][][] */ -90,-36,-59,60,48,0,127,22,-20,16,74,-23,-30,-20,-23,-33,57,-1,26,61,17,-23,-32,-18,-5,-11,7,-30,-14,6,-37,59,22,-89,63,55,55,63,26,61,-7,27,22,-44,-7,-7,109,17,16,9,2,3,-47,-100,47,1,-65,-17,-52,94,-14,-2,-50,18,42,36,-53,-65,9,-6,-44,1,-16,39,32,11,-60,-10,57,-37,37,-77,24,27,-7,24,-52,-23,23,1,60,-62,0,-65,-34,-26,-67,38,25,14,0,-4,-23,-65,-21,-16,-24,14,-15,-24,2,69, 
  /* [1240][0][][] */ -43,-58,48,-12,10,23,-25,-76,-49,26,20,-86,34,35,-37,-89,6,23,-1,-23,75,6,8,30,62,43,12,81,60,-56,-15,26,84,-73,78,53,76,-121,-15,36,16,-5,-72,-38,-74,-32,56,-70,-40,-8,1,-15,79,53,-21,-127,-51,50,90,-47,-42,79,-57,-7,-48,38,5,22,14,12,102,-15,-4,5,-1,8,-10,-90,-16,17,-39,41,14,-59,64,50,9,57,45,119,-40,-54,-44,-76,14,-12,28,42,44,-43,13,60,90,9,66,-25,-33,-35,13,13,22,-32, 
  /* [1241][0][][] */ -69,-11,-19,-3,-73,-55,-16,-27,-78,-13,34,80,-23,-85,-3,9,-30,-6,26,79,-8,3,-42,46,45,26,1,-89,-16,41,26,-14,47,38,-11,-37,-73,-30,38,82,-12,2,53,-54,-48,-30,32,32,95,21,-47,26,-63,-55,-71,114,-85,27,-4,15,-9,-19,-48,8,127,11,-71,-63,-26,-16,37,-48,-25,2,35,87,27,4,-48,33,58,105,-5,-26,-26,-70,74,-127,13,56,58,-34,49,-25,18,21,9,96,38,-86,-74,61,-50,25,35,-38,-54,-111,79,48,-38,-4, 
  /* [1242][0][][] */ -7,-30,-41,9,-36,-59,127,3,32,-71,-42,58,-39,35,-32,57,38,49,-26,8,57,-76,41,3,-117,37,39,-26,39,21,-9,-7,2,19,14,-30,-9,14,35,-29,31,26,0,45,32,-10,63,-106,-44,34,9,66,-2,0,7,6,25,4,44,-11,-37,-50,7,74,-2,67,62,-59,-24,43,23,7,-35,59,74,-14,5,-9,-2,-79,-35,-31,-8,48,9,12,51,37,-50,-77,-2,-14,20,2,-13,85,-14,23,-11,-49,-20,-47,-9,-12,26,-34,64,-51,59,-6,68,-38, 
  /* [1243][0][][] */ 16,51,-38,1,-14,-27,-27,11,-45,-4,-12,47,-36,-127,-44,81,-3,2,-22,-17,44,11,-3,1,65,7,62,102,-26,-55,45,-45,25,-91,-103,22,-48,-15,16,-32,-43,69,42,71,34,12,-21,67,23,40,-52,51,-66,-14,-34,8,1,44,81,0,-83,-47,10,0,10,-12,61,-22,90,37,12,-10,-14,-37,-35,-73,-3,-24,7,-30,2,41,-69,-12,-98,-12,-69,9,5,-19,-21,-4,5,24,7,-29,-16,15,-63,-18,-20,17,3,-14,46,28,-32,50,-43,17,-26,69, 
  /* [1244][0][][] */ -3,-21,-25,-22,28,23,38,-16,58,-10,-8,38,41,-45,-35,-23,22,3,12,14,-51,26,17,6,8,19,-18,66,11,-17,34,27,99,-31,46,-12,-26,8,56,-20,-40,-6,48,-27,-14,14,75,20,27,5,-10,55,-25,-2,-14,69,-33,-20,27,9,-44,-11,19,-35,-21,-5,8,25,2,-24,88,32,5,-22,-16,50,-13,-59,-29,35,64,13,-35,-47,-19,-28,51,-9,-55,-38,-19,25,0,17,-19,42,41,0,43,96,21,13,80,26,-24,34,-4,-21,46,-1,1,-127, 
  /* [1245][0][][] */ 13,-22,41,35,-16,-41,62,-18,21,17,-30,87,-23,-56,-20,-36,-23,-54,37,104,-4,7,43,37,-14,-18,69,-47,28,-3,-18,-95,47,-40,11,60,-40,46,8,24,-19,20,51,65,-31,124,-69,6,56,2,4,45,52,-51,-18,29,-30,26,22,-19,35,-89,-12,-94,3,-12,80,24,43,-11,-10,-17,-25,7,30,-49,46,12,11,58,8,-62,1,40,-9,-1,-127,-56,5,-16,39,37,-1,-14,4,45,-11,43,-41,4,36,4,66,-52,-48,-45,-12,14,-25,-23,-51,-46, 
  /* [1246][0][][] */ 12,66,54,-43,-73,6,-4,16,-26,-34,-9,-81,-7,10,81,-13,-8,92,-4,13,29,74,-12,-34,19,38,-3,11,-36,27,1,-108,-12,17,26,28,9,-36,-42,-11,21,1,-58,-36,37,-19,-27,47,-38,-56,-41,-46,53,7,63,5,12,10,-47,-69,74,31,-6,1,-54,-2,40,-88,1,42,21,9,11,-31,65,-40,-59,-3,-26,10,30,14,-33,-6,26,-23,44,127,24,11,-29,53,94,1,-6,19,-25,-10,10,30,-85,56,-7,-19,-31,-12,-7,-10,-8,-9,-67,32, 
  /* [1247][0][][] */ -36,65,-30,104,14,-12,-2,-37,-66,24,-32,-61,38,-3,-29,68,18,7,88,40,23,18,40,86,37,-60,35,30,-71,-1,127,28,4,3,-20,-28,-22,47,-12,44,-24,-12,31,14,37,15,-104,-34,77,-57,-19,-2,69,35,-8,11,30,21,85,43,-24,-27,73,-33,-36,1,39,27,39,-19,-49,-28,-10,-99,-22,-35,-18,76,-32,-16,-54,1,-32,5,-14,-65,-12,-69,26,89,0,-46,29,-36,-34,-73,56,99,-23,-29,-70,52,-26,7,-51,-62,8,-20,-30,17,-99,-14, 
  /* [1248][0][][] */ -74,54,120,0,119,38,119,-39,-26,-1,8,23,7,53,20,-56,44,36,29,14,-38,-18,1,-2,18,-16,-103,29,61,36,13,-127,83,6,86,37,-57,-53,-25,21,-31,-54,-30,55,-25,5,-60,-4,-70,3,28,-63,-6,-29,63,-3,27,-34,-62,49,79,-36,-42,0,48,66,16,-67,39,35,7,-26,62,24,59,-2,21,4,-29,46,31,-11,-43,-64,-13,-19,-4,1,-33,27,37,-106,57,117,-40,15,3,-15,26,-22,5,-15,33,23,-31,23,-16,40,-47,33,-70,18, 
  /* [1249][0][][] */ 10,107,19,-43,-33,90,-2,-85,80,-103,-34,-6,-8,47,-62,-24,-25,-85,59,-22,63,-38,28,65,77,-75,-38,-117,40,-54,-15,29,31,40,60,-14,-21,-59,-42,-1,-59,80,38,14,32,-38,63,61,119,111,8,30,-36,82,-2,106,-24,112,-9,102,-36,2,-62,36,34,27,36,57,-58,12,29,6,12,48,75,-67,36,-41,-30,3,38,6,-11,7,-127,14,95,17,-48,-57,-20,21,-35,-98,-55,-6,-63,-81,-47,-74,-93,98,74,64,-22,42,18,-59,-44,32,48,33, 
  /* [1250][0][][] */ 30,57,6,62,31,-35,-4,-59,33,-34,26,-47,16,-1,-13,-127,-71,41,-37,-51,76,-3,-29,42,6,-53,-34,-55,-51,-17,-28,-47,-59,-3,9,-39,22,-5,-87,-58,51,-15,13,-22,16,30,-49,-34,21,-79,20,110,-51,8,-4,87,63,-32,-12,-78,-11,-24,-97,30,-49,27,-28,57,-36,69,-32,10,46,54,-38,-3,27,-33,-8,11,80,-5,10,6,-9,-82,50,49,23,-29,-81,13,52,-23,20,64,48,-30,-57,26,31,-21,61,25,36,51,98,42,53,61,-11,44, 
  /* [1251][0][][] */ 8,-36,1,-31,1,1,-58,8,47,-15,97,-31,-10,-32,41,4,-17,6,32,24,-26,36,-24,-53,-95,58,-27,57,20,-22,14,-20,3,103,10,-38,46,-40,-23,27,-53,21,4,3,-35,78,-16,-39,34,-30,-57,2,25,10,-50,8,-66,14,67,-6,-5,101,-35,22,38,32,15,-5,-32,-13,37,46,21,11,38,-17,-28,-37,-127,-53,22,36,47,23,-49,25,-7,74,-59,20,10,5,-49,12,-37,-34,-84,-27,9,13,-56,26,-2,38,112,47,-34,-11,81,24,24,27, 
  /* [1252][0][][] */ 26,-78,0,-52,-17,32,-38,58,38,-5,-44,-28,61,-87,31,59,-10,43,-31,26,10,-13,32,1,123,1,7,-95,-61,-72,28,116,56,33,71,70,-25,-23,22,-86,45,-7,36,-65,13,8,21,32,-90,16,112,-48,-72,93,24,-33,33,46,1,-33,-111,-33,-28,21,-75,-10,28,52,60,25,83,18,-83,30,-37,-32,9,-72,-62,32,42,53,-9,3,-16,-68,19,-7,-22,105,47,26,127,-33,20,21,19,54,-49,-23,32,-77,-57,57,40,126,-90,120,-86,-36,-59,-52, 
  /* [1253][0][][] */ -9,-120,39,-27,-97,-35,13,51,-36,22,-25,69,-110,-89,-10,-39,55,-29,12,-4,-15,13,-56,-43,6,105,68,14,-1,16,-44,-53,-16,59,-58,-1,54,126,-21,30,-55,-60,-56,3,-20,-83,6,-17,-43,5,-26,9,-12,-19,-39,29,-9,-4,-42,57,7,-2,66,-74,-15,-12,-23,-4,-127,-1,-30,-77,127,4,-37,-3,41,43,-39,18,84,-40,-57,-8,-9,47,-68,47,7,16,-13,-86,-5,93,-50,-26,-19,83,-79,-24,-34,84,-23,-6,-17,-38,-37,-9,-14,-7,13,104, 
  /* [1254][0][][] */ 1,72,-33,-29,-46,4,-19,56,-43,-23,10,33,21,39,-37,12,-3,13,-17,-54,8,-27,84,-40,42,-1,-13,-66,-40,56,-42,11,-78,-53,8,-49,-17,-20,-16,14,-4,94,-31,-6,-43,-22,-63,-9,-55,58,50,57,-20,41,56,-37,18,-49,-21,-5,-6,26,48,44,-44,127,56,-51,22,33,11,-32,42,-70,9,-49,70,15,-16,71,-53,9,28,-31,-46,-36,21,-39,12,38,-41,-73,-34,15,-50,54,-56,35,-43,30,-8,-56,18,-8,60,26,-38,9,-49,12,2,49, 
  /* [1255][0][][] */ -45,-78,-84,28,-90,-41,9,55,-38,-68,54,-53,20,42,5,-28,-16,-82,-7,-58,18,-21,-9,-12,15,-28,-6,-127,-41,-43,-34,-96,48,-56,-5,25,37,-19,42,21,28,-2,10,0,9,-4,-11,40,-34,-32,-67,-5,-16,7,-67,-27,0,-87,-9,46,8,-15,-57,32,25,46,-24,8,-11,8,55,-12,-23,-10,94,-12,82,80,-45,-32,-11,-34,4,-26,-24,27,4,-48,-6,-16,47,56,0,-10,-22,-85,-39,-11,32,-6,-79,12,-59,-39,40,-28,27,-44,-9,-30,17,-52, 
  /* [1256][0][][] */ 71,95,-10,26,-1,-23,30,28,41,-16,1,-65,-14,-65,62,-75,-17,67,-9,-10,-63,13,5,49,30,49,-33,-60,-70,-29,-24,28,-108,21,-39,-67,91,23,-67,7,46,16,-11,7,-43,-12,17,109,-101,9,-40,-21,-12,-110,-38,-15,15,5,63,55,0,-27,-40,99,-39,-39,44,3,-72,-32,-20,103,-17,-83,11,-29,-40,3,5,2,44,73,12,-18,126,127,-28,24,57,109,-99,59,-8,-64,43,1,85,10,37,-37,-56,-4,-34,-63,64,-17,-24,-7,17,76,-31,42, 
  /* [1257][0][][] */ 36,-49,8,-24,28,-16,-41,25,31,-10,-30,2,-28,49,44,58,32,27,-86,1,1,53,-34,-41,-1,-15,0,-39,62,-18,-43,5,45,22,58,31,-34,-16,-3,-9,-22,-13,-8,-34,-7,-4,-3,-8,-89,9,12,12,-36,6,4,80,-17,-15,-1,-26,127,-49,-22,58,59,8,-13,55,-127,19,33,37,9,8,97,-60,7,-1,23,18,-29,-7,31,18,31,43,-23,-4,50,7,1,-12,41,-7,56,3,-13,59,21,2,-26,69,-31,-36,2,4,98,-36,-56,79,10,15, 
  /* [1258][0][][] */ 3,56,-41,47,17,-1,7,6,-7,11,101,44,58,-20,-8,-10,-111,-29,26,21,-13,-45,-49,31,16,-46,14,-61,47,32,-14,43,2,35,4,-98,-30,104,2,-31,-64,-71,-18,80,25,-65,6,44,127,-5,-55,35,-28,-6,71,-1,-15,-30,58,21,21,-91,49,21,-71,-10,41,10,47,-22,29,49,-86,4,2,-47,-4,-3,-3,-59,-7,36,-44,-22,-17,-19,91,-60,-21,6,0,28,42,20,-29,47,-8,39,20,19,70,-94,20,58,-18,55,118,117,9,-12,-3,-18, 
  /* [1259][0][][] */ 1,3,14,-97,48,40,-34,13,-16,33,-25,59,53,44,-4,-54,121,39,-53,-81,-20,-90,-27,15,17,-4,-19,83,34,3,22,39,-8,-50,-57,18,1,-52,-30,-65,-42,43,-97,-15,-18,-79,59,117,-57,55,-13,20,-14,-86,68,-40,-103,29,-127,-26,20,-42,47,45,-63,0,68,30,-51,65,32,29,-20,-28,-15,-66,3,-34,-21,-77,38,-33,14,-58,32,30,-53,12,41,41,-20,-99,-42,-90,15,-4,-34,7,-36,-101,14,-36,57,29,39,-33,-18,36,-64,46,-62,40, 
  /* [1260][0][][] */ -5,-40,4,-44,-35,47,43,-14,40,-42,7,76,34,-60,12,-75,-28,7,42,-77,28,-67,-83,44,3,-80,26,-26,27,-30,32,30,-27,-12,-71,44,61,-86,2,9,122,10,49,127,69,45,16,17,21,15,-37,58,-32,61,57,-7,6,-37,12,10,-31,-74,19,-20,-23,9,-24,6,65,-5,65,57,13,-16,-9,-74,-69,-8,-5,-29,-6,45,6,27,16,42,91,-12,-37,-51,-13,-21,-45,8,-96,-6,43,-73,10,-64,-23,31,7,13,-8,-59,-19,8,-11,95,38,-66, 
  /* [1261][0][][] */ 32,28,-22,-35,-23,-17,11,41,17,60,11,15,68,-3,27,7,65,27,79,-8,92,-32,-25,1,7,-74,-29,-87,47,-13,-94,-123,-60,-77,54,-45,-29,-45,-12,7,3,-25,127,9,40,-15,4,58,-100,-21,113,44,-40,14,44,-39,-31,2,-28,-39,-95,54,25,-20,62,23,78,-20,56,0,-2,-31,-21,65,-92,32,-46,0,-39,25,-1,-6,49,-44,-4,28,29,-53,59,-15,-28,-30,-19,-61,91,-24,-48,-36,-107,17,-22,3,10,15,73,44,9,-40,28,-108,45,-17, 
  /* [1262][0][][] */ -3,-1,19,-58,-12,-43,120,-7,-24,-82,15,-18,-47,21,-3,40,28,-12,-4,-4,58,8,18,57,27,17,12,88,-21,21,0,-46,-59,69,-1,40,-43,-37,-30,50,74,-1,17,-127,10,-63,-39,-30,-8,-4,-55,-2,-51,36,79,-28,65,30,-8,14,-2,25,-54,-41,34,-20,-58,-32,-33,-2,6,-19,66,21,-5,8,-75,44,26,21,-7,22,-46,71,19,49,16,88,-29,-74,20,29,-15,58,16,18,40,-38,-22,0,-25,5,-47,-41,37,122,-86,75,-5,38,-36,26, 
  /* [1263][0][][] */ -87,-54,39,-18,-22,27,0,-36,-6,27,-41,-34,16,56,70,-18,-100,56,42,-51,16,-3,12,24,-56,-23,-19,34,39,15,49,51,-30,-5,17,67,49,42,34,-28,-44,23,-49,-3,-25,36,48,10,-12,82,-17,56,-10,21,-127,35,27,-32,10,-51,-37,-11,-18,16,43,34,38,-16,-52,-58,7,-26,-27,13,-79,101,14,-76,49,-85,-41,0,115,12,-116,1,-99,-72,-2,45,-19,-8,-37,40,-120,17,72,13,84,38,59,39,-20,87,46,-46,24,59,-44,-17,62,-23, 
  /* [1264][0][][] */ -28,-49,-58,-47,-10,-19,2,-48,-114,-83,-65,86,-25,-41,16,36,-30,-4,-1,-23,40,7,6,-53,51,-19,-64,42,68,34,5,61,28,3,14,11,-22,15,-9,-2,8,19,105,38,-30,-10,-127,-56,-67,-26,19,37,-24,25,-1,13,22,-23,-41,-4,44,-7,-66,-43,27,47,-64,-62,-84,-72,80,14,-32,6,34,-50,33,18,0,-14,101,40,33,9,50,-82,-24,-34,-32,-17,-25,29,-13,13,63,79,-56,-49,30,-28,16,42,52,-64,40,-39,23,-25,-116,-25,13,8, 
  /* [1265][0][][] */ -127,-4,46,41,23,5,75,-25,40,46,14,44,-35,52,-47,-12,55,-4,34,3,-38,15,-8,49,61,-68,-62,-11,47,11,38,31,-61,-5,-33,-22,112,33,8,8,30,-16,-98,24,46,-33,35,89,11,-76,-23,110,72,49,-16,-12,23,44,45,103,11,18,6,49,-31,20,-18,24,6,31,-13,-48,-9,-4,21,52,27,-11,16,-4,-65,-10,32,-22,101,58,51,-33,-9,9,21,27,-42,4,-53,81,56,19,22,33,-27,-41,4,-65,35,-125,50,15,-22,12,-13,-91, 
  /* [1266][0][][] */ -4,14,64,41,-9,41,44,-10,-7,5,-42,24,-5,68,28,26,97,55,21,9,-127,-41,-32,66,54,-13,20,24,-1,15,-31,49,-5,-77,-73,45,-53,50,-4,-6,-50,-42,51,17,73,42,62,-7,29,-33,31,82,16,-67,32,-29,-33,75,-114,-22,66,4,26,32,-8,-60,34,-4,-35,41,64,-57,-43,26,-9,58,24,23,-56,-25,20,-49,0,-78,7,27,-33,28,23,17,16,-56,-38,17,16,50,-24,2,-13,92,-35,31,-37,-57,-57,-47,-27,32,21,-48,17,4, 
  /* [1267][0][][] */ 47,43,79,-58,-27,35,14,-45,-19,-87,9,69,62,-72,-64,7,104,43,-82,-26,103,29,33,30,11,-67,7,-13,23,64,-127,-1,-89,40,20,49,-34,14,-34,63,-20,-31,24,7,-18,-31,-50,-46,19,-5,23,41,-9,-90,-96,7,-6,76,18,-99,-47,-22,53,-20,2,-19,-26,57,22,-7,29,-23,57,15,-49,46,54,25,113,-10,23,-30,34,71,-47,49,29,87,17,-60,15,39,47,35,-11,-10,-98,-1,-82,-26,-7,65,48,-117,26,25,-90,73,-66,-50,-23,-37, 
  /* [1268][0][][] */ 25,69,-20,25,-45,127,31,-23,-22,20,76,3,8,31,45,-37,1,41,62,-70,-31,-7,19,-67,-18,-42,9,3,-16,26,-7,0,-24,13,-54,-27,-33,-35,-24,46,39,-35,38,62,12,29,34,15,77,-10,11,-56,-17,-9,36,18,-44,-9,56,-71,51,99,-18,35,36,-62,37,46,-53,-31,-2,-70,48,-27,2,27,67,-30,42,57,1,-9,66,-78,-14,-41,-31,68,-17,60,-14,-19,-26,-84,90,-48,-10,14,2,-8,-16,-57,12,31,19,-12,-37,-101,51,49,-3,-82, 
  /* [1269][0][][] */ 22,45,20,52,-17,-59,2,4,-67,78,9,-46,-27,-5,-108,-65,97,10,-39,-6,39,42,-24,-47,-5,3,29,-13,85,60,14,-67,-12,73,-50,72,20,-52,-48,76,-35,-52,43,-31,39,-36,80,-3,24,68,29,77,23,-24,19,72,7,58,-31,22,95,35,73,6,19,-31,-29,65,-47,57,-15,30,-23,124,5,13,-11,-38,9,27,66,-66,-127,7,-37,-33,-53,-3,2,59,26,110,19,-5,13,11,-7,46,-24,-79,-32,13,-12,-63,77,-57,-23,-23,-39,-57,-24,9, 
  /* [1270][0][][] */ 15,44,-84,54,33,25,-35,58,-7,32,-9,-27,-10,-60,-42,-33,-13,-50,-63,15,76,-34,-24,47,5,-89,-16,28,-104,-52,-79,-89,11,23,-36,29,-29,68,55,-55,-30,-36,-99,0,-24,-25,-9,0,-23,-11,55,13,74,-33,59,-35,-27,-44,65,1,-71,-13,106,-56,-52,73,127,9,31,-48,-79,57,25,8,-31,58,-109,-16,17,4,-18,-1,32,-46,-11,-79,-19,44,0,-27,-24,102,4,81,-102,114,39,5,-81,-10,53,-4,9,26,-37,-55,-57,41,61,-31,38,-44, 
  /* [1271][0][][] */ 83,7,-22,-13,12,3,-15,-17,-3,-14,-11,-55,4,27,68,0,-27,6,1,46,8,-15,-10,25,46,-35,-66,-59,35,-11,-34,-53,-24,50,25,10,-75,-39,46,36,-42,-13,13,63,32,-6,53,-38,2,-5,-56,-85,13,-18,-40,80,76,-9,31,62,-16,-33,-3,14,11,-31,-24,-33,-37,-54,29,-63,8,14,38,-91,20,40,42,-31,70,7,-101,-24,-127,53,75,52,-25,76,-56,-23,20,34,-29,-43,62,33,-31,-24,-8,47,13,-48,-92,-39,62,22,-38,-64,-14,-29, 
  /* [1272][0][][] */ -57,5,73,-49,15,2,33,42,-89,-68,66,-93,-34,17,116,45,12,19,32,29,25,-12,58,2,19,-27,-37,-26,-31,-18,12,53,16,13,4,41,-67,-127,22,59,-92,74,22,120,52,27,-15,-7,-22,51,3,22,25,-42,19,-28,-4,18,-11,-3,38,-107,-26,1,65,-16,34,-64,-15,-53,19,13,81,14,-28,-15,2,42,16,5,-72,-11,25,-52,-15,-25,104,-2,76,-15,28,77,65,-15,-47,46,112,24,126,-49,9,21,-57,24,-39,-104,77,97,46,41,-42,-76, 
  /* [1273][0][][] */ -15,-62,20,-78,-73,48,1,-13,-76,-20,11,-22,-15,-91,-22,-27,92,-18,50,21,-57,-79,-30,53,14,-31,-13,-27,-23,46,-47,-20,-22,-27,15,-19,-13,42,-33,-39,-39,-28,53,-44,-27,-48,-16,46,-37,-7,26,-10,47,-4,-91,22,9,-49,8,24,-42,59,-119,9,-12,127,-47,-14,39,-51,62,2,-2,20,16,-40,-64,97,-90,16,70,-26,49,-14,38,-32,13,-64,1,-13,-86,0,-116,85,54,-45,-3,-87,18,-29,-21,-46,-53,-58,-69,-68,-84,-32,13,-61,-57,-13, 
  /* [1274][0][][] */ -49,-87,41,22,-43,-47,29,-54,-35,17,-109,-12,-24,-31,-73,29,-34,-23,-80,-66,-10,-28,24,-55,-30,-37,70,-17,-28,108,-13,-16,-16,28,10,-10,-32,-16,-29,-55,-87,55,-74,-15,-54,20,-35,-21,-44,13,28,81,-17,13,-28,56,38,-22,-4,-67,12,2,-47,-58,88,-67,-59,33,58,-47,-11,-29,-12,-47,11,-48,-6,-24,-28,65,-84,5,-12,-11,-53,-21,35,29,5,-108,10,47,56,22,-42,58,-127,-20,-44,-65,-17,-13,45,-51,-69,-63,11,37,27,-1,10,-85, 
  /* [1275][0][][] */ -70,-11,30,26,15,39,-9,20,-52,-69,11,-58,1,30,0,-59,-14,-68,8,46,22,127,-91,34,-15,69,-18,-1,102,74,39,17,62,52,2,-10,14,37,16,73,-34,13,-28,-13,28,-3,-18,-70,87,25,21,44,35,-2,107,-13,-41,5,23,12,10,-65,-46,-12,-36,70,40,-104,-44,59,49,20,-34,-48,49,-3,-63,53,-76,54,-20,-5,-12,25,14,-9,-8,-103,30,58,44,-93,81,-48,-37,19,-16,80,-56,-56,-34,57,30,33,43,-32,57,44,27,-16,76,-24, 
  /* [1276][0][][] */ -105,-95,24,59,34,-20,-3,6,-48,9,-14,57,23,10,0,5,2,15,7,2,-24,27,67,-32,45,41,12,31,-32,85,22,25,-73,-42,69,-4,10,15,8,1,7,0,-119,-44,-58,23,57,16,37,30,-18,54,-37,-49,-77,-73,71,-31,32,-5,-80,108,-6,-4,-1,-36,53,-80,3,-77,40,29,-7,-99,43,-53,49,95,-84,-14,0,-9,-15,-8,38,-49,-127,-36,3,-35,12,28,-63,-40,9,-112,-73,46,42,4,-10,-45,-37,13,16,30,38,1,87,-12,-15,50, 
  /* [1277][0][][] */ 50,7,-29,20,45,-47,-15,-18,-48,1,-42,36,63,-29,18,-71,31,-75,61,-87,-82,6,19,44,-33,6,5,-59,-77,-12,-30,-45,61,61,-35,-87,-55,-1,127,-6,-50,0,0,62,18,-7,55,51,-56,43,6,-9,36,87,73,-124,38,5,15,38,4,56,107,14,21,-24,-27,-9,-27,-4,-15,42,-44,-61,24,-3,57,-57,43,76,-13,101,-71,-85,45,-13,41,22,103,58,4,-72,-36,-12,-123,24,36,-59,-115,-27,-122,2,8,64,-44,-43,58,-9,-68,-102,49,-60, 
  /* [1278][0][][] */ 9,-10,-16,78,66,-41,-38,-104,-81,-88,32,-45,-27,-67,87,26,-51,-9,-74,-67,41,59,87,75,-59,13,-72,42,33,39,-26,24,2,-23,16,-11,30,6,-27,43,3,105,39,-22,-31,31,-44,66,-19,20,28,-22,32,20,-22,-18,16,-81,99,-31,56,-37,16,66,66,36,-25,-53,-78,7,34,-35,35,-8,-5,70,49,82,-27,-32,48,-92,9,-17,-58,-112,62,127,49,106,-33,40,-45,10,-12,-8,-57,-11,-12,21,-59,34,31,-62,39,-85,-49,-21,46,-18,14,-16, 
  /* [1279][0][][] */ 48,42,27,90,-37,30,-47,5,-45,79,45,-46,-22,56,-45,-12,39,3,127,-27,-71,3,-4,18,8,-35,-19,-54,17,8,-6,63,43,40,-104,27,22,-9,9,64,-14,-7,-26,50,8,-40,14,-35,-24,18,-22,-56,-6,-40,19,53,-31,-70,-33,-3,-7,-51,9,-27,9,4,35,4,-11,20,86,12,8,-24,-44,44,-103,-17,-72,-16,-9,-5,-9,11,-19,16,70,2,-55,40,-35,15,1,-35,-2,86,-15,-4,-23,46,-19,-44,-72,-56,-38,59,-3,-55,-30,29,8,8, 
};
const TfArray<4, int> tensor_dimension77 = { 4, { 1280,1,1,112 } };
const TfArray<1280, float> quant77_scale = { 1280, { 0.0031100164633244276, 0.0028476701118052006, 0.0035571863409131765, 0.0032685757614672184, 0.0031477806624025106, 0.0032292511314153671, 0.003319053677842021, 0.0040031843818724155, 0.0028865316417068243, 0.0032447436824440956, 0.0027222356293350458, 0.0031801329459995031, 0.0030711235012859106, 0.0032018215861171484, 0.0031533127184957266, 0.0032313826959580183, 0.0035638932604342699, 0.0032223425805568695, 0.0026625802274793386, 0.0025482613127678633, 0.0032266343478113413, 0.0028445918578654528, 0.0035750523675233126, 0.0036127630155533552, 0.0034392599482089281, 0.0041416902095079422, 0.0038700050208717585, 0.0042003104463219643, 0.003205000190064311, 0.0034072871785610914, 0.0030885920859873295, 0.0037798581179231405, 0.0027697584591805935, 0.0024481043219566345, 0.0037159863859415054, 0.0034179887734353542, 0.0032877223566174507, 0.0033747598063200712, 0.003780995961278677, 0.0028365249745547771, 0.0032192135695368052, 0.0027938743587583303, 0.0036385806743055582, 0.0030113577377051115, 0.0041325562633574009, 0.0033746494445949793, 0.0027768111322075129, 0.0036342048551887274, 0.00368477962911129, 0.0034656231291592121, 0.00319514493457973, 0.0027894871309399605, 0.0041001602075994015, 0.002799193374812603, 0.0034571548458188772, 0.0035892222076654434, 0.0030863324645906687, 0.0026601448189467192, 0.0032777809537947178, 0.002491069259122014, 0.0030487934127449989, 0.0024666381068527699, 0.0036693280562758446, 0.0034291604533791542, 0.0029665015172213316, 0.0032240946311503649, 0.0038201282732188702, 0.0035460882354527712, 0.0035589488688856363, 0.0029545333236455917, 0.0033258509356528521, 0.0036530864890664816, 0.0031532931607216597, 0.0034856591373682022, 0.0034264442510902882, 0.0038425037637352943, 0.0025149376597255468, 0.0027557685971260071, 0.0030788502190262079, 0.0027709389105439186, 0.0035408756230026484, 0.0030900733545422554, 0.0028314443770796061, 0.0035505890846252441, 0.0033297238405793905, 0.0023768674582242966, 0.0031937963794916868, 0.0031844610348343849, 0.0033732075244188309, 0.0036687550600618124, 0.0037080480251461267, 0.0032411820720881224, 0.0028751392383128405, 0.003166720736771822, 0.0031805429607629776, 0.003393988125026226, 0.002891850657761097, 0.0029462401289492846, 0.002911748131737113, 0.0035079829394817352, 0.0038988629821687937, 0.0038952683098614216, 0.0033613950945436954, 0.0035534603521227837, 0.0027218027971684933, 0.0026891177985817194, 0.0028661033138632774, 0.0033311136066913605, 0.0030609627719968557, 0.0036955676041543484, 0.0034070706460624933, 0.0029311396647244692, 0.0041755605489015579, 0.0026901224628090858, 0.0034940531477332115, 0.0036396540235728025, 0.0036598735023289919, 0.0030839843675494194, 0.0032552473712712526, 0.0037056617438793182, 0.0027219592593610287, 0.0032698283903300762, 0.0031348320189863443, 0.0029128172900527716, 0.0032561949919909239, 0.0032717583235353231, 0.0031371857039630413, 0.0034455340355634689, 0.0034879199229180813, 0.0034187303390353918, 0.0030400487594306469, 0.0039880531840026379, 0.0036601966712623835, 0.0029351976700127125, 0.0028487748932093382, 0.0035280915908515453, 0.0033604458440095186, 0.0033394983038306236, 0.0035486014094203711, 0.003082961542531848, 0.0029731944669038057, 0.0038157375529408455, 0.003411394078284502, 0.0031636490020900965, 0.0029903729446232319, 0.0032849740236997604, 0.0026569592300802469, 0.0037187752313911915, 0.0036687643732875586, 0.003540366655215621, 0.0032286730129271746, 0.0034926226362586021, 0.0037881650496274233, 0.0029722643084824085, 0.0027851129416376352, 0.0034268083982169628, 0.0032000178471207619, 0.0030348754953593016, 0.0034255115315318108, 0.002549666678532958, 0.0031951961573213339, 0.0035312417894601822, 0.0032414624001830816, 0.0035735832061618567, 0.004114062525331974, 0.0027411615010350943, 0.0026496816426515579, 0.0036823304835706949, 0.0033134161494672298, 0.0033752631861716509, 0.003473679767921567, 0.0032996980007737875, 0.0034931779373437166, 0.0033046812750399113, 0.0030609036330133677, 0.0025332574732601643, 0.0030441537965089083, 0.0036111401859670877, 0.0033377255313098431, 0.0032796375453472137, 0.0028043687343597412, 0.0029490417800843716, 0.0030268209520727396, 0.003716886043548584, 0.0030513489618897438, 0.0034450429957360029, 0.0030121156014502048, 0.0032674830872565508, 0.0033360545057803392, 0.0030266572721302509, 0.0040198192000389099, 0.0032963440753519535, 0.0026133030187338591, 0.0025304588489234447, 0.0029794136062264442, 0.0032530869357287884, 0.0038035442121326923, 0.0044602397829294205, 0.0027216444723308086, 0.0037429940421134233, 0.0030093931127339602, 0.0030911692883819342, 0.0031109447591006756, 0.0032444247044622898, 0.002623226260766387, 0.0028952171560376883, 0.0036223197821527719, 0.0031853308901190758, 0.0029656817205250263, 0.0036574960686266422, 0.003270917572081089, 0.0032323731575161219, 0.0034061162732541561, 0.0030750685837119818, 0.003763935063034296, 0.0029550879262387753, 0.0032984206918627024, 0.0029125402215868235, 0.0028669233433902264, 0.0029439977370202541, 0.0035703312605619431, 0.0029101581312716007, 0.0029908840078860521, 0.0031194025650620461, 0.0036074041854590178, 0.002900213235989213, 0.0026335956063121557, 0.0030319599900394678, 0.0024522161111235619, 0.0036861556582152843, 0.0031265038996934891, 0.0035377878230065107, 0.0033985492773354053, 0.0036096305120736361, 0.0032677915878593922, 0.002848807955160737, 0.0030964959878474474, 0.0033795351628214121, 0.0027149498928338289, 0.0032141369301825762, 0.0038008785340934992, 0.0030100094154477119, 0.002890375442802906, 0.0034754150547087193, 0.0030446157325059175, 0.0029911808669567108, 0.0028998637571930885, 0.0030583096668124199, 0.0036668356042355299, 0.0035383242648094893, 0.0032031936571002007, 0.0032984837889671326, 0.0030644724611192942, 0.0027223322540521622, 0.0031873232219368219, 0.0034002538304775953, 0.0031236710492521524, 0.0030664603691548109, 0.0039473124779760838, 0.0027035772800445557, 0.002763788215816021, 0.0040546045638620853, 0.0031600699294358492, 0.0030611036345362663, 0.0034861932508647442, 0.0031455853022634983, 0.0035354108549654484, 0.0028191660530865192, 0.0032581416890025139, 0.0030585196800529957, 0.0028846191707998514, 0.0027095791883766651, 0.0036600141320377588, 0.0031109163537621498, 0.0029921890236437321, 0.0032317026052623987, 0.0029641238506883383, 0.0025865249335765839, 0.0026744760107249022, 0.0034698562230914831, 0.0050564799457788467, 0.0035591768100857735, 0.003183465451002121, 0.0039097750559449196, 0.00308082508854568, 0.0032043422106653452, 0.0036024553701281548, 0.0029686996713280678, 0.002597785321995616, 0.0035773797426372766, 0.0027436038944870234, 0.0031234864145517349, 0.002585988724604249, 0.0030407344456762075, 0.0035660879220813513, 0.0026057057548314333, 0.0030682215001434088, 0.003201901912689209, 0.0034351469948887825, 0.0026013853494077921, 0.0037644642870873213, 0.0037713504862040281, 0.0032919314689934254, 0.0031685724388808012, 0.0039541451260447502, 0.0028767753392457962, 0.0033059499692171812, 0.0039526605978608131, 0.0030051025096327066, 0.0033860269468277693, 0.0033277093898504972, 0.0030766285490244627, 0.0028478733729571104, 0.0034407053608447313, 0.0036758692003786564, 0.0029208585619926453, 0.002671882975846529, 0.0032185700256377459, 0.0026880507357418537, 0.002862697234377265, 0.0034794486127793789, 0.0033287536352872849, 0.0028074397705495358, 0.0032605540473014116, 0.0034007104113698006, 0.0032169769983738661, 0.0030753931496292353, 0.0031524540390819311, 0.0039826612919569016, 0.003629730548709631, 0.0026613781228661537, 0.0031669104937463999, 0.0031445352360606194, 0.0038065330591052771, 0.0032853935845196247, 0.0031479517929255962, 0.0031637805514037609, 0.0031496528536081314, 0.0031714942306280136, 0.003427624236792326, 0.0026946899015456438, 0.0031526936218142509, 0.0030374042689800262, 0.0027497000992298126, 0.0027805881109088659, 0.0028042607009410858, 0.0030028079636394978, 0.0030233003199100494, 0.0031380604486912489, 0.0035817185416817665, 0.0033906938042491674, 0.0031430667731910944, 0.0031733461655676365, 0.003223383566364646, 0.0025418722070753574, 0.0025744775775820017, 0.0027932298835366964, 0.0026197661645710468, 0.0028097433969378471, 0.0024893381632864475, 0.0032013640739023685, 0.0034010799136012793, 0.0023703186307102442, 0.0031782719306647778, 0.0032221495639532804, 0.0030016857199370861, 0.0032980905380100012, 0.0028453490231186152, 0.003769933944568038, 0.0030582370236515999, 0.0027408346068114042, 0.0029961622785776854, 0.0036596790887415409, 0.0033235985320061445, 0.0035324180498719215, 0.0033007881138473749, 0.0030244677327573299, 0.0033981648739427328, 0.0032158906105905771, 0.0028527178801596165, 0.0032806515228003263, 0.0035187643952667713, 0.0038769030943512917, 0.0028863206971436739, 0.0033487644977867603, 0.003091887105256319, 0.0032523672562092543, 0.0033534890972077847, 0.0033207372762262821, 0.0031141252256929874, 0.0039514298550784588, 0.0034986087121069431, 0.0036306297406554222, 0.002862915862351656, 0.0037422825116664171, 0.0037921811453998089, 0.0028513965662568808, 0.0032804242800921202, 0.0034181561786681414, 0.0037062030751258135, 0.0046730963513255119, 0.0032984116114675999, 0.0039793150499463081, 0.0032368991523981094, 0.0035166810266673565, 0.0028059906326234341, 0.0034411342348903418, 0.0028240710962563753, 0.0032684316392987967, 0.0027624727226793766, 0.0031392460223287344, 0.002867500763386488, 0.0033243019133806229, 0.0036511777434498072, 0.0032785041257739067, 0.0037665525451302528, 0.003509212750941515, 0.00327100302092731, 0.0035288231447339058, 0.002919249702244997, 0.0029339329339563847, 0.0031519974581897259, 0.0034294817596673965, 0.0032241924200206995, 0.0033463733270764351, 0.0031381465960294008, 0.0031771140638738871, 0.0033165959175676107, 0.0025702174752950668, 0.002973687369376421, 0.0029030148871243, 0.0030960896983742714, 0.0032159509137272835, 0.0033009580802172422, 0.0030621280893683434, 0.0030586931388825178, 0.0030015504453331232, 0.0030587723013013601, 0.003444847883656621, 0.0027642752975225449, 0.0038381824269890785, 0.0040889871306717396, 0.0029836671892553568, 0.0044072228483855724, 0.0029051823075860739, 0.0033898183610290289, 0.0030115020927041769, 0.0026111779734492302, 0.0032137222588062286, 0.0027963845059275627, 0.0025555710308253765, 0.0034644473344087601, 0.0026276393327862024, 0.0031036313157528639, 0.0033199242316186428, 0.0036480727139860392, 0.002624238608404994, 0.0035777734592556953, 0.0037457931321114302, 0.0031383447349071503, 0.002987016923725605, 0.0030980014707893133, 0.0041734636761248112, 0.0036306120455265045, 0.0031360664870589972, 0.0031139294151216745, 0.0028309030458331108, 0.0034256565850228071, 0.0032743525225669146, 0.0027928145136684179, 0.003308834508061409, 0.0031454165000468493, 0.0029769267421215773, 0.0034601842053234577, 0.0032114626374095678, 0.0032979948446154594, 0.0038065854460000992, 0.0028179348446428776, 0.002715870039537549, 0.0037614370230585337, 0.0030029898043721914, 0.002972309710457921, 0.0027464805170893669, 0.0026354703586548567, 0.0026063686236739159, 0.0029330037068575621, 0.003442118875682354, 0.0046449331566691399, 0.0048500504344701767, 0.0033043657895177603, 0.0039064697921276093, 0.0029682328458875418, 0.0028749187476933002, 0.003192950040102005, 0.0035514757037162781, 0.0042886584997177124, 0.00328974355943501, 0.0027246191166341305, 0.0038598112296313047, 0.0028054038994014263, 0.0026962254196405411, 0.0028766915202140808, 0.0040391408838331699, 0.0029119928367435932, 0.0026595147792249918, 0.0027022135909646749, 0.0033096135593950748, 0.0031601234804838896, 0.0037791023496538401, 0.003892319044098258, 0.0030652598943561316, 0.0026914884801954031, 0.0030121365562081337, 0.0029879536014050245, 0.0032608488108962774, 0.0025421157479286194, 0.0023155072703957558, 0.0039457418024539948, 0.0030010046903043985, 0.0032360097393393517, 0.0029102626722306013, 0.002979193814098835, 0.0032095909118652344, 0.0030678040347993374, 0.0031198011711239815, 0.0025386828929185867, 0.0025235158391296864, 0.0032040104269981384, 0.0027294831816107035, 0.0037207179702818394, 0.0037421898450702429, 0.0029308425728231668, 0.0031946729868650436, 0.0036669124383479357, 0.0035173711366951466, 0.0030094361864030361, 0.0038263923488557339, 0.0033714605960994959, 0.0035272617824375629, 0.0030231911223381758, 0.0031627384014427662, 0.0029230907093733549, 0.0031312860082834959, 0.0039517045952379704, 0.0028921687044203281, 0.0031312711071223021, 0.0029442033264786005, 0.0029576064553111792, 0.0029856443870812654, 0.0028215800411999226, 0.0033930041827261448, 0.0028591474983841181, 0.0039371633902192116, 0.0036559626460075378, 0.0038272114470601082, 0.002795967273414135, 0.0032750647515058517, 0.0027649709954857826, 0.0035681675653904676, 0.0025369599461555481, 0.0029938151128590107, 0.0030318677891045809, 0.0029607773758471012, 0.0029120573308318853, 0.0030992063693702221, 0.0034510307013988495, 0.0039491034112870693, 0.0034039400052279234, 0.0026516895741224289, 0.0035112933255732059, 0.0031632101163268089, 0.0029470822773873806, 0.0033536634873598814, 0.0030184751376509666, 0.0028151159640401602, 0.0035866082180291414, 0.0032637570984661579, 0.0029421430081129074, 0.0045103030279278755, 0.0032766559161245823, 0.0029151162598282099, 0.002822257112711668, 0.0033188052475452423, 0.0035098306834697723, 0.0026583867147564888, 0.003157331608235836, 0.0028230184689164162, 0.0032349452376365662, 0.0027516367845237255, 0.0028812482487410307, 0.0037570467684417963, 0.0036515265237540007, 0.0045249047689139843, 0.0038095349445939064, 0.0036763227544724941, 0.0034036173019558191, 0.0036605801433324814, 0.0033217128366231918, 0.0026277585420757532, 0.002953218761831522, 0.0023794879671186209, 0.0032559891697019339, 0.002886597067117691, 0.0032569789327681065, 0.0034548162948340178, 0.0031624531839042902, 0.0034555972088128328, 0.0037972659338265657, 0.0028757103718817234, 0.0033725972753018141, 0.0035429999697953463, 0.0028715038206428289, 0.0032438738271594048, 0.0025355715770274401, 0.0033306337427347898, 0.0029764326754957438, 0.0032590548507869244, 0.0030424732249230146, 0.0033144732005894184, 0.0043154219165444374, 0.0031839872244745493, 0.0040476517751812935, 0.0029235535766929388, 0.0034877646248787642, 0.0037176853511482477, 0.0029283040203154087, 0.0032776689622551203, 0.0034337439574301243, 0.0031486160587519407, 0.0036877149250358343, 0.003556443378329277, 0.0031347577460110188, 0.002706342376768589, 0.0025364612229168415, 0.003455224446952343, 0.0039488240145146847, 0.0029904537368565798, 0.0030263629741966724, 0.0039047321770340204, 0.0031362762674689293, 0.0031244081910699606, 0.0027233567088842392, 0.003430596087127924, 0.0027574398554861546, 0.0031804342288523912, 0.0034904102794826031, 0.0029771968256682158, 0.0028065240476280451, 0.0028557332698255777, 0.0036191819235682487, 0.0033633483108133078, 0.0028581097722053528, 0.0031965696252882481, 0.0032411138527095318, 0.0032112838234752417, 0.0028760612476617098, 0.00339321861974895, 0.0029953226912766695, 0.0033971269149333239, 0.002764994278550148, 0.0028303046710789204, 0.0036463516298681498, 0.0027577686123549938, 0.002870192751288414, 0.0029599461704492569, 0.0028209560550749302, 0.0027802551630884409, 0.0026783039793372154, 0.0032857530750334263, 0.0024762542452663183, 0.0027548305224627256, 0.003156653605401516, 0.002874280558899045, 0.0030829154420644045, 0.0034983179066330194, 0.002726513659581542, 0.003309374675154686, 0.0025437085423618555, 0.0029651233926415443, 0.0030368226580321789, 0.0029386251699179411, 0.0036102093290537596, 0.0026008277200162411, 0.0027601602487266064, 0.0027686201501637697, 0.0026143253780901432, 0.0035034315660595894, 0.0035068688448518515, 0.0028745096642524004, 0.0028859914746135473, 0.0039896317757666111, 0.0033513957168906927, 0.0032029510475695133, 0.0028988814447075129, 0.0026125304866582155, 0.0033123069442808628, 0.0031555879395455122, 0.0038405242376029491, 0.0032115259673446417, 0.0030474481172859669, 0.002961399732157588, 0.0032407122198492289, 0.0032265360932797194, 0.0028692497871816158, 0.0043359170667827129, 0.0027587132062762976, 0.0030422268901020288, 0.0028018320444971323, 0.0029738734010607004, 0.0039561972953379154, 0.0038144583813846111, 0.0043763141147792339, 0.0028982870280742645, 0.0029811416752636433, 0.0029198783449828625, 0.0035396015737205744, 0.0028021340258419514, 0.0033353576436638832, 0.0038146045990288258, 0.0026943637058138847, 0.0043852953240275383, 0.0028258881065994501, 0.0029247805941849947, 0.0028861486352980137, 0.0038188789039850235, 0.0033986736088991165, 0.0026011811569333076, 0.0034260728862136602, 0.0032524997368454933, 0.0030665700323879719, 0.0032044022809714079, 0.0027484034653753042, 0.0037270537577569485, 0.0032307929359376431, 0.0034048215020447969, 0.0032821828499436378, 0.0029635843820869923, 0.0030260379426181316, 0.0031569967977702618, 0.0025564192328602076, 0.0033080584835261106, 0.0036918709520250559, 0.0029324356000870466, 0.0031650029122829437, 0.0029921503737568855, 0.0033464317675679922, 0.0027946881018579006, 0.0029803058132529259, 0.003532330272719264, 0.0026231950614601374, 0.0037879631854593754, 0.0028448507655411959, 0.0032022034283727407, 0.0026540469843894243, 0.0025842455215752125, 0.0029726834036409855, 0.0038536675274372101, 0.0029504629783332348, 0.0026125821750611067, 0.0030600635800510645, 0.0039150831289589405, 0.0038558782543987036, 0.0030287662521004677, 0.0028368555940687656, 0.0035350790712982416, 0.0035772006958723068, 0.0030665448866784573, 0.0036976095288991928, 0.0031502142082899809, 0.0034736671950668097, 0.0035114623606204987, 0.0026737975422292948, 0.0030699579510837793, 0.0030545846093446016, 0.0030254162847995758, 0.002558581531047821, 0.0032651920337229967, 0.0026958284433931112, 0.0028071338310837746, 0.0032305647619068623, 0.003005805192515254, 0.0040137888863682747, 0.0036960553843528032, 0.0028747697360813618, 0.0038026440888643265, 0.0029956621583551168, 0.0027551522944122553, 0.0035378823522478342, 0.003479410894215107, 0.0031066325027495623, 0.0033131709787994623, 0.0030303664971143007, 0.0036693539004772902, 0.0029253626707941294, 0.0041945758275687695, 0.0029086479917168617, 0.0025967771653085947, 0.0030324948020279408, 0.0039284974336624146, 0.0028542587533593178, 0.0040999734774231911, 0.0030874055810272694, 0.0031752968207001686, 0.0030038380064070225, 0.0030514404643326998, 0.0033557484857738018, 0.0023316734004765749, 0.0032006565015763044, 0.0035234226379543543, 0.0030051327776163816, 0.00358585175126791, 0.0027270030695945024, 0.003103587543591857, 0.003099893219769001, 0.0030828751623630524, 0.0028660364914685488, 0.0032158747781068087, 0.0033184308558702469, 0.0027707989793270826, 0.0027856172528117895, 0.0029492101166397333, 0.0029663257300853729, 0.0027798186056315899, 0.0028919363394379616, 0.0034748832695186138, 0.0034823198802769184, 0.0036320255603641272, 0.002401730278506875, 0.0032034157775342464, 0.0036647026427090168, 0.0038047768175601959, 0.0035698534920811653, 0.0032327200751751661, 0.0036611128598451614, 0.0032261672895401716, 0.003226227592676878, 0.0031070604454725981, 0.003194921649992466, 0.002809600206092, 0.0029451954178512096, 0.002954935422167182, 0.0034585294779390097, 0.0029646304901689291, 0.0037090303376317024, 0.0027046301402151585, 0.0026649751234799623, 0.0029717923607677221, 0.0026693230029195547, 0.0028755194507539272, 0.0030847582966089249, 0.0036557542625814676, 0.0031360089778900146, 0.0029070498421788216, 0.0030897755641490221, 0.0027644522488117218, 0.0027621083427220583, 0.0029912467580288649, 0.0030641595367342234, 0.0034478665329515934, 0.0033458669204264879, 0.0035307076759636402, 0.0029888229910284281, 0.0032828804105520248, 0.0028704730793833733, 0.0030784315895289183, 0.0027640978805720806, 0.0043516447767615318, 0.0024454602971673012, 0.0031442546751350164, 0.0032808010000735521, 0.003020566888153553, 0.0033815342467278242, 0.0035533495247364044, 0.0026381141506135464, 0.0043596518225967884, 0.0033459560945630074, 0.0027670699637383223, 0.0030450448393821716, 0.0038724790792912245, 0.0028675289358943701, 0.0027973430696874857, 0.0033552043605595827, 0.0029198636766523123, 0.0028492214623838663, 0.0035458491183817387, 0.002809260506182909, 0.0032010599970817566, 0.0030485121533274651, 0.0031979323830455542, 0.0029960470274090767, 0.0028793592937290668, 0.0024558785371482372, 0.0032723508775234222, 0.0042335973121225834, 0.0027853567153215408, 0.0031303982250392437, 0.0028921128250658512, 0.0031839003786444664, 0.0032273316755890846, 0.0043619796633720398, 0.0035874985624104738, 0.0026199968997389078, 0.0029741858597844839, 0.0029686950147151947, 0.0024556184653192759, 0.003459300147369504, 0.0038104939740151167, 0.0032644812017679214, 0.0032532052136957645, 0.0035804484505206347, 0.0050019561313092709, 0.0029666663613170385, 0.003100251080468297, 0.0030726373661309481, 0.0031266198493540287, 0.0030749957077205181, 0.0039321114309132099, 0.0031655707862228155, 0.003041338175535202, 0.0030174511484801769, 0.0039220019243657589, 0.0027452067006379366, 0.0032153688371181488, 0.0029921191744506359, 0.0033116443082690239, 0.003230763366445899, 0.003465310437604785, 0.0031336729880422354, 0.002913178876042366, 0.0029092503245919943, 0.0031158742494881153, 0.0029773011337965727, 0.0033208397217094898, 0.002670270623639226, 0.0026567352470010519, 0.0029040554072707891, 0.0033420114777982235, 0.0026177503168582916, 0.0029667390044778585, 0.0027032291982322931, 0.0031673277262598276, 0.0036846213042736053, 0.0029967341106384993, 0.0035832582507282495, 0.0028946676757186651, 0.0029626872856169939, 0.0027072355151176453, 0.0035325901117175817, 0.0030470837373286486, 0.0029691520612686872, 0.0038709761574864388, 0.0033090843353420496, 0.0027148772496730089, 0.0034132460132241249, 0.0030753228347748518, 0.0029537321534007788, 0.0026521403342485428, 0.0032005279790610075, 0.003981191199272871, 0.0027841224800795317, 0.0037516376469284296, 0.0030748117715120316, 0.0030991246458142996, 0.003255894873291254, 0.0029352316632866859, 0.0031917376909404993, 0.002770598977804184, 0.002624014625325799, 0.003789408365264535, 0.0033885873854160309, 0.0033891184721142054, 0.0030261913780122995, 0.0023324764333665371, 0.0029837186448276043, 0.0033702037762850523, 0.0025950777344405651, 0.0032874918542802334, 0.0024027039762586355, 0.0028344434686005116, 0.0029271519742906094, 0.0037684538401663303, 0.002833137521520257, 0.0030598579905927181, 0.003250553272664547, 0.0033562094904482365, 0.0031306582968682051, 0.0031585525721311569, 0.0034737475216388702, 0.0030184921342879534, 0.0028598937205970287, 0.0026576400268822908, 0.0033030314370989799, 0.0031525983940809965, 0.0030302342493087053, 0.0035540079697966576, 0.0029823430813848972, 0.0039399000816047192, 0.0030113535467535257, 0.0029597226530313492, 0.0032587205059826374, 0.0035793338902294636, 0.004064253531396389, 0.0036857735831290483, 0.0037563610821962357, 0.0033102177549153566, 0.0032033859752118587, 0.0037755281664431095, 0.0037192837335169315, 0.0026012887246906757, 0.0032732908148318529, 0.0032640504650771618, 0.0027339488733559847, 0.0025921943597495556, 0.0027153198607265949, 0.0030381982214748859, 0.0028826715424656868, 0.0032203157898038626, 0.0031567912083119154, 0.0035045510157942772, 0.0042089112102985382, 0.0045593907125294209, 0.0031099861953407526, 0.0038405873347073793, 0.0031158654019236565, 0.0033943643793463707, 0.0031237599905580282, 0.0029941715765744448, 0.003126457566395402, 0.0042199292220175266, 0.0037364240270107985, 0.0029493446927517653, 0.003342457115650177, 0.0030588496010750532, 0.0028527393005788326, 0.0029659499414265156, 0.0032826922833919525, 0.0027411358896642923, 0.0026891957968473434, 0.0038366771768778563, 0.0038212083745747805, 0.0029449132271111012, 0.0039011968765407801, 0.0031968099065124989, 0.0035066117998212576, 0.0028603891842067242, 0.0033706945832818747, 0.0023915213532745838, 0.0036649946123361588, 0.003039459465071559, 0.002959950128570199, 0.0030374194029718637, 0.0034013676922768354, 0.0036793360486626625, 0.0037518097087740898, 0.003969480749219656, 0.0027692150324583054, 0.0037953394930809736, 0.0029701057355850935, 0.0028479576576501131, 0.0035659256391227245, 0.0047213779762387276, 0.0035195115488022566, 0.0036633696872740984, 0.0027221948839724064, 0.0026826828252524137, 0.0033633627463132143, 0.0030726238619536161, 0.0029433965682983398, 0.0030608817469328642, 0.0029246006160974503, 0.0034338661935180426, 0.0029511530883610249, 0.0029333368875086308, 0.0036461560521274805, 0.0044912500306963921, 0.0029381753411144018, 0.0037815424147993326, 0.0027195240836590528, 0.0034143046941608191, 0.0026882069651037455, 0.0035884138196706772, 0.0024826235603541136, 0.0041346377693116665, 0.0028190636076033115, 0.0027983433101326227, 0.0035535427741706371, 0.003385747317224741, 0.002898369450122118, 0.0029197810217738152, 0.0037220939993858337, 0.00383531185798347, 0.0036061098799109459, 0.0035265048500150442, 0.0033428715541958809, 0.0035544105339795351, 0.0028672115877270699, 0.0032757080625742674, 0.0034285427536815405, 0.0031979787163436413, 0.0038879727944731712, 0.0023746562656015158, 0.0040025594644248486, 0.0031166642438620329, 0.0033031427301466465, 0.0037838718853890896, 0.003273683600127697, 0.0032842289656400681, 0.0030565580818802118, 0.0036101110745221376, 0.0034250151365995407, 0.0026585438754409552, 0.0033623322378844023, 0.0029610805213451385, 0.0031622836831957102, 0.0033506359905004501, 0.0029319652821868658, 0.0029805109370499849, 0.0027887891046702862, 0.0028325910679996014, 0.0030649295076727867, 0.0029711907263845205, 0.0033167290966957808, 0.0029050309676676989, 0.0037590020801872015, 0.0035524258855730295, 0.003217003308236599, 0.0034515878651291132, 0.0030670934356749058, 0.0042245853692293167, 0.0027967717032879591, 0.004569709300994873, 0.0029827917460352182, 0.0043201763182878494, 0.0031159122008830309, 0.0030073216184973717, 0.0031291022896766663, 0.0032222671434283257, 0.0031267052982002497, 0.0035305526107549667, 0.0038398702163249254, 0.0035898564383387566, 0.0033202155027538538, 0.0044077937491238117, 0.0028442672919481993, 0.0033473174553364515, 0.0031272778287529945, 0.0033113770186901093, 0.0029595613013952971, 0.0030588635709136724, 0.002573118545114994, 0.0029480801895260811, 0.0025494375731796026, 0.0027380723040550947, 0.0027378643862903118, 0.0031624303665012121, 0.0028124791570007801, 0.0038303222972899675, 0.0034743803553283215, 0.0038267381023615599, 0.0036710929125547409, 0.003852030960842967, 0.002724754624068737, 0.0031167156994342804, 0.0030698275659233332, 0.002847128314897418, 0.0039066961035132408, 0.0026915103662759066, 0.0028494040016084909, 0.003153329947963357, 0.0030696829780936241, 0.0038028752896934748, 0.0035830705892294645, 0.0031504072248935699, 0.0034056061413139105, 0.0032050262670964003, 0.0035116230137646198, 0.0028053685091435909, 0.0033153253607451916, 0.0026950782630592585, 0.0030352247413247824, 0.0037937280721962452, 0.0026589110493659973, 0.0027908266056329012, 0.0028896746225655079, 0.0034927059896290302, 0.0035458949860185385, 0.0031904098577797413, 0.0028620979283004999, 0.0034568719565868378, 0.0024036180693656206, 0.0041440981440246105, 0.0034450364764779806, 0.0027045414317399263, 0.0027806898579001427, 0.0041003059595823288, 0.0030610349494963884, 0.0030954750254750252, 0.0026473649777472019, 0.0033618898596614599, 0.0036621806211769581, 0.0037377381231635809, 0.0029131565243005753, 0.0022031171247363091, 0.0026676298584789038, 0.0027391507755964994, 0.0043276124633848667, 0.0028399711009114981, 0.0035846678074449301, 0.0029753327835351229, 0.0028771925717592239, 0.002880350686609745, 0.0026133998762816191, 0.0031034424901008606, 0.0032521584071218967, 0.0028024369385093451, 0.0029284448828548193, 0.0030178481247276068, 0.0032146575395017862, 0.0032438794150948524, 0.0026494411285966635, 0.0031169955618679523, 0.0031481918413192034, 0.0039897155947983265, 0.0029296411667019129, 0.0035988418385386467, 0.003298445837572217, 0.0037553072907030582, 0.0040639676153659821, 0.0048987632617354393, 0.0034379987046122551, 0.00313990144059062, 0.0029894490726292133, 0.0041091563180088997, 0.0024227998219430447, 0.0035166949965059757, 0.0028908364474773407, 0.0029641862493008375, 0.0040011475794017315, 0.0032039510551840067, 0.0035418872721493244, 0.0029237102717161179, 0.0026869853027164936, 0.003505669767037034, 0.003210216062143445, 0.0038426441606134176, 0.0033198115415871143, 0.00364867621101439, 0.0031301593407988548, 0.0030998783186078072, 0.002592278178781271, 0.0031634955666959286, 0.0032116265501827002, 0.0027503492310643196, 0.002951794071123004, 0.0035767569206655025, 0.0032686276827007532, 0.0030236206948757172, 0.0036264474038034678, 0.0031349803321063519, 0.0030148974619805813, 0.0031714534852653742, 0.0030843010172247887, 0.0032515174243599176, 0.0031648371368646622, 0.0031226577702909708, 0.0032639012206345797, 0.0034605595283210278, 0.0028210990130901337, 0.0031550913117825985, 0.0029665227048099041, 0.0027756895869970322, 0.0034875627607107162, 0.0027851436752825975, 0.0029852716252207756, 0.0032733182888478041, 0.003000996308401227, 0.0030125579796731472, 0.0026861410588026047, 0.0028835071716457605, 0.0037709285970777273, } };
const TfArray<1280, int> quant77_zero = { 1280, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant77 = { (TfLiteFloatArray*)&quant77_scale, (TfLiteIntArray*)&quant77_zero, 0 };
const ALIGN(8) int8_t tensor_data78[1*3*3*16] = { 
  /* [0][0][][] */ 2,-4,4,4,-19,11,7,16,-5,-11,1,-9,-2,-8,0,-1, 7,-5,1,4,13,-2,11,-26,-7,9,-4,87,-9,20,5,0, 2,-5,-5,3,2,-13,-3,11,2,2,-3,-9,1,-5,-4,-1, 
  /* [0][1][][] */ 13,-9,2,3,127,-24,-127,-21,127,127,0,-6,111,-24,-1,-19, -127,127,127,-1,-87,-91,-16,-102,17,-105,127,127,127,127,127,127, 20,-3,-5,0,-10,127,3,-10,-2,-12,-5,-5,10,-4,-12,-9, 
  /* [0][2][][] */ 1,-4,-1,-15,-18,16,53,7,-9,-8,-1,-1,-5,1,-6,-11, 22,-14,-5,-127,7,-15,-10,127,-5,1,2,-15,-10,-57,-8,-36, 3,-4,-4,-3,1,-4,-1,-2,1,2,-2,0,0,-5,-8,-12, 
};
const TfArray<4, int> tensor_dimension78 = { 4, { 1,3,3,16 } };
const TfArray<16, float> quant78_scale = { 16, { 0.003448521951213479, 0.0079918894916772842, 0.0078272074460983276, 0.0080792820081114769, 0.040040742605924606, 0.029096713289618492, 0.0069279484450817108, 0.029020506888628006, 0.0099409362301230431, 0.038154974579811096, 0.0085100065916776657, 0.0077207763679325581, 0.0043655633926391602, 0.0095228543505072594, 0.0082917651161551476, 0.023152858018875122, } };
const TfArray<16, int> quant78_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant78 = { (TfLiteFloatArray*)&quant78_scale, (TfLiteIntArray*)&quant78_zero, 3 };
const ALIGN(8) int32_t tensor_data79[8] = { -9221, -3869, 15080, -12761, 29221, 9710, -11372, 14000, };
const TfArray<1, int> tensor_dimension79 = { 1, { 8 } };
const TfArray<8, float> quant79_scale = { 8, { 0.00015077863645274192, 0.00017635818221606314, 0.00014658761210739613, 0.0001711653167149052, 0.00013025320367887616, 0.00013184291310608387, 0.00012899623834528029, 0.00019534316379576921, } };
const TfArray<8, int> quant79_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant79 = { (TfLiteFloatArray*)&quant79_scale, (TfLiteIntArray*)&quant79_zero, 0 };
const ALIGN(8) int8_t tensor_data80[1*3*3*48] = { 
  /* [0][0][][] */ -50,-100,-13,-22,127,-55,69,-58,-88,-81,-22,-44,113,36,68,-127,62,-23,4,-40,-76,108,-1,13,-19,78,61,-34,75,-68,13,-43,-106,-85,44,72,21,79,112,-69,-125,-15,33,71,48,-127,87,79, -60,-125,-77,49,-85,107,59,-67,-69,43,77,-108,127,90,112,-79,-81,-82,34,-53,-78,97,-64,114,-87,103,88,-122,91,-48,6,-123,-49,-88,73,127,112,114,127,-67,-127,-66,65,88,81,111,90,72, 4,-58,-66,93,-45,-28,24,-5,87,23,57,-71,21,53,-39,-6,-82,-16,32,-34,-26,7,-76,-1,-70,44,18,-87,32,56,120,-71,15,11,-12,50,76,68,47,0,-22,92,60,31,38,30,15,-117, 
  /* [0][1][][] */ -124,-95,-16,-77,-82,-73,98,-112,-127,-127,84,-75,91,48,-126,-79,127,-127,-61,-75,-90,120,-43,8,-15,95,104,-49,-105,-76,-1,-52,-93,-127,-127,69,40,89,7,-90,58,-15,76,115,80,111,121,-127, -127,-127,-127,-105,-29,127,127,-127,88,67,127,-127,109,127,67,-121,55,-94,-127,-127,-127,127,-127,127,-127,127,127,-127,-127,127,-14,-127,-127,-109,47,127,127,127,-13,-127,96,-98,127,127,127,-2,127,111, -52,-66,-120,127,73,-44,46,-24,64,28,19,-57,12,63,77,-56,-19,3,-16,-69,-59,10,-75,-16,-112,48,25,-88,-52,38,127,-88,-58,10,59,76,81,73,-25,-32,42,127,75,20,51,-48,20,22, 
  /* [0][2][][] */ -108,-28,21,20,-44,-27,21,-43,26,-44,17,-37,4,20,-44,-15,-81,-21,95,-33,-14,37,-64,-14,-4,51,69,-16,33,57,-8,-5,6,-84,-42,38,13,9,-58,-41,18,-4,37,41,26,55,15,-66, -89,-41,-33,-71,90,42,54,-58,93,25,-40,-60,0,42,-127,-79,38,10,49,-67,-42,31,-60,55,-64,58,70,-36,35,5,-28,-36,-66,-25,-65,56,30,15,-103,-69,22,-42,77,69,42,-108,24,2, -30,-29,-49,-21,-24,-13,14,-21,-69,15,-15,-14,-8,13,37,-28,33,39,-1,-49,-34,-12,-16,-27,-53,6,17,-24,8,-62,54,-25,-85,20,20,45,20,17,-52,-31,0,49,23,21,17,-3,5,36, 
};
const TfArray<4, int> tensor_dimension80 = { 4, { 1,3,3,48 } };
const TfArray<48, float> quant80_scale = { 48, { 0.0034593343734741211, 0.0041916873306035995, 0.0077235368080437183, 0.0064562647603452206, 0.025419419631361961, 0.0060379169881343842, 0.0065019400790333748, 0.0046619563363492489, 0.00507001718506217, 0.0033048447221517563, 0.0030194851569831371, 0.0023436255287379026, 0.0040138121694326401, 0.003186891321092844, 0.0088743343949317932, 0.005983362440019846, 0.005719043780118227, 0.015115736983716488, 0.0071265720762312412, 0.0071251294575631618, 0.0056693996302783489, 0.015631865710020065, 0.0064758434891700745, 0.010687107220292091, 0.0045206416398286819, 0.0048669842071831226, 0.0026900987140834332, 0.0040780548006296158, 0.006528547964990139, 0.038662917912006378, 0.010090222582221031, 0.0035890510771423578, 0.0048084068112075329, 0.0066159260459244251, 0.0074272281490266323, 0.0028772768564522266, 0.0044585615396499634, 0.002051342511549592, 0.0054510454647243023, 0.0030343113467097282, 0.0070813968777656555, 0.0061389552429318428, 0.0036049257032573223, 0.0042091743089258671, 0.0035635342355817556, 0.013533354736864567, 0.0030697006732225418, 0.0075784921646118164, } };
const TfArray<48, int> quant80_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant80 = { (TfLiteFloatArray*)&quant80_scale, (TfLiteIntArray*)&quant80_zero, 3 };
const ALIGN(8) int32_t tensor_data81[8] = { 9897, 20241, -5898, 9589, -997, 5375, -15614, -25059, };
const TfArray<1, int> tensor_dimension81 = { 1, { 8 } };
const TfArray<8, float> quant81_scale = { 8, { 0.00017163148731924593, 9.241864609066397e-05, 0.0001039735579979606, 0.00010888639371842146, 0.00014266549260355532, 0.00011905157589353621, 0.00016883056377992034, 0.00010125377593794838, } };
const TfArray<8, int> quant81_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant81 = { (TfLiteFloatArray*)&quant81_scale, (TfLiteIntArray*)&quant81_zero, 0 };
const ALIGN(8) int8_t tensor_data82[1*3*3*48] = { 
  /* [0][0][][] */ 9,-39,8,7,-20,-97,-41,51,-35,-4,-2,9,45,-5,-13,5,97,17,23,2,-1,-25,-71,20,-4,-15,1,-27,-65,74,-13,-111,52,-4,-51,-56,-9,-32,9,-15,-16,38,11,2,-13,63,127,-23, -127,-90,-25,127,-69,75,-97,127,28,15,17,-3,51,20,-3,-42,-30,63,26,7,8,127,11,127,127,-30,-41,40,66,-122,-8,-72,70,-4,-40,-126,25,10,-55,-56,-127,-5,-93,-127,35,52,54,117, -14,-2,10,9,-27,33,38,47,9,-35,4,4,-22,-1,-4,6,-59,39,-68,-27,-5,-31,127,22,-55,3,13,0,16,40,12,12,-2,-14,-36,76,7,3,16,72,26,-22,29,-36,-9,35,-22,-18, 
  /* [0][1][][] */ -12,-21,-29,-1,30,-105,127,-79,-12,10,24,38,127,17,1,-33,-23,-30,27,43,61,-69,40,13,-61,127,-75,-18,127,-95,46,-127,-43,5,-79,17,11,-60,-41,9,120,127,12,-126,-65,-57,-4,85, 96,-127,127,0,127,73,-70,-50,28,127,127,-127,-93,127,127,127,127,127,122,127,127,119,3,5,119,-99,-127,127,37,127,127,0,-127,127,127,127,-127,127,-127,-127,41,36,-127,-38,127,-127,-13,84, 22,31,-41,-4,-53,127,-118,91,107,-74,19,64,-37,11,12,-64,16,10,-127,16,22,-116,-37,-2,73,-13,-21,125,-77,-36,26,-36,-28,17,95,-24,39,-5,-3,-93,112,0,34,45,-57,91,96,-82, 
  /* [0][2][][] */ -4,23,5,-31,-1,-65,-16,-7,6,-1,3,4,-16,-13,-2,-1,-52,16,10,-37,-1,-24,82,-9,-109,4,44,-22,11,0,1,35,-11,-10,-66,32,0,-12,18,52,-27,-2,12,6,-19,19,-14,8, 39,-19,-36,-35,26,36,117,-97,127,-31,-3,7,-72,-22,-22,-71,-19,106,6,25,10,30,-25,-31,-78,59,81,-5,-97,14,-32,-10,-24,-3,-38,2,55,-23,0,127,-117,-4,-10,57,34,54,7,-127, -8,26,3,-20,-17,-2,-7,-49,-24,-22,-6,6,17,-13,-11,14,45,39,-28,-17,-4,-23,-50,-13,21,-24,27,-14,-18,3,-11,18,28,-15,-26,-52,-6,5,28,16,-9,-14,9,14,-16,15,61,-52, 
};
const TfArray<4, int> tensor_dimension82 = { 4, { 1,3,3,48 } };
const TfArray<48, float> quant82_scale = { 48, { 0.011466984637081623, 0.0068491939455270767, 0.038964372128248215, 0.0096028801053762436, 0.010118194855749607, 0.012025364674627781, 0.01104909460991621, 0.013491297140717506, 0.0040691266767680645, 0.011947603896260262, 0.0088744107633829117, 0.058256227523088455, 0.021418219432234764, 0.024283189326524734, 0.016624230891466141, 0.027534320950508118, 0.0080283414572477341, 0.0026996189262717962, 0.009737466461956501, 0.012847123667597771, 0.012270162813365459, 0.0097204167395830154, 0.0037302176933735609, 0.019936889410018921, 0.0078628640621900558, 0.017456000670790672, 0.021134166046977043, 0.0087890084832906723, 0.01316530629992485, 0.014742988161742687, 0.0060848272405564785, 0.0052900868467986584, 0.0059888823889195919, 0.0090022971853613853, 0.006207780446857214, 0.012591524049639702, 0.090766951441764832, 0.014990707859396935, 0.0063424953259527683, 0.0074739279225468636, 0.0072631728835403919, 0.0062136370688676834, 0.012965243309736252, 0.0083917425945401192, 0.014217396266758442, 0.0039466647431254387, 0.0027689298149198294, 0.0077290991321206093, } };
const TfArray<48, int> quant82_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant82 = { (TfLiteFloatArray*)&quant82_scale, (TfLiteIntArray*)&quant82_zero, 3 };
const ALIGN(8) int32_t tensor_data83[8] = { 2793, 170, 22696, -5193, 5011, -14664, 2158, -14841, };
const TfArray<1, int> tensor_dimension83 = { 1, { 8 } };
const TfArray<8, float> quant83_scale = { 8, { 9.4673028797842562e-05, 0.00010104638931807131, 0.00014898341032676399, 0.00010822695912793279, 0.00013617159856949002, 0.00013705874152947217, 8.8580185547471046e-05, 8.6515821749344468e-05, } };
const TfArray<8, int> quant83_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant83 = { (TfLiteFloatArray*)&quant83_scale, (TfLiteIntArray*)&quant83_zero, 0 };
const ALIGN(8) int8_t tensor_data84[1*3*3*48] = { 
  /* [0][0][][] */ -95,61,-127,90,-96,63,-47,88,-77,-63,61,-48,61,-79,-47,-52,72,70,86,-109,85,-117,76,-91,-93,-57,62,127,-98,-51,-86,65,72,-92,62,-106,-79,-113,86,-46,-12,-92,115,-103,100,58,-72,-56, -118,90,-71,109,-76,120,-46,107,-116,-88,96,-71,93,-108,-70,-78,98,105,127,-127,109,-124,95,-127,-107,-89,78,126,30,-77,-106,100,99,-127,92,-115,-95,-127,109,-74,-101,99,127,-116,-35,100,-89,-89, -56,48,-2,25,-13,63,-21,38,-55,-33,41,-27,39,-45,-26,-13,38,45,65,-38,33,-54,35,-46,-75,-35,26,24,95,-31,-56,28,33,-81,36,-33,-28,-37,40,-42,-112,-36,36,-47,-69,54,-25,-58, 
  /* [0][1][][] */ -100,88,-72,110,-72,109,-112,100,-98,-95,79,-83,84,-99,-86,-96,98,87,-45,-98,101,-122,100,-79,-111,-87,92,108,-127,-86,-100,89,97,34,91,-117,-106,-110,103,-81,-112,-108,108,-120,127,67,-109,-91, -127,127,-110,127,-127,127,-127,127,-127,-127,127,-127,127,-127,-127,-127,127,127,-52,-113,127,-127,127,-118,-127,-127,127,121,18,-127,-127,127,127,44,127,-127,-127,-108,127,-127,-127,127,119,-127,-56,127,-127,-127, -73,71,-84,39,-53,33,-57,54,-54,-39,52,-54,53,-55,-49,-15,64,53,-39,-27,33,-56,44,-52,-112,-51,49,46,105,-59,-66,47,44,14,50,-47,-36,-23,54,-58,-54,-66,30,-62,-88,68,-26,-72, 
  /* [0][2][][] */ -42,40,-4,48,-31,48,-55,32,-47,-40,23,-45,32,-54,-37,-50,51,33,-70,-21,25,-35,34,-32,-50,-41,35,0,-77,-48,-35,34,36,52,44,-61,-43,-47,28,-38,-104,-53,37,-85,73,28,-59,-44, -66,60,-82,59,-63,37,-64,45,-62,-51,44,-66,49,-68,-59,-50,70,48,-88,-18,28,-33,41,-49,-60,-58,47,32,3,-76,-59,46,42,71,58,-65,-55,-42,33,-52,-59,67,38,-107,-32,54,-63,-62, -25,34,-69,13,-34,-5,-31,25,-14,-11,20,-28,22,-25,-25,8,38,18,-61,5,7,7,13,-12,-39,-19,23,16,60,-23,-19,12,13,42,23,-15,-5,-2,16,-18,6,-24,0,-32,-50,34,-14,-40, 
};
const TfArray<4, int> tensor_dimension84 = { 4, { 1,3,3,48 } };
const TfArray<48, float> quant84_scale = { 48, { 0.003623301163315773, 0.0055042109452188015, 0.0026752811390906572, 0.0049092071130871773, 0.0046571558341383934, 0.0036765567492693663, 0.0026864907704293728, 0.011106635443866253, 0.0044535240158438683, 0.0029009848367422819, 0.0028912737034261227, 0.0046508032828569412, 0.00341035146266222, 0.0042140050791203976, 0.0020600559655576944, 0.0037795817479491234, 0.0046362201683223248, 0.0029093986377120018, 0.0065213199704885483, 0.0020548617467284203, 0.0031895628198981285, 0.0025847735814750195, 0.0042814654298126698, 0.0047169257886707783, 0.0027802092954516411, 0.003271373687312007, 0.0029049741569906473, 0.0019315944518893957, 0.010549647733569145, 0.0044596614316105843, 0.0025508275721222162, 0.013215333223342896, 0.0055874548852443695, 0.0078212376683950424, 0.0045818369835615158, 0.0030544328037649393, 0.0045189014635980129, 0.0025473118294030428, 0.0036615387070924044, 0.0045985993929207325, 0.002291692653670907, 0.0071913530118763447, 0.0074238330125808716, 0.0026475167833268642, 0.0071259327232837677, 0.0030403039418160915, 0.0021369541063904762, 0.0025552718434482813, } };
const TfArray<48, int> quant84_zero = { 48, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant84 = { (TfLiteFloatArray*)&quant84_scale, (TfLiteIntArray*)&quant84_zero, 3 };
const ALIGN(8) int32_t tensor_data85[16] = { -6096, 15565, -28269, 2508, 19383, -22037, -59297, -13009, -7436, 10293, -23443, -18539, 9186, -17163, -4227, -3955, };
const TfArray<1, int> tensor_dimension85 = { 1, { 16 } };
const TfArray<16, float> quant85_scale = { 16, { 9.9522301752585918e-05, 0.00010281077993568033, 9.3924951215740293e-05, 0.00010644846770446748, 6.6158405388705432e-05, 0.00010156741336686537, 7.088193524396047e-05, 0.00010813732660608366, 7.0476533437613398e-05, 5.9094087191624567e-05, 0.00013248156756162643, 0.00010689240298233926, 8.9944478531833738e-05, 6.6666209022514522e-05, 9.3084694526623935e-05, 8.8863795099314302e-05, } };
const TfArray<16, int> quant85_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant85 = { (TfLiteFloatArray*)&quant85_scale, (TfLiteIntArray*)&quant85_zero, 0 };
const ALIGN(8) int8_t tensor_data86[1*3*3*96] = { 
  /* [0][0][][] */ -43,-9,-1,-31,91,-8,32,-10,-7,-3,-10,-25,-28,1,-4,-18,-16,3,-5,-17,-3,27,14,45,-1,-17,-27,-2,17,-1,26,4,-15,1,-3,-29,-2,-71,-47,2,1,-7,37,-25,-26,37,-56,-15,-22,7,-8,52,-65,3,35,-11,0,-10,4,-18,-8,-14,-10,-41,-19,-24,-43,-33,-13,26,-4,-1,30,4,0,3,-16,6,127,-23,-127,10,-102,-19,-26,-18,21,13,-31,-17,10,-34,-5,32,-23,9, -18,36,46,-67,-40,-3,127,-54,-1,-14,-35,10,-64,2,-89,78,-10,72,73,-31,-5,127,85,124,31,-1,46,64,127,37,127,-31,-123,-19,-85,-35,-22,-100,127,-54,-26,-127,-12,-44,62,-32,-33,-4,41,2,22,127,-94,34,-79,-5,-80,-6,-7,24,-11,-127,-125,-52,-44,-2,-7,-93,-9,16,-65,108,-127,-13,12,-26,-127,-78,-6,-86,-126,8,26,-57,108,75,-63,33,-127,-1,31,-16,9,127,-52,-83, -36,2,-7,-12,56,-6,46,-24,-20,11,-9,-1,-6,-2,-5,-27,-12,-3,-17,-25,-5,8,16,30,-2,-11,0,-17,8,6,16,10,-16,0,-13,57,-2,-68,-43,15,-3,-6,19,-13,-17,-25,-45,-23,-15,-3,-5,35,2,-5,9,-12,57,-16,6,-22,-8,-5,-51,-10,-25,-35,127,-28,-5,19,1,9,17,7,5,19,-12,30,-42,-16,-100,3,-110,-16,5,-30,15,-19,-37,-36,6,47,3,29,-21,14, 
  /* [0][1][][] */ -87,-5,40,-50,41,95,-38,-16,-5,-14,-24,-21,-127,22,21,70,-17,40,102,19,32,-18,120,-26,39,21,64,15,-12,2,-7,-20,-127,-17,70,-19,-9,-127,-62,-127,-16,-6,89,-34,-75,127,-87,-75,55,62,15,-45,-119,64,59,-26,22,-31,33,-11,12,-6,91,-83,-31,13,-28,-66,-12,-6,-127,15,72,127,11,-73,-122,-60,-62,-50,-77,-6,-23,-53,42,21,-99,59,-63,127,92,-85,127,3,-62,-3, 91,127,127,127,-127,-127,101,-62,127,127,-77,-63,-86,127,-29,127,127,-127,127,127,127,-82,85,-127,-127,-127,127,127,-118,127,-24,127,-65,127,127,-100,127,96,8,-18,127,-2,-127,-114,127,-27,127,127,127,-127,127,-114,114,127,-127,127,-127,127,-127,127,-108,123,103,-127,127,127,-15,127,-110,-127,-23,-127,15,115,127,70,-1,-127,91,-127,63,127,127,127,127,63,-127,127,-92,50,-5,-26,-91,-24,-127,-30, -127,-28,34,-62,5,54,-53,3,-36,-14,-2,127,-112,19,23,56,-24,49,73,6,17,-23,78,-25,39,9,40,1,-13,-5,14,-15,-95,-33,84,127,-3,-99,-82,-75,-27,-23,25,-40,-67,-66,-83,-102,42,67,-4,-27,127,11,87,-43,94,-28,47,-41,-1,-29,-127,-38,-63,-12,-54,-77,-20,2,-107,1,35,-96,8,127,-89,-38,-59,2,-106,-14,-60,-72,1,25,-80,41,-27,-80,127,127,-41,-23,-77,-5, 
  /* [0][2][][] */ -22,-38,-17,-14,28,-6,-6,20,-11,5,32,-30,51,-2,-8,-34,-3,-6,-43,-23,-11,-13,19,-24,4,-9,-11,3,0,-8,-25,5,3,-3,2,-23,-3,-37,-20,-11,-24,-2,26,9,20,11,-54,1,-30,5,-20,-17,-10,-30,27,-12,10,-18,5,-17,-3,16,5,-7,-33,-23,115,17,27,23,-6,2,-8,-13,-6,-27,-18,21,-29,-22,-28,4,-82,-16,-9,-5,42,-12,6,4,-5,-20,-13,-14,-27,-2, -28,-57,25,-91,-44,-5,51,127,-54,62,127,-26,-60,19,127,83,-11,-33,79,-50,-23,-36,127,13,19,-14,35,14,-12,5,-91,-44,-67,-32,-92,-6,-87,-100,47,-62,-22,-105,-37,127,25,-22,-45,-2,23,-7,-10,-8,59,27,-51,-38,-47,-48,42,-53,127,25,99,-1,-77,-50,-25,-53,127,28,-41,19,23,-28,21,-25,-24,-36,-1,39,-89,-22,-79,-68,40,-127,-7,13,-22,0,44,-1,13,-119,-76,127, -26,6,-15,-1,20,-13,1,17,-21,-2,15,37,58,-2,-7,-37,-5,9,-16,-29,-10,-5,11,-11,-2,-10,-12,-8,-4,-2,-32,4,9,1,2,0,-6,-52,-30,1,-30,1,-1,4,16,-5,-52,8,-26,-4,-13,-14,2,-33,24,-12,58,-11,10,-21,2,18,-14,10,-23,-26,-26,20,24,11,-14,2,-48,-37,-7,-13,-30,15,91,-9,-22,-2,-60,-3,-13,1,47,3,13,-3,-10,16,2,-20,-21,-6, 
};
const TfArray<4, int> tensor_dimension86 = { 4, { 1,3,3,96 } };
const TfArray<96, float> quant86_scale = { 96, { 0.0047577731311321259, 0.013936568982899189, 0.0078660519793629646, 0.0068517345935106277, 0.010783392004668713, 0.024085201323032379, 0.0047638136893510818, 0.0098812263458967209, 0.020259490236639977, 0.012227088212966919, 0.014601645991206169, 0.010192820802330971, 0.004460108932107687, 0.0075753531418740749, 0.011628758162260056, 0.0083634955808520317, 0.014809758402407169, 0.01600409671664238, 0.0050436356104910374, 0.019359372556209564, 0.010193483904004097, 0.012002657167613506, 0.0036116261035203934, 0.0085171163082122803, 0.095968171954154968, 0.0060456562787294388, 0.011191350407898426, 0.0072227185592055321, 0.014929024502635002, 0.0081316754221916199, 0.0088187465444207191, 0.01643327996134758, 0.0028533439617604017, 0.024302957579493523, 0.0070945080369710922, 0.0095376968383789062, 0.015903493389487267, 0.0037875850684940815, 0.010211753658950329, 0.0048658582381904125, 0.028779363259673119, 0.0089350407943129539, 0.010800118558108807, 0.0063683702610433102, 0.0073346677236258984, 0.014472468756139278, 0.0063529028557240963, 0.012640361674129963, 0.0091570671647787094, 0.023369146510958672, 0.013605671934783459, 0.0096448455005884171, 0.0066280057653784752, 0.012574912048876286, 0.013486705720424652, 0.012028943747282028, 0.0083522293716669083, 0.020526308566331863, 0.021397385746240616, 0.014508052729070187, 0.013159768655896187, 0.012759734876453876, 0.0069763553328812122, 0.0053831660188734531, 0.013046193867921829, 0.021835699677467346, 0.0054070418700575829, 0.0060657020658254623, 0.011494789272546768, 0.017533795908093452, 0.005382823757827282, 0.014209453016519547, 0.024397311732172966, 0.0081543652340769768, 0.007358125876635313, 0.0098389238119125366, 0.0032751623075455427, 0.0073244315572082996, 0.0056826621294021606, 0.0074147381819784641, 0.0032406256068497896, 0.014012591913342476, 0.00481044827029109, 0.014694925397634506, 0.0047791153192520142, 0.016444476321339607, 0.0064308927394449711, 0.010599547997117043, 0.0047580543905496597, 0.010441036894917488, 0.0045043560676276684, 0.011146429926156998, 0.014806924387812614, 0.0079082110896706581, 0.0030801179818809032, 0.013991327956318855, } };
const TfArray<96, int> quant86_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant86 = { (TfLiteFloatArray*)&quant86_scale, (TfLiteIntArray*)&quant86_zero, 3 };
const ALIGN(8) int32_t tensor_data87[16] = { -26208, -5563, 2867, -13662, 13210, -13455, 23960, -8612, 12507, -9399, 11978, 11864, -3599, -29864, 1166, 3526, };
const TfArray<1, int> tensor_dimension87 = { 1, { 16 } };
const TfArray<16, float> quant87_scale = { 16, { 8.092474308796227e-05, 5.9346049965824932e-05, 6.1735918279737234e-05, 6.1582220951095223e-05, 9.2716625658795238e-05, 0.00013903540093451738, 5.3154421038925648e-05, 5.8513804106041789e-05, 0.0001089422294171527, 9.9153650808148086e-05, 0.0001030456623993814, 7.796908903401345e-05, 8.4733466792386025e-05, 8.779532799962908e-05, 7.517747872043401e-05, 7.1687398303765804e-05, } };
const TfArray<16, int> quant87_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant87 = { (TfLiteFloatArray*)&quant87_scale, (TfLiteIntArray*)&quant87_zero, 0 };
const ALIGN(8) int8_t tensor_data88[1*3*3*96] = { 
  /* [0][0][][] */ 26,127,-5,16,-31,4,40,43,58,-73,-79,33,-13,-9,31,-46,-85,18,17,23,40,67,71,92,13,-6,-48,1,-11,16,16,-20,-50,3,-33,93,-3,43,4,-6,25,-37,-5,32,-95,-46,11,-33,-20,-92,-29,-2,17,54,-22,-9,-76,-65,-59,-127,-127,1,-88,0,-29,42,35,-22,-19,40,33,-9,-34,8,42,-3,2,-35,-83,23,2,-86,52,-29,-86,-47,-11,10,-107,14,-73,37,70,-8,64,2, -41,-37,-3,86,-9,92,-25,-4,62,23,-127,62,-29,-64,-87,127,-103,65,47,76,127,15,101,127,26,19,18,49,3,127,-12,-127,71,81,4,41,73,99,-24,-127,127,-8,91,127,-52,-84,127,-78,-11,-119,-105,-27,15,127,-27,-127,2,28,-127,-78,-49,-127,-43,95,-35,86,111,-34,6,127,127,-5,-76,27,-35,-101,28,-53,-21,127,-7,-64,127,-67,-127,-44,97,53,98,98,-81,2,127,-29,127,34, 17,-108,0,6,-16,-13,-14,46,28,63,-61,13,-10,43,9,-73,-28,14,7,16,37,51,53,94,16,-26,27,43,5,19,-11,-57,-44,-80,-34,60,-1,-6,15,14,-8,31,-17,56,-32,-24,1,-3,24,-69,15,11,4,-13,12,-2,47,-79,-20,-74,-87,24,-66,-9,38,13,-50,-14,-21,-9,7,9,-16,-39,-9,8,6,-11,-81,-1,3,-101,31,-11,-16,-34,-2,-23,-84,0,-16,33,18,36,21,-9, 
  /* [0][1][][] */ 94,-7,61,115,4,-50,127,41,-31,-127,-100,127,-1,-127,-52,30,-68,-49,71,22,-107,3,-127,-74,-16,54,-127,127,-80,83,127,77,24,58,10,127,-127,63,-17,-59,57,-127,22,68,-127,-71,4,-127,-112,-112,-127,17,127,-62,83,-22,-127,-3,-66,1,-62,-64,-36,50,-98,-21,93,-100,-40,33,-41,-127,-127,66,127,-83,96,67,-96,-47,127,-127,-30,108,-42,-15,5,77,-3,26,-61,27,-10,-81,81,-14, -127,4,-50,127,-82,-127,-118,-127,67,0,-61,39,-93,-126,-43,104,-127,-127,127,127,32,-127,-113,98,-127,127,11,66,-81,-37,-107,82,-127,85,127,-35,29,127,127,-93,-43,28,24,35,-45,-127,-74,-112,-7,-127,-110,127,36,84,62,-78,18,20,92,-27,-37,-41,-127,127,-12,-127,127,127,24,72,-94,-77,-26,55,-108,-127,127,127,91,-48,-80,5,-96,65,-108,-99,127,127,127,127,-127,-127,-96,-55,94,127, 54,-9,97,65,5,-25,5,30,-46,109,-72,69,8,-11,-127,68,18,-36,21,-3,-110,7,-84,-76,-6,18,125,-10,127,114,14,-111,-29,-127,-16,117,-120,1,-30,-44,-13,101,22,108,-18,-21,-7,-82,127,-97,-88,-2,58,-91,-127,26,96,-4,-123,66,-18,-41,2,52,127,-44,-29,-17,-51,-4,-36,-44,-125,-127,-6,-43,-7,-24,-127,-44,-69,-126,-19,127,-123,12,-3,-7,-29,-10,-3,42,-20,127,23,-14, 
  /* [0][2][][] */ 30,-127,35,-13,11,19,29,51,-39,-46,10,-32,15,-6,4,32,-14,20,-7,35,-6,46,8,-34,17,44,-7,-3,-22,20,3,24,-27,-17,-27,-3,43,-6,4,-30,-2,15,-14,-37,-16,-32,-14,-9,-14,26,-30,29,-13,-4,-36,-16,-8,-4,1,31,-45,-3,36,-8,-29,45,-54,-31,26,4,13,83,-17,15,19,8,-40,-32,-10,-3,10,-20,-16,-41,-86,32,-29,-15,-76,38,3,23,-14,1,6,-15, -52,14,127,-4,127,71,-31,10,-127,12,-69,-39,127,-19,-54,26,14,53,-6,-54,18,14,53,-4,63,-50,-9,33,-14,115,-15,21,-89,26,10,-37,67,39,23,-106,-24,-2,-127,8,-9,-9,-38,-58,-6,-61,-52,88,98,-69,-36,-77,-16,127,-39,12,69,-107,76,71,-24,22,-47,7,127,-14,9,101,-82,17,-21,-54,-12,-76,-38,-41,-9,-69,-29,-70,-88,127,32,-2,90,37,38,25,-32,-13,-6,-3, 10,97,27,-26,3,-5,-17,40,5,63,25,2,4,4,-2,38,-19,7,-4,30,-17,37,-4,-34,8,36,12,28,10,28,-23,-74,-49,-22,-19,-21,34,-30,1,-11,-6,-8,6,3,-29,-16,-15,-1,19,30,-21,10,-16,-16,8,6,8,8,7,62,-40,14,24,-16,34,11,-74,11,19,-1,8,81,24,-16,-6,7,-17,-11,-3,1,-5,-60,-13,-14,-61,25,-28,-25,-74,36,16,19,-20,9,-8,-15, 
};
const TfArray<4, int> tensor_dimension88 = { 4, { 1,3,3,96 } };
const TfArray<96, float> quant88_scale = { 96, { 0.011656709015369415, 0.0079816514626145363, 0.005816715769469738, 0.0076501858420670033, 0.011933584697544575, 0.01409101951867342, 0.014010652899742126, 0.0091475369408726692, 0.010870584286749363, 0.0074028177186846733, 0.004477775190025568, 0.015783883631229401, 0.012390987016260624, 0.0052837333641946316, 0.0055395117960870266, 0.0064718774519860744, 0.0049036894924938679, 0.010684960521757603, 0.0083673875778913498, 0.0055242744274437428, 0.0080286320298910141, 0.013198718428611755, 0.0096941031515598297, 0.0089655648916959763, 0.033377654850482941, 0.0091840056702494621, 0.012302077375352383, 0.0056722261942923069, 0.009272988885641098, 0.0033783616963773966, 0.014816994778811932, 0.009904070757329464, 0.0064202812500298023, 0.0087333777919411659, 0.013334720395505428, 0.015819745138287544, 0.0086279623210430145, 0.014366889372467995, 0.014016501605510712, 0.0053544780239462852, 0.0090976860374212265, 0.0111375842243433, 0.010577308014035225, 0.0049286982975900173, 0.0043206033296883106, 0.0043523632921278477, 0.010290833190083504, 0.0049067204818129539, 0.0097199026495218277, 0.0039262338541448116, 0.004478835966438055, 0.0057969461195170879, 0.0089329537004232407, 0.0070987865328788757, 0.010204740799963474, 0.0058494722470641136, 0.0091586718335747719, 0.0099565768614411354, 0.0067949844524264336, 0.0061689708381891251, 0.0063844360411167145, 0.0079396003857254982, 0.0067767566069960594, 0.0049417619593441486, 0.0089164674282073975, 0.01104497816413641, 0.013508518226444721, 0.0095950784161686897, 0.010394370183348656, 0.0081540215760469437, 0.011880679987370968, 0.0074425586499273777, 0.0050302860327064991, 0.01067289337515831, 0.013351485133171082, 0.0048207207582890987, 0.0071979090571403503, 0.0099426060914993286, 0.0057048220187425613, 0.010212473571300507, 0.012052165344357491, 0.0040941154584288597, 0.012150813825428486, 0.0085675474256277084, 0.0027310780715197325, 0.0095021165907382965, 0.0064465985633432865, 0.011735100299119949, 0.011597840115427971, 0.0095514608547091484, 0.0046171899884939194, 0.018177475780248642, 0.0099721075966954231, 0.012632398866117001, 0.0063444133847951889, 0.016313543543219566, } };
const TfArray<96, int> quant88_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant88 = { (TfLiteFloatArray*)&quant88_scale, (TfLiteIntArray*)&quant88_zero, 3 };
const ALIGN(8) int32_t tensor_data89[16] = { 10365, 14961, -4127, 3109, -432, 7424, -449, 4136, 16364, -4312, -10112, 9700, -14780, 11820, 5315, 6769, };
const TfArray<1, int> tensor_dimension89 = { 1, { 16 } };
const TfArray<16, float> quant89_scale = { 16, { 5.4504886065842584e-05, 6.7394576035439968e-05, 5.6531484005972743e-05, 6.614234735025093e-05, 7.5199197453912348e-05, 6.8829525844193995e-05, 5.2184630476403981e-05, 5.4581305448664352e-05, 9.5784489531069994e-05, 7.4257513915654272e-05, 5.5327662266790867e-05, 5.3649979236070067e-05, 6.8850698880851269e-05, 6.339002720778808e-05, 8.1242607848253101e-05, 6.7547785874921829e-05, } };
const TfArray<16, int> quant89_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant89 = { (TfLiteFloatArray*)&quant89_scale, (TfLiteIntArray*)&quant89_zero, 0 };
const ALIGN(8) int8_t tensor_data90[1*3*3*96] = { 
  /* [0][0][][] */ 37,-117,67,-86,-100,71,61,88,88,79,-72,80,-109,127,-73,77,105,-96,82,-103,-76,44,-79,88,78,-108,74,74,74,92,103,-106,-112,116,-89,-127,67,-75,-76,91,-63,86,93,80,-75,94,90,71,89,-110,74,86,127,89,72,-35,104,-99,60,86,71,-92,62,-120,97,70,-74,71,-60,98,-60,84,79,87,-93,-48,-95,102,-91,109,89,-107,73,71,-101,-103,95,123,-50,-77,-71,-114,64,75,-100,116, 101,-126,88,-98,-110,101,50,108,94,102,-94,92,-127,-68,-68,90,127,-119,100,-123,-106,118,-97,97,104,-124,95,97,99,105,105,-124,-127,-59,-98,-119,89,-99,-97,109,-85,96,101,108,-103,114,110,87,103,-127,86,106,-90,112,98,-61,116,-127,88,105,88,-127,76,-121,127,98,-91,101,-88,98,-67,106,90,102,-120,-55,-113,109,-111,127,127,-119,90,91,-120,-127,126,127,-78,-87,-103,32,82,107,-113,115, 52,-45,41,-39,-37,36,22,48,35,35,-43,32,-70,-99,-38,32,34,-57,32,-66,-36,62,-39,36,40,-56,29,38,37,42,31,-55,-82,-63,-75,-75,43,-40,-40,49,-10,44,37,36,-39,42,55,37,36,-61,31,51,-62,43,37,-33,33,-49,43,40,26,-45,38,-39,66,51,-34,44,-30,30,-42,45,25,44,-44,-14,-51,30,-44,51,50,-54,28,34,-47,-41,47,36,-38,-20,-43,44,23,56,-51,47, 
  /* [0][1][][] */ 51,-120,95,-94,-110,100,-80,104,114,99,-104,111,56,111,-116,102,111,-110,110,-113,-84,56,-107,106,107,-103,96,101,95,105,109,-118,-114,127,-115,-124,99,-100,-103,103,79,107,116,100,-96,110,107,103,103,-103,105,94,126,102,99,-88,111,-108,88,101,99,-107,109,-118,-60,91,-98,93,-85,113,-111,106,115,111,-101,-106,-101,121,-112,4,-67,-106,97,108,-102,-100,89,124,-82,-108,-84,-127,107,89,-123,13, 127,-127,127,-127,-127,127,-127,127,127,127,-127,127,65,-57,-127,127,122,-127,127,-127,-127,127,-127,127,127,-127,127,127,127,127,127,-127,-111,-90,-127,-122,127,-127,-127,127,97,127,127,127,-127,127,127,127,127,-111,127,127,-85,127,127,-127,127,-126,127,127,127,-114,127,-127,-79,127,-127,127,-127,127,-127,127,127,127,-127,-127,-127,127,-127,-19,-87,-127,127,127,-127,-114,127,126,-127,-127,-127,58,127,127,-127,-27, 61,-60,56,-68,-51,44,-55,55,46,44,-66,52,32,-60,-80,45,40,-69,52,-69,-46,66,-32,39,53,-59,43,56,45,58,39,-62,-76,-73,-79,-80,52,-63,-53,53,45,54,52,47,-47,42,53,57,53,-57,48,65,-45,47,43,-54,38,-51,58,51,54,-69,54,-41,-36,65,-65,52,-46,44,-84,54,41,49,-52,-42,-73,46,-72,-11,-43,-52,44,50,-66,-39,49,48,-55,-48,-66,66,38,71,-64,-5, 
  /* [0][2][][] */ 13,-49,40,-48,-28,28,-79,53,50,40,-45,39,89,84,-39,35,31,-63,52,-33,-27,17,-34,36,45,-50,21,44,28,37,29,-52,-46,62,-54,-39,37,-51,-44,35,102,32,32,38,-26,28,32,46,44,-30,40,30,93,47,37,-41,33,-45,32,35,44,-65,81,-60,-42,45,-55,38,-34,32,-87,43,57,55,-38,-69,-50,39,-48,-78,-34,-38,32,56,-53,-34,21,35,-42,-43,-17,-65,58,38,-56,-72, 46,-54,52,-78,-41,37,-113,63,57,50,-60,50,109,-66,-41,45,30,-73,55,-40,-50,47,-43,42,51,-64,27,57,40,50,34,-45,-42,-47,-76,-53,48,-71,-68,45,127,38,34,48,-41,33,48,58,56,-22,49,43,-77,53,48,-58,33,-51,54,43,61,-76,89,-76,-46,61,-79,57,-46,38,-94,53,67,65,-63,-81,-65,47,-65,-114,-47,-43,48,70,-66,-54,19,42,-61,-59,-39,31,64,61,-55,-127, 26,-13,21,-37,-16,15,-59,35,13,23,-29,18,47,-57,-13,19,14,-39,31,-6,-27,29,-12,4,20,-7,5,31,10,20,17,-15,-15,-48,-25,-26,14,-33,-27,20,69,19,8,20,-19,13,22,28,23,-9,19,18,-39,21,12,-15,7,-1,21,12,26,-34,48,-21,-27,39,-27,27,-14,14,-58,28,24,28,-18,-35,-15,25,-35,-48,-13,-1,21,27,-32,-8,17,13,-26,-30,-23,58,23,26,-28,-65, 
};
const TfArray<4, int> tensor_dimension90 = { 4, { 1,3,3,96 } };
const TfArray<96, float> quant90_scale = { 96, { 0.0036387247964739799, 0.003223351901397109, 0.0028498326428234577, 0.0037356514949351549, 0.0029903131071478128, 0.0042231213301420212, 0.0029325527139008045, 0.0033538008574396372, 0.0066355573944747448, 0.0039868094027042389, 0.0029617988038808107, 0.0043104300275444984, 0.0051465481519699097, 0.0035797201562672853, 0.0035422137007117271, 0.0031966941896826029, 0.0032856536563485861, 0.0030605087522417307, 0.0041334130801260471, 0.0030243746004998684, 0.0024990551173686981, 0.0035701277665793896, 0.0029537728987634182, 0.0029725951608270407, 0.0041598700918257236, 0.0035755718126893044, 0.0035206517204642296, 0.0030278854537755251, 0.0028322383295744658, 0.0023926063440740108, 0.002490141661837697, 0.0028250229079276323, 0.0028608138673007488, 0.0051201218739151955, 0.003175308695062995, 0.0029430773574858904, 0.003901611315086484, 0.0034545236267149448, 0.0031370348297059536, 0.0058567039668560028, 0.0033558735158294439, 0.0025314926169812679, 0.0029351215343922377, 0.0030639206524938345, 0.0031973898876458406, 0.0029374724254012108, 0.0031261001713573933, 0.0035347386728972197, 0.013653844594955444, 0.0028707594610750675, 0.0038962529506534338, 0.0082618920132517815, 0.0057469210587441921, 0.0034478050656616688, 0.0028633610345423222, 0.0028887295629829168, 0.0033581799361854792, 0.0030946002807468176, 0.0039016245864331722, 0.0042651849798858166, 0.0032945824787020683, 0.0029191605281084776, 0.0028343237936496735, 0.0032297405414283276, 0.0062177381478250027, 0.0026677972637116909, 0.0030467042233794928, 0.0027688043192028999, 0.0026189836207777262, 0.0031630038283765316, 0.0021758172661066055, 0.0027432218194007874, 0.0027966639026999474, 0.0052126487717032433, 0.0034268228337168694, 0.0041933064348995686, 0.0021062721498310566, 0.0074043809436261654, 0.0028312145732343197, 0.004224210511893034, 0.0099496012553572655, 0.0022426338400691748, 0.0036477968096733093, 0.0055659697391092777, 0.0028463515918701887, 0.0029874758329242468, 0.0025563724339008331, 0.0053856624290347099, 0.0029381050262600183, 0.0030434399377554655, 0.002754830289632082, 0.005959230475127697, 0.0038048762362450361, 0.0064250035211443901, 0.0036462401039898396, 0.0047665154561400414, } };
const TfArray<96, int> quant90_zero = { 96, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant90 = { (TfLiteFloatArray*)&quant90_scale, (TfLiteIntArray*)&quant90_zero, 3 };
const ALIGN(8) int32_t tensor_data91[24] = { 5388, 12237, -14697, -13694, 7927, 5984, -443, 16228, -4803, -16413, -505, 2106, 13754, -8264, -9460, -12788, 17468, 27212, -110, 2161, 56392, -33912, 986, -19103, };
const TfArray<1, int> tensor_dimension91 = { 1, { 24 } };
const TfArray<24, float> quant91_scale = { 24, { 0.00014925259165465832, 0.00011326926323818043, 7.3123745096381754e-05, 0.0001100330482586287, 0.00013322285667527467, 0.00011148322664666921, 9.686708654044196e-05, 9.0014946181327105e-05, 0.00013232771016191691, 0.00012339920795056969, 0.00010915562597801909, 0.00010993168689310551, 8.946464367909357e-05, 0.00012056684499839321, 9.496886923443526e-05, 9.6934301836881787e-05, 9.2714151833206415e-05, 0.00015027837071102113, 0.00015905260806903243, 0.00013859826140105724, 0.00010588511941023171, 0.00015144309145398438, 0.00010374156408943236, 0.00014112287317402661, } };
const TfArray<24, int> quant91_zero = { 24, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant91 = { (TfLiteFloatArray*)&quant91_scale, (TfLiteIntArray*)&quant91_zero, 0 };
const ALIGN(8) int8_t tensor_data92[1*3*3*144] = { 
  /* [0][0][][] */ -47,-34,-20,44,4,31,13,-39,6,-45,1,16,-11,-13,-13,-8,-32,-4,6,-6,-5,-37,-30,-16,44,0,48,4,-8,20,-17,-13,-21,8,-127,6,-56,-52,17,8,-3,-11,-2,-66,-5,-44,-8,-24,6,2,-24,-26,-12,-41,22,-12,30,-30,-4,-72,2,24,-79,10,10,-57,-10,38,15,2,9,-14,-65,-42,23,-6,-29,-19,12,-4,11,-8,-37,23,-16,-31,-10,-14,-11,-15,-1,22,-21,-96,23,-123,0,52,-32,-16,-34,43,0,-3,16,49,-16,25,-28,-15,66,37,-35,-8,38,-6,-29,43,-127,2,-12,-10,17,7,-58,30,16,-18,-18,6,-6,-4,40,-11,-7,10,-20,4,7,0,-37,20,-11,0, -77,-10,-87,-27,127,127,73,-71,-11,-30,11,-27,-63,-127,-21,-37,-75,36,127,-9,-9,-125,-44,-24,32,5,49,5,-16,127,-55,10,-81,13,54,16,-127,-111,-2,17,-127,127,23,-31,-1,-69,19,-50,127,10,-127,-63,8,11,127,-9,127,23,29,-82,36,-24,-102,-15,-10,-127,7,127,-52,-62,-41,8,-67,-66,95,127,-54,-13,15,19,-55,12,-63,118,-30,-97,16,-21,38,-127,93,127,50,-102,7,-77,-11,-90,-69,-6,-53,73,-11,17,-13,-47,-7,17,-73,45,103,-49,-100,-127,-123,-127,-82,62,-64,95,-15,11,49,22,32,-31,-23,-127,-9,-6,-63,-20,0,26,-94,17,-20,127,-54,127,-127,48,-127,21, -48,-43,-27,39,4,36,-6,-33,8,-46,1,8,37,-9,-8,-2,-19,-8,-1,-12,-4,-20,-31,-16,36,8,24,-19,-3,12,-28,-4,-15,8,78,9,-31,-50,16,10,-3,-9,-5,-59,-9,-13,-2,-14,19,5,9,-13,-11,-43,26,-15,16,-16,-8,-46,-8,0,-72,14,-13,-70,-16,28,13,-2,31,-19,-73,-31,22,-14,-30,-20,13,-7,9,-11,-2,21,-11,-26,-14,0,-16,-15,-7,29,-21,-112,11,-125,11,53,-37,-23,-29,56,0,-7,-2,16,21,28,-6,-15,57,-19,-33,-1,12,13,-21,37,-123,4,25,-66,8,1,34,3,21,-13,-14,4,-24,19,52,-19,-11,23,-24,8,10,-10,-6,20,-11,-1, 
  /* [0][1][][] */ -59,-94,-10,25,-2,-24,14,-87,127,-71,39,127,-117,-124,37,-126,-104,45,23,2,2,-127,13,-25,46,15,25,127,-25,18,1,-120,0,14,-47,17,-112,-23,94,38,-5,9,9,36,109,-126,0,-36,-86,30,-102,11,56,-45,48,-10,11,127,8,-127,21,-104,-127,-93,127,0,-3,-40,-22,-45,-89,-13,-74,-7,113,-104,-65,6,30,1,-2,-5,-127,22,-83,-96,27,-107,32,-80,11,57,-52,-65,75,-44,-97,-111,-111,-11,-89,9,-16,-25,127,115,-116,19,-127,36,127,114,26,-2,-54,-23,33,-1,-82,19,-127,49,-1,25,-38,127,16,4,17,13,-72,127,67,16,-127,42,-6,-20,-26,4,31,-118,-101,15, 127,36,-54,-127,-93,-86,127,127,-28,127,127,-38,-61,-14,127,-127,127,127,51,127,127,5,127,127,-127,127,-127,-16,-92,-30,-95,-66,127,127,-45,127,100,-17,-127,-127,108,-89,127,127,23,-25,127,127,-104,-127,-48,127,127,127,-97,127,-81,-80,127,-3,127,-17,17,127,-37,-83,127,-23,-74,127,-43,127,-71,-127,-127,9,127,-127,127,127,-85,127,-28,-127,127,127,127,-127,127,111,75,-93,127,127,-55,-16,-24,-106,59,127,127,-127,127,127,-41,-127,-10,-127,-29,127,-51,-127,65,125,127,-90,-67,-127,107,30,50,-63,127,127,-127,-37,127,29,-127,127,-17,-35,127,127,-62,127,127,-50,-127,-19,63,-37,-44,127, -68,-100,3,38,-9,-19,11,-83,-100,-80,32,-93,127,-117,31,-109,-100,53,14,-8,-10,-89,-11,-15,33,8,8,-104,-24,16,-7,-127,-4,-12,88,14,-114,-19,95,38,-12,7,2,38,-127,-127,-24,-46,-77,38,-75,19,57,-41,45,-18,27,66,-3,-101,25,127,-107,-84,-78,-11,1,-27,-24,-31,127,-34,-127,17,74,-94,-43,-13,22,-3,2,-18,-120,17,-90,-104,23,-91,23,-80,19,64,-97,-51,59,-59,127,-127,-127,-19,-97,3,-24,-25,-87,87,127,16,-94,30,97,12,18,-21,-34,-12,23,-3,-85,19,77,-127,-9,23,57,-94,1,14,25,0,-71,-96,65,7,-97,29,-15,-9,-34,3,19,-127,-75,7, 
  /* [0][2][][] */ -48,-19,50,57,3,-8,4,-10,15,-50,5,37,-1,-7,-21,13,-49,-22,-7,-6,-4,-31,-17,-24,32,15,43,3,38,20,39,-7,11,7,-125,1,-49,63,38,4,-4,18,5,13,2,-9,-17,-37,15,15,-10,-36,3,-8,-23,-10,-29,26,1,-31,-12,5,-42,0,4,-52,-6,14,7,-8,-3,-18,-67,26,33,20,-40,6,22,-4,5,-3,-32,0,-27,-18,-9,-26,-2,-38,-28,84,-31,-56,56,-125,-7,43,-70,-3,-37,46,-7,-38,24,20,-3,29,-15,6,73,12,43,4,-13,10,12,6,-103,-12,-31,16,3,-8,-4,14,6,2,33,-5,70,17,14,7,-52,5,-32,7,0,-8,4,-12,-11,8, 27,-127,127,62,-39,-83,31,-89,-13,-25,14,-36,-43,-55,14,-73,-111,30,45,4,8,-81,-28,-49,15,2,0,6,127,56,127,-41,-28,7,46,-5,-114,127,4,49,61,-57,11,-19,15,-53,-7,-44,76,36,21,-30,27,62,-109,-9,-66,9,-7,-91,28,-32,-89,11,-9,-38,0,-63,127,16,-23,4,-20,-49,44,88,-97,7,-38,7,127,-11,-118,-16,-91,-101,7,-7,-12,-71,-127,13,56,-42,127,-103,-11,-91,-25,-55,-111,-55,-50,-67,-21,80,-10,25,-53,23,88,-34,127,49,42,-73,127,0,-62,-127,13,-38,5,9,79,-10,-8,97,78,-14,127,-27,5,-29,-49,30,2,-55,-42,-31,77,-112,-84,12, -39,-4,31,54,8,-10,5,-5,-2,-63,-6,-2,21,6,-22,29,-31,-24,13,-19,-3,-22,-24,-18,33,15,22,-14,40,7,45,-2,8,5,79,4,-66,75,35,6,-2,11,1,-6,-13,6,-16,-36,17,20,-18,-21,2,-1,-22,-17,-37,14,0,-27,-19,22,-20,-6,-1,-65,-12,-5,12,-11,16,-26,-66,34,31,15,-39,13,15,-6,7,-7,-18,-4,-33,-36,-19,-9,-8,-32,-40,87,-36,-36,66,-127,20,39,-67,1,-35,45,1,-36,5,9,14,29,4,2,58,8,25,-2,-7,-8,13,-9,-81,-17,14,-66,-8,-8,24,-8,8,3,27,9,62,1,23,17,-65,17,-38,-1,12,-7,-4,-17,-11,7, 
};
const TfArray<4, int> tensor_dimension92 = { 4, { 1,3,3,144 } };
const TfArray<144, float> quant92_scale = { 144, { 0.0076275365427136421, 0.0057646785862743855, 0.010041016153991222, 0.0089006433263421059, 0.014716269448399544, 0.0089386804029345512, 0.0076110260561108589, 0.0063088797032833099, 0.01453348807990551, 0.007379499264061451, 0.0088424747809767723, 0.011022401973605156, 0.0073879114352166653, 0.004293947946280241, 0.010867776349186897, 0.0044844048097729683, 0.0058493395335972309, 0.0073360521346330643, 0.0068137990310788155, 0.016039147973060608, 0.015645196661353111, 0.0044139642268419266, 0.012977008707821369, 0.016158789396286011, 0.010648087598383427, 0.0097931176424026489, 0.012432395480573177, 0.0098630804568529129, 0.010177312418818474, 0.0098268501460552216, 0.0081458603963255882, 0.0055370000191032887, 0.011292246170341969, 0.0095948223024606705, 0.006374977994710207, 0.0087039107456803322, 0.004389642272144556, 0.0065957256592810154, 0.0075248130597174168, 0.028210438787937164, 0.0096783339977264404, 0.014442414976656437, 0.0095820240676403046, 0.010491828434169292, 0.010671379044651985, 0.0053849085234105587, 0.016064068302512169, 0.012842600233852863, 0.0085296379402279854, 0.017075905576348305, 0.0056666885502636433, 0.012304197996854782, 0.0075104166753590107, 0.0096510797739028931, 0.0087141580879688263, 0.014965987764298916, 0.0091007156297564507, 0.0091820014640688896, 0.012654383666813374, 0.0043361755087971687, 0.012037632986903191, 0.014231474138796329, 0.0040246997959911823, 0.012008519843220711, 0.01036082673817873, 0.0046965335495769978, 0.014185512438416481, 0.010263982228934765, 0.013885248452425003, 0.017649333924055099, 0.010570740327239037, 0.013680233620107174, 0.0037633341271430254, 0.0080827511847019196, 0.0070800036191940308, 0.0086161969229578972, 0.0060831140726804733, 0.009903494268655777, 0.010797754861414433, 0.011315914802253246, 0.014310187660157681, 0.012250631116330624, 0.0038776933215558529, 0.0098764058202505112, 0.0083773257210850716, 0.0057152044028043747, 0.012030791491270065, 0.004752730019390583, 0.0099512962624430656, 0.011953026056289673, 0.0090191559866070747, 0.00576751958578825, 0.012289403937757015, 0.0046127792447805405, 0.0043968362733721733, 0.0051002884283661842, 0.014798137359321117, 0.0048439339734613895, 0.0047654355876147747, 0.013524548150599003, 0.010236319154500961, 0.011148083955049515, 0.016225438565015793, 0.011386140249669552, 0.011643171310424805, 0.0064218020997941494, 0.011135422624647617, 0.016666978597640991, 0.0056629888713359833, 0.0070825917646288872, 0.003861249890178442, 0.0074411914683878422, 0.0060980138368904591, 0.0099366968497633934, 0.012625045143067837, 0.0064056040719151497, 0.010469476692378521, 0.01215076632797718, 0.0041507696732878685, 0.010982492938637733, 0.011037706397473812, 0.0051424633711576462, 0.0093362312763929367, 0.010080763138830662, 0.01006674487143755, 0.011515935882925987, 0.013082466088235378, 0.010039861313998699, 0.01105879433453083, 0.01605815626680851, 0.0073647908866405487, 0.012029814533889294, 0.0050608739256858826, 0.01097501628100872, 0.0039745792746543884, 0.008382551372051239, 0.013766874559223652, 0.012297127395868301, 0.00653058011084795, 0.013122850097715855, 0.0095064612105488777, 0.0063057052902877331, 0.0048179412260651588, 0.012188256718218327, } };
const TfArray<144, int> quant92_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant92 = { (TfLiteFloatArray*)&quant92_scale, (TfLiteIntArray*)&quant92_zero, 3 };
const ALIGN(8) int32_t tensor_data93[24] = { 12700, -17502, -3297, 3650, -12856, 1517, -6133, 22499, 650, 8992, 7045, -7120, -4326, 16886, 6471, 7553, -25541, -28622, 6612, -3415, 3780, 20632, -21681, -6297, };
const TfArray<1, int> tensor_dimension93 = { 1, { 24 } };
const TfArray<24, float> quant93_scale = { 24, { 6.4181112975347787e-05, 5.067585880169645e-05, 3.7308465834939852e-05, 5.6480574130546302e-05, 4.0723021811572835e-05, 4.8497873649466783e-05, 4.5053478970658034e-05, 7.1677706728223711e-05, 7.8460623626597226e-05, 3.7373596569523215e-05, 3.8602320273639634e-05, 5.3348860092228279e-05, 4.0192666347138584e-05, 7.1246562583837658e-05, 3.9782560634193942e-05, 4.0071550756692886e-05, 3.1894953281152993e-05, 3.9706723327981308e-05, 3.4639913792489097e-05, 6.7752698669210076e-05, 4.2273117287550122e-05, 3.2758158340584487e-05, 3.1166586268227547e-05, 4.109175642952323e-05, } };
const TfArray<24, int> quant93_zero = { 24, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant93 = { (TfLiteFloatArray*)&quant93_scale, (TfLiteIntArray*)&quant93_zero, 0 };
const ALIGN(8) int8_t tensor_data94[1*3*3*144] = { 
  /* [0][0][][] */ -10,-15,13,-18,-1,-21,-56,28,-14,8,-3,5,44,15,12,-20,44,-32,18,-7,-107,5,-4,82,-12,22,-99,1,-5,-16,-111,-20,35,-42,-30,1,6,-21,-73,5,5,-32,-58,5,-1,52,-28,-27,-107,20,-115,-5,-45,-2,0,66,25,82,-14,12,-83,7,-4,29,17,-5,-52,-45,-46,3,16,50,5,-46,27,-60,1,-3,-3,-2,12,7,-5,-27,-13,16,-10,-127,-14,-61,23,-42,127,67,32,-76,-13,13,9,-34,39,15,-52,19,1,-6,59,-26,10,-71,38,-38,-85,22,21,-4,19,3,8,6,22,46,1,-4,-42,-34,-13,-4,14,-10,-31,-109,-11,-19,-95,17,23,-97,-15,27,-5,76,33,34, -127,-25,31,-5,127,115,6,-93,41,5,-19,70,-127,127,36,127,127,-110,31,12,-68,70,127,-18,127,-6,-98,-75,32,127,-95,106,-25,-27,26,-3,24,8,-100,1,20,127,-89,23,-35,80,42,-127,-10,-5,-63,7,-127,-127,127,-14,-47,126,-17,-48,-57,-4,80,59,127,71,-82,-127,-81,10,-42,21,54,-64,87,-127,0,-83,-36,-3,42,27,-29,-5,-24,-87,-115,-18,104,-70,15,127,-76,60,-13,-77,34,-8,1,-122,12,6,-91,-17,9,21,107,-127,-29,46,127,-101,-103,-21,5,2,78,76,98,4,8,-127,24,4,-68,-28,100,51,13,-6,-92,-68,39,-127,25,-110,43,-80,-12,56,-5,-34,-126,-120, 21,28,-68,-28,-2,-24,13,18,-8,-11,-4,13,49,21,18,-24,64,5,20,0,-81,17,-7,78,-16,8,-93,-11,-6,-12,-127,-30,43,-78,0,-5,10,-7,-60,2,6,-30,-59,-1,2,80,-23,-14,-127,19,-122,-3,-63,-4,34,75,-3,95,-17,22,-90,6,-57,23,28,-9,-41,-50,-28,1,32,40,4,-48,30,-77,1,4,-3,3,10,2,19,-33,5,19,4,-93,-21,-66,20,-48,-94,69,-22,-78,-15,0,3,-14,47,-33,-37,19,-2,9,66,-41,0,-51,46,-35,-51,19,22,-2,16,3,6,-2,13,40,-5,3,-40,-28,-13,1,22,-8,61,-110,-15,-16,-88,15,13,-89,32,13,6,-79,36,46, 
  /* [0][1][][] */ -107,-124,57,-22,5,45,-127,-11,39,-127,-25,-3,-79,73,30,40,96,-110,32,8,-71,96,13,74,44,-126,-90,-127,5,42,-110,91,36,-127,-110,-127,-4,-127,-66,5,10,45,-99,12,11,15,127,-56,26,26,-25,16,-49,-28,-53,14,127,36,-26,81,-3,2,127,-6,3,24,-11,51,-37,11,127,62,-31,-7,49,-96,-107,120,-3,47,45,32,-104,-123,-127,-117,-52,-84,2,-60,38,-48,14,-43,90,-119,17,-79,-6,100,27,71,-127,13,25,-127,38,8,127,-49,88,-122,-124,127,16,127,62,-14,29,-105,56,-110,-12,24,23,-12,-2,3,127,-9,-127,-96,42,7,29,-127,43,-40,-127,27,114,121,-35,-106, 46,-3,75,127,-89,49,78,-39,127,35,127,110,-48,-97,127,81,-121,15,127,127,127,127,-82,127,4,-53,-115,-25,127,-43,-61,127,127,-44,127,94,127,121,127,127,127,17,-98,127,-106,-22,51,-123,101,127,48,-127,-93,-71,36,57,-70,-117,-127,127,-86,-127,-36,127,-96,127,127,-37,-127,127,-123,-127,127,127,127,56,-31,53,-80,-127,127,127,-31,127,-117,-127,-69,-70,26,-127,-127,-58,2,23,28,127,127,-54,127,-127,-127,97,-99,-127,127,-117,-127,92,-62,127,2,127,-35,-101,127,-12,127,127,29,-27,127,-100,127,-127,127,-127,38,127,-72,127,-10,32,127,70,127,-8,127,-127,-2,45,14,-19,96,-14, -124,127,-127,-31,7,46,106,-15,25,94,-31,1,-84,57,27,42,113,-111,45,17,-38,80,10,79,39,127,-85,-95,21,35,-96,93,36,14,29,40,0,60,-45,23,19,43,-127,1,9,28,-124,-46,17,23,-77,21,-40,-33,33,28,-53,27,-32,96,2,21,-93,-3,0,8,-37,47,-26,15,116,50,-42,-1,71,-91,127,127,1,51,33,0,-127,41,-124,-101,-67,-52,-12,-22,21,-58,4,-57,-127,-106,17,127,-13,89,12,-127,-95,8,33,-127,44,19,-52,-28,70,-118,-127,-39,-1,-126,59,-38,20,127,50,-126,-59,52,21,-21,-3,12,93,-26,118,-118,44,-1,19,-120,41,-47,126,18,-127,-112,-29,-84, 
  /* [0][2][][] */ -42,-4,26,-21,5,-24,-38,4,-6,7,-32,-35,-13,4,-45,-24,38,-4,5,-1,-117,-36,2,-1,-35,2,23,-32,-10,-20,-73,-38,50,-53,28,-6,-2,-20,-40,14,17,2,-119,-8,-3,-28,-3,-42,-1,12,-127,14,-30,-6,-29,-42,4,104,-68,-21,-124,44,45,35,1,-13,-17,21,5,-2,-5,12,5,-5,39,-34,-17,-8,35,48,25,3,-65,-53,-2,-51,2,-67,7,-38,13,-5,12,65,11,-82,0,-5,2,67,25,14,-33,50,-19,64,14,9,15,4,38,-7,-9,36,10,16,14,-61,-31,12,20,-39,3,34,9,-30,1,-1,7,-18,-51,-127,-17,6,-34,-51,5,-71,-26,-34,10,127,-6,17, 2,-10,12,-26,-22,-127,-15,127,48,-1,-22,-127,-85,-69,-13,34,119,-127,120,28,-78,111,-26,107,-121,-23,-127,-53,14,-83,-51,82,99,-47,-98,-12,-3,-8,-86,75,25,-56,43,-5,127,-127,29,-99,90,26,-62,48,-61,-86,-6,-127,-30,-22,-113,-54,-28,62,-2,-11,-24,27,-5,66,-91,20,-21,-24,65,70,-52,-19,11,-83,127,64,14,46,-117,56,-46,-84,-127,-48,-127,-90,10,53,-7,127,18,-102,22,-24,36,-9,-30,-6,-65,53,25,-3,-66,47,-26,5,53,97,-89,-22,82,-1,1,-106,-127,-15,75,-34,31,10,77,2,127,28,-52,20,-62,19,19,66,55,-53,63,-75,-8,-127,4,-27,127,-127, -48,12,-66,-26,9,-32,9,13,-8,-4,-39,-42,-25,8,-18,-12,60,2,28,3,-102,-27,11,11,-27,29,17,-40,-11,-18,-75,-7,64,-50,-29,6,-3,-15,-28,25,12,5,-108,-8,1,-33,-19,-55,-19,9,-124,20,-32,-21,13,-41,-9,127,-27,-6,-127,39,-73,43,-2,-21,-31,25,24,3,-9,3,1,-10,27,-26,14,-28,23,60,18,7,-73,-9,7,-59,0,-51,20,-44,4,-7,11,69,-43,-74,1,27,4,51,21,-38,-60,50,-22,81,15,12,8,12,27,11,-1,0,4,-11,27,-47,-23,19,33,-35,-12,29,8,-30,-6,12,6,-16,122,-110,-12,8,-37,-32,-4,-84,38,-19,-22,-88,1,16, 
};
const TfArray<4, int> tensor_dimension94 = { 4, { 1,3,3,144 } };
const TfArray<144, float> quant94_scale = { 144, { 0.0053550456650555134, 0.0092154480516910553, 0.009276730939745903, 0.012298231944441795, 0.012941215187311172, 0.009928491897881031, 0.0078917620703577995, 0.011208921670913696, 0.0089548379182815552, 0.012013362720608711, 0.015611978247761726, 0.0093046659603714943, 0.0046153930015861988, 0.0093616461381316185, 0.010522596538066864, 0.006937085185199976, 0.0050189103931188583, 0.0047430251725018024, 0.0053427061066031456, 0.011255598627030849, 0.0042514540255069733, 0.0039460649713873863, 0.014860961586236954, 0.0044015040621161461, 0.0090469187125563622, 0.009619823656976223, 0.0037735449150204659, 0.0054375366307795048, 0.012782749719917774, 0.011506079696118832, 0.0032346118241548538, 0.0048486664891242981, 0.0068017318844795227, 0.0052209766581654549, 0.0097662191838026047, 0.014310847967863083, 0.011718730442225933, 0.0081012304872274399, 0.0065548787824809551, 0.0089034270495176315, 0.0088033713400363922, 0.010739948600530624, 0.0037819067947566509, 0.012462940067052841, 0.01171281561255455, 0.0072558615356683731, 0.0083775930106639862, 0.004491196945309639, 0.0072056036442518234, 0.011403787881135941, 0.0044691711664199829, 0.019577028229832649, 0.0051498073153197765, 0.0060955574735999107, 0.010851537808775902, 0.0080236354842782021, 0.010318399406969547, 0.004839899018406868, 0.0055327895097434521, 0.0073393955826759338, 0.0051219356246292591, 0.012177394703030586, 0.0081824874505400658, 0.0073437169194221497, 0.0091404393315315247, 0.0084425574168562889, 0.010361867025494576, 0.0078754406422376633, 0.0058283125981688499, 0.0095215272158384323, 0.011493978090584278, 0.012731232680380344, 0.010433981195092201, 0.0088699283078312874, 0.0061957458965480328, 0.0055558793246746063, 0.01052442193031311, 0.0076348632574081421, 0.0099080530926585197, 0.0093191796913743019, 0.0082964422181248665, 0.0098738586530089378, 0.0053592659533023834, 0.0098055014386773109, 0.0054642772302031517, 0.0058079496957361698, 0.0052248234860599041, 0.0040855742990970612, 0.012145561166107655, 0.0048782499507069588, 0.016226798295974731, 0.011101821437478065, 0.008946763351559639, 0.0060630827210843563, 0.0093581490218639374, 0.0055869650095701218, 0.015843993052840233, 0.012615427374839783, 0.010271107777953148, 0.0081916097551584244, 0.018736017867922783, 0.0085405977442860603, 0.0043647512793540955, 0.012163499370217323, 0.010849191807210445, 0.0065148444846272469, 0.0074448320083320141, 0.010073794983327389, 0.011845250613987446, 0.010712652467191219, 0.004713735543191433, 0.0074427863582968712, 0.0039367116987705231, 0.01119700726121664, 0.0081820841878652573, 0.010211088694632053, 0.0055675245821475983, 0.0097753526642918587, 0.011425921693444252, 0.01180935837328434, 0.0058201816864311695, 0.0048459791578352451, 0.012870600447058678, 0.020471081137657166, 0.0079672224819660187, 0.0082087069749832153, 0.0069729150272905827, 0.010599768720567226, 0.009206610731780529, 0.014926344156265259, 0.0056125055998563766, 0.0034685572609305382, 0.007824351079761982, 0.010543704032897949, 0.011723442003130913, 0.0052047790959477425, 0.0076808156445622444, 0.0055821086280047894, 0.0086604440584778786, 0.0091127678751945496, 0.011191297322511673, 0.0056896931491792202, 0.0091828275471925735, 0.0071728997863829136, } };
const TfArray<144, int> quant94_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant94 = { (TfLiteFloatArray*)&quant94_scale, (TfLiteIntArray*)&quant94_zero, 3 };
const ALIGN(8) int32_t tensor_data95[24] = { 7852, -6585, 6282, 2715, -3092, 18626, -3190, 7503, -6381, 7482, 22177, 532, -3580, 15723, 8602, -14687, -7794, -4067, -24159, -16327, 8135, -7056, 3581, -25, };
const TfArray<1, int> tensor_dimension95 = { 1, { 24 } };
const TfArray<24, float> quant95_scale = { 24, { 3.3481144782854244e-05, 3.6237248423276469e-05, 3.5410874261287972e-05, 3.9797487261239439e-05, 4.9193356971954927e-05, 3.6796616768697277e-05, 2.8797379854950123e-05, 4.666956010623835e-05, 4.4285905460128561e-05, 3.2973501220112666e-05, 4.0746595914242789e-05, 4.6222361561376601e-05, 3.4616339689819142e-05, 3.8481073715956882e-05, 3.23319218296092e-05, 3.9207247027661651e-05, 2.9924391128588468e-05, 3.3878368412842974e-05, 3.1590392609359697e-05, 4.3306466977810487e-05, 4.9538775783730671e-05, 3.3925538446055725e-05, 3.6420566175365821e-05, 3.5265395126771182e-05, } };
const TfArray<24, int> quant95_zero = { 24, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant95 = { (TfLiteFloatArray*)&quant95_scale, (TfLiteIntArray*)&quant95_zero, 0 };
const ALIGN(8) int8_t tensor_data96[1*3*3*144] = { 
  /* [0][0][][] */ -127,-6,-2,11,-3,-11,24,15,17,-127,-65,-56,41,-27,-56,34,-127,13,55,-2,-43,1,-101,-109,46,51,18,-108,1,-78,62,6,23,-45,-113,-3,-30,-49,-127,-42,21,-79,-70,-127,16,22,19,-19,19,45,86,-44,-3,34,-55,-34,-36,-10,-79,-14,-2,-46,-105,-86,-13,-33,-20,-41,-7,23,17,0,-47,18,-23,-120,-9,5,-6,-22,-4,4,1,21,12,-39,-1,-19,-8,70,-37,-33,-36,-6,-7,-12,21,30,3,-63,-66,74,17,-37,14,16,-1,-9,-66,4,13,63,-30,39,-69,5,-36,27,1,6,9,3,-19,-41,-32,18,9,7,22,-14,8,-7,-127,-55,4,-118,-37,16,6,5,-48,-35,31,111, -13,127,39,-42,-127,-84,-90,127,-88,-106,39,-22,127,-7,-70,-127,-38,93,-28,127,6,-127,-105,-74,74,24,21,-84,19,-127,20,-44,1,-74,-61,-79,28,-39,-57,-100,-127,-23,2,-126,17,36,-78,107,4,14,124,-83,-27,20,-84,68,-97,-15,-31,79,-10,-7,-113,-79,10,-90,24,-89,116,120,-106,-9,-74,7,-41,-46,-65,80,59,98,-127,27,-1,15,56,50,127,25,-15,127,-27,24,9,67,127,-42,8,-36,47,-127,-127,127,-88,95,45,9,-14,127,-30,11,106,55,-44,-20,-33,-13,-14,-1,127,10,35,120,19,-46,-50,52,-127,-40,-127,-102,-9,6,-5,-127,127,-73,-89,22,23,3,-127,52,127,-127, -115,-7,7,17,-4,-34,1,14,2,-126,-64,-56,28,-22,-54,37,-110,1,48,-7,-10,3,-103,-88,45,37,11,-89,1,-49,59,9,21,-47,-104,0,-4,-56,-102,-43,23,-81,30,-110,11,27,-28,7,19,37,99,-41,1,33,70,-36,-54,4,-92,-19,-1,-36,-97,-92,-12,-34,-41,-29,-10,24,6,-2,-26,26,-19,-122,-4,13,-12,-24,-13,9,4,17,5,-127,6,-10,-6,68,55,-18,-6,2,-3,-13,32,7,20,-58,-72,83,19,-32,18,11,-13,1,-70,7,-7,32,-17,55,-45,4,46,30,-6,1,15,25,-9,-56,-48,17,-21,16,20,-12,4,-4,-117,-42,3,-89,-23,12,7,0,-52,-37,38,94, 
  /* [0][1][][] */ -101,-2,114,54,-3,-60,-127,61,127,-117,-107,-32,76,-35,-65,19,-42,9,127,25,-127,-6,-52,-72,34,46,13,-119,16,-108,36,-3,47,-112,6,127,-127,-6,-117,-127,-71,47,-127,-116,14,5,127,127,65,127,125,6,1,-81,-31,127,18,13,-111,21,-18,-59,-112,-117,6,-100,102,-105,-80,118,-92,115,-28,-8,-127,-75,-15,38,60,54,21,15,61,34,30,89,2,59,39,112,-57,43,-127,127,-36,72,47,-62,-75,-104,-34,74,65,127,34,3,-27,-2,-50,-17,80,84,-38,82,-105,26,-127,-23,83,3,39,110,49,-48,-74,35,22,36,48,-96,127,-28,-54,-46,51,-71,-58,24,1,24,-63,9,27,-98, -24,-38,37,-127,97,-127,-115,-66,-16,98,110,-127,-90,127,-127,86,13,57,-124,83,93,88,-49,-127,-127,-127,127,-71,127,-52,-127,-57,127,125,127,-89,-10,127,-30,45,-102,-127,36,-55,127,127,-25,55,-45,-114,-127,127,127,-11,-48,39,-55,127,-82,127,127,127,47,-126,127,41,126,122,-35,-127,-127,-76,127,127,-57,-35,-51,127,27,127,24,127,127,127,127,114,-34,88,-127,36,-51,83,85,-66,-126,127,-102,-70,127,29,-86,-108,-10,82,127,127,127,30,-127,127,127,127,127,-127,127,127,6,127,97,127,127,-4,127,127,127,127,-75,127,25,127,-32,127,-53,-74,90,105,127,127,127,127,92,92,-16,-84, -84,-2,127,88,-5,-87,-96,80,92,-88,-127,-36,74,-33,-62,4,-39,22,114,14,84,-5,-42,-50,18,31,9,-127,18,-121,65,-3,78,-127,9,103,120,-21,-117,-54,-70,61,97,-73,-9,11,70,125,55,25,103,-40,5,-42,127,80,-127,-6,-53,29,-6,-69,-83,-127,10,-90,105,-84,-80,77,-91,127,-58,9,-92,-104,-17,26,87,63,25,4,51,46,16,-127,-4,55,37,70,100,43,38,109,-36,77,63,127,-82,-83,-23,92,52,81,32,1,-37,-17,-82,-23,63,83,-84,73,-81,27,95,-28,65,4,52,71,47,-82,-62,49,-3,5,38,-108,-100,-24,-47,-37,52,-54,-69,-2,-3,36,-62,20,14,-71, 
  /* [0][2][][] */ -48,-4,-25,18,15,-14,40,28,0,-107,-62,-11,24,-33,-8,31,-93,-35,20,41,-107,4,-90,-88,31,20,-2,47,-10,-73,47,36,30,-62,-13,32,-9,23,-83,-30,-12,-40,-53,-74,15,-14,21,-30,59,32,81,-21,-55,-127,-26,20,9,-1,-110,26,-6,-25,-127,-104,-15,-26,-44,-10,-8,45,-48,8,-33,-31,-36,-127,11,-12,-1,1,-6,-2,-21,31,25,-20,-3,-32,21,73,83,24,-64,13,9,48,24,10,-12,-52,-4,108,-17,51,31,7,-12,7,-69,4,-18,44,-23,104,-43,11,-24,-37,1,-2,-70,51,-5,-47,3,-1,20,-14,27,8,-13,4,-31,62,-4,-127,-10,-21,-29,-5,-28,-14,11,-35, -24,-25,63,-47,27,-62,-111,89,67,-76,104,-33,-4,-31,-17,59,-99,-127,11,-42,19,52,-127,-27,25,-17,22,-33,35,-126,-3,127,4,-101,-24,-3,14,61,-27,-95,-73,-113,11,-31,21,-102,-98,108,127,-16,-4,12,-61,-102,-77,-11,-41,13,-55,11,19,-113,-78,-85,-4,-127,127,-127,127,3,-46,-14,-49,-2,-40,-118,127,18,127,37,95,54,22,22,-11,32,-23,127,58,117,39,127,16,-20,-9,20,127,-28,47,-40,-35,48,127,88,52,21,-46,61,-8,-1,52,57,-20,28,12,60,-26,-126,95,3,21,127,4,3,-120,35,-97,109,59,-87,-7,-39,-49,-54,16,-28,-65,12,-40,28,-44,-127,23,-59, -63,-10,-20,19,13,-34,30,34,1,-98,-60,-27,19,-36,-5,12,-90,-40,39,47,-7,8,-88,-73,12,16,-10,66,-12,-50,59,39,32,-49,4,26,13,17,-61,-40,-23,-44,21,-63,19,-12,-47,-21,69,36,96,-38,-62,-117,66,5,-94,5,-127,3,-2,-11,-90,-98,-11,-7,-32,-8,-14,23,-50,11,-25,-25,-25,-82,7,4,3,4,1,9,-5,30,20,-105,-7,-32,22,68,-127,20,35,16,7,56,24,9,3,-30,-40,90,-6,52,27,8,-27,7,-52,4,-21,37,-11,112,-39,10,47,-36,-7,-10,-55,14,-7,-63,4,-12,0,-12,29,4,3,4,-21,69,-2,-101,-1,-13,-33,7,-30,-19,5,-30, 
};
const TfArray<4, int> tensor_dimension96 = { 4, { 1,3,3,144 } };
const TfArray<144, float> quant96_scale = { 144, { 0.005097951740026474, 0.012375530786812305, 0.0067489086650311947, 0.01227151695638895, 0.012875914573669434, 0.0048210443928837776, 0.0055727623403072357, 0.0056132543832063675, 0.0075362958014011383, 0.0035506391432136297, 0.0078404014930129051, 0.0057585216127336025, 0.0070358878001570702, 0.012568728998303413, 0.0056101884692907333, 0.0092721264809370041, 0.0043207034468650818, 0.0098349777981638908, 0.0073877759277820587, 0.0093976818025112152, 0.0071666520088911057, 0.011071390472352505, 0.0034448506776243448, 0.0036698398180305958, 0.0087144896388053894, 0.013921839185059071, 0.016610424965620041, 0.0047980360686779022, 0.012618361972272396, 0.0032197718974202871, 0.0087560256943106651, 0.01281997375190258, 0.0072235534898936749, 0.0048656519502401352, 0.0081487400457262993, 0.010452443733811378, 0.0087823597714304924, 0.0094663631170988083, 0.0038614312652498484, 0.005448206327855587, 0.0055835973471403122, 0.0057174242101609707, 0.0072424355894327164, 0.0033085229806602001, 0.010439541190862656, 0.0099885175004601479, 0.0084587922319769859, 0.0054450840689241886, 0.0071982257068157196, 0.0093467524275183678, 0.0045366850681602955, 0.010454685427248478, 0.010800227522850037, 0.0050780628807842731, 0.0067500779405236244, 0.0065958970226347446, 0.005323444027453661, 0.013518000952899456, 0.0033765423577278852, 0.0089940456673502922, 0.013969953171908855, 0.0084171490743756294, 0.0039718560874462128, 0.0033482294529676437, 0.014251542277634144, 0.0055269757285714149, 0.0049253231845796108, 0.0064830835908651352, 0.011524058878421783, 0.0071769095957279205, 0.0050604152493178844, 0.008576645515859127, 0.0092353885993361473, 0.011107012629508972, 0.0058982209302484989, 0.0032476410269737244, 0.0099371382966637611, 0.0086498809978365898, 0.006225859746336937, 0.0071925627999007702, 0.010844736360013485, 0.010306777432560921, 0.0077085499651730061, 0.010204405523836613, 0.0094346664845943451, 0.0052960794419050217, 0.012474965304136276, 0.0062737907283008099, 0.014992078766226768, 0.0038524842821061611, 0.010802050121128559, 0.007166930940002203, 0.0094258347526192665, 0.008327677845954895, 0.0091385310515761375, 0.0065453667193651199, 0.0091016599908471107, 0.012861412018537521, 0.0095446659252047539, 0.0047619873657822609, 0.005356823094189167, 0.0043131457641720772, 0.010469467379152775, 0.0042950171045958996, 0.0078737251460552216, 0.010229944251477718, 0.012370447628200054, 0.010017948225140572, 0.0068708141334354877, 0.014500160701572895, 0.0066539091058075428, 0.0051481951959431171, 0.010874520987272263, 0.0057527525350451469, 0.0067762820981442928, 0.0067003536969423294, 0.0080015324056148529, 0.0092613007873296738, 0.0074658994562923908, 0.014954992569983006, 0.009283912368118763, 0.0067693730816245079, 0.013174476101994514, 0.0084447590634226799, 0.0089796194806694984, 0.0086009977385401726, 0.0073882420547306538, 0.0089945187792181969, 0.0098396483808755875, 0.008195715956389904, 0.010365251451730728, 0.015069206245243549, 0.0056960745714604855, 0.005946130957454443, 0.0087062520906329155, 0.0042816703207790852, 0.0090926904231309891, 0.010267144069075584, 0.013523824512958527, 0.030628371983766556, 0.0072965077124536037, 0.011250264011323452, 0.0077754361554980278, 0.0057928548194468021, } };
const TfArray<144, int> quant96_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant96 = { (TfLiteFloatArray*)&quant96_scale, (TfLiteIntArray*)&quant96_zero, 3 };
const ALIGN(8) int32_t tensor_data97[24] = { -26169, -4070, 8783, -532, -21679, -815, -20371, -2842, -3637, -230, 2506, 12305, -1945, 19899, -8778, -8720, -7848, -16500, 7491, -6774, -33460, 12990, 3956, -6839, };
const TfArray<1, int> tensor_dimension97 = { 1, { 24 } };
const TfArray<24, float> quant97_scale = { 24, { 2.6065585188916884e-05, 5.5192536819959059e-05, 4.2402967665111646e-05, 4.1020080971065909e-05, 5.3590651077684015e-05, 4.2321367800468579e-05, 3.0200557375792414e-05, 3.294431371614337e-05, 3.8176316593308002e-05, 3.6850437027169392e-05, 3.1760890124132857e-05, 3.3656098821666092e-05, 4.0153481677407399e-05, 3.4845092159230262e-05, 3.7173351302044466e-05, 3.2156349334400147e-05, 2.8693910280708224e-05, 3.4986580430995673e-05, 4.20912510890048e-05, 2.9932116376585327e-05, 2.5421601094421931e-05, 3.6000736145069823e-05, 4.3427993659861386e-05, 4.463798541110009e-05, } };
const TfArray<24, int> quant97_zero = { 24, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant97 = { (TfLiteFloatArray*)&quant97_scale, (TfLiteIntArray*)&quant97_zero, 0 };
const ALIGN(8) int8_t tensor_data98[1*3*3*144] = { 
  /* [0][0][][] */ 24,75,-102,-64,-2,-25,-3,2,-15,4,2,-1,6,-5,-40,73,6,-63,6,0,2,-5,-42,-22,3,0,-7,2,20,9,-11,13,1,2,6,0,-38,10,13,-43,-75,-59,-47,7,-22,2,11,7,8,5,7,-127,15,-46,42,27,6,4,-95,-22,1,-47,12,24,35,3,-92,-50,11,2,37,-1,41,6,-61,7,5,15,-74,-36,1,30,-1,22,-78,-62,25,-36,6,16,4,12,28,44,14,9,0,11,-4,0,27,0,-1,-65,14,-15,13,12,11,-53,-109,6,-27,28,9,-41,2,1,8,7,1,10,-5,6,8,-4,-79,1,37,-104,16,1,-1,1,7,0,-87,12,27,-63,-1,12,4,2, 34,127,-127,-127,49,-28,4,27,-127,15,1,35,29,-12,-61,68,4,-89,13,2,-56,-23,-127,-56,24,14,19,7,21,42,-30,30,19,36,-26,22,-21,19,-60,-68,-86,-126,-70,-3,-48,-26,20,-95,-42,54,10,-125,15,4,71,10,78,-24,-96,-44,-39,-127,33,64,127,15,-127,-66,-5,5,-105,-10,20,19,-112,40,8,56,-68,-81,-109,127,-26,19,-102,6,23,12,38,20,-11,16,0,54,21,-127,7,27,-8,10,127,0,13,47,52,-60,53,35,-11,-127,109,-3,-41,127,10,-120,18,28,17,15,0,22,-127,15,-7,-30,-40,0,127,-72,34,10,-5,23,-95,-127,-127,26,127,-87,38,-4,-32,30, 15,64,-97,-42,8,-21,-6,-1,-31,-4,-1,4,1,3,-28,71,7,-62,3,-3,6,2,-39,-24,0,4,-11,0,-39,-3,-9,-2,5,4,8,-4,-40,2,18,-34,-59,-25,-28,5,-29,4,14,-12,26,0,12,-74,13,11,30,25,-18,13,-62,-15,6,-37,-1,8,31,-1,-68,-29,13,-1,42,2,36,6,-43,-6,4,-6,-65,-17,28,0,8,27,-53,-74,30,25,4,13,7,-5,18,34,10,27,2,8,2,-2,-4,0,0,-50,-4,-38,1,1,20,-27,-118,9,-16,26,7,-46,5,-3,0,0,2,5,9,11,20,-2,-77,11,11,-66,6,-2,3,-6,0,27,-62,3,6,-37,-6,7,12,0, 
  /* [0][1][][] */ 36,-43,-101,-53,83,7,13,19,-102,2,14,9,-5,38,-48,29,18,-127,22,2,78,13,-115,-27,54,20,18,16,71,20,-10,15,12,6,17,49,4,20,-22,-82,-84,-65,-96,18,-85,93,39,-96,-32,32,30,-98,18,-126,70,18,16,33,-127,-127,-8,-51,28,76,-25,13,38,-98,6,29,127,23,68,38,-126,29,12,13,-127,-112,-42,24,36,20,-127,-93,32,-127,48,21,-91,16,41,87,30,-21,21,15,23,20,91,12,37,-127,21,-92,49,27,-4,-72,-53,27,42,109,21,-127,12,59,27,21,18,28,-49,38,37,22,-124,31,25,-127,15,16,16,15,121,-62,-124,10,-16,-87,9,7,34,27, 127,-100,-85,23,75,9,127,127,-127,127,127,127,127,127,-127,-127,127,-82,127,127,-55,127,-125,-127,127,127,127,127,59,127,127,127,127,127,127,127,-127,127,-56,-127,-127,-127,-127,127,-127,-127,127,-127,-127,127,127,-86,127,127,127,-127,127,-127,-83,-81,-96,-59,127,127,40,127,47,-127,127,127,-24,127,127,127,-127,127,127,127,-99,-127,-127,72,127,127,-82,-127,127,78,127,127,127,127,127,127,127,-118,127,127,127,127,60,127,127,-62,127,-127,127,127,127,-122,-127,127,127,36,127,-106,127,127,127,127,127,127,-105,127,127,127,-127,127,31,-55,127,127,127,127,-110,-96,-99,127,-64,-127,127,127,127,127, 5,-32,-84,-64,127,9,-17,-7,-100,-16,-6,-11,-37,4,-35,102,-7,-106,-6,-15,81,-13,-92,-15,20,8,-10,-12,-127,-8,-30,-16,-15,-5,-4,14,21,-18,-17,-43,-47,-52,-74,-11,-35,110,9,-77,7,7,7,-125,-15,80,21,45,-17,45,-106,-125,47,-41,-2,45,-29,-15,24,-62,-15,-3,126,-2,42,7,-77,2,-10,-32,-94,-62,-6,19,7,3,-108,-53,16,59,14,-5,-113,-27,5,68,25,2,-4,-12,-9,-8,68,-8,3,-104,-17,-41,23,-2,-17,-46,-47,9,4,82,2,-85,-5,39,0,-6,-13,-5,-39,13,-10,-15,-97,-7,16,-86,-7,-12,4,-13,127,-40,-119,-13,-7,-29,-17,-17,-4,-6, 
  /* [0][2][][] */ -6,-15,-53,-38,12,20,-17,3,-1,7,-5,-7,5,6,-22,-1,9,-93,-11,6,35,-1,-51,-57,3,-3,-7,1,13,-10,-12,1,4,8,12,-11,46,-9,4,24,-41,11,-16,6,-13,6,-2,-18,53,-17,-3,-37,3,-96,31,1,7,17,-12,-16,25,-3,-5,-12,-2,1,70,-55,1,0,18,-2,-2,1,-12,0,5,1,-23,-7,-11,9,0,14,-6,-60,14,-22,-25,-4,-32,-3,24,15,6,-16,2,-8,-3,2,11,2,-5,-46,13,-97,-13,-1,22,-5,-16,2,7,48,4,-34,2,0,2,-5,3,5,-13,-5,10,-3,-72,-12,-22,-72,2,-3,5,-10,-1,-24,-29,1,42,19,-8,0,12,2, 5,-48,-125,-29,125,127,-27,-21,-90,-11,-17,14,-15,35,-16,-27,1,-111,-2,0,127,24,-82,-29,39,8,-21,-4,9,1,-13,-35,-10,10,22,-1,40,-24,127,-17,-6,-51,-52,-20,-81,-44,-46,-34,-13,-8,0,-25,-10,43,44,15,-30,-34,-3,-62,127,-53,-13,12,27,-31,102,-74,-12,-5,-77,32,-27,-6,-32,-33,2,-39,-43,-57,-47,8,11,-23,-103,-36,30,0,18,13,-66,-30,11,13,29,-85,-8,-27,4,4,84,22,5,-118,-17,-75,-24,-23,-2,-43,2,4,13,99,-2,-29,-31,12,-26,-10,-9,-13,-59,4,19,-7,-66,19,18,-80,-18,2,13,-22,-85,-7,-101,-4,125,23,-30,-17,34,-4, -9,-14,-44,-24,-11,-4,-11,6,0,3,0,1,10,2,-3,33,4,-99,-5,2,11,-9,-32,-50,0,1,-7,3,-23,-10,-18,7,10,9,5,-7,41,-1,-12,24,-31,18,16,8,4,-1,5,-16,62,-13,4,-3,7,25,23,-3,9,24,5,-18,-28,11,3,-6,-7,5,42,-24,4,1,21,-9,-1,5,-17,3,2,12,-26,-1,3,6,1,22,1,-35,22,23,-17,-5,-28,-2,21,2,12,-9,4,-7,-1,-1,-2,4,3,-26,20,-72,-9,7,27,9,-17,2,1,24,4,-30,6,-1,5,-3,5,6,-1,0,16,-2,-65,-10,-27,-41,2,-4,2,-8,2,-29,-17,-1,28,26,-4,-1,-3,11, 
};
const TfArray<4, int> tensor_dimension98 = { 4, { 1,3,3,144 } };
const TfArray<144, float> quant98_scale = { 144, { 0.0089915543794631958, 0.0065275020897388458, 0.0038228670600801706, 0.0063660764135420322, 0.0051220804452896118, 0.010790900327265263, 0.011639738455414772, 0.010033005848526955, 0.0036706940736621618, 0.010229678824543953, 0.010109500959515572, 0.0098595228046178818, 0.010600868612527847, 0.0091915447264909744, 0.0055780718103051186, 0.0066521470434963703, 0.0099462876096367836, 0.0041156844235956669, 0.0091845961287617683, 0.011604265309870243, 0.0066325305961072445, 0.010815336368978024, 0.0033771244343370199, 0.0059472839348018169, 0.0098500428721308708, 0.012660268694162369, 0.009972916916012764, 0.0091496119275689125, 0.011258959770202637, 0.0086197005584836006, 0.011575103737413883, 0.0098117729648947716, 0.0097719058394432068, 0.011336453258991241, 0.013556872494518757, 0.0085120555013418198, 0.0098542850464582443, 0.0097282696515321732, 0.011300140060484409, 0.0055257389321923256, 0.0043065524660050869, 0.0041858037002384663, 0.0042974269017577171, 0.0096472501754760742, 0.0053911185823380947, 0.0096916584298014641, 0.0077977911569178104, 0.0048505086451768875, 0.0077922157943248749, 0.0083412257954478264, 0.0089705474674701691, 0.0032409545965492725, 0.0089718513190746307, 0.0064345798455178738, 0.0053206761367619038, 0.016220698133111, 0.0071367681957781315, 0.013325529173016548, 0.003137681633234024, 0.0059831454418599606, 0.0096824755892157555, 0.004561946727335453, 0.008698582649230957, 0.0064755212515592575, 0.0066204080358147621, 0.0099610611796379089, 0.0058791171759366989, 0.0040796017274260521, 0.011488703079521656, 0.010461149737238884, 0.0059741809964179993, 0.0095802722498774529, 0.0053030615672469139, 0.0097179524600505829, 0.0037993560545146465, 0.007992476224899292, 0.011889292858541012, 0.0085417432710528374, 0.0033219079487025738, 0.0048710787668824196, 0.0062605156563222408, 0.0060263439081609249, 0.0098864948377013206, 0.0088394815102219582, 0.0036759304348379374, 0.0038232922088354826, 0.0077182119712233543, 0.01058674231171608, 0.0090145180001854897, 0.0087113939225673676, 0.0082212788984179497, 0.010049059055745602, 0.0079779978841543198, 0.0051423539407551289, 0.0095328586176037788, 0.0082955434918403625, 0.01145324669778347, 0.0087976995855569839, 0.0087628737092018127, 0.013493516482412815, 0.0053560030646622181, 0.01063432265073061, 0.010058236308395863, 0.0037548530381172895, 0.0091054029762744904, 0.003187558613717556, 0.0079293111339211464, 0.0092500112950801849, 0.011332876980304718, 0.0045865969732403755, 0.0063043348491191864, 0.011064143851399422, 0.0088451774790883064, 0.0037937324959784746, 0.0098324967548251152, 0.0037026193458586931, 0.011630229651927948, 0.0089557040482759476, 0.0099064242094755173, 0.01102067343890667, 0.011073673143982887, 0.012422030791640282, 0.0059783407486975193, 0.0091685252264142036, 0.0087395096197724342, 0.010695158503949642, 0.0032875677570700645, 0.0090108998119831085, 0.007247620727866888, 0.0034502556081861258, 0.0095646120607852936, 0.011100878939032555, 0.0097851911559700966, 0.010311736725270748, 0.0065766666084527969, 0.0053853187710046768, 0.0035434088204056025, 0.0095191178843379021, 0.0058828936889767647, 0.0039704428054392338, 0.010519609786570072, 0.012003120966255665, 0.0084625361487269402, 0.0099733462557196617, } };
const TfArray<144, int> quant98_zero = { 144, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant98 = { (TfLiteFloatArray*)&quant98_scale, (TfLiteIntArray*)&quant98_zero, 3 };
const ALIGN(8) int32_t tensor_data99[32] = { -4687, 4671, -65, -4498, 3278, 4172, 2499, -21801, 8132, 1223, -5451, -10397, 21784, 6759, 9047, -8217, -22955, 40594, -14386, -23602, 6778, 7940, -18796, 1795, -6189, 79, 10182, -27078, -3848, -30496, 32718, -14216, };
const TfArray<1, int> tensor_dimension99 = { 1, { 32 } };
const TfArray<32, float> quant99_scale = { 32, { 5.1025854190811515e-05, 4.9138627218781039e-05, 5.2451305236900225e-05, 5.7657482102513313e-05, 6.8803914473392069e-05, 6.1008980992482975e-05, 6.0981485148658976e-05, 7.5454066973179579e-05, 6.5760650613810867e-05, 5.7984841987490654e-05, 6.7274457251187414e-05, 5.9578305808827281e-05, 5.8215151511831209e-05, 6.3724393839947879e-05, 6.0669804952340201e-05, 7.6268217526376247e-05, 6.6321008489467204e-05, 4.3791747884824872e-05, 6.812159699620679e-05, 5.0226495659444481e-05, 6.8771289079450071e-05, 5.8321886172052473e-05, 6.9141628046054393e-05, 5.9619167586788535e-05, 6.4008439949247986e-05, 7.6597687439061701e-05, 6.7058586864732206e-05, 4.0710372559260577e-05, 6.1825630837120116e-05, 6.6499640524853021e-05, 4.7109333536354825e-05, 6.2142047681845725e-05, } };
const TfArray<32, int> quant99_zero = { 32, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant99 = { (TfLiteFloatArray*)&quant99_scale, (TfLiteIntArray*)&quant99_zero, 0 };
const ALIGN(8) int8_t tensor_data100[1*3*3*192] = { 
  /* [0][0][][] */ -20,-6,66,53,-21,107,25,-90,-12,-10,20,-1,14,36,48,-59,6,-15,44,7,2,-3,27,-49,-25,46,-42,-66,36,43,46,18,-12,60,-2,3,-79,-48,7,9,-12,-1,54,16,67,-5,3,-50,48,39,7,27,-42,-24,60,-118,-2,-12,-3,-39,-107,-8,19,24,-42,-8,10,18,4,34,-94,60,22,-6,-62,34,-51,-2,12,36,-59,-11,-6,19,13,-96,37,-48,-21,-6,-26,4,-4,-17,63,-14,19,60,-44,9,-11,-51,21,-19,-58,11,-77,33,-51,0,-9,-8,27,6,-21,-7,-4,-7,-32,-9,-71,-3,-114,-51,-88,-119,-127,-12,-40,21,18,34,-44,58,14,-19,-24,-12,46,-66,6,-120,17,-96,19,-45,17,-23,68,-20,12,-23,15,-8,-34,4,12,15,-24,-24,3,19,36,-17,4,-28,-66,14,7,-48,13,32,3,34,49,-19,-52,12,-24,-95,47,-26,45,-22,-20,10,-27,-76,11,-29,9,-6, -127,80,127,127,-74,107,52,-108,41,-125,3,-127,30,127,127,-99,77,-127,-59,-11,91,33,83,-127,89,125,-21,-45,112,127,12,127,-17,-66,9,65,-127,67,29,4,-35,55,-127,20,74,25,28,-13,-17,92,-38,127,-85,-5,75,-127,39,13,-42,-127,28,127,26,-12,-24,4,-7,-99,127,127,70,-20,11,-64,-127,127,-127,10,21,25,-71,-33,110,-38,106,-89,-5,-127,37,18,10,115,-5,-127,74,-65,-71,127,-70,28,23,-107,75,-7,127,-98,127,-51,127,47,-7,32,127,26,-14,47,29,-95,-6,0,-26,30,-6,-73,-83,-124,-24,40,-73,127,-127,25,-69,127,29,92,78,-31,100,-127,53,-127,-10,-41,-35,-127,-3,-65,127,-51,23,102,3,20,41,-71,127,38,1,-127,-15,21,103,-1,43,13,-123,-2,9,-77,59,73,-37,50,-24,20,-12,100,-115,5,127,54,19,-5,-127,-127,-127,-30,127,-115,52,37, -5,-2,72,78,-7,102,21,-127,-13,-19,-26,-1,15,36,41,-60,4,-15,34,8,2,-33,20,-22,-47,37,-39,-80,33,39,29,20,-15,-61,-1,13,-70,3,6,7,46,-16,54,12,55,-28,5,-46,43,39,4,28,-11,-29,57,-107,-6,-24,55,-33,51,-6,8,20,-40,-1,-12,35,15,31,4,-76,24,-9,-64,46,-48,-9,8,24,-53,4,-30,18,10,-76,36,-54,-24,-5,7,-9,1,-26,53,-57,8,64,-36,-2,3,-53,19,-30,-63,3,-70,37,-57,-7,-4,-23,26,2,27,0,-83,27,15,-4,-67,-6,-86,-60,-99,-119,-98,-19,-11,23,21,14,-23,41,15,-15,-16,-9,42,-54,3,-117,16,-114,22,-55,26,-90,56,-14,7,-5,15,-19,-23,6,1,15,21,-17,3,17,33,-22,5,-29,-64,-14,3,-42,2,14,-1,11,-45,-24,-60,12,-22,-63,36,-25,-105,-17,-21,6,-41,-58,7,-40,-3,-8, 
  /* [0][1][][] */ -84,10,-56,-8,-127,120,26,-85,37,11,127,-83,19,-6,35,-25,9,3,-127,-6,-127,-94,-44,-123,118,18,-75,-82,-21,-13,14,55,-51,-127,-30,40,36,-75,23,62,26,88,71,36,-50,83,30,11,119,104,8,-19,-81,24,54,79,16,36,-79,34,-122,40,-6,5,9,53,63,-92,33,-8,-100,127,71,1,-64,-49,-19,-5,-31,19,-67,-23,72,102,-9,-110,18,-18,-11,30,-127,119,127,-41,-11,-116,127,22,-127,-43,70,-20,-11,125,4,-10,-80,11,-91,7,-7,-31,60,-3,-127,20,88,-112,15,-51,18,36,-127,-110,-25,-88,-94,10,-102,46,-82,123,-127,-80,-100,89,-4,-1,10,-51,-5,-41,-1,-96,86,-97,46,70,39,11,14,-12,9,127,62,4,15,1,127,5,26,-30,122,-7,39,48,61,-93,19,-102,-4,1,-52,6,127,66,-126,64,-111,-31,26,67,77,-2,46,-24,113,-15,-16,-127,52,13, -102,127,-60,-94,-111,93,-127,-51,127,127,-27,-126,127,-102,33,127,52,95,-50,127,-32,127,119,-82,-9,127,127,-38,22,-68,127,91,-90,122,127,127,113,127,127,-127,-85,127,-55,127,-127,127,127,-77,127,127,127,-66,-127,127,-127,118,127,127,-30,69,35,-5,127,127,-89,127,42,-127,-99,49,127,-12,-127,-127,-98,-58,125,127,127,127,-127,-63,127,-127,36,87,-127,77,127,127,108,65,-105,24,-127,17,-123,-79,-97,127,46,-127,68,81,115,-65,6,127,-51,127,-63,-127,-41,127,38,118,64,-73,-82,-46,4,127,-3,-127,-79,-34,-75,127,-58,32,-49,25,-61,-47,62,-127,127,47,127,-65,127,-76,127,-60,-127,-60,127,127,-71,127,127,127,127,-2,127,72,109,127,-38,92,127,127,-28,127,127,127,-25,127,127,-8,127,127,-127,127,-18,127,-35,-127,-105,127,-98,127,68,-110,21,124,-53,-127,-54,-84,127,127, -54,-1,-61,19,-114,127,24,-81,-6,14,-84,-67,22,-9,27,-35,11,1,-115,-14,-116,52,-36,-126,-127,-22,-74,-127,-16,-8,27,35,-49,47,-32,62,29,-39,23,45,127,99,60,38,-53,-114,36,17,98,124,19,-25,-37,25,84,44,-4,18,127,28,127,54,6,-4,4,57,-127,-91,15,-21,44,-100,70,-5,-51,-51,-23,-11,1,18,-52,-26,-25,83,5,-121,22,-11,-22,16,32,127,125,-28,-8,-101,116,25,-112,-28,-127,-22,-10,127,28,-16,-106,31,-118,-14,-13,-13,57,12,99,19,-127,-113,127,-40,32,30,-110,-113,15,-112,-27,14,-111,61,-71,127,-104,-65,-91,73,-3,6,0,-37,-20,-23,5,-88,56,-114,38,-125,41,9,19,-1,-6,-123,55,3,12,2,-97,8,20,-31,127,-8,18,34,69,-13,25,-127,-7,-2,-33,-2,-39,53,-127,44,-71,-11,16,58,-127,-5,44,0,104,11,-16,-120,13,4, 
  /* [0][2][][] */ 8,7,-28,-13,-38,52,31,-106,-7,27,58,-94,-51,-2,13,-39,-14,10,5,-2,-73,-17,-4,-20,-24,-123,-20,-44,-29,-13,42,12,26,1,-6,1,37,-67,8,7,-29,-26,0,-6,-38,8,-4,17,-33,-5,-23,-13,53,-35,52,29,-12,3,-21,13,-30,-1,5,53,27,33,9,-25,-42,-68,-73,65,-24,-41,-5,15,38,-18,10,5,71,65,-22,33,22,-108,27,23,-16,-15,-8,-1,11,-5,47,-6,-10,-23,1,2,-27,-24,-31,45,-44,18,-24,-24,-22,-29,28,-44,12,16,-24,-50,31,-74,-25,48,53,0,-25,-32,-63,-95,-38,-42,-35,-38,-82,-2,-26,18,19,-30,-29,4,-29,-12,-2,-78,6,-47,6,-103,0,12,-10,-17,10,-38,7,21,-7,50,-49,-1,-43,12,-10,-47,-10,-15,5,-28,37,-7,28,-66,1,37,-38,-19,16,-29,-35,4,1,-27,61,-8,1,24,4,22,59,-53,-7,-24,-83,-41, -70,43,-45,-48,18,-59,34,-79,-10,-13,-32,-80,-116,-21,34,45,-127,35,5,10,15,42,127,-39,74,-119,-64,-22,-127,-27,13,36,127,45,31,-41,36,60,34,-2,-19,77,-97,43,-9,23,29,127,105,-7,66,-29,-25,-31,61,73,-6,-6,21,72,-2,-51,-10,24,127,-11,-1,-86,16,-99,23,-24,-45,-57,-118,-74,87,-99,5,-8,-61,127,18,112,127,-127,31,110,-19,28,4,-30,-29,20,-20,-127,107,6,-53,28,28,-60,-127,-27,82,-127,-113,106,82,-18,127,-55,30,7,-4,-127,9,-127,-21,127,127,-22,-49,-23,-127,-127,-66,-7,-127,-22,-110,7,5,-77,-127,-45,-48,127,-9,-70,-30,-42,-18,-127,-4,-99,13,-6,-36,44,6,-18,-12,-10,-67,127,-67,0,11,57,66,-119,-25,5,45,22,127,29,-1,-76,8,-1,-21,-16,-17,71,-50,-24,-127,7,-26,-10,-63,127,84,100,83,-85,-25,-34,-44,-54, 25,3,-11,6,-33,48,31,-120,4,24,-50,-102,-41,0,23,-35,-12,10,-3,-9,-70,9,6,-21,-24,-104,-22,-51,-24,-20,52,10,31,-5,-10,-13,28,-17,18,5,2,-34,2,-11,-42,-16,-4,21,-45,5,-20,-14,66,-30,67,27,-13,-7,7,10,-6,-3,2,43,26,35,-20,-8,-35,-68,19,-37,-28,-47,-3,3,32,-25,4,11,69,60,-23,36,17,-87,26,22,-18,-3,5,5,11,-19,41,-50,-9,-30,-2,0,9,-40,-33,39,-42,10,18,-13,-11,-26,33,-48,12,7,24,-45,-104,-8,15,50,54,4,7,-29,-62,-110,-33,-44,-35,-37,-52,8,-19,10,10,-10,-36,23,-33,-17,-5,-75,1,-95,0,-79,5,-46,-1,-14,17,-25,19,-22,-10,48,-48,-3,33,11,-1,-52,3,-5,1,-28,41,-37,17,-52,-2,24,-43,-17,-52,-31,-44,19,37,-6,51,-7,-79,26,0,24,47,-53,-7,-57,-89,-40, 
};
const TfArray<4, int> tensor_dimension100 = { 4, { 1,3,3,192 } };
const TfArray<192, float> quant100_scale = { 192, { 0.0048519233241677284, 0.0081747053191065788, 0.0064842053689062595, 0.0084141567349433899, 0.0052901557646691799, 0.0036834278143942356, 0.012262353673577309, 0.0029577056411653757, 0.012088448740541935, 0.0096744000911712646, 0.0090307369828224182, 0.0036312236916273832, 0.0096162911504507065, 0.0097349695861339569, 0.0079180113971233368, 0.0085052773356437683, 0.013954224996268749, 0.010130811482667923, 0.0077006607316434383, 0.01303852628916502, 0.0063215014524757862, 0.0077428105287253857, 0.0063916575163602829, 0.0048794890753924847, 0.0091647179797291756, 0.0050564603880047798, 0.010731506161391735, 0.0056243967264890671, 0.0080694733187556267, 0.0085173966363072395, 0.0069646826013922691, 0.0062283934094011784, 0.0084239579737186432, 0.011499950662255287, 0.013142532669007778, 0.0071018729358911514, 0.006999592762440443, 0.0085714049637317657, 0.011662621051073074, 0.028509052470326424, 0.012317690066993237, 0.0063370713032782078, 0.010267201811075211, 0.0092246625572443008, 0.0071659795939922333, 0.0077875033020973206, 0.011036397889256477, 0.011116214096546173, 0.0058129280805587769, 0.0049151512794196606, 0.010262060910463333, 0.0095418449491262436, 0.0054151816293597221, 0.012010236270725727, 0.0065120551735162735, 0.0053830514661967754, 0.013008821755647659, 0.01232136320322752, 0.0097777554765343666, 0.0088205169886350632, 0.0066848522983491421, 0.008526102639734745, 0.012064329348504543, 0.0088151814416050911, 0.0094219446182250977, 0.0079331295564770699, 0.010014266707003117, 0.0047455406747758389, 0.011045194230973721, 0.006922583095729351, 0.0069671082310378551, 0.0064931553788483143, 0.011224017478525639, 0.0069001992233097553, 0.0041639893315732479, 0.0082809831947088242, 0.0084701878949999809, 0.010584389790892601, 0.012225297279655933, 0.0085761761292815208, 0.0059864982031285763, 0.0089814392849802971, 0.008127422071993351, 0.0084646493196487427, 0.0071777808479964733, 0.0040945522487163544, 0.015792453661561012, 0.0085063893347978592, 0.011125260032713413, 0.0099276509135961533, 0.011029850691556931, 0.0056314612738788128, 0.0083893435075879097, 0.0089827943593263626, 0.0095896273851394653, 0.0051050367765128613, 0.0071452087722718716, 0.0077120773494243622, 0.0059155747294425964, 0.011224964633584023, 0.012067327275872231, 0.0056747500784695148, 0.010015159845352173, 0.0077422382310032845, 0.0072287372313439846, 0.0070784487761557102, 0.0054832268506288528, 0.0087809460237622261, 0.0074865426868200302, 0.011714276857674122, 0.009691351093351841, 0.0067747007124125957, 0.0089557860046625137, 0.0112929567694664, 0.009094814769923687, 0.007877131924033165, 0.0068641984835267067, 0.0044746170751750469, 0.0096400417387485504, 0.0098743326961994171, 0.0073438044637441635, 0.010674498043954372, 0.0052553936839103699, 0.0044725690968334675, 0.0050049242563545704, 0.003549305722117424, 0.0043449513614177704, 0.010750161483883858, 0.0053093931637704372, 0.0075128497555851936, 0.0053026108071208, 0.00577520951628685, 0.0053075337782502174, 0.0084251146763563156, 0.010288302786648273, 0.013375595211982727, 0.009614480659365654, 0.011337423697113991, 0.0073929703794419765, 0.0058141127228736877, 0.010378314182162285, 0.004284207709133625, 0.011507714167237282, 0.0040739690884947777, 0.012572935782372952, 0.0033315287437289953, 0.0077073387801647186, 0.006920994259417057, 0.0074968957342207432, 0.0080521125346422195, 0.011010266840457916, 0.0084889158606529236, 0.01287501584738493, 0.0090178288519382477, 0.0095070190727710724, 0.0068052792921662331, 0.0067126257345080376, 0.012847324833273888, 0.013448985293507576, 0.011562792584300041, 0.0088085560128092766, 0.0087916860356926918, 0.0070402887649834156, 0.014014539308845997, 0.0096463654190301895, 0.010066986083984375, 0.0070339636877179146, 0.01150854118168354, 0.011706825345754623, 0.0054258154705166817, 0.0099750077351927757, 0.0071670161560177803, 0.0068985768593847752, 0.0088382018730044365, 0.010106339119374752, 0.0072412164881825447, 0.0054476885125041008, 0.011096932925283909, 0.0047683333978056908, 0.010277531109750271, 0.0079199234023690224, 0.0098967961966991425, 0.0071954503655433655, 0.011482776142656803, 0.010304872877895832, 0.0079292599111795425, 0.0057222237810492516, 0.0050251558423042297, 0.011266949586570263, 0.0044051539152860641, 0.0084381727501749992, 0.010352518409490585, } };
const TfArray<192, int> quant100_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant100 = { (TfLiteFloatArray*)&quant100_scale, (TfLiteIntArray*)&quant100_zero, 3 };
const ALIGN(8) int32_t tensor_data101[32] = { -8525, 12980, -12770, -37006, 12814, 8323, 24277, -10134, -10571, 3733, -13531, 5613, -2298, -6385, 13485, -17852, 5679, -4831, 3945, -14216, 1496, -4020, -23247, -8970, -2973, 19299, -6735, 8400, 15723, 14011, 15221, -1292, };
const TfArray<1, int> tensor_dimension101 = { 1, { 32 } };
const TfArray<32, float> quant101_scale = { 32, { 4.3016669224016368e-05, 3.3794585760915652e-05, 5.8316232752986252e-05, 4.4344091293169186e-05, 3.6479013942880556e-05, 3.9656166336499155e-05, 3.3883672585943714e-05, 4.0283226553583518e-05, 5.778883132734336e-05, 2.9222692319308408e-05, 4.681682912632823e-05, 3.0047753170947544e-05, 5.0243332225363702e-05, 5.3288746130419895e-05, 3.1242245313478634e-05, 4.4755848648492247e-05, 3.8007878174539655e-05, 4.4389857066562399e-05, 4.4072556192986667e-05, 3.9204154745675623e-05, 3.2262367312796414e-05, 4.5135213440516964e-05, 4.5595945266541094e-05, 3.2884880056371912e-05, 3.3383876143489033e-05, 4.616075602825731e-05, 4.7211568016791716e-05, 4.0198323404183611e-05, 3.3856566005852073e-05, 4.296078986953944e-05, 4.5307122491067275e-05, 3.4770469937939197e-05, } };
const TfArray<32, int> quant101_zero = { 32, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant101 = { (TfLiteFloatArray*)&quant101_scale, (TfLiteIntArray*)&quant101_zero, 0 };
const ALIGN(8) int8_t tensor_data102[1*3*3*192] = { 
  /* [0][0][][] */ 77,-1,36,-2,-65,20,15,-30,24,-8,-6,-15,-22,-127,-19,38,-43,6,-1,4,22,-23,-13,34,-127,29,-2,-42,14,116,-79,-23,29,127,27,-52,-74,19,2,127,-7,53,3,8,38,4,2,-73,-14,-27,-40,-127,31,-122,-84,45,51,13,38,-48,95,63,-92,-24,50,-21,-26,-73,-127,38,-14,-54,2,21,-7,-46,17,-17,-62,-96,16,46,-27,20,-119,-13,47,15,-55,-20,-5,91,-4,-13,8,-74,16,-4,-127,50,11,-113,-89,-1,28,-57,14,28,20,-3,-14,-127,-72,-39,-78,-14,-34,0,-11,37,13,5,4,-30,30,2,8,-68,-65,-1,40,-5,32,6,-127,43,17,-46,-29,-62,-83,50,-5,-30,-19,-8,59,-25,-81,113,83,49,-31,-5,127,29,19,-18,-96,-33,36,13,22,-9,-23,31,39,-71,-16,57,48,-1,-14,43,-3,44,24,0,33,-40,13,10,-11,-98,7,5,39,-23,81,-5,-77,1, 56,127,-82,-35,-62,84,36,127,127,127,127,21,34,-118,-56,33,-22,-113,15,28,54,57,-127,122,-117,111,-96,-121,111,44,-57,-10,-37,88,59,28,-29,127,75,12,-92,-127,-66,30,123,2,81,-127,-98,-83,-13,-53,127,-39,-127,-57,47,101,127,-127,65,-102,-60,-77,127,12,13,-106,64,127,10,-117,15,127,-62,112,10,-38,127,-54,39,22,-127,-127,-89,-81,12,127,-127,-9,-127,-16,-27,-74,127,-127,-95,127,-118,114,79,1,-127,23,116,50,-127,-16,54,46,14,-49,-40,-127,-107,6,60,127,127,-127,107,37,-9,54,79,127,54,-119,-54,82,-127,27,30,86,-117,127,9,-111,-122,-113,45,-31,-50,-6,-96,-10,-84,26,39,-55,93,62,13,-21,4,-61,78,127,-5,-4,-127,-22,35,26,16,127,64,-23,-127,127,-80,64,108,-127,75,-72,90,127,127,-62,127,88,127,-104,127,21,127,-57,127,5,-55,-33, 54,1,58,-42,-69,12,14,-58,7,-2,-16,-21,-17,-107,-17,-7,66,2,3,7,19,-29,-2,22,-90,36,2,-30,1,100,-77,-24,7,117,29,9,-87,14,7,-103,2,26,9,5,10,5,-16,-91,-5,-25,-41,-72,-16,-121,-77,-55,39,4,30,-11,92,70,-68,-24,48,-17,-33,-59,-108,32,-12,-46,6,16,-25,-33,22,-12,-22,-92,16,-26,-5,20,-88,-7,25,-4,-49,-16,-3,99,13,-28,6,-50,29,-10,-106,33,17,-127,-81,0,15,0,-4,-22,8,-12,-13,-89,-77,-17,-26,12,-51,-22,3,31,18,0,9,-20,30,11,-27,-49,-29,-4,35,-16,-35,-3,-125,44,12,-41,-21,-93,-84,44,-7,-38,-11,2,50,-15,30,106,-126,34,-45,-5,121,-7,12,-14,-27,-39,37,14,12,-12,4,19,38,-72,-14,45,45,-7,-47,38,-9,44,39,-1,8,-31,12,13,-34,-81,-1,4,21,-2,83,-7,-63,6, 
  /* [0][1][][] */ -86,-95,41,127,-127,92,29,31,-4,-40,25,-12,7,-54,52,127,-111,-114,13,-28,5,37,-73,116,-84,127,57,17,22,53,-120,-70,9,-38,-1,-89,-48,8,-27,88,-5,53,72,-107,-19,7,39,70,-37,65,-56,-82,-4,-121,40,82,-13,47,2,-106,80,60,-127,42,76,-4,-19,66,64,58,-15,25,-10,11,127,78,127,36,-77,-87,4,6,23,9,-82,-10,40,96,67,18,3,-40,127,-94,60,-94,102,84,-123,-1,-26,-98,0,24,127,-127,3,127,106,16,12,-88,-44,-11,-127,-127,92,41,-31,76,127,29,25,9,-15,3,48,-95,10,64,46,10,112,46,-83,-32,-47,-113,-4,-38,-69,-7,-4,-42,-56,-14,113,-127,-127,109,97,47,74,31,9,37,21,98,-97,-127,23,32,37,-29,-127,-43,51,-107,-65,-40,127,24,112,32,-27,68,-127,4,52,-68,48,61,25,-122,-4,24,45,46,105,14,-118,21, -127,-70,-6,66,-21,-67,127,104,-22,-77,-71,127,127,17,-127,23,14,-69,127,127,127,127,-105,-33,-83,40,127,127,127,-127,-34,-127,127,10,75,107,-42,-72,127,-76,127,-78,-127,-38,127,127,127,0,-73,127,127,-15,93,-29,95,70,127,65,-95,-32,-83,127,-61,-54,-39,127,127,127,108,-70,-1,127,127,-32,-102,127,40,21,21,10,80,127,98,-12,-67,127,127,-11,-7,-85,71,-127,91,21,63,-96,-127,-63,-112,13,127,-119,54,31,-20,118,89,-110,127,127,127,-42,-68,-79,45,39,119,95,45,-118,-14,29,127,127,80,-83,127,-9,127,127,72,127,44,127,-73,-51,9,-9,127,127,127,-127,-51,17,-127,127,-97,77,116,127,115,-127,127,-8,3,127,127,127,127,-54,47,127,127,127,45,-8,127,-83,-41,-58,-41,127,20,4,127,-127,80,65,83,-35,-12,-5,83,-36,-59,127,-15,-127,81,127,115,127, -81,-94,65,-87,-116,105,20,5,-7,-61,23,-21,-5,-56,61,31,42,-127,15,-28,8,35,-58,95,-54,77,47,10,17,36,-80,-56,31,-50,-4,127,-53,12,-14,-93,-12,66,59,-127,-32,16,25,71,-32,48,-61,-100,-45,-127,33,-127,-14,48,1,-121,127,90,-89,36,64,-2,-19,23,42,53,-9,14,-4,30,82,68,112,40,-29,-66,-7,-113,17,21,-64,-14,-38,126,62,23,5,-18,116,-104,46,-69,111,72,-87,9,-1,-74,-27,30,113,26,5,-23,45,-14,-12,-72,-68,-1,-100,69,105,31,-25,82,114,36,9,0,-24,-6,-118,-104,-44,45,55,39,-127,19,-100,-28,-46,-127,-4,-84,-66,1,4,-50,-74,-19,110,39,26,63,-122,19,46,27,1,-69,22,59,12,-103,18,30,44,-23,68,-57,54,-106,-56,-32,124,11,66,35,-30,53,-98,-2,36,-50,33,47,9,-127,-9,16,43,68,12,23,-103,18, 
  /* [0][2][][] */ 11,-40,60,-6,-62,1,-32,-48,-1,-21,-1,-35,13,-34,45,31,-127,-44,-12,-8,8,-11,-64,-9,-19,-38,42,-2,-20,74,-67,20,6,-51,-61,-73,-74,0,20,79,14,27,43,-27,-14,13,2,38,29,25,-22,-35,-31,-4,13,68,33,-59,-54,-48,43,8,-33,-28,28,-16,-14,-10,-9,-1,20,28,23,-1,23,-37,36,17,-41,-116,-14,9,23,20,-127,18,17,37,13,40,0,-48,-20,-114,-35,-47,66,-21,-51,-35,-3,-88,8,4,40,3,22,14,-8,-20,-40,25,-127,-59,-39,-6,45,-3,-16,33,17,47,-8,-59,-24,1,-39,-7,24,-7,47,7,-3,-38,-109,-3,28,-60,-4,25,113,68,22,15,-35,-38,6,-99,-60,24,93,-5,-34,58,121,36,-7,5,-40,-5,26,-42,32,-7,-31,11,-49,26,-58,4,26,1,-62,-5,-30,33,-8,11,17,-109,-50,-19,-59,-22,19,9,2,65,55,-5,-24,23, 11,111,127,-19,-114,-127,-14,-38,19,83,-31,-34,18,7,110,-11,62,-71,-19,-69,-31,22,-92,-127,52,30,-74,65,-55,3,-127,102,29,-52,-127,9,-127,-7,-35,27,37,-63,105,39,-15,37,-89,87,127,-19,-7,-69,-50,4,47,-51,31,-127,-42,-54,-41,-108,-49,127,-31,8,11,81,67,-39,127,35,6,11,-98,85,43,127,91,-127,-127,2,89,109,-100,74,119,81,101,127,103,-16,107,-80,-105,-41,97,-98,-122,-127,36,-78,40,127,84,10,31,2,60,-26,-42,2,-11,-62,-22,2,127,22,41,-90,0,-127,41,-82,-127,16,-27,-127,17,27,100,45,2,-25,-93,-61,127,-35,90,57,75,0,127,127,-18,122,127,17,-6,22,37,22,21,127,-17,65,45,81,26,-72,55,29,-19,21,25,-9,36,-127,21,-75,24,-36,-127,19,-66,-46,-40,-14,14,-66,-7,-127,6,-32,-31,21,2,126,14,28,-127,59, -5,-32,47,-62,-73,11,-26,-53,-8,-20,-1,-32,6,-39,54,-24,91,-32,-19,-5,15,-11,-49,-13,-23,-26,27,7,-21,67,-81,11,3,-59,-59,10,-75,4,12,-83,8,7,44,-44,-10,13,1,32,28,17,-26,-38,-13,4,29,-80,22,-72,-44,-19,50,23,-28,-11,18,-11,-17,-27,-1,-6,27,29,16,2,-6,-37,34,24,1,-92,-11,-32,12,10,-111,18,-60,32,6,46,2,-43,-17,-127,-31,-37,47,-24,-62,-24,7,-88,2,13,45,12,30,-20,-14,-15,-28,43,-113,-54,-15,7,26,-18,-20,42,21,40,-19,-48,-32,-2,2,-1,26,12,34,14,2,-34,-97,0,17,-36,2,-15,106,64,23,9,-40,-32,4,52,-1,-4,-127,-6,-69,61,103,-43,-2,1,23,-20,22,-38,18,-14,11,-5,-48,27,-56,6,25,-1,-47,-4,-37,4,-20,6,7,-127,-48,-9,-54,-22,9,13,-5,68,90,-9,-29,5, 
};
const TfArray<4, int> tensor_dimension102 = { 4, { 1,3,3,192 } };
const TfArray<192, float> quant102_scale = { 192, { 0.0076999636366963387, 0.0084169460460543633, 0.0050199707038700581, 0.0073766433633863926, 0.0042071063071489334, 0.0085747512057423592, 0.010818717069923878, 0.0081972572952508926, 0.012623819522559643, 0.0084019796922802925, 0.01126435212790966, 0.014273003675043583, 0.01051776297390461, 0.0051301587373018265, 0.0074240528047084808, 0.0084153963252902031, 0.0066600805148482323, 0.0048558022826910019, 0.011529293842613697, 0.011971671134233475, 0.0099639920517802238, 0.009703892283141613, 0.0041515491902828217, 0.0063381553627550602, 0.0038673309609293938, 0.0059977136552333832, 0.0082084890455007553, 0.010133764706552029, 0.0082499310374259949, 0.0065031209960579872, 0.0034904470667243004, 0.0095353266224265099, 0.010152548551559448, 0.0068410248495638371, 0.0085055585950613022, 0.0078166322782635689, 0.0045006480067968369, 0.010131676681339741, 0.0094866529107093811, 0.005011445377022028, 0.011763465590775013, 0.0090309716761112213, 0.0091670965775847435, 0.0092062791809439659, 0.0082083297893404961, 0.012780623510479927, 0.009314696304500103, 0.0066819135099649429, 0.0092427264899015427, 0.0091658588498830795, 0.016017138957977295, 0.0044475463218986988, 0.0081007480621337891, 0.0057679419405758381, 0.0082450695335865021, 0.0061225397512316704, 0.0073677608743309975, 0.0095260282978415489, 0.0081241000443696976, 0.0047615733928978443, 0.0050114202313125134, 0.0072932103648781776, 0.0050323288887739182, 0.010541489347815514, 0.0068146968260407448, 0.012819548137485981, 0.015581744723021984, 0.0078373560681939125, 0.0075039006769657135, 0.010681129060685635, 0.010423741303384304, 0.0093033220618963242, 0.012441608123481274, 0.012824422679841518, 0.0085330121219158173, 0.0062110461294651031, 0.005206237081438303, 0.0094240447506308556, 0.010424993932247162, 0.0045243259519338608, 0.011435238644480705, 0.010455879382789135, 0.0090156672522425652, 0.010847466066479683, 0.0038058820646256208, 0.011498386971652508, 0.0074263871647417545, 0.003977535292506218, 0.0079948948696255684, 0.0084326630458235741, 0.010002927854657173, 0.0068918671458959579, 0.0066126445308327675, 0.0046210051514208317, 0.0081740273162722588, 0.0048250393010675907, 0.0065283318981528282, 0.0096001783385872841, 0.0033040659036487341, 0.0079611875116825104, 0.0097914636135101318, 0.003716637147590518, 0.0077098580077290535, 0.0089138224720954895, 0.0061800186522305012, 0.0093770194798707962, 0.0098450537770986557, 0.011819630861282349, 0.0087285572662949562, 0.011865377426147461, 0.010785553604364395, 0.0058767413720488548, 0.0059057953767478466, 0.0056961397640407085, 0.0061685694381594658, 0.014044221490621567, 0.0064339060336351395, 0.0064751454629004002, 0.01052146777510643, 0.0083524221554398537, 0.0051908604800701141, 0.013810061849653721, 0.010135465301573277, 0.0097285090014338493, 0.0086047975346446037, 0.011921875178813934, 0.0091747408732771873, 0.0038016836624592543, 0.010147488676011562, 0.008814515545964241, 0.0083069996908307076, 0.010162703692913055, 0.0076482831500470638, 0.0078932605683803558, 0.0032108293380588293, 0.0093833161517977715, 0.012852193787693977, 0.004746235441416502, 0.01009643916040659, 0.0066308137029409409, 0.0074663199484348297, 0.015401066280901432, 0.012349909171462059, 0.010455038398504257, 0.0051410594023764133, 0.0098451441153883934, 0.0064345588907599449, 0.007925315760076046, 0.0088530434295535088, 0.0061818398535251617, 0.0047522080130875111, 0.010934923775494099, 0.009943016804754734, 0.0074815414845943451, 0.0075750900432467461, 0.009297163225710392, 0.0076453466899693012, 0.0068917488679289818, 0.0076096504926681519, 0.0055464128963649273, 0.016035696491599083, 0.010353968478739262, 0.011528684757649899, 0.013309254311025143, 0.01076396182179451, 0.0098039619624614716, 0.0073041184805333614, 0.0044371332041919231, 0.0074071194976568222, 0.0092869941145181656, 0.007588597945868969, 0.0086860088631510735, 0.0072515527717769146, 0.012914280407130718, 0.0081663308665156364, 0.0090610701590776443, 0.0093116583302617073, 0.0084845675155520439, 0.0069012222811579704, 0.0053004547953605652, 0.0096679516136646271, 0.010855820961296558, 0.0090514924377202988, 0.0041058706119656563, 0.012700988911092281, 0.010858518071472645, 0.0080013815313577652, 0.0067042992450296879, 0.0039017773233354092, 0.011183612048625946, 0.0065676984377205372, 0.0087337242439389229, } };
const TfArray<192, int> quant102_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant102 = { (TfLiteFloatArray*)&quant102_scale, (TfLiteIntArray*)&quant102_zero, 3 };
const ALIGN(8) int32_t tensor_data103[32] = { -6345, -4117, -15964, 7544, -1893, 7590, 1642, 9800, -4919, -4147, 1423, 9816, -5038, 3089, 102, -16168, 3770, 924, 14005, -4468, -5903, 7659, -802, -13269, 8973, -8266, -17605, -12778, -14277, 12474, 15992, 14339, };
const TfArray<1, int> tensor_dimension103 = { 1, { 32 } };
const TfArray<32, float> quant103_scale = { 32, { 5.6017877795966342e-05, 3.7217199860606343e-05, 3.9382026443490759e-05, 5.5999502365011722e-05, 5.3504089009948075e-05, 4.0189337596530095e-05, 4.9666821723803878e-05, 3.8549413147848099e-05, 5.9121492085978389e-05, 3.6681114579550922e-05, 9.1365334810689092e-05, 3.9910275518195704e-05, 4.0329090552404523e-05, 6.405968451872468e-05, 3.8831680285511538e-05, 3.7638408684870228e-05, 2.6120933398487978e-05, 5.5742239055689424e-05, 4.6731514885323122e-05, 4.7023080696817487e-05, 4.0112860006047413e-05, 4.7461744543397799e-05, 5.715503721148707e-05, 3.471052332315594e-05, 4.0023129258770496e-05, 5.8127021475229412e-05, 4.168921077507548e-05, 4.3157007894478738e-05, 2.7616048100753687e-05, 6.0354097513481975e-05, 5.448057345347479e-05, 3.2757368899183348e-05, } };
const TfArray<32, int> quant103_zero = { 32, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant103 = { (TfLiteFloatArray*)&quant103_scale, (TfLiteIntArray*)&quant103_zero, 0 };
const ALIGN(8) int8_t tensor_data104[1*3*3*192] = { 
  /* [0][0][][] */ -86,80,106,-65,73,113,-11,-57,-71,82,64,68,80,-84,-100,88,95,-106,-104,81,91,-111,78,87,90,88,78,-94,97,88,105,-79,-104,116,81,123,66,-94,88,-78,62,74,76,82,-92,-96,67,90,99,127,-97,72,-73,-63,102,92,121,91,111,91,90,83,96,30,83,75,84,-99,55,-63,70,79,102,-93,-86,-93,70,-106,75,113,91,105,91,-77,97,-70,-88,1,-80,88,-70,95,97,-75,-93,101,82,93,95,51,64,-90,-6,101,72,119,-50,84,76,-79,-56,83,81,89,-106,92,90,126,-82,89,-72,-66,-73,-101,69,70,-123,-86,-114,108,90,108,110,106,-69,85,-63,-95,81,110,109,-3,-73,-95,36,105,-49,80,127,-106,97,-79,-102,-78,69,74,-108,-104,77,25,-92,109,65,-119,74,-76,114,82,75,82,-82,-120,-101,-57,-56,110,-127,76,79,-86,85,73,-94,95,-91,-59,93,125,-110,100,71,-77, -104,102,127,-78,76,119,-45,-77,-87,97,75,79,93,-101,-101,109,111,-115,-127,99,105,-127,93,101,105,110,86,-101,112,109,109,-101,-114,127,95,127,73,-111,109,104,71,89,91,93,-111,-102,83,107,115,124,-112,90,-72,-85,112,107,-81,104,127,104,104,99,108,32,97,88,97,-109,61,-81,89,93,127,-102,-92,-116,76,-112,95,127,104,127,106,-97,112,-81,-100,16,-97,103,-87,116,111,-96,-112,117,102,104,109,60,75,-102,-15,121,89,127,-53,102,89,-100,-71,92,94,101,-110,109,127,-9,-89,99,-109,-76,-85,-118,-7,88,-123,-96,-123,122,94,127,127,112,49,102,-66,-102,92,122,124,73,-98,-104,52,127,-77,97,-64,-114,113,-95,-122,-97,85,86,-121,-117,89,35,-107,127,85,-110,91,-102,127,105,93,95,-91,-127,-118,-69,-72,121,-122,88,94,-104,101,96,-114,105,-112,-73,102,127,-121,105,84,-100, -31,39,30,-47,25,29,-46,-36,-30,31,23,25,30,-49,-41,38,33,-39,-54,36,24,-46,27,29,28,37,25,-23,14,37,26,-33,-30,75,25,14,17,-40,41,127,22,33,36,32,-40,-61,34,39,37,26,-40,27,-31,-18,48,33,-65,27,23,28,31,31,26,17,24,28,29,-24,33,-35,36,33,44,-44,-28,-45,20,-36,27,21,39,29,28,-42,37,-23,-30,15,-26,33,-42,25,33,-41,-58,30,33,36,23,6,20,-48,-16,32,31,16,-17,48,20,-40,-38,25,31,30,-58,32,53,-125,-46,33,-56,-10,-30,-50,-90,27,-47,-40,-59,36,23,29,46,18,-84,30,-20,-29,30,27,17,44,-57,-36,23,48,-30,29,-51,-41,39,-38,-51,-41,23,14,-40,-54,24,17,-39,17,34,-29,24,-53,63,41,35,19,-34,-43,-39,-21,-36,38,-58,38,29,-43,30,28,-53,16,-46,-25,24,25,-48,26,30,-42, 
  /* [0][1][][] */ -97,101,110,-97,118,117,121,-108,-104,106,110,106,107,-110,-112,99,105,-118,-101,107,109,-67,105,113,112,106,108,-127,109,102,124,-97,-113,-40,113,101,110,-110,100,-121,105,112,104,108,-108,-104,102,106,107,115,-104,95,-111,-90,107,110,127,112,119,107,107,105,110,103,105,118,110,-111,110,-104,102,108,98,-118,-108,-107,114,-124,105,111,113,67,110,-112,105,-116,-116,97,-112,112,-105,112,104,-109,-99,110,105,113,110,108,103,-113,74,112,106,123,-105,107,110,-107,-98,113,105,115,-127,108,-22,110,-127,108,-95,-103,-105,-117,90,108,-127,-100,-126,111,107,94,93,115,-50,102,-111,-127,103,113,116,40,-98,-108,95,95,-87,111,115,-127,102,-101,-103,-100,105,113,-99,-123,109,104,-104,81,99,-124,103,-92,-63,101,100,108,-106,-108,-109,-104,-109,101,-124,107,105,-102,109,100,-120,108,-92,-94,119,39,-118,112,109,-108, -127,127,126,-127,127,127,127,-127,-127,127,127,127,127,-127,-127,127,127,-127,-115,127,127,-76,127,127,127,127,127,-126,127,127,127,-127,-127,-53,127,100,127,-127,127,29,127,127,127,127,-127,-127,127,127,127,119,-127,127,-127,-127,127,127,-115,127,123,127,127,127,127,127,127,127,127,-127,127,-127,127,127,114,-127,-127,-127,127,-127,127,127,127,75,127,-127,127,-127,-127,127,-127,127,-127,127,127,-127,-127,127,127,127,127,127,127,-127,88,127,127,127,-127,127,127,-127,-127,127,127,127,-113,127,16,-43,-117,127,-127,-127,-127,-127,8,127,-116,-127,-127,127,127,114,113,127,86,127,-127,-126,127,127,127,127,-127,-127,127,106,-127,127,-99,-127,127,-127,-127,-127,127,127,-127,-127,127,127,-127,93,127,-127,127,-127,-69,127,127,127,-127,-109,-127,-127,-127,127,-120,127,127,-127,127,127,-127,127,-127,-127,127,31,-127,127,127,-127, -62,44,36,-55,40,29,2,-44,-43,42,46,37,34,-77,-54,41,44,-42,-37,46,29,-25,44,35,36,43,33,-61,37,46,32,-47,-37,8,39,3,34,-48,39,64,41,46,48,53,-52,-68,50,44,47,24,-53,37,-66,-37,49,37,-69,24,7,39,36,37,41,42,41,29,39,-38,44,-59,42,42,34,-58,-67,-54,28,-70,33,39,46,20,40,-65,55,-71,-63,43,-63,40,-75,26,46,-57,-53,34,37,35,29,35,39,-54,19,44,43,13,-45,46,30,-60,-64,39,40,37,-57,39,22,-127,-62,36,-59,-49,-66,-54,-127,34,-71,-55,-52,49,35,41,49,36,-127,42,-36,-76,45,39,27,58,-71,-52,52,44,-63,34,-63,-59,56,-60,-58,-60,29,31,-33,-56,35,36,-45,7,47,-86,37,-72,-17,44,45,21,-48,-42,-41,-53,-46,47,-66,45,41,-66,39,35,-60,26,-59,-44,36,-15,-55,40,41,-60, 
  /* [0][2][][] */ -53,37,41,-71,64,33,82,-66,-53,35,64,60,45,-84,-45,41,35,-33,-19,46,33,17,54,42,43,38,45,-70,47,35,45,-42,-43,-63,47,-17,51,-44,37,-94,57,51,52,45,-52,-61,52,40,28,23,-48,53,-60,-45,46,43,67,42,52,45,35,40,38,89,39,50,42,-60,70,-81,44,54,24,-69,-75,-49,55,-72,46,31,63,4,39,-70,38,-92,-52,87,-45,45,-71,24,36,-60,-66,34,49,43,38,61,53,-58,-109,34,55,25,-64,31,48,-65,-67,53,41,41,-64,44,-37,70,-59,45,-74,-72,-68,-61,69,54,-83,-42,-64,43,42,18,5,34,-49,41,-69,-72,35,25,39,44,-60,-54,61,15,-47,66,72,-68,45,-58,-51,-48,48,32,-14,-81,50,81,-27,15,47,-73,46,-61,-82,32,42,30,-67,-61,-64,-60,-55,31,-75,52,53,-58,27,44,-90,34,-47,-43,56,-21,-42,36,45,-57, -75,50,41,-90,65,37,83,-79,-59,50,77,70,49,-96,-60,51,45,-48,-23,60,40,21,70,51,43,54,60,-73,51,45,44,-46,-43,-89,57,-21,59,-48,45,25,72,59,65,60,-67,-89,65,55,34,24,-61,64,-71,-55,55,48,-87,45,50,53,43,48,46,112,49,58,52,-93,82,-90,63,62,30,-76,-77,-62,64,-85,52,31,63,-10,49,-85,47,-101,-61,111,-54,42,-70,29,46,-69,-66,46,56,47,43,73,60,-52,-127,47,67,21,-85,41,61,-68,-73,58,49,51,-75,55,-25,-4,-75,58,-87,-83,-74,-56,-2,60,-92,-54,-80,58,52,25,27,41,74,54,-71,-69,48,29,36,93,-77,-70,81,18,-64,71,-46,-77,66,-76,-61,-62,59,35,-24,-106,54,89,-37,9,60,-79,56,-89,-99,45,58,30,-90,-75,-70,-73,-80,33,-102,67,60,-61,36,54,-85,44,-56,-52,58,-34,-61,44,48,-76, -27,20,12,-36,24,11,13,-21,-12,20,38,22,12,-35,-24,18,17,-1,-9,26,8,18,27,18,23,22,21,-31,18,18,12,-6,-10,-33,19,6,13,-14,8,59,29,28,32,29,-19,-27,29,18,15,27,-7,18,-42,-7,19,12,-22,1,-5,14,11,17,13,45,29,20,21,-52,1,-34,23,21,3,-41,-33,-14,20,-23,6,18,36,-17,15,-45,28,-28,-31,35,-21,21,-47,2,16,-17,-24,17,21,6,12,26,20,-24,-88,18,25,-7,-30,-3,15,-17,-28,26,18,15,-34,13,-11,-67,-37,22,-37,-32,-21,-12,-108,22,-28,-23,-29,27,17,14,11,9,-24,25,-24,-33,15,19,16,48,-35,-16,39,12,-29,14,-46,-16,23,-28,-15,-18,18,48,18,-45,15,34,-3,3,28,-55,21,-45,-44,15,25,-1,-47,-25,-35,-10,-14,10,-22,26,18,-22,15,15,-39,6,-9,-18,18,-26,-11,11,17,-44, 
};
const TfArray<4, int> tensor_dimension104 = { 4, { 1,3,3,192 } };
const TfArray<192, float> quant104_scale = { 192, { 0.0029356232844293118, 0.0038016808684915304, 0.0056880754418671131, 0.0035264361649751663, 0.0036239044275134802, 0.0043810992501676083, 0.006664882879704237, 0.0031449696980416775, 0.0031852780375629663, 0.003310768399387598, 0.0038847010582685471, 0.0041267769411206245, 0.0039933980442583561, 0.00305140670388937, 0.0038706797640770674, 0.0033900474663823843, 0.0041103418916463852, 0.0030306580010801554, 0.0033328481949865818, 0.0045131216756999493, 0.0049378462135791779, 0.0037156746257096529, 0.0043176142498850822, 0.0039496216922998428, 0.0051105679012835026, 0.0038087875582277775, 0.0058108875527977943, 0.0028373899403959513, 0.0037645678967237473, 0.0048241508193314075, 0.0037719635292887688, 0.0029836150351911783, 0.003268109867349267, 0.0043301153928041458, 0.0044395998120307922, 0.0054292292334139347, 0.0036878229584544897, 0.0027550957165658474, 0.0046818377450108528, 0.0038896605838090181, 0.0050049745477735996, 0.0038711538072675467, 0.0036580937448889017, 0.00462768180295825, 0.0030445142183452845, 0.0025963678490370512, 0.0039448495954275131, 0.0044776424765586853, 0.0036890767514705658, 0.0043975929729640484, 0.0039685564115643501, 0.0037254409398883581, 0.0027988450601696968, 0.0037550767883658409, 0.0033541691955178976, 0.0041120885871350765, 0.0041201910935342312, 0.0039815767668187618, 0.0031355863902717829, 0.0040274341590702534, 0.0047547663561999798, 0.0041062184609472752, 0.005059409886598587, 0.004368531983345747, 0.004685679916292429, 0.0034532723948359489, 0.0039598932489752769, 0.0034742094576358795, 0.0049397433176636696, 0.0037280302494764328, 0.0051051932387053967, 0.0063157840631902218, 0.0050898664630949497, 0.0029936977662146091, 0.0028404328040778637, 0.0033051872160285711, 0.0041536404751241207, 0.0028128016274422407, 0.0041789724491536617, 0.0034780965652316809, 0.0044191614724695683, 0.0034357109107077122, 0.0036923226434737444, 0.0035192000214010477, 0.0034382655285298824, 0.0033413008786737919, 0.0032377266325056553, 0.0042750057764351368, 0.0030309578869491816, 0.0045406208373606205, 0.0032017400953918695, 0.0029588290490210056, 0.003568657673895359, 0.0036604863125830889, 0.0026546129956841469, 0.0040486566722393036, 0.0046496069990098476, 0.0051538911648094654, 0.0042341370135545731, 0.0037332100328058004, 0.003867023391649127, 0.0038890482392162085, 0.0072540710680186749, 0.0034676359500735998, 0.0053702443838119507, 0.0042712953872978687, 0.0037193275056779385, 0.0036009298637509346, 0.0039793546311557293, 0.0034284088760614395, 0.0039033093489706516, 0.0045357998460531235, 0.0046940981410443783, 0.0039990921504795551, 0.0026644477620720863, 0.0037247505970299244, 0.0059553245082497597, 0.0036469704937189817, 0.0031672695185989141, 0.0045406804420053959, 0.0032411119900643826, 0.0031598012428730726, 0.002888029906898737, 0.0026447516866028309, 0.005109014455229044, 0.0037266802974045277, 0.0030127398204058409, 0.002982723992317915, 0.0022157731000334024, 0.0051403115503489971, 0.0047505917027592659, 0.0057826689444482327, 0.0032645559404045343, 0.0038107126019895077, 0.0057368259876966476, 0.0044969953596591949, 0.0033138908911496401, 0.0026486818678677082, 0.0043179714120924473, 0.0046405983157455921, 0.0044224443845450878, 0.0039224829524755478, 0.0029005755204707384, 0.0037352335639297962, 0.0042511187493801117, 0.0044773658737540245, 0.0031172072049230337, 0.0032830918207764626, 0.0047317110002040863, 0.0032057731878012419, 0.0041787205263972282, 0.0035599700640887022, 0.0025344379246234894, 0.003771734656766057, 0.003764245193451643, 0.0049211806617677212, 0.0027881597634404898, 0.0025980377104133368, 0.0051148524507880211, 0.0032583426218479872, 0.0028142784722149372, 0.004707985557615757, 0.0047549605369567871, 0.0024503192398697138, 0.0043408581987023354, 0.0033475726377218962, 0.0042796144261956215, 0.0037028074730187654, 0.0042168921791017056, 0.0046847579069435596, 0.0032611615024507046, 0.0030257762409746647, 0.0033105607144534588, 0.0036274022422730923, 0.003585627768188715, 0.0039997515268623829, 0.0025498014874756336, 0.0049901921302080154, 0.0046034455299377441, 0.0037289001047611237, 0.0047181216068565845, 0.0036494263913482428, 0.0026173566002398729, 0.0036308614071458578, 0.0030357097275555134, 0.0035475266631692648, 0.0042883078567683697, 0.0047872434370219707, 0.003046361031010747, 0.0035848501138389111, 0.0048780669458210468, 0.0030341977253556252, } };
const TfArray<192, int> quant104_zero = { 192, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant104 = { (TfLiteFloatArray*)&quant104_scale, (TfLiteIntArray*)&quant104_zero, 3 };
const ALIGN(8) int32_t tensor_data105[56] = { -10309, 6370, -792, 6245, 10016, 12217, 1634, 29909, 8931, 501, 22124, -10219, -1681, 2569, -5968, -8024, -13791, -304, 11949, -19463, -51638, 8628, 6702, 20808, 580, -2650, -18283, -4971, 9109, -2411, 3265, -8478, -846, -20671, 18936, 12114, 32465, 3657, 16667, 8365, 19608, -10442, 20067, -461, -5499, 1854, 16271, 19473, -5448, 12970, -11773, 2537, -13824, -2033, 9359, -7987, };
const TfArray<1, int> tensor_dimension105 = { 1, { 56 } };
const TfArray<56, float> quant105_scale = { 56, { 7.2240465669892728e-05, 7.0670364948455244e-05, 5.5462111049564555e-05, 5.9263846196699888e-05, 8.2226259110029787e-05, 7.2285125497728586e-05, 6.2043356592766941e-05, 6.732973997713998e-05, 6.9061490648891777e-05, 7.6430012995842844e-05, 7.1860333264339715e-05, 6.1540260503534228e-05, 7.0528927608393133e-05, 7.5404022936709225e-05, 5.3714946261607111e-05, 7.0744586992077529e-05, 7.6782016549259424e-05, 6.3527695601806045e-05, 7.7605676779057831e-05, 6.412321818061173e-05, 6.234163447516039e-05, 8.6520682089030743e-05, 6.1406833992805332e-05, 6.8737717811018229e-05, 6.2593077018391341e-05, 5.7496712543070316e-05, 5.6817963923094794e-05, 7.6120006269775331e-05, 7.5629621278494596e-05, 7.5872201705351472e-05, 6.7461376602295786e-05, 7.5156305683776736e-05, 5.6469401897629723e-05, 6.6934015194419771e-05, 8.412462193518877e-05, 5.6168450100813061e-05, 6.5429863752797246e-05, 6.5640429966151714e-05, 6.8041721533518285e-05, 6.0070735344197601e-05, 6.1911116063129157e-05, 6.626477261306718e-05, 6.0959566326346248e-05, 6.3929859607014805e-05, 7.104472751962021e-05, 6.3623781898058951e-05, 5.318453986546956e-05, 6.5403983171563596e-05, 6.2863895436748862e-05, 7.1888214733917266e-05, 6.0600661527132615e-05, 6.2723207520321012e-05, 7.1010937972459942e-05, 7.0424153818748891e-05, 6.5750908106565475e-05, 5.8703510148916394e-05, } };
const TfArray<56, int> quant105_zero = { 56, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant105 = { (TfLiteFloatArray*)&quant105_scale, (TfLiteIntArray*)&quant105_zero, 0 };
const ALIGN(8) int8_t tensor_data106[1*3*3*336] = { 
  /* [0][0][][] */ 31,7,61,-112,32,7,-127,-7,-55,-15,-121,-127,15,-24,72,-10,46,-5,-75,-51,62,17,-41,-3,-108,-75,-60,6,44,-91,76,-127,-13,-113,-103,-84,-127,-127,42,-95,17,-9,-97,-13,-48,-10,-41,-55,5,-5,-19,-19,-49,8,-4,15,2,4,-124,59,-90,26,-37,-2,-3,-19,-127,-33,41,7,14,-68,-98,20,-65,57,37,99,9,127,40,-122,39,26,-87,-115,-3,-21,71,-39,-32,-2,-114,82,-12,81,-71,14,-114,-127,-17,72,-26,-22,102,38,-28,-46,-56,-64,34,33,127,17,-13,-127,-127,-7,-64,30,-3,33,-62,99,-21,80,-14,46,19,-4,-18,-127,40,-19,6,-34,75,30,-17,-34,-12,11,6,-22,-58,-28,-7,25,69,-127,80,47,34,-87,-6,-20,-27,-10,-1,-16,-14,-83,28,3,-36,16,23,9,4,28,-40,-15,66,7,-123,114,-54,-127,51,-88,-48,31,-4,-39,127,42,-65,42,-127,-74,-64,85,29,-26,-20,24,-36,32,31,117,19,47,-8,-40,62,109,-61,-124,31,-18,-127,0,-3,18,-24,-15,-12,7,-65,-34,-80,28,-4,-127,-30,7,-24,-127,-17,-10,-127,27,-127,-21,-83,43,-19,0,28,28,-31,-62,-5,3,53,-4,17,-9,63,-28,-38,72,61,102,-105,-127,-110,105,-1,-4,57,-19,28,-50,47,-63,-94,-34,-4,59,-38,-13,36,2,53,9,-81,-127,-27,63,26,68,-103,58,-93,-8,93,-23,-6,-62,57,11,-118,-127,-49,-3,61,19,-26,34,-24,81,-8,5,14,38,72,-127,32,-28,48,-92,1,27,35,-56,24,0,-87,0,-49,-127,61,-1,10,-47,-22,33,-91,7,-67,62,-73,-33,35,-20, 127,73,127,-100,1,6,-78,-31,27,-12,-20,-91,127,73,-8,31,127,-29,-76,-47,80,53,-95,26,-127,-36,-33,127,103,39,113,-103,-8,-114,-127,-46,21,-85,127,-99,84,64,62,-92,11,65,-127,-118,83,11,-28,61,-59,-127,127,109,1,-1,-127,36,-95,127,-17,-5,-36,127,-49,-8,-91,-6,18,-56,47,127,-127,29,97,96,31,6,113,-124,127,42,-127,-73,-4,-68,126,-55,-30,84,-73,101,54,42,58,-102,-77,-120,-92,23,-22,14,48,40,0,-127,-90,-108,-9,29,80,127,-113,-60,-68,-51,-102,112,3,62,-110,118,-72,56,89,-17,51,50,-3,-104,127,127,10,35,64,-76,54,-29,36,25,1,27,-57,-44,1,-127,12,87,73,-127,-23,38,-127,-127,91,73,45,-127,17,-55,127,110,88,-127,79,58,30,84,34,52,127,61,-120,68,-36,-123,59,-50,-3,97,3,-72,64,13,-34,36,-93,39,46,127,55,-107,83,40,37,26,23,29,-11,-17,-127,-96,31,127,13,-127,127,48,-86,-121,-61,127,-50,-49,-127,15,-127,-85,-126,3,-20,-124,-65,127,-127,-119,-1,35,-88,127,-86,-118,-96,37,24,-127,127,53,-114,-127,29,-97,127,24,32,-80,9,15,-106,-41,127,29,12,-69,-125,-54,127,-15,127,-34,81,-22,114,-39,-44,23,26,92,-46,-127,23,-6,127,-3,20,7,-54,127,51,75,-81,-127,-119,102,88,66,127,-97,109,-20,-109,-105,-105,9,59,127,-127,103,19,71,-69,46,102,-30,-2,-82,1,18,125,61,22,86,123,-127,17,-15,-105,42,-127,-97,-95,43,-24,66,7,36,63,40,-45,81,-114,-111,12,127, 32,8,48,-103,-54,-15,-115,-6,28,-18,-107,-109,13,-30,78,13,17,13,-53,-53,65,17,-24,-14,-77,-96,-62,-9,38,33,71,-90,14,-127,-93,-75,26,-104,41,-126,-69,-16,31,-24,47,1,-44,-42,-10,-1,19,-13,-41,12,-14,18,8,6,-102,57,-32,19,-31,0,-38,-25,-110,-31,5,11,-32,-79,53,18,-60,-76,24,72,3,111,37,-108,35,-79,-60,-127,-7,-34,62,-44,-15,-36,-75,66,-8,61,27,-45,-89,-110,-11,68,30,-17,81,15,8,-35,-52,-54,41,-64,96,11,1,-123,-95,-3,-44,11,-8,-48,-112,82,0,86,-39,45,14,-16,-10,-122,40,-17,-21,0,59,42,-37,-29,-50,-31,3,-4,-51,-27,-6,23,62,64,83,66,33,47,5,-29,-22,-1,-9,-12,-12,-76,21,-4,-36,30,15,-2,-34,22,0,-22,36,0,-98,103,-52,-114,35,-68,18,23,-7,-50,109,45,-65,34,-97,43,35,57,46,-15,-29,28,0,27,33,106,14,36,5,-27,50,82,-58,-121,14,-16,-45,10,-3,0,-37,-16,-11,-1,-63,-26,-73,22,0,-93,-24,-3,-6,-122,-21,1,-100,30,-65,-9,-57,-87,-19,-15,12,-71,-38,-59,-13,5,45,4,25,-4,57,11,-48,-127,58,91,-80,-104,-86,79,-6,-1,50,-43,30,-43,36,-57,-105,-45,-8,52,-33,-12,29,3,24,7,25,30,-27,62,16,74,-127,87,-82,-2,72,-21,-10,-59,39,-1,-112,-96,-54,-7,40,10,-13,29,-27,66,-17,-8,18,45,64,-104,-41,1,39,49,-11,32,37,-46,-44,3,-56,-4,-43,-96,68,1,18,35,-18,-54,48,14,-66,77,-53,-23,34,-30, 
  /* [0][1][][] */ 3,44,-38,-119,75,100,-93,46,-127,-27,-105,-98,-7,-7,57,-40,78,-127,-127,45,26,-20,33,-2,-127,-55,-46,4,8,-127,87,-101,-127,-110,84,-29,8,-94,44,-87,127,40,-102,-127,-127,92,-12,42,-47,4,86,2,-19,47,-29,127,-9,30,-94,118,31,10,-26,28,-127,66,-98,-18,-76,29,97,-26,-127,13,26,104,54,50,127,8,35,-127,20,84,-52,-57,-17,-24,-50,-8,-12,-71,-79,57,10,104,-127,-124,-115,-93,-117,57,-127,20,52,127,-127,-54,-27,-24,26,76,103,-20,-97,-34,-75,127,93,127,127,115,-110,-95,101,50,20,127,28,-18,31,-119,106,-1,65,-127,38,127,-24,-32,39,106,14,49,-127,-127,-2,-22,52,71,90,-13,-5,-127,24,-40,-102,11,35,100,2,-115,48,68,127,63,26,32,104,25,-127,-16,120,35,-116,13,-11,-80,61,-38,-127,74,26,-127,86,93,16,31,-90,-127,-127,-14,-127,31,76,72,-127,24,50,30,127,65,8,-90,35,88,20,-124,-64,24,-69,-118,-26,0,-25,73,7,127,-102,-7,-6,47,127,-89,-127,-7,81,-113,-16,57,-113,19,-82,42,-11,66,-95,-120,-36,112,-19,42,4,-17,63,31,117,-13,14,-127,-127,41,95,34,-126,-79,-127,126,-32,19,-13,18,35,-30,99,12,127,-114,11,81,-12,5,62,89,17,25,-127,10,44,117,30,73,-75,58,-25,29,127,85,-3,-21,-66,127,-109,-108,-44,65,119,-22,105,48,2,74,-127,9,18,101,68,-96,127,-127,62,-127,3,115,80,-54,53,4,3,51,-43,-120,86,27,75,-127,-4,71,-127,127,127,95,127,-11,30,-41, 84,127,-118,20,77,47,67,127,69,127,-54,-58,53,96,-127,-65,-4,81,-68,127,-127,23,-74,127,13,127,127,-1,127,102,-127,-115,57,-82,37,127,-14,-39,-17,-41,-46,127,-127,-30,-4,127,100,-24,127,127,58,127,127,17,-49,100,127,127,-78,-127,127,-30,127,-127,84,85,-34,127,127,127,12,127,94,77,49,63,47,-127,49,-123,29,-18,-91,31,-21,-46,127,-127,96,127,2,76,50,-127,127,-41,72,127,-90,74,127,-127,69,127,-127,-89,65,13,127,127,-127,50,8,-59,-127,81,-50,-68,81,-121,-63,-67,-127,86,-42,-127,127,-98,127,127,127,-93,-15,76,81,81,-127,-85,127,34,127,19,127,127,-103,-68,127,-83,-127,-83,-127,-75,-106,65,93,82,127,127,127,44,127,-127,-56,17,100,40,127,127,46,43,74,112,-99,127,12,-127,127,-13,-127,-81,116,127,127,-59,-100,61,127,54,69,24,26,-47,-91,127,127,127,9,-127,127,47,-99,-29,67,-116,-127,-66,127,-85,-9,127,-35,-63,-50,13,127,-127,56,99,-59,127,127,-127,-89,-97,-72,-49,69,-50,127,127,-3,105,-36,11,127,122,127,-9,-23,34,-41,78,127,127,111,127,-11,4,-127,67,-46,26,-29,-127,-53,43,30,59,-21,127,-72,-70,127,127,94,127,-15,-114,127,-127,127,79,-127,12,-72,-127,72,-18,85,-32,127,-127,-50,-31,127,-6,-77,127,61,95,117,25,60,-81,127,127,-127,-10,37,53,127,-127,-67,127,56,-46,-127,-33,-96,41,9,74,127,-92,127,-103,91,-127,127,127,91,-117,80,127,37,85,127,68,10,114,-78,10,17,127,-127,110, -18,31,-11,-127,-127,-127,-87,32,87,-44,-113,-86,-1,-29,46,54,70,80,-109,-37,38,-32,30,-16,-117,-61,-55,22,19,77,29,-106,87,-94,64,-38,15,-71,48,-95,-115,50,94,-123,123,86,-1,43,-30,10,-127,-13,-30,47,-16,122,-7,15,-100,109,-100,16,-35,44,85,84,-99,-32,31,10,-127,-10,97,5,21,-127,50,43,102,12,22,-122,15,-127,-63,-55,-25,-28,-43,-52,2,-127,-64,25,6,108,64,68,-114,-81,43,45,71,1,49,121,84,-56,-20,-27,34,-127,86,-10,-62,-57,-67,107,-127,103,125,-127,-93,-81,82,52,-6,125,16,-45,29,-124,100,-20,-127,45,40,105,-54,-29,-85,-127,5,34,-115,-99,-9,1,67,-64,75,-10,-9,88,12,-18,-85,9,14,87,-9,-69,39,64,125,38,17,18,-127,18,72,-17,113,19,-127,43,-19,-87,71,-47,67,63,17,-124,116,83,19,28,-102,99,95,5,-108,11,67,44,105,31,37,72,125,86,-8,-95,23,105,2,-123,-56,31,-56,-127,-21,-2,-13,96,13,108,-105,-16,-16,53,127,-93,-87,-8,78,-86,-19,50,-77,16,-50,38,-14,-127,33,-107,-33,-127,11,31,-11,-25,61,12,106,-9,33,76,-116,70,92,29,-127,-94,-118,127,-32,11,-1,22,28,-35,83,6,105,-127,3,94,-42,4,63,-127,-17,28,85,21,42,96,11,46,-102,55,-13,44,110,67,-9,-12,-67,120,-120,-88,-34,48,110,-20,-118,42,-7,74,-80,-5,13,93,78,-93,-112,83,50,81,4,127,76,-47,-127,14,-30,36,-34,-97,88,21,59,52,-6,-127,109,119,119,84,100,-24,38,-74, 
  /* [0][2][][] */ -70,34,116,-76,4,7,-102,-26,-48,-25,-99,-93,-40,8,99,47,-102,-33,-42,-27,62,52,72,-33,-59,-41,-89,15,30,-38,1,-108,-38,-96,14,-32,50,-42,40,-127,-7,1,-101,-25,-13,17,19,27,-80,-1,13,-81,-23,34,-11,64,7,-2,-83,66,-15,13,-102,69,-52,-2,-85,-31,-17,21,-4,9,-48,7,20,38,-80,70,53,82,-53,-107,-28,95,-47,-8,-30,-22,-87,-26,29,10,-127,11,-3,127,-25,-34,-127,-73,-45,114,-27,-23,74,-2,-42,61,11,12,53,4,110,2,3,-104,-114,-34,35,-46,51,11,-41,-46,127,62,-81,38,14,10,4,86,8,52,13,-8,48,20,-46,-7,-74,-7,0,-55,-29,-31,-20,15,68,53,86,58,63,-45,-21,-1,-17,-9,6,53,-7,-63,31,-39,56,74,-33,-2,14,-47,-36,-38,43,-15,-95,-15,-14,-94,16,-100,-38,-37,-15,-56,49,9,2,46,-97,-73,-31,-27,-41,8,-28,0,-41,39,37,67,-10,69,-9,-14,23,96,-77,-78,-33,-2,-38,7,8,35,-6,42,7,-25,-40,5,26,9,25,-70,-3,-19,-28,-121,-34,1,-92,-34,-87,69,-8,-69,-33,-77,-32,36,54,-7,-36,-16,4,7,87,11,73,-5,-49,45,57,71,-39,-98,-121,-81,-41,-15,-21,-8,2,-59,-4,-2,59,-23,0,45,-41,10,25,8,-43,89,-44,54,10,66,11,50,-85,104,0,50,92,-6,-16,88,-53,1,-106,-108,-1,-16,30,-41,30,-57,6,57,-28,-51,-62,30,89,-95,28,-31,-47,-4,21,107,19,-19,28,81,49,-33,-32,-122,-26,-1,33,-25,-13,15,-40,-14,108,96,19,-8,53,-19, -83,-4,67,-76,44,-2,-83,51,6,-6,-127,-107,-62,127,71,91,-123,-8,2,64,28,127,127,-77,-109,-48,-91,-1,-2,-35,-25,-51,26,-97,102,60,108,-30,3,-76,14,58,127,69,-14,42,64,127,-77,14,10,-91,-19,124,92,104,-27,23,-40,60,47,-39,-63,106,30,104,-30,42,51,-8,4,120,-31,34,82,41,-127,-13,-4,24,-127,-104,-52,24,-60,-32,-51,-89,-127,-6,127,25,-80,-2,-26,104,8,85,-84,-79,-12,56,4,1,73,-29,30,127,40,65,59,8,29,-82,-86,-24,-53,-33,44,-102,-29,48,-55,-127,90,47,-114,-30,19,43,9,90,-27,-6,6,12,34,-49,-65,127,-84,-8,17,13,23,-94,-36,-89,50,-58,47,-97,127,-47,13,98,77,1,-11,-30,-6,-91,42,-127,83,100,-34,22,22,-127,14,-127,52,5,-99,-79,18,-96,41,-69,-12,-34,6,-119,-13,127,25,127,-62,33,13,-104,-100,44,82,31,27,32,9,127,25,127,84,-127,20,24,-61,-43,-4,26,-42,-108,127,2,4,88,75,93,-123,51,115,5,-44,-67,-10,-3,96,-38,-17,20,-72,19,-90,127,15,-99,61,-48,-57,-67,127,99,-19,1,-51,2,127,127,33,10,-98,-36,-55,8,-74,-105,-73,3,54,25,-96,-127,36,-37,-127,57,-49,80,-17,21,-6,97,-31,-2,-96,91,-48,34,127,66,48,44,-44,98,70,-127,76,-16,42,127,-127,-46,-127,-100,46,33,11,-5,91,-127,10,70,-46,-22,-127,127,34,-95,-11,37,-127,-89,49,111,-29,62,-11,113,55,13,29,-111,-127,16,127,22,-19,-2,45,106,92,127,-3,26,26,-23, -48,31,104,-79,-36,-21,-79,-30,25,-34,-90,-54,-39,5,100,-127,-86,18,-33,-60,56,45,74,-41,-37,-59,-74,-2,26,12,9,-91,23,-95,11,-37,69,-38,47,-123,-10,1,35,-18,22,15,18,27,-76,-6,-18,-59,-23,33,-20,53,10,4,-81,50,-53,12,-90,60,12,-20,-76,-48,13,18,-7,19,2,8,14,-78,-69,54,35,80,-49,-84,-36,-102,-40,-21,-34,-29,-52,-38,21,8,-90,3,-2,105,26,30,-101,-63,-21,98,21,-16,69,-3,12,58,4,16,42,-34,91,7,-8,-89,-90,-45,-97,-63,52,-42,-64,-33,104,70,-67,29,29,-2,1,88,6,44,-23,4,51,21,-42,-11,-23,2,0,-49,-17,-33,-24,7,52,-84,86,54,44,34,-25,9,-19,-10,7,44,-5,-39,32,-44,47,76,-29,4,-40,-27,11,-46,31,-4,-93,-17,-18,-98,10,-127,0,-55,-13,-42,36,32,7,37,-102,25,15,-17,-39,0,-33,-6,29,36,35,60,-15,54,-10,-22,28,57,-55,-76,-25,0,-57,18,6,36,0,38,9,-28,-39,-3,11,5,19,-69,11,-20,-42,-88,-39,2,-80,-31,-61,67,-8,-30,19,-76,-28,-42,76,-21,-32,-14,6,15,80,4,60,5,-63,43,37,64,-38,-64,-103,-99,-39,-13,-30,19,3,-47,15,5,37,-36,3,39,-40,7,25,-9,-14,80,5,62,-4,65,-3,57,-81,108,-1,43,77,-1,-17,81,-49,-7,-100,-114,-5,-27,29,-43,-79,-51,6,48,-26,-43,-64,17,86,-84,-26,12,-28,-38,22,85,30,-20,-14,71,32,-26,-32,-100,-9,6,37,24,-7,-27,26,-14,90,90,21,-12,45,-11, 
};
const TfArray<4, int> tensor_dimension106 = { 4, { 1,3,3,336 } };
const TfArray<336, float> quant106_scale = { 336, { 0.0088701546192169189, 0.0082846172153949738, 0.0063470341265201569, 0.0047250306233763695, 0.0075500453822314739, 0.010608209297060966, 0.0052702273242175579, 0.0086687784641981125, 0.010224632918834686, 0.013156543485820293, 0.0039818622171878815, 0.0038405733648687601, 0.010934978723526001, 0.0083646290004253387, 0.0060462714172899723, 0.011280186474323273, 0.00585222989320755, 0.010897554457187653, 0.0063227983191609383, 0.01006982009857893, 0.0090016704052686691, 0.0077095255255699158, 0.0069723897613584995, 0.0095199383795261383, 0.0043110833503305912, 0.0083048203960061073, 0.0083862477913498878, 0.0123375179246068, 0.0054585090838372707, 0.007857603020966053, 0.0075337989255785942, 0.0038961092941462994, 0.0092783495783805847, 0.0036368542350828648, 0.0068271826021373272, 0.0096862819045782089, 0.0081204362213611603, 0.0051953364163637161, 0.0078407563269138336, 0.0044264928437769413, 0.0098856119439005852, 0.0066072428598999977, 0.0076509704813361168, 0.0071707693859934807, 0.0072254161350429058, 0.0063633657991886139, 0.0090053882449865341, 0.0072607793845236301, 0.0073933526873588562, 0.011707546189427376, 0.011257573962211609, 0.0084181670099496841, 0.009497479535639286, 0.0080819223076105118, 0.010987707413733006, 0.0041221557185053825, 0.013169352896511555, 0.0096550416201353073, 0.0042699235491454601, 0.005519205704331398, 0.0076597626321017742, 0.01041006576269865, 0.0082652894780039787, 0.0076327542774379253, 0.0094706173986196518, 0.0055430559441447258, 0.0048742233775556087, 0.013069458305835724, 0.0094043407589197159, 0.011584307067096233, 0.010599816218018532, 0.0072066024877130985, 0.0088203009217977524, 0.0082747330889105797, 0.010485460050404072, 0.0081043336540460587, 0.0088733863085508347, 0.0067947134375572205, 0.0067443912848830223, 0.0076177269220352173, 0.0085139209404587746, 0.0039060446433722973, 0.009882013313472271, 0.0072219790890812874, 0.0068061305209994316, 0.00627858005464077, 0.012578977271914482, 0.0062754042446613312, 0.0062523991800844669, 0.010237162001430988, 0.011447844095528126, 0.010163684375584126, 0.0061604850925505161, 0.0077545987442135811, 0.0091308876872062683, 0.0045304633677005768, 0.0077327489852905273, 0.0070382803678512573, 0.004121722187846899, 0.005267617292702198, 0.0085359262302517891, 0.0061663617379963398, 0.010013185441493988, 0.011209164746105671, 0.0061846710741519928, 0.0093801785260438919, 0.010074052959680557, 0.0078792469576001167, 0.0092044426128268242, 0.0087679391726851463, 0.011494304984807968, 0.010982435196638107, 0.0051159807480871677, 0.011590868234634399, 0.0049704750999808311, 0.0065197083167731762, 0.0052571333944797516, 0.0095263458788394928, 0.0075402939692139626, 0.0067726410925388336, 0.0084021994844079018, 0.0084745436906814575, 0.004071373026818037, 0.0065483083017170429, 0.0063282838091254234, 0.006562747061252594, 0.0077666142024099827, 0.0077199735678732395, 0.010863425210118294, 0.010519556701183319, 0.010263647884130478, 0.0043020774610340595, 0.0068165385164320469, 0.008985019288957119, 0.0097551718354225159, 0.01175173744559288, 0.0077457455918192863, 0.0097247716039419174, 0.010404881089925766, 0.010880405083298683, 0.0091111361980438232, 0.011677178554236889, 0.012942813336849213, 0.010026346892118454, 0.0051478669047355652, 0.0057171243242919445, 0.012655503116548061, 0.0083041228353977203, 0.0075250789523124695, 0.007772963959723711, 0.0053953733295202255, 0.0095369331538677216, 0.006850202102214098, 0.0075932741165161133, 0.011906960979104042, 0.011252277530729771, 0.0078834490850567818, 0.01217541191726923, 0.0091238431632518768, 0.0062520238570868969, 0.015658298507332802, 0.0047286101616919041, 0.0089132729917764664, 0.0089543787762522697, 0.0046247155405580997, 0.0081042824313044548, 0.010085257701575756, 0.0090601714327931404, 0.010461382567882538, 0.008206917904317379, 0.0095987757667899132, 0.010608703829348087, 0.0053748809732496738, 0.010485930368304253, 0.0043720998801290989, 0.0065423576161265373, 0.010672133415937424, 0.0043654097244143486, 0.0092539144679903984, 0.0051976721733808517, 0.0091501427814364433, 0.0063689667731523514, 0.011832397431135178, 0.0051082847639918327, 0.0057793739251792431, 0.0059743835590779781, 0.010133765637874603, 0.0070714042522013187, 0.0047086635604500771, 0.0096607524901628494, 0.0097369998693466187, 0.0073242168873548508, 0.0061273439787328243, 0.0095085958018898964, 0.0055604046210646629, 0.0073148827068507671, 0.0099334670230746269, 0.014115679077804089, 0.0068903286010026932, 0.0041806544177234173, 0.0084996391087770462, 0.0061446875333786011, 0.013450078666210175, 0.0046291430480778217, 0.011722075752913952, 0.0044846981763839722, 0.010842667892575264, 0.0036809188313782215, 0.010021017864346504, 0.0096972100436687469, 0.0065677925013005733, 0.0061025437898933887, 0.010972057469189167, 0.0095543684437870979, 0.01067441888153553, 0.0085281161591410637, 0.011230173520743847, 0.0064851082861423492, 0.0052419975399971008, 0.0093896733596920967, 0.006339190062135458, 0.015539186075329781, 0.0084879565984010696, 0.0040717143565416336, 0.0068228584714233875, 0.010424934327602386, 0.0088238008320331573, 0.0043440507724881172, 0.013312039896845818, 0.0082018524408340454, 0.0051655648276209831, 0.0066145709715783596, 0.0056542572565376759, 0.0064346920698881149, 0.01021952647715807, 0.0079077444970607758, 0.009761379100382328, 0.0055004148744046688, 0.010647286660969257, 0.007970527745783329, 0.0068392870016396046, 0.0076050753705203533, 0.01340869627892971, 0.011553565040230751, 0.0057581658475100994, 0.0099502857774496078, 0.0049772835336625576, 0.010322165675461292, 0.012213356792926788, 0.012163986451923847, 0.0043650842271745205, 0.0089891264215111732, 0.0070828837342560291, 0.0071192043833434582, 0.0048294877633452415, 0.0052290689200162888, 0.0044722761958837509, 0.0066055492497980595, 0.0097917309030890465, 0.01310307253152132, 0.0088950609788298607, 0.0093540484085679054, 0.0067114434204995632, 0.010367796756327152, 0.0060602026060223579, 0.0080074146389961243, 0.008278973400592804, 0.0062287449836730957, 0.01067035086452961, 0.0068386676721274853, 0.010191266424953938, 0.0099481334909796715, 0.012279251590371132, 0.010619102045893669, 0.0086580133065581322, 0.0062569710426032543, 0.009033706970512867, 0.010770668275654316, 0.0088724019005894661, 0.0052673290483653545, 0.0081200189888477325, 0.0069704516790807247, 0.0045962403528392315, 0.0056649362668395042, 0.007438617292791605, 0.010768434964120388, 0.0049285632558166981, 0.0085775367915630341, 0.010881598107516766, 0.005416572093963623, 0.0073053124360740185, 0.0090469736605882645, 0.0042213122360408306, 0.0041992245241999626, 0.0088521027937531471, 0.0086423503234982491, 0.0078544039279222488, 0.010955995880067348, 0.0081764915958046913, 0.0076689100824296474, 0.012846184894442558, 0.0063247820362448692, 0.0062871505506336689, 0.010551798157393932, 0.0095715885981917381, 0.0065456409938633442, 0.0056912703439593315, 0.0037842197343707085, 0.0077095655724406242, 0.011523344554007053, 0.0076165376231074333, 0.0082516102120280266, 0.0090777464210987091, 0.0052381707355380058, 0.0043584536761045456, 0.006101562175899744, 0.0097007574513554573, 0.008067745715379715, 0.0071848365478217602, 0.0087519194930791855, 0.0090608289465308189, 0.0035681899171322584, 0.0075027863495051861, 0.0092306230217218399, 0.0065458910539746284, 0.0079860584810376167, 0.014471904374659061, 0.008597848005592823, 0.0071686860173940659, 0.0052985260263085365, 0.0052671171724796295, 0.0043343757279217243, 0.0082107624039053917, 0.0094616487622261047, 0.015496563166379929, 0.0082959923893213272, } };
const TfArray<336, int> quant106_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant106 = { (TfLiteFloatArray*)&quant106_scale, (TfLiteIntArray*)&quant106_zero, 3 };
const ALIGN(8) int32_t tensor_data107[56] = { 29082, 16369, -11016, 10252, -1631, 30997, -2514, 21983, -9372, -123, -19329, -12137, 8137, -19152, 28718, 8662, -2084, -17370, -14270, 583, -1390, 7779, 2506, -5209, -31492, -2992, -18578, -3902, -29402, -8660, 8769, 13926, -31, 34453, 6716, -11090, -1719, -23252, 2520, 14085, -21524, -21473, -12849, -1667, -14393, 26079, -2394, -31379, -3647, 2874, -3725, 14907, -14146, -2931, -12671, 10047, };
const TfArray<1, int> tensor_dimension107 = { 1, { 56 } };
const TfArray<56, float> quant107_scale = { 56, { 2.1884539819438942e-05, 3.7752732168883085e-05, 2.9756334697594866e-05, 3.0675757443532348e-05, 3.0629911634605378e-05, 3.3633845305303112e-05, 2.672901791811455e-05, 2.4821021725074388e-05, 3.8397072785301134e-05, 3.2015996112022549e-05, 3.3062435250030831e-05, 3.2316838769474998e-05, 3.4602810046635568e-05, 2.6775924197863787e-05, 2.9638607884407975e-05, 2.549831333453767e-05, 2.8031616238877177e-05, 3.44089676218573e-05, 2.4970906451926567e-05, 3.6656187148764729e-05, 3.181412466801703e-05, 2.6180412532994524e-05, 2.7137981305713765e-05, 2.700549885048531e-05, 2.9087212169542909e-05, 2.9877102861064486e-05, 2.7660640625981614e-05, 3.1120733183342963e-05, 3.3311429433524609e-05, 2.8324968297965825e-05, 2.8756368919857778e-05, 3.1116025638766587e-05, 2.94412220682716e-05, 3.57625431206543e-05, 3.386441312613897e-05, 3.2590814953437075e-05, 2.892160955525469e-05, 3.8785863580415025e-05, 3.230726724723354e-05, 4.4386910303728655e-05, 3.0413952117669396e-05, 3.3607237128308043e-05, 3.7661364331142977e-05, 4.7741956223035231e-05, 2.2722408175468445e-05, 2.9309343517525122e-05, 2.7302297894493677e-05, 2.4454528102069162e-05, 2.6250063456245698e-05, 2.6563446226646192e-05, 2.6248068024870008e-05, 3.847238258458674e-05, 2.8727905373671092e-05, 3.2454525353386998e-05, 3.1386589398607612e-05, 2.8985805329284631e-05, } };
const TfArray<56, int> quant107_zero = { 56, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant107 = { (TfLiteFloatArray*)&quant107_scale, (TfLiteIntArray*)&quant107_zero, 0 };
const ALIGN(8) int8_t tensor_data108[1*3*3*336] = { 
  /* [0][0][][] */ -13,57,-71,-20,-43,53,-59,-65,-127,19,53,9,-18,-72,111,-17,-82,-51,35,-55,62,15,-127,-8,89,6,-76,-116,24,36,-13,45,-97,-127,60,121,-29,48,27,-56,-3,-7,45,78,38,-12,93,-2,-7,-6,22,48,7,-3,15,-64,-57,8,40,-99,-22,-112,44,-45,22,46,-10,9,1,8,-57,-74,-8,-33,12,46,-99,13,-36,100,12,32,44,104,59,-71,-59,-20,2,6,-125,-98,-65,75,15,-18,-55,127,0,-12,-80,2,27,-77,32,94,-124,-19,-127,-50,28,-15,58,-12,113,73,10,-117,22,9,-27,45,-14,-9,-8,26,66,13,-122,-17,17,0,89,-3,-47,12,14,-39,-65,-27,12,-64,-36,82,19,-47,19,-127,16,-72,-75,-90,-21,-11,-12,21,-127,90,55,-116,24,24,1,45,-97,-127,88,25,21,-9,13,127,72,-24,88,127,16,-11,64,-6,54,-74,-15,14,-127,16,65,57,-35,27,-4,-25,-113,5,-127,-15,-10,-78,-72,78,-10,-3,99,-51,-127,-75,37,-71,13,15,-1,102,-17,-120,56,-109,-66,4,79,50,72,104,4,-25,84,-19,-127,71,25,-39,69,-52,-55,78,67,-21,-79,-25,50,-72,-73,10,-20,-57,-3,-4,16,14,7,-12,58,3,-60,-29,-53,-79,121,-4,39,49,90,0,-33,-127,66,-14,-91,34,7,15,-28,19,40,-33,-31,-34,24,-17,63,40,-45,-48,-123,-19,-6,16,1,67,16,112,-13,-93,-21,-98,16,-47,118,19,18,9,-127,-26,-103,1,33,83,24,4,94,-43,19,-10,-24,114,-127,5,-4,-39,57,-20,58,-5,10,7,-30,-45,127,-63,-42,9,42,2,17,-7,122,35, -30,127,-127,47,-46,44,-118,-42,-50,-80,46,-10,45,-127,99,-44,60,-70,80,-61,92,-127,-106,113,64,62,-113,-74,127,127,35,-96,-3,-90,127,101,-16,127,98,-99,17,49,127,104,127,-19,74,20,49,59,108,58,59,127,2,36,-123,25,27,-12,-35,-23,-33,-112,127,127,24,35,127,46,-91,-107,12,-93,36,111,-94,99,9,59,18,26,-4,36,127,-53,-63,3,11,-32,-113,-27,-127,41,-127,19,-20,23,34,-61,-112,127,-88,-80,3,127,-117,62,-51,-63,11,-127,-113,7,63,40,-28,-107,-13,82,-10,32,67,-3,-5,127,95,-67,-110,-90,55,-123,-14,30,48,-40,13,-95,-73,-63,39,-71,6,36,37,-25,74,-94,127,-52,-93,-127,-13,61,82,51,-114,84,127,-86,79,-8,60,84,-127,-51,127,127,53,63,-81,103,-24,-18,127,69,-29,14,127,17,119,-45,74,-13,-87,29,127,127,-56,-84,-127,5,-107,-8,-90,27,-36,-73,127,11,-9,-18,-7,-100,-76,18,127,-93,40,4,10,-109,-42,-97,50,-85,45,4,25,102,6,-3,45,45,-15,17,-85,34,117,-106,61,-45,-96,96,-25,7,-47,-64,94,-96,-44,69,-47,-90,75,32,-5,-59,-22,22,87,28,-127,-61,-43,-86,60,-73,127,-17,47,6,127,-65,27,110,-127,127,24,127,32,28,127,-86,127,127,14,-65,38,101,-98,-75,-59,40,-82,-1,127,10,51,96,74,-87,12,-76,33,-2,120,124,127,40,-98,-47,-61,55,11,-2,36,47,127,-51,16,-50,-99,36,-88,-7,5,-127,24,-4,-4,-2,-21,-4,-86,-127,-12,-32,-127,22,127,31,33,126,127,87, -14,56,-76,-22,-35,42,-53,-63,-88,22,-96,17,-17,-63,97,-8,49,-41,32,-46,47,1,-110,9,93,15,-78,-110,31,38,-6,56,21,-86,41,95,-32,47,28,-38,-7,-2,49,53,34,-18,-5,-6,-9,5,16,-82,2,3,20,40,-84,7,-80,-96,-12,-95,42,-49,23,40,-10,5,4,3,-54,-56,-2,-127,7,34,-94,12,-47,93,14,24,-43,101,52,-64,-99,70,0,13,-127,-79,-53,72,2,-16,-45,122,-9,7,-84,6,13,-84,-31,71,-127,-29,-93,-47,34,-8,50,8,90,68,-3,-107,-46,2,-5,57,-16,-1,-2,31,59,23,-102,-3,24,-19,82,-2,27,21,13,-55,-51,-38,10,-46,27,72,-82,14,21,-103,13,-54,-20,-82,-64,-10,-12,25,-120,79,45,-114,26,14,-5,35,-112,-70,80,34,17,-14,16,125,48,-47,72,120,11,4,50,-1,63,-71,-72,19,-98,27,69,64,-28,23,-7,127,-116,4,-127,2,85,-77,11,70,3,6,115,-37,-53,19,61,-64,20,2,-6,78,-30,-85,54,-96,-79,7,66,46,-127,100,3,-21,68,-27,-100,71,11,-29,70,-46,-41,74,56,-12,-72,-12,51,-77,-64,14,-25,-71,-8,1,-43,11,19,-21,73,-74,-65,-17,-45,-67,127,-8,42,28,79,38,-39,-90,110,-12,-79,33,6,17,-24,12,42,-45,-24,-12,13,-26,66,36,-45,-46,-120,-42,0,12,-3,68,14,89,-21,-100,-11,-97,12,-32,114,6,5,7,-122,-9,-91,6,16,74,20,-3,80,-16,27,-6,-15,108,-123,12,-3,-40,48,-8,-27,-8,7,3,-23,-48,100,-55,-43,18,38,0,4,1,127,43, 
  /* [0][1][][] */ 24,68,-84,-8,-66,64,84,127,-54,10,100,16,13,75,117,8,-104,26,29,42,125,106,-92,127,113,9,-122,-127,-15,-3,56,106,-125,-69,18,82,31,44,-28,-76,34,65,-7,120,53,-33,127,58,-40,87,-13,91,-3,115,8,-127,-92,80,127,-47,-34,53,36,-95,-9,-20,7,33,77,35,-127,0,10,21,18,29,-118,11,-72,84,19,32,97,46,67,-112,14,82,23,13,-103,-80,-25,29,117,-109,-72,107,12,20,-109,-17,44,-98,83,75,-118,127,-58,-101,21,-4,-55,-127,126,50,80,-119,90,115,-127,6,24,114,67,69,83,127,-117,31,68,-32,120,38,-127,-84,25,77,-110,-22,17,-94,-127,84,127,-110,9,-107,5,-127,45,-96,45,34,14,28,119,-127,7,127,9,36,8,-11,70,-64,-106,-12,4,2,67,48,54,127,7,51,20,29,70,10,50,-52,35,33,-94,8,77,-6,-70,-127,45,-112,-101,5,-77,18,70,127,24,32,26,34,115,20,-63,-127,-86,-125,-18,45,-3,60,127,-127,102,-127,-57,22,60,-125,80,43,11,17,24,24,-47,53,24,-101,9,-31,-127,127,49,18,-126,2,24,-127,-41,44,-8,15,12,22,68,-14,-76,20,86,40,-55,-11,8,-127,42,97,83,127,53,32,82,-72,124,82,-120,79,4,0,33,111,-17,-120,-28,46,26,-9,100,-29,-117,-83,-49,109,-127,2,-3,49,48,100,-38,-127,21,-127,27,54,-48,49,-7,-12,-94,8,-113,16,20,43,36,34,62,91,25,41,-91,127,-46,-5,22,-45,-127,32,3,9,14,64,10,101,-39,-127,20,37,70,22,21,47,49,127, 127,-30,-40,127,-28,39,-32,-87,-9,-127,-21,127,127,80,127,127,127,127,-127,94,-87,3,-61,70,-127,-17,-127,-79,-112,63,127,127,127,-78,-10,117,-127,-94,127,-127,127,127,-66,-94,-4,127,-99,83,127,127,127,127,127,62,127,-28,-80,127,32,30,-127,81,117,-8,40,-55,127,127,81,127,4,69,127,17,127,127,-118,127,127,-60,127,127,86,-127,42,-99,-99,-109,127,127,-75,-63,64,-127,-54,127,-31,37,127,127,127,-15,-11,-41,69,-85,-54,-42,-16,-122,127,-102,-32,26,127,127,43,-77,93,127,48,127,127,62,-30,22,-127,41,-76,127,127,122,107,127,98,-83,127,-56,-127,30,127,-127,34,39,106,127,127,-82,45,-60,127,-76,127,127,127,127,-32,75,-76,-104,127,127,127,127,-48,-32,97,-17,127,127,-127,-85,49,52,-95,-93,127,127,8,127,-127,35,127,127,-103,127,-60,92,-127,-37,64,-65,-101,127,-14,-127,-108,-11,-53,-127,33,-127,-123,127,-7,86,35,-117,127,43,127,-85,-119,0,-127,-68,127,127,-13,-38,54,-127,127,7,127,127,-16,-127,14,-14,-127,127,-111,-8,-20,127,118,127,127,-114,-66,127,127,127,127,127,84,127,-74,127,-15,127,-33,127,127,-103,0,49,-6,35,-127,-105,121,-55,-73,90,-85,14,127,88,1,-51,105,-34,58,-63,127,-30,45,72,-113,-107,-19,-47,-110,48,-4,127,127,127,54,-83,-82,-120,127,127,-127,51,100,-62,-83,-53,56,127,97,127,127,127,-74,-78,127,127,-127,-44,-10,-89,127,66,-34,127,-77,127,127,127,127,50,34,-107,57,127,-90,127,127,127,25,-50, 6,63,-82,-11,-70,79,70,120,-66,22,-88,20,6,67,103,10,84,-39,35,36,127,107,-82,87,82,23,-112,-106,-5,-14,62,89,84,-61,18,71,43,37,11,-115,10,52,-3,127,66,-14,-80,-127,-34,75,-16,-109,-7,102,-4,114,-96,60,-107,-32,-49,37,34,-95,-2,-12,7,33,75,27,-93,9,4,2,3,19,-93,3,-70,64,4,26,-127,46,90,-127,21,91,7,6,-87,-49,-11,42,118,-123,-60,112,-6,19,-85,8,47,-66,-127,52,-123,118,-50,-92,17,5,-55,99,85,25,-127,-127,-127,94,93,-3,19,127,67,55,81,92,-110,26,74,-11,114,25,110,-54,22,77,-101,-13,11,-80,83,67,-118,48,-3,-84,5,-108,-57,-84,-73,30,20,20,114,-107,12,99,11,39,-6,-10,71,-57,-88,-10,3,1,69,77,63,123,2,48,14,15,71,4,73,-48,-62,37,-106,4,45,0,-56,-103,48,67,-75,16,-112,12,70,126,-23,36,25,41,127,-2,-51,90,-54,-87,-25,66,0,64,118,-90,93,-108,-114,11,50,-87,-101,41,17,15,20,11,-60,54,24,-79,19,-27,-106,110,53,-3,-117,3,12,-121,-45,48,-21,22,9,16,-127,-22,-81,13,69,-100,-48,-8,12,-126,24,-127,95,115,47,40,90,-78,91,73,-115,74,4,-8,31,127,-16,-127,-22,-56,31,0,95,-17,-120,-81,-68,-127,-107,5,29,56,37,88,-33,-98,19,-116,26,52,-60,44,0,-14,-76,5,-70,2,26,28,22,23,53,94,17,32,-94,127,-43,-3,-1,-41,-92,13,33,7,18,53,-5,88,-33,-122,20,22,74,12,28,56,35,97, 
  /* [0][2][][] */ -6,27,-37,-61,-127,26,41,58,-44,85,75,-3,-21,-1,75,-7,-38,-8,30,11,76,50,-64,-17,59,50,-77,-68,42,-29,-19,0,-68,-56,-30,127,15,27,3,-63,3,-11,13,66,29,-11,54,-3,-53,-9,20,-5,-18,-13,3,-32,-51,1,38,-127,-36,-20,-28,-108,-7,-13,2,-6,-30,-5,-88,-29,4,119,-2,1,-94,-1,-30,42,-3,17,32,86,29,-50,127,116,8,-5,-90,-127,55,5,34,-29,-70,88,-20,-1,-106,-26,45,-85,23,34,-119,-12,-107,-41,9,117,127,-14,-62,87,16,-123,6,55,-97,46,11,15,55,16,87,-11,-127,24,-1,-5,79,-19,-46,127,-8,35,-25,-3,11,-47,-1,-55,-27,-27,5,-112,-9,-71,39,-51,-11,-8,-37,20,110,-12,-34,70,-15,-5,-15,-21,85,-68,-77,-3,-23,-3,30,62,127,77,69,-11,-6,16,-5,-1,81,121,5,-67,-1,3,-71,-17,-28,57,-9,3,-86,21,-64,-30,109,11,-1,61,41,105,105,19,-66,-100,-38,-127,30,24,-22,127,25,-65,23,-76,-24,-1,27,-23,23,104,23,28,5,-16,-106,40,1,-92,86,-17,-80,1,101,-4,-127,16,-26,-67,-127,-23,-50,-14,-18,1,-8,25,-75,-4,8,-54,-53,-10,59,-97,46,15,-75,-43,50,75,13,-80,83,-28,-118,-18,4,-15,88,0,-35,-99,-48,9,28,123,127,4,-127,-127,-127,37,-103,5,-7,63,-7,90,-9,-116,22,-69,10,-3,46,-51,10,10,-76,17,-127,2,24,93,11,26,56,108,0,6,17,99,-39,14,-12,-43,-80,12,127,-2,-3,53,27,17,91,-73,13,-3,124,5,-7,-25,0,-127, 32,24,-90,50,-57,127,127,28,-60,115,110,58,-27,-5,69,62,-26,18,-1,127,45,91,-64,122,-20,127,-11,-76,-19,-42,59,59,-60,-34,-77,27,-80,4,28,-112,5,20,-81,62,122,40,43,12,-62,68,56,-37,-57,-41,38,13,-127,-33,38,-14,-72,127,127,-93,19,-82,-16,19,55,16,-124,-127,-2,113,20,19,-127,12,-58,127,30,-2,1,57,-2,4,21,104,18,37,-108,6,80,8,-114,-32,-127,-18,-21,81,-75,21,127,-127,10,8,-124,-24,-42,-127,26,39,37,-4,109,9,22,-73,-47,-61,60,74,-72,12,127,-7,24,-111,-119,80,102,127,-127,43,-48,-54,23,127,-99,127,2,-61,-4,-127,1,-43,-84,-30,15,-93,76,-70,-6,-33,-13,-4,74,96,-52,101,-19,-126,-14,11,109,-53,46,-77,8,4,-39,-28,38,-82,7,21,57,39,-40,17,110,52,76,14,-69,24,-91,52,-47,-85,-52,30,-127,2,-103,-65,127,-9,-47,15,127,71,-68,75,-24,10,65,-82,74,127,-12,116,-65,-113,68,-70,67,27,127,127,38,-38,39,127,48,-9,-54,24,127,127,62,64,-117,93,127,-8,-95,55,-7,-46,-58,-34,-18,40,-74,16,-31,86,-127,14,127,-67,-59,28,100,-91,0,72,-15,1,75,127,-35,-65,-39,127,-59,-109,-8,-127,127,-7,-13,-112,11,43,79,56,69,127,-77,-74,-60,63,-63,127,-64,25,22,-42,127,-88,127,-80,36,106,-76,-127,-23,127,-64,127,-73,22,127,2,-11,19,51,127,45,99,-10,106,-63,127,-2,-90,-93,38,58,25,60,84,93,85,-9,-47,71,32,62,24,13,-69,81,-106, -10,23,-45,-59,-99,33,35,63,-39,82,-127,-4,-19,4,73,-8,3,-9,33,14,83,61,-72,2,-33,57,-81,-72,38,-24,-14,11,1,-43,-39,114,12,29,-5,-57,2,1,19,49,26,-14,-69,-8,-49,0,26,-13,-7,-11,5,13,-51,9,-93,-107,-36,-10,-6,-127,-8,-4,1,-3,-37,-7,-109,-20,9,80,3,1,-92,9,-42,58,6,16,-48,84,16,-46,122,127,13,-2,-86,-104,52,-1,31,-33,-56,68,-16,-10,-127,-21,47,-98,-22,33,-127,0,-81,-54,8,106,116,3,-46,66,-31,-112,-27,66,55,45,17,10,57,10,78,-12,-78,31,2,-7,79,-14,34,110,-9,49,-60,7,5,-41,4,-47,-41,0,7,-82,-3,-70,-32,-58,-70,-10,-42,19,102,0,-37,60,-4,-17,0,-24,63,-69,-73,-10,-32,2,33,-25,108,106,50,-13,-8,20,4,5,83,127,-64,-69,-21,15,-73,-24,-24,46,-14,82,-83,14,-43,-25,104,-4,1,55,33,109,10,-2,-48,34,-50,-98,29,13,-31,121,15,-64,21,-48,-3,2,30,28,-87,89,7,31,-7,-14,-88,46,5,-96,81,-6,-58,-10,94,-2,-96,12,-11,-34,-105,-19,-46,-7,-24,12,-23,18,-68,-18,21,-38,-50,-12,41,-109,43,-14,-61,-82,55,77,4,-84,127,-20,-109,-43,11,-16,86,1,-35,-79,-42,-19,18,127,121,9,-91,-126,-110,-72,-101,-4,-9,71,-3,74,-3,-116,29,-87,8,14,56,-30,20,14,-61,9,-114,1,15,87,16,23,43,111,5,-4,26,82,-39,6,-16,-30,-71,10,117,0,-1,46,30,14,78,-80,17,-3,114,5,-20,-39,-3,-110, 
};
const TfArray<4, int> tensor_dimension108 = { 4, { 1,3,3,336 } };
const TfArray<336, float> quant108_scale = { 336, { 0.011647905223071575, 0.0066852020099759102, 0.0072133885696530342, 0.011739421635866165, 0.0075837792828679085, 0.0067658429034054279, 0.0079235443845391273, 0.0089569715782999992, 0.006924288347363472, 0.0066946763545274734, 0.0076313847675919533, 0.0093785328790545464, 0.013555887155234814, 0.0062326854094862938, 0.004609440453350544, 0.012880165129899979, 0.0085110627114772797, 0.011304383166134357, 0.01154614519327879, 0.0080455169081687927, 0.0056372941471636295, 0.0063451193273067474, 0.005166543647646904, 0.0056505012325942516, 0.006386779248714447, 0.0085508134216070175, 0.0055762459523975849, 0.0046236999332904816, 0.0097189778462052345, 0.0089857848361134529, 0.0077160857617855072, 0.007205156609416008, 0.0067675267346203327, 0.0053195920772850513, 0.01562307495623827, 0.0026332228444516659, 0.010500917211174965, 0.0089478567242622375, 0.0084699057042598724, 0.0048203621990978718, 0.010794435627758503, 0.0090369852259755135, 0.0087165851145982742, 0.0059365341439843178, 0.0063072429038584232, 0.01233246736228466, 0.0050579002127051353, 0.013270123861730099, 0.0092165973037481308, 0.0068749883212149143, 0.0077799181453883648, 0.0071389870718121529, 0.013146784156560898, 0.0078915702179074287, 0.011775023303925991, 0.011342104524374008, 0.0062528075650334358, 0.0095588015392422676, 0.0097466306760907173, 0.0071363602764904499, 0.0052606025710701942, 0.007820863276720047, 0.007117345929145813, 0.0051515563391149044, 0.012891492806375027, 0.010032348334789276, 0.01260656863451004, 0.0091529469937086105, 0.006733317393809557, 0.010039333254098892, 0.0046507553197443485, 0.00755722401663661, 0.01662597618997097, 0.0065171681344509125, 0.011991486884653568, 0.0081637008115649223, 0.0037899378221482038, 0.010155675001442432, 0.009609065018594265, 0.0047964770346879959, 0.0099943745881319046, 0.0081717967987060547, 0.010199020616710186, 0.0076931077055633068, 0.0059911566786468029, 0.0052513577975332737, 0.0063505531288683414, 0.0063926493749022484, 0.012177485041320324, 0.011118354275822639, 0.0047837188467383385, 0.0065973792225122452, 0.01096796989440918, 0.010818859562277794, 0.0090160500258207321, 0.0066531584598124027, 0.006651740986853838, 0.0051194136030972004, 0.011705141514539719, 0.011415191926062107, 0.0044045788235962391, 0.011565305292606354, 0.0080314530059695244, 0.0069775152951478958, 0.010962555184960365, 0.0061512347310781479, 0.0041652107611298561, 0.0098615000024437904, 0.0058476566337049007, 0.0045908102765679359, 0.012714160606265068, 0.0061662630178034306, 0.0079519888386130333, 0.013452349230647087, 0.0050342949107289314, 0.0086887245997786522, 0.013619734905660152, 0.0034069065004587173, 0.0094532277435064316, 0.0062073697336018085, 0.0084380758926272392, 0.0063359420746564865, 0.011690622195601463, 0.0086920419707894325, 0.0075866016559302807, 0.0084778089076280594, 0.0060570142231881618, 0.0071915825828909874, 0.0034803524613380432, 0.0086185969412326813, 0.0070433528162539005, 0.0076519832946360111, 0.0059833843261003494, 0.0092047760263085365, 0.011983445845544338, 0.0075113903731107712, 0.010415093041956425, 0.0079772789031267166, 0.0047348658554255962, 0.010572785511612892, 0.010686462745070457, 0.0046139447949826717, 0.012619011104106903, 0.0080240955576300621, 0.0080057177692651749, 0.010285839438438416, 0.010796346701681614, 0.0045977011322975159, 0.010882820002734661, 0.004697136115282774, 0.010943977162241936, 0.0050373240374028683, 0.0093484045937657356, 0.010754889808595181, 0.0086556579917669296, 0.0090806921944022179, 0.0065472917631268501, 0.0068387235514819622, 0.0083265267312526703, 0.0076712076552212238, 0.0098990369588136673, 0.0083057219162583351, 0.0095137301832437515, 0.0099337296560406685, 0.0060055847279727459, 0.0072119883261620998, 0.0061973272822797298, 0.011097725480794907, 0.010098057799041271, 0.011034510098397732, 0.0093589257448911667, 0.0063604670576751232, 0.0051670614629983902, 0.0072784675285220146, 0.0065860296599566936, 0.0077700139954686165, 0.011493662372231483, 0.012919588945806026, 0.006524418480694294, 0.013422276824712753, 0.0063146022148430347, 0.0083737028762698174, 0.0097306957468390465, 0.0097929695621132851, 0.0043694381602108479, 0.0091606071218848228, 0.0094944294542074203, 0.0069576920941472054, 0.0063063330017030239, 0.0085716117173433304, 0.010848604142665863, 0.0058713913895189762, 0.003531099297106266, 0.010944323614239693, 0.0048541747964918613, 0.010115056298673153, 0.0061180545017123222, 0.008731422945857048, 0.012384484522044659, 0.015761762857437134, 0.0088465092703700066, 0.0080479942262172699, 0.0055511556565761566, 0.0090680485591292381, 0.0072837206535041332, 0.008812684565782547, 0.007397389505058527, 0.004367324523627758, 0.0092182056978344917, 0.0077252080664038658, 0.012630954384803772, 0.0053684990853071213, 0.011952245607972145, 0.0038272598758339882, 0.0087576759979128838, 0.0050288867205381393, 0.006082446314394474, 0.011218362487852573, 0.0078009534627199173, 0.0065445271320641041, 0.0081845447421073914, 0.0086886808276176453, 0.010380429215729237, 0.0099994176998734474, 0.0074465833604335785, 0.011308110319077969, 0.004877106286585331, 0.010860082693397999, 0.0084080556407570839, 0.0076595069840550423, 0.0080480305477976799, 0.0097955809906125069, 0.0058020371943712234, 0.0059178215451538563, 0.0053311134688556194, 0.011896064504981041, 0.0061895023100078106, 0.0099090905860066414, 0.0083799026906490326, 0.0051886369474232197, 0.0061544729396700859, 0.011034164577722549, 0.012592578306794167, 0.008951989933848381, 0.01096795592457056, 0.011327456682920456, 0.010316668078303337, 0.010137142613530159, 0.0056284703314304352, 0.012181062251329422, 0.0076383785344660282, 0.0076193562708795071, 0.0066809910349547863, 0.012839770875871181, 0.0080148903653025627, 0.0043554366566240788, 0.0068773818202316761, 0.014160103164613247, 0.008027251809835434, 0.0082963714376091957, 0.0070409211330115795, 0.0078666526824235916, 0.0068352138623595238, 0.0060134506784379482, 0.0064666555263102055, 0.0075467857532203197, 0.0042249206453561783, 0.00885014608502388, 0.013188203796744347, 0.0092996051535010338, 0.0069334856234490871, 0.0097749531269073486, 0.0082860095426440239, 0.0048314640298485756, 0.011492808349430561, 0.012517679482698441, 0.006596284918487072, 0.0060227392241358757, 0.0051052551716566086, 0.0079164681956171989, 0.0041410047560930252, 0.0043049510568380356, 0.0040293345227837563, 0.010291456244885921, 0.0054597696289420128, 0.011035270988941193, 0.013803043402731419, 0.0080839497968554497, 0.0080349892377853394, 0.0044523077085614204, 0.010581795126199722, 0.0044113257899880409, 0.011064806953072548, 0.0046526486985385418, 0.010431691072881222, 0.0083350390195846558, 0.0057691256515681744, 0.0088396454229950905, 0.010312040336430073, 0.013853908516466618, 0.0045563308522105217, 0.012101320549845695, 0.0047983634285628796, 0.011531778611242771, 0.0069553647190332413, 0.0080034509301185608, 0.0086482185870409012, 0.0079201264306902885, 0.0057088150642812252, 0.0052645695395767689, 0.0087909447029232979, 0.0083025014027953148, 0.0056210393086075783, 0.0049024596810340881, 0.006444005761295557, 0.010109846480190754, 0.011417292058467865, 0.0082422858104109764, 0.0071572032757103443, 0.011678038164973259, 0.0075897402130067348, 0.013734514825046062, 0.012311807833611965, 0.0069491369649767876, 0.009608827531337738, 0.007225358858704567, 0.0092644784599542618, 0.0045810411684215069, 0.011292333714663982, 0.0081680631265044212, 0.00584456417709589, 0.011541202664375305, 0.01015955675393343, 0.0081201065331697464, 0.0043464419431984425, 0.0071960813365876675, } };
const TfArray<336, int> quant108_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant108 = { (TfLiteFloatArray*)&quant108_scale, (TfLiteIntArray*)&quant108_zero, 3 };
const ALIGN(8) int32_t tensor_data109[56] = { -4624, -26698, -3553, -16205, -2005, -14911, 9054, -3182, 9069, -5535, -12183, -988, 24346, 3918, 25027, -9654, 21705, -15276, -8204, -2036, -3245, -3995, -7953, 16433, -815, -282, 11773, -11837, -16638, 15090, 6944, 8171, -2967, 1357, -6771, 9820, 1562, -38, -4167, -6403, -9045, -5679, -14200, -7776, 2320, 12884, -23145, 4885, -11398, -19905, -926, 2631, 22154, 20922, 18180, 7485, };
const TfArray<1, int> tensor_dimension109 = { 1, { 56 } };
const TfArray<56, float> quant109_scale = { 56, { 2.229946585430298e-05, 3.7740257539553568e-05, 3.3051059290301055e-05, 3.6044952139491215e-05, 2.9844452001270838e-05, 3.9083617593860254e-05, 2.6595638701110147e-05, 2.7975549528491683e-05, 3.1432384275831282e-05, 3.7984664231771603e-05, 3.1431049137609079e-05, 3.1215877243084833e-05, 3.2193787774303928e-05, 4.1207626054529101e-05, 2.6019493816420436e-05, 2.7647667593555525e-05, 2.7751852030633017e-05, 3.1443873012904078e-05, 3.7966776289977133e-05, 3.6151934182271361e-05, 4.0575425373390317e-05, 3.6272798752179369e-05, 2.6182968213106506e-05, 2.8022535843774676e-05, 2.8760929126292467e-05, 4.0409970097243786e-05, 3.3208787499461323e-05, 3.6618981539504603e-05, 3.2708332582842559e-05, 3.1070390832610428e-05, 3.128104071947746e-05, 3.7714951758971438e-05, 3.4116033930331469e-05, 5.513488213182427e-05, 3.2719242881285027e-05, 3.1530453270534053e-05, 3.2749256206443533e-05, 3.2082094548968598e-05, 3.3291424188064411e-05, 3.2704974728403613e-05, 3.1661784305470064e-05, 3.4857755963457748e-05, 3.6328819987829775e-05, 5.0963466492248699e-05, 3.588668187148869e-05, 4.1373114072484896e-05, 3.7660720408894122e-05, 2.7164036509930156e-05, 3.6010995245305821e-05, 3.1627168937120587e-05, 2.9698268917854875e-05, 3.4854358091251925e-05, 2.687320920813363e-05, 2.5132701921393164e-05, 2.6913672627415508e-05, 2.8820209990954027e-05, } };
const TfArray<56, int> quant109_zero = { 56, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant109 = { (TfLiteFloatArray*)&quant109_scale, (TfLiteIntArray*)&quant109_zero, 0 };
const ALIGN(8) int8_t tensor_data110[1*3*3*336] = { 
  /* [0][0][][] */ -65,2,-56,-117,-127,14,-60,6,27,-54,20,31,-127,48,-26,8,-79,-56,-70,24,-72,-127,30,22,28,-94,59,-127,38,-17,-122,-42,-60,-127,120,-127,38,-8,42,8,42,-33,0,-90,-10,-123,-122,-110,32,-20,28,35,42,127,-42,-55,22,-22,11,-120,-30,-104,26,-111,35,-127,-64,5,-100,27,-32,15,-62,-113,-76,-75,48,32,30,44,-84,-118,40,-75,20,76,-46,43,-22,-24,73,95,-70,-65,-127,44,-115,31,37,28,20,-127,-63,-114,-127,44,-8,-55,38,-51,68,40,5,43,-34,26,-117,45,21,31,34,20,20,16,-3,-73,51,21,-29,20,-13,-38,-62,127,-117,-67,-39,-90,-122,-45,12,-95,39,55,-45,57,-46,-94,-66,-114,-89,-3,-88,-7,-16,27,34,22,-86,25,-104,49,-59,-78,62,-101,-55,-127,32,-2,127,83,54,9,-62,-51,-97,-12,-51,52,-84,77,-127,-3,-24,-26,48,-109,39,-71,-120,-99,-89,-121,67,-127,10,25,-85,31,-44,-85,-75,41,11,-127,-86,41,-79,18,-79,-106,27,22,54,2,-94,38,-83,16,-126,-76,-69,-28,-127,-127,39,-57,-97,-50,-90,-124,-11,33,2,-127,-43,40,-6,-97,23,39,-49,33,-34,30,-79,97,30,62,55,-73,65,-36,-75,12,-127,-53,28,-121,-70,-23,-96,-89,-127,-95,21,-25,50,-99,-76,-78,-91,-39,-127,-52,42,-3,-106,-93,29,-70,20,-127,39,40,-127,-86,2,52,43,-17,-7,25,-10,53,-54,-104,-100,127,27,5,41,-40,-91,45,-27,-31,18,32,74,25,37,-105,34,40,12,-28,-15,57,-97,127,-82,24,44,46,5,-42,11,38,-17,-99,53,35,-90,52, -81,64,-103,-127,-102,-84,-49,87,111,-77,99,102,-118,99,97,109,79,87,-107,103,-94,-90,127,102,68,-74,101,-121,93,102,-127,-75,-127,-107,85,-110,118,38,100,60,110,111,55,-124,-40,-106,-123,-127,90,-2,64,100,94,110,60,-99,96,82,101,-84,38,-110,121,-127,84,-20,-83,100,-127,99,-12,101,-101,-95,-95,-90,127,100,57,125,-101,-123,110,-93,79,127,-42,104,-57,-13,127,127,-92,114,-88,101,-127,99,97,99,100,-78,-73,-122,-102,100,87,-88,83,-101,108,81,-30,111,97,97,-89,105,-14,86,97,63,104,80,65,-100,109,94,114,96,90,-35,-101,112,-111,25,-105,-97,-120,-127,88,-100,98,64,-47,112,-116,106,-77,-127,-127,76,-127,71,-84,104,100,102,-117,-9,-127,107,-99,-112,110,80,-112,-93,103,87,118,127,97,88,-78,-73,-127,69,-127,105,-105,106,-124,53,-88,71,65,-127,97,75,-112,-127,-113,-111,127,-122,67,80,-120,95,22,-127,-127,113,83,-122,-105,113,-103,77,-127,-127,-7,105,126,61,-127,97,-108,101,-109,-116,-94,-123,-90,-99,107,-59,-127,-90,-127,-96,62,106,104,-37,-58,90,70,-111,109,108,-112,94,-41,87,-119,122,97,114,113,-95,125,-123,-115,80,-121,-78,74,-127,-124,54,-114,-112,-111,-101,88,40,97,-127,-127,-82,-87,106,-91,-33,104,78,-104,-127,109,-103,84,-78,-41,109,-92,-127,-47,119,94,37,71,88,54,103,-99,-103,-112,124,101,87,94,-127,-114,113,81,-55,82,90,98,44,97,-117,107,84,76,85,100,109,-109,98,-117,112,103,105,110,117,93,110,-48,-112,93,97,-127,25, -42,0,-55,-96,-99,7,-50,18,5,-43,-2,22,-105,28,-27,-19,23,-66,-62,15,-65,-87,22,12,19,-70,50,-99,33,-26,-93,-52,-54,-116,102,-90,28,-9,31,2,28,-60,0,-79,-7,-98,-86,-102,28,-37,24,25,20,111,-32,-42,13,-30,10,-100,-30,-95,-14,-103,17,-26,-54,2,-100,-21,-33,-5,-44,-98,-80,-56,25,23,19,31,-52,-96,29,-61,9,55,-43,34,-17,-13,48,84,-67,16,-96,32,-97,25,22,-10,14,-76,-39,-100,-101,31,-18,-39,29,-38,59,30,3,29,-26,24,-98,28,6,17,19,22,-8,12,-13,-64,38,4,-34,11,-15,-33,-60,86,-82,-65,-25,-78,-92,-21,-5,-71,35,47,-32,44,-36,-18,-43,-83,-74,-6,-75,-24,-21,17,29,11,-77,17,-74,35,-42,-59,40,-83,-45,-101,35,-7,99,68,43,-12,-54,-43,-101,-15,-35,36,-54,52,-109,0,-11,-43,45,-87,28,-65,-89,-67,-68,-95,41,-103,9,11,-69,28,-49,-52,-53,25,0,-103,-75,25,-57,13,-60,-83,20,17,41,11,-75,30,-68,-7,-101,-60,-49,-26,-97,-93,30,-127,-78,-28,-75,-92,-7,20,-14,-30,-33,26,-9,-60,11,33,-40,15,-43,25,-62,75,23,36,47,-64,53,-16,-65,1,-97,-43,16,-99,-51,-33,-89,-64,-96,-74,13,-16,39,-61,-59,-63,-85,-33,-123,-47,30,-12,-80,-85,23,-56,10,-103,48,27,-93,-80,-3,34,28,-6,-8,15,-7,39,-42,-76,-92,96,23,3,31,-35,-68,32,-32,-20,1,18,43,32,24,-98,21,34,8,-33,-22,39,-86,112,-63,11,30,32,-6,-56,-3,22,-14,-84,42,9,-71,44, 
  /* [0][1][][] */ -127,104,-127,-124,-102,82,-97,125,123,-105,115,102,-110,117,109,109,22,109,-93,111,-95,-101,110,88,84,-88,99,-112,88,93,-109,-100,-122,-89,-83,-106,111,77,98,106,117,118,77,-127,-85,-127,-127,-111,108,-88,109,106,114,71,103,-105,82,104,109,-127,89,-127,105,-116,99,-54,-125,102,-119,104,79,105,-127,-110,-85,-108,113,124,-74,105,-63,-93,105,-127,124,90,-101,106,-105,55,104,-5,-127,126,-121,120,-122,102,87,100,122,-57,-28,-95,-106,108,102,-127,91,-127,103,118,-104,97,115,107,-126,84,-86,100,111,98,107,82,104,-127,116,117,119,102,118,-91,-98,2,-127,91,-78,-127,-127,-120,92,-95,99,101,-47,116,-125,127,-64,-113,-100,127,-127,102,-127,94,106,99,-127,-108,-123,79,-122,-127,100,56,-127,-103,109,96,-34,-46,98,104,-127,-42,-107,96,-102,89,-123,126,-105,96,-96,77,-38,-119,109,112,-127,-103,-121,-127,97,-99,101,97,-127,106,73,-72,-113,106,105,-105,-127,118,-127,111,-121,-87,-61,127,127,95,-114,114,-127,111,-127,-127,-127,-127,-56,-80,120,-91,-111,-118,-125,-117,89,109,121,-29,-99,121,96,-127,95,93,-123,114,-92,99,-116,122,94,95,116,-127,117,-119,-127,92,-118,-98,99,-126,-110,68,-127,-100,-105,-118,120,90,114,-113,-116,-117,-127,114,-103,66,109,113,-127,-112,109,-122,82,-100,-63,87,-122,-75,-58,110,78,80,95,93,93,94,-120,-127,-112,-13,113,124,91,-116,-126,127,100,-78,90,101,94,85,121,-115,107,127,93,114,115,90,-127,22,-116,100,111,102,101,119,87,107,-110,-94,103,112,-127,-64, -100,127,-96,-91,-77,127,-91,121,106,-93,127,127,-118,127,127,127,127,127,-127,127,-127,-75,127,127,127,-127,127,-100,127,127,-79,-89,-111,-93,-127,-83,127,127,127,127,127,127,127,-106,-127,-122,-125,-126,127,-127,127,127,127,-63,127,-127,127,127,127,-93,127,-114,127,-107,127,-39,-127,127,-91,127,127,127,-112,-83,-127,-113,118,127,-127,127,-68,-127,127,-98,127,121,-127,127,-123,106,120,-70,-97,127,-84,127,-127,127,127,127,127,-63,-15,-127,-110,127,127,-69,127,-85,127,127,-96,127,127,127,-127,107,-116,127,127,127,127,127,127,-103,127,127,127,127,127,-127,-120,-24,-115,127,-127,-87,-123,-100,127,-127,127,127,-61,127,-73,105,-127,-119,-115,126,-106,127,-110,127,127,127,-109,-119,-114,127,-114,-91,127,127,-92,-110,127,127,96,-109,127,127,-119,-66,-116,127,-91,113,-127,127,-96,127,-101,127,34,-100,127,127,-97,-84,-99,-95,108,-108,127,127,-93,127,127,-102,-102,127,127,-106,-93,126,-82,127,-82,-122,-73,105,114,127,-101,127,-87,127,-90,-121,-84,-117,-73,-76,127,-76,-106,-121,-87,-127,127,127,127,-33,-109,127,127,-91,127,127,-123,127,-127,127,-127,127,127,127,127,-96,127,-110,-103,127,-123,-112,127,-92,-127,127,-107,-127,-126,-108,127,127,127,-106,-83,-99,-110,127,-99,127,127,127,-112,-124,127,-127,127,-72,-127,127,-98,-96,-127,127,127,127,127,127,127,127,-127,-102,-127,-69,127,127,127,-103,-116,126,127,-108,127,127,127,127,127,-127,127,120,127,57,127,127,-94,-68,-99,127,127,127,127,127,127,127,-127,-127,127,127,-123,-127, -114,84,-98,-110,-85,62,-84,108,113,-90,101,93,-97,110,101,100,52,97,-92,97,-77,-90,87,73,76,-89,80,-89,64,83,-126,-88,-109,-76,-65,-76,93,68,84,85,102,98,62,-113,-69,-113,-112,-107,89,-72,91,91,98,79,84,-98,62,82,90,-99,73,-112,96,-98,76,-36,-107,82,-106,92,50,92,-100,-102,-94,-87,104,111,-52,80,-50,-83,88,-112,101,77,-90,86,-91,41,90,12,-111,90,-102,101,-116,83,73,97,91,-49,-23,-79,-83,92,89,-116,78,-104,90,91,-88,78,101,87,-120,67,-72,76,98,79,101,54,86,-103,91,95,96,74,100,-85,-82,67,-95,80,-66,-99,-111,-94,83,-83,86,88,-42,92,-127,99,-51,-78,-92,105,-107,90,-90,81,88,85,-113,-91,-109,68,-113,-108,87,44,-102,-81,86,85,-31,-36,85,93,-108,-34,-93,73,-94,72,-109,109,-87,81,-94,63,13,-112,93,101,-103,-94,-112,-107,81,-83,79,79,-121,87,61,-67,-108,85,87,-88,-104,103,-105,86,-104,-74,-49,109,117,74,-93,95,-123,94,-112,-114,-85,-110,-48,-62,91,-54,-101,-115,-118,-86,78,92,114,-28,-86,102,79,-117,74,74,-109,97,-71,79,-89,112,70,82,93,-110,86,-107,-112,63,-106,-78,84,-108,-93,51,-115,-80,-91,-95,107,67,91,-87,-112,-107,-116,88,-102,46,96,94,-94,-85,104,-97,71,-77,-58,69,-95,-69,-50,96,61,68,81,81,69,75,-107,-107,-101,-3,91,101,72,-100,-127,109,85,-54,76,81,81,67,103,-77,86,109,76,115,92,73,-96,29,-102,79,97,78,89,113,75,85,-89,-81,79,100,-115,-40, 
  /* [0][2][][] */ -80,60,-13,-48,-54,0,-127,65,51,-88,22,-45,-20,41,35,-27,-73,26,-91,-55,-81,-72,-45,-16,40,-80,-18,-79,-36,-3,-86,-79,-76,-114,-60,-89,-7,7,-12,48,5,-12,13,-47,-59,-80,-109,-87,-20,-102,27,-9,37,83,62,-61,26,28,31,-114,19,-96,29,-94,10,-31,-86,34,-60,19,77,21,-98,-127,-64,-80,-26,-45,-94,-47,116,41,7,-121,38,-64,-108,3,-81,84,-18,-26,-76,24,-106,5,-96,-11,11,43,-71,-42,105,71,-66,18,41,-60,20,-66,-11,13,-127,-34,23,-70,-73,-127,-115,27,17,19,-46,-56,44,-95,-31,47,50,18,-10,-67,-101,39,-81,53,-84,-59,-54,-54,34,-46,-5,39,-127,14,-57,21,-65,-12,-43,47,-77,36,-33,-9,-31,-33,-72,-127,-4,-82,-57,-30,0,48,-80,-63,-1,41,-50,-51,-53,24,-118,99,-70,45,-66,-127,-98,23,-69,52,-72,-40,127,-111,-27,19,-65,-33,-127,-49,-118,-43,17,17,-32,-10,28,1,-44,-25,12,-40,-82,-127,-85,35,-99,46,-127,-29,27,34,-37,1,-60,10,-95,-45,-94,-36,-38,-24,17,-51,-103,-111,-73,-9,26,-35,18,-26,-111,2,17,-58,-1,-15,-85,11,-77,0,7,33,-43,11,19,-87,-97,-52,-77,27,-48,-108,14,-56,-20,-55,-43,-66,-21,-108,27,24,13,-45,-37,-104,-70,47,-58,-111,-6,13,-51,29,27,-105,-22,-61,82,-32,-49,-10,-49,-24,-27,50,33,-3,42,-9,-47,-68,-62,-72,-20,1,-55,-25,-84,-24,52,-90,19,14,-84,63,-43,-51,-35,26,5,72,5,-29,-42,55,-58,-46,8,-19,41,30,-23,-51,-111,-71,-41,29,-85,-42, -102,106,-58,-80,-56,76,-104,127,127,-127,95,104,-22,92,96,90,64,108,-105,80,-67,-79,88,74,89,-103,55,-75,30,88,-64,-127,-115,-100,-82,-90,85,85,49,96,81,101,49,-92,-81,-72,-106,-92,74,-121,83,82,95,83,98,-110,91,87,90,-105,84,-104,90,-113,74,-36,-97,115,-87,80,124,84,-112,-114,-96,-127,103,69,-94,92,127,11,72,-110,87,36,-104,81,-127,127,90,-82,-125,97,-73,71,-104,64,58,100,71,-31,127,46,-71,58,92,-109,62,-96,53,84,-108,29,98,64,-92,53,-127,71,84,71,96,4,91,-102,41,99,126,85,88,-72,-127,78,-65,102,-91,-73,-92,-95,78,-60,70,72,-43,80,-108,91,-85,-40,-100,99,-107,94,-80,63,92,64,-96,-124,-67,-5,-127,-84,77,55,-82,-75,60,102,-84,-103,32,72,-113,127,-74,98,-89,12,-91,80,-69,96,-127,-11,101,-103,72,107,-86,-39,-112,-79,23,-65,80,76,-120,67,94,-45,-90,73,71,-75,-85,55,-100,97,-118,13,-83,93,99,87,-82,85,-102,95,-96,-78,-63,-104,-36,-31,91,-73,-107,-127,-108,-28,89,48,100,-37,-127,101,76,-98,85,46,-127,82,-91,93,-35,57,38,55,85,-103,50,-127,-110,80,-79,-127,74,-75,-75,56,-55,-110,-26,-127,98,91,81,-93,-84,-127,-103,108,-75,-63,89,88,-99,-18,105,-124,70,-57,48,32,-56,-70,-80,80,20,99,103,68,94,47,-81,-93,-87,-85,76,104,20,-95,-103,109,113,-127,63,78,28,83,101,-56,58,64,53,127,88,47,-68,69,-127,73,75,51,101,99,50,58,-124,-84,16,98,-126,-101, -66,52,-19,-37,-46,-13,-101,59,37,-69,12,-45,-21,34,28,-29,7,30,-57,-79,-68,-67,-45,-14,27,-69,-28,-73,-31,-8,-71,-76,-59,-87,-58,-93,-12,-5,-7,28,5,-9,6,-42,-62,-75,-79,-82,-17,-95,38,-12,24,72,44,-52,14,19,23,-98,6,-65,18,-76,13,-26,-85,26,-49,-15,49,13,-74,-100,-57,-62,-46,-44,-74,-68,98,48,0,-93,24,-63,-100,-3,-68,69,-6,-34,-67,16,-84,-4,-76,-12,7,27,-60,-33,84,50,-68,4,22,-49,22,-57,-13,0,-107,-33,-8,-69,-53,-122,-84,15,2,18,-41,-43,36,-82,-19,38,36,16,-27,-63,-71,24,-56,41,-63,-56,-44,-32,11,-47,-9,37,-64,12,-45,16,-28,0,-39,41,-58,27,-35,-8,-25,-36,-53,-107,0,-49,-39,-14,-4,51,-66,-50,-5,33,-33,-32,-46,11,-94,83,-66,25,-43,-102,-78,26,-69,33,-56,-37,106,-92,-30,17,-53,-27,-120,-36,-89,-42,10,14,-22,-8,13,-1,-34,-19,9,-34,-69,-94,-69,26,-69,32,-85,-35,-1,23,-46,0,-50,-6,-82,-30,-127,-28,-38,-27,19,-46,-88,-80,-75,-7,6,-18,9,-20,-96,-1,-1,-43,2,-10,-55,-2,-64,-7,9,28,-36,10,8,-70,-58,-51,-71,11,-32,-92,14,-28,-17,-60,-41,-60,-10,-97,26,11,10,-29,-25,-76,-70,34,-63,-84,-22,13,-32,13,16,-77,-38,-48,86,-21,-38,-6,-39,-30,-20,38,14,-20,30,-7,-37,-62,-56,-42,-25,-4,-42,-17,-69,-23,44,-79,7,13,-61,57,-38,-62,-37,24,-1,66,2,-28,-44,54,-46,-48,0,-6,18,15,-29,-41,-83,-65,-41,22,-80,-32, 
};
const TfArray<4, int> tensor_dimension110 = { 4, { 1,3,3,336 } };
const TfArray<336, float> quant110_scale = { 336, { 0.0036409315653145313, 0.0053246784955263138, 0.0040628174319863319, 0.0041318130679428577, 0.0042061884887516499, 0.0080390693619847298, 0.0041691586375236511, 0.0042060622945427895, 0.0074748825281858444, 0.0034704003483057022, 0.0069002858363091946, 0.0075377039611339569, 0.0049096844159066677, 0.0061089885421097279, 0.0090045435354113579, 0.0074348598718643188, 0.0084793604910373688, 0.0062551824375987053, 0.0035821991041302681, 0.0070666996762156487, 0.0050157038494944572, 0.0042761513032019138, 0.0059509645216166973, 0.0082889944314956665, 0.0062861279584467411, 0.0051408195868134499, 0.0070224744267761707, 0.0030907706823199987, 0.0076090092770755291, 0.0070834187790751457, 0.0051789367571473122, 0.0047978009097278118, 0.0041019963100552559, 0.0033493333030492067, 0.0058225416578352451, 0.0030463859438896179, 0.0050486479885876179, 0.006401602178812027, 0.0070490199141204357, 0.0055550453253090382, 0.005112567450851202, 0.0066982456482946873, 0.0053088958375155926, 0.0035876280162483454, 0.0066780867055058479, 0.0036899815313518047, 0.0031406122725456953, 0.0024092432577162981, 0.0073717967607080936, 0.0054263421334326267, 0.011489481665194035, 0.0068346792832016945, 0.0052722962573170662, 0.0063122729770839214, 0.0054494841024279594, 0.0049780518747866154, 0.0059220441617071629, 0.0057850731536746025, 0.0059360889717936516, 0.0031555539462715387, 0.0073037156835198402, 0.0035003090742975473, 0.0066342731006443501, 0.0032344101928174496, 0.0064349253661930561, 0.0080288359895348549, 0.0033526753541082144, 0.0056844432838261127, 0.003248503664508462, 0.010581835173070431, 0.0061079775914549828, 0.0066738068126142025, 0.0037547668907791376, 0.0037566244136542082, 0.0040728766471147537, 0.0039840573444962502, 0.0054186177439987659, 0.0064431843347847462, 0.0056030494160950184, 0.0055908756330609322, 0.0053516258485615253, 0.005124345887452364, 0.0056861364282667637, 0.0035015519242733717, 0.0064834458753466606, 0.0056555690243840218, 0.0038544244598597288, 0.0055134519934654236, 0.0033323857933282852, 0.0064148004166781902, 0.0057044024579226971, 0.0081029655411839485, 0.0032931608147919178, 0.0093862460926175117, 0.0039020641706883907, 0.006416053045541048, 0.0031278636306524277, 0.0073871067725121975, 0.0054880776442587376, 0.0070884972810745239, 0.0067627439275383949, 0.0070510730147361755, 0.0062539479695260525, 0.0076226829551160336, 0.0036510883364826441, 0.0066487900912761688, 0.0058022039011120796, 0.0043190433643758297, 0.0080456286668777466, 0.003805345855653286, 0.0064059323631227016, 0.005052005872130394, 0.0043611167930066586, 0.0059450035914778709, 0.0068372283130884171, 0.0069646728225052357, 0.0029824851080775261, 0.0063719204626977444, 0.0066700302995741367, 0.0075800949707627296, 0.0068711135536432266, 0.0065719210542738438, 0.0077141756191849709, 0.0089485906064510345, 0.0064560831524431705, 0.0033609643578529358, 0.0067342841066420078, 0.0069478633813560009, 0.0043539172038435936, 0.0061345584690570831, 0.0058614378795027733, 0.0054870396852493286, 0.0032763909548521042, 0.0085982000455260277, 0.0040344563312828541, 0.0067749517038464546, 0.0047815293073654175, 0.0038543560076504946, 0.003660817863419652, 0.0040009254589676857, 0.0068706353195011616, 0.0039231050759553909, 0.0064967609941959381, 0.0056637818925082684, 0.008546716533601284, 0.005679168738424778, 0.0038544624112546444, 0.0066560902632772923, 0.0078772762790322304, 0.0037783861625939608, 0.0036523693706840277, 0.0067283976823091507, 0.0033465044107288122, 0.0054059247486293316, 0.0049593928270041943, 0.0072175292298197746, 0.0080881835892796516, 0.0076269279234111309, 0.0032486726995557547, 0.0037185787223279476, 0.003512596245855093, 0.0065981387160718441, 0.0033778275828808546, 0.0044782450422644615, 0.0050845271907746792, 0.0078762872144579887, 0.0039814673364162445, 0.0041891126893460751, 0.0063810665160417557, 0.0073692277073860168, 0.0067908843047916889, 0.0069089592434465885, 0.013970045372843742, 0.0067877159453928471, 0.0032879835925996304, 0.0073701380752027035, 0.0035666429903358221, 0.0071358163841068745, 0.0037881606258451939, 0.0067871049977838993, 0.0039681121706962585, 0.0042062560096383095, 0.0039786659181118011, 0.0057146134786307812, 0.003877333365380764, 0.008452187292277813, 0.0081034917384386063, 0.0033114384859800339, 0.0069348509423434734, 0.0071616964414715767, 0.00329977972432971, 0.0050949715077877045, 0.003191864350810647, 0.003403182839974761, 0.005463761743158102, 0.0032711736857891083, 0.007171060424298048, 0.0070966710336506367, 0.0035173073410987854, 0.0049661640077829361, 0.0069774859584867954, 0.0045242574997246265, 0.0043164435774087906, 0.0069535868242383003, 0.0064977998845279217, 0.0038227112963795662, 0.0036671510897576809, 0.0066682146862149239, 0.0042731920257210732, 0.0075148725882172585, 0.0034793922677636147, 0.0044248560443520546, 0.007355391513556242, 0.0052697006613016129, 0.0055069075897336006, 0.005557340569794178, 0.0044077513739466667, 0.006380823440849781, 0.0044064340181648731, 0.0067241271026432514, 0.0038206770550459623, 0.0030180905014276505, 0.0047897272743284702, 0.0041869268752634525, 0.0064945262856781483, 0.0051379832439124584, 0.0061320275999605656, 0.0057847853749990463, 0.0029915182385593653, 0.0030034757219254971, 0.0033738638740032911, 0.0040581156499683857, 0.006494882982224226, 0.006083381362259388, 0.0067488090135157108, 0.011423174291849136, 0.0045160935260355473, 0.0051964051090180874, 0.0075372057035565376, 0.0039751520380377769, 0.0061958124861121178, 0.0060075768269598484, 0.003788862144574523, 0.0069303098134696484, 0.004434940405189991, 0.0052134539000689983, 0.0045598880387842655, 0.0044278339482843876, 0.0071306708268821239, 0.0058662435039877892, 0.0074030966497957706, 0.0035095349885523319, 0.0049890903756022453, 0.0035284329205751419, 0.0037151342257857323, 0.008992842398583889, 0.0031972674187272787, 0.0033963965252041817, 0.0065100365318357944, 0.0032602616120129824, 0.0037015171255916357, 0.0080284429714083672, 0.0033668011892586946, 0.0038407470565289259, 0.0040065543726086617, 0.0030929006170481443, 0.0081079434603452682, 0.0077209724113345146, 0.0064973155967891216, 0.0037610838189721107, 0.0043759783729910851, 0.0038109763991087675, 0.0042888941243290901, 0.0063392366282641888, 0.0039206389337778091, 0.0056096324697136879, 0.012400935404002666, 0.010049386881291866, 0.0035840347409248352, 0.0040962672792375088, 0.027245109900832176, 0.0034894195850938559, 0.008645438589155674, 0.0041825822554528713, 0.0068692732602357864, 0.0065629654563963413, 0.0039466661401093006, 0.0058408565819263458, 0.0076566543430089951, 0.0065435548312962055, 0.0072436672635376453, 0.0066714980639517307, 0.0057319020852446556, 0.008237435482442379, 0.0066802287474274635, 0.0055334093049168587, 0.0035168339964002371, 0.0037393399979919195, 0.0034485042560845613, 0.0063508148305118084, 0.0056630838662385941, 0.0060584712773561478, 0.0066157253459095955, 0.0037205589469522238, 0.0034051255788654089, 0.0052733924239873886, 0.0049779461696743965, 0.0048086936585605145, 0.0090033086016774178, 0.0061706434935331345, 0.0058873309753835201, 0.0062010008841753006, 0.0068310676142573357, 0.0047295237891376019, 0.0074660340324044228, 0.0097201419994235039, 0.0066041559912264347, 0.0040179337374866009, 0.0070213982835412025, 0.0062879137694835663, 0.0042908946052193642, 0.0076032173819839954, 0.0038402145728468895, 0.0047444337978959084, 0.0052265394479036331, 0.005443197675049305, 0.005323127843439579, 0.0097195738926529884, 0.00690480787307024, 0.0055802129209041595, 0.0033377783838659525, 0.0034274619538336992, 0.0068812458775937557, 0.0061006518080830574, 0.0046407901681959629, 0.0055945091880857944, } };
const TfArray<336, int> quant110_zero = { 336, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant110 = { (TfLiteFloatArray*)&quant110_scale, (TfLiteIntArray*)&quant110_zero, 3 };
const ALIGN(8) int32_t tensor_data111[112] = { 16036, 22388, 3815, 32140, -456, -16533, 34222, -7526, 24125, -18746, -33635, -6675, 7033, -11600, 25020, -24247, 30280, 1691, 16754, 6913, -3025, -170, -4462, 28296, -8964, -5434, -883, -32912, 11010, 4914, -736, -20923, -13701, 14225, 11676, -17456, 2473, 24545, 35065, 28281, 30375, -61, 8720, 9294, 9763, -17067, 8853, 40231, 10738, -4295, -10404, -27638, 117, 21192, 19775, 18862, 736, -24421, 16222, -16045, 14549, -8520, 32538, -20193, 11653, -19111, 14881, 6627, 4849, -19445, 11552, -14524, 1480, 6901, 30017, 2072, 1122, 11750, 10156, -5077, -859, -16726, -24440, -8277, -14348, 26495, -47495, 12442, -7654, -603, -10286, 12989, 6174, -28247, -8087, 28767, 18391, 1540, 14213, 6342, 3781, 11247, -23603, -4327, 35610, 7170, 11647, 39075, 37465, -181, -10455, 11831, };
const TfArray<1, int> tensor_dimension111 = { 1, { 112 } };
const TfArray<112, float> quant111_scale = { 112, { 5.3715662943432108e-05, 4.7735855332575738e-05, 5.5114447604864836e-05, 5.6841541663743556e-05, 5.2518036682158709e-05, 4.5782329834764823e-05, 5.3601597755914554e-05, 5.4291060223476961e-05, 5.3406613005790859e-05, 5.0579998060129583e-05, 5.2848376071779057e-05, 4.7897374315652996e-05, 7.8744007623754442e-05, 5.5543667258461937e-05, 5.731595229008235e-05, 6.909461080795154e-05, 6.683512037852779e-05, 4.9846144975163043e-05, 5.3597741498379037e-05, 5.202835745876655e-05, 5.7355653552804142e-05, 6.8875953729730099e-05, 4.8917303502094001e-05, 5.4503623687196523e-05, 6.0144851886434481e-05, 4.9367401516065001e-05, 5.5527343647554517e-05, 5.2687537390738726e-05, 5.9511650761123747e-05, 5.8629037084756419e-05, 5.8911205996992067e-05, 5.6773831602185965e-05, 5.2026425692019984e-05, 4.6871024096617475e-05, 5.3975036280462518e-05, 5.3788913646712899e-05, 6.1876431573182344e-05, 5.9090176364406943e-05, 5.4670017561875284e-05, 4.5690881961490959e-05, 6.5436848672106862e-05, 5.5815351515775546e-05, 5.5979948228923604e-05, 5.0861170166172087e-05, 4.9810045311460271e-05, 5.8202687796438113e-05, 5.1749448175542057e-05, 5.3924373787594959e-05, 4.3784260924439877e-05, 5.1385723054409027e-05, 6.0115795349702239e-05, 5.2898027206538245e-05, 6.0402351664379239e-05, 7.2063383413478732e-05, 6.1683116655331105e-05, 4.57905771327205e-05, 4.9838814447866753e-05, 6.3405903347302228e-05, 5.8879802963929251e-05, 7.0520865847356617e-05, 5.7665209169499576e-05, 5.0821523473132402e-05, 5.5164717196021229e-05, 5.8030120271723717e-05, 4.6547076635761186e-05, 7.0348156441468745e-05, 5.9832276747329161e-05, 5.2233019232517108e-05, 5.3511987061938271e-05, 4.4116957724327222e-05, 5.0698221457423642e-05, 5.7955901866080239e-05, 5.6546788982814178e-05, 5.8793251810129732e-05, 5.3568634029943496e-05, 5.5689197324682027e-05, 5.5252930906135589e-05, 7.101046503521502e-05, 6.1345483118202537e-05, 4.7387748054461554e-05, 4.834067658521235e-05, 5.9454767324496061e-05, 5.294106449582614e-05, 5.9841349866474047e-05, 5.107588367536664e-05, 6.0776063037337735e-05, 4.7722514864290133e-05, 5.4002350225346163e-05, 5.0765738706104457e-05, 5.5242238886421546e-05, 4.3461062887217849e-05, 6.8253168137744069e-05, 7.928697596071288e-05, 6.2529623392038047e-05, 4.5207027142168954e-05, 5.5312102631432936e-05, 5.6979311921168119e-05, 6.0254402342252433e-05, 5.9163434343645349e-05, 5.932078420300968e-05, 5.0040769565384835e-05, 5.5487536883447319e-05, 5.4117546824272722e-05, 6.4049687352962792e-05, 6.586661038454622e-05, 5.821264858241193e-05, 5.2708262956002727e-05, 5.9579928347375244e-05, 6.4702202507760376e-05, 6.5345520852133632e-05, 5.4535656090592965e-05, 5.1252594857942313e-05, } };
const TfArray<112, int> quant111_zero = { 112, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant111 = { (TfLiteFloatArray*)&quant111_scale, (TfLiteIntArray*)&quant111_zero, 0 };
const TfArray<4, int> tensor_dimension112 = { 4, { 1,48,48,16 } };
const TfArray<1, float> quant112_scale = { 1, { 0.020638002082705498, } };
const TfArray<1, int> quant112_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant112 = { (TfLiteFloatArray*)&quant112_scale, (TfLiteIntArray*)&quant112_zero, 0 };
const TfArray<4, int> tensor_dimension113 = { 4, { 1,48,48,16 } };
const TfArray<1, float> quant113_scale = { 1, { 0.018432464450597763, } };
const TfArray<1, int> quant113_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant113 = { (TfLiteFloatArray*)&quant113_scale, (TfLiteIntArray*)&quant113_zero, 0 };
const TfArray<4, int> tensor_dimension114 = { 4, { 1,48,48,8 } };
const TfArray<1, float> quant114_scale = { 1, { 0.036980055272579193, } };
const TfArray<1, int> quant114_zero = { 1, { -11 } };
const TfLiteAffineQuantization quant114 = { (TfLiteFloatArray*)&quant114_scale, (TfLiteIntArray*)&quant114_zero, 0 };
const TfArray<4, int> tensor_dimension115 = { 4, { 1,48,48,48 } };
const TfArray<1, float> quant115_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant115_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant115 = { (TfLiteFloatArray*)&quant115_scale, (TfLiteIntArray*)&quant115_zero, 0 };
const TfArray<4, int> tensor_dimension116 = { 4, { 1,49,49,48 } };
const TfArray<1, float> quant116_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant116_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant116 = { (TfLiteFloatArray*)&quant116_scale, (TfLiteIntArray*)&quant116_zero, 0 };
const TfArray<4, int> tensor_dimension117 = { 4, { 1,24,24,48 } };
const TfArray<1, float> quant117_scale = { 1, { 0.017732869833707809, } };
const TfArray<1, int> quant117_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant117 = { (TfLiteFloatArray*)&quant117_scale, (TfLiteIntArray*)&quant117_zero, 0 };
const TfArray<4, int> tensor_dimension118 = { 4, { 1,24,24,8 } };
const TfArray<1, float> quant118_scale = { 1, { 0.040328424423933029, } };
const TfArray<1, int> quant118_zero = { 1, { 10 } };
const TfLiteAffineQuantization quant118 = { (TfLiteFloatArray*)&quant118_scale, (TfLiteIntArray*)&quant118_zero, 0 };
const TfArray<4, int> tensor_dimension119 = { 4, { 1,24,24,48 } };
const TfArray<1, float> quant119_scale = { 1, { 0.020079005509614944, } };
const TfArray<1, int> quant119_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant119 = { (TfLiteFloatArray*)&quant119_scale, (TfLiteIntArray*)&quant119_zero, 0 };
const TfArray<4, int> tensor_dimension120 = { 4, { 1,24,24,48 } };
const TfArray<1, float> quant120_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant120_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant120 = { (TfLiteFloatArray*)&quant120_scale, (TfLiteIntArray*)&quant120_zero, 0 };
const TfArray<4, int> tensor_dimension121 = { 4, { 1,24,24,8 } };
const TfArray<1, float> quant121_scale = { 1, { 0.043634086847305298, } };
const TfArray<1, int> quant121_zero = { 1, { -23 } };
const TfLiteAffineQuantization quant121 = { (TfLiteFloatArray*)&quant121_scale, (TfLiteIntArray*)&quant121_zero, 0 };
const TfArray<4, int> tensor_dimension122 = { 4, { 1,24,24,8 } };
const TfArray<1, float> quant122_scale = { 1, { 0.054552886635065079, } };
const TfArray<1, int> quant122_zero = { 1, { -15 } };
const TfLiteAffineQuantization quant122 = { (TfLiteFloatArray*)&quant122_scale, (TfLiteIntArray*)&quant122_zero, 0 };
const TfArray<4, int> tensor_dimension123 = { 4, { 1,24,24,48 } };
const TfArray<1, float> quant123_scale = { 1, { 0.022153442725539207, } };
const TfArray<1, int> quant123_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant123 = { (TfLiteFloatArray*)&quant123_scale, (TfLiteIntArray*)&quant123_zero, 0 };
const TfArray<4, int> tensor_dimension124 = { 4, { 1,25,25,48 } };
const TfArray<1, float> quant124_scale = { 1, { 0.022153442725539207, } };
const TfArray<1, int> quant124_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant124 = { (TfLiteFloatArray*)&quant124_scale, (TfLiteIntArray*)&quant124_zero, 0 };
const TfArray<4, int> tensor_dimension125 = { 4, { 1,12,12,48 } };
const TfArray<1, float> quant125_scale = { 1, { 0.016267972066998482, } };
const TfArray<1, int> quant125_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant125 = { (TfLiteFloatArray*)&quant125_scale, (TfLiteIntArray*)&quant125_zero, 0 };
const TfArray<4, int> tensor_dimension126 = { 4, { 1,12,12,16 } };
const TfArray<1, float> quant126_scale = { 1, { 0.037125047296285629, } };
const TfArray<1, int> quant126_zero = { 1, { -24 } };
const TfLiteAffineQuantization quant126 = { (TfLiteFloatArray*)&quant126_scale, (TfLiteIntArray*)&quant126_zero, 0 };
const TfArray<4, int> tensor_dimension127 = { 4, { 1,12,12,96 } };
const TfArray<1, float> quant127_scale = { 1, { 0.018188903108239174, } };
const TfArray<1, int> quant127_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant127 = { (TfLiteFloatArray*)&quant127_scale, (TfLiteIntArray*)&quant127_zero, 0 };
const TfArray<4, int> tensor_dimension128 = { 4, { 1,12,12,96 } };
const TfArray<1, float> quant128_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant128_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant128 = { (TfLiteFloatArray*)&quant128_scale, (TfLiteIntArray*)&quant128_zero, 0 };
const TfArray<4, int> tensor_dimension129 = { 4, { 1,12,12,16 } };
const TfArray<1, float> quant129_scale = { 1, { 0.051471605896949768, } };
const TfArray<1, int> quant129_zero = { 1, { -12 } };
const TfLiteAffineQuantization quant129 = { (TfLiteFloatArray*)&quant129_scale, (TfLiteIntArray*)&quant129_zero, 0 };
const TfArray<4, int> tensor_dimension130 = { 4, { 1,12,12,16 } };
const TfArray<1, float> quant130_scale = { 1, { 0.055272862315177917, } };
const TfArray<1, int> quant130_zero = { 1, { 3 } };
const TfLiteAffineQuantization quant130 = { (TfLiteFloatArray*)&quant130_scale, (TfLiteIntArray*)&quant130_zero, 0 };
const TfArray<4, int> tensor_dimension131 = { 4, { 1,12,12,96 } };
const TfArray<1, float> quant131_scale = { 1, { 0.021629815921187401, } };
const TfArray<1, int> quant131_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant131 = { (TfLiteFloatArray*)&quant131_scale, (TfLiteIntArray*)&quant131_zero, 0 };
const TfArray<4, int> tensor_dimension132 = { 4, { 1,12,12,96 } };
const TfArray<1, float> quant132_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant132_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant132 = { (TfLiteFloatArray*)&quant132_scale, (TfLiteIntArray*)&quant132_zero, 0 };
const TfArray<4, int> tensor_dimension133 = { 4, { 1,12,12,16 } };
const TfArray<1, float> quant133_scale = { 1, { 0.044123932719230652, } };
const TfArray<1, int> quant133_zero = { 1, { 12 } };
const TfLiteAffineQuantization quant133 = { (TfLiteFloatArray*)&quant133_scale, (TfLiteIntArray*)&quant133_zero, 0 };
const TfArray<4, int> tensor_dimension134 = { 4, { 1,12,12,16 } };
const TfArray<1, float> quant134_scale = { 1, { 0.068872906267642975, } };
const TfArray<1, int> quant134_zero = { 1, { 9 } };
const TfLiteAffineQuantization quant134 = { (TfLiteFloatArray*)&quant134_scale, (TfLiteIntArray*)&quant134_zero, 0 };
const TfArray<4, int> tensor_dimension135 = { 4, { 1,12,12,96 } };
const TfArray<1, float> quant135_scale = { 1, { 0.021681344136595726, } };
const TfArray<1, int> quant135_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant135 = { (TfLiteFloatArray*)&quant135_scale, (TfLiteIntArray*)&quant135_zero, 0 };
const TfArray<4, int> tensor_dimension136 = { 4, { 1,13,13,96 } };
const TfArray<1, float> quant136_scale = { 1, { 0.021681344136595726, } };
const TfArray<1, int> quant136_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant136 = { (TfLiteFloatArray*)&quant136_scale, (TfLiteIntArray*)&quant136_zero, 0 };
const TfArray<4, int> tensor_dimension137 = { 4, { 1,6,6,96 } };
const TfArray<1, float> quant137_scale = { 1, { 0.022066716104745865, } };
const TfArray<1, int> quant137_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant137 = { (TfLiteFloatArray*)&quant137_scale, (TfLiteIntArray*)&quant137_zero, 0 };
const TfArray<4, int> tensor_dimension138 = { 4, { 1,6,6,24 } };
const TfArray<1, float> quant138_scale = { 1, { 0.055218253284692764, } };
const TfArray<1, int> quant138_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant138 = { (TfLiteFloatArray*)&quant138_scale, (TfLiteIntArray*)&quant138_zero, 0 };
const TfArray<4, int> tensor_dimension139 = { 4, { 1,6,6,144 } };
const TfArray<1, float> quant139_scale = { 1, { 0.023432739078998566, } };
const TfArray<1, int> quant139_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant139 = { (TfLiteFloatArray*)&quant139_scale, (TfLiteIntArray*)&quant139_zero, 0 };
const TfArray<4, int> tensor_dimension140 = { 4, { 1,6,6,144 } };
const TfArray<1, float> quant140_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant140_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant140 = { (TfLiteFloatArray*)&quant140_scale, (TfLiteIntArray*)&quant140_zero, 0 };
const TfArray<4, int> tensor_dimension141 = { 4, { 1,6,6,24 } };
const TfArray<1, float> quant141_scale = { 1, { 0.022717220708727837, } };
const TfArray<1, int> quant141_zero = { 1, { 4 } };
const TfLiteAffineQuantization quant141 = { (TfLiteFloatArray*)&quant141_scale, (TfLiteIntArray*)&quant141_zero, 0 };
const TfArray<4, int> tensor_dimension142 = { 4, { 1,6,6,24 } };
const TfArray<1, float> quant142_scale = { 1, { 0.05794212594628334, } };
const TfArray<1, int> quant142_zero = { 1, { -2 } };
const TfLiteAffineQuantization quant142 = { (TfLiteFloatArray*)&quant142_scale, (TfLiteIntArray*)&quant142_zero, 0 };
const TfArray<4, int> tensor_dimension143 = { 4, { 1,6,6,144 } };
const TfArray<1, float> quant143_scale = { 1, { 0.019099248573184013, } };
const TfArray<1, int> quant143_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant143 = { (TfLiteFloatArray*)&quant143_scale, (TfLiteIntArray*)&quant143_zero, 0 };
const TfArray<4, int> tensor_dimension144 = { 4, { 1,6,6,144 } };
const TfArray<1, float> quant144_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant144_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant144 = { (TfLiteFloatArray*)&quant144_scale, (TfLiteIntArray*)&quant144_zero, 0 };
const TfArray<4, int> tensor_dimension145 = { 4, { 1,6,6,24 } };
const TfArray<1, float> quant145_scale = { 1, { 0.019254263490438461, } };
const TfArray<1, int> quant145_zero = { 1, { -3 } };
const TfLiteAffineQuantization quant145 = { (TfLiteFloatArray*)&quant145_scale, (TfLiteIntArray*)&quant145_zero, 0 };
const TfArray<4, int> tensor_dimension146 = { 4, { 1,6,6,24 } };
const TfArray<1, float> quant146_scale = { 1, { 0.056840933859348297, } };
const TfArray<1, int> quant146_zero = { 1, { -3 } };
const TfLiteAffineQuantization quant146 = { (TfLiteFloatArray*)&quant146_scale, (TfLiteIntArray*)&quant146_zero, 0 };
const TfArray<4, int> tensor_dimension147 = { 4, { 1,6,6,144 } };
const TfArray<1, float> quant147_scale = { 1, { 0.019231066107749939, } };
const TfArray<1, int> quant147_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant147 = { (TfLiteFloatArray*)&quant147_scale, (TfLiteIntArray*)&quant147_zero, 0 };
const TfArray<4, int> tensor_dimension148 = { 4, { 1,6,6,144 } };
const TfArray<1, float> quant148_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant148_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant148 = { (TfLiteFloatArray*)&quant148_scale, (TfLiteIntArray*)&quant148_zero, 0 };
const TfArray<4, int> tensor_dimension149 = { 4, { 1,6,6,24 } };
const TfArray<1, float> quant149_scale = { 1, { 0.021566933020949364, } };
const TfArray<1, int> quant149_zero = { 1, { -6 } };
const TfLiteAffineQuantization quant149 = { (TfLiteFloatArray*)&quant149_scale, (TfLiteIntArray*)&quant149_zero, 0 };
const TfArray<4, int> tensor_dimension150 = { 4, { 1,6,6,24 } };
const TfArray<1, float> quant150_scale = { 1, { 0.060224354267120361, } };
const TfArray<1, int> quant150_zero = { 1, { -5 } };
const TfLiteAffineQuantization quant150 = { (TfLiteFloatArray*)&quant150_scale, (TfLiteIntArray*)&quant150_zero, 0 };
const TfArray<4, int> tensor_dimension151 = { 4, { 1,6,6,144 } };
const TfArray<1, float> quant151_scale = { 1, { 0.018541891127824783, } };
const TfArray<1, int> quant151_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant151 = { (TfLiteFloatArray*)&quant151_scale, (TfLiteIntArray*)&quant151_zero, 0 };
const TfArray<4, int> tensor_dimension152 = { 4, { 1,6,6,144 } };
const TfArray<1, float> quant152_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant152_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant152 = { (TfLiteFloatArray*)&quant152_scale, (TfLiteIntArray*)&quant152_zero, 0 };
const TfArray<4, int> tensor_dimension153 = { 4, { 1,6,6,32 } };
const TfArray<1, float> quant153_scale = { 1, { 0.046585135161876678, } };
const TfArray<1, int> quant153_zero = { 1, { -13 } };
const TfLiteAffineQuantization quant153 = { (TfLiteFloatArray*)&quant153_scale, (TfLiteIntArray*)&quant153_zero, 0 };
const TfArray<4, int> tensor_dimension154 = { 4, { 1,6,6,192 } };
const TfArray<1, float> quant154_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant154_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant154 = { (TfLiteFloatArray*)&quant154_scale, (TfLiteIntArray*)&quant154_zero, 0 };
const TfArray<4, int> tensor_dimension155 = { 4, { 1,6,6,192 } };
const TfArray<1, float> quant155_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant155_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant155 = { (TfLiteFloatArray*)&quant155_scale, (TfLiteIntArray*)&quant155_zero, 0 };
const TfArray<4, int> tensor_dimension156 = { 4, { 1,6,6,32 } };
const TfArray<1, float> quant156_scale = { 1, { 0.030153943225741386, } };
const TfArray<1, int> quant156_zero = { 1, { 9 } };
const TfLiteAffineQuantization quant156 = { (TfLiteFloatArray*)&quant156_scale, (TfLiteIntArray*)&quant156_zero, 0 };
const TfArray<4, int> tensor_dimension157 = { 4, { 1,6,6,32 } };
const TfArray<1, float> quant157_scale = { 1, { 0.060041535645723343, } };
const TfArray<1, int> quant157_zero = { 1, { -15 } };
const TfLiteAffineQuantization quant157 = { (TfLiteFloatArray*)&quant157_scale, (TfLiteIntArray*)&quant157_zero, 0 };
const TfArray<4, int> tensor_dimension158 = { 4, { 1,6,6,192 } };
const TfArray<1, float> quant158_scale = { 1, { 0.023258021101355553, } };
const TfArray<1, int> quant158_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant158 = { (TfLiteFloatArray*)&quant158_scale, (TfLiteIntArray*)&quant158_zero, 0 };
const TfArray<4, int> tensor_dimension159 = { 4, { 1,6,6,192 } };
const TfArray<1, float> quant159_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant159_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant159 = { (TfLiteFloatArray*)&quant159_scale, (TfLiteIntArray*)&quant159_zero, 0 };
const TfArray<4, int> tensor_dimension160 = { 4, { 1,6,6,32 } };
const TfArray<1, float> quant160_scale = { 1, { 0.029769668355584145, } };
const TfArray<1, int> quant160_zero = { 1, { 19 } };
const TfLiteAffineQuantization quant160 = { (TfLiteFloatArray*)&quant160_scale, (TfLiteIntArray*)&quant160_zero, 0 };
const TfArray<4, int> tensor_dimension161 = { 4, { 1,6,6,32 } };
const TfArray<1, float> quant161_scale = { 1, { 0.065887793898582458, } };
const TfArray<1, int> quant161_zero = { 1, { -15 } };
const TfLiteAffineQuantization quant161 = { (TfLiteFloatArray*)&quant161_scale, (TfLiteIntArray*)&quant161_zero, 0 };
const TfArray<4, int> tensor_dimension162 = { 4, { 1,6,6,192 } };
const TfArray<1, float> quant162_scale = { 1, { 0.019575631245970726, } };
const TfArray<1, int> quant162_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant162 = { (TfLiteFloatArray*)&quant162_scale, (TfLiteIntArray*)&quant162_zero, 0 };
const TfArray<4, int> tensor_dimension163 = { 4, { 1,7,7,192 } };
const TfArray<1, float> quant163_scale = { 1, { 0.019575631245970726, } };
const TfArray<1, int> quant163_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant163 = { (TfLiteFloatArray*)&quant163_scale, (TfLiteIntArray*)&quant163_zero, 0 };
const TfArray<4, int> tensor_dimension164 = { 4, { 1,3,3,192 } };
const TfArray<1, float> quant164_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant164_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant164 = { (TfLiteFloatArray*)&quant164_scale, (TfLiteIntArray*)&quant164_zero, 0 };
const TfArray<4, int> tensor_dimension165 = { 4, { 1,3,3,56 } };
const TfArray<1, float> quant165_scale = { 1, { 0.051875021308660507, } };
const TfArray<1, int> quant165_zero = { 1, { -26 } };
const TfLiteAffineQuantization quant165 = { (TfLiteFloatArray*)&quant165_scale, (TfLiteIntArray*)&quant165_zero, 0 };
const TfArray<4, int> tensor_dimension166 = { 4, { 1,3,3,336 } };
const TfArray<1, float> quant166_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant166_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant166 = { (TfLiteFloatArray*)&quant166_scale, (TfLiteIntArray*)&quant166_zero, 0 };
const TfArray<4, int> tensor_dimension167 = { 4, { 1,3,3,336 } };
const TfArray<1, float> quant167_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant167_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant167 = { (TfLiteFloatArray*)&quant167_scale, (TfLiteIntArray*)&quant167_zero, 0 };
const TfArray<4, int> tensor_dimension168 = { 4, { 1,3,3,56 } };
const TfArray<1, float> quant168_scale = { 1, { 0.036268193274736404, } };
const TfArray<1, int> quant168_zero = { 1, { 3 } };
const TfLiteAffineQuantization quant168 = { (TfLiteFloatArray*)&quant168_scale, (TfLiteIntArray*)&quant168_zero, 0 };
const TfArray<4, int> tensor_dimension169 = { 4, { 1,3,3,56 } };
const TfArray<1, float> quant169_scale = { 1, { 0.065988637506961823, } };
const TfArray<1, int> quant169_zero = { 1, { -22 } };
const TfLiteAffineQuantization quant169 = { (TfLiteFloatArray*)&quant169_scale, (TfLiteIntArray*)&quant169_zero, 0 };
const TfArray<4, int> tensor_dimension170 = { 4, { 1,3,3,336 } };
const TfArray<1, float> quant170_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant170_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant170 = { (TfLiteFloatArray*)&quant170_scale, (TfLiteIntArray*)&quant170_zero, 0 };
const TfArray<4, int> tensor_dimension171 = { 4, { 1,3,3,336 } };
const TfArray<1, float> quant171_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant171_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant171 = { (TfLiteFloatArray*)&quant171_scale, (TfLiteIntArray*)&quant171_zero, 0 };
const TfArray<4, int> tensor_dimension172 = { 4, { 1,3,3,56 } };
const TfArray<1, float> quant172_scale = { 1, { 0.03301258385181427, } };
const TfArray<1, int> quant172_zero = { 1, { -8 } };
const TfLiteAffineQuantization quant172 = { (TfLiteFloatArray*)&quant172_scale, (TfLiteIntArray*)&quant172_zero, 0 };
const TfArray<4, int> tensor_dimension173 = { 4, { 1,3,3,56 } };
const TfArray<1, float> quant173_scale = { 1, { 0.079828664660453796, } };
const TfArray<1, int> quant173_zero = { 1, { -18 } };
const TfLiteAffineQuantization quant173 = { (TfLiteFloatArray*)&quant173_scale, (TfLiteIntArray*)&quant173_zero, 0 };
const TfArray<4, int> tensor_dimension174 = { 4, { 1,3,3,336 } };
const TfArray<1, float> quant174_scale = { 1, { 0.021896561607718468, } };
const TfArray<1, int> quant174_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant174 = { (TfLiteFloatArray*)&quant174_scale, (TfLiteIntArray*)&quant174_zero, 0 };
const TfArray<4, int> tensor_dimension175 = { 4, { 1,3,3,336 } };
const TfArray<1, float> quant175_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant175_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant175 = { (TfLiteFloatArray*)&quant175_scale, (TfLiteIntArray*)&quant175_zero, 0 };
const TfArray<4, int> tensor_dimension176 = { 4, { 1,3,3,112 } };
const TfArray<1, float> quant176_scale = { 1, { 0.034787114709615707, } };
const TfArray<1, int> quant176_zero = { 1, { -9 } };
const TfLiteAffineQuantization quant176 = { (TfLiteFloatArray*)&quant176_scale, (TfLiteIntArray*)&quant176_zero, 0 };
const TfArray<4, int> tensor_dimension177 = { 4, { 1,3,3,1280 } };
const TfArray<1, float> quant177_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant177_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant177 = { (TfLiteFloatArray*)&quant177_scale, (TfLiteIntArray*)&quant177_zero, 0 };
const TfArray<2, int> tensor_dimension178 = { 2, { 9,1280 } };
const TfArray<1, float> quant178_scale = { 1, { 0.023529412224888802, } };
const TfArray<1, int> quant178_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant178 = { (TfLiteFloatArray*)&quant178_scale, (TfLiteIntArray*)&quant178_zero, 0 };
const TfArray<2, int> tensor_dimension179 = { 2, { 9,16 } };
const TfArray<1, float> quant179_scale = { 1, { 0.049144759774208069, } };
const TfArray<1, int> quant179_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant179 = { (TfLiteFloatArray*)&quant179_scale, (TfLiteIntArray*)&quant179_zero, 0 };
const TfArray<2, int> tensor_dimension180 = { 2, { 1,144 } };
const TfArray<1, float> quant180_scale = { 1, { 0.049144759774208069, } };
const TfArray<1, int> quant180_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant180 = { (TfLiteFloatArray*)&quant180_scale, (TfLiteIntArray*)&quant180_zero, 0 };
const TfArray<2, int> tensor_dimension181 = { 2, { 1,2 } };
const TfArray<1, float> quant181_scale = { 1, { 0.16034597158432007, } };
const TfArray<1, int> quant181_zero = { 1, { 17 } };
const TfLiteAffineQuantization quant181 = { (TfLiteFloatArray*)&quant181_scale, (TfLiteIntArray*)&quant181_zero, 0 };
const TfArray<2, int> tensor_dimension182 = { 2, { 1,2 } };
const TfArray<1, float> quant182_scale = { 1, { 0.00390625, } };
const TfArray<1, int> quant182_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant182 = { (TfLiteFloatArray*)&quant182_scale, (TfLiteIntArray*)&quant182_zero, 0 };
const TfLiteConvParams opdata0 = { kTfLitePaddingSame, 2,2, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs0 = { 3, { 0,43,6 } };
const TfArray<1, int> outputs0 = { 1, { 112 } };
const TfLiteDepthwiseConvParams opdata1 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs1 = { 3, { 112,78,35 } };
const TfArray<1, int> outputs1 = { 1, { 113 } };
const TfLiteConvParams opdata2 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs2 = { 3, { 113,44,79 } };
const TfArray<1, int> outputs2 = { 1, { 114 } };
const TfLiteConvParams opdata3 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs3 = { 3, { 114,45,13 } };
const TfArray<1, int> outputs3 = { 1, { 115 } };
const TfArray<2, int> inputs4 = { 2, { 115,2 } };
const TfArray<1, int> outputs4 = { 1, { 116 } };
const TfLiteDepthwiseConvParams opdata5 = { kTfLitePaddingValid, 2,2, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs5 = { 3, { 116,80,21 } };
const TfArray<1, int> outputs5 = { 1, { 117 } };
const TfLiteConvParams opdata6 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs6 = { 3, { 117,46,81 } };
const TfArray<1, int> outputs6 = { 1, { 118 } };
const TfLiteConvParams opdata7 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs7 = { 3, { 118,47,32 } };
const TfArray<1, int> outputs7 = { 1, { 119 } };
const TfLiteDepthwiseConvParams opdata8 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs8 = { 3, { 119,82,33 } };
const TfArray<1, int> outputs8 = { 1, { 120 } };
const TfLiteConvParams opdata9 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs9 = { 3, { 120,48,83 } };
const TfArray<1, int> outputs9 = { 1, { 121 } };
const TfLiteAddParams opdata10 = { kTfLiteActNone };
const TfArray<2, int> inputs10 = { 2, { 118,121 } };
const TfArray<1, int> outputs10 = { 1, { 122 } };
const TfLiteConvParams opdata11 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs11 = { 3, { 122,49,34 } };
const TfArray<1, int> outputs11 = { 1, { 123 } };
const TfArray<2, int> inputs12 = { 2, { 123,2 } };
const TfArray<1, int> outputs12 = { 1, { 124 } };
const TfLiteDepthwiseConvParams opdata13 = { kTfLitePaddingValid, 2,2, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs13 = { 3, { 124,84,36 } };
const TfArray<1, int> outputs13 = { 1, { 125 } };
const TfLiteConvParams opdata14 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs14 = { 3, { 125,50,85 } };
const TfArray<1, int> outputs14 = { 1, { 126 } };
const TfLiteConvParams opdata15 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs15 = { 3, { 126,51,37 } };
const TfArray<1, int> outputs15 = { 1, { 127 } };
const TfLiteDepthwiseConvParams opdata16 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs16 = { 3, { 127,86,38 } };
const TfArray<1, int> outputs16 = { 1, { 128 } };
const TfLiteConvParams opdata17 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs17 = { 3, { 128,52,87 } };
const TfArray<1, int> outputs17 = { 1, { 129 } };
const TfLiteAddParams opdata18 = { kTfLiteActNone };
const TfArray<2, int> inputs18 = { 2, { 126,129 } };
const TfArray<1, int> outputs18 = { 1, { 130 } };
const TfLiteConvParams opdata19 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs19 = { 3, { 130,53,39 } };
const TfArray<1, int> outputs19 = { 1, { 131 } };
const TfLiteDepthwiseConvParams opdata20 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs20 = { 3, { 131,88,40 } };
const TfArray<1, int> outputs20 = { 1, { 132 } };
const TfLiteConvParams opdata21 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs21 = { 3, { 132,54,89 } };
const TfArray<1, int> outputs21 = { 1, { 133 } };
const TfLiteAddParams opdata22 = { kTfLiteActNone };
const TfArray<2, int> inputs22 = { 2, { 130,133 } };
const TfArray<1, int> outputs22 = { 1, { 134 } };
const TfLiteConvParams opdata23 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs23 = { 3, { 134,55,41 } };
const TfArray<1, int> outputs23 = { 1, { 135 } };
const TfArray<2, int> inputs24 = { 2, { 135,2 } };
const TfArray<1, int> outputs24 = { 1, { 136 } };
const TfLiteDepthwiseConvParams opdata25 = { kTfLitePaddingValid, 2,2, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs25 = { 3, { 136,90,42 } };
const TfArray<1, int> outputs25 = { 1, { 137 } };
const TfLiteConvParams opdata26 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs26 = { 3, { 137,56,91 } };
const TfArray<1, int> outputs26 = { 1, { 138 } };
const TfLiteConvParams opdata27 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs27 = { 3, { 138,57,7 } };
const TfArray<1, int> outputs27 = { 1, { 139 } };
const TfLiteDepthwiseConvParams opdata28 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs28 = { 3, { 139,92,8 } };
const TfArray<1, int> outputs28 = { 1, { 140 } };
const TfLiteConvParams opdata29 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs29 = { 3, { 140,58,93 } };
const TfArray<1, int> outputs29 = { 1, { 141 } };
const TfLiteAddParams opdata30 = { kTfLiteActNone };
const TfArray<2, int> inputs30 = { 2, { 138,141 } };
const TfArray<1, int> outputs30 = { 1, { 142 } };
const TfLiteConvParams opdata31 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs31 = { 3, { 142,59,9 } };
const TfArray<1, int> outputs31 = { 1, { 143 } };
const TfLiteDepthwiseConvParams opdata32 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs32 = { 3, { 143,94,10 } };
const TfArray<1, int> outputs32 = { 1, { 144 } };
const TfLiteConvParams opdata33 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs33 = { 3, { 144,60,95 } };
const TfArray<1, int> outputs33 = { 1, { 145 } };
const TfLiteAddParams opdata34 = { kTfLiteActNone };
const TfArray<2, int> inputs34 = { 2, { 142,145 } };
const TfArray<1, int> outputs34 = { 1, { 146 } };
const TfLiteConvParams opdata35 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs35 = { 3, { 146,61,11 } };
const TfArray<1, int> outputs35 = { 1, { 147 } };
const TfLiteDepthwiseConvParams opdata36 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs36 = { 3, { 147,96,12 } };
const TfArray<1, int> outputs36 = { 1, { 148 } };
const TfLiteConvParams opdata37 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs37 = { 3, { 148,62,97 } };
const TfArray<1, int> outputs37 = { 1, { 149 } };
const TfLiteAddParams opdata38 = { kTfLiteActNone };
const TfArray<2, int> inputs38 = { 2, { 146,149 } };
const TfArray<1, int> outputs38 = { 1, { 150 } };
const TfLiteConvParams opdata39 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs39 = { 3, { 150,63,14 } };
const TfArray<1, int> outputs39 = { 1, { 151 } };
const TfLiteDepthwiseConvParams opdata40 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs40 = { 3, { 151,98,15 } };
const TfArray<1, int> outputs40 = { 1, { 152 } };
const TfLiteConvParams opdata41 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs41 = { 3, { 152,64,99 } };
const TfArray<1, int> outputs41 = { 1, { 153 } };
const TfLiteConvParams opdata42 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs42 = { 3, { 153,65,16 } };
const TfArray<1, int> outputs42 = { 1, { 154 } };
const TfLiteDepthwiseConvParams opdata43 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs43 = { 3, { 154,100,17 } };
const TfArray<1, int> outputs43 = { 1, { 155 } };
const TfLiteConvParams opdata44 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs44 = { 3, { 155,66,101 } };
const TfArray<1, int> outputs44 = { 1, { 156 } };
const TfLiteAddParams opdata45 = { kTfLiteActNone };
const TfArray<2, int> inputs45 = { 2, { 153,156 } };
const TfArray<1, int> outputs45 = { 1, { 157 } };
const TfLiteConvParams opdata46 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs46 = { 3, { 157,67,18 } };
const TfArray<1, int> outputs46 = { 1, { 158 } };
const TfLiteDepthwiseConvParams opdata47 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs47 = { 3, { 158,102,19 } };
const TfArray<1, int> outputs47 = { 1, { 159 } };
const TfLiteConvParams opdata48 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs48 = { 3, { 159,68,103 } };
const TfArray<1, int> outputs48 = { 1, { 160 } };
const TfLiteAddParams opdata49 = { kTfLiteActNone };
const TfArray<2, int> inputs49 = { 2, { 157,160 } };
const TfArray<1, int> outputs49 = { 1, { 161 } };
const TfLiteConvParams opdata50 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs50 = { 3, { 161,69,20 } };
const TfArray<1, int> outputs50 = { 1, { 162 } };
const TfArray<2, int> inputs51 = { 2, { 162,2 } };
const TfArray<1, int> outputs51 = { 1, { 163 } };
const TfLiteDepthwiseConvParams opdata52 = { kTfLitePaddingValid, 2,2, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs52 = { 3, { 163,104,22 } };
const TfArray<1, int> outputs52 = { 1, { 164 } };
const TfLiteConvParams opdata53 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs53 = { 3, { 164,70,105 } };
const TfArray<1, int> outputs53 = { 1, { 165 } };
const TfLiteConvParams opdata54 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs54 = { 3, { 165,71,23 } };
const TfArray<1, int> outputs54 = { 1, { 166 } };
const TfLiteDepthwiseConvParams opdata55 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs55 = { 3, { 166,106,24 } };
const TfArray<1, int> outputs55 = { 1, { 167 } };
const TfLiteConvParams opdata56 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs56 = { 3, { 167,72,107 } };
const TfArray<1, int> outputs56 = { 1, { 168 } };
const TfLiteAddParams opdata57 = { kTfLiteActNone };
const TfArray<2, int> inputs57 = { 2, { 165,168 } };
const TfArray<1, int> outputs57 = { 1, { 169 } };
const TfLiteConvParams opdata58 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs58 = { 3, { 169,73,25 } };
const TfArray<1, int> outputs58 = { 1, { 170 } };
const TfLiteDepthwiseConvParams opdata59 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs59 = { 3, { 170,108,26 } };
const TfArray<1, int> outputs59 = { 1, { 171 } };
const TfLiteConvParams opdata60 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs60 = { 3, { 171,74,109 } };
const TfArray<1, int> outputs60 = { 1, { 172 } };
const TfLiteAddParams opdata61 = { kTfLiteActNone };
const TfArray<2, int> inputs61 = { 2, { 169,172 } };
const TfArray<1, int> outputs61 = { 1, { 173 } };
const TfLiteConvParams opdata62 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs62 = { 3, { 173,75,27 } };
const TfArray<1, int> outputs62 = { 1, { 174 } };
const TfLiteDepthwiseConvParams opdata63 = { kTfLitePaddingSame, 1,1, 1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs63 = { 3, { 174,110,28 } };
const TfArray<1, int> outputs63 = { 1, { 175 } };
const TfLiteConvParams opdata64 = { kTfLitePaddingSame, 1,1, kTfLiteActNone, 1,1 };
const TfArray<3, int> inputs64 = { 3, { 175,76,111 } };
const TfArray<1, int> outputs64 = { 1, { 176 } };
const TfLiteConvParams opdata65 = { kTfLitePaddingValid, 1,1, kTfLiteActRelu6, 1,1 };
const TfArray<3, int> inputs65 = { 3, { 176,77,29 } };
const TfArray<1, int> outputs65 = { 1, { 177 } };
const TfLiteReshapeParams opdata66 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs66 = { 2, { 177,5 } };
const TfArray<1, int> outputs66 = { 1, { 178 } };
const TfLiteFullyConnectedParams opdata67 = { kTfLiteActRelu, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs67 = { 3, { 178,30,3 } };
const TfArray<1, int> outputs67 = { 1, { 179 } };
const TfLiteReshapeParams opdata68 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs68 = { 2, { 179,1 } };
const TfArray<1, int> outputs68 = { 1, { 180 } };
const TfLiteFullyConnectedParams opdata69 = { kTfLiteActNone, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs69 = { 3, { 180,31,4 } };
const TfArray<1, int> outputs69 = { 1, { 181 } };
const TfLiteSoftmaxParams opdata70 = { 1 };
const TfArray<1, int> inputs70 = { 1, { 181 } };
const TfArray<1, int> outputs70 = { 1, { 182 } };
const TensorInfo_t tensorData[] = {
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension0, 9216, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant0))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data1, (TfLiteIntArray*)&tensor_dimension1, 8, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data2, (TfLiteIntArray*)&tensor_dimension2, 32, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data3, (TfLiteIntArray*)&tensor_dimension3, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant3))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data4, (TfLiteIntArray*)&tensor_dimension4, 8, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant4))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data5, (TfLiteIntArray*)&tensor_dimension5, 8, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data6, (TfLiteIntArray*)&tensor_dimension6, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant6))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data7, (TfLiteIntArray*)&tensor_dimension7, 576, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant7))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data8, (TfLiteIntArray*)&tensor_dimension8, 576, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant8))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data9, (TfLiteIntArray*)&tensor_dimension9, 576, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant9))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data10, (TfLiteIntArray*)&tensor_dimension10, 576, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant10))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data11, (TfLiteIntArray*)&tensor_dimension11, 576, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant11))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data12, (TfLiteIntArray*)&tensor_dimension12, 576, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant12))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data13, (TfLiteIntArray*)&tensor_dimension13, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant13))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data14, (TfLiteIntArray*)&tensor_dimension14, 576, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant14))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data15, (TfLiteIntArray*)&tensor_dimension15, 576, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant15))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data16, (TfLiteIntArray*)&tensor_dimension16, 768, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant16))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data17, (TfLiteIntArray*)&tensor_dimension17, 768, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant17))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data18, (TfLiteIntArray*)&tensor_dimension18, 768, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant18))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data19, (TfLiteIntArray*)&tensor_dimension19, 768, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant19))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data20, (TfLiteIntArray*)&tensor_dimension20, 768, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant20))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data21, (TfLiteIntArray*)&tensor_dimension21, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant21))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data22, (TfLiteIntArray*)&tensor_dimension22, 768, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant22))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data23, (TfLiteIntArray*)&tensor_dimension23, 1344, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant23))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data24, (TfLiteIntArray*)&tensor_dimension24, 1344, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant24))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data25, (TfLiteIntArray*)&tensor_dimension25, 1344, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant25))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data26, (TfLiteIntArray*)&tensor_dimension26, 1344, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant26))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data27, (TfLiteIntArray*)&tensor_dimension27, 1344, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant27))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data28, (TfLiteIntArray*)&tensor_dimension28, 1344, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant28))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data29, (TfLiteIntArray*)&tensor_dimension29, 5120, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant29))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data30, (TfLiteIntArray*)&tensor_dimension30, 20480, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant30))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data31, (TfLiteIntArray*)&tensor_dimension31, 288, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant31))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data32, (TfLiteIntArray*)&tensor_dimension32, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant32))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data33, (TfLiteIntArray*)&tensor_dimension33, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant33))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data34, (TfLiteIntArray*)&tensor_dimension34, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant34))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data35, (TfLiteIntArray*)&tensor_dimension35, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant35))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data36, (TfLiteIntArray*)&tensor_dimension36, 192, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant36))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data37, (TfLiteIntArray*)&tensor_dimension37, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant37))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data38, (TfLiteIntArray*)&tensor_dimension38, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant38))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data39, (TfLiteIntArray*)&tensor_dimension39, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant39))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data40, (TfLiteIntArray*)&tensor_dimension40, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant40))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data41, (TfLiteIntArray*)&tensor_dimension41, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant41))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data42, (TfLiteIntArray*)&tensor_dimension42, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant42))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data43, (TfLiteIntArray*)&tensor_dimension43, 144, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant43))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data44, (TfLiteIntArray*)&tensor_dimension44, 128, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant44))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data45, (TfLiteIntArray*)&tensor_dimension45, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant45))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data46, (TfLiteIntArray*)&tensor_dimension46, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant46))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data47, (TfLiteIntArray*)&tensor_dimension47, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant47))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data48, (TfLiteIntArray*)&tensor_dimension48, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant48))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data49, (TfLiteIntArray*)&tensor_dimension49, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant49))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data50, (TfLiteIntArray*)&tensor_dimension50, 768, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant50))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data51, (TfLiteIntArray*)&tensor_dimension51, 1536, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant51))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data52, (TfLiteIntArray*)&tensor_dimension52, 1536, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant52))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data53, (TfLiteIntArray*)&tensor_dimension53, 1536, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant53))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data54, (TfLiteIntArray*)&tensor_dimension54, 1536, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant54))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data55, (TfLiteIntArray*)&tensor_dimension55, 1536, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant55))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data56, (TfLiteIntArray*)&tensor_dimension56, 2304, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant56))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data57, (TfLiteIntArray*)&tensor_dimension57, 3456, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant57))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data58, (TfLiteIntArray*)&tensor_dimension58, 3456, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant58))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data59, (TfLiteIntArray*)&tensor_dimension59, 3456, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant59))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data60, (TfLiteIntArray*)&tensor_dimension60, 3456, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant60))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data61, (TfLiteIntArray*)&tensor_dimension61, 3456, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant61))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data62, (TfLiteIntArray*)&tensor_dimension62, 3456, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant62))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data63, (TfLiteIntArray*)&tensor_dimension63, 3456, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant63))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data64, (TfLiteIntArray*)&tensor_dimension64, 4608, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant64))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data65, (TfLiteIntArray*)&tensor_dimension65, 6144, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant65))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data66, (TfLiteIntArray*)&tensor_dimension66, 6144, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant66))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data67, (TfLiteIntArray*)&tensor_dimension67, 6144, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant67))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data68, (TfLiteIntArray*)&tensor_dimension68, 6144, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant68))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data69, (TfLiteIntArray*)&tensor_dimension69, 6144, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant69))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data70, (TfLiteIntArray*)&tensor_dimension70, 10752, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant70))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data71, (TfLiteIntArray*)&tensor_dimension71, 18816, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant71))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data72, (TfLiteIntArray*)&tensor_dimension72, 18816, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant72))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data73, (TfLiteIntArray*)&tensor_dimension73, 18816, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant73))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data74, (TfLiteIntArray*)&tensor_dimension74, 18816, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant74))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data75, (TfLiteIntArray*)&tensor_dimension75, 18816, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant75))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data76, (TfLiteIntArray*)&tensor_dimension76, 37632, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant76))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data77, (TfLiteIntArray*)&tensor_dimension77, 143360, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant77))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data78, (TfLiteIntArray*)&tensor_dimension78, 144, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant78))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data79, (TfLiteIntArray*)&tensor_dimension79, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant79))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data80, (TfLiteIntArray*)&tensor_dimension80, 432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant80))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data81, (TfLiteIntArray*)&tensor_dimension81, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant81))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data82, (TfLiteIntArray*)&tensor_dimension82, 432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant82))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data83, (TfLiteIntArray*)&tensor_dimension83, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant83))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data84, (TfLiteIntArray*)&tensor_dimension84, 432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant84))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data85, (TfLiteIntArray*)&tensor_dimension85, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant85))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data86, (TfLiteIntArray*)&tensor_dimension86, 864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant86))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data87, (TfLiteIntArray*)&tensor_dimension87, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant87))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data88, (TfLiteIntArray*)&tensor_dimension88, 864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant88))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data89, (TfLiteIntArray*)&tensor_dimension89, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant89))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data90, (TfLiteIntArray*)&tensor_dimension90, 864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant90))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data91, (TfLiteIntArray*)&tensor_dimension91, 96, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant91))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data92, (TfLiteIntArray*)&tensor_dimension92, 1296, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant92))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data93, (TfLiteIntArray*)&tensor_dimension93, 96, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant93))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data94, (TfLiteIntArray*)&tensor_dimension94, 1296, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant94))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data95, (TfLiteIntArray*)&tensor_dimension95, 96, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant95))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data96, (TfLiteIntArray*)&tensor_dimension96, 1296, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant96))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data97, (TfLiteIntArray*)&tensor_dimension97, 96, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant97))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data98, (TfLiteIntArray*)&tensor_dimension98, 1296, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant98))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data99, (TfLiteIntArray*)&tensor_dimension99, 128, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant99))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data100, (TfLiteIntArray*)&tensor_dimension100, 1728, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant100))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data101, (TfLiteIntArray*)&tensor_dimension101, 128, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant101))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data102, (TfLiteIntArray*)&tensor_dimension102, 1728, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant102))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data103, (TfLiteIntArray*)&tensor_dimension103, 128, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant103))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data104, (TfLiteIntArray*)&tensor_dimension104, 1728, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant104))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data105, (TfLiteIntArray*)&tensor_dimension105, 224, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant105))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data106, (TfLiteIntArray*)&tensor_dimension106, 3024, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant106))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data107, (TfLiteIntArray*)&tensor_dimension107, 224, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant107))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data108, (TfLiteIntArray*)&tensor_dimension108, 3024, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant108))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data109, (TfLiteIntArray*)&tensor_dimension109, 224, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant109))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data110, (TfLiteIntArray*)&tensor_dimension110, 3024, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant110))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data111, (TfLiteIntArray*)&tensor_dimension111, 448, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant111))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 36864, (TfLiteIntArray*)&tensor_dimension112, 36864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant112))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension113, 36864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant113))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 36864, (TfLiteIntArray*)&tensor_dimension114, 18432, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant114))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 115248, (TfLiteIntArray*)&tensor_dimension115, 110592, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant115))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension116, 115248, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant116))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 115248, (TfLiteIntArray*)&tensor_dimension117, 27648, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant117))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 55296, (TfLiteIntArray*)&tensor_dimension118, 4608, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant118))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 27648, (TfLiteIntArray*)&tensor_dimension119, 27648, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant119))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension120, 27648, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant120))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 27648, (TfLiteIntArray*)&tensor_dimension121, 4608, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant121))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension122, 4608, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant122))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 30000, (TfLiteIntArray*)&tensor_dimension123, 27648, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant123))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension124, 30000, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant124))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 30000, (TfLiteIntArray*)&tensor_dimension125, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant125))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 36912, (TfLiteIntArray*)&tensor_dimension126, 2304, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant126))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 13824, (TfLiteIntArray*)&tensor_dimension127, 13824, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant127))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension128, 13824, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant128))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 13824, (TfLiteIntArray*)&tensor_dimension129, 2304, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant129))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 27648, (TfLiteIntArray*)&tensor_dimension130, 2304, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant130))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 13824, (TfLiteIntArray*)&tensor_dimension131, 13824, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant131))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension132, 13824, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant132))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 13824, (TfLiteIntArray*)&tensor_dimension133, 2304, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant133))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension134, 2304, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant134))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 16224, (TfLiteIntArray*)&tensor_dimension135, 13824, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant135))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension136, 16224, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant136))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 16224, (TfLiteIntArray*)&tensor_dimension137, 3456, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant137))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 10368, (TfLiteIntArray*)&tensor_dimension138, 864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant138))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 5184, (TfLiteIntArray*)&tensor_dimension139, 5184, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant139))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension140, 5184, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant140))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 5184, (TfLiteIntArray*)&tensor_dimension141, 864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant141))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 11232, (TfLiteIntArray*)&tensor_dimension142, 864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant142))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 5184, (TfLiteIntArray*)&tensor_dimension143, 5184, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant143))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension144, 5184, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant144))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 5184, (TfLiteIntArray*)&tensor_dimension145, 864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant145))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 10368, (TfLiteIntArray*)&tensor_dimension146, 864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant146))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 5184, (TfLiteIntArray*)&tensor_dimension147, 5184, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant147))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension148, 5184, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant148))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 5184, (TfLiteIntArray*)&tensor_dimension149, 864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant149))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension150, 864, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant150))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 5184, (TfLiteIntArray*)&tensor_dimension151, 5184, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant151))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension152, 5184, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant152))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 14976, (TfLiteIntArray*)&tensor_dimension153, 1152, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant153))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6912, (TfLiteIntArray*)&tensor_dimension154, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant154))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension155, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant155))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6912, (TfLiteIntArray*)&tensor_dimension156, 1152, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant156))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 13824, (TfLiteIntArray*)&tensor_dimension157, 1152, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant157))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6912, (TfLiteIntArray*)&tensor_dimension158, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant158))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension159, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant159))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6912, (TfLiteIntArray*)&tensor_dimension160, 1152, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant160))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension161, 1152, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant161))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 9408, (TfLiteIntArray*)&tensor_dimension162, 6912, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant162))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension163, 9408, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant163))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 9408, (TfLiteIntArray*)&tensor_dimension164, 1728, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant164))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6560, (TfLiteIntArray*)&tensor_dimension165, 504, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant165))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 3024, (TfLiteIntArray*)&tensor_dimension166, 3024, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant166))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension167, 3024, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant167))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 3024, (TfLiteIntArray*)&tensor_dimension168, 504, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant168))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 6048, (TfLiteIntArray*)&tensor_dimension169, 504, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant169))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 3024, (TfLiteIntArray*)&tensor_dimension170, 3024, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant170))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension171, 3024, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant171))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 3024, (TfLiteIntArray*)&tensor_dimension172, 504, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant172))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension173, 504, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant173))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 3024, (TfLiteIntArray*)&tensor_dimension174, 3024, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant174))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension175, 3024, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant175))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 3024, (TfLiteIntArray*)&tensor_dimension176, 1008, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant176))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 11520, (TfLiteIntArray*)&tensor_dimension177, 11520, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant177))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension178, 11520, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant178))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 11520, (TfLiteIntArray*)&tensor_dimension179, 144, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant179))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension180, 144, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant180))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 144, (TfLiteIntArray*)&tensor_dimension181, 2, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant181))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension182, 2, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant182))}, },
};const NodeInfo_t nodeData[] = {
  { (TfLiteIntArray*)&inputs0, (TfLiteIntArray*)&outputs0, const_cast<void*>(static_cast<const void*>(&opdata0)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs1, (TfLiteIntArray*)&outputs1, const_cast<void*>(static_cast<const void*>(&opdata1)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs2, (TfLiteIntArray*)&outputs2, const_cast<void*>(static_cast<const void*>(&opdata2)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs3, (TfLiteIntArray*)&outputs3, const_cast<void*>(static_cast<const void*>(&opdata3)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs4, (TfLiteIntArray*)&outputs4, nullptr, OP_PAD, },
  { (TfLiteIntArray*)&inputs5, (TfLiteIntArray*)&outputs5, const_cast<void*>(static_cast<const void*>(&opdata5)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs6, (TfLiteIntArray*)&outputs6, const_cast<void*>(static_cast<const void*>(&opdata6)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs7, (TfLiteIntArray*)&outputs7, const_cast<void*>(static_cast<const void*>(&opdata7)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs8, (TfLiteIntArray*)&outputs8, const_cast<void*>(static_cast<const void*>(&opdata8)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs9, (TfLiteIntArray*)&outputs9, const_cast<void*>(static_cast<const void*>(&opdata9)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs10, (TfLiteIntArray*)&outputs10, const_cast<void*>(static_cast<const void*>(&opdata10)), OP_ADD, },
  { (TfLiteIntArray*)&inputs11, (TfLiteIntArray*)&outputs11, const_cast<void*>(static_cast<const void*>(&opdata11)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs12, (TfLiteIntArray*)&outputs12, nullptr, OP_PAD, },
  { (TfLiteIntArray*)&inputs13, (TfLiteIntArray*)&outputs13, const_cast<void*>(static_cast<const void*>(&opdata13)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs14, (TfLiteIntArray*)&outputs14, const_cast<void*>(static_cast<const void*>(&opdata14)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs15, (TfLiteIntArray*)&outputs15, const_cast<void*>(static_cast<const void*>(&opdata15)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs16, (TfLiteIntArray*)&outputs16, const_cast<void*>(static_cast<const void*>(&opdata16)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs17, (TfLiteIntArray*)&outputs17, const_cast<void*>(static_cast<const void*>(&opdata17)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs18, (TfLiteIntArray*)&outputs18, const_cast<void*>(static_cast<const void*>(&opdata18)), OP_ADD, },
  { (TfLiteIntArray*)&inputs19, (TfLiteIntArray*)&outputs19, const_cast<void*>(static_cast<const void*>(&opdata19)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs20, (TfLiteIntArray*)&outputs20, const_cast<void*>(static_cast<const void*>(&opdata20)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs21, (TfLiteIntArray*)&outputs21, const_cast<void*>(static_cast<const void*>(&opdata21)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs22, (TfLiteIntArray*)&outputs22, const_cast<void*>(static_cast<const void*>(&opdata22)), OP_ADD, },
  { (TfLiteIntArray*)&inputs23, (TfLiteIntArray*)&outputs23, const_cast<void*>(static_cast<const void*>(&opdata23)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs24, (TfLiteIntArray*)&outputs24, nullptr, OP_PAD, },
  { (TfLiteIntArray*)&inputs25, (TfLiteIntArray*)&outputs25, const_cast<void*>(static_cast<const void*>(&opdata25)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs26, (TfLiteIntArray*)&outputs26, const_cast<void*>(static_cast<const void*>(&opdata26)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs27, (TfLiteIntArray*)&outputs27, const_cast<void*>(static_cast<const void*>(&opdata27)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs28, (TfLiteIntArray*)&outputs28, const_cast<void*>(static_cast<const void*>(&opdata28)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs29, (TfLiteIntArray*)&outputs29, const_cast<void*>(static_cast<const void*>(&opdata29)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs30, (TfLiteIntArray*)&outputs30, const_cast<void*>(static_cast<const void*>(&opdata30)), OP_ADD, },
  { (TfLiteIntArray*)&inputs31, (TfLiteIntArray*)&outputs31, const_cast<void*>(static_cast<const void*>(&opdata31)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs32, (TfLiteIntArray*)&outputs32, const_cast<void*>(static_cast<const void*>(&opdata32)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs33, (TfLiteIntArray*)&outputs33, const_cast<void*>(static_cast<const void*>(&opdata33)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs34, (TfLiteIntArray*)&outputs34, const_cast<void*>(static_cast<const void*>(&opdata34)), OP_ADD, },
  { (TfLiteIntArray*)&inputs35, (TfLiteIntArray*)&outputs35, const_cast<void*>(static_cast<const void*>(&opdata35)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs36, (TfLiteIntArray*)&outputs36, const_cast<void*>(static_cast<const void*>(&opdata36)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs37, (TfLiteIntArray*)&outputs37, const_cast<void*>(static_cast<const void*>(&opdata37)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs38, (TfLiteIntArray*)&outputs38, const_cast<void*>(static_cast<const void*>(&opdata38)), OP_ADD, },
  { (TfLiteIntArray*)&inputs39, (TfLiteIntArray*)&outputs39, const_cast<void*>(static_cast<const void*>(&opdata39)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs40, (TfLiteIntArray*)&outputs40, const_cast<void*>(static_cast<const void*>(&opdata40)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs41, (TfLiteIntArray*)&outputs41, const_cast<void*>(static_cast<const void*>(&opdata41)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs42, (TfLiteIntArray*)&outputs42, const_cast<void*>(static_cast<const void*>(&opdata42)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs43, (TfLiteIntArray*)&outputs43, const_cast<void*>(static_cast<const void*>(&opdata43)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs44, (TfLiteIntArray*)&outputs44, const_cast<void*>(static_cast<const void*>(&opdata44)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs45, (TfLiteIntArray*)&outputs45, const_cast<void*>(static_cast<const void*>(&opdata45)), OP_ADD, },
  { (TfLiteIntArray*)&inputs46, (TfLiteIntArray*)&outputs46, const_cast<void*>(static_cast<const void*>(&opdata46)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs47, (TfLiteIntArray*)&outputs47, const_cast<void*>(static_cast<const void*>(&opdata47)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs48, (TfLiteIntArray*)&outputs48, const_cast<void*>(static_cast<const void*>(&opdata48)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs49, (TfLiteIntArray*)&outputs49, const_cast<void*>(static_cast<const void*>(&opdata49)), OP_ADD, },
  { (TfLiteIntArray*)&inputs50, (TfLiteIntArray*)&outputs50, const_cast<void*>(static_cast<const void*>(&opdata50)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs51, (TfLiteIntArray*)&outputs51, nullptr, OP_PAD, },
  { (TfLiteIntArray*)&inputs52, (TfLiteIntArray*)&outputs52, const_cast<void*>(static_cast<const void*>(&opdata52)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs53, (TfLiteIntArray*)&outputs53, const_cast<void*>(static_cast<const void*>(&opdata53)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs54, (TfLiteIntArray*)&outputs54, const_cast<void*>(static_cast<const void*>(&opdata54)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs55, (TfLiteIntArray*)&outputs55, const_cast<void*>(static_cast<const void*>(&opdata55)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs56, (TfLiteIntArray*)&outputs56, const_cast<void*>(static_cast<const void*>(&opdata56)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs57, (TfLiteIntArray*)&outputs57, const_cast<void*>(static_cast<const void*>(&opdata57)), OP_ADD, },
  { (TfLiteIntArray*)&inputs58, (TfLiteIntArray*)&outputs58, const_cast<void*>(static_cast<const void*>(&opdata58)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs59, (TfLiteIntArray*)&outputs59, const_cast<void*>(static_cast<const void*>(&opdata59)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs60, (TfLiteIntArray*)&outputs60, const_cast<void*>(static_cast<const void*>(&opdata60)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs61, (TfLiteIntArray*)&outputs61, const_cast<void*>(static_cast<const void*>(&opdata61)), OP_ADD, },
  { (TfLiteIntArray*)&inputs62, (TfLiteIntArray*)&outputs62, const_cast<void*>(static_cast<const void*>(&opdata62)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs63, (TfLiteIntArray*)&outputs63, const_cast<void*>(static_cast<const void*>(&opdata63)), OP_DEPTHWISE_CONV_2D, },
  { (TfLiteIntArray*)&inputs64, (TfLiteIntArray*)&outputs64, const_cast<void*>(static_cast<const void*>(&opdata64)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs65, (TfLiteIntArray*)&outputs65, const_cast<void*>(static_cast<const void*>(&opdata65)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs66, (TfLiteIntArray*)&outputs66, const_cast<void*>(static_cast<const void*>(&opdata66)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs67, (TfLiteIntArray*)&outputs67, const_cast<void*>(static_cast<const void*>(&opdata67)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs68, (TfLiteIntArray*)&outputs68, const_cast<void*>(static_cast<const void*>(&opdata68)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs69, (TfLiteIntArray*)&outputs69, const_cast<void*>(static_cast<const void*>(&opdata69)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs70, (TfLiteIntArray*)&outputs70, const_cast<void*>(static_cast<const void*>(&opdata70)), OP_SOFTMAX, },
};
static std::vector<void*> overflow_buffers;
static void * AllocatePersistentBuffer(struct TfLiteContext* ctx,
                                       size_t bytes) {
  void *ptr;
  if (current_location - bytes < tensor_boundary) {
    // OK, this will look super weird, but.... we have CMSIS-NN buffers which
    // we cannot calculate beforehand easily.
    ptr = ei_calloc(bytes, 1);
    if (ptr == NULL) {
      printf("ERR: Failed to allocate persistent buffer of size %d\n", (int)bytes);
      return NULL;
    }
    overflow_buffers.push_back(ptr);
    return ptr;
  }

  current_location -= bytes;

  ptr = current_location;
  memset(ptr, 0, bytes);

  return ptr;
}
typedef struct {
  size_t bytes;
  void *ptr;
} scratch_buffer_t;
static std::vector<scratch_buffer_t> scratch_buffers;

static TfLiteStatus RequestScratchBufferInArena(struct TfLiteContext* ctx, size_t bytes,
                                                int* buffer_idx) {
  scratch_buffer_t b;
  b.bytes = bytes;

  b.ptr = AllocatePersistentBuffer(ctx, b.bytes);
  if (!b.ptr) {
    return kTfLiteError;
  }

  scratch_buffers.push_back(b);

  *buffer_idx = scratch_buffers.size() - 1;

  return kTfLiteOk;
}

static void* GetScratchBuffer(struct TfLiteContext* ctx, int buffer_idx) {
  if (buffer_idx > static_cast<int>(scratch_buffers.size()) - 1) {
    return NULL;
  }
  return scratch_buffers[buffer_idx].ptr;
}

static TfLiteTensor* GetTensor(const struct TfLiteContext* context,
                               int tensor_idx) {
  return &tflTensors[tensor_idx];
}

static TfLiteEvalTensor* GetEvalTensor(const struct TfLiteContext* context,
                                       int tensor_idx) {
  return &tflEvalTensors[tensor_idx];
}

} // namespace

TfLiteStatus trained_model_init( void*(*alloc_fnc)(size_t,size_t) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  tensor_arena = (uint8_t*) alloc_fnc(16, kTensorArenaSize);
  if (!tensor_arena) {
    printf("ERR: failed to allocate tensor arena\n");
    return kTfLiteError;
  }
#else
  memset(tensor_arena, 0, kTensorArenaSize);
#endif
  tensor_boundary = tensor_arena;
  current_location = tensor_arena + kTensorArenaSize;
  ctx.AllocatePersistentBuffer = &AllocatePersistentBuffer;
  ctx.RequestScratchBufferInArena = &RequestScratchBufferInArena;
  ctx.GetScratchBuffer = &GetScratchBuffer;
  ctx.GetTensor = &GetTensor;
  ctx.GetEvalTensor = &GetEvalTensor;
  ctx.tensors = tflTensors;
  ctx.tensors_size = 183;
  for(size_t i = 0; i < 183; ++i) {
    tflTensors[i].type = tensorData[i].type;
    tflEvalTensors[i].type = tensorData[i].type;
    tflTensors[i].is_variable = 0;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    tflTensors[i].allocation_type = tensorData[i].allocation_type;
#else
    tflTensors[i].allocation_type = (tensor_arena <= tensorData[i].data && tensorData[i].data < tensor_arena + kTensorArenaSize) ? kTfLiteArenaRw : kTfLiteMmapRo;
#endif
    tflTensors[i].bytes = tensorData[i].bytes;
    tflTensors[i].dims = tensorData[i].dims;
    tflEvalTensors[i].dims = tensorData[i].dims;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    if(tflTensors[i].allocation_type == kTfLiteArenaRw){
      uint8_t* start = (uint8_t*) ((uintptr_t)tensorData[i].data + (uintptr_t) tensor_arena);

     tflTensors[i].data.data =  start;
     tflEvalTensors[i].data.data =  start;
    }
    else{
       tflTensors[i].data.data = tensorData[i].data;
       tflEvalTensors[i].data.data = tensorData[i].data;
    }
#else
    tflTensors[i].data.data = tensorData[i].data;
    tflEvalTensors[i].data.data = tensorData[i].data;
#endif // EI_CLASSIFIER_ALLOCATION_HEAP
    tflTensors[i].quantization = tensorData[i].quantization;
    if (tflTensors[i].quantization.type == kTfLiteAffineQuantization) {
      TfLiteAffineQuantization const* quant = ((TfLiteAffineQuantization const*)(tensorData[i].quantization.params));
      tflTensors[i].params.scale = quant->scale->data[0];
      tflTensors[i].params.zero_point = quant->zero_point->data[0];
    }
    if (tflTensors[i].allocation_type == kTfLiteArenaRw) {
      auto data_end_ptr = (uint8_t*)tflTensors[i].data.data + tensorData[i].bytes;
      if (data_end_ptr > tensor_boundary) {
        tensor_boundary = data_end_ptr;
      }
    }
  }
  if (tensor_boundary > current_location /* end of arena size */) {
    printf("ERR: tensor arena is too small, does not fit model - even without scratch buffers\n");
    return kTfLiteError;
  }
  registrations[OP_CONV_2D] = Register_CONV_2D();
  registrations[OP_DEPTHWISE_CONV_2D] = Register_DEPTHWISE_CONV_2D();
  registrations[OP_PAD] = Register_PAD();
  registrations[OP_ADD] = Register_ADD();
  registrations[OP_RESHAPE] = Register_RESHAPE();
  registrations[OP_FULLY_CONNECTED] = Register_FULLY_CONNECTED();
  registrations[OP_SOFTMAX] = Register_SOFTMAX();

  for(size_t i = 0; i < 71; ++i) {
    tflNodes[i].inputs = nodeData[i].inputs;
    tflNodes[i].outputs = nodeData[i].outputs;
    tflNodes[i].builtin_data = nodeData[i].builtin_data;
    tflNodes[i].custom_initial_data = nullptr;
    tflNodes[i].custom_initial_data_size = 0;
    if (registrations[nodeData[i].used_op_index].init) {
      tflNodes[i].user_data = registrations[nodeData[i].used_op_index].init(&ctx, (const char*)tflNodes[i].builtin_data, 0);
    }
  }
  for(size_t i = 0; i < 71; ++i) {
    if (registrations[nodeData[i].used_op_index].prepare) {
      TfLiteStatus status = registrations[nodeData[i].used_op_index].prepare(&ctx, &tflNodes[i]);
      if (status != kTfLiteOk) {
        return status;
      }
    }
  }
  return kTfLiteOk;
}

static const int inTensorIndices[] = {
  0, 
};
TfLiteTensor* trained_model_input(int index) {
  return &ctx.tensors[inTensorIndices[index]];
}

static const int outTensorIndices[] = {
  182, 
};
TfLiteTensor* trained_model_output(int index) {
  return &ctx.tensors[outTensorIndices[index]];
}

TfLiteStatus trained_model_invoke() {
  for(size_t i = 0; i < 71; ++i) {
    TfLiteStatus status = registrations[nodeData[i].used_op_index].invoke(&ctx, &tflNodes[i]);

#if EI_CLASSIFIER_PRINT_STATE
    ei_printf("layer %lu\n", i);
    ei_printf("    inputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].inputs->size; ix++) {
      auto d = tensorData[tflNodes[i].inputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");

    ei_printf("    outputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].outputs->size; ix++) {
      auto d = tensorData[tflNodes[i].outputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");
#endif // EI_CLASSIFIER_PRINT_STATE

    if (status != kTfLiteOk) {
      return status;
    }
  }
  return kTfLiteOk;
}

TfLiteStatus trained_model_reset( void (*free_fnc)(void* ptr) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  free_fnc(tensor_arena);
#endif
  scratch_buffers.clear();
  for (size_t ix = 0; ix < overflow_buffers.size(); ix++) {
    free(overflow_buffers[ix]);
  }
  overflow_buffers.clear();
  return kTfLiteOk;
}
